"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var commerce_plugin_tools_1 = require("@builder.io/commerce-plugin-tools");
var swell_js_1 = require("swell-js");
commerce_plugin_tools_1.registerCommercePlugin({
    name: 'Swell',
    // should always match package.json package name
    id: '@builder.io/plugin-swell',
    settings: [
        {
            name: 'storeId',
            type: 'string',
            required: true,
            helperText: 'Get your Store ID from swell store settings https://swell.store/docs/api/?javascript#authentication',
        },
        {
            name: 'publicKey',
            type: 'string',
            required: true,
            helperText: 'Get your Public key from swell store settings > API keys > Public api key https://swell.store/docs/api/?javascript#authentication',
        },
    ],
    ctaText: "Connect your swell.is store",
}, function (settings) { return __awaiter(void 0, void 0, void 0, function () {
    var storeId, publicKey, transformResource;
    var _a, _b;
    return __generator(this, function (_c) {
        switch (_c.label) {
            case 0:
                storeId = (_a = settings.get('storeId')) === null || _a === void 0 ? void 0 : _a.trim();
                publicKey = (_b = settings.get('publicKey')) === null || _b === void 0 ? void 0 : _b.trim();
                return [4 /*yield*/, swell_js_1.default.init(storeId, publicKey)];
            case 1:
                _c.sent();
                transformResource = function (resource) {
                    var _a;
                    return (__assign({ id: resource.id, title: resource.name, handle: resource.slug }, (resource.images && {
                        image: {
                            src: (_a = resource.images[0]) === null || _a === void 0 ? void 0 : _a.file.url,
                        },
                    })));
                };
                return [2 /*return*/, {
                        product: {
                            findById: function (id) {
                                return __awaiter(this, void 0, void 0, function () {
                                    var product;
                                    return __generator(this, function (_a) {
                                        switch (_a.label) {
                                            case 0: return [4 /*yield*/, swell_js_1.default.products.get(id)];
                                            case 1:
                                                product = _a.sent();
                                                return [2 /*return*/, transformResource(product)];
                                        }
                                    });
                                });
                            },
                            findByHandle: function (handle) {
                                return __awaiter(this, void 0, void 0, function () {
                                    var product;
                                    return __generator(this, function (_a) {
                                        switch (_a.label) {
                                            case 0: return [4 /*yield*/, swell_js_1.default.products.get(handle)];
                                            case 1:
                                                product = _a.sent();
                                                return [2 /*return*/, transformResource(product)];
                                        }
                                    });
                                });
                            },
                            search: function (search) {
                                return __awaiter(this, void 0, void 0, function () {
                                    var response;
                                    return __generator(this, function (_a) {
                                        switch (_a.label) {
                                            case 0: return [4 /*yield*/, swell_js_1.default.products.list({
                                                    search: search,
                                                    // TODO: pagination if needed
                                                    limit: 100,
                                                    page: 1,
                                                })];
                                            case 1:
                                                response = _a.sent();
                                                return [2 /*return*/, response.results.map(transformResource)];
                                        }
                                    });
                                });
                            },
                            getRequestObject: function (id) {
                                return {
                                    '@type': '@builder.io/core:Request',
                                    request: {
                                        // https://{public_key}@{client_id}.swell.store/api/products/5e31e67be53f9a59d89600f1.
                                        url: "https://" + publicKey + "@" + storeId + ".swell.store/api/products/" + id,
                                    },
                                    options: {
                                        product: id,
                                    },
                                };
                            },
                        },
                        category: {
                            findById: function (id) {
                                return __awaiter(this, void 0, void 0, function () {
                                    var category;
                                    return __generator(this, function (_a) {
                                        switch (_a.label) {
                                            case 0: return [4 /*yield*/, swell_js_1.default.categories.get(id)];
                                            case 1:
                                                category = _a.sent();
                                                return [2 /*return*/, transformResource(category)];
                                        }
                                    });
                                });
                            },
                            findByHandle: function (handle) {
                                return __awaiter(this, void 0, void 0, function () {
                                    var category;
                                    return __generator(this, function (_a) {
                                        switch (_a.label) {
                                            case 0: return [4 /*yield*/, swell_js_1.default.categories.get(handle)];
                                            case 1:
                                                category = _a.sent();
                                                return [2 /*return*/, transformResource(category)];
                                        }
                                    });
                                });
                            },
                            search: function (search) {
                                return __awaiter(this, void 0, void 0, function () {
                                    var response;
                                    return __generator(this, function (_a) {
                                        switch (_a.label) {
                                            case 0: return [4 /*yield*/, swell_js_1.default.categories.list({
                                                    search: search,
                                                    // TODO: pagination if needed
                                                    limit: 100,
                                                    page: 1,
                                                })];
                                            case 1:
                                                response = _a.sent();
                                                return [2 /*return*/, response.results.map(transformResource)];
                                        }
                                    });
                                });
                            },
                            getRequestObject: function (id) {
                                return {
                                    '@type': '@builder.io/core:Request',
                                    request: {
                                        // https://{public_key}@{client_id}.swell.store/api/categories/5e31e67be53f9a59d89600f1.
                                        url: "https://" + publicKey + "@" + storeId + ".swell.store/api/categories/" + id,
                                    },
                                    options: {
                                        category: id,
                                    },
                                };
                            },
                        },
                    }];
        }
    });
}); });
//# sourceMappingURL=plugin.js.map