System.register(['@builder.io/react', '@emotion/core', '@material-ui/core', 'react', 'mobx', 'mobx-react', '@builder.io/app-context'], function () {
    'use strict';
    var Builder, jsx, CircularProgress, Paper, IconButton, Button, ListItem, ListItemAvatar, Avatar, ListItemText, TextField, InputAdornment, Typography, Tooltip, React, createElement, Component, useEffect, action, runInAction, useLocalStore, useObserver, appState;
    return {
        setters: [function (module) {
            Builder = module.Builder;
        }, function (module) {
            jsx = module.jsx;
        }, function (module) {
            CircularProgress = module.CircularProgress;
            Paper = module.Paper;
            IconButton = module.IconButton;
            Button = module.Button;
            ListItem = module.ListItem;
            ListItemAvatar = module.ListItemAvatar;
            Avatar = module.Avatar;
            ListItemText = module.ListItemText;
            TextField = module.TextField;
            InputAdornment = module.InputAdornment;
            Typography = module.Typography;
            Tooltip = module.Tooltip;
        }, function (module) {
            React = module.default;
            createElement = module.createElement;
            Component = module.Component;
            useEffect = module.useEffect;
        }, function (module) {
            action = module.action;
            runInAction = module.runInAction;
        }, function (module) {
            useLocalStore = module.useLocalStore;
            useObserver = module.useObserver;
        }, function (module) {
            appState = module.default;
        }],
        execute: function () {

            /*! *****************************************************************************
            Copyright (c) Microsoft Corporation.

            Permission to use, copy, modify, and/or distribute this software for any
            purpose with or without fee is hereby granted.

            THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES WITH
            REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
            AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT,
            INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
            LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
            OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
            PERFORMANCE OF THIS SOFTWARE.
            ***************************************************************************** */

            var __assign$1 = function() {
                __assign$1 = Object.assign || function __assign(t) {
                    for (var s, i = 1, n = arguments.length; i < n; i++) {
                        s = arguments[i];
                        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
                    }
                    return t;
                };
                return __assign$1.apply(this, arguments);
            };

            function __awaiter$1(thisArg, _arguments, P, generator) {
                function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
                return new (P || (P = Promise))(function (resolve, reject) {
                    function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
                    function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
                    function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
                    step((generator = generator.apply(thisArg, _arguments || [])).next());
                });
            }

            function __generator$1(thisArg, body) {
                var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
                return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
                function verb(n) { return function (v) { return step([n, v]); }; }
                function step(op) {
                    if (f) throw new TypeError("Generator is already executing.");
                    while (_) try {
                        if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
                        if (y = 0, t) op = [op[0] & 2, t.value];
                        switch (op[0]) {
                            case 0: case 1: t = op; break;
                            case 4: _.label++; return { value: op[1], done: false };
                            case 5: _.label++; y = op[1]; op = [0]; continue;
                            case 7: op = _.ops.pop(); _.trys.pop(); continue;
                            default:
                                if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                                if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                                if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                                if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                                if (t[2]) _.ops.pop();
                                _.trys.pop(); continue;
                        }
                        op = body.call(thisArg, _);
                    } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
                    if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
                }
            }

            /*! *****************************************************************************
            Copyright (c) Microsoft Corporation.

            Permission to use, copy, modify, and/or distribute this software for any
            purpose with or without fee is hereby granted.

            THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES WITH
            REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
            AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT,
            INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
            LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
            OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
            PERFORMANCE OF THIS SOFTWARE.
            ***************************************************************************** */
            /* global Reflect, Promise */

            var extendStatics = function(d, b) {
                extendStatics = Object.setPrototypeOf ||
                    ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
                    function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
                return extendStatics(d, b);
            };

            function __extends(d, b) {
                if (typeof b !== "function" && b !== null)
                    throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
                extendStatics(d, b);
                function __() { this.constructor = d; }
                d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
            }

            var __assign = function() {
                __assign = Object.assign || function __assign(t) {
                    for (var s, i = 1, n = arguments.length; i < n; i++) {
                        s = arguments[i];
                        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
                    }
                    return t;
                };
                return __assign.apply(this, arguments);
            };

            function __rest(s, e) {
                var t = {};
                for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
                    t[p] = s[p];
                if (s != null && typeof Object.getOwnPropertySymbols === "function")
                    for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
                        if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                            t[p[i]] = s[p[i]];
                    }
                return t;
            }

            function __awaiter(thisArg, _arguments, P, generator) {
                function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
                return new (P || (P = Promise))(function (resolve, reject) {
                    function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
                    function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
                    function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
                    step((generator = generator.apply(thisArg, _arguments || [])).next());
                });
            }

            function __generator(thisArg, body) {
                var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
                return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
                function verb(n) { return function (v) { return step([n, v]); }; }
                function step(op) {
                    if (f) throw new TypeError("Generator is already executing.");
                    while (_) try {
                        if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
                        if (y = 0, t) op = [op[0] & 2, t.value];
                        switch (op[0]) {
                            case 0: case 1: t = op; break;
                            case 4: _.label++; return { value: op[1], done: false };
                            case 5: _.label++; y = op[1]; op = [0]; continue;
                            case 7: op = _.ops.pop(); _.trys.pop(); continue;
                            default:
                                if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                                if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                                if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                                if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                                if (t[2]) _.ops.pop();
                                _.trys.pop(); continue;
                        }
                        op = body.call(thisArg, _);
                    } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
                    if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
                }
            }

            /** @deprecated */
            function __spreadArrays() {
                for (var s = 0, i = 0, il = arguments.length; i < il; i++) s += arguments[i].length;
                for (var r = Array(s), k = 0, i = 0; i < il; i++)
                    for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
                        r[k] = a[j];
                return r;
            }

            var commonjsGlobal$1 = typeof globalThis !== 'undefined' ? globalThis : typeof window !== 'undefined' ? window : typeof global !== 'undefined' ? global : typeof self !== 'undefined' ? self : {};

            function commonjsRequire () {
            	throw new Error('Dynamic requires are not currently supported by rollup-plugin-commonjs');
            }

            function unwrapExports$1 (x) {
            	return x && x.__esModule && Object.prototype.hasOwnProperty.call(x, 'default') ? x['default'] : x;
            }

            function createCommonjsModule$1(fn, module) {
            	return module = { exports: {} }, fn(module, module.exports), module.exports;
            }

            var interopRequireDefault$1 = createCommonjsModule$1(function (module) {
            function _interopRequireDefault(obj) {
              return obj && obj.__esModule ? obj : {
                default: obj
              };
            }

            module.exports = _interopRequireDefault;
            });

            unwrapExports$1(interopRequireDefault$1);

            var classCallCheck$1 = createCommonjsModule$1(function (module, exports) {

            exports.__esModule = true;

            exports.default = function (instance, Constructor) {
              if (!(instance instanceof Constructor)) {
                throw new TypeError("Cannot call a class as a function");
              }
            };
            });

            unwrapExports$1(classCallCheck$1);

            // 7.1.4 ToInteger
            var ceil = Math.ceil;
            var floor$1 = Math.floor;
            var _toInteger = function (it) {
              return isNaN(it = +it) ? 0 : (it > 0 ? floor$1 : ceil)(it);
            };

            // 7.2.1 RequireObjectCoercible(argument)
            var _defined = function (it) {
              if (it == undefined) throw TypeError("Can't call method on  " + it);
              return it;
            };

            // true  -> String#at
            // false -> String#codePointAt
            var _stringAt = function (TO_STRING) {
              return function (that, pos) {
                var s = String(_defined(that));
                var i = _toInteger(pos);
                var l = s.length;
                var a, b;
                if (i < 0 || i >= l) return TO_STRING ? '' : undefined;
                a = s.charCodeAt(i);
                return a < 0xd800 || a > 0xdbff || i + 1 === l || (b = s.charCodeAt(i + 1)) < 0xdc00 || b > 0xdfff
                  ? TO_STRING ? s.charAt(i) : a
                  : TO_STRING ? s.slice(i, i + 2) : (a - 0xd800 << 10) + (b - 0xdc00) + 0x10000;
              };
            };

            var _library = true;

            var _global = createCommonjsModule$1(function (module) {
            // https://github.com/zloirock/core-js/issues/86#issuecomment-115759028
            var global = module.exports = typeof window != 'undefined' && window.Math == Math
              ? window : typeof self != 'undefined' && self.Math == Math ? self
              // eslint-disable-next-line no-new-func
              : Function('return this')();
            if (typeof __g == 'number') __g = global; // eslint-disable-line no-undef
            });

            var _core = createCommonjsModule$1(function (module) {
            var core = module.exports = { version: '2.6.11' };
            if (typeof __e == 'number') __e = core; // eslint-disable-line no-undef
            });
            _core.version;

            var _aFunction = function (it) {
              if (typeof it != 'function') throw TypeError(it + ' is not a function!');
              return it;
            };

            // optional / simple context binding

            var _ctx = function (fn, that, length) {
              _aFunction(fn);
              if (that === undefined) return fn;
              switch (length) {
                case 1: return function (a) {
                  return fn.call(that, a);
                };
                case 2: return function (a, b) {
                  return fn.call(that, a, b);
                };
                case 3: return function (a, b, c) {
                  return fn.call(that, a, b, c);
                };
              }
              return function (/* ...args */) {
                return fn.apply(that, arguments);
              };
            };

            var _isObject = function (it) {
              return typeof it === 'object' ? it !== null : typeof it === 'function';
            };

            var _anObject = function (it) {
              if (!_isObject(it)) throw TypeError(it + ' is not an object!');
              return it;
            };

            var _fails = function (exec) {
              try {
                return !!exec();
              } catch (e) {
                return true;
              }
            };

            // Thank's IE8 for his funny defineProperty
            var _descriptors = !_fails(function () {
              return Object.defineProperty({}, 'a', { get: function () { return 7; } }).a != 7;
            });

            var document$2 = _global.document;
            // typeof document.createElement is 'object' in old IE
            var is$1 = _isObject(document$2) && _isObject(document$2.createElement);
            var _domCreate = function (it) {
              return is$1 ? document$2.createElement(it) : {};
            };

            var _ie8DomDefine = !_descriptors && !_fails(function () {
              return Object.defineProperty(_domCreate('div'), 'a', { get: function () { return 7; } }).a != 7;
            });

            // 7.1.1 ToPrimitive(input [, PreferredType])

            // instead of the ES6 spec version, we didn't implement @@toPrimitive case
            // and the second argument - flag - preferred type is a string
            var _toPrimitive = function (it, S) {
              if (!_isObject(it)) return it;
              var fn, val;
              if (S && typeof (fn = it.toString) == 'function' && !_isObject(val = fn.call(it))) return val;
              if (typeof (fn = it.valueOf) == 'function' && !_isObject(val = fn.call(it))) return val;
              if (!S && typeof (fn = it.toString) == 'function' && !_isObject(val = fn.call(it))) return val;
              throw TypeError("Can't convert object to primitive value");
            };

            var dP$1 = Object.defineProperty;

            var f$6 = _descriptors ? Object.defineProperty : function defineProperty(O, P, Attributes) {
              _anObject(O);
              P = _toPrimitive(P, true);
              _anObject(Attributes);
              if (_ie8DomDefine) try {
                return dP$1(O, P, Attributes);
              } catch (e) { /* empty */ }
              if ('get' in Attributes || 'set' in Attributes) throw TypeError('Accessors not supported!');
              if ('value' in Attributes) O[P] = Attributes.value;
              return O;
            };

            var _objectDp = {
            	f: f$6
            };

            var _propertyDesc = function (bitmap, value) {
              return {
                enumerable: !(bitmap & 1),
                configurable: !(bitmap & 2),
                writable: !(bitmap & 4),
                value: value
              };
            };

            var _hide = _descriptors ? function (object, key, value) {
              return _objectDp.f(object, key, _propertyDesc(1, value));
            } : function (object, key, value) {
              object[key] = value;
              return object;
            };

            var hasOwnProperty$c$1 = {}.hasOwnProperty;
            var _has = function (it, key) {
              return hasOwnProperty$c$1.call(it, key);
            };

            var PROTOTYPE$2 = 'prototype';

            var $export = function (type, name, source) {
              var IS_FORCED = type & $export.F;
              var IS_GLOBAL = type & $export.G;
              var IS_STATIC = type & $export.S;
              var IS_PROTO = type & $export.P;
              var IS_BIND = type & $export.B;
              var IS_WRAP = type & $export.W;
              var exports = IS_GLOBAL ? _core : _core[name] || (_core[name] = {});
              var expProto = exports[PROTOTYPE$2];
              var target = IS_GLOBAL ? _global : IS_STATIC ? _global[name] : (_global[name] || {})[PROTOTYPE$2];
              var key, own, out;
              if (IS_GLOBAL) source = name;
              for (key in source) {
                // contains in native
                own = !IS_FORCED && target && target[key] !== undefined;
                if (own && _has(exports, key)) continue;
                // export native or passed
                out = own ? target[key] : source[key];
                // prevent global pollution for namespaces
                exports[key] = IS_GLOBAL && typeof target[key] != 'function' ? source[key]
                // bind timers to global for call from export context
                : IS_BIND && own ? _ctx(out, _global)
                // wrap global constructors for prevent change them in library
                : IS_WRAP && target[key] == out ? (function (C) {
                  var F = function (a, b, c) {
                    if (this instanceof C) {
                      switch (arguments.length) {
                        case 0: return new C();
                        case 1: return new C(a);
                        case 2: return new C(a, b);
                      } return new C(a, b, c);
                    } return C.apply(this, arguments);
                  };
                  F[PROTOTYPE$2] = C[PROTOTYPE$2];
                  return F;
                // make static versions for prototype methods
                })(out) : IS_PROTO && typeof out == 'function' ? _ctx(Function.call, out) : out;
                // export proto methods to core.%CONSTRUCTOR%.methods.%NAME%
                if (IS_PROTO) {
                  (exports.virtual || (exports.virtual = {}))[key] = out;
                  // export proto methods to core.%CONSTRUCTOR%.prototype.%NAME%
                  if (type & $export.R && expProto && !expProto[key]) _hide(expProto, key, out);
                }
              }
            };
            // type bitmap
            $export.F = 1;   // forced
            $export.G = 2;   // global
            $export.S = 4;   // static
            $export.P = 8;   // proto
            $export.B = 16;  // bind
            $export.W = 32;  // wrap
            $export.U = 64;  // safe
            $export.R = 128; // real proto method for `library`
            var _export = $export;

            var _redefine = _hide;

            var toString$2$1 = {}.toString;

            var _cof = function (it) {
              return toString$2$1.call(it).slice(8, -1);
            };

            // fallback for non-array-like ES3 and non-enumerable old V8 strings

            // eslint-disable-next-line no-prototype-builtins
            var _iobject = Object('z').propertyIsEnumerable(0) ? Object : function (it) {
              return _cof(it) == 'String' ? it.split('') : Object(it);
            };

            // to indexed object, toObject with fallback for non-array-like ES3 strings


            var _toIobject = function (it) {
              return _iobject(_defined(it));
            };

            // 7.1.15 ToLength

            var min$1 = Math.min;
            var _toLength = function (it) {
              return it > 0 ? min$1(_toInteger(it), 0x1fffffffffffff) : 0; // pow(2, 53) - 1 == 9007199254740991
            };

            var max = Math.max;
            var min = Math.min;
            var _toAbsoluteIndex = function (index, length) {
              index = _toInteger(index);
              return index < 0 ? max(index + length, 0) : min(index, length);
            };

            // false -> Array#indexOf
            // true  -> Array#includes



            var _arrayIncludes$1 = function (IS_INCLUDES) {
              return function ($this, el, fromIndex) {
                var O = _toIobject($this);
                var length = _toLength(O.length);
                var index = _toAbsoluteIndex(fromIndex, length);
                var value;
                // Array#includes uses SameValueZero equality algorithm
                // eslint-disable-next-line no-self-compare
                if (IS_INCLUDES && el != el) while (length > index) {
                  value = O[index++];
                  // eslint-disable-next-line no-self-compare
                  if (value != value) return true;
                // Array#indexOf ignores holes, Array#includes - not
                } else for (;length > index; index++) if (IS_INCLUDES || index in O) {
                  if (O[index] === el) return IS_INCLUDES || index || 0;
                } return !IS_INCLUDES && -1;
              };
            };

            var _shared = createCommonjsModule$1(function (module) {
            var SHARED = '__core-js_shared__';
            var store = _global[SHARED] || (_global[SHARED] = {});

            (module.exports = function (key, value) {
              return store[key] || (store[key] = value !== undefined ? value : {});
            })('versions', []).push({
              version: _core.version,
              mode: 'pure' ,
              copyright: '© 2019 Denis Pushkarev (zloirock.ru)'
            });
            });

            var id = 0;
            var px = Math.random();
            var _uid = function (key) {
              return 'Symbol('.concat(key === undefined ? '' : key, ')_', (++id + px).toString(36));
            };

            var shared = _shared('keys');

            var _sharedKey = function (key) {
              return shared[key] || (shared[key] = _uid(key));
            };

            var arrayIndexOf$1 = _arrayIncludes$1(false);
            var IE_PROTO$2 = _sharedKey('IE_PROTO');

            var _objectKeysInternal = function (object, names) {
              var O = _toIobject(object);
              var i = 0;
              var result = [];
              var key;
              for (key in O) if (key != IE_PROTO$2) _has(O, key) && result.push(key);
              // Don't enum bug & hidden keys
              while (names.length > i) if (_has(O, key = names[i++])) {
                ~arrayIndexOf$1(result, key) || result.push(key);
              }
              return result;
            };

            // IE 8- don't enum bug keys
            var _enumBugKeys = (
              'constructor,hasOwnProperty,isPrototypeOf,propertyIsEnumerable,toLocaleString,toString,valueOf'
            ).split(',');

            // 19.1.2.14 / 15.2.3.14 Object.keys(O)



            var _objectKeys = Object.keys || function keys(O) {
              return _objectKeysInternal(O, _enumBugKeys);
            };

            var _objectDps = _descriptors ? Object.defineProperties : function defineProperties(O, Properties) {
              _anObject(O);
              var keys = _objectKeys(Properties);
              var length = keys.length;
              var i = 0;
              var P;
              while (length > i) _objectDp.f(O, P = keys[i++], Properties[P]);
              return O;
            };

            var document$1 = _global.document;
            var _html = document$1 && document$1.documentElement;

            // 19.1.2.2 / 15.2.3.5 Object.create(O [, Properties])



            var IE_PROTO$1 = _sharedKey('IE_PROTO');
            var Empty = function () { /* empty */ };
            var PROTOTYPE$1 = 'prototype';

            // Create object with fake `null` prototype: use iframe Object with cleared prototype
            var createDict = function () {
              // Thrash, waste and sodomy: IE GC bug
              var iframe = _domCreate('iframe');
              var i = _enumBugKeys.length;
              var lt = '<';
              var gt = '>';
              var iframeDocument;
              iframe.style.display = 'none';
              _html.appendChild(iframe);
              iframe.src = 'javascript:'; // eslint-disable-line no-script-url
              // createDict = iframe.contentWindow.Object;
              // html.removeChild(iframe);
              iframeDocument = iframe.contentWindow.document;
              iframeDocument.open();
              iframeDocument.write(lt + 'script' + gt + 'document.F=Object' + lt + '/script' + gt);
              iframeDocument.close();
              createDict = iframeDocument.F;
              while (i--) delete createDict[PROTOTYPE$1][_enumBugKeys[i]];
              return createDict();
            };

            var _objectCreate = Object.create || function create(O, Properties) {
              var result;
              if (O !== null) {
                Empty[PROTOTYPE$1] = _anObject(O);
                result = new Empty();
                Empty[PROTOTYPE$1] = null;
                // add "__proto__" for Object.getPrototypeOf polyfill
                result[IE_PROTO$1] = O;
              } else result = createDict();
              return Properties === undefined ? result : _objectDps(result, Properties);
            };

            var _wks = createCommonjsModule$1(function (module) {
            var store = _shared('wks');

            var Symbol = _global.Symbol;
            var USE_SYMBOL = typeof Symbol == 'function';

            var $exports = module.exports = function (name) {
              return store[name] || (store[name] =
                USE_SYMBOL && Symbol[name] || (USE_SYMBOL ? Symbol : _uid)('Symbol.' + name));
            };

            $exports.store = store;
            });

            var def = _objectDp.f;

            var TAG = _wks('toStringTag');

            var _setToStringTag = function (it, tag, stat) {
              if (it && !_has(it = stat ? it : it.prototype, TAG)) def(it, TAG, { configurable: true, value: tag });
            };

            var IteratorPrototype = {};

            // 25.1.2.1.1 %IteratorPrototype%[@@iterator]()
            _hide(IteratorPrototype, _wks('iterator'), function () { return this; });

            var _iterCreate = function (Constructor, NAME, next) {
              Constructor.prototype = _objectCreate(IteratorPrototype, { next: _propertyDesc(1, next) });
              _setToStringTag(Constructor, NAME + ' Iterator');
            };

            // 7.1.13 ToObject(argument)

            var _toObject = function (it) {
              return Object(_defined(it));
            };

            // 19.1.2.9 / 15.2.3.2 Object.getPrototypeOf(O)


            var IE_PROTO = _sharedKey('IE_PROTO');
            var ObjectProto$1 = Object.prototype;

            var _objectGpo = Object.getPrototypeOf || function (O) {
              O = _toObject(O);
              if (_has(O, IE_PROTO)) return O[IE_PROTO];
              if (typeof O.constructor == 'function' && O instanceof O.constructor) {
                return O.constructor.prototype;
              } return O instanceof Object ? ObjectProto$1 : null;
            };

            var ITERATOR = _wks('iterator');
            var BUGGY = !([].keys && 'next' in [].keys()); // Safari has buggy iterators w/o `next`
            var FF_ITERATOR = '@@iterator';
            var KEYS = 'keys';
            var VALUES$1 = 'values';

            var _iterDefine = function (Base, NAME, Constructor, next, DEFAULT, IS_SET, FORCED) {
              _iterCreate(Constructor, NAME, next);
              var getMethod = function (kind) {
                if (!BUGGY && kind in proto) return proto[kind];
                switch (kind) {
                  case KEYS: return function keys() { return new Constructor(this, kind); };
                  case VALUES$1: return function values() { return new Constructor(this, kind); };
                } return function entries() { return new Constructor(this, kind); };
              };
              var TAG = NAME + ' Iterator';
              var DEF_VALUES = DEFAULT == VALUES$1;
              var VALUES_BUG = false;
              var proto = Base.prototype;
              var $native = proto[ITERATOR] || proto[FF_ITERATOR] || DEFAULT && proto[DEFAULT];
              var $default = $native || getMethod(DEFAULT);
              var $entries = DEFAULT ? !DEF_VALUES ? $default : getMethod('entries') : undefined;
              var $anyNative = NAME == 'Array' ? proto.entries || $native : $native;
              var methods, key, IteratorPrototype;
              // Fix native
              if ($anyNative) {
                IteratorPrototype = _objectGpo($anyNative.call(new Base()));
                if (IteratorPrototype !== Object.prototype && IteratorPrototype.next) {
                  // Set @@toStringTag to native iterators
                  _setToStringTag(IteratorPrototype, TAG, true);
                }
              }
              // fix Array#{values, @@iterator}.name in V8 / FF
              if (DEF_VALUES && $native && $native.name !== VALUES$1) {
                VALUES_BUG = true;
                $default = function values() { return $native.call(this); };
              }
              // Define iterator
              if ((FORCED) && (BUGGY || VALUES_BUG || !proto[ITERATOR])) {
                _hide(proto, ITERATOR, $default);
              }
              if (DEFAULT) {
                methods = {
                  values: DEF_VALUES ? $default : getMethod(VALUES$1),
                  keys: IS_SET ? $default : getMethod(KEYS),
                  entries: $entries
                };
                if (FORCED) for (key in methods) {
                  if (!(key in proto)) _redefine(proto, key, methods[key]);
                } else _export(_export.P + _export.F * (BUGGY || VALUES_BUG), NAME, methods);
              }
              return methods;
            };

            var $at = _stringAt(true);

            // 21.1.3.27 String.prototype[@@iterator]()
            _iterDefine(String, 'String', function (iterated) {
              this._t = String(iterated); // target
              this._i = 0;                // next index
            // 21.1.5.2.1 %StringIteratorPrototype%.next()
            }, function () {
              var O = this._t;
              var index = this._i;
              var point;
              if (index >= O.length) return { value: undefined, done: true };
              point = $at(O, index);
              this._i += point.length;
              return { value: point, done: false };
            });

            var _iterStep = function (done, value) {
              return { value: value, done: !!done };
            };

            // 22.1.3.4 Array.prototype.entries()
            // 22.1.3.13 Array.prototype.keys()
            // 22.1.3.29 Array.prototype.values()
            // 22.1.3.30 Array.prototype[@@iterator]()
            _iterDefine(Array, 'Array', function (iterated, kind) {
              this._t = _toIobject(iterated); // target
              this._i = 0;                   // next index
              this._k = kind;                // kind
            // 22.1.5.2.1 %ArrayIteratorPrototype%.next()
            }, function () {
              var O = this._t;
              var kind = this._k;
              var index = this._i++;
              if (!O || index >= O.length) {
                this._t = undefined;
                return _iterStep(1);
              }
              if (kind == 'keys') return _iterStep(0, index);
              if (kind == 'values') return _iterStep(0, O[index]);
              return _iterStep(0, [index, O[index]]);
            }, 'values');

            var TO_STRING_TAG = _wks('toStringTag');

            var DOMIterables = ('CSSRuleList,CSSStyleDeclaration,CSSValueList,ClientRectList,DOMRectList,DOMStringList,' +
              'DOMTokenList,DataTransferItemList,FileList,HTMLAllCollection,HTMLCollection,HTMLFormElement,HTMLSelectElement,' +
              'MediaList,MimeTypeArray,NamedNodeMap,NodeList,PaintRequestList,Plugin,PluginArray,SVGLengthList,SVGNumberList,' +
              'SVGPathSegList,SVGPointList,SVGStringList,SVGTransformList,SourceBufferList,StyleSheetList,TextTrackCueList,' +
              'TextTrackList,TouchList').split(',');

            for (var i = 0; i < DOMIterables.length; i++) {
              var NAME$1 = DOMIterables[i];
              var Collection = _global[NAME$1];
              var proto = Collection && Collection.prototype;
              if (proto && !proto[TO_STRING_TAG]) _hide(proto, TO_STRING_TAG, NAME$1);
            }

            var f$5 = _wks;

            var _wksExt = {
            	f: f$5
            };

            var iterator$1 = _wksExt.f('iterator');

            var iterator = createCommonjsModule$1(function (module) {
            module.exports = { "default": iterator$1, __esModule: true };
            });

            unwrapExports$1(iterator);

            var _meta = createCommonjsModule$1(function (module) {
            var META = _uid('meta');


            var setDesc = _objectDp.f;
            var id = 0;
            var isExtensible = Object.isExtensible || function () {
              return true;
            };
            var FREEZE = !_fails(function () {
              return isExtensible(Object.preventExtensions({}));
            });
            var setMeta = function (it) {
              setDesc(it, META, { value: {
                i: 'O' + ++id, // object ID
                w: {}          // weak collections IDs
              } });
            };
            var fastKey = function (it, create) {
              // return primitive with prefix
              if (!_isObject(it)) return typeof it == 'symbol' ? it : (typeof it == 'string' ? 'S' : 'P') + it;
              if (!_has(it, META)) {
                // can't set metadata to uncaught frozen object
                if (!isExtensible(it)) return 'F';
                // not necessary to add metadata
                if (!create) return 'E';
                // add missing metadata
                setMeta(it);
              // return object ID
              } return it[META].i;
            };
            var getWeak = function (it, create) {
              if (!_has(it, META)) {
                // can't set metadata to uncaught frozen object
                if (!isExtensible(it)) return true;
                // not necessary to add metadata
                if (!create) return false;
                // add missing metadata
                setMeta(it);
              // return hash weak collections IDs
              } return it[META].w;
            };
            // add metadata on freeze-family methods calling
            var onFreeze = function (it) {
              if (FREEZE && meta.NEED && isExtensible(it) && !_has(it, META)) setMeta(it);
              return it;
            };
            var meta = module.exports = {
              KEY: META,
              NEED: false,
              fastKey: fastKey,
              getWeak: getWeak,
              onFreeze: onFreeze
            };
            });
            _meta.KEY;
            _meta.NEED;
            _meta.fastKey;
            _meta.getWeak;
            _meta.onFreeze;

            var defineProperty$3 = _objectDp.f;
            var _wksDefine = function (name) {
              var $Symbol = _core.Symbol || (_core.Symbol = {} );
              if (name.charAt(0) != '_' && !(name in $Symbol)) defineProperty$3($Symbol, name, { value: _wksExt.f(name) });
            };

            var f$4 = Object.getOwnPropertySymbols;

            var _objectGops = {
            	f: f$4
            };

            var f$3 = {}.propertyIsEnumerable;

            var _objectPie = {
            	f: f$3
            };

            // all enumerable object keys, includes symbols



            var _enumKeys = function (it) {
              var result = _objectKeys(it);
              var getSymbols = _objectGops.f;
              if (getSymbols) {
                var symbols = getSymbols(it);
                var isEnum = _objectPie.f;
                var i = 0;
                var key;
                while (symbols.length > i) if (isEnum.call(it, key = symbols[i++])) result.push(key);
              } return result;
            };

            // 7.2.2 IsArray(argument)

            var _isArray = Array.isArray || function isArray(arg) {
              return _cof(arg) == 'Array';
            };

            // 19.1.2.7 / 15.2.3.4 Object.getOwnPropertyNames(O)

            var hiddenKeys = _enumBugKeys.concat('length', 'prototype');

            var f$2 = Object.getOwnPropertyNames || function getOwnPropertyNames(O) {
              return _objectKeysInternal(O, hiddenKeys);
            };

            var _objectGopn = {
            	f: f$2
            };

            // fallback for IE11 buggy Object.getOwnPropertyNames with iframe and window

            var gOPN$1 = _objectGopn.f;
            var toString$1$1 = {}.toString;

            var windowNames = typeof window == 'object' && window && Object.getOwnPropertyNames
              ? Object.getOwnPropertyNames(window) : [];

            var getWindowNames = function (it) {
              try {
                return gOPN$1(it);
              } catch (e) {
                return windowNames.slice();
              }
            };

            var f$1 = function getOwnPropertyNames(it) {
              return windowNames && toString$1$1.call(it) == '[object Window]' ? getWindowNames(it) : gOPN$1(_toIobject(it));
            };

            var _objectGopnExt = {
            	f: f$1
            };

            var gOPD$1 = Object.getOwnPropertyDescriptor;

            var f = _descriptors ? gOPD$1 : function getOwnPropertyDescriptor(O, P) {
              O = _toIobject(O);
              P = _toPrimitive(P, true);
              if (_ie8DomDefine) try {
                return gOPD$1(O, P);
              } catch (e) { /* empty */ }
              if (_has(O, P)) return _propertyDesc(!_objectPie.f.call(O, P), O[P]);
            };

            var _objectGopd = {
            	f: f
            };

            // ECMAScript 6 symbols shim





            var META = _meta.KEY;





















            var gOPD = _objectGopd.f;
            var dP = _objectDp.f;
            var gOPN = _objectGopnExt.f;
            var $Symbol = _global.Symbol;
            var $JSON = _global.JSON;
            var _stringify = $JSON && $JSON.stringify;
            var PROTOTYPE = 'prototype';
            var HIDDEN = _wks('_hidden');
            var TO_PRIMITIVE = _wks('toPrimitive');
            var isEnum = {}.propertyIsEnumerable;
            var SymbolRegistry = _shared('symbol-registry');
            var AllSymbols = _shared('symbols');
            var OPSymbols = _shared('op-symbols');
            var ObjectProto = Object[PROTOTYPE];
            var USE_NATIVE = typeof $Symbol == 'function' && !!_objectGops.f;
            var QObject = _global.QObject;
            // Don't use setters in Qt Script, https://github.com/zloirock/core-js/issues/173
            var setter = !QObject || !QObject[PROTOTYPE] || !QObject[PROTOTYPE].findChild;

            // fallback for old Android, https://code.google.com/p/v8/issues/detail?id=687
            var setSymbolDesc = _descriptors && _fails(function () {
              return _objectCreate(dP({}, 'a', {
                get: function () { return dP(this, 'a', { value: 7 }).a; }
              })).a != 7;
            }) ? function (it, key, D) {
              var protoDesc = gOPD(ObjectProto, key);
              if (protoDesc) delete ObjectProto[key];
              dP(it, key, D);
              if (protoDesc && it !== ObjectProto) dP(ObjectProto, key, protoDesc);
            } : dP;

            var wrap = function (tag) {
              var sym = AllSymbols[tag] = _objectCreate($Symbol[PROTOTYPE]);
              sym._k = tag;
              return sym;
            };

            var isSymbol$1$1 = USE_NATIVE && typeof $Symbol.iterator == 'symbol' ? function (it) {
              return typeof it == 'symbol';
            } : function (it) {
              return it instanceof $Symbol;
            };

            var $defineProperty = function defineProperty(it, key, D) {
              if (it === ObjectProto) $defineProperty(OPSymbols, key, D);
              _anObject(it);
              key = _toPrimitive(key, true);
              _anObject(D);
              if (_has(AllSymbols, key)) {
                if (!D.enumerable) {
                  if (!_has(it, HIDDEN)) dP(it, HIDDEN, _propertyDesc(1, {}));
                  it[HIDDEN][key] = true;
                } else {
                  if (_has(it, HIDDEN) && it[HIDDEN][key]) it[HIDDEN][key] = false;
                  D = _objectCreate(D, { enumerable: _propertyDesc(0, false) });
                } return setSymbolDesc(it, key, D);
              } return dP(it, key, D);
            };
            var $defineProperties = function defineProperties(it, P) {
              _anObject(it);
              var keys = _enumKeys(P = _toIobject(P));
              var i = 0;
              var l = keys.length;
              var key;
              while (l > i) $defineProperty(it, key = keys[i++], P[key]);
              return it;
            };
            var $create = function create(it, P) {
              return P === undefined ? _objectCreate(it) : $defineProperties(_objectCreate(it), P);
            };
            var $propertyIsEnumerable = function propertyIsEnumerable(key) {
              var E = isEnum.call(this, key = _toPrimitive(key, true));
              if (this === ObjectProto && _has(AllSymbols, key) && !_has(OPSymbols, key)) return false;
              return E || !_has(this, key) || !_has(AllSymbols, key) || _has(this, HIDDEN) && this[HIDDEN][key] ? E : true;
            };
            var $getOwnPropertyDescriptor = function getOwnPropertyDescriptor(it, key) {
              it = _toIobject(it);
              key = _toPrimitive(key, true);
              if (it === ObjectProto && _has(AllSymbols, key) && !_has(OPSymbols, key)) return;
              var D = gOPD(it, key);
              if (D && _has(AllSymbols, key) && !(_has(it, HIDDEN) && it[HIDDEN][key])) D.enumerable = true;
              return D;
            };
            var $getOwnPropertyNames = function getOwnPropertyNames(it) {
              var names = gOPN(_toIobject(it));
              var result = [];
              var i = 0;
              var key;
              while (names.length > i) {
                if (!_has(AllSymbols, key = names[i++]) && key != HIDDEN && key != META) result.push(key);
              } return result;
            };
            var $getOwnPropertySymbols = function getOwnPropertySymbols(it) {
              var IS_OP = it === ObjectProto;
              var names = gOPN(IS_OP ? OPSymbols : _toIobject(it));
              var result = [];
              var i = 0;
              var key;
              while (names.length > i) {
                if (_has(AllSymbols, key = names[i++]) && (IS_OP ? _has(ObjectProto, key) : true)) result.push(AllSymbols[key]);
              } return result;
            };

            // 19.4.1.1 Symbol([description])
            if (!USE_NATIVE) {
              $Symbol = function Symbol() {
                if (this instanceof $Symbol) throw TypeError('Symbol is not a constructor!');
                var tag = _uid(arguments.length > 0 ? arguments[0] : undefined);
                var $set = function (value) {
                  if (this === ObjectProto) $set.call(OPSymbols, value);
                  if (_has(this, HIDDEN) && _has(this[HIDDEN], tag)) this[HIDDEN][tag] = false;
                  setSymbolDesc(this, tag, _propertyDesc(1, value));
                };
                if (_descriptors && setter) setSymbolDesc(ObjectProto, tag, { configurable: true, set: $set });
                return wrap(tag);
              };
              _redefine($Symbol[PROTOTYPE], 'toString', function toString() {
                return this._k;
              });

              _objectGopd.f = $getOwnPropertyDescriptor;
              _objectDp.f = $defineProperty;
              _objectGopn.f = _objectGopnExt.f = $getOwnPropertyNames;
              _objectPie.f = $propertyIsEnumerable;
              _objectGops.f = $getOwnPropertySymbols;

              if (_descriptors && !_library) {
                _redefine(ObjectProto, 'propertyIsEnumerable', $propertyIsEnumerable);
              }

              _wksExt.f = function (name) {
                return wrap(_wks(name));
              };
            }

            _export(_export.G + _export.W + _export.F * !USE_NATIVE, { Symbol: $Symbol });

            for (var es6Symbols = (
              // 19.4.2.2, 19.4.2.3, 19.4.2.4, 19.4.2.6, 19.4.2.8, 19.4.2.9, 19.4.2.10, 19.4.2.11, 19.4.2.12, 19.4.2.13, 19.4.2.14
              'hasInstance,isConcatSpreadable,iterator,match,replace,search,species,split,toPrimitive,toStringTag,unscopables'
            ).split(','), j = 0; es6Symbols.length > j;)_wks(es6Symbols[j++]);

            for (var wellKnownSymbols = _objectKeys(_wks.store), k = 0; wellKnownSymbols.length > k;) _wksDefine(wellKnownSymbols[k++]);

            _export(_export.S + _export.F * !USE_NATIVE, 'Symbol', {
              // 19.4.2.1 Symbol.for(key)
              'for': function (key) {
                return _has(SymbolRegistry, key += '')
                  ? SymbolRegistry[key]
                  : SymbolRegistry[key] = $Symbol(key);
              },
              // 19.4.2.5 Symbol.keyFor(sym)
              keyFor: function keyFor(sym) {
                if (!isSymbol$1$1(sym)) throw TypeError(sym + ' is not a symbol!');
                for (var key in SymbolRegistry) if (SymbolRegistry[key] === sym) return key;
              },
              useSetter: function () { setter = true; },
              useSimple: function () { setter = false; }
            });

            _export(_export.S + _export.F * !USE_NATIVE, 'Object', {
              // 19.1.2.2 Object.create(O [, Properties])
              create: $create,
              // 19.1.2.4 Object.defineProperty(O, P, Attributes)
              defineProperty: $defineProperty,
              // 19.1.2.3 Object.defineProperties(O, Properties)
              defineProperties: $defineProperties,
              // 19.1.2.6 Object.getOwnPropertyDescriptor(O, P)
              getOwnPropertyDescriptor: $getOwnPropertyDescriptor,
              // 19.1.2.7 Object.getOwnPropertyNames(O)
              getOwnPropertyNames: $getOwnPropertyNames,
              // 19.1.2.8 Object.getOwnPropertySymbols(O)
              getOwnPropertySymbols: $getOwnPropertySymbols
            });

            // Chrome 38 and 39 `Object.getOwnPropertySymbols` fails on primitives
            // https://bugs.chromium.org/p/v8/issues/detail?id=3443
            var FAILS_ON_PRIMITIVES = _fails(function () { _objectGops.f(1); });

            _export(_export.S + _export.F * FAILS_ON_PRIMITIVES, 'Object', {
              getOwnPropertySymbols: function getOwnPropertySymbols(it) {
                return _objectGops.f(_toObject(it));
              }
            });

            // 24.3.2 JSON.stringify(value [, replacer [, space]])
            $JSON && _export(_export.S + _export.F * (!USE_NATIVE || _fails(function () {
              var S = $Symbol();
              // MS Edge converts symbol values to JSON as {}
              // WebKit converts symbol values to JSON as null
              // V8 throws on boxed symbols
              return _stringify([S]) != '[null]' || _stringify({ a: S }) != '{}' || _stringify(Object(S)) != '{}';
            })), 'JSON', {
              stringify: function stringify(it) {
                var args = [it];
                var i = 1;
                var replacer, $replacer;
                while (arguments.length > i) args.push(arguments[i++]);
                $replacer = replacer = args[1];
                if (!_isObject(replacer) && it === undefined || isSymbol$1$1(it)) return; // IE8 returns string on undefined
                if (!_isArray(replacer)) replacer = function (key, value) {
                  if (typeof $replacer == 'function') value = $replacer.call(this, key, value);
                  if (!isSymbol$1$1(value)) return value;
                };
                args[1] = replacer;
                return _stringify.apply($JSON, args);
              }
            });

            // 19.4.3.4 Symbol.prototype[@@toPrimitive](hint)
            $Symbol[PROTOTYPE][TO_PRIMITIVE] || _hide($Symbol[PROTOTYPE], TO_PRIMITIVE, $Symbol[PROTOTYPE].valueOf);
            // 19.4.3.5 Symbol.prototype[@@toStringTag]
            _setToStringTag($Symbol, 'Symbol');
            // 20.2.1.9 Math[@@toStringTag]
            _setToStringTag(Math, 'Math', true);
            // 24.3.3 JSON[@@toStringTag]
            _setToStringTag(_global.JSON, 'JSON', true);

            _wksDefine('asyncIterator');

            _wksDefine('observable');

            var symbol$1 = _core.Symbol;

            var symbol = createCommonjsModule$1(function (module) {
            module.exports = { "default": symbol$1, __esModule: true };
            });

            unwrapExports$1(symbol);

            var _typeof_1$1 = createCommonjsModule$1(function (module, exports) {

            exports.__esModule = true;



            var _iterator2 = _interopRequireDefault(iterator);



            var _symbol2 = _interopRequireDefault(symbol);

            var _typeof = typeof _symbol2.default === "function" && typeof _iterator2.default === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof _symbol2.default === "function" && obj.constructor === _symbol2.default && obj !== _symbol2.default.prototype ? "symbol" : typeof obj; };

            function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

            exports.default = typeof _symbol2.default === "function" && _typeof(_iterator2.default) === "symbol" ? function (obj) {
              return typeof obj === "undefined" ? "undefined" : _typeof(obj);
            } : function (obj) {
              return obj && typeof _symbol2.default === "function" && obj.constructor === _symbol2.default && obj !== _symbol2.default.prototype ? "symbol" : typeof obj === "undefined" ? "undefined" : _typeof(obj);
            };
            });

            unwrapExports$1(_typeof_1$1);

            var possibleConstructorReturn$1 = createCommonjsModule$1(function (module, exports) {

            exports.__esModule = true;



            var _typeof3 = _interopRequireDefault(_typeof_1$1);

            function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

            exports.default = function (self, call) {
              if (!self) {
                throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
              }

              return call && ((typeof call === "undefined" ? "undefined" : (0, _typeof3.default)(call)) === "object" || typeof call === "function") ? call : self;
            };
            });

            unwrapExports$1(possibleConstructorReturn$1);

            // Works with __proto__ only. Old v8 can't work with null proto objects.
            /* eslint-disable no-proto */


            var check = function (O, proto) {
              _anObject(O);
              if (!_isObject(proto) && proto !== null) throw TypeError(proto + ": can't set as prototype!");
            };
            var _setProto = {
              set: Object.setPrototypeOf || ('__proto__' in {} ? // eslint-disable-line
                function (test, buggy, set) {
                  try {
                    set = _ctx(Function.call, _objectGopd.f(Object.prototype, '__proto__').set, 2);
                    set(test, []);
                    buggy = !(test instanceof Array);
                  } catch (e) { buggy = true; }
                  return function setPrototypeOf(O, proto) {
                    check(O, proto);
                    if (buggy) O.__proto__ = proto;
                    else set(O, proto);
                    return O;
                  };
                }({}, false) : undefined),
              check: check
            };

            // 19.1.3.19 Object.setPrototypeOf(O, proto)

            _export(_export.S, 'Object', { setPrototypeOf: _setProto.set });

            var setPrototypeOf$2 = _core.Object.setPrototypeOf;

            var setPrototypeOf$1 = createCommonjsModule$1(function (module) {
            module.exports = { "default": setPrototypeOf$2, __esModule: true };
            });

            unwrapExports$1(setPrototypeOf$1);

            // 19.1.2.2 / 15.2.3.5 Object.create(O [, Properties])
            _export(_export.S, 'Object', { create: _objectCreate });

            var $Object = _core.Object;
            var create$1 = function create(P, D) {
              return $Object.create(P, D);
            };

            var create = createCommonjsModule$1(function (module) {
            module.exports = { "default": create$1, __esModule: true };
            });

            unwrapExports$1(create);

            var inherits$1$1 = createCommonjsModule$1(function (module, exports) {

            exports.__esModule = true;



            var _setPrototypeOf2 = _interopRequireDefault(setPrototypeOf$1);



            var _create2 = _interopRequireDefault(create);



            var _typeof3 = _interopRequireDefault(_typeof_1$1);

            function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

            exports.default = function (subClass, superClass) {
              if (typeof superClass !== "function" && superClass !== null) {
                throw new TypeError("Super expression must either be null or a function, not " + (typeof superClass === "undefined" ? "undefined" : (0, _typeof3.default)(superClass)));
              }

              subClass.prototype = (0, _create2.default)(superClass && superClass.prototype, {
                constructor: {
                  value: subClass,
                  enumerable: false,
                  writable: true,
                  configurable: true
                }
              });
              if (superClass) _setPrototypeOf2.default ? (0, _setPrototypeOf2.default)(subClass, superClass) : subClass.__proto__ = superClass;
            };
            });

            unwrapExports$1(inherits$1$1);

            var setStatic_1 = createCommonjsModule$1(function (module, exports) {

            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            var setStatic = function setStatic(key, value) {
              return function (BaseComponent) {
                /* eslint-disable no-param-reassign */
                BaseComponent[key] = value;
                /* eslint-enable no-param-reassign */
                return BaseComponent;
              };
            };

            exports.default = setStatic;
            });

            unwrapExports$1(setStatic_1);

            var setDisplayName_1 = createCommonjsModule$1(function (module, exports) {

            Object.defineProperty(exports, "__esModule", {
              value: true
            });



            var _setStatic2 = _interopRequireDefault(setStatic_1);

            function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

            var setDisplayName = function setDisplayName(displayName) {
              return (0, _setStatic2.default)('displayName', displayName);
            };

            exports.default = setDisplayName;
            });

            unwrapExports$1(setDisplayName_1);

            var getDisplayName_1$1 = createCommonjsModule$1(function (module, exports) {

            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            var getDisplayName = function getDisplayName(Component) {
              if (typeof Component === 'string') {
                return Component;
              }

              if (!Component) {
                return undefined;
              }

              return Component.displayName || Component.name || 'Component';
            };

            exports.default = getDisplayName;
            });

            unwrapExports$1(getDisplayName_1$1);

            var wrapDisplayName_1 = createCommonjsModule$1(function (module, exports) {

            Object.defineProperty(exports, "__esModule", {
              value: true
            });



            var _getDisplayName2 = _interopRequireDefault(getDisplayName_1$1);

            function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

            var wrapDisplayName = function wrapDisplayName(BaseComponent, hocName) {
              return hocName + '(' + (0, _getDisplayName2.default)(BaseComponent) + ')';
            };

            exports.default = wrapDisplayName;
            });

            unwrapExports$1(wrapDisplayName_1);

            var shouldUpdate_1 = createCommonjsModule$1(function (module, exports) {

            Object.defineProperty(exports, "__esModule", {
              value: true
            });



            var _classCallCheck3 = _interopRequireDefault(classCallCheck$1);



            var _possibleConstructorReturn3 = _interopRequireDefault(possibleConstructorReturn$1);



            var _inherits3 = _interopRequireDefault(inherits$1$1);





            _interopRequireDefault(setDisplayName_1);



            _interopRequireDefault(wrapDisplayName_1);

            function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

            var shouldUpdate = function shouldUpdate(test) {
              return function (BaseComponent) {
                var factory = (0, React.createFactory)(BaseComponent);

                var ShouldUpdate = function (_Component) {
                  (0, _inherits3.default)(ShouldUpdate, _Component);

                  function ShouldUpdate() {
                    (0, _classCallCheck3.default)(this, ShouldUpdate);
                    return (0, _possibleConstructorReturn3.default)(this, _Component.apply(this, arguments));
                  }

                  ShouldUpdate.prototype.shouldComponentUpdate = function shouldComponentUpdate(nextProps) {
                    return test(this.props, nextProps);
                  };

                  ShouldUpdate.prototype.render = function render() {
                    return factory(this.props);
                  };

                  return ShouldUpdate;
                }(React.Component);
                return ShouldUpdate;
              };
            };

            exports.default = shouldUpdate;
            });

            unwrapExports$1(shouldUpdate_1);

            /**
             * Copyright (c) 2013-present, Facebook, Inc.
             *
             * This source code is licensed under the MIT license found in the
             * LICENSE file in the root directory of this source tree.
             *
             * @typechecks
             * 
             */

            var hasOwnProperty$b$1 = Object.prototype.hasOwnProperty;

            /**
             * inlined Object.is polyfill to avoid requiring consumers ship their own
             * https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/Object/is
             */
            function is(x, y) {
              // SameValue algorithm
              if (x === y) {
                // Steps 1-5, 7-10
                // Steps 6.b-6.e: +0 != -0
                // Added the nonzero y check to make Flow happy, but it is redundant
                return x !== 0 || y !== 0 || 1 / x === 1 / y;
              } else {
                // Step 6.a: NaN == NaN
                return x !== x && y !== y;
              }
            }

            /**
             * Performs equality by iterating through keys on an object and returning false
             * when any key has values which are not strictly equal between the arguments.
             * Returns true when the values of all keys are strictly equal.
             */
            function shallowEqual$1(objA, objB) {
              if (is(objA, objB)) {
                return true;
              }

              if (typeof objA !== 'object' || objA === null || typeof objB !== 'object' || objB === null) {
                return false;
              }

              var keysA = Object.keys(objA);
              var keysB = Object.keys(objB);

              if (keysA.length !== keysB.length) {
                return false;
              }

              // Test for A's keys different from B.
              for (var i = 0; i < keysA.length; i++) {
                if (!hasOwnProperty$b$1.call(objB, keysA[i]) || !is(objA[keysA[i]], objB[keysA[i]])) {
                  return false;
                }
              }

              return true;
            }

            var shallowEqual_1 = shallowEqual$1;

            var shallowEqual = createCommonjsModule$1(function (module, exports) {

            Object.defineProperty(exports, "__esModule", {
              value: true
            });



            var _shallowEqual2 = _interopRequireDefault(shallowEqual_1);

            function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

            exports.default = _shallowEqual2.default;
            });

            unwrapExports$1(shallowEqual);

            var pure_1 = createCommonjsModule$1(function (module, exports) {

            Object.defineProperty(exports, "__esModule", {
              value: true
            });



            var _shouldUpdate2 = _interopRequireDefault(shouldUpdate_1);



            var _shallowEqual2 = _interopRequireDefault(shallowEqual);



            _interopRequireDefault(setDisplayName_1);



            _interopRequireDefault(wrapDisplayName_1);

            function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

            var pure = function pure(BaseComponent) {
              var hoc = (0, _shouldUpdate2.default)(function (props, nextProps) {
                return !(0, _shallowEqual2.default)(props, nextProps);
              });

              return hoc(BaseComponent);
            };

            exports.default = pure;
            });

            unwrapExports$1(pure_1);

            var interopRequireDefault$2 = createCommonjsModule$1(function (module) {
            function _interopRequireDefault(obj) {
              return obj && obj.__esModule ? obj : {
                "default": obj
              };
            }

            module.exports = _interopRequireDefault;
            });

            unwrapExports$1(interopRequireDefault$2);

            var _extends_1 = createCommonjsModule$1(function (module) {
            function _extends() {
              module.exports = _extends = Object.assign || function (target) {
                for (var i = 1; i < arguments.length; i++) {
                  var source = arguments[i];

                  for (var key in source) {
                    if (Object.prototype.hasOwnProperty.call(source, key)) {
                      target[key] = source[key];
                    }
                  }
                }

                return target;
              };

              return _extends.apply(this, arguments);
            }

            module.exports = _extends;
            });

            function _defineProperty$1$1(obj, key, value) {
              if (key in obj) {
                Object.defineProperty(obj, key, {
                  value: value,
                  enumerable: true,
                  configurable: true,
                  writable: true
                });
              } else {
                obj[key] = value;
              }

              return obj;
            }

            var defineProperty$2 = _defineProperty$1$1;

            function _objectWithoutPropertiesLoose(source, excluded) {
              if (source == null) return {};
              var target = {};
              var sourceKeys = Object.keys(source);
              var key, i;

              for (i = 0; i < sourceKeys.length; i++) {
                key = sourceKeys[i];
                if (excluded.indexOf(key) >= 0) continue;
                target[key] = source[key];
              }

              return target;
            }

            var objectWithoutPropertiesLoose = _objectWithoutPropertiesLoose;

            function _objectWithoutProperties(source, excluded) {
              if (source == null) return {};
              var target = objectWithoutPropertiesLoose(source, excluded);
              var key, i;

              if (Object.getOwnPropertySymbols) {
                var sourceSymbolKeys = Object.getOwnPropertySymbols(source);

                for (i = 0; i < sourceSymbolKeys.length; i++) {
                  key = sourceSymbolKeys[i];
                  if (excluded.indexOf(key) >= 0) continue;
                  if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue;
                  target[key] = source[key];
                }
              }

              return target;
            }

            var objectWithoutProperties = _objectWithoutProperties;

            var reactIs_production_min = createCommonjsModule$1(function (module, exports) {
            Object.defineProperty(exports,"__esModule",{value:!0});
            var b="function"===typeof Symbol&&Symbol.for,c=b?Symbol.for("react.element"):60103,d=b?Symbol.for("react.portal"):60106,e=b?Symbol.for("react.fragment"):60107,f=b?Symbol.for("react.strict_mode"):60108,g=b?Symbol.for("react.profiler"):60114,h=b?Symbol.for("react.provider"):60109,k=b?Symbol.for("react.context"):60110,l=b?Symbol.for("react.async_mode"):60111,m=b?Symbol.for("react.concurrent_mode"):60111,n=b?Symbol.for("react.forward_ref"):60112,p=b?Symbol.for("react.suspense"):60113,q=b?Symbol.for("react.suspense_list"):
            60120,r=b?Symbol.for("react.memo"):60115,t=b?Symbol.for("react.lazy"):60116,v=b?Symbol.for("react.fundamental"):60117,w=b?Symbol.for("react.responder"):60118,x=b?Symbol.for("react.scope"):60119;function y(a){if("object"===typeof a&&null!==a){var u=a.$$typeof;switch(u){case c:switch(a=a.type,a){case l:case m:case e:case g:case f:case p:return a;default:switch(a=a&&a.$$typeof,a){case k:case n:case t:case r:case h:return a;default:return u}}case d:return u}}}function z(a){return y(a)===m}
            exports.typeOf=y;exports.AsyncMode=l;exports.ConcurrentMode=m;exports.ContextConsumer=k;exports.ContextProvider=h;exports.Element=c;exports.ForwardRef=n;exports.Fragment=e;exports.Lazy=t;exports.Memo=r;exports.Portal=d;exports.Profiler=g;exports.StrictMode=f;exports.Suspense=p;
            exports.isValidElementType=function(a){return "string"===typeof a||"function"===typeof a||a===e||a===m||a===g||a===f||a===p||a===q||"object"===typeof a&&null!==a&&(a.$$typeof===t||a.$$typeof===r||a.$$typeof===h||a.$$typeof===k||a.$$typeof===n||a.$$typeof===v||a.$$typeof===w||a.$$typeof===x)};exports.isAsyncMode=function(a){return z(a)||y(a)===l};exports.isConcurrentMode=z;exports.isContextConsumer=function(a){return y(a)===k};exports.isContextProvider=function(a){return y(a)===h};
            exports.isElement=function(a){return "object"===typeof a&&null!==a&&a.$$typeof===c};exports.isForwardRef=function(a){return y(a)===n};exports.isFragment=function(a){return y(a)===e};exports.isLazy=function(a){return y(a)===t};exports.isMemo=function(a){return y(a)===r};exports.isPortal=function(a){return y(a)===d};exports.isProfiler=function(a){return y(a)===g};exports.isStrictMode=function(a){return y(a)===f};exports.isSuspense=function(a){return y(a)===p};
            });

            unwrapExports$1(reactIs_production_min);
            reactIs_production_min.typeOf;
            reactIs_production_min.AsyncMode;
            reactIs_production_min.ConcurrentMode;
            reactIs_production_min.ContextConsumer;
            reactIs_production_min.ContextProvider;
            reactIs_production_min.Element;
            reactIs_production_min.ForwardRef;
            reactIs_production_min.Fragment;
            reactIs_production_min.Lazy;
            reactIs_production_min.Memo;
            reactIs_production_min.Portal;
            reactIs_production_min.Profiler;
            reactIs_production_min.StrictMode;
            reactIs_production_min.Suspense;
            reactIs_production_min.isValidElementType;
            reactIs_production_min.isAsyncMode;
            reactIs_production_min.isConcurrentMode;
            reactIs_production_min.isContextConsumer;
            reactIs_production_min.isContextProvider;
            reactIs_production_min.isElement;
            reactIs_production_min.isForwardRef;
            reactIs_production_min.isFragment;
            reactIs_production_min.isLazy;
            reactIs_production_min.isMemo;
            reactIs_production_min.isPortal;
            reactIs_production_min.isProfiler;
            reactIs_production_min.isStrictMode;
            reactIs_production_min.isSuspense;

            var reactIs_development = createCommonjsModule$1(function (module, exports) {
            });

            unwrapExports$1(reactIs_development);
            reactIs_development.typeOf;
            reactIs_development.AsyncMode;
            reactIs_development.ConcurrentMode;
            reactIs_development.ContextConsumer;
            reactIs_development.ContextProvider;
            reactIs_development.Element;
            reactIs_development.ForwardRef;
            reactIs_development.Fragment;
            reactIs_development.Lazy;
            reactIs_development.Memo;
            reactIs_development.Portal;
            reactIs_development.Profiler;
            reactIs_development.StrictMode;
            reactIs_development.Suspense;
            reactIs_development.isValidElementType;
            reactIs_development.isAsyncMode;
            reactIs_development.isConcurrentMode;
            reactIs_development.isContextConsumer;
            reactIs_development.isContextProvider;
            reactIs_development.isElement;
            reactIs_development.isForwardRef;
            reactIs_development.isFragment;
            reactIs_development.isLazy;
            reactIs_development.isMemo;
            reactIs_development.isPortal;
            reactIs_development.isProfiler;
            reactIs_development.isStrictMode;
            reactIs_development.isSuspense;

            var reactIs = createCommonjsModule$1(function (module) {

            {
              module.exports = reactIs_production_min;
            }
            });

            /*
            object-assign
            (c) Sindre Sorhus
            @license MIT
            */
            /* eslint-disable no-unused-vars */
            var getOwnPropertySymbols$1 = Object.getOwnPropertySymbols;
            var hasOwnProperty$a$1 = Object.prototype.hasOwnProperty;
            var propIsEnumerable = Object.prototype.propertyIsEnumerable;

            function toObject(val) {
            	if (val === null || val === undefined) {
            		throw new TypeError('Object.assign cannot be called with null or undefined');
            	}

            	return Object(val);
            }

            function shouldUseNative() {
            	try {
            		if (!Object.assign) {
            			return false;
            		}

            		// Detect buggy property enumeration order in older V8 versions.

            		// https://bugs.chromium.org/p/v8/issues/detail?id=4118
            		var test1 = new String('abc');  // eslint-disable-line no-new-wrappers
            		test1[5] = 'de';
            		if (Object.getOwnPropertyNames(test1)[0] === '5') {
            			return false;
            		}

            		// https://bugs.chromium.org/p/v8/issues/detail?id=3056
            		var test2 = {};
            		for (var i = 0; i < 10; i++) {
            			test2['_' + String.fromCharCode(i)] = i;
            		}
            		var order2 = Object.getOwnPropertyNames(test2).map(function (n) {
            			return test2[n];
            		});
            		if (order2.join('') !== '0123456789') {
            			return false;
            		}

            		// https://bugs.chromium.org/p/v8/issues/detail?id=3056
            		var test3 = {};
            		'abcdefghijklmnopqrst'.split('').forEach(function (letter) {
            			test3[letter] = letter;
            		});
            		if (Object.keys(Object.assign({}, test3)).join('') !==
            				'abcdefghijklmnopqrst') {
            			return false;
            		}

            		return true;
            	} catch (err) {
            		// We don't expect any of the above to throw, but better to be safe.
            		return false;
            	}
            }

            shouldUseNative() ? Object.assign : function (target, source) {
            	var from;
            	var to = toObject(target);
            	var symbols;

            	for (var s = 1; s < arguments.length; s++) {
            		from = Object(arguments[s]);

            		for (var key in from) {
            			if (hasOwnProperty$a$1.call(from, key)) {
            				to[key] = from[key];
            			}
            		}

            		if (getOwnPropertySymbols$1) {
            			symbols = getOwnPropertySymbols$1(from);
            			for (var i = 0; i < symbols.length; i++) {
            				if (propIsEnumerable.call(from, symbols[i])) {
            					to[symbols[i]] = from[symbols[i]];
            				}
            			}
            		}
            	}

            	return to;
            };

            /**
             * Copyright (c) 2013-present, Facebook, Inc.
             *
             * This source code is licensed under the MIT license found in the
             * LICENSE file in the root directory of this source tree.
             */

            var ReactPropTypesSecret = 'SECRET_DO_NOT_PASS_THIS_OR_YOU_WILL_BE_FIRED';

            var ReactPropTypesSecret_1 = ReactPropTypesSecret;

            Function.call.bind(Object.prototype.hasOwnProperty);

            function emptyFunction() {}
            function emptyFunctionWithReset() {}
            emptyFunctionWithReset.resetWarningCache = emptyFunction;

            var factoryWithThrowingShims = function() {
              function shim(props, propName, componentName, location, propFullName, secret) {
                if (secret === ReactPropTypesSecret_1) {
                  // It is still safe when called from React.
                  return;
                }
                var err = new Error(
                  'Calling PropTypes validators directly is not supported by the `prop-types` package. ' +
                  'Use PropTypes.checkPropTypes() to call them. ' +
                  'Read more at http://fb.me/use-check-prop-types'
                );
                err.name = 'Invariant Violation';
                throw err;
              }  shim.isRequired = shim;
              function getShim() {
                return shim;
              }  // Important!
              // Keep this list in sync with production version in `./factoryWithTypeCheckers.js`.
              var ReactPropTypes = {
                array: shim,
                bool: shim,
                func: shim,
                number: shim,
                object: shim,
                string: shim,
                symbol: shim,

                any: shim,
                arrayOf: getShim,
                element: shim,
                elementType: shim,
                instanceOf: getShim,
                node: shim,
                objectOf: getShim,
                oneOf: getShim,
                oneOfType: getShim,
                shape: getShim,
                exact: getShim,

                checkPropTypes: emptyFunctionWithReset,
                resetWarningCache: emptyFunction
              };

              ReactPropTypes.PropTypes = ReactPropTypes;

              return ReactPropTypes;
            };

            var propTypes = createCommonjsModule$1(function (module) {
            /**
             * Copyright (c) 2013-present, Facebook, Inc.
             *
             * This source code is licensed under the MIT license found in the
             * LICENSE file in the root directory of this source tree.
             */

            {
              // By explicitly using `prop-types` you are opting into new production behavior.
              // http://fb.me/prop-types-in-prod
              module.exports = factoryWithThrowingShims();
            }
            });

            var classnames = createCommonjsModule$1(function (module) {
            /*!
              Copyright (c) 2017 Jed Watson.
              Licensed under the MIT License (MIT), see
              http://jedwatson.github.io/classnames
            */
            /* global define */

            (function () {

            	var hasOwn = {}.hasOwnProperty;

            	function classNames () {
            		var classes = [];

            		for (var i = 0; i < arguments.length; i++) {
            			var arg = arguments[i];
            			if (!arg) continue;

            			var argType = typeof arg;

            			if (argType === 'string' || argType === 'number') {
            				classes.push(arg);
            			} else if (Array.isArray(arg) && arg.length) {
            				var inner = classNames.apply(null, arg);
            				if (inner) {
            					classes.push(inner);
            				}
            			} else if (argType === 'object') {
            				for (var key in arg) {
            					if (hasOwn.call(arg, key) && arg[key]) {
            						classes.push(key);
            					}
            				}
            			}
            		}

            		return classes.join(' ');
            	}

            	if (module.exports) {
            		classNames.default = classNames;
            		module.exports = classNames;
            	} else {
            		window.classNames = classNames;
            	}
            }());
            });

            var _typeof_1$2 = createCommonjsModule$1(function (module) {
            function _typeof(obj) {
              if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") {
                module.exports = _typeof = function _typeof(obj) {
                  return typeof obj;
                };
              } else {
                module.exports = _typeof = function _typeof(obj) {
                  return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj;
                };
              }

              return _typeof(obj);
            }

            module.exports = _typeof;
            });

            var componentPropType_1 = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            interopRequireDefault$2(_typeof_1$2);



            /**
             * A factory that returns a propTypes validator that only accepts values that
             * are also accepted by React.createElement
             * e.g. "div", functional, class components, forwardRef etc.
             *
             * @param {boolean} isRequired If `true` returns a validator
             *                             that will throw if nullish values are passed
             */
            function createComponentProp(isRequired) {
              /* istanbul ignore if */
              {
                return function () {
                  return null;
                };
              }
            }

            var componentPropType = createComponentProp();
            componentPropType.isRequired = createComponentProp();
            var _default = componentPropType;
            exports.default = _default;
            });

            var componentPropType = unwrapExports$1(componentPropType_1);

            var chainPropTypes_1 = createCommonjsModule$1(function (module, exports) {

            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            function chainPropTypes(propType1, propType2) {
              /* istanbul ignore if */
              {
                return function () {
                  return null;
                };
              }
            }

            var _default = chainPropTypes;
            exports.default = _default;
            });

            var chainPropTypes = unwrapExports$1(chainPropTypes_1);

            var exactProp_1 = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = exports.specialProperty = void 0;

            interopRequireDefault$2(defineProperty$2);

            interopRequireDefault$2(_extends_1);

            // This module is based on https://github.com/airbnb/prop-types-exact repository.
            // However, in order to reduce the number of dependencies and to remove some extra safe checks
            // the module was forked.
            // Only exported for test purposes.
            var specialProperty = "exact-prop: \u200B";
            exports.specialProperty = specialProperty;

            function exactProp(propTypes) {
              /* istanbul ignore if */
              {
                return propTypes;
              }
            }

            var _default = exactProp;
            exports.default = _default;
            });

            var exactProp = unwrapExports$1(exactProp_1);
            exactProp_1.specialProperty;

            var getDisplayName_1 = createCommonjsModule$1(function (module, exports) {

            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.getFunctionName = getFunctionName;
            exports.default = void 0;
            // Fork of recompose/getDisplayName with added IE 11 support
            // Simplified polyfill for IE 11 support
            // https://github.com/JamesMGreene/Function.name/blob/58b314d4a983110c3682f1228f845d39ccca1817/Function.name.js#L3
            var fnNameMatchRegex = /^\s*function(?:\s|\s*\/\*.*\*\/\s*)+([^(\s/]*)\s*/;

            function getFunctionName(fn) {
              var match = "".concat(fn).match(fnNameMatchRegex);
              var name = match && match[1];
              return name || '';
            }

            function getDisplayName(Component) {
              if (typeof Component === 'string') {
                return Component;
              }

              if (!Component) {
                return undefined;
              }

              return Component.displayName || Component.name || getFunctionName(Component) || 'Component';
            }

            var _default = getDisplayName;
            exports.default = _default;
            });

            var getDisplayName = unwrapExports$1(getDisplayName_1);
            getDisplayName_1.getFunctionName;

            var ponyfillGlobal = createCommonjsModule$1(function (module, exports) {

            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            /* eslint-disable */
            // https://github.com/zloirock/core-js/issues/86#issuecomment-115759028
            var _default = typeof window != 'undefined' && window.Math == Math ? window : typeof self != 'undefined' && self.Math == Math ? self : Function('return this')();

            exports.default = _default;
            });

            var ponyfillGlobal$1 = unwrapExports$1(ponyfillGlobal);

            /** @license Material-UI v3.0.0-alpha.3
             *
             * This source code is licensed under the MIT license found in the
             * LICENSE file in the root directory of this source tree.
             */

            var index_es = /*#__PURE__*/Object.freeze({
                __proto__: null,
                componentPropType: componentPropType,
                chainPropTypes: chainPropTypes,
                exactProp: exactProp,
                getDisplayName: getDisplayName,
                ponyfillGlobal: ponyfillGlobal$1
            });

            function _classCallCheck(instance, Constructor) {
              if (!(instance instanceof Constructor)) {
                throw new TypeError("Cannot call a class as a function");
              }
            }

            var classCallCheck = _classCallCheck;

            function _defineProperties(target, props) {
              for (var i = 0; i < props.length; i++) {
                var descriptor = props[i];
                descriptor.enumerable = descriptor.enumerable || false;
                descriptor.configurable = true;
                if ("value" in descriptor) descriptor.writable = true;
                Object.defineProperty(target, descriptor.key, descriptor);
              }
            }

            function _createClass(Constructor, protoProps, staticProps) {
              if (protoProps) _defineProperties(Constructor.prototype, protoProps);
              if (staticProps) _defineProperties(Constructor, staticProps);
              return Constructor;
            }

            var createClass = _createClass;

            function _assertThisInitialized(self) {
              if (self === void 0) {
                throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
              }

              return self;
            }

            var assertThisInitialized = _assertThisInitialized;

            function _possibleConstructorReturn(self, call) {
              if (call && (_typeof_1$2(call) === "object" || typeof call === "function")) {
                return call;
              }

              return assertThisInitialized(self);
            }

            var possibleConstructorReturn = _possibleConstructorReturn;

            var getPrototypeOf$1 = createCommonjsModule$1(function (module) {
            function _getPrototypeOf(o) {
              module.exports = _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) {
                return o.__proto__ || Object.getPrototypeOf(o);
              };
              return _getPrototypeOf(o);
            }

            module.exports = _getPrototypeOf;
            });

            var setPrototypeOf = createCommonjsModule$1(function (module) {
            function _setPrototypeOf(o, p) {
              module.exports = _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) {
                o.__proto__ = p;
                return o;
              };

              return _setPrototypeOf(o, p);
            }

            module.exports = _setPrototypeOf;
            });

            function _inherits(subClass, superClass) {
              if (typeof superClass !== "function" && superClass !== null) {
                throw new TypeError("Super expression must either be null or a function");
              }

              subClass.prototype = Object.create(superClass && superClass.prototype, {
                constructor: {
                  value: subClass,
                  writable: true,
                  configurable: true
                }
              });
              if (superClass) setPrototypeOf(subClass, superClass);
            }

            var inherits$2 = _inherits;

            /**
             * Copyright (c) 2014-present, Facebook, Inc.
             *
             * This source code is licensed under the MIT license found in the
             * LICENSE file in the root directory of this source tree.
             */

            var warning$2 = function() {};

            var warning_1$2 = warning$2;

            /**
             * Copyright 2015, Yahoo! Inc.
             * Copyrights licensed under the New BSD License. See the accompanying LICENSE file for terms.
             */
            var REACT_STATICS = {
              childContextTypes: true,
              contextType: true,
              contextTypes: true,
              defaultProps: true,
              displayName: true,
              getDefaultProps: true,
              getDerivedStateFromError: true,
              getDerivedStateFromProps: true,
              mixins: true,
              propTypes: true,
              type: true
            };
            var KNOWN_STATICS = {
              name: true,
              length: true,
              prototype: true,
              caller: true,
              callee: true,
              arguments: true,
              arity: true
            };
            var FORWARD_REF_STATICS = {
              '$$typeof': true,
              render: true,
              defaultProps: true,
              displayName: true,
              propTypes: true
            };
            var MEMO_STATICS = {
              '$$typeof': true,
              compare: true,
              defaultProps: true,
              displayName: true,
              propTypes: true,
              type: true
            };
            var TYPE_STATICS = {};
            TYPE_STATICS[reactIs.ForwardRef] = FORWARD_REF_STATICS;

            function getStatics(component) {
              if (reactIs.isMemo(component)) {
                return MEMO_STATICS;
              }

              return TYPE_STATICS[component['$$typeof']] || REACT_STATICS;
            }

            var defineProperty$1$1 = Object.defineProperty;
            var getOwnPropertyNames = Object.getOwnPropertyNames;
            var getOwnPropertySymbols = Object.getOwnPropertySymbols;
            var getOwnPropertyDescriptor = Object.getOwnPropertyDescriptor;
            var getPrototypeOf = Object.getPrototypeOf;
            var objectPrototype = Object.prototype;
            function hoistNonReactStatics(targetComponent, sourceComponent, blacklist) {
              if (typeof sourceComponent !== 'string') {
                // don't hoist over string (html) components
                if (objectPrototype) {
                  var inheritedComponent = getPrototypeOf(sourceComponent);

                  if (inheritedComponent && inheritedComponent !== objectPrototype) {
                    hoistNonReactStatics(targetComponent, inheritedComponent, blacklist);
                  }
                }

                var keys = getOwnPropertyNames(sourceComponent);

                if (getOwnPropertySymbols) {
                  keys = keys.concat(getOwnPropertySymbols(sourceComponent));
                }

                var targetStatics = getStatics(targetComponent);
                var sourceStatics = getStatics(sourceComponent);

                for (var i = 0; i < keys.length; ++i) {
                  var key = keys[i];

                  if (!KNOWN_STATICS[key] && !(blacklist && blacklist[key]) && !(sourceStatics && sourceStatics[key]) && !(targetStatics && targetStatics[key])) {
                    var descriptor = getOwnPropertyDescriptor(sourceComponent, key);

                    try {
                      // Avoid failures from read-only properties
                      defineProperty$1$1(targetComponent, key, descriptor);
                    } catch (e) {}
                  }
                }
              }

              return targetComponent;
            }

            var hoistNonReactStatics_cjs = hoistNonReactStatics;

            var getDynamicStyles_1 = createCommonjsModule$1(function (module, exports) {

            Object.defineProperty(exports, "__esModule", {
              value: true
            });

            var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; };

            exports['default'] = getDynamicStyles;
            /**
             * Extracts a styles object with only props that contain function values.
             */
            function getDynamicStyles(styles) {
              var to = null;

              for (var key in styles) {
                var value = styles[key];
                var type = typeof value === 'undefined' ? 'undefined' : _typeof(value);

                if (type === 'function') {
                  if (!to) to = {};
                  to[key] = value;
                } else if (type === 'object' && value !== null && !Array.isArray(value)) {
                  var extracted = getDynamicStyles(value);
                  if (extracted) {
                    if (!to) to = {};
                    to[key] = extracted;
                  }
                }
              }

              return to;
            }
            });

            unwrapExports$1(getDynamicStyles_1);

            var toCssValue_1 = createCommonjsModule$1(function (module, exports) {

            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports['default'] = toCssValue;
            var join = function join(value, by) {
              var result = '';
              for (var i = 0; i < value.length; i++) {
                // Remove !important from the value, it will be readded later.
                if (value[i] === '!important') break;
                if (result) result += by;
                result += value[i];
              }
              return result;
            };

            /**
             * Converts array values to string.
             *
             * `margin: [['5px', '10px']]` > `margin: 5px 10px;`
             * `border: ['1px', '2px']` > `border: 1px, 2px;`
             * `margin: [['5px', '10px'], '!important']` > `margin: 5px 10px !important;`
             * `color: ['red', !important]` > `color: red !important;`
             */
            function toCssValue(value) {
              var ignoreImportant = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : false;

              if (!Array.isArray(value)) return value;

              var cssValue = '';

              // Support space separated values via `[['5px', '10px']]`.
              if (Array.isArray(value[0])) {
                for (var i = 0; i < value.length; i++) {
                  if (value[i] === '!important') break;
                  if (cssValue) cssValue += ', ';
                  cssValue += join(value[i], ' ');
                }
              } else cssValue = join(value, ', ');

              // Add !important, because it was ignored.
              if (!ignoreImportant && value[value.length - 1] === '!important') {
                cssValue += ' !important';
              }

              return cssValue;
            }
            });

            unwrapExports$1(toCssValue_1);

            var SheetsRegistry_1 = createCommonjsModule$1(function (module, exports) {

            Object.defineProperty(exports, "__esModule", {
              value: true
            });

            var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

            function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

            /**
             * Sheets registry to access them all at one place.
             */
            var SheetsRegistry = function () {
              function SheetsRegistry() {
                _classCallCheck(this, SheetsRegistry);

                this.registry = [];
              }

              _createClass(SheetsRegistry, [{
                key: 'add',


                /**
                 * Register a Style Sheet.
                 */
                value: function add(sheet) {
                  var registry = this.registry;
                  var index = sheet.options.index;


                  if (registry.indexOf(sheet) !== -1) return;

                  if (registry.length === 0 || index >= this.index) {
                    registry.push(sheet);
                    return;
                  }

                  // Find a position.
                  for (var i = 0; i < registry.length; i++) {
                    if (registry[i].options.index > index) {
                      registry.splice(i, 0, sheet);
                      return;
                    }
                  }
                }

                /**
                 * Reset the registry.
                 */

              }, {
                key: 'reset',
                value: function reset() {
                  this.registry = [];
                }

                /**
                 * Remove a Style Sheet.
                 */

              }, {
                key: 'remove',
                value: function remove(sheet) {
                  var index = this.registry.indexOf(sheet);
                  this.registry.splice(index, 1);
                }

                /**
                 * Convert all attached sheets to a CSS string.
                 */

              }, {
                key: 'toString',
                value: function toString(options) {
                  return this.registry.filter(function (sheet) {
                    return sheet.attached;
                  }).map(function (sheet) {
                    return sheet.toString(options);
                  }).join('\n');
                }
              }, {
                key: 'index',


                /**
                 * Current highest index number.
                 */
                get: function get() {
                  return this.registry.length === 0 ? 0 : this.registry[this.registry.length - 1].options.index;
                }
              }]);

              return SheetsRegistry;
            }();

            exports['default'] = SheetsRegistry;
            });

            unwrapExports$1(SheetsRegistry_1);

            /**
             * Copyright 2014-2015, Facebook, Inc.
             * All rights reserved.
             *
             * This source code is licensed under the BSD-style license found in the
             * LICENSE file in the root directory of this source tree. An additional grant
             * of patent rights can be found in the PATENTS file in the same directory.
             */

            var warning$1 = function() {};

            var warning_1$1 = warning$1;

            var SheetsManager_1 = createCommonjsModule$1(function (module, exports) {

            Object.defineProperty(exports, "__esModule", {
              value: true
            });

            var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();



            var _warning2 = _interopRequireDefault(warning_1$1);

            function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

            function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

            /**
             * SheetsManager is like a WeakMap which is designed to count StyleSheet
             * instances and attach/detach automatically.
             */
            var SheetsManager = function () {
              function SheetsManager() {
                _classCallCheck(this, SheetsManager);

                this.sheets = [];
                this.refs = [];
                this.keys = [];
              }

              _createClass(SheetsManager, [{
                key: 'get',
                value: function get(key) {
                  var index = this.keys.indexOf(key);
                  return this.sheets[index];
                }
              }, {
                key: 'add',
                value: function add(key, sheet) {
                  var sheets = this.sheets,
                      refs = this.refs,
                      keys = this.keys;

                  var index = sheets.indexOf(sheet);

                  if (index !== -1) return index;

                  sheets.push(sheet);
                  refs.push(0);
                  keys.push(key);

                  return sheets.length - 1;
                }
              }, {
                key: 'manage',
                value: function manage(key) {
                  var index = this.keys.indexOf(key);
                  var sheet = this.sheets[index];
                  if (this.refs[index] === 0) sheet.attach();
                  this.refs[index]++;
                  if (!this.keys[index]) this.keys.splice(index, 0, key);
                  return sheet;
                }
              }, {
                key: 'unmanage',
                value: function unmanage(key) {
                  var index = this.keys.indexOf(key);
                  if (index === -1) {
                    // eslint-ignore-next-line no-console
                    (0, _warning2['default'])(false, "SheetsManager: can't find sheet to unmanage");
                    return;
                  }
                  if (this.refs[index] > 0) {
                    this.refs[index]--;
                    if (this.refs[index] === 0) this.sheets[index].detach();
                  }
                }
              }, {
                key: 'size',
                get: function get() {
                  return this.keys.length;
                }
              }]);

              return SheetsManager;
            }();

            exports['default'] = SheetsManager;
            });

            unwrapExports$1(SheetsManager_1);

            var toCss_1 = createCommonjsModule$1(function (module, exports) {

            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports['default'] = toCss;



            var _toCssValue2 = _interopRequireDefault(toCssValue_1);

            function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

            /**
             * Indent a string.
             * http://jsperf.com/array-join-vs-for
             */
            function indentStr(str, indent) {
              var result = '';
              for (var index = 0; index < indent; index++) {
                result += '  ';
              }return result + str;
            }

            /**
             * Converts a Rule to CSS string.
             */

            function toCss(selector, style) {
              var options = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : {};

              var result = '';

              if (!style) return result;

              var _options$indent = options.indent,
                  indent = _options$indent === undefined ? 0 : _options$indent;
              var fallbacks = style.fallbacks;


              indent++;

              // Apply fallbacks first.
              if (fallbacks) {
                // Array syntax {fallbacks: [{prop: value}]}
                if (Array.isArray(fallbacks)) {
                  for (var index = 0; index < fallbacks.length; index++) {
                    var fallback = fallbacks[index];
                    for (var prop in fallback) {
                      var value = fallback[prop];
                      if (value != null) {
                        result += '\n' + indentStr(prop + ': ' + (0, _toCssValue2['default'])(value) + ';', indent);
                      }
                    }
                  }
                } else {
                  // Object syntax {fallbacks: {prop: value}}
                  for (var _prop in fallbacks) {
                    var _value = fallbacks[_prop];
                    if (_value != null) {
                      result += '\n' + indentStr(_prop + ': ' + (0, _toCssValue2['default'])(_value) + ';', indent);
                    }
                  }
                }
              }

              for (var _prop2 in style) {
                var _value2 = style[_prop2];
                if (_value2 != null && _prop2 !== 'fallbacks') {
                  result += '\n' + indentStr(_prop2 + ': ' + (0, _toCssValue2['default'])(_value2) + ';', indent);
                }
              }

              // Allow empty style in this case, because properties will be added dynamically.
              if (!result && !options.allowEmpty) return result;

              indent--;
              result = indentStr(selector + ' {' + result + '\n', indent) + indentStr('}', indent);

              return result;
            }
            });

            unwrapExports$1(toCss_1);

            var StyleRule_1 = createCommonjsModule$1(function (module, exports) {

            Object.defineProperty(exports, "__esModule", {
              value: true
            });

            var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

            var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; };

            var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();



            var _warning2 = _interopRequireDefault(warning_1$1);



            var _toCss2 = _interopRequireDefault(toCss_1);



            var _toCssValue2 = _interopRequireDefault(toCssValue_1);

            function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

            function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

            var StyleRule = function () {
              function StyleRule(key, style, options) {
                _classCallCheck(this, StyleRule);

                this.type = 'style';
                this.isProcessed = false;
                var sheet = options.sheet,
                    Renderer = options.Renderer,
                    selector = options.selector;

                this.key = key;
                this.options = options;
                this.style = style;
                if (selector) this.selectorText = selector;
                this.renderer = sheet ? sheet.renderer : new Renderer();
              }

              /**
               * Set selector string.
               * Attention: use this with caution. Most browsers didn't implement
               * selectorText setter, so this may result in rerendering of entire Style Sheet.
               */


              _createClass(StyleRule, [{
                key: 'prop',


                /**
                 * Get or set a style property.
                 */
                value: function prop(name, value) {
                  // It's a getter.
                  if (value === undefined) return this.style[name];

                  // Don't do anything if the value has not changed.
                  if (this.style[name] === value) return this;

                  value = this.options.jss.plugins.onChangeValue(value, name, this);

                  var isEmpty = value == null || value === false;
                  var isDefined = name in this.style;

                  // Value is empty and wasn't defined before.
                  if (isEmpty && !isDefined) return this;

                  // We are going to remove this value.
                  var remove = isEmpty && isDefined;

                  if (remove) delete this.style[name];else this.style[name] = value;

                  // Renderable is defined if StyleSheet option `link` is true.
                  if (this.renderable) {
                    if (remove) this.renderer.removeProperty(this.renderable, name);else this.renderer.setProperty(this.renderable, name, value);
                    return this;
                  }

                  var sheet = this.options.sheet;

                  if (sheet && sheet.attached) {
                    (0, _warning2['default'])(false, 'Rule is not linked. Missing sheet option "link: true".');
                  }
                  return this;
                }

                /**
                 * Apply rule to an element inline.
                 */

              }, {
                key: 'applyTo',
                value: function applyTo(renderable) {
                  var json = this.toJSON();
                  for (var prop in json) {
                    this.renderer.setProperty(renderable, prop, json[prop]);
                  }return this;
                }

                /**
                 * Returns JSON representation of the rule.
                 * Fallbacks are not supported.
                 * Useful for inline styles.
                 */

              }, {
                key: 'toJSON',
                value: function toJSON() {
                  var json = {};
                  for (var prop in this.style) {
                    var value = this.style[prop];
                    if ((typeof value === 'undefined' ? 'undefined' : _typeof(value)) !== 'object') json[prop] = value;else if (Array.isArray(value)) json[prop] = (0, _toCssValue2['default'])(value);
                  }
                  return json;
                }

                /**
                 * Generates a CSS string.
                 */

              }, {
                key: 'toString',
                value: function toString(options) {
                  var sheet = this.options.sheet;

                  var link = sheet ? sheet.options.link : false;
                  var opts = link ? _extends({}, options, { allowEmpty: true }) : options;
                  return (0, _toCss2['default'])(this.selector, this.style, opts);
                }
              }, {
                key: 'selector',
                set: function set(selector) {
                  if (selector === this.selectorText) return;

                  this.selectorText = selector;

                  if (!this.renderable) return;

                  var hasChanged = this.renderer.setSelector(this.renderable, selector);

                  // If selector setter is not implemented, rerender the rule.
                  if (!hasChanged && this.renderable) {
                    var renderable = this.renderer.replaceRule(this.renderable, this);
                    if (renderable) this.renderable = renderable;
                  }
                }

                /**
                 * Get selector string.
                 */
                ,
                get: function get() {
                  return this.selectorText;
                }
              }]);

              return StyleRule;
            }();

            exports['default'] = StyleRule;
            });

            unwrapExports$1(StyleRule_1);

            function symbolObservablePonyfill(root) {
            	var result;
            	var Symbol = root.Symbol;

            	if (typeof Symbol === 'function') {
            		if (Symbol.observable) {
            			result = Symbol.observable;
            		} else {
            			result = Symbol('observable');
            			Symbol.observable = result;
            		}
            	} else {
            		result = '@@observable';
            	}

            	return result;
            }

            /* global window */

            var root$1$1;

            if (typeof self !== 'undefined') {
              root$1$1 = self;
            } else if (typeof window !== 'undefined') {
              root$1$1 = window;
            } else if (typeof global !== 'undefined') {
              root$1$1 = global;
            } else if (typeof module !== 'undefined') {
              root$1$1 = module;
            } else {
              root$1$1 = Function('return this')();
            }

            var result = symbolObservablePonyfill(root$1$1);

            var isObservable = createCommonjsModule$1(function (module, exports) {

            Object.defineProperty(exports, "__esModule", {
              value: true
            });



            var _symbolObservable2 = _interopRequireDefault(result);

            function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

            exports['default'] = function (value) {
              return value && value[_symbolObservable2['default']] && value === value[_symbolObservable2['default']]();
            };
            });

            unwrapExports$1(isObservable);

            var cloneStyle_1 = createCommonjsModule$1(function (module, exports) {

            Object.defineProperty(exports, "__esModule", {
              value: true
            });

            var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; };

            exports['default'] = cloneStyle;



            var _isObservable2 = _interopRequireDefault(isObservable);

            function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

            var isArray = Array.isArray;
            function cloneStyle(style) {
              // Support empty values in case user ends up with them by accident.
              if (style == null) return style;

              // Support string value for SimpleRule.
              var typeOfStyle = typeof style === 'undefined' ? 'undefined' : _typeof(style);

              if (typeOfStyle === 'string' || typeOfStyle === 'number' || typeOfStyle === 'function') {
                return style;
              }

              // Support array for FontFaceRule.
              if (isArray(style)) return style.map(cloneStyle);

              // Support Observable styles.  Observables are immutable, so we don't need to
              // copy them.
              if ((0, _isObservable2['default'])(style)) return style;

              var newStyle = {};
              for (var name in style) {
                var value = style[name];
                if ((typeof value === 'undefined' ? 'undefined' : _typeof(value)) === 'object') {
                  newStyle[name] = cloneStyle(value);
                  continue;
                }
                newStyle[name] = value;
              }

              return newStyle;
            }
            });

            unwrapExports$1(cloneStyle_1);

            var createRule_1 = createCommonjsModule$1(function (module, exports) {

            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports['default'] = createRule;



            var _warning2 = _interopRequireDefault(warning_1$1);



            var _StyleRule2 = _interopRequireDefault(StyleRule_1);



            var _cloneStyle2 = _interopRequireDefault(cloneStyle_1);

            function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

            /**
             * Create a rule instance.
             */
            function createRule() {
              var name = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : 'unnamed';
              var decl = arguments[1];
              var options = arguments[2];
              var jss = options.jss;

              var declCopy = (0, _cloneStyle2['default'])(decl);

              var rule = jss.plugins.onCreateRule(name, declCopy, options);
              if (rule) return rule;

              // It is an at-rule and it has no instance.
              if (name[0] === '@') {
                (0, _warning2['default'])(false, '[JSS] Unknown at-rule %s', name);
              }

              return new _StyleRule2['default'](name, declCopy, options);
            }
            });

            unwrapExports$1(createRule_1);

            var linkRule_1 = createCommonjsModule$1(function (module, exports) {

            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports["default"] = linkRule;
            /**
             * Link rule with CSSStyleRule and nested rules with corresponding nested cssRules if both exists.
             */
            function linkRule(rule, cssRule) {
              rule.renderable = cssRule;
              if (rule.rules && cssRule.cssRules) rule.rules.link(cssRule.cssRules);
            }
            });

            unwrapExports$1(linkRule_1);

            var _escape$1 = createCommonjsModule$1(function (module, exports) {

            Object.defineProperty(exports, "__esModule", {
              value: true
            });

            exports['default'] = function (str) {
              // We don't need to escape it in production, because we are not using user's
              // input for selectors, we are generating a valid selector.
              return str;
            };
            });

            unwrapExports$1(_escape$1);

            var RuleList_1 = createCommonjsModule$1(function (module, exports) {

            Object.defineProperty(exports, "__esModule", {
              value: true
            });

            var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

            var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();



            var _createRule2 = _interopRequireDefault(createRule_1);



            var _linkRule2 = _interopRequireDefault(linkRule_1);



            var _StyleRule2 = _interopRequireDefault(StyleRule_1);



            var _escape2 = _interopRequireDefault(_escape$1);

            function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

            function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

            /**
             * Contains rules objects and allows adding/removing etc.
             * Is used for e.g. by `StyleSheet` or `ConditionalRule`.
             */
            var RuleList = function () {

              // Original styles object.
              function RuleList(options) {
                var _this = this;

                _classCallCheck(this, RuleList);

                this.map = {};
                this.raw = {};
                this.index = [];

                this.update = function (name, data) {
                  var _options = _this.options,
                      plugins = _options.jss.plugins,
                      sheet = _options.sheet;

                  if (typeof name === 'string') {
                    plugins.onUpdate(data, _this.get(name), sheet);
                  } else {
                    for (var index = 0; index < _this.index.length; index++) {
                      plugins.onUpdate(name, _this.index[index], sheet);
                    }
                  }
                };

                this.options = options;
                this.classes = options.classes;
              }

              /**
               * Create and register rule.
               *
               * Will not render after Style Sheet was rendered the first time.
               */


              // Used to ensure correct rules order.

              // Rules registry for access by .get() method.
              // It contains the same rule registered by name and by selector.


              _createClass(RuleList, [{
                key: 'add',
                value: function add(name, decl, options) {
                  var _options2 = this.options,
                      parent = _options2.parent,
                      sheet = _options2.sheet,
                      jss = _options2.jss,
                      Renderer = _options2.Renderer,
                      generateClassName = _options2.generateClassName;


                  options = _extends({
                    classes: this.classes,
                    parent: parent,
                    sheet: sheet,
                    jss: jss,
                    Renderer: Renderer,
                    generateClassName: generateClassName
                  }, options);

                  if (!options.selector && this.classes[name]) {
                    options.selector = '.' + (0, _escape2['default'])(this.classes[name]);
                  }

                  this.raw[name] = decl;

                  var rule = (0, _createRule2['default'])(name, decl, options);

                  var className = void 0;

                  if (!options.selector && rule instanceof _StyleRule2['default']) {
                    className = generateClassName(rule, sheet);
                    rule.selector = '.' + (0, _escape2['default'])(className);
                  }

                  this.register(rule, className);

                  var index = options.index === undefined ? this.index.length : options.index;
                  this.index.splice(index, 0, rule);

                  return rule;
                }

                /**
                 * Get a rule.
                 */

              }, {
                key: 'get',
                value: function get(name) {
                  return this.map[name];
                }

                /**
                 * Delete a rule.
                 */

              }, {
                key: 'remove',
                value: function remove(rule) {
                  this.unregister(rule);
                  this.index.splice(this.indexOf(rule), 1);
                }

                /**
                 * Get index of a rule.
                 */

              }, {
                key: 'indexOf',
                value: function indexOf(rule) {
                  return this.index.indexOf(rule);
                }

                /**
                 * Run `onProcessRule()` plugins on every rule.
                 */

              }, {
                key: 'process',
                value: function process() {
                  var plugins = this.options.jss.plugins;
                  // We need to clone array because if we modify the index somewhere else during a loop
                  // we end up with very hard-to-track-down side effects.

                  this.index.slice(0).forEach(plugins.onProcessRule, plugins);
                }

                /**
                 * Register a rule in `.map` and `.classes` maps.
                 */

              }, {
                key: 'register',
                value: function register(rule, className) {
                  this.map[rule.key] = rule;
                  if (rule instanceof _StyleRule2['default']) {
                    this.map[rule.selector] = rule;
                    if (className) this.classes[rule.key] = className;
                  }
                }

                /**
                 * Unregister a rule.
                 */

              }, {
                key: 'unregister',
                value: function unregister(rule) {
                  delete this.map[rule.key];
                  if (rule instanceof _StyleRule2['default']) {
                    delete this.map[rule.selector];
                    delete this.classes[rule.key];
                  }
                }

                /**
                 * Update the function values with a new data.
                 */

              }, {
                key: 'link',


                /**
                 * Link renderable rules with CSSRuleList.
                 */
                value: function link(cssRules) {
                  var map = this.options.sheet.renderer.getUnescapedKeysMap(this.index);

                  for (var i = 0; i < cssRules.length; i++) {
                    var cssRule = cssRules[i];
                    var _key = this.options.sheet.renderer.getKey(cssRule);
                    if (map[_key]) _key = map[_key];
                    var rule = this.map[_key];
                    if (rule) (0, _linkRule2['default'])(rule, cssRule);
                  }
                }

                /**
                 * Convert rules to a CSS string.
                 */

              }, {
                key: 'toString',
                value: function toString(options) {
                  var str = '';
                  var sheet = this.options.sheet;

                  var link = sheet ? sheet.options.link : false;

                  for (var index = 0; index < this.index.length; index++) {
                    var rule = this.index[index];
                    var css = rule.toString(options);

                    // No need to render an empty rule.
                    if (!css && !link) continue;

                    if (str) str += '\n';
                    str += css;
                  }

                  return str;
                }
              }]);

              return RuleList;
            }();

            exports['default'] = RuleList;
            });

            unwrapExports$1(RuleList_1);

            var sheets = createCommonjsModule$1(function (module, exports) {

            Object.defineProperty(exports, "__esModule", {
              value: true
            });



            var _SheetsRegistry2 = _interopRequireDefault(SheetsRegistry_1);

            function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

            /**
             * This is a global sheets registry. Only DomRenderer will add sheets to it.
             * On the server one should use an own SheetsRegistry instance and add the
             * sheets to it, because you need to make sure to create a new registry for
             * each request in order to not leak sheets across requests.
             */
            exports['default'] = new _SheetsRegistry2['default']();
            });

            unwrapExports$1(sheets);

            var StyleSheet_1 = createCommonjsModule$1(function (module, exports) {

            Object.defineProperty(exports, "__esModule", {
              value: true
            });

            var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

            var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();



            var _linkRule2 = _interopRequireDefault(linkRule_1);



            var _RuleList2 = _interopRequireDefault(RuleList_1);

            function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

            function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

            /* eslint-disable-next-line no-use-before-define */
            var StyleSheet = function () {
              function StyleSheet(styles, options) {
                var _this = this;

                _classCallCheck(this, StyleSheet);

                this.update = function (name, data) {
                  if (typeof name === 'string') {
                    _this.rules.update(name, data);
                  } else {
                    _this.rules.update(name);
                  }
                  return _this;
                };

                this.attached = false;
                this.deployed = false;
                this.linked = false;
                this.classes = {};
                this.options = _extends({}, options, {
                  sheet: this,
                  parent: this,
                  classes: this.classes
                });
                this.renderer = new options.Renderer(this);
                this.rules = new _RuleList2['default'](this.options);

                for (var _name in styles) {
                  this.rules.add(_name, styles[_name]);
                }

                this.rules.process();
              }

              /**
               * Attach renderable to the render tree.
               */


              _createClass(StyleSheet, [{
                key: 'attach',
                value: function attach() {
                  if (this.attached) return this;
                  if (!this.deployed) this.deploy();
                  this.renderer.attach();
                  if (!this.linked && this.options.link) this.link();
                  this.attached = true;
                  return this;
                }

                /**
                 * Remove renderable from render tree.
                 */

              }, {
                key: 'detach',
                value: function detach() {
                  if (!this.attached) return this;
                  this.renderer.detach();
                  this.attached = false;
                  return this;
                }

                /**
                 * Add a rule to the current stylesheet.
                 * Will insert a rule also after the stylesheet has been rendered first time.
                 */

              }, {
                key: 'addRule',
                value: function addRule(name, decl, options) {
                  var queue = this.queue;

                  // Plugins can create rules.
                  // In order to preserve the right order, we need to queue all `.addRule` calls,
                  // which happen after the first `rules.add()` call.

                  if (this.attached && !queue) this.queue = [];

                  var rule = this.rules.add(name, decl, options);
                  this.options.jss.plugins.onProcessRule(rule);

                  if (this.attached) {
                    if (!this.deployed) return rule;
                    // Don't insert rule directly if there is no stringified version yet.
                    // It will be inserted all together when .attach is called.
                    if (queue) queue.push(rule);else {
                      this.insertRule(rule);
                      if (this.queue) {
                        this.queue.forEach(this.insertRule, this);
                        this.queue = undefined;
                      }
                    }
                    return rule;
                  }

                  // We can't add rules to a detached style node.
                  // We will redeploy the sheet once user will attach it.
                  this.deployed = false;

                  return rule;
                }

                /**
                 * Insert rule into the StyleSheet
                 */

              }, {
                key: 'insertRule',
                value: function insertRule(rule) {
                  var renderable = this.renderer.insertRule(rule);
                  if (renderable && this.options.link) (0, _linkRule2['default'])(rule, renderable);
                }

                /**
                 * Create and add rules.
                 * Will render also after Style Sheet was rendered the first time.
                 */

              }, {
                key: 'addRules',
                value: function addRules(styles, options) {
                  var added = [];
                  for (var _name2 in styles) {
                    added.push(this.addRule(_name2, styles[_name2], options));
                  }
                  return added;
                }

                /**
                 * Get a rule by name.
                 */

              }, {
                key: 'getRule',
                value: function getRule(name) {
                  return this.rules.get(name);
                }

                /**
                 * Delete a rule by name.
                 * Returns `true`: if rule has been deleted from the DOM.
                 */

              }, {
                key: 'deleteRule',
                value: function deleteRule(name) {
                  var rule = this.rules.get(name);

                  if (!rule) return false;

                  this.rules.remove(rule);

                  if (this.attached && rule.renderable) {
                    return this.renderer.deleteRule(rule.renderable);
                  }

                  return true;
                }

                /**
                 * Get index of a rule.
                 */

              }, {
                key: 'indexOf',
                value: function indexOf(rule) {
                  return this.rules.indexOf(rule);
                }

                /**
                 * Deploy pure CSS string to a renderable.
                 */

              }, {
                key: 'deploy',
                value: function deploy() {
                  this.renderer.deploy();
                  this.deployed = true;
                  return this;
                }

                /**
                 * Link renderable CSS rules from sheet with their corresponding models.
                 */

              }, {
                key: 'link',
                value: function link() {
                  var cssRules = this.renderer.getRules();

                  // Is undefined when VirtualRenderer is used.
                  if (cssRules) this.rules.link(cssRules);
                  this.linked = true;
                  return this;
                }

                /**
                 * Update the function values with a new data.
                 */

              }, {
                key: 'toString',


                /**
                 * Convert rules to a CSS string.
                 */
                value: function toString(options) {
                  return this.rules.toString(options);
                }
              }]);

              return StyleSheet;
            }();

            exports['default'] = StyleSheet;
            });

            unwrapExports$1(StyleSheet_1);

            var moduleId = createCommonjsModule$1(function (module, exports) {

            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            var ns = '2f1acc6c3a606b082e5eef5e54414ffb';
            if (commonjsGlobal$1[ns] == null) commonjsGlobal$1[ns] = 0;

            // Bundle may contain multiple JSS versions at the same time. In order to identify
            // the current version with just one short number and use it for classes generation
            // we use a counter. Also it is more accurate, because user can manually reevaluate
            // the module.
            exports['default'] = commonjsGlobal$1[ns]++;
            });

            unwrapExports$1(moduleId);

            var createGenerateClassName = createCommonjsModule$1(function (module, exports) {

            Object.defineProperty(exports, "__esModule", {
              value: true
            });



            var _warning2 = _interopRequireDefault(warning_1$1);



            _interopRequireDefault(StyleSheet_1);



            var _moduleId2 = _interopRequireDefault(moduleId);

            function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

            var maxRules = 1e10;

            /**
             * Returns a function which generates unique class names based on counters.
             * When new generator function is created, rule counter is reseted.
             * We need to reset the rule counter for SSR for each request.
             */

            exports['default'] = function () {
              var ruleCounter = 0;
              var defaultPrefix = 'c' ;

              return function (rule, sheet) {
                ruleCounter += 1;

                if (ruleCounter > maxRules) {
                  (0, _warning2['default'])(false, '[JSS] You might have a memory leak. Rule counter is at %s.', ruleCounter);
                }

                var prefix = defaultPrefix;
                var jssId = '';

                if (sheet) {
                  prefix = sheet.options.classNamePrefix || defaultPrefix;
                  if (sheet.options.jss.id != null) jssId += sheet.options.jss.id;
                }

                {
                  return '' + prefix + _moduleId2['default'] + jssId + ruleCounter;
                }
              };
            };
            });

            unwrapExports$1(createGenerateClassName);

            var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; };

            var isBrowser = (typeof window === "undefined" ? "undefined" : _typeof(window)) === "object" && (typeof document === "undefined" ? "undefined" : _typeof(document)) === 'object' && document.nodeType === 9;

            var PluginsRegistry_1 = createCommonjsModule$1(function (module, exports) {

            Object.defineProperty(exports, "__esModule", {
              value: true
            });

            var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();



            var _warning2 = _interopRequireDefault(warning_1$1);

            function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

            function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

            var PluginsRegistry = function () {
              function PluginsRegistry() {
                _classCallCheck(this, PluginsRegistry);

                this.hooks = {
                  onCreateRule: [],
                  onProcessRule: [],
                  onProcessStyle: [],
                  onProcessSheet: [],
                  onChangeValue: [],
                  onUpdate: []

                  /**
                   * Call `onCreateRule` hooks and return an object if returned by a hook.
                   */
                };
              }

              _createClass(PluginsRegistry, [{
                key: 'onCreateRule',
                value: function onCreateRule(name, decl, options) {
                  for (var i = 0; i < this.hooks.onCreateRule.length; i++) {
                    var rule = this.hooks.onCreateRule[i](name, decl, options);
                    if (rule) return rule;
                  }
                  return null;
                }

                /**
                 * Call `onProcessRule` hooks.
                 */

              }, {
                key: 'onProcessRule',
                value: function onProcessRule(rule) {
                  if (rule.isProcessed) return;
                  var sheet = rule.options.sheet;

                  for (var i = 0; i < this.hooks.onProcessRule.length; i++) {
                    this.hooks.onProcessRule[i](rule, sheet);
                  }

                  // $FlowFixMe
                  if (rule.style) this.onProcessStyle(rule.style, rule, sheet);

                  rule.isProcessed = true;
                }

                /**
                 * Call `onProcessStyle` hooks.
                 */

              }, {
                key: 'onProcessStyle',
                value: function onProcessStyle(style, rule, sheet) {
                  var nextStyle = style;

                  for (var i = 0; i < this.hooks.onProcessStyle.length; i++) {
                    nextStyle = this.hooks.onProcessStyle[i](nextStyle, rule, sheet);
                    // $FlowFixMe
                    rule.style = nextStyle;
                  }
                }

                /**
                 * Call `onProcessSheet` hooks.
                 */

              }, {
                key: 'onProcessSheet',
                value: function onProcessSheet(sheet) {
                  for (var i = 0; i < this.hooks.onProcessSheet.length; i++) {
                    this.hooks.onProcessSheet[i](sheet);
                  }
                }

                /**
                 * Call `onUpdate` hooks.
                 */

              }, {
                key: 'onUpdate',
                value: function onUpdate(data, rule, sheet) {
                  for (var i = 0; i < this.hooks.onUpdate.length; i++) {
                    this.hooks.onUpdate[i](data, rule, sheet);
                  }
                }

                /**
                 * Call `onChangeValue` hooks.
                 */

              }, {
                key: 'onChangeValue',
                value: function onChangeValue(value, prop, rule) {
                  var processedValue = value;
                  for (var i = 0; i < this.hooks.onChangeValue.length; i++) {
                    processedValue = this.hooks.onChangeValue[i](processedValue, prop, rule);
                  }
                  return processedValue;
                }

                /**
                 * Register a plugin.
                 * If function is passed, it is a shortcut for `{onProcessRule}`.
                 */

              }, {
                key: 'use',
                value: function use(plugin) {
                  for (var name in plugin) {
                    if (this.hooks[name]) this.hooks[name].push(plugin[name]);else (0, _warning2['default'])(false, '[JSS] Unknown hook "%s".', name);
                  }
                }
              }]);

              return PluginsRegistry;
            }();

            exports['default'] = PluginsRegistry;
            });

            unwrapExports$1(PluginsRegistry_1);

            var SimpleRule_1 = createCommonjsModule$1(function (module, exports) {

            Object.defineProperty(exports, "__esModule", {
              value: true
            });

            var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

            function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

            var SimpleRule = function () {
              function SimpleRule(key, value, options) {
                _classCallCheck(this, SimpleRule);

                this.type = 'simple';
                this.isProcessed = false;

                this.key = key;
                this.value = value;
                this.options = options;
              }

              /**
               * Generates a CSS string.
               */
              // eslint-disable-next-line no-unused-vars


              _createClass(SimpleRule, [{
                key: 'toString',
                value: function toString(options) {
                  if (Array.isArray(this.value)) {
                    var str = '';
                    for (var index = 0; index < this.value.length; index++) {
                      str += this.key + ' ' + this.value[index] + ';';
                      if (this.value[index + 1]) str += '\n';
                    }
                    return str;
                  }

                  return this.key + ' ' + this.value + ';';
                }
              }]);

              return SimpleRule;
            }();

            exports['default'] = SimpleRule;
            });

            unwrapExports$1(SimpleRule_1);

            var KeyframesRule_1 = createCommonjsModule$1(function (module, exports) {

            Object.defineProperty(exports, "__esModule", {
              value: true
            });

            var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

            var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();



            var _RuleList2 = _interopRequireDefault(RuleList_1);

            function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

            function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

            /**
             * Rule for @keyframes
             */
            var KeyframesRule = function () {
              function KeyframesRule(key, frames, options) {
                _classCallCheck(this, KeyframesRule);

                this.type = 'keyframes';
                this.isProcessed = false;

                this.key = key;
                this.options = options;
                this.rules = new _RuleList2['default'](_extends({}, options, { parent: this }));

                for (var name in frames) {
                  this.rules.add(name, frames[name], _extends({}, this.options, {
                    parent: this,
                    selector: name
                  }));
                }

                this.rules.process();
              }

              /**
               * Generates a CSS string.
               */


              _createClass(KeyframesRule, [{
                key: 'toString',
                value: function toString() {
                  var options = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : { indent: 1 };

                  var inner = this.rules.toString(options);
                  if (inner) inner += '\n';
                  return this.key + ' {\n' + inner + '}';
                }
              }]);

              return KeyframesRule;
            }();

            exports['default'] = KeyframesRule;
            });

            unwrapExports$1(KeyframesRule_1);

            var ConditionalRule_1 = createCommonjsModule$1(function (module, exports) {

            Object.defineProperty(exports, "__esModule", {
              value: true
            });

            var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

            var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();



            var _RuleList2 = _interopRequireDefault(RuleList_1);

            function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

            function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

            /**
             * Conditional rule for @media, @supports
             */
            var ConditionalRule = function () {
              function ConditionalRule(key, styles, options) {
                _classCallCheck(this, ConditionalRule);

                this.type = 'conditional';
                this.isProcessed = false;

                this.key = key;
                this.options = options;
                this.rules = new _RuleList2['default'](_extends({}, options, { parent: this }));

                for (var name in styles) {
                  this.rules.add(name, styles[name]);
                }

                this.rules.process();
              }

              /**
               * Get a rule.
               */


              _createClass(ConditionalRule, [{
                key: 'getRule',
                value: function getRule(name) {
                  return this.rules.get(name);
                }

                /**
                 * Get index of a rule.
                 */

              }, {
                key: 'indexOf',
                value: function indexOf(rule) {
                  return this.rules.indexOf(rule);
                }

                /**
                 * Create and register rule, run plugins.
                 */

              }, {
                key: 'addRule',
                value: function addRule(name, style, options) {
                  var rule = this.rules.add(name, style, options);
                  this.options.jss.plugins.onProcessRule(rule);
                  return rule;
                }

                /**
                 * Generates a CSS string.
                 */

              }, {
                key: 'toString',
                value: function toString() {
                  var options = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : { indent: 1 };

                  var inner = this.rules.toString(options);
                  return inner ? this.key + ' {\n' + inner + '\n}' : '';
                }
              }]);

              return ConditionalRule;
            }();

            exports['default'] = ConditionalRule;
            });

            unwrapExports$1(ConditionalRule_1);

            var FontFaceRule_1 = createCommonjsModule$1(function (module, exports) {

            Object.defineProperty(exports, "__esModule", {
              value: true
            });

            var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();



            var _toCss2 = _interopRequireDefault(toCss_1);

            function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

            function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

            var FontFaceRule = function () {
              function FontFaceRule(key, style, options) {
                _classCallCheck(this, FontFaceRule);

                this.type = 'font-face';
                this.isProcessed = false;

                this.key = key;
                this.style = style;
                this.options = options;
              }

              /**
               * Generates a CSS string.
               */


              _createClass(FontFaceRule, [{
                key: 'toString',
                value: function toString(options) {
                  if (Array.isArray(this.style)) {
                    var str = '';
                    for (var index = 0; index < this.style.length; index++) {
                      str += (0, _toCss2['default'])(this.key, this.style[index]);
                      if (this.style[index + 1]) str += '\n';
                    }
                    return str;
                  }

                  return (0, _toCss2['default'])(this.key, this.style, options);
                }
              }]);

              return FontFaceRule;
            }();

            exports['default'] = FontFaceRule;
            });

            unwrapExports$1(FontFaceRule_1);

            var ViewportRule_1 = createCommonjsModule$1(function (module, exports) {

            Object.defineProperty(exports, "__esModule", {
              value: true
            });

            var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();



            var _toCss2 = _interopRequireDefault(toCss_1);

            function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

            function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

            var ViewportRule = function () {
              function ViewportRule(key, style, options) {
                _classCallCheck(this, ViewportRule);

                this.type = 'viewport';
                this.isProcessed = false;

                this.key = key;
                this.style = style;
                this.options = options;
              }

              /**
               * Generates a CSS string.
               */


              _createClass(ViewportRule, [{
                key: 'toString',
                value: function toString(options) {
                  return (0, _toCss2['default'])(this.key, this.style, options);
                }
              }]);

              return ViewportRule;
            }();

            exports['default'] = ViewportRule;
            });

            unwrapExports$1(ViewportRule_1);

            var rules = createCommonjsModule$1(function (module, exports) {

            Object.defineProperty(exports, "__esModule", {
              value: true
            });



            var _SimpleRule2 = _interopRequireDefault(SimpleRule_1);



            var _KeyframesRule2 = _interopRequireDefault(KeyframesRule_1);



            var _ConditionalRule2 = _interopRequireDefault(ConditionalRule_1);



            var _FontFaceRule2 = _interopRequireDefault(FontFaceRule_1);



            var _ViewportRule2 = _interopRequireDefault(ViewportRule_1);

            function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

            var classes = {
              '@charset': _SimpleRule2['default'],
              '@import': _SimpleRule2['default'],
              '@namespace': _SimpleRule2['default'],
              '@keyframes': _KeyframesRule2['default'],
              '@media': _ConditionalRule2['default'],
              '@supports': _ConditionalRule2['default'],
              '@font-face': _FontFaceRule2['default'],
              '@viewport': _ViewportRule2['default'],
              '@-ms-viewport': _ViewportRule2['default']

              /**
               * Generate plugins which will register all rules.
               */
            };
            var plugins = Object.keys(classes).map(function (key) {
              // https://jsperf.com/indexof-vs-substr-vs-regex-at-the-beginning-3
              var re = new RegExp('^' + key);
              var RuleClass = classes[key];
              var onCreateRule = function onCreateRule(name, decl, options) {
                return re.test(name) ? new RuleClass(name, decl, options) : null;
              };
              return { onCreateRule: onCreateRule };
            });

            exports['default'] = plugins;
            });

            unwrapExports$1(rules);

            var observables = createCommonjsModule$1(function (module, exports) {

            Object.defineProperty(exports, "__esModule", {
              value: true
            });



            var _StyleRule2 = _interopRequireDefault(StyleRule_1);



            var _createRule2 = _interopRequireDefault(createRule_1);



            var _isObservable2 = _interopRequireDefault(isObservable);

            function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

            exports['default'] = {
              onCreateRule: function onCreateRule(name, decl, options) {
                if (!(0, _isObservable2['default'])(decl)) return null;

                // Cast `decl` to `Observable`, since it passed the type guard.
                var style$ = decl;

                var rule = (0, _createRule2['default'])(name, {}, options);

                // TODO
                // Call `stream.subscribe()` returns a subscription, which should be explicitly
                // unsubscribed from when we know this sheet is no longer needed.
                style$.subscribe(function (style) {
                  for (var prop in style) {
                    rule.prop(prop, style[prop]);
                  }
                });

                return rule;
              },
              onProcessRule: function onProcessRule(rule) {
                if (!(rule instanceof _StyleRule2['default'])) return;
                var styleRule = rule;
                var style = styleRule.style;

                var _loop = function _loop(prop) {
                  var value = style[prop];
                  if (!(0, _isObservable2['default'])(value)) return 'continue';
                  delete style[prop];
                  value.subscribe({
                    next: function next(nextValue) {
                      styleRule.prop(prop, nextValue);
                    }
                  });
                };

                for (var prop in style) {
                  var _ret = _loop(prop);

                  if (_ret === 'continue') continue;
                }
              }
            };
            });

            unwrapExports$1(observables);

            var functions = createCommonjsModule$1(function (module, exports) {

            Object.defineProperty(exports, "__esModule", {
              value: true
            });



            var _RuleList2 = _interopRequireDefault(RuleList_1);



            var _StyleRule2 = _interopRequireDefault(StyleRule_1);



            var _createRule2 = _interopRequireDefault(createRule_1);

            function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

            // A symbol replacement.
            var now = Date.now();

            var fnValuesNs = 'fnValues' + now;
            var fnStyleNs = 'fnStyle' + ++now;

            exports['default'] = {
              onCreateRule: function onCreateRule(name, decl, options) {
                if (typeof decl !== 'function') return null;
                var rule = (0, _createRule2['default'])(name, {}, options);
                rule[fnStyleNs] = decl;
                return rule;
              },
              onProcessStyle: function onProcessStyle(style, rule) {
                var fn = {};
                for (var prop in style) {
                  var value = style[prop];
                  if (typeof value !== 'function') continue;
                  delete style[prop];
                  fn[prop] = value;
                }
                rule = rule;
                rule[fnValuesNs] = fn;
                return style;
              },
              onUpdate: function onUpdate(data, rule) {
                // It is a rules container like for e.g. ConditionalRule.
                if (rule.rules instanceof _RuleList2['default']) {
                  rule.rules.update(data);
                  return;
                }
                if (!(rule instanceof _StyleRule2['default'])) return;

                rule = rule;

                // If we have a fn values map, it is a rule with function values.
                if (rule[fnValuesNs]) {
                  for (var prop in rule[fnValuesNs]) {
                    rule.prop(prop, rule[fnValuesNs][prop](data));
                  }
                }

                rule = rule;

                var fnStyle = rule[fnStyleNs];

                // If we have a style function, the entire rule is dynamic and style object
                // will be returned from that function.
                if (fnStyle) {
                  var style = fnStyle(data);
                  for (var _prop in style) {
                    rule.prop(_prop, style[_prop]);
                  }
                }
              }
            };
            });

            unwrapExports$1(functions);

            var DomRenderer_1 = createCommonjsModule$1(function (module, exports) {

            Object.defineProperty(exports, "__esModule", {
              value: true
            });

            var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();



            var _warning2 = _interopRequireDefault(warning_1$1);



            var _sheets2 = _interopRequireDefault(sheets);



            var _StyleRule2 = _interopRequireDefault(StyleRule_1);



            var _toCssValue2 = _interopRequireDefault(toCssValue_1);

            function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

            function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

            /**
             * Cache the value from the first time a function is called.
             */
            var memoize = function memoize(fn) {
              var value = void 0;
              return function () {
                if (!value) value = fn();
                return value;
              };
            };

            /**
             * Get a style property value.
             */
            function getPropertyValue(cssRule, prop) {
              try {
                return cssRule.style.getPropertyValue(prop);
              } catch (err) {
                // IE may throw if property is unknown.
                return '';
              }
            }

            /**
             * Set a style property.
             */
            function setProperty(cssRule, prop, value) {
              try {
                var cssValue = value;

                if (Array.isArray(value)) {
                  cssValue = (0, _toCssValue2['default'])(value, true);

                  if (value[value.length - 1] === '!important') {
                    cssRule.style.setProperty(prop, cssValue, 'important');
                    return true;
                  }
                }

                cssRule.style.setProperty(prop, cssValue);
              } catch (err) {
                // IE may throw if property is unknown.
                return false;
              }
              return true;
            }

            /**
             * Remove a style property.
             */
            function removeProperty(cssRule, prop) {
              try {
                cssRule.style.removeProperty(prop);
              } catch (err) {
                (0, _warning2['default'])(false, '[JSS] DOMException "%s" was thrown. Tried to remove property "%s".', err.message, prop);
              }
            }

            var CSSRuleTypes = {
              STYLE_RULE: 1,
              KEYFRAMES_RULE: 7

              /**
               * Get the CSS Rule key.
               */

            };var getKey = function () {
              var extractKey = function extractKey(cssText) {
                var from = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 0;
                return cssText.substr(from, cssText.indexOf('{') - 1);
              };

              return function (cssRule) {
                if (cssRule.type === CSSRuleTypes.STYLE_RULE) return cssRule.selectorText;
                if (cssRule.type === CSSRuleTypes.KEYFRAMES_RULE) {
                  var name = cssRule.name;

                  if (name) return '@keyframes ' + name;

                  // There is no rule.name in the following browsers:
                  // - IE 9
                  // - Safari 7.1.8
                  // - Mobile Safari 9.0.0
                  var cssText = cssRule.cssText;

                  return '@' + extractKey(cssText, cssText.indexOf('keyframes'));
                }

                // Conditionals.
                return extractKey(cssRule.cssText);
              };
            }();

            /**
             * Set the selector.
             */
            function setSelector(cssRule, selectorText) {
              cssRule.selectorText = selectorText;

              // Return false if setter was not successful.
              // Currently works in chrome only.
              return cssRule.selectorText === selectorText;
            }

            /**
             * Gets the `head` element upon the first call and caches it.
             */
            var getHead = memoize(function () {
              return document.head || document.getElementsByTagName('head')[0];
            });

            /**
             * Gets a map of rule keys, where the property is an unescaped key and value
             * is a potentially escaped one.
             * It is used to identify CSS rules and the corresponding JSS rules. As an identifier
             * for CSSStyleRule we normally use `selectorText`. Though if original selector text
             * contains escaped code points e.g. `:not(#\\20)`, CSSOM will compile it to `:not(# )`
             * and so CSS rule's `selectorText` won't match JSS rule selector.
             *
             * https://www.w3.org/International/questions/qa-escapes#cssescapes
             */
            var getUnescapedKeysMap = function () {
              var style = void 0;
              var isAttached = false;

              return function (rules) {
                var map = {};
                // https://github.com/facebook/flow/issues/2696
                if (!style) style = document.createElement('style');
                for (var i = 0; i < rules.length; i++) {
                  var rule = rules[i];
                  if (!(rule instanceof _StyleRule2['default'])) continue;
                  var selector = rule.selector;
                  // Only unescape selector over CSSOM if it contains a back slash.

                  if (selector && selector.indexOf('\\') !== -1) {
                    // Lazilly attach when needed.
                    if (!isAttached) {
                      getHead().appendChild(style);
                      isAttached = true;
                    }
                    style.textContent = selector + ' {}';
                    var _style = style,
                        sheet = _style.sheet;

                    if (sheet) {
                      var cssRules = sheet.cssRules;

                      if (cssRules) map[cssRules[0].selectorText] = rule.key;
                    }
                  }
                }
                if (isAttached) {
                  getHead().removeChild(style);
                  isAttached = false;
                }
                return map;
              };
            }();

            /**
             * Find attached sheet with an index higher than the passed one.
             */
            function findHigherSheet(registry, options) {
              for (var i = 0; i < registry.length; i++) {
                var sheet = registry[i];
                if (sheet.attached && sheet.options.index > options.index && sheet.options.insertionPoint === options.insertionPoint) {
                  return sheet;
                }
              }
              return null;
            }

            /**
             * Find attached sheet with the highest index.
             */
            function findHighestSheet(registry, options) {
              for (var i = registry.length - 1; i >= 0; i--) {
                var sheet = registry[i];
                if (sheet.attached && sheet.options.insertionPoint === options.insertionPoint) {
                  return sheet;
                }
              }
              return null;
            }

            /**
             * Find a comment with "jss" inside.
             */
            function findCommentNode(text) {
              var head = getHead();
              for (var i = 0; i < head.childNodes.length; i++) {
                var node = head.childNodes[i];
                if (node.nodeType === 8 && node.nodeValue.trim() === text) {
                  return node;
                }
              }
              return null;
            }

            /**
             * Find a node before which we can insert the sheet.
             */
            function findPrevNode(options) {
              var registry = _sheets2['default'].registry;


              if (registry.length > 0) {
                // Try to insert before the next higher sheet.
                var sheet = findHigherSheet(registry, options);
                if (sheet) return sheet.renderer.element;

                // Otherwise insert after the last attached.
                sheet = findHighestSheet(registry, options);
                if (sheet) return sheet.renderer.element.nextElementSibling;
              }

              // Try to find a comment placeholder if registry is empty.
              var insertionPoint = options.insertionPoint;

              if (insertionPoint && typeof insertionPoint === 'string') {
                var comment = findCommentNode(insertionPoint);
                if (comment) return comment.nextSibling;
                // If user specifies an insertion point and it can't be found in the document -
                // bad specificity issues may appear.
                (0, _warning2['default'])(insertionPoint === 'jss', '[JSS] Insertion point "%s" not found.', insertionPoint);
              }

              return null;
            }

            /**
             * Insert style element into the DOM.
             */
            function insertStyle(style, options) {
              var insertionPoint = options.insertionPoint;

              var prevNode = findPrevNode(options);

              if (prevNode) {
                var parentNode = prevNode.parentNode;

                if (parentNode) parentNode.insertBefore(style, prevNode);
                return;
              }

              // Works with iframes and any node types.
              if (insertionPoint && typeof insertionPoint.nodeType === 'number') {
                // https://stackoverflow.com/questions/41328728/force-casting-in-flow
                var insertionPointElement = insertionPoint;
                var _parentNode = insertionPointElement.parentNode;

                if (_parentNode) _parentNode.insertBefore(style, insertionPointElement.nextSibling);else (0, _warning2['default'])(false, '[JSS] Insertion point is not in the DOM.');
                return;
              }

              getHead().insertBefore(style, prevNode);
            }

            /**
             * Read jss nonce setting from the page if the user has set it.
             */
            var getNonce = memoize(function () {
              var node = document.querySelector('meta[property="csp-nonce"]');
              return node ? node.getAttribute('content') : null;
            });

            var DomRenderer = function () {
              function DomRenderer(sheet) {
                _classCallCheck(this, DomRenderer);

                this.getPropertyValue = getPropertyValue;
                this.setProperty = setProperty;
                this.removeProperty = removeProperty;
                this.setSelector = setSelector;
                this.getKey = getKey;
                this.getUnescapedKeysMap = getUnescapedKeysMap;
                this.hasInsertedRules = false;

                // There is no sheet when the renderer is used from a standalone StyleRule.
                if (sheet) _sheets2['default'].add(sheet);

                this.sheet = sheet;

                var _ref = this.sheet ? this.sheet.options : {},
                    media = _ref.media,
                    meta = _ref.meta,
                    element = _ref.element;

                this.element = element || document.createElement('style');
                this.element.setAttribute('data-jss', '');
                if (media) this.element.setAttribute('media', media);
                if (meta) this.element.setAttribute('data-meta', meta);
                var nonce = getNonce();
                if (nonce) this.element.setAttribute('nonce', nonce);
              }

              /**
               * Insert style element into render tree.
               */


              // HTMLStyleElement needs fixing https://github.com/facebook/flow/issues/2696


              _createClass(DomRenderer, [{
                key: 'attach',
                value: function attach() {
                  // In the case the element node is external and it is already in the DOM.
                  if (this.element.parentNode || !this.sheet) return;

                  // When rules are inserted using `insertRule` API, after `sheet.detach().attach()`
                  // browsers remove those rules.
                  // TODO figure out if its a bug and if it is known.
                  // Workaround is to redeploy the sheet before attaching as a string.
                  if (this.hasInsertedRules) {
                    this.deploy();
                    this.hasInsertedRules = false;
                  }

                  insertStyle(this.element, this.sheet.options);
                }

                /**
                 * Remove style element from render tree.
                 */

              }, {
                key: 'detach',
                value: function detach() {
                  this.element.parentNode.removeChild(this.element);
                }

                /**
                 * Inject CSS string into element.
                 */

              }, {
                key: 'deploy',
                value: function deploy() {
                  if (!this.sheet) return;
                  this.element.textContent = '\n' + this.sheet.toString() + '\n';
                }

                /**
                 * Insert a rule into element.
                 */

              }, {
                key: 'insertRule',
                value: function insertRule(rule, index) {
                  var sheet = this.element.sheet;
                  var cssRules = sheet.cssRules;

                  var str = rule.toString();
                  if (!index) index = cssRules.length;

                  if (!str) return false;

                  try {
                    sheet.insertRule(str, index);
                  } catch (err) {
                    (0, _warning2['default'])(false, '[JSS] Can not insert an unsupported rule \n\r%s', rule);
                    return false;
                  }
                  this.hasInsertedRules = true;

                  return cssRules[index];
                }

                /**
                 * Delete a rule.
                 */

              }, {
                key: 'deleteRule',
                value: function deleteRule(cssRule) {
                  var sheet = this.element.sheet;

                  var index = this.indexOf(cssRule);
                  if (index === -1) return false;
                  sheet.deleteRule(index);
                  return true;
                }

                /**
                 * Get index of a CSS Rule.
                 */

              }, {
                key: 'indexOf',
                value: function indexOf(cssRule) {
                  var cssRules = this.element.sheet.cssRules;

                  for (var _index = 0; _index < cssRules.length; _index++) {
                    if (cssRule === cssRules[_index]) return _index;
                  }
                  return -1;
                }

                /**
                 * Generate a new CSS rule and replace the existing one.
                 */

              }, {
                key: 'replaceRule',
                value: function replaceRule(cssRule, rule) {
                  var index = this.indexOf(cssRule);
                  var newCssRule = this.insertRule(rule, index);
                  this.element.sheet.deleteRule(index);
                  return newCssRule;
                }

                /**
                 * Get all rules elements.
                 */

              }, {
                key: 'getRules',
                value: function getRules() {
                  return this.element.sheet.cssRules;
                }
              }]);

              return DomRenderer;
            }();

            exports['default'] = DomRenderer;
            });

            unwrapExports$1(DomRenderer_1);

            var VirtualRenderer_1 = createCommonjsModule$1(function (module, exports) {

            Object.defineProperty(exports, "__esModule", {
              value: true
            });

            var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

            function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

            /* eslint-disable class-methods-use-this */

            /**
             * Rendering backend to do nothing in nodejs.
             */
            var VirtualRenderer = function () {
              function VirtualRenderer() {
                _classCallCheck(this, VirtualRenderer);
              }

              _createClass(VirtualRenderer, [{
                key: 'setProperty',
                value: function setProperty() {
                  return true;
                }
              }, {
                key: 'getPropertyValue',
                value: function getPropertyValue() {
                  return '';
                }
              }, {
                key: 'removeProperty',
                value: function removeProperty() {}
              }, {
                key: 'setSelector',
                value: function setSelector() {
                  return true;
                }
              }, {
                key: 'getKey',
                value: function getKey() {
                  return '';
                }
              }, {
                key: 'attach',
                value: function attach() {}
              }, {
                key: 'detach',
                value: function detach() {}
              }, {
                key: 'deploy',
                value: function deploy() {}
              }, {
                key: 'insertRule',
                value: function insertRule() {
                  return false;
                }
              }, {
                key: 'deleteRule',
                value: function deleteRule() {
                  return true;
                }
              }, {
                key: 'replaceRule',
                value: function replaceRule() {
                  return false;
                }
              }, {
                key: 'getRules',
                value: function getRules() {}
              }, {
                key: 'indexOf',
                value: function indexOf() {
                  return -1;
                }
              }]);

              return VirtualRenderer;
            }();

            exports['default'] = VirtualRenderer;
            });

            unwrapExports$1(VirtualRenderer_1);

            var Jss_1 = createCommonjsModule$1(function (module, exports) {

            Object.defineProperty(exports, "__esModule", {
              value: true
            });

            var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; };

            var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

            var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();



            var _isInBrowser2 = _interopRequireDefault(isBrowser);



            var _StyleSheet2 = _interopRequireDefault(StyleSheet_1);



            var _PluginsRegistry2 = _interopRequireDefault(PluginsRegistry_1);



            var _rules2 = _interopRequireDefault(rules);



            var _observables2 = _interopRequireDefault(observables);



            var _functions2 = _interopRequireDefault(functions);



            var _sheets2 = _interopRequireDefault(sheets);



            var _StyleRule2 = _interopRequireDefault(StyleRule_1);



            var _createGenerateClassName2 = _interopRequireDefault(createGenerateClassName);



            var _createRule3 = _interopRequireDefault(createRule_1);



            var _DomRenderer2 = _interopRequireDefault(DomRenderer_1);



            var _VirtualRenderer2 = _interopRequireDefault(VirtualRenderer_1);

            function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

            function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

            var defaultPlugins = _rules2['default'].concat([_observables2['default'], _functions2['default']]);

            var instanceCounter = 0;

            var Jss = function () {
              function Jss(options) {
                _classCallCheck(this, Jss);

                this.id = instanceCounter++;
                this.version = "9.8.7";
                this.plugins = new _PluginsRegistry2['default']();
                this.options = {
                  createGenerateClassName: _createGenerateClassName2['default'],
                  Renderer: _isInBrowser2['default'] ? _DomRenderer2['default'] : _VirtualRenderer2['default'],
                  plugins: []
                };
                this.generateClassName = (0, _createGenerateClassName2['default'])();

                // eslint-disable-next-line prefer-spread
                this.use.apply(this, defaultPlugins);
                this.setup(options);
              }

              _createClass(Jss, [{
                key: 'setup',
                value: function setup() {
                  var options = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

                  if (options.createGenerateClassName) {
                    this.options.createGenerateClassName = options.createGenerateClassName;
                    // $FlowFixMe
                    this.generateClassName = options.createGenerateClassName();
                  }

                  if (options.insertionPoint != null) this.options.insertionPoint = options.insertionPoint;
                  if (options.virtual || options.Renderer) {
                    this.options.Renderer = options.Renderer || (options.virtual ? _VirtualRenderer2['default'] : _DomRenderer2['default']);
                  }

                  // eslint-disable-next-line prefer-spread
                  if (options.plugins) this.use.apply(this, options.plugins);

                  return this;
                }

                /**
                 * Create a Style Sheet.
                 */

              }, {
                key: 'createStyleSheet',
                value: function createStyleSheet(styles) {
                  var options = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};

                  var index = options.index;
                  if (typeof index !== 'number') {
                    index = _sheets2['default'].index === 0 ? 0 : _sheets2['default'].index + 1;
                  }
                  var sheet = new _StyleSheet2['default'](styles, _extends({}, options, {
                    jss: this,
                    generateClassName: options.generateClassName || this.generateClassName,
                    insertionPoint: this.options.insertionPoint,
                    Renderer: this.options.Renderer,
                    index: index
                  }));
                  this.plugins.onProcessSheet(sheet);

                  return sheet;
                }

                /**
                 * Detach the Style Sheet and remove it from the registry.
                 */

              }, {
                key: 'removeStyleSheet',
                value: function removeStyleSheet(sheet) {
                  sheet.detach();
                  _sheets2['default'].remove(sheet);
                  return this;
                }

                /**
                 * Create a rule without a Style Sheet.
                 */

              }, {
                key: 'createRule',
                value: function createRule(name) {
                  var style = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
                  var options = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : {};

                  // Enable rule without name for inline styles.
                  if ((typeof name === 'undefined' ? 'undefined' : _typeof(name)) === 'object') {
                    options = style;
                    style = name;
                    name = undefined;
                  }

                  // Cast from RuleFactoryOptions to RuleOptions
                  // https://stackoverflow.com/questions/41328728/force-casting-in-flow
                  var ruleOptions = options;

                  ruleOptions.jss = this;
                  ruleOptions.Renderer = this.options.Renderer;
                  if (!ruleOptions.generateClassName) ruleOptions.generateClassName = this.generateClassName;
                  if (!ruleOptions.classes) ruleOptions.classes = {};
                  var rule = (0, _createRule3['default'])(name, style, ruleOptions);

                  if (!ruleOptions.selector && rule instanceof _StyleRule2['default']) {
                    rule.selector = '.' + ruleOptions.generateClassName(rule);
                  }

                  this.plugins.onProcessRule(rule);

                  return rule;
                }

                /**
                 * Register plugin. Passed function will be invoked with a rule instance.
                 */

              }, {
                key: 'use',
                value: function use() {
                  var _this = this;

                  for (var _len = arguments.length, plugins = Array(_len), _key = 0; _key < _len; _key++) {
                    plugins[_key] = arguments[_key];
                  }

                  plugins.forEach(function (plugin) {
                    // Avoids applying same plugin twice, at least based on ref.
                    if (_this.options.plugins.indexOf(plugin) === -1) {
                      _this.options.plugins.push(plugin);
                      _this.plugins.use(plugin);
                    }
                  });

                  return this;
                }
              }]);

              return Jss;
            }();

            exports['default'] = Jss;
            });

            unwrapExports$1(Jss_1);

            var lib$7 = createCommonjsModule$1(function (module, exports) {

            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.create = exports.createGenerateClassName = exports.sheets = exports.RuleList = exports.SheetsManager = exports.SheetsRegistry = exports.toCssValue = exports.getDynamicStyles = undefined;



            Object.defineProperty(exports, 'getDynamicStyles', {
              enumerable: true,
              get: function get() {
                return _interopRequireDefault(getDynamicStyles_1)['default'];
              }
            });



            Object.defineProperty(exports, 'toCssValue', {
              enumerable: true,
              get: function get() {
                return _interopRequireDefault(toCssValue_1)['default'];
              }
            });



            Object.defineProperty(exports, 'SheetsRegistry', {
              enumerable: true,
              get: function get() {
                return _interopRequireDefault(SheetsRegistry_1)['default'];
              }
            });



            Object.defineProperty(exports, 'SheetsManager', {
              enumerable: true,
              get: function get() {
                return _interopRequireDefault(SheetsManager_1)['default'];
              }
            });



            Object.defineProperty(exports, 'RuleList', {
              enumerable: true,
              get: function get() {
                return _interopRequireDefault(RuleList_1)['default'];
              }
            });



            Object.defineProperty(exports, 'sheets', {
              enumerable: true,
              get: function get() {
                return _interopRequireDefault(sheets)['default'];
              }
            });



            Object.defineProperty(exports, 'createGenerateClassName', {
              enumerable: true,
              get: function get() {
                return _interopRequireDefault(createGenerateClassName)['default'];
              }
            });



            var _Jss2 = _interopRequireDefault(Jss_1);

            function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

            /**
             * Creates a new instance of Jss.
             */
            var create = exports.create = function create(options) {
              return new _Jss2['default'](options);
            };

            /**
             * A global Jss instance.
             */
            exports['default'] = create();
            });

            unwrapExports$1(lib$7);
            lib$7.create;
            lib$7.createGenerateClassName;
            lib$7.sheets;
            lib$7.RuleList;
            lib$7.SheetsManager;
            lib$7.SheetsRegistry;
            lib$7.toCssValue;
            lib$7.getDynamicStyles;

            var reactJssContext = createCommonjsModule$1(function (module, exports) {

            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;
            // Share the same values than in
            // https://github.com/cssinjs/jss/blob/master/packages/react-jss/src/ns.js
            var ns = {
              jss: '64a55d578f856d258dc345b094a2a2b3',
              sheetsRegistry: 'd4bd0baacbc52bbd48bbb9eb24344ecd',
              sheetOptions: '6fc570d6bd61383819d0f9e7407c452d'
            };
            var _default = ns;
            exports.default = _default;
            });

            unwrapExports$1(reactJssContext);

            var lib$6 = createCommonjsModule$1(function (module, exports) {

            Object.defineProperty(exports, "__esModule", {
              value: true
            });

            var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

            var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

            exports['default'] = jssGlobal;



            function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

            var propKey = '@global';
            var prefixKey = '@global ';

            var GlobalContainerRule = function () {
              function GlobalContainerRule(key, styles, options) {
                _classCallCheck(this, GlobalContainerRule);

                this.type = 'global';

                this.key = key;
                this.options = options;
                this.rules = new lib$7.RuleList(_extends({}, options, {
                  parent: this
                }));

                for (var selector in styles) {
                  this.rules.add(selector, styles[selector], { selector: selector });
                }

                this.rules.process();
              }

              /**
               * Get a rule.
               */


              _createClass(GlobalContainerRule, [{
                key: 'getRule',
                value: function getRule(name) {
                  return this.rules.get(name);
                }

                /**
                 * Create and register rule, run plugins.
                 */

              }, {
                key: 'addRule',
                value: function addRule(name, style, options) {
                  var rule = this.rules.add(name, style, options);
                  this.options.jss.plugins.onProcessRule(rule);
                  return rule;
                }

                /**
                 * Get index of a rule.
                 */

              }, {
                key: 'indexOf',
                value: function indexOf(rule) {
                  return this.rules.indexOf(rule);
                }

                /**
                 * Generates a CSS string.
                 */

              }, {
                key: 'toString',
                value: function toString() {
                  return this.rules.toString();
                }
              }]);

              return GlobalContainerRule;
            }();

            var GlobalPrefixedRule = function () {
              function GlobalPrefixedRule(name, style, options) {
                _classCallCheck(this, GlobalPrefixedRule);

                this.name = name;
                this.options = options;
                var selector = name.substr(prefixKey.length);
                this.rule = options.jss.createRule(selector, style, _extends({}, options, {
                  parent: this,
                  selector: selector
                }));
              }

              _createClass(GlobalPrefixedRule, [{
                key: 'toString',
                value: function toString(options) {
                  return this.rule.toString(options);
                }
              }]);

              return GlobalPrefixedRule;
            }();

            var separatorRegExp = /\s*,\s*/g;

            function addScope(selector, scope) {
              var parts = selector.split(separatorRegExp);
              var scoped = '';
              for (var i = 0; i < parts.length; i++) {
                scoped += scope + ' ' + parts[i].trim();
                if (parts[i + 1]) scoped += ', ';
              }
              return scoped;
            }

            function handleNestedGlobalContainerRule(rule) {
              var options = rule.options,
                  style = rule.style;

              var rules = style[propKey];

              if (!rules) return;

              for (var name in rules) {
                options.sheet.addRule(name, rules[name], _extends({}, options, {
                  selector: addScope(name, rule.selector)
                }));
              }

              delete style[propKey];
            }

            function handlePrefixedGlobalRule(rule) {
              var options = rule.options,
                  style = rule.style;

              for (var prop in style) {
                if (prop.substr(0, propKey.length) !== propKey) continue;

                var selector = addScope(prop.substr(propKey.length), rule.selector);
                options.sheet.addRule(selector, style[prop], _extends({}, options, {
                  selector: selector
                }));
                delete style[prop];
              }
            }

            /**
             * Convert nested rules to separate, remove them from original styles.
             *
             * @param {Rule} rule
             * @api public
             */
            function jssGlobal() {
              function onCreateRule(name, styles, options) {
                if (name === propKey) {
                  return new GlobalContainerRule(name, styles, options);
                }

                if (name[0] === '@' && name.substr(0, prefixKey.length) === prefixKey) {
                  return new GlobalPrefixedRule(name, styles, options);
                }

                var parent = options.parent;


                if (parent) {
                  if (parent.type === 'global' || parent.options.parent.type === 'global') {
                    options.global = true;
                  }
                }

                if (options.global) options.selector = name;

                return null;
              }

              function onProcessRule(rule) {
                if (rule.type !== 'style') return;

                handleNestedGlobalContainerRule(rule);
                handlePrefixedGlobalRule(rule);
              }

              return { onCreateRule: onCreateRule, onProcessRule: onProcessRule };
            }
            });

            unwrapExports$1(lib$6);

            /**
             * Copyright 2014-2015, Facebook, Inc.
             * All rights reserved.
             *
             * This source code is licensed under the BSD-style license found in the
             * LICENSE file in the root directory of this source tree. An additional grant
             * of patent rights can be found in the PATENTS file in the same directory.
             */

            var warning = function() {};

            var warning_1 = warning;

            var lib$5 = createCommonjsModule$1(function (module, exports) {

            Object.defineProperty(exports, "__esModule", {
              value: true
            });

            var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

            exports.default = jssNested;



            var _warning2 = _interopRequireDefault(warning_1);

            function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

            var separatorRegExp = /\s*,\s*/g;
            var parentRegExp = /&/g;
            var refRegExp = /\$([\w-]+)/g;

            /**
             * Convert nested rules to separate, remove them from original styles.
             *
             * @param {Rule} rule
             * @api public
             */
            function jssNested() {
              // Get a function to be used for $ref replacement.
              function getReplaceRef(container) {
                return function (match, key) {
                  var rule = container.getRule(key);
                  if (rule) return rule.selector;
                  (0, _warning2.default)(false, '[JSS] Could not find the referenced rule %s in %s.', key, container.options.meta || container);
                  return key;
                };
              }

              var hasAnd = function hasAnd(str) {
                return str.indexOf('&') !== -1;
              };

              function replaceParentRefs(nestedProp, parentProp) {
                var parentSelectors = parentProp.split(separatorRegExp);
                var nestedSelectors = nestedProp.split(separatorRegExp);

                var result = '';

                for (var i = 0; i < parentSelectors.length; i++) {
                  var parent = parentSelectors[i];

                  for (var j = 0; j < nestedSelectors.length; j++) {
                    var nested = nestedSelectors[j];
                    if (result) result += ', ';
                    // Replace all & by the parent or prefix & with the parent.
                    result += hasAnd(nested) ? nested.replace(parentRegExp, parent) : parent + ' ' + nested;
                  }
                }

                return result;
              }

              function getOptions(rule, container, options) {
                // Options has been already created, now we only increase index.
                if (options) return _extends({}, options, { index: options.index + 1 });

                var nestingLevel = rule.options.nestingLevel;

                nestingLevel = nestingLevel === undefined ? 1 : nestingLevel + 1;

                return _extends({}, rule.options, {
                  nestingLevel: nestingLevel,
                  index: container.indexOf(rule) + 1
                });
              }

              function onProcessStyle(style, rule) {
                if (rule.type !== 'style') return style;
                var container = rule.options.parent;
                var options = void 0;
                var replaceRef = void 0;
                for (var prop in style) {
                  var isNested = hasAnd(prop);
                  var isNestedConditional = prop[0] === '@';

                  if (!isNested && !isNestedConditional) continue;

                  options = getOptions(rule, container, options);

                  if (isNested) {
                    var selector = replaceParentRefs(prop, rule.selector
                    // Lazily create the ref replacer function just once for
                    // all nested rules within the sheet.
                    );if (!replaceRef) replaceRef = getReplaceRef(container
                    // Replace all $refs.
                    );selector = selector.replace(refRegExp, replaceRef);

                    container.addRule(selector, style[prop], _extends({}, options, { selector: selector }));
                  } else if (isNestedConditional) {
                    container
                    // Place conditional right after the parent rule to ensure right ordering.
                    .addRule(prop, null, options).addRule(rule.key, style[prop], { selector: rule.selector });
                  }

                  delete style[prop];
                }

                return style;
              }

              return { onProcessStyle: onProcessStyle };
            }
            });

            unwrapExports$1(lib$5);

            /* eslint-disable no-var, prefer-template */
            var uppercasePattern = /[A-Z]/g;
            var msPattern = /^ms-/;
            var cache$1 = {};

            function toHyphenLower(match) {
              return '-' + match.toLowerCase()
            }

            function hyphenateStyleName(name) {
              if (cache$1.hasOwnProperty(name)) {
                return cache$1[name]
              }

              var hName = name.replace(uppercasePattern, toHyphenLower);
              return (cache$1[name] = msPattern.test(hName) ? '-' + hName : hName)
            }

            var lib$4 = createCommonjsModule$1(function (module, exports) {

            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports['default'] = camelCase;



            var _hyphenateStyleName2 = _interopRequireDefault(hyphenateStyleName);

            function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

            /**
             * Convert camel cased property names to dash separated.
             *
             * @param {Object} style
             * @return {Object}
             */
            function convertCase(style) {
              var converted = {};

              for (var prop in style) {
                converted[(0, _hyphenateStyleName2['default'])(prop)] = style[prop];
              }

              if (style.fallbacks) {
                if (Array.isArray(style.fallbacks)) converted.fallbacks = style.fallbacks.map(convertCase);else converted.fallbacks = convertCase(style.fallbacks);
              }

              return converted;
            }

            /**
             * Allow camel cased property names by converting them back to dasherized.
             *
             * @param {Rule} rule
             */
            function camelCase() {
              function onProcessStyle(style) {
                if (Array.isArray(style)) {
                  // Handle rules like @font-face, which can have multiple styles in an array
                  for (var index = 0; index < style.length; index++) {
                    style[index] = convertCase(style[index]);
                  }
                  return style;
                }

                return convertCase(style);
              }

              function onChangeValue(value, prop, rule) {
                var hyphenatedProp = (0, _hyphenateStyleName2['default'])(prop);

                // There was no camel case in place
                if (prop === hyphenatedProp) return value;

                rule.prop(hyphenatedProp, value);

                // Core will ignore that property value we set the proper one above.
                return null;
              }

              return { onProcessStyle: onProcessStyle, onChangeValue: onChangeValue };
            }
            });

            unwrapExports$1(lib$4);

            var defaultUnits = createCommonjsModule$1(function (module, exports) {

            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            /**
             * Generated jss-default-unit CSS property units
             *
             * @type object
             */
            exports['default'] = {
              'animation-delay': 'ms',
              'animation-duration': 'ms',
              'background-position': 'px',
              'background-position-x': 'px',
              'background-position-y': 'px',
              'background-size': 'px',
              border: 'px',
              'border-bottom': 'px',
              'border-bottom-left-radius': 'px',
              'border-bottom-right-radius': 'px',
              'border-bottom-width': 'px',
              'border-left': 'px',
              'border-left-width': 'px',
              'border-radius': 'px',
              'border-right': 'px',
              'border-right-width': 'px',
              'border-spacing': 'px',
              'border-top': 'px',
              'border-top-left-radius': 'px',
              'border-top-right-radius': 'px',
              'border-top-width': 'px',
              'border-width': 'px',
              'border-after-width': 'px',
              'border-before-width': 'px',
              'border-end-width': 'px',
              'border-horizontal-spacing': 'px',
              'border-start-width': 'px',
              'border-vertical-spacing': 'px',
              bottom: 'px',
              'box-shadow': 'px',
              'column-gap': 'px',
              'column-rule': 'px',
              'column-rule-width': 'px',
              'column-width': 'px',
              'flex-basis': 'px',
              'font-size': 'px',
              'font-size-delta': 'px',
              height: 'px',
              left: 'px',
              'letter-spacing': 'px',
              'logical-height': 'px',
              'logical-width': 'px',
              margin: 'px',
              'margin-after': 'px',
              'margin-before': 'px',
              'margin-bottom': 'px',
              'margin-left': 'px',
              'margin-right': 'px',
              'margin-top': 'px',
              'max-height': 'px',
              'max-width': 'px',
              'margin-end': 'px',
              'margin-start': 'px',
              'mask-position-x': 'px',
              'mask-position-y': 'px',
              'mask-size': 'px',
              'max-logical-height': 'px',
              'max-logical-width': 'px',
              'min-height': 'px',
              'min-width': 'px',
              'min-logical-height': 'px',
              'min-logical-width': 'px',
              motion: 'px',
              'motion-offset': 'px',
              outline: 'px',
              'outline-offset': 'px',
              'outline-width': 'px',
              padding: 'px',
              'padding-bottom': 'px',
              'padding-left': 'px',
              'padding-right': 'px',
              'padding-top': 'px',
              'padding-after': 'px',
              'padding-before': 'px',
              'padding-end': 'px',
              'padding-start': 'px',
              'perspective-origin-x': '%',
              'perspective-origin-y': '%',
              perspective: 'px',
              right: 'px',
              'shape-margin': 'px',
              size: 'px',
              'text-indent': 'px',
              'text-stroke': 'px',
              'text-stroke-width': 'px',
              top: 'px',
              'transform-origin': '%',
              'transform-origin-x': '%',
              'transform-origin-y': '%',
              'transform-origin-z': '%',
              'transition-delay': 'ms',
              'transition-duration': 'ms',
              'vertical-align': 'px',
              width: 'px',
              'word-spacing': 'px',
              // Not existing properties.
              // Used to avoid issues with jss-expand intergration.
              'box-shadow-x': 'px',
              'box-shadow-y': 'px',
              'box-shadow-blur': 'px',
              'box-shadow-spread': 'px',
              'font-line-height': 'px',
              'text-shadow-x': 'px',
              'text-shadow-y': 'px',
              'text-shadow-blur': 'px'
            };
            });

            unwrapExports$1(defaultUnits);

            var lib$3 = createCommonjsModule$1(function (module, exports) {

            Object.defineProperty(exports, "__esModule", {
              value: true
            });

            var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; };

            exports['default'] = defaultUnit;



            var _defaultUnits2 = _interopRequireDefault(defaultUnits);

            function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

            /**
             * Clones the object and adds a camel cased property version.
             */
            function addCamelCasedVersion(obj) {
              var regExp = /(-[a-z])/g;
              var replace = function replace(str) {
                return str[1].toUpperCase();
              };
              var newObj = {};
              for (var key in obj) {
                newObj[key] = obj[key];
                newObj[key.replace(regExp, replace)] = obj[key];
              }
              return newObj;
            }

            var units = addCamelCasedVersion(_defaultUnits2['default']);

            /**
             * Recursive deep style passing function
             *
             * @param {String} current property
             * @param {(Object|Array|Number|String)} property value
             * @param {Object} options
             * @return {(Object|Array|Number|String)} resulting value
             */
            function iterate(prop, value, options) {
              if (!value) return value;

              var convertedValue = value;

              var type = typeof value === 'undefined' ? 'undefined' : _typeof(value);
              if (type === 'object' && Array.isArray(value)) type = 'array';

              switch (type) {
                case 'object':
                  if (prop === 'fallbacks') {
                    for (var innerProp in value) {
                      value[innerProp] = iterate(innerProp, value[innerProp], options);
                    }
                    break;
                  }
                  for (var _innerProp in value) {
                    value[_innerProp] = iterate(prop + '-' + _innerProp, value[_innerProp], options);
                  }
                  break;
                case 'array':
                  for (var i = 0; i < value.length; i++) {
                    value[i] = iterate(prop, value[i], options);
                  }
                  break;
                case 'number':
                  if (value !== 0) {
                    convertedValue = value + (options[prop] || units[prop] || '');
                  }
                  break;
              }

              return convertedValue;
            }

            /**
             * Add unit to numeric values.
             */
            function defaultUnit() {
              var options = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

              var camelCasedOptions = addCamelCasedVersion(options);

              function onProcessStyle(style, rule) {
                if (rule.type !== 'style') return style;

                for (var prop in style) {
                  style[prop] = iterate(prop, style[prop], camelCasedOptions);
                }

                return style;
              }

              function onChangeValue(value, prop) {
                return iterate(prop, value, camelCasedOptions);
              }

              return { onProcessStyle: onProcessStyle, onChangeValue: onChangeValue };
            }
            });

            unwrapExports$1(lib$3);

            var prefix = createCommonjsModule$1(function (module, exports) {

            Object.defineProperty(exports, "__esModule", {
              value: true
            });



            var _isInBrowser2 = _interopRequireDefault(isBrowser);

            function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

            var js = ''; /**
                          * Export javascript style and css style vendor prefixes.
                          * Based on "transform" support test.
                          */

            var css = '';

            // We should not do anything if required serverside.
            if (_isInBrowser2['default']) {
              // Order matters. We need to check Webkit the last one because
              // other vendors use to add Webkit prefixes to some properties
              var jsCssMap = {
                Moz: '-moz-',
                // IE did it wrong again ...
                ms: '-ms-',
                O: '-o-',
                Webkit: '-webkit-'
              };
              var style = document.createElement('p').style;
              var testProp = 'Transform';

              for (var key in jsCssMap) {
                if (key + testProp in style) {
                  js = key;
                  css = jsCssMap[key];
                  break;
                }
              }
            }

            /**
             * Vendor prefix string for the current browser.
             *
             * @type {{js: String, css: String}}
             * @api public
             */
            exports['default'] = { js: js, css: css };
            });

            unwrapExports$1(prefix);

            var camelize_1 = createCommonjsModule$1(function (module, exports) {

            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports['default'] = camelize;
            var regExp = /[-\s]+(.)?/g;

            /**
             * Convert dash separated strings to camel cased.
             *
             * @param {String} str
             * @return {String}
             */
            function camelize(str) {
              return str.replace(regExp, toUpper);
            }

            function toUpper(match, c) {
              return c ? c.toUpperCase() : '';
            }
            });

            unwrapExports$1(camelize_1);

            var supportedProperty_1 = createCommonjsModule$1(function (module, exports) {

            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports['default'] = supportedProperty;



            var _isInBrowser2 = _interopRequireDefault(isBrowser);



            var _prefix2 = _interopRequireDefault(prefix);



            var _camelize2 = _interopRequireDefault(camelize_1);

            function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

            var el = void 0;
            var cache = {};

            if (_isInBrowser2['default']) {
              el = document.createElement('p');

              /**
               * We test every property on vendor prefix requirement.
               * Once tested, result is cached. It gives us up to 70% perf boost.
               * http://jsperf.com/element-style-object-access-vs-plain-object
               *
               * Prefill cache with known css properties to reduce amount of
               * properties we need to feature test at runtime.
               * http://davidwalsh.name/vendor-prefix
               */
              var computed = window.getComputedStyle(document.documentElement, '');
              for (var key in computed) {
                if (!isNaN(key)) cache[computed[key]] = computed[key];
              }
            }

            /**
             * Test if a property is supported, returns supported property with vendor
             * prefix if required. Returns `false` if not supported.
             *
             * @param {String} prop dash separated
             * @return {String|Boolean}
             * @api public
             */
            function supportedProperty(prop) {
              // For server-side rendering.
              if (!el) return prop;

              // We have not tested this prop yet, lets do the test.
              if (cache[prop] != null) return cache[prop];

              // Camelization is required because we can't test using
              // css syntax for e.g. in FF.
              // Test if property is supported as it is.
              if ((0, _camelize2['default'])(prop) in el.style) {
                cache[prop] = prop;
              }
              // Test if property is supported with vendor prefix.
              else if (_prefix2['default'].js + (0, _camelize2['default'])('-' + prop) in el.style) {
                  cache[prop] = _prefix2['default'].css + prop;
                } else {
                  cache[prop] = false;
                }

              return cache[prop];
            }
            });

            unwrapExports$1(supportedProperty_1);

            var supportedValue_1 = createCommonjsModule$1(function (module, exports) {

            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports['default'] = supportedValue;



            var _isInBrowser2 = _interopRequireDefault(isBrowser);



            var _prefix2 = _interopRequireDefault(prefix);

            function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

            var cache = {};
            var el = void 0;

            if (_isInBrowser2['default']) el = document.createElement('p');

            /**
             * Returns prefixed value if needed. Returns `false` if value is not supported.
             *
             * @param {String} property
             * @param {String} value
             * @return {String|Boolean}
             * @api public
             */
            function supportedValue(property, value) {
              // For server-side rendering.
              if (!el) return value;

              // It is a string or a number as a string like '1'.
              // We want only prefixable values here.
              if (typeof value !== 'string' || !isNaN(parseInt(value, 10))) return value;

              var cacheKey = property + value;

              if (cache[cacheKey] != null) return cache[cacheKey];

              // IE can even throw an error in some cases, for e.g. style.content = 'bar'
              try {
                // Test value as it is.
                el.style[property] = value;
              } catch (err) {
                cache[cacheKey] = false;
                return false;
              }

              // Value is supported as it is.
              if (el.style[property] !== '') {
                cache[cacheKey] = value;
              } else {
                // Test value with vendor prefix.
                value = _prefix2['default'].css + value;

                // Hardcode test to convert "flex" to "-ms-flexbox" for IE10.
                if (value === '-ms-flex') value = '-ms-flexbox';

                el.style[property] = value;

                // Value is supported with vendor prefix.
                if (el.style[property] !== '') cache[cacheKey] = value;
              }

              if (!cache[cacheKey]) cache[cacheKey] = false;

              // Reset style value.
              el.style[property] = '';

              return cache[cacheKey];
            }
            });

            unwrapExports$1(supportedValue_1);

            var lib$2 = createCommonjsModule$1(function (module, exports) {

            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.supportedValue = exports.supportedProperty = exports.prefix = undefined;



            var _prefix2 = _interopRequireDefault(prefix);



            var _supportedProperty2 = _interopRequireDefault(supportedProperty_1);



            var _supportedValue2 = _interopRequireDefault(supportedValue_1);

            function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

            exports['default'] = {
              prefix: _prefix2['default'],
              supportedProperty: _supportedProperty2['default'],
              supportedValue: _supportedValue2['default']
            }; /**
                * CSS Vendor prefix detection and property feature testing.
                *
                * @copyright Oleg Slobodskoi 2015
                * @website https://github.com/jsstyles/css-vendor
                * @license MIT
                */

            exports.prefix = _prefix2['default'];
            exports.supportedProperty = _supportedProperty2['default'];
            exports.supportedValue = _supportedValue2['default'];
            });

            unwrapExports$1(lib$2);
            lib$2.supportedValue;
            lib$2.supportedProperty;
            lib$2.prefix;

            var lib$1$1 = createCommonjsModule$1(function (module, exports) {

            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports['default'] = jssVendorPrefixer;



            var vendor = _interopRequireWildcard(lib$2);

            function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj['default'] = obj; return newObj; } }

            /**
             * Add vendor prefix to a property name when needed.
             *
             * @param {Rule} rule
             * @api public
             */
            function jssVendorPrefixer() {
              function onProcessRule(rule) {
                if (rule.type === 'keyframes') {
                  rule.key = '@' + vendor.prefix.css + rule.key.substr(1);
                }
              }

              function onProcessStyle(style, rule) {
                if (rule.type !== 'style') return style;

                for (var prop in style) {
                  var value = style[prop];

                  var changeProp = false;
                  var supportedProp = vendor.supportedProperty(prop);
                  if (supportedProp && supportedProp !== prop) changeProp = true;

                  var changeValue = false;
                  var supportedValue = vendor.supportedValue(supportedProp, value);
                  if (supportedValue && supportedValue !== value) changeValue = true;

                  if (changeProp || changeValue) {
                    if (changeProp) delete style[prop];
                    style[supportedProp || prop] = supportedValue || value;
                  }
                }

                return style;
              }

              function onChangeValue(value, prop) {
                return vendor.supportedValue(prop, value);
              }

              return { onProcessRule: onProcessRule, onProcessStyle: onProcessStyle, onChangeValue: onChangeValue };
            }
            });

            unwrapExports$1(lib$1$1);

            var lib$8 = createCommonjsModule$1(function (module, exports) {

            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports['default'] = jssPropsSort;
            /**
             * Sort props by length.
             */
            function jssPropsSort() {
              function sort(prop0, prop1) {
                return prop0.length - prop1.length;
              }

              function onProcessStyle(style, rule) {
                if (rule.type !== 'style') return style;

                var newStyle = {};
                var props = Object.keys(style).sort(sort);
                for (var prop in props) {
                  newStyle[props[prop]] = style[props[prop]];
                }
                return newStyle;
              }

              return { onProcessStyle: onProcessStyle };
            }
            });

            unwrapExports$1(lib$8);

            var jssPreset_1 = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _jssGlobal = interopRequireDefault$2(lib$6);

            var _jssNested = interopRequireDefault$2(lib$5);

            var _jssCamelCase = interopRequireDefault$2(lib$4);

            var _jssDefaultUnit = interopRequireDefault$2(lib$3);

            var _jssVendorPrefixer = interopRequireDefault$2(lib$1$1);

            var _jssPropsSort = interopRequireDefault$2(lib$8);

            // Subset of jss-preset-default with only the plugins the Material-UI components are using.
            function jssPreset() {
              return {
                plugins: [(0, _jssGlobal.default)(), (0, _jssNested.default)(), (0, _jssCamelCase.default)(), (0, _jssDefaultUnit.default)(), // Disable the vendor prefixer server-side, it does nothing.
                // This way, we can get a performance boost.
                // In the documentation, we are using `autoprefixer` to solve this problem.
                typeof window === 'undefined' ? null : (0, _jssVendorPrefixer.default)(), (0, _jssPropsSort.default)()]
              };
            }

            var _default = jssPreset;
            exports.default = _default;
            });

            unwrapExports$1(jssPreset_1);

            var mergeClasses_1 = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _extends2 = interopRequireDefault$2(_extends_1);

            interopRequireDefault$2(warning_1$2);



            function mergeClasses() {
              var options = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
              var baseClasses = options.baseClasses,
                  newClasses = options.newClasses;
                  options.Component;

              if (!newClasses) {
                return baseClasses;
              }

              var nextClasses = (0, _extends2.default)({}, baseClasses);

              Object.keys(newClasses).forEach(function (key) {

                if (newClasses[key]) {
                  nextClasses[key] = "".concat(baseClasses[key], " ").concat(newClasses[key]);
                }
              });
              return nextClasses;
            }

            var _default = mergeClasses;
            exports.default = _default;
            });

            unwrapExports$1(mergeClasses_1);

            var multiKeyStore_1 = createCommonjsModule$1(function (module, exports) {

            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;
            // Used https://github.com/thinkloop/multi-key-cache as inspiration
            var multiKeyStore = {
              set: function set(cache, key1, key2, value) {
                var subCache = cache.get(key1);

                if (!subCache) {
                  subCache = new Map();
                  cache.set(key1, subCache);
                }

                subCache.set(key2, value);
              },
              get: function get(cache, key1, key2) {
                var subCache = cache.get(key1);
                return subCache ? subCache.get(key2) : undefined;
              },
              delete: function _delete(cache, key1, key2) {
                var subCache = cache.get(key1);
                subCache.delete(key2);
              }
            };
            var _default = multiKeyStore;
            exports.default = _default;
            });

            unwrapExports$1(multiKeyStore_1);

            var umd = createCommonjsModule$1(function (module, exports) {
            (function (global, factory) {
            	module.exports = factory() ;
            }(commonjsGlobal$1, function () {
            	var isMergeableObject = function isMergeableObject(value) {
            		return isNonNullObject(value)
            			&& !isSpecial(value)
            	};

            	function isNonNullObject(value) {
            		return !!value && typeof value === 'object'
            	}

            	function isSpecial(value) {
            		var stringValue = Object.prototype.toString.call(value);

            		return stringValue === '[object RegExp]'
            			|| stringValue === '[object Date]'
            			|| isReactElement(value)
            	}

            	// see https://github.com/facebook/react/blob/b5ac963fb791d1298e7f396236383bc955f916c1/src/isomorphic/classic/element/ReactElement.js#L21-L25
            	var canUseSymbol = typeof Symbol === 'function' && Symbol.for;
            	var REACT_ELEMENT_TYPE = canUseSymbol ? Symbol.for('react.element') : 0xeac7;

            	function isReactElement(value) {
            		return value.$$typeof === REACT_ELEMENT_TYPE
            	}

            	function emptyTarget(val) {
            		return Array.isArray(val) ? [] : {}
            	}

            	function cloneUnlessOtherwiseSpecified(value, options) {
            		return (options.clone !== false && options.isMergeableObject(value))
            			? deepmerge(emptyTarget(value), value, options)
            			: value
            	}

            	function defaultArrayMerge(target, source, options) {
            		return target.concat(source).map(function(element) {
            			return cloneUnlessOtherwiseSpecified(element, options)
            		})
            	}

            	function getMergeFunction(key, options) {
            		if (!options.customMerge) {
            			return deepmerge
            		}
            		var customMerge = options.customMerge(key);
            		return typeof customMerge === 'function' ? customMerge : deepmerge
            	}

            	function getEnumerableOwnPropertySymbols(target) {
            		return Object.getOwnPropertySymbols
            			? Object.getOwnPropertySymbols(target).filter(function(symbol) {
            				return target.propertyIsEnumerable(symbol)
            			})
            			: []
            	}

            	function getKeys(target) {
            		return Object.keys(target).concat(getEnumerableOwnPropertySymbols(target))
            	}

            	function mergeObject(target, source, options) {
            		var destination = {};
            		if (options.isMergeableObject(target)) {
            			getKeys(target).forEach(function(key) {
            				destination[key] = cloneUnlessOtherwiseSpecified(target[key], options);
            			});
            		}
            		getKeys(source).forEach(function(key) {
            			if (!options.isMergeableObject(source[key]) || !target[key]) {
            				destination[key] = cloneUnlessOtherwiseSpecified(source[key], options);
            			} else {
            				destination[key] = getMergeFunction(key, options)(target[key], source[key], options);
            			}
            		});
            		return destination
            	}

            	function deepmerge(target, source, options) {
            		options = options || {};
            		options.arrayMerge = options.arrayMerge || defaultArrayMerge;
            		options.isMergeableObject = options.isMergeableObject || isMergeableObject;

            		var sourceIsArray = Array.isArray(source);
            		var targetIsArray = Array.isArray(target);
            		var sourceAndTargetTypesMatch = sourceIsArray === targetIsArray;

            		if (!sourceAndTargetTypesMatch) {
            			return cloneUnlessOtherwiseSpecified(source, options)
            		} else if (sourceIsArray) {
            			return options.arrayMerge(target, source, options)
            		} else {
            			return mergeObject(target, source, options)
            		}
            	}

            	deepmerge.all = function deepmergeAll(array, options) {
            		if (!Array.isArray(array)) {
            			throw new Error('first argument should be an array')
            		}

            		return array.reduce(function(prev, next) {
            			return deepmerge(prev, next, options)
            		}, {})
            	};

            	var deepmerge_1 = deepmerge;

            	return deepmerge_1;

            }));
            });

            /*!
             * isobject <https://github.com/jonschlinkert/isobject>
             *
             * Copyright (c) 2014-2017, Jon Schlinkert.
             * Released under the MIT License.
             */

            var isobject = function isObject(val) {
              return val != null && typeof val === 'object' && Array.isArray(val) === false;
            };

            function isObjectObject(o) {
              return isobject(o) === true
                && Object.prototype.toString.call(o) === '[object Object]';
            }

            var isPlainObject$1 = function isPlainObject(o) {
              var ctor,prot;

              if (isObjectObject(o) === false) return false;

              // If has modified constructor
              ctor = o.constructor;
              if (typeof ctor !== 'function') return false;

              // If has modified prototype
              prot = ctor.prototype;
              if (isObjectObject(prot) === false) return false;

              // If constructor does not have an Object-specific method
              if (prot.hasOwnProperty('isPrototypeOf') === false) {
                return false;
              }

              // Most likely a plain Object
              return true;
            };

            var createBreakpoints_1 = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = createBreakpoints;
            exports.keys = void 0;

            var _extends2 = interopRequireDefault$2(_extends_1);

            var _objectWithoutProperties2 = interopRequireDefault$2(objectWithoutProperties);

            // Sorted ASC by size. That's important.
            // It can't be configured as it's used statically for propTypes.
            var keys = ['xs', 'sm', 'md', 'lg', 'xl']; // Keep in mind that @media is inclusive by the CSS specification.

            exports.keys = keys;

            function createBreakpoints(breakpoints) {
              var _breakpoints$values = breakpoints.values,
                  values = _breakpoints$values === void 0 ? {
                xs: 0,
                sm: 600,
                md: 960,
                lg: 1280,
                xl: 1920
              } : _breakpoints$values,
                  _breakpoints$unit = breakpoints.unit,
                  unit = _breakpoints$unit === void 0 ? 'px' : _breakpoints$unit,
                  _breakpoints$step = breakpoints.step,
                  step = _breakpoints$step === void 0 ? 5 : _breakpoints$step,
                  other = (0, _objectWithoutProperties2.default)(breakpoints, ["values", "unit", "step"]);

              function up(key) {
                var value = typeof values[key] === 'number' ? values[key] : key;
                return "@media (min-width:".concat(value).concat(unit, ")");
              }

              function down(key) {
                var endIndex = keys.indexOf(key) + 1;
                var upperbound = values[keys[endIndex]];

                if (endIndex === keys.length) {
                  // xl down applies to all sizes
                  return up('xs');
                }

                var value = typeof upperbound === 'number' && endIndex > 0 ? upperbound : key;
                return "@media (max-width:".concat(value - step / 100).concat(unit, ")");
              }

              function between(start, end) {
                var endIndex = keys.indexOf(end) + 1;

                if (endIndex === keys.length) {
                  return up(start);
                }

                return "@media (min-width:".concat(values[start]).concat(unit, ") and ") + "(max-width:".concat(values[keys[endIndex]] - step / 100).concat(unit, ")");
              }

              function only(key) {
                return between(key, key);
              }

              function width(key) {
                return values[key];
              }

              return (0, _extends2.default)({
                keys: keys,
                values: values,
                up: up,
                down: down,
                between: between,
                only: only,
                width: width
              }, other);
            }
            });

            unwrapExports$1(createBreakpoints_1);
            createBreakpoints_1.keys;

            var createMixins_1 = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = createMixins;

            var _defineProperty2 = interopRequireDefault$2(defineProperty$2);

            var _extends3 = interopRequireDefault$2(_extends_1);

            function createMixins(breakpoints, spacing, mixins) {
              var _toolbar;

              return (0, _extends3.default)({
                gutters: function gutters() {
                  var styles = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
                  return (0, _extends3.default)({
                    paddingLeft: spacing.unit * 2,
                    paddingRight: spacing.unit * 2
                  }, styles, (0, _defineProperty2.default)({}, breakpoints.up('sm'), (0, _extends3.default)({
                    paddingLeft: spacing.unit * 3,
                    paddingRight: spacing.unit * 3
                  }, styles[breakpoints.up('sm')])));
                },
                toolbar: (_toolbar = {
                  minHeight: 56
                }, (0, _defineProperty2.default)(_toolbar, "".concat(breakpoints.up('xs'), " and (orientation: landscape)"), {
                  minHeight: 48
                }), (0, _defineProperty2.default)(_toolbar, breakpoints.up('sm'), {
                  minHeight: 64
                }), _toolbar)
              }, mixins);
            }
            });

            unwrapExports$1(createMixins_1);

            var indigo_1 = createCommonjsModule$1(function (module, exports) {

            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;
            var indigo = {
              50: '#e8eaf6',
              100: '#c5cae9',
              200: '#9fa8da',
              300: '#7986cb',
              400: '#5c6bc0',
              500: '#3f51b5',
              600: '#3949ab',
              700: '#303f9f',
              800: '#283593',
              900: '#1a237e',
              A100: '#8c9eff',
              A200: '#536dfe',
              A400: '#3d5afe',
              A700: '#304ffe'
            };
            var _default = indigo;
            exports.default = _default;
            });

            unwrapExports$1(indigo_1);

            var pink_1 = createCommonjsModule$1(function (module, exports) {

            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;
            var pink = {
              50: '#fce4ec',
              100: '#f8bbd0',
              200: '#f48fb1',
              300: '#f06292',
              400: '#ec407a',
              500: '#e91e63',
              600: '#d81b60',
              700: '#c2185b',
              800: '#ad1457',
              900: '#880e4f',
              A100: '#ff80ab',
              A200: '#ff4081',
              A400: '#f50057',
              A700: '#c51162'
            };
            var _default = pink;
            exports.default = _default;
            });

            unwrapExports$1(pink_1);

            var grey_1 = createCommonjsModule$1(function (module, exports) {

            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;
            var grey = {
              50: '#fafafa',
              100: '#f5f5f5',
              200: '#eeeeee',
              300: '#e0e0e0',
              400: '#bdbdbd',
              500: '#9e9e9e',
              600: '#757575',
              700: '#616161',
              800: '#424242',
              900: '#212121',
              A100: '#d5d5d5',
              A200: '#aaaaaa',
              A400: '#303030',
              A700: '#616161'
            };
            var _default = grey;
            exports.default = _default;
            });

            unwrapExports$1(grey_1);

            var red_1 = createCommonjsModule$1(function (module, exports) {

            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;
            var red = {
              50: '#ffebee',
              100: '#ffcdd2',
              200: '#ef9a9a',
              300: '#e57373',
              400: '#ef5350',
              500: '#f44336',
              600: '#e53935',
              700: '#d32f2f',
              800: '#c62828',
              900: '#b71c1c',
              A100: '#ff8a80',
              A200: '#ff5252',
              A400: '#ff1744',
              A700: '#d50000'
            };
            var _default = red;
            exports.default = _default;
            });

            unwrapExports$1(red_1);

            var common_1 = createCommonjsModule$1(function (module, exports) {

            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;
            var common = {
              black: '#000',
              white: '#fff'
            };
            var _default = common;
            exports.default = _default;
            });

            unwrapExports$1(common_1);

            var colorManipulator = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.convertHexToRGB = convertHexToRGB;
            exports.rgbToHex = rgbToHex;
            exports.decomposeColor = decomposeColor;
            exports.recomposeColor = recomposeColor;
            exports.getContrastRatio = getContrastRatio;
            exports.getLuminance = getLuminance;
            exports.emphasize = emphasize;
            exports.fade = fade;
            exports.darken = darken;
            exports.lighten = lighten;

            interopRequireDefault$2(warning_1$2);

            /* eslint-disable no-use-before-define */

            /**
             * Returns a number whose value is limited to the given range.
             *
             * @param {number} value The value to be clamped
             * @param {number} min The lower boundary of the output range
             * @param {number} max The upper boundary of the output range
             * @returns {number} A number in the range [min, max]
             */
            function clamp(value) {
              var min = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 0;
              var max = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : 1;

              if (value < min) {
                return min;
              }

              if (value > max) {
                return max;
              }

              return value;
            }
            /**
             * Converts a color from CSS hex format to CSS rgb format.
             *
             * @param {string} color - Hex color, i.e. #nnn or #nnnnnn
             * @returns {string} A CSS rgb color string
             */


            function convertHexToRGB(color) {
              color = color.substr(1);
              var re = new RegExp(".{1,".concat(color.length / 3, "}"), 'g');
              var colors = color.match(re);

              if (colors && colors[0].length === 1) {
                colors = colors.map(function (n) {
                  return n + n;
                });
              }

              return colors ? "rgb(".concat(colors.map(function (n) {
                return parseInt(n, 16);
              }).join(', '), ")") : '';
            }
            /**
             * Converts a color from CSS rgb format to CSS hex format.
             *
             * @param {string} color - RGB color, i.e. rgb(n, n, n)
             * @returns {string} A CSS rgb color string, i.e. #nnnnnn
             */


            function rgbToHex(color) {
              // Pass hex straight through
              if (color.indexOf('#') === 0) {
                return color;
              }

              function intToHex(c) {
                var hex = c.toString(16);
                return hex.length === 1 ? "0".concat(hex) : hex;
              }

              var _decomposeColor = decomposeColor(color),
                  values = _decomposeColor.values;

              values = values.map(function (n) {
                return intToHex(n);
              });
              return "#".concat(values.join(''));
            }
            /**
             * Returns an object with the type and values of a color.
             *
             * Note: Does not support rgb % values.
             *
             * @param {string} color - CSS color, i.e. one of: #nnn, #nnnnnn, rgb(), rgba(), hsl(), hsla()
             * @returns {object} - A MUI color object: {type: string, values: number[]}
             */


            function decomposeColor(color) {
              if (color.charAt(0) === '#') {
                return decomposeColor(convertHexToRGB(color));
              }

              var marker = color.indexOf('(');
              var type = color.substring(0, marker);
              var values = color.substring(marker + 1, color.length - 1).split(',');
              values = values.map(function (value) {
                return parseFloat(value);
              });

              return {
                type: type,
                values: values
              };
            }
            /**
             * Converts a color object with type and values to a string.
             *
             * @param {object} color - Decomposed color
             * @param {string} color.type - One of: 'rgb', 'rgba', 'hsl', 'hsla'
             * @param {array} color.values - [n,n,n] or [n,n,n,n]
             * @returns {string} A CSS color string
             */


            function recomposeColor(color) {
              var type = color.type;
              var values = color.values;

              if (type.indexOf('rgb') !== -1) {
                // Only convert the first 3 values to int (i.e. not alpha)
                values = values.map(function (n, i) {
                  return i < 3 ? parseInt(n, 10) : n;
                });
              }

              if (type.indexOf('hsl') !== -1) {
                values[1] = "".concat(values[1], "%");
                values[2] = "".concat(values[2], "%");
              }

              return "".concat(color.type, "(").concat(values.join(', '), ")");
            }
            /**
             * Calculates the contrast ratio between two colors.
             *
             * Formula: https://www.w3.org/TR/WCAG20-TECHS/G17.html#G17-tests
             *
             * @param {string} foreground - CSS color, i.e. one of: #nnn, #nnnnnn, rgb(), rgba(), hsl(), hsla()
             * @param {string} background - CSS color, i.e. one of: #nnn, #nnnnnn, rgb(), rgba(), hsl(), hsla()
             * @returns {number} A contrast ratio value in the range 0 - 21.
             */


            function getContrastRatio(foreground, background) {
              var lumA = getLuminance(foreground);
              var lumB = getLuminance(background);
              return (Math.max(lumA, lumB) + 0.05) / (Math.min(lumA, lumB) + 0.05);
            }
            /**
             * The relative brightness of any point in a color space,
             * normalized to 0 for darkest black and 1 for lightest white.
             *
             * Formula: https://www.w3.org/TR/WCAG20-TECHS/G17.html#G17-tests
             *
             * @param {string} color - CSS color, i.e. one of: #nnn, #nnnnnn, rgb(), rgba(), hsl(), hsla()
             * @returns {number} The relative brightness of the color in the range 0 - 1
             */


            function getLuminance(color) {
              var decomposedColor = decomposeColor(color);

              if (decomposedColor.type.indexOf('rgb') !== -1) {
                var rgb = decomposedColor.values.map(function (val) {
                  val /= 255; // normalized

                  return val <= 0.03928 ? val / 12.92 : Math.pow((val + 0.055) / 1.055, 2.4);
                }); // Truncate at 3 digits

                return Number((0.2126 * rgb[0] + 0.7152 * rgb[1] + 0.0722 * rgb[2]).toFixed(3));
              } // else if (decomposedColor.type.indexOf('hsl') !== -1)


              return decomposedColor.values[2] / 100;
            }
            /**
             * Darken or lighten a colour, depending on its luminance.
             * Light colors are darkened, dark colors are lightened.
             *
             * @param {string} color - CSS color, i.e. one of: #nnn, #nnnnnn, rgb(), rgba(), hsl(), hsla()
             * @param {number} coefficient=0.15 - multiplier in the range 0 - 1
             * @returns {string} A CSS color string. Hex input values are returned as rgb
             */


            function emphasize(color) {
              var coefficient = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 0.15;
              return getLuminance(color) > 0.5 ? darken(color, coefficient) : lighten(color, coefficient);
            }
            /**
             * Set the absolute transparency of a color.
             * Any existing alpha values are overwritten.
             *
             * @param {string} color - CSS color, i.e. one of: #nnn, #nnnnnn, rgb(), rgba(), hsl(), hsla()
             * @param {number} value - value to set the alpha channel to in the range 0 -1
             * @returns {string} A CSS color string. Hex input values are returned as rgb
             */


            function fade(color, value) {
              if (!color) return color;
              color = decomposeColor(color);
              value = clamp(value);

              if (color.type === 'rgb' || color.type === 'hsl') {
                color.type += 'a';
              }

              color.values[3] = value;
              return recomposeColor(color);
            }
            /**
             * Darkens a color.
             *
             * @param {string} color - CSS color, i.e. one of: #nnn, #nnnnnn, rgb(), rgba(), hsl(), hsla()
             * @param {number} coefficient - multiplier in the range 0 - 1
             * @returns {string} A CSS color string. Hex input values are returned as rgb
             */


            function darken(color, coefficient) {
              if (!color) return color;
              color = decomposeColor(color);
              coefficient = clamp(coefficient);

              if (color.type.indexOf('hsl') !== -1) {
                color.values[2] *= 1 - coefficient;
              } else if (color.type.indexOf('rgb') !== -1) {
                for (var i = 0; i < 3; i += 1) {
                  color.values[i] *= 1 - coefficient;
                }
              }

              return recomposeColor(color);
            }
            /**
             * Lightens a color.
             *
             * @param {string} color - CSS color, i.e. one of: #nnn, #nnnnnn, rgb(), rgba(), hsl(), hsla()
             * @param {number} coefficient - multiplier in the range 0 - 1
             * @returns {string} A CSS color string. Hex input values are returned as rgb
             */


            function lighten(color, coefficient) {
              if (!color) return color;
              color = decomposeColor(color);
              coefficient = clamp(coefficient);

              if (color.type.indexOf('hsl') !== -1) {
                color.values[2] += (100 - color.values[2]) * coefficient;
              } else if (color.type.indexOf('rgb') !== -1) {
                for (var i = 0; i < 3; i += 1) {
                  color.values[i] += (255 - color.values[i]) * coefficient;
                }
              }

              return recomposeColor(color);
            }
            });

            unwrapExports$1(colorManipulator);
            colorManipulator.convertHexToRGB;
            colorManipulator.rgbToHex;
            colorManipulator.decomposeColor;
            colorManipulator.recomposeColor;
            colorManipulator.getContrastRatio;
            colorManipulator.getLuminance;
            colorManipulator.emphasize;
            colorManipulator.fade;
            colorManipulator.darken;
            colorManipulator.lighten;

            var createPalette_1 = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = createPalette;
            exports.dark = exports.light = void 0;

            var _extends2 = interopRequireDefault$2(_extends_1);

            var _objectWithoutProperties2 = interopRequireDefault$2(objectWithoutProperties);

            interopRequireDefault$2(warning_1$2);

            var _deepmerge = interopRequireDefault$2(umd);

            var _indigo = interopRequireDefault$2(indigo_1);

            var _pink = interopRequireDefault$2(pink_1);

            var _grey = interopRequireDefault$2(grey_1);

            var _red = interopRequireDefault$2(red_1);

            var _common = interopRequireDefault$2(common_1);



            // < 1kb payload overhead when lodash/merge is > 3kb.
            var light = {
              // The colors used to style the text.
              text: {
                // The most important text.
                primary: 'rgba(0, 0, 0, 0.87)',
                // Secondary text.
                secondary: 'rgba(0, 0, 0, 0.54)',
                // Disabled text have even lower visual prominence.
                disabled: 'rgba(0, 0, 0, 0.38)',
                // Text hints.
                hint: 'rgba(0, 0, 0, 0.38)'
              },
              // The color used to divide different elements.
              divider: 'rgba(0, 0, 0, 0.12)',
              // The background colors used to style the surfaces.
              // Consistency between these values is important.
              background: {
                paper: _common.default.white,
                default: _grey.default[50]
              },
              // The colors used to style the action elements.
              action: {
                // The color of an active action like an icon button.
                active: 'rgba(0, 0, 0, 0.54)',
                // The color of an hovered action.
                hover: 'rgba(0, 0, 0, 0.08)',
                hoverOpacity: 0.08,
                // The color of a selected action.
                selected: 'rgba(0, 0, 0, 0.14)',
                // The color of a disabled action.
                disabled: 'rgba(0, 0, 0, 0.26)',
                // The background color of a disabled action.
                disabledBackground: 'rgba(0, 0, 0, 0.12)'
              }
            };
            exports.light = light;
            var dark = {
              text: {
                primary: _common.default.white,
                secondary: 'rgba(255, 255, 255, 0.7)',
                disabled: 'rgba(255, 255, 255, 0.5)',
                hint: 'rgba(255, 255, 255, 0.5)',
                icon: 'rgba(255, 255, 255, 0.5)'
              },
              divider: 'rgba(255, 255, 255, 0.12)',
              background: {
                paper: _grey.default[800],
                default: '#303030'
              },
              action: {
                active: _common.default.white,
                hover: 'rgba(255, 255, 255, 0.1)',
                hoverOpacity: 0.1,
                selected: 'rgba(255, 255, 255, 0.2)',
                disabled: 'rgba(255, 255, 255, 0.3)',
                disabledBackground: 'rgba(255, 255, 255, 0.12)'
              }
            };
            exports.dark = dark;

            function addLightOrDark(intent, direction, shade, tonalOffset) {
              if (!intent[direction]) {
                if (intent.hasOwnProperty(shade)) {
                  intent[direction] = intent[shade];
                } else if (direction === 'light') {
                  intent.light = (0, colorManipulator.lighten)(intent.main, tonalOffset);
                } else if (direction === 'dark') {
                  intent.dark = (0, colorManipulator.darken)(intent.main, tonalOffset * 1.5);
                }
              }
            }

            function createPalette(palette) {
              var _palette$primary = palette.primary,
                  primary = _palette$primary === void 0 ? {
                light: _indigo.default[300],
                main: _indigo.default[500],
                dark: _indigo.default[700]
              } : _palette$primary,
                  _palette$secondary = palette.secondary,
                  secondary = _palette$secondary === void 0 ? {
                light: _pink.default.A200,
                main: _pink.default.A400,
                dark: _pink.default.A700
              } : _palette$secondary,
                  _palette$error = palette.error,
                  error = _palette$error === void 0 ? {
                light: _red.default[300],
                main: _red.default[500],
                dark: _red.default[700]
              } : _palette$error,
                  _palette$type = palette.type,
                  type = _palette$type === void 0 ? 'light' : _palette$type,
                  _palette$contrastThre = palette.contrastThreshold,
                  contrastThreshold = _palette$contrastThre === void 0 ? 3 : _palette$contrastThre,
                  _palette$tonalOffset = palette.tonalOffset,
                  tonalOffset = _palette$tonalOffset === void 0 ? 0.2 : _palette$tonalOffset,
                  other = (0, _objectWithoutProperties2.default)(palette, ["primary", "secondary", "error", "type", "contrastThreshold", "tonalOffset"]);

              function getContrastText(background) {
                // Use the same logic as
                // Bootstrap: https://github.com/twbs/bootstrap/blob/1d6e3710dd447de1a200f29e8fa521f8a0908f70/scss/_functions.scss#L59
                // and material-components-web https://github.com/material-components/material-components-web/blob/ac46b8863c4dab9fc22c4c662dc6bd1b65dd652f/packages/mdc-theme/_functions.scss#L54
                var contrastText = (0, colorManipulator.getContrastRatio)(background, dark.text.primary) >= contrastThreshold ? dark.text.primary : light.text.primary;

                return contrastText;
              }

              function augmentColor(color) {
                var mainShade = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 500;
                var lightShade = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : 300;
                var darkShade = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : 700;

                if (!color.main && color[mainShade]) {
                  color.main = color[mainShade];
                }

                addLightOrDark(color, 'light', lightShade, tonalOffset);
                addLightOrDark(color, 'dark', darkShade, tonalOffset);

                if (!color.contrastText) {
                  color.contrastText = getContrastText(color.main);
                }

                return color;
              }

              augmentColor(primary);
              augmentColor(secondary, 'A400', 'A200', 'A700');
              augmentColor(error);
              var types = {
                dark: dark,
                light: light
              };
              var paletteOutput = (0, _deepmerge.default)((0, _extends2.default)({
                // A collection of common colors.
                common: _common.default,
                // The palette type, can be light or dark.
                type: type,
                // The colors used to represent primary interface elements for a user.
                primary: primary,
                // The colors used to represent secondary interface elements for a user.
                secondary: secondary,
                // The colors used to represent interface elements that the user should be made aware of.
                error: error,
                // The grey colors.
                grey: _grey.default,
                // Used by `getContrastText()` to maximize the contrast between the background and
                // the text.
                contrastThreshold: contrastThreshold,
                // Take a background color and return the color of the text to maximize the contrast.
                getContrastText: getContrastText,
                // Generate a rich color object.
                augmentColor: augmentColor,
                // Used by the functions below to shift a color's luminance by approximately
                // two indexes within its tonal palette.
                // E.g., shift from Red 500 to Red 300 or Red 700.
                tonalOffset: tonalOffset
              }, types[type]), other, {
                clone: false // No need to clone deep

              });
              return paletteOutput;
            }
            });

            unwrapExports$1(createPalette_1);
            createPalette_1.dark;
            createPalette_1.light;

            var createTypography_1 = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = createTypography;

            var _extends2 = interopRequireDefault$2(_extends_1);

            var _objectWithoutProperties2 = interopRequireDefault$2(objectWithoutProperties);

            var _deepmerge = interopRequireDefault$2(umd);

            interopRequireDefault$2(warning_1$2);



            // < 1kb payload overhead when lodash/merge is > 3kb.
            function round(value) {
              return Math.round(value * 1e5) / 1e5;
            }

            var caseAllCaps = {
              textTransform: 'uppercase'
            };
            var defaultFontFamily = '"Roboto", "Helvetica", "Arial", sans-serif';
            /**
             * @see @link{https://material.io/design/typography/the-type-system.html}
             * @see @link{https://material.io/design/typography/understanding-typography.html}
             */

            function createTypography(palette, typography) {
              var _ref = typeof typography === 'function' ? typography(palette) : typography,
                  _ref$fontFamily = _ref.fontFamily,
                  fontFamily = _ref$fontFamily === void 0 ? defaultFontFamily : _ref$fontFamily,
                  _ref$fontSize = _ref.fontSize,
                  fontSize = _ref$fontSize === void 0 ? 14 : _ref$fontSize,
                  _ref$fontWeightLight = _ref.fontWeightLight,
                  fontWeightLight = _ref$fontWeightLight === void 0 ? 300 : _ref$fontWeightLight,
                  _ref$fontWeightRegula = _ref.fontWeightRegular,
                  fontWeightRegular = _ref$fontWeightRegula === void 0 ? 400 : _ref$fontWeightRegula,
                  _ref$fontWeightMedium = _ref.fontWeightMedium,
                  fontWeightMedium = _ref$fontWeightMedium === void 0 ? 500 : _ref$fontWeightMedium,
                  _ref$htmlFontSize = _ref.htmlFontSize,
                  htmlFontSize = _ref$htmlFontSize === void 0 ? 16 : _ref$htmlFontSize,
                  _ref$useNextVariants = _ref.useNextVariants,
                  useNextVariants = _ref$useNextVariants === void 0 ? Boolean(index_es.ponyfillGlobal.__MUI_USE_NEXT_TYPOGRAPHY_VARIANTS__) : _ref$useNextVariants;
                  _ref.suppressWarning;
                  var allVariants = _ref.allVariants,
                  other = (0, _objectWithoutProperties2.default)(_ref, ["fontFamily", "fontSize", "fontWeightLight", "fontWeightRegular", "fontWeightMedium", "htmlFontSize", "useNextVariants", "suppressWarning", "allVariants"]);
              var coef = fontSize / 14;

              var pxToRem = function pxToRem(size) {
                return "".concat(size / htmlFontSize * coef, "rem");
              };

              var buildVariant = function buildVariant(fontWeight, size, lineHeight, letterSpacing, casing) {
                return (0, _extends2.default)({
                  color: palette.text.primary,
                  fontFamily: fontFamily,
                  fontWeight: fontWeight,
                  fontSize: pxToRem(size),
                  // Unitless following http://meyerweb.com/eric/thoughts/2006/02/08/unitless-line-heights/
                  lineHeight: lineHeight
                }, fontFamily === defaultFontFamily ? {
                  letterSpacing: "".concat(round(letterSpacing / size), "em")
                } : {}, casing, allVariants);
              };

              var nextVariants = {
                h1: buildVariant(fontWeightLight, 96, 1, -1.5),
                h2: buildVariant(fontWeightLight, 60, 1, -0.5),
                h3: buildVariant(fontWeightRegular, 48, 1.04, 0),
                h4: buildVariant(fontWeightRegular, 34, 1.17, 0.25),
                h5: buildVariant(fontWeightRegular, 24, 1.33, 0),
                h6: buildVariant(fontWeightMedium, 20, 1.6, 0.15),
                subtitle1: buildVariant(fontWeightRegular, 16, 1.75, 0.15),
                subtitle2: buildVariant(fontWeightMedium, 14, 1.57, 0.1),
                body1Next: buildVariant(fontWeightRegular, 16, 1.5, 0.15),
                body2Next: buildVariant(fontWeightRegular, 14, 1.5, 0.15),
                buttonNext: buildVariant(fontWeightMedium, 14, 1.75, 0.4, caseAllCaps),
                captionNext: buildVariant(fontWeightRegular, 12, 1.66, 0.4),
                overline: buildVariant(fontWeightRegular, 12, 2.66, 1, caseAllCaps)
              }; // To remove in v4

              var oldVariants = {
                display4: (0, _extends2.default)({
                  fontSize: pxToRem(112),
                  fontWeight: fontWeightLight,
                  fontFamily: fontFamily,
                  letterSpacing: '-.04em',
                  lineHeight: "".concat(round(128 / 112), "em"),
                  marginLeft: '-.04em',
                  color: palette.text.secondary
                }, allVariants),
                display3: (0, _extends2.default)({
                  fontSize: pxToRem(56),
                  fontWeight: fontWeightRegular,
                  fontFamily: fontFamily,
                  letterSpacing: '-.02em',
                  lineHeight: "".concat(round(73 / 56), "em"),
                  marginLeft: '-.02em',
                  color: palette.text.secondary
                }, allVariants),
                display2: (0, _extends2.default)({
                  fontSize: pxToRem(45),
                  fontWeight: fontWeightRegular,
                  fontFamily: fontFamily,
                  lineHeight: "".concat(round(51 / 45), "em"),
                  marginLeft: '-.02em',
                  color: palette.text.secondary
                }, allVariants),
                display1: (0, _extends2.default)({
                  fontSize: pxToRem(34),
                  fontWeight: fontWeightRegular,
                  fontFamily: fontFamily,
                  lineHeight: "".concat(round(41 / 34), "em"),
                  color: palette.text.secondary
                }, allVariants),
                headline: (0, _extends2.default)({
                  fontSize: pxToRem(24),
                  fontWeight: fontWeightRegular,
                  fontFamily: fontFamily,
                  lineHeight: "".concat(round(32.5 / 24), "em"),
                  color: palette.text.primary
                }, allVariants),
                title: (0, _extends2.default)({
                  fontSize: pxToRem(21),
                  fontWeight: fontWeightMedium,
                  fontFamily: fontFamily,
                  lineHeight: "".concat(round(24.5 / 21), "em"),
                  color: palette.text.primary
                }, allVariants),
                subheading: (0, _extends2.default)({
                  fontSize: pxToRem(16),
                  fontWeight: fontWeightRegular,
                  fontFamily: fontFamily,
                  lineHeight: "".concat(round(24 / 16), "em"),
                  color: palette.text.primary
                }, allVariants),
                body2: (0, _extends2.default)({
                  fontSize: pxToRem(14),
                  fontWeight: fontWeightMedium,
                  fontFamily: fontFamily,
                  lineHeight: "".concat(round(24 / 14), "em"),
                  color: palette.text.primary
                }, allVariants),
                body1: (0, _extends2.default)({
                  fontSize: pxToRem(14),
                  fontWeight: fontWeightRegular,
                  fontFamily: fontFamily,
                  lineHeight: "".concat(round(20.5 / 14), "em"),
                  color: palette.text.primary
                }, allVariants),
                caption: (0, _extends2.default)({
                  fontSize: pxToRem(12),
                  fontWeight: fontWeightRegular,
                  fontFamily: fontFamily,
                  lineHeight: "".concat(round(16.5 / 12), "em"),
                  color: palette.text.secondary
                }, allVariants),
                button: (0, _extends2.default)({
                  fontSize: pxToRem(14),
                  textTransform: 'uppercase',
                  fontWeight: fontWeightMedium,
                  fontFamily: fontFamily,
                  color: palette.text.primary
                }, allVariants)
              };
              return (0, _deepmerge.default)((0, _extends2.default)({
                pxToRem: pxToRem,
                round: round,
                fontFamily: fontFamily,
                fontSize: fontSize,
                fontWeightLight: fontWeightLight,
                fontWeightRegular: fontWeightRegular,
                fontWeightMedium: fontWeightMedium
              }, oldVariants, nextVariants, useNextVariants ? {
                body1: nextVariants.body1Next,
                body2: nextVariants.body2Next,
                button: nextVariants.buttonNext,
                caption: nextVariants.captionNext
              } : {}, {
                useNextVariants: useNextVariants
              }), other, {
                clone: false // No need to clone deep

              });
            }
            });

            unwrapExports$1(createTypography_1);

            var shadows_1 = createCommonjsModule$1(function (module, exports) {

            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;
            var shadowKeyUmbraOpacity = 0.2;
            var shadowKeyPenumbraOpacity = 0.14;
            var shadowAmbientShadowOpacity = 0.12;

            function createShadow() {
              return ["".concat(arguments.length <= 0 ? undefined : arguments[0], "px ").concat(arguments.length <= 1 ? undefined : arguments[1], "px ").concat(arguments.length <= 2 ? undefined : arguments[2], "px ").concat(arguments.length <= 3 ? undefined : arguments[3], "px rgba(0,0,0,").concat(shadowKeyUmbraOpacity, ")"), "".concat(arguments.length <= 4 ? undefined : arguments[4], "px ").concat(arguments.length <= 5 ? undefined : arguments[5], "px ").concat(arguments.length <= 6 ? undefined : arguments[6], "px ").concat(arguments.length <= 7 ? undefined : arguments[7], "px rgba(0,0,0,").concat(shadowKeyPenumbraOpacity, ")"), "".concat(arguments.length <= 8 ? undefined : arguments[8], "px ").concat(arguments.length <= 9 ? undefined : arguments[9], "px ").concat(arguments.length <= 10 ? undefined : arguments[10], "px ").concat(arguments.length <= 11 ? undefined : arguments[11], "px rgba(0,0,0,").concat(shadowAmbientShadowOpacity, ")")].join(',');
            }

            var shadows = ['none', createShadow(0, 1, 3, 0, 0, 1, 1, 0, 0, 2, 1, -1), createShadow(0, 1, 5, 0, 0, 2, 2, 0, 0, 3, 1, -2), createShadow(0, 1, 8, 0, 0, 3, 4, 0, 0, 3, 3, -2), createShadow(0, 2, 4, -1, 0, 4, 5, 0, 0, 1, 10, 0), createShadow(0, 3, 5, -1, 0, 5, 8, 0, 0, 1, 14, 0), createShadow(0, 3, 5, -1, 0, 6, 10, 0, 0, 1, 18, 0), createShadow(0, 4, 5, -2, 0, 7, 10, 1, 0, 2, 16, 1), createShadow(0, 5, 5, -3, 0, 8, 10, 1, 0, 3, 14, 2), createShadow(0, 5, 6, -3, 0, 9, 12, 1, 0, 3, 16, 2), createShadow(0, 6, 6, -3, 0, 10, 14, 1, 0, 4, 18, 3), createShadow(0, 6, 7, -4, 0, 11, 15, 1, 0, 4, 20, 3), createShadow(0, 7, 8, -4, 0, 12, 17, 2, 0, 5, 22, 4), createShadow(0, 7, 8, -4, 0, 13, 19, 2, 0, 5, 24, 4), createShadow(0, 7, 9, -4, 0, 14, 21, 2, 0, 5, 26, 4), createShadow(0, 8, 9, -5, 0, 15, 22, 2, 0, 6, 28, 5), createShadow(0, 8, 10, -5, 0, 16, 24, 2, 0, 6, 30, 5), createShadow(0, 8, 11, -5, 0, 17, 26, 2, 0, 6, 32, 5), createShadow(0, 9, 11, -5, 0, 18, 28, 2, 0, 7, 34, 6), createShadow(0, 9, 12, -6, 0, 19, 29, 2, 0, 7, 36, 6), createShadow(0, 10, 13, -6, 0, 20, 31, 3, 0, 8, 38, 7), createShadow(0, 10, 13, -6, 0, 21, 33, 3, 0, 8, 40, 7), createShadow(0, 10, 14, -6, 0, 22, 35, 3, 0, 8, 42, 7), createShadow(0, 11, 14, -7, 0, 23, 36, 3, 0, 9, 44, 8), createShadow(0, 11, 15, -7, 0, 24, 38, 3, 0, 9, 46, 8)];
            var _default = shadows;
            exports.default = _default;
            });

            unwrapExports$1(shadows_1);

            var shape_1 = createCommonjsModule$1(function (module, exports) {

            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;
            var shape = {
              borderRadius: 4
            };
            var _default = shape;
            exports.default = _default;
            });

            unwrapExports$1(shape_1);

            var spacing_1 = createCommonjsModule$1(function (module, exports) {

            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;
            var spacing = {
              // All components align to an 8dp square baseline grid for mobile, tablet, and desktop.
              // https://material.io/design/layout/understanding-layout.html#pixel-density
              unit: 8
            };
            var _default = spacing;
            exports.default = _default;
            });

            unwrapExports$1(spacing_1);

            var transitions = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = exports.isNumber = exports.isString = exports.formatMs = exports.duration = exports.easing = void 0;

            var _objectWithoutProperties2 = interopRequireDefault$2(objectWithoutProperties);

            interopRequireDefault$2(warning_1$2);

            /* eslint-disable no-restricted-globals */
            // Follow https://material.google.com/motion/duration-easing.html#duration-easing-natural-easing-curves
            // to learn the context in which each easing should be used.
            var easing = {
              // This is the most common easing curve.
              easeInOut: 'cubic-bezier(0.4, 0, 0.2, 1)',
              // Objects enter the screen at full velocity from off-screen and
              // slowly decelerate to a resting point.
              easeOut: 'cubic-bezier(0.0, 0, 0.2, 1)',
              // Objects leave the screen at full velocity. They do not decelerate when off-screen.
              easeIn: 'cubic-bezier(0.4, 0, 1, 1)',
              // The sharp curve is used by objects that may return to the screen at any time.
              sharp: 'cubic-bezier(0.4, 0, 0.6, 1)'
            }; // Follow https://material.io/guidelines/motion/duration-easing.html#duration-easing-common-durations
            // to learn when use what timing

            exports.easing = easing;
            var duration = {
              shortest: 150,
              shorter: 200,
              short: 250,
              // most basic recommended timing
              standard: 300,
              // this is to be used in complex animations
              complex: 375,
              // recommended when something is entering screen
              enteringScreen: 225,
              // recommended when something is leaving screen
              leavingScreen: 195
            };
            exports.duration = duration;

            var formatMs = function formatMs(milliseconds) {
              return "".concat(Math.round(milliseconds), "ms");
            };

            exports.formatMs = formatMs;

            var isString = function isString(value) {
              return typeof value === 'string';
            };

            exports.isString = isString;

            var isNumber = function isNumber(value) {
              return !isNaN(parseFloat(value));
            };
            /**
             * @param {string|Array} props
             * @param {object} param
             * @param {string} param.prop
             * @param {number} param.duration
             * @param {string} param.easing
             * @param {number} param.delay
             */


            exports.isNumber = isNumber;
            var _default = {
              easing: easing,
              duration: duration,
              create: function create() {
                var props = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : ['all'];
                var options = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
                var _options$duration = options.duration,
                    durationOption = _options$duration === void 0 ? duration.standard : _options$duration,
                    _options$easing = options.easing,
                    easingOption = _options$easing === void 0 ? easing.easeInOut : _options$easing,
                    _options$delay = options.delay,
                    delay = _options$delay === void 0 ? 0 : _options$delay;
                    (0, _objectWithoutProperties2.default)(options, ["duration", "easing", "delay"]);
                return (Array.isArray(props) ? props : [props]).map(function (animatedProp) {
                  return "".concat(animatedProp, " ").concat(typeof durationOption === 'string' ? durationOption : formatMs(durationOption), " ").concat(easingOption, " ").concat(typeof delay === 'string' ? delay : formatMs(delay));
                }).join(',');
              },
              getAutoHeightDuration: function getAutoHeightDuration(height) {
                if (!height) {
                  return 0;
                }

                var constant = height / 36; // https://www.wolframalpha.com/input/?i=(4+%2B+15+*+(x+%2F+36+)+**+0.25+%2B+(x+%2F+36)+%2F+5)+*+10

                return Math.round((4 + 15 * Math.pow(constant, 0.25) + constant / 5) * 10);
              }
            };
            exports.default = _default;
            });

            unwrapExports$1(transitions);
            transitions.isNumber;
            transitions.isString;
            transitions.formatMs;
            transitions.duration;
            transitions.easing;

            var zIndex_1 = createCommonjsModule$1(function (module, exports) {

            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;
            // We need to centralize the zIndex definitions as they work
            // like global values in the browser.
            var zIndex = {
              mobileStepper: 1000,
              appBar: 1100,
              drawer: 1200,
              modal: 1300,
              snackbar: 1400,
              tooltip: 1500
            };
            var _default = zIndex;
            exports.default = _default;
            });

            unwrapExports$1(zIndex_1);

            var createMuiTheme_1 = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            interopRequireDefault$2(defineProperty$2);

            var _extends2 = interopRequireDefault$2(_extends_1);

            var _objectWithoutProperties2 = interopRequireDefault$2(objectWithoutProperties);

            var _deepmerge = interopRequireDefault$2(umd);

            var _isPlainObject = interopRequireDefault$2(isPlainObject$1);

            interopRequireDefault$2(warning_1$2);

            var _createBreakpoints = interopRequireDefault$2(createBreakpoints_1);

            var _createMixins = interopRequireDefault$2(createMixins_1);

            var _createPalette = interopRequireDefault$2(createPalette_1);

            var _createTypography = interopRequireDefault$2(createTypography_1);

            var _shadows = interopRequireDefault$2(shadows_1);

            var _shape = interopRequireDefault$2(shape_1);

            var _spacing = interopRequireDefault$2(spacing_1);

            var _transitions = interopRequireDefault$2(transitions);

            var _zIndex = interopRequireDefault$2(zIndex_1);

            // < 1kb payload overhead when lodash/merge is > 3kb.
            function createMuiTheme() {
              var options = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
              var _options$breakpoints = options.breakpoints,
                  breakpointsInput = _options$breakpoints === void 0 ? {} : _options$breakpoints,
                  _options$mixins = options.mixins,
                  mixinsInput = _options$mixins === void 0 ? {} : _options$mixins,
                  _options$palette = options.palette,
                  paletteInput = _options$palette === void 0 ? {} : _options$palette,
                  shadowsInput = options.shadows,
                  _options$spacing = options.spacing,
                  spacingInput = _options$spacing === void 0 ? {} : _options$spacing,
                  _options$typography = options.typography,
                  typographyInput = _options$typography === void 0 ? {} : _options$typography,
                  other = (0, _objectWithoutProperties2.default)(options, ["breakpoints", "mixins", "palette", "shadows", "spacing", "typography"]);
              var palette = (0, _createPalette.default)(paletteInput);
              var breakpoints = (0, _createBreakpoints.default)(breakpointsInput);
              var spacing = (0, _extends2.default)({}, _spacing.default, spacingInput);
              var muiTheme = (0, _extends2.default)({
                breakpoints: breakpoints,
                direction: 'ltr',
                mixins: (0, _createMixins.default)(breakpoints, spacing, mixinsInput),
                overrides: {},
                // Inject custom styles
                palette: palette,
                props: {},
                // Inject custom properties
                shadows: shadowsInput || _shadows.default,
                typography: (0, _createTypography.default)(palette, typographyInput)
              }, (0, _deepmerge.default)({
                shape: _shape.default,
                spacing: spacing,
                transitions: _transitions.default,
                zIndex: _zIndex.default
              }, other, {
                isMergeableObject: _isPlainObject.default
              }));
              return muiTheme;
            }

            var _default = createMuiTheme;
            exports.default = _default;
            });

            unwrapExports$1(createMuiTheme_1);

            var themeListener_1 = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = exports.CHANNEL = void 0;

            var _defineProperty2 = interopRequireDefault$2(defineProperty$2);

            // Same value used by react-jss
            var CHANNEL = '__THEMING__';
            exports.CHANNEL = CHANNEL;
            var themeListener = {
              contextTypes: (0, _defineProperty2.default)({}, CHANNEL, function () {}),
              initial: function initial(context) {
                if (!context[CHANNEL]) {
                  return null;
                }

                return context[CHANNEL].getState();
              },
              subscribe: function subscribe(context, cb) {
                if (!context[CHANNEL]) {
                  return null;
                }

                return context[CHANNEL].subscribe(cb);
              },
              unsubscribe: function unsubscribe(context, subscriptionId) {
                if (context[CHANNEL]) {
                  context[CHANNEL].unsubscribe(subscriptionId);
                }
              }
            };
            var _default = themeListener;
            exports.default = _default;
            });

            unwrapExports$1(themeListener_1);
            themeListener_1.CHANNEL;

            var createGenerateClassName_1 = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = createGenerateClassName;

            interopRequireDefault$2(warning_1$2);

            var escapeRegex = /([[\].#*$><+~=|^:(),"'`\s])/g;

            function safePrefix(classNamePrefix) {
              var prefix = String(classNamePrefix);

              return prefix.replace(escapeRegex, '-');
            } // Returns a function which generates unique class names based on counters.
            // When new generator function is created, rule counter is reset.
            // We need to reset the rule counter for SSR for each request.
            //
            // It's inspired by
            // https://github.com/cssinjs/jss/blob/4e6a05dd3f7b6572fdd3ab216861d9e446c20331/src/utils/createGenerateClassName.js


            function createGenerateClassName() {
              var options = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
              var _options$dangerouslyU = options.dangerouslyUseGlobalCSS,
                  dangerouslyUseGlobalCSS = _options$dangerouslyU === void 0 ? false : _options$dangerouslyU,
                  _options$productionPr = options.productionPrefix,
                  productionPrefix = _options$productionPr === void 0 ? 'jss' : _options$productionPr,
                  _options$seed = options.seed,
                  seed = _options$seed === void 0 ? '' : _options$seed;
              var ruleCounter = 0;
              return function (rule, styleSheet) {
                ruleCounter += 1;

                if (dangerouslyUseGlobalCSS && styleSheet && styleSheet.options.name) {
                  return "".concat(safePrefix(styleSheet.options.name), "-").concat(rule.key);
                }

                {
                  return "".concat(productionPrefix).concat(seed).concat(ruleCounter);
                } // Help with debuggability.
              };
            }
            });

            unwrapExports$1(createGenerateClassName_1);

            var getStylesCreator_1 = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _extends2 = interopRequireDefault$2(_extends_1);

            interopRequireDefault$2(_typeof_1$2);

            interopRequireDefault$2(warning_1$2);

            var _deepmerge = interopRequireDefault$2(umd);

            // < 1kb payload overhead when lodash/merge is > 3kb.
            // Support for the jss-expand plugin.
            function arrayMerge(destination, source) {
              return source;
            }

            function getStylesCreator(stylesOrCreator) {
              var themingEnabled = typeof stylesOrCreator === 'function';

              function create(theme, name) {
                var styles = themingEnabled ? stylesOrCreator(theme) : stylesOrCreator;

                if (!name || !theme.overrides || !theme.overrides[name]) {
                  return styles;
                }

                var overrides = theme.overrides[name];
                var stylesWithOverrides = (0, _extends2.default)({}, styles);
                Object.keys(overrides).forEach(function (key) {
                  stylesWithOverrides[key] = (0, _deepmerge.default)(stylesWithOverrides[key], overrides[key], {
                    arrayMerge: arrayMerge
                  });
                });
                return stylesWithOverrides;
              }

              return {
                create: create,
                options: {},
                themingEnabled: themingEnabled
              };
            }

            var _default = getStylesCreator;
            exports.default = _default;
            });

            unwrapExports$1(getStylesCreator_1);

            var getThemeProps_1 = createCommonjsModule$1(function (module, exports) {

            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            /* eslint-disable no-restricted-syntax */
            function getThemeProps(params) {
              var theme = params.theme,
                  name = params.name,
                  props = params.props;

              if (!theme.props || !name || !theme.props[name]) {
                return props;
              } // Resolve default props, code borrow from React source.
              // https://github.com/facebook/react/blob/15a8f031838a553e41c0b66eb1bcf1da8448104d/packages/react/src/ReactElement.js#L221


              var defaultProps = theme.props[name];
              var propName;

              for (propName in defaultProps) {
                if (props[propName] === undefined) {
                  props[propName] = defaultProps[propName];
                }
              }

              return props;
            }

            var _default = getThemeProps;
            exports.default = _default;
            });

            unwrapExports$1(getThemeProps_1);

            var withStyles = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = exports.sheetsManager = void 0;

            var _defineProperty2 = interopRequireDefault$2(defineProperty$2);

            var _extends3 = interopRequireDefault$2(_extends_1);

            var _classCallCheck2 = interopRequireDefault$2(classCallCheck);

            var _createClass2 = interopRequireDefault$2(createClass);

            var _possibleConstructorReturn2 = interopRequireDefault$2(possibleConstructorReturn);

            var _getPrototypeOf2 = interopRequireDefault$2(getPrototypeOf$1);

            var _inherits2 = interopRequireDefault$2(inherits$2);

            var _objectWithoutProperties2 = interopRequireDefault$2(objectWithoutProperties);

            var _react = interopRequireDefault$2(React);

            var _propTypes = interopRequireDefault$2(propTypes);

            interopRequireDefault$2(warning_1$2);

            var _hoistNonReactStatics = interopRequireDefault$2(hoistNonReactStatics_cjs);





            var _reactJssContext = interopRequireDefault$2(reactJssContext);

            var _jssPreset = interopRequireDefault$2(jssPreset_1);

            var _mergeClasses = interopRequireDefault$2(mergeClasses_1);

            var _multiKeyStore = interopRequireDefault$2(multiKeyStore_1);

            var _createMuiTheme = interopRequireDefault$2(createMuiTheme_1);

            var _themeListener = interopRequireDefault$2(themeListener_1);

            var _createGenerateClassName = interopRequireDefault$2(createGenerateClassName_1);

            var _getStylesCreator = interopRequireDefault$2(getStylesCreator_1);

            var _getThemeProps = interopRequireDefault$2(getThemeProps_1);

            /* eslint-disable no-underscore-dangle */
            // Default JSS instance.
            var jss = (0, lib$7.create)((0, _jssPreset.default)()); // Use a singleton or the provided one by the context.
            //
            // The counter-based approach doesn't tolerate any mistake.
            // It's much safer to use the same counter everywhere.

            var generateClassName = (0, _createGenerateClassName.default)(); // Global index counter to preserve source order.
            // We create the style sheet during at the creation of the component,
            // children are handled after the parents, so the order of style elements would be parent->child.
            // It is a problem though when a parent passes a className
            // which needs to override any child's styles.
            // StyleSheet of the child has a higher specificity, because of the source order.
            // So our solution is to render sheets them in the reverse order child->sheet, so
            // that parent has a higher specificity.

            var indexCounter = -10e10; // Exported for test purposes

            var sheetsManager = new Map(); // We use the same empty object to ref count the styles that don't need a theme object.

            exports.sheetsManager = sheetsManager;
            var noopTheme = {}; // In order to have self-supporting components, we rely on default theme when not provided.

            var defaultTheme = (0, _createMuiTheme.default)({
              typography: {
                suppressWarning: true
              }
            }); // Link a style sheet with a component.
            // It does not modify the component passed to it;
            // instead, it returns a new component, with a `classes` property.

            var withStylesOld = function withStylesOld(stylesOrCreator) {
              var options = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
              return function (Component) {
                var _extends2;

                var _options$withTheme = options.withTheme,
                    withTheme = _options$withTheme === void 0 ? false : _options$withTheme,
                    _options$flip = options.flip,
                    flip = _options$flip === void 0 ? null : _options$flip,
                    name = options.name,
                    styleSheetOptions = (0, _objectWithoutProperties2.default)(options, ["withTheme", "flip", "name"]);
                var stylesCreator = (0, _getStylesCreator.default)(stylesOrCreator);
                var listenToTheme = stylesCreator.themingEnabled || typeof name === 'string' || withTheme;
                indexCounter += 1;
                stylesCreator.options.index = indexCounter;

                var WithStyles =
                /*#__PURE__*/
                function (_React$Component) {
                  (0, _inherits2.default)(WithStyles, _React$Component);

                  function WithStyles(props, context) {
                    var _this;

                    (0, _classCallCheck2.default)(this, WithStyles);
                    _this = (0, _possibleConstructorReturn2.default)(this, (0, _getPrototypeOf2.default)(WithStyles).call(this, props, context));
                    _this.jss = context[_reactJssContext.default.jss] || jss;
                    _this.sheetsManager = sheetsManager;
                    _this.unsubscribeId = null;
                    var muiThemeProviderOptions = context.muiThemeProviderOptions;

                    if (muiThemeProviderOptions) {
                      if (muiThemeProviderOptions.sheetsManager) {
                        _this.sheetsManager = muiThemeProviderOptions.sheetsManager;
                      }

                      _this.sheetsCache = muiThemeProviderOptions.sheetsCache;
                      _this.disableStylesGeneration = muiThemeProviderOptions.disableStylesGeneration;
                    } // Attach the stylesCreator to the instance of the component as in the context
                    // of react-hot-loader the hooks can be executed in a different closure context:
                    // https://github.com/gaearon/react-hot-loader/blob/master/src/patch.dev.js#L107


                    _this.stylesCreatorSaved = stylesCreator;
                    _this.sheetOptions = (0, _extends3.default)({
                      generateClassName: generateClassName
                    }, context[_reactJssContext.default.sheetOptions]); // We use || as the function call is lazy evaluated.

                    _this.theme = listenToTheme ? _themeListener.default.initial(context) || defaultTheme : noopTheme;

                    _this.attach(_this.theme);

                    _this.cacheClasses = {
                      // Cache for the finalized classes value.
                      value: null,
                      // Cache for the last used classes prop pointer.
                      lastProp: null,
                      // Cache for the last used rendered classes pointer.
                      lastJSS: {}
                    };
                    return _this;
                  }

                  (0, _createClass2.default)(WithStyles, [{
                    key: "componentDidMount",
                    value: function componentDidMount() {
                      var _this2 = this;

                      if (!listenToTheme) {
                        return;
                      }

                      this.unsubscribeId = _themeListener.default.subscribe(this.context, function (theme) {
                        var oldTheme = _this2.theme;
                        _this2.theme = theme;

                        _this2.attach(_this2.theme); // Rerender the component so the underlying component gets the theme update.
                        // By theme update we mean receiving and applying the new class names.


                        _this2.setState({}, function () {
                          _this2.detach(oldTheme);
                        });
                      });
                    }
                  }, {
                    key: "componentDidUpdate",
                    value: function componentDidUpdate() {
                      // react-hot-loader specific logic
                      if (this.stylesCreatorSaved === stylesCreator || "production" === 'production') {
                        return;
                      }

                      this.detach(this.theme);
                      this.stylesCreatorSaved = stylesCreator;
                      this.attach(this.theme);
                      this.forceUpdate();
                    }
                  }, {
                    key: "componentWillUnmount",
                    value: function componentWillUnmount() {
                      this.detach(this.theme);

                      if (this.unsubscribeId !== null) {
                        _themeListener.default.unsubscribe(this.context, this.unsubscribeId);
                      }
                    }
                  }, {
                    key: "getClasses",
                    value: function getClasses() {
                      if (this.disableStylesGeneration) {
                        return this.props.classes || {};
                      } // Tracks if either the rendered classes or classes prop has changed,
                      // requiring the generation of a new finalized classes object.


                      var generate = false;

                      var sheetManager = _multiKeyStore.default.get(this.sheetsManager, this.stylesCreatorSaved, this.theme);

                      if (sheetManager.sheet.classes !== this.cacheClasses.lastJSS) {
                        this.cacheClasses.lastJSS = sheetManager.sheet.classes;
                        generate = true;
                      }

                      if (this.props.classes !== this.cacheClasses.lastProp) {
                        this.cacheClasses.lastProp = this.props.classes;
                        generate = true;
                      }

                      if (generate) {
                        this.cacheClasses.value = (0, _mergeClasses.default)({
                          baseClasses: this.cacheClasses.lastJSS,
                          newClasses: this.props.classes,
                          Component: Component
                        });
                      }

                      return this.cacheClasses.value;
                    }
                  }, {
                    key: "attach",
                    value: function attach(theme) {
                      if (this.disableStylesGeneration) {
                        return;
                      }

                      var stylesCreatorSaved = this.stylesCreatorSaved;

                      var sheetManager = _multiKeyStore.default.get(this.sheetsManager, stylesCreatorSaved, theme);

                      if (!sheetManager) {
                        sheetManager = {
                          refs: 0,
                          sheet: null
                        };

                        _multiKeyStore.default.set(this.sheetsManager, stylesCreatorSaved, theme, sheetManager);
                      }

                      if (sheetManager.refs === 0) {
                        var sheet;

                        if (this.sheetsCache) {
                          sheet = _multiKeyStore.default.get(this.sheetsCache, stylesCreatorSaved, theme);
                        }

                        if (!sheet) {
                          sheet = this.createSheet(theme);
                          sheet.attach();

                          if (this.sheetsCache) {
                            _multiKeyStore.default.set(this.sheetsCache, stylesCreatorSaved, theme, sheet);
                          }
                        }

                        sheetManager.sheet = sheet;
                        var sheetsRegistry = this.context[_reactJssContext.default.sheetsRegistry];

                        if (sheetsRegistry) {
                          sheetsRegistry.add(sheet);
                        }
                      }

                      sheetManager.refs += 1;
                    }
                  }, {
                    key: "createSheet",
                    value: function createSheet(theme) {
                      var styles = this.stylesCreatorSaved.create(theme, name);
                      var meta = name;

                      var sheet = this.jss.createStyleSheet(styles, (0, _extends3.default)({
                        meta: meta,
                        classNamePrefix: meta,
                        flip: typeof flip === 'boolean' ? flip : theme.direction === 'rtl',
                        link: false
                      }, this.sheetOptions, this.stylesCreatorSaved.options, {
                        name: name || Component.displayName
                      }, styleSheetOptions));
                      return sheet;
                    }
                  }, {
                    key: "detach",
                    value: function detach(theme) {
                      if (this.disableStylesGeneration) {
                        return;
                      }

                      var sheetManager = _multiKeyStore.default.get(this.sheetsManager, this.stylesCreatorSaved, theme);

                      sheetManager.refs -= 1;

                      if (sheetManager.refs === 0) {
                        _multiKeyStore.default.delete(this.sheetsManager, this.stylesCreatorSaved, theme);

                        this.jss.removeStyleSheet(sheetManager.sheet);
                        var sheetsRegistry = this.context[_reactJssContext.default.sheetsRegistry];

                        if (sheetsRegistry) {
                          sheetsRegistry.remove(sheetManager.sheet);
                        }
                      }
                    }
                  }, {
                    key: "render",
                    value: function render() {
                      var _this$props = this.props;
                          _this$props.classes;
                          var innerRef = _this$props.innerRef,
                          other = (0, _objectWithoutProperties2.default)(_this$props, ["classes", "innerRef"]);
                      var more = (0, _getThemeProps.default)({
                        theme: this.theme,
                        name: name,
                        props: other
                      }); // Provide the theme to the wrapped component.
                      // So we don't have to use the `withTheme()` Higher-order Component.

                      if (withTheme && !more.theme) {
                        more.theme = this.theme;
                      }

                      return _react.default.createElement(Component, (0, _extends3.default)({}, more, {
                        classes: this.getClasses(),
                        ref: innerRef
                      }));
                    }
                  }]);
                  return WithStyles;
                }(_react.default.Component);
                WithStyles.contextTypes = (0, _extends3.default)((_extends2 = {
                  muiThemeProviderOptions: _propTypes.default.object
                }, (0, _defineProperty2.default)(_extends2, _reactJssContext.default.jss, _propTypes.default.object), (0, _defineProperty2.default)(_extends2, _reactJssContext.default.sheetOptions, _propTypes.default.object), (0, _defineProperty2.default)(_extends2, _reactJssContext.default.sheetsRegistry, _propTypes.default.object), _extends2), listenToTheme ? _themeListener.default.contextTypes : {});

                (0, _hoistNonReactStatics.default)(WithStyles, Component);

                return WithStyles;
              };
            };
            /* istanbul ignore if */


            if (!index_es.ponyfillGlobal.__MUI_STYLES__) {
              index_es.ponyfillGlobal.__MUI_STYLES__ = {};
            }

            if (!index_es.ponyfillGlobal.__MUI_STYLES__.withStyles) {
              index_es.ponyfillGlobal.__MUI_STYLES__.withStyles = withStylesOld;
            }

            var _default = function _default(styles, options) {
              return index_es.ponyfillGlobal.__MUI_STYLES__.withStyles(styles, (0, _extends3.default)({
                defaultTheme: defaultTheme
              }, options));
            };

            exports.default = _default;
            });

            unwrapExports$1(withStyles);
            withStyles.sheetsManager;

            var helpers = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.capitalize = capitalize;
            exports.contains = contains;
            exports.findIndex = findIndex;
            exports.find = find;
            exports.createChainedFunction = createChainedFunction;

            var _typeof2 = interopRequireDefault$2(_typeof_1$2);

            interopRequireDefault$2(warning_1$2);

            // It should to be noted that this function isn't equivalent to `text-transform: capitalize`.
            //
            // A strict capitalization should uppercase the first letter of each word a the sentence.
            // We only handle the first word.
            function capitalize(string) {

              return string.charAt(0).toUpperCase() + string.slice(1);
            }

            function contains(obj, pred) {
              return Object.keys(pred).every(function (key) {
                return obj.hasOwnProperty(key) && obj[key] === pred[key];
              });
            }

            function findIndex(arr, pred) {
              var predType = (0, _typeof2.default)(pred);

              for (var i = 0; i < arr.length; i += 1) {
                if (predType === 'function' && !!pred(arr[i], i, arr) === true) {
                  return i;
                }

                if (predType === 'object' && contains(arr[i], pred)) {
                  return i;
                }

                if (['string', 'number', 'boolean'].indexOf(predType) !== -1) {
                  return arr.indexOf(pred);
                }
              }

              return -1;
            }

            function find(arr, pred) {
              var index = findIndex(arr, pred);
              return index > -1 ? arr[index] : undefined;
            }
            /**
             * Safe chained function
             *
             * Will only create a new function if needed,
             * otherwise will pass back existing functions or null.
             *
             * @param {function} functions to chain
             * @returns {function|null}
             */


            function createChainedFunction() {
              for (var _len = arguments.length, funcs = new Array(_len), _key = 0; _key < _len; _key++) {
                funcs[_key] = arguments[_key];
              }

              return funcs.reduce(function (acc, func) {
                if (func == null) {
                  return acc;
                }
                return function chainedFunction() {
                  for (var _len2 = arguments.length, args = new Array(_len2), _key2 = 0; _key2 < _len2; _key2++) {
                    args[_key2] = arguments[_key2];
                  }

                  acc.apply(this, args);
                  func.apply(this, args);
                };
              }, function () {});
            }
            });

            unwrapExports$1(helpers);
            helpers.capitalize;
            helpers.contains;
            helpers.findIndex;
            helpers.find;
            helpers.createChainedFunction;

            var SvgIcon_1 = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = exports.styles = void 0;

            var _extends2 = interopRequireDefault$2(_extends_1);

            var _defineProperty2 = interopRequireDefault$2(defineProperty$2);

            var _objectWithoutProperties2 = interopRequireDefault$2(objectWithoutProperties);

            var _react = interopRequireDefault$2(React);

            interopRequireDefault$2(propTypes);

            var _classnames = interopRequireDefault$2(classnames);



            var _withStyles = interopRequireDefault$2(withStyles);



            var styles = function styles(theme) {
              return {
                /* Styles applied to the root element. */
                root: {
                  userSelect: 'none',
                  width: '1em',
                  height: '1em',
                  display: 'inline-block',
                  fill: 'currentColor',
                  flexShrink: 0,
                  fontSize: 24,
                  transition: theme.transitions.create('fill', {
                    duration: theme.transitions.duration.shorter
                  })
                },

                /* Styles applied to the root element if `color="primary"`. */
                colorPrimary: {
                  color: theme.palette.primary.main
                },

                /* Styles applied to the root element if `color="secondary"`. */
                colorSecondary: {
                  color: theme.palette.secondary.main
                },

                /* Styles applied to the root element if `color="action"`. */
                colorAction: {
                  color: theme.palette.action.active
                },

                /* Styles applied to the root element if `color="error"`. */
                colorError: {
                  color: theme.palette.error.main
                },

                /* Styles applied to the root element if `color="disabled"`. */
                colorDisabled: {
                  color: theme.palette.action.disabled
                },

                /* Styles applied to the root element if `fontSize="inherit"`. */
                fontSizeInherit: {
                  fontSize: 'inherit'
                },

                /* Styles applied to the root element if `fontSize="small"`. */
                fontSizeSmall: {
                  fontSize: 20
                },

                /* Styles applied to the root element if `fontSize="large"`. */
                fontSizeLarge: {
                  fontSize: 35
                }
              };
            };

            exports.styles = styles;

            function SvgIcon(props) {
              var _classNames;

              var children = props.children,
                  classes = props.classes,
                  className = props.className,
                  color = props.color,
                  Component = props.component,
                  fontSize = props.fontSize,
                  nativeColor = props.nativeColor,
                  titleAccess = props.titleAccess,
                  viewBox = props.viewBox,
                  other = (0, _objectWithoutProperties2.default)(props, ["children", "classes", "className", "color", "component", "fontSize", "nativeColor", "titleAccess", "viewBox"]);
              return _react.default.createElement(Component, (0, _extends2.default)({
                className: (0, _classnames.default)(classes.root, (_classNames = {}, (0, _defineProperty2.default)(_classNames, classes["color".concat((0, helpers.capitalize)(color))], color !== 'inherit'), (0, _defineProperty2.default)(_classNames, classes["fontSize".concat((0, helpers.capitalize)(fontSize))], fontSize !== 'default'), _classNames), className),
                focusable: "false",
                viewBox: viewBox,
                color: nativeColor,
                "aria-hidden": titleAccess ? 'false' : 'true',
                role: titleAccess ? 'img' : 'presentation'
              }, other), children, titleAccess ? _react.default.createElement("title", null, titleAccess) : null);
            }
            SvgIcon.defaultProps = {
              color: 'inherit',
              component: 'svg',
              fontSize: 'default',
              viewBox: '0 0 24 24'
            };
            SvgIcon.muiName = 'SvgIcon';

            var _default = (0, _withStyles.default)(styles, {
              name: 'MuiSvgIcon'
            })(SvgIcon);

            exports.default = _default;
            });

            unwrapExports$1(SvgIcon_1);
            SvgIcon_1.styles;

            var SvgIcon = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            Object.defineProperty(exports, "default", {
              enumerable: true,
              get: function get() {
                return _SvgIcon.default;
              }
            });

            var _SvgIcon = interopRequireDefault$2(SvgIcon_1);
            });

            unwrapExports$1(SvgIcon);

            var createSvgIcon_1 = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _pure = interopRequireDefault$1(pure_1);

            var _SvgIcon = interopRequireDefault$1(SvgIcon);

            function createSvgIcon(path, displayName) {
              var Icon = function Icon(props) {
                return _react.default.createElement(_SvgIcon.default, props, path);
              };

              Icon.displayName = displayName;
              Icon = (0, _pure.default)(Icon);
              Icon.muiName = 'SvgIcon';
              return Icon;
            }
            var _default = createSvgIcon;
            exports.default = _default;
            });

            unwrapExports$1(createSvgIcon_1);

            var AccessAlarm = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M22 5.72l-4.6-3.86-1.29 1.53 4.6 3.86L22 5.72zM7.88 3.39L6.6 1.86 2 5.71l1.29 1.53 4.59-3.85zM12.5 8H11v6l4.75 2.85.75-1.23-4-2.37V8zM12 4c-4.97 0-9 4.03-9 9s4.02 9 9 9c4.97 0 9-4.03 9-9s-4.03-9-9-9zm0 16c-3.87 0-7-3.13-7-7s3.13-7 7-7 7 3.13 7 7-3.13 7-7 7z"
            })), 'AccessAlarm');

            exports.default = _default;
            });

            unwrapExports$1(AccessAlarm);

            var AccessAlarms = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M22 5.7l-4.6-3.9-1.3 1.5 4.6 3.9L22 5.7zM7.9 3.4L6.6 1.9 2 5.7l1.3 1.5 4.6-3.8zM12.5 8H11v6l4.7 2.9.8-1.2-4-2.4V8zM12 4c-5 0-9 4-9 9s4 9 9 9 9-4 9-9-4-9-9-9zm0 16c-3.9 0-7-3.1-7-7s3.1-7 7-7 7 3.1 7 7-3.1 7-7 7z"
            })), 'AccessAlarms');

            exports.default = _default;
            });

            unwrapExports$1(AccessAlarms);

            var Accessibility = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M12 2c1.1 0 2 .9 2 2s-.9 2-2 2-2-.9-2-2 .9-2 2-2zm9 7h-6v13h-2v-6h-2v6H9V9H3V7h18v2z"
            })), 'Accessibility');

            exports.default = _default;
            });

            unwrapExports$1(Accessibility);

            var Accessible = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("circle", {
              cx: "12",
              cy: "4",
              r: "2"
            }), _react.default.createElement("path", {
              d: "M19 13v-2c-1.54.02-3.09-.75-4.07-1.83l-1.29-1.43c-.17-.19-.38-.34-.61-.45-.01 0-.01-.01-.02-.01H13c-.35-.2-.75-.3-1.19-.26C10.76 7.11 10 8.04 10 9.09V15c0 1.1.9 2 2 2h5v5h2v-5.5c0-1.1-.9-2-2-2h-3v-3.45c1.29 1.07 3.25 1.94 5 1.95zm-6.17 5c-.41 1.16-1.52 2-2.83 2-1.66 0-3-1.34-3-3 0-1.31.84-2.41 2-2.83V12.1c-2.28.46-4 2.48-4 4.9 0 2.76 2.24 5 5 5 2.42 0 4.44-1.72 4.9-4h-2.07z"
            })), 'Accessible');

            exports.default = _default;
            });

            unwrapExports$1(Accessible);

            var AccessTime = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M11.99 2C6.47 2 2 6.48 2 12s4.47 10 9.99 10C17.52 22 22 17.52 22 12S17.52 2 11.99 2zM12 20c-4.42 0-8-3.58-8-8s3.58-8 8-8 8 3.58 8 8-3.58 8-8 8zm.5-13H11v6l5.25 3.15.75-1.23-4.5-2.67z"
            })), 'AccessTime');

            exports.default = _default;
            });

            unwrapExports$1(AccessTime);

            var AccountBalance = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M4 10v7h3v-7H4zm6 0v7h3v-7h-3zM2 22h19v-3H2v3zm14-12v7h3v-7h-3zm-4.5-9L2 6v2h19V6l-9.5-5z"
            })), 'AccountBalance');

            exports.default = _default;
            });

            unwrapExports$1(AccountBalance);

            var AccountBalanceWallet = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M21 18v1c0 1.1-.9 2-2 2H5c-1.11 0-2-.9-2-2V5c0-1.1.89-2 2-2h14c1.1 0 2 .9 2 2v1h-9c-1.11 0-2 .9-2 2v8c0 1.1.89 2 2 2h9zm-9-2h10V8H12v8zm4-2.5c-.83 0-1.5-.67-1.5-1.5s.67-1.5 1.5-1.5 1.5.67 1.5 1.5-.67 1.5-1.5 1.5z"
            })), 'AccountBalanceWallet');

            exports.default = _default;
            });

            unwrapExports$1(AccountBalanceWallet);

            var AccountBox = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M3 5v14c0 1.1.89 2 2 2h14c1.1 0 2-.9 2-2V5c0-1.1-.9-2-2-2H5c-1.11 0-2 .9-2 2zm12 4c0 1.66-1.34 3-3 3s-3-1.34-3-3 1.34-3 3-3 3 1.34 3 3zm-9 8c0-2 4-3.1 6-3.1s6 1.1 6 3.1v1H6v-1z"
            })), 'AccountBox');

            exports.default = _default;
            });

            unwrapExports$1(AccountBox);

            var AccountCircle = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M12 2C6.48 2 2 6.48 2 12s4.48 10 10 10 10-4.48 10-10S17.52 2 12 2zm0 3c1.66 0 3 1.34 3 3s-1.34 3-3 3-3-1.34-3-3 1.34-3 3-3zm0 14.2c-2.5 0-4.71-1.28-6-3.22.03-1.99 4-3.08 6-3.08 1.99 0 5.97 1.09 6 3.08-1.29 1.94-3.5 3.22-6 3.22z"
            })), 'AccountCircle');

            exports.default = _default;
            });

            unwrapExports$1(AccountCircle);

            var AcUnit = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M22 11h-4.17l3.24-3.24-1.41-1.42L15 11h-2V9l4.66-4.66-1.42-1.41L13 6.17V2h-2v4.17L7.76 2.93 6.34 4.34 11 9v2H9L4.34 6.34 2.93 7.76 6.17 11H2v2h4.17l-3.24 3.24 1.41 1.42L9 13h2v2l-4.66 4.66 1.42 1.41L11 17.83V22h2v-4.17l3.24 3.24 1.42-1.41L13 15v-2h2l4.66 4.66 1.41-1.42L17.83 13H22z"
            })), 'AcUnit');

            exports.default = _default;
            });

            unwrapExports$1(AcUnit);

            var Adb = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M5 16c0 3.87 3.13 7 7 7s7-3.13 7-7v-4H5v4zM16.12 4.37l2.1-2.1-.82-.83-2.3 2.31C14.16 3.28 13.12 3 12 3s-2.16.28-3.09.75L6.6 1.44l-.82.83 2.1 2.1C6.14 5.64 5 7.68 5 10v1h14v-1c0-2.32-1.14-4.36-2.88-5.63zM9 9c-.55 0-1-.45-1-1s.45-1 1-1 1 .45 1 1-.45 1-1 1zm6 0c-.55 0-1-.45-1-1s.45-1 1-1 1 .45 1 1-.45 1-1 1z"
            })), 'Adb');

            exports.default = _default;
            });

            unwrapExports$1(Adb);

            var Add = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M19 13h-6v6h-2v-6H5v-2h6V5h2v6h6v2z"
            })), 'Add');

            exports.default = _default;
            });

            unwrapExports$1(Add);

            var AddAlarm = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M7.88 3.39L6.6 1.86 2 5.71l1.29 1.53 4.59-3.85zM22 5.72l-4.6-3.86-1.29 1.53 4.6 3.86L22 5.72zM12 4c-4.97 0-9 4.03-9 9s4.02 9 9 9c4.97 0 9-4.03 9-9s-4.03-9-9-9zm0 16c-3.87 0-7-3.13-7-7s3.13-7 7-7 7 3.13 7 7-3.13 7-7 7zm1-11h-2v3H8v2h3v3h2v-3h3v-2h-3V9z"
            })), 'AddAlarm');

            exports.default = _default;
            });

            unwrapExports$1(AddAlarm);

            var AddAlert = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M10.01 21.01c0 1.1.89 1.99 1.99 1.99s1.99-.89 1.99-1.99h-3.98zm8.87-4.19V11c0-3.25-2.25-5.97-5.29-6.69v-.72C13.59 2.71 12.88 2 12 2s-1.59.71-1.59 1.59v.72C7.37 5.03 5.12 7.75 5.12 11v5.82L3 18.94V20h18v-1.06l-2.12-2.12zM16 13.01h-3v3h-2v-3H8V11h3V8h2v3h3v2.01z"
            })), 'AddAlert');

            exports.default = _default;
            });

            unwrapExports$1(AddAlert);

            var AddAPhoto = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M3 4V1h2v3h3v2H5v3H3V6H0V4h3zm3 6V7h3V4h7l1.83 2H21c1.1 0 2 .9 2 2v12c0 1.1-.9 2-2 2H5c-1.1 0-2-.9-2-2V10h3zm7 9c2.76 0 5-2.24 5-5s-2.24-5-5-5-5 2.24-5 5 2.24 5 5 5zm-3.2-5c0 1.77 1.43 3.2 3.2 3.2s3.2-1.43 3.2-3.2-1.43-3.2-3.2-3.2-3.2 1.43-3.2 3.2z"
            })), 'AddAPhoto');

            exports.default = _default;
            });

            unwrapExports$1(AddAPhoto);

            var AddBox = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M19 3H5c-1.11 0-2 .9-2 2v14c0 1.1.89 2 2 2h14c1.1 0 2-.9 2-2V5c0-1.1-.9-2-2-2zm-2 10h-4v4h-2v-4H7v-2h4V7h2v4h4v2z"
            })), 'AddBox');

            exports.default = _default;
            });

            unwrapExports$1(AddBox);

            var AddCircle = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M12 2C6.48 2 2 6.48 2 12s4.48 10 10 10 10-4.48 10-10S17.52 2 12 2zm5 11h-4v4h-2v-4H7v-2h4V7h2v4h4v2z"
            })), 'AddCircle');

            exports.default = _default;
            });

            unwrapExports$1(AddCircle);

            var AddCircleOutline = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M13 7h-2v4H7v2h4v4h2v-4h4v-2h-4V7zm-1-5C6.48 2 2 6.48 2 12s4.48 10 10 10 10-4.48 10-10S17.52 2 12 2zm0 18c-4.41 0-8-3.59-8-8s3.59-8 8-8 8 3.59 8 8-3.59 8-8 8z"
            })), 'AddCircleOutline');

            exports.default = _default;
            });

            unwrapExports$1(AddCircleOutline);

            var AddLocation = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M12 2C8.14 2 5 5.14 5 9c0 5.25 7 13 7 13s7-7.75 7-13c0-3.86-3.14-7-7-7zm4 8h-3v3h-2v-3H8V8h3V5h2v3h3v2z"
            })), 'AddLocation');

            exports.default = _default;
            });

            unwrapExports$1(AddLocation);

            var AddShoppingCart = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M11 9h2V6h3V4h-3V1h-2v3H8v2h3v3zm-4 9c-1.1 0-1.99.9-1.99 2S5.9 22 7 22s2-.9 2-2-.9-2-2-2zm10 0c-1.1 0-1.99.9-1.99 2s.89 2 1.99 2 2-.9 2-2-.9-2-2-2zm-9.83-3.25l.03-.12.9-1.63h7.45c.75 0 1.41-.41 1.75-1.03l3.86-7.01L19.42 4h-.01l-1.1 2-2.76 5H8.53l-.13-.27L6.16 6l-.95-2-.94-2H1v2h2l3.6 7.59-1.35 2.45c-.16.28-.25.61-.25.96 0 1.1.9 2 2 2h12v-2H7.42c-.13 0-.25-.11-.25-.25z"
            })), 'AddShoppingCart');

            exports.default = _default;
            });

            unwrapExports$1(AddShoppingCart);

            var AddToPhotos = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M4 6H2v14c0 1.1.9 2 2 2h14v-2H4V6zm16-4H8c-1.1 0-2 .9-2 2v12c0 1.1.9 2 2 2h12c1.1 0 2-.9 2-2V4c0-1.1-.9-2-2-2zm-1 9h-4v4h-2v-4H9V9h4V5h2v4h4v2z"
            })), 'AddToPhotos');

            exports.default = _default;
            });

            unwrapExports$1(AddToPhotos);

            var AddToQueue = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M21 3H3c-1.11 0-2 .89-2 2v12c0 1.1.89 2 2 2h5v2h8v-2h5c1.1 0 1.99-.9 1.99-2L23 5c0-1.11-.9-2-2-2zm0 14H3V5h18v12zm-5-7v2h-3v3h-2v-3H8v-2h3V7h2v3h3z"
            })), 'AddToQueue');

            exports.default = _default;
            });

            unwrapExports$1(AddToQueue);

            var Adjust = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M12 2C6.49 2 2 6.49 2 12s4.49 10 10 10 10-4.49 10-10S17.51 2 12 2zm0 18c-4.41 0-8-3.59-8-8s3.59-8 8-8 8 3.59 8 8-3.59 8-8 8zm3-8c0 1.66-1.34 3-3 3s-3-1.34-3-3 1.34-3 3-3 3 1.34 3 3z"
            })), 'Adjust');

            exports.default = _default;
            });

            unwrapExports$1(Adjust);

            var AirlineSeatFlat = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M22 11v2H9V7h9c2.21 0 4 1.79 4 4zM2 14v2h6v2h8v-2h6v-2H2zm5.14-1.9c1.16-1.19 1.14-3.08-.04-4.24-1.19-1.16-3.08-1.14-4.24.04-1.16 1.19-1.14 3.08.04 4.24 1.19 1.16 3.08 1.14 4.24-.04z"
            })), 'AirlineSeatFlat');

            exports.default = _default;
            });

            unwrapExports$1(AirlineSeatFlat);

            var AirlineSeatFlatAngled = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M22.25 14.29l-.69 1.89L9.2 11.71l2.08-5.66 8.56 3.09c2.1.76 3.18 3.06 2.41 5.15zM1.5 12.14L8 14.48V19h8v-1.63L20.52 19l.69-1.89-19.02-6.86-.69 1.89zm5.8-1.94c1.49-.72 2.12-2.51 1.41-4C7.99 4.71 6.2 4.08 4.7 4.8c-1.49.71-2.12 2.5-1.4 4 .71 1.49 2.5 2.12 4 1.4z"
            })), 'AirlineSeatFlatAngled');

            exports.default = _default;
            });

            unwrapExports$1(AirlineSeatFlatAngled);

            var AirlineSeatIndividualSuite = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M7 13c1.65 0 3-1.35 3-3S8.65 7 7 7s-3 1.35-3 3 1.35 3 3 3zm12-6h-8v7H3V7H1v10h22v-6c0-2.21-1.79-4-4-4z"
            })), 'AirlineSeatIndividualSuite');

            exports.default = _default;
            });

            unwrapExports$1(AirlineSeatIndividualSuite);

            var AirlineSeatLegroomExtra = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M4 12V3H2v9c0 2.76 2.24 5 5 5h6v-2H7c-1.66 0-3-1.34-3-3zm18.83 5.24c-.38-.72-1.29-.97-2.03-.63l-1.09.5-3.41-6.98c-.34-.68-1.03-1.12-1.79-1.12L11 9V3H5v8c0 1.66 1.34 3 3 3h7l3.41 7 3.72-1.7c.77-.36 1.1-1.3.7-2.06z"
            })), 'AirlineSeatLegroomExtra');

            exports.default = _default;
            });

            unwrapExports$1(AirlineSeatLegroomExtra);

            var AirlineSeatLegroomNormal = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M5 12V3H3v9c0 2.76 2.24 5 5 5h6v-2H8c-1.66 0-3-1.34-3-3zm15.5 6H19v-7c0-1.1-.9-2-2-2h-5V3H6v8c0 1.65 1.35 3 3 3h7v7h4.5c.83 0 1.5-.67 1.5-1.5s-.67-1.5-1.5-1.5z"
            })), 'AirlineSeatLegroomNormal');

            exports.default = _default;
            });

            unwrapExports$1(AirlineSeatLegroomNormal);

            var AirlineSeatLegroomReduced = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M19.97 19.2c.18.96-.55 1.8-1.47 1.8H14v-3l1-4H9c-1.65 0-3-1.35-3-3V3h6v6h5c1.1 0 2 .9 2 2l-2 7h1.44c.73 0 1.39.49 1.53 1.2zM5 12V3H3v9c0 2.76 2.24 5 5 5h4v-2H8c-1.66 0-3-1.34-3-3z"
            })), 'AirlineSeatLegroomReduced');

            exports.default = _default;
            });

            unwrapExports$1(AirlineSeatLegroomReduced);

            var AirlineSeatReclineExtra = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M5.35 5.64c-.9-.64-1.12-1.88-.49-2.79.63-.9 1.88-1.12 2.79-.49.9.64 1.12 1.88.49 2.79-.64.9-1.88 1.12-2.79.49zM16 19H8.93c-1.48 0-2.74-1.08-2.96-2.54L4 7H2l1.99 9.76C4.37 19.2 6.47 21 8.94 21H16v-2zm.23-4h-4.88l-1.03-4.1c1.58.89 3.28 1.54 5.15 1.22V9.99c-1.63.31-3.44-.27-4.69-1.25L9.14 7.47c-.23-.18-.49-.3-.76-.38-.32-.09-.66-.12-.99-.06h-.02c-1.23.22-2.05 1.39-1.84 2.61l1.35 5.92C7.16 16.98 8.39 18 9.83 18h6.85l3.82 3 1.5-1.5-5.77-4.5z"
            })), 'AirlineSeatReclineExtra');

            exports.default = _default;
            });

            unwrapExports$1(AirlineSeatReclineExtra);

            var AirlineSeatReclineNormal = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M7.59 5.41c-.78-.78-.78-2.05 0-2.83.78-.78 2.05-.78 2.83 0 .78.78.78 2.05 0 2.83-.79.79-2.05.79-2.83 0zM6 16V7H4v9c0 2.76 2.24 5 5 5h6v-2H9c-1.66 0-3-1.34-3-3zm14 4.07L14.93 15H11.5v-3.68c1.4 1.15 3.6 2.16 5.5 2.16v-2.16c-1.66.02-3.61-.87-4.67-2.04l-1.4-1.55c-.19-.21-.43-.38-.69-.5-.29-.14-.62-.23-.96-.23h-.03C8.01 7 7 8.01 7 9.25V15c0 1.66 1.34 3 3 3h5.07l3.5 3.5L20 20.07z"
            })), 'AirlineSeatReclineNormal');

            exports.default = _default;
            });

            unwrapExports$1(AirlineSeatReclineNormal);

            var AirplanemodeActive = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M10.18 9"
            }), _react.default.createElement("path", {
              d: "M21 16v-2l-8-5V3.5c0-.83-.67-1.5-1.5-1.5S10 2.67 10 3.5V9l-8 5v2l8-2.5V19l-2 1.5V22l3.5-1 3.5 1v-1.5L13 19v-5.5l8 2.5z"
            })), 'AirplanemodeActive');

            exports.default = _default;
            });

            unwrapExports$1(AirplanemodeActive);

            var AirplanemodeInactive = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M13 9V3.5c0-.83-.67-1.5-1.5-1.5S10 2.67 10 3.5v3.68l7.83 7.83L21 16v-2l-8-5zM3 5.27l4.99 4.99L2 14v2l8-2.5V19l-2 1.5V22l3.5-1 3.5 1v-1.5L13 19v-3.73L18.73 21 20 19.73 4.27 4 3 5.27z"
            })), 'AirplanemodeInactive');

            exports.default = _default;
            });

            unwrapExports$1(AirplanemodeInactive);

            var Airplay = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M6 22h12l-6-6zM21 3H3c-1.1 0-2 .9-2 2v12c0 1.1.9 2 2 2h4v-2H3V5h18v12h-4v2h4c1.1 0 2-.9 2-2V5c0-1.1-.9-2-2-2z"
            })), 'Airplay');

            exports.default = _default;
            });

            unwrapExports$1(Airplay);

            var AirportShuttle = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M17 5H3c-1.1 0-2 .89-2 2v9h2c0 1.65 1.34 3 3 3s3-1.35 3-3h5.5c0 1.65 1.34 3 3 3s3-1.35 3-3H23v-5l-6-6zM3 11V7h4v4H3zm3 6.5c-.83 0-1.5-.67-1.5-1.5s.67-1.5 1.5-1.5 1.5.67 1.5 1.5-.67 1.5-1.5 1.5zm7-6.5H9V7h4v4zm4.5 6.5c-.83 0-1.5-.67-1.5-1.5s.67-1.5 1.5-1.5 1.5.67 1.5 1.5-.67 1.5-1.5 1.5zM15 11V7h1l4 4h-5z"
            })), 'AirportShuttle');

            exports.default = _default;
            });

            unwrapExports$1(AirportShuttle);

            var Alarm = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M22 5.72l-4.6-3.86-1.29 1.53 4.6 3.86L22 5.72zM7.88 3.39L6.6 1.86 2 5.71l1.29 1.53 4.59-3.85zM12.5 8H11v6l4.75 2.85.75-1.23-4-2.37V8zM12 4c-4.97 0-9 4.03-9 9s4.02 9 9 9c4.97 0 9-4.03 9-9s-4.03-9-9-9zm0 16c-3.87 0-7-3.13-7-7s3.13-7 7-7 7 3.13 7 7-3.13 7-7 7z"
            })), 'Alarm');

            exports.default = _default;
            });

            unwrapExports$1(Alarm);

            var AlarmAdd = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M7.88 3.39L6.6 1.86 2 5.71l1.29 1.53 4.59-3.85zM22 5.72l-4.6-3.86-1.29 1.53 4.6 3.86L22 5.72zM12 4c-4.97 0-9 4.03-9 9s4.02 9 9 9c4.97 0 9-4.03 9-9s-4.03-9-9-9zm0 16c-3.87 0-7-3.13-7-7s3.13-7 7-7 7 3.13 7 7-3.13 7-7 7zm1-11h-2v3H8v2h3v3h2v-3h3v-2h-3V9z"
            })), 'AlarmAdd');

            exports.default = _default;
            });

            unwrapExports$1(AlarmAdd);

            var AlarmOff = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M12 6c3.87 0 7 3.13 7 7 0 .84-.16 1.65-.43 2.4l1.52 1.52c.58-1.19.91-2.51.91-3.92 0-4.97-4.03-9-9-9-1.41 0-2.73.33-3.92.91L9.6 6.43C10.35 6.16 11.16 6 12 6zm10-.28l-4.6-3.86-1.29 1.53 4.6 3.86L22 5.72zM2.92 2.29L1.65 3.57 2.98 4.9l-1.11.93 1.42 1.42 1.11-.94.8.8C3.83 8.69 3 10.75 3 13c0 4.97 4.02 9 9 9 2.25 0 4.31-.83 5.89-2.2l2.2 2.2 1.27-1.27L3.89 3.27l-.97-.98zm13.55 16.1C15.26 19.39 13.7 20 12 20c-3.87 0-7-3.13-7-7 0-1.7.61-3.26 1.61-4.47l9.86 9.86zM8.02 3.28L6.6 1.86l-.86.71 1.42 1.42.86-.71z"
            })), 'AlarmOff');

            exports.default = _default;
            });

            unwrapExports$1(AlarmOff);

            var AlarmOn = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M22 5.72l-4.6-3.86-1.29 1.53 4.6 3.86L22 5.72zM7.88 3.39L6.6 1.86 2 5.71l1.29 1.53 4.59-3.85zM12 4c-4.97 0-9 4.03-9 9s4.02 9 9 9c4.97 0 9-4.03 9-9s-4.03-9-9-9zm0 16c-3.87 0-7-3.13-7-7s3.13-7 7-7 7 3.13 7 7-3.13 7-7 7zm-1.46-5.47L8.41 12.4l-1.06 1.06 3.18 3.18 6-6-1.06-1.06-4.93 4.95z"
            })), 'AlarmOn');

            exports.default = _default;
            });

            unwrapExports$1(AlarmOn);

            var Album = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M12 2C6.48 2 2 6.48 2 12s4.48 10 10 10 10-4.48 10-10S17.52 2 12 2zm0 14.5c-2.49 0-4.5-2.01-4.5-4.5S9.51 7.5 12 7.5s4.5 2.01 4.5 4.5-2.01 4.5-4.5 4.5zm0-5.5c-.55 0-1 .45-1 1s.45 1 1 1 1-.45 1-1-.45-1-1-1z"
            })), 'Album');

            exports.default = _default;
            });

            unwrapExports$1(Album);

            var AllInclusive = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M18.6 6.62c-1.44 0-2.8.56-3.77 1.53L12 10.66 10.48 12h.01L7.8 14.39c-.64.64-1.49.99-2.4.99-1.87 0-3.39-1.51-3.39-3.38S3.53 8.62 5.4 8.62c.91 0 1.76.35 2.44 1.03l1.13 1 1.51-1.34L9.22 8.2C8.2 7.18 6.84 6.62 5.4 6.62 2.42 6.62 0 9.04 0 12s2.42 5.38 5.4 5.38c1.44 0 2.8-.56 3.77-1.53l2.83-2.5.01.01L13.52 12h-.01l2.69-2.39c.64-.64 1.49-.99 2.4-.99 1.87 0 3.39 1.51 3.39 3.38s-1.52 3.38-3.39 3.38c-.9 0-1.76-.35-2.44-1.03l-1.14-1.01-1.51 1.34 1.27 1.12c1.02 1.01 2.37 1.57 3.82 1.57 2.98 0 5.4-2.41 5.4-5.38s-2.42-5.37-5.4-5.37z"
            })), 'AllInclusive');

            exports.default = _default;
            });

            unwrapExports$1(AllInclusive);

            var AllOut = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M16.21 4.16l4 4v-4zm4 12l-4 4h4zm-12 4l-4-4v4zm-4-12l4-4h-4zm12.95-.95c-2.73-2.73-7.17-2.73-9.9 0s-2.73 7.17 0 9.9 7.17 2.73 9.9 0 2.73-7.16 0-9.9zm-1.1 8.8c-2.13 2.13-5.57 2.13-7.7 0s-2.13-5.57 0-7.7 5.57-2.13 7.7 0 2.13 5.57 0 7.7z"
            })), 'AllOut');

            exports.default = _default;
            });

            unwrapExports$1(AllOut);

            var Android = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M6 18c0 .55.45 1 1 1h1v3.5c0 .83.67 1.5 1.5 1.5s1.5-.67 1.5-1.5V19h2v3.5c0 .83.67 1.5 1.5 1.5s1.5-.67 1.5-1.5V19h1c.55 0 1-.45 1-1V8H6v10zM3.5 8C2.67 8 2 8.67 2 9.5v7c0 .83.67 1.5 1.5 1.5S5 17.33 5 16.5v-7C5 8.67 4.33 8 3.5 8zm17 0c-.83 0-1.5.67-1.5 1.5v7c0 .83.67 1.5 1.5 1.5s1.5-.67 1.5-1.5v-7c0-.83-.67-1.5-1.5-1.5zm-4.97-5.84l1.3-1.3c.2-.2.2-.51 0-.71-.2-.2-.51-.2-.71 0l-1.48 1.48C13.85 1.23 12.95 1 12 1c-.96 0-1.86.23-2.66.63L7.85.15c-.2-.2-.51-.2-.71 0-.2.2-.2.51 0 .71l1.31 1.31C6.97 3.26 6 5.01 6 7h12c0-1.99-.97-3.75-2.47-4.84zM10 5H9V4h1v1zm5 0h-1V4h1v1z"
            })), 'Android');

            exports.default = _default;
            });

            unwrapExports$1(Android);

            var Announcement = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M20 2H4c-1.1 0-1.99.9-1.99 2L2 22l4-4h14c1.1 0 2-.9 2-2V4c0-1.1-.9-2-2-2zm-7 9h-2V5h2v6zm0 4h-2v-2h2v2z"
            })), 'Announcement');

            exports.default = _default;
            });

            unwrapExports$1(Announcement);

            var Apps = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M4 8h4V4H4v4zm6 12h4v-4h-4v4zm-6 0h4v-4H4v4zm0-6h4v-4H4v4zm6 0h4v-4h-4v4zm6-10v4h4V4h-4zm-6 4h4V4h-4v4zm6 6h4v-4h-4v4zm0 6h4v-4h-4v4z"
            })), 'Apps');

            exports.default = _default;
            });

            unwrapExports$1(Apps);

            var Archive = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M20.54 5.23l-1.39-1.68C18.88 3.21 18.47 3 18 3H6c-.47 0-.88.21-1.16.55L3.46 5.23C3.17 5.57 3 6.02 3 6.5V19c0 1.1.9 2 2 2h14c1.1 0 2-.9 2-2V6.5c0-.48-.17-.93-.46-1.27zM12 17.5L6.5 12H10v-2h4v2h3.5L12 17.5zM5.12 5l.81-1h12l.94 1H5.12z"
            })), 'Archive');

            exports.default = _default;
            });

            unwrapExports$1(Archive);

            var ArrowBack = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M20 11H7.83l5.59-5.59L12 4l-8 8 8 8 1.41-1.41L7.83 13H20v-2z"
            })), 'ArrowBack');

            exports.default = _default;
            });

            unwrapExports$1(ArrowBack);

            var ArrowDownward = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M20 12l-1.41-1.41L13 16.17V4h-2v12.17l-5.58-5.59L4 12l8 8 8-8z"
            })), 'ArrowDownward');

            exports.default = _default;
            });

            unwrapExports$1(ArrowDownward);

            var ArrowDropDown = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M7 10l5 5 5-5z"
            })), 'ArrowDropDown');

            exports.default = _default;
            });

            unwrapExports$1(ArrowDropDown);

            var ArrowDropDownCircle = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M12 2C6.48 2 2 6.48 2 12s4.48 10 10 10 10-4.48 10-10S17.52 2 12 2zm0 12l-4-4h8l-4 4z"
            })), 'ArrowDropDownCircle');

            exports.default = _default;
            });

            unwrapExports$1(ArrowDropDownCircle);

            var ArrowDropUp = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M7 14l5-5 5 5z"
            })), 'ArrowDropUp');

            exports.default = _default;
            });

            unwrapExports$1(ArrowDropUp);

            var ArrowForward = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M12 4l-1.41 1.41L16.17 11H4v2h12.17l-5.58 5.59L12 20l8-8z"
            })), 'ArrowForward');

            exports.default = _default;
            });

            unwrapExports$1(ArrowForward);

            var ArrowUpward = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M4 12l1.41 1.41L11 7.83V20h2V7.83l5.58 5.59L20 12l-8-8-8 8z"
            })), 'ArrowUpward');

            exports.default = _default;
            });

            unwrapExports$1(ArrowUpward);

            var ArtTrack = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M22 13h-8v-2h8v2zm0-6h-8v2h8V7zm-8 10h8v-2h-8v2zm-2-8v6c0 1.1-.9 2-2 2H4c-1.1 0-2-.9-2-2V9c0-1.1.9-2 2-2h6c1.1 0 2 .9 2 2zm-1.5 6l-2.25-3-1.75 2.26-1.25-1.51L3.5 15h7z"
            })), 'ArtTrack');

            exports.default = _default;
            });

            unwrapExports$1(ArtTrack);

            var AspectRatio = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M19 12h-2v3h-3v2h5v-5zM7 9h3V7H5v5h2V9zm14-6H3c-1.1 0-2 .9-2 2v14c0 1.1.9 2 2 2h18c1.1 0 2-.9 2-2V5c0-1.1-.9-2-2-2zm0 16.01H3V4.99h18v14.02z"
            })), 'AspectRatio');

            exports.default = _default;
            });

            unwrapExports$1(AspectRatio);

            var Assessment = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M19 3H5c-1.1 0-2 .9-2 2v14c0 1.1.9 2 2 2h14c1.1 0 2-.9 2-2V5c0-1.1-.9-2-2-2zM9 17H7v-7h2v7zm4 0h-2V7h2v10zm4 0h-2v-4h2v4z"
            })), 'Assessment');

            exports.default = _default;
            });

            unwrapExports$1(Assessment);

            var Assignment = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M19 3h-4.18C14.4 1.84 13.3 1 12 1c-1.3 0-2.4.84-2.82 2H5c-1.1 0-2 .9-2 2v14c0 1.1.9 2 2 2h14c1.1 0 2-.9 2-2V5c0-1.1-.9-2-2-2zm-7 0c.55 0 1 .45 1 1s-.45 1-1 1-1-.45-1-1 .45-1 1-1zm2 14H7v-2h7v2zm3-4H7v-2h10v2zm0-4H7V7h10v2z"
            })), 'Assignment');

            exports.default = _default;
            });

            unwrapExports$1(Assignment);

            var AssignmentInd = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M19 3h-4.18C14.4 1.84 13.3 1 12 1c-1.3 0-2.4.84-2.82 2H5c-1.1 0-2 .9-2 2v14c0 1.1.9 2 2 2h14c1.1 0 2-.9 2-2V5c0-1.1-.9-2-2-2zm-7 0c.55 0 1 .45 1 1s-.45 1-1 1-1-.45-1-1 .45-1 1-1zm0 4c1.66 0 3 1.34 3 3s-1.34 3-3 3-3-1.34-3-3 1.34-3 3-3zm6 12H6v-1.4c0-2 4-3.1 6-3.1s6 1.1 6 3.1V19z"
            })), 'AssignmentInd');

            exports.default = _default;
            });

            unwrapExports$1(AssignmentInd);

            var AssignmentLate = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M19 3h-4.18C14.4 1.84 13.3 1 12 1c-1.3 0-2.4.84-2.82 2H5c-1.1 0-2 .9-2 2v14c0 1.1.9 2 2 2h14c1.1 0 2-.9 2-2V5c0-1.1-.9-2-2-2zm-6 15h-2v-2h2v2zm0-4h-2V8h2v6zm-1-9c-.55 0-1-.45-1-1s.45-1 1-1 1 .45 1 1-.45 1-1 1z"
            })), 'AssignmentLate');

            exports.default = _default;
            });

            unwrapExports$1(AssignmentLate);

            var AssignmentReturn = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M19 3h-4.18C14.4 1.84 13.3 1 12 1c-1.3 0-2.4.84-2.82 2H5c-1.1 0-2 .9-2 2v14c0 1.1.9 2 2 2h14c1.1 0 2-.9 2-2V5c0-1.1-.9-2-2-2zm-7 0c.55 0 1 .45 1 1s-.45 1-1 1-1-.45-1-1 .45-1 1-1zm4 12h-4v3l-5-5 5-5v3h4v4z"
            })), 'AssignmentReturn');

            exports.default = _default;
            });

            unwrapExports$1(AssignmentReturn);

            var AssignmentReturned = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M19 3h-4.18C14.4 1.84 13.3 1 12 1c-1.3 0-2.4.84-2.82 2H5c-1.1 0-2 .9-2 2v14c0 1.1.9 2 2 2h14c1.1 0 2-.9 2-2V5c0-1.1-.9-2-2-2zm-7 0c.55 0 1 .45 1 1s-.45 1-1 1-1-.45-1-1 .45-1 1-1zm0 15l-5-5h3V9h4v4h3l-5 5z"
            })), 'AssignmentReturned');

            exports.default = _default;
            });

            unwrapExports$1(AssignmentReturned);

            var AssignmentTurnedIn = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M19 3h-4.18C14.4 1.84 13.3 1 12 1c-1.3 0-2.4.84-2.82 2H5c-1.1 0-2 .9-2 2v14c0 1.1.9 2 2 2h14c1.1 0 2-.9 2-2V5c0-1.1-.9-2-2-2zm-7 0c.55 0 1 .45 1 1s-.45 1-1 1-1-.45-1-1 .45-1 1-1zm-2 14l-4-4 1.41-1.41L10 14.17l6.59-6.59L18 9l-8 8z"
            })), 'AssignmentTurnedIn');

            exports.default = _default;
            });

            unwrapExports$1(AssignmentTurnedIn);

            var Assistant = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M19 2H5c-1.1 0-2 .9-2 2v14c0 1.1.9 2 2 2h4l3 3 3-3h4c1.1 0 2-.9 2-2V4c0-1.1-.9-2-2-2zm-5.12 10.88L12 17l-1.88-4.12L6 11l4.12-1.88L12 5l1.88 4.12L18 11l-4.12 1.88z"
            })), 'Assistant');

            exports.default = _default;
            });

            unwrapExports$1(Assistant);

            var AssistantPhoto = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M14.4 6L14 4H5v17h2v-7h5.6l.4 2h7V6z"
            })), 'AssistantPhoto');

            exports.default = _default;
            });

            unwrapExports$1(AssistantPhoto);

            var AttachFile = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M16.5 6v11.5c0 2.21-1.79 4-4 4s-4-1.79-4-4V5c0-1.38 1.12-2.5 2.5-2.5s2.5 1.12 2.5 2.5v10.5c0 .55-.45 1-1 1s-1-.45-1-1V6H10v9.5c0 1.38 1.12 2.5 2.5 2.5s2.5-1.12 2.5-2.5V5c0-2.21-1.79-4-4-4S7 2.79 7 5v12.5c0 3.04 2.46 5.5 5.5 5.5s5.5-2.46 5.5-5.5V6h-1.5z"
            })), 'AttachFile');

            exports.default = _default;
            });

            unwrapExports$1(AttachFile);

            var Attachment = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M2 12.5C2 9.46 4.46 7 7.5 7H18c2.21 0 4 1.79 4 4s-1.79 4-4 4H9.5C8.12 15 7 13.88 7 12.5S8.12 10 9.5 10H17v2H9.41c-.55 0-.55 1 0 1H18c1.1 0 2-.9 2-2s-.9-2-2-2H7.5C5.57 9 4 10.57 4 12.5S5.57 16 7.5 16H17v2H7.5C4.46 18 2 15.54 2 12.5z"
            })), 'Attachment');

            exports.default = _default;
            });

            unwrapExports$1(Attachment);

            var AttachMoney = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M11.8 10.9c-2.27-.59-3-1.2-3-2.15 0-1.09 1.01-1.85 2.7-1.85 1.78 0 2.44.85 2.5 2.1h2.21c-.07-1.72-1.12-3.3-3.21-3.81V3h-3v2.16c-1.94.42-3.5 1.68-3.5 3.61 0 2.31 1.91 3.46 4.7 4.13 2.5.6 3 1.48 3 2.41 0 .69-.49 1.79-2.7 1.79-2.06 0-2.87-.92-2.98-2.1h-2.2c.12 2.19 1.76 3.42 3.68 3.83V21h3v-2.15c1.95-.37 3.5-1.5 3.5-3.55 0-2.84-2.43-3.81-4.7-4.4z"
            })), 'AttachMoney');

            exports.default = _default;
            });

            unwrapExports$1(AttachMoney);

            var Audiotrack = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M12 3v9.28c-.47-.17-.97-.28-1.5-.28C8.01 12 6 14.01 6 16.5S8.01 21 10.5 21c2.31 0 4.2-1.75 4.45-4H15V6h4V3h-7z"
            })), 'Audiotrack');

            exports.default = _default;
            });

            unwrapExports$1(Audiotrack);

            var Autorenew = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M12 6v3l4-4-4-4v3c-4.42 0-8 3.58-8 8 0 1.57.46 3.03 1.24 4.26L6.7 14.8c-.45-.83-.7-1.79-.7-2.8 0-3.31 2.69-6 6-6zm6.76 1.74L17.3 9.2c.44.84.7 1.79.7 2.8 0 3.31-2.69 6-6 6v-3l-4 4 4 4v-3c4.42 0 8-3.58 8-8 0-1.57-.46-3.03-1.24-4.26z"
            })), 'Autorenew');

            exports.default = _default;
            });

            unwrapExports$1(Autorenew);

            var AvTimer = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M11 17c0 .55.45 1 1 1s1-.45 1-1-.45-1-1-1-1 .45-1 1zm0-14v4h2V5.08c3.39.49 6 3.39 6 6.92 0 3.87-3.13 7-7 7s-7-3.13-7-7c0-1.68.59-3.22 1.58-4.42L12 13l1.41-1.41-6.8-6.8v.02C4.42 6.45 3 9.05 3 12c0 4.97 4.02 9 9 9 4.97 0 9-4.03 9-9s-4.03-9-9-9h-1zm7 9c0-.55-.45-1-1-1s-1 .45-1 1 .45 1 1 1 1-.45 1-1zM6 12c0 .55.45 1 1 1s1-.45 1-1-.45-1-1-1-1 .45-1 1z"
            })), 'AvTimer');

            exports.default = _default;
            });

            unwrapExports$1(AvTimer);

            var Backspace = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M22 3H7c-.69 0-1.23.35-1.59.88L0 12l5.41 8.11c.36.53.9.89 1.59.89h15c1.1 0 2-.9 2-2V5c0-1.1-.9-2-2-2zm-3 12.59L17.59 17 14 13.41 10.41 17 9 15.59 12.59 12 9 8.41 10.41 7 14 10.59 17.59 7 19 8.41 15.41 12 19 15.59z"
            })), 'Backspace');

            exports.default = _default;
            });

            unwrapExports$1(Backspace);

            var Backup = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M19.35 10.04C18.67 6.59 15.64 4 12 4 9.11 4 6.6 5.64 5.35 8.04 2.34 8.36 0 10.91 0 14c0 3.31 2.69 6 6 6h13c2.76 0 5-2.24 5-5 0-2.64-2.05-4.78-4.65-4.96zM14 13v4h-4v-4H7l5-5 5 5h-3z"
            })), 'Backup');

            exports.default = _default;
            });

            unwrapExports$1(Backup);

            var Battery20 = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M7 17v3.67C7 21.4 7.6 22 8.33 22h7.33c.74 0 1.34-.6 1.34-1.33V17H7z"
            }), _react.default.createElement("path", {
              fillOpacity: ".3",
              d: "M17 5.33C17 4.6 16.4 4 15.67 4H14V2h-4v2H8.33C7.6 4 7 4.6 7 5.33V17h10V5.33z"
            })), 'Battery20');

            exports.default = _default;
            });

            unwrapExports$1(Battery20);

            var Battery30 = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              fillOpacity: ".3",
              d: "M17 5.33C17 4.6 16.4 4 15.67 4H14V2h-4v2H8.33C7.6 4 7 4.6 7 5.33V15h10V5.33z"
            }), _react.default.createElement("path", {
              d: "M7 15v5.67C7 21.4 7.6 22 8.33 22h7.33c.74 0 1.34-.6 1.34-1.33V15H7z"
            })), 'Battery30');

            exports.default = _default;
            });

            unwrapExports$1(Battery30);

            var Battery50 = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              fillOpacity: ".3",
              d: "M17 5.33C17 4.6 16.4 4 15.67 4H14V2h-4v2H8.33C7.6 4 7 4.6 7 5.33V13h10V5.33z"
            }), _react.default.createElement("path", {
              d: "M7 13v7.67C7 21.4 7.6 22 8.33 22h7.33c.74 0 1.34-.6 1.34-1.33V13H7z"
            })), 'Battery50');

            exports.default = _default;
            });

            unwrapExports$1(Battery50);

            var Battery60 = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              fillOpacity: ".3",
              d: "M17 5.33C17 4.6 16.4 4 15.67 4H14V2h-4v2H8.33C7.6 4 7 4.6 7 5.33V11h10V5.33z"
            }), _react.default.createElement("path", {
              d: "M7 11v9.67C7 21.4 7.6 22 8.33 22h7.33c.74 0 1.34-.6 1.34-1.33V11H7z"
            })), 'Battery60');

            exports.default = _default;
            });

            unwrapExports$1(Battery60);

            var Battery80 = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              fillOpacity: ".3",
              d: "M17 5.33C17 4.6 16.4 4 15.67 4H14V2h-4v2H8.33C7.6 4 7 4.6 7 5.33V9h10V5.33z"
            }), _react.default.createElement("path", {
              d: "M7 9v11.67C7 21.4 7.6 22 8.33 22h7.33c.74 0 1.34-.6 1.34-1.33V9H7z"
            })), 'Battery80');

            exports.default = _default;
            });

            unwrapExports$1(Battery80);

            var Battery90 = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              fillOpacity: ".3",
              d: "M17 5.33C17 4.6 16.4 4 15.67 4H14V2h-4v2H8.33C7.6 4 7 4.6 7 5.33V8h10V5.33z"
            }), _react.default.createElement("path", {
              d: "M7 8v12.67C7 21.4 7.6 22 8.33 22h7.33c.74 0 1.34-.6 1.34-1.33V8H7z"
            })), 'Battery90');

            exports.default = _default;
            });

            unwrapExports$1(Battery90);

            var BatteryAlert = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M15.67 4H14V2h-4v2H8.33C7.6 4 7 4.6 7 5.33v15.33C7 21.4 7.6 22 8.33 22h7.33c.74 0 1.34-.6 1.34-1.33V5.33C17 4.6 16.4 4 15.67 4zM13 18h-2v-2h2v2zm0-4h-2V9h2v5z"
            })), 'BatteryAlert');

            exports.default = _default;
            });

            unwrapExports$1(BatteryAlert);

            var BatteryCharging20 = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M11 20v-3H7v3.67C7 21.4 7.6 22 8.33 22h7.33c.74 0 1.34-.6 1.34-1.33V17h-4.4L11 20z"
            }), _react.default.createElement("path", {
              fillOpacity: ".3",
              d: "M15.67 4H14V2h-4v2H8.33C7.6 4 7 4.6 7 5.33V17h4v-2.5H9L13 7v5.5h2L12.6 17H17V5.33C17 4.6 16.4 4 15.67 4z"
            })), 'BatteryCharging20');

            exports.default = _default;
            });

            unwrapExports$1(BatteryCharging20);

            var BatteryCharging30 = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              fillOpacity: ".3",
              d: "M15.67 4H14V2h-4v2H8.33C7.6 4 7 4.6 7 5.33v9.17h2L13 7v5.5h2l-1.07 2H17V5.33C17 4.6 16.4 4 15.67 4z"
            }), _react.default.createElement("path", {
              d: "M11 20v-5.5H7v6.17C7 21.4 7.6 22 8.33 22h7.33c.74 0 1.34-.6 1.34-1.33V14.5h-3.07L11 20z"
            })), 'BatteryCharging30');

            exports.default = _default;
            });

            unwrapExports$1(BatteryCharging30);

            var BatteryCharging50 = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M14.47 13.5L11 20v-5.5H9l.53-1H7v7.17C7 21.4 7.6 22 8.33 22h7.33c.74 0 1.34-.6 1.34-1.33V13.5h-2.53z"
            }), _react.default.createElement("path", {
              fillOpacity: ".3",
              d: "M15.67 4H14V2h-4v2H8.33C7.6 4 7 4.6 7 5.33v8.17h2.53L13 7v5.5h2l-.53 1H17V5.33C17 4.6 16.4 4 15.67 4z"
            })), 'BatteryCharging50');

            exports.default = _default;
            });

            unwrapExports$1(BatteryCharging50);

            var BatteryCharging60 = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              fillOpacity: ".3",
              d: "M15.67 4H14V2h-4v2H8.33C7.6 4 7 4.6 7 5.33V11h3.87L13 7v4h4V5.33C17 4.6 16.4 4 15.67 4z"
            }), _react.default.createElement("path", {
              d: "M13 12.5h2L11 20v-5.5H9l1.87-3.5H7v9.67C7 21.4 7.6 22 8.33 22h7.33c.74 0 1.34-.6 1.34-1.33V11h-4v1.5z"
            })), 'BatteryCharging60');

            exports.default = _default;
            });

            unwrapExports$1(BatteryCharging60);

            var BatteryCharging80 = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              fillOpacity: ".3",
              d: "M15.67 4H14V2h-4v2H8.33C7.6 4 7 4.6 7 5.33V9h4.93L13 7v2h4V5.33C17 4.6 16.4 4 15.67 4z"
            }), _react.default.createElement("path", {
              d: "M13 12.5h2L11 20v-5.5H9L11.93 9H7v11.67C7 21.4 7.6 22 8.33 22h7.33c.74 0 1.34-.6 1.34-1.33V9h-4v3.5z"
            })), 'BatteryCharging80');

            exports.default = _default;
            });

            unwrapExports$1(BatteryCharging80);

            var BatteryCharging90 = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              fillOpacity: ".3",
              d: "M15.67 4H14V2h-4v2H8.33C7.6 4 7 4.6 7 5.33V8h5.47L13 7v1h4V5.33C17 4.6 16.4 4 15.67 4z"
            }), _react.default.createElement("path", {
              d: "M13 12.5h2L11 20v-5.5H9L12.47 8H7v12.67C7 21.4 7.6 22 8.33 22h7.33c.74 0 1.34-.6 1.34-1.33V8h-4v4.5z"
            })), 'BatteryCharging90');

            exports.default = _default;
            });

            unwrapExports$1(BatteryCharging90);

            var BatteryChargingFull = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M15.67 4H14V2h-4v2H8.33C7.6 4 7 4.6 7 5.33v15.33C7 21.4 7.6 22 8.33 22h7.33c.74 0 1.34-.6 1.34-1.33V5.33C17 4.6 16.4 4 15.67 4zM11 20v-5.5H9L13 7v5.5h2L11 20z"
            })), 'BatteryChargingFull');

            exports.default = _default;
            });

            unwrapExports$1(BatteryChargingFull);

            var BatteryFull = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M15.67 4H14V2h-4v2H8.33C7.6 4 7 4.6 7 5.33v15.33C7 21.4 7.6 22 8.33 22h7.33c.74 0 1.34-.6 1.34-1.33V5.33C17 4.6 16.4 4 15.67 4z"
            })), 'BatteryFull');

            exports.default = _default;
            });

            unwrapExports$1(BatteryFull);

            var BatteryStd = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M15.67 4H14V2h-4v2H8.33C7.6 4 7 4.6 7 5.33v15.33C7 21.4 7.6 22 8.33 22h7.33c.74 0 1.34-.6 1.34-1.33V5.33C17 4.6 16.4 4 15.67 4z"
            })), 'BatteryStd');

            exports.default = _default;
            });

            unwrapExports$1(BatteryStd);

            var BatteryUnknown = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M15.67 4H14V2h-4v2H8.33C7.6 4 7 4.6 7 5.33v15.33C7 21.4 7.6 22 8.33 22h7.33c.74 0 1.34-.6 1.34-1.33V5.33C17 4.6 16.4 4 15.67 4zm-2.72 13.95h-1.9v-1.9h1.9v1.9zm1.35-5.26s-.38.42-.67.71c-.48.48-.83 1.15-.83 1.6h-1.6c0-.83.46-1.52.93-2l.93-.94c.27-.27.44-.65.44-1.06 0-.83-.67-1.5-1.5-1.5s-1.5.67-1.5 1.5H9c0-1.66 1.34-3 3-3s3 1.34 3 3c0 .66-.27 1.26-.7 1.69z"
            })), 'BatteryUnknown');

            exports.default = _default;
            });

            unwrapExports$1(BatteryUnknown);

            var BeachAccess = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M13.127 14.56l1.43-1.43 6.44 6.443L19.57 21zm4.293-5.73l2.86-2.86c-3.95-3.95-10.35-3.96-14.3-.02 3.93-1.3 8.31-.25 11.44 2.88zM5.95 5.98c-3.94 3.95-3.93 10.35.02 14.3l2.86-2.86C5.7 14.29 4.65 9.91 5.95 5.98zm.02-.02l-.01.01c-.38 3.01 1.17 6.88 4.3 10.02l5.73-5.73c-3.13-3.13-7.01-4.68-10.02-4.3z"
            })), 'BeachAccess');

            exports.default = _default;
            });

            unwrapExports$1(BeachAccess);

            var Beenhere = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M19 1H5c-1.1 0-1.99.9-1.99 2L3 15.93c0 .69.35 1.3.88 1.66L12 23l8.11-5.41c.53-.36.88-.97.88-1.66L21 3c0-1.1-.9-2-2-2zm-9 15l-5-5 1.41-1.41L10 13.17l7.59-7.59L19 7l-9 9z"
            })), 'Beenhere');

            exports.default = _default;
            });

            unwrapExports$1(Beenhere);

            var Block = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M12 2C6.48 2 2 6.48 2 12s4.48 10 10 10 10-4.48 10-10S17.52 2 12 2zM4 12c0-4.42 3.58-8 8-8 1.85 0 3.55.63 4.9 1.69L5.69 16.9C4.63 15.55 4 13.85 4 12zm8 8c-1.85 0-3.55-.63-4.9-1.69L18.31 7.1C19.37 8.45 20 10.15 20 12c0 4.42-3.58 8-8 8z"
            })), 'Block');

            exports.default = _default;
            });

            unwrapExports$1(Block);

            var Bluetooth = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M17.71 7.71L12 2h-1v7.59L6.41 5 5 6.41 10.59 12 5 17.59 6.41 19 11 14.41V22h1l5.71-5.71-4.3-4.29 4.3-4.29zM13 5.83l1.88 1.88L13 9.59V5.83zm1.88 10.46L13 18.17v-3.76l1.88 1.88z"
            })), 'Bluetooth');

            exports.default = _default;
            });

            unwrapExports$1(Bluetooth);

            var BluetoothAudio = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M14.24 12.01l2.32 2.32c.28-.72.44-1.51.44-2.33 0-.82-.16-1.59-.43-2.31l-2.33 2.32zm5.29-5.3l-1.26 1.26c.63 1.21.98 2.57.98 4.02s-.36 2.82-.98 4.02l1.2 1.2c.97-1.54 1.54-3.36 1.54-5.31-.01-1.89-.55-3.67-1.48-5.19zm-3.82 1L10 2H9v7.59L4.41 5 3 6.41 8.59 12 3 17.59 4.41 19 9 14.41V22h1l5.71-5.71-4.3-4.29 4.3-4.29zM11 5.83l1.88 1.88L11 9.59V5.83zm1.88 10.46L11 18.17v-3.76l1.88 1.88z"
            })), 'BluetoothAudio');

            exports.default = _default;
            });

            unwrapExports$1(BluetoothAudio);

            var BluetoothConnected = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M7 12l-2-2-2 2 2 2 2-2zm10.71-4.29L12 2h-1v7.59L6.41 5 5 6.41 10.59 12 5 17.59 6.41 19 11 14.41V22h1l5.71-5.71-4.3-4.29 4.3-4.29zM13 5.83l1.88 1.88L13 9.59V5.83zm1.88 10.46L13 18.17v-3.76l1.88 1.88zM19 10l-2 2 2 2 2-2-2-2z"
            })), 'BluetoothConnected');

            exports.default = _default;
            });

            unwrapExports$1(BluetoothConnected);

            var BluetoothDisabled = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M13 5.83l1.88 1.88-1.6 1.6 1.41 1.41 3.02-3.02L12 2h-1v5.03l2 2v-3.2zM5.41 4L4 5.41 10.59 12 5 17.59 6.41 19 11 14.41V22h1l4.29-4.29 2.3 2.29L20 18.59 5.41 4zM13 18.17v-3.76l1.88 1.88L13 18.17z"
            })), 'BluetoothDisabled');

            exports.default = _default;
            });

            unwrapExports$1(BluetoothDisabled);

            var BluetoothSearching = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M14.24 12.01l2.32 2.32c.28-.72.44-1.51.44-2.33 0-.82-.16-1.59-.43-2.31l-2.33 2.32zm5.29-5.3l-1.26 1.26c.63 1.21.98 2.57.98 4.02s-.36 2.82-.98 4.02l1.2 1.2c.97-1.54 1.54-3.36 1.54-5.31-.01-1.89-.55-3.67-1.48-5.19zm-3.82 1L10 2H9v7.59L4.41 5 3 6.41 8.59 12 3 17.59 4.41 19 9 14.41V22h1l5.71-5.71-4.3-4.29 4.3-4.29zM11 5.83l1.88 1.88L11 9.59V5.83zm1.88 10.46L11 18.17v-3.76l1.88 1.88z"
            })), 'BluetoothSearching');

            exports.default = _default;
            });

            unwrapExports$1(BluetoothSearching);

            var BlurCircular = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M10 9c-.55 0-1 .45-1 1s.45 1 1 1 1-.45 1-1-.45-1-1-1zm0 4c-.55 0-1 .45-1 1s.45 1 1 1 1-.45 1-1-.45-1-1-1zM7 9.5c-.28 0-.5.22-.5.5s.22.5.5.5.5-.22.5-.5-.22-.5-.5-.5zm3 7c-.28 0-.5.22-.5.5s.22.5.5.5.5-.22.5-.5-.22-.5-.5-.5zm-3-3c-.28 0-.5.22-.5.5s.22.5.5.5.5-.22.5-.5-.22-.5-.5-.5zm3-6c.28 0 .5-.22.5-.5s-.22-.5-.5-.5-.5.22-.5.5.22.5.5.5zM14 9c-.55 0-1 .45-1 1s.45 1 1 1 1-.45 1-1-.45-1-1-1zm0-1.5c.28 0 .5-.22.5-.5s-.22-.5-.5-.5-.5.22-.5.5.22.5.5.5zm3 6c-.28 0-.5.22-.5.5s.22.5.5.5.5-.22.5-.5-.22-.5-.5-.5zm0-4c-.28 0-.5.22-.5.5s.22.5.5.5.5-.22.5-.5-.22-.5-.5-.5zM12 2C6.48 2 2 6.48 2 12s4.48 10 10 10 10-4.48 10-10S17.52 2 12 2zm0 18c-4.42 0-8-3.58-8-8s3.58-8 8-8 8 3.58 8 8-3.58 8-8 8zm2-3.5c-.28 0-.5.22-.5.5s.22.5.5.5.5-.22.5-.5-.22-.5-.5-.5zm0-3.5c-.55 0-1 .45-1 1s.45 1 1 1 1-.45 1-1-.45-1-1-1z"
            })), 'BlurCircular');

            exports.default = _default;
            });

            unwrapExports$1(BlurCircular);

            var BlurLinear = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M5 17.5c.83 0 1.5-.67 1.5-1.5s-.67-1.5-1.5-1.5-1.5.67-1.5 1.5.67 1.5 1.5 1.5zM9 13c.55 0 1-.45 1-1s-.45-1-1-1-1 .45-1 1 .45 1 1 1zm0-4c.55 0 1-.45 1-1s-.45-1-1-1-1 .45-1 1 .45 1 1 1zM3 21h18v-2H3v2zM5 9.5c.83 0 1.5-.67 1.5-1.5S5.83 6.5 5 6.5 3.5 7.17 3.5 8 4.17 9.5 5 9.5zm0 4c.83 0 1.5-.67 1.5-1.5s-.67-1.5-1.5-1.5-1.5.67-1.5 1.5.67 1.5 1.5 1.5zM9 17c.55 0 1-.45 1-1s-.45-1-1-1-1 .45-1 1 .45 1 1 1zm8-.5c.28 0 .5-.22.5-.5s-.22-.5-.5-.5-.5.22-.5.5.22.5.5.5zM3 3v2h18V3H3zm14 5.5c.28 0 .5-.22.5-.5s-.22-.5-.5-.5-.5.22-.5.5.22.5.5.5zm0 4c.28 0 .5-.22.5-.5s-.22-.5-.5-.5-.5.22-.5.5.22.5.5.5zM13 9c.55 0 1-.45 1-1s-.45-1-1-1-1 .45-1 1 .45 1 1 1zm0 4c.55 0 1-.45 1-1s-.45-1-1-1-1 .45-1 1 .45 1 1 1zm0 4c.55 0 1-.45 1-1s-.45-1-1-1-1 .45-1 1 .45 1 1 1z"
            })), 'BlurLinear');

            exports.default = _default;
            });

            unwrapExports$1(BlurLinear);

            var BlurOff = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M14 7c.55 0 1-.45 1-1s-.45-1-1-1-1 .45-1 1 .45 1 1 1zm-.2 4.48l.2.02c.83 0 1.5-.67 1.5-1.5s-.67-1.5-1.5-1.5-1.5.67-1.5 1.5l.02.2c.09.67.61 1.19 1.28 1.28zM14 3.5c.28 0 .5-.22.5-.5s-.22-.5-.5-.5-.5.22-.5.5.22.5.5.5zm-4 0c.28 0 .5-.22.5-.5s-.22-.5-.5-.5-.5.22-.5.5.22.5.5.5zm11 7c.28 0 .5-.22.5-.5s-.22-.5-.5-.5-.5.22-.5.5.22.5.5.5zM10 7c.55 0 1-.45 1-1s-.45-1-1-1-1 .45-1 1 .45 1 1 1zm8 8c.55 0 1-.45 1-1s-.45-1-1-1-1 .45-1 1 .45 1 1 1zm0-4c.55 0 1-.45 1-1s-.45-1-1-1-1 .45-1 1 .45 1 1 1zm0-4c.55 0 1-.45 1-1s-.45-1-1-1-1 .45-1 1 .45 1 1 1zm-4 13.5c-.28 0-.5.22-.5.5s.22.5.5.5.5-.22.5-.5-.22-.5-.5-.5zM2.5 5.27l3.78 3.78L6 9c-.55 0-1 .45-1 1s.45 1 1 1 1-.45 1-1c0-.1-.03-.19-.06-.28l2.81 2.81c-.71.11-1.25.73-1.25 1.47 0 .83.67 1.5 1.5 1.5.74 0 1.36-.54 1.47-1.25l2.81 2.81c-.09-.03-.18-.06-.28-.06-.55 0-1 .45-1 1s.45 1 1 1 1-.45 1-1c0-.1-.03-.19-.06-.28l3.78 3.78L20 20.23 3.77 4 2.5 5.27zM10 17c-.55 0-1 .45-1 1s.45 1 1 1 1-.45 1-1-.45-1-1-1zm11-3.5c-.28 0-.5.22-.5.5s.22.5.5.5.5-.22.5-.5-.22-.5-.5-.5zM6 13c-.55 0-1 .45-1 1s.45 1 1 1 1-.45 1-1-.45-1-1-1zM3 9.5c-.28 0-.5.22-.5.5s.22.5.5.5.5-.22.5-.5-.22-.5-.5-.5zm7 11c-.28 0-.5.22-.5.5s.22.5.5.5.5-.22.5-.5-.22-.5-.5-.5zM6 17c-.55 0-1 .45-1 1s.45 1 1 1 1-.45 1-1-.45-1-1-1zm-3-3.5c-.28 0-.5.22-.5.5s.22.5.5.5.5-.22.5-.5-.22-.5-.5-.5z"
            })), 'BlurOff');

            exports.default = _default;
            });

            unwrapExports$1(BlurOff);

            var BlurOn = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M6 13c-.55 0-1 .45-1 1s.45 1 1 1 1-.45 1-1-.45-1-1-1zm0 4c-.55 0-1 .45-1 1s.45 1 1 1 1-.45 1-1-.45-1-1-1zm0-8c-.55 0-1 .45-1 1s.45 1 1 1 1-.45 1-1-.45-1-1-1zm-3 .5c-.28 0-.5.22-.5.5s.22.5.5.5.5-.22.5-.5-.22-.5-.5-.5zM6 5c-.55 0-1 .45-1 1s.45 1 1 1 1-.45 1-1-.45-1-1-1zm15 5.5c.28 0 .5-.22.5-.5s-.22-.5-.5-.5-.5.22-.5.5.22.5.5.5zM14 7c.55 0 1-.45 1-1s-.45-1-1-1-1 .45-1 1 .45 1 1 1zm0-3.5c.28 0 .5-.22.5-.5s-.22-.5-.5-.5-.5.22-.5.5.22.5.5.5zm-11 10c-.28 0-.5.22-.5.5s.22.5.5.5.5-.22.5-.5-.22-.5-.5-.5zm7 7c-.28 0-.5.22-.5.5s.22.5.5.5.5-.22.5-.5-.22-.5-.5-.5zm0-17c.28 0 .5-.22.5-.5s-.22-.5-.5-.5-.5.22-.5.5.22.5.5.5zM10 7c.55 0 1-.45 1-1s-.45-1-1-1-1 .45-1 1 .45 1 1 1zm0 5.5c-.83 0-1.5.67-1.5 1.5s.67 1.5 1.5 1.5 1.5-.67 1.5-1.5-.67-1.5-1.5-1.5zm8 .5c-.55 0-1 .45-1 1s.45 1 1 1 1-.45 1-1-.45-1-1-1zm0 4c-.55 0-1 .45-1 1s.45 1 1 1 1-.45 1-1-.45-1-1-1zm0-8c-.55 0-1 .45-1 1s.45 1 1 1 1-.45 1-1-.45-1-1-1zm0-4c-.55 0-1 .45-1 1s.45 1 1 1 1-.45 1-1-.45-1-1-1zm3 8.5c-.28 0-.5.22-.5.5s.22.5.5.5.5-.22.5-.5-.22-.5-.5-.5zM14 17c-.55 0-1 .45-1 1s.45 1 1 1 1-.45 1-1-.45-1-1-1zm0 3.5c-.28 0-.5.22-.5.5s.22.5.5.5.5-.22.5-.5-.22-.5-.5-.5zm-4-12c-.83 0-1.5.67-1.5 1.5s.67 1.5 1.5 1.5 1.5-.67 1.5-1.5-.67-1.5-1.5-1.5zm0 8.5c-.55 0-1 .45-1 1s.45 1 1 1 1-.45 1-1-.45-1-1-1zm4-4.5c-.83 0-1.5.67-1.5 1.5s.67 1.5 1.5 1.5 1.5-.67 1.5-1.5-.67-1.5-1.5-1.5zm0-4c-.83 0-1.5.67-1.5 1.5s.67 1.5 1.5 1.5 1.5-.67 1.5-1.5-.67-1.5-1.5-1.5z"
            })), 'BlurOn');

            exports.default = _default;
            });

            unwrapExports$1(BlurOn);

            var Book = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M18 2H6c-1.1 0-2 .9-2 2v16c0 1.1.9 2 2 2h12c1.1 0 2-.9 2-2V4c0-1.1-.9-2-2-2zM6 4h5v8l-2.5-1.5L6 12V4z"
            })), 'Book');

            exports.default = _default;
            });

            unwrapExports$1(Book);

            var Bookmark = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M17 3H7c-1.1 0-1.99.9-1.99 2L5 21l7-3 7 3V5c0-1.1-.9-2-2-2z"
            })), 'Bookmark');

            exports.default = _default;
            });

            unwrapExports$1(Bookmark);

            var BookmarkBorder = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M17 3H7c-1.1 0-1.99.9-1.99 2L5 21l7-3 7 3V5c0-1.1-.9-2-2-2zm0 15l-5-2.18L7 18V5h10v13z"
            })), 'BookmarkBorder');

            exports.default = _default;
            });

            unwrapExports$1(BookmarkBorder);

            var BorderAll = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M3 3v18h18V3H3zm8 16H5v-6h6v6zm0-8H5V5h6v6zm8 8h-6v-6h6v6zm0-8h-6V5h6v6z"
            })), 'BorderAll');

            exports.default = _default;
            });

            unwrapExports$1(BorderAll);

            var BorderBottom = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M9 11H7v2h2v-2zm4 4h-2v2h2v-2zM9 3H7v2h2V3zm4 8h-2v2h2v-2zM5 3H3v2h2V3zm8 4h-2v2h2V7zm4 4h-2v2h2v-2zm-4-8h-2v2h2V3zm4 0h-2v2h2V3zm2 10h2v-2h-2v2zm0 4h2v-2h-2v2zM5 7H3v2h2V7zm14-4v2h2V3h-2zm0 6h2V7h-2v2zM5 11H3v2h2v-2zM3 21h18v-2H3v2zm2-6H3v2h2v-2z"
            })), 'BorderBottom');

            exports.default = _default;
            });

            unwrapExports$1(BorderBottom);

            var BorderClear = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M7 5h2V3H7v2zm0 8h2v-2H7v2zm0 8h2v-2H7v2zm4-4h2v-2h-2v2zm0 4h2v-2h-2v2zm-8 0h2v-2H3v2zm0-4h2v-2H3v2zm0-4h2v-2H3v2zm0-4h2V7H3v2zm0-4h2V3H3v2zm8 8h2v-2h-2v2zm8 4h2v-2h-2v2zm0-4h2v-2h-2v2zm0 8h2v-2h-2v2zm0-12h2V7h-2v2zm-8 0h2V7h-2v2zm8-6v2h2V3h-2zm-8 2h2V3h-2v2zm4 16h2v-2h-2v2zm0-8h2v-2h-2v2zm0-8h2V3h-2v2z"
            })), 'BorderClear');

            exports.default = _default;
            });

            unwrapExports$1(BorderClear);

            var BorderColor = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M17.75 7L14 3.25l-10 10V17h3.75l10-10zm2.96-2.96c.39-.39.39-1.02 0-1.41L18.37.29c-.39-.39-1.02-.39-1.41 0L15 2.25 18.75 6l1.96-1.96z"
            }), _react.default.createElement("path", {
              fillOpacity: ".36",
              d: "M0 20h24v4H0z"
            })), 'BorderColor');

            exports.default = _default;
            });

            unwrapExports$1(BorderColor);

            var BorderHorizontal = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M3 21h2v-2H3v2zM5 7H3v2h2V7zM3 17h2v-2H3v2zm4 4h2v-2H7v2zM5 3H3v2h2V3zm4 0H7v2h2V3zm8 0h-2v2h2V3zm-4 4h-2v2h2V7zm0-4h-2v2h2V3zm6 14h2v-2h-2v2zm-8 4h2v-2h-2v2zm-8-8h18v-2H3v2zM19 3v2h2V3h-2zm0 6h2V7h-2v2zm-8 8h2v-2h-2v2zm4 4h2v-2h-2v2zm4 0h2v-2h-2v2z"
            })), 'BorderHorizontal');

            exports.default = _default;
            });

            unwrapExports$1(BorderHorizontal);

            var BorderInner = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M3 21h2v-2H3v2zm4 0h2v-2H7v2zM5 7H3v2h2V7zM3 17h2v-2H3v2zM9 3H7v2h2V3zM5 3H3v2h2V3zm12 0h-2v2h2V3zm2 6h2V7h-2v2zm0-6v2h2V3h-2zm-4 18h2v-2h-2v2zM13 3h-2v8H3v2h8v8h2v-8h8v-2h-8V3zm6 18h2v-2h-2v2zm0-4h2v-2h-2v2z"
            })), 'BorderInner');

            exports.default = _default;
            });

            unwrapExports$1(BorderInner);

            var BorderLeft = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M11 21h2v-2h-2v2zm0-4h2v-2h-2v2zm0-12h2V3h-2v2zm0 4h2V7h-2v2zm0 4h2v-2h-2v2zm-4 8h2v-2H7v2zM7 5h2V3H7v2zm0 8h2v-2H7v2zm-4 8h2V3H3v18zM19 9h2V7h-2v2zm-4 12h2v-2h-2v2zm4-4h2v-2h-2v2zm0-14v2h2V3h-2zm0 10h2v-2h-2v2zm0 8h2v-2h-2v2zm-4-8h2v-2h-2v2zm0-8h2V3h-2v2z"
            })), 'BorderLeft');

            exports.default = _default;
            });

            unwrapExports$1(BorderLeft);

            var BorderOuter = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M13 7h-2v2h2V7zm0 4h-2v2h2v-2zm4 0h-2v2h2v-2zM3 3v18h18V3H3zm16 16H5V5h14v14zm-6-4h-2v2h2v-2zm-4-4H7v2h2v-2z"
            })), 'BorderOuter');

            exports.default = _default;
            });

            unwrapExports$1(BorderOuter);

            var BorderRight = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M7 21h2v-2H7v2zM3 5h2V3H3v2zm4 0h2V3H7v2zm0 8h2v-2H7v2zm-4 8h2v-2H3v2zm8 0h2v-2h-2v2zm-8-8h2v-2H3v2zm0 4h2v-2H3v2zm0-8h2V7H3v2zm8 8h2v-2h-2v2zm4-4h2v-2h-2v2zm4-10v18h2V3h-2zm-4 18h2v-2h-2v2zm0-16h2V3h-2v2zm-4 8h2v-2h-2v2zm0-8h2V3h-2v2zm0 4h2V7h-2v2z"
            })), 'BorderRight');

            exports.default = _default;
            });

            unwrapExports$1(BorderRight);

            var BorderStyle = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M15 21h2v-2h-2v2zm4 0h2v-2h-2v2zM7 21h2v-2H7v2zm4 0h2v-2h-2v2zm8-4h2v-2h-2v2zm0-4h2v-2h-2v2zM3 3v18h2V5h16V3H3zm16 6h2V7h-2v2z"
            })), 'BorderStyle');

            exports.default = _default;
            });

            unwrapExports$1(BorderStyle);

            var BorderTop = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M7 21h2v-2H7v2zm0-8h2v-2H7v2zm4 0h2v-2h-2v2zm0 8h2v-2h-2v2zm-8-4h2v-2H3v2zm0 4h2v-2H3v2zm0-8h2v-2H3v2zm0-4h2V7H3v2zm8 8h2v-2h-2v2zm8-8h2V7h-2v2zm0 4h2v-2h-2v2zM3 3v2h18V3H3zm16 14h2v-2h-2v2zm-4 4h2v-2h-2v2zM11 9h2V7h-2v2zm8 12h2v-2h-2v2zm-4-8h2v-2h-2v2z"
            })), 'BorderTop');

            exports.default = _default;
            });

            unwrapExports$1(BorderTop);

            var BorderVertical = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M3 9h2V7H3v2zm0-4h2V3H3v2zm4 16h2v-2H7v2zm0-8h2v-2H7v2zm-4 0h2v-2H3v2zm0 8h2v-2H3v2zm0-4h2v-2H3v2zM7 5h2V3H7v2zm12 12h2v-2h-2v2zm-8 4h2V3h-2v18zm8 0h2v-2h-2v2zm0-8h2v-2h-2v2zm0-10v2h2V3h-2zm0 6h2V7h-2v2zm-4-4h2V3h-2v2zm0 16h2v-2h-2v2zm0-8h2v-2h-2v2z"
            })), 'BorderVertical');

            exports.default = _default;
            });

            unwrapExports$1(BorderVertical);

            var BrandingWatermark = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M21 3H3c-1.1 0-2 .9-2 2v14c0 1.1.9 2 2 2h18c1.1 0 2-.9 2-2V5c0-1.1-.9-2-2-2zm0 16h-9v-6h9v6z"
            })), 'BrandingWatermark');

            exports.default = _default;
            });

            unwrapExports$1(BrandingWatermark);

            var Brightness1 = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("circle", {
              cx: "12",
              cy: "12",
              r: "10"
            })), 'Brightness1');

            exports.default = _default;
            });

            unwrapExports$1(Brightness1);

            var Brightness2 = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M10 2c-1.82 0-3.53.5-5 1.35C7.99 5.08 10 8.3 10 12s-2.01 6.92-5 8.65C6.47 21.5 8.18 22 10 22c5.52 0 10-4.48 10-10S15.52 2 10 2z"
            })), 'Brightness2');

            exports.default = _default;
            });

            unwrapExports$1(Brightness2);

            var Brightness3 = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M9 2c-1.05 0-2.05.16-3 .46 4.06 1.27 7 5.06 7 9.54 0 4.48-2.94 8.27-7 9.54.95.3 1.95.46 3 .46 5.52 0 10-4.48 10-10S14.52 2 9 2z"
            })), 'Brightness3');

            exports.default = _default;
            });

            unwrapExports$1(Brightness3);

            var Brightness4 = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M20 8.69V4h-4.69L12 .69 8.69 4H4v4.69L.69 12 4 15.31V20h4.69L12 23.31 15.31 20H20v-4.69L23.31 12 20 8.69zM12 18c-.89 0-1.74-.2-2.5-.55C11.56 16.5 13 14.42 13 12s-1.44-4.5-3.5-5.45C10.26 6.2 11.11 6 12 6c3.31 0 6 2.69 6 6s-2.69 6-6 6z"
            })), 'Brightness4');

            exports.default = _default;
            });

            unwrapExports$1(Brightness4);

            var Brightness5 = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M20 15.31L23.31 12 20 8.69V4h-4.69L12 .69 8.69 4H4v4.69L.69 12 4 15.31V20h4.69L12 23.31 15.31 20H20v-4.69zM12 18c-3.31 0-6-2.69-6-6s2.69-6 6-6 6 2.69 6 6-2.69 6-6 6z"
            })), 'Brightness5');

            exports.default = _default;
            });

            unwrapExports$1(Brightness5);

            var Brightness6 = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M20 15.31L23.31 12 20 8.69V4h-4.69L12 .69 8.69 4H4v4.69L.69 12 4 15.31V20h4.69L12 23.31 15.31 20H20v-4.69zM12 18V6c3.31 0 6 2.69 6 6s-2.69 6-6 6z"
            })), 'Brightness6');

            exports.default = _default;
            });

            unwrapExports$1(Brightness6);

            var Brightness7 = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M20 8.69V4h-4.69L12 .69 8.69 4H4v4.69L.69 12 4 15.31V20h4.69L12 23.31 15.31 20H20v-4.69L23.31 12 20 8.69zM12 18c-3.31 0-6-2.69-6-6s2.69-6 6-6 6 2.69 6 6-2.69 6-6 6zm0-10c-2.21 0-4 1.79-4 4s1.79 4 4 4 4-1.79 4-4-1.79-4-4-4z"
            })), 'Brightness7');

            exports.default = _default;
            });

            unwrapExports$1(Brightness7);

            var BrightnessAuto = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M10.85 12.65h2.3L12 9l-1.15 3.65zM20 8.69V4h-4.69L12 .69 8.69 4H4v4.69L.69 12 4 15.31V20h4.69L12 23.31 15.31 20H20v-4.69L23.31 12 20 8.69zM14.3 16l-.7-2h-3.2l-.7 2H7.8L11 7h2l3.2 9h-1.9z"
            })), 'BrightnessAuto');

            exports.default = _default;
            });

            unwrapExports$1(BrightnessAuto);

            var BrightnessHigh = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M20 8.69V4h-4.69L12 .69 8.69 4H4v4.69L.69 12 4 15.31V20h4.69L12 23.31 15.31 20H20v-4.69L23.31 12 20 8.69zM12 18c-3.31 0-6-2.69-6-6s2.69-6 6-6 6 2.69 6 6-2.69 6-6 6zm0-10c-2.21 0-4 1.79-4 4s1.79 4 4 4 4-1.79 4-4-1.79-4-4-4z"
            })), 'BrightnessHigh');

            exports.default = _default;
            });

            unwrapExports$1(BrightnessHigh);

            var BrightnessLow = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M20 15.31L23.31 12 20 8.69V4h-4.69L12 .69 8.69 4H4v4.69L.69 12 4 15.31V20h4.69L12 23.31 15.31 20H20v-4.69zM12 18c-3.31 0-6-2.69-6-6s2.69-6 6-6 6 2.69 6 6-2.69 6-6 6z"
            })), 'BrightnessLow');

            exports.default = _default;
            });

            unwrapExports$1(BrightnessLow);

            var BrightnessMedium = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M20 15.31L23.31 12 20 8.69V4h-4.69L12 .69 8.69 4H4v4.69L.69 12 4 15.31V20h4.69L12 23.31 15.31 20H20v-4.69zM12 18V6c3.31 0 6 2.69 6 6s-2.69 6-6 6z"
            })), 'BrightnessMedium');

            exports.default = _default;
            });

            unwrapExports$1(BrightnessMedium);

            var BrokenImage = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M21 5v6.59l-3-3.01-4 4.01-4-4-4 4-3-3.01V5c0-1.1.9-2 2-2h14c1.1 0 2 .9 2 2zm-3 6.42l3 3.01V19c0 1.1-.9 2-2 2H5c-1.1 0-2-.9-2-2v-6.58l3 2.99 4-4 4 4 4-3.99z"
            })), 'BrokenImage');

            exports.default = _default;
            });

            unwrapExports$1(BrokenImage);

            var Brush = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M7 14c-1.66 0-3 1.34-3 3 0 1.31-1.16 2-2 2 .92 1.22 2.49 2 4 2 2.21 0 4-1.79 4-4 0-1.66-1.34-3-3-3zm13.71-9.37l-1.34-1.34c-.39-.39-1.02-.39-1.41 0L9 12.25 11.75 15l8.96-8.96c.39-.39.39-1.02 0-1.41z"
            })), 'Brush');

            exports.default = _default;
            });

            unwrapExports$1(Brush);

            var BubbleChart = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("circle", {
              cx: "7.2",
              cy: "14.4",
              r: "3.2"
            }), _react.default.createElement("circle", {
              cx: "14.8",
              cy: "18",
              r: "2"
            }), _react.default.createElement("circle", {
              cx: "15.2",
              cy: "8.8",
              r: "4.8"
            })), 'BubbleChart');

            exports.default = _default;
            });

            unwrapExports$1(BubbleChart);

            var BugReport = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M20 8h-2.81c-.45-.78-1.07-1.45-1.82-1.96L17 4.41 15.59 3l-2.17 2.17C12.96 5.06 12.49 5 12 5c-.49 0-.96.06-1.41.17L8.41 3 7 4.41l1.62 1.63C7.88 6.55 7.26 7.22 6.81 8H4v2h2.09c-.05.33-.09.66-.09 1v1H4v2h2v1c0 .34.04.67.09 1H4v2h2.81c1.04 1.79 2.97 3 5.19 3s4.15-1.21 5.19-3H20v-2h-2.09c.05-.33.09-.66.09-1v-1h2v-2h-2v-1c0-.34-.04-.67-.09-1H20V8zm-6 8h-4v-2h4v2zm0-4h-4v-2h4v2z"
            })), 'BugReport');

            exports.default = _default;
            });

            unwrapExports$1(BugReport);

            var Build = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M22.7 19l-9.1-9.1c.9-2.3.4-5-1.5-6.9-2-2-5-2.4-7.4-1.3L9 6 6 9 1.6 4.7C.4 7.1.9 10.1 2.9 12.1c1.9 1.9 4.6 2.4 6.9 1.5l9.1 9.1c.4.4 1 .4 1.4 0l2.3-2.3c.5-.4.5-1.1.1-1.4z"
            })), 'Build');

            exports.default = _default;
            });

            unwrapExports$1(Build);

            var BurstMode = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M1 5h2v14H1zm4 0h2v14H5zm17 0H10c-.55 0-1 .45-1 1v12c0 .55.45 1 1 1h12c.55 0 1-.45 1-1V6c0-.55-.45-1-1-1zM11 17l2.5-3.15L15.29 16l2.5-3.22L21 17H11z"
            })), 'BurstMode');

            exports.default = _default;
            });

            unwrapExports$1(BurstMode);

            var Business = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M12 7V3H2v18h20V7H12zM6 19H4v-2h2v2zm0-4H4v-2h2v2zm0-4H4V9h2v2zm0-4H4V5h2v2zm4 12H8v-2h2v2zm0-4H8v-2h2v2zm0-4H8V9h2v2zm0-4H8V5h2v2zm10 12h-8v-2h2v-2h-2v-2h2v-2h-2V9h8v10zm-2-8h-2v2h2v-2zm0 4h-2v2h2v-2z"
            })), 'Business');

            exports.default = _default;
            });

            unwrapExports$1(Business);

            var BusinessCenter = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M10 16v-1H3.01L3 19c0 1.11.89 2 2 2h14c1.11 0 2-.89 2-2v-4h-7v1h-4zm10-9h-4.01V5l-2-2h-4l-2 2v2H4c-1.1 0-2 .9-2 2v3c0 1.11.89 2 2 2h6v-2h4v2h6c1.1 0 2-.9 2-2V9c0-1.1-.9-2-2-2zm-6 0h-4V5h4v2z"
            })), 'BusinessCenter');

            exports.default = _default;
            });

            unwrapExports$1(BusinessCenter);

            var Cached = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M19 8l-4 4h3c0 3.31-2.69 6-6 6-1.01 0-1.97-.25-2.8-.7l-1.46 1.46C8.97 19.54 10.43 20 12 20c4.42 0 8-3.58 8-8h3l-4-4zM6 12c0-3.31 2.69-6 6-6 1.01 0 1.97.25 2.8.7l1.46-1.46C15.03 4.46 13.57 4 12 4c-4.42 0-8 3.58-8 8H1l4 4 4-4H6z"
            })), 'Cached');

            exports.default = _default;
            });

            unwrapExports$1(Cached);

            var Cake = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M12 6c1.11 0 2-.9 2-2 0-.38-.1-.73-.29-1.03L12 0l-1.71 2.97c-.19.3-.29.65-.29 1.03 0 1.1.9 2 2 2zm4.6 9.99l-1.07-1.07-1.08 1.07c-1.3 1.3-3.58 1.31-4.89 0l-1.07-1.07-1.09 1.07C6.75 16.64 5.88 17 4.96 17c-.73 0-1.4-.23-1.96-.61V21c0 .55.45 1 1 1h16c.55 0 1-.45 1-1v-4.61c-.56.38-1.23.61-1.96.61-.92 0-1.79-.36-2.44-1.01zM18 9h-5V7h-2v2H6c-1.66 0-3 1.34-3 3v1.54c0 1.08.88 1.96 1.96 1.96.52 0 1.02-.2 1.38-.57l2.14-2.13 2.13 2.13c.74.74 2.03.74 2.77 0l2.14-2.13 2.13 2.13c.37.37.86.57 1.38.57 1.08 0 1.96-.88 1.96-1.96V12C21 10.34 19.66 9 18 9z"
            })), 'Cake');

            exports.default = _default;
            });

            unwrapExports$1(Cake);

            var Call = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M6.62 10.79c1.44 2.83 3.76 5.14 6.59 6.59l2.2-2.2c.27-.27.67-.36 1.02-.24 1.12.37 2.33.57 3.57.57.55 0 1 .45 1 1V20c0 .55-.45 1-1 1-9.39 0-17-7.61-17-17 0-.55.45-1 1-1h3.5c.55 0 1 .45 1 1 0 1.25.2 2.45.57 3.57.11.35.03.74-.25 1.02l-2.2 2.2z"
            })), 'Call');

            exports.default = _default;
            });

            unwrapExports$1(Call);

            var CallEnd = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M12 9c-1.6 0-3.15.25-4.6.72v3.1c0 .39-.23.74-.56.9-.98.49-1.87 1.12-2.66 1.85-.18.18-.43.28-.7.28-.28 0-.53-.11-.71-.29L.29 13.08c-.18-.17-.29-.42-.29-.7 0-.28.11-.53.29-.71C3.34 8.78 7.46 7 12 7s8.66 1.78 11.71 4.67c.18.18.29.43.29.71 0 .28-.11.53-.29.71l-2.48 2.48c-.18.18-.43.29-.71.29-.27 0-.52-.11-.7-.28-.79-.74-1.69-1.36-2.67-1.85-.33-.16-.56-.5-.56-.9v-3.1C15.15 9.25 13.6 9 12 9z"
            })), 'CallEnd');

            exports.default = _default;
            });

            unwrapExports$1(CallEnd);

            var CallMade = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M9 5v2h6.59L4 18.59 5.41 20 17 8.41V15h2V5z"
            })), 'CallMade');

            exports.default = _default;
            });

            unwrapExports$1(CallMade);

            var CallMerge = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M17 20.41L18.41 19 15 15.59 13.59 17 17 20.41zM7.5 8H11v5.59L5.59 19 7 20.41l6-6V8h3.5L12 3.5 7.5 8z"
            })), 'CallMerge');

            exports.default = _default;
            });

            unwrapExports$1(CallMerge);

            var CallMissed = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M19.59 7L12 14.59 6.41 9H11V7H3v8h2v-4.59l7 7 9-9z"
            })), 'CallMissed');

            exports.default = _default;
            });

            unwrapExports$1(CallMissed);

            var CallMissedOutgoing = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M3 8.41l9 9 7-7V15h2V7h-8v2h4.59L12 14.59 4.41 7 3 8.41z"
            })), 'CallMissedOutgoing');

            exports.default = _default;
            });

            unwrapExports$1(CallMissedOutgoing);

            var CallReceived = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M20 5.41L18.59 4 7 15.59V9H5v10h10v-2H8.41z"
            })), 'CallReceived');

            exports.default = _default;
            });

            unwrapExports$1(CallReceived);

            var CallSplit = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M14 4l2.29 2.29-2.88 2.88 1.42 1.42 2.88-2.88L20 10V4zm-4 0H4v6l2.29-2.29 4.71 4.7V20h2v-8.41l-5.29-5.3z"
            })), 'CallSplit');

            exports.default = _default;
            });

            unwrapExports$1(CallSplit);

            var CallToAction = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M21 3H3c-1.1 0-2 .9-2 2v14c0 1.1.9 2 2 2h18c1.1 0 2-.9 2-2V5c0-1.1-.9-2-2-2zm0 16H3v-3h18v3z"
            })), 'CallToAction');

            exports.default = _default;
            });

            unwrapExports$1(CallToAction);

            var Camera = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M9.4 10.5l4.77-8.26C13.47 2.09 12.75 2 12 2c-2.4 0-4.6.85-6.32 2.25l3.66 6.35.06-.1zM21.54 9c-.92-2.92-3.15-5.26-6-6.34L11.88 9h9.66zm.26 1h-7.49l.29.5 4.76 8.25C21 16.97 22 14.61 22 12c0-.69-.07-1.35-.2-2zM8.54 12l-3.9-6.75C3.01 7.03 2 9.39 2 12c0 .69.07 1.35.2 2h7.49l-1.15-2zm-6.08 3c.92 2.92 3.15 5.26 6 6.34L12.12 15H2.46zm11.27 0l-3.9 6.76c.7.15 1.42.24 2.17.24 2.4 0 4.6-.85 6.32-2.25l-3.66-6.35-.93 1.6z"
            })), 'Camera');

            exports.default = _default;
            });

            unwrapExports$1(Camera);

            var CameraAlt = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("circle", {
              cx: "12",
              cy: "12",
              r: "3.2"
            }), _react.default.createElement("path", {
              d: "M9 2L7.17 4H4c-1.1 0-2 .9-2 2v12c0 1.1.9 2 2 2h16c1.1 0 2-.9 2-2V6c0-1.1-.9-2-2-2h-3.17L15 2H9zm3 15c-2.76 0-5-2.24-5-5s2.24-5 5-5 5 2.24 5 5-2.24 5-5 5z"
            })), 'CameraAlt');

            exports.default = _default;
            });

            unwrapExports$1(CameraAlt);

            var CameraEnhance = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M9 3L7.17 5H4c-1.1 0-2 .9-2 2v12c0 1.1.9 2 2 2h16c1.1 0 2-.9 2-2V7c0-1.1-.9-2-2-2h-3.17L15 3H9zm3 15c-2.76 0-5-2.24-5-5s2.24-5 5-5 5 2.24 5 5-2.24 5-5 5zm0-1l1.25-2.75L16 13l-2.75-1.25L12 9l-1.25 2.75L8 13l2.75 1.25z"
            })), 'CameraEnhance');

            exports.default = _default;
            });

            unwrapExports$1(CameraEnhance);

            var CameraFront = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M10 20H5v2h5v2l3-3-3-3v2zm4 0v2h5v-2h-5zM12 8c1.1 0 2-.9 2-2s-.9-2-2-2-1.99.9-1.99 2S10.9 8 12 8zm5-8H7C5.9 0 5 .9 5 2v14c0 1.1.9 2 2 2h10c1.1 0 2-.9 2-2V2c0-1.1-.9-2-2-2zM7 2h10v10.5c0-1.67-3.33-2.5-5-2.5s-5 .83-5 2.5V2z"
            })), 'CameraFront');

            exports.default = _default;
            });

            unwrapExports$1(CameraFront);

            var CameraRear = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M10 20H5v2h5v2l3-3-3-3v2zm4 0v2h5v-2h-5zm3-20H7C5.9 0 5 .9 5 2v14c0 1.1.9 2 2 2h10c1.1 0 2-.9 2-2V2c0-1.1-.9-2-2-2zm-5 6c-1.11 0-2-.9-2-2s.89-2 1.99-2 2 .9 2 2C14 5.1 13.1 6 12 6z"
            })), 'CameraRear');

            exports.default = _default;
            });

            unwrapExports$1(CameraRear);

            var CameraRoll = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M14 5c0-1.1-.9-2-2-2h-1V2c0-.55-.45-1-1-1H6c-.55 0-1 .45-1 1v1H4c-1.1 0-2 .9-2 2v15c0 1.1.9 2 2 2h8c1.1 0 2-.9 2-2h8V5h-8zm-2 13h-2v-2h2v2zm0-9h-2V7h2v2zm4 9h-2v-2h2v2zm0-9h-2V7h2v2zm4 9h-2v-2h2v2zm0-9h-2V7h2v2z"
            })), 'CameraRoll');

            exports.default = _default;
            });

            unwrapExports$1(CameraRoll);

            var Cancel = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M12 2C6.47 2 2 6.47 2 12s4.47 10 10 10 10-4.47 10-10S17.53 2 12 2zm5 13.59L15.59 17 12 13.41 8.41 17 7 15.59 10.59 12 7 8.41 8.41 7 12 10.59 15.59 7 17 8.41 13.41 12 17 15.59z"
            })), 'Cancel');

            exports.default = _default;
            });

            unwrapExports$1(Cancel);

            var CardGiftcard = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M20 6h-2.18c.11-.31.18-.65.18-1 0-1.66-1.34-3-3-3-1.05 0-1.96.54-2.5 1.35l-.5.67-.5-.68C10.96 2.54 10.05 2 9 2 7.34 2 6 3.34 6 5c0 .35.07.69.18 1H4c-1.11 0-1.99.89-1.99 2L2 19c0 1.11.89 2 2 2h16c1.11 0 2-.89 2-2V8c0-1.11-.89-2-2-2zm-5-2c.55 0 1 .45 1 1s-.45 1-1 1-1-.45-1-1 .45-1 1-1zM9 4c.55 0 1 .45 1 1s-.45 1-1 1-1-.45-1-1 .45-1 1-1zm11 15H4v-2h16v2zm0-5H4V8h5.08L7 10.83 8.62 12 11 8.76l1-1.36 1 1.36L15.38 12 17 10.83 14.92 8H20v6z"
            })), 'CardGiftcard');

            exports.default = _default;
            });

            unwrapExports$1(CardGiftcard);

            var CardMembership = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M20 2H4c-1.11 0-2 .89-2 2v11c0 1.11.89 2 2 2h4v5l4-2 4 2v-5h4c1.11 0 2-.89 2-2V4c0-1.11-.89-2-2-2zm0 13H4v-2h16v2zm0-5H4V4h16v6z"
            })), 'CardMembership');

            exports.default = _default;
            });

            unwrapExports$1(CardMembership);

            var CardTravel = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M20 6h-3V4c0-1.11-.89-2-2-2H9c-1.11 0-2 .89-2 2v2H4c-1.11 0-2 .89-2 2v11c0 1.11.89 2 2 2h16c1.11 0 2-.89 2-2V8c0-1.11-.89-2-2-2zM9 4h6v2H9V4zm11 15H4v-2h16v2zm0-5H4V8h3v2h2V8h6v2h2V8h3v6z"
            })), 'CardTravel');

            exports.default = _default;
            });

            unwrapExports$1(CardTravel);

            var Casino = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M19 3H5c-1.1 0-2 .9-2 2v14c0 1.1.9 2 2 2h14c1.1 0 2-.9 2-2V5c0-1.1-.9-2-2-2zM7.5 18c-.83 0-1.5-.67-1.5-1.5S6.67 15 7.5 15s1.5.67 1.5 1.5S8.33 18 7.5 18zm0-9C6.67 9 6 8.33 6 7.5S6.67 6 7.5 6 9 6.67 9 7.5 8.33 9 7.5 9zm4.5 4.5c-.83 0-1.5-.67-1.5-1.5s.67-1.5 1.5-1.5 1.5.67 1.5 1.5-.67 1.5-1.5 1.5zm4.5 4.5c-.83 0-1.5-.67-1.5-1.5s.67-1.5 1.5-1.5 1.5.67 1.5 1.5-.67 1.5-1.5 1.5zm0-9c-.83 0-1.5-.67-1.5-1.5S15.67 6 16.5 6s1.5.67 1.5 1.5S17.33 9 16.5 9z"
            })), 'Casino');

            exports.default = _default;
            });

            unwrapExports$1(Casino);

            var Cast = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M21 3H3c-1.1 0-2 .9-2 2v3h2V5h18v14h-7v2h7c1.1 0 2-.9 2-2V5c0-1.1-.9-2-2-2zM1 18v3h3c0-1.66-1.34-3-3-3zm0-4v2c2.76 0 5 2.24 5 5h2c0-3.87-3.13-7-7-7zm0-4v2c4.97 0 9 4.03 9 9h2c0-6.08-4.93-11-11-11z"
            })), 'Cast');

            exports.default = _default;
            });

            unwrapExports$1(Cast);

            var CastConnected = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M1 18v3h3c0-1.66-1.34-3-3-3zm0-4v2c2.76 0 5 2.24 5 5h2c0-3.87-3.13-7-7-7zm18-7H5v1.63c3.96 1.28 7.09 4.41 8.37 8.37H19V7zM1 10v2c4.97 0 9 4.03 9 9h2c0-6.08-4.93-11-11-11zm20-7H3c-1.1 0-2 .9-2 2v3h2V5h18v14h-7v2h7c1.1 0 2-.9 2-2V5c0-1.1-.9-2-2-2z"
            })), 'CastConnected');

            exports.default = _default;
            });

            unwrapExports$1(CastConnected);

            var CenterFocusStrong = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M12 8c-2.21 0-4 1.79-4 4s1.79 4 4 4 4-1.79 4-4-1.79-4-4-4zm-7 7H3v4c0 1.1.9 2 2 2h4v-2H5v-4zM5 5h4V3H5c-1.1 0-2 .9-2 2v4h2V5zm14-2h-4v2h4v4h2V5c0-1.1-.9-2-2-2zm0 16h-4v2h4c1.1 0 2-.9 2-2v-4h-2v4z"
            })), 'CenterFocusStrong');

            exports.default = _default;
            });

            unwrapExports$1(CenterFocusStrong);

            var CenterFocusWeak = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M5 15H3v4c0 1.1.9 2 2 2h4v-2H5v-4zM5 5h4V3H5c-1.1 0-2 .9-2 2v4h2V5zm14-2h-4v2h4v4h2V5c0-1.1-.9-2-2-2zm0 16h-4v2h4c1.1 0 2-.9 2-2v-4h-2v4zM12 8c-2.21 0-4 1.79-4 4s1.79 4 4 4 4-1.79 4-4-1.79-4-4-4zm0 6c-1.1 0-2-.9-2-2s.9-2 2-2 2 .9 2 2-.9 2-2 2z"
            })), 'CenterFocusWeak');

            exports.default = _default;
            });

            unwrapExports$1(CenterFocusWeak);

            var ChangeHistory = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M12 7.77L18.39 18H5.61L12 7.77M12 4L2 20h20L12 4z"
            })), 'ChangeHistory');

            exports.default = _default;
            });

            unwrapExports$1(ChangeHistory);

            var Chat = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M20 2H4c-1.1 0-1.99.9-1.99 2L2 22l4-4h14c1.1 0 2-.9 2-2V4c0-1.1-.9-2-2-2zM6 9h12v2H6V9zm8 5H6v-2h8v2zm4-6H6V6h12v2z"
            })), 'Chat');

            exports.default = _default;
            });

            unwrapExports$1(Chat);

            var ChatBubble = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M20 2H4c-1.1 0-2 .9-2 2v18l4-4h14c1.1 0 2-.9 2-2V4c0-1.1-.9-2-2-2z"
            })), 'ChatBubble');

            exports.default = _default;
            });

            unwrapExports$1(ChatBubble);

            var ChatBubbleOutline = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M20 2H4c-1.1 0-2 .9-2 2v18l4-4h14c1.1 0 2-.9 2-2V4c0-1.1-.9-2-2-2zm0 14H6l-2 2V4h16v12z"
            })), 'ChatBubbleOutline');

            exports.default = _default;
            });

            unwrapExports$1(ChatBubbleOutline);

            var Check = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M9 16.17L4.83 12l-1.42 1.41L9 19 21 7l-1.41-1.41z"
            })), 'Check');

            exports.default = _default;
            });

            unwrapExports$1(Check);

            var CheckBox = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M19 3H5c-1.11 0-2 .9-2 2v14c0 1.1.89 2 2 2h14c1.11 0 2-.9 2-2V5c0-1.1-.89-2-2-2zm-9 14l-5-5 1.41-1.41L10 14.17l7.59-7.59L19 8l-9 9z"
            })), 'CheckBox');

            exports.default = _default;
            });

            unwrapExports$1(CheckBox);

            var CheckBoxOutlineBlank = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M19 5v14H5V5h14m0-2H5c-1.1 0-2 .9-2 2v14c0 1.1.9 2 2 2h14c1.1 0 2-.9 2-2V5c0-1.1-.9-2-2-2z"
            })), 'CheckBoxOutlineBlank');

            exports.default = _default;
            });

            unwrapExports$1(CheckBoxOutlineBlank);

            var CheckCircle = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M12 2C6.48 2 2 6.48 2 12s4.48 10 10 10 10-4.48 10-10S17.52 2 12 2zm-2 15l-5-5 1.41-1.41L10 14.17l7.59-7.59L19 8l-9 9z"
            })), 'CheckCircle');

            exports.default = _default;
            });

            unwrapExports$1(CheckCircle);

            var ChevronLeft = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M15.41 7.41L14 6l-6 6 6 6 1.41-1.41L10.83 12z"
            })), 'ChevronLeft');

            exports.default = _default;
            });

            unwrapExports$1(ChevronLeft);

            var ChevronRight = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M10 6L8.59 7.41 13.17 12l-4.58 4.59L10 18l6-6z"
            })), 'ChevronRight');

            exports.default = _default;
            });

            unwrapExports$1(ChevronRight);

            var ChildCare = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("circle", {
              cx: "14.5",
              cy: "10.5",
              r: "1.25"
            }), _react.default.createElement("circle", {
              cx: "9.5",
              cy: "10.5",
              r: "1.25"
            }), _react.default.createElement("path", {
              d: "M22.94 12.66c.04-.21.06-.43.06-.66s-.02-.45-.06-.66c-.25-1.51-1.36-2.74-2.81-3.17-.53-1.12-1.28-2.1-2.19-2.91C16.36 3.85 14.28 3 12 3s-4.36.85-5.94 2.26c-.92.81-1.67 1.8-2.19 2.91-1.45.43-2.56 1.65-2.81 3.17-.04.21-.06.43-.06.66s.02.45.06.66c.25 1.51 1.36 2.74 2.81 3.17.52 1.11 1.27 2.09 2.17 2.89C7.62 20.14 9.71 21 12 21s4.38-.86 5.97-2.28c.9-.8 1.65-1.79 2.17-2.89 1.44-.43 2.55-1.65 2.8-3.17zM19 14c-.1 0-.19-.02-.29-.03-.2.67-.49 1.29-.86 1.86C16.6 17.74 14.45 19 12 19s-4.6-1.26-5.85-3.17c-.37-.57-.66-1.19-.86-1.86-.1.01-.19.03-.29.03-1.1 0-2-.9-2-2s.9-2 2-2c.1 0 .19.02.29.03.2-.67.49-1.29.86-1.86C7.4 6.26 9.55 5 12 5s4.6 1.26 5.85 3.17c.37.57.66 1.19.86 1.86.1-.01.19-.03.29-.03 1.1 0 2 .9 2 2s-.9 2-2 2zM7.5 14c.76 1.77 2.49 3 4.5 3s3.74-1.23 4.5-3h-9z"
            })), 'ChildCare');

            exports.default = _default;
            });

            unwrapExports$1(ChildCare);

            var ChildFriendly = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M13 2v8h8c0-4.42-3.58-8-8-8zm6.32 13.89C20.37 14.54 21 12.84 21 11H6.44l-.95-2H2v2h2.22s1.89 4.07 2.12 4.42c-1.1.59-1.84 1.75-1.84 3.08C4.5 20.43 6.07 22 8 22c1.76 0 3.22-1.3 3.46-3h2.08c.24 1.7 1.7 3 3.46 3 1.93 0 3.5-1.57 3.5-3.5 0-1.04-.46-1.97-1.18-2.61zM8 20c-.83 0-1.5-.67-1.5-1.5S7.17 17 8 17s1.5.67 1.5 1.5S8.83 20 8 20zm9 0c-.83 0-1.5-.67-1.5-1.5S16.17 17 17 17s1.5.67 1.5 1.5S17.83 20 17 20z"
            })), 'ChildFriendly');

            exports.default = _default;
            });

            unwrapExports$1(ChildFriendly);

            var ChromeReaderMode = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M13 12h7v1.5h-7zm0-2.5h7V11h-7zm0 5h7V16h-7zM21 4H3c-1.1 0-2 .9-2 2v13c0 1.1.9 2 2 2h18c1.1 0 2-.9 2-2V6c0-1.1-.9-2-2-2zm0 15h-9V6h9v13z"
            })), 'ChromeReaderMode');

            exports.default = _default;
            });

            unwrapExports$1(ChromeReaderMode);

            var Class = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M18 2H6c-1.1 0-2 .9-2 2v16c0 1.1.9 2 2 2h12c1.1 0 2-.9 2-2V4c0-1.1-.9-2-2-2zM6 4h5v8l-2.5-1.5L6 12V4z"
            })), 'Class');

            exports.default = _default;
            });

            unwrapExports$1(Class);

            var Clear = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M19 6.41L17.59 5 12 10.59 6.41 5 5 6.41 10.59 12 5 17.59 6.41 19 12 13.41 17.59 19 19 17.59 13.41 12z"
            })), 'Clear');

            exports.default = _default;
            });

            unwrapExports$1(Clear);

            var ClearAll = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M5 13h14v-2H5v2zm-2 4h14v-2H3v2zM7 7v2h14V7H7z"
            })), 'ClearAll');

            exports.default = _default;
            });

            unwrapExports$1(ClearAll);

            var Close = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M19 6.41L17.59 5 12 10.59 6.41 5 5 6.41 10.59 12 5 17.59 6.41 19 12 13.41 17.59 19 19 17.59 13.41 12z"
            })), 'Close');

            exports.default = _default;
            });

            var Close$1 = unwrapExports$1(Close);

            var ClosedCaption = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M19 4H5c-1.11 0-2 .9-2 2v12c0 1.1.89 2 2 2h14c1.1 0 2-.9 2-2V6c0-1.1-.9-2-2-2zm-8 7H9.5v-.5h-2v3h2V13H11v1c0 .55-.45 1-1 1H7c-.55 0-1-.45-1-1v-4c0-.55.45-1 1-1h3c.55 0 1 .45 1 1v1zm7 0h-1.5v-.5h-2v3h2V13H18v1c0 .55-.45 1-1 1h-3c-.55 0-1-.45-1-1v-4c0-.55.45-1 1-1h3c.55 0 1 .45 1 1v1z"
            })), 'ClosedCaption');

            exports.default = _default;
            });

            unwrapExports$1(ClosedCaption);

            var Cloud = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M19.35 10.04C18.67 6.59 15.64 4 12 4 9.11 4 6.6 5.64 5.35 8.04 2.34 8.36 0 10.91 0 14c0 3.31 2.69 6 6 6h13c2.76 0 5-2.24 5-5 0-2.64-2.05-4.78-4.65-4.96z"
            })), 'Cloud');

            exports.default = _default;
            });

            unwrapExports$1(Cloud);

            var CloudCircle = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M12 2C6.48 2 2 6.48 2 12s4.48 10 10 10 10-4.48 10-10S17.52 2 12 2zm4.5 14H8c-1.66 0-3-1.34-3-3s1.34-3 3-3l.14.01C8.58 8.28 10.13 7 12 7c2.21 0 4 1.79 4 4h.5c1.38 0 2.5 1.12 2.5 2.5S17.88 16 16.5 16z"
            })), 'CloudCircle');

            exports.default = _default;
            });

            unwrapExports$1(CloudCircle);

            var CloudDone = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M19.35 10.04C18.67 6.59 15.64 4 12 4 9.11 4 6.6 5.64 5.35 8.04 2.34 8.36 0 10.91 0 14c0 3.31 2.69 6 6 6h13c2.76 0 5-2.24 5-5 0-2.64-2.05-4.78-4.65-4.96zM10 17l-3.5-3.5 1.41-1.41L10 14.17 15.18 9l1.41 1.41L10 17z"
            })), 'CloudDone');

            exports.default = _default;
            });

            unwrapExports$1(CloudDone);

            var CloudDownload = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M19.35 10.04C18.67 6.59 15.64 4 12 4 9.11 4 6.6 5.64 5.35 8.04 2.34 8.36 0 10.91 0 14c0 3.31 2.69 6 6 6h13c2.76 0 5-2.24 5-5 0-2.64-2.05-4.78-4.65-4.96zM17 13l-5 5-5-5h3V9h4v4h3z"
            })), 'CloudDownload');

            exports.default = _default;
            });

            unwrapExports$1(CloudDownload);

            var CloudOff = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M19.35 10.04C18.67 6.59 15.64 4 12 4c-1.48 0-2.85.43-4.01 1.17l1.46 1.46C10.21 6.23 11.08 6 12 6c3.04 0 5.5 2.46 5.5 5.5v.5H19c1.66 0 3 1.34 3 3 0 1.13-.64 2.11-1.56 2.62l1.45 1.45C23.16 18.16 24 16.68 24 15c0-2.64-2.05-4.78-4.65-4.96zM3 5.27l2.75 2.74C2.56 8.15 0 10.77 0 14c0 3.31 2.69 6 6 6h11.73l2 2L21 20.73 4.27 4 3 5.27zM7.73 10l8 8H6c-2.21 0-4-1.79-4-4s1.79-4 4-4h1.73z"
            })), 'CloudOff');

            exports.default = _default;
            });

            unwrapExports$1(CloudOff);

            var CloudQueue = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M19.35 10.04C18.67 6.59 15.64 4 12 4 9.11 4 6.6 5.64 5.35 8.04 2.34 8.36 0 10.91 0 14c0 3.31 2.69 6 6 6h13c2.76 0 5-2.24 5-5 0-2.64-2.05-4.78-4.65-4.96zM19 18H6c-2.21 0-4-1.79-4-4s1.79-4 4-4h.71C7.37 7.69 9.48 6 12 6c3.04 0 5.5 2.46 5.5 5.5v.5H19c1.66 0 3 1.34 3 3s-1.34 3-3 3z"
            })), 'CloudQueue');

            exports.default = _default;
            });

            unwrapExports$1(CloudQueue);

            var CloudUpload = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M19.35 10.04C18.67 6.59 15.64 4 12 4 9.11 4 6.6 5.64 5.35 8.04 2.34 8.36 0 10.91 0 14c0 3.31 2.69 6 6 6h13c2.76 0 5-2.24 5-5 0-2.64-2.05-4.78-4.65-4.96zM14 13v4h-4v-4H7l5-5 5 5h-3z"
            })), 'CloudUpload');

            exports.default = _default;
            });

            unwrapExports$1(CloudUpload);

            var Code = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M9.4 16.6L4.8 12l4.6-4.6L8 6l-6 6 6 6 1.4-1.4zm5.2 0l4.6-4.6-4.6-4.6L16 6l6 6-6 6-1.4-1.4z"
            })), 'Code');

            exports.default = _default;
            });

            unwrapExports$1(Code);

            var Collections = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M22 16V4c0-1.1-.9-2-2-2H8c-1.1 0-2 .9-2 2v12c0 1.1.9 2 2 2h12c1.1 0 2-.9 2-2zm-11-4l2.03 2.71L16 11l4 5H8l3-4zM2 6v14c0 1.1.9 2 2 2h14v-2H4V6H2z"
            })), 'Collections');

            exports.default = _default;
            });

            unwrapExports$1(Collections);

            var CollectionsBookmark = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M4 6H2v14c0 1.1.9 2 2 2h14v-2H4V6zm16-4H8c-1.1 0-2 .9-2 2v12c0 1.1.9 2 2 2h12c1.1 0 2-.9 2-2V4c0-1.1-.9-2-2-2zm0 10l-2.5-1.5L15 12V4h5v8z"
            })), 'CollectionsBookmark');

            exports.default = _default;
            });

            unwrapExports$1(CollectionsBookmark);

            var Colorize = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M20.71 5.63l-2.34-2.34c-.39-.39-1.02-.39-1.41 0l-3.12 3.12-1.93-1.91-1.41 1.41 1.42 1.42L3 16.25V21h4.75l8.92-8.92 1.42 1.42 1.41-1.41-1.92-1.92 3.12-3.12c.4-.4.4-1.03.01-1.42zM6.92 19L5 17.08l8.06-8.06 1.92 1.92L6.92 19z"
            })), 'Colorize');

            exports.default = _default;
            });

            unwrapExports$1(Colorize);

            var ColorLens = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M12 3c-4.97 0-9 4.03-9 9s4.03 9 9 9c.83 0 1.5-.67 1.5-1.5 0-.39-.15-.74-.39-1.01-.23-.26-.38-.61-.38-.99 0-.83.67-1.5 1.5-1.5H16c2.76 0 5-2.24 5-5 0-4.42-4.03-8-9-8zm-5.5 9c-.83 0-1.5-.67-1.5-1.5S5.67 9 6.5 9 8 9.67 8 10.5 7.33 12 6.5 12zm3-4C8.67 8 8 7.33 8 6.5S8.67 5 9.5 5s1.5.67 1.5 1.5S10.33 8 9.5 8zm5 0c-.83 0-1.5-.67-1.5-1.5S13.67 5 14.5 5s1.5.67 1.5 1.5S15.33 8 14.5 8zm3 4c-.83 0-1.5-.67-1.5-1.5S16.67 9 17.5 9s1.5.67 1.5 1.5-.67 1.5-1.5 1.5z"
            })), 'ColorLens');

            exports.default = _default;
            });

            unwrapExports$1(ColorLens);

            var Comment = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M21.99 4c0-1.1-.89-2-1.99-2H4c-1.1 0-2 .9-2 2v12c0 1.1.9 2 2 2h14l4 4-.01-18zM18 14H6v-2h12v2zm0-3H6V9h12v2zm0-3H6V6h12v2z"
            })), 'Comment');

            exports.default = _default;
            });

            unwrapExports$1(Comment);

            var Compare = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M10 3H5c-1.1 0-2 .9-2 2v14c0 1.1.9 2 2 2h5v2h2V1h-2v2zm0 15H5l5-6v6zm9-15h-5v2h5v13l-5-6v9h5c1.1 0 2-.9 2-2V5c0-1.1-.9-2-2-2z"
            })), 'Compare');

            exports.default = _default;
            });

            unwrapExports$1(Compare);

            var CompareArrows = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M9.01 14H2v2h7.01v3L13 15l-3.99-4v3zm5.98-1v-3H22V8h-7.01V5L11 9l3.99 4z"
            })), 'CompareArrows');

            exports.default = _default;
            });

            unwrapExports$1(CompareArrows);

            var Computer = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M20 18c1.1 0 1.99-.9 1.99-2L22 6c0-1.1-.9-2-2-2H4c-1.1 0-2 .9-2 2v10c0 1.1.9 2 2 2H0v2h24v-2h-4zM4 6h16v10H4V6z"
            })), 'Computer');

            exports.default = _default;
            });

            unwrapExports$1(Computer);

            var ConfirmationNumber = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M22 10V6c0-1.11-.9-2-2-2H4c-1.1 0-1.99.89-1.99 2v4c1.1 0 1.99.9 1.99 2s-.89 2-2 2v4c0 1.1.9 2 2 2h16c1.1 0 2-.9 2-2v-4c-1.1 0-2-.9-2-2s.9-2 2-2zm-9 7.5h-2v-2h2v2zm0-4.5h-2v-2h2v2zm0-4.5h-2v-2h2v2z"
            })), 'ConfirmationNumber');

            exports.default = _default;
            });

            unwrapExports$1(ConfirmationNumber);

            var ContactMail = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M21 8V7l-3 2-3-2v1l3 2 3-2zm1-5H2C.9 3 0 3.9 0 5v14c0 1.1.9 2 2 2h20c1.1 0 1.99-.9 1.99-2L24 5c0-1.1-.9-2-2-2zM8 6c1.66 0 3 1.34 3 3s-1.34 3-3 3-3-1.34-3-3 1.34-3 3-3zm6 12H2v-1c0-2 4-3.1 6-3.1s6 1.1 6 3.1v1zm8-6h-8V6h8v6z"
            })), 'ContactMail');

            exports.default = _default;
            });

            unwrapExports$1(ContactMail);

            var ContactPhone = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M22 3H2C.9 3 0 3.9 0 5v14c0 1.1.9 2 2 2h20c1.1 0 1.99-.9 1.99-2L24 5c0-1.1-.9-2-2-2zM8 6c1.66 0 3 1.34 3 3s-1.34 3-3 3-3-1.34-3-3 1.34-3 3-3zm6 12H2v-1c0-2 4-3.1 6-3.1s6 1.1 6 3.1v1zm3.85-4h1.64L21 16l-1.99 1.99c-1.31-.98-2.28-2.38-2.73-3.99-.18-.64-.28-1.31-.28-2s.1-1.36.28-2c.45-1.62 1.42-3.01 2.73-3.99L21 8l-1.51 2h-1.64c-.22.63-.35 1.3-.35 2s.13 1.37.35 2z"
            })), 'ContactPhone');

            exports.default = _default;
            });

            unwrapExports$1(ContactPhone);

            var Contacts = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M20 0H4v2h16V0zM4 24h16v-2H4v2zM20 4H4c-1.1 0-2 .9-2 2v12c0 1.1.9 2 2 2h16c1.1 0 2-.9 2-2V6c0-1.1-.9-2-2-2zm-8 2.75c1.24 0 2.25 1.01 2.25 2.25s-1.01 2.25-2.25 2.25S9.75 10.24 9.75 9 10.76 6.75 12 6.75zM17 17H7v-1.5c0-1.67 3.33-2.5 5-2.5s5 .83 5 2.5V17z"
            })), 'Contacts');

            exports.default = _default;
            });

            unwrapExports$1(Contacts);

            var ContentCopy = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M16 1H4c-1.1 0-2 .9-2 2v14h2V3h12V1zm3 4H8c-1.1 0-2 .9-2 2v14c0 1.1.9 2 2 2h11c1.1 0 2-.9 2-2V7c0-1.1-.9-2-2-2zm0 16H8V7h11v14z"
            })), 'ContentCopy');

            exports.default = _default;
            });

            unwrapExports$1(ContentCopy);

            var ContentCut = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M9.64 7.64c.23-.5.36-1.05.36-1.64 0-2.21-1.79-4-4-4S2 3.79 2 6s1.79 4 4 4c.59 0 1.14-.13 1.64-.36L10 12l-2.36 2.36C7.14 14.13 6.59 14 6 14c-2.21 0-4 1.79-4 4s1.79 4 4 4 4-1.79 4-4c0-.59-.13-1.14-.36-1.64L12 14l7 7h3v-1L9.64 7.64zM6 8c-1.1 0-2-.89-2-2s.9-2 2-2 2 .89 2 2-.9 2-2 2zm0 12c-1.1 0-2-.89-2-2s.9-2 2-2 2 .89 2 2-.9 2-2 2zm6-7.5c-.28 0-.5-.22-.5-.5s.22-.5.5-.5.5.22.5.5-.22.5-.5.5zM19 3l-6 6 2 2 7-7V3z"
            })), 'ContentCut');

            exports.default = _default;
            });

            unwrapExports$1(ContentCut);

            var ContentPaste = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M19 2h-4.18C14.4.84 13.3 0 12 0c-1.3 0-2.4.84-2.82 2H5c-1.1 0-2 .9-2 2v16c0 1.1.9 2 2 2h14c1.1 0 2-.9 2-2V4c0-1.1-.9-2-2-2zm-7 0c.55 0 1 .45 1 1s-.45 1-1 1-1-.45-1-1 .45-1 1-1zm7 18H5V4h2v3h10V4h2v16z"
            })), 'ContentPaste');

            exports.default = _default;
            });

            unwrapExports$1(ContentPaste);

            var ControlPoint = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M13 7h-2v4H7v2h4v4h2v-4h4v-2h-4V7zm-1-5C6.49 2 2 6.49 2 12s4.49 10 10 10 10-4.49 10-10S17.51 2 12 2zm0 18c-4.41 0-8-3.59-8-8s3.59-8 8-8 8 3.59 8 8-3.59 8-8 8z"
            })), 'ControlPoint');

            exports.default = _default;
            });

            unwrapExports$1(ControlPoint);

            var ControlPointDuplicate = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M16 8h-2v3h-3v2h3v3h2v-3h3v-2h-3zM2 12c0-2.79 1.64-5.2 4.01-6.32V3.52C2.52 4.76 0 8.09 0 12s2.52 7.24 6.01 8.48v-2.16C3.64 17.2 2 14.79 2 12zm13-9c-4.96 0-9 4.04-9 9s4.04 9 9 9 9-4.04 9-9-4.04-9-9-9zm0 16c-3.86 0-7-3.14-7-7s3.14-7 7-7 7 3.14 7 7-3.14 7-7 7z"
            })), 'ControlPointDuplicate');

            exports.default = _default;
            });

            unwrapExports$1(ControlPointDuplicate);

            var Copyright = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M10.08 10.86c.05-.33.16-.62.3-.87s.34-.46.59-.62c.24-.15.54-.22.91-.23.23.01.44.05.63.13.2.09.38.21.52.36s.25.33.34.53.13.42.14.64h1.79c-.02-.47-.11-.9-.28-1.29s-.4-.73-.7-1.01-.66-.5-1.08-.66-.88-.23-1.39-.23c-.65 0-1.22.11-1.7.34s-.88.53-1.2.92-.56.84-.71 1.36S8 11.29 8 11.87v.27c0 .58.08 1.12.23 1.64s.39.97.71 1.35.72.69 1.2.91 1.05.34 1.7.34c.47 0 .91-.08 1.32-.23s.77-.36 1.08-.63.56-.58.74-.94.29-.74.3-1.15h-1.79c-.01.21-.06.4-.15.58s-.21.33-.36.46-.32.23-.52.3c-.19.07-.39.09-.6.1-.36-.01-.66-.08-.89-.23-.25-.16-.45-.37-.59-.62s-.25-.55-.3-.88-.08-.67-.08-1v-.27c0-.35.03-.68.08-1.01zM12 2C6.48 2 2 6.48 2 12s4.48 10 10 10 10-4.48 10-10S17.52 2 12 2zm0 18c-4.41 0-8-3.59-8-8s3.59-8 8-8 8 3.59 8 8-3.59 8-8 8z"
            })), 'Copyright');

            exports.default = _default;
            });

            unwrapExports$1(Copyright);

            var Create = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M3 17.25V21h3.75L17.81 9.94l-3.75-3.75L3 17.25zM20.71 7.04c.39-.39.39-1.02 0-1.41l-2.34-2.34c-.39-.39-1.02-.39-1.41 0l-1.83 1.83 3.75 3.75 1.83-1.83z"
            })), 'Create');

            exports.default = _default;
            });

            var Create$1 = unwrapExports$1(Create);

            var CreateNewFolder = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M20 6h-8l-2-2H4c-1.11 0-1.99.89-1.99 2L2 18c0 1.11.89 2 2 2h16c1.11 0 2-.89 2-2V8c0-1.11-.89-2-2-2zm-1 8h-3v3h-2v-3h-3v-2h3V9h2v3h3v2z"
            })), 'CreateNewFolder');

            exports.default = _default;
            });

            unwrapExports$1(CreateNewFolder);

            var CreditCard = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M20 4H4c-1.11 0-1.99.89-1.99 2L2 18c0 1.11.89 2 2 2h16c1.11 0 2-.89 2-2V6c0-1.11-.89-2-2-2zm0 14H4v-6h16v6zm0-10H4V6h16v2z"
            })), 'CreditCard');

            exports.default = _default;
            });

            unwrapExports$1(CreditCard);

            var Crop = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M17 15h2V7c0-1.1-.9-2-2-2H9v2h8v8zM7 17V1H5v4H1v2h4v10c0 1.1.9 2 2 2h10v4h2v-4h4v-2H7z"
            })), 'Crop');

            exports.default = _default;
            });

            unwrapExports$1(Crop);

            var Crop169 = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M19 6H5c-1.1 0-2 .9-2 2v8c0 1.1.9 2 2 2h14c1.1 0 2-.9 2-2V8c0-1.1-.9-2-2-2zm0 10H5V8h14v8z"
            })), 'Crop169');

            exports.default = _default;
            });

            unwrapExports$1(Crop169);

            var Crop32 = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M19 4H5c-1.1 0-2 .9-2 2v12c0 1.1.9 2 2 2h14c1.1 0 2-.9 2-2V6c0-1.1-.9-2-2-2zm0 14H5V6h14v12z"
            })), 'Crop32');

            exports.default = _default;
            });

            unwrapExports$1(Crop32);

            var Crop54 = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M19 5H5c-1.1 0-2 .9-2 2v10c0 1.1.9 2 2 2h14c1.1 0 2-.9 2-2V7c0-1.1-.9-2-2-2zm0 12H5V7h14v10z"
            })), 'Crop54');

            exports.default = _default;
            });

            unwrapExports$1(Crop54);

            var Crop75 = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M19 7H5c-1.1 0-2 .9-2 2v6c0 1.1.9 2 2 2h14c1.1 0 2-.9 2-2V9c0-1.1-.9-2-2-2zm0 8H5V9h14v6z"
            })), 'Crop75');

            exports.default = _default;
            });

            unwrapExports$1(Crop75);

            var CropDin = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M19 3H5c-1.1 0-2 .9-2 2v14c0 1.1.9 2 2 2h14c1.1 0 2-.9 2-2V5c0-1.1-.9-2-2-2zm0 16H5V5h14v14z"
            })), 'CropDin');

            exports.default = _default;
            });

            unwrapExports$1(CropDin);

            var CropFree = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M3 5v4h2V5h4V3H5c-1.1 0-2 .9-2 2zm2 10H3v4c0 1.1.9 2 2 2h4v-2H5v-4zm14 4h-4v2h4c1.1 0 2-.9 2-2v-4h-2v4zm0-16h-4v2h4v4h2V5c0-1.1-.9-2-2-2z"
            })), 'CropFree');

            exports.default = _default;
            });

            unwrapExports$1(CropFree);

            var CropLandscape = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M19 5H5c-1.1 0-2 .9-2 2v10c0 1.1.9 2 2 2h14c1.1 0 2-.9 2-2V7c0-1.1-.9-2-2-2zm0 12H5V7h14v10z"
            })), 'CropLandscape');

            exports.default = _default;
            });

            unwrapExports$1(CropLandscape);

            var CropOriginal = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M19 3H5c-1.1 0-2 .9-2 2v14c0 1.1.9 2 2 2h14c1.1 0 2-.9 2-2V5c0-1.1-.9-2-2-2zm0 16H5V5h14v14zm-5.04-6.71l-2.75 3.54-1.96-2.36L6.5 17h11l-3.54-4.71z"
            })), 'CropOriginal');

            exports.default = _default;
            });

            unwrapExports$1(CropOriginal);

            var CropPortrait = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M17 3H7c-1.1 0-2 .9-2 2v14c0 1.1.9 2 2 2h10c1.1 0 2-.9 2-2V5c0-1.1-.9-2-2-2zm0 16H7V5h10v14z"
            })), 'CropPortrait');

            exports.default = _default;
            });

            unwrapExports$1(CropPortrait);

            var CropRotate = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M7.47 21.49C4.2 19.93 1.86 16.76 1.5 13H0c.51 6.16 5.66 11 11.95 11 .23 0 .44-.02.66-.03L8.8 20.15l-1.33 1.34zM12.05 0c-.23 0-.44.02-.66.04l3.81 3.81 1.33-1.33C19.8 4.07 22.14 7.24 22.5 11H24c-.51-6.16-5.66-11-11.95-11zM16 14h2V8c0-1.11-.9-2-2-2h-6v2h6v6zm-8 2V4H6v2H4v2h2v8c0 1.1.89 2 2 2h8v2h2v-2h2v-2H8z"
            })), 'CropRotate');

            exports.default = _default;
            });

            unwrapExports$1(CropRotate);

            var CropSquare = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M18 4H6c-1.1 0-2 .9-2 2v12c0 1.1.9 2 2 2h12c1.1 0 2-.9 2-2V6c0-1.1-.9-2-2-2zm0 14H6V6h12v12z"
            })), 'CropSquare');

            exports.default = _default;
            });

            unwrapExports$1(CropSquare);

            var Dashboard = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M3 13h8V3H3v10zm0 8h8v-6H3v6zm10 0h8V11h-8v10zm0-18v6h8V3h-8z"
            })), 'Dashboard');

            exports.default = _default;
            });

            unwrapExports$1(Dashboard);

            var DataUsage = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M13 2.05v3.03c3.39.49 6 3.39 6 6.92 0 .9-.18 1.75-.48 2.54l2.6 1.53c.56-1.24.88-2.62.88-4.07 0-5.18-3.95-9.45-9-9.95zM12 19c-3.87 0-7-3.13-7-7 0-3.53 2.61-6.43 6-6.92V2.05c-5.06.5-9 4.76-9 9.95 0 5.52 4.47 10 9.99 10 3.31 0 6.24-1.61 8.06-4.09l-2.6-1.53C16.17 17.98 14.21 19 12 19z"
            })), 'DataUsage');

            exports.default = _default;
            });

            unwrapExports$1(DataUsage);

            var DateRange = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M9 11H7v2h2v-2zm4 0h-2v2h2v-2zm4 0h-2v2h2v-2zm2-7h-1V2h-2v2H8V2H6v2H5c-1.11 0-1.99.9-1.99 2L3 20c0 1.1.89 2 2 2h14c1.1 0 2-.9 2-2V6c0-1.1-.9-2-2-2zm0 16H5V9h14v11z"
            })), 'DateRange');

            exports.default = _default;
            });

            unwrapExports$1(DateRange);

            var Dehaze = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M2 15.5v2h20v-2H2zm0-5v2h20v-2H2zm0-5v2h20v-2H2z"
            })), 'Dehaze');

            exports.default = _default;
            });

            unwrapExports$1(Dehaze);

            var Delete = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M6 19c0 1.1.9 2 2 2h8c1.1 0 2-.9 2-2V7H6v12zM19 4h-3.5l-1-1h-5l-1 1H5v2h14V4z"
            })), 'Delete');

            exports.default = _default;
            });

            unwrapExports$1(Delete);

            var DeleteForever = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M6 19c0 1.1.9 2 2 2h8c1.1 0 2-.9 2-2V7H6v12zm2.46-7.12l1.41-1.41L12 12.59l2.12-2.12 1.41 1.41L13.41 14l2.12 2.12-1.41 1.41L12 15.41l-2.12 2.12-1.41-1.41L10.59 14l-2.13-2.12zM15.5 4l-1-1h-5l-1 1H5v2h14V4z"
            })), 'DeleteForever');

            exports.default = _default;
            });

            unwrapExports$1(DeleteForever);

            var DeleteSweep = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M15 16h4v2h-4zm0-8h7v2h-7zm0 4h6v2h-6zM3 18c0 1.1.9 2 2 2h6c1.1 0 2-.9 2-2V8H3v10zM14 5h-3l-1-1H6L5 5H2v2h12z"
            })), 'DeleteSweep');

            exports.default = _default;
            });

            unwrapExports$1(DeleteSweep);

            var Description = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M14 2H6c-1.1 0-1.99.9-1.99 2L4 20c0 1.1.89 2 1.99 2H18c1.1 0 2-.9 2-2V8l-6-6zm2 16H8v-2h8v2zm0-4H8v-2h8v2zm-3-5V3.5L18.5 9H13z"
            })), 'Description');

            exports.default = _default;
            });

            unwrapExports$1(Description);

            var DesktopMac = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M21 2H3c-1.1 0-2 .9-2 2v12c0 1.1.9 2 2 2h7l-2 3v1h8v-1l-2-3h7c1.1 0 2-.9 2-2V4c0-1.1-.9-2-2-2zm0 12H3V4h18v10z"
            })), 'DesktopMac');

            exports.default = _default;
            });

            unwrapExports$1(DesktopMac);

            var DesktopWindows = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M21 2H3c-1.1 0-2 .9-2 2v12c0 1.1.9 2 2 2h7v2H8v2h8v-2h-2v-2h7c1.1 0 2-.9 2-2V4c0-1.1-.9-2-2-2zm0 14H3V4h18v12z"
            })), 'DesktopWindows');

            exports.default = _default;
            });

            unwrapExports$1(DesktopWindows);

            var Details = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M3 4l9 16 9-16H3zm3.38 2h11.25L12 16 6.38 6z"
            })), 'Details');

            exports.default = _default;
            });

            unwrapExports$1(Details);

            var DeveloperBoard = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M22 9V7h-2V5c0-1.1-.9-2-2-2H4c-1.1 0-2 .9-2 2v14c0 1.1.9 2 2 2h14c1.1 0 2-.9 2-2v-2h2v-2h-2v-2h2v-2h-2V9h2zm-4 10H4V5h14v14zM6 13h5v4H6zm6-6h4v3h-4zM6 7h5v5H6zm6 4h4v6h-4z"
            })), 'DeveloperBoard');

            exports.default = _default;
            });

            unwrapExports$1(DeveloperBoard);

            var DeveloperMode = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M7 5h10v2h2V3c0-1.1-.9-1.99-2-1.99L7 1c-1.1 0-2 .9-2 2v4h2V5zm8.41 11.59L20 12l-4.59-4.59L14 8.83 17.17 12 14 15.17l1.41 1.42zM10 15.17L6.83 12 10 8.83 8.59 7.41 4 12l4.59 4.59L10 15.17zM17 19H7v-2H5v4c0 1.1.9 2 2 2h10c1.1 0 2-.9 2-2v-4h-2v2z"
            })), 'DeveloperMode');

            exports.default = _default;
            });

            unwrapExports$1(DeveloperMode);

            var DeviceHub = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M17 16l-4-4V8.82C14.16 8.4 15 7.3 15 6c0-1.66-1.34-3-3-3S9 4.34 9 6c0 1.3.84 2.4 2 2.82V12l-4 4H3v5h5v-3.05l4-4.2 4 4.2V21h5v-5h-4z"
            })), 'DeviceHub');

            exports.default = _default;
            });

            unwrapExports$1(DeviceHub);

            var Devices = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M4 6h18V4H4c-1.1 0-2 .9-2 2v11H0v3h14v-3H4V6zm19 2h-6c-.55 0-1 .45-1 1v10c0 .55.45 1 1 1h6c.55 0 1-.45 1-1V9c0-.55-.45-1-1-1zm-1 9h-4v-7h4v7z"
            })), 'Devices');

            exports.default = _default;
            });

            unwrapExports$1(Devices);

            var DevicesOther = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M3 6h18V4H3c-1.1 0-2 .9-2 2v12c0 1.1.9 2 2 2h4v-2H3V6zm10 6H9v1.78c-.61.55-1 1.33-1 2.22s.39 1.67 1 2.22V20h4v-1.78c.61-.55 1-1.34 1-2.22s-.39-1.67-1-2.22V12zm-2 5.5c-.83 0-1.5-.67-1.5-1.5s.67-1.5 1.5-1.5 1.5.67 1.5 1.5-.67 1.5-1.5 1.5zM22 8h-6c-.5 0-1 .5-1 1v10c0 .5.5 1 1 1h6c.5 0 1-.5 1-1V9c0-.5-.5-1-1-1zm-1 10h-4v-8h4v8z"
            })), 'DevicesOther');

            exports.default = _default;
            });

            unwrapExports$1(DevicesOther);

            var DialerSip = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M17 3h-1v5h1V3zm-2 2h-2V4h2V3h-3v3h2v1h-2v1h3V5zm3-2v5h1V6h2V3h-3zm2 2h-1V4h1v1zm0 10.5c-1.25 0-2.45-.2-3.57-.57-.35-.11-.74-.03-1.01.24l-2.2 2.2c-2.83-1.44-5.15-3.75-6.59-6.59l2.2-2.21c.27-.26.35-.65.24-1C8.7 6.45 8.5 5.25 8.5 4c0-.55-.45-1-1-1H4c-.55 0-1 .45-1 1 0 9.39 7.61 17 17 17 .55 0 1-.45 1-1v-3.5c0-.55-.45-1-1-1z"
            })), 'DialerSip');

            exports.default = _default;
            });

            unwrapExports$1(DialerSip);

            var Dialpad = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M12 19c-1.1 0-2 .9-2 2s.9 2 2 2 2-.9 2-2-.9-2-2-2zM6 1c-1.1 0-2 .9-2 2s.9 2 2 2 2-.9 2-2-.9-2-2-2zm0 6c-1.1 0-2 .9-2 2s.9 2 2 2 2-.9 2-2-.9-2-2-2zm0 6c-1.1 0-2 .9-2 2s.9 2 2 2 2-.9 2-2-.9-2-2-2zm12-8c1.1 0 2-.9 2-2s-.9-2-2-2-2 .9-2 2 .9 2 2 2zm-6 8c-1.1 0-2 .9-2 2s.9 2 2 2 2-.9 2-2-.9-2-2-2zm6 0c-1.1 0-2 .9-2 2s.9 2 2 2 2-.9 2-2-.9-2-2-2zm0-6c-1.1 0-2 .9-2 2s.9 2 2 2 2-.9 2-2-.9-2-2-2zm-6 0c-1.1 0-2 .9-2 2s.9 2 2 2 2-.9 2-2-.9-2-2-2zm0-6c-1.1 0-2 .9-2 2s.9 2 2 2 2-.9 2-2-.9-2-2-2z"
            })), 'Dialpad');

            exports.default = _default;
            });

            unwrapExports$1(Dialpad);

            var Directions = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M21.71 11.29l-9-9c-.39-.39-1.02-.39-1.41 0l-9 9c-.39.39-.39 1.02 0 1.41l9 9c.39.39 1.02.39 1.41 0l9-9c.39-.38.39-1.01 0-1.41zM14 14.5V12h-4v3H8v-4c0-.55.45-1 1-1h5V7.5l3.5 3.5-3.5 3.5z"
            })), 'Directions');

            exports.default = _default;
            });

            unwrapExports$1(Directions);

            var DirectionsBike = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M15.5 5.5c1.1 0 2-.9 2-2s-.9-2-2-2-2 .9-2 2 .9 2 2 2zM5 12c-2.8 0-5 2.2-5 5s2.2 5 5 5 5-2.2 5-5-2.2-5-5-5zm0 8.5c-1.9 0-3.5-1.6-3.5-3.5s1.6-3.5 3.5-3.5 3.5 1.6 3.5 3.5-1.6 3.5-3.5 3.5zm5.8-10l2.4-2.4.8.8c1.3 1.3 3 2.1 5.1 2.1V9c-1.5 0-2.7-.6-3.6-1.5l-1.9-1.9c-.5-.4-1-.6-1.6-.6s-1.1.2-1.4.6L7.8 8.4c-.4.4-.6.9-.6 1.4 0 .6.2 1.1.6 1.4L11 14v5h2v-6.2l-2.2-2.3zM19 12c-2.8 0-5 2.2-5 5s2.2 5 5 5 5-2.2 5-5-2.2-5-5-5zm0 8.5c-1.9 0-3.5-1.6-3.5-3.5s1.6-3.5 3.5-3.5 3.5 1.6 3.5 3.5-1.6 3.5-3.5 3.5z"
            })), 'DirectionsBike');

            exports.default = _default;
            });

            unwrapExports$1(DirectionsBike);

            var DirectionsBoat = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M20 21c-1.39 0-2.78-.47-4-1.32-2.44 1.71-5.56 1.71-8 0C6.78 20.53 5.39 21 4 21H2v2h2c1.38 0 2.74-.35 4-.99 2.52 1.29 5.48 1.29 8 0 1.26.65 2.62.99 4 .99h2v-2h-2zM3.95 19H4c1.6 0 3.02-.88 4-2 .98 1.12 2.4 2 4 2s3.02-.88 4-2c.98 1.12 2.4 2 4 2h.05l1.89-6.68c.08-.26.06-.54-.06-.78s-.34-.42-.6-.5L20 10.62V6c0-1.1-.9-2-2-2h-3V1H9v3H6c-1.1 0-2 .9-2 2v4.62l-1.29.42c-.26.08-.48.26-.6.5s-.15.52-.06.78L3.95 19zM6 6h12v3.97L12 8 6 9.97V6z"
            })), 'DirectionsBoat');

            exports.default = _default;
            });

            unwrapExports$1(DirectionsBoat);

            var DirectionsBus = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M4 16c0 .88.39 1.67 1 2.22V20c0 .55.45 1 1 1h1c.55 0 1-.45 1-1v-1h8v1c0 .55.45 1 1 1h1c.55 0 1-.45 1-1v-1.78c.61-.55 1-1.34 1-2.22V6c0-3.5-3.58-4-8-4s-8 .5-8 4v10zm3.5 1c-.83 0-1.5-.67-1.5-1.5S6.67 14 7.5 14s1.5.67 1.5 1.5S8.33 17 7.5 17zm9 0c-.83 0-1.5-.67-1.5-1.5s.67-1.5 1.5-1.5 1.5.67 1.5 1.5-.67 1.5-1.5 1.5zm1.5-6H6V6h12v5z"
            })), 'DirectionsBus');

            exports.default = _default;
            });

            unwrapExports$1(DirectionsBus);

            var DirectionsCar = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M18.92 6.01C18.72 5.42 18.16 5 17.5 5h-11c-.66 0-1.21.42-1.42 1.01L3 12v8c0 .55.45 1 1 1h1c.55 0 1-.45 1-1v-1h12v1c0 .55.45 1 1 1h1c.55 0 1-.45 1-1v-8l-2.08-5.99zM6.5 16c-.83 0-1.5-.67-1.5-1.5S5.67 13 6.5 13s1.5.67 1.5 1.5S7.33 16 6.5 16zm11 0c-.83 0-1.5-.67-1.5-1.5s.67-1.5 1.5-1.5 1.5.67 1.5 1.5-.67 1.5-1.5 1.5zM5 11l1.5-4.5h11L19 11H5z"
            })), 'DirectionsCar');

            exports.default = _default;
            });

            unwrapExports$1(DirectionsCar);

            var DirectionsRailway = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M4 15.5C4 17.43 5.57 19 7.5 19L6 20.5v.5h12v-.5L16.5 19c1.93 0 3.5-1.57 3.5-3.5V5c0-3.5-3.58-4-8-4s-8 .5-8 4v10.5zm8 1.5c-1.1 0-2-.9-2-2s.9-2 2-2 2 .9 2 2-.9 2-2 2zm6-7H6V5h12v5z"
            })), 'DirectionsRailway');

            exports.default = _default;
            });

            unwrapExports$1(DirectionsRailway);

            var DirectionsRun = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M13.49 5.48c1.1 0 2-.9 2-2s-.9-2-2-2-2 .9-2 2 .9 2 2 2zm-3.6 13.9l1-4.4 2.1 2v6h2v-7.5l-2.1-2 .6-3c1.3 1.5 3.3 2.5 5.5 2.5v-2c-1.9 0-3.5-1-4.3-2.4l-1-1.6c-.4-.6-1-1-1.7-1-.3 0-.5.1-.8.1l-5.2 2.2v4.7h2v-3.4l1.8-.7-1.6 8.1-4.9-1-.4 2 7 1.4z"
            })), 'DirectionsRun');

            exports.default = _default;
            });

            unwrapExports$1(DirectionsRun);

            var DirectionsSubway = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M12 2c-4.42 0-8 .5-8 4v9.5C4 17.43 5.57 19 7.5 19L6 20.5v.5h12v-.5L16.5 19c1.93 0 3.5-1.57 3.5-3.5V6c0-3.5-3.58-4-8-4zM7.5 17c-.83 0-1.5-.67-1.5-1.5S6.67 14 7.5 14s1.5.67 1.5 1.5S8.33 17 7.5 17zm3.5-6H6V6h5v5zm5.5 6c-.83 0-1.5-.67-1.5-1.5s.67-1.5 1.5-1.5 1.5.67 1.5 1.5-.67 1.5-1.5 1.5zm1.5-6h-5V6h5v5z"
            })), 'DirectionsSubway');

            exports.default = _default;
            });

            unwrapExports$1(DirectionsSubway);

            var DirectionsTransit = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M12 2c-4.42 0-8 .5-8 4v9.5C4 17.43 5.57 19 7.5 19L6 20.5v.5h12v-.5L16.5 19c1.93 0 3.5-1.57 3.5-3.5V6c0-3.5-3.58-4-8-4zM7.5 17c-.83 0-1.5-.67-1.5-1.5S6.67 14 7.5 14s1.5.67 1.5 1.5S8.33 17 7.5 17zm3.5-6H6V6h5v5zm5.5 6c-.83 0-1.5-.67-1.5-1.5s.67-1.5 1.5-1.5 1.5.67 1.5 1.5-.67 1.5-1.5 1.5zm1.5-6h-5V6h5v5z"
            })), 'DirectionsTransit');

            exports.default = _default;
            });

            unwrapExports$1(DirectionsTransit);

            var DirectionsWalk = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M13.5 5.5c1.1 0 2-.9 2-2s-.9-2-2-2-2 .9-2 2 .9 2 2 2zM9.8 8.9L7 23h2.1l1.8-8 2.1 2v6h2v-7.5l-2.1-2 .6-3C14.8 12 16.8 13 19 13v-2c-1.9 0-3.5-1-4.3-2.4l-1-1.6c-.4-.6-1-1-1.7-1-.3 0-.5.1-.8.1L6 8.3V13h2V9.6l1.8-.7"
            })), 'DirectionsWalk');

            exports.default = _default;
            });

            unwrapExports$1(DirectionsWalk);

            var DiscFull = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M20 16h2v-2h-2v2zm0-9v5h2V7h-2zM10 4c-4.42 0-8 3.58-8 8s3.58 8 8 8 8-3.58 8-8-3.58-8-8-8zm0 10c-1.1 0-2-.9-2-2s.9-2 2-2 2 .9 2 2-.9 2-2 2z"
            })), 'DiscFull');

            exports.default = _default;
            });

            unwrapExports$1(DiscFull);

            var Dns = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M20 13H4c-.55 0-1 .45-1 1v6c0 .55.45 1 1 1h16c.55 0 1-.45 1-1v-6c0-.55-.45-1-1-1zM7 19c-1.1 0-2-.9-2-2s.9-2 2-2 2 .9 2 2-.9 2-2 2zM20 3H4c-.55 0-1 .45-1 1v6c0 .55.45 1 1 1h16c.55 0 1-.45 1-1V4c0-.55-.45-1-1-1zM7 9c-1.1 0-2-.9-2-2s.9-2 2-2 2 .9 2 2-.9 2-2 2z"
            })), 'Dns');

            exports.default = _default;
            });

            unwrapExports$1(Dns);

            var Dock = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M8 23h8v-2H8v2zm8-21.99L8 1c-1.1 0-2 .9-2 2v14c0 1.1.9 2 2 2h8c1.1 0 2-.9 2-2V3c0-1.1-.9-1.99-2-1.99zM16 15H8V5h8v10z"
            })), 'Dock');

            exports.default = _default;
            });

            unwrapExports$1(Dock);

            var Domain = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M12 7V3H2v18h20V7H12zM6 19H4v-2h2v2zm0-4H4v-2h2v2zm0-4H4V9h2v2zm0-4H4V5h2v2zm4 12H8v-2h2v2zm0-4H8v-2h2v2zm0-4H8V9h2v2zm0-4H8V5h2v2zm10 12h-8v-2h2v-2h-2v-2h2v-2h-2V9h8v10zm-2-8h-2v2h2v-2zm0 4h-2v2h2v-2z"
            })), 'Domain');

            exports.default = _default;
            });

            unwrapExports$1(Domain);

            var Done = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M9 16.2L4.8 12l-1.4 1.4L9 19 21 7l-1.4-1.4L9 16.2z"
            })), 'Done');

            exports.default = _default;
            });

            unwrapExports$1(Done);

            var DoneAll = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M18 7l-1.41-1.41-6.34 6.34 1.41 1.41L18 7zm4.24-1.41L11.66 16.17 7.48 12l-1.41 1.41L11.66 19l12-12-1.42-1.41zM.41 13.41L6 19l1.41-1.41L1.83 12 .41 13.41z"
            })), 'DoneAll');

            exports.default = _default;
            });

            unwrapExports$1(DoneAll);

            var DoNotDisturb = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M12 2C6.48 2 2 6.48 2 12s4.48 10 10 10 10-4.48 10-10S17.52 2 12 2zm0 18c-4.42 0-8-3.58-8-8 0-1.85.63-3.55 1.69-4.9L16.9 18.31C15.55 19.37 13.85 20 12 20zm6.31-3.1L7.1 5.69C8.45 4.63 10.15 4 12 4c4.42 0 8 3.58 8 8 0 1.85-.63 3.55-1.69 4.9z"
            })), 'DoNotDisturb');

            exports.default = _default;
            });

            unwrapExports$1(DoNotDisturb);

            var DoNotDisturbAlt = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M12 2C6.5 2 2 6.5 2 12s4.5 10 10 10 10-4.5 10-10S17.5 2 12 2zM4 12c0-4.4 3.6-8 8-8 1.8 0 3.5.6 4.9 1.7L5.7 16.9C4.6 15.5 4 13.8 4 12zm8 8c-1.8 0-3.5-.6-4.9-1.7L18.3 7.1C19.4 8.5 20 10.2 20 12c0 4.4-3.6 8-8 8z"
            })), 'DoNotDisturbAlt');

            exports.default = _default;
            });

            unwrapExports$1(DoNotDisturbAlt);

            var DoNotDisturbOff = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M17 11v2h-1.46l4.68 4.68C21.34 16.07 22 14.11 22 12c0-5.52-4.48-10-10-10-2.11 0-4.07.66-5.68 1.78L13.54 11H17zM2.27 2.27L1 3.54l2.78 2.78C2.66 7.93 2 9.89 2 12c0 5.52 4.48 10 10 10 2.11 0 4.07-.66 5.68-1.78L20.46 23l1.27-1.27L11 11 2.27 2.27zM7 13v-2h1.46l2 2H7z"
            })), 'DoNotDisturbOff');

            exports.default = _default;
            });

            unwrapExports$1(DoNotDisturbOff);

            var DoNotDisturbOn = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M12 2C6.48 2 2 6.48 2 12s4.48 10 10 10 10-4.48 10-10S17.52 2 12 2zm5 11H7v-2h10v2z"
            })), 'DoNotDisturbOn');

            exports.default = _default;
            });

            unwrapExports$1(DoNotDisturbOn);

            var DonutLarge = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M11 5.08V2c-5 .5-9 4.81-9 10s4 9.5 9 10v-3.08c-3-.48-6-3.4-6-6.92s3-6.44 6-6.92zM18.97 11H22c-.47-5-4-8.53-9-9v3.08C16 5.51 18.54 8 18.97 11zM13 18.92V22c5-.47 8.53-4 9-9h-3.03c-.43 3-2.97 5.49-5.97 5.92z"
            })), 'DonutLarge');

            exports.default = _default;
            });

            unwrapExports$1(DonutLarge);

            var DonutSmall = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M11 9.16V2c-5 .5-9 4.79-9 10s4 9.5 9 10v-7.16c-1-.41-2-1.52-2-2.84s1-2.43 2-2.84zM14.86 11H22c-.48-4.75-4-8.53-9-9v7.16c1 .3 1.52.98 1.86 1.84zM13 14.84V22c5-.47 8.52-4.25 9-9h-7.14c-.34.86-.86 1.54-1.86 1.84z"
            })), 'DonutSmall');

            exports.default = _default;
            });

            unwrapExports$1(DonutSmall);

            var Drafts = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M21.99 8c0-.72-.37-1.35-.94-1.7L12 1 2.95 6.3C2.38 6.65 2 7.28 2 8v10c0 1.1.9 2 2 2h16c1.1 0 2-.9 2-2l-.01-10zM12 13L3.74 7.84 12 3l8.26 4.84L12 13z"
            })), 'Drafts');

            exports.default = _default;
            });

            unwrapExports$1(Drafts);

            var DragHandle = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M20 9H4v2h16V9zM4 15h16v-2H4v2z"
            })), 'DragHandle');

            exports.default = _default;
            });

            unwrapExports$1(DragHandle);

            var DriveEta = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M18.92 5.01C18.72 4.42 18.16 4 17.5 4h-11c-.66 0-1.21.42-1.42 1.01L3 11v8c0 .55.45 1 1 1h1c.55 0 1-.45 1-1v-1h12v1c0 .55.45 1 1 1h1c.55 0 1-.45 1-1v-8l-2.08-5.99zM6.5 15c-.83 0-1.5-.67-1.5-1.5S5.67 12 6.5 12s1.5.67 1.5 1.5S7.33 15 6.5 15zm11 0c-.83 0-1.5-.67-1.5-1.5s.67-1.5 1.5-1.5 1.5.67 1.5 1.5-.67 1.5-1.5 1.5zM5 10l1.5-4.5h11L19 10H5z"
            })), 'DriveEta');

            exports.default = _default;
            });

            unwrapExports$1(DriveEta);

            var Dvr = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M21 3H3c-1.1 0-2 .9-2 2v12c0 1.1.9 2 2 2h5v2h8v-2h5c1.1 0 1.99-.9 1.99-2L23 5c0-1.1-.9-2-2-2zm0 14H3V5h18v12zm-2-9H8v2h11V8zm0 4H8v2h11v-2zM7 8H5v2h2V8zm0 4H5v2h2v-2z"
            })), 'Dvr');

            exports.default = _default;
            });

            unwrapExports$1(Dvr);

            var Edit = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M3 17.25V21h3.75L17.81 9.94l-3.75-3.75L3 17.25zM20.71 7.04c.39-.39.39-1.02 0-1.41l-2.34-2.34c-.39-.39-1.02-.39-1.41 0l-1.83 1.83 3.75 3.75 1.83-1.83z"
            })), 'Edit');

            exports.default = _default;
            });

            unwrapExports$1(Edit);

            var EditLocation = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M12 2C8.14 2 5 5.14 5 9c0 5.25 7 13 7 13s7-7.75 7-13c0-3.86-3.14-7-7-7zm-1.56 10H9v-1.44l3.35-3.34 1.43 1.43L10.44 12zm4.45-4.45l-.7.7-1.44-1.44.7-.7c.15-.15.39-.15.54 0l.9.9c.15.15.15.39 0 .54z"
            })), 'EditLocation');

            exports.default = _default;
            });

            unwrapExports$1(EditLocation);

            var Eject = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M5 17h14v2H5zm7-12L5.33 15h13.34z"
            })), 'Eject');

            exports.default = _default;
            });

            unwrapExports$1(Eject);

            var Email = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M20 4H4c-1.1 0-1.99.9-1.99 2L2 18c0 1.1.9 2 2 2h16c1.1 0 2-.9 2-2V6c0-1.1-.9-2-2-2zm0 4l-8 5-8-5V6l8 5 8-5v2z"
            })), 'Email');

            exports.default = _default;
            });

            unwrapExports$1(Email);

            var EnhancedEncryption = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M18 8h-1V6c0-2.76-2.24-5-5-5S7 3.24 7 6v2H6c-1.1 0-2 .9-2 2v10c0 1.1.9 2 2 2h12c1.1 0 2-.9 2-2V10c0-1.1-.9-2-2-2zM8.9 6c0-1.71 1.39-3.1 3.1-3.1s3.1 1.39 3.1 3.1v2H8.9V6zM16 16h-3v3h-2v-3H8v-2h3v-3h2v3h3v2z"
            })), 'EnhancedEncryption');

            exports.default = _default;
            });

            unwrapExports$1(EnhancedEncryption);

            var Equalizer = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M10 20h4V4h-4v16zm-6 0h4v-8H4v8zM16 9v11h4V9h-4z"
            })), 'Equalizer');

            exports.default = _default;
            });

            unwrapExports$1(Equalizer);

            var _Error = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M12 2C6.48 2 2 6.48 2 12s4.48 10 10 10 10-4.48 10-10S17.52 2 12 2zm1 15h-2v-2h2v2zm0-4h-2V7h2v6z"
            })), 'Error');

            exports.default = _default;
            });

            unwrapExports$1(_Error);

            var ErrorOutline = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M11 15h2v2h-2zm0-8h2v6h-2zm.99-5C6.47 2 2 6.48 2 12s4.47 10 9.99 10C17.52 22 22 17.52 22 12S17.52 2 11.99 2zM12 20c-4.42 0-8-3.58-8-8s3.58-8 8-8 8 3.58 8 8-3.58 8-8 8z"
            })), 'ErrorOutline');

            exports.default = _default;
            });

            unwrapExports$1(ErrorOutline);

            var EuroSymbol = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M15 18.5c-2.51 0-4.68-1.42-5.76-3.5H15v-2H8.58c-.05-.33-.08-.66-.08-1s.03-.67.08-1H15V9H9.24C10.32 6.92 12.5 5.5 15 5.5c1.61 0 3.09.59 4.23 1.57L21 5.3C19.41 3.87 17.3 3 15 3c-3.92 0-7.24 2.51-8.48 6H3v2h3.06c-.04.33-.06.66-.06 1 0 .34.02.67.06 1H3v2h3.52c1.24 3.49 4.56 6 8.48 6 2.31 0 4.41-.87 6-2.3l-1.78-1.77c-1.13.98-2.6 1.57-4.22 1.57z"
            })), 'EuroSymbol');

            exports.default = _default;
            });

            unwrapExports$1(EuroSymbol);

            var Event = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M17 12h-5v5h5v-5zM16 1v2H8V1H6v2H5c-1.11 0-1.99.9-1.99 2L3 19c0 1.1.89 2 2 2h14c1.1 0 2-.9 2-2V5c0-1.1-.9-2-2-2h-1V1h-2zm3 18H5V8h14v11z"
            })), 'Event');

            exports.default = _default;
            });

            unwrapExports$1(Event);

            var EventAvailable = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M16.53 11.06L15.47 10l-4.88 4.88-2.12-2.12-1.06 1.06L10.59 17l5.94-5.94zM19 3h-1V1h-2v2H8V1H6v2H5c-1.11 0-1.99.9-1.99 2L3 19c0 1.1.89 2 2 2h14c1.1 0 2-.9 2-2V5c0-1.1-.9-2-2-2zm0 16H5V8h14v11z"
            })), 'EventAvailable');

            exports.default = _default;
            });

            unwrapExports$1(EventAvailable);

            var EventBusy = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M9.31 17l2.44-2.44L14.19 17l1.06-1.06-2.44-2.44 2.44-2.44L14.19 10l-2.44 2.44L9.31 10l-1.06 1.06 2.44 2.44-2.44 2.44L9.31 17zM19 3h-1V1h-2v2H8V1H6v2H5c-1.11 0-1.99.9-1.99 2L3 19c0 1.1.89 2 2 2h14c1.1 0 2-.9 2-2V5c0-1.1-.9-2-2-2zm0 16H5V8h14v11z"
            })), 'EventBusy');

            exports.default = _default;
            });

            unwrapExports$1(EventBusy);

            var EventNote = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M17 10H7v2h10v-2zm2-7h-1V1h-2v2H8V1H6v2H5c-1.11 0-1.99.9-1.99 2L3 19c0 1.1.89 2 2 2h14c1.1 0 2-.9 2-2V5c0-1.1-.9-2-2-2zm0 16H5V8h14v11zm-5-5H7v2h7v-2z"
            })), 'EventNote');

            exports.default = _default;
            });

            unwrapExports$1(EventNote);

            var EventSeat = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M4 18v3h3v-3h10v3h3v-6H4zm15-8h3v3h-3zM2 10h3v3H2zm15 3H7V5c0-1.1.9-2 2-2h6c1.1 0 2 .9 2 2v8z"
            })), 'EventSeat');

            exports.default = _default;
            });

            unwrapExports$1(EventSeat);

            var EvStation = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M19.77 7.23l.01-.01-3.72-3.72L15 4.56l2.11 2.11c-.94.36-1.61 1.26-1.61 2.33 0 1.38 1.12 2.5 2.5 2.5.36 0 .69-.08 1-.21v7.21c0 .55-.45 1-1 1s-1-.45-1-1V14c0-1.1-.9-2-2-2h-1V5c0-1.1-.9-2-2-2H6c-1.1 0-2 .9-2 2v16h10v-7.5h1.5v5c0 1.38 1.12 2.5 2.5 2.5s2.5-1.12 2.5-2.5V9c0-.69-.28-1.32-.73-1.77zM18 10c-.55 0-1-.45-1-1s.45-1 1-1 1 .45 1 1-.45 1-1 1zM8 18v-4.5H6L10 6v5h2l-4 7z"
            })), 'EvStation');

            exports.default = _default;
            });

            unwrapExports$1(EvStation);

            var ExitToApp = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M10.09 15.59L11.5 17l5-5-5-5-1.41 1.41L12.67 11H3v2h9.67l-2.58 2.59zM19 3H5c-1.11 0-2 .9-2 2v4h2V5h14v14H5v-4H3v4c0 1.1.89 2 2 2h14c1.1 0 2-.9 2-2V5c0-1.1-.9-2-2-2z"
            })), 'ExitToApp');

            exports.default = _default;
            });

            unwrapExports$1(ExitToApp);

            var ExpandLess = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M12 8l-6 6 1.41 1.41L12 10.83l4.59 4.58L18 14z"
            })), 'ExpandLess');

            exports.default = _default;
            });

            unwrapExports$1(ExpandLess);

            var ExpandMore = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M16.59 8.59L12 13.17 7.41 8.59 6 10l6 6 6-6z"
            })), 'ExpandMore');

            exports.default = _default;
            });

            unwrapExports$1(ExpandMore);

            var Explicit = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M19 3H5c-1.1 0-2 .9-2 2v14c0 1.1.9 2 2 2h14c1.1 0 2-.9 2-2V5c0-1.1-.9-2-2-2zm-4 6h-4v2h4v2h-4v2h4v2H9V7h6v2z"
            })), 'Explicit');

            exports.default = _default;
            });

            unwrapExports$1(Explicit);

            var Explore = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M12 10.9c-.61 0-1.1.49-1.1 1.1s.49 1.1 1.1 1.1c.61 0 1.1-.49 1.1-1.1s-.49-1.1-1.1-1.1zM12 2C6.48 2 2 6.48 2 12s4.48 10 10 10 10-4.48 10-10S17.52 2 12 2zm2.19 12.19L6 18l3.81-8.19L18 6l-3.81 8.19z"
            })), 'Explore');

            exports.default = _default;
            });

            unwrapExports$1(Explore);

            var Exposure = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M15 17v2h2v-2h2v-2h-2v-2h-2v2h-2v2h2zm5-15H4c-1.1 0-2 .9-2 2v16c0 1.1.9 2 2 2h16c1.1 0 2-.9 2-2V4c0-1.1-.9-2-2-2zM5 5h6v2H5V5zm15 15H4L20 4v16z"
            })), 'Exposure');

            exports.default = _default;
            });

            unwrapExports$1(Exposure);

            var ExposureNeg1 = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M4 11v2h8v-2H4zm15 7h-2V7.38L14 8.4V6.7L18.7 5h.3v13z"
            })), 'ExposureNeg1');

            exports.default = _default;
            });

            unwrapExports$1(ExposureNeg1);

            var ExposureNeg2 = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M15.05 16.29l2.86-3.07c.38-.39.72-.79 1.04-1.18.32-.39.59-.78.82-1.17.23-.39.41-.78.54-1.17s.19-.79.19-1.18c0-.53-.09-1.02-.27-1.46-.18-.44-.44-.81-.78-1.11-.34-.31-.77-.54-1.26-.71-.51-.16-1.08-.24-1.72-.24-.69 0-1.31.11-1.85.32-.54.21-1 .51-1.36.88-.37.37-.65.8-.84 1.3-.18.47-.27.97-.28 1.5h2.14c.01-.31.05-.6.13-.87.09-.29.23-.54.4-.75.18-.21.41-.37.68-.49.27-.12.6-.18.96-.18.31 0 .58.05.81.15.23.1.43.25.59.43.16.18.28.4.37.65.08.25.13.52.13.81 0 .22-.03.43-.08.65-.06.22-.15.45-.29.7-.14.25-.32.53-.56.83-.23.3-.52.65-.88 1.03l-4.17 4.55V18H21v-1.71h-5.95zM2 11v2h8v-2H2z"
            })), 'ExposureNeg2');

            exports.default = _default;
            });

            unwrapExports$1(ExposureNeg2);

            var ExposurePlus1 = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M10 7H8v4H4v2h4v4h2v-4h4v-2h-4V7zm10 11h-2V7.38L15 8.4V6.7L19.7 5h.3v13z"
            })), 'ExposurePlus1');

            exports.default = _default;
            });

            unwrapExports$1(ExposurePlus1);

            var ExposurePlus2 = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M16.05 16.29l2.86-3.07c.38-.39.72-.79 1.04-1.18.32-.39.59-.78.82-1.17.23-.39.41-.78.54-1.17.13-.39.19-.79.19-1.18 0-.53-.09-1.02-.27-1.46-.18-.44-.44-.81-.78-1.11-.34-.31-.77-.54-1.26-.71-.51-.16-1.08-.24-1.72-.24-.69 0-1.31.11-1.85.32-.54.21-1 .51-1.36.88-.37.37-.65.8-.84 1.3-.18.47-.27.97-.28 1.5h2.14c.01-.31.05-.6.13-.87.09-.29.23-.54.4-.75.18-.21.41-.37.68-.49.27-.12.6-.18.96-.18.31 0 .58.05.81.15.23.1.43.25.59.43.16.18.28.4.37.65.08.25.13.52.13.81 0 .22-.03.43-.08.65-.06.22-.15.45-.29.7-.14.25-.32.53-.56.83-.23.3-.52.65-.88 1.03l-4.17 4.55V18H22v-1.71h-5.95zM8 7H6v4H2v2h4v4h2v-4h4v-2H8V7z"
            })), 'ExposurePlus2');

            exports.default = _default;
            });

            unwrapExports$1(ExposurePlus2);

            var ExposureZero = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M16.14 12.5c0 1-.1 1.85-.3 2.55-.2.7-.48 1.27-.83 1.7-.36.44-.79.75-1.3.95-.51.2-1.07.3-1.7.3-.62 0-1.18-.1-1.69-.3-.51-.2-.95-.51-1.31-.95-.36-.44-.65-1.01-.85-1.7-.2-.7-.3-1.55-.3-2.55v-2.04c0-1 .1-1.85.3-2.55.2-.7.48-1.26.84-1.69.36-.43.8-.74 1.31-.93C10.81 5.1 11.38 5 12 5c.63 0 1.19.1 1.7.29.51.19.95.5 1.31.93.36.43.64.99.84 1.69.2.7.3 1.54.3 2.55v2.04zm-2.11-2.36c0-.64-.05-1.18-.13-1.62-.09-.44-.22-.79-.4-1.06-.17-.27-.39-.46-.64-.58-.25-.13-.54-.19-.86-.19-.32 0-.61.06-.86.18s-.47.31-.64.58c-.17.27-.31.62-.4 1.06s-.13.98-.13 1.62v2.67c0 .64.05 1.18.14 1.62.09.45.23.81.4 1.09s.39.48.64.61.54.19.87.19c.33 0 .62-.06.87-.19s.46-.33.63-.61c.17-.28.3-.64.39-1.09.09-.45.13-.99.13-1.62v-2.66z"
            })), 'ExposureZero');

            exports.default = _default;
            });

            unwrapExports$1(ExposureZero);

            var Extension = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M20.5 11H19V7c0-1.1-.9-2-2-2h-4V3.5C13 2.12 11.88 1 10.5 1S8 2.12 8 3.5V5H4c-1.1 0-1.99.9-1.99 2v3.8H3.5c1.49 0 2.7 1.21 2.7 2.7s-1.21 2.7-2.7 2.7H2V20c0 1.1.9 2 2 2h3.8v-1.5c0-1.49 1.21-2.7 2.7-2.7 1.49 0 2.7 1.21 2.7 2.7V22H17c1.1 0 2-.9 2-2v-4h1.5c1.38 0 2.5-1.12 2.5-2.5S21.88 11 20.5 11z"
            })), 'Extension');

            exports.default = _default;
            });

            unwrapExports$1(Extension);

            var Face = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M9 11.75c-.69 0-1.25.56-1.25 1.25s.56 1.25 1.25 1.25 1.25-.56 1.25-1.25-.56-1.25-1.25-1.25zm6 0c-.69 0-1.25.56-1.25 1.25s.56 1.25 1.25 1.25 1.25-.56 1.25-1.25-.56-1.25-1.25-1.25zM12 2C6.48 2 2 6.48 2 12s4.48 10 10 10 10-4.48 10-10S17.52 2 12 2zm0 18c-4.41 0-8-3.59-8-8 0-.29.02-.58.05-.86 2.36-1.05 4.23-2.98 5.21-5.37C11.07 8.33 14.05 10 17.42 10c.78 0 1.53-.09 2.25-.26.21.71.33 1.47.33 2.26 0 4.41-3.59 8-8 8z"
            })), 'Face');

            exports.default = _default;
            });

            unwrapExports$1(Face);

            var FastForward = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M4 18l8.5-6L4 6v12zm9-12v12l8.5-6L13 6z"
            })), 'FastForward');

            exports.default = _default;
            });

            unwrapExports$1(FastForward);

            var FastRewind = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M11 18V6l-8.5 6 8.5 6zm.5-6l8.5 6V6l-8.5 6z"
            })), 'FastRewind');

            exports.default = _default;
            });

            unwrapExports$1(FastRewind);

            var Favorite = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M12 21.35l-1.45-1.32C5.4 15.36 2 12.28 2 8.5 2 5.42 4.42 3 7.5 3c1.74 0 3.41.81 4.5 2.09C13.09 3.81 14.76 3 16.5 3 19.58 3 22 5.42 22 8.5c0 3.78-3.4 6.86-8.55 11.54L12 21.35z"
            })), 'Favorite');

            exports.default = _default;
            });

            unwrapExports$1(Favorite);

            var FavoriteBorder = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M16.5 3c-1.74 0-3.41.81-4.5 2.09C10.91 3.81 9.24 3 7.5 3 4.42 3 2 5.42 2 8.5c0 3.78 3.4 6.86 8.55 11.54L12 21.35l1.45-1.32C18.6 15.36 22 12.28 22 8.5 22 5.42 19.58 3 16.5 3zm-4.4 15.55l-.1.1-.1-.1C7.14 14.24 4 11.39 4 8.5 4 6.5 5.5 5 7.5 5c1.54 0 3.04.99 3.57 2.36h1.87C13.46 5.99 14.96 5 16.5 5c2 0 3.5 1.5 3.5 3.5 0 2.89-3.14 5.74-7.9 10.05z"
            })), 'FavoriteBorder');

            exports.default = _default;
            });

            unwrapExports$1(FavoriteBorder);

            var FeaturedPlayList = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M21 3H3c-1.1 0-2 .9-2 2v14c0 1.1.9 2 2 2h18c1.1 0 2-.9 2-2V5c0-1.1-.9-2-2-2zm-9 8H3V9h9v2zm0-4H3V5h9v2z"
            })), 'FeaturedPlayList');

            exports.default = _default;
            });

            unwrapExports$1(FeaturedPlayList);

            var FeaturedVideo = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M21 3H3c-1.1 0-2 .9-2 2v14c0 1.1.9 2 2 2h18c1.1 0 2-.9 2-2V5c0-1.1-.9-2-2-2zm-9 9H3V5h9v7z"
            })), 'FeaturedVideo');

            exports.default = _default;
            });

            unwrapExports$1(FeaturedVideo);

            var Feedback = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M20 2H4c-1.1 0-1.99.9-1.99 2L2 22l4-4h14c1.1 0 2-.9 2-2V4c0-1.1-.9-2-2-2zm-7 12h-2v-2h2v2zm0-4h-2V6h2v4z"
            })), 'Feedback');

            exports.default = _default;
            });

            unwrapExports$1(Feedback);

            var FiberDvr = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M17.5 10.5h2v1h-2zm-13 0h2v3h-2zM21 3H3c-1.11 0-2 .89-2 2v14c0 1.1.89 2 2 2h18c1.11 0 2-.9 2-2V5c0-1.11-.89-2-2-2zM8 13.5c0 .85-.65 1.5-1.5 1.5H3V9h3.5c.85 0 1.5.65 1.5 1.5v3zm4.62 1.5h-1.5L9.37 9h1.5l1 3.43 1-3.43h1.5l-1.75 6zM21 11.5c0 .6-.4 1.15-.9 1.4L21 15h-1.5l-.85-2H17.5v2H16V9h3.5c.85 0 1.5.65 1.5 1.5v1z"
            })), 'FiberDvr');

            exports.default = _default;
            });

            unwrapExports$1(FiberDvr);

            var FiberManualRecord = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("circle", {
              cx: "12",
              cy: "12",
              r: "8"
            })), 'FiberManualRecord');

            exports.default = _default;
            });

            unwrapExports$1(FiberManualRecord);

            var FiberNew = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M20 4H4c-1.11 0-1.99.89-1.99 2L2 18c0 1.11.89 2 2 2h16c1.11 0 2-.89 2-2V6c0-1.11-.89-2-2-2zM8.5 15H7.3l-2.55-3.5V15H3.5V9h1.25l2.5 3.5V9H8.5v6zm5-4.74H11v1.12h2.5v1.26H11v1.11h2.5V15h-4V9h4v1.26zm7 3.74c0 .55-.45 1-1 1h-4c-.55 0-1-.45-1-1V9h1.25v4.51h1.13V9.99h1.25v3.51h1.12V9h1.25v5z"
            })), 'FiberNew');

            exports.default = _default;
            });

            unwrapExports$1(FiberNew);

            var FiberPin = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M5.5 10.5h2v1h-2zM20 4H4c-1.11 0-1.99.89-1.99 2L2 18c0 1.11.89 2 2 2h16c1.11 0 2-.89 2-2V6c0-1.11-.89-2-2-2zM9 11.5c0 .85-.65 1.5-1.5 1.5h-2v2H4V9h3.5c.85 0 1.5.65 1.5 1.5v1zm3.5 3.5H11V9h1.5v6zm7.5 0h-1.2l-2.55-3.5V15H15V9h1.25l2.5 3.5V9H20v6z"
            })), 'FiberPin');

            exports.default = _default;
            });

            unwrapExports$1(FiberPin);

            var FiberSmartRecord = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("g", null, _react.default.createElement("circle", {
              cx: "9",
              cy: "12",
              r: "8"
            }), _react.default.createElement("path", {
              d: "M17 4.26v2.09c2.33.82 4 3.04 4 5.65s-1.67 4.83-4 5.65v2.09c3.45-.89 6-4.01 6-7.74s-2.55-6.85-6-7.74z"
            }))), 'FiberSmartRecord');

            exports.default = _default;
            });

            unwrapExports$1(FiberSmartRecord);

            var FileDownload = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M19 9h-4V3H9v6H5l7 7 7-7zM5 18v2h14v-2H5z"
            })), 'FileDownload');

            exports.default = _default;
            });

            unwrapExports$1(FileDownload);

            var FileUpload = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M9 16h6v-6h4l-7-7-7 7h4zm-4 2h14v2H5z"
            })), 'FileUpload');

            exports.default = _default;
            });

            unwrapExports$1(FileUpload);

            var Filter = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M15.96 10.29l-2.75 3.54-1.96-2.36L8.5 15h11l-3.54-4.71zM3 5H1v16c0 1.1.9 2 2 2h16v-2H3V5zm18-4H7c-1.1 0-2 .9-2 2v14c0 1.1.9 2 2 2h14c1.1 0 2-.9 2-2V3c0-1.1-.9-2-2-2zm0 16H7V3h14v14z"
            })), 'Filter');

            exports.default = _default;
            });

            unwrapExports$1(Filter);

            var Filter1 = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M3 5H1v16c0 1.1.9 2 2 2h16v-2H3V5zm11 10h2V5h-4v2h2v8zm7-14H7c-1.1 0-2 .9-2 2v14c0 1.1.9 2 2 2h14c1.1 0 2-.9 2-2V3c0-1.1-.9-2-2-2zm0 16H7V3h14v14z"
            })), 'Filter1');

            exports.default = _default;
            });

            unwrapExports$1(Filter1);

            var Filter2 = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M3 5H1v16c0 1.1.9 2 2 2h16v-2H3V5zm18-4H7c-1.1 0-2 .9-2 2v14c0 1.1.9 2 2 2h14c1.1 0 2-.9 2-2V3c0-1.1-.9-2-2-2zm0 16H7V3h14v14zm-4-4h-4v-2h2c1.1 0 2-.89 2-2V7c0-1.11-.9-2-2-2h-4v2h4v2h-2c-1.1 0-2 .89-2 2v4h6v-2z"
            })), 'Filter2');

            exports.default = _default;
            });

            unwrapExports$1(Filter2);

            var Filter3 = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M21 1H7c-1.1 0-2 .9-2 2v14c0 1.1.9 2 2 2h14c1.1 0 2-.9 2-2V3c0-1.1-.9-2-2-2zm0 16H7V3h14v14zM3 5H1v16c0 1.1.9 2 2 2h16v-2H3V5zm14 8v-1.5c0-.83-.67-1.5-1.5-1.5.83 0 1.5-.67 1.5-1.5V7c0-1.11-.9-2-2-2h-4v2h4v2h-2v2h2v2h-4v2h4c1.1 0 2-.89 2-2z"
            })), 'Filter3');

            exports.default = _default;
            });

            unwrapExports$1(Filter3);

            var Filter4 = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M3 5H1v16c0 1.1.9 2 2 2h16v-2H3V5zm12 10h2V5h-2v4h-2V5h-2v6h4v4zm6-14H7c-1.1 0-2 .9-2 2v14c0 1.1.9 2 2 2h14c1.1 0 2-.9 2-2V3c0-1.1-.9-2-2-2zm0 16H7V3h14v14z"
            })), 'Filter4');

            exports.default = _default;
            });

            unwrapExports$1(Filter4);

            var Filter5 = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M21 1H7c-1.1 0-2 .9-2 2v14c0 1.1.9 2 2 2h14c1.1 0 2-.9 2-2V3c0-1.1-.9-2-2-2zm0 16H7V3h14v14zM3 5H1v16c0 1.1.9 2 2 2h16v-2H3V5zm14 8v-2c0-1.11-.9-2-2-2h-2V7h4V5h-6v6h4v2h-4v2h4c1.1 0 2-.89 2-2z"
            })), 'Filter5');

            exports.default = _default;
            });

            unwrapExports$1(Filter5);

            var Filter6 = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M3 5H1v16c0 1.1.9 2 2 2h16v-2H3V5zm18-4H7c-1.1 0-2 .9-2 2v14c0 1.1.9 2 2 2h14c1.1 0 2-.9 2-2V3c0-1.1-.9-2-2-2zm0 16H7V3h14v14zm-8-2h2c1.1 0 2-.89 2-2v-2c0-1.11-.9-2-2-2h-2V7h4V5h-4c-1.1 0-2 .89-2 2v6c0 1.11.9 2 2 2zm0-4h2v2h-2v-2z"
            })), 'Filter6');

            exports.default = _default;
            });

            unwrapExports$1(Filter6);

            var Filter7 = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M3 5H1v16c0 1.1.9 2 2 2h16v-2H3V5zm18-4H7c-1.1 0-2 .9-2 2v14c0 1.1.9 2 2 2h14c1.1 0 2-.9 2-2V3c0-1.1-.9-2-2-2zm0 16H7V3h14v14zm-8-2l4-8V5h-6v2h4l-4 8h2z"
            })), 'Filter7');

            exports.default = _default;
            });

            unwrapExports$1(Filter7);

            var Filter8 = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M3 5H1v16c0 1.1.9 2 2 2h16v-2H3V5zm18-4H7c-1.1 0-2 .9-2 2v14c0 1.1.9 2 2 2h14c1.1 0 2-.9 2-2V3c0-1.1-.9-2-2-2zm0 16H7V3h14v14zm-8-2h2c1.1 0 2-.89 2-2v-1.5c0-.83-.67-1.5-1.5-1.5.83 0 1.5-.67 1.5-1.5V7c0-1.11-.9-2-2-2h-2c-1.1 0-2 .89-2 2v1.5c0 .83.67 1.5 1.5 1.5-.83 0-1.5.67-1.5 1.5V13c0 1.11.9 2 2 2zm0-8h2v2h-2V7zm0 4h2v2h-2v-2z"
            })), 'Filter8');

            exports.default = _default;
            });

            unwrapExports$1(Filter8);

            var Filter9 = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M3 5H1v16c0 1.1.9 2 2 2h16v-2H3V5zm18-4H7c-1.1 0-2 .9-2 2v14c0 1.1.9 2 2 2h14c1.1 0 2-.9 2-2V3c0-1.1-.9-2-2-2zm0 16H7V3h14v14zM15 5h-2c-1.1 0-2 .89-2 2v2c0 1.11.9 2 2 2h2v2h-4v2h4c1.1 0 2-.89 2-2V7c0-1.11-.9-2-2-2zm0 4h-2V7h2v2z"
            })), 'Filter9');

            exports.default = _default;
            });

            unwrapExports$1(Filter9);

            var Filter9Plus = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M3 5H1v16c0 1.1.9 2 2 2h16v-2H3V5zm11 7V8c0-1.11-.9-2-2-2h-1c-1.1 0-2 .89-2 2v1c0 1.11.9 2 2 2h1v1H9v2h3c1.1 0 2-.89 2-2zm-3-3V8h1v1h-1zm10-8H7c-1.1 0-2 .9-2 2v14c0 1.1.9 2 2 2h14c1.1 0 2-.9 2-2V3c0-1.1-.9-2-2-2zm0 8h-2V7h-2v2h-2v2h2v2h2v-2h2v6H7V3h14v6z"
            })), 'Filter9Plus');

            exports.default = _default;
            });

            unwrapExports$1(Filter9Plus);

            var FilterBAndW = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M19 3H5c-1.1 0-2 .9-2 2v14c0 1.1.9 2 2 2h14c1.1 0 2-.9 2-2V5c0-1.1-.9-2-2-2zm0 16l-7-8v8H5l7-8V5h7v14z"
            })), 'FilterBAndW');

            exports.default = _default;
            });

            unwrapExports$1(FilterBAndW);

            var FilterCenterFocus = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M5 15H3v4c0 1.1.9 2 2 2h4v-2H5v-4zM5 5h4V3H5c-1.1 0-2 .9-2 2v4h2V5zm14-2h-4v2h4v4h2V5c0-1.1-.9-2-2-2zm0 16h-4v2h4c1.1 0 2-.9 2-2v-4h-2v4zM12 9c-1.66 0-3 1.34-3 3s1.34 3 3 3 3-1.34 3-3-1.34-3-3-3z"
            })), 'FilterCenterFocus');

            exports.default = _default;
            });

            unwrapExports$1(FilterCenterFocus);

            var FilterDrama = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M19.35 10.04C18.67 6.59 15.64 4 12 4 9.11 4 6.61 5.64 5.36 8.04 2.35 8.36 0 10.9 0 14c0 3.31 2.69 6 6 6h13c2.76 0 5-2.24 5-5 0-2.64-2.05-4.78-4.65-4.96zM19 18H6c-2.21 0-4-1.79-4-4s1.79-4 4-4 4 1.79 4 4h2c0-2.76-1.86-5.08-4.4-5.78C8.61 6.88 10.2 6 12 6c3.03 0 5.5 2.47 5.5 5.5v.5H19c1.65 0 3 1.35 3 3s-1.35 3-3 3z"
            })), 'FilterDrama');

            exports.default = _default;
            });

            unwrapExports$1(FilterDrama);

            var FilterFrames = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M20 4h-4l-4-4-4 4H4c-1.1 0-2 .9-2 2v14c0 1.1.9 2 2 2h16c1.1 0 2-.9 2-2V6c0-1.1-.9-2-2-2zm0 16H4V6h4.52l3.52-3.5L15.52 6H20v14zM18 8H6v10h12"
            })), 'FilterFrames');

            exports.default = _default;
            });

            unwrapExports$1(FilterFrames);

            var FilterHdr = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M14 6l-3.75 5 2.85 3.8-1.6 1.2C9.81 13.75 7 10 7 10l-6 8h22L14 6z"
            })), 'FilterHdr');

            exports.default = _default;
            });

            unwrapExports$1(FilterHdr);

            var FilterList = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M10 18h4v-2h-4v2zM3 6v2h18V6H3zm3 7h12v-2H6v2z"
            })), 'FilterList');

            exports.default = _default;
            });

            unwrapExports$1(FilterList);

            var FilterNone = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M3 5H1v16c0 1.1.9 2 2 2h16v-2H3V5zm18-4H7c-1.1 0-2 .9-2 2v14c0 1.1.9 2 2 2h14c1.1 0 2-.9 2-2V3c0-1.1-.9-2-2-2zm0 16H7V3h14v14z"
            })), 'FilterNone');

            exports.default = _default;
            });

            unwrapExports$1(FilterNone);

            var FilterTiltShift = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M11 4.07V2.05c-2.01.2-3.84 1-5.32 2.21L7.1 5.69c1.11-.86 2.44-1.44 3.9-1.62zm7.32.19C16.84 3.05 15.01 2.25 13 2.05v2.02c1.46.18 2.79.76 3.9 1.62l1.42-1.43zM19.93 11h2.02c-.2-2.01-1-3.84-2.21-5.32L18.31 7.1c.86 1.11 1.44 2.44 1.62 3.9zM5.69 7.1L4.26 5.68C3.05 7.16 2.25 8.99 2.05 11h2.02c.18-1.46.76-2.79 1.62-3.9zM4.07 13H2.05c.2 2.01 1 3.84 2.21 5.32l1.43-1.43c-.86-1.1-1.44-2.43-1.62-3.89zM15 12c0-1.66-1.34-3-3-3s-3 1.34-3 3 1.34 3 3 3 3-1.34 3-3zm3.31 4.9l1.43 1.43c1.21-1.48 2.01-3.32 2.21-5.32h-2.02c-.18 1.45-.76 2.78-1.62 3.89zM13 19.93v2.02c2.01-.2 3.84-1 5.32-2.21l-1.43-1.43c-1.1.86-2.43 1.44-3.89 1.62zm-7.32-.19C7.16 20.95 9 21.75 11 21.95v-2.02c-1.46-.18-2.79-.76-3.9-1.62l-1.42 1.43z"
            })), 'FilterTiltShift');

            exports.default = _default;
            });

            unwrapExports$1(FilterTiltShift);

            var FilterVintage = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M18.7 12.4c-.28-.16-.57-.29-.86-.4.29-.11.58-.24.86-.4 1.92-1.11 2.99-3.12 3-5.19-1.79-1.03-4.07-1.11-6 0-.28.16-.54.35-.78.54.05-.31.08-.63.08-.95 0-2.22-1.21-4.15-3-5.19C10.21 1.85 9 3.78 9 6c0 .32.03.64.08.95-.24-.2-.5-.39-.78-.55-1.92-1.11-4.2-1.03-6 0 0 2.07 1.07 4.08 3 5.19.28.16.57.29.86.4-.29.11-.58.24-.86.4-1.92 1.11-2.99 3.12-3 5.19 1.79 1.03 4.07 1.11 6 0 .28-.16.54-.35.78-.54-.05.32-.08.64-.08.96 0 2.22 1.21 4.15 3 5.19 1.79-1.04 3-2.97 3-5.19 0-.32-.03-.64-.08-.95.24.2.5.38.78.54 1.92 1.11 4.2 1.03 6 0-.01-2.07-1.08-4.08-3-5.19zM12 16c-2.21 0-4-1.79-4-4s1.79-4 4-4 4 1.79 4 4-1.79 4-4 4z"
            })), 'FilterVintage');

            exports.default = _default;
            });

            unwrapExports$1(FilterVintage);

            var FindInPage = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M20 19.59V8l-6-6H6c-1.1 0-1.99.9-1.99 2L4 20c0 1.1.89 2 1.99 2H18c.45 0 .85-.15 1.19-.4l-4.43-4.43c-.8.52-1.74.83-2.76.83-2.76 0-5-2.24-5-5s2.24-5 5-5 5 2.24 5 5c0 1.02-.31 1.96-.83 2.75L20 19.59zM9 13c0 1.66 1.34 3 3 3s3-1.34 3-3-1.34-3-3-3-3 1.34-3 3z"
            })), 'FindInPage');

            exports.default = _default;
            });

            unwrapExports$1(FindInPage);

            var FindReplace = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M11 6c1.38 0 2.63.56 3.54 1.46L12 10h6V4l-2.05 2.05C14.68 4.78 12.93 4 11 4c-3.53 0-6.43 2.61-6.92 6H6.1c.46-2.28 2.48-4 4.9-4zm5.64 9.14c.66-.9 1.12-1.97 1.28-3.14H15.9c-.46 2.28-2.48 4-4.9 4-1.38 0-2.63-.56-3.54-1.46L10 12H4v6l2.05-2.05C7.32 17.22 9.07 18 11 18c1.55 0 2.98-.51 4.14-1.36L20 21.49 21.49 20l-4.85-4.86z"
            })), 'FindReplace');

            exports.default = _default;
            });

            unwrapExports$1(FindReplace);

            var Fingerprint = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M17.81 4.47c-.08 0-.16-.02-.23-.06C15.66 3.42 14 3 12.01 3c-1.98 0-3.86.47-5.57 1.41-.24.13-.54.04-.68-.2-.13-.24-.04-.55.2-.68C7.82 2.52 9.86 2 12.01 2c2.13 0 3.99.47 6.03 1.52.25.13.34.43.21.67-.09.18-.26.28-.44.28zM3.5 9.72c-.1 0-.2-.03-.29-.09-.23-.16-.28-.47-.12-.7.99-1.4 2.25-2.5 3.75-3.27C9.98 4.04 14 4.03 17.15 5.65c1.5.77 2.76 1.86 3.75 3.25.16.22.11.54-.12.7-.23.16-.54.11-.7-.12-.9-1.26-2.04-2.25-3.39-2.94-2.87-1.47-6.54-1.47-9.4.01-1.36.7-2.5 1.7-3.4 2.96-.08.14-.23.21-.39.21zm6.25 12.07c-.13 0-.26-.05-.35-.15-.87-.87-1.34-1.43-2.01-2.64-.69-1.23-1.05-2.73-1.05-4.34 0-2.97 2.54-5.39 5.66-5.39s5.66 2.42 5.66 5.39c0 .28-.22.5-.5.5s-.5-.22-.5-.5c0-2.42-2.09-4.39-4.66-4.39-2.57 0-4.66 1.97-4.66 4.39 0 1.44.32 2.77.93 3.85.64 1.15 1.08 1.64 1.85 2.42.19.2.19.51 0 .71-.11.1-.24.15-.37.15zm7.17-1.85c-1.19 0-2.24-.3-3.1-.89-1.49-1.01-2.38-2.65-2.38-4.39 0-.28.22-.5.5-.5s.5.22.5.5c0 1.41.72 2.74 1.94 3.56.71.48 1.54.71 2.54.71.24 0 .64-.03 1.04-.1.27-.05.53.13.58.41.05.27-.13.53-.41.58-.57.11-1.07.12-1.21.12zM14.91 22c-.04 0-.09-.01-.13-.02-1.59-.44-2.63-1.03-3.72-2.1-1.4-1.39-2.17-3.24-2.17-5.22 0-1.62 1.38-2.94 3.08-2.94 1.7 0 3.08 1.32 3.08 2.94 0 1.07.93 1.94 2.08 1.94s2.08-.87 2.08-1.94c0-3.77-3.25-6.83-7.25-6.83-2.84 0-5.44 1.58-6.61 4.03-.39.81-.59 1.76-.59 2.8 0 .78.07 2.01.67 3.61.1.26-.03.55-.29.64-.26.1-.55-.04-.64-.29-.49-1.31-.73-2.61-.73-3.96 0-1.2.23-2.29.68-3.24 1.33-2.79 4.28-4.6 7.51-4.6 4.55 0 8.25 3.51 8.25 7.83 0 1.62-1.38 2.94-3.08 2.94s-3.08-1.32-3.08-2.94c0-1.07-.93-1.94-2.08-1.94s-2.08.87-2.08 1.94c0 1.71.66 3.31 1.87 4.51.95.94 1.86 1.46 3.27 1.85.27.07.42.35.35.61-.05.23-.26.38-.47.38z"
            })), 'Fingerprint');

            exports.default = _default;
            });

            unwrapExports$1(Fingerprint);

            var FirstPage = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M18.41 16.59L13.82 12l4.59-4.59L17 6l-6 6 6 6zM6 6h2v12H6z"
            })), 'FirstPage');

            exports.default = _default;
            });

            unwrapExports$1(FirstPage);

            var FitnessCenter = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M20.57 14.86L22 13.43 20.57 12 17 15.57 8.43 7 12 3.43 10.57 2 9.14 3.43 7.71 2 5.57 4.14 4.14 2.71 2.71 4.14l1.43 1.43L2 7.71l1.43 1.43L2 10.57 3.43 12 7 8.43 15.57 17 12 20.57 13.43 22l1.43-1.43L16.29 22l2.14-2.14 1.43 1.43 1.43-1.43-1.43-1.43L22 16.29z"
            })), 'FitnessCenter');

            exports.default = _default;
            });

            unwrapExports$1(FitnessCenter);

            var Flag = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M14.4 6L14 4H5v17h2v-7h5.6l.4 2h7V6z"
            })), 'Flag');

            exports.default = _default;
            });

            unwrapExports$1(Flag);

            var Flare = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M7 11H1v2h6v-2zm2.17-3.24L7.05 5.64 5.64 7.05l2.12 2.12 1.41-1.41zM13 1h-2v6h2V1zm5.36 6.05l-1.41-1.41-2.12 2.12 1.41 1.41 2.12-2.12zM17 11v2h6v-2h-6zm-5-2c-1.66 0-3 1.34-3 3s1.34 3 3 3 3-1.34 3-3-1.34-3-3-3zm2.83 7.24l2.12 2.12 1.41-1.41-2.12-2.12-1.41 1.41zm-9.19.71l1.41 1.41 2.12-2.12-1.41-1.41-2.12 2.12zM11 23h2v-6h-2v6z"
            })), 'Flare');

            exports.default = _default;
            });

            unwrapExports$1(Flare);

            var FlashAuto = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M3 2v12h3v9l7-12H9l4-9H3zm16 0h-2l-3.2 9h1.9l.7-2h3.2l.7 2h1.9L19 2zm-2.15 5.65L18 4l1.15 3.65h-2.3z"
            })), 'FlashAuto');

            exports.default = _default;
            });

            unwrapExports$1(FlashAuto);

            var FlashOff = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M3.27 3L2 4.27l5 5V13h3v9l3.58-6.14L17.73 20 19 18.73 3.27 3zM17 10h-4l4-8H7v2.18l8.46 8.46L17 10z"
            })), 'FlashOff');

            exports.default = _default;
            });

            unwrapExports$1(FlashOff);

            var FlashOn = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M7 2v11h3v9l7-12h-4l4-8z"
            })), 'FlashOn');

            exports.default = _default;
            });

            unwrapExports$1(FlashOn);

            var Flight = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M10.18 9"
            }), _react.default.createElement("path", {
              d: "M21 16v-2l-8-5V3.5c0-.83-.67-1.5-1.5-1.5S10 2.67 10 3.5V9l-8 5v2l8-2.5V19l-2 1.5V22l3.5-1 3.5 1v-1.5L13 19v-5.5l8 2.5z"
            })), 'Flight');

            exports.default = _default;
            });

            unwrapExports$1(Flight);

            var FlightLand = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M2.5 19h19v2h-19zm7.18-5.73l4.35 1.16 5.31 1.42c.8.21 1.62-.26 1.84-1.06.21-.8-.26-1.62-1.06-1.84l-5.31-1.42-2.76-9.02L10.12 2v8.28L5.15 8.95l-.93-2.32-1.45-.39v5.17l1.6.43 5.31 1.43z"
            })), 'FlightLand');

            exports.default = _default;
            });

            unwrapExports$1(FlightLand);

            var FlightTakeoff = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M2.5 19h19v2h-19zm19.57-9.36c-.21-.8-1.04-1.28-1.84-1.06L14.92 10l-6.9-6.43-1.93.51 4.14 7.17-4.97 1.33-1.97-1.54-1.45.39 1.82 3.16.77 1.33 1.6-.43 5.31-1.42 4.35-1.16L21 11.49c.81-.23 1.28-1.05 1.07-1.85z"
            })), 'FlightTakeoff');

            exports.default = _default;
            });

            unwrapExports$1(FlightTakeoff);

            var Flip = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M15 21h2v-2h-2v2zm4-12h2V7h-2v2zM3 5v14c0 1.1.9 2 2 2h4v-2H5V5h4V3H5c-1.1 0-2 .9-2 2zm16-2v2h2c0-1.1-.9-2-2-2zm-8 20h2V1h-2v22zm8-6h2v-2h-2v2zM15 5h2V3h-2v2zm4 8h2v-2h-2v2zm0 8c1.1 0 2-.9 2-2h-2v2z"
            })), 'Flip');

            exports.default = _default;
            });

            unwrapExports$1(Flip);

            var FlipToBack = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M9 7H7v2h2V7zm0 4H7v2h2v-2zm0-8c-1.11 0-2 .9-2 2h2V3zm4 12h-2v2h2v-2zm6-12v2h2c0-1.1-.9-2-2-2zm-6 0h-2v2h2V3zM9 17v-2H7c0 1.1.89 2 2 2zm10-4h2v-2h-2v2zm0-4h2V7h-2v2zm0 8c1.1 0 2-.9 2-2h-2v2zM5 7H3v12c0 1.1.89 2 2 2h12v-2H5V7zm10-2h2V3h-2v2zm0 12h2v-2h-2v2z"
            })), 'FlipToBack');

            exports.default = _default;
            });

            unwrapExports$1(FlipToBack);

            var FlipToFront = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M3 13h2v-2H3v2zm0 4h2v-2H3v2zm2 4v-2H3c0 1.1.89 2 2 2zM3 9h2V7H3v2zm12 12h2v-2h-2v2zm4-18H9c-1.11 0-2 .9-2 2v10c0 1.1.89 2 2 2h10c1.1 0 2-.9 2-2V5c0-1.1-.9-2-2-2zm0 12H9V5h10v10zm-8 6h2v-2h-2v2zm-4 0h2v-2H7v2z"
            })), 'FlipToFront');

            exports.default = _default;
            });

            unwrapExports$1(FlipToFront);

            var Folder = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M10 4H4c-1.1 0-1.99.9-1.99 2L2 18c0 1.1.9 2 2 2h16c1.1 0 2-.9 2-2V8c0-1.1-.9-2-2-2h-8l-2-2z"
            })), 'Folder');

            exports.default = _default;
            });

            unwrapExports$1(Folder);

            var FolderOpen = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M20 6h-8l-2-2H4c-1.1 0-1.99.9-1.99 2L2 18c0 1.1.9 2 2 2h16c1.1 0 2-.9 2-2V8c0-1.1-.9-2-2-2zm0 12H4V8h16v10z"
            })), 'FolderOpen');

            exports.default = _default;
            });

            unwrapExports$1(FolderOpen);

            var FolderShared = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M20 6h-8l-2-2H4c-1.1 0-1.99.9-1.99 2L2 18c0 1.1.9 2 2 2h16c1.1 0 2-.9 2-2V8c0-1.1-.9-2-2-2zm-5 3c1.1 0 2 .9 2 2s-.9 2-2 2-2-.9-2-2 .9-2 2-2zm4 8h-8v-1c0-1.33 2.67-2 4-2s4 .67 4 2v1z"
            })), 'FolderShared');

            exports.default = _default;
            });

            unwrapExports$1(FolderShared);

            var FolderSpecial = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M20 6h-8l-2-2H4c-1.1 0-2 .9-2 2v12c0 1.1.9 2 2 2h16c1.1 0 2-.9 2-2V8c0-1.1-.9-2-2-2zm-2.06 11L15 15.28 12.06 17l.78-3.33-2.59-2.24 3.41-.29L15 8l1.34 3.14 3.41.29-2.59 2.24.78 3.33z"
            })), 'FolderSpecial');

            exports.default = _default;
            });

            unwrapExports$1(FolderSpecial);

            var FontDownload = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M9.93 13.5h4.14L12 7.98zM20 2H4c-1.1 0-2 .9-2 2v16c0 1.1.9 2 2 2h16c1.1 0 2-.9 2-2V4c0-1.1-.9-2-2-2zm-4.05 16.5l-1.14-3H9.17l-1.12 3H5.96l5.11-13h1.86l5.11 13h-2.09z"
            })), 'FontDownload');

            exports.default = _default;
            });

            unwrapExports$1(FontDownload);

            var FormatAlignCenter = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M7 15v2h10v-2H7zm-4 6h18v-2H3v2zm0-8h18v-2H3v2zm4-6v2h10V7H7zM3 3v2h18V3H3z"
            })), 'FormatAlignCenter');

            exports.default = _default;
            });

            unwrapExports$1(FormatAlignCenter);

            var FormatAlignJustify = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M3 21h18v-2H3v2zm0-4h18v-2H3v2zm0-4h18v-2H3v2zm0-4h18V7H3v2zm0-6v2h18V3H3z"
            })), 'FormatAlignJustify');

            exports.default = _default;
            });

            unwrapExports$1(FormatAlignJustify);

            var FormatAlignLeft = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M15 15H3v2h12v-2zm0-8H3v2h12V7zM3 13h18v-2H3v2zm0 8h18v-2H3v2zM3 3v2h18V3H3z"
            })), 'FormatAlignLeft');

            exports.default = _default;
            });

            unwrapExports$1(FormatAlignLeft);

            var FormatAlignRight = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M3 21h18v-2H3v2zm6-4h12v-2H9v2zm-6-4h18v-2H3v2zm6-4h12V7H9v2zM3 3v2h18V3H3z"
            })), 'FormatAlignRight');

            exports.default = _default;
            });

            unwrapExports$1(FormatAlignRight);

            var FormatBold = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M15.6 10.79c.97-.67 1.65-1.77 1.65-2.79 0-2.26-1.75-4-4-4H7v14h7.04c2.09 0 3.71-1.7 3.71-3.79 0-1.52-.86-2.82-2.15-3.42zM10 6.5h3c.83 0 1.5.67 1.5 1.5s-.67 1.5-1.5 1.5h-3v-3zm3.5 9H10v-3h3.5c.83 0 1.5.67 1.5 1.5s-.67 1.5-1.5 1.5z"
            })), 'FormatBold');

            exports.default = _default;
            });

            unwrapExports$1(FormatBold);

            var FormatClear = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M3.27 5L2 6.27l6.97 6.97L6.5 19h3l1.57-3.66L16.73 21 18 19.73 3.55 5.27 3.27 5zM6 5v.18L8.82 8h2.4l-.72 1.68 2.1 2.1L14.21 8H20V5H6z"
            })), 'FormatClear');

            exports.default = _default;
            });

            unwrapExports$1(FormatClear);

            var FormatColorFill = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M16.56 8.94L7.62 0 6.21 1.41l2.38 2.38-5.15 5.15c-.59.59-.59 1.54 0 2.12l5.5 5.5c.29.29.68.44 1.06.44s.77-.15 1.06-.44l5.5-5.5c.59-.58.59-1.53 0-2.12zM5.21 10L10 5.21 14.79 10H5.21zM19 11.5s-2 2.17-2 3.5c0 1.1.9 2 2 2s2-.9 2-2c0-1.33-2-3.5-2-3.5z"
            }), _react.default.createElement("path", {
              fillOpacity: ".36",
              d: "M0 20h24v4H0z"
            })), 'FormatColorFill');

            exports.default = _default;
            });

            unwrapExports$1(FormatColorFill);

            var FormatColorReset = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M18 14c0-4-6-10.8-6-10.8s-1.33 1.51-2.73 3.52l8.59 8.59c.09-.42.14-.86.14-1.31zm-.88 3.12L12.5 12.5 5.27 5.27 4 6.55l3.32 3.32C6.55 11.32 6 12.79 6 14c0 3.31 2.69 6 6 6 1.52 0 2.9-.57 3.96-1.5l2.63 2.63 1.27-1.27-2.74-2.74z"
            })), 'FormatColorReset');

            exports.default = _default;
            });

            unwrapExports$1(FormatColorReset);

            var FormatColorText = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              fillOpacity: ".36",
              d: "M0 20h24v4H0z"
            }), _react.default.createElement("path", {
              d: "M11 3L5.5 17h2.25l1.12-3h6.25l1.12 3h2.25L13 3h-2zm-1.38 9L12 5.67 14.38 12H9.62z"
            })), 'FormatColorText');

            exports.default = _default;
            });

            unwrapExports$1(FormatColorText);

            var FormatIndentDecrease = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M11 17h10v-2H11v2zm-8-5l4 4V8l-4 4zm0 9h18v-2H3v2zM3 3v2h18V3H3zm8 6h10V7H11v2zm0 4h10v-2H11v2z"
            })), 'FormatIndentDecrease');

            exports.default = _default;
            });

            unwrapExports$1(FormatIndentDecrease);

            var FormatIndentIncrease = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M3 21h18v-2H3v2zM3 8v8l4-4-4-4zm8 9h10v-2H11v2zM3 3v2h18V3H3zm8 6h10V7H11v2zm0 4h10v-2H11v2z"
            })), 'FormatIndentIncrease');

            exports.default = _default;
            });

            unwrapExports$1(FormatIndentIncrease);

            var FormatItalic = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M10 4v3h2.21l-3.42 8H6v3h8v-3h-2.21l3.42-8H18V4z"
            })), 'FormatItalic');

            exports.default = _default;
            });

            unwrapExports$1(FormatItalic);

            var FormatLineSpacing = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M6 7h2.5L5 3.5 1.5 7H4v10H1.5L5 20.5 8.5 17H6V7zm4-2v2h12V5H10zm0 14h12v-2H10v2zm0-6h12v-2H10v2z"
            })), 'FormatLineSpacing');

            exports.default = _default;
            });

            unwrapExports$1(FormatLineSpacing);

            var FormatListBulleted = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M4 10.5c-.83 0-1.5.67-1.5 1.5s.67 1.5 1.5 1.5 1.5-.67 1.5-1.5-.67-1.5-1.5-1.5zm0-6c-.83 0-1.5.67-1.5 1.5S3.17 7.5 4 7.5 5.5 6.83 5.5 6 4.83 4.5 4 4.5zm0 12c-.83 0-1.5.68-1.5 1.5s.68 1.5 1.5 1.5 1.5-.68 1.5-1.5-.67-1.5-1.5-1.5zM7 19h14v-2H7v2zm0-6h14v-2H7v2zm0-8v2h14V5H7z"
            })), 'FormatListBulleted');

            exports.default = _default;
            });

            unwrapExports$1(FormatListBulleted);

            var FormatListNumbered = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M2 17h2v.5H3v1h1v.5H2v1h3v-4H2v1zm1-9h1V4H2v1h1v3zm-1 3h1.8L2 13.1v.9h3v-1H3.2L5 10.9V10H2v1zm5-6v2h14V5H7zm0 14h14v-2H7v2zm0-6h14v-2H7v2z"
            })), 'FormatListNumbered');

            exports.default = _default;
            });

            unwrapExports$1(FormatListNumbered);

            var FormatPaint = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M18 4V3c0-.55-.45-1-1-1H5c-.55 0-1 .45-1 1v4c0 .55.45 1 1 1h12c.55 0 1-.45 1-1V6h1v4H9v11c0 .55.45 1 1 1h2c.55 0 1-.45 1-1v-9h8V4h-3z"
            })), 'FormatPaint');

            exports.default = _default;
            });

            unwrapExports$1(FormatPaint);

            var FormatQuote = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M6 17h3l2-4V7H5v6h3zm8 0h3l2-4V7h-6v6h3z"
            })), 'FormatQuote');

            exports.default = _default;
            });

            unwrapExports$1(FormatQuote);

            var FormatShapes = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M23 7V1h-6v2H7V1H1v6h2v10H1v6h6v-2h10v2h6v-6h-2V7h2zM3 3h2v2H3V3zm2 18H3v-2h2v2zm12-2H7v-2H5V7h2V5h10v2h2v10h-2v2zm4 2h-2v-2h2v2zM19 5V3h2v2h-2zm-5.27 9h-3.49l-.73 2H7.89l3.4-9h1.4l3.41 9h-1.63l-.74-2zm-3.04-1.26h2.61L12 8.91l-1.31 3.83z"
            })), 'FormatShapes');

            exports.default = _default;
            });

            unwrapExports$1(FormatShapes);

            var FormatSize = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M9 4v3h5v12h3V7h5V4H9zm-6 8h3v7h3v-7h3V9H3v3z"
            })), 'FormatSize');

            exports.default = _default;
            });

            unwrapExports$1(FormatSize);

            var FormatStrikethrough = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M10 19h4v-3h-4v3zM5 4v3h5v3h4V7h5V4H5zM3 14h18v-2H3v2z"
            })), 'FormatStrikethrough');

            exports.default = _default;
            });

            unwrapExports$1(FormatStrikethrough);

            var FormatTextdirectionLToR = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M9 10v5h2V4h2v11h2V4h2V2H9C6.79 2 5 3.79 5 6s1.79 4 4 4zm12 8l-4-4v3H5v2h12v3l4-4z"
            })), 'FormatTextdirectionLToR');

            exports.default = _default;
            });

            unwrapExports$1(FormatTextdirectionLToR);

            var FormatTextdirectionRToL = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M10 10v5h2V4h2v11h2V4h2V2h-8C7.79 2 6 3.79 6 6s1.79 4 4 4zm-2 7v-3l-4 4 4 4v-3h12v-2H8z"
            })), 'FormatTextdirectionRToL');

            exports.default = _default;
            });

            unwrapExports$1(FormatTextdirectionRToL);

            var FormatUnderlined = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M12 17c3.31 0 6-2.69 6-6V3h-2.5v8c0 1.93-1.57 3.5-3.5 3.5S8.5 12.93 8.5 11V3H6v8c0 3.31 2.69 6 6 6zm-7 2v2h14v-2H5z"
            })), 'FormatUnderlined');

            exports.default = _default;
            });

            unwrapExports$1(FormatUnderlined);

            var Forum = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M21 6h-2v9H6v2c0 .55.45 1 1 1h11l4 4V7c0-.55-.45-1-1-1zm-4 6V3c0-.55-.45-1-1-1H3c-.55 0-1 .45-1 1v14l4-4h10c.55 0 1-.45 1-1z"
            })), 'Forum');

            exports.default = _default;
            });

            unwrapExports$1(Forum);

            var Forward = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M12 8V4l8 8-8 8v-4H4V8z"
            })), 'Forward');

            exports.default = _default;
            });

            unwrapExports$1(Forward);

            var Forward10 = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M4 13c0 4.4 3.6 8 8 8s8-3.6 8-8h-2c0 3.3-2.7 6-6 6s-6-2.7-6-6 2.7-6 6-6v4l5-5-5-5v4c-4.4 0-8 3.6-8 8zm6.8 3H10v-3.3L9 13v-.7l1.8-.6h.1V16zm4.3-1.8c0 .3 0 .6-.1.8l-.3.6s-.3.3-.5.3-.4.1-.6.1-.4 0-.6-.1-.3-.2-.5-.3-.2-.3-.3-.6-.1-.5-.1-.8v-.7c0-.3 0-.6.1-.8l.3-.6s.3-.3.5-.3.4-.1.6-.1.4 0 .6.1.3.2.5.3.2.3.3.6.1.5.1.8v.7zm-.8-.8v-.5s-.1-.2-.1-.3-.1-.1-.2-.2-.2-.1-.3-.1-.2 0-.3.1l-.2.2s-.1.2-.1.3v2s.1.2.1.3.1.1.2.2.2.1.3.1.2 0 .3-.1l.2-.2s.1-.2.1-.3v-1.5z"
            })), 'Forward10');

            exports.default = _default;
            });

            unwrapExports$1(Forward10);

            var Forward30 = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M9.6 13.5h.4c.2 0 .4-.1.5-.2s.2-.2.2-.4v-.2s-.1-.1-.1-.2-.1-.1-.2-.1h-.5s-.1.1-.2.1-.1.1-.1.2v.2h-1c0-.2 0-.3.1-.5s.2-.3.3-.4.3-.2.4-.2.4-.1.5-.1c.2 0 .4 0 .6.1s.3.1.5.2.2.2.3.4.1.3.1.5v.3s-.1.2-.1.3-.1.2-.2.2-.2.1-.3.2c.2.1.4.2.5.4s.2.4.2.6c0 .2 0 .4-.1.5s-.2.3-.3.4-.3.2-.5.2-.4.1-.6.1c-.2 0-.4 0-.5-.1s-.3-.1-.5-.2-.2-.2-.3-.4-.1-.4-.1-.6h.8v.2s.1.1.1.2.1.1.2.1h.5s.1-.1.2-.1.1-.1.1-.2v-.5s-.1-.1-.1-.2-.1-.1-.2-.1h-.6v-.7zm5.7.7c0 .3 0 .6-.1.8l-.3.6s-.3.3-.5.3-.4.1-.6.1-.4 0-.6-.1-.3-.2-.5-.3-.2-.3-.3-.6-.1-.5-.1-.8v-.7c0-.3 0-.6.1-.8l.3-.6s.3-.3.5-.3.4-.1.6-.1.4 0 .6.1.3.2.5.3.2.3.3.6.1.5.1.8v.7zm-.9-.8v-.5s-.1-.2-.1-.3-.1-.1-.2-.2-.2-.1-.3-.1-.2 0-.3.1l-.2.2s-.1.2-.1.3v2s.1.2.1.3.1.1.2.2.2.1.3.1.2 0 .3-.1l.2-.2s.1-.2.1-.3v-1.5zM4 13c0 4.4 3.6 8 8 8s8-3.6 8-8h-2c0 3.3-2.7 6-6 6s-6-2.7-6-6 2.7-6 6-6v4l5-5-5-5v4c-4.4 0-8 3.6-8 8z"
            })), 'Forward30');

            exports.default = _default;
            });

            unwrapExports$1(Forward30);

            var Forward5 = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M4 13c0 4.4 3.6 8 8 8s8-3.6 8-8h-2c0 3.3-2.7 6-6 6s-6-2.7-6-6 2.7-6 6-6v4l5-5-5-5v4c-4.4 0-8 3.6-8 8zm6.7.9l.2-2.2h2.4v.7h-1.7l-.1.9s.1 0 .1-.1.1 0 .1-.1.1 0 .2 0h.2c.2 0 .4 0 .5.1s.3.2.4.3.2.3.3.5.1.4.1.6c0 .2 0 .4-.1.5s-.1.3-.3.5-.3.2-.5.3-.4.1-.6.1c-.2 0-.4 0-.5-.1s-.3-.1-.5-.2-.2-.2-.3-.4-.1-.3-.1-.5h.8c0 .2.1.3.2.4s.2.1.4.1c.1 0 .2 0 .3-.1l.2-.2s.1-.2.1-.3v-.6l-.1-.2-.2-.2s-.2-.1-.3-.1h-.2s-.1 0-.2.1-.1 0-.1.1-.1.1-.1.1h-.6z"
            })), 'Forward5');

            exports.default = _default;
            });

            unwrapExports$1(Forward5);

            var FreeBreakfast = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M20 3H4v10c0 2.21 1.79 4 4 4h6c2.21 0 4-1.79 4-4v-3h2c1.11 0 2-.9 2-2V5c0-1.11-.89-2-2-2zm0 5h-2V5h2v3zM4 19h16v2H4z"
            })), 'FreeBreakfast');

            exports.default = _default;
            });

            unwrapExports$1(FreeBreakfast);

            var Fullscreen = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M7 14H5v5h5v-2H7v-3zm-2-4h2V7h3V5H5v5zm12 7h-3v2h5v-5h-2v3zM14 5v2h3v3h2V5h-5z"
            })), 'Fullscreen');

            exports.default = _default;
            });

            unwrapExports$1(Fullscreen);

            var FullscreenExit = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M5 16h3v3h2v-5H5v2zm3-8H5v2h5V5H8v3zm6 11h2v-3h3v-2h-5v5zm2-11V5h-2v5h5V8h-3z"
            })), 'FullscreenExit');

            exports.default = _default;
            });

            unwrapExports$1(FullscreenExit);

            var Functions = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M18 4H6v2l6.5 6L6 18v2h12v-3h-7l5-5-5-5h7z"
            })), 'Functions');

            exports.default = _default;
            });

            unwrapExports$1(Functions);

            var Gamepad = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M15 7.5V2H9v5.5l3 3 3-3zM7.5 9H2v6h5.5l3-3-3-3zM9 16.5V22h6v-5.5l-3-3-3 3zM16.5 9l-3 3 3 3H22V9h-5.5z"
            })), 'Gamepad');

            exports.default = _default;
            });

            unwrapExports$1(Gamepad);

            var Games = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M15 7.5V2H9v5.5l3 3 3-3zM7.5 9H2v6h5.5l3-3-3-3zM9 16.5V22h6v-5.5l-3-3-3 3zM16.5 9l-3 3 3 3H22V9h-5.5z"
            })), 'Games');

            exports.default = _default;
            });

            unwrapExports$1(Games);

            var Gavel = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M1 21h12v2H1zM5.245 8.07l2.83-2.827 14.14 14.142-2.828 2.828zM12.317 1l5.657 5.656-2.83 2.83-5.654-5.66zM3.825 9.485l5.657 5.657-2.828 2.828-5.657-5.657z"
            })), 'Gavel');

            exports.default = _default;
            });

            unwrapExports$1(Gavel);

            var Gesture = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M4.59 6.89c.7-.71 1.4-1.35 1.71-1.22.5.2 0 1.03-.3 1.52-.25.42-2.86 3.89-2.86 6.31 0 1.28.48 2.34 1.34 2.98.75.56 1.74.73 2.64.46 1.07-.31 1.95-1.4 3.06-2.77 1.21-1.49 2.83-3.44 4.08-3.44 1.63 0 1.65 1.01 1.76 1.79-3.78.64-5.38 3.67-5.38 5.37 0 1.7 1.44 3.09 3.21 3.09 1.63 0 4.29-1.33 4.69-6.1H21v-2.5h-2.47c-.15-1.65-1.09-4.2-4.03-4.2-2.25 0-4.18 1.91-4.94 2.84-.58.73-2.06 2.48-2.29 2.72-.25.3-.68.84-1.11.84-.45 0-.72-.83-.36-1.92.35-1.09 1.4-2.86 1.85-3.52.78-1.14 1.3-1.92 1.3-3.28C8.95 3.69 7.31 3 6.44 3 5.12 3 3.97 4 3.72 4.25c-.36.36-.66.66-.88.93l1.75 1.71zm9.29 11.66c-.31 0-.74-.26-.74-.72 0-.6.73-2.2 2.87-2.76-.3 2.69-1.43 3.48-2.13 3.48z"
            })), 'Gesture');

            exports.default = _default;
            });

            unwrapExports$1(Gesture);

            var GetApp = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M19 9h-4V3H9v6H5l7 7 7-7zM5 18v2h14v-2H5z"
            })), 'GetApp');

            exports.default = _default;
            });

            unwrapExports$1(GetApp);

            var Gif = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M11.5 9H13v6h-1.5zM9 9H6c-.6 0-1 .5-1 1v4c0 .5.4 1 1 1h3c.6 0 1-.5 1-1v-2H8.5v1.5h-2v-3H10V10c0-.5-.4-1-1-1zm10 1.5V9h-4.5v6H16v-2h2v-1.5h-2v-1z"
            })), 'Gif');

            exports.default = _default;
            });

            unwrapExports$1(Gif);

            var GolfCourse = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("circle", {
              cx: "19.5",
              cy: "19.5",
              r: "1.5"
            }), _react.default.createElement("path", {
              d: "M17 5.92L9 2v18H7v-1.73c-1.79.35-3 .99-3 1.73 0 1.1 2.69 2 6 2s6-.9 6-2c0-.99-2.16-1.81-5-1.97V8.98l6-3.06z"
            })), 'GolfCourse');

            exports.default = _default;
            });

            unwrapExports$1(GolfCourse);

            var GpsFixed = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M12 8c-2.21 0-4 1.79-4 4s1.79 4 4 4 4-1.79 4-4-1.79-4-4-4zm8.94 3c-.46-4.17-3.77-7.48-7.94-7.94V1h-2v2.06C6.83 3.52 3.52 6.83 3.06 11H1v2h2.06c.46 4.17 3.77 7.48 7.94 7.94V23h2v-2.06c4.17-.46 7.48-3.77 7.94-7.94H23v-2h-2.06zM12 19c-3.87 0-7-3.13-7-7s3.13-7 7-7 7 3.13 7 7-3.13 7-7 7z"
            })), 'GpsFixed');

            exports.default = _default;
            });

            unwrapExports$1(GpsFixed);

            var GpsNotFixed = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M20.94 11c-.46-4.17-3.77-7.48-7.94-7.94V1h-2v2.06C6.83 3.52 3.52 6.83 3.06 11H1v2h2.06c.46 4.17 3.77 7.48 7.94 7.94V23h2v-2.06c4.17-.46 7.48-3.77 7.94-7.94H23v-2h-2.06zM12 19c-3.87 0-7-3.13-7-7s3.13-7 7-7 7 3.13 7 7-3.13 7-7 7z"
            })), 'GpsNotFixed');

            exports.default = _default;
            });

            unwrapExports$1(GpsNotFixed);

            var GpsOff = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M20.94 11c-.46-4.17-3.77-7.48-7.94-7.94V1h-2v2.06c-1.13.12-2.19.46-3.16.97l1.5 1.5C10.16 5.19 11.06 5 12 5c3.87 0 7 3.13 7 7 0 .94-.19 1.84-.52 2.65l1.5 1.5c.5-.96.84-2.02.97-3.15H23v-2h-2.06zM3 4.27l2.04 2.04C3.97 7.62 3.25 9.23 3.06 11H1v2h2.06c.46 4.17 3.77 7.48 7.94 7.94V23h2v-2.06c1.77-.2 3.38-.91 4.69-1.98L19.73 21 21 19.73 4.27 3 3 4.27zm13.27 13.27C15.09 18.45 13.61 19 12 19c-3.87 0-7-3.13-7-7 0-1.61.55-3.09 1.46-4.27l9.81 9.81z"
            })), 'GpsOff');

            exports.default = _default;
            });

            unwrapExports$1(GpsOff);

            var Grade = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M12 17.27L18.18 21l-1.64-7.03L22 9.24l-7.19-.61L12 2 9.19 8.63 2 9.24l5.46 4.73L5.82 21z"
            })), 'Grade');

            exports.default = _default;
            });

            unwrapExports$1(Grade);

            var Gradient = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M11 9h2v2h-2zm-2 2h2v2H9zm4 0h2v2h-2zm2-2h2v2h-2zM7 9h2v2H7zm12-6H5c-1.1 0-2 .9-2 2v14c0 1.1.9 2 2 2h14c1.1 0 2-.9 2-2V5c0-1.1-.9-2-2-2zM9 18H7v-2h2v2zm4 0h-2v-2h2v2zm4 0h-2v-2h2v2zm2-7h-2v2h2v2h-2v-2h-2v2h-2v-2h-2v2H9v-2H7v2H5v-2h2v-2H5V5h14v6z"
            })), 'Gradient');

            exports.default = _default;
            });

            unwrapExports$1(Gradient);

            var Grain = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M10 12c-1.1 0-2 .9-2 2s.9 2 2 2 2-.9 2-2-.9-2-2-2zM6 8c-1.1 0-2 .9-2 2s.9 2 2 2 2-.9 2-2-.9-2-2-2zm0 8c-1.1 0-2 .9-2 2s.9 2 2 2 2-.9 2-2-.9-2-2-2zm12-8c1.1 0 2-.9 2-2s-.9-2-2-2-2 .9-2 2 .9 2 2 2zm-4 8c-1.1 0-2 .9-2 2s.9 2 2 2 2-.9 2-2-.9-2-2-2zm4-4c-1.1 0-2 .9-2 2s.9 2 2 2 2-.9 2-2-.9-2-2-2zm-4-4c-1.1 0-2 .9-2 2s.9 2 2 2 2-.9 2-2-.9-2-2-2zm-4-4c-1.1 0-2 .9-2 2s.9 2 2 2 2-.9 2-2-.9-2-2-2z"
            })), 'Grain');

            exports.default = _default;
            });

            unwrapExports$1(Grain);

            var GraphicEq = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M7 18h2V6H7v12zm4 4h2V2h-2v20zm-8-8h2v-4H3v4zm12 4h2V6h-2v12zm4-8v4h2v-4h-2z"
            })), 'GraphicEq');

            exports.default = _default;
            });

            unwrapExports$1(GraphicEq);

            var GridOff = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M8 4v1.45l2 2V4h4v4h-3.45l2 2H14v1.45l2 2V10h4v4h-3.45l2 2H20v1.45l2 2V4c0-1.1-.9-2-2-2H4.55l2 2H8zm8 0h4v4h-4V4zM1.27 1.27L0 2.55l2 2V20c0 1.1.9 2 2 2h15.46l2 2 1.27-1.27L1.27 1.27zM10 12.55L11.45 14H10v-1.45zm-6-6L5.45 8H4V6.55zM8 20H4v-4h4v4zm0-6H4v-4h3.45l.55.55V14zm6 6h-4v-4h3.45l.55.54V20zm2 0v-1.46L17.46 20H16z"
            })), 'GridOff');

            exports.default = _default;
            });

            unwrapExports$1(GridOff);

            var GridOn = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M20 2H4c-1.1 0-2 .9-2 2v16c0 1.1.9 2 2 2h16c1.1 0 2-.9 2-2V4c0-1.1-.9-2-2-2zM8 20H4v-4h4v4zm0-6H4v-4h4v4zm0-6H4V4h4v4zm6 12h-4v-4h4v4zm0-6h-4v-4h4v4zm0-6h-4V4h4v4zm6 12h-4v-4h4v4zm0-6h-4v-4h4v4zm0-6h-4V4h4v4z"
            })), 'GridOn');

            exports.default = _default;
            });

            unwrapExports$1(GridOn);

            var Group = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M16 11c1.66 0 2.99-1.34 2.99-3S17.66 5 16 5c-1.66 0-3 1.34-3 3s1.34 3 3 3zm-8 0c1.66 0 2.99-1.34 2.99-3S9.66 5 8 5C6.34 5 5 6.34 5 8s1.34 3 3 3zm0 2c-2.33 0-7 1.17-7 3.5V19h14v-2.5c0-2.33-4.67-3.5-7-3.5zm8 0c-.29 0-.62.02-.97.05 1.16.84 1.97 1.97 1.97 3.45V19h6v-2.5c0-2.33-4.67-3.5-7-3.5z"
            })), 'Group');

            exports.default = _default;
            });

            unwrapExports$1(Group);

            var GroupAdd = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M8 10H5V7H3v3H0v2h3v3h2v-3h3v-2zm10 1c1.66 0 2.99-1.34 2.99-3S19.66 5 18 5c-.32 0-.63.05-.91.14.57.81.9 1.79.9 2.86s-.34 2.04-.9 2.86c.28.09.59.14.91.14zm-5 0c1.66 0 2.99-1.34 2.99-3S14.66 5 13 5c-1.66 0-3 1.34-3 3s1.34 3 3 3zm6.62 2.16c.83.73 1.38 1.66 1.38 2.84v2h3v-2c0-1.54-2.37-2.49-4.38-2.84zM13 13c-2 0-6 1-6 3v2h12v-2c0-2-4-3-6-3z"
            })), 'GroupAdd');

            exports.default = _default;
            });

            unwrapExports$1(GroupAdd);

            var GroupWork = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M12 2C6.48 2 2 6.48 2 12s4.48 10 10 10 10-4.48 10-10S17.52 2 12 2zM8 17.5c-1.38 0-2.5-1.12-2.5-2.5s1.12-2.5 2.5-2.5 2.5 1.12 2.5 2.5-1.12 2.5-2.5 2.5zM9.5 8c0-1.38 1.12-2.5 2.5-2.5s2.5 1.12 2.5 2.5-1.12 2.5-2.5 2.5S9.5 9.38 9.5 8zm6.5 9.5c-1.38 0-2.5-1.12-2.5-2.5s1.12-2.5 2.5-2.5 2.5 1.12 2.5 2.5-1.12 2.5-2.5 2.5z"
            })), 'GroupWork');

            exports.default = _default;
            });

            unwrapExports$1(GroupWork);

            var GTranslate = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M20 5h-9.12L10 2H4c-1.1 0-2 .9-2 2v13c0 1.1.9 2 2 2h7l1 3h8c1.1 0 2-.9 2-2V7c0-1.1-.9-2-2-2zM7.17 14.59c-2.25 0-4.09-1.83-4.09-4.09s1.83-4.09 4.09-4.09c1.04 0 1.99.37 2.74 1.07l.07.06-1.23 1.18-.06-.05c-.29-.27-.78-.59-1.52-.59-1.31 0-2.38 1.09-2.38 2.42s1.07 2.42 2.38 2.42c1.37 0 1.96-.87 2.12-1.46H7.08V9.91h3.95l.01.07c.04.21.05.4.05.61 0 2.35-1.61 4-3.92 4zm6.03-1.71c.33.6.74 1.18 1.19 1.7l-.54.53-.65-2.23zm.77-.76h-.99l-.31-1.04h3.99s-.34 1.31-1.56 2.74c-.52-.62-.89-1.23-1.13-1.7zM21 20c0 .55-.45 1-1 1h-7l2-2-.81-2.77.92-.92L17.79 18l.73-.73-2.71-2.68c.9-1.03 1.6-2.25 1.92-3.51H19v-1.04h-3.64V9h-1.04v1.04h-1.96L11.18 6H20c.55 0 1 .45 1 1v13z"
            })), 'GTranslate');

            exports.default = _default;
            });

            unwrapExports$1(GTranslate);

            var Hd = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M19 3H5c-1.11 0-2 .9-2 2v14c0 1.1.89 2 2 2h14c1.1 0 2-.9 2-2V5c0-1.1-.9-2-2-2zm-8 12H9.5v-2h-2v2H6V9h1.5v2.5h2V9H11v6zm2-6h4c.55 0 1 .45 1 1v4c0 .55-.45 1-1 1h-4V9zm1.5 4.5h2v-3h-2v3z"
            })), 'Hd');

            exports.default = _default;
            });

            unwrapExports$1(Hd);

            var HdrOff = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M17.5 15v-2h1.1l.9 2H21l-.9-2.1c.5-.2.9-.8.9-1.4v-1c0-.8-.7-1.5-1.5-1.5H16v4.9l1.1 1.1h.4zm0-4.5h2v1h-2v-1zm-4.5 0v.4l1.5 1.5v-1.9c0-.8-.7-1.5-1.5-1.5h-1.9l1.5 1.5h.4zm-3.5-1l-7-7-1.1 1L6.9 9h-.4v2h-2V9H3v6h1.5v-2.5h2V15H8v-4.9l1.5 1.5V15h3.4l7.6 7.6 1.1-1.1-12.1-12z"
            })), 'HdrOff');

            exports.default = _default;
            });

            unwrapExports$1(HdrOff);

            var HdrOn = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M21 11.5v-1c0-.8-.7-1.5-1.5-1.5H16v6h1.5v-2h1.1l.9 2H21l-.9-2.1c.5-.3.9-.8.9-1.4zm-1.5 0h-2v-1h2v1zm-13-.5h-2V9H3v6h1.5v-2.5h2V15H8V9H6.5v2zM13 9H9.5v6H13c.8 0 1.5-.7 1.5-1.5v-3c0-.8-.7-1.5-1.5-1.5zm0 4.5h-2v-3h2v3z"
            })), 'HdrOn');

            exports.default = _default;
            });

            unwrapExports$1(HdrOn);

            var HdrStrong = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M17 6c-3.31 0-6 2.69-6 6s2.69 6 6 6 6-2.69 6-6-2.69-6-6-6zM5 8c-2.21 0-4 1.79-4 4s1.79 4 4 4 4-1.79 4-4-1.79-4-4-4zm0 6c-1.1 0-2-.9-2-2s.9-2 2-2 2 .9 2 2-.9 2-2 2z"
            })), 'HdrStrong');

            exports.default = _default;
            });

            unwrapExports$1(HdrStrong);

            var HdrWeak = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M5 8c-2.21 0-4 1.79-4 4s1.79 4 4 4 4-1.79 4-4-1.79-4-4-4zm12-2c-3.31 0-6 2.69-6 6s2.69 6 6 6 6-2.69 6-6-2.69-6-6-6zm0 10c-2.21 0-4-1.79-4-4s1.79-4 4-4 4 1.79 4 4-1.79 4-4 4z"
            })), 'HdrWeak');

            exports.default = _default;
            });

            unwrapExports$1(HdrWeak);

            var Headset = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M12 1c-4.97 0-9 4.03-9 9v7c0 1.66 1.34 3 3 3h3v-8H5v-2c0-3.87 3.13-7 7-7s7 3.13 7 7v2h-4v8h3c1.66 0 3-1.34 3-3v-7c0-4.97-4.03-9-9-9z"
            })), 'Headset');

            exports.default = _default;
            });

            unwrapExports$1(Headset);

            var HeadsetMic = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M12 1c-4.97 0-9 4.03-9 9v7c0 1.66 1.34 3 3 3h3v-8H5v-2c0-3.87 3.13-7 7-7s7 3.13 7 7v2h-4v8h4v1h-7v2h6c1.66 0 3-1.34 3-3V10c0-4.97-4.03-9-9-9z"
            })), 'HeadsetMic');

            exports.default = _default;
            });

            unwrapExports$1(HeadsetMic);

            var Healing = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M17.73 12.02l3.98-3.98c.39-.39.39-1.02 0-1.41l-4.34-4.34c-.39-.39-1.02-.39-1.41 0l-3.98 3.98L8 2.29C7.8 2.1 7.55 2 7.29 2c-.25 0-.51.1-.7.29L2.25 6.63c-.39.39-.39 1.02 0 1.41l3.98 3.98L2.25 16c-.39.39-.39 1.02 0 1.41l4.34 4.34c.39.39 1.02.39 1.41 0l3.98-3.98 3.98 3.98c.2.2.45.29.71.29.26 0 .51-.1.71-.29l4.34-4.34c.39-.39.39-1.02 0-1.41l-3.99-3.98zM12 9c.55 0 1 .45 1 1s-.45 1-1 1-1-.45-1-1 .45-1 1-1zm-4.71 1.96L3.66 7.34l3.63-3.63 3.62 3.62-3.62 3.63zM10 13c-.55 0-1-.45-1-1s.45-1 1-1 1 .45 1 1-.45 1-1 1zm2 2c-.55 0-1-.45-1-1s.45-1 1-1 1 .45 1 1-.45 1-1 1zm2-4c.55 0 1 .45 1 1s-.45 1-1 1-1-.45-1-1 .45-1 1-1zm2.66 9.34l-3.63-3.62 3.63-3.63 3.62 3.62-3.62 3.63z"
            })), 'Healing');

            exports.default = _default;
            });

            unwrapExports$1(Healing);

            var Hearing = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M17 20c-.29 0-.56-.06-.76-.15-.71-.37-1.21-.88-1.71-2.38-.51-1.56-1.47-2.29-2.39-3-.79-.61-1.61-1.24-2.32-2.53C9.29 10.98 9 9.93 9 9c0-2.8 2.2-5 5-5s5 2.2 5 5h2c0-3.93-3.07-7-7-7S7 5.07 7 9c0 1.26.38 2.65 1.07 3.9.91 1.65 1.98 2.48 2.85 3.15.81.62 1.39 1.07 1.71 2.05.6 1.82 1.37 2.84 2.73 3.55.51.23 1.07.35 1.64.35 2.21 0 4-1.79 4-4h-2c0 1.1-.9 2-2 2zM7.64 2.64L6.22 1.22C4.23 3.21 3 5.96 3 9s1.23 5.79 3.22 7.78l1.41-1.41C6.01 13.74 5 11.49 5 9s1.01-4.74 2.64-6.36zM11.5 9c0 1.38 1.12 2.5 2.5 2.5s2.5-1.12 2.5-2.5-1.12-2.5-2.5-2.5-2.5 1.12-2.5 2.5z"
            })), 'Hearing');

            exports.default = _default;
            });

            unwrapExports$1(Hearing);

            var Help = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M12 2C6.48 2 2 6.48 2 12s4.48 10 10 10 10-4.48 10-10S17.52 2 12 2zm1 17h-2v-2h2v2zm2.07-7.75l-.9.92C13.45 12.9 13 13.5 13 15h-2v-.5c0-1.1.45-2.1 1.17-2.83l1.24-1.26c.37-.36.59-.86.59-1.41 0-1.1-.9-2-2-2s-2 .9-2 2H8c0-2.21 1.79-4 4-4s4 1.79 4 4c0 .88-.36 1.68-.93 2.25z"
            })), 'Help');

            exports.default = _default;
            });

            unwrapExports$1(Help);

            var HelpOutline = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M11 18h2v-2h-2v2zm1-16C6.48 2 2 6.48 2 12s4.48 10 10 10 10-4.48 10-10S17.52 2 12 2zm0 18c-4.41 0-8-3.59-8-8s3.59-8 8-8 8 3.59 8 8-3.59 8-8 8zm0-14c-2.21 0-4 1.79-4 4h2c0-1.1.9-2 2-2s2 .9 2 2c0 2-3 1.75-3 5h2c0-2.25 3-2.5 3-5 0-2.21-1.79-4-4-4z"
            })), 'HelpOutline');

            exports.default = _default;
            });

            unwrapExports$1(HelpOutline);

            var Highlight = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M6 14l3 3v5h6v-5l3-3V9H6zm5-12h2v3h-2zM3.5 5.875L4.914 4.46l2.12 2.122L5.62 7.997zm13.46.71l2.123-2.12 1.414 1.414L18.375 8z"
            })), 'Highlight');

            exports.default = _default;
            });

            unwrapExports$1(Highlight);

            var HighlightOff = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M14.59 8L12 10.59 9.41 8 8 9.41 10.59 12 8 14.59 9.41 16 12 13.41 14.59 16 16 14.59 13.41 12 16 9.41 14.59 8zM12 2C6.47 2 2 6.47 2 12s4.47 10 10 10 10-4.47 10-10S17.53 2 12 2zm0 18c-4.41 0-8-3.59-8-8s3.59-8 8-8 8 3.59 8 8-3.59 8-8 8z"
            })), 'HighlightOff');

            exports.default = _default;
            });

            unwrapExports$1(HighlightOff);

            var HighQuality = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M19 4H5c-1.11 0-2 .9-2 2v12c0 1.1.89 2 2 2h14c1.1 0 2-.9 2-2V6c0-1.1-.9-2-2-2zm-8 11H9.5v-2h-2v2H6V9h1.5v2.5h2V9H11v6zm7-1c0 .55-.45 1-1 1h-.75v1.5h-1.5V15H14c-.55 0-1-.45-1-1v-4c0-.55.45-1 1-1h3c.55 0 1 .45 1 1v4zm-3.5-.5h2v-3h-2v3z"
            })), 'HighQuality');

            exports.default = _default;
            });

            unwrapExports$1(HighQuality);

            var History = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M13 3c-4.97 0-9 4.03-9 9H1l3.89 3.89.07.14L9 12H6c0-3.87 3.13-7 7-7s7 3.13 7 7-3.13 7-7 7c-1.93 0-3.68-.79-4.94-2.06l-1.42 1.42C8.27 19.99 10.51 21 13 21c4.97 0 9-4.03 9-9s-4.03-9-9-9zm-1 5v5l4.28 2.54.72-1.21-3.5-2.08V8H12z"
            })), 'History');

            exports.default = _default;
            });

            unwrapExports$1(History);

            var Home = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M10 20v-6h4v6h5v-8h3L12 3 2 12h3v8z"
            })), 'Home');

            exports.default = _default;
            });

            unwrapExports$1(Home);

            var Hotel = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M7 13c1.66 0 3-1.34 3-3S8.66 7 7 7s-3 1.34-3 3 1.34 3 3 3zm12-6h-8v7H3V5H1v15h2v-3h18v3h2v-9c0-2.21-1.79-4-4-4z"
            })), 'Hotel');

            exports.default = _default;
            });

            unwrapExports$1(Hotel);

            var HotTub = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("circle", {
              cx: "7",
              cy: "6",
              r: "2"
            }), _react.default.createElement("path", {
              d: "M11.15 12c-.31-.22-.59-.46-.82-.72l-1.4-1.55c-.19-.21-.43-.38-.69-.5-.29-.14-.62-.23-.96-.23h-.03C6.01 9 5 10.01 5 11.25V12H2v8c0 1.1.9 2 2 2h16c1.1 0 2-.9 2-2v-8H11.15zM7 20H5v-6h2v6zm4 0H9v-6h2v6zm4 0h-2v-6h2v6zm4 0h-2v-6h2v6zm-.35-14.14l-.07-.07c-.57-.62-.82-1.41-.67-2.2L18 3h-1.89l-.06.43c-.2 1.36.27 2.71 1.3 3.72l.07.06c.57.62.82 1.41.67 2.2l-.11.59h1.91l.06-.43c.21-1.36-.27-2.71-1.3-3.71zm-4 0l-.07-.07c-.57-.62-.82-1.41-.67-2.2L14 3h-1.89l-.06.43c-.2 1.36.27 2.71 1.3 3.72l.07.06c.57.62.82 1.41.67 2.2l-.11.59h1.91l.06-.43c.21-1.36-.27-2.71-1.3-3.71z"
            })), 'HotTub');

            exports.default = _default;
            });

            unwrapExports$1(HotTub);

            var HourglassEmpty = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M6 2v6h.01L6 8.01 10 12l-4 4 .01.01H6V22h12v-5.99h-.01L18 16l-4-4 4-3.99-.01-.01H18V2H6zm10 14.5V20H8v-3.5l4-4 4 4zm-4-5l-4-4V4h8v3.5l-4 4z"
            })), 'HourglassEmpty');

            exports.default = _default;
            });

            unwrapExports$1(HourglassEmpty);

            var HourglassFull = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M6 2v6h.01L6 8.01 10 12l-4 4 .01.01H6V22h12v-5.99h-.01L18 16l-4-4 4-3.99-.01-.01H18V2H6z"
            })), 'HourglassFull');

            exports.default = _default;
            });

            unwrapExports$1(HourglassFull);

            var Http = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M4.5 11h-2V9H1v6h1.5v-2.5h2V15H6V9H4.5v2zm2.5-.5h1.5V15H10v-4.5h1.5V9H7v1.5zm5.5 0H14V15h1.5v-4.5H17V9h-4.5v1.5zm9-1.5H18v6h1.5v-2h2c.8 0 1.5-.7 1.5-1.5v-1c0-.8-.7-1.5-1.5-1.5zm0 2.5h-2v-1h2v1z"
            })), 'Http');

            exports.default = _default;
            });

            unwrapExports$1(Http);

            var Https = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M18 8h-1V6c0-2.76-2.24-5-5-5S7 3.24 7 6v2H6c-1.1 0-2 .9-2 2v10c0 1.1.9 2 2 2h12c1.1 0 2-.9 2-2V10c0-1.1-.9-2-2-2zm-6 9c-1.1 0-2-.9-2-2s.9-2 2-2 2 .9 2 2-.9 2-2 2zm3.1-9H8.9V6c0-1.71 1.39-3.1 3.1-3.1 1.71 0 3.1 1.39 3.1 3.1v2z"
            })), 'Https');

            exports.default = _default;
            });

            unwrapExports$1(Https);

            var Image = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M21 19V5c0-1.1-.9-2-2-2H5c-1.1 0-2 .9-2 2v14c0 1.1.9 2 2 2h14c1.1 0 2-.9 2-2zM8.5 13.5l2.5 3.01L14.5 12l4.5 6H5l3.5-4.5z"
            })), 'Image');

            exports.default = _default;
            });

            unwrapExports$1(Image);

            var ImageAspectRatio = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M16 10h-2v2h2v-2zm0 4h-2v2h2v-2zm-8-4H6v2h2v-2zm4 0h-2v2h2v-2zm8-6H4c-1.1 0-2 .9-2 2v12c0 1.1.9 2 2 2h16c1.1 0 2-.9 2-2V6c0-1.1-.9-2-2-2zm0 14H4V6h16v12z"
            })), 'ImageAspectRatio');

            exports.default = _default;
            });

            unwrapExports$1(ImageAspectRatio);

            var ImportantDevices = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M23 11.01L18 11c-.55 0-1 .45-1 1v9c0 .55.45 1 1 1h5c.55 0 1-.45 1-1v-9c0-.55-.45-.99-1-.99zM23 20h-5v-7h5v7zM20 2H2C.89 2 0 2.89 0 4v12c0 1.1.89 2 2 2h7v2H7v2h8v-2h-2v-2h2v-2H2V4h18v5h2V4c0-1.11-.9-2-2-2zm-8.03 7L11 6l-.97 3H7l2.47 1.76-.94 2.91 2.47-1.8 2.47 1.8-.94-2.91L15 9h-3.03z"
            })), 'ImportantDevices');

            exports.default = _default;
            });

            unwrapExports$1(ImportantDevices);

            var ImportContacts = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M21 5c-1.11-.35-2.33-.5-3.5-.5-1.95 0-4.05.4-5.5 1.5-1.45-1.1-3.55-1.5-5.5-1.5S2.45 4.9 1 6v14.65c0 .25.25.5.5.5.1 0 .15-.05.25-.05C3.1 20.45 5.05 20 6.5 20c1.95 0 4.05.4 5.5 1.5 1.35-.85 3.8-1.5 5.5-1.5 1.65 0 3.35.3 4.75 1.05.1.05.15.05.25.05.25 0 .5-.25.5-.5V6c-.6-.45-1.25-.75-2-1zm0 13.5c-1.1-.35-2.3-.5-3.5-.5-1.7 0-4.15.65-5.5 1.5V8c1.35-.85 3.8-1.5 5.5-1.5 1.2 0 2.4.15 3.5.5v11.5z"
            })), 'ImportContacts');

            exports.default = _default;
            });

            unwrapExports$1(ImportContacts);

            var ImportExport = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M9 3L5 6.99h3V14h2V6.99h3L9 3zm7 14.01V10h-2v7.01h-3L15 21l4-3.99h-3z"
            })), 'ImportExport');

            exports.default = _default;
            });

            unwrapExports$1(ImportExport);

            var Inbox = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M19 3H4.99c-1.11 0-1.98.89-1.98 2L3 19c0 1.1.88 2 1.99 2H19c1.1 0 2-.9 2-2V5c0-1.11-.9-2-2-2zm0 12h-4c0 1.66-1.35 3-3 3s-3-1.34-3-3H4.99V5H19v10z"
            })), 'Inbox');

            exports.default = _default;
            });

            unwrapExports$1(Inbox);

            var IndeterminateCheckBox = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M19 3H5c-1.1 0-2 .9-2 2v14c0 1.1.9 2 2 2h14c1.1 0 2-.9 2-2V5c0-1.1-.9-2-2-2zm-2 10H7v-2h10v2z"
            })), 'IndeterminateCheckBox');

            exports.default = _default;
            });

            unwrapExports$1(IndeterminateCheckBox);

            var Info = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M12 2C6.48 2 2 6.48 2 12s4.48 10 10 10 10-4.48 10-10S17.52 2 12 2zm1 15h-2v-6h2v6zm0-8h-2V7h2v2z"
            })), 'Info');

            exports.default = _default;
            });

            unwrapExports$1(Info);

            var InfoOutline = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M11 17h2v-6h-2v6zm1-15C6.48 2 2 6.48 2 12s4.48 10 10 10 10-4.48 10-10S17.52 2 12 2zm0 18c-4.41 0-8-3.59-8-8s3.59-8 8-8 8 3.59 8 8-3.59 8-8 8zM11 9h2V7h-2v2z"
            })), 'InfoOutline');

            exports.default = _default;
            });

            unwrapExports$1(InfoOutline);

            var Input = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M21 3.01H3c-1.1 0-2 .9-2 2V9h2V4.99h18v14.03H3V15H1v4.01c0 1.1.9 1.98 2 1.98h18c1.1 0 2-.88 2-1.98v-14c0-1.11-.9-2-2-2zM11 16l4-4-4-4v3H1v2h10v3z"
            })), 'Input');

            exports.default = _default;
            });

            unwrapExports$1(Input);

            var InsertChart = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M19 3H5c-1.1 0-2 .9-2 2v14c0 1.1.9 2 2 2h14c1.1 0 2-.9 2-2V5c0-1.1-.9-2-2-2zM9 17H7v-7h2v7zm4 0h-2V7h2v10zm4 0h-2v-4h2v4z"
            })), 'InsertChart');

            exports.default = _default;
            });

            unwrapExports$1(InsertChart);

            var InsertComment = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M20 2H4c-1.1 0-2 .9-2 2v12c0 1.1.9 2 2 2h14l4 4V4c0-1.1-.9-2-2-2zm-2 12H6v-2h12v2zm0-3H6V9h12v2zm0-3H6V6h12v2z"
            })), 'InsertComment');

            exports.default = _default;
            });

            unwrapExports$1(InsertComment);

            var InsertDriveFile = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M6 2c-1.1 0-1.99.9-1.99 2L4 20c0 1.1.89 2 1.99 2H18c1.1 0 2-.9 2-2V8l-6-6H6zm7 7V3.5L18.5 9H13z"
            })), 'InsertDriveFile');

            exports.default = _default;
            });

            unwrapExports$1(InsertDriveFile);

            var InsertEmoticon = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M11.99 2C6.47 2 2 6.48 2 12s4.47 10 9.99 10C17.52 22 22 17.52 22 12S17.52 2 11.99 2zM12 20c-4.42 0-8-3.58-8-8s3.58-8 8-8 8 3.58 8 8-3.58 8-8 8zm3.5-9c.83 0 1.5-.67 1.5-1.5S16.33 8 15.5 8 14 8.67 14 9.5s.67 1.5 1.5 1.5zm-7 0c.83 0 1.5-.67 1.5-1.5S9.33 8 8.5 8 7 8.67 7 9.5 7.67 11 8.5 11zm3.5 6.5c2.33 0 4.31-1.46 5.11-3.5H6.89c.8 2.04 2.78 3.5 5.11 3.5z"
            })), 'InsertEmoticon');

            exports.default = _default;
            });

            unwrapExports$1(InsertEmoticon);

            var InsertInvitation = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M17 12h-5v5h5v-5zM16 1v2H8V1H6v2H5c-1.11 0-1.99.9-1.99 2L3 19c0 1.1.89 2 2 2h14c1.1 0 2-.9 2-2V5c0-1.1-.9-2-2-2h-1V1h-2zm3 18H5V8h14v11z"
            })), 'InsertInvitation');

            exports.default = _default;
            });

            unwrapExports$1(InsertInvitation);

            var InsertLink = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M3.9 12c0-1.71 1.39-3.1 3.1-3.1h4V7H7c-2.76 0-5 2.24-5 5s2.24 5 5 5h4v-1.9H7c-1.71 0-3.1-1.39-3.1-3.1zM8 13h8v-2H8v2zm9-6h-4v1.9h4c1.71 0 3.1 1.39 3.1 3.1s-1.39 3.1-3.1 3.1h-4V17h4c2.76 0 5-2.24 5-5s-2.24-5-5-5z"
            })), 'InsertLink');

            exports.default = _default;
            });

            unwrapExports$1(InsertLink);

            var InsertPhoto = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M21 19V5c0-1.1-.9-2-2-2H5c-1.1 0-2 .9-2 2v14c0 1.1.9 2 2 2h14c1.1 0 2-.9 2-2zM8.5 13.5l2.5 3.01L14.5 12l4.5 6H5l3.5-4.5z"
            })), 'InsertPhoto');

            exports.default = _default;
            });

            unwrapExports$1(InsertPhoto);

            var InvertColors = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M17.66 7.93L12 2.27 6.34 7.93c-3.12 3.12-3.12 8.19 0 11.31C7.9 20.8 9.95 21.58 12 21.58c2.05 0 4.1-.78 5.66-2.34 3.12-3.12 3.12-8.19 0-11.31zM12 19.59c-1.6 0-3.11-.62-4.24-1.76C6.62 16.69 6 15.19 6 13.59s.62-3.11 1.76-4.24L12 5.1v14.49z"
            })), 'InvertColors');

            exports.default = _default;
            });

            unwrapExports$1(InvertColors);

            var InvertColorsOff = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M20.65 20.87l-2.35-2.35-6.3-6.29-3.56-3.57-1.42-1.41L4.27 4.5 3 5.77l2.78 2.78c-2.55 3.14-2.36 7.76.56 10.69C7.9 20.8 9.95 21.58 12 21.58c1.79 0 3.57-.59 5.03-1.78l2.7 2.7L21 21.23l-.35-.36zM12 19.59c-1.6 0-3.11-.62-4.24-1.76C6.62 16.69 6 15.19 6 13.59c0-1.32.43-2.57 1.21-3.6L12 14.77v4.82zM12 5.1v4.58l7.25 7.26c1.37-2.96.84-6.57-1.6-9.01L12 2.27l-3.7 3.7 1.41 1.41L12 5.1z"
            })), 'InvertColorsOff');

            exports.default = _default;
            });

            unwrapExports$1(InvertColorsOff);

            var Iso = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M19 3H5c-1.1 0-2 .9-2 2v14c0 1.1.9 2 2 2h14c1.1 0 2-.9 2-2V5c0-1.1-.9-2-2-2zM5.5 7.5h2v-2H9v2h2V9H9v2H7.5V9h-2V7.5zM19 19H5L19 5v14zm-2-2v-1.5h-5V17h5z"
            })), 'Iso');

            exports.default = _default;
            });

            unwrapExports$1(Iso);

            var Keyboard = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M20 5H4c-1.1 0-1.99.9-1.99 2L2 17c0 1.1.9 2 2 2h16c1.1 0 2-.9 2-2V7c0-1.1-.9-2-2-2zm-9 3h2v2h-2V8zm0 3h2v2h-2v-2zM8 8h2v2H8V8zm0 3h2v2H8v-2zm-1 2H5v-2h2v2zm0-3H5V8h2v2zm9 7H8v-2h8v2zm0-4h-2v-2h2v2zm0-3h-2V8h2v2zm3 3h-2v-2h2v2zm0-3h-2V8h2v2z"
            })), 'Keyboard');

            exports.default = _default;
            });

            unwrapExports$1(Keyboard);

            var KeyboardArrowDown = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M7.41 7.84L12 12.42l4.59-4.58L18 9.25l-6 6-6-6z"
            })), 'KeyboardArrowDown');

            exports.default = _default;
            });

            unwrapExports$1(KeyboardArrowDown);

            var KeyboardArrowLeft = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M15.41 16.09l-4.58-4.59 4.58-4.59L14 5.5l-6 6 6 6z"
            })), 'KeyboardArrowLeft');

            exports.default = _default;
            });

            unwrapExports$1(KeyboardArrowLeft);

            var KeyboardArrowRight = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M8.59 16.34l4.58-4.59-4.58-4.59L10 5.75l6 6-6 6z"
            })), 'KeyboardArrowRight');

            exports.default = _default;
            });

            unwrapExports$1(KeyboardArrowRight);

            var KeyboardArrowUp = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M7.41 15.41L12 10.83l4.59 4.58L18 14l-6-6-6 6z"
            })), 'KeyboardArrowUp');

            exports.default = _default;
            });

            unwrapExports$1(KeyboardArrowUp);

            var KeyboardBackspace = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M21 11H6.83l3.58-3.59L9 6l-6 6 6 6 1.41-1.41L6.83 13H21z"
            })), 'KeyboardBackspace');

            exports.default = _default;
            });

            unwrapExports$1(KeyboardBackspace);

            var KeyboardCapslock = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M12 8.41L16.59 13 18 11.59l-6-6-6 6L7.41 13 12 8.41zM6 18h12v-2H6v2z"
            })), 'KeyboardCapslock');

            exports.default = _default;
            });

            unwrapExports$1(KeyboardCapslock);

            var KeyboardHide = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M20 3H4c-1.1 0-1.99.9-1.99 2L2 15c0 1.1.9 2 2 2h16c1.1 0 2-.9 2-2V5c0-1.1-.9-2-2-2zm-9 3h2v2h-2V6zm0 3h2v2h-2V9zM8 6h2v2H8V6zm0 3h2v2H8V9zm-1 2H5V9h2v2zm0-3H5V6h2v2zm9 7H8v-2h8v2zm0-4h-2V9h2v2zm0-3h-2V6h2v2zm3 3h-2V9h2v2zm0-3h-2V6h2v2zm-7 15l4-4H8l4 4z"
            })), 'KeyboardHide');

            exports.default = _default;
            });

            unwrapExports$1(KeyboardHide);

            var KeyboardReturn = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M19 7v4H5.83l3.58-3.59L8 6l-6 6 6 6 1.41-1.41L5.83 13H21V7z"
            })), 'KeyboardReturn');

            exports.default = _default;
            });

            unwrapExports$1(KeyboardReturn);

            var KeyboardTab = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M11.59 7.41L15.17 11H1v2h14.17l-3.59 3.59L13 18l6-6-6-6-1.41 1.41zM20 6v12h2V6h-2z"
            })), 'KeyboardTab');

            exports.default = _default;
            });

            unwrapExports$1(KeyboardTab);

            var KeyboardVoice = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M12 15c1.66 0 2.99-1.34 2.99-3L15 6c0-1.66-1.34-3-3-3S9 4.34 9 6v6c0 1.66 1.34 3 3 3zm5.3-3c0 3-2.54 5.1-5.3 5.1S6.7 15 6.7 12H5c0 3.42 2.72 6.23 6 6.72V22h2v-3.28c3.28-.48 6-3.3 6-6.72h-1.7z"
            })), 'KeyboardVoice');

            exports.default = _default;
            });

            unwrapExports$1(KeyboardVoice);

            var Kitchen = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M18 2.01L6 2c-1.1 0-2 .89-2 2v16c0 1.1.9 2 2 2h12c1.1 0 2-.9 2-2V4c0-1.11-.9-1.99-2-1.99zM18 20H6v-9.02h12V20zm0-11H6V4h12v5zM8 5h2v3H8zm0 7h2v5H8z"
            })), 'Kitchen');

            exports.default = _default;
            });

            unwrapExports$1(Kitchen);

            var Label = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M17.63 5.84C17.27 5.33 16.67 5 16 5L5 5.01C3.9 5.01 3 5.9 3 7v10c0 1.1.9 1.99 2 1.99L16 19c.67 0 1.27-.33 1.63-.84L22 12l-4.37-6.16z"
            })), 'Label');

            exports.default = _default;
            });

            unwrapExports$1(Label);

            var LabelOutline = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M17.63 5.84C17.27 5.33 16.67 5 16 5L5 5.01C3.9 5.01 3 5.9 3 7v10c0 1.1.9 1.99 2 1.99L16 19c.67 0 1.27-.33 1.63-.84L22 12l-4.37-6.16zM16 17H5V7h11l3.55 5L16 17z"
            })), 'LabelOutline');

            exports.default = _default;
            });

            unwrapExports$1(LabelOutline);

            var Landscape = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M14 6l-3.75 5 2.85 3.8-1.6 1.2C9.81 13.75 7 10 7 10l-6 8h22L14 6z"
            })), 'Landscape');

            exports.default = _default;
            });

            unwrapExports$1(Landscape);

            var Language = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M11.99 2C6.47 2 2 6.48 2 12s4.47 10 9.99 10C17.52 22 22 17.52 22 12S17.52 2 11.99 2zm6.93 6h-2.95c-.32-1.25-.78-2.45-1.38-3.56 1.84.63 3.37 1.91 4.33 3.56zM12 4.04c.83 1.2 1.48 2.53 1.91 3.96h-3.82c.43-1.43 1.08-2.76 1.91-3.96zM4.26 14C4.1 13.36 4 12.69 4 12s.1-1.36.26-2h3.38c-.08.66-.14 1.32-.14 2 0 .68.06 1.34.14 2H4.26zm.82 2h2.95c.32 1.25.78 2.45 1.38 3.56-1.84-.63-3.37-1.9-4.33-3.56zm2.95-8H5.08c.96-1.66 2.49-2.93 4.33-3.56C8.81 5.55 8.35 6.75 8.03 8zM12 19.96c-.83-1.2-1.48-2.53-1.91-3.96h3.82c-.43 1.43-1.08 2.76-1.91 3.96zM14.34 14H9.66c-.09-.66-.16-1.32-.16-2 0-.68.07-1.35.16-2h4.68c.09.65.16 1.32.16 2 0 .68-.07 1.34-.16 2zm.25 5.56c.6-1.11 1.06-2.31 1.38-3.56h2.95c-.96 1.65-2.49 2.93-4.33 3.56zM16.36 14c.08-.66.14-1.32.14-2 0-.68-.06-1.34-.14-2h3.38c.16.64.26 1.31.26 2s-.1 1.36-.26 2h-3.38z"
            })), 'Language');

            exports.default = _default;
            });

            unwrapExports$1(Language);

            var Laptop = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M20 18c1.1 0 2-.9 2-2V6c0-1.1-.9-2-2-2H4c-1.1 0-2 .9-2 2v10c0 1.1.9 2 2 2H0v2h24v-2h-4zM4 6h16v10H4V6z"
            })), 'Laptop');

            exports.default = _default;
            });

            unwrapExports$1(Laptop);

            var LaptopChromebook = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M22 18V3H2v15H0v2h24v-2h-2zm-8 0h-4v-1h4v1zm6-3H4V5h16v10z"
            })), 'LaptopChromebook');

            exports.default = _default;
            });

            unwrapExports$1(LaptopChromebook);

            var LaptopMac = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M20 18c1.1 0 1.99-.9 1.99-2L22 5c0-1.1-.9-2-2-2H4c-1.1 0-2 .9-2 2v11c0 1.1.9 2 2 2H0c0 1.1.9 2 2 2h20c1.1 0 2-.9 2-2h-4zM4 5h16v11H4V5zm8 14c-.55 0-1-.45-1-1s.45-1 1-1 1 .45 1 1-.45 1-1 1z"
            })), 'LaptopMac');

            exports.default = _default;
            });

            unwrapExports$1(LaptopMac);

            var LaptopWindows = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M20 18v-1c1.1 0 1.99-.9 1.99-2L22 5c0-1.1-.9-2-2-2H4c-1.1 0-2 .9-2 2v10c0 1.1.9 2 2 2v1H0v2h24v-2h-4zM4 5h16v10H4V5z"
            })), 'LaptopWindows');

            exports.default = _default;
            });

            unwrapExports$1(LaptopWindows);

            var LastPage = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M5.59 7.41L10.18 12l-4.59 4.59L7 18l6-6-6-6zM16 6h2v12h-2z"
            })), 'LastPage');

            exports.default = _default;
            });

            unwrapExports$1(LastPage);

            var Launch = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M19 19H5V5h7V3H5c-1.11 0-2 .9-2 2v14c0 1.1.89 2 2 2h14c1.1 0 2-.9 2-2v-7h-2v7zM14 3v2h3.59l-9.83 9.83 1.41 1.41L19 6.41V10h2V3h-7z"
            })), 'Launch');

            exports.default = _default;
            });

            unwrapExports$1(Launch);

            var Layers = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M11.99 18.54l-7.37-5.73L3 14.07l9 7 9-7-1.63-1.27-7.38 5.74zM12 16l7.36-5.73L21 9l-9-7-9 7 1.63 1.27L12 16z"
            })), 'Layers');

            exports.default = _default;
            });

            unwrapExports$1(Layers);

            var LayersClear = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M19.81 14.99l1.19-.92-1.43-1.43-1.19.92 1.43 1.43zm-.45-4.72L21 9l-9-7-2.91 2.27 7.87 7.88 2.4-1.88zM3.27 1L2 2.27l4.22 4.22L3 9l1.63 1.27L12 16l2.1-1.63 1.43 1.43L12 18.54l-7.37-5.73L3 14.07l9 7 4.95-3.85L20.73 21 22 19.73 3.27 1z"
            })), 'LayersClear');

            exports.default = _default;
            });

            unwrapExports$1(LayersClear);

            var LeakAdd = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M6 3H3v3c1.66 0 3-1.34 3-3zm8 0h-2c0 4.97-4.03 9-9 9v2c6.08 0 11-4.93 11-11zm-4 0H8c0 2.76-2.24 5-5 5v2c3.87 0 7-3.13 7-7zm0 18h2c0-4.97 4.03-9 9-9v-2c-6.07 0-11 4.93-11 11zm8 0h3v-3c-1.66 0-3 1.34-3 3zm-4 0h2c0-2.76 2.24-5 5-5v-2c-3.87 0-7 3.13-7 7z"
            })), 'LeakAdd');

            exports.default = _default;
            });

            unwrapExports$1(LeakAdd);

            var LeakRemove = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M10 3H8c0 .37-.04.72-.12 1.06l1.59 1.59C9.81 4.84 10 3.94 10 3zM3 4.27l2.84 2.84C5.03 7.67 4.06 8 3 8v2c1.61 0 3.09-.55 4.27-1.46L8.7 9.97C7.14 11.24 5.16 12 3 12v2c2.71 0 5.19-.99 7.11-2.62l2.5 2.5C10.99 15.81 10 18.29 10 21h2c0-2.16.76-4.14 2.03-5.69l1.43 1.43C14.55 17.91 14 19.39 14 21h2c0-1.06.33-2.03.89-2.84L19.73 21 21 19.73 4.27 3 3 4.27zM14 3h-2c0 1.5-.37 2.91-1.02 4.16l1.46 1.46C13.42 6.98 14 5.06 14 3zm5.94 13.12c.34-.08.69-.12 1.06-.12v-2c-.94 0-1.84.19-2.66.52l1.6 1.6zm-4.56-4.56l1.46 1.46C18.09 12.37 19.5 12 21 12v-2c-2.06 0-3.98.58-5.62 1.56z"
            })), 'LeakRemove');

            exports.default = _default;
            });

            unwrapExports$1(LeakRemove);

            var Lens = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M12 2C6.48 2 2 6.48 2 12s4.48 10 10 10 10-4.48 10-10S17.52 2 12 2z"
            })), 'Lens');

            exports.default = _default;
            });

            unwrapExports$1(Lens);

            var LibraryAdd = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M4 6H2v14c0 1.1.9 2 2 2h14v-2H4V6zm16-4H8c-1.1 0-2 .9-2 2v12c0 1.1.9 2 2 2h12c1.1 0 2-.9 2-2V4c0-1.1-.9-2-2-2zm-1 9h-4v4h-2v-4H9V9h4V5h2v4h4v2z"
            })), 'LibraryAdd');

            exports.default = _default;
            });

            unwrapExports$1(LibraryAdd);

            var LibraryBooks = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M4 6H2v14c0 1.1.9 2 2 2h14v-2H4V6zm16-4H8c-1.1 0-2 .9-2 2v12c0 1.1.9 2 2 2h12c1.1 0 2-.9 2-2V4c0-1.1-.9-2-2-2zm-1 9H9V9h10v2zm-4 4H9v-2h6v2zm4-8H9V5h10v2z"
            })), 'LibraryBooks');

            exports.default = _default;
            });

            unwrapExports$1(LibraryBooks);

            var LibraryMusic = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M20 2H8c-1.1 0-2 .9-2 2v12c0 1.1.9 2 2 2h12c1.1 0 2-.9 2-2V4c0-1.1-.9-2-2-2zm-2 5h-3v5.5c0 1.38-1.12 2.5-2.5 2.5S10 13.88 10 12.5s1.12-2.5 2.5-2.5c.57 0 1.08.19 1.5.51V5h4v2zM4 6H2v14c0 1.1.9 2 2 2h14v-2H4V6z"
            })), 'LibraryMusic');

            exports.default = _default;
            });

            unwrapExports$1(LibraryMusic);

            var LightbulbOutline = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M9 21c0 .55.45 1 1 1h4c.55 0 1-.45 1-1v-1H9v1zm3-19C8.14 2 5 5.14 5 9c0 2.38 1.19 4.47 3 5.74V17c0 .55.45 1 1 1h6c.55 0 1-.45 1-1v-2.26c1.81-1.27 3-3.36 3-5.74 0-3.86-3.14-7-7-7zm2.85 11.1l-.85.6V16h-4v-2.3l-.85-.6C7.8 12.16 7 10.63 7 9c0-2.76 2.24-5 5-5s5 2.24 5 5c0 1.63-.8 3.16-2.15 4.1z"
            })), 'LightbulbOutline');

            exports.default = _default;
            });

            unwrapExports$1(LightbulbOutline);

            var LinearScale = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M19.5 9.5c-1.03 0-1.9.62-2.29 1.5h-2.92c-.39-.88-1.26-1.5-2.29-1.5s-1.9.62-2.29 1.5H6.79c-.39-.88-1.26-1.5-2.29-1.5C3.12 9.5 2 10.62 2 12s1.12 2.5 2.5 2.5c1.03 0 1.9-.62 2.29-1.5h2.92c.39.88 1.26 1.5 2.29 1.5s1.9-.62 2.29-1.5h2.92c.39.88 1.26 1.5 2.29 1.5 1.38 0 2.5-1.12 2.5-2.5s-1.12-2.5-2.5-2.5z"
            })), 'LinearScale');

            exports.default = _default;
            });

            unwrapExports$1(LinearScale);

            var LineStyle = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M3 16h5v-2H3v2zm6.5 0h5v-2h-5v2zm6.5 0h5v-2h-5v2zM3 20h2v-2H3v2zm4 0h2v-2H7v2zm4 0h2v-2h-2v2zm4 0h2v-2h-2v2zm4 0h2v-2h-2v2zM3 12h8v-2H3v2zm10 0h8v-2h-8v2zM3 4v4h18V4H3z"
            })), 'LineStyle');

            exports.default = _default;
            });

            unwrapExports$1(LineStyle);

            var LineWeight = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M3 17h18v-2H3v2zm0 3h18v-1H3v1zm0-7h18v-3H3v3zm0-9v4h18V4H3z"
            })), 'LineWeight');

            exports.default = _default;
            });

            unwrapExports$1(LineWeight);

            var Link = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M3.9 12c0-1.71 1.39-3.1 3.1-3.1h4V7H7c-2.76 0-5 2.24-5 5s2.24 5 5 5h4v-1.9H7c-1.71 0-3.1-1.39-3.1-3.1zM8 13h8v-2H8v2zm9-6h-4v1.9h4c1.71 0 3.1 1.39 3.1 3.1s-1.39 3.1-3.1 3.1h-4V17h4c2.76 0 5-2.24 5-5s-2.24-5-5-5z"
            })), 'Link');

            exports.default = _default;
            });

            unwrapExports$1(Link);

            var LinkedCamera = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("circle", {
              cx: "12",
              cy: "14",
              r: "3.2"
            }), _react.default.createElement("path", {
              d: "M16 3.33c2.58 0 4.67 2.09 4.67 4.67H22c0-3.31-2.69-6-6-6v1.33M16 6c1.11 0 2 .89 2 2h1.33c0-1.84-1.49-3.33-3.33-3.33V6"
            }), _react.default.createElement("path", {
              d: "M17 9c0-1.11-.89-2-2-2V4H9L7.17 6H4c-1.1 0-2 .9-2 2v12c0 1.1.9 2 2 2h16c1.1 0 2-.9 2-2V9h-5zm-5 10c-2.76 0-5-2.24-5-5s2.24-5 5-5 5 2.24 5 5-2.24 5-5 5z"
            })), 'LinkedCamera');

            exports.default = _default;
            });

            unwrapExports$1(LinkedCamera);

            var List = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M3 13h2v-2H3v2zm0 4h2v-2H3v2zm0-8h2V7H3v2zm4 4h14v-2H7v2zm0 4h14v-2H7v2zM7 7v2h14V7H7z"
            })), 'List');

            exports.default = _default;
            });

            unwrapExports$1(List);

            var LiveHelp = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M19 2H5c-1.11 0-2 .9-2 2v14c0 1.1.89 2 2 2h4l3 3 3-3h4c1.1 0 2-.9 2-2V4c0-1.1-.9-2-2-2zm-6 16h-2v-2h2v2zm2.07-7.75l-.9.92C13.45 11.9 13 12.5 13 14h-2v-.5c0-1.1.45-2.1 1.17-2.83l1.24-1.26c.37-.36.59-.86.59-1.41 0-1.1-.9-2-2-2s-2 .9-2 2H8c0-2.21 1.79-4 4-4s4 1.79 4 4c0 .88-.36 1.68-.93 2.25z"
            })), 'LiveHelp');

            exports.default = _default;
            });

            unwrapExports$1(LiveHelp);

            var LiveTv = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M21 6h-7.59l3.29-3.29L16 2l-4 4-4-4-.71.71L10.59 6H3c-1.1 0-2 .89-2 2v12c0 1.1.9 2 2 2h18c1.1 0 2-.9 2-2V8c0-1.11-.9-2-2-2zm0 14H3V8h18v12zM9 10v8l7-4z"
            })), 'LiveTv');

            exports.default = _default;
            });

            unwrapExports$1(LiveTv);

            var LocalActivity = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M20 12c0-1.1.9-2 2-2V6c0-1.1-.9-2-2-2H4c-1.1 0-1.99.9-1.99 2v4c1.1 0 1.99.9 1.99 2s-.89 2-2 2v4c0 1.1.9 2 2 2h16c1.1 0 2-.9 2-2v-4c-1.1 0-2-.9-2-2zm-4.42 4.8L12 14.5l-3.58 2.3 1.08-4.12-3.29-2.69 4.24-.25L12 5.8l1.54 3.95 4.24.25-3.29 2.69 1.09 4.11z"
            })), 'LocalActivity');

            exports.default = _default;
            });

            unwrapExports$1(LocalActivity);

            var LocalAirport = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M21 16v-2l-8-5V3.5c0-.83-.67-1.5-1.5-1.5S10 2.67 10 3.5V9l-8 5v2l8-2.5V19l-2 1.5V22l3.5-1 3.5 1v-1.5L13 19v-5.5l8 2.5z"
            })), 'LocalAirport');

            exports.default = _default;
            });

            unwrapExports$1(LocalAirport);

            var LocalAtm = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M11 17h2v-1h1c.55 0 1-.45 1-1v-3c0-.55-.45-1-1-1h-3v-1h4V8h-2V7h-2v1h-1c-.55 0-1 .45-1 1v3c0 .55.45 1 1 1h3v1H9v2h2v1zm9-13H4c-1.11 0-1.99.89-1.99 2L2 18c0 1.11.89 2 2 2h16c1.11 0 2-.89 2-2V6c0-1.11-.89-2-2-2zm0 14H4V6h16v12z"
            })), 'LocalAtm');

            exports.default = _default;
            });

            unwrapExports$1(LocalAtm);

            var LocalBar = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M21 5V3H3v2l8 9v5H6v2h12v-2h-5v-5l8-9zM7.43 7L5.66 5h12.69l-1.78 2H7.43z"
            })), 'LocalBar');

            exports.default = _default;
            });

            unwrapExports$1(LocalBar);

            var LocalCafe = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M20 3H4v10c0 2.21 1.79 4 4 4h6c2.21 0 4-1.79 4-4v-3h2c1.11 0 2-.89 2-2V5c0-1.11-.89-2-2-2zm0 5h-2V5h2v3zM2 21h18v-2H2v2z"
            })), 'LocalCafe');

            exports.default = _default;
            });

            unwrapExports$1(LocalCafe);

            var LocalCarWash = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M17 5c.83 0 1.5-.67 1.5-1.5 0-1-1.5-2.7-1.5-2.7s-1.5 1.7-1.5 2.7c0 .83.67 1.5 1.5 1.5zm-5 0c.83 0 1.5-.67 1.5-1.5 0-1-1.5-2.7-1.5-2.7s-1.5 1.7-1.5 2.7c0 .83.67 1.5 1.5 1.5zM7 5c.83 0 1.5-.67 1.5-1.5C8.5 2.5 7 .8 7 .8S5.5 2.5 5.5 3.5C5.5 4.33 6.17 5 7 5zm11.92 3.01C18.72 7.42 18.16 7 17.5 7h-11c-.66 0-1.21.42-1.42 1.01L3 14v8c0 .55.45 1 1 1h1c.55 0 1-.45 1-1v-1h12v1c0 .55.45 1 1 1h1c.55 0 1-.45 1-1v-8l-2.08-5.99zM6.5 18c-.83 0-1.5-.67-1.5-1.5S5.67 15 6.5 15s1.5.67 1.5 1.5S7.33 18 6.5 18zm11 0c-.83 0-1.5-.67-1.5-1.5s.67-1.5 1.5-1.5 1.5.67 1.5 1.5-.67 1.5-1.5 1.5zM5 13l1.5-4.5h11L19 13H5z"
            })), 'LocalCarWash');

            exports.default = _default;
            });

            unwrapExports$1(LocalCarWash);

            var LocalConvenienceStore = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M19 7V4H5v3H2v13h8v-4h4v4h8V7h-3zm-8 3H9v1h2v1H8V9h2V8H8V7h3v3zm5 2h-1v-2h-2V7h1v2h1V7h1v5z"
            })), 'LocalConvenienceStore');

            exports.default = _default;
            });

            unwrapExports$1(LocalConvenienceStore);

            var LocalDining = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M8.1 13.34l2.83-2.83L3.91 3.5c-1.56 1.56-1.56 4.09 0 5.66l4.19 4.18zm6.78-1.81c1.53.71 3.68.21 5.27-1.38 1.91-1.91 2.28-4.65.81-6.12-1.46-1.46-4.2-1.1-6.12.81-1.59 1.59-2.09 3.74-1.38 5.27L3.7 19.87l1.41 1.41L12 14.41l6.88 6.88 1.41-1.41L13.41 13l1.47-1.47z"
            })), 'LocalDining');

            exports.default = _default;
            });

            unwrapExports$1(LocalDining);

            var LocalDrink = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M3 2l2.01 18.23C5.13 21.23 5.97 22 7 22h10c1.03 0 1.87-.77 1.99-1.77L21 2H3zm9 17c-1.66 0-3-1.34-3-3 0-2 3-5.4 3-5.4s3 3.4 3 5.4c0 1.66-1.34 3-3 3zm6.33-11H5.67l-.44-4h13.53l-.43 4z"
            })), 'LocalDrink');

            exports.default = _default;
            });

            unwrapExports$1(LocalDrink);

            var LocalFlorist = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M12 22c4.97 0 9-4.03 9-9-4.97 0-9 4.03-9 9zM5.6 10.25c0 1.38 1.12 2.5 2.5 2.5.53 0 1.01-.16 1.42-.44l-.02.19c0 1.38 1.12 2.5 2.5 2.5s2.5-1.12 2.5-2.5l-.02-.19c.4.28.89.44 1.42.44 1.38 0 2.5-1.12 2.5-2.5 0-1-.59-1.85-1.43-2.25.84-.4 1.43-1.25 1.43-2.25 0-1.38-1.12-2.5-2.5-2.5-.53 0-1.01.16-1.42.44l.02-.19C14.5 2.12 13.38 1 12 1S9.5 2.12 9.5 3.5l.02.19c-.4-.28-.89-.44-1.42-.44-1.38 0-2.5 1.12-2.5 2.5 0 1 .59 1.85 1.43 2.25-.84.4-1.43 1.25-1.43 2.25zM12 5.5c1.38 0 2.5 1.12 2.5 2.5s-1.12 2.5-2.5 2.5S9.5 9.38 9.5 8s1.12-2.5 2.5-2.5zM3 13c0 4.97 4.03 9 9 9 0-4.97-4.03-9-9-9z"
            })), 'LocalFlorist');

            exports.default = _default;
            });

            unwrapExports$1(LocalFlorist);

            var LocalGasStation = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M19.77 7.23l.01-.01-3.72-3.72L15 4.56l2.11 2.11c-.94.36-1.61 1.26-1.61 2.33 0 1.38 1.12 2.5 2.5 2.5.36 0 .69-.08 1-.21v7.21c0 .55-.45 1-1 1s-1-.45-1-1V14c0-1.1-.9-2-2-2h-1V5c0-1.1-.9-2-2-2H6c-1.1 0-2 .9-2 2v16h10v-7.5h1.5v5c0 1.38 1.12 2.5 2.5 2.5s2.5-1.12 2.5-2.5V9c0-.69-.28-1.32-.73-1.77zM12 10H6V5h6v5zm6 0c-.55 0-1-.45-1-1s.45-1 1-1 1 .45 1 1-.45 1-1 1z"
            })), 'LocalGasStation');

            exports.default = _default;
            });

            unwrapExports$1(LocalGasStation);

            var LocalGroceryStore = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M7 18c-1.1 0-1.99.9-1.99 2S5.9 22 7 22s2-.9 2-2-.9-2-2-2zM1 2v2h2l3.6 7.59-1.35 2.45c-.16.28-.25.61-.25.96 0 1.1.9 2 2 2h12v-2H7.42c-.14 0-.25-.11-.25-.25l.03-.12.9-1.63h7.45c.75 0 1.41-.41 1.75-1.03l3.58-6.49c.08-.14.12-.31.12-.48 0-.55-.45-1-1-1H5.21l-.94-2H1zm16 16c-1.1 0-1.99.9-1.99 2s.89 2 1.99 2 2-.9 2-2-.9-2-2-2z"
            })), 'LocalGroceryStore');

            exports.default = _default;
            });

            unwrapExports$1(LocalGroceryStore);

            var LocalHospital = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M19 3H5c-1.1 0-1.99.9-1.99 2L3 19c0 1.1.9 2 2 2h14c1.1 0 2-.9 2-2V5c0-1.1-.9-2-2-2zm-1 11h-4v4h-4v-4H6v-4h4V6h4v4h4v4z"
            })), 'LocalHospital');

            exports.default = _default;
            });

            unwrapExports$1(LocalHospital);

            var LocalHotel = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M7 13c1.66 0 3-1.34 3-3S8.66 7 7 7s-3 1.34-3 3 1.34 3 3 3zm12-6h-8v7H3V5H1v15h2v-3h18v3h2v-9c0-2.21-1.79-4-4-4z"
            })), 'LocalHotel');

            exports.default = _default;
            });

            unwrapExports$1(LocalHotel);

            var LocalLaundryService = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M9.17 16.83c1.56 1.56 4.1 1.56 5.66 0 1.56-1.56 1.56-4.1 0-5.66l-5.66 5.66zM18 2.01L6 2c-1.11 0-2 .89-2 2v16c0 1.11.89 2 2 2h12c1.11 0 2-.89 2-2V4c0-1.11-.89-1.99-2-1.99zM10 4c.55 0 1 .45 1 1s-.45 1-1 1-1-.45-1-1 .45-1 1-1zM7 4c.55 0 1 .45 1 1s-.45 1-1 1-1-.45-1-1 .45-1 1-1zm5 16c-3.31 0-6-2.69-6-6s2.69-6 6-6 6 2.69 6 6-2.69 6-6 6z"
            })), 'LocalLaundryService');

            exports.default = _default;
            });

            unwrapExports$1(LocalLaundryService);

            var LocalLibrary = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M12 11.55C9.64 9.35 6.48 8 3 8v11c3.48 0 6.64 1.35 9 3.55 2.36-2.19 5.52-3.55 9-3.55V8c-3.48 0-6.64 1.35-9 3.55zM12 8c1.66 0 3-1.34 3-3s-1.34-3-3-3-3 1.34-3 3 1.34 3 3 3z"
            })), 'LocalLibrary');

            exports.default = _default;
            });

            unwrapExports$1(LocalLibrary);

            var LocalMall = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M19 6h-2c0-2.76-2.24-5-5-5S7 3.24 7 6H5c-1.1 0-1.99.9-1.99 2L3 20c0 1.1.9 2 2 2h14c1.1 0 2-.9 2-2V8c0-1.1-.9-2-2-2zm-7-3c1.66 0 3 1.34 3 3H9c0-1.66 1.34-3 3-3zm0 10c-2.76 0-5-2.24-5-5h2c0 1.66 1.34 3 3 3s3-1.34 3-3h2c0 2.76-2.24 5-5 5z"
            })), 'LocalMall');

            exports.default = _default;
            });

            unwrapExports$1(LocalMall);

            var LocalMovies = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M18 3v2h-2V3H8v2H6V3H4v18h2v-2h2v2h8v-2h2v2h2V3h-2zM8 17H6v-2h2v2zm0-4H6v-2h2v2zm0-4H6V7h2v2zm10 8h-2v-2h2v2zm0-4h-2v-2h2v2zm0-4h-2V7h2v2z"
            })), 'LocalMovies');

            exports.default = _default;
            });

            unwrapExports$1(LocalMovies);

            var LocalOffer = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M21.41 11.58l-9-9C12.05 2.22 11.55 2 11 2H4c-1.1 0-2 .9-2 2v7c0 .55.22 1.05.59 1.42l9 9c.36.36.86.58 1.41.58.55 0 1.05-.22 1.41-.59l7-7c.37-.36.59-.86.59-1.41 0-.55-.23-1.06-.59-1.42zM5.5 7C4.67 7 4 6.33 4 5.5S4.67 4 5.5 4 7 4.67 7 5.5 6.33 7 5.5 7z"
            })), 'LocalOffer');

            exports.default = _default;
            });

            unwrapExports$1(LocalOffer);

            var LocalParking = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M13 3H6v18h4v-6h3c3.31 0 6-2.69 6-6s-2.69-6-6-6zm.2 8H10V7h3.2c1.1 0 2 .9 2 2s-.9 2-2 2z"
            })), 'LocalParking');

            exports.default = _default;
            });

            unwrapExports$1(LocalParking);

            var LocalPharmacy = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M21 5h-2.64l1.14-3.14L17.15 1l-1.46 4H3v2l2 6-2 6v2h18v-2l-2-6 2-6V5zm-5 9h-3v3h-2v-3H8v-2h3V9h2v3h3v2z"
            })), 'LocalPharmacy');

            exports.default = _default;
            });

            unwrapExports$1(LocalPharmacy);

            var LocalPhone = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M6.62 10.79c1.44 2.83 3.76 5.14 6.59 6.59l2.2-2.2c.27-.27.67-.36 1.02-.24 1.12.37 2.33.57 3.57.57.55 0 1 .45 1 1V20c0 .55-.45 1-1 1-9.39 0-17-7.61-17-17 0-.55.45-1 1-1h3.5c.55 0 1 .45 1 1 0 1.25.2 2.45.57 3.57.11.35.03.74-.25 1.02l-2.2 2.2z"
            })), 'LocalPhone');

            exports.default = _default;
            });

            unwrapExports$1(LocalPhone);

            var LocalPizza = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M12 2C8.43 2 5.23 3.54 3.01 6L12 22l8.99-16C18.78 3.55 15.57 2 12 2zM7 7c0-1.1.9-2 2-2s2 .9 2 2-.9 2-2 2-2-.9-2-2zm5 8c-1.1 0-2-.9-2-2s.9-2 2-2 2 .9 2 2-.9 2-2 2z"
            })), 'LocalPizza');

            exports.default = _default;
            });

            unwrapExports$1(LocalPizza);

            var LocalPlay = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M20 12c0-1.1.9-2 2-2V6c0-1.1-.9-2-2-2H4c-1.1 0-1.99.9-1.99 2v4c1.1 0 1.99.9 1.99 2s-.89 2-2 2v4c0 1.1.9 2 2 2h16c1.1 0 2-.9 2-2v-4c-1.1 0-2-.9-2-2zm-4.42 4.8L12 14.5l-3.58 2.3 1.08-4.12-3.29-2.69 4.24-.25L12 5.8l1.54 3.95 4.24.25-3.29 2.69 1.09 4.11z"
            })), 'LocalPlay');

            exports.default = _default;
            });

            unwrapExports$1(LocalPlay);

            var LocalPostOffice = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M20 4H4c-1.1 0-1.99.9-1.99 2L2 18c0 1.1.9 2 2 2h16c1.1 0 2-.9 2-2V6c0-1.1-.9-2-2-2zm0 4l-8 5-8-5V6l8 5 8-5v2z"
            })), 'LocalPostOffice');

            exports.default = _default;
            });

            unwrapExports$1(LocalPostOffice);

            var LocalPrintshop = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M19 8H5c-1.66 0-3 1.34-3 3v6h4v4h12v-4h4v-6c0-1.66-1.34-3-3-3zm-3 11H8v-5h8v5zm3-7c-.55 0-1-.45-1-1s.45-1 1-1 1 .45 1 1-.45 1-1 1zm-1-9H6v4h12V3z"
            })), 'LocalPrintshop');

            exports.default = _default;
            });

            unwrapExports$1(LocalPrintshop);

            var LocalSee = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("circle", {
              cx: "12",
              cy: "12",
              r: "3.2"
            }), _react.default.createElement("path", {
              d: "M9 2L7.17 4H4c-1.1 0-2 .9-2 2v12c0 1.1.9 2 2 2h16c1.1 0 2-.9 2-2V6c0-1.1-.9-2-2-2h-3.17L15 2H9zm3 15c-2.76 0-5-2.24-5-5s2.24-5 5-5 5 2.24 5 5-2.24 5-5 5z"
            })), 'LocalSee');

            exports.default = _default;
            });

            unwrapExports$1(LocalSee);

            var LocalShipping = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M20 8h-3V4H3c-1.1 0-2 .9-2 2v11h2c0 1.66 1.34 3 3 3s3-1.34 3-3h6c0 1.66 1.34 3 3 3s3-1.34 3-3h2v-5l-3-4zM6 18.5c-.83 0-1.5-.67-1.5-1.5s.67-1.5 1.5-1.5 1.5.67 1.5 1.5-.67 1.5-1.5 1.5zm13.5-9l1.96 2.5H17V9.5h2.5zm-1.5 9c-.83 0-1.5-.67-1.5-1.5s.67-1.5 1.5-1.5 1.5.67 1.5 1.5-.67 1.5-1.5 1.5z"
            })), 'LocalShipping');

            exports.default = _default;
            });

            unwrapExports$1(LocalShipping);

            var LocalTaxi = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M18.92 6.01C18.72 5.42 18.16 5 17.5 5H15V3H9v2H6.5c-.66 0-1.21.42-1.42 1.01L3 12v8c0 .55.45 1 1 1h1c.55 0 1-.45 1-1v-1h12v1c0 .55.45 1 1 1h1c.55 0 1-.45 1-1v-8l-2.08-5.99zM6.5 16c-.83 0-1.5-.67-1.5-1.5S5.67 13 6.5 13s1.5.67 1.5 1.5S7.33 16 6.5 16zm11 0c-.83 0-1.5-.67-1.5-1.5s.67-1.5 1.5-1.5 1.5.67 1.5 1.5-.67 1.5-1.5 1.5zM5 11l1.5-4.5h11L19 11H5z"
            })), 'LocalTaxi');

            exports.default = _default;
            });

            unwrapExports$1(LocalTaxi);

            var LocationCity = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M15 11V5l-3-3-3 3v2H3v14h18V11h-6zm-8 8H5v-2h2v2zm0-4H5v-2h2v2zm0-4H5V9h2v2zm6 8h-2v-2h2v2zm0-4h-2v-2h2v2zm0-4h-2V9h2v2zm0-4h-2V5h2v2zm6 12h-2v-2h2v2zm0-4h-2v-2h2v2z"
            })), 'LocationCity');

            exports.default = _default;
            });

            unwrapExports$1(LocationCity);

            var LocationDisabled = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M20.94 11c-.46-4.17-3.77-7.48-7.94-7.94V1h-2v2.06c-1.13.12-2.19.46-3.16.97l1.5 1.5C10.16 5.19 11.06 5 12 5c3.87 0 7 3.13 7 7 0 .94-.19 1.84-.52 2.65l1.5 1.5c.5-.96.84-2.02.97-3.15H23v-2h-2.06zM3 4.27l2.04 2.04C3.97 7.62 3.25 9.23 3.06 11H1v2h2.06c.46 4.17 3.77 7.48 7.94 7.94V23h2v-2.06c1.77-.2 3.38-.91 4.69-1.98L19.73 21 21 19.73 4.27 3 3 4.27zm13.27 13.27C15.09 18.45 13.61 19 12 19c-3.87 0-7-3.13-7-7 0-1.61.55-3.09 1.46-4.27l9.81 9.81z"
            })), 'LocationDisabled');

            exports.default = _default;
            });

            unwrapExports$1(LocationDisabled);

            var LocationOff = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M12 6.5c1.38 0 2.5 1.12 2.5 2.5 0 .74-.33 1.39-.83 1.85l3.63 3.63c.98-1.86 1.7-3.8 1.7-5.48 0-3.87-3.13-7-7-7-1.98 0-3.76.83-5.04 2.15l3.19 3.19c.46-.52 1.11-.84 1.85-.84zm4.37 9.6l-4.63-4.63-.11-.11L3.27 3 2 4.27l3.18 3.18C5.07 7.95 5 8.47 5 9c0 5.25 7 13 7 13s1.67-1.85 3.38-4.35L18.73 21 20 19.73l-3.63-3.63z"
            })), 'LocationOff');

            exports.default = _default;
            });

            unwrapExports$1(LocationOff);

            var LocationOn = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M12 2C8.13 2 5 5.13 5 9c0 5.25 7 13 7 13s7-7.75 7-13c0-3.87-3.13-7-7-7zm0 9.5c-1.38 0-2.5-1.12-2.5-2.5s1.12-2.5 2.5-2.5 2.5 1.12 2.5 2.5-1.12 2.5-2.5 2.5z"
            })), 'LocationOn');

            exports.default = _default;
            });

            unwrapExports$1(LocationOn);

            var LocationSearching = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M20.94 11c-.46-4.17-3.77-7.48-7.94-7.94V1h-2v2.06C6.83 3.52 3.52 6.83 3.06 11H1v2h2.06c.46 4.17 3.77 7.48 7.94 7.94V23h2v-2.06c4.17-.46 7.48-3.77 7.94-7.94H23v-2h-2.06zM12 19c-3.87 0-7-3.13-7-7s3.13-7 7-7 7 3.13 7 7-3.13 7-7 7z"
            })), 'LocationSearching');

            exports.default = _default;
            });

            unwrapExports$1(LocationSearching);

            var Lock = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M18 8h-1V6c0-2.76-2.24-5-5-5S7 3.24 7 6v2H6c-1.1 0-2 .9-2 2v10c0 1.1.9 2 2 2h12c1.1 0 2-.9 2-2V10c0-1.1-.9-2-2-2zm-6 9c-1.1 0-2-.9-2-2s.9-2 2-2 2 .9 2 2-.9 2-2 2zm3.1-9H8.9V6c0-1.71 1.39-3.1 3.1-3.1 1.71 0 3.1 1.39 3.1 3.1v2z"
            })), 'Lock');

            exports.default = _default;
            });

            unwrapExports$1(Lock);

            var LockOpen = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M12 17c1.1 0 2-.9 2-2s-.9-2-2-2-2 .9-2 2 .9 2 2 2zm6-9h-1V6c0-2.76-2.24-5-5-5S7 3.24 7 6h1.9c0-1.71 1.39-3.1 3.1-3.1 1.71 0 3.1 1.39 3.1 3.1v2H6c-1.1 0-2 .9-2 2v10c0 1.1.9 2 2 2h12c1.1 0 2-.9 2-2V10c0-1.1-.9-2-2-2zm0 12H6V10h12v10z"
            })), 'LockOpen');

            exports.default = _default;
            });

            unwrapExports$1(LockOpen);

            var LockOutline = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M12 17c1.1 0 2-.9 2-2s-.9-2-2-2-2 .9-2 2 .9 2 2 2zm6-9h-1V6c0-2.76-2.24-5-5-5S7 3.24 7 6v2H6c-1.1 0-2 .9-2 2v10c0 1.1.9 2 2 2h12c1.1 0 2-.9 2-2V10c0-1.1-.9-2-2-2zM8.9 6c0-1.71 1.39-3.1 3.1-3.1s3.1 1.39 3.1 3.1v2H8.9V6zM18 20H6V10h12v10z"
            })), 'LockOutline');

            exports.default = _default;
            });

            unwrapExports$1(LockOutline);

            var Looks = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M12 10c-3.86 0-7 3.14-7 7h2c0-2.76 2.24-5 5-5s5 2.24 5 5h2c0-3.86-3.14-7-7-7zm0-4C5.93 6 1 10.93 1 17h2c0-4.96 4.04-9 9-9s9 4.04 9 9h2c0-6.07-4.93-11-11-11z"
            })), 'Looks');

            exports.default = _default;
            });

            unwrapExports$1(Looks);

            var Looks3 = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M19.01 3h-14c-1.1 0-2 .9-2 2v14c0 1.1.9 2 2 2h14c1.1 0 2-.9 2-2V5c0-1.1-.9-2-2-2zm-4 7.5c0 .83-.67 1.5-1.5 1.5.83 0 1.5.67 1.5 1.5V15c0 1.11-.9 2-2 2h-4v-2h4v-2h-2v-2h2V9h-4V7h4c1.1 0 2 .89 2 2v1.5z"
            })), 'Looks3');

            exports.default = _default;
            });

            unwrapExports$1(Looks3);

            var Looks4 = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M19 3H5c-1.1 0-2 .9-2 2v14c0 1.1.9 2 2 2h14c1.1 0 2-.9 2-2V5c0-1.1-.9-2-2-2zm-4 14h-2v-4H9V7h2v4h2V7h2v10z"
            })), 'Looks4');

            exports.default = _default;
            });

            unwrapExports$1(Looks4);

            var Looks5 = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M19 3H5c-1.1 0-2 .9-2 2v14c0 1.1.9 2 2 2h14c1.1 0 2-.9 2-2V5c0-1.1-.9-2-2-2zm-4 6h-4v2h2c1.1 0 2 .89 2 2v2c0 1.11-.9 2-2 2H9v-2h4v-2H9V7h6v2z"
            })), 'Looks5');

            exports.default = _default;
            });

            unwrapExports$1(Looks5);

            var Looks6 = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M11 15h2v-2h-2v2zm8-12H5c-1.1 0-2 .9-2 2v14c0 1.1.9 2 2 2h14c1.1 0 2-.9 2-2V5c0-1.1-.9-2-2-2zm-4 6h-4v2h2c1.1 0 2 .89 2 2v2c0 1.11-.9 2-2 2h-2c-1.1 0-2-.89-2-2V9c0-1.11.9-2 2-2h4v2z"
            })), 'Looks6');

            exports.default = _default;
            });

            unwrapExports$1(Looks6);

            var LooksOne = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M19 3H5c-1.1 0-2 .9-2 2v14c0 1.1.9 2 2 2h14c1.1 0 2-.9 2-2V5c0-1.1-.9-2-2-2zm-5 14h-2V9h-2V7h4v10z"
            })), 'LooksOne');

            exports.default = _default;
            });

            unwrapExports$1(LooksOne);

            var LooksTwo = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M19 3H5c-1.1 0-2 .9-2 2v14c0 1.1.9 2 2 2h14c1.1 0 2-.9 2-2V5c0-1.1-.9-2-2-2zm-4 8c0 1.11-.9 2-2 2h-2v2h4v2H9v-4c0-1.11.9-2 2-2h2V9H9V7h4c1.1 0 2 .89 2 2v2z"
            })), 'LooksTwo');

            exports.default = _default;
            });

            unwrapExports$1(LooksTwo);

            var Loop = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M12 4V1L8 5l4 4V6c3.31 0 6 2.69 6 6 0 1.01-.25 1.97-.7 2.8l1.46 1.46C19.54 15.03 20 13.57 20 12c0-4.42-3.58-8-8-8zm0 14c-3.31 0-6-2.69-6-6 0-1.01.25-1.97.7-2.8L5.24 7.74C4.46 8.97 4 10.43 4 12c0 4.42 3.58 8 8 8v3l4-4-4-4v3z"
            })), 'Loop');

            exports.default = _default;
            });

            unwrapExports$1(Loop);

            var Loupe = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M13 7h-2v4H7v2h4v4h2v-4h4v-2h-4V7zm-1-5C6.49 2 2 6.49 2 12s4.49 10 10 10h8c1.1 0 2-.9 2-2v-8c0-5.51-4.49-10-10-10zm0 18c-4.41 0-8-3.59-8-8s3.59-8 8-8 8 3.59 8 8-3.59 8-8 8z"
            })), 'Loupe');

            exports.default = _default;
            });

            unwrapExports$1(Loupe);

            var LowPriority = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M14 5h8v2h-8zm0 5.5h8v2h-8zm0 5.5h8v2h-8zM2 11.5C2 15.08 4.92 18 8.5 18H9v2l3-3-3-3v2h-.5C6.02 16 4 13.98 4 11.5S6.02 7 8.5 7H12V5H8.5C4.92 5 2 7.92 2 11.5z"
            })), 'LowPriority');

            exports.default = _default;
            });

            unwrapExports$1(LowPriority);

            var Loyalty = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M21.41 11.58l-9-9C12.05 2.22 11.55 2 11 2H4c-1.1 0-2 .9-2 2v7c0 .55.22 1.05.59 1.42l9 9c.36.36.86.58 1.41.58.55 0 1.05-.22 1.41-.59l7-7c.37-.36.59-.86.59-1.41 0-.55-.23-1.06-.59-1.42zM5.5 7C4.67 7 4 6.33 4 5.5S4.67 4 5.5 4 7 4.67 7 5.5 6.33 7 5.5 7zm11.77 8.27L13 19.54l-4.27-4.27C8.28 14.81 8 14.19 8 13.5c0-1.38 1.12-2.5 2.5-2.5.69 0 1.32.28 1.77.74l.73.72.73-.73c.45-.45 1.08-.73 1.77-.73 1.38 0 2.5 1.12 2.5 2.5 0 .69-.28 1.32-.73 1.77z"
            })), 'Loyalty');

            exports.default = _default;
            });

            unwrapExports$1(Loyalty);

            var Mail = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M20 4H4c-1.1 0-1.99.9-1.99 2L2 18c0 1.1.9 2 2 2h16c1.1 0 2-.9 2-2V6c0-1.1-.9-2-2-2zm0 4l-8 5-8-5V6l8 5 8-5v2z"
            })), 'Mail');

            exports.default = _default;
            });

            unwrapExports$1(Mail);

            var MailOutline = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M20 4H4c-1.1 0-1.99.9-1.99 2L2 18c0 1.1.9 2 2 2h16c1.1 0 2-.9 2-2V6c0-1.1-.9-2-2-2zm0 14H4V8l8 5 8-5v10zm-8-7L4 6h16l-8 5z"
            })), 'MailOutline');

            exports.default = _default;
            });

            unwrapExports$1(MailOutline);

            var _Map$1 = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M20.5 3l-.16.03L15 5.1 9 3 3.36 4.9c-.21.07-.36.25-.36.48V20.5c0 .28.22.5.5.5l.16-.03L9 18.9l6 2.1 5.64-1.9c.21-.07.36-.25.36-.48V3.5c0-.28-.22-.5-.5-.5zM15 19l-6-2.11V5l6 2.11V19z"
            })), 'Map');

            exports.default = _default;
            });

            unwrapExports$1(_Map$1);

            var Markunread = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M20 4H4c-1.1 0-1.99.9-1.99 2L2 18c0 1.1.9 2 2 2h16c1.1 0 2-.9 2-2V6c0-1.1-.9-2-2-2zm0 4l-8 5-8-5V6l8 5 8-5v2z"
            })), 'Markunread');

            exports.default = _default;
            });

            unwrapExports$1(Markunread);

            var MarkunreadMailbox = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M20 6H10v6H8V4h6V0H6v6H4c-1.1 0-2 .9-2 2v12c0 1.1.9 2 2 2h16c1.1 0 2-.9 2-2V8c0-1.1-.9-2-2-2z"
            })), 'MarkunreadMailbox');

            exports.default = _default;
            });

            unwrapExports$1(MarkunreadMailbox);

            var Memory = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M15 9H9v6h6V9zm-2 4h-2v-2h2v2zm8-2V9h-2V7c0-1.1-.9-2-2-2h-2V3h-2v2h-2V3H9v2H7c-1.1 0-2 .9-2 2v2H3v2h2v2H3v2h2v2c0 1.1.9 2 2 2h2v2h2v-2h2v2h2v-2h2c1.1 0 2-.9 2-2v-2h2v-2h-2v-2h2zm-4 6H7V7h10v10z"
            })), 'Memory');

            exports.default = _default;
            });

            unwrapExports$1(Memory);

            var Menu = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M3 18h18v-2H3v2zm0-5h18v-2H3v2zm0-7v2h18V6H3z"
            })), 'Menu');

            exports.default = _default;
            });

            unwrapExports$1(Menu);

            var MergeType = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M17 20.41L18.41 19 15 15.59 13.59 17 17 20.41zM7.5 8H11v5.59L5.59 19 7 20.41l6-6V8h3.5L12 3.5 7.5 8z"
            })), 'MergeType');

            exports.default = _default;
            });

            unwrapExports$1(MergeType);

            var Message = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M20 2H4c-1.1 0-1.99.9-1.99 2L2 22l4-4h14c1.1 0 2-.9 2-2V4c0-1.1-.9-2-2-2zm-2 12H6v-2h12v2zm0-3H6V9h12v2zm0-3H6V6h12v2z"
            })), 'Message');

            exports.default = _default;
            });

            unwrapExports$1(Message);

            var Mic = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M12 14c1.66 0 2.99-1.34 2.99-3L15 5c0-1.66-1.34-3-3-3S9 3.34 9 5v6c0 1.66 1.34 3 3 3zm5.3-3c0 3-2.54 5.1-5.3 5.1S6.7 14 6.7 11H5c0 3.41 2.72 6.23 6 6.72V21h2v-3.28c3.28-.48 6-3.3 6-6.72h-1.7z"
            })), 'Mic');

            exports.default = _default;
            });

            unwrapExports$1(Mic);

            var MicNone = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M12 14c1.66 0 2.99-1.34 2.99-3L15 5c0-1.66-1.34-3-3-3S9 3.34 9 5v6c0 1.66 1.34 3 3 3zm-1.2-9.1c0-.66.54-1.2 1.2-1.2.66 0 1.2.54 1.2 1.2l-.01 6.2c0 .66-.53 1.2-1.19 1.2-.66 0-1.2-.54-1.2-1.2V4.9zm6.5 6.1c0 3-2.54 5.1-5.3 5.1S6.7 14 6.7 11H5c0 3.41 2.72 6.23 6 6.72V21h2v-3.28c3.28-.48 6-3.3 6-6.72h-1.7z"
            })), 'MicNone');

            exports.default = _default;
            });

            unwrapExports$1(MicNone);

            var MicOff = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M19 11h-1.7c0 .74-.16 1.43-.43 2.05l1.23 1.23c.56-.98.9-2.09.9-3.28zm-4.02.17c0-.06.02-.11.02-.17V5c0-1.66-1.34-3-3-3S9 3.34 9 5v.18l5.98 5.99zM4.27 3L3 4.27l6.01 6.01V11c0 1.66 1.33 3 2.99 3 .22 0 .44-.03.65-.08l1.66 1.66c-.71.33-1.5.52-2.31.52-2.76 0-5.3-2.1-5.3-5.1H5c0 3.41 2.72 6.23 6 6.72V21h2v-3.28c.91-.13 1.77-.45 2.54-.9L19.73 21 21 19.73 4.27 3z"
            })), 'MicOff');

            exports.default = _default;
            });

            unwrapExports$1(MicOff);

            var Mms = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M20 2H4c-1.1 0-1.99.9-1.99 2L2 22l4-4h14c1.1 0 2-.9 2-2V4c0-1.1-.9-2-2-2zM5 14l3.5-4.5 2.5 3.01L14.5 8l4.5 6H5z"
            })), 'Mms');

            exports.default = _default;
            });

            unwrapExports$1(Mms);

            var ModeComment = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M21.99 4c0-1.1-.89-2-1.99-2H4c-1.1 0-2 .9-2 2v12c0 1.1.9 2 2 2h14l4 4-.01-18z"
            })), 'ModeComment');

            exports.default = _default;
            });

            unwrapExports$1(ModeComment);

            var ModeEdit = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M3 17.25V21h3.75L17.81 9.94l-3.75-3.75L3 17.25zM20.71 7.04c.39-.39.39-1.02 0-1.41l-2.34-2.34c-.39-.39-1.02-.39-1.41 0l-1.83 1.83 3.75 3.75 1.83-1.83z"
            })), 'ModeEdit');

            exports.default = _default;
            });

            unwrapExports$1(ModeEdit);

            var MonetizationOn = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M12 2C6.48 2 2 6.48 2 12s4.48 10 10 10 10-4.48 10-10S17.52 2 12 2zm1.41 16.09V20h-2.67v-1.93c-1.71-.36-3.16-1.46-3.27-3.4h1.96c.1 1.05.82 1.87 2.65 1.87 1.96 0 2.4-.98 2.4-1.59 0-.83-.44-1.61-2.67-2.14-2.48-.6-4.18-1.62-4.18-3.67 0-1.72 1.39-2.84 3.11-3.21V4h2.67v1.95c1.86.45 2.79 1.86 2.85 3.39H14.3c-.05-1.11-.64-1.87-2.22-1.87-1.5 0-2.4.68-2.4 1.64 0 .84.65 1.39 2.67 1.91s4.18 1.39 4.18 3.91c-.01 1.83-1.38 2.83-3.12 3.16z"
            })), 'MonetizationOn');

            exports.default = _default;
            });

            unwrapExports$1(MonetizationOn);

            var MoneyOff = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M12.5 6.9c1.78 0 2.44.85 2.5 2.1h2.21c-.07-1.72-1.12-3.3-3.21-3.81V3h-3v2.16c-.53.12-1.03.3-1.48.54l1.47 1.47c.41-.17.91-.27 1.51-.27zM5.33 4.06L4.06 5.33 7.5 8.77c0 2.08 1.56 3.21 3.91 3.91l3.51 3.51c-.34.48-1.05.91-2.42.91-2.06 0-2.87-.92-2.98-2.1h-2.2c.12 2.19 1.76 3.42 3.68 3.83V21h3v-2.15c.96-.18 1.82-.55 2.45-1.12l2.22 2.22 1.27-1.27L5.33 4.06z"
            })), 'MoneyOff');

            exports.default = _default;
            });

            unwrapExports$1(MoneyOff);

            var MonochromePhotos = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M20 5h-3.2L15 3H9L7.2 5H4c-1.1 0-2 .9-2 2v12c0 1.1.9 2 2 2h16c1.1 0 2-.9 2-2V7c0-1.1-.9-2-2-2zm0 14h-8v-1c-2.8 0-5-2.2-5-5s2.2-5 5-5V7h8v12zm-3-6c0-2.8-2.2-5-5-5v1.8c1.8 0 3.2 1.4 3.2 3.2s-1.4 3.2-3.2 3.2V18c2.8 0 5-2.2 5-5zm-8.2 0c0 1.8 1.4 3.2 3.2 3.2V9.8c-1.8 0-3.2 1.4-3.2 3.2z"
            })), 'MonochromePhotos');

            exports.default = _default;
            });

            unwrapExports$1(MonochromePhotos);

            var Mood = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M11.99 2C6.47 2 2 6.48 2 12s4.47 10 9.99 10C17.52 22 22 17.52 22 12S17.52 2 11.99 2zM12 20c-4.42 0-8-3.58-8-8s3.58-8 8-8 8 3.58 8 8-3.58 8-8 8zm3.5-9c.83 0 1.5-.67 1.5-1.5S16.33 8 15.5 8 14 8.67 14 9.5s.67 1.5 1.5 1.5zm-7 0c.83 0 1.5-.67 1.5-1.5S9.33 8 8.5 8 7 8.67 7 9.5 7.67 11 8.5 11zm3.5 6.5c2.33 0 4.31-1.46 5.11-3.5H6.89c.8 2.04 2.78 3.5 5.11 3.5z"
            })), 'Mood');

            exports.default = _default;
            });

            unwrapExports$1(Mood);

            var MoodBad = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M11.99 2C6.47 2 2 6.48 2 12s4.47 10 9.99 10C17.52 22 22 17.52 22 12S17.52 2 11.99 2zM12 20c-4.42 0-8-3.58-8-8s3.58-8 8-8 8 3.58 8 8-3.58 8-8 8zm3.5-9c.83 0 1.5-.67 1.5-1.5S16.33 8 15.5 8 14 8.67 14 9.5s.67 1.5 1.5 1.5zm-7 0c.83 0 1.5-.67 1.5-1.5S9.33 8 8.5 8 7 8.67 7 9.5 7.67 11 8.5 11zm3.5 3c-2.33 0-4.31 1.46-5.11 3.5h10.22c-.8-2.04-2.78-3.5-5.11-3.5z"
            })), 'MoodBad');

            exports.default = _default;
            });

            unwrapExports$1(MoodBad);

            var More = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M22 3H7c-.69 0-1.23.35-1.59.88L0 12l5.41 8.11c.36.53.97.89 1.66.89H22c1.1 0 2-.9 2-2V5c0-1.1-.9-2-2-2zM9 13.5c-.83 0-1.5-.67-1.5-1.5s.67-1.5 1.5-1.5 1.5.67 1.5 1.5-.67 1.5-1.5 1.5zm5 0c-.83 0-1.5-.67-1.5-1.5s.67-1.5 1.5-1.5 1.5.67 1.5 1.5-.67 1.5-1.5 1.5zm5 0c-.83 0-1.5-.67-1.5-1.5s.67-1.5 1.5-1.5 1.5.67 1.5 1.5-.67 1.5-1.5 1.5z"
            })), 'More');

            exports.default = _default;
            });

            unwrapExports$1(More);

            var MoreHoriz = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M6 10c-1.1 0-2 .9-2 2s.9 2 2 2 2-.9 2-2-.9-2-2-2zm12 0c-1.1 0-2 .9-2 2s.9 2 2 2 2-.9 2-2-.9-2-2-2zm-6 0c-1.1 0-2 .9-2 2s.9 2 2 2 2-.9 2-2-.9-2-2-2z"
            })), 'MoreHoriz');

            exports.default = _default;
            });

            unwrapExports$1(MoreHoriz);

            var MoreVert = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M12 8c1.1 0 2-.9 2-2s-.9-2-2-2-2 .9-2 2 .9 2 2 2zm0 2c-1.1 0-2 .9-2 2s.9 2 2 2 2-.9 2-2-.9-2-2-2zm0 6c-1.1 0-2 .9-2 2s.9 2 2 2 2-.9 2-2-.9-2-2-2z"
            })), 'MoreVert');

            exports.default = _default;
            });

            unwrapExports$1(MoreVert);

            var Motorcycle = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M19.44 9.03L15.41 5H11v2h3.59l2 2H5c-2.8 0-5 2.2-5 5s2.2 5 5 5c2.46 0 4.45-1.69 4.9-4h1.65l2.77-2.77c-.21.54-.32 1.14-.32 1.77 0 2.8 2.2 5 5 5s5-2.2 5-5c0-2.65-1.97-4.77-4.56-4.97zM7.82 15C7.4 16.15 6.28 17 5 17c-1.63 0-3-1.37-3-3s1.37-3 3-3c1.28 0 2.4.85 2.82 2H5v2h2.82zM19 17c-1.66 0-3-1.34-3-3s1.34-3 3-3 3 1.34 3 3-1.34 3-3 3z"
            })), 'Motorcycle');

            exports.default = _default;
            });

            unwrapExports$1(Motorcycle);

            var Mouse = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M13 1.07V9h7c0-4.08-3.05-7.44-7-7.93zM4 15c0 4.42 3.58 8 8 8s8-3.58 8-8v-4H4v4zm7-13.93C7.05 1.56 4 4.92 4 9h7V1.07z"
            })), 'Mouse');

            exports.default = _default;
            });

            unwrapExports$1(Mouse);

            var MoveToInbox = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M19 3H4.99c-1.11 0-1.98.9-1.98 2L3 19c0 1.1.88 2 1.99 2H19c1.1 0 2-.9 2-2V5c0-1.1-.9-2-2-2zm0 12h-4c0 1.66-1.35 3-3 3s-3-1.34-3-3H4.99V5H19v10zm-3-5h-2V7h-4v3H8l4 4 4-4z"
            })), 'MoveToInbox');

            exports.default = _default;
            });

            unwrapExports$1(MoveToInbox);

            var Movie = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M18 4l2 4h-3l-2-4h-2l2 4h-3l-2-4H8l2 4H7L5 4H4c-1.1 0-1.99.9-1.99 2L2 18c0 1.1.9 2 2 2h16c1.1 0 2-.9 2-2V4h-4z"
            })), 'Movie');

            exports.default = _default;
            });

            unwrapExports$1(Movie);

            var MovieCreation = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M18 4l2 4h-3l-2-4h-2l2 4h-3l-2-4H8l2 4H7L5 4H4c-1.1 0-1.99.9-1.99 2L2 18c0 1.1.9 2 2 2h16c1.1 0 2-.9 2-2V4h-4z"
            })), 'MovieCreation');

            exports.default = _default;
            });

            unwrapExports$1(MovieCreation);

            var MovieFilter = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M18 4l2 3h-3l-2-3h-2l2 3h-3l-2-3H8l2 3H7L5 4H4c-1.1 0-1.99.9-1.99 2L2 18c0 1.1.9 2 2 2h16c1.1 0 2-.9 2-2V4h-4zm-6.75 11.25L10 18l-1.25-2.75L6 14l2.75-1.25L10 10l1.25 2.75L14 14l-2.75 1.25zm5.69-3.31L16 14l-.94-2.06L13 11l2.06-.94L16 8l.94 2.06L19 11l-2.06.94z"
            })), 'MovieFilter');

            exports.default = _default;
            });

            unwrapExports$1(MovieFilter);

            var MultilineChart = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M22 6.92l-1.41-1.41-2.85 3.21C15.68 6.4 12.83 5 9.61 5 6.72 5 4.07 6.16 2 8l1.42 1.42C5.12 7.93 7.27 7 9.61 7c2.74 0 5.09 1.26 6.77 3.24l-2.88 3.24-4-4L2 16.99l1.5 1.5 6-6.01 4 4 4.05-4.55c.75 1.35 1.25 2.9 1.44 4.55H21c-.22-2.3-.95-4.39-2.04-6.14L22 6.92z"
            })), 'MultilineChart');

            exports.default = _default;
            });

            unwrapExports$1(MultilineChart);

            var MusicNote = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M12 3v10.55c-.59-.34-1.27-.55-2-.55-2.21 0-4 1.79-4 4s1.79 4 4 4 4-1.79 4-4V7h4V3h-6z"
            })), 'MusicNote');

            exports.default = _default;
            });

            unwrapExports$1(MusicNote);

            var MusicVideo = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M21 3H3c-1.1 0-2 .9-2 2v14c0 1.1.9 2 2 2h18c1.1 0 2-.9 2-2V5c0-1.1-.9-2-2-2zm0 16H3V5h18v14zM8 15c0-1.66 1.34-3 3-3 .35 0 .69.07 1 .18V6h5v2h-3v7.03c-.02 1.64-1.35 2.97-3 2.97-1.66 0-3-1.34-3-3z"
            })), 'MusicVideo');

            exports.default = _default;
            });

            unwrapExports$1(MusicVideo);

            var MyLocation = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M12 8c-2.21 0-4 1.79-4 4s1.79 4 4 4 4-1.79 4-4-1.79-4-4-4zm8.94 3c-.46-4.17-3.77-7.48-7.94-7.94V1h-2v2.06C6.83 3.52 3.52 6.83 3.06 11H1v2h2.06c.46 4.17 3.77 7.48 7.94 7.94V23h2v-2.06c4.17-.46 7.48-3.77 7.94-7.94H23v-2h-2.06zM12 19c-3.87 0-7-3.13-7-7s3.13-7 7-7 7 3.13 7 7-3.13 7-7 7z"
            })), 'MyLocation');

            exports.default = _default;
            });

            unwrapExports$1(MyLocation);

            var Nature = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M13 16.12c3.47-.41 6.17-3.36 6.17-6.95 0-3.87-3.13-7-7-7s-7 3.13-7 7c0 3.47 2.52 6.34 5.83 6.89V20H5v2h14v-2h-6v-3.88z"
            })), 'Nature');

            exports.default = _default;
            });

            unwrapExports$1(Nature);

            var NaturePeople = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M22.17 9.17c0-3.87-3.13-7-7-7s-7 3.13-7 7c0 3.47 2.52 6.34 5.83 6.89V20H6v-3h1v-4c0-.55-.45-1-1-1H3c-.55 0-1 .45-1 1v4h1v5h16v-2h-3v-3.88c3.47-.41 6.17-3.36 6.17-6.95zM4.5 11c.83 0 1.5-.67 1.5-1.5S5.33 8 4.5 8 3 8.67 3 9.5 3.67 11 4.5 11z"
            })), 'NaturePeople');

            exports.default = _default;
            });

            unwrapExports$1(NaturePeople);

            var NavigateBefore = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M15.41 7.41L14 6l-6 6 6 6 1.41-1.41L10.83 12z"
            })), 'NavigateBefore');

            exports.default = _default;
            });

            unwrapExports$1(NavigateBefore);

            var NavigateNext = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M10 6L8.59 7.41 13.17 12l-4.58 4.59L10 18l6-6z"
            })), 'NavigateNext');

            exports.default = _default;
            });

            unwrapExports$1(NavigateNext);

            var Navigation = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M12 2L4.5 20.29l.71.71L12 18l6.79 3 .71-.71z"
            })), 'Navigation');

            exports.default = _default;
            });

            unwrapExports$1(Navigation);

            var NearMe = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M21 3L3 10.53v.98l6.84 2.65L12.48 21h.98L21 3z"
            })), 'NearMe');

            exports.default = _default;
            });

            unwrapExports$1(NearMe);

            var NetworkCell = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              fillOpacity: ".3",
              d: "M2 22h20V2z"
            }), _react.default.createElement("path", {
              d: "M17 7L2 22h15z"
            })), 'NetworkCell');

            exports.default = _default;
            });

            unwrapExports$1(NetworkCell);

            var NetworkCheck = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M15.9 5c-.17 0-.32.09-.41.23l-.07.15-5.18 11.65c-.16.29-.26.61-.26.96 0 1.11.9 2.01 2.01 2.01.96 0 1.77-.68 1.96-1.59l.01-.03L16.4 5.5c0-.28-.22-.5-.5-.5zM1 9l2 2c2.88-2.88 6.79-4.08 10.53-3.62l1.19-2.68C9.89 3.84 4.74 5.27 1 9zm20 2l2-2c-1.64-1.64-3.55-2.82-5.59-3.57l-.53 2.82c1.5.62 2.9 1.53 4.12 2.75zm-4 4l2-2c-.8-.8-1.7-1.42-2.66-1.89l-.55 2.92c.42.27.83.59 1.21.97zM5 13l2 2c1.13-1.13 2.56-1.79 4.03-2l1.28-2.88c-2.63-.08-5.3.87-7.31 2.88z"
            })), 'NetworkCheck');

            exports.default = _default;
            });

            unwrapExports$1(NetworkCheck);

            var NetworkLocked = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M19.5 10c.17 0 .33.03.5.05V1L1 20h13v-3c0-.89.39-1.68 1-2.23v-.27c0-2.48 2.02-4.5 4.5-4.5zm2.5 6v-1.5c0-1.38-1.12-2.5-2.5-2.5S17 13.12 17 14.5V16c-.55 0-1 .45-1 1v4c0 .55.45 1 1 1h5c.55 0 1-.45 1-1v-4c0-.55-.45-1-1-1zm-1 0h-3v-1.5c0-.83.67-1.5 1.5-1.5s1.5.67 1.5 1.5V16z"
            })), 'NetworkLocked');

            exports.default = _default;
            });

            unwrapExports$1(NetworkLocked);

            var NetworkWifi = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              fillOpacity: ".3",
              d: "M12.01 21.49L23.64 7c-.45-.34-4.93-4-11.64-4C5.28 3 .81 6.66.36 7l11.63 14.49.01.01.01-.01z"
            }), _react.default.createElement("path", {
              d: "M3.53 10.95l8.46 10.54.01.01.01-.01 8.46-10.54C20.04 10.62 16.81 8 12 8c-4.81 0-8.04 2.62-8.47 2.95z"
            })), 'NetworkWifi');

            exports.default = _default;
            });

            unwrapExports$1(NetworkWifi);

            var NewReleases = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M23 12l-2.44-2.78.34-3.68-3.61-.82-1.89-3.18L12 3 8.6 1.54 6.71 4.72l-3.61.81.34 3.68L1 12l2.44 2.78-.34 3.69 3.61.82 1.89 3.18L12 21l3.4 1.46 1.89-3.18 3.61-.82-.34-3.68L23 12zm-10 5h-2v-2h2v2zm0-4h-2V7h2v6z"
            })), 'NewReleases');

            exports.default = _default;
            });

            unwrapExports$1(NewReleases);

            var NextWeek = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M20 7h-4V5c0-.55-.22-1.05-.59-1.41C15.05 3.22 14.55 3 14 3h-4c-1.1 0-2 .9-2 2v2H4c-1.1 0-2 .9-2 2v11c0 1.1.9 2 2 2h16c1.1 0 2-.9 2-2V9c0-1.1-.9-2-2-2zM10 5h4v2h-4V5zm1 13.5l-1-1 3-3-3-3 1-1 4 4-4 4z"
            })), 'NextWeek');

            exports.default = _default;
            });

            unwrapExports$1(NextWeek);

            var Nfc = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M20 2H4c-1.1 0-2 .9-2 2v16c0 1.1.9 2 2 2h16c1.1 0 2-.9 2-2V4c0-1.1-.9-2-2-2zm0 18H4V4h16v16zM18 6h-5c-1.1 0-2 .9-2 2v2.28c-.6.35-1 .98-1 1.72 0 1.1.9 2 2 2s2-.9 2-2c0-.74-.4-1.38-1-1.72V8h3v8H8V8h2V6H6v12h12V6z"
            })), 'Nfc');

            exports.default = _default;
            });

            unwrapExports$1(Nfc);

            var NoEncryption = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M21 21.78L4.22 5 3 6.22l2.04 2.04C4.42 8.6 4 9.25 4 10v10c0 1.1.9 2 2 2h12c.23 0 .45-.05.66-.12L19.78 23 21 21.78zM8.9 6c0-1.71 1.39-3.1 3.1-3.1s3.1 1.39 3.1 3.1v2H9.66L20 18.34V10c0-1.1-.9-2-2-2h-1V6c0-2.76-2.24-5-5-5-2.56 0-4.64 1.93-4.94 4.4L8.9 7.24V6z"
            })), 'NoEncryption');

            exports.default = _default;
            });

            unwrapExports$1(NoEncryption);

            var NoSim = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M18.99 5c0-1.1-.89-2-1.99-2h-7L7.66 5.34 19 16.68 18.99 5zM3.65 3.88L2.38 5.15 5 7.77V19c0 1.1.9 2 2 2h10.01c.35 0 .67-.1.96-.26l1.88 1.88 1.27-1.27L3.65 3.88z"
            })), 'NoSim');

            exports.default = _default;
            });

            unwrapExports$1(NoSim);

            var Note = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M22 10l-6-6H4c-1.1 0-2 .9-2 2v12.01c0 1.1.9 1.99 2 1.99l16-.01c1.1 0 2-.89 2-1.99v-8zm-7-4.5l5.5 5.5H15V5.5z"
            })), 'Note');

            exports.default = _default;
            });

            unwrapExports$1(Note);

            var NoteAdd = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M14 2H6c-1.1 0-1.99.9-1.99 2L4 20c0 1.1.89 2 1.99 2H18c1.1 0 2-.9 2-2V8l-6-6zm2 14h-3v3h-2v-3H8v-2h3v-3h2v3h3v2zm-3-7V3.5L18.5 9H13z"
            })), 'NoteAdd');

            exports.default = _default;
            });

            unwrapExports$1(NoteAdd);

            var Notifications = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M12 22c1.1 0 2-.9 2-2h-4c0 1.1.89 2 2 2zm6-6v-5c0-3.07-1.64-5.64-4.5-6.32V4c0-.83-.67-1.5-1.5-1.5s-1.5.67-1.5 1.5v.68C7.63 5.36 6 7.92 6 11v5l-2 2v1h16v-1l-2-2z"
            })), 'Notifications');

            exports.default = _default;
            });

            unwrapExports$1(Notifications);

            var NotificationsActive = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M7.58 4.08L6.15 2.65C3.75 4.48 2.17 7.3 2.03 10.5h2c.15-2.65 1.51-4.97 3.55-6.42zm12.39 6.42h2c-.15-3.2-1.73-6.02-4.12-7.85l-1.42 1.43c2.02 1.45 3.39 3.77 3.54 6.42zM18 11c0-3.07-1.64-5.64-4.5-6.32V4c0-.83-.67-1.5-1.5-1.5s-1.5.67-1.5 1.5v.68C7.63 5.36 6 7.92 6 11v5l-2 2v1h16v-1l-2-2v-5zm-6 11c.14 0 .27-.01.4-.04.65-.14 1.18-.58 1.44-1.18.1-.24.15-.5.15-.78h-4c.01 1.1.9 2 2.01 2z"
            })), 'NotificationsActive');

            exports.default = _default;
            });

            unwrapExports$1(NotificationsActive);

            var NotificationsNone = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M12 22c1.1 0 2-.9 2-2h-4c0 1.1.9 2 2 2zm6-6v-5c0-3.07-1.63-5.64-4.5-6.32V4c0-.83-.67-1.5-1.5-1.5s-1.5.67-1.5 1.5v.68C7.64 5.36 6 7.92 6 11v5l-2 2v1h16v-1l-2-2zm-2 1H8v-6c0-2.48 1.51-4.5 4-4.5s4 2.02 4 4.5v6z"
            })), 'NotificationsNone');

            exports.default = _default;
            });

            unwrapExports$1(NotificationsNone);

            var NotificationsOff = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M20 18.69L7.84 6.14 5.27 3.49 4 4.76l2.8 2.8v.01c-.52.99-.8 2.16-.8 3.42v5l-2 2v1h13.73l2 2L21 19.72l-1-1.03zM12 22c1.11 0 2-.89 2-2h-4c0 1.11.89 2 2 2zm6-7.32V11c0-3.08-1.64-5.64-4.5-6.32V4c0-.83-.67-1.5-1.5-1.5s-1.5.67-1.5 1.5v.68c-.15.03-.29.08-.42.12-.1.03-.2.07-.3.11h-.01c-.01 0-.01 0-.02.01-.23.09-.46.2-.68.31 0 0-.01 0-.01.01L18 14.68z"
            })), 'NotificationsOff');

            exports.default = _default;
            });

            unwrapExports$1(NotificationsOff);

            var NotificationsPaused = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M12 22c1.1 0 2-.9 2-2h-4c0 1.1.89 2 2 2zm6-6v-5c0-3.07-1.64-5.64-4.5-6.32V4c0-.83-.67-1.5-1.5-1.5s-1.5.67-1.5 1.5v.68C7.63 5.36 6 7.93 6 11v5l-2 2v1h16v-1l-2-2zm-3.5-6.2l-2.8 3.4h2.8V15h-5v-1.8l2.8-3.4H9.5V8h5v1.8z"
            })), 'NotificationsPaused');

            exports.default = _default;
            });

            unwrapExports$1(NotificationsPaused);

            var NotInterested = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M12 2C6.48 2 2 6.48 2 12s4.48 10 10 10 10-4.48 10-10S17.52 2 12 2zm0 18c-4.42 0-8-3.58-8-8 0-1.85.63-3.55 1.69-4.9L16.9 18.31C15.55 19.37 13.85 20 12 20zm6.31-3.1L7.1 5.69C8.45 4.63 10.15 4 12 4c4.42 0 8 3.58 8 8 0 1.85-.63 3.55-1.69 4.9z"
            })), 'NotInterested');

            exports.default = _default;
            });

            unwrapExports$1(NotInterested);

            var OfflinePin = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M12 2C6.5 2 2 6.5 2 12s4.5 10 10 10 10-4.5 10-10S17.5 2 12 2zm5 16H7v-2h10v2zm-6.7-4L7 10.7l1.4-1.4 1.9 1.9 5.3-5.3L17 7.3 10.3 14z"
            })), 'OfflinePin');

            exports.default = _default;
            });

            unwrapExports$1(OfflinePin);

            var OndemandVideo = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M21 3H3c-1.11 0-2 .89-2 2v12c0 1.1.89 2 2 2h5v2h8v-2h5c1.1 0 1.99-.9 1.99-2L23 5c0-1.11-.9-2-2-2zm0 14H3V5h18v12zm-5-6l-7 4V7z"
            })), 'OndemandVideo');

            exports.default = _default;
            });

            unwrapExports$1(OndemandVideo);

            var Opacity = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M17.66 8L12 2.35 6.34 8C4.78 9.56 4 11.64 4 13.64s.78 4.11 2.34 5.67 3.61 2.35 5.66 2.35 4.1-.79 5.66-2.35S20 15.64 20 13.64 19.22 9.56 17.66 8zM6 14c.01-2 .62-3.27 1.76-4.4L12 5.27l4.24 4.38C17.38 10.77 17.99 12 18 14H6z"
            })), 'Opacity');

            exports.default = _default;
            });

            unwrapExports$1(Opacity);

            var OpenInBrowser = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M19 4H5c-1.11 0-2 .9-2 2v12c0 1.1.89 2 2 2h4v-2H5V8h14v10h-4v2h4c1.1 0 2-.9 2-2V6c0-1.1-.89-2-2-2zm-7 6l-4 4h3v6h2v-6h3l-4-4z"
            })), 'OpenInBrowser');

            exports.default = _default;
            });

            unwrapExports$1(OpenInBrowser);

            var OpenInNew = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M19 19H5V5h7V3H5c-1.11 0-2 .9-2 2v14c0 1.1.89 2 2 2h14c1.1 0 2-.9 2-2v-7h-2v7zM14 3v2h3.59l-9.83 9.83 1.41 1.41L19 6.41V10h2V3h-7z"
            })), 'OpenInNew');

            exports.default = _default;
            });

            unwrapExports$1(OpenInNew);

            var OpenWith = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M10 9h4V6h3l-5-5-5 5h3v3zm-1 1H6V7l-5 5 5 5v-3h3v-4zm14 2l-5-5v3h-3v4h3v3l5-5zm-9 3h-4v3H7l5 5 5-5h-3v-3z"
            })), 'OpenWith');

            exports.default = _default;
            });

            unwrapExports$1(OpenWith);

            var Pages = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M3 5v6h5L7 7l4 1V3H5c-1.1 0-2 .9-2 2zm5 8H3v6c0 1.1.9 2 2 2h6v-5l-4 1 1-4zm9 4l-4-1v5h6c1.1 0 2-.9 2-2v-6h-5l1 4zm2-14h-6v5l4-1-1 4h5V5c0-1.1-.9-2-2-2z"
            })), 'Pages');

            exports.default = _default;
            });

            unwrapExports$1(Pages);

            var Pageview = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M11.5 9C10.12 9 9 10.12 9 11.5s1.12 2.5 2.5 2.5 2.5-1.12 2.5-2.5S12.88 9 11.5 9zM20 4H4c-1.1 0-2 .9-2 2v12c0 1.1.9 2 2 2h16c1.1 0 2-.9 2-2V6c0-1.1-.9-2-2-2zm-3.21 14.21l-2.91-2.91c-.69.44-1.51.7-2.39.7C9.01 16 7 13.99 7 11.5S9.01 7 11.5 7 16 9.01 16 11.5c0 .88-.26 1.69-.7 2.39l2.91 2.9-1.42 1.42z"
            })), 'Pageview');

            exports.default = _default;
            });

            unwrapExports$1(Pageview);

            var Palette = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M12 3c-4.97 0-9 4.03-9 9s4.03 9 9 9c.83 0 1.5-.67 1.5-1.5 0-.39-.15-.74-.39-1.01-.23-.26-.38-.61-.38-.99 0-.83.67-1.5 1.5-1.5H16c2.76 0 5-2.24 5-5 0-4.42-4.03-8-9-8zm-5.5 9c-.83 0-1.5-.67-1.5-1.5S5.67 9 6.5 9 8 9.67 8 10.5 7.33 12 6.5 12zm3-4C8.67 8 8 7.33 8 6.5S8.67 5 9.5 5s1.5.67 1.5 1.5S10.33 8 9.5 8zm5 0c-.83 0-1.5-.67-1.5-1.5S13.67 5 14.5 5s1.5.67 1.5 1.5S15.33 8 14.5 8zm3 4c-.83 0-1.5-.67-1.5-1.5S16.67 9 17.5 9s1.5.67 1.5 1.5-.67 1.5-1.5 1.5z"
            })), 'Palette');

            exports.default = _default;
            });

            unwrapExports$1(Palette);

            var Panorama = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M23 18V6c0-1.1-.9-2-2-2H3c-1.1 0-2 .9-2 2v12c0 1.1.9 2 2 2h18c1.1 0 2-.9 2-2zM8.5 12.5l2.5 3.01L14.5 11l4.5 6H5l3.5-4.5z"
            })), 'Panorama');

            exports.default = _default;
            });

            unwrapExports$1(Panorama);

            var PanoramaFishEye = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M12 2C6.47 2 2 6.47 2 12s4.47 10 10 10 10-4.47 10-10S17.53 2 12 2zm0 18c-4.41 0-8-3.59-8-8s3.59-8 8-8 8 3.59 8 8-3.59 8-8 8z"
            })), 'PanoramaFishEye');

            exports.default = _default;
            });

            unwrapExports$1(PanoramaFishEye);

            var PanoramaHorizontal = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M20 6.54v10.91c-2.6-.77-5.28-1.16-8-1.16-2.72 0-5.4.39-8 1.16V6.54c2.6.77 5.28 1.16 8 1.16 2.72.01 5.4-.38 8-1.16M21.43 4c-.1 0-.2.02-.31.06C18.18 5.16 15.09 5.7 12 5.7c-3.09 0-6.18-.55-9.12-1.64-.11-.04-.22-.06-.31-.06-.34 0-.57.23-.57.63v14.75c0 .39.23.62.57.62.1 0 .2-.02.31-.06 2.94-1.1 6.03-1.64 9.12-1.64 3.09 0 6.18.55 9.12 1.64.11.04.21.06.31.06.33 0 .57-.23.57-.63V4.63c0-.4-.24-.63-.57-.63z"
            })), 'PanoramaHorizontal');

            exports.default = _default;
            });

            unwrapExports$1(PanoramaHorizontal);

            var PanoramaVertical = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M19.94 21.12c-1.1-2.94-1.64-6.03-1.64-9.12 0-3.09.55-6.18 1.64-9.12.04-.11.06-.22.06-.31 0-.34-.23-.57-.63-.57H4.63c-.4 0-.63.23-.63.57 0 .1.02.2.06.31C5.16 5.82 5.71 8.91 5.71 12c0 3.09-.55 6.18-1.64 9.12-.05.11-.07.22-.07.31 0 .33.23.57.63.57h14.75c.39 0 .63-.24.63-.57-.01-.1-.03-.2-.07-.31zM6.54 20c.77-2.6 1.16-5.28 1.16-8 0-2.72-.39-5.4-1.16-8h10.91c-.77 2.6-1.16 5.28-1.16 8 0 2.72.39 5.4 1.16 8H6.54z"
            })), 'PanoramaVertical');

            exports.default = _default;
            });

            unwrapExports$1(PanoramaVertical);

            var PanoramaWideAngle = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M12 6c2.45 0 4.71.2 7.29.64.47 1.78.71 3.58.71 5.36 0 1.78-.24 3.58-.71 5.36-2.58.44-4.84.64-7.29.64s-4.71-.2-7.29-.64C4.24 15.58 4 13.78 4 12c0-1.78.24-3.58.71-5.36C7.29 6.2 9.55 6 12 6m0-2c-2.73 0-5.22.24-7.95.72l-.93.16-.25.9C2.29 7.85 2 9.93 2 12s.29 4.15.87 6.22l.25.89.93.16c2.73.49 5.22.73 7.95.73s5.22-.24 7.95-.72l.93-.16.25-.89c.58-2.08.87-4.16.87-6.23s-.29-4.15-.87-6.22l-.25-.89-.93-.16C17.22 4.24 14.73 4 12 4z"
            })), 'PanoramaWideAngle');

            exports.default = _default;
            });

            unwrapExports$1(PanoramaWideAngle);

            var PanTool = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M23 5.5V20c0 2.2-1.8 4-4 4h-7.3c-1.08 0-2.1-.43-2.85-1.19L1 14.83s1.26-1.23 1.3-1.25c.22-.19.49-.29.79-.29.22 0 .42.06.6.16.04.01 4.31 2.46 4.31 2.46V4c0-.83.67-1.5 1.5-1.5S11 3.17 11 4v7h1V1.5c0-.83.67-1.5 1.5-1.5S15 .67 15 1.5V11h1V2.5c0-.83.67-1.5 1.5-1.5s1.5.67 1.5 1.5V11h1V5.5c0-.83.67-1.5 1.5-1.5s1.5.67 1.5 1.5z"
            })), 'PanTool');

            exports.default = _default;
            });

            unwrapExports$1(PanTool);

            var PartyMode = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M20 4h-3.17L15 2H9L7.17 4H4c-1.1 0-2 .9-2 2v12c0 1.1.9 2 2 2h16c1.1 0 2-.9 2-2V6c0-1.1-.9-2-2-2zm-8 3c1.63 0 3.06.79 3.98 2H12c-1.66 0-3 1.34-3 3 0 .35.07.69.18 1H7.1c-.06-.32-.1-.66-.1-1 0-2.76 2.24-5 5-5zm0 10c-1.63 0-3.06-.79-3.98-2H12c1.66 0 3-1.34 3-3 0-.35-.07-.69-.18-1h2.08c.07.32.1.66.1 1 0 2.76-2.24 5-5 5z"
            })), 'PartyMode');

            exports.default = _default;
            });

            unwrapExports$1(PartyMode);

            var Pause = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M6 19h4V5H6v14zm8-14v14h4V5h-4z"
            })), 'Pause');

            exports.default = _default;
            });

            unwrapExports$1(Pause);

            var PauseCircleFilled = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M12 2C6.48 2 2 6.48 2 12s4.48 10 10 10 10-4.48 10-10S17.52 2 12 2zm-1 14H9V8h2v8zm4 0h-2V8h2v8z"
            })), 'PauseCircleFilled');

            exports.default = _default;
            });

            unwrapExports$1(PauseCircleFilled);

            var PauseCircleOutline = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M9 16h2V8H9v8zm3-14C6.48 2 2 6.48 2 12s4.48 10 10 10 10-4.48 10-10S17.52 2 12 2zm0 18c-4.41 0-8-3.59-8-8s3.59-8 8-8 8 3.59 8 8-3.59 8-8 8zm1-4h2V8h-2v8z"
            })), 'PauseCircleOutline');

            exports.default = _default;
            });

            unwrapExports$1(PauseCircleOutline);

            var Payment = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M20 4H4c-1.11 0-1.99.89-1.99 2L2 18c0 1.11.89 2 2 2h16c1.11 0 2-.89 2-2V6c0-1.11-.89-2-2-2zm0 14H4v-6h16v6zm0-10H4V6h16v2z"
            })), 'Payment');

            exports.default = _default;
            });

            unwrapExports$1(Payment);

            var People = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M16 11c1.66 0 2.99-1.34 2.99-3S17.66 5 16 5c-1.66 0-3 1.34-3 3s1.34 3 3 3zm-8 0c1.66 0 2.99-1.34 2.99-3S9.66 5 8 5C6.34 5 5 6.34 5 8s1.34 3 3 3zm0 2c-2.33 0-7 1.17-7 3.5V19h14v-2.5c0-2.33-4.67-3.5-7-3.5zm8 0c-.29 0-.62.02-.97.05 1.16.84 1.97 1.97 1.97 3.45V19h6v-2.5c0-2.33-4.67-3.5-7-3.5z"
            })), 'People');

            exports.default = _default;
            });

            unwrapExports$1(People);

            var PeopleOutline = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M16.5 13c-1.2 0-3.07.34-4.5 1-1.43-.67-3.3-1-4.5-1C5.33 13 1 14.08 1 16.25V19h22v-2.75c0-2.17-4.33-3.25-6.5-3.25zm-4 4.5h-10v-1.25c0-.54 2.56-1.75 5-1.75s5 1.21 5 1.75v1.25zm9 0H14v-1.25c0-.46-.2-.86-.52-1.22.88-.3 1.96-.53 3.02-.53 2.44 0 5 1.21 5 1.75v1.25zM7.5 12c1.93 0 3.5-1.57 3.5-3.5S9.43 5 7.5 5 4 6.57 4 8.5 5.57 12 7.5 12zm0-5.5c1.1 0 2 .9 2 2s-.9 2-2 2-2-.9-2-2 .9-2 2-2zm9 5.5c1.93 0 3.5-1.57 3.5-3.5S18.43 5 16.5 5 13 6.57 13 8.5s1.57 3.5 3.5 3.5zm0-5.5c1.1 0 2 .9 2 2s-.9 2-2 2-2-.9-2-2 .9-2 2-2z"
            })), 'PeopleOutline');

            exports.default = _default;
            });

            unwrapExports$1(PeopleOutline);

            var PermCameraMic = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M20 5h-3.17L15 3H9L7.17 5H4c-1.1 0-2 .9-2 2v12c0 1.1.9 2 2 2h7v-2.09c-2.83-.48-5-2.94-5-5.91h2c0 2.21 1.79 4 4 4s4-1.79 4-4h2c0 2.97-2.17 5.43-5 5.91V21h7c1.1 0 2-.9 2-2V7c0-1.1-.9-2-2-2zm-6 8c0 1.1-.9 2-2 2s-2-.9-2-2V9c0-1.1.9-2 2-2s2 .9 2 2v4z"
            })), 'PermCameraMic');

            exports.default = _default;
            });

            unwrapExports$1(PermCameraMic);

            var PermContactCalendar = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M19 3h-1V1h-2v2H8V1H6v2H5c-1.11 0-2 .9-2 2v14c0 1.1.89 2 2 2h14c1.1 0 2-.9 2-2V5c0-1.1-.9-2-2-2zm-7 3c1.66 0 3 1.34 3 3s-1.34 3-3 3-3-1.34-3-3 1.34-3 3-3zm6 12H6v-1c0-2 4-3.1 6-3.1s6 1.1 6 3.1v1z"
            })), 'PermContactCalendar');

            exports.default = _default;
            });

            unwrapExports$1(PermContactCalendar);

            var PermDataSetting = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M18.99 11.5c.34 0 .67.03 1 .07L20 0 0 20h11.56c-.04-.33-.07-.66-.07-1 0-4.14 3.36-7.5 7.5-7.5zm3.71 7.99c.02-.16.04-.32.04-.49 0-.17-.01-.33-.04-.49l1.06-.83c.09-.08.12-.21.06-.32l-1-1.73c-.06-.11-.19-.15-.31-.11l-1.24.5c-.26-.2-.54-.37-.85-.49l-.19-1.32c-.01-.12-.12-.21-.24-.21h-2c-.12 0-.23.09-.25.21l-.19 1.32c-.3.13-.59.29-.85.49l-1.24-.5c-.11-.04-.24 0-.31.11l-1 1.73c-.06.11-.04.24.06.32l1.06.83c-.02.16-.03.32-.03.49 0 .17.01.33.03.49l-1.06.83c-.09.08-.12.21-.06.32l1 1.73c.06.11.19.15.31.11l1.24-.5c.26.2.54.37.85.49l.19 1.32c.02.12.12.21.25.21h2c.12 0 .23-.09.25-.21l.19-1.32c.3-.13.59-.29.84-.49l1.25.5c.11.04.24 0 .31-.11l1-1.73c.06-.11.03-.24-.06-.32l-1.07-.83zm-3.71 1.01c-.83 0-1.5-.67-1.5-1.5s.67-1.5 1.5-1.5 1.5.67 1.5 1.5-.67 1.5-1.5 1.5z"
            })), 'PermDataSetting');

            exports.default = _default;
            });

            unwrapExports$1(PermDataSetting);

            var PermDeviceInformation = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M13 7h-2v2h2V7zm0 4h-2v6h2v-6zm4-9.99L7 1c-1.1 0-2 .9-2 2v18c0 1.1.9 2 2 2h10c1.1 0 2-.9 2-2V3c0-1.1-.9-1.99-2-1.99zM17 19H7V5h10v14z"
            })), 'PermDeviceInformation');

            exports.default = _default;
            });

            unwrapExports$1(PermDeviceInformation);

            var PermIdentity = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M12 5.9c1.16 0 2.1.94 2.1 2.1s-.94 2.1-2.1 2.1S9.9 9.16 9.9 8s.94-2.1 2.1-2.1m0 9c2.97 0 6.1 1.46 6.1 2.1v1.1H5.9V17c0-.64 3.13-2.1 6.1-2.1M12 4C9.79 4 8 5.79 8 8s1.79 4 4 4 4-1.79 4-4-1.79-4-4-4zm0 9c-2.67 0-8 1.34-8 4v3h16v-3c0-2.66-5.33-4-8-4z"
            })), 'PermIdentity');

            exports.default = _default;
            });

            unwrapExports$1(PermIdentity);

            var PermMedia = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M2 6H0v5h.01L0 20c0 1.1.9 2 2 2h18v-2H2V6zm20-2h-8l-2-2H6c-1.1 0-1.99.9-1.99 2L4 16c0 1.1.9 2 2 2h16c1.1 0 2-.9 2-2V6c0-1.1-.9-2-2-2zM7 15l4.5-6 3.5 4.51 2.5-3.01L21 15H7z"
            })), 'PermMedia');

            exports.default = _default;
            });

            unwrapExports$1(PermMedia);

            var PermPhoneMsg = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M20 15.5c-1.25 0-2.45-.2-3.57-.57-.35-.11-.74-.03-1.02.24l-2.2 2.2c-2.83-1.44-5.15-3.75-6.59-6.58l2.2-2.21c.28-.27.36-.66.25-1.01C8.7 6.45 8.5 5.25 8.5 4c0-.55-.45-1-1-1H4c-.55 0-1 .45-1 1 0 9.39 7.61 17 17 17 .55 0 1-.45 1-1v-3.5c0-.55-.45-1-1-1zM12 3v10l3-3h6V3h-9z"
            })), 'PermPhoneMsg');

            exports.default = _default;
            });

            unwrapExports$1(PermPhoneMsg);

            var PermScanWifi = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M12 3C6.95 3 3.15 4.85 0 7.23L12 22 24 7.25C20.85 4.87 17.05 3 12 3zm1 13h-2v-6h2v6zm-2-8V6h2v2h-2z"
            })), 'PermScanWifi');

            exports.default = _default;
            });

            unwrapExports$1(PermScanWifi);

            var Person = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M12 12c2.21 0 4-1.79 4-4s-1.79-4-4-4-4 1.79-4 4 1.79 4 4 4zm0 2c-2.67 0-8 1.34-8 4v2h16v-2c0-2.66-5.33-4-8-4z"
            })), 'Person');

            exports.default = _default;
            });

            unwrapExports$1(Person);

            var PersonAdd = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M15 12c2.21 0 4-1.79 4-4s-1.79-4-4-4-4 1.79-4 4 1.79 4 4 4zm-9-2V7H4v3H1v2h3v3h2v-3h3v-2H6zm9 4c-2.67 0-8 1.34-8 4v2h16v-2c0-2.66-5.33-4-8-4z"
            })), 'PersonAdd');

            exports.default = _default;
            });

            unwrapExports$1(PersonAdd);

            var PersonalVideo = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M21 3H3c-1.11 0-2 .89-2 2v12c0 1.1.89 2 2 2h5v2h8v-2h5c1.1 0 1.99-.9 1.99-2L23 5c0-1.11-.9-2-2-2zm0 14H3V5h18v12z"
            })), 'PersonalVideo');

            exports.default = _default;
            });

            unwrapExports$1(PersonalVideo);

            var PersonOutline = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M12 5.9c1.16 0 2.1.94 2.1 2.1s-.94 2.1-2.1 2.1S9.9 9.16 9.9 8s.94-2.1 2.1-2.1m0 9c2.97 0 6.1 1.46 6.1 2.1v1.1H5.9V17c0-.64 3.13-2.1 6.1-2.1M12 4C9.79 4 8 5.79 8 8s1.79 4 4 4 4-1.79 4-4-1.79-4-4-4zm0 9c-2.67 0-8 1.34-8 4v3h16v-3c0-2.66-5.33-4-8-4z"
            })), 'PersonOutline');

            exports.default = _default;
            });

            unwrapExports$1(PersonOutline);

            var PersonPin = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M19 2H5c-1.11 0-2 .9-2 2v14c0 1.1.89 2 2 2h4l3 3 3-3h4c1.1 0 2-.9 2-2V4c0-1.1-.9-2-2-2zm-7 3.3c1.49 0 2.7 1.21 2.7 2.7 0 1.49-1.21 2.7-2.7 2.7-1.49 0-2.7-1.21-2.7-2.7 0-1.49 1.21-2.7 2.7-2.7zM18 16H6v-.9c0-2 4-3.1 6-3.1s6 1.1 6 3.1v.9z"
            })), 'PersonPin');

            exports.default = _default;
            });

            unwrapExports$1(PersonPin);

            var PersonPinCircle = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M12 2C8.14 2 5 5.14 5 9c0 5.25 7 13 7 13s7-7.75 7-13c0-3.86-3.14-7-7-7zm0 2c1.1 0 2 .9 2 2 0 1.11-.9 2-2 2s-2-.89-2-2c0-1.1.9-2 2-2zm0 10c-1.67 0-3.14-.85-4-2.15.02-1.32 2.67-2.05 4-2.05s3.98.73 4 2.05c-.86 1.3-2.33 2.15-4 2.15z"
            })), 'PersonPinCircle');

            exports.default = _default;
            });

            unwrapExports$1(PersonPinCircle);

            var Pets = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("circle", {
              cx: "4.5",
              cy: "9.5",
              r: "2.5"
            }), _react.default.createElement("circle", {
              cx: "9",
              cy: "5.5",
              r: "2.5"
            }), _react.default.createElement("circle", {
              cx: "15",
              cy: "5.5",
              r: "2.5"
            }), _react.default.createElement("circle", {
              cx: "19.5",
              cy: "9.5",
              r: "2.5"
            }), _react.default.createElement("path", {
              d: "M17.34 14.86c-.87-1.02-1.6-1.89-2.48-2.91-.46-.54-1.05-1.08-1.75-1.32-.11-.04-.22-.07-.33-.09-.25-.04-.52-.04-.78-.04s-.53 0-.79.05c-.11.02-.22.05-.33.09-.7.24-1.28.78-1.75 1.32-.87 1.02-1.6 1.89-2.48 2.91-1.31 1.31-2.92 2.76-2.62 4.79.29 1.02 1.02 2.03 2.33 2.32.73.15 3.06-.44 5.54-.44h.18c2.48 0 4.81.58 5.54.44 1.31-.29 2.04-1.31 2.33-2.32.31-2.04-1.3-3.49-2.61-4.8z"
            })), 'Pets');

            exports.default = _default;
            });

            unwrapExports$1(Pets);

            var Phone = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M6.62 10.79c1.44 2.83 3.76 5.14 6.59 6.59l2.2-2.2c.27-.27.67-.36 1.02-.24 1.12.37 2.33.57 3.57.57.55 0 1 .45 1 1V20c0 .55-.45 1-1 1-9.39 0-17-7.61-17-17 0-.55.45-1 1-1h3.5c.55 0 1 .45 1 1 0 1.25.2 2.45.57 3.57.11.35.03.74-.25 1.02l-2.2 2.2z"
            })), 'Phone');

            exports.default = _default;
            });

            unwrapExports$1(Phone);

            var PhoneAndroid = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M16 1H8C6.34 1 5 2.34 5 4v16c0 1.66 1.34 3 3 3h8c1.66 0 3-1.34 3-3V4c0-1.66-1.34-3-3-3zm-2 20h-4v-1h4v1zm3.25-3H6.75V4h10.5v14z"
            })), 'PhoneAndroid');

            exports.default = _default;
            });

            unwrapExports$1(PhoneAndroid);

            var PhoneBluetoothSpeaker = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M14.71 9.5L17 7.21V11h.5l2.85-2.85L18.21 6l2.15-2.15L17.5 1H17v3.79L14.71 2.5l-.71.71L16.79 6 14 8.79l.71.71zM18 2.91l.94.94-.94.94V2.91zm0 4.3l.94.94-.94.94V7.21zm2 8.29c-1.25 0-2.45-.2-3.57-.57-.35-.11-.74-.03-1.02.24l-2.2 2.2c-2.83-1.44-5.15-3.75-6.59-6.59l2.2-2.21c.28-.26.36-.65.25-1C8.7 6.45 8.5 5.25 8.5 4c0-.55-.45-1-1-1H4c-.55 0-1 .45-1 1 0 9.39 7.61 17 17 17 .55 0 1-.45 1-1v-3.5c0-.55-.45-1-1-1z"
            })), 'PhoneBluetoothSpeaker');

            exports.default = _default;
            });

            unwrapExports$1(PhoneBluetoothSpeaker);

            var PhoneForwarded = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M18 11l5-5-5-5v3h-4v4h4v3zm2 4.5c-1.25 0-2.45-.2-3.57-.57-.35-.11-.74-.03-1.02.24l-2.2 2.2c-2.83-1.44-5.15-3.75-6.59-6.59l2.2-2.21c.28-.26.36-.65.25-1C8.7 6.45 8.5 5.25 8.5 4c0-.55-.45-1-1-1H4c-.55 0-1 .45-1 1 0 9.39 7.61 17 17 17 .55 0 1-.45 1-1v-3.5c0-.55-.45-1-1-1z"
            })), 'PhoneForwarded');

            exports.default = _default;
            });

            unwrapExports$1(PhoneForwarded);

            var PhoneInTalk = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M20 15.5c-1.25 0-2.45-.2-3.57-.57-.35-.11-.74-.03-1.02.24l-2.2 2.2c-2.83-1.44-5.15-3.75-6.59-6.59l2.2-2.21c.28-.26.36-.65.25-1C8.7 6.45 8.5 5.25 8.5 4c0-.55-.45-1-1-1H4c-.55 0-1 .45-1 1 0 9.39 7.61 17 17 17 .55 0 1-.45 1-1v-3.5c0-.55-.45-1-1-1zM19 12h2c0-4.97-4.03-9-9-9v2c3.87 0 7 3.13 7 7zm-4 0h2c0-2.76-2.24-5-5-5v2c1.66 0 3 1.34 3 3z"
            })), 'PhoneInTalk');

            exports.default = _default;
            });

            unwrapExports$1(PhoneInTalk);

            var PhoneIphone = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M15.5 1h-8C6.12 1 5 2.12 5 3.5v17C5 21.88 6.12 23 7.5 23h8c1.38 0 2.5-1.12 2.5-2.5v-17C18 2.12 16.88 1 15.5 1zm-4 21c-.83 0-1.5-.67-1.5-1.5s.67-1.5 1.5-1.5 1.5.67 1.5 1.5-.67 1.5-1.5 1.5zm4.5-4H7V4h9v14z"
            })), 'PhoneIphone');

            exports.default = _default;
            });

            unwrapExports$1(PhoneIphone);

            var Phonelink = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M4 6h18V4H4c-1.1 0-2 .9-2 2v11H0v3h14v-3H4V6zm19 2h-6c-.55 0-1 .45-1 1v10c0 .55.45 1 1 1h6c.55 0 1-.45 1-1V9c0-.55-.45-1-1-1zm-1 9h-4v-7h4v7z"
            })), 'Phonelink');

            exports.default = _default;
            });

            unwrapExports$1(Phonelink);

            var PhonelinkErase = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M13 8.2l-1-1-4 4-4-4-1 1 4 4-4 4 1 1 4-4 4 4 1-1-4-4 4-4zM19 1H9c-1.1 0-2 .9-2 2v3h2V4h10v16H9v-2H7v3c0 1.1.9 2 2 2h10c1.1 0 2-.9 2-2V3c0-1.1-.9-2-2-2z"
            })), 'PhonelinkErase');

            exports.default = _default;
            });

            unwrapExports$1(PhonelinkErase);

            var PhonelinkLock = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M19 1H9c-1.1 0-2 .9-2 2v3h2V4h10v16H9v-2H7v3c0 1.1.9 2 2 2h10c1.1 0 2-.9 2-2V3c0-1.1-.9-2-2-2zm-8.2 10V9.5C10.8 8.1 9.4 7 8 7S5.2 8.1 5.2 9.5V11c-.6 0-1.2.6-1.2 1.2v3.5c0 .7.6 1.3 1.2 1.3h5.5c.7 0 1.3-.6 1.3-1.2v-3.5c0-.7-.6-1.3-1.2-1.3zm-1.3 0h-3V9.5c0-.8.7-1.3 1.5-1.3s1.5.5 1.5 1.3V11z"
            })), 'PhonelinkLock');

            exports.default = _default;
            });

            unwrapExports$1(PhonelinkLock);

            var PhonelinkOff = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M22 6V4H6.82l2 2H22zM1.92 1.65L.65 2.92l1.82 1.82C2.18 5.08 2 5.52 2 6v11H0v3h17.73l2.35 2.35 1.27-1.27L3.89 3.62 1.92 1.65zM4 6.27L14.73 17H4V6.27zM23 8h-6c-.55 0-1 .45-1 1v4.18l2 2V10h4v7h-2.18l3 3H23c.55 0 1-.45 1-1V9c0-.55-.45-1-1-1z"
            })), 'PhonelinkOff');

            exports.default = _default;
            });

            unwrapExports$1(PhonelinkOff);

            var PhonelinkRing = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M20.1 7.7l-1 1c1.8 1.8 1.8 4.6 0 6.5l1 1c2.5-2.3 2.5-6.1 0-8.5zM18 9.8l-1 1c.5.7.5 1.6 0 2.3l1 1c1.2-1.2 1.2-3 0-4.3zM14 1H4c-1.1 0-2 .9-2 2v18c0 1.1.9 2 2 2h10c1.1 0 2-.9 2-2V3c0-1.1-.9-2-2-2zm0 19H4V4h10v16z"
            })), 'PhonelinkRing');

            exports.default = _default;
            });

            unwrapExports$1(PhonelinkRing);

            var PhonelinkSetup = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M11.8 12.5v-1l1.1-.8c.1-.1.1-.2.1-.3l-1-1.7c-.1-.1-.2-.2-.3-.1l-1.3.4c-.3-.2-.6-.4-.9-.5l-.2-1.3c0-.1-.1-.2-.3-.2H7c-.1 0-.2.1-.3.2l-.2 1.3c-.3.1-.6.3-.9.5l-1.3-.5c-.1 0-.2 0-.3.1l-1 1.7c-.1.1 0 .2.1.3l1.1.8v1l-1.1.8c-.1.2-.1.3-.1.4l1 1.7c.1.1.2.2.3.1l1.4-.4c.3.2.6.4.9.5l.2 1.3c-.1.1.1.2.2.2h2c.1 0 .2-.1.3-.2l.2-1.3c.3-.1.6-.3.9-.5l1.3.5c.1 0 .2 0 .3-.1l1-1.7c.1-.1 0-.2-.1-.3l-1.1-.9zM8 14c-1.1 0-2-.9-2-2s.9-2 2-2 2 .9 2 2-.9 2-2 2zM19 1H9c-1.1 0-2 .9-2 2v3h2V4h10v16H9v-2H7v3c0 1.1.9 2 2 2h10c1.1 0 2-.9 2-2V3c0-1.1-.9-2-2-2z"
            })), 'PhonelinkSetup');

            exports.default = _default;
            });

            unwrapExports$1(PhonelinkSetup);

            var PhoneLocked = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M20 15.5c-1.25 0-2.45-.2-3.57-.57-.35-.11-.74-.03-1.02.24l-2.2 2.2c-2.83-1.44-5.15-3.75-6.59-6.59l2.2-2.21c.28-.26.36-.65.25-1C8.7 6.45 8.5 5.25 8.5 4c0-.55-.45-1-1-1H4c-.55 0-1 .45-1 1 0 9.39 7.61 17 17 17 .55 0 1-.45 1-1v-3.5c0-.55-.45-1-1-1zM20 4v-.5C20 2.12 18.88 1 17.5 1S15 2.12 15 3.5V4c-.55 0-1 .45-1 1v4c0 .55.45 1 1 1h5c.55 0 1-.45 1-1V5c0-.55-.45-1-1-1zm-.8 0h-3.4v-.5c0-.94.76-1.7 1.7-1.7s1.7.76 1.7 1.7V4z"
            })), 'PhoneLocked');

            exports.default = _default;
            });

            unwrapExports$1(PhoneLocked);

            var PhoneMissed = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M6.5 5.5L12 11l7-7-1-1-6 6-4.5-4.5H11V3H5v6h1.5V5.5zm17.21 11.17C20.66 13.78 16.54 12 12 12 7.46 12 3.34 13.78.29 16.67c-.18.18-.29.43-.29.71s.11.53.29.71l2.48 2.48c.18.18.43.29.71.29.27 0 .52-.11.7-.28.79-.74 1.69-1.36 2.66-1.85.33-.16.56-.5.56-.9v-3.1c1.45-.48 3-.73 4.6-.73 1.6 0 3.15.25 4.6.72v3.1c0 .39.23.74.56.9.98.49 1.87 1.12 2.67 1.85.18.18.43.28.7.28.28 0 .53-.11.71-.29l2.48-2.48c.18-.18.29-.43.29-.71s-.12-.52-.3-.7z"
            })), 'PhoneMissed');

            exports.default = _default;
            });

            unwrapExports$1(PhoneMissed);

            var PhonePaused = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M17 3h-2v7h2V3zm3 12.5c-1.25 0-2.45-.2-3.57-.57-.35-.11-.74-.03-1.02.24l-2.2 2.2c-2.83-1.44-5.15-3.75-6.59-6.59l2.2-2.21c.28-.26.36-.65.25-1C8.7 6.45 8.5 5.25 8.5 4c0-.55-.45-1-1-1H4c-.55 0-1 .45-1 1 0 9.39 7.61 17 17 17 .55 0 1-.45 1-1v-3.5c0-.55-.45-1-1-1zM19 3v7h2V3h-2z"
            })), 'PhonePaused');

            exports.default = _default;
            });

            unwrapExports$1(PhonePaused);

            var Photo = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M21 19V5c0-1.1-.9-2-2-2H5c-1.1 0-2 .9-2 2v14c0 1.1.9 2 2 2h14c1.1 0 2-.9 2-2zM8.5 13.5l2.5 3.01L14.5 12l4.5 6H5l3.5-4.5z"
            })), 'Photo');

            exports.default = _default;
            });

            unwrapExports$1(Photo);

            var PhotoAlbum = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M18 2H6c-1.1 0-2 .9-2 2v16c0 1.1.9 2 2 2h12c1.1 0 2-.9 2-2V4c0-1.1-.9-2-2-2zM6 4h5v8l-2.5-1.5L6 12V4zm0 15l3-3.86 2.14 2.58 3-3.86L18 19H6z"
            })), 'PhotoAlbum');

            exports.default = _default;
            });

            unwrapExports$1(PhotoAlbum);

            var PhotoCamera = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("circle", {
              cx: "12",
              cy: "12",
              r: "3.2"
            }), _react.default.createElement("path", {
              d: "M9 2L7.17 4H4c-1.1 0-2 .9-2 2v12c0 1.1.9 2 2 2h16c1.1 0 2-.9 2-2V6c0-1.1-.9-2-2-2h-3.17L15 2H9zm3 15c-2.76 0-5-2.24-5-5s2.24-5 5-5 5 2.24 5 5-2.24 5-5 5z"
            })), 'PhotoCamera');

            exports.default = _default;
            });

            unwrapExports$1(PhotoCamera);

            var PhotoFilter = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M19.02 10v9H5V5h9V3H5.02c-1.1 0-2 .9-2 2v14c0 1.1.9 2 2 2h14c1.1 0 2-.9 2-2v-9h-2zM17 10l.94-2.06L20 7l-2.06-.94L17 4l-.94 2.06L14 7l2.06.94zm-3.75.75L12 8l-1.25 2.75L8 12l2.75 1.25L12 16l1.25-2.75L16 12z"
            })), 'PhotoFilter');

            exports.default = _default;
            });

            unwrapExports$1(PhotoFilter);

            var PhotoLibrary = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M22 16V4c0-1.1-.9-2-2-2H8c-1.1 0-2 .9-2 2v12c0 1.1.9 2 2 2h12c1.1 0 2-.9 2-2zm-11-4l2.03 2.71L16 11l4 5H8l3-4zM2 6v14c0 1.1.9 2 2 2h14v-2H4V6H2z"
            })), 'PhotoLibrary');

            exports.default = _default;
            });

            unwrapExports$1(PhotoLibrary);

            var PhotoSizeSelectActual = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M21 3H3C2 3 1 4 1 5v14c0 1.1.9 2 2 2h18c1 0 2-1 2-2V5c0-1-1-2-2-2zM5 17l3.5-4.5 2.5 3.01L14.5 11l4.5 6H5z"
            })), 'PhotoSizeSelectActual');

            exports.default = _default;
            });

            unwrapExports$1(PhotoSizeSelectActual);

            var PhotoSizeSelectLarge = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M21 15h2v2h-2v-2zm0-4h2v2h-2v-2zm2 8h-2v2c1 0 2-1 2-2zM13 3h2v2h-2V3zm8 4h2v2h-2V7zm0-4v2h2c0-1-1-2-2-2zM1 7h2v2H1V7zm16-4h2v2h-2V3zm0 16h2v2h-2v-2zM3 3C2 3 1 4 1 5h2V3zm6 0h2v2H9V3zM5 3h2v2H5V3zm-4 8v8c0 1.1.9 2 2 2h12V11H1zm2 8l2.5-3.21 1.79 2.15 2.5-3.22L13 19H3z"
            })), 'PhotoSizeSelectLarge');

            exports.default = _default;
            });

            unwrapExports$1(PhotoSizeSelectLarge);

            var PhotoSizeSelectSmall = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M23 15h-2v2h2v-2zm0-4h-2v2h2v-2zm0 8h-2v2c1 0 2-1 2-2zM15 3h-2v2h2V3zm8 4h-2v2h2V7zm-2-4v2h2c0-1-1-2-2-2zM3 21h8v-6H1v4c0 1.1.9 2 2 2zM3 7H1v2h2V7zm12 12h-2v2h2v-2zm4-16h-2v2h2V3zm0 16h-2v2h2v-2zM3 3C2 3 1 4 1 5h2V3zm0 8H1v2h2v-2zm8-8H9v2h2V3zM7 3H5v2h2V3z"
            })), 'PhotoSizeSelectSmall');

            exports.default = _default;
            });

            unwrapExports$1(PhotoSizeSelectSmall);

            var PictureAsPdf = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M20 2H8c-1.1 0-2 .9-2 2v12c0 1.1.9 2 2 2h12c1.1 0 2-.9 2-2V4c0-1.1-.9-2-2-2zm-8.5 7.5c0 .83-.67 1.5-1.5 1.5H9v2H7.5V7H10c.83 0 1.5.67 1.5 1.5v1zm5 2c0 .83-.67 1.5-1.5 1.5h-2.5V7H15c.83 0 1.5.67 1.5 1.5v3zm4-3H19v1h1.5V11H19v2h-1.5V7h3v1.5zM9 9.5h1v-1H9v1zM4 6H2v14c0 1.1.9 2 2 2h14v-2H4V6zm10 5.5h1v-3h-1v3z"
            })), 'PictureAsPdf');

            exports.default = _default;
            });

            unwrapExports$1(PictureAsPdf);

            var PictureInPicture = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M19 7h-8v6h8V7zm2-4H3c-1.1 0-2 .9-2 2v14c0 1.1.9 1.98 2 1.98h18c1.1 0 2-.88 2-1.98V5c0-1.1-.9-2-2-2zm0 16.01H3V4.98h18v14.03z"
            })), 'PictureInPicture');

            exports.default = _default;
            });

            unwrapExports$1(PictureInPicture);

            var PictureInPictureAlt = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M19 11h-8v6h8v-6zm4 8V4.98C23 3.88 22.1 3 21 3H3c-1.1 0-2 .88-2 1.98V19c0 1.1.9 2 2 2h18c1.1 0 2-.9 2-2zm-2 .02H3V4.97h18v14.05z"
            })), 'PictureInPictureAlt');

            exports.default = _default;
            });

            unwrapExports$1(PictureInPictureAlt);

            var PieChart = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M11 2v20c-5.07-.5-9-4.79-9-10s3.93-9.5 9-10zm2.03 0v8.99H22c-.47-4.74-4.24-8.52-8.97-8.99zm0 11.01V22c4.74-.47 8.5-4.25 8.97-8.99h-8.97z"
            })), 'PieChart');

            exports.default = _default;
            });

            unwrapExports$1(PieChart);

            var PieChartOutlined = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M12 2C6.5 2 2 6.5 2 12s4.5 10 10 10 10-4.5 10-10S17.5 2 12 2zm1 2.07c3.61.45 6.48 3.33 6.93 6.93H13V4.07zM4 12c0-4.06 3.07-7.44 7-7.93v15.87c-3.93-.5-7-3.88-7-7.94zm9 7.93V13h6.93c-.45 3.61-3.32 6.48-6.93 6.93z"
            })), 'PieChartOutlined');

            exports.default = _default;
            });

            unwrapExports$1(PieChartOutlined);

            var PinDrop = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M18 8c0-3.31-2.69-6-6-6S6 4.69 6 8c0 4.5 6 11 6 11s6-6.5 6-11zm-8 0c0-1.1.9-2 2-2s2 .9 2 2-.89 2-2 2c-1.1 0-2-.9-2-2zM5 20v2h14v-2H5z"
            })), 'PinDrop');

            exports.default = _default;
            });

            unwrapExports$1(PinDrop);

            var Place = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M12 2C8.13 2 5 5.13 5 9c0 5.25 7 13 7 13s7-7.75 7-13c0-3.87-3.13-7-7-7zm0 9.5c-1.38 0-2.5-1.12-2.5-2.5s1.12-2.5 2.5-2.5 2.5 1.12 2.5 2.5-1.12 2.5-2.5 2.5z"
            })), 'Place');

            exports.default = _default;
            });

            unwrapExports$1(Place);

            var PlayArrow = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M8 5v14l11-7z"
            })), 'PlayArrow');

            exports.default = _default;
            });

            unwrapExports$1(PlayArrow);

            var PlayCircleFilled = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M12 2C6.48 2 2 6.48 2 12s4.48 10 10 10 10-4.48 10-10S17.52 2 12 2zm-2 14.5v-9l6 4.5-6 4.5z"
            })), 'PlayCircleFilled');

            exports.default = _default;
            });

            unwrapExports$1(PlayCircleFilled);

            var PlayCircleOutline = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M10 16.5l6-4.5-6-4.5v9zM12 2C6.48 2 2 6.48 2 12s4.48 10 10 10 10-4.48 10-10S17.52 2 12 2zm0 18c-4.41 0-8-3.59-8-8s3.59-8 8-8 8 3.59 8 8-3.59 8-8 8z"
            })), 'PlayCircleOutline');

            exports.default = _default;
            });

            unwrapExports$1(PlayCircleOutline);

            var PlayForWork = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M11 5v5.59H7.5l4.5 4.5 4.5-4.5H13V5h-2zm-5 9c0 3.31 2.69 6 6 6s6-2.69 6-6h-2c0 2.21-1.79 4-4 4s-4-1.79-4-4H6z"
            })), 'PlayForWork');

            exports.default = _default;
            });

            unwrapExports$1(PlayForWork);

            var PlaylistAdd = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M14 10H2v2h12v-2zm0-4H2v2h12V6zm4 8v-4h-2v4h-4v2h4v4h2v-4h4v-2h-4zM2 16h8v-2H2v2z"
            })), 'PlaylistAdd');

            exports.default = _default;
            });

            unwrapExports$1(PlaylistAdd);

            var PlaylistAddCheck = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M14 10H2v2h12v-2zm0-4H2v2h12V6zM2 16h8v-2H2v2zm19.5-4.5L23 13l-6.99 7-4.51-4.5L13 14l3.01 3 5.49-5.5z"
            })), 'PlaylistAddCheck');

            exports.default = _default;
            });

            unwrapExports$1(PlaylistAddCheck);

            var PlaylistPlay = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M19 9H2v2h17V9zm0-4H2v2h17V5zM2 15h13v-2H2v2zm15-2v6l5-3-5-3z"
            })), 'PlaylistPlay');

            exports.default = _default;
            });

            unwrapExports$1(PlaylistPlay);

            var PlusOne = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M10 8H8v4H4v2h4v4h2v-4h4v-2h-4zm4.5-1.92V7.9l2.5-.5V18h2V5z"
            })), 'PlusOne');

            exports.default = _default;
            });

            unwrapExports$1(PlusOne);

            var Poll = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M19 3H5c-1.1 0-2 .9-2 2v14c0 1.1.9 2 2 2h14c1.1 0 2-.9 2-2V5c0-1.1-.9-2-2-2zM9 17H7v-7h2v7zm4 0h-2V7h2v10zm4 0h-2v-4h2v4z"
            })), 'Poll');

            exports.default = _default;
            });

            unwrapExports$1(Poll);

            var Polymer = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M19 4h-4L7.11 16.63 4.5 12 9 4H5L.5 12 5 20h4l7.89-12.63L19.5 12 15 20h4l4.5-8z"
            })), 'Polymer');

            exports.default = _default;
            });

            unwrapExports$1(Polymer);

            var Pool = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M22 21c-1.11 0-1.73-.37-2.18-.64-.37-.22-.6-.36-1.15-.36-.56 0-.78.13-1.15.36-.46.27-1.07.64-2.18.64s-1.73-.37-2.18-.64c-.37-.22-.6-.36-1.15-.36-.56 0-.78.13-1.15.36-.46.27-1.08.64-2.19.64-1.11 0-1.73-.37-2.18-.64-.37-.23-.6-.36-1.15-.36s-.78.13-1.15.36c-.46.27-1.08.64-2.19.64v-2c.56 0 .78-.13 1.15-.36.46-.27 1.08-.64 2.19-.64s1.73.37 2.18.64c.37.23.59.36 1.15.36.56 0 .78-.13 1.15-.36.46-.27 1.08-.64 2.19-.64 1.11 0 1.73.37 2.18.64.37.22.6.36 1.15.36s.78-.13 1.15-.36c.45-.27 1.07-.64 2.18-.64s1.73.37 2.18.64c.37.23.59.36 1.15.36v2zm0-4.5c-1.11 0-1.73-.37-2.18-.64-.37-.22-.6-.36-1.15-.36-.56 0-.78.13-1.15.36-.45.27-1.07.64-2.18.64s-1.73-.37-2.18-.64c-.37-.22-.6-.36-1.15-.36-.56 0-.78.13-1.15.36-.45.27-1.07.64-2.18.64s-1.73-.37-2.18-.64c-.37-.22-.6-.36-1.15-.36s-.78.13-1.15.36c-.47.27-1.09.64-2.2.64v-2c.56 0 .78-.13 1.15-.36.45-.27 1.07-.64 2.18-.64s1.73.37 2.18.64c.37.22.6.36 1.15.36.56 0 .78-.13 1.15-.36.45-.27 1.07-.64 2.18-.64s1.73.37 2.18.64c.37.22.6.36 1.15.36s.78-.13 1.15-.36c.45-.27 1.07-.64 2.18-.64s1.73.37 2.18.64c.37.22.6.36 1.15.36v2zM8.67 12c.56 0 .78-.13 1.15-.36.46-.27 1.08-.64 2.19-.64 1.11 0 1.73.37 2.18.64.37.22.6.36 1.15.36s.78-.13 1.15-.36c.12-.07.26-.15.41-.23L10.48 5C8.93 3.45 7.5 2.99 5 3v2.5c1.82-.01 2.89.39 4 1.5l1 1-3.25 3.25c.31.12.56.27.77.39.37.23.59.36 1.15.36z"
            }), _react.default.createElement("circle", {
              cx: "16.5",
              cy: "5.5",
              r: "2.5"
            })), 'Pool');

            exports.default = _default;
            });

            unwrapExports$1(Pool);

            var PortableWifiOff = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M17.56 14.24c.28-.69.44-1.45.44-2.24 0-3.31-2.69-6-6-6-.79 0-1.55.16-2.24.44l1.62 1.62c.2-.03.41-.06.62-.06 2.21 0 4 1.79 4 4 0 .21-.02.42-.05.63l1.61 1.61zM12 4c4.42 0 8 3.58 8 8 0 1.35-.35 2.62-.95 3.74l1.47 1.47C21.46 15.69 22 13.91 22 12c0-5.52-4.48-10-10-10-1.91 0-3.69.55-5.21 1.47l1.46 1.46C9.37 4.34 10.65 4 12 4zM3.27 2.5L2 3.77l2.1 2.1C2.79 7.57 2 9.69 2 12c0 3.7 2.01 6.92 4.99 8.65l1-1.73C5.61 17.53 4 14.96 4 12c0-1.76.57-3.38 1.53-4.69l1.43 1.44C6.36 9.68 6 10.8 6 12c0 2.22 1.21 4.15 3 5.19l1-1.74c-1.19-.7-2-1.97-2-3.45 0-.65.17-1.25.44-1.79l1.58 1.58L10 12c0 1.1.9 2 2 2l.21-.02.01.01 7.51 7.51L21 20.23 4.27 3.5l-1-1z"
            })), 'PortableWifiOff');

            exports.default = _default;
            });

            unwrapExports$1(PortableWifiOff);

            var Portrait = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M12 12.25c1.24 0 2.25-1.01 2.25-2.25S13.24 7.75 12 7.75 9.75 8.76 9.75 10s1.01 2.25 2.25 2.25zm4.5 4c0-1.5-3-2.25-4.5-2.25s-4.5.75-4.5 2.25V17h9v-.75zM19 3H5c-1.1 0-2 .9-2 2v14c0 1.1.9 2 2 2h14c1.1 0 2-.9 2-2V5c0-1.1-.9-2-2-2zm0 16H5V5h14v14z"
            })), 'Portrait');

            exports.default = _default;
            });

            unwrapExports$1(Portrait);

            var Power = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M16.01 7L16 3h-2v4h-4V3H8v4h-.01C7 6.99 6 7.99 6 8.99v5.49L9.5 18v3h5v-3l3.5-3.51v-5.5c0-1-1-2-1.99-1.99z"
            })), 'Power');

            exports.default = _default;
            });

            unwrapExports$1(Power);

            var PowerInput = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M2 9v2h19V9H2zm0 6h5v-2H2v2zm7 0h5v-2H9v2zm7 0h5v-2h-5v2z"
            })), 'PowerInput');

            exports.default = _default;
            });

            unwrapExports$1(PowerInput);

            var PowerSettingsNew = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M13 3h-2v10h2V3zm4.83 2.17l-1.42 1.42C17.99 7.86 19 9.81 19 12c0 3.87-3.13 7-7 7s-7-3.13-7-7c0-2.19 1.01-4.14 2.58-5.42L6.17 5.17C4.23 6.82 3 9.26 3 12c0 4.97 4.03 9 9 9s9-4.03 9-9c0-2.74-1.23-5.18-3.17-6.83z"
            })), 'PowerSettingsNew');

            exports.default = _default;
            });

            unwrapExports$1(PowerSettingsNew);

            var PregnantWoman = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M9 4c0-1.11.89-2 2-2s2 .89 2 2-.89 2-2 2-2-.89-2-2zm7 9c-.01-1.34-.83-2.51-2-3 0-1.66-1.34-3-3-3s-3 1.34-3 3v7h2v5h3v-5h3v-4z"
            })), 'PregnantWoman');

            exports.default = _default;
            });

            unwrapExports$1(PregnantWoman);

            var PresentToAll = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M21 3H3c-1.11 0-2 .89-2 2v14c0 1.11.89 2 2 2h18c1.11 0 2-.89 2-2V5c0-1.11-.89-2-2-2zm0 16.02H3V4.98h18v14.04zM10 12H8l4-4 4 4h-2v4h-4v-4z"
            })), 'PresentToAll');

            exports.default = _default;
            });

            unwrapExports$1(PresentToAll);

            var Print = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M19 8H5c-1.66 0-3 1.34-3 3v6h4v4h12v-4h4v-6c0-1.66-1.34-3-3-3zm-3 11H8v-5h8v5zm3-7c-.55 0-1-.45-1-1s.45-1 1-1 1 .45 1 1-.45 1-1 1zm-1-9H6v4h12V3z"
            })), 'Print');

            exports.default = _default;
            });

            unwrapExports$1(Print);

            var PriorityHigh = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("circle", {
              cx: "12",
              cy: "19",
              r: "2"
            }), _react.default.createElement("path", {
              d: "M10 3h4v12h-4z"
            })), 'PriorityHigh');

            exports.default = _default;
            });

            unwrapExports$1(PriorityHigh);

            var Public = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M12 2C6.48 2 2 6.48 2 12s4.48 10 10 10 10-4.48 10-10S17.52 2 12 2zm-1 17.93c-3.95-.49-7-3.85-7-7.93 0-.62.08-1.21.21-1.79L9 15v1c0 1.1.9 2 2 2v1.93zm6.9-2.54c-.26-.81-1-1.39-1.9-1.39h-1v-3c0-.55-.45-1-1-1H8v-2h2c.55 0 1-.45 1-1V7h2c1.1 0 2-.9 2-2v-.41c2.93 1.19 5 4.06 5 7.41 0 2.08-.8 3.97-2.1 5.39z"
            })), 'Public');

            exports.default = _default;
            });

            unwrapExports$1(Public);

            var Publish = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M5 4v2h14V4H5zm0 10h4v6h6v-6h4l-7-7-7 7z"
            })), 'Publish');

            exports.default = _default;
            });

            unwrapExports$1(Publish);

            var QueryBuilder = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M11.99 2C6.47 2 2 6.48 2 12s4.47 10 9.99 10C17.52 22 22 17.52 22 12S17.52 2 11.99 2zM12 20c-4.42 0-8-3.58-8-8s3.58-8 8-8 8 3.58 8 8-3.58 8-8 8zm.5-13H11v6l5.25 3.15.75-1.23-4.5-2.67z"
            })), 'QueryBuilder');

            exports.default = _default;
            });

            unwrapExports$1(QueryBuilder);

            var QuestionAnswer = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M21 6h-2v9H6v2c0 .55.45 1 1 1h11l4 4V7c0-.55-.45-1-1-1zm-4 6V3c0-.55-.45-1-1-1H3c-.55 0-1 .45-1 1v14l4-4h10c.55 0 1-.45 1-1z"
            })), 'QuestionAnswer');

            exports.default = _default;
            });

            unwrapExports$1(QuestionAnswer);

            var Queue = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M4 6H2v14c0 1.1.9 2 2 2h14v-2H4V6zm16-4H8c-1.1 0-2 .9-2 2v12c0 1.1.9 2 2 2h12c1.1 0 2-.9 2-2V4c0-1.1-.9-2-2-2zm-1 9h-4v4h-2v-4H9V9h4V5h2v4h4v2z"
            })), 'Queue');

            exports.default = _default;
            });

            unwrapExports$1(Queue);

            var QueueMusic = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M15 6H3v2h12V6zm0 4H3v2h12v-2zM3 16h8v-2H3v2zM17 6v8.18c-.31-.11-.65-.18-1-.18-1.66 0-3 1.34-3 3s1.34 3 3 3 3-1.34 3-3V8h3V6h-5z"
            })), 'QueueMusic');

            exports.default = _default;
            });

            unwrapExports$1(QueueMusic);

            var QueuePlayNext = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M21 3H3c-1.11 0-2 .89-2 2v12c0 1.1.89 2 2 2h5v2h8v-2h2v-2H3V5h18v8h2V5c0-1.11-.9-2-2-2zm-8 7V7h-2v3H8v2h3v3h2v-3h3v-2h-3zm11 8l-4.5 4.5L18 21l3-3-3-3 1.5-1.5L24 18z"
            })), 'QueuePlayNext');

            exports.default = _default;
            });

            unwrapExports$1(QueuePlayNext);

            var Radio = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M3.24 6.15C2.51 6.43 2 7.17 2 8v12c0 1.1.89 2 2 2h16c1.11 0 2-.9 2-2V8c0-1.11-.89-2-2-2H8.3l8.26-3.34L15.88 1 3.24 6.15zM7 20c-1.66 0-3-1.34-3-3s1.34-3 3-3 3 1.34 3 3-1.34 3-3 3zm13-8h-2v-2h-2v2H4V8h16v4z"
            })), 'Radio');

            exports.default = _default;
            });

            unwrapExports$1(Radio);

            var RadioButtonChecked = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M12 7c-2.76 0-5 2.24-5 5s2.24 5 5 5 5-2.24 5-5-2.24-5-5-5zm0-5C6.48 2 2 6.48 2 12s4.48 10 10 10 10-4.48 10-10S17.52 2 12 2zm0 18c-4.42 0-8-3.58-8-8s3.58-8 8-8 8 3.58 8 8-3.58 8-8 8z"
            })), 'RadioButtonChecked');

            exports.default = _default;
            });

            unwrapExports$1(RadioButtonChecked);

            var RadioButtonUnchecked = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M12 2C6.48 2 2 6.48 2 12s4.48 10 10 10 10-4.48 10-10S17.52 2 12 2zm0 18c-4.42 0-8-3.58-8-8s3.58-8 8-8 8 3.58 8 8-3.58 8-8 8z"
            })), 'RadioButtonUnchecked');

            exports.default = _default;
            });

            unwrapExports$1(RadioButtonUnchecked);

            var RateReview = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M20 2H4c-1.1 0-1.99.9-1.99 2L2 22l4-4h14c1.1 0 2-.9 2-2V4c0-1.1-.9-2-2-2zM6 14v-2.47l6.88-6.88c.2-.2.51-.2.71 0l1.77 1.77c.2.2.2.51 0 .71L8.47 14H6zm12 0h-7.5l2-2H18v2z"
            })), 'RateReview');

            exports.default = _default;
            });

            unwrapExports$1(RateReview);

            var Receipt = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M18 17H6v-2h12v2zm0-4H6v-2h12v2zm0-4H6V7h12v2zM3 22l1.5-1.5L6 22l1.5-1.5L9 22l1.5-1.5L12 22l1.5-1.5L15 22l1.5-1.5L18 22l1.5-1.5L21 22V2l-1.5 1.5L18 2l-1.5 1.5L15 2l-1.5 1.5L12 2l-1.5 1.5L9 2 7.5 3.5 6 2 4.5 3.5 3 2v20z"
            })), 'Receipt');

            exports.default = _default;
            });

            unwrapExports$1(Receipt);

            var RecentActors = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M21 5v14h2V5h-2zm-4 14h2V5h-2v14zM14 5H2c-.55 0-1 .45-1 1v12c0 .55.45 1 1 1h12c.55 0 1-.45 1-1V6c0-.55-.45-1-1-1zM8 7.75c1.24 0 2.25 1.01 2.25 2.25S9.24 12.25 8 12.25 5.75 11.24 5.75 10 6.76 7.75 8 7.75zM12.5 17h-9v-.75c0-1.5 3-2.25 4.5-2.25s4.5.75 4.5 2.25V17z"
            })), 'RecentActors');

            exports.default = _default;
            });

            unwrapExports$1(RecentActors);

            var RecordVoiceOver = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("circle", {
              cx: "9",
              cy: "9",
              r: "4"
            }), _react.default.createElement("path", {
              d: "M9 15c-2.67 0-8 1.34-8 4v2h16v-2c0-2.66-5.33-4-8-4zm7.76-9.64l-1.68 1.69c.84 1.18.84 2.71 0 3.89l1.68 1.69c2.02-2.02 2.02-5.07 0-7.27zM20.07 2l-1.63 1.63c2.77 3.02 2.77 7.56 0 10.74L20.07 16c3.9-3.89 3.91-9.95 0-14z"
            })), 'RecordVoiceOver');

            exports.default = _default;
            });

            unwrapExports$1(RecordVoiceOver);

            var Redeem = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M20 6h-2.18c.11-.31.18-.65.18-1 0-1.66-1.34-3-3-3-1.05 0-1.96.54-2.5 1.35l-.5.67-.5-.68C10.96 2.54 10.05 2 9 2 7.34 2 6 3.34 6 5c0 .35.07.69.18 1H4c-1.11 0-1.99.89-1.99 2L2 19c0 1.11.89 2 2 2h16c1.11 0 2-.89 2-2V8c0-1.11-.89-2-2-2zm-5-2c.55 0 1 .45 1 1s-.45 1-1 1-1-.45-1-1 .45-1 1-1zM9 4c.55 0 1 .45 1 1s-.45 1-1 1-1-.45-1-1 .45-1 1-1zm11 15H4v-2h16v2zm0-5H4V8h5.08L7 10.83 8.62 12 11 8.76l1-1.36 1 1.36L15.38 12 17 10.83 14.92 8H20v6z"
            })), 'Redeem');

            exports.default = _default;
            });

            unwrapExports$1(Redeem);

            var Redo = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M18.4 10.6C16.55 8.99 14.15 8 11.5 8c-4.65 0-8.58 3.03-9.96 7.22L3.9 16c1.05-3.19 4.05-5.5 7.6-5.5 1.95 0 3.73.72 5.12 1.88L13 16h9V7l-3.6 3.6z"
            })), 'Redo');

            exports.default = _default;
            });

            unwrapExports$1(Redo);

            var Refresh = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M17.65 6.35C16.2 4.9 14.21 4 12 4c-4.42 0-7.99 3.58-7.99 8s3.57 8 7.99 8c3.73 0 6.84-2.55 7.73-6h-2.08c-.82 2.33-3.04 4-5.65 4-3.31 0-6-2.69-6-6s2.69-6 6-6c1.66 0 3.14.69 4.22 1.78L13 11h7V4l-2.35 2.35z"
            })), 'Refresh');

            exports.default = _default;
            });

            unwrapExports$1(Refresh);

            var Remove = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M19 13H5v-2h14v2z"
            })), 'Remove');

            exports.default = _default;
            });

            unwrapExports$1(Remove);

            var RemoveCircle = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M12 2C6.48 2 2 6.48 2 12s4.48 10 10 10 10-4.48 10-10S17.52 2 12 2zm5 11H7v-2h10v2z"
            })), 'RemoveCircle');

            exports.default = _default;
            });

            unwrapExports$1(RemoveCircle);

            var RemoveCircleOutline = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M7 11v2h10v-2H7zm5-9C6.48 2 2 6.48 2 12s4.48 10 10 10 10-4.48 10-10S17.52 2 12 2zm0 18c-4.41 0-8-3.59-8-8s3.59-8 8-8 8 3.59 8 8-3.59 8-8 8z"
            })), 'RemoveCircleOutline');

            exports.default = _default;
            });

            unwrapExports$1(RemoveCircleOutline);

            var RemoveFromQueue = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M21 3H3c-1.11 0-2 .89-2 2v12c0 1.1.89 2 2 2h5v2h8v-2h5c1.1 0 1.99-.9 1.99-2L23 5c0-1.11-.9-2-2-2zm0 14H3V5h18v12zm-5-7v2H8v-2h8z"
            })), 'RemoveFromQueue');

            exports.default = _default;
            });

            unwrapExports$1(RemoveFromQueue);

            var RemoveRedEye = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M12 4.5C7 4.5 2.73 7.61 1 12c1.73 4.39 6 7.5 11 7.5s9.27-3.11 11-7.5c-1.73-4.39-6-7.5-11-7.5zM12 17c-2.76 0-5-2.24-5-5s2.24-5 5-5 5 2.24 5 5-2.24 5-5 5zm0-8c-1.66 0-3 1.34-3 3s1.34 3 3 3 3-1.34 3-3-1.34-3-3-3z"
            })), 'RemoveRedEye');

            exports.default = _default;
            });

            unwrapExports$1(RemoveRedEye);

            var RemoveShoppingCart = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M22.73 22.73L2.77 2.77 2 2l-.73-.73L0 2.54l4.39 4.39 2.21 4.66-1.35 2.45c-.16.28-.25.61-.25.96 0 1.1.9 2 2 2h7.46l1.38 1.38c-.5.36-.83.95-.83 1.62 0 1.1.89 2 1.99 2 .67 0 1.26-.33 1.62-.84L21.46 24l1.27-1.27zM7.42 15c-.14 0-.25-.11-.25-.25l.03-.12.9-1.63h2.36l2 2H7.42zm8.13-2c.75 0 1.41-.41 1.75-1.03l3.58-6.49c.08-.14.12-.31.12-.48 0-.55-.45-1-1-1H6.54l9.01 9zM7 18c-1.1 0-1.99.9-1.99 2S5.9 22 7 22s2-.9 2-2-.9-2-2-2z"
            })), 'RemoveShoppingCart');

            exports.default = _default;
            });

            unwrapExports$1(RemoveShoppingCart);

            var Reorder = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M3 15h18v-2H3v2zm0 4h18v-2H3v2zm0-8h18V9H3v2zm0-6v2h18V5H3z"
            })), 'Reorder');

            exports.default = _default;
            });

            unwrapExports$1(Reorder);

            var Repeat = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M7 7h10v3l4-4-4-4v3H5v6h2V7zm10 10H7v-3l-4 4 4 4v-3h12v-6h-2v4z"
            })), 'Repeat');

            exports.default = _default;
            });

            unwrapExports$1(Repeat);

            var RepeatOne = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M7 7h10v3l4-4-4-4v3H5v6h2V7zm10 10H7v-3l-4 4 4 4v-3h12v-6h-2v4zm-4-2V9h-1l-2 1v1h1.5v4H13z"
            })), 'RepeatOne');

            exports.default = _default;
            });

            unwrapExports$1(RepeatOne);

            var Replay = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M12 5V1L7 6l5 5V7c3.31 0 6 2.69 6 6s-2.69 6-6 6-6-2.69-6-6H4c0 4.42 3.58 8 8 8s8-3.58 8-8-3.58-8-8-8z"
            })), 'Replay');

            exports.default = _default;
            });

            unwrapExports$1(Replay);

            var Replay10 = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M12 5V1L7 6l5 5V7c3.3 0 6 2.7 6 6s-2.7 6-6 6-6-2.7-6-6H4c0 4.4 3.6 8 8 8s8-3.6 8-8-3.6-8-8-8zm-1.1 11H10v-3.3L9 13v-.7l1.8-.6h.1V16zm4.3-1.8c0 .3 0 .6-.1.8l-.3.6s-.3.3-.5.3-.4.1-.6.1-.4 0-.6-.1-.3-.2-.5-.3-.2-.3-.3-.6-.1-.5-.1-.8v-.7c0-.3 0-.6.1-.8l.3-.6s.3-.3.5-.3.4-.1.6-.1.4 0 .6.1c.2.1.3.2.5.3s.2.3.3.6.1.5.1.8v.7zm-.9-.8v-.5s-.1-.2-.1-.3-.1-.1-.2-.2-.2-.1-.3-.1-.2 0-.3.1l-.2.2s-.1.2-.1.3v2s.1.2.1.3.1.1.2.2.2.1.3.1.2 0 .3-.1l.2-.2s.1-.2.1-.3v-1.5z"
            })), 'Replay10');

            exports.default = _default;
            });

            unwrapExports$1(Replay10);

            var Replay30 = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M12 5V1L7 6l5 5V7c3.3 0 6 2.7 6 6s-2.7 6-6 6-6-2.7-6-6H4c0 4.4 3.6 8 8 8s8-3.6 8-8-3.6-8-8-8zm-2.4 8.5h.4c.2 0 .4-.1.5-.2s.2-.2.2-.4v-.2s-.1-.1-.1-.2-.1-.1-.2-.1h-.5s-.1.1-.2.1-.1.1-.1.2v.2h-1c0-.2 0-.3.1-.5s.2-.3.3-.4.3-.2.4-.2.4-.1.5-.1c.2 0 .4 0 .6.1s.3.1.5.2.2.2.3.4.1.3.1.5v.3s-.1.2-.1.3-.1.2-.2.2-.2.1-.3.2c.2.1.4.2.5.4s.2.4.2.6c0 .2 0 .4-.1.5s-.2.3-.3.4-.3.2-.5.2-.4.1-.6.1c-.2 0-.4 0-.5-.1s-.3-.1-.5-.2-.2-.2-.3-.4-.1-.4-.1-.6h.8v.2s.1.1.1.2.1.1.2.1h.5s.1-.1.2-.1.1-.1.1-.2v-.5s-.1-.1-.1-.2-.1-.1-.2-.1h-.6v-.7zm5.7.7c0 .3 0 .6-.1.8l-.3.6s-.3.3-.5.3-.4.1-.6.1-.4 0-.6-.1-.3-.2-.5-.3-.2-.3-.3-.6-.1-.5-.1-.8v-.7c0-.3 0-.6.1-.8l.3-.6s.3-.3.5-.3.4-.1.6-.1.4 0 .6.1.3.2.5.3.2.3.3.6.1.5.1.8v.7zm-.8-.8v-.5c0-.1-.1-.2-.1-.3s-.1-.1-.2-.2-.2-.1-.3-.1-.2 0-.3.1l-.2.2s-.1.2-.1.3v2s.1.2.1.3.1.1.2.2.2.1.3.1.2 0 .3-.1l.2-.2s.1-.2.1-.3v-1.5z"
            })), 'Replay30');

            exports.default = _default;
            });

            unwrapExports$1(Replay30);

            var Replay5 = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M12 5V1L7 6l5 5V7c3.3 0 6 2.7 6 6s-2.7 6-6 6-6-2.7-6-6H4c0 4.4 3.6 8 8 8s8-3.6 8-8-3.6-8-8-8zm-1.3 8.9l.2-2.2h2.4v.7h-1.7l-.1.9s.1 0 .1-.1.1 0 .1-.1.1 0 .2 0h.2c.2 0 .4 0 .5.1s.3.2.4.3.2.3.3.5.1.4.1.6c0 .2 0 .4-.1.5s-.1.3-.3.5-.3.2-.4.3-.4.1-.6.1c-.2 0-.4 0-.5-.1s-.3-.1-.5-.2-.2-.2-.3-.4-.1-.3-.1-.5h.8c0 .2.1.3.2.4s.2.1.4.1c.1 0 .2 0 .3-.1l.2-.2s.1-.2.1-.3v-.6l-.1-.2-.2-.2s-.2-.1-.3-.1h-.2s-.1 0-.2.1-.1 0-.1.1-.1.1-.1.1h-.7z"
            })), 'Replay5');

            exports.default = _default;
            });

            unwrapExports$1(Replay5);

            var Reply = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M10 9V5l-7 7 7 7v-4.1c5 0 8.5 1.6 11 5.1-1-5-4-10-11-11z"
            })), 'Reply');

            exports.default = _default;
            });

            unwrapExports$1(Reply);

            var ReplyAll = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M7 8V5l-7 7 7 7v-3l-4-4 4-4zm6 1V5l-7 7 7 7v-4.1c5 0 8.5 1.6 11 5.1-1-5-4-10-11-11z"
            })), 'ReplyAll');

            exports.default = _default;
            });

            unwrapExports$1(ReplyAll);

            var Report = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M15.73 3H8.27L3 8.27v7.46L8.27 21h7.46L21 15.73V8.27L15.73 3zM12 17.3c-.72 0-1.3-.58-1.3-1.3 0-.72.58-1.3 1.3-1.3.72 0 1.3.58 1.3 1.3 0 .72-.58 1.3-1.3 1.3zm1-4.3h-2V7h2v6z"
            })), 'Report');

            exports.default = _default;
            });

            unwrapExports$1(Report);

            var ReportProblem = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M1 21h22L12 2 1 21zm12-3h-2v-2h2v2zm0-4h-2v-4h2v4z"
            })), 'ReportProblem');

            exports.default = _default;
            });

            unwrapExports$1(ReportProblem);

            var Restaurant = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M11 9H9V2H7v7H5V2H3v7c0 2.12 1.66 3.84 3.75 3.97V22h2.5v-9.03C11.34 12.84 13 11.12 13 9V2h-2v7zm5-3v8h2.5v8H21V2c-2.76 0-5 2.24-5 4z"
            })), 'Restaurant');

            exports.default = _default;
            });

            unwrapExports$1(Restaurant);

            var RestaurantMenu = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M8.1 13.34l2.83-2.83L3.91 3.5c-1.56 1.56-1.56 4.09 0 5.66l4.19 4.18zm6.78-1.81c1.53.71 3.68.21 5.27-1.38 1.91-1.91 2.28-4.65.81-6.12-1.46-1.46-4.2-1.1-6.12.81-1.59 1.59-2.09 3.74-1.38 5.27L3.7 19.87l1.41 1.41L12 14.41l6.88 6.88 1.41-1.41L13.41 13l1.47-1.47z"
            })), 'RestaurantMenu');

            exports.default = _default;
            });

            unwrapExports$1(RestaurantMenu);

            var Restore = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M13 3c-4.97 0-9 4.03-9 9H1l3.89 3.89.07.14L9 12H6c0-3.87 3.13-7 7-7s7 3.13 7 7-3.13 7-7 7c-1.93 0-3.68-.79-4.94-2.06l-1.42 1.42C8.27 19.99 10.51 21 13 21c4.97 0 9-4.03 9-9s-4.03-9-9-9zm-1 5v5l4.28 2.54.72-1.21-3.5-2.08V8H12z"
            })), 'Restore');

            exports.default = _default;
            });

            unwrapExports$1(Restore);

            var RestorePage = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M14 2H6c-1.1 0-1.99.9-1.99 2L4 20c0 1.1.89 2 1.99 2H18c1.1 0 2-.9 2-2V8l-6-6zm-2 16c-2.05 0-3.81-1.24-4.58-3h1.71c.63.9 1.68 1.5 2.87 1.5 1.93 0 3.5-1.57 3.5-3.5S13.93 9.5 12 9.5c-1.35 0-2.52.78-3.1 1.9l1.6 1.6h-4V9l1.3 1.3C8.69 8.92 10.23 8 12 8c2.76 0 5 2.24 5 5s-2.24 5-5 5z"
            })), 'RestorePage');

            exports.default = _default;
            });

            unwrapExports$1(RestorePage);

            var RingVolume = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M23.71 16.67C20.66 13.78 16.54 12 12 12 7.46 12 3.34 13.78.29 16.67c-.18.18-.29.43-.29.71 0 .28.11.53.29.71l2.48 2.48c.18.18.43.29.71.29.27 0 .52-.11.7-.28.79-.74 1.69-1.36 2.66-1.85.33-.16.56-.5.56-.9v-3.1c1.45-.48 3-.73 4.6-.73s3.15.25 4.6.72v3.1c0 .39.23.74.56.9.98.49 1.87 1.12 2.66 1.85.18.18.43.28.7.28.28 0 .53-.11.71-.29l2.48-2.48c.18-.18.29-.43.29-.71 0-.27-.11-.52-.29-.7zM21.16 6.26l-1.41-1.41-3.56 3.55 1.41 1.41s3.45-3.52 3.56-3.55zM13 2h-2v5h2V2zM6.4 9.81L7.81 8.4 4.26 4.84 2.84 6.26c.11.03 3.56 3.55 3.56 3.55z"
            })), 'RingVolume');

            exports.default = _default;
            });

            unwrapExports$1(RingVolume);

            var Room = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M12 2C8.13 2 5 5.13 5 9c0 5.25 7 13 7 13s7-7.75 7-13c0-3.87-3.13-7-7-7zm0 9.5c-1.38 0-2.5-1.12-2.5-2.5s1.12-2.5 2.5-2.5 2.5 1.12 2.5 2.5-1.12 2.5-2.5 2.5z"
            })), 'Room');

            exports.default = _default;
            });

            unwrapExports$1(Room);

            var RoomService = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M2 17h20v2H2zm11.84-9.21c.1-.24.16-.51.16-.79 0-1.1-.9-2-2-2s-2 .9-2 2c0 .28.06.55.16.79C6.25 8.6 3.27 11.93 3 16h18c-.27-4.07-3.25-7.4-7.16-8.21z"
            })), 'RoomService');

            exports.default = _default;
            });

            unwrapExports$1(RoomService);

            var Rotate90DegreesCcw = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M7.34 6.41L.86 12.9l6.49 6.48 6.49-6.48-6.5-6.49zM3.69 12.9l3.66-3.66L11 12.9l-3.66 3.66-3.65-3.66zm15.67-6.26C17.61 4.88 15.3 4 13 4V.76L8.76 5 13 9.24V6c1.79 0 3.58.68 4.95 2.05 2.73 2.73 2.73 7.17 0 9.9C16.58 19.32 14.79 20 13 20c-.97 0-1.94-.21-2.84-.61l-1.49 1.49C10.02 21.62 11.51 22 13 22c2.3 0 4.61-.88 6.36-2.64 3.52-3.51 3.52-9.21 0-12.72z"
            })), 'Rotate90DegreesCcw');

            exports.default = _default;
            });

            unwrapExports$1(Rotate90DegreesCcw);

            var RotateLeft = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M7.11 8.53L5.7 7.11C4.8 8.27 4.24 9.61 4.07 11h2.02c.14-.87.49-1.72 1.02-2.47zM6.09 13H4.07c.17 1.39.72 2.73 1.62 3.89l1.41-1.42c-.52-.75-.87-1.59-1.01-2.47zm1.01 5.32c1.16.9 2.51 1.44 3.9 1.61V17.9c-.87-.15-1.71-.49-2.46-1.03L7.1 18.32zM13 4.07V1L8.45 5.55 13 10V6.09c2.84.48 5 2.94 5 5.91s-2.16 5.43-5 5.91v2.02c3.95-.49 7-3.85 7-7.93s-3.05-7.44-7-7.93z"
            })), 'RotateLeft');

            exports.default = _default;
            });

            unwrapExports$1(RotateLeft);

            var RotateRight = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M15.55 5.55L11 1v3.07C7.06 4.56 4 7.92 4 12s3.05 7.44 7 7.93v-2.02c-2.84-.48-5-2.94-5-5.91s2.16-5.43 5-5.91V10l4.55-4.45zM19.93 11c-.17-1.39-.72-2.73-1.62-3.89l-1.42 1.42c.54.75.88 1.6 1.02 2.47h2.02zM13 17.9v2.02c1.39-.17 2.74-.71 3.9-1.61l-1.44-1.44c-.75.54-1.59.89-2.46 1.03zm3.89-2.42l1.42 1.41c.9-1.16 1.45-2.5 1.62-3.89h-2.02c-.14.87-.48 1.72-1.02 2.48z"
            })), 'RotateRight');

            exports.default = _default;
            });

            unwrapExports$1(RotateRight);

            var RoundedCorner = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M19 19h2v2h-2v-2zm0-2h2v-2h-2v2zM3 13h2v-2H3v2zm0 4h2v-2H3v2zm0-8h2V7H3v2zm0-4h2V3H3v2zm4 0h2V3H7v2zm8 16h2v-2h-2v2zm-4 0h2v-2h-2v2zm4 0h2v-2h-2v2zm-8 0h2v-2H7v2zm-4 0h2v-2H3v2zM21 8c0-2.76-2.24-5-5-5h-5v2h5c1.65 0 3 1.35 3 3v5h2V8z"
            })), 'RoundedCorner');

            exports.default = _default;
            });

            unwrapExports$1(RoundedCorner);

            var Router = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M20.2 5.9l.8-.8C19.6 3.7 17.8 3 16 3s-3.6.7-5 2.1l.8.8C13 4.8 14.5 4.2 16 4.2s3 .6 4.2 1.7zm-.9.8c-.9-.9-2.1-1.4-3.3-1.4s-2.4.5-3.3 1.4l.8.8c.7-.7 1.6-1 2.5-1 .9 0 1.8.3 2.5 1l.8-.8zM19 13h-2V9h-2v4H5c-1.1 0-2 .9-2 2v4c0 1.1.9 2 2 2h14c1.1 0 2-.9 2-2v-4c0-1.1-.9-2-2-2zM8 18H6v-2h2v2zm3.5 0h-2v-2h2v2zm3.5 0h-2v-2h2v2z"
            })), 'Router');

            exports.default = _default;
            });

            unwrapExports$1(Router);

            var Rowing = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M8.5 14.5L4 19l1.5 1.5L9 17h2l-2.5-2.5zM15 1c-1.1 0-2 .9-2 2s.9 2 2 2 2-.9 2-2-.9-2-2-2zm6 20.01L18 24l-2.99-3.01V19.5l-7.1-7.09c-.31.05-.61.07-.91.07v-2.16c1.66.03 3.61-.87 4.67-2.04l1.4-1.55c.19-.21.43-.38.69-.5.29-.14.62-.23.96-.23h.03C15.99 6.01 17 7.02 17 8.26v5.75c0 .84-.35 1.61-.92 2.16l-3.58-3.58v-2.27c-.63.52-1.43 1.02-2.29 1.39L16.5 18H18l3 3.01z"
            })), 'Rowing');

            exports.default = _default;
            });

            unwrapExports$1(Rowing);

            var RssFeed = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("circle", {
              cx: "6.18",
              cy: "17.82",
              r: "2.18"
            }), _react.default.createElement("path", {
              d: "M4 4.44v2.83c7.03 0 12.73 5.7 12.73 12.73h2.83c0-8.59-6.97-15.56-15.56-15.56zm0 5.66v2.83c3.9 0 7.07 3.17 7.07 7.07h2.83c0-5.47-4.43-9.9-9.9-9.9z"
            })), 'RssFeed');

            exports.default = _default;
            });

            unwrapExports$1(RssFeed);

            var RvHookup = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M20 17v-6c0-1.1-.9-2-2-2H7V7l-3 3 3 3v-2h4v3H4v3c0 1.1.9 2 2 2h2c0 1.66 1.34 3 3 3s3-1.34 3-3h8v-2h-2zm-9 3c-.55 0-1-.45-1-1s.45-1 1-1 1 .45 1 1-.45 1-1 1zm7-6h-4v-3h4v3zM17 2v2H9v2h8v2l3-3z"
            })), 'RvHookup');

            exports.default = _default;
            });

            unwrapExports$1(RvHookup);

            var Satellite = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M19 3H5c-1.1 0-2 .9-2 2v14c0 1.1.9 2 2 2h14c1.1 0 2-.9 2-2V5c0-1.1-.9-2-2-2zM5 4.99h3C8 6.65 6.66 8 5 8V4.99zM5 12v-2c2.76 0 5-2.25 5-5.01h2C12 8.86 8.87 12 5 12zm0 6l3.5-4.5 2.5 3.01L14.5 12l4.5 6H5z"
            })), 'Satellite');

            exports.default = _default;
            });

            unwrapExports$1(Satellite);

            var Save = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M17 3H5c-1.11 0-2 .9-2 2v14c0 1.1.89 2 2 2h14c1.1 0 2-.9 2-2V7l-4-4zm-5 16c-1.66 0-3-1.34-3-3s1.34-3 3-3 3 1.34 3 3-1.34 3-3 3zm3-10H5V5h10v4z"
            })), 'Save');

            exports.default = _default;
            });

            unwrapExports$1(Save);

            var Scanner = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M19.8 10.7L4.2 5l-.7 1.9L17.6 12H5c-1.1 0-2 .9-2 2v4c0 1.1.9 2 2 2h14c1.1 0 2-.9 2-2v-5.5c0-.8-.5-1.6-1.2-1.8zM7 17H5v-2h2v2zm12 0H9v-2h10v2z"
            })), 'Scanner');

            exports.default = _default;
            });

            unwrapExports$1(Scanner);

            var Schedule = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M11.99 2C6.47 2 2 6.48 2 12s4.47 10 9.99 10C17.52 22 22 17.52 22 12S17.52 2 11.99 2zM12 20c-4.42 0-8-3.58-8-8s3.58-8 8-8 8 3.58 8 8-3.58 8-8 8zm.5-13H11v6l5.25 3.15.75-1.23-4.5-2.67z"
            })), 'Schedule');

            exports.default = _default;
            });

            unwrapExports$1(Schedule);

            var School = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M5 13.18v4L12 21l7-3.82v-4L12 17l-7-3.82zM12 3L1 9l11 6 9-4.91V17h2V9L12 3z"
            })), 'School');

            exports.default = _default;
            });

            unwrapExports$1(School);

            var ScreenLockLandscape = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M21 5H3c-1.1 0-2 .9-2 2v10c0 1.1.9 2 2 2h18c1.1 0 2-.9 2-2V7c0-1.1-.9-2-2-2zm-2 12H5V7h14v10zm-9-1h4c.55 0 1-.45 1-1v-3c0-.55-.45-1-1-1v-1c0-1.11-.9-2-2-2-1.11 0-2 .9-2 2v1c-.55 0-1 .45-1 1v3c0 .55.45 1 1 1zm.8-6c0-.66.54-1.2 1.2-1.2.66 0 1.2.54 1.2 1.2v1h-2.4v-1z"
            })), 'ScreenLockLandscape');

            exports.default = _default;
            });

            unwrapExports$1(ScreenLockLandscape);

            var ScreenLockPortrait = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M10 16h4c.55 0 1-.45 1-1v-3c0-.55-.45-1-1-1v-1c0-1.11-.9-2-2-2-1.11 0-2 .9-2 2v1c-.55 0-1 .45-1 1v3c0 .55.45 1 1 1zm.8-6c0-.66.54-1.2 1.2-1.2.66 0 1.2.54 1.2 1.2v1h-2.4v-1zM17 1H7c-1.1 0-2 .9-2 2v18c0 1.1.9 2 2 2h10c1.1 0 2-.9 2-2V3c0-1.1-.9-2-2-2zm0 18H7V5h10v14z"
            })), 'ScreenLockPortrait');

            exports.default = _default;
            });

            unwrapExports$1(ScreenLockPortrait);

            var ScreenLockRotation = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M23.25 12.77l-2.57-2.57-1.41 1.41 2.22 2.22-5.66 5.66L4.51 8.17l5.66-5.66 2.1 2.1 1.41-1.41L11.23.75c-.59-.59-1.54-.59-2.12 0L2.75 7.11c-.59.59-.59 1.54 0 2.12l12.02 12.02c.59.59 1.54.59 2.12 0l6.36-6.36c.59-.59.59-1.54 0-2.12zM8.47 20.48C5.2 18.94 2.86 15.76 2.5 12H1c.51 6.16 5.66 11 11.95 11l.66-.03-3.81-3.82-1.33 1.33zM16 9h5c.55 0 1-.45 1-1V4c0-.55-.45-1-1-1v-.5C21 1.12 19.88 0 18.5 0S16 1.12 16 2.5V3c-.55 0-1 .45-1 1v4c0 .55.45 1 1 1zm.8-6.5c0-.94.76-1.7 1.7-1.7s1.7.76 1.7 1.7V3h-3.4v-.5z"
            })), 'ScreenLockRotation');

            exports.default = _default;
            });

            unwrapExports$1(ScreenLockRotation);

            var ScreenRotation = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M16.48 2.52c3.27 1.55 5.61 4.72 5.97 8.48h1.5C23.44 4.84 18.29 0 12 0l-.66.03 3.81 3.81 1.33-1.32zm-6.25-.77c-.59-.59-1.54-.59-2.12 0L1.75 8.11c-.59.59-.59 1.54 0 2.12l12.02 12.02c.59.59 1.54.59 2.12 0l6.36-6.36c.59-.59.59-1.54 0-2.12L10.23 1.75zm4.6 19.44L2.81 9.17l6.36-6.36 12.02 12.02-6.36 6.36zm-7.31.29C4.25 19.94 1.91 16.76 1.55 13H.05C.56 19.16 5.71 24 12 24l.66-.03-3.81-3.81-1.33 1.32z"
            })), 'ScreenRotation');

            exports.default = _default;
            });

            unwrapExports$1(ScreenRotation);

            var ScreenShare = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M20 18c1.1 0 1.99-.9 1.99-2L22 6c0-1.11-.9-2-2-2H4c-1.11 0-2 .89-2 2v10c0 1.1.89 2 2 2H0v2h24v-2h-4zm-7-3.53v-2.19c-2.78 0-4.61.85-6 2.72.56-2.67 2.11-5.33 6-5.87V7l4 3.73-4 3.74z"
            })), 'ScreenShare');

            exports.default = _default;
            });

            unwrapExports$1(ScreenShare);

            var SdCard = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M18 2h-8L4.02 8 4 20c0 1.1.9 2 2 2h12c1.1 0 2-.9 2-2V4c0-1.1-.9-2-2-2zm-6 6h-2V4h2v4zm3 0h-2V4h2v4zm3 0h-2V4h2v4z"
            })), 'SdCard');

            exports.default = _default;
            });

            unwrapExports$1(SdCard);

            var SdStorage = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M18 2h-8L4.02 8 4 20c0 1.1.9 2 2 2h12c1.1 0 2-.9 2-2V4c0-1.1-.9-2-2-2zm-6 6h-2V4h2v4zm3 0h-2V4h2v4zm3 0h-2V4h2v4z"
            })), 'SdStorage');

            exports.default = _default;
            });

            unwrapExports$1(SdStorage);

            var Search = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M15.5 14h-.79l-.28-.27C15.41 12.59 16 11.11 16 9.5 16 5.91 13.09 3 9.5 3S3 5.91 3 9.5 5.91 16 9.5 16c1.61 0 3.09-.59 4.23-1.57l.27.28v.79l5 4.99L20.49 19l-4.99-5zm-6 0C7.01 14 5 11.99 5 9.5S7.01 5 9.5 5 14 7.01 14 9.5 11.99 14 9.5 14z"
            })), 'Search');

            exports.default = _default;
            });

            var Search$1 = unwrapExports$1(Search);

            var Security = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M12 1L3 5v6c0 5.55 3.84 10.74 9 12 5.16-1.26 9-6.45 9-12V5l-9-4zm0 10.99h7c-.53 4.12-3.28 7.79-7 8.94V12H5V6.3l7-3.11v8.8z"
            })), 'Security');

            exports.default = _default;
            });

            unwrapExports$1(Security);

            var SelectAll = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M3 5h2V3c-1.1 0-2 .9-2 2zm0 8h2v-2H3v2zm4 8h2v-2H7v2zM3 9h2V7H3v2zm10-6h-2v2h2V3zm6 0v2h2c0-1.1-.9-2-2-2zM5 21v-2H3c0 1.1.9 2 2 2zm-2-4h2v-2H3v2zM9 3H7v2h2V3zm2 18h2v-2h-2v2zm8-8h2v-2h-2v2zm0 8c1.1 0 2-.9 2-2h-2v2zm0-12h2V7h-2v2zm0 8h2v-2h-2v2zm-4 4h2v-2h-2v2zm0-16h2V3h-2v2zM7 17h10V7H7v10zm2-8h6v6H9V9z"
            })), 'SelectAll');

            exports.default = _default;
            });

            unwrapExports$1(SelectAll);

            var Send = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M2.01 21L23 12 2.01 3 2 10l15 2-15 2z"
            })), 'Send');

            exports.default = _default;
            });

            unwrapExports$1(Send);

            var SentimentDissatisfied = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("circle", {
              cx: "15.5",
              cy: "9.5",
              r: "1.5"
            }), _react.default.createElement("circle", {
              cx: "8.5",
              cy: "9.5",
              r: "1.5"
            }), _react.default.createElement("path", {
              d: "M11.99 2C6.47 2 2 6.48 2 12s4.47 10 9.99 10C17.52 22 22 17.52 22 12S17.52 2 11.99 2zM12 20c-4.42 0-8-3.58-8-8s3.58-8 8-8 8 3.58 8 8-3.58 8-8 8zm0-6c-2.33 0-4.32 1.45-5.12 3.5h1.67c.69-1.19 1.97-2 3.45-2s2.75.81 3.45 2h1.67c-.8-2.05-2.79-3.5-5.12-3.5z"
            })), 'SentimentDissatisfied');

            exports.default = _default;
            });

            unwrapExports$1(SentimentDissatisfied);

            var SentimentNeutral = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M9 14h6v1.5H9z"
            }), _react.default.createElement("circle", {
              cx: "15.5",
              cy: "9.5",
              r: "1.5"
            }), _react.default.createElement("circle", {
              cx: "8.5",
              cy: "9.5",
              r: "1.5"
            }), _react.default.createElement("path", {
              d: "M11.99 2C6.47 2 2 6.48 2 12s4.47 10 9.99 10C17.52 22 22 17.52 22 12S17.52 2 11.99 2zM12 20c-4.42 0-8-3.58-8-8s3.58-8 8-8 8 3.58 8 8-3.58 8-8 8z"
            })), 'SentimentNeutral');

            exports.default = _default;
            });

            unwrapExports$1(SentimentNeutral);

            var SentimentSatisfied = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("circle", {
              cx: "15.5",
              cy: "9.5",
              r: "1.5"
            }), _react.default.createElement("circle", {
              cx: "8.5",
              cy: "9.5",
              r: "1.5"
            }), _react.default.createElement("path", {
              d: "M11.99 2C6.47 2 2 6.48 2 12s4.47 10 9.99 10C17.52 22 22 17.52 22 12S17.52 2 11.99 2zM12 20c-4.42 0-8-3.58-8-8s3.58-8 8-8 8 3.58 8 8-3.58 8-8 8zm0-4c-1.48 0-2.75-.81-3.45-2H6.88c.8 2.05 2.79 3.5 5.12 3.5s4.32-1.45 5.12-3.5h-1.67c-.7 1.19-1.97 2-3.45 2z"
            })), 'SentimentSatisfied');

            exports.default = _default;
            });

            unwrapExports$1(SentimentSatisfied);

            var SentimentVeryDissatisfied = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M11.99 2C6.47 2 2 6.47 2 12s4.47 10 9.99 10S22 17.53 22 12 17.52 2 11.99 2zM12 20c-4.42 0-8-3.58-8-8s3.58-8 8-8 8 3.58 8 8-3.58 8-8 8zm4.18-12.24l-1.06 1.06-1.06-1.06L13 8.82l1.06 1.06L13 10.94 14.06 12l1.06-1.06L16.18 12l1.06-1.06-1.06-1.06 1.06-1.06zM7.82 12l1.06-1.06L9.94 12 11 10.94 9.94 9.88 11 8.82 9.94 7.76 8.88 8.82 7.82 7.76 6.76 8.82l1.06 1.06-1.06 1.06zM12 14c-2.33 0-4.31 1.46-5.11 3.5h10.22c-.8-2.04-2.78-3.5-5.11-3.5z"
            })), 'SentimentVeryDissatisfied');

            exports.default = _default;
            });

            unwrapExports$1(SentimentVeryDissatisfied);

            var SentimentVerySatisfied = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M11.99 2C6.47 2 2 6.47 2 12s4.47 10 9.99 10S22 17.53 22 12 17.52 2 11.99 2zM12 20c-4.42 0-8-3.58-8-8s3.58-8 8-8 8 3.58 8 8-3.58 8-8 8zm1-10.06L14.06 11l1.06-1.06L16.18 11l1.06-1.06-2.12-2.12zm-4.12 0L9.94 11 11 9.94 8.88 7.82 6.76 9.94 7.82 11zM12 17.5c2.33 0 4.31-1.46 5.11-3.5H6.89c.8 2.04 2.78 3.5 5.11 3.5z"
            })), 'SentimentVerySatisfied');

            exports.default = _default;
            });

            unwrapExports$1(SentimentVerySatisfied);

            var Settings = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M19.43 12.98c.04-.32.07-.64.07-.98s-.03-.66-.07-.98l2.11-1.65c.19-.15.24-.42.12-.64l-2-3.46c-.12-.22-.39-.3-.61-.22l-2.49 1c-.52-.4-1.08-.73-1.69-.98l-.38-2.65C14.46 2.18 14.25 2 14 2h-4c-.25 0-.46.18-.49.42l-.38 2.65c-.61.25-1.17.59-1.69.98l-2.49-1c-.23-.09-.49 0-.61.22l-2 3.46c-.13.22-.07.49.12.64l2.11 1.65c-.04.32-.07.65-.07.98s.03.66.07.98l-2.11 1.65c-.19.15-.24.42-.12.64l2 3.46c.12.22.39.3.61.22l2.49-1c.52.4 1.08.73 1.69.98l.38 2.65c.03.24.24.42.49.42h4c.25 0 .46-.18.49-.42l.38-2.65c.61-.25 1.17-.59 1.69-.98l2.49 1c.23.09.49 0 .61-.22l2-3.46c.12-.22.07-.49-.12-.64l-2.11-1.65zM12 15.5c-1.93 0-3.5-1.57-3.5-3.5s1.57-3.5 3.5-3.5 3.5 1.57 3.5 3.5-1.57 3.5-3.5 3.5z"
            })), 'Settings');

            exports.default = _default;
            });

            unwrapExports$1(Settings);

            var SettingsApplications = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M12 10c-1.1 0-2 .9-2 2s.9 2 2 2 2-.9 2-2-.9-2-2-2zm7-7H5c-1.11 0-2 .9-2 2v14c0 1.1.89 2 2 2h14c1.11 0 2-.9 2-2V5c0-1.1-.89-2-2-2zm-1.75 9c0 .23-.02.46-.05.68l1.48 1.16c.13.11.17.3.08.45l-1.4 2.42c-.09.15-.27.21-.43.15l-1.74-.7c-.36.28-.76.51-1.18.69l-.26 1.85c-.03.17-.18.3-.35.3h-2.8c-.17 0-.32-.13-.35-.29l-.26-1.85c-.43-.18-.82-.41-1.18-.69l-1.74.7c-.16.06-.34 0-.43-.15l-1.4-2.42c-.09-.15-.05-.34.08-.45l1.48-1.16c-.03-.23-.05-.46-.05-.69 0-.23.02-.46.05-.68l-1.48-1.16c-.13-.11-.17-.3-.08-.45l1.4-2.42c.09-.15.27-.21.43-.15l1.74.7c.36-.28.76-.51 1.18-.69l.26-1.85c.03-.17.18-.3.35-.3h2.8c.17 0 .32.13.35.29l.26 1.85c.43.18.82.41 1.18.69l1.74-.7c.16-.06.34 0 .43.15l1.4 2.42c.09.15.05.34-.08.45l-1.48 1.16c.03.23.05.46.05.69z"
            })), 'SettingsApplications');

            exports.default = _default;
            });

            unwrapExports$1(SettingsApplications);

            var SettingsBackupRestore = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M14 12c0-1.1-.9-2-2-2s-2 .9-2 2 .9 2 2 2 2-.9 2-2zm-2-9c-4.97 0-9 4.03-9 9H0l4 4 4-4H5c0-3.87 3.13-7 7-7s7 3.13 7 7-3.13 7-7 7c-1.51 0-2.91-.49-4.06-1.3l-1.42 1.44C8.04 20.3 9.94 21 12 21c4.97 0 9-4.03 9-9s-4.03-9-9-9z"
            })), 'SettingsBackupRestore');

            exports.default = _default;
            });

            unwrapExports$1(SettingsBackupRestore);

            var SettingsBluetooth = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M11 24h2v-2h-2v2zm-4 0h2v-2H7v2zm8 0h2v-2h-2v2zm2.71-18.29L12 0h-1v7.59L6.41 3 5 4.41 10.59 10 5 15.59 6.41 17 11 12.41V20h1l5.71-5.71-4.3-4.29 4.3-4.29zM13 3.83l1.88 1.88L13 7.59V3.83zm1.88 10.46L13 16.17v-3.76l1.88 1.88z"
            })), 'SettingsBluetooth');

            exports.default = _default;
            });

            unwrapExports$1(SettingsBluetooth);

            var SettingsBrightness = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M21 3H3c-1.1 0-2 .9-2 2v14c0 1.1.9 2 2 2h18c1.1 0 2-.9 2-2V5c0-1.1-.9-2-2-2zm0 16.01H3V4.99h18v14.02zM8 16h2.5l1.5 1.5 1.5-1.5H16v-2.5l1.5-1.5-1.5-1.5V8h-2.5L12 6.5 10.5 8H8v2.5L6.5 12 8 13.5V16zm4-7c1.66 0 3 1.34 3 3s-1.34 3-3 3V9z"
            })), 'SettingsBrightness');

            exports.default = _default;
            });

            unwrapExports$1(SettingsBrightness);

            var SettingsCell = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M7 24h2v-2H7v2zm4 0h2v-2h-2v2zm4 0h2v-2h-2v2zM16 .01L8 0C6.9 0 6 .9 6 2v16c0 1.1.9 2 2 2h8c1.1 0 2-.9 2-2V2c0-1.1-.9-1.99-2-1.99zM16 16H8V4h8v12z"
            })), 'SettingsCell');

            exports.default = _default;
            });

            unwrapExports$1(SettingsCell);

            var SettingsEthernet = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M7.77 6.76L6.23 5.48.82 12l5.41 6.52 1.54-1.28L3.42 12l4.35-5.24zM7 13h2v-2H7v2zm10-2h-2v2h2v-2zm-6 2h2v-2h-2v2zm6.77-7.52l-1.54 1.28L20.58 12l-4.35 5.24 1.54 1.28L23.18 12l-5.41-6.52z"
            })), 'SettingsEthernet');

            exports.default = _default;
            });

            unwrapExports$1(SettingsEthernet);

            var SettingsInputAntenna = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M12 5c-3.87 0-7 3.13-7 7h2c0-2.76 2.24-5 5-5s5 2.24 5 5h2c0-3.87-3.13-7-7-7zm1 9.29c.88-.39 1.5-1.26 1.5-2.29 0-1.38-1.12-2.5-2.5-2.5S9.5 10.62 9.5 12c0 1.02.62 1.9 1.5 2.29v3.3L7.59 21 9 22.41l3-3 3 3L16.41 21 13 17.59v-3.3zM12 1C5.93 1 1 5.93 1 12h2c0-4.97 4.03-9 9-9s9 4.03 9 9h2c0-6.07-4.93-11-11-11z"
            })), 'SettingsInputAntenna');

            exports.default = _default;
            });

            unwrapExports$1(SettingsInputAntenna);

            var SettingsInputComponent = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M5 2c0-.55-.45-1-1-1s-1 .45-1 1v4H1v6h6V6H5V2zm4 14c0 1.3.84 2.4 2 2.82V23h2v-4.18c1.16-.41 2-1.51 2-2.82v-2H9v2zm-8 0c0 1.3.84 2.4 2 2.82V23h2v-4.18C6.16 18.4 7 17.3 7 16v-2H1v2zM21 6V2c0-.55-.45-1-1-1s-1 .45-1 1v4h-2v6h6V6h-2zm-8-4c0-.55-.45-1-1-1s-1 .45-1 1v4H9v6h6V6h-2V2zm4 14c0 1.3.84 2.4 2 2.82V23h2v-4.18c1.16-.41 2-1.51 2-2.82v-2h-6v2z"
            })), 'SettingsInputComponent');

            exports.default = _default;
            });

            unwrapExports$1(SettingsInputComponent);

            var SettingsInputComposite = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M5 2c0-.55-.45-1-1-1s-1 .45-1 1v4H1v6h6V6H5V2zm4 14c0 1.3.84 2.4 2 2.82V23h2v-4.18c1.16-.41 2-1.51 2-2.82v-2H9v2zm-8 0c0 1.3.84 2.4 2 2.82V23h2v-4.18C6.16 18.4 7 17.3 7 16v-2H1v2zM21 6V2c0-.55-.45-1-1-1s-1 .45-1 1v4h-2v6h6V6h-2zm-8-4c0-.55-.45-1-1-1s-1 .45-1 1v4H9v6h6V6h-2V2zm4 14c0 1.3.84 2.4 2 2.82V23h2v-4.18c1.16-.41 2-1.51 2-2.82v-2h-6v2z"
            })), 'SettingsInputComposite');

            exports.default = _default;
            });

            unwrapExports$1(SettingsInputComposite);

            var SettingsInputHdmi = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M18 7V4c0-1.1-.9-2-2-2H8c-1.1 0-2 .9-2 2v3H5v6l3 6v3h8v-3l3-6V7h-1zM8 4h8v3h-2V5h-1v2h-2V5h-1v2H8V4z"
            })), 'SettingsInputHdmi');

            exports.default = _default;
            });

            unwrapExports$1(SettingsInputHdmi);

            var SettingsInputSvideo = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M8 11.5c0-.83-.67-1.5-1.5-1.5S5 10.67 5 11.5 5.67 13 6.5 13 8 12.33 8 11.5zm7-5c0-.83-.67-1.5-1.5-1.5h-3C9.67 5 9 5.67 9 6.5S9.67 8 10.5 8h3c.83 0 1.5-.67 1.5-1.5zM8.5 15c-.83 0-1.5.67-1.5 1.5S7.67 18 8.5 18s1.5-.67 1.5-1.5S9.33 15 8.5 15zM12 1C5.93 1 1 5.93 1 12s4.93 11 11 11 11-4.93 11-11S18.07 1 12 1zm0 20c-4.96 0-9-4.04-9-9s4.04-9 9-9 9 4.04 9 9-4.04 9-9 9zm5.5-11c-.83 0-1.5.67-1.5 1.5s.67 1.5 1.5 1.5 1.5-.67 1.5-1.5-.67-1.5-1.5-1.5zm-2 5c-.83 0-1.5.67-1.5 1.5s.67 1.5 1.5 1.5 1.5-.67 1.5-1.5-.67-1.5-1.5-1.5z"
            })), 'SettingsInputSvideo');

            exports.default = _default;
            });

            unwrapExports$1(SettingsInputSvideo);

            var SettingsOverscan = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M12.01 5.5L10 8h4l-1.99-2.5zM18 10v4l2.5-1.99L18 10zM6 10l-2.5 2.01L6 14v-4zm8 6h-4l2.01 2.5L14 16zm7-13H3c-1.1 0-2 .9-2 2v14c0 1.1.9 2 2 2h18c1.1 0 2-.9 2-2V5c0-1.1-.9-2-2-2zm0 16.01H3V4.99h18v14.02z"
            })), 'SettingsOverscan');

            exports.default = _default;
            });

            unwrapExports$1(SettingsOverscan);

            var SettingsPhone = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M13 9h-2v2h2V9zm4 0h-2v2h2V9zm3 6.5c-1.25 0-2.45-.2-3.57-.57-.35-.11-.74-.03-1.02.24l-2.2 2.2c-2.83-1.44-5.15-3.75-6.59-6.58l2.2-2.21c.28-.27.36-.66.25-1.01C8.7 6.45 8.5 5.25 8.5 4c0-.55-.45-1-1-1H4c-.55 0-1 .45-1 1 0 9.39 7.61 17 17 17 .55 0 1-.45 1-1v-3.5c0-.55-.45-1-1-1zM19 9v2h2V9h-2z"
            })), 'SettingsPhone');

            exports.default = _default;
            });

            unwrapExports$1(SettingsPhone);

            var SettingsPower = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M7 24h2v-2H7v2zm4 0h2v-2h-2v2zm2-22h-2v10h2V2zm3.56 2.44l-1.45 1.45C16.84 6.94 18 8.83 18 11c0 3.31-2.69 6-6 6s-6-2.69-6-6c0-2.17 1.16-4.06 2.88-5.12L7.44 4.44C5.36 5.88 4 8.28 4 11c0 4.42 3.58 8 8 8s8-3.58 8-8c0-2.72-1.36-5.12-3.44-6.56zM15 24h2v-2h-2v2z"
            })), 'SettingsPower');

            exports.default = _default;
            });

            unwrapExports$1(SettingsPower);

            var SettingsRemote = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M15 9H9c-.55 0-1 .45-1 1v12c0 .55.45 1 1 1h6c.55 0 1-.45 1-1V10c0-.55-.45-1-1-1zm-3 6c-1.1 0-2-.9-2-2s.9-2 2-2 2 .9 2 2-.9 2-2 2zM7.05 6.05l1.41 1.41C9.37 6.56 10.62 6 12 6s2.63.56 3.54 1.46l1.41-1.41C15.68 4.78 13.93 4 12 4s-3.68.78-4.95 2.05zM12 0C8.96 0 6.21 1.23 4.22 3.22l1.41 1.41C7.26 3.01 9.51 2 12 2s4.74 1.01 6.36 2.64l1.41-1.41C17.79 1.23 15.04 0 12 0z"
            })), 'SettingsRemote');

            exports.default = _default;
            });

            unwrapExports$1(SettingsRemote);

            var SettingsSystemDaydream = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M9 16h6.5c1.38 0 2.5-1.12 2.5-2.5S16.88 11 15.5 11h-.05c-.24-1.69-1.69-3-3.45-3-1.4 0-2.6.83-3.16 2.02h-.16C7.17 10.18 6 11.45 6 13c0 1.66 1.34 3 3 3zM21 3H3c-1.1 0-2 .9-2 2v14c0 1.1.9 2 2 2h18c1.1 0 2-.9 2-2V5c0-1.1-.9-2-2-2zm0 16.01H3V4.99h18v14.02z"
            })), 'SettingsSystemDaydream');

            exports.default = _default;
            });

            unwrapExports$1(SettingsSystemDaydream);

            var SettingsVoice = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M7 24h2v-2H7v2zm5-11c1.66 0 2.99-1.34 2.99-3L15 4c0-1.66-1.34-3-3-3S9 2.34 9 4v6c0 1.66 1.34 3 3 3zm-1 11h2v-2h-2v2zm4 0h2v-2h-2v2zm4-14h-1.7c0 3-2.54 5.1-5.3 5.1S6.7 13 6.7 10H5c0 3.41 2.72 6.23 6 6.72V20h2v-3.28c3.28-.49 6-3.31 6-6.72z"
            })), 'SettingsVoice');

            exports.default = _default;
            });

            unwrapExports$1(SettingsVoice);

            var Share = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M18 16.08c-.76 0-1.44.3-1.96.77L8.91 12.7c.05-.23.09-.46.09-.7s-.04-.47-.09-.7l7.05-4.11c.54.5 1.25.81 2.04.81 1.66 0 3-1.34 3-3s-1.34-3-3-3-3 1.34-3 3c0 .24.04.47.09.7L8.04 9.81C7.5 9.31 6.79 9 6 9c-1.66 0-3 1.34-3 3s1.34 3 3 3c.79 0 1.5-.31 2.04-.81l7.12 4.16c-.05.21-.08.43-.08.65 0 1.61 1.31 2.92 2.92 2.92 1.61 0 2.92-1.31 2.92-2.92s-1.31-2.92-2.92-2.92z"
            })), 'Share');

            exports.default = _default;
            });

            unwrapExports$1(Share);

            var Shop = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M16 6V4c0-1.11-.89-2-2-2h-4c-1.11 0-2 .89-2 2v2H2v13c0 1.11.89 2 2 2h16c1.11 0 2-.89 2-2V6h-6zm-6-2h4v2h-4V4zM9 18V9l7.5 4L9 18z"
            })), 'Shop');

            exports.default = _default;
            });

            unwrapExports$1(Shop);

            var ShoppingBasket = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M17.21 9l-4.38-6.56c-.19-.28-.51-.42-.83-.42-.32 0-.64.14-.83.43L6.79 9H2c-.55 0-1 .45-1 1 0 .09.01.18.04.27l2.54 9.27c.23.84 1 1.46 1.92 1.46h13c.92 0 1.69-.62 1.93-1.46l2.54-9.27L23 10c0-.55-.45-1-1-1h-4.79zM9 9l3-4.4L15 9H9zm3 8c-1.1 0-2-.9-2-2s.9-2 2-2 2 .9 2 2-.9 2-2 2z"
            })), 'ShoppingBasket');

            exports.default = _default;
            });

            unwrapExports$1(ShoppingBasket);

            var ShoppingCart = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M7 18c-1.1 0-1.99.9-1.99 2S5.9 22 7 22s2-.9 2-2-.9-2-2-2zM1 2v2h2l3.6 7.59-1.35 2.45c-.16.28-.25.61-.25.96 0 1.1.9 2 2 2h12v-2H7.42c-.14 0-.25-.11-.25-.25l.03-.12.9-1.63h7.45c.75 0 1.41-.41 1.75-1.03l3.58-6.49c.08-.14.12-.31.12-.48 0-.55-.45-1-1-1H5.21l-.94-2H1zm16 16c-1.1 0-1.99.9-1.99 2s.89 2 1.99 2 2-.9 2-2-.9-2-2-2z"
            })), 'ShoppingCart');

            exports.default = _default;
            });

            unwrapExports$1(ShoppingCart);

            var ShopTwo = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M3 9H1v11c0 1.11.89 2 2 2h14c1.11 0 2-.89 2-2H3V9zm15-4V3c0-1.11-.89-2-2-2h-4c-1.11 0-2 .89-2 2v2H5v11c0 1.11.89 2 2 2h14c1.11 0 2-.89 2-2V5h-5zm-6-2h4v2h-4V3zm0 12V8l5.5 3-5.5 4z"
            })), 'ShopTwo');

            exports.default = _default;
            });

            unwrapExports$1(ShopTwo);

            var ShortText = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M4 9h16v2H4zm0 4h10v2H4z"
            })), 'ShortText');

            exports.default = _default;
            });

            unwrapExports$1(ShortText);

            var ShowChart = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M3.5 18.49l6-6.01 4 4L22 6.92l-1.41-1.41-7.09 7.97-4-4L2 16.99z"
            })), 'ShowChart');

            exports.default = _default;
            });

            unwrapExports$1(ShowChart);

            var Shuffle = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M10.59 9.17L5.41 4 4 5.41l5.17 5.17 1.42-1.41zM14.5 4l2.04 2.04L4 18.59 5.41 20 17.96 7.46 20 9.5V4h-5.5zm.33 9.41l-1.41 1.41 3.13 3.13L14.5 20H20v-5.5l-2.04 2.04-3.13-3.13z"
            })), 'Shuffle');

            exports.default = _default;
            });

            unwrapExports$1(Shuffle);

            var SignalCellular0Bar = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              fillOpacity: ".3",
              d: "M2 22h20V2z"
            })), 'SignalCellular0Bar');

            exports.default = _default;
            });

            unwrapExports$1(SignalCellular0Bar);

            var SignalCellular1Bar = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              fillOpacity: ".3",
              d: "M2 22h20V2z"
            }), _react.default.createElement("path", {
              d: "M12 12L2 22h10z"
            })), 'SignalCellular1Bar');

            exports.default = _default;
            });

            unwrapExports$1(SignalCellular1Bar);

            var SignalCellular2Bar = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              fillOpacity: ".3",
              d: "M2 22h20V2z"
            }), _react.default.createElement("path", {
              d: "M14 10L2 22h12z"
            })), 'SignalCellular2Bar');

            exports.default = _default;
            });

            unwrapExports$1(SignalCellular2Bar);

            var SignalCellular3Bar = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              fillOpacity: ".3",
              d: "M2 22h20V2z"
            }), _react.default.createElement("path", {
              d: "M17 7L2 22h15z"
            })), 'SignalCellular3Bar');

            exports.default = _default;
            });

            unwrapExports$1(SignalCellular3Bar);

            var SignalCellular4Bar = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M2 22h20V2z"
            })), 'SignalCellular4Bar');

            exports.default = _default;
            });

            unwrapExports$1(SignalCellular4Bar);

            var SignalCellularConnectedNoInternet0Bar = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              fillOpacity: ".3",
              d: "M22 8V2L2 22h16V8z"
            }), _react.default.createElement("path", {
              d: "M20 22h2v-2h-2v2zm0-12v8h2v-8h-2z"
            })), 'SignalCellularConnectedNoInternet0Bar');

            exports.default = _default;
            });

            unwrapExports$1(SignalCellularConnectedNoInternet0Bar);

            var SignalCellularConnectedNoInternet1Bar = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              fillOpacity: ".3",
              d: "M22 8V2L2 22h16V8z"
            }), _react.default.createElement("path", {
              d: "M20 10v8h2v-8h-2zm-8 12V12L2 22h10zm8 0h2v-2h-2v2z"
            })), 'SignalCellularConnectedNoInternet1Bar');

            exports.default = _default;
            });

            unwrapExports$1(SignalCellularConnectedNoInternet1Bar);

            var SignalCellularConnectedNoInternet2Bar = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              fillOpacity: ".3",
              d: "M22 8V2L2 22h16V8z"
            }), _react.default.createElement("path", {
              d: "M14 22V10L2 22h12zm6-12v8h2v-8h-2zm0 12h2v-2h-2v2z"
            })), 'SignalCellularConnectedNoInternet2Bar');

            exports.default = _default;
            });

            unwrapExports$1(SignalCellularConnectedNoInternet2Bar);

            var SignalCellularConnectedNoInternet3Bar = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              fillOpacity: ".3",
              d: "M22 8V2L2 22h16V8z"
            }), _react.default.createElement("path", {
              d: "M17 22V7L2 22h15zm3-12v8h2v-8h-2zm0 12h2v-2h-2v2z"
            })), 'SignalCellularConnectedNoInternet3Bar');

            exports.default = _default;
            });

            unwrapExports$1(SignalCellularConnectedNoInternet3Bar);

            var SignalCellularConnectedNoInternet4Bar = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M20 18h2v-8h-2v8zm0 4h2v-2h-2v2zM2 22h16V8h4V2L2 22z"
            })), 'SignalCellularConnectedNoInternet4Bar');

            exports.default = _default;
            });

            unwrapExports$1(SignalCellularConnectedNoInternet4Bar);

            var SignalCellularNoSim = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M18.99 5c0-1.1-.89-2-1.99-2h-7L7.66 5.34 19 16.68 18.99 5zM3.65 3.88L2.38 5.15 5 7.77V19c0 1.1.9 2 2 2h10.01c.35 0 .67-.1.96-.26l1.88 1.88 1.27-1.27L3.65 3.88z"
            })), 'SignalCellularNoSim');

            exports.default = _default;
            });

            unwrapExports$1(SignalCellularNoSim);

            var SignalCellularNull = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M20 6.83V20H6.83L20 6.83M22 2L2 22h20V2z"
            })), 'SignalCellularNull');

            exports.default = _default;
            });

            unwrapExports$1(SignalCellularNull);

            var SignalCellularOff = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M21 1l-8.59 8.59L21 18.18V1zM4.77 4.5L3.5 5.77l6.36 6.36L1 21h17.73l2 2L22 21.73 4.77 4.5z"
            })), 'SignalCellularOff');

            exports.default = _default;
            });

            unwrapExports$1(SignalCellularOff);

            var SignalWifi0Bar = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              fillOpacity: ".3",
              d: "M12.01 21.49L23.64 7c-.45-.34-4.93-4-11.64-4C5.28 3 .81 6.66.36 7l11.63 14.49.01.01.01-.01z"
            })), 'SignalWifi0Bar');

            exports.default = _default;
            });

            unwrapExports$1(SignalWifi0Bar);

            var SignalWifi1Bar = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              fillOpacity: ".3",
              d: "M12.01 21.49L23.64 7c-.45-.34-4.93-4-11.64-4C5.28 3 .81 6.66.36 7l11.63 14.49.01.01.01-.01z"
            }), _react.default.createElement("path", {
              d: "M6.67 14.86L12 21.49v.01l.01-.01 5.33-6.63C17.06 14.65 15.03 13 12 13s-5.06 1.65-5.33 1.86z"
            })), 'SignalWifi1Bar');

            exports.default = _default;
            });

            unwrapExports$1(SignalWifi1Bar);

            var SignalWifi1BarLock = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M23 16v-1.5c0-1.4-1.1-2.5-2.5-2.5S18 13.1 18 14.5V16c-.5 0-1 .5-1 1v4c0 .5.5 1 1 1h5c.5 0 1-.5 1-1v-4c0-.5-.5-1-1-1zm-1 0h-3v-1.5c0-.8.7-1.5 1.5-1.5s1.5.7 1.5 1.5V16z"
            }), _react.default.createElement("path", {
              d: "M15.5 14.5c0-2.8 2.2-5 5-5 .4 0 .7 0 1 .1L23.6 7c-.4-.3-4.9-4-11.6-4C5.3 3 .8 6.7.4 7L12 21.5l3.5-4.3v-2.7z",
              opacity: ".3"
            }), _react.default.createElement("path", {
              d: "M6.7 14.9l5.3 6.6 3.5-4.3v-2.6c0-.2 0-.5.1-.7-.9-.5-2.2-.9-3.6-.9-3 0-5.1 1.7-5.3 1.9z"
            })), 'SignalWifi1BarLock');

            exports.default = _default;
            });

            unwrapExports$1(SignalWifi1BarLock);

            var SignalWifi2Bar = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              fillOpacity: ".3",
              d: "M12.01 21.49L23.64 7c-.45-.34-4.93-4-11.64-4C5.28 3 .81 6.66.36 7l11.63 14.49.01.01.01-.01z"
            }), _react.default.createElement("path", {
              d: "M4.79 12.52l7.2 8.98H12l.01-.01 7.2-8.98C18.85 12.24 16.1 10 12 10s-6.85 2.24-7.21 2.52z"
            })), 'SignalWifi2Bar');

            exports.default = _default;
            });

            unwrapExports$1(SignalWifi2Bar);

            var SignalWifi2BarLock = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M23 16v-1.5c0-1.4-1.1-2.5-2.5-2.5S18 13.1 18 14.5V16c-.5 0-1 .5-1 1v4c0 .5.5 1 1 1h5c.5 0 1-.5 1-1v-4c0-.5-.5-1-1-1zm-1 0h-3v-1.5c0-.8.7-1.5 1.5-1.5s1.5.7 1.5 1.5V16z"
            }), _react.default.createElement("path", {
              d: "M15.5 14.5c0-2.8 2.2-5 5-5 .4 0 .7 0 1 .1L23.6 7c-.4-.3-4.9-4-11.6-4C5.3 3 .8 6.7.4 7L12 21.5l3.5-4.3v-2.7z",
              opacity: ".3"
            }), _react.default.createElement("path", {
              d: "M4.8 12.5l7.2 9 3.5-4.4v-2.6c0-1.3.5-2.5 1.4-3.4C15.6 10.5 14 10 12 10c-4.1 0-6.8 2.2-7.2 2.5z"
            })), 'SignalWifi2BarLock');

            exports.default = _default;
            });

            unwrapExports$1(SignalWifi2BarLock);

            var SignalWifi3Bar = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              fillOpacity: ".3",
              d: "M12.01 21.49L23.64 7c-.45-.34-4.93-4-11.64-4C5.28 3 .81 6.66.36 7l11.63 14.49.01.01.01-.01z"
            }), _react.default.createElement("path", {
              d: "M3.53 10.95l8.46 10.54.01.01.01-.01 8.46-10.54C20.04 10.62 16.81 8 12 8c-4.81 0-8.04 2.62-8.47 2.95z"
            })), 'SignalWifi3Bar');

            exports.default = _default;
            });

            unwrapExports$1(SignalWifi3Bar);

            var SignalWifi3BarLock = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              opacity: ".3",
              d: "M12 3C5.3 3 .8 6.7.4 7l3.2 3.9L12 21.5l3.5-4.3v-2.6c0-2.2 1.4-4 3.3-4.7.3-.1.5-.2.8-.2.3-.1.6-.1.9-.1.4 0 .7 0 1 .1L23.6 7c-.4-.3-4.9-4-11.6-4z"
            }), _react.default.createElement("path", {
              d: "M23 16v-1.5c0-1.4-1.1-2.5-2.5-2.5S18 13.1 18 14.5V16c-.5 0-1 .5-1 1v4c0 .5.5 1 1 1h5c.5 0 1-.5 1-1v-4c0-.5-.5-1-1-1zm-1 0h-3v-1.5c0-.8.7-1.5 1.5-1.5s1.5.7 1.5 1.5V16zm-10 5.5l3.5-4.3v-2.6c0-2.2 1.4-4 3.3-4.7C17.3 9 14.9 8 12 8c-4.8 0-8 2.6-8.5 2.9"
            })), 'SignalWifi3BarLock');

            exports.default = _default;
            });

            unwrapExports$1(SignalWifi3BarLock);

            var SignalWifi4Bar = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M12.01 21.49L23.64 7c-.45-.34-4.93-4-11.64-4C5.28 3 .81 6.66.36 7l11.63 14.49.01.01.01-.01z"
            })), 'SignalWifi4Bar');

            exports.default = _default;
            });

            unwrapExports$1(SignalWifi4Bar);

            var SignalWifi4BarLock = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M23 16v-1.5c0-1.4-1.1-2.5-2.5-2.5S18 13.1 18 14.5V16c-.5 0-1 .5-1 1v4c0 .5.5 1 1 1h5c.5 0 1-.5 1-1v-4c0-.5-.5-1-1-1zm-1 0h-3v-1.5c0-.8.7-1.5 1.5-1.5s1.5.7 1.5 1.5V16zm-6.5-1.5c0-2.8 2.2-5 5-5 .4 0 .7 0 1 .1L23.6 7c-.4-.3-4.9-4-11.6-4C5.3 3 .8 6.7.4 7L12 21.5l3.5-4.4v-2.6z"
            })), 'SignalWifi4BarLock');

            exports.default = _default;
            });

            unwrapExports$1(SignalWifi4BarLock);

            var SignalWifiOff = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M23.64 7c-.45-.34-4.93-4-11.64-4-1.5 0-2.89.19-4.15.48L18.18 13.8 23.64 7zm-6.6 8.22L3.27 1.44 2 2.72l2.05 2.06C1.91 5.76.59 6.82.36 7l11.63 14.49.01.01.01-.01 3.9-4.86 3.32 3.32 1.27-1.27-3.46-3.46z"
            })), 'SignalWifiOff');

            exports.default = _default;
            });

            unwrapExports$1(SignalWifiOff);

            var SimCard = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M19.99 4c0-1.1-.89-2-1.99-2h-8L4 8v12c0 1.1.9 2 2 2h12.01c1.1 0 1.99-.9 1.99-2l-.01-16zM9 19H7v-2h2v2zm8 0h-2v-2h2v2zm-8-4H7v-4h2v4zm4 4h-2v-4h2v4zm0-6h-2v-2h2v2zm4 2h-2v-4h2v4z"
            })), 'SimCard');

            exports.default = _default;
            });

            unwrapExports$1(SimCard);

            var SimCardAlert = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M18 2h-8L4.02 8 4 20c0 1.1.9 2 2 2h12c1.1 0 2-.9 2-2V4c0-1.1-.9-2-2-2zm-5 15h-2v-2h2v2zm0-4h-2V8h2v5z"
            })), 'SimCardAlert');

            exports.default = _default;
            });

            unwrapExports$1(SimCardAlert);

            var SkipNext = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M6 18l8.5-6L6 6v12zM16 6v12h2V6h-2z"
            })), 'SkipNext');

            exports.default = _default;
            });

            unwrapExports$1(SkipNext);

            var SkipPrevious = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M6 6h2v12H6zm3.5 6l8.5 6V6z"
            })), 'SkipPrevious');

            exports.default = _default;
            });

            unwrapExports$1(SkipPrevious);

            var Slideshow = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M10 8v8l5-4-5-4zm9-5H5c-1.1 0-2 .9-2 2v14c0 1.1.9 2 2 2h14c1.1 0 2-.9 2-2V5c0-1.1-.9-2-2-2zm0 16H5V5h14v14z"
            })), 'Slideshow');

            exports.default = _default;
            });

            unwrapExports$1(Slideshow);

            var SlowMotionVideo = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M13.05 9.79L10 7.5v9l3.05-2.29L16 12zm0 0L10 7.5v9l3.05-2.29L16 12zm0 0L10 7.5v9l3.05-2.29L16 12zM11 4.07V2.05c-2.01.2-3.84 1-5.32 2.21L7.1 5.69c1.11-.86 2.44-1.44 3.9-1.62zM5.69 7.1L4.26 5.68C3.05 7.16 2.25 8.99 2.05 11h2.02c.18-1.46.76-2.79 1.62-3.9zM4.07 13H2.05c.2 2.01 1 3.84 2.21 5.32l1.43-1.43c-.86-1.1-1.44-2.43-1.62-3.89zm1.61 6.74C7.16 20.95 9 21.75 11 21.95v-2.02c-1.46-.18-2.79-.76-3.9-1.62l-1.42 1.43zM22 12c0 5.16-3.92 9.42-8.95 9.95v-2.02C16.97 19.41 20 16.05 20 12s-3.03-7.41-6.95-7.93V2.05C18.08 2.58 22 6.84 22 12z"
            })), 'SlowMotionVideo');

            exports.default = _default;
            });

            unwrapExports$1(SlowMotionVideo);

            var Smartphone = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M17 1.01L7 1c-1.1 0-2 .9-2 2v18c0 1.1.9 2 2 2h10c1.1 0 2-.9 2-2V3c0-1.1-.9-1.99-2-1.99zM17 19H7V5h10v14z"
            })), 'Smartphone');

            exports.default = _default;
            });

            unwrapExports$1(Smartphone);

            var SmokeFree = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M2 6l6.99 7H2v3h9.99l7 7 1.26-1.25-17-17zm18.5 7H22v3h-1.5zM18 13h1.5v3H18zm.85-8.12c.62-.61 1-1.45 1-2.38h-1.5c0 1.02-.83 1.85-1.85 1.85v1.5c2.24 0 4 1.83 4 4.07V12H22V9.92c0-2.23-1.28-4.15-3.15-5.04zM14.5 8.7h1.53c1.05 0 1.97.74 1.97 2.05V12h1.5v-1.59c0-1.8-1.6-3.16-3.47-3.16H14.5c-1.02 0-1.85-.98-1.85-2s.83-1.75 1.85-1.75V2c-1.85 0-3.35 1.5-3.35 3.35s1.5 3.35 3.35 3.35zm2.5 7.23V13h-2.93z"
            })), 'SmokeFree');

            exports.default = _default;
            });

            unwrapExports$1(SmokeFree);

            var SmokingRooms = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M2 16h15v3H2zm18.5 0H22v3h-1.5zM18 16h1.5v3H18zm.85-8.27c.62-.61 1-1.45 1-2.38C19.85 3.5 18.35 2 16.5 2v1.5c1.02 0 1.85.83 1.85 1.85S17.52 7.2 16.5 7.2v1.5c2.24 0 4 1.83 4 4.07V15H22v-2.24c0-2.22-1.28-4.14-3.15-5.03zm-2.82 2.47H14.5c-1.02 0-1.85-.98-1.85-2s.83-1.75 1.85-1.75v-1.5c-1.85 0-3.35 1.5-3.35 3.35s1.5 3.35 3.35 3.35h1.53c1.05 0 1.97.74 1.97 2.05V15h1.5v-1.64c0-1.81-1.6-3.16-3.47-3.16z"
            })), 'SmokingRooms');

            exports.default = _default;
            });

            unwrapExports$1(SmokingRooms);

            var Sms = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M20 2H4c-1.1 0-1.99.9-1.99 2L2 22l4-4h14c1.1 0 2-.9 2-2V4c0-1.1-.9-2-2-2zM9 11H7V9h2v2zm4 0h-2V9h2v2zm4 0h-2V9h2v2z"
            })), 'Sms');

            exports.default = _default;
            });

            unwrapExports$1(Sms);

            var SmsFailed = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M20 2H4c-1.1 0-1.99.9-1.99 2L2 22l4-4h14c1.1 0 2-.9 2-2V4c0-1.1-.9-2-2-2zm-7 12h-2v-2h2v2zm0-4h-2V6h2v4z"
            })), 'SmsFailed');

            exports.default = _default;
            });

            unwrapExports$1(SmsFailed);

            var Snooze = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M7.88 3.39L6.6 1.86 2 5.71l1.29 1.53 4.59-3.85zM22 5.72l-4.6-3.86-1.29 1.53 4.6 3.86L22 5.72zM12 4c-4.97 0-9 4.03-9 9s4.02 9 9 9c4.97 0 9-4.03 9-9s-4.03-9-9-9zm0 16c-3.87 0-7-3.13-7-7s3.13-7 7-7 7 3.13 7 7-3.13 7-7 7zm-3-9h3.63L9 15.2V17h6v-2h-3.63L15 10.8V9H9v2z"
            })), 'Snooze');

            exports.default = _default;
            });

            unwrapExports$1(Snooze);

            var Sort = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M3 18h6v-2H3v2zM3 6v2h18V6H3zm0 7h12v-2H3v2z"
            })), 'Sort');

            exports.default = _default;
            });

            unwrapExports$1(Sort);

            var SortByAlpha = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M14.94 4.66h-4.72l2.36-2.36zm-4.69 14.71h4.66l-2.33 2.33zM6.1 6.27L1.6 17.73h1.84l.92-2.45h5.11l.92 2.45h1.84L7.74 6.27H6.1zm-1.13 7.37l1.94-5.18 1.94 5.18H4.97zm10.76 2.5h6.12v1.59h-8.53v-1.29l5.92-8.56h-5.88v-1.6h8.3v1.26l-5.93 8.6z"
            })), 'SortByAlpha');

            exports.default = _default;
            });

            unwrapExports$1(SortByAlpha);

            var Spa = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M8.55 12c-1.07-.71-2.25-1.27-3.53-1.61 1.28.34 2.46.9 3.53 1.61zm10.43-1.61c-1.29.34-2.49.91-3.57 1.64 1.08-.73 2.28-1.3 3.57-1.64z"
            }), _react.default.createElement("path", {
              d: "M15.49 9.63c-.18-2.79-1.31-5.51-3.43-7.63-2.14 2.14-3.32 4.86-3.55 7.63 1.28.68 2.46 1.56 3.49 2.63 1.03-1.06 2.21-1.94 3.49-2.63zm-6.5 2.65c-.14-.1-.3-.19-.45-.29.15.11.31.19.45.29zm6.42-.25c-.13.09-.27.16-.4.26.13-.1.27-.17.4-.26zM12 15.45C9.85 12.17 6.18 10 2 10c0 5.32 3.36 9.82 8.03 11.49.63.23 1.29.4 1.97.51.68-.12 1.33-.29 1.97-.51C18.64 19.82 22 15.32 22 10c-4.18 0-7.85 2.17-10 5.45z"
            })), 'Spa');

            exports.default = _default;
            });

            unwrapExports$1(Spa);

            var SpaceBar = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M18 9v4H6V9H4v6h16V9z"
            })), 'SpaceBar');

            exports.default = _default;
            });

            unwrapExports$1(SpaceBar);

            var Speaker = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M17 2H7c-1.1 0-2 .9-2 2v16c0 1.1.9 1.99 2 1.99L17 22c1.1 0 2-.9 2-2V4c0-1.1-.9-2-2-2zm-5 2c1.1 0 2 .9 2 2s-.9 2-2 2c-1.11 0-2-.9-2-2s.89-2 2-2zm0 16c-2.76 0-5-2.24-5-5s2.24-5 5-5 5 2.24 5 5-2.24 5-5 5zm0-8c-1.66 0-3 1.34-3 3s1.34 3 3 3 3-1.34 3-3-1.34-3-3-3z"
            })), 'Speaker');

            exports.default = _default;
            });

            unwrapExports$1(Speaker);

            var SpeakerGroup = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M18.2 1H9.8C8.81 1 8 1.81 8 2.8v14.4c0 .99.81 1.79 1.8 1.79l8.4.01c.99 0 1.8-.81 1.8-1.8V2.8c0-.99-.81-1.8-1.8-1.8zM14 3c1.1 0 2 .89 2 2s-.9 2-2 2-2-.89-2-2 .9-2 2-2zm0 13.5c-2.21 0-4-1.79-4-4s1.79-4 4-4 4 1.79 4 4-1.79 4-4 4z"
            }), _react.default.createElement("circle", {
              cx: "14",
              cy: "12.5",
              r: "2.5"
            }), _react.default.createElement("path", {
              d: "M6 5H4v16c0 1.1.89 2 2 2h10v-2H6V5z"
            })), 'SpeakerGroup');

            exports.default = _default;
            });

            unwrapExports$1(SpeakerGroup);

            var SpeakerNotes = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M20 2H4c-1.1 0-1.99.9-1.99 2L2 22l4-4h14c1.1 0 2-.9 2-2V4c0-1.1-.9-2-2-2zM8 14H6v-2h2v2zm0-3H6V9h2v2zm0-3H6V6h2v2zm7 6h-5v-2h5v2zm3-3h-8V9h8v2zm0-3h-8V6h8v2z"
            })), 'SpeakerNotes');

            exports.default = _default;
            });

            unwrapExports$1(SpeakerNotes);

            var SpeakerNotesOff = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M10.54 11l-.54-.54L7.54 8 6 6.46 2.38 2.84 1.27 1.73 0 3l2.01 2.01L2 22l4-4h9l5.73 5.73L22 22.46 17.54 18l-7-7zM8 14H6v-2h2v2zm-2-3V9l2 2H6zm14-9H4.08L10 7.92V6h8v2h-7.92l1 1H18v2h-4.92l6.99 6.99C21.14 17.95 22 17.08 22 16V4c0-1.1-.9-2-2-2z"
            })), 'SpeakerNotesOff');

            exports.default = _default;
            });

            unwrapExports$1(SpeakerNotesOff);

            var SpeakerPhone = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M7 7.07L8.43 8.5c.91-.91 2.18-1.48 3.57-1.48s2.66.57 3.57 1.48L17 7.07C15.72 5.79 13.95 5 12 5s-3.72.79-5 2.07zM12 1C8.98 1 6.24 2.23 4.25 4.21l1.41 1.41C7.28 4 9.53 3 12 3s4.72 1 6.34 2.62l1.41-1.41C17.76 2.23 15.02 1 12 1zm2.86 9.01L9.14 10C8.51 10 8 10.51 8 11.14v9.71c0 .63.51 1.14 1.14 1.14h5.71c.63 0 1.14-.51 1.14-1.14v-9.71c.01-.63-.5-1.13-1.13-1.13zM15 20H9v-8h6v8z"
            })), 'SpeakerPhone');

            exports.default = _default;
            });

            unwrapExports$1(SpeakerPhone);

            var Spellcheck = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M12.45 16h2.09L9.43 3H7.57L2.46 16h2.09l1.12-3h5.64l1.14 3zm-6.02-5L8.5 5.48 10.57 11H6.43zm15.16.59l-8.09 8.09L9.83 16l-1.41 1.41 5.09 5.09L23 13l-1.41-1.41z"
            })), 'Spellcheck');

            exports.default = _default;
            });

            unwrapExports$1(Spellcheck);

            var Star = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M12 17.27L18.18 21l-1.64-7.03L22 9.24l-7.19-.61L12 2 9.19 8.63 2 9.24l5.46 4.73L5.82 21z"
            })), 'Star');

            exports.default = _default;
            });

            unwrapExports$1(Star);

            var StarBorder = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M22 9.24l-7.19-.62L12 2 9.19 8.63 2 9.24l5.46 4.73L5.82 21 12 17.27 18.18 21l-1.63-7.03L22 9.24zM12 15.4l-3.76 2.27 1-4.28-3.32-2.88 4.38-.38L12 6.1l1.71 4.04 4.38.38-3.32 2.88 1 4.28L12 15.4z"
            })), 'StarBorder');

            exports.default = _default;
            });

            unwrapExports$1(StarBorder);

            var StarHalf = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M22 9.24l-7.19-.62L12 2 9.19 8.63 2 9.24l5.46 4.73L5.82 21 12 17.27 18.18 21l-1.63-7.03L22 9.24zM12 15.4V6.1l1.71 4.04 4.38.38-3.32 2.88 1 4.28L12 15.4z"
            })), 'StarHalf');

            exports.default = _default;
            });

            unwrapExports$1(StarHalf);

            var Stars = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M11.99 2C6.47 2 2 6.48 2 12s4.47 10 9.99 10C17.52 22 22 17.52 22 12S17.52 2 11.99 2zm4.24 16L12 15.45 7.77 18l1.12-4.81-3.73-3.23 4.92-.42L12 5l1.92 4.53 4.92.42-3.73 3.23L16.23 18z"
            })), 'Stars');

            exports.default = _default;
            });

            unwrapExports$1(Stars);

            var StayCurrentLandscape = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M1.01 7L1 17c0 1.1.9 2 2 2h18c1.1 0 2-.9 2-2V7c0-1.1-.9-2-2-2H3c-1.1 0-1.99.9-1.99 2zM19 7v10H5V7h14z"
            })), 'StayCurrentLandscape');

            exports.default = _default;
            });

            unwrapExports$1(StayCurrentLandscape);

            var StayCurrentPortrait = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M17 1.01L7 1c-1.1 0-1.99.9-1.99 2v18c0 1.1.89 2 1.99 2h10c1.1 0 2-.9 2-2V3c0-1.1-.9-1.99-2-1.99zM17 19H7V5h10v14z"
            })), 'StayCurrentPortrait');

            exports.default = _default;
            });

            unwrapExports$1(StayCurrentPortrait);

            var StayPrimaryLandscape = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M1.01 7L1 17c0 1.1.9 2 2 2h18c1.1 0 2-.9 2-2V7c0-1.1-.9-2-2-2H3c-1.1 0-1.99.9-1.99 2zM19 7v10H5V7h14z"
            })), 'StayPrimaryLandscape');

            exports.default = _default;
            });

            unwrapExports$1(StayPrimaryLandscape);

            var StayPrimaryPortrait = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M17 1.01L7 1c-1.1 0-1.99.9-1.99 2v18c0 1.1.89 2 1.99 2h10c1.1 0 2-.9 2-2V3c0-1.1-.9-1.99-2-1.99zM17 19H7V5h10v14z"
            })), 'StayPrimaryPortrait');

            exports.default = _default;
            });

            unwrapExports$1(StayPrimaryPortrait);

            var Stop = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M6 6h12v12H6z"
            })), 'Stop');

            exports.default = _default;
            });

            unwrapExports$1(Stop);

            var StopScreenShare = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M21.22 18.02l2 2H24v-2h-2.78zm.77-2l.01-10c0-1.11-.9-2-2-2H7.22l5.23 5.23c.18-.04.36-.07.55-.1V7.02l4 3.73-1.58 1.47 5.54 5.54c.61-.33 1.03-.99 1.03-1.74zM2.39 1.73L1.11 3l1.54 1.54c-.4.36-.65.89-.65 1.48v10c0 1.1.89 2 2 2H0v2h18.13l2.71 2.71 1.27-1.27L2.39 1.73zM7 15.02c.31-1.48.92-2.95 2.07-4.06l1.59 1.59c-1.54.38-2.7 1.18-3.66 2.47z"
            })), 'StopScreenShare');

            exports.default = _default;
            });

            unwrapExports$1(StopScreenShare);

            var Storage = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M2 20h20v-4H2v4zm2-3h2v2H4v-2zM2 4v4h20V4H2zm4 3H4V5h2v2zm-4 7h20v-4H2v4zm2-3h2v2H4v-2z"
            })), 'Storage');

            exports.default = _default;
            });

            unwrapExports$1(Storage);

            var Store = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M20 4H4v2h16V4zm1 10v-2l-1-5H4l-1 5v2h1v6h10v-6h4v6h2v-6h1zm-9 4H6v-4h6v4z"
            })), 'Store');

            exports.default = _default;
            });

            unwrapExports$1(Store);

            var StoreMallDirectory = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M20 4H4v2h16V4zm1 10v-2l-1-5H4l-1 5v2h1v6h10v-6h4v6h2v-6h1zm-9 4H6v-4h6v4z"
            })), 'StoreMallDirectory');

            exports.default = _default;
            });

            unwrapExports$1(StoreMallDirectory);

            var Straighten = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M21 6H3c-1.1 0-2 .9-2 2v8c0 1.1.9 2 2 2h18c1.1 0 2-.9 2-2V8c0-1.1-.9-2-2-2zm0 10H3V8h2v4h2V8h2v4h2V8h2v4h2V8h2v4h2V8h2v8z"
            })), 'Straighten');

            exports.default = _default;
            });

            unwrapExports$1(Straighten);

            var Streetview = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M12.56 14.33c-.34.27-.56.7-.56 1.17V21h7c1.1 0 2-.9 2-2v-5.98c-.94-.33-1.95-.52-3-.52-2.03 0-3.93.7-5.44 1.83z"
            }), _react.default.createElement("circle", {
              cx: "18",
              cy: "6",
              r: "5"
            }), _react.default.createElement("path", {
              d: "M11.5 6c0-1.08.27-2.1.74-3H5c-1.1 0-2 .9-2 2v14c0 .55.23 1.05.59 1.41l9.82-9.82C12.23 9.42 11.5 7.8 11.5 6z"
            })), 'Streetview');

            exports.default = _default;
            });

            unwrapExports$1(Streetview);

            var StrikethroughS = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M7.24 8.75c-.26-.48-.39-1.03-.39-1.67 0-.61.13-1.16.4-1.67.26-.5.63-.93 1.11-1.29.48-.35 1.05-.63 1.7-.83.66-.19 1.39-.29 2.18-.29.81 0 1.54.11 2.21.34.66.22 1.23.54 1.69.94.47.4.83.88 1.08 1.43.25.55.38 1.15.38 1.81h-3.01c0-.31-.05-.59-.15-.85-.09-.27-.24-.49-.44-.68-.2-.19-.45-.33-.75-.44-.3-.1-.66-.16-1.06-.16-.39 0-.74.04-1.03.13-.29.09-.53.21-.72.36-.19.16-.34.34-.44.55-.1.21-.15.43-.15.66 0 .48.25.88.74 1.21.38.25.77.48 1.41.7H7.39c-.05-.08-.11-.17-.15-.25zM21 12v-2H3v2h9.62c.18.07.4.14.55.2.37.17.66.34.87.51.21.17.35.36.43.57.07.2.11.43.11.69 0 .23-.05.45-.14.66-.09.2-.23.38-.42.53-.19.15-.42.26-.71.35-.29.08-.63.13-1.01.13-.43 0-.83-.04-1.18-.13s-.66-.23-.91-.42c-.25-.19-.45-.44-.59-.75-.14-.31-.25-.76-.25-1.21H6.4c0 .55.08 1.13.24 1.58.16.45.37.85.65 1.21.28.35.6.66.98.92.37.26.78.48 1.22.65.44.17.9.3 1.38.39.48.08.96.13 1.44.13.8 0 1.53-.09 2.18-.28s1.21-.45 1.67-.79c.46-.34.82-.77 1.07-1.27s.38-1.07.38-1.71c0-.6-.1-1.14-.31-1.61-.05-.11-.11-.23-.17-.33H21z"
            })), 'StrikethroughS');

            exports.default = _default;
            });

            unwrapExports$1(StrikethroughS);

            var Style = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M2.53 19.65l1.34.56v-9.03l-2.43 5.86c-.41 1.02.08 2.19 1.09 2.61zm19.5-3.7L17.07 3.98c-.31-.75-1.04-1.21-1.81-1.23-.26 0-.53.04-.79.15L7.1 5.95c-.75.31-1.21 1.03-1.23 1.8-.01.27.04.54.15.8l4.96 11.97c.31.76 1.05 1.22 1.83 1.23.26 0 .52-.05.77-.15l7.36-3.05c1.02-.42 1.51-1.59 1.09-2.6zM7.88 8.75c-.55 0-1-.45-1-1s.45-1 1-1 1 .45 1 1-.45 1-1 1zm-2 11c0 1.1.9 2 2 2h1.45l-3.45-8.34v6.34z"
            })), 'Style');

            exports.default = _default;
            });

            unwrapExports$1(Style);

            var SubdirectoryArrowLeft = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M11 9l1.42 1.42L8.83 14H18V4h2v12H8.83l3.59 3.58L11 21l-6-6 6-6z"
            })), 'SubdirectoryArrowLeft');

            exports.default = _default;
            });

            unwrapExports$1(SubdirectoryArrowLeft);

            var SubdirectoryArrowRight = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M19 15l-6 6-1.42-1.42L15.17 16H4V4h2v10h9.17l-3.59-3.58L13 9l6 6z"
            })), 'SubdirectoryArrowRight');

            exports.default = _default;
            });

            unwrapExports$1(SubdirectoryArrowRight);

            var Subject = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M14 17H4v2h10v-2zm6-8H4v2h16V9zM4 15h16v-2H4v2zM4 5v2h16V5H4z"
            })), 'Subject');

            exports.default = _default;
            });

            unwrapExports$1(Subject);

            var Subscriptions = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M20 8H4V6h16v2zm-2-6H6v2h12V2zm4 10v8c0 1.1-.9 2-2 2H4c-1.1 0-2-.9-2-2v-8c0-1.1.9-2 2-2h16c1.1 0 2 .9 2 2zm-6 4l-6-3.27v6.53L16 16z"
            })), 'Subscriptions');

            exports.default = _default;
            });

            unwrapExports$1(Subscriptions);

            var Subtitles = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M20 4H4c-1.1 0-2 .9-2 2v12c0 1.1.9 2 2 2h16c1.1 0 2-.9 2-2V6c0-1.1-.9-2-2-2zM4 12h4v2H4v-2zm10 6H4v-2h10v2zm6 0h-4v-2h4v2zm0-4H10v-2h10v2z"
            })), 'Subtitles');

            exports.default = _default;
            });

            unwrapExports$1(Subtitles);

            var Subway = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("circle", {
              cx: "15.5",
              cy: "16",
              r: "1"
            }), _react.default.createElement("circle", {
              cx: "8.5",
              cy: "16",
              r: "1"
            }), _react.default.createElement("path", {
              d: "M7.01 9h10v5h-10zM17.8 2.8C16 2.09 13.86 2 12 2c-1.86 0-4 .09-5.8.8C3.53 3.84 2 6.05 2 8.86V22h20V8.86c0-2.81-1.53-5.02-4.2-6.06zm.2 13.08c0 1.45-1.18 2.62-2.63 2.62l1.13 1.12V20H15l-1.5-1.5h-2.83L9.17 20H7.5v-.38l1.12-1.12C7.18 18.5 6 17.32 6 15.88V9c0-2.63 3-3 6-3 3.32 0 6 .38 6 3v6.88z"
            })), 'Subway');

            exports.default = _default;
            });

            unwrapExports$1(Subway);

            var SupervisorAccount = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M16.5 12c1.38 0 2.49-1.12 2.49-2.5S17.88 7 16.5 7C15.12 7 14 8.12 14 9.5s1.12 2.5 2.5 2.5zM9 11c1.66 0 2.99-1.34 2.99-3S10.66 5 9 5C7.34 5 6 6.34 6 8s1.34 3 3 3zm7.5 3c-1.83 0-5.5.92-5.5 2.75V19h11v-2.25c0-1.83-3.67-2.75-5.5-2.75zM9 13c-2.33 0-7 1.17-7 3.5V19h7v-2.25c0-.85.33-2.34 2.37-3.47C10.5 13.1 9.66 13 9 13z"
            })), 'SupervisorAccount');

            exports.default = _default;
            });

            unwrapExports$1(SupervisorAccount);

            var SurroundSound = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M20 4H4c-1.1 0-2 .9-2 2v12c0 1.1.9 2 2 2h16c1.1 0 2-.9 2-2V6c0-1.1-.9-2-2-2zM7.76 16.24l-1.41 1.41C4.78 16.1 4 14.05 4 12c0-2.05.78-4.1 2.34-5.66l1.41 1.41C6.59 8.93 6 10.46 6 12s.59 3.07 1.76 4.24zM12 16c-2.21 0-4-1.79-4-4s1.79-4 4-4 4 1.79 4 4-1.79 4-4 4zm5.66 1.66l-1.41-1.41C17.41 15.07 18 13.54 18 12s-.59-3.07-1.76-4.24l1.41-1.41C19.22 7.9 20 9.95 20 12c0 2.05-.78 4.1-2.34 5.66zM12 10c-1.1 0-2 .9-2 2s.9 2 2 2 2-.9 2-2-.9-2-2-2z"
            })), 'SurroundSound');

            exports.default = _default;
            });

            unwrapExports$1(SurroundSound);

            var SwapCalls = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M18 4l-4 4h3v7c0 1.1-.9 2-2 2s-2-.9-2-2V8c0-2.21-1.79-4-4-4S5 5.79 5 8v7H2l4 4 4-4H7V8c0-1.1.9-2 2-2s2 .9 2 2v7c0 2.21 1.79 4 4 4s4-1.79 4-4V8h3l-4-4z"
            })), 'SwapCalls');

            exports.default = _default;
            });

            unwrapExports$1(SwapCalls);

            var SwapHoriz = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M6.99 11L3 15l3.99 4v-3H14v-2H6.99v-3zM21 9l-3.99-4v3H10v2h7.01v3L21 9z"
            })), 'SwapHoriz');

            exports.default = _default;
            });

            unwrapExports$1(SwapHoriz);

            var SwapVert = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M16 17.01V10h-2v7.01h-3L15 21l4-3.99h-3zM9 3L5 6.99h3V14h2V6.99h3L9 3z"
            })), 'SwapVert');

            exports.default = _default;
            });

            unwrapExports$1(SwapVert);

            var SwapVerticalCircle = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M12 2C6.48 2 2 6.48 2 12s4.48 10 10 10 10-4.48 10-10S17.52 2 12 2zM6.5 9L10 5.5 13.5 9H11v4H9V9H6.5zm11 6L14 18.5 10.5 15H13v-4h2v4h2.5z"
            })), 'SwapVerticalCircle');

            exports.default = _default;
            });

            unwrapExports$1(SwapVerticalCircle);

            var SwitchCamera = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M20 4h-3.17L15 2H9L7.17 4H4c-1.1 0-2 .9-2 2v12c0 1.1.9 2 2 2h16c1.1 0 2-.9 2-2V6c0-1.1-.9-2-2-2zm-5 11.5V13H9v2.5L5.5 12 9 8.5V11h6V8.5l3.5 3.5-3.5 3.5z"
            })), 'SwitchCamera');

            exports.default = _default;
            });

            unwrapExports$1(SwitchCamera);

            var SwitchVideo = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M18 9.5V6c0-.55-.45-1-1-1H3c-.55 0-1 .45-1 1v12c0 .55.45 1 1 1h14c.55 0 1-.45 1-1v-3.5l4 4v-13l-4 4zm-5 6V13H7v2.5L3.5 12 7 8.5V11h6V8.5l3.5 3.5-3.5 3.5z"
            })), 'SwitchVideo');

            exports.default = _default;
            });

            unwrapExports$1(SwitchVideo);

            var Sync = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M12 4V1L8 5l4 4V6c3.31 0 6 2.69 6 6 0 1.01-.25 1.97-.7 2.8l1.46 1.46C19.54 15.03 20 13.57 20 12c0-4.42-3.58-8-8-8zm0 14c-3.31 0-6-2.69-6-6 0-1.01.25-1.97.7-2.8L5.24 7.74C4.46 8.97 4 10.43 4 12c0 4.42 3.58 8 8 8v3l4-4-4-4v3z"
            })), 'Sync');

            exports.default = _default;
            });

            unwrapExports$1(Sync);

            var SyncDisabled = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M10 6.35V4.26c-.8.21-1.55.54-2.23.96l1.46 1.46c.25-.12.5-.24.77-.33zm-7.14-.94l2.36 2.36C4.45 8.99 4 10.44 4 12c0 2.21.91 4.2 2.36 5.64L4 20h6v-6l-2.24 2.24C6.68 15.15 6 13.66 6 12c0-1 .25-1.94.68-2.77l8.08 8.08c-.25.13-.5.25-.77.34v2.09c.8-.21 1.55-.54 2.23-.96l2.36 2.36 1.27-1.27L4.14 4.14 2.86 5.41zM20 4h-6v6l2.24-2.24C17.32 8.85 18 10.34 18 12c0 1-.25 1.94-.68 2.77l1.46 1.46C19.55 15.01 20 13.56 20 12c0-2.21-.91-4.2-2.36-5.64L20 4z"
            })), 'SyncDisabled');

            exports.default = _default;
            });

            unwrapExports$1(SyncDisabled);

            var SyncProblem = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M3 12c0 2.21.91 4.2 2.36 5.64L3 20h6v-6l-2.24 2.24C5.68 15.15 5 13.66 5 12c0-2.61 1.67-4.83 4-5.65V4.26C5.55 5.15 3 8.27 3 12zm8 5h2v-2h-2v2zM21 4h-6v6l2.24-2.24C18.32 8.85 19 10.34 19 12c0 2.61-1.67 4.83-4 5.65v2.09c3.45-.89 6-4.01 6-7.74 0-2.21-.91-4.2-2.36-5.64L21 4zm-10 9h2V7h-2v6z"
            })), 'SyncProblem');

            exports.default = _default;
            });

            unwrapExports$1(SyncProblem);

            var SystemUpdate = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M17 1.01L7 1c-1.1 0-2 .9-2 2v18c0 1.1.9 2 2 2h10c1.1 0 2-.9 2-2V3c0-1.1-.9-1.99-2-1.99zM17 19H7V5h10v14zm-1-6h-3V8h-2v5H8l4 4 4-4z"
            })), 'SystemUpdate');

            exports.default = _default;
            });

            unwrapExports$1(SystemUpdate);

            var SystemUpdateAlt = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M12 16.5l4-4h-3v-9h-2v9H8l4 4zm9-13h-6v1.99h6v14.03H3V5.49h6V3.5H3c-1.1 0-2 .9-2 2v14c0 1.1.9 2 2 2h18c1.1 0 2-.9 2-2v-14c0-1.1-.9-2-2-2z"
            })), 'SystemUpdateAlt');

            exports.default = _default;
            });

            unwrapExports$1(SystemUpdateAlt);

            var Tab = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M21 3H3c-1.1 0-2 .9-2 2v14c0 1.1.9 2 2 2h18c1.1 0 2-.9 2-2V5c0-1.1-.9-2-2-2zm0 16H3V5h10v4h8v10z"
            })), 'Tab');

            exports.default = _default;
            });

            unwrapExports$1(Tab);

            var Tablet = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M21 4H3c-1.1 0-2 .9-2 2v12c0 1.1.9 2 2 2h18c1.1 0 1.99-.9 1.99-2L23 6c0-1.1-.9-2-2-2zm-2 14H5V6h14v12z"
            })), 'Tablet');

            exports.default = _default;
            });

            unwrapExports$1(Tablet);

            var TabletAndroid = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M18 0H6C4.34 0 3 1.34 3 3v18c0 1.66 1.34 3 3 3h12c1.66 0 3-1.34 3-3V3c0-1.66-1.34-3-3-3zm-4 22h-4v-1h4v1zm5.25-3H4.75V3h14.5v16z"
            })), 'TabletAndroid');

            exports.default = _default;
            });

            unwrapExports$1(TabletAndroid);

            var TabletMac = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M18.5 0h-14C3.12 0 2 1.12 2 2.5v19C2 22.88 3.12 24 4.5 24h14c1.38 0 2.5-1.12 2.5-2.5v-19C21 1.12 19.88 0 18.5 0zm-7 23c-.83 0-1.5-.67-1.5-1.5s.67-1.5 1.5-1.5 1.5.67 1.5 1.5-.67 1.5-1.5 1.5zm7.5-4H4V3h15v16z"
            })), 'TabletMac');

            exports.default = _default;
            });

            unwrapExports$1(TabletMac);

            var TabUnselected = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M1 9h2V7H1v2zm0 4h2v-2H1v2zm0-8h2V3c-1.1 0-2 .9-2 2zm8 16h2v-2H9v2zm-8-4h2v-2H1v2zm2 4v-2H1c0 1.1.9 2 2 2zM21 3h-8v6h10V5c0-1.1-.9-2-2-2zm0 14h2v-2h-2v2zM9 5h2V3H9v2zM5 21h2v-2H5v2zM5 5h2V3H5v2zm16 16c1.1 0 2-.9 2-2h-2v2zm0-8h2v-2h-2v2zm-8 8h2v-2h-2v2zm4 0h2v-2h-2v2z"
            })), 'TabUnselected');

            exports.default = _default;
            });

            unwrapExports$1(TabUnselected);

            var TagFaces = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M11.99 2C6.47 2 2 6.48 2 12s4.47 10 9.99 10C17.52 22 22 17.52 22 12S17.52 2 11.99 2zM12 20c-4.42 0-8-3.58-8-8s3.58-8 8-8 8 3.58 8 8-3.58 8-8 8zm3.5-9c.83 0 1.5-.67 1.5-1.5S16.33 8 15.5 8 14 8.67 14 9.5s.67 1.5 1.5 1.5zm-7 0c.83 0 1.5-.67 1.5-1.5S9.33 8 8.5 8 7 8.67 7 9.5 7.67 11 8.5 11zm3.5 6.5c2.33 0 4.31-1.46 5.11-3.5H6.89c.8 2.04 2.78 3.5 5.11 3.5z"
            })), 'TagFaces');

            exports.default = _default;
            });

            unwrapExports$1(TagFaces);

            var TapAndPlay = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M2 16v2c2.76 0 5 2.24 5 5h2c0-3.87-3.13-7-7-7zm0 4v3h3c0-1.66-1.34-3-3-3zm0-8v2c4.97 0 9 4.03 9 9h2c0-6.08-4.92-11-11-11zM17 1.01L7 1c-1.1 0-2 .9-2 2v7.37c.69.16 1.36.37 2 .64V5h10v13h-3.03c.52 1.25.84 2.59.95 4H17c1.1 0 2-.9 2-2V3c0-1.1-.9-1.99-2-1.99z"
            })), 'TapAndPlay');

            exports.default = _default;
            });

            unwrapExports$1(TapAndPlay);

            var Terrain = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M14 6l-3.75 5 2.85 3.8-1.6 1.2C9.81 13.75 7 10 7 10l-6 8h22L14 6z"
            })), 'Terrain');

            exports.default = _default;
            });

            unwrapExports$1(Terrain);

            var TextFields = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M2.5 4v3h5v12h3V7h5V4h-13zm19 5h-9v3h3v7h3v-7h3V9z"
            })), 'TextFields');

            exports.default = _default;
            });

            unwrapExports$1(TextFields);

            var TextFormat = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M5 17v2h14v-2H5zm4.5-4.2h5l.9 2.2h2.1L12.75 4h-1.5L6.5 15h2.1l.9-2.2zM12 5.98L13.87 11h-3.74L12 5.98z"
            })), 'TextFormat');

            exports.default = _default;
            });

            unwrapExports$1(TextFormat);

            var Textsms = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M20 2H4c-1.1 0-1.99.9-1.99 2L2 22l4-4h14c1.1 0 2-.9 2-2V4c0-1.1-.9-2-2-2zM9 11H7V9h2v2zm4 0h-2V9h2v2zm4 0h-2V9h2v2z"
            })), 'Textsms');

            exports.default = _default;
            });

            unwrapExports$1(Textsms);

            var Texture = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M19.51 3.08L3.08 19.51c.09.34.27.65.51.9.25.24.56.42.9.51L20.93 4.49c-.19-.69-.73-1.23-1.42-1.41zM11.88 3L3 11.88v2.83L14.71 3h-2.83zM5 3c-1.1 0-2 .9-2 2v2l4-4H5zm14 18c.55 0 1.05-.22 1.41-.59.37-.36.59-.86.59-1.41v-2l-4 4h2zm-9.71 0h2.83L21 12.12V9.29L9.29 21z"
            })), 'Texture');

            exports.default = _default;
            });

            unwrapExports$1(Texture);

            var Theaters = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M18 3v2h-2V3H8v2H6V3H4v18h2v-2h2v2h8v-2h2v2h2V3h-2zM8 17H6v-2h2v2zm0-4H6v-2h2v2zm0-4H6V7h2v2zm10 8h-2v-2h2v2zm0-4h-2v-2h2v2zm0-4h-2V7h2v2z"
            })), 'Theaters');

            exports.default = _default;
            });

            unwrapExports$1(Theaters);

            var ThreeDRotation = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M7.52 21.48C4.25 19.94 1.91 16.76 1.55 13H.05C.56 19.16 5.71 24 12 24l.66-.03-3.81-3.81-1.33 1.32zm.89-6.52c-.19 0-.37-.03-.52-.08-.16-.06-.29-.13-.4-.24-.11-.1-.2-.22-.26-.37-.06-.14-.09-.3-.09-.47h-1.3c0 .36.07.68.21.95.14.27.33.5.56.69.24.18.51.32.82.41.3.1.62.15.96.15.37 0 .72-.05 1.03-.15.32-.1.6-.25.83-.44s.42-.43.55-.72c.13-.29.2-.61.2-.97 0-.19-.02-.38-.07-.56-.05-.18-.12-.35-.23-.51-.1-.16-.24-.3-.4-.43-.17-.13-.37-.23-.61-.31.2-.09.37-.2.52-.33.15-.13.27-.27.37-.42.1-.15.17-.3.22-.46.05-.16.07-.32.07-.48 0-.36-.06-.68-.18-.96-.12-.28-.29-.51-.51-.69-.2-.19-.47-.33-.77-.43C9.1 8.05 8.76 8 8.39 8c-.36 0-.69.05-1 .16-.3.11-.57.26-.79.45-.21.19-.38.41-.51.67-.12.26-.18.54-.18.85h1.3c0-.17.03-.32.09-.45s.14-.25.25-.34c.11-.09.23-.17.38-.22.15-.05.3-.08.48-.08.4 0 .7.1.89.31.19.2.29.49.29.86 0 .18-.03.34-.08.49-.05.15-.14.27-.25.37-.11.1-.25.18-.41.24-.16.06-.36.09-.58.09H7.5v1.03h.77c.22 0 .42.02.6.07s.33.13.45.23c.12.11.22.24.29.4.07.16.1.35.1.57 0 .41-.12.72-.35.93-.23.23-.55.33-.95.33zm8.55-5.92c-.32-.33-.7-.59-1.14-.77-.43-.18-.92-.27-1.46-.27H12v8h2.3c.55 0 1.06-.09 1.51-.27.45-.18.84-.43 1.16-.76.32-.33.57-.73.74-1.19.17-.47.26-.99.26-1.57v-.4c0-.58-.09-1.1-.26-1.57-.18-.47-.43-.87-.75-1.2zm-.39 3.16c0 .42-.05.79-.14 1.13-.1.33-.24.62-.43.85-.19.23-.43.41-.71.53-.29.12-.62.18-.99.18h-.91V9.12h.97c.72 0 1.27.23 1.64.69.38.46.57 1.12.57 1.99v.4zM12 0l-.66.03 3.81 3.81 1.33-1.33c3.27 1.55 5.61 4.72 5.96 8.48h1.5C23.44 4.84 18.29 0 12 0z"
            })), 'ThreeDRotation');

            exports.default = _default;
            });

            unwrapExports$1(ThreeDRotation);

            var ThumbDown = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M15 3H6c-.83 0-1.54.5-1.84 1.22l-3.02 7.05c-.09.23-.14.47-.14.73v1.91l.01.01L1 14c0 1.1.9 2 2 2h6.31l-.95 4.57-.03.32c0 .41.17.79.44 1.06L9.83 23l6.59-6.59c.36-.36.58-.86.58-1.41V5c0-1.1-.9-2-2-2zm4 0v12h4V3h-4z"
            })), 'ThumbDown');

            exports.default = _default;
            });

            unwrapExports$1(ThumbDown);

            var ThumbsUpDown = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M12 6c0-.55-.45-1-1-1H5.82l.66-3.18.02-.23c0-.31-.13-.59-.33-.8L5.38 0 .44 4.94C.17 5.21 0 5.59 0 6v6.5c0 .83.67 1.5 1.5 1.5h6.75c.62 0 1.15-.38 1.38-.91l2.26-5.29c.07-.17.11-.36.11-.55V6zm10.5 4h-6.75c-.62 0-1.15.38-1.38.91l-2.26 5.29c-.07.17-.11.36-.11.55V18c0 .55.45 1 1 1h5.18l-.66 3.18-.02.24c0 .31.13.59.33.8l.79.78 4.94-4.94c.27-.27.44-.65.44-1.06v-6.5c0-.83-.67-1.5-1.5-1.5z"
            })), 'ThumbsUpDown');

            exports.default = _default;
            });

            unwrapExports$1(ThumbsUpDown);

            var ThumbUp = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M1 21h4V9H1v12zm22-11c0-1.1-.9-2-2-2h-6.31l.95-4.57.03-.32c0-.41-.17-.79-.44-1.06L14.17 1 7.59 7.59C7.22 7.95 7 8.45 7 9v10c0 1.1.9 2 2 2h9c.83 0 1.54-.5 1.84-1.22l3.02-7.05c.09-.23.14-.47.14-.73v-1.91l-.01-.01L23 10z"
            })), 'ThumbUp');

            exports.default = _default;
            });

            unwrapExports$1(ThumbUp);

            var Timelapse = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M16.24 7.76C15.07 6.59 13.54 6 12 6v6l-4.24 4.24c2.34 2.34 6.14 2.34 8.49 0 2.34-2.34 2.34-6.14-.01-8.48zM12 2C6.48 2 2 6.48 2 12s4.48 10 10 10 10-4.48 10-10S17.52 2 12 2zm0 18c-4.42 0-8-3.58-8-8s3.58-8 8-8 8 3.58 8 8-3.58 8-8 8z"
            })), 'Timelapse');

            exports.default = _default;
            });

            unwrapExports$1(Timelapse);

            var Timeline = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M23 8c0 1.1-.9 2-2 2-.18 0-.35-.02-.51-.07l-3.56 3.55c.05.16.07.34.07.52 0 1.1-.9 2-2 2s-2-.9-2-2c0-.18.02-.36.07-.52l-2.55-2.55c-.16.05-.34.07-.52.07s-.36-.02-.52-.07l-4.55 4.56c.05.16.07.33.07.51 0 1.1-.9 2-2 2s-2-.9-2-2 .9-2 2-2c.18 0 .35.02.51.07l4.56-4.55C8.02 9.36 8 9.18 8 9c0-1.1.9-2 2-2s2 .9 2 2c0 .18-.02.36-.07.52l2.55 2.55c.16-.05.34-.07.52-.07s.36.02.52.07l3.55-3.56C19.02 8.35 19 8.18 19 8c0-1.1.9-2 2-2s2 .9 2 2z"
            })), 'Timeline');

            exports.default = _default;
            });

            unwrapExports$1(Timeline);

            var Timer = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M15 1H9v2h6V1zm-4 13h2V8h-2v6zm8.03-6.61l1.42-1.42c-.43-.51-.9-.99-1.41-1.41l-1.42 1.42C16.07 4.74 14.12 4 12 4c-4.97 0-9 4.03-9 9s4.02 9 9 9 9-4.03 9-9c0-2.12-.74-4.07-1.97-5.61zM12 20c-3.87 0-7-3.13-7-7s3.13-7 7-7 7 3.13 7 7-3.13 7-7 7z"
            })), 'Timer');

            exports.default = _default;
            });

            unwrapExports$1(Timer);

            var Timer10 = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M0 7.72V9.4l3-1V18h2V6h-.25L0 7.72zm23.78 6.65c-.14-.28-.35-.53-.63-.74-.28-.21-.61-.39-1.01-.53s-.85-.27-1.35-.38c-.35-.07-.64-.15-.87-.23-.23-.08-.41-.16-.55-.25-.14-.09-.23-.19-.28-.3-.05-.11-.08-.24-.08-.39 0-.14.03-.28.09-.41.06-.13.15-.25.27-.34.12-.1.27-.18.45-.24s.4-.09.64-.09c.25 0 .47.04.66.11.19.07.35.17.48.29.13.12.22.26.29.42.06.16.1.32.1.49h1.95c0-.39-.08-.75-.24-1.09-.16-.34-.39-.63-.69-.88-.3-.25-.66-.44-1.09-.59C21.49 9.07 21 9 20.46 9c-.51 0-.98.07-1.39.21-.41.14-.77.33-1.06.57-.29.24-.51.52-.67.84-.16.32-.23.65-.23 1.01s.08.69.23.96c.15.28.36.52.64.73.27.21.6.38.98.53.38.14.81.26 1.27.36.39.08.71.17.95.26s.43.19.57.29c.13.1.22.22.27.34.05.12.07.25.07.39 0 .32-.13.57-.4.77-.27.2-.66.29-1.17.29-.22 0-.43-.02-.64-.08-.21-.05-.4-.13-.56-.24-.17-.11-.3-.26-.41-.44-.11-.18-.17-.41-.18-.67h-1.89c0 .36.08.71.24 1.05.16.34.39.65.7.93.31.27.69.49 1.15.66.46.17.98.25 1.58.25.53 0 1.01-.06 1.44-.19.43-.13.8-.31 1.11-.54.31-.23.54-.51.71-.83.17-.32.25-.67.25-1.06-.02-.4-.09-.74-.24-1.02zm-9.96-7.32c-.34-.4-.75-.7-1.23-.88-.47-.18-1.01-.27-1.59-.27-.58 0-1.11.09-1.59.27-.48.18-.89.47-1.23.88-.34.41-.6.93-.79 1.59-.18.65-.28 1.45-.28 2.39v1.92c0 .94.09 1.74.28 2.39.19.66.45 1.19.8 1.6.34.41.75.71 1.23.89.48.18 1.01.28 1.59.28.59 0 1.12-.09 1.59-.28.48-.18.88-.48 1.22-.89.34-.41.6-.94.78-1.6.18-.65.28-1.45.28-2.39v-1.92c0-.94-.09-1.74-.28-2.39-.18-.66-.44-1.19-.78-1.59zm-.92 6.17c0 .6-.04 1.11-.12 1.53-.08.42-.2.76-.36 1.02-.16.26-.36.45-.59.57-.23.12-.51.18-.82.18-.3 0-.58-.06-.82-.18s-.44-.31-.6-.57c-.16-.26-.29-.6-.38-1.02-.09-.42-.13-.93-.13-1.53v-2.5c0-.6.04-1.11.13-1.52.09-.41.21-.74.38-1 .16-.25.36-.43.6-.55.24-.11.51-.17.81-.17.31 0 .58.06.81.17.24.11.44.29.6.55.16.25.29.58.37.99.08.41.13.92.13 1.52v2.51z"
            })), 'Timer10');

            exports.default = _default;
            });

            unwrapExports$1(Timer10);

            var Timer3 = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M11.61 12.97c-.16-.24-.36-.46-.62-.65-.25-.19-.56-.35-.93-.48.3-.14.57-.3.8-.5.23-.2.42-.41.57-.64.15-.23.27-.46.34-.71.08-.24.11-.49.11-.73 0-.55-.09-1.04-.28-1.46-.18-.42-.44-.77-.78-1.06-.33-.28-.73-.5-1.2-.64-.45-.13-.97-.2-1.53-.2-.55 0-1.06.08-1.52.24-.47.17-.87.4-1.2.69-.33.29-.6.63-.78 1.03-.2.39-.29.83-.29 1.29h1.98c0-.26.05-.49.14-.69.09-.2.22-.38.38-.52.17-.14.36-.25.58-.33.22-.08.46-.12.73-.12.61 0 1.06.16 1.36.47.3.31.44.75.44 1.32 0 .27-.04.52-.12.74-.08.22-.21.41-.38.57-.17.16-.38.28-.63.37-.25.09-.55.13-.89.13H6.72v1.57H7.9c.34 0 .64.04.91.11.27.08.5.19.69.35.19.16.34.36.44.61.1.24.16.54.16.87 0 .62-.18 1.09-.53 1.42-.35.33-.84.49-1.45.49-.29 0-.56-.04-.8-.13-.24-.08-.44-.2-.61-.36-.17-.16-.3-.34-.39-.56-.09-.22-.14-.46-.14-.72H4.19c0 .55.11 1.03.32 1.45.21.42.5.77.86 1.05s.77.49 1.24.63.96.21 1.48.21c.57 0 1.09-.08 1.58-.23.49-.15.91-.38 1.26-.68.36-.3.64-.66.84-1.1.2-.43.3-.93.3-1.48 0-.29-.04-.58-.11-.86-.08-.25-.19-.51-.35-.76zm9.26 1.4c-.14-.28-.35-.53-.63-.74-.28-.21-.61-.39-1.01-.53s-.85-.27-1.35-.38c-.35-.07-.64-.15-.87-.23-.23-.08-.41-.16-.55-.25-.14-.09-.23-.19-.28-.3-.05-.11-.08-.24-.08-.39s.03-.28.09-.41c.06-.13.15-.25.27-.34.12-.1.27-.18.45-.24s.4-.09.64-.09c.25 0 .47.04.66.11.19.07.35.17.48.29.13.12.22.26.29.42.06.16.1.32.1.49h1.95c0-.39-.08-.75-.24-1.09-.16-.34-.39-.63-.69-.88-.3-.25-.66-.44-1.09-.59-.43-.15-.92-.22-1.46-.22-.51 0-.98.07-1.39.21-.41.14-.77.33-1.06.57-.29.24-.51.52-.67.84-.16.32-.23.65-.23 1.01s.08.68.23.96c.15.28.37.52.64.73.27.21.6.38.98.53.38.14.81.26 1.27.36.39.08.71.17.95.26s.43.19.57.29c.13.1.22.22.27.34.05.12.07.25.07.39 0 .32-.13.57-.4.77-.27.2-.66.29-1.17.29-.22 0-.43-.02-.64-.08-.21-.05-.4-.13-.56-.24-.17-.11-.3-.26-.41-.44-.11-.18-.17-.41-.18-.67h-1.89c0 .36.08.71.24 1.05.16.34.39.65.7.93.31.27.69.49 1.15.66.46.17.98.25 1.58.25.53 0 1.01-.06 1.44-.19.43-.13.8-.31 1.11-.54.31-.23.54-.51.71-.83.17-.32.25-.67.25-1.06-.02-.4-.09-.74-.24-1.02z"
            })), 'Timer3');

            exports.default = _default;
            });

            unwrapExports$1(Timer3);

            var TimerOff = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M19.04 4.55l-1.42 1.42C16.07 4.74 14.12 4 12 4c-1.83 0-3.53.55-4.95 1.48l1.46 1.46C9.53 6.35 10.73 6 12 6c3.87 0 7 3.13 7 7 0 1.27-.35 2.47-.94 3.49l1.45 1.45C20.45 16.53 21 14.83 21 13c0-2.12-.74-4.07-1.97-5.61l1.42-1.42-1.41-1.42zM15 1H9v2h6V1zm-4 8.44l2 2V8h-2v1.44zM3.02 4L1.75 5.27 4.5 8.03C3.55 9.45 3 11.16 3 13c0 4.97 4.02 9 9 9 1.84 0 3.55-.55 4.98-1.5l2.5 2.5 1.27-1.27-7.71-7.71L3.02 4zM12 20c-3.87 0-7-3.13-7-7 0-1.28.35-2.48.95-3.52l9.56 9.56c-1.03.61-2.23.96-3.51.96z"
            })), 'TimerOff');

            exports.default = _default;
            });

            unwrapExports$1(TimerOff);

            var TimeToLeave = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M18.92 5.01C18.72 4.42 18.16 4 17.5 4h-11c-.66 0-1.21.42-1.42 1.01L3 11v8c0 .55.45 1 1 1h1c.55 0 1-.45 1-1v-1h12v1c0 .55.45 1 1 1h1c.55 0 1-.45 1-1v-8l-2.08-5.99zM6.5 15c-.83 0-1.5-.67-1.5-1.5S5.67 12 6.5 12s1.5.67 1.5 1.5S7.33 15 6.5 15zm11 0c-.83 0-1.5-.67-1.5-1.5s.67-1.5 1.5-1.5 1.5.67 1.5 1.5-.67 1.5-1.5 1.5zM5 10l1.5-4.5h11L19 10H5z"
            })), 'TimeToLeave');

            exports.default = _default;
            });

            unwrapExports$1(TimeToLeave);

            var Title = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M5 4v3h5.5v12h3V7H19V4z"
            })), 'Title');

            exports.default = _default;
            });

            unwrapExports$1(Title);

            var Toc = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M3 9h14V7H3v2zm0 4h14v-2H3v2zm0 4h14v-2H3v2zm16 0h2v-2h-2v2zm0-10v2h2V7h-2zm0 6h2v-2h-2v2z"
            })), 'Toc');

            exports.default = _default;
            });

            unwrapExports$1(Toc);

            var Today = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M19 3h-1V1h-2v2H8V1H6v2H5c-1.11 0-1.99.9-1.99 2L3 19c0 1.1.89 2 2 2h14c1.1 0 2-.9 2-2V5c0-1.1-.9-2-2-2zm0 16H5V8h14v11zM7 10h5v5H7z"
            })), 'Today');

            exports.default = _default;
            });

            unwrapExports$1(Today);

            var Toll = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M15 4c-4.42 0-8 3.58-8 8s3.58 8 8 8 8-3.58 8-8-3.58-8-8-8zm0 14c-3.31 0-6-2.69-6-6s2.69-6 6-6 6 2.69 6 6-2.69 6-6 6zM3 12c0-2.61 1.67-4.83 4-5.65V4.26C3.55 5.15 1 8.27 1 12s2.55 6.85 6 7.74v-2.09c-2.33-.82-4-3.04-4-5.65z"
            })), 'Toll');

            exports.default = _default;
            });

            unwrapExports$1(Toll);

            var Tonality = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M12 2C6.48 2 2 6.48 2 12s4.48 10 10 10 10-4.48 10-10S17.52 2 12 2zm-1 17.93c-3.94-.49-7-3.85-7-7.93s3.05-7.44 7-7.93v15.86zm2-15.86c1.03.13 2 .45 2.87.93H13v-.93zM13 7h5.24c.25.31.48.65.68 1H13V7zm0 3h6.74c.08.33.15.66.19 1H13v-1zm0 9.93V19h2.87c-.87.48-1.84.8-2.87.93zM18.24 17H13v-1h5.92c-.2.35-.43.69-.68 1zm1.5-3H13v-1h6.93c-.04.34-.11.67-.19 1z"
            })), 'Tonality');

            exports.default = _default;
            });

            unwrapExports$1(Tonality);

            var TouchApp = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M9 11.24V7.5C9 6.12 10.12 5 11.5 5S14 6.12 14 7.5v3.74c1.21-.81 2-2.18 2-3.74C16 5.01 13.99 3 11.5 3S7 5.01 7 7.5c0 1.56.79 2.93 2 3.74zm9.84 4.63l-4.54-2.26c-.17-.07-.35-.11-.54-.11H13v-6c0-.83-.67-1.5-1.5-1.5S10 6.67 10 7.5v10.74l-3.43-.72c-.08-.01-.15-.03-.24-.03-.31 0-.59.13-.79.33l-.79.8 4.94 4.94c.27.27.65.44 1.06.44h6.79c.75 0 1.33-.55 1.44-1.28l.75-5.27c.01-.07.02-.14.02-.2 0-.62-.38-1.16-.91-1.38z"
            })), 'TouchApp');

            exports.default = _default;
            });

            unwrapExports$1(TouchApp);

            var Toys = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M12 12c0-3 2.5-5.5 5.5-5.5S23 9 23 12H12zm0 0c0 3-2.5 5.5-5.5 5.5S1 15 1 12h11zm0 0c-3 0-5.5-2.5-5.5-5.5S9 1 12 1v11zm0 0c3 0 5.5 2.5 5.5 5.5S15 23 12 23V12z"
            })), 'Toys');

            exports.default = _default;
            });

            unwrapExports$1(Toys);

            var TrackChanges = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M19.07 4.93l-1.41 1.41C19.1 7.79 20 9.79 20 12c0 4.42-3.58 8-8 8s-8-3.58-8-8c0-4.08 3.05-7.44 7-7.93v2.02C8.16 6.57 6 9.03 6 12c0 3.31 2.69 6 6 6s6-2.69 6-6c0-1.66-.67-3.16-1.76-4.24l-1.41 1.41C15.55 9.9 16 10.9 16 12c0 2.21-1.79 4-4 4s-4-1.79-4-4c0-1.86 1.28-3.41 3-3.86v2.14c-.6.35-1 .98-1 1.72 0 1.1.9 2 2 2s2-.9 2-2c0-.74-.4-1.38-1-1.72V2h-1C6.48 2 2 6.48 2 12s4.48 10 10 10 10-4.48 10-10c0-2.76-1.12-5.26-2.93-7.07z"
            })), 'TrackChanges');

            exports.default = _default;
            });

            unwrapExports$1(TrackChanges);

            var Traffic = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M20 10h-3V8.86c1.72-.45 3-2 3-3.86h-3V4c0-.55-.45-1-1-1H8c-.55 0-1 .45-1 1v1H4c0 1.86 1.28 3.41 3 3.86V10H4c0 1.86 1.28 3.41 3 3.86V15H4c0 1.86 1.28 3.41 3 3.86V20c0 .55.45 1 1 1h8c.55 0 1-.45 1-1v-1.14c1.72-.45 3-2 3-3.86h-3v-1.14c1.72-.45 3-2 3-3.86zm-8 9c-1.11 0-2-.9-2-2s.89-2 2-2c1.1 0 2 .9 2 2s-.89 2-2 2zm0-5c-1.11 0-2-.9-2-2s.89-2 2-2c1.1 0 2 .9 2 2s-.89 2-2 2zm0-5c-1.11 0-2-.9-2-2 0-1.11.89-2 2-2 1.1 0 2 .89 2 2 0 1.1-.89 2-2 2z"
            })), 'Traffic');

            exports.default = _default;
            });

            unwrapExports$1(Traffic);

            var Train = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M12 2c-4 0-8 .5-8 4v9.5C4 17.43 5.57 19 7.5 19L6 20.5v.5h2.23l2-2H14l2 2h2v-.5L16.5 19c1.93 0 3.5-1.57 3.5-3.5V6c0-3.5-3.58-4-8-4zM7.5 17c-.83 0-1.5-.67-1.5-1.5S6.67 14 7.5 14s1.5.67 1.5 1.5S8.33 17 7.5 17zm3.5-7H6V6h5v4zm2 0V6h5v4h-5zm3.5 7c-.83 0-1.5-.67-1.5-1.5s.67-1.5 1.5-1.5 1.5.67 1.5 1.5-.67 1.5-1.5 1.5z"
            })), 'Train');

            exports.default = _default;
            });

            unwrapExports$1(Train);

            var Tram = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M19 16.94V8.5c0-2.79-2.61-3.4-6.01-3.49l.76-1.51H17V2H7v1.5h4.75l-.76 1.52C7.86 5.11 5 5.73 5 8.5v8.44c0 1.45 1.19 2.66 2.59 2.97L6 21.5v.5h2.23l2-2H14l2 2h2v-.5L16.5 20h-.08c1.69 0 2.58-1.37 2.58-3.06zm-7 1.56c-.83 0-1.5-.67-1.5-1.5s.67-1.5 1.5-1.5 1.5.67 1.5 1.5-.67 1.5-1.5 1.5zm5-4.5H7V9h10v5z"
            })), 'Tram');

            exports.default = _default;
            });

            unwrapExports$1(Tram);

            var TransferWithinAStation = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M16.49 15.5v-1.75L14 16.25l2.49 2.5V17H22v-1.5zm3.02 4.25H14v1.5h5.51V23L22 20.5 19.51 18zM9.5 5.5c1.1 0 2-.9 2-2s-.9-2-2-2-2 .9-2 2 .9 2 2 2zM5.75 8.9L3 23h2.1l1.75-8L9 17v6h2v-7.55L8.95 13.4l.6-3C10.85 12 12.8 13 15 13v-2c-1.85 0-3.45-1-4.35-2.45l-.95-1.6C9.35 6.35 8.7 6 8 6c-.25 0-.5.05-.75.15L2 8.3V13h2V9.65l1.75-.75"
            })), 'TransferWithinAStation');

            exports.default = _default;
            });

            unwrapExports$1(TransferWithinAStation);

            var Transform$1 = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M22 18v-2H8V4h2L7 1 4 4h2v2H2v2h4v8c0 1.1.9 2 2 2h8v2h-2l3 3 3-3h-2v-2h4zM10 8h6v6h2V8c0-1.1-.9-2-2-2h-6v2z"
            })), 'Transform');

            exports.default = _default;
            });

            unwrapExports$1(Transform$1);

            var Translate = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M12.87 15.07l-2.54-2.51.03-.03c1.74-1.94 2.98-4.17 3.71-6.53H17V4h-7V2H8v2H1v1.99h11.17C11.5 7.92 10.44 9.75 9 11.35 8.07 10.32 7.3 9.19 6.69 8h-2c.73 1.63 1.73 3.17 2.98 4.56l-5.09 5.02L4 19l5-5 3.11 3.11.76-2.04zM18.5 10h-2L12 22h2l1.12-3h4.75L21 22h2l-4.5-12zm-2.62 7l1.62-4.33L19.12 17h-3.24z"
            })), 'Translate');

            exports.default = _default;
            });

            unwrapExports$1(Translate);

            var TrendingDown = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M16 18l2.29-2.29-4.88-4.88-4 4L2 7.41 3.41 6l6 6 4-4 6.3 6.29L22 12v6z"
            })), 'TrendingDown');

            exports.default = _default;
            });

            unwrapExports$1(TrendingDown);

            var TrendingFlat = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M22 12l-4-4v3H3v2h15v3z"
            })), 'TrendingFlat');

            exports.default = _default;
            });

            unwrapExports$1(TrendingFlat);

            var TrendingUp = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M16 6l2.29 2.29-4.88 4.88-4-4L2 16.59 3.41 18l6-6 4 4 6.3-6.29L22 12V6z"
            })), 'TrendingUp');

            exports.default = _default;
            });

            unwrapExports$1(TrendingUp);

            var Tune = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M3 17v2h6v-2H3zM3 5v2h10V5H3zm10 16v-2h8v-2h-8v-2h-2v6h2zM7 9v2H3v2h4v2h2V9H7zm14 4v-2H11v2h10zm-6-4h2V7h4V5h-4V3h-2v6z"
            })), 'Tune');

            exports.default = _default;
            });

            unwrapExports$1(Tune);

            var TurnedIn = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M17 3H7c-1.1 0-1.99.9-1.99 2L5 21l7-3 7 3V5c0-1.1-.9-2-2-2z"
            })), 'TurnedIn');

            exports.default = _default;
            });

            unwrapExports$1(TurnedIn);

            var TurnedInNot = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M17 3H7c-1.1 0-1.99.9-1.99 2L5 21l7-3 7 3V5c0-1.1-.9-2-2-2zm0 15l-5-2.18L7 18V5h10v13z"
            })), 'TurnedInNot');

            exports.default = _default;
            });

            unwrapExports$1(TurnedInNot);

            var Tv = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M21 3H3c-1.1 0-2 .9-2 2v12c0 1.1.9 2 2 2h5v2h8v-2h5c1.1 0 1.99-.9 1.99-2L23 5c0-1.1-.9-2-2-2zm0 14H3V5h18v12z"
            })), 'Tv');

            exports.default = _default;
            });

            unwrapExports$1(Tv);

            var Unarchive = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M20.55 5.22l-1.39-1.68C18.88 3.21 18.47 3 18 3H6c-.47 0-.88.21-1.15.55L3.46 5.22C3.17 5.57 3 6.01 3 6.5V19c0 1.1.89 2 2 2h14c1.1 0 2-.9 2-2V6.5c0-.49-.17-.93-.45-1.28zM12 9.5l5.5 5.5H14v2h-4v-2H6.5L12 9.5zM5.12 5l.82-1h12l.93 1H5.12z"
            })), 'Unarchive');

            exports.default = _default;
            });

            unwrapExports$1(Unarchive);

            var Undo = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M12.5 8c-2.65 0-5.05.99-6.9 2.6L2 7v9h9l-3.62-3.62c1.39-1.16 3.16-1.88 5.12-1.88 3.54 0 6.55 2.31 7.6 5.5l2.37-.78C21.08 11.03 17.15 8 12.5 8z"
            })), 'Undo');

            exports.default = _default;
            });

            unwrapExports$1(Undo);

            var UnfoldLess = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M7.41 18.59L8.83 20 12 16.83 15.17 20l1.41-1.41L12 14l-4.59 4.59zm9.18-13.18L15.17 4 12 7.17 8.83 4 7.41 5.41 12 10l4.59-4.59z"
            })), 'UnfoldLess');

            exports.default = _default;
            });

            unwrapExports$1(UnfoldLess);

            var UnfoldMore = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M12 5.83L15.17 9l1.41-1.41L12 3 7.41 7.59 8.83 9 12 5.83zm0 12.34L8.83 15l-1.41 1.41L12 21l4.59-4.59L15.17 15 12 18.17z"
            })), 'UnfoldMore');

            exports.default = _default;
            });

            unwrapExports$1(UnfoldMore);

            var Update = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M21 10.12h-6.78l2.74-2.82c-2.73-2.7-7.15-2.8-9.88-.1-2.73 2.71-2.73 7.08 0 9.79 2.73 2.71 7.15 2.71 9.88 0C18.32 15.65 19 14.08 19 12.1h2c0 1.98-.88 4.55-2.64 6.29-3.51 3.48-9.21 3.48-12.72 0-3.5-3.47-3.53-9.11-.02-12.58 3.51-3.47 9.14-3.47 12.65 0L21 3v7.12zM12.5 8v4.25l3.5 2.08-.72 1.21L11 13V8h1.5z"
            })), 'Update');

            exports.default = _default;
            });

            unwrapExports$1(Update);

            var Usb = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M15 7v4h1v2h-3V5h2l-3-4-3 4h2v8H8v-2.07c.7-.37 1.2-1.08 1.2-1.93 0-1.21-.99-2.2-2.2-2.2-1.21 0-2.2.99-2.2 2.2 0 .85.5 1.56 1.2 1.93V13c0 1.11.89 2 2 2h3v3.05c-.71.37-1.2 1.1-1.2 1.95 0 1.22.99 2.2 2.2 2.2 1.21 0 2.2-.98 2.2-2.2 0-.85-.49-1.58-1.2-1.95V15h3c1.11 0 2-.89 2-2v-2h1V7h-4z"
            })), 'Usb');

            exports.default = _default;
            });

            unwrapExports$1(Usb);

            var VerifiedUser = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M12 1L3 5v6c0 5.55 3.84 10.74 9 12 5.16-1.26 9-6.45 9-12V5l-9-4zm-2 16l-4-4 1.41-1.41L10 14.17l6.59-6.59L18 9l-8 8z"
            })), 'VerifiedUser');

            exports.default = _default;
            });

            unwrapExports$1(VerifiedUser);

            var VerticalAlignBottom = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M16 13h-3V3h-2v10H8l4 4 4-4zM4 19v2h16v-2H4z"
            })), 'VerticalAlignBottom');

            exports.default = _default;
            });

            unwrapExports$1(VerticalAlignBottom);

            var VerticalAlignCenter = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M8 19h3v4h2v-4h3l-4-4-4 4zm8-14h-3V1h-2v4H8l4 4 4-4zM4 11v2h16v-2H4z"
            })), 'VerticalAlignCenter');

            exports.default = _default;
            });

            unwrapExports$1(VerticalAlignCenter);

            var VerticalAlignTop = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M8 11h3v10h2V11h3l-4-4-4 4zM4 3v2h16V3H4z"
            })), 'VerticalAlignTop');

            exports.default = _default;
            });

            unwrapExports$1(VerticalAlignTop);

            var Vibration = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M0 15h2V9H0v6zm3 2h2V7H3v10zm19-8v6h2V9h-2zm-3 8h2V7h-2v10zM16.5 3h-9C6.67 3 6 3.67 6 4.5v15c0 .83.67 1.5 1.5 1.5h9c.83 0 1.5-.67 1.5-1.5v-15c0-.83-.67-1.5-1.5-1.5zM16 19H8V5h8v14z"
            })), 'Vibration');

            exports.default = _default;
            });

            unwrapExports$1(Vibration);

            var VideoCall = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M17 10.5V7c0-.55-.45-1-1-1H4c-.55 0-1 .45-1 1v10c0 .55.45 1 1 1h12c.55 0 1-.45 1-1v-3.5l4 4v-11l-4 4zM14 13h-3v3H9v-3H6v-2h3V8h2v3h3v2z"
            })), 'VideoCall');

            exports.default = _default;
            });

            unwrapExports$1(VideoCall);

            var Videocam = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M17 10.5V7c0-.55-.45-1-1-1H4c-.55 0-1 .45-1 1v10c0 .55.45 1 1 1h12c.55 0 1-.45 1-1v-3.5l4 4v-11l-4 4z"
            })), 'Videocam');

            exports.default = _default;
            });

            unwrapExports$1(Videocam);

            var VideocamOff = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M21 6.5l-4 4V7c0-.55-.45-1-1-1H9.82L21 17.18V6.5zM3.27 2L2 3.27 4.73 6H4c-.55 0-1 .45-1 1v10c0 .55.45 1 1 1h12c.21 0 .39-.08.54-.18L19.73 21 21 19.73 3.27 2z"
            })), 'VideocamOff');

            exports.default = _default;
            });

            unwrapExports$1(VideocamOff);

            var VideogameAsset = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M21 6H3c-1.1 0-2 .9-2 2v8c0 1.1.9 2 2 2h18c1.1 0 2-.9 2-2V8c0-1.1-.9-2-2-2zm-10 7H8v3H6v-3H3v-2h3V8h2v3h3v2zm4.5 2c-.83 0-1.5-.67-1.5-1.5s.67-1.5 1.5-1.5 1.5.67 1.5 1.5-.67 1.5-1.5 1.5zm4-3c-.83 0-1.5-.67-1.5-1.5S18.67 9 19.5 9s1.5.67 1.5 1.5-.67 1.5-1.5 1.5z"
            })), 'VideogameAsset');

            exports.default = _default;
            });

            unwrapExports$1(VideogameAsset);

            var VideoLabel = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M21 3H3c-1.1 0-2 .9-2 2v14c0 1.1.9 2 2 2h18c1.1 0 2-.9 2-2V5c0-1.1-.9-2-2-2zm0 13H3V5h18v11z"
            })), 'VideoLabel');

            exports.default = _default;
            });

            unwrapExports$1(VideoLabel);

            var VideoLibrary = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M4 6H2v14c0 1.1.9 2 2 2h14v-2H4V6zm16-4H8c-1.1 0-2 .9-2 2v12c0 1.1.9 2 2 2h12c1.1 0 2-.9 2-2V4c0-1.1-.9-2-2-2zm-8 12.5v-9l6 4.5-6 4.5z"
            })), 'VideoLibrary');

            exports.default = _default;
            });

            unwrapExports$1(VideoLibrary);

            var ViewAgenda = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M20 13H3c-.55 0-1 .45-1 1v6c0 .55.45 1 1 1h17c.55 0 1-.45 1-1v-6c0-.55-.45-1-1-1zm0-10H3c-.55 0-1 .45-1 1v6c0 .55.45 1 1 1h17c.55 0 1-.45 1-1V4c0-.55-.45-1-1-1z"
            })), 'ViewAgenda');

            exports.default = _default;
            });

            unwrapExports$1(ViewAgenda);

            var ViewArray = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M4 18h3V5H4v13zM18 5v13h3V5h-3zM8 18h9V5H8v13z"
            })), 'ViewArray');

            exports.default = _default;
            });

            unwrapExports$1(ViewArray);

            var ViewCarousel = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M7 19h10V4H7v15zm-5-2h4V6H2v11zM18 6v11h4V6h-4z"
            })), 'ViewCarousel');

            exports.default = _default;
            });

            unwrapExports$1(ViewCarousel);

            var ViewColumn = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M10 18h5V5h-5v13zm-6 0h5V5H4v13zM16 5v13h5V5h-5z"
            })), 'ViewColumn');

            exports.default = _default;
            });

            unwrapExports$1(ViewColumn);

            var ViewComfy = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M3 9h4V5H3v4zm0 5h4v-4H3v4zm5 0h4v-4H8v4zm5 0h4v-4h-4v4zM8 9h4V5H8v4zm5-4v4h4V5h-4zm5 9h4v-4h-4v4zM3 19h4v-4H3v4zm5 0h4v-4H8v4zm5 0h4v-4h-4v4zm5 0h4v-4h-4v4zm0-14v4h4V5h-4z"
            })), 'ViewComfy');

            exports.default = _default;
            });

            unwrapExports$1(ViewComfy);

            var ViewCompact = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M3 19h6v-7H3v7zm7 0h12v-7H10v7zM3 5v6h19V5H3z"
            })), 'ViewCompact');

            exports.default = _default;
            });

            unwrapExports$1(ViewCompact);

            var ViewDay = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M2 21h19v-3H2v3zM20 8H3c-.55 0-1 .45-1 1v6c0 .55.45 1 1 1h17c.55 0 1-.45 1-1V9c0-.55-.45-1-1-1zM2 3v3h19V3H2z"
            })), 'ViewDay');

            exports.default = _default;
            });

            unwrapExports$1(ViewDay);

            var ViewHeadline = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M4 15h16v-2H4v2zm0 4h16v-2H4v2zm0-8h16V9H4v2zm0-6v2h16V5H4z"
            })), 'ViewHeadline');

            exports.default = _default;
            });

            unwrapExports$1(ViewHeadline);

            var ViewList = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M4 14h4v-4H4v4zm0 5h4v-4H4v4zM4 9h4V5H4v4zm5 5h12v-4H9v4zm0 5h12v-4H9v4zM9 5v4h12V5H9z"
            })), 'ViewList');

            exports.default = _default;
            });

            unwrapExports$1(ViewList);

            var ViewModule = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M4 11h5V5H4v6zm0 7h5v-6H4v6zm6 0h5v-6h-5v6zm6 0h5v-6h-5v6zm-6-7h5V5h-5v6zm6-6v6h5V5h-5z"
            })), 'ViewModule');

            exports.default = _default;
            });

            unwrapExports$1(ViewModule);

            var ViewQuilt = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M10 18h5v-6h-5v6zm-6 0h5V5H4v13zm12 0h5v-6h-5v6zM10 5v6h11V5H10z"
            })), 'ViewQuilt');

            exports.default = _default;
            });

            unwrapExports$1(ViewQuilt);

            var ViewStream = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M4 18h17v-6H4v6zM4 5v6h17V5H4z"
            })), 'ViewStream');

            exports.default = _default;
            });

            unwrapExports$1(ViewStream);

            var ViewWeek = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M6 5H3c-.55 0-1 .45-1 1v12c0 .55.45 1 1 1h3c.55 0 1-.45 1-1V6c0-.55-.45-1-1-1zm14 0h-3c-.55 0-1 .45-1 1v12c0 .55.45 1 1 1h3c.55 0 1-.45 1-1V6c0-.55-.45-1-1-1zm-7 0h-3c-.55 0-1 .45-1 1v12c0 .55.45 1 1 1h3c.55 0 1-.45 1-1V6c0-.55-.45-1-1-1z"
            })), 'ViewWeek');

            exports.default = _default;
            });

            unwrapExports$1(ViewWeek);

            var Vignette = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M21 3H3c-1.1 0-2 .9-2 2v14c0 1.1.9 2 2 2h18c1.1 0 2-.9 2-2V5c0-1.1-.9-2-2-2zm-9 15c-4.42 0-8-2.69-8-6s3.58-6 8-6 8 2.69 8 6-3.58 6-8 6z"
            })), 'Vignette');

            exports.default = _default;
            });

            unwrapExports$1(Vignette);

            var Visibility = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M12 4.5C7 4.5 2.73 7.61 1 12c1.73 4.39 6 7.5 11 7.5s9.27-3.11 11-7.5c-1.73-4.39-6-7.5-11-7.5zM12 17c-2.76 0-5-2.24-5-5s2.24-5 5-5 5 2.24 5 5-2.24 5-5 5zm0-8c-1.66 0-3 1.34-3 3s1.34 3 3 3 3-1.34 3-3-1.34-3-3-3z"
            })), 'Visibility');

            exports.default = _default;
            });

            unwrapExports$1(Visibility);

            var VisibilityOff = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M12 7c2.76 0 5 2.24 5 5 0 .65-.13 1.26-.36 1.83l2.92 2.92c1.51-1.26 2.7-2.89 3.43-4.75-1.73-4.39-6-7.5-11-7.5-1.4 0-2.74.25-3.98.7l2.16 2.16C10.74 7.13 11.35 7 12 7zM2 4.27l2.28 2.28.46.46C3.08 8.3 1.78 10.02 1 12c1.73 4.39 6 7.5 11 7.5 1.55 0 3.03-.3 4.38-.84l.42.42L19.73 22 21 20.73 3.27 3 2 4.27zM7.53 9.8l1.55 1.55c-.05.21-.08.43-.08.65 0 1.66 1.34 3 3 3 .22 0 .44-.03.65-.08l1.55 1.55c-.67.33-1.41.53-2.2.53-2.76 0-5-2.24-5-5 0-.79.2-1.53.53-2.2zm4.31-.78l3.15 3.15.02-.16c0-1.66-1.34-3-3-3l-.17.01z"
            })), 'VisibilityOff');

            exports.default = _default;
            });

            unwrapExports$1(VisibilityOff);

            var VoiceChat = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M20 2H4c-1.1 0-1.99.9-1.99 2L2 22l4-4h14c1.1 0 2-.9 2-2V4c0-1.1-.9-2-2-2zm-2 12l-4-3.2V14H6V6h8v3.2L18 6v8z"
            })), 'VoiceChat');

            exports.default = _default;
            });

            unwrapExports$1(VoiceChat);

            var Voicemail = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M18.5 6C15.46 6 13 8.46 13 11.5c0 1.33.47 2.55 1.26 3.5H9.74c.79-.95 1.26-2.17 1.26-3.5C11 8.46 8.54 6 5.5 6S0 8.46 0 11.5 2.46 17 5.5 17h13c3.04 0 5.5-2.46 5.5-5.5S21.54 6 18.5 6zm-13 9C3.57 15 2 13.43 2 11.5S3.57 8 5.5 8 9 9.57 9 11.5 7.43 15 5.5 15zm13 0c-1.93 0-3.5-1.57-3.5-3.5S16.57 8 18.5 8 22 9.57 22 11.5 20.43 15 18.5 15z"
            })), 'Voicemail');

            exports.default = _default;
            });

            unwrapExports$1(Voicemail);

            var VolumeDown = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M18.5 12c0-1.77-1.02-3.29-2.5-4.03v8.05c1.48-.73 2.5-2.25 2.5-4.02zM5 9v6h4l5 5V4L9 9H5z"
            })), 'VolumeDown');

            exports.default = _default;
            });

            unwrapExports$1(VolumeDown);

            var VolumeMute = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M7 9v6h4l5 5V4l-5 5H7z"
            })), 'VolumeMute');

            exports.default = _default;
            });

            unwrapExports$1(VolumeMute);

            var VolumeOff = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M16.5 12c0-1.77-1.02-3.29-2.5-4.03v2.21l2.45 2.45c.03-.2.05-.41.05-.63zm2.5 0c0 .94-.2 1.82-.54 2.64l1.51 1.51C20.63 14.91 21 13.5 21 12c0-4.28-2.99-7.86-7-8.77v2.06c2.89.86 5 3.54 5 6.71zM4.27 3L3 4.27 7.73 9H3v6h4l5 5v-6.73l4.25 4.25c-.67.52-1.42.93-2.25 1.18v2.06c1.38-.31 2.63-.95 3.69-1.81L19.73 21 21 19.73l-9-9L4.27 3zM12 4L9.91 6.09 12 8.18V4z"
            })), 'VolumeOff');

            exports.default = _default;
            });

            unwrapExports$1(VolumeOff);

            var VolumeUp = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M3 9v6h4l5 5V4L7 9H3zm13.5 3c0-1.77-1.02-3.29-2.5-4.03v8.05c1.48-.73 2.5-2.25 2.5-4.02zM14 3.23v2.06c2.89.86 5 3.54 5 6.71s-2.11 5.85-5 6.71v2.06c4.01-.91 7-4.49 7-8.77s-2.99-7.86-7-8.77z"
            })), 'VolumeUp');

            exports.default = _default;
            });

            unwrapExports$1(VolumeUp);

            var VpnKey = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M12.65 10C11.83 7.67 9.61 6 7 6c-3.31 0-6 2.69-6 6s2.69 6 6 6c2.61 0 4.83-1.67 5.65-4H17v4h4v-4h2v-4H12.65zM7 14c-1.1 0-2-.9-2-2s.9-2 2-2 2 .9 2 2-.9 2-2 2z"
            })), 'VpnKey');

            exports.default = _default;
            });

            unwrapExports$1(VpnKey);

            var VpnLock = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M22 4v-.5C22 2.12 20.88 1 19.5 1S17 2.12 17 3.5V4c-.55 0-1 .45-1 1v4c0 .55.45 1 1 1h5c.55 0 1-.45 1-1V5c0-.55-.45-1-1-1zm-.8 0h-3.4v-.5c0-.94.76-1.7 1.7-1.7s1.7.76 1.7 1.7V4zm-2.28 8c.04.33.08.66.08 1 0 2.08-.8 3.97-2.1 5.39-.26-.81-1-1.39-1.9-1.39h-1v-3c0-.55-.45-1-1-1H7v-2h2c.55 0 1-.45 1-1V8h2c1.1 0 2-.9 2-2V3.46c-.95-.3-1.95-.46-3-.46C5.48 3 1 7.48 1 13s4.48 10 10 10 10-4.48 10-10c0-.34-.02-.67-.05-1h-2.03zM10 20.93c-3.95-.49-7-3.85-7-7.93 0-.62.08-1.21.21-1.79L8 16v1c0 1.1.9 2 2 2v1.93z"
            })), 'VpnLock');

            exports.default = _default;
            });

            unwrapExports$1(VpnLock);

            var Wallpaper = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M4 4h7V2H4c-1.1 0-2 .9-2 2v7h2V4zm6 9l-4 5h12l-3-4-2.03 2.71L10 13zm7-4.5c0-.83-.67-1.5-1.5-1.5S14 7.67 14 8.5s.67 1.5 1.5 1.5S17 9.33 17 8.5zM20 2h-7v2h7v7h2V4c0-1.1-.9-2-2-2zm0 18h-7v2h7c1.1 0 2-.9 2-2v-7h-2v7zM4 13H2v7c0 1.1.9 2 2 2h7v-2H4v-7z"
            })), 'Wallpaper');

            exports.default = _default;
            });

            unwrapExports$1(Wallpaper);

            var Warning = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M1 21h22L12 2 1 21zm12-3h-2v-2h2v2zm0-4h-2v-4h2v4z"
            })), 'Warning');

            exports.default = _default;
            });

            unwrapExports$1(Warning);

            var Watch = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M20 12c0-2.54-1.19-4.81-3.04-6.27L16 0H8l-.95 5.73C5.19 7.19 4 9.45 4 12s1.19 4.81 3.05 6.27L8 24h8l.96-5.73C18.81 16.81 20 14.54 20 12zM6 12c0-3.31 2.69-6 6-6s6 2.69 6 6-2.69 6-6 6-6-2.69-6-6z"
            })), 'Watch');

            exports.default = _default;
            });

            unwrapExports$1(Watch);

            var WatchLater = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M12 2C6.5 2 2 6.5 2 12s4.5 10 10 10 10-4.5 10-10S17.5 2 12 2zm4.2 14.2L11 13V7h1.5v5.2l4.5 2.7-.8 1.3z"
            })), 'WatchLater');

            exports.default = _default;
            });

            unwrapExports$1(WatchLater);

            var WbAuto = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M6.85 12.65h2.3L8 9l-1.15 3.65zM22 7l-1.2 6.29L19.3 7h-1.6l-1.49 6.29L15 7h-.76C12.77 5.17 10.53 4 8 4c-4.42 0-8 3.58-8 8s3.58 8 8 8c3.13 0 5.84-1.81 7.15-4.43l.1.43H17l1.5-6.1L20 16h1.75l2.05-9H22zm-11.7 9l-.7-2H6.4l-.7 2H3.8L7 7h2l3.2 9h-1.9z"
            })), 'WbAuto');

            exports.default = _default;
            });

            unwrapExports$1(WbAuto);

            var WbCloudy = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M19.36 10.04C18.67 6.59 15.64 4 12 4 9.11 4 6.6 5.64 5.35 8.04 2.34 8.36 0 10.91 0 14c0 3.31 2.69 6 6 6h13c2.76 0 5-2.24 5-5 0-2.64-2.05-4.78-4.64-4.96z"
            })), 'WbCloudy');

            exports.default = _default;
            });

            unwrapExports$1(WbCloudy);

            var WbIncandescent = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M3.55 18.54l1.41 1.41 1.79-1.8-1.41-1.41-1.79 1.8zM11 22.45h2V19.5h-2v2.95zM4 10.5H1v2h3v-2zm11-4.19V1.5H9v4.81C7.21 7.35 6 9.28 6 11.5c0 3.31 2.69 6 6 6s6-2.69 6-6c0-2.22-1.21-4.15-3-5.19zm5 4.19v2h3v-2h-3zm-2.76 7.66l1.79 1.8 1.41-1.41-1.8-1.79-1.4 1.4z"
            })), 'WbIncandescent');

            exports.default = _default;
            });

            unwrapExports$1(WbIncandescent);

            var WbIridescent = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M5 14.5h14v-6H5v6zM11 .55V3.5h2V.55h-2zm8.04 2.5l-1.79 1.79 1.41 1.41 1.8-1.79-1.42-1.41zM13 22.45V19.5h-2v2.95h2zm7.45-3.91l-1.8-1.79-1.41 1.41 1.79 1.8 1.42-1.42zM3.55 4.46l1.79 1.79 1.41-1.41-1.79-1.79-1.41 1.41zm1.41 15.49l1.79-1.8-1.41-1.41-1.79 1.79 1.41 1.42z"
            })), 'WbIridescent');

            exports.default = _default;
            });

            unwrapExports$1(WbIridescent);

            var WbSunny = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M6.76 4.84l-1.8-1.79-1.41 1.41 1.79 1.79 1.42-1.41zM4 10.5H1v2h3v-2zm9-9.95h-2V3.5h2V.55zm7.45 3.91l-1.41-1.41-1.79 1.79 1.41 1.41 1.79-1.79zm-3.21 13.7l1.79 1.8 1.41-1.41-1.8-1.79-1.4 1.4zM20 10.5v2h3v-2h-3zm-8-5c-3.31 0-6 2.69-6 6s2.69 6 6 6 6-2.69 6-6-2.69-6-6-6zm-1 16.95h2V19.5h-2v2.95zm-7.45-3.91l1.41 1.41 1.79-1.8-1.41-1.41-1.79 1.8z"
            })), 'WbSunny');

            exports.default = _default;
            });

            unwrapExports$1(WbSunny);

            var Wc = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M5.5 22v-7.5H4V9c0-1.1.9-2 2-2h3c1.1 0 2 .9 2 2v5.5H9.5V22h-4zM18 22v-6h3l-2.54-7.63C18.18 7.55 17.42 7 16.56 7h-.12c-.86 0-1.63.55-1.9 1.37L12 16h3v6h3zM7.5 6c1.11 0 2-.89 2-2s-.89-2-2-2-2 .89-2 2 .89 2 2 2zm9 0c1.11 0 2-.89 2-2s-.89-2-2-2-2 .89-2 2 .89 2 2 2z"
            })), 'Wc');

            exports.default = _default;
            });

            unwrapExports$1(Wc);

            var Web = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M20 4H4c-1.1 0-1.99.9-1.99 2L2 18c0 1.1.9 2 2 2h16c1.1 0 2-.9 2-2V6c0-1.1-.9-2-2-2zm-5 14H4v-4h11v4zm0-5H4V9h11v4zm5 5h-4V9h4v9z"
            })), 'Web');

            exports.default = _default;
            });

            unwrapExports$1(Web);

            var WebAsset = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M19 4H5c-1.11 0-2 .9-2 2v12c0 1.1.89 2 2 2h14c1.1 0 2-.9 2-2V6c0-1.1-.89-2-2-2zm0 14H5V8h14v10z"
            })), 'WebAsset');

            exports.default = _default;
            });

            unwrapExports$1(WebAsset);

            var Weekend = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M21 10c-1.1 0-2 .9-2 2v3H5v-3c0-1.1-.9-2-2-2s-2 .9-2 2v5c0 1.1.9 2 2 2h18c1.1 0 2-.9 2-2v-5c0-1.1-.9-2-2-2zm-3-5H6c-1.1 0-2 .9-2 2v2.15c1.16.41 2 1.51 2 2.82V14h12v-2.03c0-1.3.84-2.4 2-2.82V7c0-1.1-.9-2-2-2z"
            })), 'Weekend');

            exports.default = _default;
            });

            unwrapExports$1(Weekend);

            var Whatshot = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M13.5.67s.74 2.65.74 4.8c0 2.06-1.35 3.73-3.41 3.73-2.07 0-3.63-1.67-3.63-3.73l.03-.36C5.21 7.51 4 10.62 4 14c0 4.42 3.58 8 8 8s8-3.58 8-8C20 8.61 17.41 3.8 13.5.67zM11.71 19c-1.78 0-3.22-1.4-3.22-3.14 0-1.62 1.05-2.76 2.81-3.12 1.77-.36 3.6-1.21 4.62-2.58.39 1.29.59 2.65.59 4.04 0 2.65-2.15 4.8-4.8 4.8z"
            })), 'Whatshot');

            exports.default = _default;
            });

            unwrapExports$1(Whatshot);

            var Widgets = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M13 13v8h8v-8h-8zM3 21h8v-8H3v8zM3 3v8h8V3H3zm13.66-1.31L11 7.34 16.66 13l5.66-5.66-5.66-5.65z"
            })), 'Widgets');

            exports.default = _default;
            });

            unwrapExports$1(Widgets);

            var Wifi = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M1 9l2 2c4.97-4.97 13.03-4.97 18 0l2-2C16.93 2.93 7.08 2.93 1 9zm8 8l3 3 3-3c-1.65-1.66-4.34-1.66-6 0zm-4-4l2 2c2.76-2.76 7.24-2.76 10 0l2-2C15.14 9.14 8.87 9.14 5 13z"
            })), 'Wifi');

            exports.default = _default;
            });

            unwrapExports$1(Wifi);

            var WifiLock = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M20.5 9.5c.28 0 .55.04.81.08L24 6c-3.34-2.51-7.5-4-12-4S3.34 3.49 0 6l12 16 3.5-4.67V14.5c0-2.76 2.24-5 5-5zM23 16v-1.5c0-1.38-1.12-2.5-2.5-2.5S18 13.12 18 14.5V16c-.55 0-1 .45-1 1v4c0 .55.45 1 1 1h5c.55 0 1-.45 1-1v-4c0-.55-.45-1-1-1zm-1 0h-3v-1.5c0-.83.67-1.5 1.5-1.5s1.5.67 1.5 1.5V16z"
            })), 'WifiLock');

            exports.default = _default;
            });

            unwrapExports$1(WifiLock);

            var WifiTethering = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M12 11c-1.1 0-2 .9-2 2s.9 2 2 2 2-.9 2-2-.9-2-2-2zm6 2c0-3.31-2.69-6-6-6s-6 2.69-6 6c0 2.22 1.21 4.15 3 5.19l1-1.74c-1.19-.7-2-1.97-2-3.45 0-2.21 1.79-4 4-4s4 1.79 4 4c0 1.48-.81 2.75-2 3.45l1 1.74c1.79-1.04 3-2.97 3-5.19zM12 3C6.48 3 2 7.48 2 13c0 3.7 2.01 6.92 4.99 8.65l1-1.73C5.61 18.53 4 15.96 4 13c0-4.42 3.58-8 8-8s8 3.58 8 8c0 2.96-1.61 5.53-4 6.92l1 1.73c2.99-1.73 5-4.95 5-8.65 0-5.52-4.48-10-10-10z"
            })), 'WifiTethering');

            exports.default = _default;
            });

            unwrapExports$1(WifiTethering);

            var Work = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M20 6h-4V4c0-1.11-.89-2-2-2h-4c-1.11 0-2 .89-2 2v2H4c-1.11 0-1.99.89-1.99 2L2 19c0 1.11.89 2 2 2h16c1.11 0 2-.89 2-2V8c0-1.11-.89-2-2-2zm-6 0h-4V4h4v2z"
            })), 'Work');

            exports.default = _default;
            });

            unwrapExports$1(Work);

            var WrapText = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M4 19h6v-2H4v2zM20 5H4v2h16V5zm-3 6H4v2h13.25c1.1 0 2 .9 2 2s-.9 2-2 2H15v-2l-3 3 3 3v-2h2c2.21 0 4-1.79 4-4s-1.79-4-4-4z"
            })), 'WrapText');

            exports.default = _default;
            });

            unwrapExports$1(WrapText);

            var YoutubeSearchedFor = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M17.01 14h-.8l-.27-.27c.98-1.14 1.57-2.61 1.57-4.23 0-3.59-2.91-6.5-6.5-6.5s-6.5 3-6.5 6.5H2l3.84 4 4.16-4H6.51C6.51 7 8.53 5 11.01 5s4.5 2.01 4.5 4.5c0 2.48-2.02 4.5-4.5 4.5-.65 0-1.26-.14-1.82-.38L7.71 15.1c.97.57 2.09.9 3.3.9 1.61 0 3.08-.59 4.22-1.57l.27.27v.79l5.01 4.99L22 19l-4.99-5z"
            })), 'YoutubeSearchedFor');

            exports.default = _default;
            });

            unwrapExports$1(YoutubeSearchedFor);

            var ZoomIn = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M15.5 14h-.79l-.28-.27C15.41 12.59 16 11.11 16 9.5 16 5.91 13.09 3 9.5 3S3 5.91 3 9.5 5.91 16 9.5 16c1.61 0 3.09-.59 4.23-1.57l.27.28v.79l5 4.99L20.49 19l-4.99-5zm-6 0C7.01 14 5 11.99 5 9.5S7.01 5 9.5 5 14 7.01 14 9.5 11.99 14 9.5 14zm2.5-4h-2v2H9v-2H7V9h2V7h1v2h2v1z"
            })), 'ZoomIn');

            exports.default = _default;
            });

            unwrapExports$1(ZoomIn);

            var ZoomOut = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M15.5 14h-.79l-.28-.27C15.41 12.59 16 11.11 16 9.5 16 5.91 13.09 3 9.5 3S3 5.91 3 9.5 5.91 16 9.5 16c1.61 0 3.09-.59 4.23-1.57l.27.28v.79l5 4.99L20.49 19l-4.99-5zm-6 0C7.01 14 5 11.99 5 9.5S7.01 5 9.5 5 14 7.01 14 9.5 11.99 14 9.5 14zM7 9h5v1H7z"
            })), 'ZoomOut');

            exports.default = _default;
            });

            unwrapExports$1(ZoomOut);

            var ZoomOutMap = createCommonjsModule$1(function (module, exports) {



            Object.defineProperty(exports, "__esModule", {
              value: true
            });
            exports.default = void 0;

            var _react = interopRequireDefault$1(React);

            var _createSvgIcon = interopRequireDefault$1(createSvgIcon_1);

            var _default = (0, _createSvgIcon.default)(_react.default.createElement("g", null, _react.default.createElement("path", {
              d: "M15 3l2.3 2.3-2.89 2.87 1.42 1.42L18.7 6.7 21 9V3zM3 9l2.3-2.3 2.87 2.89 1.42-1.42L6.7 5.3 9 3H3zm6 12l-2.3-2.3 2.89-2.87-1.42-1.42L5.3 17.3 3 15v6zm12-6l-2.3 2.3-2.87-2.89-1.42 1.42 2.89 2.87L15 21h6z"
            })), 'ZoomOutMap');

            exports.default = _default;
            });

            unwrapExports$1(ZoomOutMap);

            /** @jsx jsx */
            function SetEcomKeysMessage(props) {
                return (jsx("div", { css: {
                        padding: 40,
                        color: '#444',
                        textAlign: 'center',
                    } },
                    jsx("div", { css: { color: '#000', paddingBottom: 10 } },
                        "You have not entered your ",
                        props.pluginName,
                        " keys!",
                        ' '),
                    "Go to your",
                    ' ',
                    jsx("a", { target: "_blank", href: "/account/organization", css: { color: 'steelblue' } }, "settings"),
                    ' ',
                    "page, find ",
                    props.pluginId,
                    " in the list, and set your API and secret keys to use this plugin"));
            }

            var pluralize = createCommonjsModule$1(function (module, exports) {
            /* global define */

            (function (root, pluralize) {
              /* istanbul ignore else */
              if (typeof commonjsRequire === 'function' && 'object' === 'object' && 'object' === 'object') {
                // Node.
                module.exports = pluralize();
              } else {
                // Browser global.
                root.pluralize = pluralize();
              }
            })(commonjsGlobal$1, function () {
              // Rule storage - pluralize and singularize need to be run sequentially,
              // while other rules can be optimized using an object for instant lookups.
              var pluralRules = [];
              var singularRules = [];
              var uncountables = {};
              var irregularPlurals = {};
              var irregularSingles = {};

              /**
               * Sanitize a pluralization rule to a usable regular expression.
               *
               * @param  {(RegExp|string)} rule
               * @return {RegExp}
               */
              function sanitizeRule (rule) {
                if (typeof rule === 'string') {
                  return new RegExp('^' + rule + '$', 'i');
                }

                return rule;
              }

              /**
               * Pass in a word token to produce a function that can replicate the case on
               * another word.
               *
               * @param  {string}   word
               * @param  {string}   token
               * @return {Function}
               */
              function restoreCase (word, token) {
                // Tokens are an exact match.
                if (word === token) return token;

                // Lower cased words. E.g. "hello".
                if (word === word.toLowerCase()) return token.toLowerCase();

                // Upper cased words. E.g. "WHISKY".
                if (word === word.toUpperCase()) return token.toUpperCase();

                // Title cased words. E.g. "Title".
                if (word[0] === word[0].toUpperCase()) {
                  return token.charAt(0).toUpperCase() + token.substr(1).toLowerCase();
                }

                // Lower cased words. E.g. "test".
                return token.toLowerCase();
              }

              /**
               * Interpolate a regexp string.
               *
               * @param  {string} str
               * @param  {Array}  args
               * @return {string}
               */
              function interpolate (str, args) {
                return str.replace(/\$(\d{1,2})/g, function (match, index) {
                  return args[index] || '';
                });
              }

              /**
               * Replace a word using a rule.
               *
               * @param  {string} word
               * @param  {Array}  rule
               * @return {string}
               */
              function replace (word, rule) {
                return word.replace(rule[0], function (match, index) {
                  var result = interpolate(rule[1], arguments);

                  if (match === '') {
                    return restoreCase(word[index - 1], result);
                  }

                  return restoreCase(match, result);
                });
              }

              /**
               * Sanitize a word by passing in the word and sanitization rules.
               *
               * @param  {string}   token
               * @param  {string}   word
               * @param  {Array}    rules
               * @return {string}
               */
              function sanitizeWord (token, word, rules) {
                // Empty string or doesn't need fixing.
                if (!token.length || uncountables.hasOwnProperty(token)) {
                  return word;
                }

                var len = rules.length;

                // Iterate over the sanitization rules and use the first one to match.
                while (len--) {
                  var rule = rules[len];

                  if (rule[0].test(word)) return replace(word, rule);
                }

                return word;
              }

              /**
               * Replace a word with the updated word.
               *
               * @param  {Object}   replaceMap
               * @param  {Object}   keepMap
               * @param  {Array}    rules
               * @return {Function}
               */
              function replaceWord (replaceMap, keepMap, rules) {
                return function (word) {
                  // Get the correct token and case restoration functions.
                  var token = word.toLowerCase();

                  // Check against the keep object map.
                  if (keepMap.hasOwnProperty(token)) {
                    return restoreCase(word, token);
                  }

                  // Check against the replacement map for a direct word replacement.
                  if (replaceMap.hasOwnProperty(token)) {
                    return restoreCase(word, replaceMap[token]);
                  }

                  // Run all the rules against the word.
                  return sanitizeWord(token, word, rules);
                };
              }

              /**
               * Check if a word is part of the map.
               */
              function checkWord (replaceMap, keepMap, rules, bool) {
                return function (word) {
                  var token = word.toLowerCase();

                  if (keepMap.hasOwnProperty(token)) return true;
                  if (replaceMap.hasOwnProperty(token)) return false;

                  return sanitizeWord(token, token, rules) === token;
                };
              }

              /**
               * Pluralize or singularize a word based on the passed in count.
               *
               * @param  {string}  word      The word to pluralize
               * @param  {number}  count     How many of the word exist
               * @param  {boolean} inclusive Whether to prefix with the number (e.g. 3 ducks)
               * @return {string}
               */
              function pluralize (word, count, inclusive) {
                var pluralized = count === 1
                  ? pluralize.singular(word) : pluralize.plural(word);

                return (inclusive ? count + ' ' : '') + pluralized;
              }

              /**
               * Pluralize a word.
               *
               * @type {Function}
               */
              pluralize.plural = replaceWord(
                irregularSingles, irregularPlurals, pluralRules
              );

              /**
               * Check if a word is plural.
               *
               * @type {Function}
               */
              pluralize.isPlural = checkWord(
                irregularSingles, irregularPlurals, pluralRules
              );

              /**
               * Singularize a word.
               *
               * @type {Function}
               */
              pluralize.singular = replaceWord(
                irregularPlurals, irregularSingles, singularRules
              );

              /**
               * Check if a word is singular.
               *
               * @type {Function}
               */
              pluralize.isSingular = checkWord(
                irregularPlurals, irregularSingles, singularRules
              );

              /**
               * Add a pluralization rule to the collection.
               *
               * @param {(string|RegExp)} rule
               * @param {string}          replacement
               */
              pluralize.addPluralRule = function (rule, replacement) {
                pluralRules.push([sanitizeRule(rule), replacement]);
              };

              /**
               * Add a singularization rule to the collection.
               *
               * @param {(string|RegExp)} rule
               * @param {string}          replacement
               */
              pluralize.addSingularRule = function (rule, replacement) {
                singularRules.push([sanitizeRule(rule), replacement]);
              };

              /**
               * Add an uncountable word rule.
               *
               * @param {(string|RegExp)} word
               */
              pluralize.addUncountableRule = function (word) {
                if (typeof word === 'string') {
                  uncountables[word.toLowerCase()] = true;
                  return;
                }

                // Set singular and plural references for the word.
                pluralize.addPluralRule(word, '$0');
                pluralize.addSingularRule(word, '$0');
              };

              /**
               * Add an irregular word definition.
               *
               * @param {string} single
               * @param {string} plural
               */
              pluralize.addIrregularRule = function (single, plural) {
                plural = plural.toLowerCase();
                single = single.toLowerCase();

                irregularSingles[single] = plural;
                irregularPlurals[plural] = single;
              };

              /**
               * Irregular rules.
               */
              [
                // Pronouns.
                ['I', 'we'],
                ['me', 'us'],
                ['he', 'they'],
                ['she', 'they'],
                ['them', 'them'],
                ['myself', 'ourselves'],
                ['yourself', 'yourselves'],
                ['itself', 'themselves'],
                ['herself', 'themselves'],
                ['himself', 'themselves'],
                ['themself', 'themselves'],
                ['is', 'are'],
                ['was', 'were'],
                ['has', 'have'],
                ['this', 'these'],
                ['that', 'those'],
                // Words ending in with a consonant and `o`.
                ['echo', 'echoes'],
                ['dingo', 'dingoes'],
                ['volcano', 'volcanoes'],
                ['tornado', 'tornadoes'],
                ['torpedo', 'torpedoes'],
                // Ends with `us`.
                ['genus', 'genera'],
                ['viscus', 'viscera'],
                // Ends with `ma`.
                ['stigma', 'stigmata'],
                ['stoma', 'stomata'],
                ['dogma', 'dogmata'],
                ['lemma', 'lemmata'],
                ['schema', 'schemata'],
                ['anathema', 'anathemata'],
                // Other irregular rules.
                ['ox', 'oxen'],
                ['axe', 'axes'],
                ['die', 'dice'],
                ['yes', 'yeses'],
                ['foot', 'feet'],
                ['eave', 'eaves'],
                ['goose', 'geese'],
                ['tooth', 'teeth'],
                ['quiz', 'quizzes'],
                ['human', 'humans'],
                ['proof', 'proofs'],
                ['carve', 'carves'],
                ['valve', 'valves'],
                ['looey', 'looies'],
                ['thief', 'thieves'],
                ['groove', 'grooves'],
                ['pickaxe', 'pickaxes'],
                ['passerby', 'passersby']
              ].forEach(function (rule) {
                return pluralize.addIrregularRule(rule[0], rule[1]);
              });

              /**
               * Pluralization rules.
               */
              [
                [/s?$/i, 's'],
                [/[^\u0000-\u007F]$/i, '$0'],
                [/([^aeiou]ese)$/i, '$1'],
                [/(ax|test)is$/i, '$1es'],
                [/(alias|[^aou]us|t[lm]as|gas|ris)$/i, '$1es'],
                [/(e[mn]u)s?$/i, '$1s'],
                [/([^l]ias|[aeiou]las|[ejzr]as|[iu]am)$/i, '$1'],
                [/(alumn|syllab|vir|radi|nucle|fung|cact|stimul|termin|bacill|foc|uter|loc|strat)(?:us|i)$/i, '$1i'],
                [/(alumn|alg|vertebr)(?:a|ae)$/i, '$1ae'],
                [/(seraph|cherub)(?:im)?$/i, '$1im'],
                [/(her|at|gr)o$/i, '$1oes'],
                [/(agend|addend|millenni|dat|extrem|bacteri|desiderat|strat|candelabr|errat|ov|symposi|curricul|automat|quor)(?:a|um)$/i, '$1a'],
                [/(apheli|hyperbat|periheli|asyndet|noumen|phenomen|criteri|organ|prolegomen|hedr|automat)(?:a|on)$/i, '$1a'],
                [/sis$/i, 'ses'],
                [/(?:(kni|wi|li)fe|(ar|l|ea|eo|oa|hoo)f)$/i, '$1$2ves'],
                [/([^aeiouy]|qu)y$/i, '$1ies'],
                [/([^ch][ieo][ln])ey$/i, '$1ies'],
                [/(x|ch|ss|sh|zz)$/i, '$1es'],
                [/(matr|cod|mur|sil|vert|ind|append)(?:ix|ex)$/i, '$1ices'],
                [/\b((?:tit)?m|l)(?:ice|ouse)$/i, '$1ice'],
                [/(pe)(?:rson|ople)$/i, '$1ople'],
                [/(child)(?:ren)?$/i, '$1ren'],
                [/eaux$/i, '$0'],
                [/m[ae]n$/i, 'men'],
                ['thou', 'you']
              ].forEach(function (rule) {
                return pluralize.addPluralRule(rule[0], rule[1]);
              });

              /**
               * Singularization rules.
               */
              [
                [/s$/i, ''],
                [/(ss)$/i, '$1'],
                [/(wi|kni|(?:after|half|high|low|mid|non|night|[^\w]|^)li)ves$/i, '$1fe'],
                [/(ar|(?:wo|[ae])l|[eo][ao])ves$/i, '$1f'],
                [/ies$/i, 'y'],
                [/\b([pl]|zomb|(?:neck|cross)?t|coll|faer|food|gen|goon|group|lass|talk|goal|cut)ies$/i, '$1ie'],
                [/\b(mon|smil)ies$/i, '$1ey'],
                [/\b((?:tit)?m|l)ice$/i, '$1ouse'],
                [/(seraph|cherub)im$/i, '$1'],
                [/(x|ch|ss|sh|zz|tto|go|cho|alias|[^aou]us|t[lm]as|gas|(?:her|at|gr)o|[aeiou]ris)(?:es)?$/i, '$1'],
                [/(analy|diagno|parenthe|progno|synop|the|empha|cri|ne)(?:sis|ses)$/i, '$1sis'],
                [/(movie|twelve|abuse|e[mn]u)s$/i, '$1'],
                [/(test)(?:is|es)$/i, '$1is'],
                [/(alumn|syllab|vir|radi|nucle|fung|cact|stimul|termin|bacill|foc|uter|loc|strat)(?:us|i)$/i, '$1us'],
                [/(agend|addend|millenni|dat|extrem|bacteri|desiderat|strat|candelabr|errat|ov|symposi|curricul|quor)a$/i, '$1um'],
                [/(apheli|hyperbat|periheli|asyndet|noumen|phenomen|criteri|organ|prolegomen|hedr|automat)a$/i, '$1on'],
                [/(alumn|alg|vertebr)ae$/i, '$1a'],
                [/(cod|mur|sil|vert|ind)ices$/i, '$1ex'],
                [/(matr|append)ices$/i, '$1ix'],
                [/(pe)(rson|ople)$/i, '$1rson'],
                [/(child)ren$/i, '$1'],
                [/(eau)x?$/i, '$1'],
                [/men$/i, 'man']
              ].forEach(function (rule) {
                return pluralize.addSingularRule(rule[0], rule[1]);
              });

              /**
               * Uncountable rules.
               */
              [
                // Singular words with no plurals.
                'adulthood',
                'advice',
                'agenda',
                'aid',
                'aircraft',
                'alcohol',
                'ammo',
                'analytics',
                'anime',
                'athletics',
                'audio',
                'bison',
                'blood',
                'bream',
                'buffalo',
                'butter',
                'carp',
                'cash',
                'chassis',
                'chess',
                'clothing',
                'cod',
                'commerce',
                'cooperation',
                'corps',
                'debris',
                'diabetes',
                'digestion',
                'elk',
                'energy',
                'equipment',
                'excretion',
                'expertise',
                'firmware',
                'flounder',
                'fun',
                'gallows',
                'garbage',
                'graffiti',
                'hardware',
                'headquarters',
                'health',
                'herpes',
                'highjinks',
                'homework',
                'housework',
                'information',
                'jeans',
                'justice',
                'kudos',
                'labour',
                'literature',
                'machinery',
                'mackerel',
                'mail',
                'media',
                'mews',
                'moose',
                'music',
                'mud',
                'manga',
                'news',
                'only',
                'personnel',
                'pike',
                'plankton',
                'pliers',
                'police',
                'pollution',
                'premises',
                'rain',
                'research',
                'rice',
                'salmon',
                'scissors',
                'series',
                'sewage',
                'shambles',
                'shrimp',
                'software',
                'species',
                'staff',
                'swine',
                'tennis',
                'traffic',
                'transportation',
                'trout',
                'tuna',
                'wealth',
                'welfare',
                'whiting',
                'wildebeest',
                'wildlife',
                'you',
                /pok[eé]mon$/i,
                // Regexes.
                /[^aeiou]ese$/i, // "chinese", "japanese"
                /deer$/i, // "deer", "reindeer"
                /fish$/i, // "fish", "blowfish", "angelfish"
                /measles$/i,
                /o[iu]s$/i, // "carnivorous"
                /pox$/i, // "chickpox", "smallpox"
                /sheep$/i
              ].forEach(pluralize.addUncountableRule);

              return pluralize;
            });
            });

            var ResourcePreviewCell = function (props) {
                return useObserver(function () { return (jsx(ListItem, { className: props.className, button: props.button, selected: props.selected },
                    props.resource.image && (jsx(ListItemAvatar, null,
                        jsx(Avatar, { css: { borderRadius: 4 }, src: props.resource.image.src }))),
                    jsx(ListItemText, { primary: jsx("div", { css: {
                                maxWidth: 400,
                                overflow: 'hidden',
                                textOverflow: 'ellipsis',
                                whiteSpace: 'nowrap',
                            } }, props.resource.title) }))); });
            };
            var ResourcePicker = function (props) {
                var store = useLocalStore(function () { return ({
                    searchInputText: '',
                    loading: false,
                    resources: [],
                    search: function () {
                        return __awaiter(this, void 0, void 0, function () {
                            var catchError, resourcesResponse;
                            var _this = this;
                            return __generator(this, function (_a) {
                                switch (_a.label) {
                                    case 0:
                                        this.loading = true;
                                        catchError = function (err) {
                                            console.error('search error:', err);
                                            props.context.snackBar.show('Oh no! There was an error searching for resources');
                                        };
                                        return [4 /*yield*/, props.api[props.resourceName]
                                                .search(store.searchInputText)
                                                .catch(catchError)];
                                    case 1:
                                        resourcesResponse = _a.sent();
                                        runInAction(function () {
                                            if (Array.isArray(resourcesResponse)) {
                                                _this.resources = resourcesResponse.filter(function (resource) { return !(props.omitIds || []).includes(String(resource.id)); });
                                            }
                                            _this.loading = false;
                                        });
                                        return [2 /*return*/];
                                }
                            });
                        });
                    },
                }); });
                useEffect(function () {
                    store.search();
                }, [store.searchInputText]);
                return useObserver(function () { return (jsx("div", { css: { display: 'flex', flexDirection: 'column', minWidth: 500 } },
                    jsx(TextField, { css: { margin: 15 }, value: store.searchInputText, placeholder: props.title || "Search " + pluralize.plural(props.resourceName) + "...", InputProps: {
                            startAdornment: (jsx(InputAdornment, { position: "start" },
                                jsx(Search$1, { css: { color: '#999', marginRight: -2, fontSize: 20 } }))),
                        }, onChange: action(function (e) { return (store.searchInputText = e.target.value); }) }),
                    store.loading && jsx(CircularProgress, { disableShrink: true, css: { margin: '50px auto' } }),
                    jsx("div", { css: { maxHeight: '80vh', overflow: 'auto' } }, !store.loading &&
                        (store.resources.length ? (store.resources.map(function (item) {
                            var _a;
                            return (jsx("div", { key: item.id, onClick: function (e) {
                                    props.onChange(item);
                                } },
                                jsx(ResourcePreviewCell, { selected: String(item.id) === String((_a = props.value) === null || _a === void 0 ? void 0 : _a.id), button: true, resource: item, key: item.id })));
                        })) : (jsx("div", null,
                            jsx(Typography, { css: {
                                    margin: '40px 20px',
                                    textAlign: 'center',
                                    fontSize: 17,
                                }, variant: "caption" },
                                "No ",
                                pluralize.plural(props.resourceName),
                                " found"))))))); });
            };
            var ResourcesPickerButton = function (props) {
                var store = useLocalStore(function () {
                    var _a, _b;
                    return ({
                        loading: false,
                        error: null,
                        resourceInfo: null,
                        resourceHandle: props.handleOnly && typeof props.value === 'string' ? props.value : undefined,
                        resourceId: props.handleOnly
                            ? undefined
                            : typeof props.value === 'string'
                                ? props.value
                                : (_b = (_a = props.value) === null || _a === void 0 ? void 0 : _a.options) === null || _b === void 0 ? void 0 : _b.get(props.resourceName),
                        getResource: function () {
                            return __awaiter(this, void 0, void 0, function () {
                                var resourceService, value, _a, _b, _c, e_1;
                                return __generator(this, function (_d) {
                                    switch (_d.label) {
                                        case 0:
                                            this.error = null;
                                            this.loading = true;
                                            _d.label = 1;
                                        case 1:
                                            _d.trys.push([1, 7, , 8]);
                                            resourceService = props.api[props.resourceName];
                                            _b = this.resourceId;
                                            if (!_b) return [3 /*break*/, 3];
                                            return [4 /*yield*/, resourceService.findById(this.resourceId)];
                                        case 2:
                                            _b = (_d.sent());
                                            _d.label = 3;
                                        case 3:
                                            _a = (_b);
                                            if (_a) return [3 /*break*/, 6];
                                            _c = this.resourceHandle &&
                                                resourceService.findByHandle;
                                            if (!_c) return [3 /*break*/, 5];
                                            return [4 /*yield*/, resourceService.findByHandle(this.resourceHandle)];
                                        case 4:
                                            _c = (_d.sent());
                                            _d.label = 5;
                                        case 5:
                                            _a = (_c);
                                            _d.label = 6;
                                        case 6:
                                            value = _a;
                                            this.resourceInfo = value || null;
                                            return [3 /*break*/, 8];
                                        case 7:
                                            e_1 = _d.sent();
                                            console.error(e_1);
                                            this.error = e_1;
                                            props.context.snackBar.show("Oh no! There was an error fetching " + pluralize.plural(props.resourceName));
                                            return [3 /*break*/, 8];
                                        case 8:
                                            this.loading = false;
                                            return [2 /*return*/];
                                    }
                                });
                            });
                        },
                        showPickResouceModal: function (title) {
                            return __awaiter(this, void 0, void 0, function () {
                                var close;
                                var _this = this;
                                return __generator(this, function (_a) {
                                    switch (_a.label) {
                                        case 0: return [4 /*yield*/, props.context.globalState.openDialog(jsx(ResourcePicker, __assign({ resourceName: props.resourceName, api: props.api, context: props.context }, (this.resourceInfo && { value: this.resourceInfo }), { title: title, onChange: action(function (value) {
                                                    var _a;
                                                    if (value) {
                                                        _this.resourceHandle = value.handle;
                                                        _this.resourceId = String(value.id);
                                                        _this.getResource();
                                                        if (props.handleOnly) {
                                                            props.onChange(_this.resourceHandle);
                                                        }
                                                        else {
                                                            if ((_a = props.field) === null || _a === void 0 ? void 0 : _a.isTargeting) {
                                                                props.onChange(_this.resourceId);
                                                            }
                                                            else {
                                                                props.onChange(props.api[props.resourceName].getRequestObject(_this.resourceId, value));
                                                            }
                                                        }
                                                    }
                                                    close();
                                                }) })), true, {
                                                PaperProps: {
                                                    // Align modal to top so doesn't jump around centering itself when
                                                    // grows and shrinks to show more/less resources or loading
                                                    style: {
                                                        alignSelf: 'flex-start',
                                                    },
                                                },
                                            })];
                                        case 1:
                                            close = _a.sent();
                                            return [2 /*return*/];
                                    }
                                });
                            });
                        },
                    });
                });
                useEffect(function () {
                    store.getResource();
                }, []);
                useEffect(function () {
                    var _a, _b;
                    var hasPreviewFields = Boolean((_a = props.context.designerState.editingModel) === null || _a === void 0 ? void 0 : _a.fields.find(function (field) { return field.type === props.previewType; }));
                    if (hasPreviewFields &&
                        props.context.globalState.globalDialogs.length === 0 && ((_b = props.context.designerState) === null || _b === void 0 ? void 0 : _b.editingContentModel) &&
                        props.isPreview &&
                        (!props.value || store.error)) {
                        setTimeout(function () { return store.showPickResouceModal("Pick a " + props.resourceName + " to preview"); });
                    }
                }, [store.error]);
                return useObserver(function () {
                    var pluginSettings = props.context.user.organization.value.settings.plugins.get(props.pluginId);
                    if (!pluginSettings.get('hasConnected')) {
                        return jsx(SetEcomKeysMessage, { pluginId: props.pluginId, pluginName: props.pluginName });
                    }
                    return (jsx("div", { css: { display: 'flex', flexDirection: 'column', padding: '10px 0' } },
                        store.loading && (jsx(CircularProgress, { size: 20, disableShrink: true, css: { margin: '30px auto' } })),
                        store.resourceInfo && (jsx(Paper, { css: {
                                marginBottom: 15,
                                position: 'relative',
                            } },
                            jsx(ResourcePreviewCell, { button: true, css: { paddingRight: 30 }, resource: store.resourceInfo }),
                            jsx(IconButton, { css: {
                                    position: 'absolute',
                                    right: 2,
                                    top: 0,
                                    bottom: 0,
                                    height: 50,
                                    marginTop: 'auto',
                                    marginBottom: 'auto',
                                }, onClick: function () {
                                    store.showPickResouceModal();
                                } },
                                jsx(Create$1, { css: { color: '#888' } })))),
                        !store.resourceInfo && !store.loading && (jsx(Button, { color: "primary", variant: "contained", onClick: function () {
                                store.showPickResouceModal();
                            } },
                            "Choose ",
                            props.resourceName))));
                });
            };

            /** Detect free variable `global` from Node.js. */
            var freeGlobal$3 = typeof commonjsGlobal$1 == 'object' && commonjsGlobal$1 && commonjsGlobal$1.Object === Object && commonjsGlobal$1;

            var _freeGlobal$1 = freeGlobal$3;

            /** Detect free variable `self`. */
            var freeSelf$3 = typeof self == 'object' && self && self.Object === Object && self;

            /** Used as a reference to the global object. */
            var root$3 = _freeGlobal$1 || freeSelf$3 || Function('return this')();

            var _root$1 = root$3;

            /** Built-in value references. */
            var Symbol$1$1 = _root$1.Symbol;

            var _Symbol$1 = Symbol$1$1;

            /**
             * A specialized version of `_.map` for arrays without support for iteratee
             * shorthands.
             *
             * @private
             * @param {Array} [array] The array to iterate over.
             * @param {Function} iteratee The function invoked per iteration.
             * @returns {Array} Returns the new mapped array.
             */
            function arrayMap$1(array, iteratee) {
              var index = -1,
                  length = array == null ? 0 : array.length,
                  result = Array(length);

              while (++index < length) {
                result[index] = iteratee(array[index], index, array);
              }
              return result;
            }

            var _arrayMap$1 = arrayMap$1;

            /**
             * Checks if `value` is classified as an `Array` object.
             *
             * @static
             * @memberOf _
             * @since 0.1.0
             * @category Lang
             * @param {*} value The value to check.
             * @returns {boolean} Returns `true` if `value` is an array, else `false`.
             * @example
             *
             * _.isArray([1, 2, 3]);
             * // => true
             *
             * _.isArray(document.body.children);
             * // => false
             *
             * _.isArray('abc');
             * // => false
             *
             * _.isArray(_.noop);
             * // => false
             */
            var isArray$6 = Array.isArray;

            var isArray_1$1 = isArray$6;

            /** Used for built-in method references. */
            var objectProto$b$1 = Object.prototype;

            /** Used to check objects for own properties. */
            var hasOwnProperty$9$1 = objectProto$b$1.hasOwnProperty;

            /**
             * Used to resolve the
             * [`toStringTag`](http://ecma-international.org/ecma-262/7.0/#sec-object.prototype.tostring)
             * of values.
             */
            var nativeObjectToString$1$1 = objectProto$b$1.toString;

            /** Built-in value references. */
            var symToStringTag$1$1 = _Symbol$1 ? _Symbol$1.toStringTag : undefined;

            /**
             * A specialized version of `baseGetTag` which ignores `Symbol.toStringTag` values.
             *
             * @private
             * @param {*} value The value to query.
             * @returns {string} Returns the raw `toStringTag`.
             */
            function getRawTag$1(value) {
              var isOwn = hasOwnProperty$9$1.call(value, symToStringTag$1$1),
                  tag = value[symToStringTag$1$1];

              try {
                value[symToStringTag$1$1] = undefined;
                var unmasked = true;
              } catch (e) {}

              var result = nativeObjectToString$1$1.call(value);
              if (unmasked) {
                if (isOwn) {
                  value[symToStringTag$1$1] = tag;
                } else {
                  delete value[symToStringTag$1$1];
                }
              }
              return result;
            }

            var _getRawTag$1 = getRawTag$1;

            /** Used for built-in method references. */
            var objectProto$a$1 = Object.prototype;

            /**
             * Used to resolve the
             * [`toStringTag`](http://ecma-international.org/ecma-262/7.0/#sec-object.prototype.tostring)
             * of values.
             */
            var nativeObjectToString$2 = objectProto$a$1.toString;

            /**
             * Converts `value` to a string using `Object.prototype.toString`.
             *
             * @private
             * @param {*} value The value to convert.
             * @returns {string} Returns the converted string.
             */
            function objectToString$4(value) {
              return nativeObjectToString$2.call(value);
            }

            var _objectToString$1 = objectToString$4;

            /** `Object#toString` result references. */
            var nullTag$1 = '[object Null]',
                undefinedTag$1 = '[object Undefined]';

            /** Built-in value references. */
            var symToStringTag$2 = _Symbol$1 ? _Symbol$1.toStringTag : undefined;

            /**
             * The base implementation of `getTag` without fallbacks for buggy environments.
             *
             * @private
             * @param {*} value The value to query.
             * @returns {string} Returns the `toStringTag`.
             */
            function baseGetTag$1(value) {
              if (value == null) {
                return value === undefined ? undefinedTag$1 : nullTag$1;
              }
              return (symToStringTag$2 && symToStringTag$2 in Object(value))
                ? _getRawTag$1(value)
                : _objectToString$1(value);
            }

            var _baseGetTag$1 = baseGetTag$1;

            /**
             * Checks if `value` is object-like. A value is object-like if it's not `null`
             * and has a `typeof` result of "object".
             *
             * @static
             * @memberOf _
             * @since 4.0.0
             * @category Lang
             * @param {*} value The value to check.
             * @returns {boolean} Returns `true` if `value` is object-like, else `false`.
             * @example
             *
             * _.isObjectLike({});
             * // => true
             *
             * _.isObjectLike([1, 2, 3]);
             * // => true
             *
             * _.isObjectLike(_.noop);
             * // => false
             *
             * _.isObjectLike(null);
             * // => false
             */
            function isObjectLike$3(value) {
              return value != null && typeof value == 'object';
            }

            var isObjectLike_1$1 = isObjectLike$3;

            /** `Object#toString` result references. */
            var symbolTag$6 = '[object Symbol]';

            /**
             * Checks if `value` is classified as a `Symbol` primitive or object.
             *
             * @static
             * @memberOf _
             * @since 4.0.0
             * @category Lang
             * @param {*} value The value to check.
             * @returns {boolean} Returns `true` if `value` is a symbol, else `false`.
             * @example
             *
             * _.isSymbol(Symbol.iterator);
             * // => true
             *
             * _.isSymbol('abc');
             * // => false
             */
            function isSymbol$3(value) {
              return typeof value == 'symbol' ||
                (isObjectLike_1$1(value) && _baseGetTag$1(value) == symbolTag$6);
            }

            var isSymbol_1$1 = isSymbol$3;

            /** Used as references for various `Number` constants. */
            var INFINITY$6 = 1 / 0;

            /** Used to convert symbols to primitives and strings. */
            var symbolProto$5 = _Symbol$1 ? _Symbol$1.prototype : undefined,
                symbolToString$3 = symbolProto$5 ? symbolProto$5.toString : undefined;

            /**
             * The base implementation of `_.toString` which doesn't convert nullish
             * values to empty strings.
             *
             * @private
             * @param {*} value The value to process.
             * @returns {string} Returns the string.
             */
            function baseToString$3(value) {
              // Exit early for strings to avoid a performance hit in some environments.
              if (typeof value == 'string') {
                return value;
              }
              if (isArray_1$1(value)) {
                // Recursively convert values (susceptible to call stack limits).
                return _arrayMap$1(value, baseToString$3) + '';
              }
              if (isSymbol_1$1(value)) {
                return symbolToString$3 ? symbolToString$3.call(value) : '';
              }
              var result = (value + '');
              return (result == '0' && (1 / value) == -INFINITY$6) ? '-0' : result;
            }

            var _baseToString$1 = baseToString$3;

            /**
             * Converts `value` to a string. An empty string is returned for `null`
             * and `undefined` values. The sign of `-0` is preserved.
             *
             * @static
             * @memberOf _
             * @since 4.0.0
             * @category Lang
             * @param {*} value The value to convert.
             * @returns {string} Returns the converted string.
             * @example
             *
             * _.toString(null);
             * // => ''
             *
             * _.toString(-0);
             * // => '-0'
             *
             * _.toString([1, 2, 3]);
             * // => '1,2,3'
             */
            function toString$4(value) {
              return value == null ? '' : _baseToString$1(value);
            }

            var toString_1$1 = toString$4;

            /**
             * The base implementation of `_.slice` without an iteratee call guard.
             *
             * @private
             * @param {Array} array The array to slice.
             * @param {number} [start=0] The start position.
             * @param {number} [end=array.length] The end position.
             * @returns {Array} Returns the slice of `array`.
             */
            function baseSlice$2(array, start, end) {
              var index = -1,
                  length = array.length;

              if (start < 0) {
                start = -start > length ? 0 : (length + start);
              }
              end = end > length ? length : end;
              if (end < 0) {
                end += length;
              }
              length = start > end ? 0 : ((end - start) >>> 0);
              start >>>= 0;

              var result = Array(length);
              while (++index < length) {
                result[index] = array[index + start];
              }
              return result;
            }

            var _baseSlice$1 = baseSlice$2;

            /**
             * Casts `array` to a slice if it's needed.
             *
             * @private
             * @param {Array} array The array to inspect.
             * @param {number} start The start position.
             * @param {number} [end=array.length] The end position.
             * @returns {Array} Returns the cast slice.
             */
            function castSlice$2(array, start, end) {
              var length = array.length;
              end = end === undefined ? length : end;
              return (!start && end >= length) ? array : _baseSlice$1(array, start, end);
            }

            var _castSlice$1 = castSlice$2;

            /** Used to compose unicode character classes. */
            var rsAstralRange$1$1 = '\\ud800-\\udfff',
                rsComboMarksRange$1$1 = '\\u0300-\\u036f',
                reComboHalfMarksRange$1$1 = '\\ufe20-\\ufe2f',
                rsComboSymbolsRange$1$1 = '\\u20d0-\\u20ff',
                rsComboRange$1$1 = rsComboMarksRange$1$1 + reComboHalfMarksRange$1$1 + rsComboSymbolsRange$1$1,
                rsVarRange$1$1 = '\\ufe0e\\ufe0f';

            /** Used to compose unicode capture groups. */
            var rsZWJ$1$1 = '\\u200d';

            /** Used to detect strings with [zero-width joiners or code points from the astral planes](http://eev.ee/blog/2015/09/12/dark-corners-of-unicode/). */
            var reHasUnicode$2 = RegExp('[' + rsZWJ$1$1 + rsAstralRange$1$1  + rsComboRange$1$1 + rsVarRange$1$1 + ']');

            /**
             * Checks if `string` contains Unicode symbols.
             *
             * @private
             * @param {string} string The string to inspect.
             * @returns {boolean} Returns `true` if a symbol is found, else `false`.
             */
            function hasUnicode$2(string) {
              return reHasUnicode$2.test(string);
            }

            var _hasUnicode$1 = hasUnicode$2;

            /**
             * Converts an ASCII `string` to an array.
             *
             * @private
             * @param {string} string The string to convert.
             * @returns {Array} Returns the converted array.
             */
            function asciiToArray$2(string) {
              return string.split('');
            }

            var _asciiToArray$1 = asciiToArray$2;

            /** Used to compose unicode character classes. */
            var rsAstralRange$5 = '\\ud800-\\udfff',
                rsComboMarksRange$6 = '\\u0300-\\u036f',
                reComboHalfMarksRange$4 = '\\ufe20-\\ufe2f',
                rsComboSymbolsRange$6 = '\\u20d0-\\u20ff',
                rsComboRange$4 = rsComboMarksRange$6 + reComboHalfMarksRange$4 + rsComboSymbolsRange$6,
                rsVarRange$5 = '\\ufe0e\\ufe0f';

            /** Used to compose unicode capture groups. */
            var rsAstral$2 = '[' + rsAstralRange$5 + ']',
                rsCombo$5 = '[' + rsComboRange$4 + ']',
                rsFitz$4 = '\\ud83c[\\udffb-\\udfff]',
                rsModifier$4 = '(?:' + rsCombo$5 + '|' + rsFitz$4 + ')',
                rsNonAstral$4 = '[^' + rsAstralRange$5 + ']',
                rsRegional$4 = '(?:\\ud83c[\\udde6-\\uddff]){2}',
                rsSurrPair$4 = '[\\ud800-\\udbff][\\udc00-\\udfff]',
                rsZWJ$5 = '\\u200d';

            /** Used to compose unicode regexes. */
            var reOptMod$4 = rsModifier$4 + '?',
                rsOptVar$4 = '[' + rsVarRange$5 + ']?',
                rsOptJoin$4 = '(?:' + rsZWJ$5 + '(?:' + [rsNonAstral$4, rsRegional$4, rsSurrPair$4].join('|') + ')' + rsOptVar$4 + reOptMod$4 + ')*',
                rsSeq$4 = rsOptVar$4 + reOptMod$4 + rsOptJoin$4,
                rsSymbol$2 = '(?:' + [rsNonAstral$4 + rsCombo$5 + '?', rsCombo$5, rsRegional$4, rsSurrPair$4, rsAstral$2].join('|') + ')';

            /** Used to match [string symbols](https://mathiasbynens.be/notes/javascript-unicode). */
            var reUnicode$2 = RegExp(rsFitz$4 + '(?=' + rsFitz$4 + ')|' + rsSymbol$2 + rsSeq$4, 'g');

            /**
             * Converts a Unicode `string` to an array.
             *
             * @private
             * @param {string} string The string to convert.
             * @returns {Array} Returns the converted array.
             */
            function unicodeToArray$2(string) {
              return string.match(reUnicode$2) || [];
            }

            var _unicodeToArray$1 = unicodeToArray$2;

            /**
             * Converts `string` to an array.
             *
             * @private
             * @param {string} string The string to convert.
             * @returns {Array} Returns the converted array.
             */
            function stringToArray$2(string) {
              return _hasUnicode$1(string)
                ? _unicodeToArray$1(string)
                : _asciiToArray$1(string);
            }

            var _stringToArray$1 = stringToArray$2;

            /**
             * Creates a function like `_.lowerFirst`.
             *
             * @private
             * @param {string} methodName The name of the `String` case method to use.
             * @returns {Function} Returns the new case function.
             */
            function createCaseFirst$2(methodName) {
              return function(string) {
                string = toString_1$1(string);

                var strSymbols = _hasUnicode$1(string)
                  ? _stringToArray$1(string)
                  : undefined;

                var chr = strSymbols
                  ? strSymbols[0]
                  : string.charAt(0);

                var trailing = strSymbols
                  ? _castSlice$1(strSymbols, 1).join('')
                  : string.slice(1);

                return chr[methodName]() + trailing;
              };
            }

            var _createCaseFirst$1 = createCaseFirst$2;

            /**
             * Converts the first character of `string` to upper case.
             *
             * @static
             * @memberOf _
             * @since 4.0.0
             * @category String
             * @param {string} [string=''] The string to convert.
             * @returns {string} Returns the converted string.
             * @example
             *
             * _.upperFirst('fred');
             * // => 'Fred'
             *
             * _.upperFirst('FRED');
             * // => 'FRED'
             */
            var upperFirst$2 = _createCaseFirst$1('toUpperCase');

            var upperFirst_1$1 = upperFirst$2;

            /**
             * Converts the first character of `string` to upper case and the remaining
             * to lower case.
             *
             * @static
             * @memberOf _
             * @since 3.0.0
             * @category String
             * @param {string} [string=''] The string to capitalize.
             * @returns {string} Returns the capitalized string.
             * @example
             *
             * _.capitalize('FRED');
             * // => 'Fred'
             */
            function capitalize$2(string) {
              return upperFirst_1$1(toString_1$1(string).toLowerCase());
            }

            var capitalize_1$1 = capitalize$2;

            var ResourcePreviewById = function (props) {
                props.id; var rest = __rest(props, ["id"]);
                var store = useLocalStore(function () { return ({
                    loading: false,
                    resourceInfo: null,
                    getResource: function () {
                        return __awaiter(this, void 0, void 0, function () {
                            var value, e_1;
                            return __generator(this, function (_a) {
                                switch (_a.label) {
                                    case 0:
                                        this.loading = true;
                                        _a.label = 1;
                                    case 1:
                                        _a.trys.push([1, 3, , 4]);
                                        return [4 /*yield*/, props.api[props.resourceName].findById(props.id)];
                                    case 2:
                                        value = _a.sent();
                                        this.resourceInfo = value;
                                        return [3 /*break*/, 4];
                                    case 3:
                                        e_1 = _a.sent();
                                        console.error(e_1);
                                        return [3 /*break*/, 4];
                                    case 4:
                                        this.loading = false;
                                        return [2 /*return*/];
                                }
                            });
                        });
                    },
                }); });
                useEffect(function () {
                    store.getResource();
                }, []);
                return useObserver(function () {
                    // TODO: HTTP cache, while loading show placeholder loading
                    if (store.loading) {
                        // TODO: fancy material placeholders
                        return jsx(CircularProgress, { disableShrink: true, size: 20 });
                    }
                    return ((store.resourceInfo && jsx(ResourcePreviewCell, __assign({ resource: store.resourceInfo }, rest))) || (jsx(React.Fragment, null)));
                });
            };
            function PickResourceList(props) {
                var store = useLocalStore(function () { return ({
                    get value() {
                        return props.value || [];
                    },
                }); });
                return useObserver(function () {
                    var _a;
                    return (jsx(React.Fragment, null,
                        jsx(Typography, { variant: "caption", css: { paddingBottom: 15, textAlign: 'center' } },
                            "Choose ",
                            pluralize.plural(props.resourceName)),
                        jsx("div", null, (_a = store.value) === null || _a === void 0 ? void 0 : _a.map(function (item, index) { return (jsx("div", { css: {
                                display: 'flex',
                                '&:hover button': {
                                    opacity: 1,
                                },
                            }, key: index },
                            jsx(ResourcePreviewById, { resourceName: props.resourceName, key: item, id: item, api: props.api }),
                            jsx(Tooltip, { title: "Remove product" },
                                jsx(IconButton, { css: {
                                        opacity: 0,
                                        transition: 'opacity 0.2s ease-in-out',
                                        padding: 5,
                                        marginLeft: 'auto',
                                        alignSelf: 'center',
                                    }, onClick: function () {
                                        var res = __spreadArrays(props.value).splice(props.value.indexOf(item) + 1, 1);
                                        props.onChange(res);
                                    } },
                                    jsx(Close$1, null))))); })),
                        jsx(Button, { color: "primary", variant: "outlined", fullWidth: true, css: { marginTop: 10 }, onClick: function () {
                                var close = appState.globalState.openDialog(jsx(ResourcePicker, { resourceName: props.resourceName, api: props.api, context: appState, omitIds: store.value, onChange: action(function (resource) {
                                        if (resource) {
                                            props.onChange(__spreadArrays((store.value || []), [String(resource.id)]));
                                        }
                                        close();
                                    }) }));
                            } },
                            "+ ",
                            capitalize_1$1(props.resourceName)),
                        jsx(Button, { color: "primary", variant: "outlined", fullWidth: true, css: { marginTop: 10 }, onClick: props.onDone }, "Done")));
                });
            }
            function PickResourcesListButton(props) {
                useEffect(function () {
                    if (typeof props.value === 'undefined') {
                        try {
                            props.onChange([]);
                        }
                        catch (e) {
                            console.warn('coudnt set default value', e);
                        }
                    }
                }, []);
                return useObserver(function () {
                    var _a, _b;
                    return (jsx(React.Fragment, null,
                        jsx(Button, { onClick: function () {
                                var close = appState.globalState.openDialog(jsx("div", { css: { padding: 30, width: 500, maxWidth: '90vw' } },
                                    jsx(PickResourceList, __assign({}, props, { onDone: function () { return close(); } }))));
                            }, color: "inherit", css: { color: '#999', whiteSpace: 'nowrap' } },
                            ((_a = props.value) === null || _a === void 0 ? void 0 : _a.length) || 0,
                            " ",
                            pluralize(props.resourceName, ((_b = props.value) === null || _b === void 0 ? void 0 : _b.length) || 0))));
                });
            }

            /**
             * Checks if `value` is the
             * [language type](http://www.ecma-international.org/ecma-262/7.0/#sec-ecmascript-language-types)
             * of `Object`. (e.g. arrays, functions, objects, regexes, `new Number(0)`, and `new String('')`)
             *
             * @static
             * @memberOf _
             * @since 0.1.0
             * @category Lang
             * @param {*} value The value to check.
             * @returns {boolean} Returns `true` if `value` is an object, else `false`.
             * @example
             *
             * _.isObject({});
             * // => true
             *
             * _.isObject([1, 2, 3]);
             * // => true
             *
             * _.isObject(_.noop);
             * // => true
             *
             * _.isObject(null);
             * // => false
             */
            function isObject$4(value) {
              var type = typeof value;
              return value != null && (type == 'object' || type == 'function');
            }

            var isObject_1$1 = isObject$4;

            /** `Object#toString` result references. */
            var asyncTag$1 = '[object AsyncFunction]',
                funcTag$1$1 = '[object Function]',
                genTag$2 = '[object GeneratorFunction]',
                proxyTag$1 = '[object Proxy]';

            /**
             * Checks if `value` is classified as a `Function` object.
             *
             * @static
             * @memberOf _
             * @since 0.1.0
             * @category Lang
             * @param {*} value The value to check.
             * @returns {boolean} Returns `true` if `value` is a function, else `false`.
             * @example
             *
             * _.isFunction(_);
             * // => true
             *
             * _.isFunction(/abc/);
             * // => false
             */
            function isFunction$5(value) {
              if (!isObject_1$1(value)) {
                return false;
              }
              // The use of `Object#toString` avoids issues with the `typeof` operator
              // in Safari 9 which returns 'object' for typed arrays and other constructors.
              var tag = _baseGetTag$1(value);
              return tag == funcTag$1$1 || tag == genTag$2 || tag == asyncTag$1 || tag == proxyTag$1;
            }

            var isFunction_1$1 = isFunction$5;

            /** Used to detect overreaching core-js shims. */
            var coreJsData$1 = _root$1['__core-js_shared__'];

            var _coreJsData$1 = coreJsData$1;

            /** Used to detect methods masquerading as native. */
            var maskSrcKey$1 = (function() {
              var uid = /[^.]+$/.exec(_coreJsData$1 && _coreJsData$1.keys && _coreJsData$1.keys.IE_PROTO || '');
              return uid ? ('Symbol(src)_1.' + uid) : '';
            }());

            /**
             * Checks if `func` has its source masked.
             *
             * @private
             * @param {Function} func The function to check.
             * @returns {boolean} Returns `true` if `func` is masked, else `false`.
             */
            function isMasked$1(func) {
              return !!maskSrcKey$1 && (maskSrcKey$1 in func);
            }

            var _isMasked$1 = isMasked$1;

            /** Used for built-in method references. */
            var funcProto$2 = Function.prototype;

            /** Used to resolve the decompiled source of functions. */
            var funcToString$2 = funcProto$2.toString;

            /**
             * Converts `func` to its source code.
             *
             * @private
             * @param {Function} func The function to convert.
             * @returns {string} Returns the source code.
             */
            function toSource$1(func) {
              if (func != null) {
                try {
                  return funcToString$2.call(func);
                } catch (e) {}
                try {
                  return (func + '');
                } catch (e) {}
              }
              return '';
            }

            var _toSource$1 = toSource$1;

            /**
             * Used to match `RegExp`
             * [syntax characters](http://ecma-international.org/ecma-262/7.0/#sec-patterns).
             */
            var reRegExpChar$1 = /[\\^$.*+?()[\]{}|]/g;

            /** Used to detect host constructors (Safari). */
            var reIsHostCtor$1 = /^\[object .+?Constructor\]$/;

            /** Used for built-in method references. */
            var funcProto$1$1 = Function.prototype,
                objectProto$9$1 = Object.prototype;

            /** Used to resolve the decompiled source of functions. */
            var funcToString$1$1 = funcProto$1$1.toString;

            /** Used to check objects for own properties. */
            var hasOwnProperty$8$1 = objectProto$9$1.hasOwnProperty;

            /** Used to detect if a method is native. */
            var reIsNative$1 = RegExp('^' +
              funcToString$1$1.call(hasOwnProperty$8$1).replace(reRegExpChar$1, '\\$&')
              .replace(/hasOwnProperty|(function).*?(?=\\\()| for .+?(?=\\\])/g, '$1.*?') + '$'
            );

            /**
             * The base implementation of `_.isNative` without bad shim checks.
             *
             * @private
             * @param {*} value The value to check.
             * @returns {boolean} Returns `true` if `value` is a native function,
             *  else `false`.
             */
            function baseIsNative$1(value) {
              if (!isObject_1$1(value) || _isMasked$1(value)) {
                return false;
              }
              var pattern = isFunction_1$1(value) ? reIsNative$1 : reIsHostCtor$1;
              return pattern.test(_toSource$1(value));
            }

            var _baseIsNative$1 = baseIsNative$1;

            /**
             * Gets the value at `key` of `object`.
             *
             * @private
             * @param {Object} [object] The object to query.
             * @param {string} key The key of the property to get.
             * @returns {*} Returns the property value.
             */
            function getValue$1(object, key) {
              return object == null ? undefined : object[key];
            }

            var _getValue$1 = getValue$1;

            /**
             * Gets the native function at `key` of `object`.
             *
             * @private
             * @param {Object} object The object to query.
             * @param {string} key The key of the method to get.
             * @returns {*} Returns the function if it's native, else `undefined`.
             */
            function getNative$1(object, key) {
              var value = _getValue$1(object, key);
              return _baseIsNative$1(value) ? value : undefined;
            }

            var _getNative$1 = getNative$1;

            var defineProperty$4 = (function() {
              try {
                var func = _getNative$1(Object, 'defineProperty');
                func({}, '', {});
                return func;
              } catch (e) {}
            }());

            var _defineProperty$2 = defineProperty$4;

            /**
             * The base implementation of `assignValue` and `assignMergeValue` without
             * value checks.
             *
             * @private
             * @param {Object} object The object to modify.
             * @param {string} key The key of the property to assign.
             * @param {*} value The value to assign.
             */
            function baseAssignValue$1(object, key, value) {
              if (key == '__proto__' && _defineProperty$2) {
                _defineProperty$2(object, key, {
                  'configurable': true,
                  'enumerable': true,
                  'value': value,
                  'writable': true
                });
              } else {
                object[key] = value;
              }
            }

            var _baseAssignValue$1 = baseAssignValue$1;

            /**
             * Performs a
             * [`SameValueZero`](http://ecma-international.org/ecma-262/7.0/#sec-samevaluezero)
             * comparison between two values to determine if they are equivalent.
             *
             * @static
             * @memberOf _
             * @since 4.0.0
             * @category Lang
             * @param {*} value The value to compare.
             * @param {*} other The other value to compare.
             * @returns {boolean} Returns `true` if the values are equivalent, else `false`.
             * @example
             *
             * var object = { 'a': 1 };
             * var other = { 'a': 1 };
             *
             * _.eq(object, object);
             * // => true
             *
             * _.eq(object, other);
             * // => false
             *
             * _.eq('a', 'a');
             * // => true
             *
             * _.eq('a', Object('a'));
             * // => false
             *
             * _.eq(NaN, NaN);
             * // => true
             */
            function eq$1(value, other) {
              return value === other || (value !== value && other !== other);
            }

            var eq_1$1 = eq$1;

            /** Used for built-in method references. */
            var objectProto$8$1 = Object.prototype;

            /** Used to check objects for own properties. */
            var hasOwnProperty$7$1 = objectProto$8$1.hasOwnProperty;

            /**
             * Assigns `value` to `key` of `object` if the existing value is not equivalent
             * using [`SameValueZero`](http://ecma-international.org/ecma-262/7.0/#sec-samevaluezero)
             * for equality comparisons.
             *
             * @private
             * @param {Object} object The object to modify.
             * @param {string} key The key of the property to assign.
             * @param {*} value The value to assign.
             */
            function assignValue$1(object, key, value) {
              var objValue = object[key];
              if (!(hasOwnProperty$7$1.call(object, key) && eq_1$1(objValue, value)) ||
                  (value === undefined && !(key in object))) {
                _baseAssignValue$1(object, key, value);
              }
            }

            var _assignValue$1 = assignValue$1;

            /**
             * Copies properties of `source` to `object`.
             *
             * @private
             * @param {Object} source The object to copy properties from.
             * @param {Array} props The property identifiers to copy.
             * @param {Object} [object={}] The object to copy properties to.
             * @param {Function} [customizer] The function to customize copied values.
             * @returns {Object} Returns `object`.
             */
            function copyObject$1(source, props, object, customizer) {
              var isNew = !object;
              object || (object = {});

              var index = -1,
                  length = props.length;

              while (++index < length) {
                var key = props[index];

                var newValue = customizer
                  ? customizer(object[key], source[key], key, object, source)
                  : undefined;

                if (newValue === undefined) {
                  newValue = source[key];
                }
                if (isNew) {
                  _baseAssignValue$1(object, key, newValue);
                } else {
                  _assignValue$1(object, key, newValue);
                }
              }
              return object;
            }

            var _copyObject$1 = copyObject$1;

            /**
             * This method returns the first argument it receives.
             *
             * @static
             * @since 0.1.0
             * @memberOf _
             * @category Util
             * @param {*} value Any value.
             * @returns {*} Returns `value`.
             * @example
             *
             * var object = { 'a': 1 };
             *
             * console.log(_.identity(object) === object);
             * // => true
             */
            function identity$1(value) {
              return value;
            }

            var identity_1$1 = identity$1;

            /**
             * A faster alternative to `Function#apply`, this function invokes `func`
             * with the `this` binding of `thisArg` and the arguments of `args`.
             *
             * @private
             * @param {Function} func The function to invoke.
             * @param {*} thisArg The `this` binding of `func`.
             * @param {Array} args The arguments to invoke `func` with.
             * @returns {*} Returns the result of `func`.
             */
            function apply(func, thisArg, args) {
              switch (args.length) {
                case 0: return func.call(thisArg);
                case 1: return func.call(thisArg, args[0]);
                case 2: return func.call(thisArg, args[0], args[1]);
                case 3: return func.call(thisArg, args[0], args[1], args[2]);
              }
              return func.apply(thisArg, args);
            }

            var _apply = apply;

            /* Built-in method references for those with the same name as other `lodash` methods. */
            var nativeMax$1 = Math.max;

            /**
             * A specialized version of `baseRest` which transforms the rest array.
             *
             * @private
             * @param {Function} func The function to apply a rest parameter to.
             * @param {number} [start=func.length-1] The start position of the rest parameter.
             * @param {Function} transform The rest array transform.
             * @returns {Function} Returns the new function.
             */
            function overRest(func, start, transform) {
              start = nativeMax$1(start === undefined ? (func.length - 1) : start, 0);
              return function() {
                var args = arguments,
                    index = -1,
                    length = nativeMax$1(args.length - start, 0),
                    array = Array(length);

                while (++index < length) {
                  array[index] = args[start + index];
                }
                index = -1;
                var otherArgs = Array(start + 1);
                while (++index < start) {
                  otherArgs[index] = args[index];
                }
                otherArgs[start] = transform(array);
                return _apply(func, this, otherArgs);
              };
            }

            var _overRest = overRest;

            /**
             * Creates a function that returns `value`.
             *
             * @static
             * @memberOf _
             * @since 2.4.0
             * @category Util
             * @param {*} value The value to return from the new function.
             * @returns {Function} Returns the new constant function.
             * @example
             *
             * var objects = _.times(2, _.constant({ 'a': 1 }));
             *
             * console.log(objects);
             * // => [{ 'a': 1 }, { 'a': 1 }]
             *
             * console.log(objects[0] === objects[1]);
             * // => true
             */
            function constant(value) {
              return function() {
                return value;
              };
            }

            var constant_1 = constant;

            /**
             * The base implementation of `setToString` without support for hot loop shorting.
             *
             * @private
             * @param {Function} func The function to modify.
             * @param {Function} string The `toString` result.
             * @returns {Function} Returns `func`.
             */
            var baseSetToString = !_defineProperty$2 ? identity_1$1 : function(func, string) {
              return _defineProperty$2(func, 'toString', {
                'configurable': true,
                'enumerable': false,
                'value': constant_1(string),
                'writable': true
              });
            };

            var _baseSetToString = baseSetToString;

            /** Used to detect hot functions by number of calls within a span of milliseconds. */
            var HOT_COUNT = 800,
                HOT_SPAN = 16;

            /* Built-in method references for those with the same name as other `lodash` methods. */
            var nativeNow = Date.now;

            /**
             * Creates a function that'll short out and invoke `identity` instead
             * of `func` when it's called `HOT_COUNT` or more times in `HOT_SPAN`
             * milliseconds.
             *
             * @private
             * @param {Function} func The function to restrict.
             * @returns {Function} Returns the new shortable function.
             */
            function shortOut(func) {
              var count = 0,
                  lastCalled = 0;

              return function() {
                var stamp = nativeNow(),
                    remaining = HOT_SPAN - (stamp - lastCalled);

                lastCalled = stamp;
                if (remaining > 0) {
                  if (++count >= HOT_COUNT) {
                    return arguments[0];
                  }
                } else {
                  count = 0;
                }
                return func.apply(undefined, arguments);
              };
            }

            var _shortOut = shortOut;

            /**
             * Sets the `toString` method of `func` to return `string`.
             *
             * @private
             * @param {Function} func The function to modify.
             * @param {Function} string The `toString` result.
             * @returns {Function} Returns `func`.
             */
            var setToString = _shortOut(_baseSetToString);

            var _setToString = setToString;

            /**
             * The base implementation of `_.rest` which doesn't validate or coerce arguments.
             *
             * @private
             * @param {Function} func The function to apply a rest parameter to.
             * @param {number} [start=func.length-1] The start position of the rest parameter.
             * @returns {Function} Returns the new function.
             */
            function baseRest(func, start) {
              return _setToString(_overRest(func, start, identity_1$1), func + '');
            }

            var _baseRest = baseRest;

            /** Used as references for various `Number` constants. */
            var MAX_SAFE_INTEGER$1$1 = 9007199254740991;

            /**
             * Checks if `value` is a valid array-like length.
             *
             * **Note:** This method is loosely based on
             * [`ToLength`](http://ecma-international.org/ecma-262/7.0/#sec-tolength).
             *
             * @static
             * @memberOf _
             * @since 4.0.0
             * @category Lang
             * @param {*} value The value to check.
             * @returns {boolean} Returns `true` if `value` is a valid length, else `false`.
             * @example
             *
             * _.isLength(3);
             * // => true
             *
             * _.isLength(Number.MIN_VALUE);
             * // => false
             *
             * _.isLength(Infinity);
             * // => false
             *
             * _.isLength('3');
             * // => false
             */
            function isLength$1(value) {
              return typeof value == 'number' &&
                value > -1 && value % 1 == 0 && value <= MAX_SAFE_INTEGER$1$1;
            }

            var isLength_1$1 = isLength$1;

            /**
             * Checks if `value` is array-like. A value is considered array-like if it's
             * not a function and has a `value.length` that's an integer greater than or
             * equal to `0` and less than or equal to `Number.MAX_SAFE_INTEGER`.
             *
             * @static
             * @memberOf _
             * @since 4.0.0
             * @category Lang
             * @param {*} value The value to check.
             * @returns {boolean} Returns `true` if `value` is array-like, else `false`.
             * @example
             *
             * _.isArrayLike([1, 2, 3]);
             * // => true
             *
             * _.isArrayLike(document.body.children);
             * // => true
             *
             * _.isArrayLike('abc');
             * // => true
             *
             * _.isArrayLike(_.noop);
             * // => false
             */
            function isArrayLike$1(value) {
              return value != null && isLength_1$1(value.length) && !isFunction_1$1(value);
            }

            var isArrayLike_1$1 = isArrayLike$1;

            /** Used as references for various `Number` constants. */
            var MAX_SAFE_INTEGER$2 = 9007199254740991;

            /** Used to detect unsigned integer values. */
            var reIsUint$1 = /^(?:0|[1-9]\d*)$/;

            /**
             * Checks if `value` is a valid array-like index.
             *
             * @private
             * @param {*} value The value to check.
             * @param {number} [length=MAX_SAFE_INTEGER] The upper bounds of a valid index.
             * @returns {boolean} Returns `true` if `value` is a valid index, else `false`.
             */
            function isIndex$1(value, length) {
              var type = typeof value;
              length = length == null ? MAX_SAFE_INTEGER$2 : length;

              return !!length &&
                (type == 'number' ||
                  (type != 'symbol' && reIsUint$1.test(value))) &&
                    (value > -1 && value % 1 == 0 && value < length);
            }

            var _isIndex$1 = isIndex$1;

            /**
             * Checks if the given arguments are from an iteratee call.
             *
             * @private
             * @param {*} value The potential iteratee value argument.
             * @param {*} index The potential iteratee index or key argument.
             * @param {*} object The potential iteratee object argument.
             * @returns {boolean} Returns `true` if the arguments are from an iteratee call,
             *  else `false`.
             */
            function isIterateeCall(value, index, object) {
              if (!isObject_1$1(object)) {
                return false;
              }
              var type = typeof index;
              if (type == 'number'
                    ? (isArrayLike_1$1(object) && _isIndex$1(index, object.length))
                    : (type == 'string' && index in object)
                  ) {
                return eq_1$1(object[index], value);
              }
              return false;
            }

            var _isIterateeCall = isIterateeCall;

            /**
             * Creates a function like `_.assign`.
             *
             * @private
             * @param {Function} assigner The function to assign values.
             * @returns {Function} Returns the new assigner function.
             */
            function createAssigner(assigner) {
              return _baseRest(function(object, sources) {
                var index = -1,
                    length = sources.length,
                    customizer = length > 1 ? sources[length - 1] : undefined,
                    guard = length > 2 ? sources[2] : undefined;

                customizer = (assigner.length > 3 && typeof customizer == 'function')
                  ? (length--, customizer)
                  : undefined;

                if (guard && _isIterateeCall(sources[0], sources[1], guard)) {
                  customizer = length < 3 ? undefined : customizer;
                  length = 1;
                }
                object = Object(object);
                while (++index < length) {
                  var source = sources[index];
                  if (source) {
                    assigner(object, source, index, customizer);
                  }
                }
                return object;
              });
            }

            var _createAssigner = createAssigner;

            /**
             * The base implementation of `_.times` without support for iteratee shorthands
             * or max array length checks.
             *
             * @private
             * @param {number} n The number of times to invoke `iteratee`.
             * @param {Function} iteratee The function invoked per iteration.
             * @returns {Array} Returns the array of results.
             */
            function baseTimes$1(n, iteratee) {
              var index = -1,
                  result = Array(n);

              while (++index < n) {
                result[index] = iteratee(index);
              }
              return result;
            }

            var _baseTimes$1 = baseTimes$1;

            /** `Object#toString` result references. */
            var argsTag$1$1 = '[object Arguments]';

            /**
             * The base implementation of `_.isArguments`.
             *
             * @private
             * @param {*} value The value to check.
             * @returns {boolean} Returns `true` if `value` is an `arguments` object,
             */
            function baseIsArguments$1(value) {
              return isObjectLike_1$1(value) && _baseGetTag$1(value) == argsTag$1$1;
            }

            var _baseIsArguments$1 = baseIsArguments$1;

            /** Used for built-in method references. */
            var objectProto$7$1 = Object.prototype;

            /** Used to check objects for own properties. */
            var hasOwnProperty$6$1 = objectProto$7$1.hasOwnProperty;

            /** Built-in value references. */
            var propertyIsEnumerable$2 = objectProto$7$1.propertyIsEnumerable;

            /**
             * Checks if `value` is likely an `arguments` object.
             *
             * @static
             * @memberOf _
             * @since 0.1.0
             * @category Lang
             * @param {*} value The value to check.
             * @returns {boolean} Returns `true` if `value` is an `arguments` object,
             *  else `false`.
             * @example
             *
             * _.isArguments(function() { return arguments; }());
             * // => true
             *
             * _.isArguments([1, 2, 3]);
             * // => false
             */
            var isArguments$1 = _baseIsArguments$1(function() { return arguments; }()) ? _baseIsArguments$1 : function(value) {
              return isObjectLike_1$1(value) && hasOwnProperty$6$1.call(value, 'callee') &&
                !propertyIsEnumerable$2.call(value, 'callee');
            };

            var isArguments_1$1 = isArguments$1;

            /**
             * This method returns `false`.
             *
             * @static
             * @memberOf _
             * @since 4.13.0
             * @category Util
             * @returns {boolean} Returns `false`.
             * @example
             *
             * _.times(2, _.stubFalse);
             * // => [false, false]
             */
            function stubFalse$1() {
              return false;
            }

            var stubFalse_1$1 = stubFalse$1;

            var isBuffer_1$1 = createCommonjsModule$1(function (module, exports) {
            /** Detect free variable `exports`. */
            var freeExports = exports && !exports.nodeType && exports;

            /** Detect free variable `module`. */
            var freeModule = freeExports && 'object' == 'object' && module && !module.nodeType && module;

            /** Detect the popular CommonJS extension `module.exports`. */
            var moduleExports = freeModule && freeModule.exports === freeExports;

            /** Built-in value references. */
            var Buffer = moduleExports ? _root$1.Buffer : undefined;

            /* Built-in method references for those with the same name as other `lodash` methods. */
            var nativeIsBuffer = Buffer ? Buffer.isBuffer : undefined;

            /**
             * Checks if `value` is a buffer.
             *
             * @static
             * @memberOf _
             * @since 4.3.0
             * @category Lang
             * @param {*} value The value to check.
             * @returns {boolean} Returns `true` if `value` is a buffer, else `false`.
             * @example
             *
             * _.isBuffer(new Buffer(2));
             * // => true
             *
             * _.isBuffer(new Uint8Array(2));
             * // => false
             */
            var isBuffer = nativeIsBuffer || stubFalse_1$1;

            module.exports = isBuffer;
            });

            /** `Object#toString` result references. */
            var argsTag$4 = '[object Arguments]',
                arrayTag$3 = '[object Array]',
                boolTag$4 = '[object Boolean]',
                dateTag$4 = '[object Date]',
                errorTag$1$1 = '[object Error]',
                funcTag$3 = '[object Function]',
                mapTag$7 = '[object Map]',
                numberTag$4 = '[object Number]',
                objectTag$1$1 = '[object Object]',
                regexpTag$4 = '[object RegExp]',
                setTag$7 = '[object Set]',
                stringTag$4 = '[object String]',
                weakMapTag$3 = '[object WeakMap]';

            var arrayBufferTag$4 = '[object ArrayBuffer]',
                dataViewTag$5 = '[object DataView]',
                float32Tag$3 = '[object Float32Array]',
                float64Tag$3 = '[object Float64Array]',
                int8Tag$3 = '[object Int8Array]',
                int16Tag$3 = '[object Int16Array]',
                int32Tag$3 = '[object Int32Array]',
                uint8Tag$3 = '[object Uint8Array]',
                uint8ClampedTag$3 = '[object Uint8ClampedArray]',
                uint16Tag$3 = '[object Uint16Array]',
                uint32Tag$3 = '[object Uint32Array]';

            /** Used to identify `toStringTag` values of typed arrays. */
            var typedArrayTags$1 = {};
            typedArrayTags$1[float32Tag$3] = typedArrayTags$1[float64Tag$3] =
            typedArrayTags$1[int8Tag$3] = typedArrayTags$1[int16Tag$3] =
            typedArrayTags$1[int32Tag$3] = typedArrayTags$1[uint8Tag$3] =
            typedArrayTags$1[uint8ClampedTag$3] = typedArrayTags$1[uint16Tag$3] =
            typedArrayTags$1[uint32Tag$3] = true;
            typedArrayTags$1[argsTag$4] = typedArrayTags$1[arrayTag$3] =
            typedArrayTags$1[arrayBufferTag$4] = typedArrayTags$1[boolTag$4] =
            typedArrayTags$1[dataViewTag$5] = typedArrayTags$1[dateTag$4] =
            typedArrayTags$1[errorTag$1$1] = typedArrayTags$1[funcTag$3] =
            typedArrayTags$1[mapTag$7] = typedArrayTags$1[numberTag$4] =
            typedArrayTags$1[objectTag$1$1] = typedArrayTags$1[regexpTag$4] =
            typedArrayTags$1[setTag$7] = typedArrayTags$1[stringTag$4] =
            typedArrayTags$1[weakMapTag$3] = false;

            /**
             * The base implementation of `_.isTypedArray` without Node.js optimizations.
             *
             * @private
             * @param {*} value The value to check.
             * @returns {boolean} Returns `true` if `value` is a typed array, else `false`.
             */
            function baseIsTypedArray$1(value) {
              return isObjectLike_1$1(value) &&
                isLength_1$1(value.length) && !!typedArrayTags$1[_baseGetTag$1(value)];
            }

            var _baseIsTypedArray$1 = baseIsTypedArray$1;

            /**
             * The base implementation of `_.unary` without support for storing metadata.
             *
             * @private
             * @param {Function} func The function to cap arguments for.
             * @returns {Function} Returns the new capped function.
             */
            function baseUnary$1(func) {
              return function(value) {
                return func(value);
              };
            }

            var _baseUnary$1 = baseUnary$1;

            var _nodeUtil$1 = createCommonjsModule$1(function (module, exports) {
            /** Detect free variable `exports`. */
            var freeExports = exports && !exports.nodeType && exports;

            /** Detect free variable `module`. */
            var freeModule = freeExports && 'object' == 'object' && module && !module.nodeType && module;

            /** Detect the popular CommonJS extension `module.exports`. */
            var moduleExports = freeModule && freeModule.exports === freeExports;

            /** Detect free variable `process` from Node.js. */
            var freeProcess = moduleExports && _freeGlobal$1.process;

            /** Used to access faster Node.js helpers. */
            var nodeUtil = (function() {
              try {
                // Use `util.types` for Node.js 10+.
                var types = freeModule && freeModule.require && freeModule.require('util').types;

                if (types) {
                  return types;
                }

                // Legacy `process.binding('util')` for Node.js < 10.
                return freeProcess && freeProcess.binding && freeProcess.binding('util');
              } catch (e) {}
            }());

            module.exports = nodeUtil;
            });

            /* Node.js helper references. */
            var nodeIsTypedArray$1 = _nodeUtil$1 && _nodeUtil$1.isTypedArray;

            /**
             * Checks if `value` is classified as a typed array.
             *
             * @static
             * @memberOf _
             * @since 3.0.0
             * @category Lang
             * @param {*} value The value to check.
             * @returns {boolean} Returns `true` if `value` is a typed array, else `false`.
             * @example
             *
             * _.isTypedArray(new Uint8Array);
             * // => true
             *
             * _.isTypedArray([]);
             * // => false
             */
            var isTypedArray$1 = nodeIsTypedArray$1 ? _baseUnary$1(nodeIsTypedArray$1) : _baseIsTypedArray$1;

            var isTypedArray_1$1 = isTypedArray$1;

            /** Used for built-in method references. */
            var objectProto$6$1 = Object.prototype;

            /** Used to check objects for own properties. */
            var hasOwnProperty$5$1 = objectProto$6$1.hasOwnProperty;

            /**
             * Creates an array of the enumerable property names of the array-like `value`.
             *
             * @private
             * @param {*} value The value to query.
             * @param {boolean} inherited Specify returning inherited property names.
             * @returns {Array} Returns the array of property names.
             */
            function arrayLikeKeys$1(value, inherited) {
              var isArr = isArray_1$1(value),
                  isArg = !isArr && isArguments_1$1(value),
                  isBuff = !isArr && !isArg && isBuffer_1$1(value),
                  isType = !isArr && !isArg && !isBuff && isTypedArray_1$1(value),
                  skipIndexes = isArr || isArg || isBuff || isType,
                  result = skipIndexes ? _baseTimes$1(value.length, String) : [],
                  length = result.length;

              for (var key in value) {
                if ((inherited || hasOwnProperty$5$1.call(value, key)) &&
                    !(skipIndexes && (
                       // Safari 9 has enumerable `arguments.length` in strict mode.
                       key == 'length' ||
                       // Node.js 0.10 has enumerable non-index properties on buffers.
                       (isBuff && (key == 'offset' || key == 'parent')) ||
                       // PhantomJS 2 has enumerable non-index properties on typed arrays.
                       (isType && (key == 'buffer' || key == 'byteLength' || key == 'byteOffset')) ||
                       // Skip index properties.
                       _isIndex$1(key, length)
                    ))) {
                  result.push(key);
                }
              }
              return result;
            }

            var _arrayLikeKeys$1 = arrayLikeKeys$1;

            /** Used for built-in method references. */
            var objectProto$5$1 = Object.prototype;

            /**
             * Checks if `value` is likely a prototype object.
             *
             * @private
             * @param {*} value The value to check.
             * @returns {boolean} Returns `true` if `value` is a prototype, else `false`.
             */
            function isPrototype$1(value) {
              var Ctor = value && value.constructor,
                  proto = (typeof Ctor == 'function' && Ctor.prototype) || objectProto$5$1;

              return value === proto;
            }

            var _isPrototype$1 = isPrototype$1;

            /**
             * This function is like
             * [`Object.keys`](http://ecma-international.org/ecma-262/7.0/#sec-object.keys)
             * except that it includes inherited enumerable properties.
             *
             * @private
             * @param {Object} object The object to query.
             * @returns {Array} Returns the array of property names.
             */
            function nativeKeysIn$1(object) {
              var result = [];
              if (object != null) {
                for (var key in Object(object)) {
                  result.push(key);
                }
              }
              return result;
            }

            var _nativeKeysIn$1 = nativeKeysIn$1;

            /** Used for built-in method references. */
            var objectProto$4$1 = Object.prototype;

            /** Used to check objects for own properties. */
            var hasOwnProperty$4$1 = objectProto$4$1.hasOwnProperty;

            /**
             * The base implementation of `_.keysIn` which doesn't treat sparse arrays as dense.
             *
             * @private
             * @param {Object} object The object to query.
             * @returns {Array} Returns the array of property names.
             */
            function baseKeysIn$1(object) {
              if (!isObject_1$1(object)) {
                return _nativeKeysIn$1(object);
              }
              var isProto = _isPrototype$1(object),
                  result = [];

              for (var key in object) {
                if (!(key == 'constructor' && (isProto || !hasOwnProperty$4$1.call(object, key)))) {
                  result.push(key);
                }
              }
              return result;
            }

            var _baseKeysIn$1 = baseKeysIn$1;

            /**
             * Creates an array of the own and inherited enumerable property names of `object`.
             *
             * **Note:** Non-object values are coerced to objects.
             *
             * @static
             * @memberOf _
             * @since 3.0.0
             * @category Object
             * @param {Object} object The object to query.
             * @returns {Array} Returns the array of property names.
             * @example
             *
             * function Foo() {
             *   this.a = 1;
             *   this.b = 2;
             * }
             *
             * Foo.prototype.c = 3;
             *
             * _.keysIn(new Foo);
             * // => ['a', 'b', 'c'] (iteration order is not guaranteed)
             */
            function keysIn$1(object) {
              return isArrayLike_1$1(object) ? _arrayLikeKeys$1(object, true) : _baseKeysIn$1(object);
            }

            var keysIn_1$1 = keysIn$1;

            /**
             * This method is like `_.assignIn` except that it accepts `customizer`
             * which is invoked to produce the assigned values. If `customizer` returns
             * `undefined`, assignment is handled by the method instead. The `customizer`
             * is invoked with five arguments: (objValue, srcValue, key, object, source).
             *
             * **Note:** This method mutates `object`.
             *
             * @static
             * @memberOf _
             * @since 4.0.0
             * @alias extendWith
             * @category Object
             * @param {Object} object The destination object.
             * @param {...Object} sources The source objects.
             * @param {Function} [customizer] The function to customize assigned values.
             * @returns {Object} Returns `object`.
             * @see _.assignWith
             * @example
             *
             * function customizer(objValue, srcValue) {
             *   return _.isUndefined(objValue) ? srcValue : objValue;
             * }
             *
             * var defaults = _.partialRight(_.assignInWith, customizer);
             *
             * defaults({ 'a': 1 }, { 'b': 2 }, { 'a': 3 });
             * // => { 'a': 1, 'b': 2 }
             */
            var assignInWith = _createAssigner(function(object, source, srcIndex, customizer) {
              _copyObject$1(source, keysIn_1$1(source), object, customizer);
            });

            var assignInWith_1 = assignInWith;

            /**
             * Creates a unary function that invokes `func` with its argument transformed.
             *
             * @private
             * @param {Function} func The function to wrap.
             * @param {Function} transform The argument transform.
             * @returns {Function} Returns the new function.
             */
            function overArg$1(func, transform) {
              return function(arg) {
                return func(transform(arg));
              };
            }

            var _overArg$1 = overArg$1;

            /** Built-in value references. */
            var getPrototype$1 = _overArg$1(Object.getPrototypeOf, Object);

            var _getPrototype$1 = getPrototype$1;

            /** `Object#toString` result references. */
            var objectTag$4 = '[object Object]';

            /** Used for built-in method references. */
            var funcProto$3 = Function.prototype,
                objectProto$3$1 = Object.prototype;

            /** Used to resolve the decompiled source of functions. */
            var funcToString$3 = funcProto$3.toString;

            /** Used to check objects for own properties. */
            var hasOwnProperty$3$1 = objectProto$3$1.hasOwnProperty;

            /** Used to infer the `Object` constructor. */
            var objectCtorString = funcToString$3.call(Object);

            /**
             * Checks if `value` is a plain object, that is, an object created by the
             * `Object` constructor or one with a `[[Prototype]]` of `null`.
             *
             * @static
             * @memberOf _
             * @since 0.8.0
             * @category Lang
             * @param {*} value The value to check.
             * @returns {boolean} Returns `true` if `value` is a plain object, else `false`.
             * @example
             *
             * function Foo() {
             *   this.a = 1;
             * }
             *
             * _.isPlainObject(new Foo);
             * // => false
             *
             * _.isPlainObject([1, 2, 3]);
             * // => false
             *
             * _.isPlainObject({ 'x': 0, 'y': 0 });
             * // => true
             *
             * _.isPlainObject(Object.create(null));
             * // => true
             */
            function isPlainObject(value) {
              if (!isObjectLike_1$1(value) || _baseGetTag$1(value) != objectTag$4) {
                return false;
              }
              var proto = _getPrototype$1(value);
              if (proto === null) {
                return true;
              }
              var Ctor = hasOwnProperty$3$1.call(proto, 'constructor') && proto.constructor;
              return typeof Ctor == 'function' && Ctor instanceof Ctor &&
                funcToString$3.call(Ctor) == objectCtorString;
            }

            var isPlainObject_1 = isPlainObject;

            /** `Object#toString` result references. */
            var domExcTag = '[object DOMException]',
                errorTag$3 = '[object Error]';

            /**
             * Checks if `value` is an `Error`, `EvalError`, `RangeError`, `ReferenceError`,
             * `SyntaxError`, `TypeError`, or `URIError` object.
             *
             * @static
             * @memberOf _
             * @since 3.0.0
             * @category Lang
             * @param {*} value The value to check.
             * @returns {boolean} Returns `true` if `value` is an error object, else `false`.
             * @example
             *
             * _.isError(new Error);
             * // => true
             *
             * _.isError(Error);
             * // => false
             */
            function isError$1(value) {
              if (!isObjectLike_1$1(value)) {
                return false;
              }
              var tag = _baseGetTag$1(value);
              return tag == errorTag$3 || tag == domExcTag ||
                (typeof value.message == 'string' && typeof value.name == 'string' && !isPlainObject_1(value));
            }

            var isError_1 = isError$1;

            /**
             * Attempts to invoke `func`, returning either the result or the caught error
             * object. Any additional arguments are provided to `func` when it's invoked.
             *
             * @static
             * @memberOf _
             * @since 3.0.0
             * @category Util
             * @param {Function} func The function to attempt.
             * @param {...*} [args] The arguments to invoke `func` with.
             * @returns {*} Returns the `func` result or error object.
             * @example
             *
             * // Avoid throwing errors for invalid selectors.
             * var elements = _.attempt(function(selector) {
             *   return document.querySelectorAll(selector);
             * }, '>_>');
             *
             * if (_.isError(elements)) {
             *   elements = [];
             * }
             */
            var attempt = _baseRest(function(func, args) {
              try {
                return _apply(func, undefined, args);
              } catch (e) {
                return isError_1(e) ? e : new Error(e);
              }
            });

            var attempt_1 = attempt;

            /**
             * The base implementation of `_.values` and `_.valuesIn` which creates an
             * array of `object` property values corresponding to the property names
             * of `props`.
             *
             * @private
             * @param {Object} object The object to query.
             * @param {Array} props The property names to get values for.
             * @returns {Object} Returns the array of property values.
             */
            function baseValues(object, props) {
              return _arrayMap$1(props, function(key) {
                return object[key];
              });
            }

            var _baseValues = baseValues;

            /** Used for built-in method references. */
            var objectProto$2$1 = Object.prototype;

            /** Used to check objects for own properties. */
            var hasOwnProperty$2$1 = objectProto$2$1.hasOwnProperty;

            /**
             * Used by `_.defaults` to customize its `_.assignIn` use to assign properties
             * of source objects to the destination object for all destination properties
             * that resolve to `undefined`.
             *
             * @private
             * @param {*} objValue The destination value.
             * @param {*} srcValue The source value.
             * @param {string} key The key of the property to assign.
             * @param {Object} object The parent object of `objValue`.
             * @returns {*} Returns the value to assign.
             */
            function customDefaultsAssignIn(objValue, srcValue, key, object) {
              if (objValue === undefined ||
                  (eq_1$1(objValue, objectProto$2$1[key]) && !hasOwnProperty$2$1.call(object, key))) {
                return srcValue;
              }
              return objValue;
            }

            var _customDefaultsAssignIn = customDefaultsAssignIn;

            /** Used to escape characters for inclusion in compiled string literals. */
            var stringEscapes = {
              '\\': '\\',
              "'": "'",
              '\n': 'n',
              '\r': 'r',
              '\u2028': 'u2028',
              '\u2029': 'u2029'
            };

            /**
             * Used by `_.template` to escape characters for inclusion in compiled string literals.
             *
             * @private
             * @param {string} chr The matched character to escape.
             * @returns {string} Returns the escaped character.
             */
            function escapeStringChar(chr) {
              return '\\' + stringEscapes[chr];
            }

            var _escapeStringChar = escapeStringChar;

            /* Built-in method references for those with the same name as other `lodash` methods. */
            var nativeKeys$1 = _overArg$1(Object.keys, Object);

            var _nativeKeys$1 = nativeKeys$1;

            /** Used for built-in method references. */
            var objectProto$1$1 = Object.prototype;

            /** Used to check objects for own properties. */
            var hasOwnProperty$1$1 = objectProto$1$1.hasOwnProperty;

            /**
             * The base implementation of `_.keys` which doesn't treat sparse arrays as dense.
             *
             * @private
             * @param {Object} object The object to query.
             * @returns {Array} Returns the array of property names.
             */
            function baseKeys$1(object) {
              if (!_isPrototype$1(object)) {
                return _nativeKeys$1(object);
              }
              var result = [];
              for (var key in Object(object)) {
                if (hasOwnProperty$1$1.call(object, key) && key != 'constructor') {
                  result.push(key);
                }
              }
              return result;
            }

            var _baseKeys$1 = baseKeys$1;

            /**
             * Creates an array of the own enumerable property names of `object`.
             *
             * **Note:** Non-object values are coerced to objects. See the
             * [ES spec](http://ecma-international.org/ecma-262/7.0/#sec-object.keys)
             * for more details.
             *
             * @static
             * @since 0.1.0
             * @memberOf _
             * @category Object
             * @param {Object} object The object to query.
             * @returns {Array} Returns the array of property names.
             * @example
             *
             * function Foo() {
             *   this.a = 1;
             *   this.b = 2;
             * }
             *
             * Foo.prototype.c = 3;
             *
             * _.keys(new Foo);
             * // => ['a', 'b'] (iteration order is not guaranteed)
             *
             * _.keys('hi');
             * // => ['0', '1']
             */
            function keys$2(object) {
              return isArrayLike_1$1(object) ? _arrayLikeKeys$1(object) : _baseKeys$1(object);
            }

            var keys_1$1 = keys$2;

            /** Used to match template delimiters. */
            var reInterpolate = /<%=([\s\S]+?)%>/g;

            var _reInterpolate = reInterpolate;

            /**
             * The base implementation of `_.propertyOf` without support for deep paths.
             *
             * @private
             * @param {Object} object The object to query.
             * @returns {Function} Returns the new accessor function.
             */
            function basePropertyOf$3(object) {
              return function(key) {
                return object == null ? undefined : object[key];
              };
            }

            var _basePropertyOf$1 = basePropertyOf$3;

            /** Used to map characters to HTML entities. */
            var htmlEscapes = {
              '&': '&amp;',
              '<': '&lt;',
              '>': '&gt;',
              '"': '&quot;',
              "'": '&#39;'
            };

            /**
             * Used by `_.escape` to convert characters to HTML entities.
             *
             * @private
             * @param {string} chr The matched character to escape.
             * @returns {string} Returns the escaped character.
             */
            var escapeHtmlChar = _basePropertyOf$1(htmlEscapes);

            var _escapeHtmlChar = escapeHtmlChar;

            /** Used to match HTML entities and HTML characters. */
            var reUnescapedHtml = /[&<>"']/g,
                reHasUnescapedHtml = RegExp(reUnescapedHtml.source);

            /**
             * Converts the characters "&", "<", ">", '"', and "'" in `string` to their
             * corresponding HTML entities.
             *
             * **Note:** No other characters are escaped. To escape additional
             * characters use a third-party library like [_he_](https://mths.be/he).
             *
             * Though the ">" character is escaped for symmetry, characters like
             * ">" and "/" don't need escaping in HTML and have no special meaning
             * unless they're part of a tag or unquoted attribute value. See
             * [Mathias Bynens's article](https://mathiasbynens.be/notes/ambiguous-ampersands)
             * (under "semi-related fun fact") for more details.
             *
             * When working with HTML you should always
             * [quote attribute values](http://wonko.com/post/html-escaping) to reduce
             * XSS vectors.
             *
             * @static
             * @since 0.1.0
             * @memberOf _
             * @category String
             * @param {string} [string=''] The string to escape.
             * @returns {string} Returns the escaped string.
             * @example
             *
             * _.escape('fred, barney, & pebbles');
             * // => 'fred, barney, &amp; pebbles'
             */
            function escape$1(string) {
              string = toString_1$1(string);
              return (string && reHasUnescapedHtml.test(string))
                ? string.replace(reUnescapedHtml, _escapeHtmlChar)
                : string;
            }

            var _escape = escape$1;

            /** Used to match template delimiters. */
            var reEscape = /<%-([\s\S]+?)%>/g;

            var _reEscape = reEscape;

            /** Used to match template delimiters. */
            var reEvaluate = /<%([\s\S]+?)%>/g;

            var _reEvaluate = reEvaluate;

            /**
             * By default, the template delimiters used by lodash are like those in
             * embedded Ruby (ERB) as well as ES2015 template strings. Change the
             * following template settings to use alternative delimiters.
             *
             * @static
             * @memberOf _
             * @type {Object}
             */
            var templateSettings = {

              /**
               * Used to detect `data` property values to be HTML-escaped.
               *
               * @memberOf _.templateSettings
               * @type {RegExp}
               */
              'escape': _reEscape,

              /**
               * Used to detect code to be evaluated.
               *
               * @memberOf _.templateSettings
               * @type {RegExp}
               */
              'evaluate': _reEvaluate,

              /**
               * Used to detect `data` property values to inject.
               *
               * @memberOf _.templateSettings
               * @type {RegExp}
               */
              'interpolate': _reInterpolate,

              /**
               * Used to reference the data object in the template text.
               *
               * @memberOf _.templateSettings
               * @type {string}
               */
              'variable': '',

              /**
               * Used to import variables into the compiled template.
               *
               * @memberOf _.templateSettings
               * @type {Object}
               */
              'imports': {

                /**
                 * A reference to the `lodash` function.
                 *
                 * @memberOf _.templateSettings.imports
                 * @type {Function}
                 */
                '_': { 'escape': _escape }
              }
            };

            var templateSettings_1 = templateSettings;

            /** Error message constants. */
            var INVALID_TEMPL_VAR_ERROR_TEXT = 'Invalid `variable` option passed into `_.template`';

            /** Used to match empty string literals in compiled template source. */
            var reEmptyStringLeading = /\b__p \+= '';/g,
                reEmptyStringMiddle = /\b(__p \+=) '' \+/g,
                reEmptyStringTrailing = /(__e\(.*?\)|\b__t\)) \+\n'';/g;

            /**
             * Used to validate the `validate` option in `_.template` variable.
             *
             * Forbids characters which could potentially change the meaning of the function argument definition:
             * - "()," (modification of function parameters)
             * - "=" (default value)
             * - "[]{}" (destructuring of function parameters)
             * - "/" (beginning of a comment)
             * - whitespace
             */
            var reForbiddenIdentifierChars = /[()=,{}\[\]\/\s]/;

            /**
             * Used to match
             * [ES template delimiters](http://ecma-international.org/ecma-262/7.0/#sec-template-literal-lexical-components).
             */
            var reEsTemplate = /\$\{([^\\}]*(?:\\.[^\\}]*)*)\}/g;

            /** Used to ensure capturing order of template delimiters. */
            var reNoMatch = /($^)/;

            /** Used to match unescaped characters in compiled string literals. */
            var reUnescapedString = /['\n\r\u2028\u2029\\]/g;

            /** Used for built-in method references. */
            var objectProto$i = Object.prototype;

            /** Used to check objects for own properties. */
            var hasOwnProperty$f = objectProto$i.hasOwnProperty;

            /**
             * Creates a compiled template function that can interpolate data properties
             * in "interpolate" delimiters, HTML-escape interpolated data properties in
             * "escape" delimiters, and execute JavaScript in "evaluate" delimiters. Data
             * properties may be accessed as free variables in the template. If a setting
             * object is given, it takes precedence over `_.templateSettings` values.
             *
             * **Note:** In the development build `_.template` utilizes
             * [sourceURLs](http://www.html5rocks.com/en/tutorials/developertools/sourcemaps/#toc-sourceurl)
             * for easier debugging.
             *
             * For more information on precompiling templates see
             * [lodash's custom builds documentation](https://lodash.com/custom-builds).
             *
             * For more information on Chrome extension sandboxes see
             * [Chrome's extensions documentation](https://developer.chrome.com/extensions/sandboxingEval).
             *
             * @static
             * @since 0.1.0
             * @memberOf _
             * @category String
             * @param {string} [string=''] The template string.
             * @param {Object} [options={}] The options object.
             * @param {RegExp} [options.escape=_.templateSettings.escape]
             *  The HTML "escape" delimiter.
             * @param {RegExp} [options.evaluate=_.templateSettings.evaluate]
             *  The "evaluate" delimiter.
             * @param {Object} [options.imports=_.templateSettings.imports]
             *  An object to import into the template as free variables.
             * @param {RegExp} [options.interpolate=_.templateSettings.interpolate]
             *  The "interpolate" delimiter.
             * @param {string} [options.sourceURL='templateSources[n]']
             *  The sourceURL of the compiled template.
             * @param {string} [options.variable='obj']
             *  The data object variable name.
             * @param- {Object} [guard] Enables use as an iteratee for methods like `_.map`.
             * @returns {Function} Returns the compiled template function.
             * @example
             *
             * // Use the "interpolate" delimiter to create a compiled template.
             * var compiled = _.template('hello <%= user %>!');
             * compiled({ 'user': 'fred' });
             * // => 'hello fred!'
             *
             * // Use the HTML "escape" delimiter to escape data property values.
             * var compiled = _.template('<b><%- value %></b>');
             * compiled({ 'value': '<script>' });
             * // => '<b>&lt;script&gt;</b>'
             *
             * // Use the "evaluate" delimiter to execute JavaScript and generate HTML.
             * var compiled = _.template('<% _.forEach(users, function(user) { %><li><%- user %></li><% }); %>');
             * compiled({ 'users': ['fred', 'barney'] });
             * // => '<li>fred</li><li>barney</li>'
             *
             * // Use the internal `print` function in "evaluate" delimiters.
             * var compiled = _.template('<% print("hello " + user); %>!');
             * compiled({ 'user': 'barney' });
             * // => 'hello barney!'
             *
             * // Use the ES template literal delimiter as an "interpolate" delimiter.
             * // Disable support by replacing the "interpolate" delimiter.
             * var compiled = _.template('hello ${ user }!');
             * compiled({ 'user': 'pebbles' });
             * // => 'hello pebbles!'
             *
             * // Use backslashes to treat delimiters as plain text.
             * var compiled = _.template('<%= "\\<%- value %\\>" %>');
             * compiled({ 'value': 'ignored' });
             * // => '<%- value %>'
             *
             * // Use the `imports` option to import `jQuery` as `jq`.
             * var text = '<% jq.each(users, function(user) { %><li><%- user %></li><% }); %>';
             * var compiled = _.template(text, { 'imports': { 'jq': jQuery } });
             * compiled({ 'users': ['fred', 'barney'] });
             * // => '<li>fred</li><li>barney</li>'
             *
             * // Use the `sourceURL` option to specify a custom sourceURL for the template.
             * var compiled = _.template('hello <%= user %>!', { 'sourceURL': '/basic/greeting.jst' });
             * compiled(data);
             * // => Find the source of "greeting.jst" under the Sources tab or Resources panel of the web inspector.
             *
             * // Use the `variable` option to ensure a with-statement isn't used in the compiled template.
             * var compiled = _.template('hi <%= data.user %>!', { 'variable': 'data' });
             * compiled.source;
             * // => function(data) {
             * //   var __t, __p = '';
             * //   __p += 'hi ' + ((__t = ( data.user )) == null ? '' : __t) + '!';
             * //   return __p;
             * // }
             *
             * // Use custom template delimiters.
             * _.templateSettings.interpolate = /{{([\s\S]+?)}}/g;
             * var compiled = _.template('hello {{ user }}!');
             * compiled({ 'user': 'mustache' });
             * // => 'hello mustache!'
             *
             * // Use the `source` property to inline compiled templates for meaningful
             * // line numbers in error messages and stack traces.
             * fs.writeFileSync(path.join(process.cwd(), 'jst.js'), '\
             *   var JST = {\
             *     "main": ' + _.template(mainText).source + '\
             *   };\
             * ');
             */
            function template(string, options, guard) {
              // Based on John Resig's `tmpl` implementation
              // (http://ejohn.org/blog/javascript-micro-templating/)
              // and Laura Doktorova's doT.js (https://github.com/olado/doT).
              var settings = templateSettings_1.imports._.templateSettings || templateSettings_1;

              if (guard && _isIterateeCall(string, options, guard)) {
                options = undefined;
              }
              string = toString_1$1(string);
              options = assignInWith_1({}, options, settings, _customDefaultsAssignIn);

              var imports = assignInWith_1({}, options.imports, settings.imports, _customDefaultsAssignIn),
                  importsKeys = keys_1$1(imports),
                  importsValues = _baseValues(imports, importsKeys);

              var isEscaping,
                  isEvaluating,
                  index = 0,
                  interpolate = options.interpolate || reNoMatch,
                  source = "__p += '";

              // Compile the regexp to match each delimiter.
              var reDelimiters = RegExp(
                (options.escape || reNoMatch).source + '|' +
                interpolate.source + '|' +
                (interpolate === _reInterpolate ? reEsTemplate : reNoMatch).source + '|' +
                (options.evaluate || reNoMatch).source + '|$'
              , 'g');

              // Use a sourceURL for easier debugging.
              // The sourceURL gets injected into the source that's eval-ed, so be careful
              // to normalize all kinds of whitespace, so e.g. newlines (and unicode versions of it) can't sneak in
              // and escape the comment, thus injecting code that gets evaled.
              var sourceURL = hasOwnProperty$f.call(options, 'sourceURL')
                ? ('//# sourceURL=' +
                   (options.sourceURL + '').replace(/\s/g, ' ') +
                   '\n')
                : '';

              string.replace(reDelimiters, function(match, escapeValue, interpolateValue, esTemplateValue, evaluateValue, offset) {
                interpolateValue || (interpolateValue = esTemplateValue);

                // Escape characters that can't be included in string literals.
                source += string.slice(index, offset).replace(reUnescapedString, _escapeStringChar);

                // Replace delimiters with snippets.
                if (escapeValue) {
                  isEscaping = true;
                  source += "' +\n__e(" + escapeValue + ") +\n'";
                }
                if (evaluateValue) {
                  isEvaluating = true;
                  source += "';\n" + evaluateValue + ";\n__p += '";
                }
                if (interpolateValue) {
                  source += "' +\n((__t = (" + interpolateValue + ")) == null ? '' : __t) +\n'";
                }
                index = offset + match.length;

                // The JS engine embedded in Adobe products needs `match` returned in
                // order to produce the correct `offset` value.
                return match;
              });

              source += "';\n";

              // If `variable` is not specified wrap a with-statement around the generated
              // code to add the data object to the top of the scope chain.
              var variable = hasOwnProperty$f.call(options, 'variable') && options.variable;
              if (!variable) {
                source = 'with (obj) {\n' + source + '\n}\n';
              }
              // Throw an error if a forbidden character was found in `variable`, to prevent
              // potential command injection attacks.
              else if (reForbiddenIdentifierChars.test(variable)) {
                throw new Error(INVALID_TEMPL_VAR_ERROR_TEXT);
              }

              // Cleanup code by stripping empty strings.
              source = (isEvaluating ? source.replace(reEmptyStringLeading, '') : source)
                .replace(reEmptyStringMiddle, '$1')
                .replace(reEmptyStringTrailing, '$1;');

              // Frame code as the function body.
              source = 'function(' + (variable || 'obj') + ') {\n' +
                (variable
                  ? ''
                  : 'obj || (obj = {});\n'
                ) +
                "var __t, __p = ''" +
                (isEscaping
                   ? ', __e = _.escape'
                   : ''
                ) +
                (isEvaluating
                  ? ', __j = Array.prototype.join;\n' +
                    "function print() { __p += __j.call(arguments, '') }\n"
                  : ';\n'
                ) +
                source +
                'return __p\n}';

              var result = attempt_1(function() {
                return Function(importsKeys, sourceURL + 'return ' + source)
                  .apply(undefined, importsValues);
              });

              // Provide the compiled function's source by its `toString` method or
              // the `source` property as a convenience for inlining compiled templates.
              result.source = source;
              if (isError_1(result)) {
                throw result;
              }
              return result;
            }

            var template_1 = template;

            var onEditorLoad = function (config, apiOperations, resourceName) { return function (_a) {
                var safeReaction = _a.safeReaction, updatePreviewUrl = _a.updatePreviewUrl;
                // compile previewResource if any, to allow user to have templated editing urls for their models (e.g in cases of product page template)
                safeReaction(function () {
                    var _a, _b, _c, _d, _e, _f, _g, _h;
                    var modelUrl = (_a = appState.designerState.editingModel) === null || _a === void 0 ? void 0 : _a.examplePageUrl;
                    if (!modelUrl) {
                        return;
                    }
                    var previewField = (_c = (_b = appState.designerState.editingModel) === null || _b === void 0 ? void 0 : _b.fields.find(function (field) {
                        return field.type === "" + config.name + capitalize_1$1(resourceName) + "Preview";
                    })) === null || _c === void 0 ? void 0 : _c.name;
                    if (previewField && appState.designerState.editingContentModel) {
                        var resourceId = (_d = appState.designerState.editingContentModel.data
                            .get(previewField)) === null || _d === void 0 ? void 0 : _d.options.get(resourceName);
                        return apiOperations[resourceName].findById(resourceId);
                    }
                    var pluginSettings = appState.user.organization.value.settings.plugins.get(config.id);
                    var shouldSync = pluginSettings.get('syncPreviewUrlWithTargeting');
                    var query = (_f = (_e = appState.designerState.editingContentModel) === null || _e === void 0 ? void 0 : _e.query) === null || _f === void 0 ? void 0 : _f.toJSON();
                    var customAttributes = (_g = appState.user.organization.value.customTargetingAttributes) === null || _g === void 0 ? void 0 : _g.toJSON();
                    if (shouldSync && customAttributes && query) {
                        var apiService = apiOperations[resourceName];
                        var _loop_1 = function (key, value) {
                            var targetingValue = (_h = query.find(function (q) { return q.property === key; })) === null || _h === void 0 ? void 0 : _h.value;
                            if (targetingValue && value.type === "" + config.name + capitalize_1$1(resourceName)) {
                                return { value: apiService.findById(targetingValue) };
                            }
                            if (apiService.findByHandle &&
                                targetingValue &&
                                value.type === "" + config.name + capitalize_1$1(resourceName) + "Handle") {
                                return { value: apiService.findByHandle(targetingValue) };
                            }
                        };
                        for (var _i = 0, _j = Object.entries(customAttributes); _i < _j.length; _i++) {
                            var _k = _j[_i], key = _k[0], value = _k[1];
                            var state_1 = _loop_1(key, value);
                            if (typeof state_1 === "object")
                                return state_1.value;
                        }
                    }
                }, function (resourcePromise) { return __awaiter(void 0, void 0, void 0, function () {
                    var modelUrl, previewResource, compiled, previewUrl;
                    var _a;
                    return __generator(this, function (_b) {
                        switch (_b.label) {
                            case 0:
                                modelUrl = (_a = appState.designerState.editingModel) === null || _a === void 0 ? void 0 : _a.examplePageUrl;
                                if (!(resourcePromise && modelUrl)) return [3 /*break*/, 2];
                                return [4 /*yield*/, resourcePromise];
                            case 1:
                                previewResource = _b.sent();
                                compiled = template_1(modelUrl);
                                previewUrl = compiled(withDefaults({
                                    previewResource: previewResource,
                                }));
                                if (modelUrl !== previewUrl) {
                                    updatePreviewUrl(previewUrl);
                                    appState.snackBar.show("Previewing " + previewUrl);
                                }
                                _b.label = 2;
                            case 2: return [2 /*return*/];
                        }
                    });
                }); });
            }; };
            var withDefaults = function (obj) {
                var _a;
                return (__assign(__assign({}, obj), { space: {
                        siteUrl: (_a = appState.user.organization.value) === null || _a === void 0 ? void 0 : _a.siteUrl,
                    } }));
            };

            var ErrorMessage = function () { return (createElement("div", { css: {
                    margin: 15,
                    borderRadius: 4,
                    border: '1px solid rgba(150, 0, 0, 0.35)',
                    color: 'rgba(150, 0, 0, 1)',
                    backgroundColor: 'rgba(255, 0, 0, 0.1)',
                    padding: 15,
                    fontSize: 14,
                    textAlign: 'center',
                } },
                "Oh no! We had an error :( Try",
                ' ',
                createElement("a", { onClick: function () { return location.reload(); }, css: { color: 'steelblue', cursor: 'pointer', fontWeight: 'bold' } }, "refreshing this page"),
                ' ',
                "and",
                ' ',
                createElement("a", { css: { color: 'steelblue', cursor: 'pointer', fontWeight: 'bold' }, onClick: function () {
                        window.Intercom('showNewMesage', 'I am getting an error - please help');
                    } }, "chat us"),
                ' ',
                "or contact",
                ' ',
                createElement("a", { css: { color: 'steelblue', cursor: 'pointer', fontWeight: 'bold' }, target: "_blank", href: "mailto:help@builder.io" }, "help@builder.io"),
                ' ',
                "if this continues")); };
            /**
             * Provides error boundaries for safety (one component errors won't crash the whole app)
             */
            var ErrorBoundary = /** @class */ (function (_super) {
                __extends(ErrorBoundary, _super);
                function ErrorBoundary() {
                    var _this = _super !== null && _super.apply(this, arguments) || this;
                    _this.state = { hasError: false };
                    return _this;
                }
                ErrorBoundary.getDerivedStateFromError = function () {
                    // Update state so the next render will show the fallback UI.
                    return { hasError: true };
                };
                ErrorBoundary.prototype.render = function () {
                    if (this.state.hasError) {
                        return createElement(ErrorMessage, null);
                    }
                    return this.props.children;
                };
                return ErrorBoundary;
            }(Component));

            var registerCommercePlugin = function (config, apiOperationsFromSettings) { return __awaiter(void 0, void 0, void 0, function () {
                var registerEditors, onSave, savedSettings;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            registerEditors = function () { return __awaiter(void 0, void 0, void 0, function () {
                                var apiOperations, resources;
                                return __generator(this, function (_a) {
                                    switch (_a.label) {
                                        case 0: return [4 /*yield*/, apiOperationsFromSettings(appState.user.organization.value.settings.plugins.get(config.id))];
                                        case 1:
                                            apiOperations = _a.sent();
                                            resources = Object.keys(apiOperations);
                                            resources.forEach(function (resourceName) {
                                                var contextProps = {
                                                    resourceName: resourceName,
                                                    pluginId: config.id,
                                                    plulginName: config.name,
                                                    api: apiOperations,
                                                };
                                                Builder.register('editor.onLoad', onEditorLoad(config, apiOperations, resourceName));
                                                var resourceType = "" + config.name + capitalize_1$1(resourceName);
                                                Builder.registerEditor({
                                                    name: resourceType,
                                                    isDataResource: true,
                                                    pluginId: config.id,
                                                    component: function (props) { return (React.createElement(ErrorBoundary, null,
                                                        React.createElement(ResourcesPickerButton, __assign({}, props, contextProps)))); },
                                                });
                                                Builder.register("resource" + config.id, {
                                                    pluginId: config.id,
                                                    name: resourceName,
                                                    inputs: [
                                                        {
                                                            name: resourceName,
                                                            type: resourceType
                                                        }
                                                    ],
                                                    toUrl: function (options) {
                                                        var _a;
                                                        console.log(options);
                                                        return (_a = options.request) === null || _a === void 0 ? void 0 : _a.url;
                                                    },
                                                    getCustomHeaders: function (options) {
                                                        var _a;
                                                        console.log(options);
                                                        return (_a = options.request) === null || _a === void 0 ? void 0 : _a.headers;
                                                    }
                                                });
                                                Builder.registerEditor({
                                                    name: "" + config.name + capitalize_1$1(resourceName) + "Preview",
                                                    pluginId: config.id,
                                                    component: function (props) { return (React.createElement(ErrorBoundary, null,
                                                        React.createElement(ResourcesPickerButton, __assign({}, props, contextProps, { previewType: "" + config.name + capitalize_1$1(resourceName) + "Preview", isPreview: true })))); },
                                                });
                                                if (apiOperations[resourceName].findByHandle) {
                                                    Builder.registerEditor({
                                                        name: "" + config.name + capitalize_1$1(resourceName) + "Handle",
                                                        pluginId: config.id,
                                                        component: function (props) { return (React.createElement(ErrorBoundary, null,
                                                            React.createElement(ResourcesPickerButton, __assign({}, props, contextProps, { handleOnly: true })))); },
                                                    });
                                                }
                                                Builder.registerEditor({
                                                    name: "" + config.name + capitalize_1$1(pluralize.plural(resourceName)) + "List",
                                                    pluginId: config.id,
                                                    component: function (props) { return (React.createElement(ErrorBoundary, null,
                                                        React.createElement(PickResourcesListButton, __assign({}, props, contextProps)))); },
                                                });
                                            });
                                            return [2 /*return*/];
                                    }
                                });
                            }); };
                            onSave = config.onSave;
                            config.onSave = function (actions) { return __awaiter(void 0, void 0, void 0, function () {
                                return __generator(this, function (_a) {
                                    switch (_a.label) {
                                        case 0: return [4 /*yield*/, actions.updateSettings({ hasConnected: true })];
                                        case 1:
                                            _a.sent();
                                            if (!onSave) return [3 /*break*/, 3];
                                            return [4 /*yield*/, onSave(actions)];
                                        case 2:
                                            _a.sent();
                                            _a.label = 3;
                                        case 3:
                                            registerEditors();
                                            return [2 /*return*/];
                                    }
                                });
                            }); };
                            Builder.register('plugin', __assign(__assign({}, config), { isSourcePlugin: true }));
                            Builder.register('app.onLoad', function (_a) {
                                var triggerSettingsDialog = _a.triggerSettingsDialog;
                                return __awaiter(void 0, void 0, void 0, function () {
                                    var pluginSettings, hasConnected;
                                    var _b;
                                    return __generator(this, function (_c) {
                                        switch (_c.label) {
                                            case 0:
                                                pluginSettings = appState.user.organization.value.settings.plugins.get(config.id);
                                                hasConnected = (_b = pluginSettings) === null || _b === void 0 ? void 0 : _b.get('hasConnected');
                                                if (!!hasConnected) return [3 /*break*/, 2];
                                                return [4 /*yield*/, triggerSettingsDialog(config.id)];
                                            case 1:
                                                _c.sent();
                                                _c.label = 2;
                                            case 2: return [2 /*return*/];
                                        }
                                    });
                                });
                            });
                            savedSettings = appState.user.organization.value.settings.plugins.get(config.id);
                            if (!savedSettings) {
                                return [2 /*return*/];
                            }
                            return [4 /*yield*/, registerEditors()];
                        case 1:
                            _a.sent();
                            return [2 /*return*/];
                    }
                });
            }); };

            var commonjsGlobal = typeof globalThis !== 'undefined' ? globalThis : typeof window !== 'undefined' ? window : typeof global !== 'undefined' ? global : typeof self !== 'undefined' ? self : {};

            function unwrapExports (x) {
            	return x && x.__esModule && Object.prototype.hasOwnProperty.call(x, 'default') ? x['default'] : x;
            }

            function createCommonjsModule(fn, module) {
            	return module = { exports: {} }, fn(module, module.exports), module.exports;
            }

            function getCjsExportFromNamespace (n) {
            	return n && n['default'] || n;
            }

            var interopRequireDefault = createCommonjsModule(function (module) {
            function _interopRequireDefault(obj) {
              return obj && obj.__esModule ? obj : {
                "default": obj
              };
            }

            module.exports = _interopRequireDefault;
            });

            unwrapExports(interopRequireDefault);

            var runtime_1 = createCommonjsModule(function (module) {
            /**
             * Copyright (c) 2014-present, Facebook, Inc.
             *
             * This source code is licensed under the MIT license found in the
             * LICENSE file in the root directory of this source tree.
             */

            var runtime = (function (exports) {

              var Op = Object.prototype;
              var hasOwn = Op.hasOwnProperty;
              var undefined$1; // More compressible than void 0.
              var $Symbol = typeof Symbol === "function" ? Symbol : {};
              var iteratorSymbol = $Symbol.iterator || "@@iterator";
              var asyncIteratorSymbol = $Symbol.asyncIterator || "@@asyncIterator";
              var toStringTagSymbol = $Symbol.toStringTag || "@@toStringTag";

              function wrap(innerFn, outerFn, self, tryLocsList) {
                // If outerFn provided and outerFn.prototype is a Generator, then outerFn.prototype instanceof Generator.
                var protoGenerator = outerFn && outerFn.prototype instanceof Generator ? outerFn : Generator;
                var generator = Object.create(protoGenerator.prototype);
                var context = new Context(tryLocsList || []);

                // The ._invoke method unifies the implementations of the .next,
                // .throw, and .return methods.
                generator._invoke = makeInvokeMethod(innerFn, self, context);

                return generator;
              }
              exports.wrap = wrap;

              // Try/catch helper to minimize deoptimizations. Returns a completion
              // record like context.tryEntries[i].completion. This interface could
              // have been (and was previously) designed to take a closure to be
              // invoked without arguments, but in all the cases we care about we
              // already have an existing method we want to call, so there's no need
              // to create a new function object. We can even get away with assuming
              // the method takes exactly one argument, since that happens to be true
              // in every case, so we don't have to touch the arguments object. The
              // only additional allocation required is the completion record, which
              // has a stable shape and so hopefully should be cheap to allocate.
              function tryCatch(fn, obj, arg) {
                try {
                  return { type: "normal", arg: fn.call(obj, arg) };
                } catch (err) {
                  return { type: "throw", arg: err };
                }
              }

              var GenStateSuspendedStart = "suspendedStart";
              var GenStateSuspendedYield = "suspendedYield";
              var GenStateExecuting = "executing";
              var GenStateCompleted = "completed";

              // Returning this object from the innerFn has the same effect as
              // breaking out of the dispatch switch statement.
              var ContinueSentinel = {};

              // Dummy constructor functions that we use as the .constructor and
              // .constructor.prototype properties for functions that return Generator
              // objects. For full spec compliance, you may wish to configure your
              // minifier not to mangle the names of these two functions.
              function Generator() {}
              function GeneratorFunction() {}
              function GeneratorFunctionPrototype() {}

              // This is a polyfill for %IteratorPrototype% for environments that
              // don't natively support it.
              var IteratorPrototype = {};
              IteratorPrototype[iteratorSymbol] = function () {
                return this;
              };

              var getProto = Object.getPrototypeOf;
              var NativeIteratorPrototype = getProto && getProto(getProto(values([])));
              if (NativeIteratorPrototype &&
                  NativeIteratorPrototype !== Op &&
                  hasOwn.call(NativeIteratorPrototype, iteratorSymbol)) {
                // This environment has a native %IteratorPrototype%; use it instead
                // of the polyfill.
                IteratorPrototype = NativeIteratorPrototype;
              }

              var Gp = GeneratorFunctionPrototype.prototype =
                Generator.prototype = Object.create(IteratorPrototype);
              GeneratorFunction.prototype = Gp.constructor = GeneratorFunctionPrototype;
              GeneratorFunctionPrototype.constructor = GeneratorFunction;
              GeneratorFunctionPrototype[toStringTagSymbol] =
                GeneratorFunction.displayName = "GeneratorFunction";

              // Helper for defining the .next, .throw, and .return methods of the
              // Iterator interface in terms of a single ._invoke method.
              function defineIteratorMethods(prototype) {
                ["next", "throw", "return"].forEach(function(method) {
                  prototype[method] = function(arg) {
                    return this._invoke(method, arg);
                  };
                });
              }

              exports.isGeneratorFunction = function(genFun) {
                var ctor = typeof genFun === "function" && genFun.constructor;
                return ctor
                  ? ctor === GeneratorFunction ||
                    // For the native GeneratorFunction constructor, the best we can
                    // do is to check its .name property.
                    (ctor.displayName || ctor.name) === "GeneratorFunction"
                  : false;
              };

              exports.mark = function(genFun) {
                if (Object.setPrototypeOf) {
                  Object.setPrototypeOf(genFun, GeneratorFunctionPrototype);
                } else {
                  genFun.__proto__ = GeneratorFunctionPrototype;
                  if (!(toStringTagSymbol in genFun)) {
                    genFun[toStringTagSymbol] = "GeneratorFunction";
                  }
                }
                genFun.prototype = Object.create(Gp);
                return genFun;
              };

              // Within the body of any async function, `await x` is transformed to
              // `yield regeneratorRuntime.awrap(x)`, so that the runtime can test
              // `hasOwn.call(value, "__await")` to determine if the yielded value is
              // meant to be awaited.
              exports.awrap = function(arg) {
                return { __await: arg };
              };

              function AsyncIterator(generator) {
                function invoke(method, arg, resolve, reject) {
                  var record = tryCatch(generator[method], generator, arg);
                  if (record.type === "throw") {
                    reject(record.arg);
                  } else {
                    var result = record.arg;
                    var value = result.value;
                    if (value &&
                        typeof value === "object" &&
                        hasOwn.call(value, "__await")) {
                      return Promise.resolve(value.__await).then(function(value) {
                        invoke("next", value, resolve, reject);
                      }, function(err) {
                        invoke("throw", err, resolve, reject);
                      });
                    }

                    return Promise.resolve(value).then(function(unwrapped) {
                      // When a yielded Promise is resolved, its final value becomes
                      // the .value of the Promise<{value,done}> result for the
                      // current iteration.
                      result.value = unwrapped;
                      resolve(result);
                    }, function(error) {
                      // If a rejected Promise was yielded, throw the rejection back
                      // into the async generator function so it can be handled there.
                      return invoke("throw", error, resolve, reject);
                    });
                  }
                }

                var previousPromise;

                function enqueue(method, arg) {
                  function callInvokeWithMethodAndArg() {
                    return new Promise(function(resolve, reject) {
                      invoke(method, arg, resolve, reject);
                    });
                  }

                  return previousPromise =
                    // If enqueue has been called before, then we want to wait until
                    // all previous Promises have been resolved before calling invoke,
                    // so that results are always delivered in the correct order. If
                    // enqueue has not been called before, then it is important to
                    // call invoke immediately, without waiting on a callback to fire,
                    // so that the async generator function has the opportunity to do
                    // any necessary setup in a predictable way. This predictability
                    // is why the Promise constructor synchronously invokes its
                    // executor callback, and why async functions synchronously
                    // execute code before the first await. Since we implement simple
                    // async functions in terms of async generators, it is especially
                    // important to get this right, even though it requires care.
                    previousPromise ? previousPromise.then(
                      callInvokeWithMethodAndArg,
                      // Avoid propagating failures to Promises returned by later
                      // invocations of the iterator.
                      callInvokeWithMethodAndArg
                    ) : callInvokeWithMethodAndArg();
                }

                // Define the unified helper method that is used to implement .next,
                // .throw, and .return (see defineIteratorMethods).
                this._invoke = enqueue;
              }

              defineIteratorMethods(AsyncIterator.prototype);
              AsyncIterator.prototype[asyncIteratorSymbol] = function () {
                return this;
              };
              exports.AsyncIterator = AsyncIterator;

              // Note that simple async functions are implemented on top of
              // AsyncIterator objects; they just return a Promise for the value of
              // the final result produced by the iterator.
              exports.async = function(innerFn, outerFn, self, tryLocsList) {
                var iter = new AsyncIterator(
                  wrap(innerFn, outerFn, self, tryLocsList)
                );

                return exports.isGeneratorFunction(outerFn)
                  ? iter // If outerFn is a generator, return the full iterator.
                  : iter.next().then(function(result) {
                      return result.done ? result.value : iter.next();
                    });
              };

              function makeInvokeMethod(innerFn, self, context) {
                var state = GenStateSuspendedStart;

                return function invoke(method, arg) {
                  if (state === GenStateExecuting) {
                    throw new Error("Generator is already running");
                  }

                  if (state === GenStateCompleted) {
                    if (method === "throw") {
                      throw arg;
                    }

                    // Be forgiving, per 25.3.3.3.3 of the spec:
                    // https://people.mozilla.org/~jorendorff/es6-draft.html#sec-generatorresume
                    return doneResult();
                  }

                  context.method = method;
                  context.arg = arg;

                  while (true) {
                    var delegate = context.delegate;
                    if (delegate) {
                      var delegateResult = maybeInvokeDelegate(delegate, context);
                      if (delegateResult) {
                        if (delegateResult === ContinueSentinel) continue;
                        return delegateResult;
                      }
                    }

                    if (context.method === "next") {
                      // Setting context._sent for legacy support of Babel's
                      // function.sent implementation.
                      context.sent = context._sent = context.arg;

                    } else if (context.method === "throw") {
                      if (state === GenStateSuspendedStart) {
                        state = GenStateCompleted;
                        throw context.arg;
                      }

                      context.dispatchException(context.arg);

                    } else if (context.method === "return") {
                      context.abrupt("return", context.arg);
                    }

                    state = GenStateExecuting;

                    var record = tryCatch(innerFn, self, context);
                    if (record.type === "normal") {
                      // If an exception is thrown from innerFn, we leave state ===
                      // GenStateExecuting and loop back for another invocation.
                      state = context.done
                        ? GenStateCompleted
                        : GenStateSuspendedYield;

                      if (record.arg === ContinueSentinel) {
                        continue;
                      }

                      return {
                        value: record.arg,
                        done: context.done
                      };

                    } else if (record.type === "throw") {
                      state = GenStateCompleted;
                      // Dispatch the exception by looping back around to the
                      // context.dispatchException(context.arg) call above.
                      context.method = "throw";
                      context.arg = record.arg;
                    }
                  }
                };
              }

              // Call delegate.iterator[context.method](context.arg) and handle the
              // result, either by returning a { value, done } result from the
              // delegate iterator, or by modifying context.method and context.arg,
              // setting context.delegate to null, and returning the ContinueSentinel.
              function maybeInvokeDelegate(delegate, context) {
                var method = delegate.iterator[context.method];
                if (method === undefined$1) {
                  // A .throw or .return when the delegate iterator has no .throw
                  // method always terminates the yield* loop.
                  context.delegate = null;

                  if (context.method === "throw") {
                    // Note: ["return"] must be used for ES3 parsing compatibility.
                    if (delegate.iterator["return"]) {
                      // If the delegate iterator has a return method, give it a
                      // chance to clean up.
                      context.method = "return";
                      context.arg = undefined$1;
                      maybeInvokeDelegate(delegate, context);

                      if (context.method === "throw") {
                        // If maybeInvokeDelegate(context) changed context.method from
                        // "return" to "throw", let that override the TypeError below.
                        return ContinueSentinel;
                      }
                    }

                    context.method = "throw";
                    context.arg = new TypeError(
                      "The iterator does not provide a 'throw' method");
                  }

                  return ContinueSentinel;
                }

                var record = tryCatch(method, delegate.iterator, context.arg);

                if (record.type === "throw") {
                  context.method = "throw";
                  context.arg = record.arg;
                  context.delegate = null;
                  return ContinueSentinel;
                }

                var info = record.arg;

                if (! info) {
                  context.method = "throw";
                  context.arg = new TypeError("iterator result is not an object");
                  context.delegate = null;
                  return ContinueSentinel;
                }

                if (info.done) {
                  // Assign the result of the finished delegate to the temporary
                  // variable specified by delegate.resultName (see delegateYield).
                  context[delegate.resultName] = info.value;

                  // Resume execution at the desired location (see delegateYield).
                  context.next = delegate.nextLoc;

                  // If context.method was "throw" but the delegate handled the
                  // exception, let the outer generator proceed normally. If
                  // context.method was "next", forget context.arg since it has been
                  // "consumed" by the delegate iterator. If context.method was
                  // "return", allow the original .return call to continue in the
                  // outer generator.
                  if (context.method !== "return") {
                    context.method = "next";
                    context.arg = undefined$1;
                  }

                } else {
                  // Re-yield the result returned by the delegate method.
                  return info;
                }

                // The delegate iterator is finished, so forget it and continue with
                // the outer generator.
                context.delegate = null;
                return ContinueSentinel;
              }

              // Define Generator.prototype.{next,throw,return} in terms of the
              // unified ._invoke helper method.
              defineIteratorMethods(Gp);

              Gp[toStringTagSymbol] = "Generator";

              // A Generator should always return itself as the iterator object when the
              // @@iterator function is called on it. Some browsers' implementations of the
              // iterator prototype chain incorrectly implement this, causing the Generator
              // object to not be returned from this call. This ensures that doesn't happen.
              // See https://github.com/facebook/regenerator/issues/274 for more details.
              Gp[iteratorSymbol] = function() {
                return this;
              };

              Gp.toString = function() {
                return "[object Generator]";
              };

              function pushTryEntry(locs) {
                var entry = { tryLoc: locs[0] };

                if (1 in locs) {
                  entry.catchLoc = locs[1];
                }

                if (2 in locs) {
                  entry.finallyLoc = locs[2];
                  entry.afterLoc = locs[3];
                }

                this.tryEntries.push(entry);
              }

              function resetTryEntry(entry) {
                var record = entry.completion || {};
                record.type = "normal";
                delete record.arg;
                entry.completion = record;
              }

              function Context(tryLocsList) {
                // The root entry object (effectively a try statement without a catch
                // or a finally block) gives us a place to store values thrown from
                // locations where there is no enclosing try statement.
                this.tryEntries = [{ tryLoc: "root" }];
                tryLocsList.forEach(pushTryEntry, this);
                this.reset(true);
              }

              exports.keys = function(object) {
                var keys = [];
                for (var key in object) {
                  keys.push(key);
                }
                keys.reverse();

                // Rather than returning an object with a next method, we keep
                // things simple and return the next function itself.
                return function next() {
                  while (keys.length) {
                    var key = keys.pop();
                    if (key in object) {
                      next.value = key;
                      next.done = false;
                      return next;
                    }
                  }

                  // To avoid creating an additional object, we just hang the .value
                  // and .done properties off the next function object itself. This
                  // also ensures that the minifier will not anonymize the function.
                  next.done = true;
                  return next;
                };
              };

              function values(iterable) {
                if (iterable) {
                  var iteratorMethod = iterable[iteratorSymbol];
                  if (iteratorMethod) {
                    return iteratorMethod.call(iterable);
                  }

                  if (typeof iterable.next === "function") {
                    return iterable;
                  }

                  if (!isNaN(iterable.length)) {
                    var i = -1, next = function next() {
                      while (++i < iterable.length) {
                        if (hasOwn.call(iterable, i)) {
                          next.value = iterable[i];
                          next.done = false;
                          return next;
                        }
                      }

                      next.value = undefined$1;
                      next.done = true;

                      return next;
                    };

                    return next.next = next;
                  }
                }

                // Return an iterator with no values.
                return { next: doneResult };
              }
              exports.values = values;

              function doneResult() {
                return { value: undefined$1, done: true };
              }

              Context.prototype = {
                constructor: Context,

                reset: function(skipTempReset) {
                  this.prev = 0;
                  this.next = 0;
                  // Resetting context._sent for legacy support of Babel's
                  // function.sent implementation.
                  this.sent = this._sent = undefined$1;
                  this.done = false;
                  this.delegate = null;

                  this.method = "next";
                  this.arg = undefined$1;

                  this.tryEntries.forEach(resetTryEntry);

                  if (!skipTempReset) {
                    for (var name in this) {
                      // Not sure about the optimal order of these conditions:
                      if (name.charAt(0) === "t" &&
                          hasOwn.call(this, name) &&
                          !isNaN(+name.slice(1))) {
                        this[name] = undefined$1;
                      }
                    }
                  }
                },

                stop: function() {
                  this.done = true;

                  var rootEntry = this.tryEntries[0];
                  var rootRecord = rootEntry.completion;
                  if (rootRecord.type === "throw") {
                    throw rootRecord.arg;
                  }

                  return this.rval;
                },

                dispatchException: function(exception) {
                  if (this.done) {
                    throw exception;
                  }

                  var context = this;
                  function handle(loc, caught) {
                    record.type = "throw";
                    record.arg = exception;
                    context.next = loc;

                    if (caught) {
                      // If the dispatched exception was caught by a catch block,
                      // then let that catch block handle the exception normally.
                      context.method = "next";
                      context.arg = undefined$1;
                    }

                    return !! caught;
                  }

                  for (var i = this.tryEntries.length - 1; i >= 0; --i) {
                    var entry = this.tryEntries[i];
                    var record = entry.completion;

                    if (entry.tryLoc === "root") {
                      // Exception thrown outside of any try block that could handle
                      // it, so set the completion value of the entire function to
                      // throw the exception.
                      return handle("end");
                    }

                    if (entry.tryLoc <= this.prev) {
                      var hasCatch = hasOwn.call(entry, "catchLoc");
                      var hasFinally = hasOwn.call(entry, "finallyLoc");

                      if (hasCatch && hasFinally) {
                        if (this.prev < entry.catchLoc) {
                          return handle(entry.catchLoc, true);
                        } else if (this.prev < entry.finallyLoc) {
                          return handle(entry.finallyLoc);
                        }

                      } else if (hasCatch) {
                        if (this.prev < entry.catchLoc) {
                          return handle(entry.catchLoc, true);
                        }

                      } else if (hasFinally) {
                        if (this.prev < entry.finallyLoc) {
                          return handle(entry.finallyLoc);
                        }

                      } else {
                        throw new Error("try statement without catch or finally");
                      }
                    }
                  }
                },

                abrupt: function(type, arg) {
                  for (var i = this.tryEntries.length - 1; i >= 0; --i) {
                    var entry = this.tryEntries[i];
                    if (entry.tryLoc <= this.prev &&
                        hasOwn.call(entry, "finallyLoc") &&
                        this.prev < entry.finallyLoc) {
                      var finallyEntry = entry;
                      break;
                    }
                  }

                  if (finallyEntry &&
                      (type === "break" ||
                       type === "continue") &&
                      finallyEntry.tryLoc <= arg &&
                      arg <= finallyEntry.finallyLoc) {
                    // Ignore the finally entry if control is not jumping to a
                    // location outside the try/catch block.
                    finallyEntry = null;
                  }

                  var record = finallyEntry ? finallyEntry.completion : {};
                  record.type = type;
                  record.arg = arg;

                  if (finallyEntry) {
                    this.method = "next";
                    this.next = finallyEntry.finallyLoc;
                    return ContinueSentinel;
                  }

                  return this.complete(record);
                },

                complete: function(record, afterLoc) {
                  if (record.type === "throw") {
                    throw record.arg;
                  }

                  if (record.type === "break" ||
                      record.type === "continue") {
                    this.next = record.arg;
                  } else if (record.type === "return") {
                    this.rval = this.arg = record.arg;
                    this.method = "return";
                    this.next = "end";
                  } else if (record.type === "normal" && afterLoc) {
                    this.next = afterLoc;
                  }

                  return ContinueSentinel;
                },

                finish: function(finallyLoc) {
                  for (var i = this.tryEntries.length - 1; i >= 0; --i) {
                    var entry = this.tryEntries[i];
                    if (entry.finallyLoc === finallyLoc) {
                      this.complete(entry.completion, entry.afterLoc);
                      resetTryEntry(entry);
                      return ContinueSentinel;
                    }
                  }
                },

                "catch": function(tryLoc) {
                  for (var i = this.tryEntries.length - 1; i >= 0; --i) {
                    var entry = this.tryEntries[i];
                    if (entry.tryLoc === tryLoc) {
                      var record = entry.completion;
                      if (record.type === "throw") {
                        var thrown = record.arg;
                        resetTryEntry(entry);
                      }
                      return thrown;
                    }
                  }

                  // The context.catch method must only be called with a location
                  // argument that corresponds to a known catch block.
                  throw new Error("illegal catch attempt");
                },

                delegateYield: function(iterable, resultName, nextLoc) {
                  this.delegate = {
                    iterator: values(iterable),
                    resultName: resultName,
                    nextLoc: nextLoc
                  };

                  if (this.method === "next") {
                    // Deliberately forget the last sent value so that we don't
                    // accidentally pass it on to the delegate.
                    this.arg = undefined$1;
                  }

                  return ContinueSentinel;
                }
              };

              // Regardless of whether this script is executing as a CommonJS module
              // or not, return the runtime object so that we can declare the variable
              // regeneratorRuntime in the outer scope, which allows this module to be
              // injected easily by `bin/regenerator --include-runtime script.js`.
              return exports;

            }(
              // If this script is executing as a CommonJS module, use module.exports
              // as the regeneratorRuntime namespace. Otherwise create a new empty
              // object. Either way, the resulting object will be used to initialize
              // the regeneratorRuntime variable at the top of this file.
              module.exports 
            ));

            try {
              regeneratorRuntime = runtime;
            } catch (accidentalStrictMode) {
              // This module should not be running in strict mode, so the above
              // assignment should always work unless something is misconfigured. Just
              // in case runtime.js accidentally runs in strict mode, we can escape
              // strict mode using a global Function call. This could conceivably fail
              // if a Content Security Policy forbids using Function, but in that case
              // the proper solution is to fix the accidental strict mode problem. If
              // you've misconfigured your bundler to force strict mode and applied a
              // CSP to forbid Function, and you're not willing to fix either of those
              // problems, please detail your unique predicament in a GitHub issue.
              Function("r", "regeneratorRuntime = r")(runtime);
            }
            });

            var regenerator = runtime_1;

            function _arrayWithHoles(arr) {
              if (Array.isArray(arr)) return arr;
            }

            var arrayWithHoles = _arrayWithHoles;

            function _iterableToArrayLimit(arr, i) {
              var _arr = [];
              var _n = true;
              var _d = false;
              var _e = undefined;

              try {
                for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) {
                  _arr.push(_s.value);

                  if (i && _arr.length === i) break;
                }
              } catch (err) {
                _d = true;
                _e = err;
              } finally {
                try {
                  if (!_n && _i["return"] != null) _i["return"]();
                } finally {
                  if (_d) throw _e;
                }
              }

              return _arr;
            }

            var iterableToArrayLimit = _iterableToArrayLimit;

            function _nonIterableRest() {
              throw new TypeError("Invalid attempt to destructure non-iterable instance");
            }

            var nonIterableRest = _nonIterableRest;

            function _slicedToArray(arr, i) {
              return arrayWithHoles(arr) || iterableToArrayLimit(arr, i) || nonIterableRest();
            }

            var slicedToArray = _slicedToArray;

            function _defineProperty$1(obj, key, value) {
              if (key in obj) {
                Object.defineProperty(obj, key, {
                  value: value,
                  enumerable: true,
                  configurable: true,
                  writable: true
                });
              } else {
                obj[key] = value;
              }

              return obj;
            }

            var defineProperty$1 = _defineProperty$1;

            function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) {
              try {
                var info = gen[key](arg);
                var value = info.value;
              } catch (error) {
                reject(error);
                return;
              }

              if (info.done) {
                resolve(value);
              } else {
                Promise.resolve(value).then(_next, _throw);
              }
            }

            function _asyncToGenerator(fn) {
              return function () {
                var self = this,
                    args = arguments;
                return new Promise(function (resolve, reject) {
                  var gen = fn.apply(self, args);

                  function _next(value) {
                    asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value);
                  }

                  function _throw(err) {
                    asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err);
                  }

                  _next(undefined);
                });
              };
            }

            var asyncToGenerator = _asyncToGenerator;

            var global$1 = (typeof global !== "undefined" ? global :
              typeof self !== "undefined" ? self :
              typeof window !== "undefined" ? window : {});

            var lookup = [];
            var revLookup = [];
            var Arr = typeof Uint8Array !== 'undefined' ? Uint8Array : Array;
            var inited = false;
            function init () {
              inited = true;
              var code = 'ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/';
              for (var i = 0, len = code.length; i < len; ++i) {
                lookup[i] = code[i];
                revLookup[code.charCodeAt(i)] = i;
              }

              revLookup['-'.charCodeAt(0)] = 62;
              revLookup['_'.charCodeAt(0)] = 63;
            }

            function toByteArray (b64) {
              if (!inited) {
                init();
              }
              var i, j, l, tmp, placeHolders, arr;
              var len = b64.length;

              if (len % 4 > 0) {
                throw new Error('Invalid string. Length must be a multiple of 4')
              }

              // the number of equal signs (place holders)
              // if there are two placeholders, than the two characters before it
              // represent one byte
              // if there is only one, then the three characters before it represent 2 bytes
              // this is just a cheap hack to not do indexOf twice
              placeHolders = b64[len - 2] === '=' ? 2 : b64[len - 1] === '=' ? 1 : 0;

              // base64 is 4/3 + up to two characters of the original data
              arr = new Arr(len * 3 / 4 - placeHolders);

              // if there are placeholders, only get up to the last complete 4 chars
              l = placeHolders > 0 ? len - 4 : len;

              var L = 0;

              for (i = 0, j = 0; i < l; i += 4, j += 3) {
                tmp = (revLookup[b64.charCodeAt(i)] << 18) | (revLookup[b64.charCodeAt(i + 1)] << 12) | (revLookup[b64.charCodeAt(i + 2)] << 6) | revLookup[b64.charCodeAt(i + 3)];
                arr[L++] = (tmp >> 16) & 0xFF;
                arr[L++] = (tmp >> 8) & 0xFF;
                arr[L++] = tmp & 0xFF;
              }

              if (placeHolders === 2) {
                tmp = (revLookup[b64.charCodeAt(i)] << 2) | (revLookup[b64.charCodeAt(i + 1)] >> 4);
                arr[L++] = tmp & 0xFF;
              } else if (placeHolders === 1) {
                tmp = (revLookup[b64.charCodeAt(i)] << 10) | (revLookup[b64.charCodeAt(i + 1)] << 4) | (revLookup[b64.charCodeAt(i + 2)] >> 2);
                arr[L++] = (tmp >> 8) & 0xFF;
                arr[L++] = tmp & 0xFF;
              }

              return arr
            }

            function tripletToBase64 (num) {
              return lookup[num >> 18 & 0x3F] + lookup[num >> 12 & 0x3F] + lookup[num >> 6 & 0x3F] + lookup[num & 0x3F]
            }

            function encodeChunk (uint8, start, end) {
              var tmp;
              var output = [];
              for (var i = start; i < end; i += 3) {
                tmp = (uint8[i] << 16) + (uint8[i + 1] << 8) + (uint8[i + 2]);
                output.push(tripletToBase64(tmp));
              }
              return output.join('')
            }

            function fromByteArray (uint8) {
              if (!inited) {
                init();
              }
              var tmp;
              var len = uint8.length;
              var extraBytes = len % 3; // if we have 1 byte left, pad 2 bytes
              var output = '';
              var parts = [];
              var maxChunkLength = 16383; // must be multiple of 3

              // go through the array every three bytes, we'll deal with trailing stuff later
              for (var i = 0, len2 = len - extraBytes; i < len2; i += maxChunkLength) {
                parts.push(encodeChunk(uint8, i, (i + maxChunkLength) > len2 ? len2 : (i + maxChunkLength)));
              }

              // pad the end with zeros, but make sure to not forget the extra bytes
              if (extraBytes === 1) {
                tmp = uint8[len - 1];
                output += lookup[tmp >> 2];
                output += lookup[(tmp << 4) & 0x3F];
                output += '==';
              } else if (extraBytes === 2) {
                tmp = (uint8[len - 2] << 8) + (uint8[len - 1]);
                output += lookup[tmp >> 10];
                output += lookup[(tmp >> 4) & 0x3F];
                output += lookup[(tmp << 2) & 0x3F];
                output += '=';
              }

              parts.push(output);

              return parts.join('')
            }

            function read (buffer, offset, isLE, mLen, nBytes) {
              var e, m;
              var eLen = nBytes * 8 - mLen - 1;
              var eMax = (1 << eLen) - 1;
              var eBias = eMax >> 1;
              var nBits = -7;
              var i = isLE ? (nBytes - 1) : 0;
              var d = isLE ? -1 : 1;
              var s = buffer[offset + i];

              i += d;

              e = s & ((1 << (-nBits)) - 1);
              s >>= (-nBits);
              nBits += eLen;
              for (; nBits > 0; e = e * 256 + buffer[offset + i], i += d, nBits -= 8) {}

              m = e & ((1 << (-nBits)) - 1);
              e >>= (-nBits);
              nBits += mLen;
              for (; nBits > 0; m = m * 256 + buffer[offset + i], i += d, nBits -= 8) {}

              if (e === 0) {
                e = 1 - eBias;
              } else if (e === eMax) {
                return m ? NaN : ((s ? -1 : 1) * Infinity)
              } else {
                m = m + Math.pow(2, mLen);
                e = e - eBias;
              }
              return (s ? -1 : 1) * m * Math.pow(2, e - mLen)
            }

            function write (buffer, value, offset, isLE, mLen, nBytes) {
              var e, m, c;
              var eLen = nBytes * 8 - mLen - 1;
              var eMax = (1 << eLen) - 1;
              var eBias = eMax >> 1;
              var rt = (mLen === 23 ? Math.pow(2, -24) - Math.pow(2, -77) : 0);
              var i = isLE ? 0 : (nBytes - 1);
              var d = isLE ? 1 : -1;
              var s = value < 0 || (value === 0 && 1 / value < 0) ? 1 : 0;

              value = Math.abs(value);

              if (isNaN(value) || value === Infinity) {
                m = isNaN(value) ? 1 : 0;
                e = eMax;
              } else {
                e = Math.floor(Math.log(value) / Math.LN2);
                if (value * (c = Math.pow(2, -e)) < 1) {
                  e--;
                  c *= 2;
                }
                if (e + eBias >= 1) {
                  value += rt / c;
                } else {
                  value += rt * Math.pow(2, 1 - eBias);
                }
                if (value * c >= 2) {
                  e++;
                  c /= 2;
                }

                if (e + eBias >= eMax) {
                  m = 0;
                  e = eMax;
                } else if (e + eBias >= 1) {
                  m = (value * c - 1) * Math.pow(2, mLen);
                  e = e + eBias;
                } else {
                  m = value * Math.pow(2, eBias - 1) * Math.pow(2, mLen);
                  e = 0;
                }
              }

              for (; mLen >= 8; buffer[offset + i] = m & 0xff, i += d, m /= 256, mLen -= 8) {}

              e = (e << mLen) | m;
              eLen += mLen;
              for (; eLen > 0; buffer[offset + i] = e & 0xff, i += d, e /= 256, eLen -= 8) {}

              buffer[offset + i - d] |= s * 128;
            }

            var toString$3 = {}.toString;

            var isArray$5 = Array.isArray || function (arr) {
              return toString$3.call(arr) == '[object Array]';
            };

            /*!
             * The buffer module from node.js, for the browser.
             *
             * @author   Feross Aboukhadijeh <feross@feross.org> <http://feross.org>
             * @license  MIT
             */

            var INSPECT_MAX_BYTES = 50;

            /**
             * If `Buffer.TYPED_ARRAY_SUPPORT`:
             *   === true    Use Uint8Array implementation (fastest)
             *   === false   Use Object implementation (most compatible, even IE6)
             *
             * Browsers that support typed arrays are IE 10+, Firefox 4+, Chrome 7+, Safari 5.1+,
             * Opera 11.6+, iOS 4.2+.
             *
             * Due to various browser bugs, sometimes the Object implementation will be used even
             * when the browser supports typed arrays.
             *
             * Note:
             *
             *   - Firefox 4-29 lacks support for adding new properties to `Uint8Array` instances,
             *     See: https://bugzilla.mozilla.org/show_bug.cgi?id=695438.
             *
             *   - Chrome 9-10 is missing the `TypedArray.prototype.subarray` function.
             *
             *   - IE10 has a broken `TypedArray.prototype.subarray` function which returns arrays of
             *     incorrect length in some situations.

             * We detect these buggy browsers and set `Buffer.TYPED_ARRAY_SUPPORT` to `false` so they
             * get the Object implementation, which is slower but behaves correctly.
             */
            Buffer$1.TYPED_ARRAY_SUPPORT = global$1.TYPED_ARRAY_SUPPORT !== undefined
              ? global$1.TYPED_ARRAY_SUPPORT
              : true;

            function kMaxLength () {
              return Buffer$1.TYPED_ARRAY_SUPPORT
                ? 0x7fffffff
                : 0x3fffffff
            }

            function createBuffer (that, length) {
              if (kMaxLength() < length) {
                throw new RangeError('Invalid typed array length')
              }
              if (Buffer$1.TYPED_ARRAY_SUPPORT) {
                // Return an augmented `Uint8Array` instance, for best performance
                that = new Uint8Array(length);
                that.__proto__ = Buffer$1.prototype;
              } else {
                // Fallback: Return an object instance of the Buffer class
                if (that === null) {
                  that = new Buffer$1(length);
                }
                that.length = length;
              }

              return that
            }

            /**
             * The Buffer constructor returns instances of `Uint8Array` that have their
             * prototype changed to `Buffer.prototype`. Furthermore, `Buffer` is a subclass of
             * `Uint8Array`, so the returned instances will have all the node `Buffer` methods
             * and the `Uint8Array` methods. Square bracket notation works as expected -- it
             * returns a single octet.
             *
             * The `Uint8Array` prototype remains unmodified.
             */

            function Buffer$1 (arg, encodingOrOffset, length) {
              if (!Buffer$1.TYPED_ARRAY_SUPPORT && !(this instanceof Buffer$1)) {
                return new Buffer$1(arg, encodingOrOffset, length)
              }

              // Common case.
              if (typeof arg === 'number') {
                if (typeof encodingOrOffset === 'string') {
                  throw new Error(
                    'If encoding is specified then the first argument must be a string'
                  )
                }
                return allocUnsafe(this, arg)
              }
              return from(this, arg, encodingOrOffset, length)
            }

            Buffer$1.poolSize = 8192; // not used by this implementation

            // TODO: Legacy, not needed anymore. Remove in next major version.
            Buffer$1._augment = function (arr) {
              arr.__proto__ = Buffer$1.prototype;
              return arr
            };

            function from (that, value, encodingOrOffset, length) {
              if (typeof value === 'number') {
                throw new TypeError('"value" argument must not be a number')
              }

              if (typeof ArrayBuffer !== 'undefined' && value instanceof ArrayBuffer) {
                return fromArrayBuffer(that, value, encodingOrOffset, length)
              }

              if (typeof value === 'string') {
                return fromString(that, value, encodingOrOffset)
              }

              return fromObject(that, value)
            }

            /**
             * Functionally equivalent to Buffer(arg, encoding) but throws a TypeError
             * if value is a number.
             * Buffer.from(str[, encoding])
             * Buffer.from(array)
             * Buffer.from(buffer)
             * Buffer.from(arrayBuffer[, byteOffset[, length]])
             **/
            Buffer$1.from = function (value, encodingOrOffset, length) {
              return from(null, value, encodingOrOffset, length)
            };

            if (Buffer$1.TYPED_ARRAY_SUPPORT) {
              Buffer$1.prototype.__proto__ = Uint8Array.prototype;
              Buffer$1.__proto__ = Uint8Array;
            }

            function assertSize (size) {
              if (typeof size !== 'number') {
                throw new TypeError('"size" argument must be a number')
              } else if (size < 0) {
                throw new RangeError('"size" argument must not be negative')
              }
            }

            function alloc (that, size, fill, encoding) {
              assertSize(size);
              if (size <= 0) {
                return createBuffer(that, size)
              }
              if (fill !== undefined) {
                // Only pay attention to encoding if it's a string. This
                // prevents accidentally sending in a number that would
                // be interpretted as a start offset.
                return typeof encoding === 'string'
                  ? createBuffer(that, size).fill(fill, encoding)
                  : createBuffer(that, size).fill(fill)
              }
              return createBuffer(that, size)
            }

            /**
             * Creates a new filled Buffer instance.
             * alloc(size[, fill[, encoding]])
             **/
            Buffer$1.alloc = function (size, fill, encoding) {
              return alloc(null, size, fill, encoding)
            };

            function allocUnsafe (that, size) {
              assertSize(size);
              that = createBuffer(that, size < 0 ? 0 : checked(size) | 0);
              if (!Buffer$1.TYPED_ARRAY_SUPPORT) {
                for (var i = 0; i < size; ++i) {
                  that[i] = 0;
                }
              }
              return that
            }

            /**
             * Equivalent to Buffer(num), by default creates a non-zero-filled Buffer instance.
             * */
            Buffer$1.allocUnsafe = function (size) {
              return allocUnsafe(null, size)
            };
            /**
             * Equivalent to SlowBuffer(num), by default creates a non-zero-filled Buffer instance.
             */
            Buffer$1.allocUnsafeSlow = function (size) {
              return allocUnsafe(null, size)
            };

            function fromString (that, string, encoding) {
              if (typeof encoding !== 'string' || encoding === '') {
                encoding = 'utf8';
              }

              if (!Buffer$1.isEncoding(encoding)) {
                throw new TypeError('"encoding" must be a valid string encoding')
              }

              var length = byteLength(string, encoding) | 0;
              that = createBuffer(that, length);

              var actual = that.write(string, encoding);

              if (actual !== length) {
                // Writing a hex string, for example, that contains invalid characters will
                // cause everything after the first invalid character to be ignored. (e.g.
                // 'abxxcd' will be treated as 'ab')
                that = that.slice(0, actual);
              }

              return that
            }

            function fromArrayLike (that, array) {
              var length = array.length < 0 ? 0 : checked(array.length) | 0;
              that = createBuffer(that, length);
              for (var i = 0; i < length; i += 1) {
                that[i] = array[i] & 255;
              }
              return that
            }

            function fromArrayBuffer (that, array, byteOffset, length) {
              array.byteLength; // this throws if `array` is not a valid ArrayBuffer

              if (byteOffset < 0 || array.byteLength < byteOffset) {
                throw new RangeError('\'offset\' is out of bounds')
              }

              if (array.byteLength < byteOffset + (length || 0)) {
                throw new RangeError('\'length\' is out of bounds')
              }

              if (byteOffset === undefined && length === undefined) {
                array = new Uint8Array(array);
              } else if (length === undefined) {
                array = new Uint8Array(array, byteOffset);
              } else {
                array = new Uint8Array(array, byteOffset, length);
              }

              if (Buffer$1.TYPED_ARRAY_SUPPORT) {
                // Return an augmented `Uint8Array` instance, for best performance
                that = array;
                that.__proto__ = Buffer$1.prototype;
              } else {
                // Fallback: Return an object instance of the Buffer class
                that = fromArrayLike(that, array);
              }
              return that
            }

            function fromObject (that, obj) {
              if (internalIsBuffer(obj)) {
                var len = checked(obj.length) | 0;
                that = createBuffer(that, len);

                if (that.length === 0) {
                  return that
                }

                obj.copy(that, 0, 0, len);
                return that
              }

              if (obj) {
                if ((typeof ArrayBuffer !== 'undefined' &&
                    obj.buffer instanceof ArrayBuffer) || 'length' in obj) {
                  if (typeof obj.length !== 'number' || isnan(obj.length)) {
                    return createBuffer(that, 0)
                  }
                  return fromArrayLike(that, obj)
                }

                if (obj.type === 'Buffer' && isArray$5(obj.data)) {
                  return fromArrayLike(that, obj.data)
                }
              }

              throw new TypeError('First argument must be a string, Buffer, ArrayBuffer, Array, or array-like object.')
            }

            function checked (length) {
              // Note: cannot use `length < kMaxLength()` here because that fails when
              // length is NaN (which is otherwise coerced to zero.)
              if (length >= kMaxLength()) {
                throw new RangeError('Attempt to allocate Buffer larger than maximum ' +
                                     'size: 0x' + kMaxLength().toString(16) + ' bytes')
              }
              return length | 0
            }
            Buffer$1.isBuffer = isBuffer$1;
            function internalIsBuffer (b) {
              return !!(b != null && b._isBuffer)
            }

            Buffer$1.compare = function compare (a, b) {
              if (!internalIsBuffer(a) || !internalIsBuffer(b)) {
                throw new TypeError('Arguments must be Buffers')
              }

              if (a === b) return 0

              var x = a.length;
              var y = b.length;

              for (var i = 0, len = Math.min(x, y); i < len; ++i) {
                if (a[i] !== b[i]) {
                  x = a[i];
                  y = b[i];
                  break
                }
              }

              if (x < y) return -1
              if (y < x) return 1
              return 0
            };

            Buffer$1.isEncoding = function isEncoding (encoding) {
              switch (String(encoding).toLowerCase()) {
                case 'hex':
                case 'utf8':
                case 'utf-8':
                case 'ascii':
                case 'latin1':
                case 'binary':
                case 'base64':
                case 'ucs2':
                case 'ucs-2':
                case 'utf16le':
                case 'utf-16le':
                  return true
                default:
                  return false
              }
            };

            Buffer$1.concat = function concat (list, length) {
              if (!isArray$5(list)) {
                throw new TypeError('"list" argument must be an Array of Buffers')
              }

              if (list.length === 0) {
                return Buffer$1.alloc(0)
              }

              var i;
              if (length === undefined) {
                length = 0;
                for (i = 0; i < list.length; ++i) {
                  length += list[i].length;
                }
              }

              var buffer = Buffer$1.allocUnsafe(length);
              var pos = 0;
              for (i = 0; i < list.length; ++i) {
                var buf = list[i];
                if (!internalIsBuffer(buf)) {
                  throw new TypeError('"list" argument must be an Array of Buffers')
                }
                buf.copy(buffer, pos);
                pos += buf.length;
              }
              return buffer
            };

            function byteLength (string, encoding) {
              if (internalIsBuffer(string)) {
                return string.length
              }
              if (typeof ArrayBuffer !== 'undefined' && typeof ArrayBuffer.isView === 'function' &&
                  (ArrayBuffer.isView(string) || string instanceof ArrayBuffer)) {
                return string.byteLength
              }
              if (typeof string !== 'string') {
                string = '' + string;
              }

              var len = string.length;
              if (len === 0) return 0

              // Use a for loop to avoid recursion
              var loweredCase = false;
              for (;;) {
                switch (encoding) {
                  case 'ascii':
                  case 'latin1':
                  case 'binary':
                    return len
                  case 'utf8':
                  case 'utf-8':
                  case undefined:
                    return utf8ToBytes(string).length
                  case 'ucs2':
                  case 'ucs-2':
                  case 'utf16le':
                  case 'utf-16le':
                    return len * 2
                  case 'hex':
                    return len >>> 1
                  case 'base64':
                    return base64ToBytes(string).length
                  default:
                    if (loweredCase) return utf8ToBytes(string).length // assume utf8
                    encoding = ('' + encoding).toLowerCase();
                    loweredCase = true;
                }
              }
            }
            Buffer$1.byteLength = byteLength;

            function slowToString (encoding, start, end) {
              var loweredCase = false;

              // No need to verify that "this.length <= MAX_UINT32" since it's a read-only
              // property of a typed array.

              // This behaves neither like String nor Uint8Array in that we set start/end
              // to their upper/lower bounds if the value passed is out of range.
              // undefined is handled specially as per ECMA-262 6th Edition,
              // Section 13.3.3.7 Runtime Semantics: KeyedBindingInitialization.
              if (start === undefined || start < 0) {
                start = 0;
              }
              // Return early if start > this.length. Done here to prevent potential uint32
              // coercion fail below.
              if (start > this.length) {
                return ''
              }

              if (end === undefined || end > this.length) {
                end = this.length;
              }

              if (end <= 0) {
                return ''
              }

              // Force coersion to uint32. This will also coerce falsey/NaN values to 0.
              end >>>= 0;
              start >>>= 0;

              if (end <= start) {
                return ''
              }

              if (!encoding) encoding = 'utf8';

              while (true) {
                switch (encoding) {
                  case 'hex':
                    return hexSlice(this, start, end)

                  case 'utf8':
                  case 'utf-8':
                    return utf8Slice(this, start, end)

                  case 'ascii':
                    return asciiSlice(this, start, end)

                  case 'latin1':
                  case 'binary':
                    return latin1Slice(this, start, end)

                  case 'base64':
                    return base64Slice(this, start, end)

                  case 'ucs2':
                  case 'ucs-2':
                  case 'utf16le':
                  case 'utf-16le':
                    return utf16leSlice(this, start, end)

                  default:
                    if (loweredCase) throw new TypeError('Unknown encoding: ' + encoding)
                    encoding = (encoding + '').toLowerCase();
                    loweredCase = true;
                }
              }
            }

            // The property is used by `Buffer.isBuffer` and `is-buffer` (in Safari 5-7) to detect
            // Buffer instances.
            Buffer$1.prototype._isBuffer = true;

            function swap (b, n, m) {
              var i = b[n];
              b[n] = b[m];
              b[m] = i;
            }

            Buffer$1.prototype.swap16 = function swap16 () {
              var len = this.length;
              if (len % 2 !== 0) {
                throw new RangeError('Buffer size must be a multiple of 16-bits')
              }
              for (var i = 0; i < len; i += 2) {
                swap(this, i, i + 1);
              }
              return this
            };

            Buffer$1.prototype.swap32 = function swap32 () {
              var len = this.length;
              if (len % 4 !== 0) {
                throw new RangeError('Buffer size must be a multiple of 32-bits')
              }
              for (var i = 0; i < len; i += 4) {
                swap(this, i, i + 3);
                swap(this, i + 1, i + 2);
              }
              return this
            };

            Buffer$1.prototype.swap64 = function swap64 () {
              var len = this.length;
              if (len % 8 !== 0) {
                throw new RangeError('Buffer size must be a multiple of 64-bits')
              }
              for (var i = 0; i < len; i += 8) {
                swap(this, i, i + 7);
                swap(this, i + 1, i + 6);
                swap(this, i + 2, i + 5);
                swap(this, i + 3, i + 4);
              }
              return this
            };

            Buffer$1.prototype.toString = function toString () {
              var length = this.length | 0;
              if (length === 0) return ''
              if (arguments.length === 0) return utf8Slice(this, 0, length)
              return slowToString.apply(this, arguments)
            };

            Buffer$1.prototype.equals = function equals (b) {
              if (!internalIsBuffer(b)) throw new TypeError('Argument must be a Buffer')
              if (this === b) return true
              return Buffer$1.compare(this, b) === 0
            };

            Buffer$1.prototype.inspect = function inspect () {
              var str = '';
              var max = INSPECT_MAX_BYTES;
              if (this.length > 0) {
                str = this.toString('hex', 0, max).match(/.{2}/g).join(' ');
                if (this.length > max) str += ' ... ';
              }
              return '<Buffer ' + str + '>'
            };

            Buffer$1.prototype.compare = function compare (target, start, end, thisStart, thisEnd) {
              if (!internalIsBuffer(target)) {
                throw new TypeError('Argument must be a Buffer')
              }

              if (start === undefined) {
                start = 0;
              }
              if (end === undefined) {
                end = target ? target.length : 0;
              }
              if (thisStart === undefined) {
                thisStart = 0;
              }
              if (thisEnd === undefined) {
                thisEnd = this.length;
              }

              if (start < 0 || end > target.length || thisStart < 0 || thisEnd > this.length) {
                throw new RangeError('out of range index')
              }

              if (thisStart >= thisEnd && start >= end) {
                return 0
              }
              if (thisStart >= thisEnd) {
                return -1
              }
              if (start >= end) {
                return 1
              }

              start >>>= 0;
              end >>>= 0;
              thisStart >>>= 0;
              thisEnd >>>= 0;

              if (this === target) return 0

              var x = thisEnd - thisStart;
              var y = end - start;
              var len = Math.min(x, y);

              var thisCopy = this.slice(thisStart, thisEnd);
              var targetCopy = target.slice(start, end);

              for (var i = 0; i < len; ++i) {
                if (thisCopy[i] !== targetCopy[i]) {
                  x = thisCopy[i];
                  y = targetCopy[i];
                  break
                }
              }

              if (x < y) return -1
              if (y < x) return 1
              return 0
            };

            // Finds either the first index of `val` in `buffer` at offset >= `byteOffset`,
            // OR the last index of `val` in `buffer` at offset <= `byteOffset`.
            //
            // Arguments:
            // - buffer - a Buffer to search
            // - val - a string, Buffer, or number
            // - byteOffset - an index into `buffer`; will be clamped to an int32
            // - encoding - an optional encoding, relevant is val is a string
            // - dir - true for indexOf, false for lastIndexOf
            function bidirectionalIndexOf (buffer, val, byteOffset, encoding, dir) {
              // Empty buffer means no match
              if (buffer.length === 0) return -1

              // Normalize byteOffset
              if (typeof byteOffset === 'string') {
                encoding = byteOffset;
                byteOffset = 0;
              } else if (byteOffset > 0x7fffffff) {
                byteOffset = 0x7fffffff;
              } else if (byteOffset < -0x80000000) {
                byteOffset = -0x80000000;
              }
              byteOffset = +byteOffset;  // Coerce to Number.
              if (isNaN(byteOffset)) {
                // byteOffset: it it's undefined, null, NaN, "foo", etc, search whole buffer
                byteOffset = dir ? 0 : (buffer.length - 1);
              }

              // Normalize byteOffset: negative offsets start from the end of the buffer
              if (byteOffset < 0) byteOffset = buffer.length + byteOffset;
              if (byteOffset >= buffer.length) {
                if (dir) return -1
                else byteOffset = buffer.length - 1;
              } else if (byteOffset < 0) {
                if (dir) byteOffset = 0;
                else return -1
              }

              // Normalize val
              if (typeof val === 'string') {
                val = Buffer$1.from(val, encoding);
              }

              // Finally, search either indexOf (if dir is true) or lastIndexOf
              if (internalIsBuffer(val)) {
                // Special case: looking for empty string/buffer always fails
                if (val.length === 0) {
                  return -1
                }
                return arrayIndexOf(buffer, val, byteOffset, encoding, dir)
              } else if (typeof val === 'number') {
                val = val & 0xFF; // Search for a byte value [0-255]
                if (Buffer$1.TYPED_ARRAY_SUPPORT &&
                    typeof Uint8Array.prototype.indexOf === 'function') {
                  if (dir) {
                    return Uint8Array.prototype.indexOf.call(buffer, val, byteOffset)
                  } else {
                    return Uint8Array.prototype.lastIndexOf.call(buffer, val, byteOffset)
                  }
                }
                return arrayIndexOf(buffer, [ val ], byteOffset, encoding, dir)
              }

              throw new TypeError('val must be string, number or Buffer')
            }

            function arrayIndexOf (arr, val, byteOffset, encoding, dir) {
              var indexSize = 1;
              var arrLength = arr.length;
              var valLength = val.length;

              if (encoding !== undefined) {
                encoding = String(encoding).toLowerCase();
                if (encoding === 'ucs2' || encoding === 'ucs-2' ||
                    encoding === 'utf16le' || encoding === 'utf-16le') {
                  if (arr.length < 2 || val.length < 2) {
                    return -1
                  }
                  indexSize = 2;
                  arrLength /= 2;
                  valLength /= 2;
                  byteOffset /= 2;
                }
              }

              function read (buf, i) {
                if (indexSize === 1) {
                  return buf[i]
                } else {
                  return buf.readUInt16BE(i * indexSize)
                }
              }

              var i;
              if (dir) {
                var foundIndex = -1;
                for (i = byteOffset; i < arrLength; i++) {
                  if (read(arr, i) === read(val, foundIndex === -1 ? 0 : i - foundIndex)) {
                    if (foundIndex === -1) foundIndex = i;
                    if (i - foundIndex + 1 === valLength) return foundIndex * indexSize
                  } else {
                    if (foundIndex !== -1) i -= i - foundIndex;
                    foundIndex = -1;
                  }
                }
              } else {
                if (byteOffset + valLength > arrLength) byteOffset = arrLength - valLength;
                for (i = byteOffset; i >= 0; i--) {
                  var found = true;
                  for (var j = 0; j < valLength; j++) {
                    if (read(arr, i + j) !== read(val, j)) {
                      found = false;
                      break
                    }
                  }
                  if (found) return i
                }
              }

              return -1
            }

            Buffer$1.prototype.includes = function includes (val, byteOffset, encoding) {
              return this.indexOf(val, byteOffset, encoding) !== -1
            };

            Buffer$1.prototype.indexOf = function indexOf (val, byteOffset, encoding) {
              return bidirectionalIndexOf(this, val, byteOffset, encoding, true)
            };

            Buffer$1.prototype.lastIndexOf = function lastIndexOf (val, byteOffset, encoding) {
              return bidirectionalIndexOf(this, val, byteOffset, encoding, false)
            };

            function hexWrite (buf, string, offset, length) {
              offset = Number(offset) || 0;
              var remaining = buf.length - offset;
              if (!length) {
                length = remaining;
              } else {
                length = Number(length);
                if (length > remaining) {
                  length = remaining;
                }
              }

              // must be an even number of digits
              var strLen = string.length;
              if (strLen % 2 !== 0) throw new TypeError('Invalid hex string')

              if (length > strLen / 2) {
                length = strLen / 2;
              }
              for (var i = 0; i < length; ++i) {
                var parsed = parseInt(string.substr(i * 2, 2), 16);
                if (isNaN(parsed)) return i
                buf[offset + i] = parsed;
              }
              return i
            }

            function utf8Write (buf, string, offset, length) {
              return blitBuffer(utf8ToBytes(string, buf.length - offset), buf, offset, length)
            }

            function asciiWrite (buf, string, offset, length) {
              return blitBuffer(asciiToBytes(string), buf, offset, length)
            }

            function latin1Write (buf, string, offset, length) {
              return asciiWrite(buf, string, offset, length)
            }

            function base64Write (buf, string, offset, length) {
              return blitBuffer(base64ToBytes(string), buf, offset, length)
            }

            function ucs2Write (buf, string, offset, length) {
              return blitBuffer(utf16leToBytes(string, buf.length - offset), buf, offset, length)
            }

            Buffer$1.prototype.write = function write (string, offset, length, encoding) {
              // Buffer#write(string)
              if (offset === undefined) {
                encoding = 'utf8';
                length = this.length;
                offset = 0;
              // Buffer#write(string, encoding)
              } else if (length === undefined && typeof offset === 'string') {
                encoding = offset;
                length = this.length;
                offset = 0;
              // Buffer#write(string, offset[, length][, encoding])
              } else if (isFinite(offset)) {
                offset = offset | 0;
                if (isFinite(length)) {
                  length = length | 0;
                  if (encoding === undefined) encoding = 'utf8';
                } else {
                  encoding = length;
                  length = undefined;
                }
              // legacy write(string, encoding, offset, length) - remove in v0.13
              } else {
                throw new Error(
                  'Buffer.write(string, encoding, offset[, length]) is no longer supported'
                )
              }

              var remaining = this.length - offset;
              if (length === undefined || length > remaining) length = remaining;

              if ((string.length > 0 && (length < 0 || offset < 0)) || offset > this.length) {
                throw new RangeError('Attempt to write outside buffer bounds')
              }

              if (!encoding) encoding = 'utf8';

              var loweredCase = false;
              for (;;) {
                switch (encoding) {
                  case 'hex':
                    return hexWrite(this, string, offset, length)

                  case 'utf8':
                  case 'utf-8':
                    return utf8Write(this, string, offset, length)

                  case 'ascii':
                    return asciiWrite(this, string, offset, length)

                  case 'latin1':
                  case 'binary':
                    return latin1Write(this, string, offset, length)

                  case 'base64':
                    // Warning: maxLength not taken into account in base64Write
                    return base64Write(this, string, offset, length)

                  case 'ucs2':
                  case 'ucs-2':
                  case 'utf16le':
                  case 'utf-16le':
                    return ucs2Write(this, string, offset, length)

                  default:
                    if (loweredCase) throw new TypeError('Unknown encoding: ' + encoding)
                    encoding = ('' + encoding).toLowerCase();
                    loweredCase = true;
                }
              }
            };

            Buffer$1.prototype.toJSON = function toJSON () {
              return {
                type: 'Buffer',
                data: Array.prototype.slice.call(this._arr || this, 0)
              }
            };

            function base64Slice (buf, start, end) {
              if (start === 0 && end === buf.length) {
                return fromByteArray(buf)
              } else {
                return fromByteArray(buf.slice(start, end))
              }
            }

            function utf8Slice (buf, start, end) {
              end = Math.min(buf.length, end);
              var res = [];

              var i = start;
              while (i < end) {
                var firstByte = buf[i];
                var codePoint = null;
                var bytesPerSequence = (firstByte > 0xEF) ? 4
                  : (firstByte > 0xDF) ? 3
                  : (firstByte > 0xBF) ? 2
                  : 1;

                if (i + bytesPerSequence <= end) {
                  var secondByte, thirdByte, fourthByte, tempCodePoint;

                  switch (bytesPerSequence) {
                    case 1:
                      if (firstByte < 0x80) {
                        codePoint = firstByte;
                      }
                      break
                    case 2:
                      secondByte = buf[i + 1];
                      if ((secondByte & 0xC0) === 0x80) {
                        tempCodePoint = (firstByte & 0x1F) << 0x6 | (secondByte & 0x3F);
                        if (tempCodePoint > 0x7F) {
                          codePoint = tempCodePoint;
                        }
                      }
                      break
                    case 3:
                      secondByte = buf[i + 1];
                      thirdByte = buf[i + 2];
                      if ((secondByte & 0xC0) === 0x80 && (thirdByte & 0xC0) === 0x80) {
                        tempCodePoint = (firstByte & 0xF) << 0xC | (secondByte & 0x3F) << 0x6 | (thirdByte & 0x3F);
                        if (tempCodePoint > 0x7FF && (tempCodePoint < 0xD800 || tempCodePoint > 0xDFFF)) {
                          codePoint = tempCodePoint;
                        }
                      }
                      break
                    case 4:
                      secondByte = buf[i + 1];
                      thirdByte = buf[i + 2];
                      fourthByte = buf[i + 3];
                      if ((secondByte & 0xC0) === 0x80 && (thirdByte & 0xC0) === 0x80 && (fourthByte & 0xC0) === 0x80) {
                        tempCodePoint = (firstByte & 0xF) << 0x12 | (secondByte & 0x3F) << 0xC | (thirdByte & 0x3F) << 0x6 | (fourthByte & 0x3F);
                        if (tempCodePoint > 0xFFFF && tempCodePoint < 0x110000) {
                          codePoint = tempCodePoint;
                        }
                      }
                  }
                }

                if (codePoint === null) {
                  // we did not generate a valid codePoint so insert a
                  // replacement char (U+FFFD) and advance only 1 byte
                  codePoint = 0xFFFD;
                  bytesPerSequence = 1;
                } else if (codePoint > 0xFFFF) {
                  // encode to utf16 (surrogate pair dance)
                  codePoint -= 0x10000;
                  res.push(codePoint >>> 10 & 0x3FF | 0xD800);
                  codePoint = 0xDC00 | codePoint & 0x3FF;
                }

                res.push(codePoint);
                i += bytesPerSequence;
              }

              return decodeCodePointsArray(res)
            }

            // Based on http://stackoverflow.com/a/22747272/680742, the browser with
            // the lowest limit is Chrome, with 0x10000 args.
            // We go 1 magnitude less, for safety
            var MAX_ARGUMENTS_LENGTH = 0x1000;

            function decodeCodePointsArray (codePoints) {
              var len = codePoints.length;
              if (len <= MAX_ARGUMENTS_LENGTH) {
                return String.fromCharCode.apply(String, codePoints) // avoid extra slice()
              }

              // Decode in chunks to avoid "call stack size exceeded".
              var res = '';
              var i = 0;
              while (i < len) {
                res += String.fromCharCode.apply(
                  String,
                  codePoints.slice(i, i += MAX_ARGUMENTS_LENGTH)
                );
              }
              return res
            }

            function asciiSlice (buf, start, end) {
              var ret = '';
              end = Math.min(buf.length, end);

              for (var i = start; i < end; ++i) {
                ret += String.fromCharCode(buf[i] & 0x7F);
              }
              return ret
            }

            function latin1Slice (buf, start, end) {
              var ret = '';
              end = Math.min(buf.length, end);

              for (var i = start; i < end; ++i) {
                ret += String.fromCharCode(buf[i]);
              }
              return ret
            }

            function hexSlice (buf, start, end) {
              var len = buf.length;

              if (!start || start < 0) start = 0;
              if (!end || end < 0 || end > len) end = len;

              var out = '';
              for (var i = start; i < end; ++i) {
                out += toHex(buf[i]);
              }
              return out
            }

            function utf16leSlice (buf, start, end) {
              var bytes = buf.slice(start, end);
              var res = '';
              for (var i = 0; i < bytes.length; i += 2) {
                res += String.fromCharCode(bytes[i] + bytes[i + 1] * 256);
              }
              return res
            }

            Buffer$1.prototype.slice = function slice (start, end) {
              var len = this.length;
              start = ~~start;
              end = end === undefined ? len : ~~end;

              if (start < 0) {
                start += len;
                if (start < 0) start = 0;
              } else if (start > len) {
                start = len;
              }

              if (end < 0) {
                end += len;
                if (end < 0) end = 0;
              } else if (end > len) {
                end = len;
              }

              if (end < start) end = start;

              var newBuf;
              if (Buffer$1.TYPED_ARRAY_SUPPORT) {
                newBuf = this.subarray(start, end);
                newBuf.__proto__ = Buffer$1.prototype;
              } else {
                var sliceLen = end - start;
                newBuf = new Buffer$1(sliceLen, undefined);
                for (var i = 0; i < sliceLen; ++i) {
                  newBuf[i] = this[i + start];
                }
              }

              return newBuf
            };

            /*
             * Need to make sure that buffer isn't trying to write out of bounds.
             */
            function checkOffset (offset, ext, length) {
              if ((offset % 1) !== 0 || offset < 0) throw new RangeError('offset is not uint')
              if (offset + ext > length) throw new RangeError('Trying to access beyond buffer length')
            }

            Buffer$1.prototype.readUIntLE = function readUIntLE (offset, byteLength, noAssert) {
              offset = offset | 0;
              byteLength = byteLength | 0;
              if (!noAssert) checkOffset(offset, byteLength, this.length);

              var val = this[offset];
              var mul = 1;
              var i = 0;
              while (++i < byteLength && (mul *= 0x100)) {
                val += this[offset + i] * mul;
              }

              return val
            };

            Buffer$1.prototype.readUIntBE = function readUIntBE (offset, byteLength, noAssert) {
              offset = offset | 0;
              byteLength = byteLength | 0;
              if (!noAssert) {
                checkOffset(offset, byteLength, this.length);
              }

              var val = this[offset + --byteLength];
              var mul = 1;
              while (byteLength > 0 && (mul *= 0x100)) {
                val += this[offset + --byteLength] * mul;
              }

              return val
            };

            Buffer$1.prototype.readUInt8 = function readUInt8 (offset, noAssert) {
              if (!noAssert) checkOffset(offset, 1, this.length);
              return this[offset]
            };

            Buffer$1.prototype.readUInt16LE = function readUInt16LE (offset, noAssert) {
              if (!noAssert) checkOffset(offset, 2, this.length);
              return this[offset] | (this[offset + 1] << 8)
            };

            Buffer$1.prototype.readUInt16BE = function readUInt16BE (offset, noAssert) {
              if (!noAssert) checkOffset(offset, 2, this.length);
              return (this[offset] << 8) | this[offset + 1]
            };

            Buffer$1.prototype.readUInt32LE = function readUInt32LE (offset, noAssert) {
              if (!noAssert) checkOffset(offset, 4, this.length);

              return ((this[offset]) |
                  (this[offset + 1] << 8) |
                  (this[offset + 2] << 16)) +
                  (this[offset + 3] * 0x1000000)
            };

            Buffer$1.prototype.readUInt32BE = function readUInt32BE (offset, noAssert) {
              if (!noAssert) checkOffset(offset, 4, this.length);

              return (this[offset] * 0x1000000) +
                ((this[offset + 1] << 16) |
                (this[offset + 2] << 8) |
                this[offset + 3])
            };

            Buffer$1.prototype.readIntLE = function readIntLE (offset, byteLength, noAssert) {
              offset = offset | 0;
              byteLength = byteLength | 0;
              if (!noAssert) checkOffset(offset, byteLength, this.length);

              var val = this[offset];
              var mul = 1;
              var i = 0;
              while (++i < byteLength && (mul *= 0x100)) {
                val += this[offset + i] * mul;
              }
              mul *= 0x80;

              if (val >= mul) val -= Math.pow(2, 8 * byteLength);

              return val
            };

            Buffer$1.prototype.readIntBE = function readIntBE (offset, byteLength, noAssert) {
              offset = offset | 0;
              byteLength = byteLength | 0;
              if (!noAssert) checkOffset(offset, byteLength, this.length);

              var i = byteLength;
              var mul = 1;
              var val = this[offset + --i];
              while (i > 0 && (mul *= 0x100)) {
                val += this[offset + --i] * mul;
              }
              mul *= 0x80;

              if (val >= mul) val -= Math.pow(2, 8 * byteLength);

              return val
            };

            Buffer$1.prototype.readInt8 = function readInt8 (offset, noAssert) {
              if (!noAssert) checkOffset(offset, 1, this.length);
              if (!(this[offset] & 0x80)) return (this[offset])
              return ((0xff - this[offset] + 1) * -1)
            };

            Buffer$1.prototype.readInt16LE = function readInt16LE (offset, noAssert) {
              if (!noAssert) checkOffset(offset, 2, this.length);
              var val = this[offset] | (this[offset + 1] << 8);
              return (val & 0x8000) ? val | 0xFFFF0000 : val
            };

            Buffer$1.prototype.readInt16BE = function readInt16BE (offset, noAssert) {
              if (!noAssert) checkOffset(offset, 2, this.length);
              var val = this[offset + 1] | (this[offset] << 8);
              return (val & 0x8000) ? val | 0xFFFF0000 : val
            };

            Buffer$1.prototype.readInt32LE = function readInt32LE (offset, noAssert) {
              if (!noAssert) checkOffset(offset, 4, this.length);

              return (this[offset]) |
                (this[offset + 1] << 8) |
                (this[offset + 2] << 16) |
                (this[offset + 3] << 24)
            };

            Buffer$1.prototype.readInt32BE = function readInt32BE (offset, noAssert) {
              if (!noAssert) checkOffset(offset, 4, this.length);

              return (this[offset] << 24) |
                (this[offset + 1] << 16) |
                (this[offset + 2] << 8) |
                (this[offset + 3])
            };

            Buffer$1.prototype.readFloatLE = function readFloatLE (offset, noAssert) {
              if (!noAssert) checkOffset(offset, 4, this.length);
              return read(this, offset, true, 23, 4)
            };

            Buffer$1.prototype.readFloatBE = function readFloatBE (offset, noAssert) {
              if (!noAssert) checkOffset(offset, 4, this.length);
              return read(this, offset, false, 23, 4)
            };

            Buffer$1.prototype.readDoubleLE = function readDoubleLE (offset, noAssert) {
              if (!noAssert) checkOffset(offset, 8, this.length);
              return read(this, offset, true, 52, 8)
            };

            Buffer$1.prototype.readDoubleBE = function readDoubleBE (offset, noAssert) {
              if (!noAssert) checkOffset(offset, 8, this.length);
              return read(this, offset, false, 52, 8)
            };

            function checkInt (buf, value, offset, ext, max, min) {
              if (!internalIsBuffer(buf)) throw new TypeError('"buffer" argument must be a Buffer instance')
              if (value > max || value < min) throw new RangeError('"value" argument is out of bounds')
              if (offset + ext > buf.length) throw new RangeError('Index out of range')
            }

            Buffer$1.prototype.writeUIntLE = function writeUIntLE (value, offset, byteLength, noAssert) {
              value = +value;
              offset = offset | 0;
              byteLength = byteLength | 0;
              if (!noAssert) {
                var maxBytes = Math.pow(2, 8 * byteLength) - 1;
                checkInt(this, value, offset, byteLength, maxBytes, 0);
              }

              var mul = 1;
              var i = 0;
              this[offset] = value & 0xFF;
              while (++i < byteLength && (mul *= 0x100)) {
                this[offset + i] = (value / mul) & 0xFF;
              }

              return offset + byteLength
            };

            Buffer$1.prototype.writeUIntBE = function writeUIntBE (value, offset, byteLength, noAssert) {
              value = +value;
              offset = offset | 0;
              byteLength = byteLength | 0;
              if (!noAssert) {
                var maxBytes = Math.pow(2, 8 * byteLength) - 1;
                checkInt(this, value, offset, byteLength, maxBytes, 0);
              }

              var i = byteLength - 1;
              var mul = 1;
              this[offset + i] = value & 0xFF;
              while (--i >= 0 && (mul *= 0x100)) {
                this[offset + i] = (value / mul) & 0xFF;
              }

              return offset + byteLength
            };

            Buffer$1.prototype.writeUInt8 = function writeUInt8 (value, offset, noAssert) {
              value = +value;
              offset = offset | 0;
              if (!noAssert) checkInt(this, value, offset, 1, 0xff, 0);
              if (!Buffer$1.TYPED_ARRAY_SUPPORT) value = Math.floor(value);
              this[offset] = (value & 0xff);
              return offset + 1
            };

            function objectWriteUInt16 (buf, value, offset, littleEndian) {
              if (value < 0) value = 0xffff + value + 1;
              for (var i = 0, j = Math.min(buf.length - offset, 2); i < j; ++i) {
                buf[offset + i] = (value & (0xff << (8 * (littleEndian ? i : 1 - i)))) >>>
                  (littleEndian ? i : 1 - i) * 8;
              }
            }

            Buffer$1.prototype.writeUInt16LE = function writeUInt16LE (value, offset, noAssert) {
              value = +value;
              offset = offset | 0;
              if (!noAssert) checkInt(this, value, offset, 2, 0xffff, 0);
              if (Buffer$1.TYPED_ARRAY_SUPPORT) {
                this[offset] = (value & 0xff);
                this[offset + 1] = (value >>> 8);
              } else {
                objectWriteUInt16(this, value, offset, true);
              }
              return offset + 2
            };

            Buffer$1.prototype.writeUInt16BE = function writeUInt16BE (value, offset, noAssert) {
              value = +value;
              offset = offset | 0;
              if (!noAssert) checkInt(this, value, offset, 2, 0xffff, 0);
              if (Buffer$1.TYPED_ARRAY_SUPPORT) {
                this[offset] = (value >>> 8);
                this[offset + 1] = (value & 0xff);
              } else {
                objectWriteUInt16(this, value, offset, false);
              }
              return offset + 2
            };

            function objectWriteUInt32 (buf, value, offset, littleEndian) {
              if (value < 0) value = 0xffffffff + value + 1;
              for (var i = 0, j = Math.min(buf.length - offset, 4); i < j; ++i) {
                buf[offset + i] = (value >>> (littleEndian ? i : 3 - i) * 8) & 0xff;
              }
            }

            Buffer$1.prototype.writeUInt32LE = function writeUInt32LE (value, offset, noAssert) {
              value = +value;
              offset = offset | 0;
              if (!noAssert) checkInt(this, value, offset, 4, 0xffffffff, 0);
              if (Buffer$1.TYPED_ARRAY_SUPPORT) {
                this[offset + 3] = (value >>> 24);
                this[offset + 2] = (value >>> 16);
                this[offset + 1] = (value >>> 8);
                this[offset] = (value & 0xff);
              } else {
                objectWriteUInt32(this, value, offset, true);
              }
              return offset + 4
            };

            Buffer$1.prototype.writeUInt32BE = function writeUInt32BE (value, offset, noAssert) {
              value = +value;
              offset = offset | 0;
              if (!noAssert) checkInt(this, value, offset, 4, 0xffffffff, 0);
              if (Buffer$1.TYPED_ARRAY_SUPPORT) {
                this[offset] = (value >>> 24);
                this[offset + 1] = (value >>> 16);
                this[offset + 2] = (value >>> 8);
                this[offset + 3] = (value & 0xff);
              } else {
                objectWriteUInt32(this, value, offset, false);
              }
              return offset + 4
            };

            Buffer$1.prototype.writeIntLE = function writeIntLE (value, offset, byteLength, noAssert) {
              value = +value;
              offset = offset | 0;
              if (!noAssert) {
                var limit = Math.pow(2, 8 * byteLength - 1);

                checkInt(this, value, offset, byteLength, limit - 1, -limit);
              }

              var i = 0;
              var mul = 1;
              var sub = 0;
              this[offset] = value & 0xFF;
              while (++i < byteLength && (mul *= 0x100)) {
                if (value < 0 && sub === 0 && this[offset + i - 1] !== 0) {
                  sub = 1;
                }
                this[offset + i] = ((value / mul) >> 0) - sub & 0xFF;
              }

              return offset + byteLength
            };

            Buffer$1.prototype.writeIntBE = function writeIntBE (value, offset, byteLength, noAssert) {
              value = +value;
              offset = offset | 0;
              if (!noAssert) {
                var limit = Math.pow(2, 8 * byteLength - 1);

                checkInt(this, value, offset, byteLength, limit - 1, -limit);
              }

              var i = byteLength - 1;
              var mul = 1;
              var sub = 0;
              this[offset + i] = value & 0xFF;
              while (--i >= 0 && (mul *= 0x100)) {
                if (value < 0 && sub === 0 && this[offset + i + 1] !== 0) {
                  sub = 1;
                }
                this[offset + i] = ((value / mul) >> 0) - sub & 0xFF;
              }

              return offset + byteLength
            };

            Buffer$1.prototype.writeInt8 = function writeInt8 (value, offset, noAssert) {
              value = +value;
              offset = offset | 0;
              if (!noAssert) checkInt(this, value, offset, 1, 0x7f, -0x80);
              if (!Buffer$1.TYPED_ARRAY_SUPPORT) value = Math.floor(value);
              if (value < 0) value = 0xff + value + 1;
              this[offset] = (value & 0xff);
              return offset + 1
            };

            Buffer$1.prototype.writeInt16LE = function writeInt16LE (value, offset, noAssert) {
              value = +value;
              offset = offset | 0;
              if (!noAssert) checkInt(this, value, offset, 2, 0x7fff, -0x8000);
              if (Buffer$1.TYPED_ARRAY_SUPPORT) {
                this[offset] = (value & 0xff);
                this[offset + 1] = (value >>> 8);
              } else {
                objectWriteUInt16(this, value, offset, true);
              }
              return offset + 2
            };

            Buffer$1.prototype.writeInt16BE = function writeInt16BE (value, offset, noAssert) {
              value = +value;
              offset = offset | 0;
              if (!noAssert) checkInt(this, value, offset, 2, 0x7fff, -0x8000);
              if (Buffer$1.TYPED_ARRAY_SUPPORT) {
                this[offset] = (value >>> 8);
                this[offset + 1] = (value & 0xff);
              } else {
                objectWriteUInt16(this, value, offset, false);
              }
              return offset + 2
            };

            Buffer$1.prototype.writeInt32LE = function writeInt32LE (value, offset, noAssert) {
              value = +value;
              offset = offset | 0;
              if (!noAssert) checkInt(this, value, offset, 4, 0x7fffffff, -0x80000000);
              if (Buffer$1.TYPED_ARRAY_SUPPORT) {
                this[offset] = (value & 0xff);
                this[offset + 1] = (value >>> 8);
                this[offset + 2] = (value >>> 16);
                this[offset + 3] = (value >>> 24);
              } else {
                objectWriteUInt32(this, value, offset, true);
              }
              return offset + 4
            };

            Buffer$1.prototype.writeInt32BE = function writeInt32BE (value, offset, noAssert) {
              value = +value;
              offset = offset | 0;
              if (!noAssert) checkInt(this, value, offset, 4, 0x7fffffff, -0x80000000);
              if (value < 0) value = 0xffffffff + value + 1;
              if (Buffer$1.TYPED_ARRAY_SUPPORT) {
                this[offset] = (value >>> 24);
                this[offset + 1] = (value >>> 16);
                this[offset + 2] = (value >>> 8);
                this[offset + 3] = (value & 0xff);
              } else {
                objectWriteUInt32(this, value, offset, false);
              }
              return offset + 4
            };

            function checkIEEE754 (buf, value, offset, ext, max, min) {
              if (offset + ext > buf.length) throw new RangeError('Index out of range')
              if (offset < 0) throw new RangeError('Index out of range')
            }

            function writeFloat (buf, value, offset, littleEndian, noAssert) {
              if (!noAssert) {
                checkIEEE754(buf, value, offset, 4);
              }
              write(buf, value, offset, littleEndian, 23, 4);
              return offset + 4
            }

            Buffer$1.prototype.writeFloatLE = function writeFloatLE (value, offset, noAssert) {
              return writeFloat(this, value, offset, true, noAssert)
            };

            Buffer$1.prototype.writeFloatBE = function writeFloatBE (value, offset, noAssert) {
              return writeFloat(this, value, offset, false, noAssert)
            };

            function writeDouble (buf, value, offset, littleEndian, noAssert) {
              if (!noAssert) {
                checkIEEE754(buf, value, offset, 8);
              }
              write(buf, value, offset, littleEndian, 52, 8);
              return offset + 8
            }

            Buffer$1.prototype.writeDoubleLE = function writeDoubleLE (value, offset, noAssert) {
              return writeDouble(this, value, offset, true, noAssert)
            };

            Buffer$1.prototype.writeDoubleBE = function writeDoubleBE (value, offset, noAssert) {
              return writeDouble(this, value, offset, false, noAssert)
            };

            // copy(targetBuffer, targetStart=0, sourceStart=0, sourceEnd=buffer.length)
            Buffer$1.prototype.copy = function copy (target, targetStart, start, end) {
              if (!start) start = 0;
              if (!end && end !== 0) end = this.length;
              if (targetStart >= target.length) targetStart = target.length;
              if (!targetStart) targetStart = 0;
              if (end > 0 && end < start) end = start;

              // Copy 0 bytes; we're done
              if (end === start) return 0
              if (target.length === 0 || this.length === 0) return 0

              // Fatal error conditions
              if (targetStart < 0) {
                throw new RangeError('targetStart out of bounds')
              }
              if (start < 0 || start >= this.length) throw new RangeError('sourceStart out of bounds')
              if (end < 0) throw new RangeError('sourceEnd out of bounds')

              // Are we oob?
              if (end > this.length) end = this.length;
              if (target.length - targetStart < end - start) {
                end = target.length - targetStart + start;
              }

              var len = end - start;
              var i;

              if (this === target && start < targetStart && targetStart < end) {
                // descending copy from end
                for (i = len - 1; i >= 0; --i) {
                  target[i + targetStart] = this[i + start];
                }
              } else if (len < 1000 || !Buffer$1.TYPED_ARRAY_SUPPORT) {
                // ascending copy from start
                for (i = 0; i < len; ++i) {
                  target[i + targetStart] = this[i + start];
                }
              } else {
                Uint8Array.prototype.set.call(
                  target,
                  this.subarray(start, start + len),
                  targetStart
                );
              }

              return len
            };

            // Usage:
            //    buffer.fill(number[, offset[, end]])
            //    buffer.fill(buffer[, offset[, end]])
            //    buffer.fill(string[, offset[, end]][, encoding])
            Buffer$1.prototype.fill = function fill (val, start, end, encoding) {
              // Handle string cases:
              if (typeof val === 'string') {
                if (typeof start === 'string') {
                  encoding = start;
                  start = 0;
                  end = this.length;
                } else if (typeof end === 'string') {
                  encoding = end;
                  end = this.length;
                }
                if (val.length === 1) {
                  var code = val.charCodeAt(0);
                  if (code < 256) {
                    val = code;
                  }
                }
                if (encoding !== undefined && typeof encoding !== 'string') {
                  throw new TypeError('encoding must be a string')
                }
                if (typeof encoding === 'string' && !Buffer$1.isEncoding(encoding)) {
                  throw new TypeError('Unknown encoding: ' + encoding)
                }
              } else if (typeof val === 'number') {
                val = val & 255;
              }

              // Invalid ranges are not set to a default, so can range check early.
              if (start < 0 || this.length < start || this.length < end) {
                throw new RangeError('Out of range index')
              }

              if (end <= start) {
                return this
              }

              start = start >>> 0;
              end = end === undefined ? this.length : end >>> 0;

              if (!val) val = 0;

              var i;
              if (typeof val === 'number') {
                for (i = start; i < end; ++i) {
                  this[i] = val;
                }
              } else {
                var bytes = internalIsBuffer(val)
                  ? val
                  : utf8ToBytes(new Buffer$1(val, encoding).toString());
                var len = bytes.length;
                for (i = 0; i < end - start; ++i) {
                  this[i + start] = bytes[i % len];
                }
              }

              return this
            };

            // HELPER FUNCTIONS
            // ================

            var INVALID_BASE64_RE = /[^+\/0-9A-Za-z-_]/g;

            function base64clean (str) {
              // Node strips out invalid characters like \n and \t from the string, base64-js does not
              str = stringtrim(str).replace(INVALID_BASE64_RE, '');
              // Node converts strings with length < 2 to ''
              if (str.length < 2) return ''
              // Node allows for non-padded base64 strings (missing trailing ===), base64-js does not
              while (str.length % 4 !== 0) {
                str = str + '=';
              }
              return str
            }

            function stringtrim (str) {
              if (str.trim) return str.trim()
              return str.replace(/^\s+|\s+$/g, '')
            }

            function toHex (n) {
              if (n < 16) return '0' + n.toString(16)
              return n.toString(16)
            }

            function utf8ToBytes (string, units) {
              units = units || Infinity;
              var codePoint;
              var length = string.length;
              var leadSurrogate = null;
              var bytes = [];

              for (var i = 0; i < length; ++i) {
                codePoint = string.charCodeAt(i);

                // is surrogate component
                if (codePoint > 0xD7FF && codePoint < 0xE000) {
                  // last char was a lead
                  if (!leadSurrogate) {
                    // no lead yet
                    if (codePoint > 0xDBFF) {
                      // unexpected trail
                      if ((units -= 3) > -1) bytes.push(0xEF, 0xBF, 0xBD);
                      continue
                    } else if (i + 1 === length) {
                      // unpaired lead
                      if ((units -= 3) > -1) bytes.push(0xEF, 0xBF, 0xBD);
                      continue
                    }

                    // valid lead
                    leadSurrogate = codePoint;

                    continue
                  }

                  // 2 leads in a row
                  if (codePoint < 0xDC00) {
                    if ((units -= 3) > -1) bytes.push(0xEF, 0xBF, 0xBD);
                    leadSurrogate = codePoint;
                    continue
                  }

                  // valid surrogate pair
                  codePoint = (leadSurrogate - 0xD800 << 10 | codePoint - 0xDC00) + 0x10000;
                } else if (leadSurrogate) {
                  // valid bmp char, but last char was a lead
                  if ((units -= 3) > -1) bytes.push(0xEF, 0xBF, 0xBD);
                }

                leadSurrogate = null;

                // encode utf8
                if (codePoint < 0x80) {
                  if ((units -= 1) < 0) break
                  bytes.push(codePoint);
                } else if (codePoint < 0x800) {
                  if ((units -= 2) < 0) break
                  bytes.push(
                    codePoint >> 0x6 | 0xC0,
                    codePoint & 0x3F | 0x80
                  );
                } else if (codePoint < 0x10000) {
                  if ((units -= 3) < 0) break
                  bytes.push(
                    codePoint >> 0xC | 0xE0,
                    codePoint >> 0x6 & 0x3F | 0x80,
                    codePoint & 0x3F | 0x80
                  );
                } else if (codePoint < 0x110000) {
                  if ((units -= 4) < 0) break
                  bytes.push(
                    codePoint >> 0x12 | 0xF0,
                    codePoint >> 0xC & 0x3F | 0x80,
                    codePoint >> 0x6 & 0x3F | 0x80,
                    codePoint & 0x3F | 0x80
                  );
                } else {
                  throw new Error('Invalid code point')
                }
              }

              return bytes
            }

            function asciiToBytes (str) {
              var byteArray = [];
              for (var i = 0; i < str.length; ++i) {
                // Node's code seems to be doing this and not & 0x7F..
                byteArray.push(str.charCodeAt(i) & 0xFF);
              }
              return byteArray
            }

            function utf16leToBytes (str, units) {
              var c, hi, lo;
              var byteArray = [];
              for (var i = 0; i < str.length; ++i) {
                if ((units -= 2) < 0) break

                c = str.charCodeAt(i);
                hi = c >> 8;
                lo = c % 256;
                byteArray.push(lo);
                byteArray.push(hi);
              }

              return byteArray
            }


            function base64ToBytes (str) {
              return toByteArray(base64clean(str))
            }

            function blitBuffer (src, dst, offset, length) {
              for (var i = 0; i < length; ++i) {
                if ((i + offset >= dst.length) || (i >= src.length)) break
                dst[i + offset] = src[i];
              }
              return i
            }

            function isnan (val) {
              return val !== val // eslint-disable-line no-self-compare
            }


            // the following is from is-buffer, also by Feross Aboukhadijeh and with same lisence
            // The _isBuffer check is for Safari 5-7 support, because it's missing
            // Object.prototype.constructor. Remove this eventually
            function isBuffer$1(obj) {
              return obj != null && (!!obj._isBuffer || isFastBuffer(obj) || isSlowBuffer(obj))
            }

            function isFastBuffer (obj) {
              return !!obj.constructor && typeof obj.constructor.isBuffer === 'function' && obj.constructor.isBuffer(obj)
            }

            // For Node v0.10 support. Remove this eventually.
            function isSlowBuffer (obj) {
              return typeof obj.readFloatLE === 'function' && typeof obj.slice === 'function' && isFastBuffer(obj.slice(0, 0))
            }

            var _typeof_1 = createCommonjsModule(function (module) {
            function _typeof2(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof2 = function _typeof2(obj) { return typeof obj; }; } else { _typeof2 = function _typeof2(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof2(obj); }

            function _typeof(obj) {
              if (typeof Symbol === "function" && _typeof2(Symbol.iterator) === "symbol") {
                module.exports = _typeof = function _typeof(obj) {
                  return _typeof2(obj);
                };
              } else {
                module.exports = _typeof = function _typeof(obj) {
                  return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : _typeof2(obj);
                };
              }

              return _typeof(obj);
            }

            module.exports = _typeof;
            });

            var has$2 = Object.prototype.hasOwnProperty;
            var isArray$4 = Array.isArray;

            var hexTable = (function () {
                var array = [];
                for (var i = 0; i < 256; ++i) {
                    array.push('%' + ((i < 16 ? '0' : '') + i.toString(16)).toUpperCase());
                }

                return array;
            }());

            var compactQueue = function compactQueue(queue) {
                while (queue.length > 1) {
                    var item = queue.pop();
                    var obj = item.obj[item.prop];

                    if (isArray$4(obj)) {
                        var compacted = [];

                        for (var j = 0; j < obj.length; ++j) {
                            if (typeof obj[j] !== 'undefined') {
                                compacted.push(obj[j]);
                            }
                        }

                        item.obj[item.prop] = compacted;
                    }
                }
            };

            var arrayToObject = function arrayToObject(source, options) {
                var obj = options && options.plainObjects ? Object.create(null) : {};
                for (var i = 0; i < source.length; ++i) {
                    if (typeof source[i] !== 'undefined') {
                        obj[i] = source[i];
                    }
                }

                return obj;
            };

            var merge$3 = function merge(target, source, options) {
                if (!source) {
                    return target;
                }

                if (typeof source !== 'object') {
                    if (isArray$4(target)) {
                        target.push(source);
                    } else if (target && typeof target === 'object') {
                        if ((options && (options.plainObjects || options.allowPrototypes)) || !has$2.call(Object.prototype, source)) {
                            target[source] = true;
                        }
                    } else {
                        return [target, source];
                    }

                    return target;
                }

                if (!target || typeof target !== 'object') {
                    return [target].concat(source);
                }

                var mergeTarget = target;
                if (isArray$4(target) && !isArray$4(source)) {
                    mergeTarget = arrayToObject(target, options);
                }

                if (isArray$4(target) && isArray$4(source)) {
                    source.forEach(function (item, i) {
                        if (has$2.call(target, i)) {
                            var targetItem = target[i];
                            if (targetItem && typeof targetItem === 'object' && item && typeof item === 'object') {
                                target[i] = merge(targetItem, item, options);
                            } else {
                                target.push(item);
                            }
                        } else {
                            target[i] = item;
                        }
                    });
                    return target;
                }

                return Object.keys(source).reduce(function (acc, key) {
                    var value = source[key];

                    if (has$2.call(acc, key)) {
                        acc[key] = merge(acc[key], value, options);
                    } else {
                        acc[key] = value;
                    }
                    return acc;
                }, mergeTarget);
            };

            var assign = function assignSingleSource(target, source) {
                return Object.keys(source).reduce(function (acc, key) {
                    acc[key] = source[key];
                    return acc;
                }, target);
            };

            var decode = function (str, decoder, charset) {
                var strWithoutPlus = str.replace(/\+/g, ' ');
                if (charset === 'iso-8859-1') {
                    // unescape never throws, no try...catch needed:
                    return strWithoutPlus.replace(/%[0-9a-f]{2}/gi, unescape);
                }
                // utf-8
                try {
                    return decodeURIComponent(strWithoutPlus);
                } catch (e) {
                    return strWithoutPlus;
                }
            };

            var encode$1 = function encode(str, defaultEncoder, charset) {
                // This code was originally written by Brian White (mscdex) for the io.js core querystring library.
                // It has been adapted here for stricter adherence to RFC 3986
                if (str.length === 0) {
                    return str;
                }

                var string = typeof str === 'string' ? str : String(str);

                if (charset === 'iso-8859-1') {
                    return escape(string).replace(/%u[0-9a-f]{4}/gi, function ($0) {
                        return '%26%23' + parseInt($0.slice(2), 16) + '%3B';
                    });
                }

                var out = '';
                for (var i = 0; i < string.length; ++i) {
                    var c = string.charCodeAt(i);

                    if (
                        c === 0x2D // -
                        || c === 0x2E // .
                        || c === 0x5F // _
                        || c === 0x7E // ~
                        || (c >= 0x30 && c <= 0x39) // 0-9
                        || (c >= 0x41 && c <= 0x5A) // a-z
                        || (c >= 0x61 && c <= 0x7A) // A-Z
                    ) {
                        out += string.charAt(i);
                        continue;
                    }

                    if (c < 0x80) {
                        out = out + hexTable[c];
                        continue;
                    }

                    if (c < 0x800) {
                        out = out + (hexTable[0xC0 | (c >> 6)] + hexTable[0x80 | (c & 0x3F)]);
                        continue;
                    }

                    if (c < 0xD800 || c >= 0xE000) {
                        out = out + (hexTable[0xE0 | (c >> 12)] + hexTable[0x80 | ((c >> 6) & 0x3F)] + hexTable[0x80 | (c & 0x3F)]);
                        continue;
                    }

                    i += 1;
                    c = 0x10000 + (((c & 0x3FF) << 10) | (string.charCodeAt(i) & 0x3FF));
                    out += hexTable[0xF0 | (c >> 18)]
                        + hexTable[0x80 | ((c >> 12) & 0x3F)]
                        + hexTable[0x80 | ((c >> 6) & 0x3F)]
                        + hexTable[0x80 | (c & 0x3F)];
                }

                return out;
            };

            var compact = function compact(value) {
                var queue = [{ obj: { o: value }, prop: 'o' }];
                var refs = [];

                for (var i = 0; i < queue.length; ++i) {
                    var item = queue[i];
                    var obj = item.obj[item.prop];

                    var keys = Object.keys(obj);
                    for (var j = 0; j < keys.length; ++j) {
                        var key = keys[j];
                        var val = obj[key];
                        if (typeof val === 'object' && val !== null && refs.indexOf(val) === -1) {
                            queue.push({ obj: obj, prop: key });
                            refs.push(val);
                        }
                    }
                }

                compactQueue(queue);

                return value;
            };

            var isRegExp$1 = function isRegExp(obj) {
                return Object.prototype.toString.call(obj) === '[object RegExp]';
            };

            var isBuffer = function isBuffer(obj) {
                if (!obj || typeof obj !== 'object') {
                    return false;
                }

                return !!(obj.constructor && obj.constructor.isBuffer && obj.constructor.isBuffer(obj));
            };

            var combine = function combine(a, b) {
                return [].concat(a, b);
            };

            var utils$1 = {
                arrayToObject: arrayToObject,
                assign: assign,
                combine: combine,
                compact: compact,
                decode: decode,
                encode: encode$1,
                isBuffer: isBuffer,
                isRegExp: isRegExp$1,
                merge: merge$3
            };

            var replace = String.prototype.replace;
            var percentTwenties = /%20/g;

            var formats = {
                'default': 'RFC3986',
                formatters: {
                    RFC1738: function (value) {
                        return replace.call(value, percentTwenties, '+');
                    },
                    RFC3986: function (value) {
                        return value;
                    }
                },
                RFC1738: 'RFC1738',
                RFC3986: 'RFC3986'
            };

            var has$1 = Object.prototype.hasOwnProperty;

            var arrayPrefixGenerators = {
                brackets: function brackets(prefix) { // eslint-disable-line func-name-matching
                    return prefix + '[]';
                },
                comma: 'comma',
                indices: function indices(prefix, key) { // eslint-disable-line func-name-matching
                    return prefix + '[' + key + ']';
                },
                repeat: function repeat(prefix) { // eslint-disable-line func-name-matching
                    return prefix;
                }
            };

            var isArray$3 = Array.isArray;
            var push = Array.prototype.push;
            var pushToArray = function (arr, valueOrArray) {
                push.apply(arr, isArray$3(valueOrArray) ? valueOrArray : [valueOrArray]);
            };

            var toISO = Date.prototype.toISOString;

            var defaults$1 = {
                addQueryPrefix: false,
                allowDots: false,
                charset: 'utf-8',
                charsetSentinel: false,
                delimiter: '&',
                encode: true,
                encoder: utils$1.encode,
                encodeValuesOnly: false,
                formatter: formats.formatters[formats['default']],
                // deprecated
                indices: false,
                serializeDate: function serializeDate(date) { // eslint-disable-line func-name-matching
                    return toISO.call(date);
                },
                skipNulls: false,
                strictNullHandling: false
            };

            var stringify$1 = function stringify( // eslint-disable-line func-name-matching
                object,
                prefix,
                generateArrayPrefix,
                strictNullHandling,
                skipNulls,
                encoder,
                filter,
                sort,
                allowDots,
                serializeDate,
                formatter,
                encodeValuesOnly,
                charset
            ) {
                var obj = object;
                if (typeof filter === 'function') {
                    obj = filter(prefix, obj);
                } else if (obj instanceof Date) {
                    obj = serializeDate(obj);
                } else if (generateArrayPrefix === 'comma' && isArray$3(obj)) {
                    obj = obj.join(',');
                }

                if (obj === null) {
                    if (strictNullHandling) {
                        return encoder && !encodeValuesOnly ? encoder(prefix, defaults$1.encoder, charset) : prefix;
                    }

                    obj = '';
                }

                if (typeof obj === 'string' || typeof obj === 'number' || typeof obj === 'boolean' || utils$1.isBuffer(obj)) {
                    if (encoder) {
                        var keyValue = encodeValuesOnly ? prefix : encoder(prefix, defaults$1.encoder, charset);
                        return [formatter(keyValue) + '=' + formatter(encoder(obj, defaults$1.encoder, charset))];
                    }
                    return [formatter(prefix) + '=' + formatter(String(obj))];
                }

                var values = [];

                if (typeof obj === 'undefined') {
                    return values;
                }

                var objKeys;
                if (isArray$3(filter)) {
                    objKeys = filter;
                } else {
                    var keys = Object.keys(obj);
                    objKeys = sort ? keys.sort(sort) : keys;
                }

                for (var i = 0; i < objKeys.length; ++i) {
                    var key = objKeys[i];

                    if (skipNulls && obj[key] === null) {
                        continue;
                    }

                    if (isArray$3(obj)) {
                        pushToArray(values, stringify(
                            obj[key],
                            typeof generateArrayPrefix === 'function' ? generateArrayPrefix(prefix, key) : prefix,
                            generateArrayPrefix,
                            strictNullHandling,
                            skipNulls,
                            encoder,
                            filter,
                            sort,
                            allowDots,
                            serializeDate,
                            formatter,
                            encodeValuesOnly,
                            charset
                        ));
                    } else {
                        pushToArray(values, stringify(
                            obj[key],
                            prefix + (allowDots ? '.' + key : '[' + key + ']'),
                            generateArrayPrefix,
                            strictNullHandling,
                            skipNulls,
                            encoder,
                            filter,
                            sort,
                            allowDots,
                            serializeDate,
                            formatter,
                            encodeValuesOnly,
                            charset
                        ));
                    }
                }

                return values;
            };

            var normalizeStringifyOptions = function normalizeStringifyOptions(opts) {
                if (!opts) {
                    return defaults$1;
                }

                if (opts.encoder !== null && opts.encoder !== undefined && typeof opts.encoder !== 'function') {
                    throw new TypeError('Encoder has to be a function.');
                }

                var charset = opts.charset || defaults$1.charset;
                if (typeof opts.charset !== 'undefined' && opts.charset !== 'utf-8' && opts.charset !== 'iso-8859-1') {
                    throw new TypeError('The charset option must be either utf-8, iso-8859-1, or undefined');
                }

                var format = formats['default'];
                if (typeof opts.format !== 'undefined') {
                    if (!has$1.call(formats.formatters, opts.format)) {
                        throw new TypeError('Unknown format option provided.');
                    }
                    format = opts.format;
                }
                var formatter = formats.formatters[format];

                var filter = defaults$1.filter;
                if (typeof opts.filter === 'function' || isArray$3(opts.filter)) {
                    filter = opts.filter;
                }

                return {
                    addQueryPrefix: typeof opts.addQueryPrefix === 'boolean' ? opts.addQueryPrefix : defaults$1.addQueryPrefix,
                    allowDots: typeof opts.allowDots === 'undefined' ? defaults$1.allowDots : !!opts.allowDots,
                    charset: charset,
                    charsetSentinel: typeof opts.charsetSentinel === 'boolean' ? opts.charsetSentinel : defaults$1.charsetSentinel,
                    delimiter: typeof opts.delimiter === 'undefined' ? defaults$1.delimiter : opts.delimiter,
                    encode: typeof opts.encode === 'boolean' ? opts.encode : defaults$1.encode,
                    encoder: typeof opts.encoder === 'function' ? opts.encoder : defaults$1.encoder,
                    encodeValuesOnly: typeof opts.encodeValuesOnly === 'boolean' ? opts.encodeValuesOnly : defaults$1.encodeValuesOnly,
                    filter: filter,
                    formatter: formatter,
                    serializeDate: typeof opts.serializeDate === 'function' ? opts.serializeDate : defaults$1.serializeDate,
                    skipNulls: typeof opts.skipNulls === 'boolean' ? opts.skipNulls : defaults$1.skipNulls,
                    sort: typeof opts.sort === 'function' ? opts.sort : null,
                    strictNullHandling: typeof opts.strictNullHandling === 'boolean' ? opts.strictNullHandling : defaults$1.strictNullHandling
                };
            };

            var stringify_1 = function (object, opts) {
                var obj = object;
                var options = normalizeStringifyOptions(opts);

                var objKeys;
                var filter;

                if (typeof options.filter === 'function') {
                    filter = options.filter;
                    obj = filter('', obj);
                } else if (isArray$3(options.filter)) {
                    filter = options.filter;
                    objKeys = filter;
                }

                var keys = [];

                if (typeof obj !== 'object' || obj === null) {
                    return '';
                }

                var arrayFormat;
                if (opts && opts.arrayFormat in arrayPrefixGenerators) {
                    arrayFormat = opts.arrayFormat;
                } else if (opts && 'indices' in opts) {
                    arrayFormat = opts.indices ? 'indices' : 'repeat';
                } else {
                    arrayFormat = 'indices';
                }

                var generateArrayPrefix = arrayPrefixGenerators[arrayFormat];

                if (!objKeys) {
                    objKeys = Object.keys(obj);
                }

                if (options.sort) {
                    objKeys.sort(options.sort);
                }

                for (var i = 0; i < objKeys.length; ++i) {
                    var key = objKeys[i];

                    if (options.skipNulls && obj[key] === null) {
                        continue;
                    }
                    pushToArray(keys, stringify$1(
                        obj[key],
                        key,
                        generateArrayPrefix,
                        options.strictNullHandling,
                        options.skipNulls,
                        options.encode ? options.encoder : null,
                        options.filter,
                        options.sort,
                        options.allowDots,
                        options.serializeDate,
                        options.formatter,
                        options.encodeValuesOnly,
                        options.charset
                    ));
                }

                var joined = keys.join(options.delimiter);
                var prefix = options.addQueryPrefix === true ? '?' : '';

                if (options.charsetSentinel) {
                    if (options.charset === 'iso-8859-1') {
                        // encodeURIComponent('&#10003;'), the "numeric entity" representation of a checkmark
                        prefix += 'utf8=%26%2310003%3B&';
                    } else {
                        // encodeURIComponent('✓')
                        prefix += 'utf8=%E2%9C%93&';
                    }
                }

                return joined.length > 0 ? prefix + joined : '';
            };

            var has = Object.prototype.hasOwnProperty;

            var defaults = {
                allowDots: false,
                allowPrototypes: false,
                arrayLimit: 20,
                charset: 'utf-8',
                charsetSentinel: false,
                comma: false,
                decoder: utils$1.decode,
                delimiter: '&',
                depth: 5,
                ignoreQueryPrefix: false,
                interpretNumericEntities: false,
                parameterLimit: 1000,
                parseArrays: true,
                plainObjects: false,
                strictNullHandling: false
            };

            var interpretNumericEntities = function (str) {
                return str.replace(/&#(\d+);/g, function ($0, numberStr) {
                    return String.fromCharCode(parseInt(numberStr, 10));
                });
            };

            // This is what browsers will submit when the ✓ character occurs in an
            // application/x-www-form-urlencoded body and the encoding of the page containing
            // the form is iso-8859-1, or when the submitted form has an accept-charset
            // attribute of iso-8859-1. Presumably also with other charsets that do not contain
            // the ✓ character, such as us-ascii.
            var isoSentinel = 'utf8=%26%2310003%3B'; // encodeURIComponent('&#10003;')

            // These are the percent-encoded utf-8 octets representing a checkmark, indicating that the request actually is utf-8 encoded.
            var charsetSentinel = 'utf8=%E2%9C%93'; // encodeURIComponent('✓')

            var parseValues = function parseQueryStringValues(str, options) {
                var obj = {};
                var cleanStr = options.ignoreQueryPrefix ? str.replace(/^\?/, '') : str;
                var limit = options.parameterLimit === Infinity ? undefined : options.parameterLimit;
                var parts = cleanStr.split(options.delimiter, limit);
                var skipIndex = -1; // Keep track of where the utf8 sentinel was found
                var i;

                var charset = options.charset;
                if (options.charsetSentinel) {
                    for (i = 0; i < parts.length; ++i) {
                        if (parts[i].indexOf('utf8=') === 0) {
                            if (parts[i] === charsetSentinel) {
                                charset = 'utf-8';
                            } else if (parts[i] === isoSentinel) {
                                charset = 'iso-8859-1';
                            }
                            skipIndex = i;
                            i = parts.length; // The eslint settings do not allow break;
                        }
                    }
                }

                for (i = 0; i < parts.length; ++i) {
                    if (i === skipIndex) {
                        continue;
                    }
                    var part = parts[i];

                    var bracketEqualsPos = part.indexOf(']=');
                    var pos = bracketEqualsPos === -1 ? part.indexOf('=') : bracketEqualsPos + 1;

                    var key, val;
                    if (pos === -1) {
                        key = options.decoder(part, defaults.decoder, charset);
                        val = options.strictNullHandling ? null : '';
                    } else {
                        key = options.decoder(part.slice(0, pos), defaults.decoder, charset);
                        val = options.decoder(part.slice(pos + 1), defaults.decoder, charset);
                    }

                    if (val && options.interpretNumericEntities && charset === 'iso-8859-1') {
                        val = interpretNumericEntities(val);
                    }

                    if (val && options.comma && val.indexOf(',') > -1) {
                        val = val.split(',');
                    }

                    if (has.call(obj, key)) {
                        obj[key] = utils$1.combine(obj[key], val);
                    } else {
                        obj[key] = val;
                    }
                }

                return obj;
            };

            var parseObject = function (chain, val, options) {
                var leaf = val;

                for (var i = chain.length - 1; i >= 0; --i) {
                    var obj;
                    var root = chain[i];

                    if (root === '[]' && options.parseArrays) {
                        obj = [].concat(leaf);
                    } else {
                        obj = options.plainObjects ? Object.create(null) : {};
                        var cleanRoot = root.charAt(0) === '[' && root.charAt(root.length - 1) === ']' ? root.slice(1, -1) : root;
                        var index = parseInt(cleanRoot, 10);
                        if (!options.parseArrays && cleanRoot === '') {
                            obj = { 0: leaf };
                        } else if (
                            !isNaN(index)
                            && root !== cleanRoot
                            && String(index) === cleanRoot
                            && index >= 0
                            && (options.parseArrays && index <= options.arrayLimit)
                        ) {
                            obj = [];
                            obj[index] = leaf;
                        } else {
                            obj[cleanRoot] = leaf;
                        }
                    }

                    leaf = obj;
                }

                return leaf;
            };

            var parseKeys = function parseQueryStringKeys(givenKey, val, options) {
                if (!givenKey) {
                    return;
                }

                // Transform dot notation to bracket notation
                var key = options.allowDots ? givenKey.replace(/\.([^.[]+)/g, '[$1]') : givenKey;

                // The regex chunks

                var brackets = /(\[[^[\]]*])/;
                var child = /(\[[^[\]]*])/g;

                // Get the parent

                var segment = brackets.exec(key);
                var parent = segment ? key.slice(0, segment.index) : key;

                // Stash the parent if it exists

                var keys = [];
                if (parent) {
                    // If we aren't using plain objects, optionally prefix keys that would overwrite object prototype properties
                    if (!options.plainObjects && has.call(Object.prototype, parent)) {
                        if (!options.allowPrototypes) {
                            return;
                        }
                    }

                    keys.push(parent);
                }

                // Loop through children appending to the array until we hit depth

                var i = 0;
                while ((segment = child.exec(key)) !== null && i < options.depth) {
                    i += 1;
                    if (!options.plainObjects && has.call(Object.prototype, segment[1].slice(1, -1))) {
                        if (!options.allowPrototypes) {
                            return;
                        }
                    }
                    keys.push(segment[1]);
                }

                // If there's a remainder, just add whatever is left

                if (segment) {
                    keys.push('[' + key.slice(segment.index) + ']');
                }

                return parseObject(keys, val, options);
            };

            var normalizeParseOptions = function normalizeParseOptions(opts) {
                if (!opts) {
                    return defaults;
                }

                if (opts.decoder !== null && opts.decoder !== undefined && typeof opts.decoder !== 'function') {
                    throw new TypeError('Decoder has to be a function.');
                }

                if (typeof opts.charset !== 'undefined' && opts.charset !== 'utf-8' && opts.charset !== 'iso-8859-1') {
                    throw new Error('The charset option must be either utf-8, iso-8859-1, or undefined');
                }
                var charset = typeof opts.charset === 'undefined' ? defaults.charset : opts.charset;

                return {
                    allowDots: typeof opts.allowDots === 'undefined' ? defaults.allowDots : !!opts.allowDots,
                    allowPrototypes: typeof opts.allowPrototypes === 'boolean' ? opts.allowPrototypes : defaults.allowPrototypes,
                    arrayLimit: typeof opts.arrayLimit === 'number' ? opts.arrayLimit : defaults.arrayLimit,
                    charset: charset,
                    charsetSentinel: typeof opts.charsetSentinel === 'boolean' ? opts.charsetSentinel : defaults.charsetSentinel,
                    comma: typeof opts.comma === 'boolean' ? opts.comma : defaults.comma,
                    decoder: typeof opts.decoder === 'function' ? opts.decoder : defaults.decoder,
                    delimiter: typeof opts.delimiter === 'string' || utils$1.isRegExp(opts.delimiter) ? opts.delimiter : defaults.delimiter,
                    depth: typeof opts.depth === 'number' ? opts.depth : defaults.depth,
                    ignoreQueryPrefix: opts.ignoreQueryPrefix === true,
                    interpretNumericEntities: typeof opts.interpretNumericEntities === 'boolean' ? opts.interpretNumericEntities : defaults.interpretNumericEntities,
                    parameterLimit: typeof opts.parameterLimit === 'number' ? opts.parameterLimit : defaults.parameterLimit,
                    parseArrays: opts.parseArrays !== false,
                    plainObjects: typeof opts.plainObjects === 'boolean' ? opts.plainObjects : defaults.plainObjects,
                    strictNullHandling: typeof opts.strictNullHandling === 'boolean' ? opts.strictNullHandling : defaults.strictNullHandling
                };
            };

            var parse$2 = function (str, opts) {
                var options = normalizeParseOptions(opts);

                if (str === '' || str === null || typeof str === 'undefined') {
                    return options.plainObjects ? Object.create(null) : {};
                }

                var tempObj = typeof str === 'string' ? parseValues(str, options) : str;
                var obj = options.plainObjects ? Object.create(null) : {};

                // Iterate over the keys and setup the new object

                var keys = Object.keys(tempObj);
                for (var i = 0; i < keys.length; ++i) {
                    var key = keys[i];
                    var newObj = parseKeys(key, tempObj[key], options);
                    obj = utils$1.merge(obj, newObj, options);
                }

                return utils$1.compact(obj);
            };

            var lib$1 = {
                formats: formats,
                parse: parse$2,
                stringify: stringify_1
            };

            /** Detect free variable `global` from Node.js. */
            var freeGlobal$2 = typeof commonjsGlobal == 'object' && commonjsGlobal && commonjsGlobal.Object === Object && commonjsGlobal;

            var _freeGlobal = freeGlobal$2;

            /** Detect free variable `self`. */
            var freeSelf$2 = typeof self == 'object' && self && self.Object === Object && self;

            /** Used as a reference to the global object. */
            var root$2 = _freeGlobal || freeSelf$2 || Function('return this')();

            var _root = root$2;

            /** Built-in value references. */
            var Symbol$3 = _root.Symbol;

            var _Symbol = Symbol$3;

            /** Used for built-in method references. */
            var objectProto$h = Object.prototype;

            /** Used to check objects for own properties. */
            var hasOwnProperty$e = objectProto$h.hasOwnProperty;

            /**
             * Used to resolve the
             * [`toStringTag`](http://ecma-international.org/ecma-262/7.0/#sec-object.prototype.tostring)
             * of values.
             */
            var nativeObjectToString$1 = objectProto$h.toString;

            /** Built-in value references. */
            var symToStringTag$1 = _Symbol ? _Symbol.toStringTag : undefined;

            /**
             * A specialized version of `baseGetTag` which ignores `Symbol.toStringTag` values.
             *
             * @private
             * @param {*} value The value to query.
             * @returns {string} Returns the raw `toStringTag`.
             */
            function getRawTag(value) {
              var isOwn = hasOwnProperty$e.call(value, symToStringTag$1),
                  tag = value[symToStringTag$1];

              try {
                value[symToStringTag$1] = undefined;
                var unmasked = true;
              } catch (e) {}

              var result = nativeObjectToString$1.call(value);
              if (unmasked) {
                if (isOwn) {
                  value[symToStringTag$1] = tag;
                } else {
                  delete value[symToStringTag$1];
                }
              }
              return result;
            }

            var _getRawTag = getRawTag;

            /** Used for built-in method references. */
            var objectProto$g = Object.prototype;

            /**
             * Used to resolve the
             * [`toStringTag`](http://ecma-international.org/ecma-262/7.0/#sec-object.prototype.tostring)
             * of values.
             */
            var nativeObjectToString = objectProto$g.toString;

            /**
             * Converts `value` to a string using `Object.prototype.toString`.
             *
             * @private
             * @param {*} value The value to convert.
             * @returns {string} Returns the converted string.
             */
            function objectToString$3(value) {
              return nativeObjectToString.call(value);
            }

            var _objectToString = objectToString$3;

            /** `Object#toString` result references. */
            var nullTag = '[object Null]',
                undefinedTag = '[object Undefined]';

            /** Built-in value references. */
            var symToStringTag = _Symbol ? _Symbol.toStringTag : undefined;

            /**
             * The base implementation of `getTag` without fallbacks for buggy environments.
             *
             * @private
             * @param {*} value The value to query.
             * @returns {string} Returns the `toStringTag`.
             */
            function baseGetTag(value) {
              if (value == null) {
                return value === undefined ? undefinedTag : nullTag;
              }
              return (symToStringTag && symToStringTag in Object(value))
                ? _getRawTag(value)
                : _objectToString(value);
            }

            var _baseGetTag = baseGetTag;

            /**
             * Checks if `value` is the
             * [language type](http://www.ecma-international.org/ecma-262/7.0/#sec-ecmascript-language-types)
             * of `Object`. (e.g. arrays, functions, objects, regexes, `new Number(0)`, and `new String('')`)
             *
             * @static
             * @memberOf _
             * @since 0.1.0
             * @category Lang
             * @param {*} value The value to check.
             * @returns {boolean} Returns `true` if `value` is an object, else `false`.
             * @example
             *
             * _.isObject({});
             * // => true
             *
             * _.isObject([1, 2, 3]);
             * // => true
             *
             * _.isObject(_.noop);
             * // => true
             *
             * _.isObject(null);
             * // => false
             */
            function isObject$3(value) {
              var type = typeof value;
              return value != null && (type == 'object' || type == 'function');
            }

            var isObject_1 = isObject$3;

            /** `Object#toString` result references. */
            var asyncTag = '[object AsyncFunction]',
                funcTag$2 = '[object Function]',
                genTag$1 = '[object GeneratorFunction]',
                proxyTag = '[object Proxy]';

            /**
             * Checks if `value` is classified as a `Function` object.
             *
             * @static
             * @memberOf _
             * @since 0.1.0
             * @category Lang
             * @param {*} value The value to check.
             * @returns {boolean} Returns `true` if `value` is a function, else `false`.
             * @example
             *
             * _.isFunction(_);
             * // => true
             *
             * _.isFunction(/abc/);
             * // => false
             */
            function isFunction$4(value) {
              if (!isObject_1(value)) {
                return false;
              }
              // The use of `Object#toString` avoids issues with the `typeof` operator
              // in Safari 9 which returns 'object' for typed arrays and other constructors.
              var tag = _baseGetTag(value);
              return tag == funcTag$2 || tag == genTag$1 || tag == asyncTag || tag == proxyTag;
            }

            var isFunction_1 = isFunction$4;

            /** Used to detect overreaching core-js shims. */
            var coreJsData = _root['__core-js_shared__'];

            var _coreJsData = coreJsData;

            /** Used to detect methods masquerading as native. */
            var maskSrcKey = (function() {
              var uid = /[^.]+$/.exec(_coreJsData && _coreJsData.keys && _coreJsData.keys.IE_PROTO || '');
              return uid ? ('Symbol(src)_1.' + uid) : '';
            }());

            /**
             * Checks if `func` has its source masked.
             *
             * @private
             * @param {Function} func The function to check.
             * @returns {boolean} Returns `true` if `func` is masked, else `false`.
             */
            function isMasked(func) {
              return !!maskSrcKey && (maskSrcKey in func);
            }

            var _isMasked = isMasked;

            /** Used for built-in method references. */
            var funcProto$1 = Function.prototype;

            /** Used to resolve the decompiled source of functions. */
            var funcToString$1 = funcProto$1.toString;

            /**
             * Converts `func` to its source code.
             *
             * @private
             * @param {Function} func The function to convert.
             * @returns {string} Returns the source code.
             */
            function toSource(func) {
              if (func != null) {
                try {
                  return funcToString$1.call(func);
                } catch (e) {}
                try {
                  return (func + '');
                } catch (e) {}
              }
              return '';
            }

            var _toSource = toSource;

            /**
             * Used to match `RegExp`
             * [syntax characters](http://ecma-international.org/ecma-262/7.0/#sec-patterns).
             */
            var reRegExpChar = /[\\^$.*+?()[\]{}|]/g;

            /** Used to detect host constructors (Safari). */
            var reIsHostCtor = /^\[object .+?Constructor\]$/;

            /** Used for built-in method references. */
            var funcProto = Function.prototype,
                objectProto$f = Object.prototype;

            /** Used to resolve the decompiled source of functions. */
            var funcToString = funcProto.toString;

            /** Used to check objects for own properties. */
            var hasOwnProperty$d = objectProto$f.hasOwnProperty;

            /** Used to detect if a method is native. */
            var reIsNative = RegExp('^' +
              funcToString.call(hasOwnProperty$d).replace(reRegExpChar, '\\$&')
              .replace(/hasOwnProperty|(function).*?(?=\\\()| for .+?(?=\\\])/g, '$1.*?') + '$'
            );

            /**
             * The base implementation of `_.isNative` without bad shim checks.
             *
             * @private
             * @param {*} value The value to check.
             * @returns {boolean} Returns `true` if `value` is a native function,
             *  else `false`.
             */
            function baseIsNative(value) {
              if (!isObject_1(value) || _isMasked(value)) {
                return false;
              }
              var pattern = isFunction_1(value) ? reIsNative : reIsHostCtor;
              return pattern.test(_toSource(value));
            }

            var _baseIsNative = baseIsNative;

            /**
             * Gets the value at `key` of `object`.
             *
             * @private
             * @param {Object} [object] The object to query.
             * @param {string} key The key of the property to get.
             * @returns {*} Returns the property value.
             */
            function getValue(object, key) {
              return object == null ? undefined : object[key];
            }

            var _getValue = getValue;

            /**
             * Gets the native function at `key` of `object`.
             *
             * @private
             * @param {Object} object The object to query.
             * @param {string} key The key of the method to get.
             * @returns {*} Returns the function if it's native, else `undefined`.
             */
            function getNative(object, key) {
              var value = _getValue(object, key);
              return _baseIsNative(value) ? value : undefined;
            }

            var _getNative = getNative;

            var defineProperty = (function() {
              try {
                var func = _getNative(Object, 'defineProperty');
                func({}, '', {});
                return func;
              } catch (e) {}
            }());

            var _defineProperty = defineProperty;

            /**
             * The base implementation of `assignValue` and `assignMergeValue` without
             * value checks.
             *
             * @private
             * @param {Object} object The object to modify.
             * @param {string} key The key of the property to assign.
             * @param {*} value The value to assign.
             */
            function baseAssignValue(object, key, value) {
              if (key == '__proto__' && _defineProperty) {
                _defineProperty(object, key, {
                  'configurable': true,
                  'enumerable': true,
                  'value': value,
                  'writable': true
                });
              } else {
                object[key] = value;
              }
            }

            var _baseAssignValue = baseAssignValue;

            /**
             * Performs a
             * [`SameValueZero`](http://ecma-international.org/ecma-262/7.0/#sec-samevaluezero)
             * comparison between two values to determine if they are equivalent.
             *
             * @static
             * @memberOf _
             * @since 4.0.0
             * @category Lang
             * @param {*} value The value to compare.
             * @param {*} other The other value to compare.
             * @returns {boolean} Returns `true` if the values are equivalent, else `false`.
             * @example
             *
             * var object = { 'a': 1 };
             * var other = { 'a': 1 };
             *
             * _.eq(object, object);
             * // => true
             *
             * _.eq(object, other);
             * // => false
             *
             * _.eq('a', 'a');
             * // => true
             *
             * _.eq('a', Object('a'));
             * // => false
             *
             * _.eq(NaN, NaN);
             * // => true
             */
            function eq(value, other) {
              return value === other || (value !== value && other !== other);
            }

            var eq_1 = eq;

            /** Used for built-in method references. */
            var objectProto$e = Object.prototype;

            /** Used to check objects for own properties. */
            var hasOwnProperty$c = objectProto$e.hasOwnProperty;

            /**
             * Assigns `value` to `key` of `object` if the existing value is not equivalent
             * using [`SameValueZero`](http://ecma-international.org/ecma-262/7.0/#sec-samevaluezero)
             * for equality comparisons.
             *
             * @private
             * @param {Object} object The object to modify.
             * @param {string} key The key of the property to assign.
             * @param {*} value The value to assign.
             */
            function assignValue(object, key, value) {
              var objValue = object[key];
              if (!(hasOwnProperty$c.call(object, key) && eq_1(objValue, value)) ||
                  (value === undefined && !(key in object))) {
                _baseAssignValue(object, key, value);
              }
            }

            var _assignValue = assignValue;

            /**
             * Checks if `value` is classified as an `Array` object.
             *
             * @static
             * @memberOf _
             * @since 0.1.0
             * @category Lang
             * @param {*} value The value to check.
             * @returns {boolean} Returns `true` if `value` is an array, else `false`.
             * @example
             *
             * _.isArray([1, 2, 3]);
             * // => true
             *
             * _.isArray(document.body.children);
             * // => false
             *
             * _.isArray('abc');
             * // => false
             *
             * _.isArray(_.noop);
             * // => false
             */
            var isArray$2 = Array.isArray;

            var isArray_1 = isArray$2;

            /**
             * Checks if `value` is object-like. A value is object-like if it's not `null`
             * and has a `typeof` result of "object".
             *
             * @static
             * @memberOf _
             * @since 4.0.0
             * @category Lang
             * @param {*} value The value to check.
             * @returns {boolean} Returns `true` if `value` is object-like, else `false`.
             * @example
             *
             * _.isObjectLike({});
             * // => true
             *
             * _.isObjectLike([1, 2, 3]);
             * // => true
             *
             * _.isObjectLike(_.noop);
             * // => false
             *
             * _.isObjectLike(null);
             * // => false
             */
            function isObjectLike$2(value) {
              return value != null && typeof value == 'object';
            }

            var isObjectLike_1 = isObjectLike$2;

            /** `Object#toString` result references. */
            var symbolTag$5 = '[object Symbol]';

            /**
             * Checks if `value` is classified as a `Symbol` primitive or object.
             *
             * @static
             * @memberOf _
             * @since 4.0.0
             * @category Lang
             * @param {*} value The value to check.
             * @returns {boolean} Returns `true` if `value` is a symbol, else `false`.
             * @example
             *
             * _.isSymbol(Symbol.iterator);
             * // => true
             *
             * _.isSymbol('abc');
             * // => false
             */
            function isSymbol$2(value) {
              return typeof value == 'symbol' ||
                (isObjectLike_1(value) && _baseGetTag(value) == symbolTag$5);
            }

            var isSymbol_1 = isSymbol$2;

            /** Used to match property names within property paths. */
            var reIsDeepProp = /\.|\[(?:[^[\]]*|(["'])(?:(?!\1)[^\\]|\\.)*?\1)\]/,
                reIsPlainProp = /^\w*$/;

            /**
             * Checks if `value` is a property name and not a property path.
             *
             * @private
             * @param {*} value The value to check.
             * @param {Object} [object] The object to query keys on.
             * @returns {boolean} Returns `true` if `value` is a property name, else `false`.
             */
            function isKey(value, object) {
              if (isArray_1(value)) {
                return false;
              }
              var type = typeof value;
              if (type == 'number' || type == 'symbol' || type == 'boolean' ||
                  value == null || isSymbol_1(value)) {
                return true;
              }
              return reIsPlainProp.test(value) || !reIsDeepProp.test(value) ||
                (object != null && value in Object(object));
            }

            var _isKey = isKey;

            /* Built-in method references that are verified to be native. */
            var nativeCreate = _getNative(Object, 'create');

            var _nativeCreate = nativeCreate;

            /**
             * Removes all key-value entries from the hash.
             *
             * @private
             * @name clear
             * @memberOf Hash
             */
            function hashClear() {
              this.__data__ = _nativeCreate ? _nativeCreate(null) : {};
              this.size = 0;
            }

            var _hashClear = hashClear;

            /**
             * Removes `key` and its value from the hash.
             *
             * @private
             * @name delete
             * @memberOf Hash
             * @param {Object} hash The hash to modify.
             * @param {string} key The key of the value to remove.
             * @returns {boolean} Returns `true` if the entry was removed, else `false`.
             */
            function hashDelete(key) {
              var result = this.has(key) && delete this.__data__[key];
              this.size -= result ? 1 : 0;
              return result;
            }

            var _hashDelete = hashDelete;

            /** Used to stand-in for `undefined` hash values. */
            var HASH_UNDEFINED$2 = '__lodash_hash_undefined__';

            /** Used for built-in method references. */
            var objectProto$d = Object.prototype;

            /** Used to check objects for own properties. */
            var hasOwnProperty$b = objectProto$d.hasOwnProperty;

            /**
             * Gets the hash value for `key`.
             *
             * @private
             * @name get
             * @memberOf Hash
             * @param {string} key The key of the value to get.
             * @returns {*} Returns the entry value.
             */
            function hashGet(key) {
              var data = this.__data__;
              if (_nativeCreate) {
                var result = data[key];
                return result === HASH_UNDEFINED$2 ? undefined : result;
              }
              return hasOwnProperty$b.call(data, key) ? data[key] : undefined;
            }

            var _hashGet = hashGet;

            /** Used for built-in method references. */
            var objectProto$c = Object.prototype;

            /** Used to check objects for own properties. */
            var hasOwnProperty$a = objectProto$c.hasOwnProperty;

            /**
             * Checks if a hash value for `key` exists.
             *
             * @private
             * @name has
             * @memberOf Hash
             * @param {string} key The key of the entry to check.
             * @returns {boolean} Returns `true` if an entry for `key` exists, else `false`.
             */
            function hashHas(key) {
              var data = this.__data__;
              return _nativeCreate ? (data[key] !== undefined) : hasOwnProperty$a.call(data, key);
            }

            var _hashHas = hashHas;

            /** Used to stand-in for `undefined` hash values. */
            var HASH_UNDEFINED$1 = '__lodash_hash_undefined__';

            /**
             * Sets the hash `key` to `value`.
             *
             * @private
             * @name set
             * @memberOf Hash
             * @param {string} key The key of the value to set.
             * @param {*} value The value to set.
             * @returns {Object} Returns the hash instance.
             */
            function hashSet(key, value) {
              var data = this.__data__;
              this.size += this.has(key) ? 0 : 1;
              data[key] = (_nativeCreate && value === undefined) ? HASH_UNDEFINED$1 : value;
              return this;
            }

            var _hashSet = hashSet;

            /**
             * Creates a hash object.
             *
             * @private
             * @constructor
             * @param {Array} [entries] The key-value pairs to cache.
             */
            function Hash(entries) {
              var index = -1,
                  length = entries == null ? 0 : entries.length;

              this.clear();
              while (++index < length) {
                var entry = entries[index];
                this.set(entry[0], entry[1]);
              }
            }

            // Add methods to `Hash`.
            Hash.prototype.clear = _hashClear;
            Hash.prototype['delete'] = _hashDelete;
            Hash.prototype.get = _hashGet;
            Hash.prototype.has = _hashHas;
            Hash.prototype.set = _hashSet;

            var _Hash = Hash;

            /**
             * Removes all key-value entries from the list cache.
             *
             * @private
             * @name clear
             * @memberOf ListCache
             */
            function listCacheClear() {
              this.__data__ = [];
              this.size = 0;
            }

            var _listCacheClear = listCacheClear;

            /**
             * Gets the index at which the `key` is found in `array` of key-value pairs.
             *
             * @private
             * @param {Array} array The array to inspect.
             * @param {*} key The key to search for.
             * @returns {number} Returns the index of the matched value, else `-1`.
             */
            function assocIndexOf(array, key) {
              var length = array.length;
              while (length--) {
                if (eq_1(array[length][0], key)) {
                  return length;
                }
              }
              return -1;
            }

            var _assocIndexOf = assocIndexOf;

            /** Used for built-in method references. */
            var arrayProto = Array.prototype;

            /** Built-in value references. */
            var splice = arrayProto.splice;

            /**
             * Removes `key` and its value from the list cache.
             *
             * @private
             * @name delete
             * @memberOf ListCache
             * @param {string} key The key of the value to remove.
             * @returns {boolean} Returns `true` if the entry was removed, else `false`.
             */
            function listCacheDelete(key) {
              var data = this.__data__,
                  index = _assocIndexOf(data, key);

              if (index < 0) {
                return false;
              }
              var lastIndex = data.length - 1;
              if (index == lastIndex) {
                data.pop();
              } else {
                splice.call(data, index, 1);
              }
              --this.size;
              return true;
            }

            var _listCacheDelete = listCacheDelete;

            /**
             * Gets the list cache value for `key`.
             *
             * @private
             * @name get
             * @memberOf ListCache
             * @param {string} key The key of the value to get.
             * @returns {*} Returns the entry value.
             */
            function listCacheGet(key) {
              var data = this.__data__,
                  index = _assocIndexOf(data, key);

              return index < 0 ? undefined : data[index][1];
            }

            var _listCacheGet = listCacheGet;

            /**
             * Checks if a list cache value for `key` exists.
             *
             * @private
             * @name has
             * @memberOf ListCache
             * @param {string} key The key of the entry to check.
             * @returns {boolean} Returns `true` if an entry for `key` exists, else `false`.
             */
            function listCacheHas(key) {
              return _assocIndexOf(this.__data__, key) > -1;
            }

            var _listCacheHas = listCacheHas;

            /**
             * Sets the list cache `key` to `value`.
             *
             * @private
             * @name set
             * @memberOf ListCache
             * @param {string} key The key of the value to set.
             * @param {*} value The value to set.
             * @returns {Object} Returns the list cache instance.
             */
            function listCacheSet(key, value) {
              var data = this.__data__,
                  index = _assocIndexOf(data, key);

              if (index < 0) {
                ++this.size;
                data.push([key, value]);
              } else {
                data[index][1] = value;
              }
              return this;
            }

            var _listCacheSet = listCacheSet;

            /**
             * Creates an list cache object.
             *
             * @private
             * @constructor
             * @param {Array} [entries] The key-value pairs to cache.
             */
            function ListCache(entries) {
              var index = -1,
                  length = entries == null ? 0 : entries.length;

              this.clear();
              while (++index < length) {
                var entry = entries[index];
                this.set(entry[0], entry[1]);
              }
            }

            // Add methods to `ListCache`.
            ListCache.prototype.clear = _listCacheClear;
            ListCache.prototype['delete'] = _listCacheDelete;
            ListCache.prototype.get = _listCacheGet;
            ListCache.prototype.has = _listCacheHas;
            ListCache.prototype.set = _listCacheSet;

            var _ListCache = ListCache;

            /* Built-in method references that are verified to be native. */
            var Map$1 = _getNative(_root, 'Map');

            var _Map = Map$1;

            /**
             * Removes all key-value entries from the map.
             *
             * @private
             * @name clear
             * @memberOf MapCache
             */
            function mapCacheClear() {
              this.size = 0;
              this.__data__ = {
                'hash': new _Hash,
                'map': new (_Map || _ListCache),
                'string': new _Hash
              };
            }

            var _mapCacheClear = mapCacheClear;

            /**
             * Checks if `value` is suitable for use as unique object key.
             *
             * @private
             * @param {*} value The value to check.
             * @returns {boolean} Returns `true` if `value` is suitable, else `false`.
             */
            function isKeyable(value) {
              var type = typeof value;
              return (type == 'string' || type == 'number' || type == 'symbol' || type == 'boolean')
                ? (value !== '__proto__')
                : (value === null);
            }

            var _isKeyable = isKeyable;

            /**
             * Gets the data for `map`.
             *
             * @private
             * @param {Object} map The map to query.
             * @param {string} key The reference key.
             * @returns {*} Returns the map data.
             */
            function getMapData(map, key) {
              var data = map.__data__;
              return _isKeyable(key)
                ? data[typeof key == 'string' ? 'string' : 'hash']
                : data.map;
            }

            var _getMapData = getMapData;

            /**
             * Removes `key` and its value from the map.
             *
             * @private
             * @name delete
             * @memberOf MapCache
             * @param {string} key The key of the value to remove.
             * @returns {boolean} Returns `true` if the entry was removed, else `false`.
             */
            function mapCacheDelete(key) {
              var result = _getMapData(this, key)['delete'](key);
              this.size -= result ? 1 : 0;
              return result;
            }

            var _mapCacheDelete = mapCacheDelete;

            /**
             * Gets the map value for `key`.
             *
             * @private
             * @name get
             * @memberOf MapCache
             * @param {string} key The key of the value to get.
             * @returns {*} Returns the entry value.
             */
            function mapCacheGet(key) {
              return _getMapData(this, key).get(key);
            }

            var _mapCacheGet = mapCacheGet;

            /**
             * Checks if a map value for `key` exists.
             *
             * @private
             * @name has
             * @memberOf MapCache
             * @param {string} key The key of the entry to check.
             * @returns {boolean} Returns `true` if an entry for `key` exists, else `false`.
             */
            function mapCacheHas(key) {
              return _getMapData(this, key).has(key);
            }

            var _mapCacheHas = mapCacheHas;

            /**
             * Sets the map `key` to `value`.
             *
             * @private
             * @name set
             * @memberOf MapCache
             * @param {string} key The key of the value to set.
             * @param {*} value The value to set.
             * @returns {Object} Returns the map cache instance.
             */
            function mapCacheSet(key, value) {
              var data = _getMapData(this, key),
                  size = data.size;

              data.set(key, value);
              this.size += data.size == size ? 0 : 1;
              return this;
            }

            var _mapCacheSet = mapCacheSet;

            /**
             * Creates a map cache object to store key-value pairs.
             *
             * @private
             * @constructor
             * @param {Array} [entries] The key-value pairs to cache.
             */
            function MapCache(entries) {
              var index = -1,
                  length = entries == null ? 0 : entries.length;

              this.clear();
              while (++index < length) {
                var entry = entries[index];
                this.set(entry[0], entry[1]);
              }
            }

            // Add methods to `MapCache`.
            MapCache.prototype.clear = _mapCacheClear;
            MapCache.prototype['delete'] = _mapCacheDelete;
            MapCache.prototype.get = _mapCacheGet;
            MapCache.prototype.has = _mapCacheHas;
            MapCache.prototype.set = _mapCacheSet;

            var _MapCache = MapCache;

            /** Error message constants. */
            var FUNC_ERROR_TEXT = 'Expected a function';

            /**
             * Creates a function that memoizes the result of `func`. If `resolver` is
             * provided, it determines the cache key for storing the result based on the
             * arguments provided to the memoized function. By default, the first argument
             * provided to the memoized function is used as the map cache key. The `func`
             * is invoked with the `this` binding of the memoized function.
             *
             * **Note:** The cache is exposed as the `cache` property on the memoized
             * function. Its creation may be customized by replacing the `_.memoize.Cache`
             * constructor with one whose instances implement the
             * [`Map`](http://ecma-international.org/ecma-262/7.0/#sec-properties-of-the-map-prototype-object)
             * method interface of `clear`, `delete`, `get`, `has`, and `set`.
             *
             * @static
             * @memberOf _
             * @since 0.1.0
             * @category Function
             * @param {Function} func The function to have its output memoized.
             * @param {Function} [resolver] The function to resolve the cache key.
             * @returns {Function} Returns the new memoized function.
             * @example
             *
             * var object = { 'a': 1, 'b': 2 };
             * var other = { 'c': 3, 'd': 4 };
             *
             * var values = _.memoize(_.values);
             * values(object);
             * // => [1, 2]
             *
             * values(other);
             * // => [3, 4]
             *
             * object.a = 2;
             * values(object);
             * // => [1, 2]
             *
             * // Modify the result cache.
             * values.cache.set(object, ['a', 'b']);
             * values(object);
             * // => ['a', 'b']
             *
             * // Replace `_.memoize.Cache`.
             * _.memoize.Cache = WeakMap;
             */
            function memoize(func, resolver) {
              if (typeof func != 'function' || (resolver != null && typeof resolver != 'function')) {
                throw new TypeError(FUNC_ERROR_TEXT);
              }
              var memoized = function() {
                var args = arguments,
                    key = resolver ? resolver.apply(this, args) : args[0],
                    cache = memoized.cache;

                if (cache.has(key)) {
                  return cache.get(key);
                }
                var result = func.apply(this, args);
                memoized.cache = cache.set(key, result) || cache;
                return result;
              };
              memoized.cache = new (memoize.Cache || _MapCache);
              return memoized;
            }

            // Expose `MapCache`.
            memoize.Cache = _MapCache;

            var memoize_1 = memoize;

            /** Used as the maximum memoize cache size. */
            var MAX_MEMOIZE_SIZE = 500;

            /**
             * A specialized version of `_.memoize` which clears the memoized function's
             * cache when it exceeds `MAX_MEMOIZE_SIZE`.
             *
             * @private
             * @param {Function} func The function to have its output memoized.
             * @returns {Function} Returns the new memoized function.
             */
            function memoizeCapped(func) {
              var result = memoize_1(func, function(key) {
                if (cache.size === MAX_MEMOIZE_SIZE) {
                  cache.clear();
                }
                return key;
              });

              var cache = result.cache;
              return result;
            }

            var _memoizeCapped = memoizeCapped;

            /** Used to match property names within property paths. */
            var rePropName = /[^.[\]]+|\[(?:(-?\d+(?:\.\d+)?)|(["'])((?:(?!\2)[^\\]|\\.)*?)\2)\]|(?=(?:\.|\[\])(?:\.|\[\]|$))/g;

            /** Used to match backslashes in property paths. */
            var reEscapeChar = /\\(\\)?/g;

            /**
             * Converts `string` to a property path array.
             *
             * @private
             * @param {string} string The string to convert.
             * @returns {Array} Returns the property path array.
             */
            var stringToPath = _memoizeCapped(function(string) {
              var result = [];
              if (string.charCodeAt(0) === 46 /* . */) {
                result.push('');
              }
              string.replace(rePropName, function(match, number, quote, subString) {
                result.push(quote ? subString.replace(reEscapeChar, '$1') : (number || match));
              });
              return result;
            });

            var _stringToPath = stringToPath;

            /**
             * A specialized version of `_.map` for arrays without support for iteratee
             * shorthands.
             *
             * @private
             * @param {Array} [array] The array to iterate over.
             * @param {Function} iteratee The function invoked per iteration.
             * @returns {Array} Returns the new mapped array.
             */
            function arrayMap(array, iteratee) {
              var index = -1,
                  length = array == null ? 0 : array.length,
                  result = Array(length);

              while (++index < length) {
                result[index] = iteratee(array[index], index, array);
              }
              return result;
            }

            var _arrayMap = arrayMap;

            /** Used as references for various `Number` constants. */
            var INFINITY$5 = 1 / 0;

            /** Used to convert symbols to primitives and strings. */
            var symbolProto$4 = _Symbol ? _Symbol.prototype : undefined,
                symbolToString$2 = symbolProto$4 ? symbolProto$4.toString : undefined;

            /**
             * The base implementation of `_.toString` which doesn't convert nullish
             * values to empty strings.
             *
             * @private
             * @param {*} value The value to process.
             * @returns {string} Returns the string.
             */
            function baseToString$2(value) {
              // Exit early for strings to avoid a performance hit in some environments.
              if (typeof value == 'string') {
                return value;
              }
              if (isArray_1(value)) {
                // Recursively convert values (susceptible to call stack limits).
                return _arrayMap(value, baseToString$2) + '';
              }
              if (isSymbol_1(value)) {
                return symbolToString$2 ? symbolToString$2.call(value) : '';
              }
              var result = (value + '');
              return (result == '0' && (1 / value) == -INFINITY$5) ? '-0' : result;
            }

            var _baseToString = baseToString$2;

            /**
             * Converts `value` to a string. An empty string is returned for `null`
             * and `undefined` values. The sign of `-0` is preserved.
             *
             * @static
             * @memberOf _
             * @since 4.0.0
             * @category Lang
             * @param {*} value The value to convert.
             * @returns {string} Returns the converted string.
             * @example
             *
             * _.toString(null);
             * // => ''
             *
             * _.toString(-0);
             * // => '-0'
             *
             * _.toString([1, 2, 3]);
             * // => '1,2,3'
             */
            function toString$2(value) {
              return value == null ? '' : _baseToString(value);
            }

            var toString_1 = toString$2;

            /**
             * Casts `value` to a path array if it's not one.
             *
             * @private
             * @param {*} value The value to inspect.
             * @param {Object} [object] The object to query keys on.
             * @returns {Array} Returns the cast property path array.
             */
            function castPath(value, object) {
              if (isArray_1(value)) {
                return value;
              }
              return _isKey(value, object) ? [value] : _stringToPath(toString_1(value));
            }

            var _castPath = castPath;

            /** Used as references for various `Number` constants. */
            var MAX_SAFE_INTEGER$1 = 9007199254740991;

            /** Used to detect unsigned integer values. */
            var reIsUint = /^(?:0|[1-9]\d*)$/;

            /**
             * Checks if `value` is a valid array-like index.
             *
             * @private
             * @param {*} value The value to check.
             * @param {number} [length=MAX_SAFE_INTEGER] The upper bounds of a valid index.
             * @returns {boolean} Returns `true` if `value` is a valid index, else `false`.
             */
            function isIndex(value, length) {
              var type = typeof value;
              length = length == null ? MAX_SAFE_INTEGER$1 : length;

              return !!length &&
                (type == 'number' ||
                  (type != 'symbol' && reIsUint.test(value))) &&
                    (value > -1 && value % 1 == 0 && value < length);
            }

            var _isIndex = isIndex;

            /** Used as references for various `Number` constants. */
            var INFINITY$4 = 1 / 0;

            /**
             * Converts `value` to a string key if it's not a string or symbol.
             *
             * @private
             * @param {*} value The value to inspect.
             * @returns {string|symbol} Returns the key.
             */
            function toKey(value) {
              if (typeof value == 'string' || isSymbol_1(value)) {
                return value;
              }
              var result = (value + '');
              return (result == '0' && (1 / value) == -INFINITY$4) ? '-0' : result;
            }

            var _toKey = toKey;

            /**
             * The base implementation of `_.set`.
             *
             * @private
             * @param {Object} object The object to modify.
             * @param {Array|string} path The path of the property to set.
             * @param {*} value The value to set.
             * @param {Function} [customizer] The function to customize path creation.
             * @returns {Object} Returns `object`.
             */
            function baseSet(object, path, value, customizer) {
              if (!isObject_1(object)) {
                return object;
              }
              path = _castPath(path, object);

              var index = -1,
                  length = path.length,
                  lastIndex = length - 1,
                  nested = object;

              while (nested != null && ++index < length) {
                var key = _toKey(path[index]),
                    newValue = value;

                if (key === '__proto__' || key === 'constructor' || key === 'prototype') {
                  return object;
                }

                if (index != lastIndex) {
                  var objValue = nested[key];
                  newValue = customizer ? customizer(objValue, key, nested) : undefined;
                  if (newValue === undefined) {
                    newValue = isObject_1(objValue)
                      ? objValue
                      : (_isIndex(path[index + 1]) ? [] : {});
                  }
                }
                _assignValue(nested, key, newValue);
                nested = nested[key];
              }
              return object;
            }

            var _baseSet = baseSet;

            /**
             * Sets the value at `path` of `object`. If a portion of `path` doesn't exist,
             * it's created. Arrays are created for missing index properties while objects
             * are created for all other missing properties. Use `_.setWith` to customize
             * `path` creation.
             *
             * **Note:** This method mutates `object`.
             *
             * @static
             * @memberOf _
             * @since 3.7.0
             * @category Object
             * @param {Object} object The object to modify.
             * @param {Array|string} path The path of the property to set.
             * @param {*} value The value to set.
             * @returns {Object} Returns `object`.
             * @example
             *
             * var object = { 'a': [{ 'b': { 'c': 3 } }] };
             *
             * _.set(object, 'a[0].b.c', 4);
             * console.log(object.a[0].b.c);
             * // => 4
             *
             * _.set(object, ['x', '0', 'y', 'z'], 5);
             * console.log(object.x[0].y.z);
             * // => 5
             */
            function set(object, path, value) {
              return object == null ? object : _baseSet(object, path, value);
            }

            var set_1 = set;

            /**
             * The base implementation of `_.get` without support for default values.
             *
             * @private
             * @param {Object} object The object to query.
             * @param {Array|string} path The path of the property to get.
             * @returns {*} Returns the resolved value.
             */
            function baseGet(object, path) {
              path = _castPath(path, object);

              var index = 0,
                  length = path.length;

              while (object != null && index < length) {
                object = object[_toKey(path[index++])];
              }
              return (index && index == length) ? object : undefined;
            }

            var _baseGet = baseGet;

            /**
             * Gets the value at `path` of `object`. If the resolved value is
             * `undefined`, the `defaultValue` is returned in its place.
             *
             * @static
             * @memberOf _
             * @since 3.7.0
             * @category Object
             * @param {Object} object The object to query.
             * @param {Array|string} path The path of the property to get.
             * @param {*} [defaultValue] The value returned for `undefined` resolved values.
             * @returns {*} Returns the resolved value.
             * @example
             *
             * var object = { 'a': [{ 'b': { 'c': 3 } }] };
             *
             * _.get(object, 'a[0].b.c');
             * // => 3
             *
             * _.get(object, ['a', '0', 'b', 'c']);
             * // => 3
             *
             * _.get(object, 'a.b.c', 'default');
             * // => 'default'
             */
            function get$4(object, path, defaultValue) {
              var result = object == null ? undefined : _baseGet(object, path);
              return result === undefined ? defaultValue : result;
            }

            var get_1 = get$4;

            /** Used to stand-in for `undefined` hash values. */
            var HASH_UNDEFINED = '__lodash_hash_undefined__';

            /**
             * Adds `value` to the array cache.
             *
             * @private
             * @name add
             * @memberOf SetCache
             * @alias push
             * @param {*} value The value to cache.
             * @returns {Object} Returns the cache instance.
             */
            function setCacheAdd(value) {
              this.__data__.set(value, HASH_UNDEFINED);
              return this;
            }

            var _setCacheAdd = setCacheAdd;

            /**
             * Checks if `value` is in the array cache.
             *
             * @private
             * @name has
             * @memberOf SetCache
             * @param {*} value The value to search for.
             * @returns {number} Returns `true` if `value` is found, else `false`.
             */
            function setCacheHas(value) {
              return this.__data__.has(value);
            }

            var _setCacheHas = setCacheHas;

            /**
             *
             * Creates an array cache object to store unique values.
             *
             * @private
             * @constructor
             * @param {Array} [values] The values to cache.
             */
            function SetCache(values) {
              var index = -1,
                  length = values == null ? 0 : values.length;

              this.__data__ = new _MapCache;
              while (++index < length) {
                this.add(values[index]);
              }
            }

            // Add methods to `SetCache`.
            SetCache.prototype.add = SetCache.prototype.push = _setCacheAdd;
            SetCache.prototype.has = _setCacheHas;

            var _SetCache = SetCache;

            /**
             * The base implementation of `_.findIndex` and `_.findLastIndex` without
             * support for iteratee shorthands.
             *
             * @private
             * @param {Array} array The array to inspect.
             * @param {Function} predicate The function invoked per iteration.
             * @param {number} fromIndex The index to search from.
             * @param {boolean} [fromRight] Specify iterating from right to left.
             * @returns {number} Returns the index of the matched value, else `-1`.
             */
            function baseFindIndex(array, predicate, fromIndex, fromRight) {
              var length = array.length,
                  index = fromIndex + (fromRight ? 1 : -1);

              while ((fromRight ? index-- : ++index < length)) {
                if (predicate(array[index], index, array)) {
                  return index;
                }
              }
              return -1;
            }

            var _baseFindIndex = baseFindIndex;

            /**
             * The base implementation of `_.isNaN` without support for number objects.
             *
             * @private
             * @param {*} value The value to check.
             * @returns {boolean} Returns `true` if `value` is `NaN`, else `false`.
             */
            function baseIsNaN(value) {
              return value !== value;
            }

            var _baseIsNaN = baseIsNaN;

            /**
             * A specialized version of `_.indexOf` which performs strict equality
             * comparisons of values, i.e. `===`.
             *
             * @private
             * @param {Array} array The array to inspect.
             * @param {*} value The value to search for.
             * @param {number} fromIndex The index to search from.
             * @returns {number} Returns the index of the matched value, else `-1`.
             */
            function strictIndexOf(array, value, fromIndex) {
              var index = fromIndex - 1,
                  length = array.length;

              while (++index < length) {
                if (array[index] === value) {
                  return index;
                }
              }
              return -1;
            }

            var _strictIndexOf = strictIndexOf;

            /**
             * The base implementation of `_.indexOf` without `fromIndex` bounds checks.
             *
             * @private
             * @param {Array} array The array to inspect.
             * @param {*} value The value to search for.
             * @param {number} fromIndex The index to search from.
             * @returns {number} Returns the index of the matched value, else `-1`.
             */
            function baseIndexOf(array, value, fromIndex) {
              return value === value
                ? _strictIndexOf(array, value, fromIndex)
                : _baseFindIndex(array, _baseIsNaN, fromIndex);
            }

            var _baseIndexOf = baseIndexOf;

            /**
             * A specialized version of `_.includes` for arrays without support for
             * specifying an index to search from.
             *
             * @private
             * @param {Array} [array] The array to inspect.
             * @param {*} target The value to search for.
             * @returns {boolean} Returns `true` if `target` is found, else `false`.
             */
            function arrayIncludes(array, value) {
              var length = array == null ? 0 : array.length;
              return !!length && _baseIndexOf(array, value, 0) > -1;
            }

            var _arrayIncludes = arrayIncludes;

            /**
             * This function is like `arrayIncludes` except that it accepts a comparator.
             *
             * @private
             * @param {Array} [array] The array to inspect.
             * @param {*} target The value to search for.
             * @param {Function} comparator The comparator invoked per element.
             * @returns {boolean} Returns `true` if `target` is found, else `false`.
             */
            function arrayIncludesWith(array, value, comparator) {
              var index = -1,
                  length = array == null ? 0 : array.length;

              while (++index < length) {
                if (comparator(value, array[index])) {
                  return true;
                }
              }
              return false;
            }

            var _arrayIncludesWith = arrayIncludesWith;

            /**
             * Checks if a `cache` value for `key` exists.
             *
             * @private
             * @param {Object} cache The cache to query.
             * @param {string} key The key of the entry to check.
             * @returns {boolean} Returns `true` if an entry for `key` exists, else `false`.
             */
            function cacheHas(cache, key) {
              return cache.has(key);
            }

            var _cacheHas = cacheHas;

            /* Built-in method references that are verified to be native. */
            var Set = _getNative(_root, 'Set');

            var _Set = Set;

            /**
             * This method returns `undefined`.
             *
             * @static
             * @memberOf _
             * @since 2.3.0
             * @category Util
             * @example
             *
             * _.times(2, _.noop);
             * // => [undefined, undefined]
             */
            function noop$1() {
              // No operation performed.
            }

            var noop_1 = noop$1;

            /**
             * Converts `set` to an array of its values.
             *
             * @private
             * @param {Object} set The set to convert.
             * @returns {Array} Returns the values.
             */
            function setToArray(set) {
              var index = -1,
                  result = Array(set.size);

              set.forEach(function(value) {
                result[++index] = value;
              });
              return result;
            }

            var _setToArray = setToArray;

            /** Used as references for various `Number` constants. */
            var INFINITY$3 = 1 / 0;

            /**
             * Creates a set object of `values`.
             *
             * @private
             * @param {Array} values The values to add to the set.
             * @returns {Object} Returns the new set.
             */
            var createSet = !(_Set && (1 / _setToArray(new _Set([,-0]))[1]) == INFINITY$3) ? noop_1 : function(values) {
              return new _Set(values);
            };

            var _createSet = createSet;

            /** Used as the size to enable large array optimizations. */
            var LARGE_ARRAY_SIZE$1 = 200;

            /**
             * The base implementation of `_.uniqBy` without support for iteratee shorthands.
             *
             * @private
             * @param {Array} array The array to inspect.
             * @param {Function} [iteratee] The iteratee invoked per element.
             * @param {Function} [comparator] The comparator invoked per element.
             * @returns {Array} Returns the new duplicate free array.
             */
            function baseUniq(array, iteratee, comparator) {
              var index = -1,
                  includes = _arrayIncludes,
                  length = array.length,
                  isCommon = true,
                  result = [],
                  seen = result;

              if (comparator) {
                isCommon = false;
                includes = _arrayIncludesWith;
              }
              else if (length >= LARGE_ARRAY_SIZE$1) {
                var set = iteratee ? null : _createSet(array);
                if (set) {
                  return _setToArray(set);
                }
                isCommon = false;
                includes = _cacheHas;
                seen = new _SetCache;
              }
              else {
                seen = iteratee ? [] : result;
              }
              outer:
              while (++index < length) {
                var value = array[index],
                    computed = iteratee ? iteratee(value) : value;

                value = (comparator || value !== 0) ? value : 0;
                if (isCommon && computed === computed) {
                  var seenIndex = seen.length;
                  while (seenIndex--) {
                    if (seen[seenIndex] === computed) {
                      continue outer;
                    }
                  }
                  if (iteratee) {
                    seen.push(computed);
                  }
                  result.push(value);
                }
                else if (!includes(seen, computed, comparator)) {
                  if (seen !== result) {
                    seen.push(computed);
                  }
                  result.push(value);
                }
              }
              return result;
            }

            var _baseUniq = baseUniq;

            /**
             * Creates a duplicate-free version of an array, using
             * [`SameValueZero`](http://ecma-international.org/ecma-262/7.0/#sec-samevaluezero)
             * for equality comparisons, in which only the first occurrence of each element
             * is kept. The order of result values is determined by the order they occur
             * in the array.
             *
             * @static
             * @memberOf _
             * @since 0.1.0
             * @category Array
             * @param {Array} array The array to inspect.
             * @returns {Array} Returns the new duplicate free array.
             * @example
             *
             * _.uniq([2, 1, 2]);
             * // => [2, 1]
             */
            function uniq$1(array) {
              return (array && array.length) ? _baseUniq(array) : [];
            }

            var uniq_1 = uniq$1;

            /**
             * Removes all key-value entries from the stack.
             *
             * @private
             * @name clear
             * @memberOf Stack
             */
            function stackClear() {
              this.__data__ = new _ListCache;
              this.size = 0;
            }

            var _stackClear = stackClear;

            /**
             * Removes `key` and its value from the stack.
             *
             * @private
             * @name delete
             * @memberOf Stack
             * @param {string} key The key of the value to remove.
             * @returns {boolean} Returns `true` if the entry was removed, else `false`.
             */
            function stackDelete(key) {
              var data = this.__data__,
                  result = data['delete'](key);

              this.size = data.size;
              return result;
            }

            var _stackDelete = stackDelete;

            /**
             * Gets the stack value for `key`.
             *
             * @private
             * @name get
             * @memberOf Stack
             * @param {string} key The key of the value to get.
             * @returns {*} Returns the entry value.
             */
            function stackGet(key) {
              return this.__data__.get(key);
            }

            var _stackGet = stackGet;

            /**
             * Checks if a stack value for `key` exists.
             *
             * @private
             * @name has
             * @memberOf Stack
             * @param {string} key The key of the entry to check.
             * @returns {boolean} Returns `true` if an entry for `key` exists, else `false`.
             */
            function stackHas(key) {
              return this.__data__.has(key);
            }

            var _stackHas = stackHas;

            /** Used as the size to enable large array optimizations. */
            var LARGE_ARRAY_SIZE = 200;

            /**
             * Sets the stack `key` to `value`.
             *
             * @private
             * @name set
             * @memberOf Stack
             * @param {string} key The key of the value to set.
             * @param {*} value The value to set.
             * @returns {Object} Returns the stack cache instance.
             */
            function stackSet(key, value) {
              var data = this.__data__;
              if (data instanceof _ListCache) {
                var pairs = data.__data__;
                if (!_Map || (pairs.length < LARGE_ARRAY_SIZE - 1)) {
                  pairs.push([key, value]);
                  this.size = ++data.size;
                  return this;
                }
                data = this.__data__ = new _MapCache(pairs);
              }
              data.set(key, value);
              this.size = data.size;
              return this;
            }

            var _stackSet = stackSet;

            /**
             * Creates a stack cache object to store key-value pairs.
             *
             * @private
             * @constructor
             * @param {Array} [entries] The key-value pairs to cache.
             */
            function Stack(entries) {
              var data = this.__data__ = new _ListCache(entries);
              this.size = data.size;
            }

            // Add methods to `Stack`.
            Stack.prototype.clear = _stackClear;
            Stack.prototype['delete'] = _stackDelete;
            Stack.prototype.get = _stackGet;
            Stack.prototype.has = _stackHas;
            Stack.prototype.set = _stackSet;

            var _Stack = Stack;

            /**
             * A specialized version of `_.some` for arrays without support for iteratee
             * shorthands.
             *
             * @private
             * @param {Array} [array] The array to iterate over.
             * @param {Function} predicate The function invoked per iteration.
             * @returns {boolean} Returns `true` if any element passes the predicate check,
             *  else `false`.
             */
            function arraySome(array, predicate) {
              var index = -1,
                  length = array == null ? 0 : array.length;

              while (++index < length) {
                if (predicate(array[index], index, array)) {
                  return true;
                }
              }
              return false;
            }

            var _arraySome = arraySome;

            /** Used to compose bitmasks for value comparisons. */
            var COMPARE_PARTIAL_FLAG$5 = 1,
                COMPARE_UNORDERED_FLAG$3 = 2;

            /**
             * A specialized version of `baseIsEqualDeep` for arrays with support for
             * partial deep comparisons.
             *
             * @private
             * @param {Array} array The array to compare.
             * @param {Array} other The other array to compare.
             * @param {number} bitmask The bitmask flags. See `baseIsEqual` for more details.
             * @param {Function} customizer The function to customize comparisons.
             * @param {Function} equalFunc The function to determine equivalents of values.
             * @param {Object} stack Tracks traversed `array` and `other` objects.
             * @returns {boolean} Returns `true` if the arrays are equivalent, else `false`.
             */
            function equalArrays(array, other, bitmask, customizer, equalFunc, stack) {
              var isPartial = bitmask & COMPARE_PARTIAL_FLAG$5,
                  arrLength = array.length,
                  othLength = other.length;

              if (arrLength != othLength && !(isPartial && othLength > arrLength)) {
                return false;
              }
              // Check that cyclic values are equal.
              var arrStacked = stack.get(array);
              var othStacked = stack.get(other);
              if (arrStacked && othStacked) {
                return arrStacked == other && othStacked == array;
              }
              var index = -1,
                  result = true,
                  seen = (bitmask & COMPARE_UNORDERED_FLAG$3) ? new _SetCache : undefined;

              stack.set(array, other);
              stack.set(other, array);

              // Ignore non-index properties.
              while (++index < arrLength) {
                var arrValue = array[index],
                    othValue = other[index];

                if (customizer) {
                  var compared = isPartial
                    ? customizer(othValue, arrValue, index, other, array, stack)
                    : customizer(arrValue, othValue, index, array, other, stack);
                }
                if (compared !== undefined) {
                  if (compared) {
                    continue;
                  }
                  result = false;
                  break;
                }
                // Recursively compare arrays (susceptible to call stack limits).
                if (seen) {
                  if (!_arraySome(other, function(othValue, othIndex) {
                        if (!_cacheHas(seen, othIndex) &&
                            (arrValue === othValue || equalFunc(arrValue, othValue, bitmask, customizer, stack))) {
                          return seen.push(othIndex);
                        }
                      })) {
                    result = false;
                    break;
                  }
                } else if (!(
                      arrValue === othValue ||
                        equalFunc(arrValue, othValue, bitmask, customizer, stack)
                    )) {
                  result = false;
                  break;
                }
              }
              stack['delete'](array);
              stack['delete'](other);
              return result;
            }

            var _equalArrays = equalArrays;

            /** Built-in value references. */
            var Uint8Array$1 = _root.Uint8Array;

            var _Uint8Array = Uint8Array$1;

            /**
             * Converts `map` to its key-value pairs.
             *
             * @private
             * @param {Object} map The map to convert.
             * @returns {Array} Returns the key-value pairs.
             */
            function mapToArray(map) {
              var index = -1,
                  result = Array(map.size);

              map.forEach(function(value, key) {
                result[++index] = [key, value];
              });
              return result;
            }

            var _mapToArray = mapToArray;

            /** Used to compose bitmasks for value comparisons. */
            var COMPARE_PARTIAL_FLAG$4 = 1,
                COMPARE_UNORDERED_FLAG$2 = 2;

            /** `Object#toString` result references. */
            var boolTag$3 = '[object Boolean]',
                dateTag$3 = '[object Date]',
                errorTag$2 = '[object Error]',
                mapTag$6 = '[object Map]',
                numberTag$3 = '[object Number]',
                regexpTag$3 = '[object RegExp]',
                setTag$6 = '[object Set]',
                stringTag$3 = '[object String]',
                symbolTag$4 = '[object Symbol]';

            var arrayBufferTag$3 = '[object ArrayBuffer]',
                dataViewTag$4 = '[object DataView]';

            /** Used to convert symbols to primitives and strings. */
            var symbolProto$3 = _Symbol ? _Symbol.prototype : undefined,
                symbolValueOf$1 = symbolProto$3 ? symbolProto$3.valueOf : undefined;

            /**
             * A specialized version of `baseIsEqualDeep` for comparing objects of
             * the same `toStringTag`.
             *
             * **Note:** This function only supports comparing values with tags of
             * `Boolean`, `Date`, `Error`, `Number`, `RegExp`, or `String`.
             *
             * @private
             * @param {Object} object The object to compare.
             * @param {Object} other The other object to compare.
             * @param {string} tag The `toStringTag` of the objects to compare.
             * @param {number} bitmask The bitmask flags. See `baseIsEqual` for more details.
             * @param {Function} customizer The function to customize comparisons.
             * @param {Function} equalFunc The function to determine equivalents of values.
             * @param {Object} stack Tracks traversed `object` and `other` objects.
             * @returns {boolean} Returns `true` if the objects are equivalent, else `false`.
             */
            function equalByTag(object, other, tag, bitmask, customizer, equalFunc, stack) {
              switch (tag) {
                case dataViewTag$4:
                  if ((object.byteLength != other.byteLength) ||
                      (object.byteOffset != other.byteOffset)) {
                    return false;
                  }
                  object = object.buffer;
                  other = other.buffer;

                case arrayBufferTag$3:
                  if ((object.byteLength != other.byteLength) ||
                      !equalFunc(new _Uint8Array(object), new _Uint8Array(other))) {
                    return false;
                  }
                  return true;

                case boolTag$3:
                case dateTag$3:
                case numberTag$3:
                  // Coerce booleans to `1` or `0` and dates to milliseconds.
                  // Invalid dates are coerced to `NaN`.
                  return eq_1(+object, +other);

                case errorTag$2:
                  return object.name == other.name && object.message == other.message;

                case regexpTag$3:
                case stringTag$3:
                  // Coerce regexes to strings and treat strings, primitives and objects,
                  // as equal. See http://www.ecma-international.org/ecma-262/7.0/#sec-regexp.prototype.tostring
                  // for more details.
                  return object == (other + '');

                case mapTag$6:
                  var convert = _mapToArray;

                case setTag$6:
                  var isPartial = bitmask & COMPARE_PARTIAL_FLAG$4;
                  convert || (convert = _setToArray);

                  if (object.size != other.size && !isPartial) {
                    return false;
                  }
                  // Assume cyclic values are equal.
                  var stacked = stack.get(object);
                  if (stacked) {
                    return stacked == other;
                  }
                  bitmask |= COMPARE_UNORDERED_FLAG$2;

                  // Recursively compare objects (susceptible to call stack limits).
                  stack.set(object, other);
                  var result = _equalArrays(convert(object), convert(other), bitmask, customizer, equalFunc, stack);
                  stack['delete'](object);
                  return result;

                case symbolTag$4:
                  if (symbolValueOf$1) {
                    return symbolValueOf$1.call(object) == symbolValueOf$1.call(other);
                  }
              }
              return false;
            }

            var _equalByTag = equalByTag;

            /**
             * Appends the elements of `values` to `array`.
             *
             * @private
             * @param {Array} array The array to modify.
             * @param {Array} values The values to append.
             * @returns {Array} Returns `array`.
             */
            function arrayPush(array, values) {
              var index = -1,
                  length = values.length,
                  offset = array.length;

              while (++index < length) {
                array[offset + index] = values[index];
              }
              return array;
            }

            var _arrayPush = arrayPush;

            /**
             * The base implementation of `getAllKeys` and `getAllKeysIn` which uses
             * `keysFunc` and `symbolsFunc` to get the enumerable property names and
             * symbols of `object`.
             *
             * @private
             * @param {Object} object The object to query.
             * @param {Function} keysFunc The function to get the keys of `object`.
             * @param {Function} symbolsFunc The function to get the symbols of `object`.
             * @returns {Array} Returns the array of property names and symbols.
             */
            function baseGetAllKeys(object, keysFunc, symbolsFunc) {
              var result = keysFunc(object);
              return isArray_1(object) ? result : _arrayPush(result, symbolsFunc(object));
            }

            var _baseGetAllKeys = baseGetAllKeys;

            /**
             * A specialized version of `_.filter` for arrays without support for
             * iteratee shorthands.
             *
             * @private
             * @param {Array} [array] The array to iterate over.
             * @param {Function} predicate The function invoked per iteration.
             * @returns {Array} Returns the new filtered array.
             */
            function arrayFilter(array, predicate) {
              var index = -1,
                  length = array == null ? 0 : array.length,
                  resIndex = 0,
                  result = [];

              while (++index < length) {
                var value = array[index];
                if (predicate(value, index, array)) {
                  result[resIndex++] = value;
                }
              }
              return result;
            }

            var _arrayFilter = arrayFilter;

            /**
             * This method returns a new empty array.
             *
             * @static
             * @memberOf _
             * @since 4.13.0
             * @category Util
             * @returns {Array} Returns the new empty array.
             * @example
             *
             * var arrays = _.times(2, _.stubArray);
             *
             * console.log(arrays);
             * // => [[], []]
             *
             * console.log(arrays[0] === arrays[1]);
             * // => false
             */
            function stubArray() {
              return [];
            }

            var stubArray_1 = stubArray;

            /** Used for built-in method references. */
            var objectProto$b = Object.prototype;

            /** Built-in value references. */
            var propertyIsEnumerable$1 = objectProto$b.propertyIsEnumerable;

            /* Built-in method references for those with the same name as other `lodash` methods. */
            var nativeGetSymbols$1 = Object.getOwnPropertySymbols;

            /**
             * Creates an array of the own enumerable symbols of `object`.
             *
             * @private
             * @param {Object} object The object to query.
             * @returns {Array} Returns the array of symbols.
             */
            var getSymbols = !nativeGetSymbols$1 ? stubArray_1 : function(object) {
              if (object == null) {
                return [];
              }
              object = Object(object);
              return _arrayFilter(nativeGetSymbols$1(object), function(symbol) {
                return propertyIsEnumerable$1.call(object, symbol);
              });
            };

            var _getSymbols = getSymbols;

            /**
             * The base implementation of `_.times` without support for iteratee shorthands
             * or max array length checks.
             *
             * @private
             * @param {number} n The number of times to invoke `iteratee`.
             * @param {Function} iteratee The function invoked per iteration.
             * @returns {Array} Returns the array of results.
             */
            function baseTimes(n, iteratee) {
              var index = -1,
                  result = Array(n);

              while (++index < n) {
                result[index] = iteratee(index);
              }
              return result;
            }

            var _baseTimes = baseTimes;

            /** `Object#toString` result references. */
            var argsTag$3 = '[object Arguments]';

            /**
             * The base implementation of `_.isArguments`.
             *
             * @private
             * @param {*} value The value to check.
             * @returns {boolean} Returns `true` if `value` is an `arguments` object,
             */
            function baseIsArguments(value) {
              return isObjectLike_1(value) && _baseGetTag(value) == argsTag$3;
            }

            var _baseIsArguments = baseIsArguments;

            /** Used for built-in method references. */
            var objectProto$a = Object.prototype;

            /** Used to check objects for own properties. */
            var hasOwnProperty$9 = objectProto$a.hasOwnProperty;

            /** Built-in value references. */
            var propertyIsEnumerable = objectProto$a.propertyIsEnumerable;

            /**
             * Checks if `value` is likely an `arguments` object.
             *
             * @static
             * @memberOf _
             * @since 0.1.0
             * @category Lang
             * @param {*} value The value to check.
             * @returns {boolean} Returns `true` if `value` is an `arguments` object,
             *  else `false`.
             * @example
             *
             * _.isArguments(function() { return arguments; }());
             * // => true
             *
             * _.isArguments([1, 2, 3]);
             * // => false
             */
            var isArguments = _baseIsArguments(function() { return arguments; }()) ? _baseIsArguments : function(value) {
              return isObjectLike_1(value) && hasOwnProperty$9.call(value, 'callee') &&
                !propertyIsEnumerable.call(value, 'callee');
            };

            var isArguments_1 = isArguments;

            /**
             * This method returns `false`.
             *
             * @static
             * @memberOf _
             * @since 4.13.0
             * @category Util
             * @returns {boolean} Returns `false`.
             * @example
             *
             * _.times(2, _.stubFalse);
             * // => [false, false]
             */
            function stubFalse() {
              return false;
            }

            var stubFalse_1 = stubFalse;

            var isBuffer_1 = createCommonjsModule(function (module, exports) {
            /** Detect free variable `exports`. */
            var freeExports = exports && !exports.nodeType && exports;

            /** Detect free variable `module`. */
            var freeModule = freeExports && 'object' == 'object' && module && !module.nodeType && module;

            /** Detect the popular CommonJS extension `module.exports`. */
            var moduleExports = freeModule && freeModule.exports === freeExports;

            /** Built-in value references. */
            var Buffer = moduleExports ? _root.Buffer : undefined;

            /* Built-in method references for those with the same name as other `lodash` methods. */
            var nativeIsBuffer = Buffer ? Buffer.isBuffer : undefined;

            /**
             * Checks if `value` is a buffer.
             *
             * @static
             * @memberOf _
             * @since 4.3.0
             * @category Lang
             * @param {*} value The value to check.
             * @returns {boolean} Returns `true` if `value` is a buffer, else `false`.
             * @example
             *
             * _.isBuffer(new Buffer(2));
             * // => true
             *
             * _.isBuffer(new Uint8Array(2));
             * // => false
             */
            var isBuffer = nativeIsBuffer || stubFalse_1;

            module.exports = isBuffer;
            });

            /** Used as references for various `Number` constants. */
            var MAX_SAFE_INTEGER = 9007199254740991;

            /**
             * Checks if `value` is a valid array-like length.
             *
             * **Note:** This method is loosely based on
             * [`ToLength`](http://ecma-international.org/ecma-262/7.0/#sec-tolength).
             *
             * @static
             * @memberOf _
             * @since 4.0.0
             * @category Lang
             * @param {*} value The value to check.
             * @returns {boolean} Returns `true` if `value` is a valid length, else `false`.
             * @example
             *
             * _.isLength(3);
             * // => true
             *
             * _.isLength(Number.MIN_VALUE);
             * // => false
             *
             * _.isLength(Infinity);
             * // => false
             *
             * _.isLength('3');
             * // => false
             */
            function isLength(value) {
              return typeof value == 'number' &&
                value > -1 && value % 1 == 0 && value <= MAX_SAFE_INTEGER;
            }

            var isLength_1 = isLength;

            /** `Object#toString` result references. */
            var argsTag$2 = '[object Arguments]',
                arrayTag$2 = '[object Array]',
                boolTag$2 = '[object Boolean]',
                dateTag$2 = '[object Date]',
                errorTag$1 = '[object Error]',
                funcTag$1 = '[object Function]',
                mapTag$5 = '[object Map]',
                numberTag$2 = '[object Number]',
                objectTag$3 = '[object Object]',
                regexpTag$2 = '[object RegExp]',
                setTag$5 = '[object Set]',
                stringTag$2 = '[object String]',
                weakMapTag$2 = '[object WeakMap]';

            var arrayBufferTag$2 = '[object ArrayBuffer]',
                dataViewTag$3 = '[object DataView]',
                float32Tag$2 = '[object Float32Array]',
                float64Tag$2 = '[object Float64Array]',
                int8Tag$2 = '[object Int8Array]',
                int16Tag$2 = '[object Int16Array]',
                int32Tag$2 = '[object Int32Array]',
                uint8Tag$2 = '[object Uint8Array]',
                uint8ClampedTag$2 = '[object Uint8ClampedArray]',
                uint16Tag$2 = '[object Uint16Array]',
                uint32Tag$2 = '[object Uint32Array]';

            /** Used to identify `toStringTag` values of typed arrays. */
            var typedArrayTags = {};
            typedArrayTags[float32Tag$2] = typedArrayTags[float64Tag$2] =
            typedArrayTags[int8Tag$2] = typedArrayTags[int16Tag$2] =
            typedArrayTags[int32Tag$2] = typedArrayTags[uint8Tag$2] =
            typedArrayTags[uint8ClampedTag$2] = typedArrayTags[uint16Tag$2] =
            typedArrayTags[uint32Tag$2] = true;
            typedArrayTags[argsTag$2] = typedArrayTags[arrayTag$2] =
            typedArrayTags[arrayBufferTag$2] = typedArrayTags[boolTag$2] =
            typedArrayTags[dataViewTag$3] = typedArrayTags[dateTag$2] =
            typedArrayTags[errorTag$1] = typedArrayTags[funcTag$1] =
            typedArrayTags[mapTag$5] = typedArrayTags[numberTag$2] =
            typedArrayTags[objectTag$3] = typedArrayTags[regexpTag$2] =
            typedArrayTags[setTag$5] = typedArrayTags[stringTag$2] =
            typedArrayTags[weakMapTag$2] = false;

            /**
             * The base implementation of `_.isTypedArray` without Node.js optimizations.
             *
             * @private
             * @param {*} value The value to check.
             * @returns {boolean} Returns `true` if `value` is a typed array, else `false`.
             */
            function baseIsTypedArray(value) {
              return isObjectLike_1(value) &&
                isLength_1(value.length) && !!typedArrayTags[_baseGetTag(value)];
            }

            var _baseIsTypedArray = baseIsTypedArray;

            /**
             * The base implementation of `_.unary` without support for storing metadata.
             *
             * @private
             * @param {Function} func The function to cap arguments for.
             * @returns {Function} Returns the new capped function.
             */
            function baseUnary(func) {
              return function(value) {
                return func(value);
              };
            }

            var _baseUnary = baseUnary;

            var _nodeUtil = createCommonjsModule(function (module, exports) {
            /** Detect free variable `exports`. */
            var freeExports = exports && !exports.nodeType && exports;

            /** Detect free variable `module`. */
            var freeModule = freeExports && 'object' == 'object' && module && !module.nodeType && module;

            /** Detect the popular CommonJS extension `module.exports`. */
            var moduleExports = freeModule && freeModule.exports === freeExports;

            /** Detect free variable `process` from Node.js. */
            var freeProcess = moduleExports && _freeGlobal.process;

            /** Used to access faster Node.js helpers. */
            var nodeUtil = (function() {
              try {
                // Use `util.types` for Node.js 10+.
                var types = freeModule && freeModule.require && freeModule.require('util').types;

                if (types) {
                  return types;
                }

                // Legacy `process.binding('util')` for Node.js < 10.
                return freeProcess && freeProcess.binding && freeProcess.binding('util');
              } catch (e) {}
            }());

            module.exports = nodeUtil;
            });

            /* Node.js helper references. */
            var nodeIsTypedArray = _nodeUtil && _nodeUtil.isTypedArray;

            /**
             * Checks if `value` is classified as a typed array.
             *
             * @static
             * @memberOf _
             * @since 3.0.0
             * @category Lang
             * @param {*} value The value to check.
             * @returns {boolean} Returns `true` if `value` is a typed array, else `false`.
             * @example
             *
             * _.isTypedArray(new Uint8Array);
             * // => true
             *
             * _.isTypedArray([]);
             * // => false
             */
            var isTypedArray = nodeIsTypedArray ? _baseUnary(nodeIsTypedArray) : _baseIsTypedArray;

            var isTypedArray_1 = isTypedArray;

            /** Used for built-in method references. */
            var objectProto$9 = Object.prototype;

            /** Used to check objects for own properties. */
            var hasOwnProperty$8 = objectProto$9.hasOwnProperty;

            /**
             * Creates an array of the enumerable property names of the array-like `value`.
             *
             * @private
             * @param {*} value The value to query.
             * @param {boolean} inherited Specify returning inherited property names.
             * @returns {Array} Returns the array of property names.
             */
            function arrayLikeKeys(value, inherited) {
              var isArr = isArray_1(value),
                  isArg = !isArr && isArguments_1(value),
                  isBuff = !isArr && !isArg && isBuffer_1(value),
                  isType = !isArr && !isArg && !isBuff && isTypedArray_1(value),
                  skipIndexes = isArr || isArg || isBuff || isType,
                  result = skipIndexes ? _baseTimes(value.length, String) : [],
                  length = result.length;

              for (var key in value) {
                if ((inherited || hasOwnProperty$8.call(value, key)) &&
                    !(skipIndexes && (
                       // Safari 9 has enumerable `arguments.length` in strict mode.
                       key == 'length' ||
                       // Node.js 0.10 has enumerable non-index properties on buffers.
                       (isBuff && (key == 'offset' || key == 'parent')) ||
                       // PhantomJS 2 has enumerable non-index properties on typed arrays.
                       (isType && (key == 'buffer' || key == 'byteLength' || key == 'byteOffset')) ||
                       // Skip index properties.
                       _isIndex(key, length)
                    ))) {
                  result.push(key);
                }
              }
              return result;
            }

            var _arrayLikeKeys = arrayLikeKeys;

            /** Used for built-in method references. */
            var objectProto$8 = Object.prototype;

            /**
             * Checks if `value` is likely a prototype object.
             *
             * @private
             * @param {*} value The value to check.
             * @returns {boolean} Returns `true` if `value` is a prototype, else `false`.
             */
            function isPrototype(value) {
              var Ctor = value && value.constructor,
                  proto = (typeof Ctor == 'function' && Ctor.prototype) || objectProto$8;

              return value === proto;
            }

            var _isPrototype = isPrototype;

            /**
             * Creates a unary function that invokes `func` with its argument transformed.
             *
             * @private
             * @param {Function} func The function to wrap.
             * @param {Function} transform The argument transform.
             * @returns {Function} Returns the new function.
             */
            function overArg(func, transform) {
              return function(arg) {
                return func(transform(arg));
              };
            }

            var _overArg = overArg;

            /* Built-in method references for those with the same name as other `lodash` methods. */
            var nativeKeys = _overArg(Object.keys, Object);

            var _nativeKeys = nativeKeys;

            /** Used for built-in method references. */
            var objectProto$7 = Object.prototype;

            /** Used to check objects for own properties. */
            var hasOwnProperty$7 = objectProto$7.hasOwnProperty;

            /**
             * The base implementation of `_.keys` which doesn't treat sparse arrays as dense.
             *
             * @private
             * @param {Object} object The object to query.
             * @returns {Array} Returns the array of property names.
             */
            function baseKeys(object) {
              if (!_isPrototype(object)) {
                return _nativeKeys(object);
              }
              var result = [];
              for (var key in Object(object)) {
                if (hasOwnProperty$7.call(object, key) && key != 'constructor') {
                  result.push(key);
                }
              }
              return result;
            }

            var _baseKeys = baseKeys;

            /**
             * Checks if `value` is array-like. A value is considered array-like if it's
             * not a function and has a `value.length` that's an integer greater than or
             * equal to `0` and less than or equal to `Number.MAX_SAFE_INTEGER`.
             *
             * @static
             * @memberOf _
             * @since 4.0.0
             * @category Lang
             * @param {*} value The value to check.
             * @returns {boolean} Returns `true` if `value` is array-like, else `false`.
             * @example
             *
             * _.isArrayLike([1, 2, 3]);
             * // => true
             *
             * _.isArrayLike(document.body.children);
             * // => true
             *
             * _.isArrayLike('abc');
             * // => true
             *
             * _.isArrayLike(_.noop);
             * // => false
             */
            function isArrayLike(value) {
              return value != null && isLength_1(value.length) && !isFunction_1(value);
            }

            var isArrayLike_1 = isArrayLike;

            /**
             * Creates an array of the own enumerable property names of `object`.
             *
             * **Note:** Non-object values are coerced to objects. See the
             * [ES spec](http://ecma-international.org/ecma-262/7.0/#sec-object.keys)
             * for more details.
             *
             * @static
             * @since 0.1.0
             * @memberOf _
             * @category Object
             * @param {Object} object The object to query.
             * @returns {Array} Returns the array of property names.
             * @example
             *
             * function Foo() {
             *   this.a = 1;
             *   this.b = 2;
             * }
             *
             * Foo.prototype.c = 3;
             *
             * _.keys(new Foo);
             * // => ['a', 'b'] (iteration order is not guaranteed)
             *
             * _.keys('hi');
             * // => ['0', '1']
             */
            function keys$1(object) {
              return isArrayLike_1(object) ? _arrayLikeKeys(object) : _baseKeys(object);
            }

            var keys_1 = keys$1;

            /**
             * Creates an array of own enumerable property names and symbols of `object`.
             *
             * @private
             * @param {Object} object The object to query.
             * @returns {Array} Returns the array of property names and symbols.
             */
            function getAllKeys(object) {
              return _baseGetAllKeys(object, keys_1, _getSymbols);
            }

            var _getAllKeys = getAllKeys;

            /** Used to compose bitmasks for value comparisons. */
            var COMPARE_PARTIAL_FLAG$3 = 1;

            /** Used for built-in method references. */
            var objectProto$6 = Object.prototype;

            /** Used to check objects for own properties. */
            var hasOwnProperty$6 = objectProto$6.hasOwnProperty;

            /**
             * A specialized version of `baseIsEqualDeep` for objects with support for
             * partial deep comparisons.
             *
             * @private
             * @param {Object} object The object to compare.
             * @param {Object} other The other object to compare.
             * @param {number} bitmask The bitmask flags. See `baseIsEqual` for more details.
             * @param {Function} customizer The function to customize comparisons.
             * @param {Function} equalFunc The function to determine equivalents of values.
             * @param {Object} stack Tracks traversed `object` and `other` objects.
             * @returns {boolean} Returns `true` if the objects are equivalent, else `false`.
             */
            function equalObjects(object, other, bitmask, customizer, equalFunc, stack) {
              var isPartial = bitmask & COMPARE_PARTIAL_FLAG$3,
                  objProps = _getAllKeys(object),
                  objLength = objProps.length,
                  othProps = _getAllKeys(other),
                  othLength = othProps.length;

              if (objLength != othLength && !isPartial) {
                return false;
              }
              var index = objLength;
              while (index--) {
                var key = objProps[index];
                if (!(isPartial ? key in other : hasOwnProperty$6.call(other, key))) {
                  return false;
                }
              }
              // Check that cyclic values are equal.
              var objStacked = stack.get(object);
              var othStacked = stack.get(other);
              if (objStacked && othStacked) {
                return objStacked == other && othStacked == object;
              }
              var result = true;
              stack.set(object, other);
              stack.set(other, object);

              var skipCtor = isPartial;
              while (++index < objLength) {
                key = objProps[index];
                var objValue = object[key],
                    othValue = other[key];

                if (customizer) {
                  var compared = isPartial
                    ? customizer(othValue, objValue, key, other, object, stack)
                    : customizer(objValue, othValue, key, object, other, stack);
                }
                // Recursively compare objects (susceptible to call stack limits).
                if (!(compared === undefined
                      ? (objValue === othValue || equalFunc(objValue, othValue, bitmask, customizer, stack))
                      : compared
                    )) {
                  result = false;
                  break;
                }
                skipCtor || (skipCtor = key == 'constructor');
              }
              if (result && !skipCtor) {
                var objCtor = object.constructor,
                    othCtor = other.constructor;

                // Non `Object` object instances with different constructors are not equal.
                if (objCtor != othCtor &&
                    ('constructor' in object && 'constructor' in other) &&
                    !(typeof objCtor == 'function' && objCtor instanceof objCtor &&
                      typeof othCtor == 'function' && othCtor instanceof othCtor)) {
                  result = false;
                }
              }
              stack['delete'](object);
              stack['delete'](other);
              return result;
            }

            var _equalObjects = equalObjects;

            /* Built-in method references that are verified to be native. */
            var DataView = _getNative(_root, 'DataView');

            var _DataView = DataView;

            /* Built-in method references that are verified to be native. */
            var Promise$1 = _getNative(_root, 'Promise');

            var _Promise = Promise$1;

            /* Built-in method references that are verified to be native. */
            var WeakMap = _getNative(_root, 'WeakMap');

            var _WeakMap = WeakMap;

            /** `Object#toString` result references. */
            var mapTag$4 = '[object Map]',
                objectTag$2 = '[object Object]',
                promiseTag = '[object Promise]',
                setTag$4 = '[object Set]',
                weakMapTag$1 = '[object WeakMap]';

            var dataViewTag$2 = '[object DataView]';

            /** Used to detect maps, sets, and weakmaps. */
            var dataViewCtorString = _toSource(_DataView),
                mapCtorString = _toSource(_Map),
                promiseCtorString = _toSource(_Promise),
                setCtorString = _toSource(_Set),
                weakMapCtorString = _toSource(_WeakMap);

            /**
             * Gets the `toStringTag` of `value`.
             *
             * @private
             * @param {*} value The value to query.
             * @returns {string} Returns the `toStringTag`.
             */
            var getTag = _baseGetTag;

            // Fallback for data views, maps, sets, and weak maps in IE 11 and promises in Node.js < 6.
            if ((_DataView && getTag(new _DataView(new ArrayBuffer(1))) != dataViewTag$2) ||
                (_Map && getTag(new _Map) != mapTag$4) ||
                (_Promise && getTag(_Promise.resolve()) != promiseTag) ||
                (_Set && getTag(new _Set) != setTag$4) ||
                (_WeakMap && getTag(new _WeakMap) != weakMapTag$1)) {
              getTag = function(value) {
                var result = _baseGetTag(value),
                    Ctor = result == objectTag$2 ? value.constructor : undefined,
                    ctorString = Ctor ? _toSource(Ctor) : '';

                if (ctorString) {
                  switch (ctorString) {
                    case dataViewCtorString: return dataViewTag$2;
                    case mapCtorString: return mapTag$4;
                    case promiseCtorString: return promiseTag;
                    case setCtorString: return setTag$4;
                    case weakMapCtorString: return weakMapTag$1;
                  }
                }
                return result;
              };
            }

            var _getTag = getTag;

            /** Used to compose bitmasks for value comparisons. */
            var COMPARE_PARTIAL_FLAG$2 = 1;

            /** `Object#toString` result references. */
            var argsTag$1 = '[object Arguments]',
                arrayTag$1 = '[object Array]',
                objectTag$1 = '[object Object]';

            /** Used for built-in method references. */
            var objectProto$5 = Object.prototype;

            /** Used to check objects for own properties. */
            var hasOwnProperty$5 = objectProto$5.hasOwnProperty;

            /**
             * A specialized version of `baseIsEqual` for arrays and objects which performs
             * deep comparisons and tracks traversed objects enabling objects with circular
             * references to be compared.
             *
             * @private
             * @param {Object} object The object to compare.
             * @param {Object} other The other object to compare.
             * @param {number} bitmask The bitmask flags. See `baseIsEqual` for more details.
             * @param {Function} customizer The function to customize comparisons.
             * @param {Function} equalFunc The function to determine equivalents of values.
             * @param {Object} [stack] Tracks traversed `object` and `other` objects.
             * @returns {boolean} Returns `true` if the objects are equivalent, else `false`.
             */
            function baseIsEqualDeep(object, other, bitmask, customizer, equalFunc, stack) {
              var objIsArr = isArray_1(object),
                  othIsArr = isArray_1(other),
                  objTag = objIsArr ? arrayTag$1 : _getTag(object),
                  othTag = othIsArr ? arrayTag$1 : _getTag(other);

              objTag = objTag == argsTag$1 ? objectTag$1 : objTag;
              othTag = othTag == argsTag$1 ? objectTag$1 : othTag;

              var objIsObj = objTag == objectTag$1,
                  othIsObj = othTag == objectTag$1,
                  isSameTag = objTag == othTag;

              if (isSameTag && isBuffer_1(object)) {
                if (!isBuffer_1(other)) {
                  return false;
                }
                objIsArr = true;
                objIsObj = false;
              }
              if (isSameTag && !objIsObj) {
                stack || (stack = new _Stack);
                return (objIsArr || isTypedArray_1(object))
                  ? _equalArrays(object, other, bitmask, customizer, equalFunc, stack)
                  : _equalByTag(object, other, objTag, bitmask, customizer, equalFunc, stack);
              }
              if (!(bitmask & COMPARE_PARTIAL_FLAG$2)) {
                var objIsWrapped = objIsObj && hasOwnProperty$5.call(object, '__wrapped__'),
                    othIsWrapped = othIsObj && hasOwnProperty$5.call(other, '__wrapped__');

                if (objIsWrapped || othIsWrapped) {
                  var objUnwrapped = objIsWrapped ? object.value() : object,
                      othUnwrapped = othIsWrapped ? other.value() : other;

                  stack || (stack = new _Stack);
                  return equalFunc(objUnwrapped, othUnwrapped, bitmask, customizer, stack);
                }
              }
              if (!isSameTag) {
                return false;
              }
              stack || (stack = new _Stack);
              return _equalObjects(object, other, bitmask, customizer, equalFunc, stack);
            }

            var _baseIsEqualDeep = baseIsEqualDeep;

            /**
             * The base implementation of `_.isEqual` which supports partial comparisons
             * and tracks traversed objects.
             *
             * @private
             * @param {*} value The value to compare.
             * @param {*} other The other value to compare.
             * @param {boolean} bitmask The bitmask flags.
             *  1 - Unordered comparison
             *  2 - Partial comparison
             * @param {Function} [customizer] The function to customize comparisons.
             * @param {Object} [stack] Tracks traversed `value` and `other` objects.
             * @returns {boolean} Returns `true` if the values are equivalent, else `false`.
             */
            function baseIsEqual(value, other, bitmask, customizer, stack) {
              if (value === other) {
                return true;
              }
              if (value == null || other == null || (!isObjectLike_1(value) && !isObjectLike_1(other))) {
                return value !== value && other !== other;
              }
              return _baseIsEqualDeep(value, other, bitmask, customizer, baseIsEqual, stack);
            }

            var _baseIsEqual = baseIsEqual;

            /** Used to compose bitmasks for value comparisons. */
            var COMPARE_PARTIAL_FLAG$1 = 1,
                COMPARE_UNORDERED_FLAG$1 = 2;

            /**
             * The base implementation of `_.isMatch` without support for iteratee shorthands.
             *
             * @private
             * @param {Object} object The object to inspect.
             * @param {Object} source The object of property values to match.
             * @param {Array} matchData The property names, values, and compare flags to match.
             * @param {Function} [customizer] The function to customize comparisons.
             * @returns {boolean} Returns `true` if `object` is a match, else `false`.
             */
            function baseIsMatch(object, source, matchData, customizer) {
              var index = matchData.length,
                  length = index,
                  noCustomizer = !customizer;

              if (object == null) {
                return !length;
              }
              object = Object(object);
              while (index--) {
                var data = matchData[index];
                if ((noCustomizer && data[2])
                      ? data[1] !== object[data[0]]
                      : !(data[0] in object)
                    ) {
                  return false;
                }
              }
              while (++index < length) {
                data = matchData[index];
                var key = data[0],
                    objValue = object[key],
                    srcValue = data[1];

                if (noCustomizer && data[2]) {
                  if (objValue === undefined && !(key in object)) {
                    return false;
                  }
                } else {
                  var stack = new _Stack;
                  if (customizer) {
                    var result = customizer(objValue, srcValue, key, object, source, stack);
                  }
                  if (!(result === undefined
                        ? _baseIsEqual(srcValue, objValue, COMPARE_PARTIAL_FLAG$1 | COMPARE_UNORDERED_FLAG$1, customizer, stack)
                        : result
                      )) {
                    return false;
                  }
                }
              }
              return true;
            }

            var _baseIsMatch = baseIsMatch;

            /**
             * Checks if `value` is suitable for strict equality comparisons, i.e. `===`.
             *
             * @private
             * @param {*} value The value to check.
             * @returns {boolean} Returns `true` if `value` if suitable for strict
             *  equality comparisons, else `false`.
             */
            function isStrictComparable(value) {
              return value === value && !isObject_1(value);
            }

            var _isStrictComparable = isStrictComparable;

            /**
             * Gets the property names, values, and compare flags of `object`.
             *
             * @private
             * @param {Object} object The object to query.
             * @returns {Array} Returns the match data of `object`.
             */
            function getMatchData(object) {
              var result = keys_1(object),
                  length = result.length;

              while (length--) {
                var key = result[length],
                    value = object[key];

                result[length] = [key, value, _isStrictComparable(value)];
              }
              return result;
            }

            var _getMatchData = getMatchData;

            /**
             * A specialized version of `matchesProperty` for source values suitable
             * for strict equality comparisons, i.e. `===`.
             *
             * @private
             * @param {string} key The key of the property to get.
             * @param {*} srcValue The value to match.
             * @returns {Function} Returns the new spec function.
             */
            function matchesStrictComparable(key, srcValue) {
              return function(object) {
                if (object == null) {
                  return false;
                }
                return object[key] === srcValue &&
                  (srcValue !== undefined || (key in Object(object)));
              };
            }

            var _matchesStrictComparable = matchesStrictComparable;

            /**
             * The base implementation of `_.matches` which doesn't clone `source`.
             *
             * @private
             * @param {Object} source The object of property values to match.
             * @returns {Function} Returns the new spec function.
             */
            function baseMatches(source) {
              var matchData = _getMatchData(source);
              if (matchData.length == 1 && matchData[0][2]) {
                return _matchesStrictComparable(matchData[0][0], matchData[0][1]);
              }
              return function(object) {
                return object === source || _baseIsMatch(object, source, matchData);
              };
            }

            var _baseMatches = baseMatches;

            /**
             * The base implementation of `_.hasIn` without support for deep paths.
             *
             * @private
             * @param {Object} [object] The object to query.
             * @param {Array|string} key The key to check.
             * @returns {boolean} Returns `true` if `key` exists, else `false`.
             */
            function baseHasIn(object, key) {
              return object != null && key in Object(object);
            }

            var _baseHasIn = baseHasIn;

            /**
             * Checks if `path` exists on `object`.
             *
             * @private
             * @param {Object} object The object to query.
             * @param {Array|string} path The path to check.
             * @param {Function} hasFunc The function to check properties.
             * @returns {boolean} Returns `true` if `path` exists, else `false`.
             */
            function hasPath(object, path, hasFunc) {
              path = _castPath(path, object);

              var index = -1,
                  length = path.length,
                  result = false;

              while (++index < length) {
                var key = _toKey(path[index]);
                if (!(result = object != null && hasFunc(object, key))) {
                  break;
                }
                object = object[key];
              }
              if (result || ++index != length) {
                return result;
              }
              length = object == null ? 0 : object.length;
              return !!length && isLength_1(length) && _isIndex(key, length) &&
                (isArray_1(object) || isArguments_1(object));
            }

            var _hasPath = hasPath;

            /**
             * Checks if `path` is a direct or inherited property of `object`.
             *
             * @static
             * @memberOf _
             * @since 4.0.0
             * @category Object
             * @param {Object} object The object to query.
             * @param {Array|string} path The path to check.
             * @returns {boolean} Returns `true` if `path` exists, else `false`.
             * @example
             *
             * var object = _.create({ 'a': _.create({ 'b': 2 }) });
             *
             * _.hasIn(object, 'a');
             * // => true
             *
             * _.hasIn(object, 'a.b');
             * // => true
             *
             * _.hasIn(object, ['a', 'b']);
             * // => true
             *
             * _.hasIn(object, 'b');
             * // => false
             */
            function hasIn(object, path) {
              return object != null && _hasPath(object, path, _baseHasIn);
            }

            var hasIn_1 = hasIn;

            /** Used to compose bitmasks for value comparisons. */
            var COMPARE_PARTIAL_FLAG = 1,
                COMPARE_UNORDERED_FLAG = 2;

            /**
             * The base implementation of `_.matchesProperty` which doesn't clone `srcValue`.
             *
             * @private
             * @param {string} path The path of the property to get.
             * @param {*} srcValue The value to match.
             * @returns {Function} Returns the new spec function.
             */
            function baseMatchesProperty(path, srcValue) {
              if (_isKey(path) && _isStrictComparable(srcValue)) {
                return _matchesStrictComparable(_toKey(path), srcValue);
              }
              return function(object) {
                var objValue = get_1(object, path);
                return (objValue === undefined && objValue === srcValue)
                  ? hasIn_1(object, path)
                  : _baseIsEqual(srcValue, objValue, COMPARE_PARTIAL_FLAG | COMPARE_UNORDERED_FLAG);
              };
            }

            var _baseMatchesProperty = baseMatchesProperty;

            /**
             * This method returns the first argument it receives.
             *
             * @static
             * @since 0.1.0
             * @memberOf _
             * @category Util
             * @param {*} value Any value.
             * @returns {*} Returns `value`.
             * @example
             *
             * var object = { 'a': 1 };
             *
             * console.log(_.identity(object) === object);
             * // => true
             */
            function identity(value) {
              return value;
            }

            var identity_1 = identity;

            /**
             * The base implementation of `_.property` without support for deep paths.
             *
             * @private
             * @param {string} key The key of the property to get.
             * @returns {Function} Returns the new accessor function.
             */
            function baseProperty(key) {
              return function(object) {
                return object == null ? undefined : object[key];
              };
            }

            var _baseProperty = baseProperty;

            /**
             * A specialized version of `baseProperty` which supports deep paths.
             *
             * @private
             * @param {Array|string} path The path of the property to get.
             * @returns {Function} Returns the new accessor function.
             */
            function basePropertyDeep(path) {
              return function(object) {
                return _baseGet(object, path);
              };
            }

            var _basePropertyDeep = basePropertyDeep;

            /**
             * Creates a function that returns the value at `path` of a given object.
             *
             * @static
             * @memberOf _
             * @since 2.4.0
             * @category Util
             * @param {Array|string} path The path of the property to get.
             * @returns {Function} Returns the new accessor function.
             * @example
             *
             * var objects = [
             *   { 'a': { 'b': 2 } },
             *   { 'a': { 'b': 1 } }
             * ];
             *
             * _.map(objects, _.property('a.b'));
             * // => [2, 1]
             *
             * _.map(_.sortBy(objects, _.property(['a', 'b'])), 'a.b');
             * // => [1, 2]
             */
            function property(path) {
              return _isKey(path) ? _baseProperty(_toKey(path)) : _basePropertyDeep(path);
            }

            var property_1 = property;

            /**
             * The base implementation of `_.iteratee`.
             *
             * @private
             * @param {*} [value=_.identity] The value to convert to an iteratee.
             * @returns {Function} Returns the iteratee.
             */
            function baseIteratee(value) {
              // Don't store the `typeof` result in a variable to avoid a JIT bug in Safari 9.
              // See https://bugs.webkit.org/show_bug.cgi?id=156034 for more details.
              if (typeof value == 'function') {
                return value;
              }
              if (value == null) {
                return identity_1;
              }
              if (typeof value == 'object') {
                return isArray_1(value)
                  ? _baseMatchesProperty(value[0], value[1])
                  : _baseMatches(value);
              }
              return property_1(value);
            }

            var _baseIteratee = baseIteratee;

            /**
             * Creates a `_.find` or `_.findLast` function.
             *
             * @private
             * @param {Function} findIndexFunc The function to find the collection index.
             * @returns {Function} Returns the new find function.
             */
            function createFind(findIndexFunc) {
              return function(collection, predicate, fromIndex) {
                var iterable = Object(collection);
                if (!isArrayLike_1(collection)) {
                  var iteratee = _baseIteratee(predicate);
                  collection = keys_1(collection);
                  predicate = function(key) { return iteratee(iterable[key], key, iterable); };
                }
                var index = findIndexFunc(collection, predicate, fromIndex);
                return index > -1 ? iterable[iteratee ? collection[index] : index] : undefined;
              };
            }

            var _createFind = createFind;

            /** Used to match a single whitespace character. */
            var reWhitespace = /\s/;

            /**
             * Used by `_.trim` and `_.trimEnd` to get the index of the last non-whitespace
             * character of `string`.
             *
             * @private
             * @param {string} string The string to inspect.
             * @returns {number} Returns the index of the last non-whitespace character.
             */
            function trimmedEndIndex(string) {
              var index = string.length;

              while (index-- && reWhitespace.test(string.charAt(index))) {}
              return index;
            }

            var _trimmedEndIndex = trimmedEndIndex;

            /** Used to match leading whitespace. */
            var reTrimStart = /^\s+/;

            /**
             * The base implementation of `_.trim`.
             *
             * @private
             * @param {string} string The string to trim.
             * @returns {string} Returns the trimmed string.
             */
            function baseTrim(string) {
              return string
                ? string.slice(0, _trimmedEndIndex(string) + 1).replace(reTrimStart, '')
                : string;
            }

            var _baseTrim = baseTrim;

            /** Used as references for various `Number` constants. */
            var NAN = 0 / 0;

            /** Used to detect bad signed hexadecimal string values. */
            var reIsBadHex = /^[-+]0x[0-9a-f]+$/i;

            /** Used to detect binary string values. */
            var reIsBinary = /^0b[01]+$/i;

            /** Used to detect octal string values. */
            var reIsOctal = /^0o[0-7]+$/i;

            /** Built-in method references without a dependency on `root`. */
            var freeParseInt = parseInt;

            /**
             * Converts `value` to a number.
             *
             * @static
             * @memberOf _
             * @since 4.0.0
             * @category Lang
             * @param {*} value The value to process.
             * @returns {number} Returns the number.
             * @example
             *
             * _.toNumber(3.2);
             * // => 3.2
             *
             * _.toNumber(Number.MIN_VALUE);
             * // => 5e-324
             *
             * _.toNumber(Infinity);
             * // => Infinity
             *
             * _.toNumber('3.2');
             * // => 3.2
             */
            function toNumber(value) {
              if (typeof value == 'number') {
                return value;
              }
              if (isSymbol_1(value)) {
                return NAN;
              }
              if (isObject_1(value)) {
                var other = typeof value.valueOf == 'function' ? value.valueOf() : value;
                value = isObject_1(other) ? (other + '') : other;
              }
              if (typeof value != 'string') {
                return value === 0 ? value : +value;
              }
              value = _baseTrim(value);
              var isBinary = reIsBinary.test(value);
              return (isBinary || reIsOctal.test(value))
                ? freeParseInt(value.slice(2), isBinary ? 2 : 8)
                : (reIsBadHex.test(value) ? NAN : +value);
            }

            var toNumber_1 = toNumber;

            /** Used as references for various `Number` constants. */
            var INFINITY$2 = 1 / 0,
                MAX_INTEGER = 1.7976931348623157e+308;

            /**
             * Converts `value` to a finite number.
             *
             * @static
             * @memberOf _
             * @since 4.12.0
             * @category Lang
             * @param {*} value The value to convert.
             * @returns {number} Returns the converted number.
             * @example
             *
             * _.toFinite(3.2);
             * // => 3.2
             *
             * _.toFinite(Number.MIN_VALUE);
             * // => 5e-324
             *
             * _.toFinite(Infinity);
             * // => 1.7976931348623157e+308
             *
             * _.toFinite('3.2');
             * // => 3.2
             */
            function toFinite(value) {
              if (!value) {
                return value === 0 ? value : 0;
              }
              value = toNumber_1(value);
              if (value === INFINITY$2 || value === -INFINITY$2) {
                var sign = (value < 0 ? -1 : 1);
                return sign * MAX_INTEGER;
              }
              return value === value ? value : 0;
            }

            var toFinite_1 = toFinite;

            /**
             * Converts `value` to an integer.
             *
             * **Note:** This method is loosely based on
             * [`ToInteger`](http://www.ecma-international.org/ecma-262/7.0/#sec-tointeger).
             *
             * @static
             * @memberOf _
             * @since 4.0.0
             * @category Lang
             * @param {*} value The value to convert.
             * @returns {number} Returns the converted integer.
             * @example
             *
             * _.toInteger(3.2);
             * // => 3
             *
             * _.toInteger(Number.MIN_VALUE);
             * // => 0
             *
             * _.toInteger(Infinity);
             * // => 1.7976931348623157e+308
             *
             * _.toInteger('3.2');
             * // => 3
             */
            function toInteger(value) {
              var result = toFinite_1(value),
                  remainder = result % 1;

              return result === result ? (remainder ? result - remainder : result) : 0;
            }

            var toInteger_1 = toInteger;

            /* Built-in method references for those with the same name as other `lodash` methods. */
            var nativeMax = Math.max;

            /**
             * This method is like `_.find` except that it returns the index of the first
             * element `predicate` returns truthy for instead of the element itself.
             *
             * @static
             * @memberOf _
             * @since 1.1.0
             * @category Array
             * @param {Array} array The array to inspect.
             * @param {Function} [predicate=_.identity] The function invoked per iteration.
             * @param {number} [fromIndex=0] The index to search from.
             * @returns {number} Returns the index of the found element, else `-1`.
             * @example
             *
             * var users = [
             *   { 'user': 'barney',  'active': false },
             *   { 'user': 'fred',    'active': false },
             *   { 'user': 'pebbles', 'active': true }
             * ];
             *
             * _.findIndex(users, function(o) { return o.user == 'barney'; });
             * // => 0
             *
             * // The `_.matches` iteratee shorthand.
             * _.findIndex(users, { 'user': 'fred', 'active': false });
             * // => 1
             *
             * // The `_.matchesProperty` iteratee shorthand.
             * _.findIndex(users, ['active', false]);
             * // => 0
             *
             * // The `_.property` iteratee shorthand.
             * _.findIndex(users, 'active');
             * // => 2
             */
            function findIndex(array, predicate, fromIndex) {
              var length = array == null ? 0 : array.length;
              if (!length) {
                return -1;
              }
              var index = fromIndex == null ? 0 : toInteger_1(fromIndex);
              if (index < 0) {
                index = nativeMax(length + index, 0);
              }
              return _baseFindIndex(array, _baseIteratee(predicate), index);
            }

            var findIndex_1 = findIndex;

            /**
             * Iterates over elements of `collection`, returning the first element
             * `predicate` returns truthy for. The predicate is invoked with three
             * arguments: (value, index|key, collection).
             *
             * @static
             * @memberOf _
             * @since 0.1.0
             * @category Collection
             * @param {Array|Object} collection The collection to inspect.
             * @param {Function} [predicate=_.identity] The function invoked per iteration.
             * @param {number} [fromIndex=0] The index to search from.
             * @returns {*} Returns the matched element, else `undefined`.
             * @example
             *
             * var users = [
             *   { 'user': 'barney',  'age': 36, 'active': true },
             *   { 'user': 'fred',    'age': 40, 'active': false },
             *   { 'user': 'pebbles', 'age': 1,  'active': true }
             * ];
             *
             * _.find(users, function(o) { return o.age < 40; });
             * // => object for 'barney'
             *
             * // The `_.matches` iteratee shorthand.
             * _.find(users, { 'age': 1, 'active': true });
             * // => object for 'pebbles'
             *
             * // The `_.matchesProperty` iteratee shorthand.
             * _.find(users, ['active', false]);
             * // => object for 'fred'
             *
             * // The `_.property` iteratee shorthand.
             * _.find(users, 'active');
             * // => object for 'barney'
             */
            var find$5 = _createFind(findIndex_1);

            var find_1 = find$5;

            /**
             * The base implementation of `_.slice` without an iteratee call guard.
             *
             * @private
             * @param {Array} array The array to slice.
             * @param {number} [start=0] The start position.
             * @param {number} [end=array.length] The end position.
             * @returns {Array} Returns the slice of `array`.
             */
            function baseSlice$1(array, start, end) {
              var index = -1,
                  length = array.length;

              if (start < 0) {
                start = -start > length ? 0 : (length + start);
              }
              end = end > length ? length : end;
              if (end < 0) {
                end += length;
              }
              length = start > end ? 0 : ((end - start) >>> 0);
              start >>>= 0;

              var result = Array(length);
              while (++index < length) {
                result[index] = array[index + start];
              }
              return result;
            }

            var _baseSlice = baseSlice$1;

            /**
             * Casts `array` to a slice if it's needed.
             *
             * @private
             * @param {Array} array The array to inspect.
             * @param {number} start The start position.
             * @param {number} [end=array.length] The end position.
             * @returns {Array} Returns the cast slice.
             */
            function castSlice$1(array, start, end) {
              var length = array.length;
              end = end === undefined ? length : end;
              return (!start && end >= length) ? array : _baseSlice(array, start, end);
            }

            var _castSlice = castSlice$1;

            /** Used to compose unicode character classes. */
            var rsAstralRange$4 = '\\ud800-\\udfff',
                rsComboMarksRange$5 = '\\u0300-\\u036f',
                reComboHalfMarksRange$3 = '\\ufe20-\\ufe2f',
                rsComboSymbolsRange$5 = '\\u20d0-\\u20ff',
                rsComboRange$3 = rsComboMarksRange$5 + reComboHalfMarksRange$3 + rsComboSymbolsRange$5,
                rsVarRange$4 = '\\ufe0e\\ufe0f';

            /** Used to compose unicode capture groups. */
            var rsZWJ$4 = '\\u200d';

            /** Used to detect strings with [zero-width joiners or code points from the astral planes](http://eev.ee/blog/2015/09/12/dark-corners-of-unicode/). */
            var reHasUnicode$1 = RegExp('[' + rsZWJ$4 + rsAstralRange$4  + rsComboRange$3 + rsVarRange$4 + ']');

            /**
             * Checks if `string` contains Unicode symbols.
             *
             * @private
             * @param {string} string The string to inspect.
             * @returns {boolean} Returns `true` if a symbol is found, else `false`.
             */
            function hasUnicode$1(string) {
              return reHasUnicode$1.test(string);
            }

            var _hasUnicode = hasUnicode$1;

            /**
             * Converts an ASCII `string` to an array.
             *
             * @private
             * @param {string} string The string to convert.
             * @returns {Array} Returns the converted array.
             */
            function asciiToArray$1(string) {
              return string.split('');
            }

            var _asciiToArray = asciiToArray$1;

            /** Used to compose unicode character classes. */
            var rsAstralRange$3 = '\\ud800-\\udfff',
                rsComboMarksRange$4 = '\\u0300-\\u036f',
                reComboHalfMarksRange$2 = '\\ufe20-\\ufe2f',
                rsComboSymbolsRange$4 = '\\u20d0-\\u20ff',
                rsComboRange$2 = rsComboMarksRange$4 + reComboHalfMarksRange$2 + rsComboSymbolsRange$4,
                rsVarRange$3 = '\\ufe0e\\ufe0f';

            /** Used to compose unicode capture groups. */
            var rsAstral$1 = '[' + rsAstralRange$3 + ']',
                rsCombo$4 = '[' + rsComboRange$2 + ']',
                rsFitz$3 = '\\ud83c[\\udffb-\\udfff]',
                rsModifier$3 = '(?:' + rsCombo$4 + '|' + rsFitz$3 + ')',
                rsNonAstral$3 = '[^' + rsAstralRange$3 + ']',
                rsRegional$3 = '(?:\\ud83c[\\udde6-\\uddff]){2}',
                rsSurrPair$3 = '[\\ud800-\\udbff][\\udc00-\\udfff]',
                rsZWJ$3 = '\\u200d';

            /** Used to compose unicode regexes. */
            var reOptMod$3 = rsModifier$3 + '?',
                rsOptVar$3 = '[' + rsVarRange$3 + ']?',
                rsOptJoin$3 = '(?:' + rsZWJ$3 + '(?:' + [rsNonAstral$3, rsRegional$3, rsSurrPair$3].join('|') + ')' + rsOptVar$3 + reOptMod$3 + ')*',
                rsSeq$3 = rsOptVar$3 + reOptMod$3 + rsOptJoin$3,
                rsSymbol$1 = '(?:' + [rsNonAstral$3 + rsCombo$4 + '?', rsCombo$4, rsRegional$3, rsSurrPair$3, rsAstral$1].join('|') + ')';

            /** Used to match [string symbols](https://mathiasbynens.be/notes/javascript-unicode). */
            var reUnicode$1 = RegExp(rsFitz$3 + '(?=' + rsFitz$3 + ')|' + rsSymbol$1 + rsSeq$3, 'g');

            /**
             * Converts a Unicode `string` to an array.
             *
             * @private
             * @param {string} string The string to convert.
             * @returns {Array} Returns the converted array.
             */
            function unicodeToArray$1(string) {
              return string.match(reUnicode$1) || [];
            }

            var _unicodeToArray = unicodeToArray$1;

            /**
             * Converts `string` to an array.
             *
             * @private
             * @param {string} string The string to convert.
             * @returns {Array} Returns the converted array.
             */
            function stringToArray$1(string) {
              return _hasUnicode(string)
                ? _unicodeToArray(string)
                : _asciiToArray(string);
            }

            var _stringToArray = stringToArray$1;

            /**
             * Creates a function like `_.lowerFirst`.
             *
             * @private
             * @param {string} methodName The name of the `String` case method to use.
             * @returns {Function} Returns the new case function.
             */
            function createCaseFirst$1(methodName) {
              return function(string) {
                string = toString_1(string);

                var strSymbols = _hasUnicode(string)
                  ? _stringToArray(string)
                  : undefined;

                var chr = strSymbols
                  ? strSymbols[0]
                  : string.charAt(0);

                var trailing = strSymbols
                  ? _castSlice(strSymbols, 1).join('')
                  : string.slice(1);

                return chr[methodName]() + trailing;
              };
            }

            var _createCaseFirst = createCaseFirst$1;

            /**
             * Converts the first character of `string` to upper case.
             *
             * @static
             * @memberOf _
             * @since 4.0.0
             * @category String
             * @param {string} [string=''] The string to convert.
             * @returns {string} Returns the converted string.
             * @example
             *
             * _.upperFirst('fred');
             * // => 'Fred'
             *
             * _.upperFirst('FRED');
             * // => 'FRED'
             */
            var upperFirst$1 = _createCaseFirst('toUpperCase');

            var upperFirst_1 = upperFirst$1;

            /**
             * Converts the first character of `string` to upper case and the remaining
             * to lower case.
             *
             * @static
             * @memberOf _
             * @since 3.0.0
             * @category String
             * @param {string} [string=''] The string to capitalize.
             * @returns {string} Returns the capitalized string.
             * @example
             *
             * _.capitalize('FRED');
             * // => 'Fred'
             */
            function capitalize$1(string) {
              return upperFirst_1(toString_1(string).toLowerCase());
            }

            var capitalize_1 = capitalize$1;

            /**
             * A specialized version of `_.reduce` for arrays without support for
             * iteratee shorthands.
             *
             * @private
             * @param {Array} [array] The array to iterate over.
             * @param {Function} iteratee The function invoked per iteration.
             * @param {*} [accumulator] The initial value.
             * @param {boolean} [initAccum] Specify using the first element of `array` as
             *  the initial value.
             * @returns {*} Returns the accumulated value.
             */
            function arrayReduce$2(array, iteratee, accumulator, initAccum) {
              var index = -1,
                  length = array == null ? 0 : array.length;

              if (initAccum && length) {
                accumulator = array[++index];
              }
              while (++index < length) {
                accumulator = iteratee(accumulator, array[index], index, array);
              }
              return accumulator;
            }

            var _arrayReduce = arrayReduce$2;

            /**
             * The base implementation of `_.propertyOf` without support for deep paths.
             *
             * @private
             * @param {Object} object The object to query.
             * @returns {Function} Returns the new accessor function.
             */
            function basePropertyOf$2(object) {
              return function(key) {
                return object == null ? undefined : object[key];
              };
            }

            var _basePropertyOf = basePropertyOf$2;

            /** Used to map Latin Unicode letters to basic Latin letters. */
            var deburredLetters$2 = {
              // Latin-1 Supplement block.
              '\xc0': 'A',  '\xc1': 'A', '\xc2': 'A', '\xc3': 'A', '\xc4': 'A', '\xc5': 'A',
              '\xe0': 'a',  '\xe1': 'a', '\xe2': 'a', '\xe3': 'a', '\xe4': 'a', '\xe5': 'a',
              '\xc7': 'C',  '\xe7': 'c',
              '\xd0': 'D',  '\xf0': 'd',
              '\xc8': 'E',  '\xc9': 'E', '\xca': 'E', '\xcb': 'E',
              '\xe8': 'e',  '\xe9': 'e', '\xea': 'e', '\xeb': 'e',
              '\xcc': 'I',  '\xcd': 'I', '\xce': 'I', '\xcf': 'I',
              '\xec': 'i',  '\xed': 'i', '\xee': 'i', '\xef': 'i',
              '\xd1': 'N',  '\xf1': 'n',
              '\xd2': 'O',  '\xd3': 'O', '\xd4': 'O', '\xd5': 'O', '\xd6': 'O', '\xd8': 'O',
              '\xf2': 'o',  '\xf3': 'o', '\xf4': 'o', '\xf5': 'o', '\xf6': 'o', '\xf8': 'o',
              '\xd9': 'U',  '\xda': 'U', '\xdb': 'U', '\xdc': 'U',
              '\xf9': 'u',  '\xfa': 'u', '\xfb': 'u', '\xfc': 'u',
              '\xdd': 'Y',  '\xfd': 'y', '\xff': 'y',
              '\xc6': 'Ae', '\xe6': 'ae',
              '\xde': 'Th', '\xfe': 'th',
              '\xdf': 'ss',
              // Latin Extended-A block.
              '\u0100': 'A',  '\u0102': 'A', '\u0104': 'A',
              '\u0101': 'a',  '\u0103': 'a', '\u0105': 'a',
              '\u0106': 'C',  '\u0108': 'C', '\u010a': 'C', '\u010c': 'C',
              '\u0107': 'c',  '\u0109': 'c', '\u010b': 'c', '\u010d': 'c',
              '\u010e': 'D',  '\u0110': 'D', '\u010f': 'd', '\u0111': 'd',
              '\u0112': 'E',  '\u0114': 'E', '\u0116': 'E', '\u0118': 'E', '\u011a': 'E',
              '\u0113': 'e',  '\u0115': 'e', '\u0117': 'e', '\u0119': 'e', '\u011b': 'e',
              '\u011c': 'G',  '\u011e': 'G', '\u0120': 'G', '\u0122': 'G',
              '\u011d': 'g',  '\u011f': 'g', '\u0121': 'g', '\u0123': 'g',
              '\u0124': 'H',  '\u0126': 'H', '\u0125': 'h', '\u0127': 'h',
              '\u0128': 'I',  '\u012a': 'I', '\u012c': 'I', '\u012e': 'I', '\u0130': 'I',
              '\u0129': 'i',  '\u012b': 'i', '\u012d': 'i', '\u012f': 'i', '\u0131': 'i',
              '\u0134': 'J',  '\u0135': 'j',
              '\u0136': 'K',  '\u0137': 'k', '\u0138': 'k',
              '\u0139': 'L',  '\u013b': 'L', '\u013d': 'L', '\u013f': 'L', '\u0141': 'L',
              '\u013a': 'l',  '\u013c': 'l', '\u013e': 'l', '\u0140': 'l', '\u0142': 'l',
              '\u0143': 'N',  '\u0145': 'N', '\u0147': 'N', '\u014a': 'N',
              '\u0144': 'n',  '\u0146': 'n', '\u0148': 'n', '\u014b': 'n',
              '\u014c': 'O',  '\u014e': 'O', '\u0150': 'O',
              '\u014d': 'o',  '\u014f': 'o', '\u0151': 'o',
              '\u0154': 'R',  '\u0156': 'R', '\u0158': 'R',
              '\u0155': 'r',  '\u0157': 'r', '\u0159': 'r',
              '\u015a': 'S',  '\u015c': 'S', '\u015e': 'S', '\u0160': 'S',
              '\u015b': 's',  '\u015d': 's', '\u015f': 's', '\u0161': 's',
              '\u0162': 'T',  '\u0164': 'T', '\u0166': 'T',
              '\u0163': 't',  '\u0165': 't', '\u0167': 't',
              '\u0168': 'U',  '\u016a': 'U', '\u016c': 'U', '\u016e': 'U', '\u0170': 'U', '\u0172': 'U',
              '\u0169': 'u',  '\u016b': 'u', '\u016d': 'u', '\u016f': 'u', '\u0171': 'u', '\u0173': 'u',
              '\u0174': 'W',  '\u0175': 'w',
              '\u0176': 'Y',  '\u0177': 'y', '\u0178': 'Y',
              '\u0179': 'Z',  '\u017b': 'Z', '\u017d': 'Z',
              '\u017a': 'z',  '\u017c': 'z', '\u017e': 'z',
              '\u0132': 'IJ', '\u0133': 'ij',
              '\u0152': 'Oe', '\u0153': 'oe',
              '\u0149': "'n", '\u017f': 's'
            };

            /**
             * Used by `_.deburr` to convert Latin-1 Supplement and Latin Extended-A
             * letters to basic Latin letters.
             *
             * @private
             * @param {string} letter The matched letter to deburr.
             * @returns {string} Returns the deburred letter.
             */
            var deburrLetter$2 = _basePropertyOf(deburredLetters$2);

            var _deburrLetter = deburrLetter$2;

            /** Used to match Latin Unicode letters (excluding mathematical operators). */
            var reLatin$2 = /[\xc0-\xd6\xd8-\xf6\xf8-\xff\u0100-\u017f]/g;

            /** Used to compose unicode character classes. */
            var rsComboMarksRange$3 = '\\u0300-\\u036f',
                reComboHalfMarksRange$1 = '\\ufe20-\\ufe2f',
                rsComboSymbolsRange$3 = '\\u20d0-\\u20ff',
                rsComboRange$1 = rsComboMarksRange$3 + reComboHalfMarksRange$1 + rsComboSymbolsRange$3;

            /** Used to compose unicode capture groups. */
            var rsCombo$3 = '[' + rsComboRange$1 + ']';

            /**
             * Used to match [combining diacritical marks](https://en.wikipedia.org/wiki/Combining_Diacritical_Marks) and
             * [combining diacritical marks for symbols](https://en.wikipedia.org/wiki/Combining_Diacritical_Marks_for_Symbols).
             */
            var reComboMark$2 = RegExp(rsCombo$3, 'g');

            /**
             * Deburrs `string` by converting
             * [Latin-1 Supplement](https://en.wikipedia.org/wiki/Latin-1_Supplement_(Unicode_block)#Character_table)
             * and [Latin Extended-A](https://en.wikipedia.org/wiki/Latin_Extended-A)
             * letters to basic Latin letters and removing
             * [combining diacritical marks](https://en.wikipedia.org/wiki/Combining_Diacritical_Marks).
             *
             * @static
             * @memberOf _
             * @since 3.0.0
             * @category String
             * @param {string} [string=''] The string to deburr.
             * @returns {string} Returns the deburred string.
             * @example
             *
             * _.deburr('déjà vu');
             * // => 'deja vu'
             */
            function deburr$2(string) {
              string = toString_1(string);
              return string && string.replace(reLatin$2, _deburrLetter).replace(reComboMark$2, '');
            }

            var deburr_1 = deburr$2;

            /** Used to match words composed of alphanumeric characters. */
            var reAsciiWord$2 = /[^\x00-\x2f\x3a-\x40\x5b-\x60\x7b-\x7f]+/g;

            /**
             * Splits an ASCII `string` into an array of its words.
             *
             * @private
             * @param {string} The string to inspect.
             * @returns {Array} Returns the words of `string`.
             */
            function asciiWords$2(string) {
              return string.match(reAsciiWord$2) || [];
            }

            var _asciiWords = asciiWords$2;

            /** Used to detect strings that need a more robust regexp to match words. */
            var reHasUnicodeWord$2 = /[a-z][A-Z]|[A-Z]{2}[a-z]|[0-9][a-zA-Z]|[a-zA-Z][0-9]|[^a-zA-Z0-9 ]/;

            /**
             * Checks if `string` contains a word composed of Unicode symbols.
             *
             * @private
             * @param {string} string The string to inspect.
             * @returns {boolean} Returns `true` if a word is found, else `false`.
             */
            function hasUnicodeWord$2(string) {
              return reHasUnicodeWord$2.test(string);
            }

            var _hasUnicodeWord = hasUnicodeWord$2;

            /** Used to compose unicode character classes. */
            var rsAstralRange$2 = '\\ud800-\\udfff',
                rsComboMarksRange$2 = '\\u0300-\\u036f',
                reComboHalfMarksRange = '\\ufe20-\\ufe2f',
                rsComboSymbolsRange$2 = '\\u20d0-\\u20ff',
                rsComboRange = rsComboMarksRange$2 + reComboHalfMarksRange + rsComboSymbolsRange$2,
                rsDingbatRange$2 = '\\u2700-\\u27bf',
                rsLowerRange$2 = 'a-z\\xdf-\\xf6\\xf8-\\xff',
                rsMathOpRange$2 = '\\xac\\xb1\\xd7\\xf7',
                rsNonCharRange$2 = '\\x00-\\x2f\\x3a-\\x40\\x5b-\\x60\\x7b-\\xbf',
                rsPunctuationRange$2 = '\\u2000-\\u206f',
                rsSpaceRange$2 = ' \\t\\x0b\\f\\xa0\\ufeff\\n\\r\\u2028\\u2029\\u1680\\u180e\\u2000\\u2001\\u2002\\u2003\\u2004\\u2005\\u2006\\u2007\\u2008\\u2009\\u200a\\u202f\\u205f\\u3000',
                rsUpperRange$2 = 'A-Z\\xc0-\\xd6\\xd8-\\xde',
                rsVarRange$2 = '\\ufe0e\\ufe0f',
                rsBreakRange$2 = rsMathOpRange$2 + rsNonCharRange$2 + rsPunctuationRange$2 + rsSpaceRange$2;

            /** Used to compose unicode capture groups. */
            var rsApos$3 = "['\u2019]",
                rsBreak$2 = '[' + rsBreakRange$2 + ']',
                rsCombo$2 = '[' + rsComboRange + ']',
                rsDigits$2 = '\\d+',
                rsDingbat$2 = '[' + rsDingbatRange$2 + ']',
                rsLower$2 = '[' + rsLowerRange$2 + ']',
                rsMisc$2 = '[^' + rsAstralRange$2 + rsBreakRange$2 + rsDigits$2 + rsDingbatRange$2 + rsLowerRange$2 + rsUpperRange$2 + ']',
                rsFitz$2 = '\\ud83c[\\udffb-\\udfff]',
                rsModifier$2 = '(?:' + rsCombo$2 + '|' + rsFitz$2 + ')',
                rsNonAstral$2 = '[^' + rsAstralRange$2 + ']',
                rsRegional$2 = '(?:\\ud83c[\\udde6-\\uddff]){2}',
                rsSurrPair$2 = '[\\ud800-\\udbff][\\udc00-\\udfff]',
                rsUpper$2 = '[' + rsUpperRange$2 + ']',
                rsZWJ$2 = '\\u200d';

            /** Used to compose unicode regexes. */
            var rsMiscLower = '(?:' + rsLower$2 + '|' + rsMisc$2 + ')',
                rsMiscUpper = '(?:' + rsUpper$2 + '|' + rsMisc$2 + ')',
                rsOptContrLower = '(?:' + rsApos$3 + '(?:d|ll|m|re|s|t|ve))?',
                rsOptContrUpper = '(?:' + rsApos$3 + '(?:D|LL|M|RE|S|T|VE))?',
                reOptMod$2 = rsModifier$2 + '?',
                rsOptVar$2 = '[' + rsVarRange$2 + ']?',
                rsOptJoin$2 = '(?:' + rsZWJ$2 + '(?:' + [rsNonAstral$2, rsRegional$2, rsSurrPair$2].join('|') + ')' + rsOptVar$2 + reOptMod$2 + ')*',
                rsOrdLower = '\\d*(?:1st|2nd|3rd|(?![123])\\dth)(?=\\b|[A-Z_])',
                rsOrdUpper = '\\d*(?:1ST|2ND|3RD|(?![123])\\dTH)(?=\\b|[a-z_])',
                rsSeq$2 = rsOptVar$2 + reOptMod$2 + rsOptJoin$2,
                rsEmoji$2 = '(?:' + [rsDingbat$2, rsRegional$2, rsSurrPair$2].join('|') + ')' + rsSeq$2;

            /** Used to match complex or compound words. */
            var reUnicodeWord$2 = RegExp([
              rsUpper$2 + '?' + rsLower$2 + '+' + rsOptContrLower + '(?=' + [rsBreak$2, rsUpper$2, '$'].join('|') + ')',
              rsMiscUpper + '+' + rsOptContrUpper + '(?=' + [rsBreak$2, rsUpper$2 + rsMiscLower, '$'].join('|') + ')',
              rsUpper$2 + '?' + rsMiscLower + '+' + rsOptContrLower,
              rsUpper$2 + '+' + rsOptContrUpper,
              rsOrdUpper,
              rsOrdLower,
              rsDigits$2,
              rsEmoji$2
            ].join('|'), 'g');

            /**
             * Splits a Unicode `string` into an array of its words.
             *
             * @private
             * @param {string} The string to inspect.
             * @returns {Array} Returns the words of `string`.
             */
            function unicodeWords$2(string) {
              return string.match(reUnicodeWord$2) || [];
            }

            var _unicodeWords = unicodeWords$2;

            /**
             * Splits `string` into an array of its words.
             *
             * @static
             * @memberOf _
             * @since 3.0.0
             * @category String
             * @param {string} [string=''] The string to inspect.
             * @param {RegExp|string} [pattern] The pattern to match words.
             * @param- {Object} [guard] Enables use as an iteratee for methods like `_.map`.
             * @returns {Array} Returns the words of `string`.
             * @example
             *
             * _.words('fred, barney, & pebbles');
             * // => ['fred', 'barney', 'pebbles']
             *
             * _.words('fred, barney, & pebbles', /[^, ]+/g);
             * // => ['fred', 'barney', '&', 'pebbles']
             */
            function words$2(string, pattern, guard) {
              string = toString_1(string);
              pattern = guard ? undefined : pattern;

              if (pattern === undefined) {
                return _hasUnicodeWord(string) ? _unicodeWords(string) : _asciiWords(string);
              }
              return string.match(pattern) || [];
            }

            var words_1 = words$2;

            /** Used to compose unicode capture groups. */
            var rsApos$2 = "['\u2019]";

            /** Used to match apostrophes. */
            var reApos$2 = RegExp(rsApos$2, 'g');

            /**
             * Creates a function like `_.camelCase`.
             *
             * @private
             * @param {Function} callback The function to combine each word.
             * @returns {Function} Returns the new compounder function.
             */
            function createCompounder$2(callback) {
              return function(string) {
                return _arrayReduce(words_1(deburr_1(string).replace(reApos$2, '')), callback, '');
              };
            }

            var _createCompounder = createCompounder$2;

            /**
             * Converts `string` to [camel case](https://en.wikipedia.org/wiki/CamelCase).
             *
             * @static
             * @memberOf _
             * @since 3.0.0
             * @category String
             * @param {string} [string=''] The string to convert.
             * @returns {string} Returns the camel cased string.
             * @example
             *
             * _.camelCase('Foo Bar');
             * // => 'fooBar'
             *
             * _.camelCase('--foo-bar--');
             * // => 'fooBar'
             *
             * _.camelCase('__FOO_BAR__');
             * // => 'fooBar'
             */
            var camelCase$1 = _createCompounder(function(result, word, index) {
              word = word.toLowerCase();
              return result + (index ? capitalize_1(word) : word);
            });

            var camelCase_1 = camelCase$1;

            /**
             * Converts `string` to
             * [snake case](https://en.wikipedia.org/wiki/Snake_case).
             *
             * @static
             * @memberOf _
             * @since 3.0.0
             * @category String
             * @param {string} [string=''] The string to convert.
             * @returns {string} Returns the snake cased string.
             * @example
             *
             * _.snakeCase('Foo Bar');
             * // => 'foo_bar'
             *
             * _.snakeCase('fooBar');
             * // => 'foo_bar'
             *
             * _.snakeCase('--FOO-BAR--');
             * // => 'foo_bar'
             */
            var snakeCase$1 = _createCompounder(function(result, word, index) {
              return result + (index ? '_' : '') + word.toLowerCase();
            });

            var snakeCase_1 = snakeCase$1;

            /**
             * A specialized version of `_.forEach` for arrays without support for
             * iteratee shorthands.
             *
             * @private
             * @param {Array} [array] The array to iterate over.
             * @param {Function} iteratee The function invoked per iteration.
             * @returns {Array} Returns `array`.
             */
            function arrayEach(array, iteratee) {
              var index = -1,
                  length = array == null ? 0 : array.length;

              while (++index < length) {
                if (iteratee(array[index], index, array) === false) {
                  break;
                }
              }
              return array;
            }

            var _arrayEach = arrayEach;

            /**
             * Copies properties of `source` to `object`.
             *
             * @private
             * @param {Object} source The object to copy properties from.
             * @param {Array} props The property identifiers to copy.
             * @param {Object} [object={}] The object to copy properties to.
             * @param {Function} [customizer] The function to customize copied values.
             * @returns {Object} Returns `object`.
             */
            function copyObject(source, props, object, customizer) {
              var isNew = !object;
              object || (object = {});

              var index = -1,
                  length = props.length;

              while (++index < length) {
                var key = props[index];

                var newValue = customizer
                  ? customizer(object[key], source[key], key, object, source)
                  : undefined;

                if (newValue === undefined) {
                  newValue = source[key];
                }
                if (isNew) {
                  _baseAssignValue(object, key, newValue);
                } else {
                  _assignValue(object, key, newValue);
                }
              }
              return object;
            }

            var _copyObject = copyObject;

            /**
             * The base implementation of `_.assign` without support for multiple sources
             * or `customizer` functions.
             *
             * @private
             * @param {Object} object The destination object.
             * @param {Object} source The source object.
             * @returns {Object} Returns `object`.
             */
            function baseAssign(object, source) {
              return object && _copyObject(source, keys_1(source), object);
            }

            var _baseAssign = baseAssign;

            /**
             * This function is like
             * [`Object.keys`](http://ecma-international.org/ecma-262/7.0/#sec-object.keys)
             * except that it includes inherited enumerable properties.
             *
             * @private
             * @param {Object} object The object to query.
             * @returns {Array} Returns the array of property names.
             */
            function nativeKeysIn(object) {
              var result = [];
              if (object != null) {
                for (var key in Object(object)) {
                  result.push(key);
                }
              }
              return result;
            }

            var _nativeKeysIn = nativeKeysIn;

            /** Used for built-in method references. */
            var objectProto$4 = Object.prototype;

            /** Used to check objects for own properties. */
            var hasOwnProperty$4 = objectProto$4.hasOwnProperty;

            /**
             * The base implementation of `_.keysIn` which doesn't treat sparse arrays as dense.
             *
             * @private
             * @param {Object} object The object to query.
             * @returns {Array} Returns the array of property names.
             */
            function baseKeysIn(object) {
              if (!isObject_1(object)) {
                return _nativeKeysIn(object);
              }
              var isProto = _isPrototype(object),
                  result = [];

              for (var key in object) {
                if (!(key == 'constructor' && (isProto || !hasOwnProperty$4.call(object, key)))) {
                  result.push(key);
                }
              }
              return result;
            }

            var _baseKeysIn = baseKeysIn;

            /**
             * Creates an array of the own and inherited enumerable property names of `object`.
             *
             * **Note:** Non-object values are coerced to objects.
             *
             * @static
             * @memberOf _
             * @since 3.0.0
             * @category Object
             * @param {Object} object The object to query.
             * @returns {Array} Returns the array of property names.
             * @example
             *
             * function Foo() {
             *   this.a = 1;
             *   this.b = 2;
             * }
             *
             * Foo.prototype.c = 3;
             *
             * _.keysIn(new Foo);
             * // => ['a', 'b', 'c'] (iteration order is not guaranteed)
             */
            function keysIn(object) {
              return isArrayLike_1(object) ? _arrayLikeKeys(object, true) : _baseKeysIn(object);
            }

            var keysIn_1 = keysIn;

            /**
             * The base implementation of `_.assignIn` without support for multiple sources
             * or `customizer` functions.
             *
             * @private
             * @param {Object} object The destination object.
             * @param {Object} source The source object.
             * @returns {Object} Returns `object`.
             */
            function baseAssignIn(object, source) {
              return object && _copyObject(source, keysIn_1(source), object);
            }

            var _baseAssignIn = baseAssignIn;

            var _cloneBuffer = createCommonjsModule(function (module, exports) {
            /** Detect free variable `exports`. */
            var freeExports = exports && !exports.nodeType && exports;

            /** Detect free variable `module`. */
            var freeModule = freeExports && 'object' == 'object' && module && !module.nodeType && module;

            /** Detect the popular CommonJS extension `module.exports`. */
            var moduleExports = freeModule && freeModule.exports === freeExports;

            /** Built-in value references. */
            var Buffer = moduleExports ? _root.Buffer : undefined,
                allocUnsafe = Buffer ? Buffer.allocUnsafe : undefined;

            /**
             * Creates a clone of  `buffer`.
             *
             * @private
             * @param {Buffer} buffer The buffer to clone.
             * @param {boolean} [isDeep] Specify a deep clone.
             * @returns {Buffer} Returns the cloned buffer.
             */
            function cloneBuffer(buffer, isDeep) {
              if (isDeep) {
                return buffer.slice();
              }
              var length = buffer.length,
                  result = allocUnsafe ? allocUnsafe(length) : new buffer.constructor(length);

              buffer.copy(result);
              return result;
            }

            module.exports = cloneBuffer;
            });

            /**
             * Copies the values of `source` to `array`.
             *
             * @private
             * @param {Array} source The array to copy values from.
             * @param {Array} [array=[]] The array to copy values to.
             * @returns {Array} Returns `array`.
             */
            function copyArray(source, array) {
              var index = -1,
                  length = source.length;

              array || (array = Array(length));
              while (++index < length) {
                array[index] = source[index];
              }
              return array;
            }

            var _copyArray = copyArray;

            /**
             * Copies own symbols of `source` to `object`.
             *
             * @private
             * @param {Object} source The object to copy symbols from.
             * @param {Object} [object={}] The object to copy symbols to.
             * @returns {Object} Returns `object`.
             */
            function copySymbols(source, object) {
              return _copyObject(source, _getSymbols(source), object);
            }

            var _copySymbols = copySymbols;

            /** Built-in value references. */
            var getPrototype = _overArg(Object.getPrototypeOf, Object);

            var _getPrototype = getPrototype;

            /* Built-in method references for those with the same name as other `lodash` methods. */
            var nativeGetSymbols = Object.getOwnPropertySymbols;

            /**
             * Creates an array of the own and inherited enumerable symbols of `object`.
             *
             * @private
             * @param {Object} object The object to query.
             * @returns {Array} Returns the array of symbols.
             */
            var getSymbolsIn = !nativeGetSymbols ? stubArray_1 : function(object) {
              var result = [];
              while (object) {
                _arrayPush(result, _getSymbols(object));
                object = _getPrototype(object);
              }
              return result;
            };

            var _getSymbolsIn = getSymbolsIn;

            /**
             * Copies own and inherited symbols of `source` to `object`.
             *
             * @private
             * @param {Object} source The object to copy symbols from.
             * @param {Object} [object={}] The object to copy symbols to.
             * @returns {Object} Returns `object`.
             */
            function copySymbolsIn(source, object) {
              return _copyObject(source, _getSymbolsIn(source), object);
            }

            var _copySymbolsIn = copySymbolsIn;

            /**
             * Creates an array of own and inherited enumerable property names and
             * symbols of `object`.
             *
             * @private
             * @param {Object} object The object to query.
             * @returns {Array} Returns the array of property names and symbols.
             */
            function getAllKeysIn(object) {
              return _baseGetAllKeys(object, keysIn_1, _getSymbolsIn);
            }

            var _getAllKeysIn = getAllKeysIn;

            /** Used for built-in method references. */
            var objectProto$3 = Object.prototype;

            /** Used to check objects for own properties. */
            var hasOwnProperty$3 = objectProto$3.hasOwnProperty;

            /**
             * Initializes an array clone.
             *
             * @private
             * @param {Array} array The array to clone.
             * @returns {Array} Returns the initialized clone.
             */
            function initCloneArray(array) {
              var length = array.length,
                  result = new array.constructor(length);

              // Add properties assigned by `RegExp#exec`.
              if (length && typeof array[0] == 'string' && hasOwnProperty$3.call(array, 'index')) {
                result.index = array.index;
                result.input = array.input;
              }
              return result;
            }

            var _initCloneArray = initCloneArray;

            /**
             * Creates a clone of `arrayBuffer`.
             *
             * @private
             * @param {ArrayBuffer} arrayBuffer The array buffer to clone.
             * @returns {ArrayBuffer} Returns the cloned array buffer.
             */
            function cloneArrayBuffer(arrayBuffer) {
              var result = new arrayBuffer.constructor(arrayBuffer.byteLength);
              new _Uint8Array(result).set(new _Uint8Array(arrayBuffer));
              return result;
            }

            var _cloneArrayBuffer = cloneArrayBuffer;

            /**
             * Creates a clone of `dataView`.
             *
             * @private
             * @param {Object} dataView The data view to clone.
             * @param {boolean} [isDeep] Specify a deep clone.
             * @returns {Object} Returns the cloned data view.
             */
            function cloneDataView(dataView, isDeep) {
              var buffer = isDeep ? _cloneArrayBuffer(dataView.buffer) : dataView.buffer;
              return new dataView.constructor(buffer, dataView.byteOffset, dataView.byteLength);
            }

            var _cloneDataView = cloneDataView;

            /** Used to match `RegExp` flags from their coerced string values. */
            var reFlags = /\w*$/;

            /**
             * Creates a clone of `regexp`.
             *
             * @private
             * @param {Object} regexp The regexp to clone.
             * @returns {Object} Returns the cloned regexp.
             */
            function cloneRegExp(regexp) {
              var result = new regexp.constructor(regexp.source, reFlags.exec(regexp));
              result.lastIndex = regexp.lastIndex;
              return result;
            }

            var _cloneRegExp = cloneRegExp;

            /** Used to convert symbols to primitives and strings. */
            var symbolProto$2 = _Symbol ? _Symbol.prototype : undefined,
                symbolValueOf = symbolProto$2 ? symbolProto$2.valueOf : undefined;

            /**
             * Creates a clone of the `symbol` object.
             *
             * @private
             * @param {Object} symbol The symbol object to clone.
             * @returns {Object} Returns the cloned symbol object.
             */
            function cloneSymbol(symbol) {
              return symbolValueOf ? Object(symbolValueOf.call(symbol)) : {};
            }

            var _cloneSymbol = cloneSymbol;

            /**
             * Creates a clone of `typedArray`.
             *
             * @private
             * @param {Object} typedArray The typed array to clone.
             * @param {boolean} [isDeep] Specify a deep clone.
             * @returns {Object} Returns the cloned typed array.
             */
            function cloneTypedArray(typedArray, isDeep) {
              var buffer = isDeep ? _cloneArrayBuffer(typedArray.buffer) : typedArray.buffer;
              return new typedArray.constructor(buffer, typedArray.byteOffset, typedArray.length);
            }

            var _cloneTypedArray = cloneTypedArray;

            /** `Object#toString` result references. */
            var boolTag$1 = '[object Boolean]',
                dateTag$1 = '[object Date]',
                mapTag$3 = '[object Map]',
                numberTag$1 = '[object Number]',
                regexpTag$1 = '[object RegExp]',
                setTag$3 = '[object Set]',
                stringTag$1 = '[object String]',
                symbolTag$3 = '[object Symbol]';

            var arrayBufferTag$1 = '[object ArrayBuffer]',
                dataViewTag$1 = '[object DataView]',
                float32Tag$1 = '[object Float32Array]',
                float64Tag$1 = '[object Float64Array]',
                int8Tag$1 = '[object Int8Array]',
                int16Tag$1 = '[object Int16Array]',
                int32Tag$1 = '[object Int32Array]',
                uint8Tag$1 = '[object Uint8Array]',
                uint8ClampedTag$1 = '[object Uint8ClampedArray]',
                uint16Tag$1 = '[object Uint16Array]',
                uint32Tag$1 = '[object Uint32Array]';

            /**
             * Initializes an object clone based on its `toStringTag`.
             *
             * **Note:** This function only supports cloning values with tags of
             * `Boolean`, `Date`, `Error`, `Map`, `Number`, `RegExp`, `Set`, or `String`.
             *
             * @private
             * @param {Object} object The object to clone.
             * @param {string} tag The `toStringTag` of the object to clone.
             * @param {boolean} [isDeep] Specify a deep clone.
             * @returns {Object} Returns the initialized clone.
             */
            function initCloneByTag(object, tag, isDeep) {
              var Ctor = object.constructor;
              switch (tag) {
                case arrayBufferTag$1:
                  return _cloneArrayBuffer(object);

                case boolTag$1:
                case dateTag$1:
                  return new Ctor(+object);

                case dataViewTag$1:
                  return _cloneDataView(object, isDeep);

                case float32Tag$1: case float64Tag$1:
                case int8Tag$1: case int16Tag$1: case int32Tag$1:
                case uint8Tag$1: case uint8ClampedTag$1: case uint16Tag$1: case uint32Tag$1:
                  return _cloneTypedArray(object, isDeep);

                case mapTag$3:
                  return new Ctor;

                case numberTag$1:
                case stringTag$1:
                  return new Ctor(object);

                case regexpTag$1:
                  return _cloneRegExp(object);

                case setTag$3:
                  return new Ctor;

                case symbolTag$3:
                  return _cloneSymbol(object);
              }
            }

            var _initCloneByTag = initCloneByTag;

            /** Built-in value references. */
            var objectCreate = Object.create;

            /**
             * The base implementation of `_.create` without support for assigning
             * properties to the created object.
             *
             * @private
             * @param {Object} proto The object to inherit from.
             * @returns {Object} Returns the new object.
             */
            var baseCreate = (function() {
              function object() {}
              return function(proto) {
                if (!isObject_1(proto)) {
                  return {};
                }
                if (objectCreate) {
                  return objectCreate(proto);
                }
                object.prototype = proto;
                var result = new object;
                object.prototype = undefined;
                return result;
              };
            }());

            var _baseCreate = baseCreate;

            /**
             * Initializes an object clone.
             *
             * @private
             * @param {Object} object The object to clone.
             * @returns {Object} Returns the initialized clone.
             */
            function initCloneObject(object) {
              return (typeof object.constructor == 'function' && !_isPrototype(object))
                ? _baseCreate(_getPrototype(object))
                : {};
            }

            var _initCloneObject = initCloneObject;

            /** `Object#toString` result references. */
            var mapTag$2 = '[object Map]';

            /**
             * The base implementation of `_.isMap` without Node.js optimizations.
             *
             * @private
             * @param {*} value The value to check.
             * @returns {boolean} Returns `true` if `value` is a map, else `false`.
             */
            function baseIsMap(value) {
              return isObjectLike_1(value) && _getTag(value) == mapTag$2;
            }

            var _baseIsMap = baseIsMap;

            /* Node.js helper references. */
            var nodeIsMap = _nodeUtil && _nodeUtil.isMap;

            /**
             * Checks if `value` is classified as a `Map` object.
             *
             * @static
             * @memberOf _
             * @since 4.3.0
             * @category Lang
             * @param {*} value The value to check.
             * @returns {boolean} Returns `true` if `value` is a map, else `false`.
             * @example
             *
             * _.isMap(new Map);
             * // => true
             *
             * _.isMap(new WeakMap);
             * // => false
             */
            var isMap = nodeIsMap ? _baseUnary(nodeIsMap) : _baseIsMap;

            var isMap_1 = isMap;

            /** `Object#toString` result references. */
            var setTag$2 = '[object Set]';

            /**
             * The base implementation of `_.isSet` without Node.js optimizations.
             *
             * @private
             * @param {*} value The value to check.
             * @returns {boolean} Returns `true` if `value` is a set, else `false`.
             */
            function baseIsSet(value) {
              return isObjectLike_1(value) && _getTag(value) == setTag$2;
            }

            var _baseIsSet = baseIsSet;

            /* Node.js helper references. */
            var nodeIsSet = _nodeUtil && _nodeUtil.isSet;

            /**
             * Checks if `value` is classified as a `Set` object.
             *
             * @static
             * @memberOf _
             * @since 4.3.0
             * @category Lang
             * @param {*} value The value to check.
             * @returns {boolean} Returns `true` if `value` is a set, else `false`.
             * @example
             *
             * _.isSet(new Set);
             * // => true
             *
             * _.isSet(new WeakSet);
             * // => false
             */
            var isSet = nodeIsSet ? _baseUnary(nodeIsSet) : _baseIsSet;

            var isSet_1 = isSet;

            /** Used to compose bitmasks for cloning. */
            var CLONE_DEEP_FLAG$1 = 1,
                CLONE_FLAT_FLAG = 2,
                CLONE_SYMBOLS_FLAG$1 = 4;

            /** `Object#toString` result references. */
            var argsTag = '[object Arguments]',
                arrayTag = '[object Array]',
                boolTag = '[object Boolean]',
                dateTag = '[object Date]',
                errorTag = '[object Error]',
                funcTag = '[object Function]',
                genTag = '[object GeneratorFunction]',
                mapTag$1 = '[object Map]',
                numberTag = '[object Number]',
                objectTag = '[object Object]',
                regexpTag = '[object RegExp]',
                setTag$1 = '[object Set]',
                stringTag = '[object String]',
                symbolTag$2 = '[object Symbol]',
                weakMapTag = '[object WeakMap]';

            var arrayBufferTag = '[object ArrayBuffer]',
                dataViewTag = '[object DataView]',
                float32Tag = '[object Float32Array]',
                float64Tag = '[object Float64Array]',
                int8Tag = '[object Int8Array]',
                int16Tag = '[object Int16Array]',
                int32Tag = '[object Int32Array]',
                uint8Tag = '[object Uint8Array]',
                uint8ClampedTag = '[object Uint8ClampedArray]',
                uint16Tag = '[object Uint16Array]',
                uint32Tag = '[object Uint32Array]';

            /** Used to identify `toStringTag` values supported by `_.clone`. */
            var cloneableTags = {};
            cloneableTags[argsTag] = cloneableTags[arrayTag] =
            cloneableTags[arrayBufferTag] = cloneableTags[dataViewTag] =
            cloneableTags[boolTag] = cloneableTags[dateTag] =
            cloneableTags[float32Tag] = cloneableTags[float64Tag] =
            cloneableTags[int8Tag] = cloneableTags[int16Tag] =
            cloneableTags[int32Tag] = cloneableTags[mapTag$1] =
            cloneableTags[numberTag] = cloneableTags[objectTag] =
            cloneableTags[regexpTag] = cloneableTags[setTag$1] =
            cloneableTags[stringTag] = cloneableTags[symbolTag$2] =
            cloneableTags[uint8Tag] = cloneableTags[uint8ClampedTag] =
            cloneableTags[uint16Tag] = cloneableTags[uint32Tag] = true;
            cloneableTags[errorTag] = cloneableTags[funcTag] =
            cloneableTags[weakMapTag] = false;

            /**
             * The base implementation of `_.clone` and `_.cloneDeep` which tracks
             * traversed objects.
             *
             * @private
             * @param {*} value The value to clone.
             * @param {boolean} bitmask The bitmask flags.
             *  1 - Deep clone
             *  2 - Flatten inherited properties
             *  4 - Clone symbols
             * @param {Function} [customizer] The function to customize cloning.
             * @param {string} [key] The key of `value`.
             * @param {Object} [object] The parent object of `value`.
             * @param {Object} [stack] Tracks traversed objects and their clone counterparts.
             * @returns {*} Returns the cloned value.
             */
            function baseClone(value, bitmask, customizer, key, object, stack) {
              var result,
                  isDeep = bitmask & CLONE_DEEP_FLAG$1,
                  isFlat = bitmask & CLONE_FLAT_FLAG,
                  isFull = bitmask & CLONE_SYMBOLS_FLAG$1;

              if (customizer) {
                result = object ? customizer(value, key, object, stack) : customizer(value);
              }
              if (result !== undefined) {
                return result;
              }
              if (!isObject_1(value)) {
                return value;
              }
              var isArr = isArray_1(value);
              if (isArr) {
                result = _initCloneArray(value);
                if (!isDeep) {
                  return _copyArray(value, result);
                }
              } else {
                var tag = _getTag(value),
                    isFunc = tag == funcTag || tag == genTag;

                if (isBuffer_1(value)) {
                  return _cloneBuffer(value, isDeep);
                }
                if (tag == objectTag || tag == argsTag || (isFunc && !object)) {
                  result = (isFlat || isFunc) ? {} : _initCloneObject(value);
                  if (!isDeep) {
                    return isFlat
                      ? _copySymbolsIn(value, _baseAssignIn(result, value))
                      : _copySymbols(value, _baseAssign(result, value));
                  }
                } else {
                  if (!cloneableTags[tag]) {
                    return object ? value : {};
                  }
                  result = _initCloneByTag(value, tag, isDeep);
                }
              }
              // Check for circular references and return its corresponding clone.
              stack || (stack = new _Stack);
              var stacked = stack.get(value);
              if (stacked) {
                return stacked;
              }
              stack.set(value, result);

              if (isSet_1(value)) {
                value.forEach(function(subValue) {
                  result.add(baseClone(subValue, bitmask, customizer, subValue, value, stack));
                });
              } else if (isMap_1(value)) {
                value.forEach(function(subValue, key) {
                  result.set(key, baseClone(subValue, bitmask, customizer, key, value, stack));
                });
              }

              var keysFunc = isFull
                ? (isFlat ? _getAllKeysIn : _getAllKeys)
                : (isFlat ? keysIn_1 : keys_1);

              var props = isArr ? undefined : keysFunc(value);
              _arrayEach(props || value, function(subValue, key) {
                if (props) {
                  key = subValue;
                  subValue = value[key];
                }
                // Recursively populate clone (susceptible to call stack limits).
                _assignValue(result, key, baseClone(subValue, bitmask, customizer, key, value, stack));
              });
              return result;
            }

            var _baseClone = baseClone;

            /** Used to compose bitmasks for cloning. */
            var CLONE_DEEP_FLAG = 1,
                CLONE_SYMBOLS_FLAG = 4;

            /**
             * This method is like `_.clone` except that it recursively clones `value`.
             *
             * @static
             * @memberOf _
             * @since 1.0.0
             * @category Lang
             * @param {*} value The value to recursively clone.
             * @returns {*} Returns the deep cloned value.
             * @see _.clone
             * @example
             *
             * var objects = [{ 'a': 1 }, { 'b': 2 }];
             *
             * var deep = _.cloneDeep(objects);
             * console.log(deep[0] === objects[0]);
             * // => false
             */
            function cloneDeep$2(value) {
              return _baseClone(value, CLONE_DEEP_FLAG | CLONE_SYMBOLS_FLAG);
            }

            var cloneDeep_1 = cloneDeep$2;

            var isMergeableObject = function isMergeableObject(value) {
            	return isNonNullObject(value)
            		&& !isSpecial(value)
            };

            function isNonNullObject(value) {
            	return !!value && typeof value === 'object'
            }

            function isSpecial(value) {
            	var stringValue = Object.prototype.toString.call(value);

            	return stringValue === '[object RegExp]'
            		|| stringValue === '[object Date]'
            		|| isReactElement(value)
            }

            // see https://github.com/facebook/react/blob/b5ac963fb791d1298e7f396236383bc955f916c1/src/isomorphic/classic/element/ReactElement.js#L21-L25
            var canUseSymbol = typeof Symbol === 'function' && Symbol.for;
            var REACT_ELEMENT_TYPE = canUseSymbol ? Symbol.for('react.element') : 0xeac7;

            function isReactElement(value) {
            	return value.$$typeof === REACT_ELEMENT_TYPE
            }

            function emptyTarget(val) {
            	return Array.isArray(val) ? [] : {}
            }

            function cloneUnlessOtherwiseSpecified(value, options) {
            	return (options.clone !== false && options.isMergeableObject(value))
            		? deepmerge(emptyTarget(value), value, options)
            		: value
            }

            function defaultArrayMerge(target, source, options) {
            	return target.concat(source).map(function(element) {
            		return cloneUnlessOtherwiseSpecified(element, options)
            	})
            }

            function getMergeFunction(key, options) {
            	if (!options.customMerge) {
            		return deepmerge
            	}
            	var customMerge = options.customMerge(key);
            	return typeof customMerge === 'function' ? customMerge : deepmerge
            }

            function getEnumerableOwnPropertySymbols(target) {
            	return Object.getOwnPropertySymbols
            		? Object.getOwnPropertySymbols(target).filter(function(symbol) {
            			return target.propertyIsEnumerable(symbol)
            		})
            		: []
            }

            function getKeys(target) {
            	return Object.keys(target).concat(getEnumerableOwnPropertySymbols(target))
            }

            function propertyIsOnObject(object, property) {
            	try {
            		return property in object
            	} catch(_) {
            		return false
            	}
            }

            // Protects from prototype poisoning and unexpected merging up the prototype chain.
            function propertyIsUnsafe(target, key) {
            	return propertyIsOnObject(target, key) // Properties are safe to merge if they don't exist in the target yet,
            		&& !(Object.hasOwnProperty.call(target, key) // unsafe if they exist up the prototype chain,
            			&& Object.propertyIsEnumerable.call(target, key)) // and also unsafe if they're nonenumerable.
            }

            function mergeObject(target, source, options) {
            	var destination = {};
            	if (options.isMergeableObject(target)) {
            		getKeys(target).forEach(function(key) {
            			destination[key] = cloneUnlessOtherwiseSpecified(target[key], options);
            		});
            	}
            	getKeys(source).forEach(function(key) {
            		if (propertyIsUnsafe(target, key)) {
            			return
            		}

            		if (propertyIsOnObject(target, key) && options.isMergeableObject(source[key])) {
            			destination[key] = getMergeFunction(key, options)(target[key], source[key], options);
            		} else {
            			destination[key] = cloneUnlessOtherwiseSpecified(source[key], options);
            		}
            	});
            	return destination
            }

            function deepmerge(target, source, options) {
            	options = options || {};
            	options.arrayMerge = options.arrayMerge || defaultArrayMerge;
            	options.isMergeableObject = options.isMergeableObject || isMergeableObject;
            	// cloneUnlessOtherwiseSpecified is added to `options` so that custom arrayMerge()
            	// implementations can use it. The caller may not replace it.
            	options.cloneUnlessOtherwiseSpecified = cloneUnlessOtherwiseSpecified;

            	var sourceIsArray = Array.isArray(source);
            	var targetIsArray = Array.isArray(target);
            	var sourceAndTargetTypesMatch = sourceIsArray === targetIsArray;

            	if (!sourceAndTargetTypesMatch) {
            		return cloneUnlessOtherwiseSpecified(source, options)
            	} else if (sourceIsArray) {
            		return options.arrayMerge(target, source, options)
            	} else {
            		return mergeObject(target, source, options)
            	}
            }

            deepmerge.all = function deepmergeAll(array, options) {
            	if (!Array.isArray(array)) {
            		throw new Error('first argument should be an array')
            	}

            	return array.reduce(function(prev, next) {
            		return deepmerge(prev, next, options)
            	}, {})
            };

            var deepmerge_1 = deepmerge;

            var cjs = deepmerge_1;

            /**
             * lodash (Custom Build) <https://lodash.com/>
             * Build: `lodash modularize exports="npm" -o ./`
             * Copyright jQuery Foundation and other contributors <https://jquery.org/>
             * Released under MIT license <https://lodash.com/license>
             * Based on Underscore.js 1.8.3 <http://underscorejs.org/LICENSE>
             * Copyright Jeremy Ashkenas, DocumentCloud and Investigative Reporters & Editors
             */

            /** Used as references for various `Number` constants. */
            var INFINITY$1 = 1 / 0;

            /** `Object#toString` result references. */
            var symbolTag$1 = '[object Symbol]';

            /** Used to match words composed of alphanumeric characters. */
            var reAsciiWord$1 = /[^\x00-\x2f\x3a-\x40\x5b-\x60\x7b-\x7f]+/g;

            /** Used to match Latin Unicode letters (excluding mathematical operators). */
            var reLatin$1 = /[\xc0-\xd6\xd8-\xf6\xf8-\xff\u0100-\u017f]/g;

            /** Used to compose unicode character classes. */
            var rsAstralRange$1 = '\\ud800-\\udfff',
                rsComboMarksRange$1 = '\\u0300-\\u036f\\ufe20-\\ufe23',
                rsComboSymbolsRange$1 = '\\u20d0-\\u20f0',
                rsDingbatRange$1 = '\\u2700-\\u27bf',
                rsLowerRange$1 = 'a-z\\xdf-\\xf6\\xf8-\\xff',
                rsMathOpRange$1 = '\\xac\\xb1\\xd7\\xf7',
                rsNonCharRange$1 = '\\x00-\\x2f\\x3a-\\x40\\x5b-\\x60\\x7b-\\xbf',
                rsPunctuationRange$1 = '\\u2000-\\u206f',
                rsSpaceRange$1 = ' \\t\\x0b\\f\\xa0\\ufeff\\n\\r\\u2028\\u2029\\u1680\\u180e\\u2000\\u2001\\u2002\\u2003\\u2004\\u2005\\u2006\\u2007\\u2008\\u2009\\u200a\\u202f\\u205f\\u3000',
                rsUpperRange$1 = 'A-Z\\xc0-\\xd6\\xd8-\\xde',
                rsVarRange$1 = '\\ufe0e\\ufe0f',
                rsBreakRange$1 = rsMathOpRange$1 + rsNonCharRange$1 + rsPunctuationRange$1 + rsSpaceRange$1;

            /** Used to compose unicode capture groups. */
            var rsApos$1 = "['\u2019]",
                rsAstral = '[' + rsAstralRange$1 + ']',
                rsBreak$1 = '[' + rsBreakRange$1 + ']',
                rsCombo$1 = '[' + rsComboMarksRange$1 + rsComboSymbolsRange$1 + ']',
                rsDigits$1 = '\\d+',
                rsDingbat$1 = '[' + rsDingbatRange$1 + ']',
                rsLower$1 = '[' + rsLowerRange$1 + ']',
                rsMisc$1 = '[^' + rsAstralRange$1 + rsBreakRange$1 + rsDigits$1 + rsDingbatRange$1 + rsLowerRange$1 + rsUpperRange$1 + ']',
                rsFitz$1 = '\\ud83c[\\udffb-\\udfff]',
                rsModifier$1 = '(?:' + rsCombo$1 + '|' + rsFitz$1 + ')',
                rsNonAstral$1 = '[^' + rsAstralRange$1 + ']',
                rsRegional$1 = '(?:\\ud83c[\\udde6-\\uddff]){2}',
                rsSurrPair$1 = '[\\ud800-\\udbff][\\udc00-\\udfff]',
                rsUpper$1 = '[' + rsUpperRange$1 + ']',
                rsZWJ$1 = '\\u200d';

            /** Used to compose unicode regexes. */
            var rsLowerMisc$1 = '(?:' + rsLower$1 + '|' + rsMisc$1 + ')',
                rsUpperMisc$1 = '(?:' + rsUpper$1 + '|' + rsMisc$1 + ')',
                rsOptLowerContr$1 = '(?:' + rsApos$1 + '(?:d|ll|m|re|s|t|ve))?',
                rsOptUpperContr$1 = '(?:' + rsApos$1 + '(?:D|LL|M|RE|S|T|VE))?',
                reOptMod$1 = rsModifier$1 + '?',
                rsOptVar$1 = '[' + rsVarRange$1 + ']?',
                rsOptJoin$1 = '(?:' + rsZWJ$1 + '(?:' + [rsNonAstral$1, rsRegional$1, rsSurrPair$1].join('|') + ')' + rsOptVar$1 + reOptMod$1 + ')*',
                rsSeq$1 = rsOptVar$1 + reOptMod$1 + rsOptJoin$1,
                rsEmoji$1 = '(?:' + [rsDingbat$1, rsRegional$1, rsSurrPair$1].join('|') + ')' + rsSeq$1,
                rsSymbol = '(?:' + [rsNonAstral$1 + rsCombo$1 + '?', rsCombo$1, rsRegional$1, rsSurrPair$1, rsAstral].join('|') + ')';

            /** Used to match apostrophes. */
            var reApos$1 = RegExp(rsApos$1, 'g');

            /**
             * Used to match [combining diacritical marks](https://en.wikipedia.org/wiki/Combining_Diacritical_Marks) and
             * [combining diacritical marks for symbols](https://en.wikipedia.org/wiki/Combining_Diacritical_Marks_for_Symbols).
             */
            var reComboMark$1 = RegExp(rsCombo$1, 'g');

            /** Used to match [string symbols](https://mathiasbynens.be/notes/javascript-unicode). */
            var reUnicode = RegExp(rsFitz$1 + '(?=' + rsFitz$1 + ')|' + rsSymbol + rsSeq$1, 'g');

            /** Used to match complex or compound words. */
            var reUnicodeWord$1 = RegExp([
              rsUpper$1 + '?' + rsLower$1 + '+' + rsOptLowerContr$1 + '(?=' + [rsBreak$1, rsUpper$1, '$'].join('|') + ')',
              rsUpperMisc$1 + '+' + rsOptUpperContr$1 + '(?=' + [rsBreak$1, rsUpper$1 + rsLowerMisc$1, '$'].join('|') + ')',
              rsUpper$1 + '?' + rsLowerMisc$1 + '+' + rsOptLowerContr$1,
              rsUpper$1 + '+' + rsOptUpperContr$1,
              rsDigits$1,
              rsEmoji$1
            ].join('|'), 'g');

            /** Used to detect strings with [zero-width joiners or code points from the astral planes](http://eev.ee/blog/2015/09/12/dark-corners-of-unicode/). */
            var reHasUnicode = RegExp('[' + rsZWJ$1 + rsAstralRange$1  + rsComboMarksRange$1 + rsComboSymbolsRange$1 + rsVarRange$1 + ']');

            /** Used to detect strings that need a more robust regexp to match words. */
            var reHasUnicodeWord$1 = /[a-z][A-Z]|[A-Z]{2,}[a-z]|[0-9][a-zA-Z]|[a-zA-Z][0-9]|[^a-zA-Z0-9 ]/;

            /** Used to map Latin Unicode letters to basic Latin letters. */
            var deburredLetters$1 = {
              // Latin-1 Supplement block.
              '\xc0': 'A',  '\xc1': 'A', '\xc2': 'A', '\xc3': 'A', '\xc4': 'A', '\xc5': 'A',
              '\xe0': 'a',  '\xe1': 'a', '\xe2': 'a', '\xe3': 'a', '\xe4': 'a', '\xe5': 'a',
              '\xc7': 'C',  '\xe7': 'c',
              '\xd0': 'D',  '\xf0': 'd',
              '\xc8': 'E',  '\xc9': 'E', '\xca': 'E', '\xcb': 'E',
              '\xe8': 'e',  '\xe9': 'e', '\xea': 'e', '\xeb': 'e',
              '\xcc': 'I',  '\xcd': 'I', '\xce': 'I', '\xcf': 'I',
              '\xec': 'i',  '\xed': 'i', '\xee': 'i', '\xef': 'i',
              '\xd1': 'N',  '\xf1': 'n',
              '\xd2': 'O',  '\xd3': 'O', '\xd4': 'O', '\xd5': 'O', '\xd6': 'O', '\xd8': 'O',
              '\xf2': 'o',  '\xf3': 'o', '\xf4': 'o', '\xf5': 'o', '\xf6': 'o', '\xf8': 'o',
              '\xd9': 'U',  '\xda': 'U', '\xdb': 'U', '\xdc': 'U',
              '\xf9': 'u',  '\xfa': 'u', '\xfb': 'u', '\xfc': 'u',
              '\xdd': 'Y',  '\xfd': 'y', '\xff': 'y',
              '\xc6': 'Ae', '\xe6': 'ae',
              '\xde': 'Th', '\xfe': 'th',
              '\xdf': 'ss',
              // Latin Extended-A block.
              '\u0100': 'A',  '\u0102': 'A', '\u0104': 'A',
              '\u0101': 'a',  '\u0103': 'a', '\u0105': 'a',
              '\u0106': 'C',  '\u0108': 'C', '\u010a': 'C', '\u010c': 'C',
              '\u0107': 'c',  '\u0109': 'c', '\u010b': 'c', '\u010d': 'c',
              '\u010e': 'D',  '\u0110': 'D', '\u010f': 'd', '\u0111': 'd',
              '\u0112': 'E',  '\u0114': 'E', '\u0116': 'E', '\u0118': 'E', '\u011a': 'E',
              '\u0113': 'e',  '\u0115': 'e', '\u0117': 'e', '\u0119': 'e', '\u011b': 'e',
              '\u011c': 'G',  '\u011e': 'G', '\u0120': 'G', '\u0122': 'G',
              '\u011d': 'g',  '\u011f': 'g', '\u0121': 'g', '\u0123': 'g',
              '\u0124': 'H',  '\u0126': 'H', '\u0125': 'h', '\u0127': 'h',
              '\u0128': 'I',  '\u012a': 'I', '\u012c': 'I', '\u012e': 'I', '\u0130': 'I',
              '\u0129': 'i',  '\u012b': 'i', '\u012d': 'i', '\u012f': 'i', '\u0131': 'i',
              '\u0134': 'J',  '\u0135': 'j',
              '\u0136': 'K',  '\u0137': 'k', '\u0138': 'k',
              '\u0139': 'L',  '\u013b': 'L', '\u013d': 'L', '\u013f': 'L', '\u0141': 'L',
              '\u013a': 'l',  '\u013c': 'l', '\u013e': 'l', '\u0140': 'l', '\u0142': 'l',
              '\u0143': 'N',  '\u0145': 'N', '\u0147': 'N', '\u014a': 'N',
              '\u0144': 'n',  '\u0146': 'n', '\u0148': 'n', '\u014b': 'n',
              '\u014c': 'O',  '\u014e': 'O', '\u0150': 'O',
              '\u014d': 'o',  '\u014f': 'o', '\u0151': 'o',
              '\u0154': 'R',  '\u0156': 'R', '\u0158': 'R',
              '\u0155': 'r',  '\u0157': 'r', '\u0159': 'r',
              '\u015a': 'S',  '\u015c': 'S', '\u015e': 'S', '\u0160': 'S',
              '\u015b': 's',  '\u015d': 's', '\u015f': 's', '\u0161': 's',
              '\u0162': 'T',  '\u0164': 'T', '\u0166': 'T',
              '\u0163': 't',  '\u0165': 't', '\u0167': 't',
              '\u0168': 'U',  '\u016a': 'U', '\u016c': 'U', '\u016e': 'U', '\u0170': 'U', '\u0172': 'U',
              '\u0169': 'u',  '\u016b': 'u', '\u016d': 'u', '\u016f': 'u', '\u0171': 'u', '\u0173': 'u',
              '\u0174': 'W',  '\u0175': 'w',
              '\u0176': 'Y',  '\u0177': 'y', '\u0178': 'Y',
              '\u0179': 'Z',  '\u017b': 'Z', '\u017d': 'Z',
              '\u017a': 'z',  '\u017c': 'z', '\u017e': 'z',
              '\u0132': 'IJ', '\u0133': 'ij',
              '\u0152': 'Oe', '\u0153': 'oe',
              '\u0149': "'n", '\u017f': 'ss'
            };

            /** Detect free variable `global` from Node.js. */
            var freeGlobal$1 = typeof commonjsGlobal == 'object' && commonjsGlobal && commonjsGlobal.Object === Object && commonjsGlobal;

            /** Detect free variable `self`. */
            var freeSelf$1 = typeof self == 'object' && self && self.Object === Object && self;

            /** Used as a reference to the global object. */
            var root$1 = freeGlobal$1 || freeSelf$1 || Function('return this')();

            /**
             * A specialized version of `_.reduce` for arrays without support for
             * iteratee shorthands.
             *
             * @private
             * @param {Array} [array] The array to iterate over.
             * @param {Function} iteratee The function invoked per iteration.
             * @param {*} [accumulator] The initial value.
             * @param {boolean} [initAccum] Specify using the first element of `array` as
             *  the initial value.
             * @returns {*} Returns the accumulated value.
             */
            function arrayReduce$1(array, iteratee, accumulator, initAccum) {
              var index = -1,
                  length = array ? array.length : 0;

              if (initAccum && length) {
                accumulator = array[++index];
              }
              while (++index < length) {
                accumulator = iteratee(accumulator, array[index], index, array);
              }
              return accumulator;
            }

            /**
             * Converts an ASCII `string` to an array.
             *
             * @private
             * @param {string} string The string to convert.
             * @returns {Array} Returns the converted array.
             */
            function asciiToArray(string) {
              return string.split('');
            }

            /**
             * Splits an ASCII `string` into an array of its words.
             *
             * @private
             * @param {string} The string to inspect.
             * @returns {Array} Returns the words of `string`.
             */
            function asciiWords$1(string) {
              return string.match(reAsciiWord$1) || [];
            }

            /**
             * The base implementation of `_.propertyOf` without support for deep paths.
             *
             * @private
             * @param {Object} object The object to query.
             * @returns {Function} Returns the new accessor function.
             */
            function basePropertyOf$1(object) {
              return function(key) {
                return object == null ? undefined : object[key];
              };
            }

            /**
             * Used by `_.deburr` to convert Latin-1 Supplement and Latin Extended-A
             * letters to basic Latin letters.
             *
             * @private
             * @param {string} letter The matched letter to deburr.
             * @returns {string} Returns the deburred letter.
             */
            var deburrLetter$1 = basePropertyOf$1(deburredLetters$1);

            /**
             * Checks if `string` contains Unicode symbols.
             *
             * @private
             * @param {string} string The string to inspect.
             * @returns {boolean} Returns `true` if a symbol is found, else `false`.
             */
            function hasUnicode(string) {
              return reHasUnicode.test(string);
            }

            /**
             * Checks if `string` contains a word composed of Unicode symbols.
             *
             * @private
             * @param {string} string The string to inspect.
             * @returns {boolean} Returns `true` if a word is found, else `false`.
             */
            function hasUnicodeWord$1(string) {
              return reHasUnicodeWord$1.test(string);
            }

            /**
             * Converts `string` to an array.
             *
             * @private
             * @param {string} string The string to convert.
             * @returns {Array} Returns the converted array.
             */
            function stringToArray(string) {
              return hasUnicode(string)
                ? unicodeToArray(string)
                : asciiToArray(string);
            }

            /**
             * Converts a Unicode `string` to an array.
             *
             * @private
             * @param {string} string The string to convert.
             * @returns {Array} Returns the converted array.
             */
            function unicodeToArray(string) {
              return string.match(reUnicode) || [];
            }

            /**
             * Splits a Unicode `string` into an array of its words.
             *
             * @private
             * @param {string} The string to inspect.
             * @returns {Array} Returns the words of `string`.
             */
            function unicodeWords$1(string) {
              return string.match(reUnicodeWord$1) || [];
            }

            /** Used for built-in method references. */
            var objectProto$2 = Object.prototype;

            /**
             * Used to resolve the
             * [`toStringTag`](http://ecma-international.org/ecma-262/7.0/#sec-object.prototype.tostring)
             * of values.
             */
            var objectToString$2 = objectProto$2.toString;

            /** Built-in value references. */
            var Symbol$2 = root$1.Symbol;

            /** Used to convert symbols to primitives and strings. */
            var symbolProto$1 = Symbol$2 ? Symbol$2.prototype : undefined,
                symbolToString$1 = symbolProto$1 ? symbolProto$1.toString : undefined;

            /**
             * The base implementation of `_.slice` without an iteratee call guard.
             *
             * @private
             * @param {Array} array The array to slice.
             * @param {number} [start=0] The start position.
             * @param {number} [end=array.length] The end position.
             * @returns {Array} Returns the slice of `array`.
             */
            function baseSlice(array, start, end) {
              var index = -1,
                  length = array.length;

              if (start < 0) {
                start = -start > length ? 0 : (length + start);
              }
              end = end > length ? length : end;
              if (end < 0) {
                end += length;
              }
              length = start > end ? 0 : ((end - start) >>> 0);
              start >>>= 0;

              var result = Array(length);
              while (++index < length) {
                result[index] = array[index + start];
              }
              return result;
            }

            /**
             * The base implementation of `_.toString` which doesn't convert nullish
             * values to empty strings.
             *
             * @private
             * @param {*} value The value to process.
             * @returns {string} Returns the string.
             */
            function baseToString$1(value) {
              // Exit early for strings to avoid a performance hit in some environments.
              if (typeof value == 'string') {
                return value;
              }
              if (isSymbol$1(value)) {
                return symbolToString$1 ? symbolToString$1.call(value) : '';
              }
              var result = (value + '');
              return (result == '0' && (1 / value) == -INFINITY$1) ? '-0' : result;
            }

            /**
             * Casts `array` to a slice if it's needed.
             *
             * @private
             * @param {Array} array The array to inspect.
             * @param {number} start The start position.
             * @param {number} [end=array.length] The end position.
             * @returns {Array} Returns the cast slice.
             */
            function castSlice(array, start, end) {
              var length = array.length;
              end = end === undefined ? length : end;
              return (!start && end >= length) ? array : baseSlice(array, start, end);
            }

            /**
             * Creates a function like `_.lowerFirst`.
             *
             * @private
             * @param {string} methodName The name of the `String` case method to use.
             * @returns {Function} Returns the new case function.
             */
            function createCaseFirst(methodName) {
              return function(string) {
                string = toString$1(string);

                var strSymbols = hasUnicode(string)
                  ? stringToArray(string)
                  : undefined;

                var chr = strSymbols
                  ? strSymbols[0]
                  : string.charAt(0);

                var trailing = strSymbols
                  ? castSlice(strSymbols, 1).join('')
                  : string.slice(1);

                return chr[methodName]() + trailing;
              };
            }

            /**
             * Creates a function like `_.camelCase`.
             *
             * @private
             * @param {Function} callback The function to combine each word.
             * @returns {Function} Returns the new compounder function.
             */
            function createCompounder$1(callback) {
              return function(string) {
                return arrayReduce$1(words$1(deburr$1(string).replace(reApos$1, '')), callback, '');
              };
            }

            /**
             * Checks if `value` is object-like. A value is object-like if it's not `null`
             * and has a `typeof` result of "object".
             *
             * @static
             * @memberOf _
             * @since 4.0.0
             * @category Lang
             * @param {*} value The value to check.
             * @returns {boolean} Returns `true` if `value` is object-like, else `false`.
             * @example
             *
             * _.isObjectLike({});
             * // => true
             *
             * _.isObjectLike([1, 2, 3]);
             * // => true
             *
             * _.isObjectLike(_.noop);
             * // => false
             *
             * _.isObjectLike(null);
             * // => false
             */
            function isObjectLike$1(value) {
              return !!value && typeof value == 'object';
            }

            /**
             * Checks if `value` is classified as a `Symbol` primitive or object.
             *
             * @static
             * @memberOf _
             * @since 4.0.0
             * @category Lang
             * @param {*} value The value to check.
             * @returns {boolean} Returns `true` if `value` is a symbol, else `false`.
             * @example
             *
             * _.isSymbol(Symbol.iterator);
             * // => true
             *
             * _.isSymbol('abc');
             * // => false
             */
            function isSymbol$1(value) {
              return typeof value == 'symbol' ||
                (isObjectLike$1(value) && objectToString$2.call(value) == symbolTag$1);
            }

            /**
             * Converts `value` to a string. An empty string is returned for `null`
             * and `undefined` values. The sign of `-0` is preserved.
             *
             * @static
             * @memberOf _
             * @since 4.0.0
             * @category Lang
             * @param {*} value The value to process.
             * @returns {string} Returns the string.
             * @example
             *
             * _.toString(null);
             * // => ''
             *
             * _.toString(-0);
             * // => '-0'
             *
             * _.toString([1, 2, 3]);
             * // => '1,2,3'
             */
            function toString$1(value) {
              return value == null ? '' : baseToString$1(value);
            }

            /**
             * Converts `string` to [camel case](https://en.wikipedia.org/wiki/CamelCase).
             *
             * @static
             * @memberOf _
             * @since 3.0.0
             * @category String
             * @param {string} [string=''] The string to convert.
             * @returns {string} Returns the camel cased string.
             * @example
             *
             * _.camelCase('Foo Bar');
             * // => 'fooBar'
             *
             * _.camelCase('--foo-bar--');
             * // => 'fooBar'
             *
             * _.camelCase('__FOO_BAR__');
             * // => 'fooBar'
             */
            var camelCase = createCompounder$1(function(result, word, index) {
              word = word.toLowerCase();
              return result + (index ? capitalize(word) : word);
            });

            /**
             * Converts the first character of `string` to upper case and the remaining
             * to lower case.
             *
             * @static
             * @memberOf _
             * @since 3.0.0
             * @category String
             * @param {string} [string=''] The string to capitalize.
             * @returns {string} Returns the capitalized string.
             * @example
             *
             * _.capitalize('FRED');
             * // => 'Fred'
             */
            function capitalize(string) {
              return upperFirst(toString$1(string).toLowerCase());
            }

            /**
             * Deburrs `string` by converting
             * [Latin-1 Supplement](https://en.wikipedia.org/wiki/Latin-1_Supplement_(Unicode_block)#Character_table)
             * and [Latin Extended-A](https://en.wikipedia.org/wiki/Latin_Extended-A)
             * letters to basic Latin letters and removing
             * [combining diacritical marks](https://en.wikipedia.org/wiki/Combining_Diacritical_Marks).
             *
             * @static
             * @memberOf _
             * @since 3.0.0
             * @category String
             * @param {string} [string=''] The string to deburr.
             * @returns {string} Returns the deburred string.
             * @example
             *
             * _.deburr('déjà vu');
             * // => 'deja vu'
             */
            function deburr$1(string) {
              string = toString$1(string);
              return string && string.replace(reLatin$1, deburrLetter$1).replace(reComboMark$1, '');
            }

            /**
             * Converts the first character of `string` to upper case.
             *
             * @static
             * @memberOf _
             * @since 4.0.0
             * @category String
             * @param {string} [string=''] The string to convert.
             * @returns {string} Returns the converted string.
             * @example
             *
             * _.upperFirst('fred');
             * // => 'Fred'
             *
             * _.upperFirst('FRED');
             * // => 'FRED'
             */
            var upperFirst = createCaseFirst('toUpperCase');

            /**
             * Splits `string` into an array of its words.
             *
             * @static
             * @memberOf _
             * @since 3.0.0
             * @category String
             * @param {string} [string=''] The string to inspect.
             * @param {RegExp|string} [pattern] The pattern to match words.
             * @param- {Object} [guard] Enables use as an iteratee for methods like `_.map`.
             * @returns {Array} Returns the words of `string`.
             * @example
             *
             * _.words('fred, barney, & pebbles');
             * // => ['fred', 'barney', 'pebbles']
             *
             * _.words('fred, barney, & pebbles', /[^, ]+/g);
             * // => ['fred', 'barney', '&', 'pebbles']
             */
            function words$1(string, pattern, guard) {
              string = toString$1(string);
              pattern = guard ? undefined : pattern;

              if (pattern === undefined) {
                return hasUnicodeWord$1(string) ? unicodeWords$1(string) : asciiWords$1(string);
              }
              return string.match(pattern) || [];
            }

            var lodash_camelcase = camelCase;

            /**
             * lodash (Custom Build) <https://lodash.com/>
             * Build: `lodash modularize exports="npm" -o ./`
             * Copyright jQuery Foundation and other contributors <https://jquery.org/>
             * Released under MIT license <https://lodash.com/license>
             * Based on Underscore.js 1.8.3 <http://underscorejs.org/LICENSE>
             * Copyright Jeremy Ashkenas, DocumentCloud and Investigative Reporters & Editors
             */

            /** Used as references for various `Number` constants. */
            var INFINITY = 1 / 0;

            /** `Object#toString` result references. */
            var symbolTag = '[object Symbol]';

            /** Used to match words composed of alphanumeric characters. */
            var reAsciiWord = /[^\x00-\x2f\x3a-\x40\x5b-\x60\x7b-\x7f]+/g;

            /** Used to match Latin Unicode letters (excluding mathematical operators). */
            var reLatin = /[\xc0-\xd6\xd8-\xf6\xf8-\xff\u0100-\u017f]/g;

            /** Used to compose unicode character classes. */
            var rsAstralRange = '\\ud800-\\udfff',
                rsComboMarksRange = '\\u0300-\\u036f\\ufe20-\\ufe23',
                rsComboSymbolsRange = '\\u20d0-\\u20f0',
                rsDingbatRange = '\\u2700-\\u27bf',
                rsLowerRange = 'a-z\\xdf-\\xf6\\xf8-\\xff',
                rsMathOpRange = '\\xac\\xb1\\xd7\\xf7',
                rsNonCharRange = '\\x00-\\x2f\\x3a-\\x40\\x5b-\\x60\\x7b-\\xbf',
                rsPunctuationRange = '\\u2000-\\u206f',
                rsSpaceRange = ' \\t\\x0b\\f\\xa0\\ufeff\\n\\r\\u2028\\u2029\\u1680\\u180e\\u2000\\u2001\\u2002\\u2003\\u2004\\u2005\\u2006\\u2007\\u2008\\u2009\\u200a\\u202f\\u205f\\u3000',
                rsUpperRange = 'A-Z\\xc0-\\xd6\\xd8-\\xde',
                rsVarRange = '\\ufe0e\\ufe0f',
                rsBreakRange = rsMathOpRange + rsNonCharRange + rsPunctuationRange + rsSpaceRange;

            /** Used to compose unicode capture groups. */
            var rsApos = "['\u2019]",
                rsBreak = '[' + rsBreakRange + ']',
                rsCombo = '[' + rsComboMarksRange + rsComboSymbolsRange + ']',
                rsDigits = '\\d+',
                rsDingbat = '[' + rsDingbatRange + ']',
                rsLower = '[' + rsLowerRange + ']',
                rsMisc = '[^' + rsAstralRange + rsBreakRange + rsDigits + rsDingbatRange + rsLowerRange + rsUpperRange + ']',
                rsFitz = '\\ud83c[\\udffb-\\udfff]',
                rsModifier = '(?:' + rsCombo + '|' + rsFitz + ')',
                rsNonAstral = '[^' + rsAstralRange + ']',
                rsRegional = '(?:\\ud83c[\\udde6-\\uddff]){2}',
                rsSurrPair = '[\\ud800-\\udbff][\\udc00-\\udfff]',
                rsUpper = '[' + rsUpperRange + ']',
                rsZWJ = '\\u200d';

            /** Used to compose unicode regexes. */
            var rsLowerMisc = '(?:' + rsLower + '|' + rsMisc + ')',
                rsUpperMisc = '(?:' + rsUpper + '|' + rsMisc + ')',
                rsOptLowerContr = '(?:' + rsApos + '(?:d|ll|m|re|s|t|ve))?',
                rsOptUpperContr = '(?:' + rsApos + '(?:D|LL|M|RE|S|T|VE))?',
                reOptMod = rsModifier + '?',
                rsOptVar = '[' + rsVarRange + ']?',
                rsOptJoin = '(?:' + rsZWJ + '(?:' + [rsNonAstral, rsRegional, rsSurrPair].join('|') + ')' + rsOptVar + reOptMod + ')*',
                rsSeq = rsOptVar + reOptMod + rsOptJoin,
                rsEmoji = '(?:' + [rsDingbat, rsRegional, rsSurrPair].join('|') + ')' + rsSeq;

            /** Used to match apostrophes. */
            var reApos = RegExp(rsApos, 'g');

            /**
             * Used to match [combining diacritical marks](https://en.wikipedia.org/wiki/Combining_Diacritical_Marks) and
             * [combining diacritical marks for symbols](https://en.wikipedia.org/wiki/Combining_Diacritical_Marks_for_Symbols).
             */
            var reComboMark = RegExp(rsCombo, 'g');

            /** Used to match complex or compound words. */
            var reUnicodeWord = RegExp([
              rsUpper + '?' + rsLower + '+' + rsOptLowerContr + '(?=' + [rsBreak, rsUpper, '$'].join('|') + ')',
              rsUpperMisc + '+' + rsOptUpperContr + '(?=' + [rsBreak, rsUpper + rsLowerMisc, '$'].join('|') + ')',
              rsUpper + '?' + rsLowerMisc + '+' + rsOptLowerContr,
              rsUpper + '+' + rsOptUpperContr,
              rsDigits,
              rsEmoji
            ].join('|'), 'g');

            /** Used to detect strings that need a more robust regexp to match words. */
            var reHasUnicodeWord = /[a-z][A-Z]|[A-Z]{2,}[a-z]|[0-9][a-zA-Z]|[a-zA-Z][0-9]|[^a-zA-Z0-9 ]/;

            /** Used to map Latin Unicode letters to basic Latin letters. */
            var deburredLetters = {
              // Latin-1 Supplement block.
              '\xc0': 'A',  '\xc1': 'A', '\xc2': 'A', '\xc3': 'A', '\xc4': 'A', '\xc5': 'A',
              '\xe0': 'a',  '\xe1': 'a', '\xe2': 'a', '\xe3': 'a', '\xe4': 'a', '\xe5': 'a',
              '\xc7': 'C',  '\xe7': 'c',
              '\xd0': 'D',  '\xf0': 'd',
              '\xc8': 'E',  '\xc9': 'E', '\xca': 'E', '\xcb': 'E',
              '\xe8': 'e',  '\xe9': 'e', '\xea': 'e', '\xeb': 'e',
              '\xcc': 'I',  '\xcd': 'I', '\xce': 'I', '\xcf': 'I',
              '\xec': 'i',  '\xed': 'i', '\xee': 'i', '\xef': 'i',
              '\xd1': 'N',  '\xf1': 'n',
              '\xd2': 'O',  '\xd3': 'O', '\xd4': 'O', '\xd5': 'O', '\xd6': 'O', '\xd8': 'O',
              '\xf2': 'o',  '\xf3': 'o', '\xf4': 'o', '\xf5': 'o', '\xf6': 'o', '\xf8': 'o',
              '\xd9': 'U',  '\xda': 'U', '\xdb': 'U', '\xdc': 'U',
              '\xf9': 'u',  '\xfa': 'u', '\xfb': 'u', '\xfc': 'u',
              '\xdd': 'Y',  '\xfd': 'y', '\xff': 'y',
              '\xc6': 'Ae', '\xe6': 'ae',
              '\xde': 'Th', '\xfe': 'th',
              '\xdf': 'ss',
              // Latin Extended-A block.
              '\u0100': 'A',  '\u0102': 'A', '\u0104': 'A',
              '\u0101': 'a',  '\u0103': 'a', '\u0105': 'a',
              '\u0106': 'C',  '\u0108': 'C', '\u010a': 'C', '\u010c': 'C',
              '\u0107': 'c',  '\u0109': 'c', '\u010b': 'c', '\u010d': 'c',
              '\u010e': 'D',  '\u0110': 'D', '\u010f': 'd', '\u0111': 'd',
              '\u0112': 'E',  '\u0114': 'E', '\u0116': 'E', '\u0118': 'E', '\u011a': 'E',
              '\u0113': 'e',  '\u0115': 'e', '\u0117': 'e', '\u0119': 'e', '\u011b': 'e',
              '\u011c': 'G',  '\u011e': 'G', '\u0120': 'G', '\u0122': 'G',
              '\u011d': 'g',  '\u011f': 'g', '\u0121': 'g', '\u0123': 'g',
              '\u0124': 'H',  '\u0126': 'H', '\u0125': 'h', '\u0127': 'h',
              '\u0128': 'I',  '\u012a': 'I', '\u012c': 'I', '\u012e': 'I', '\u0130': 'I',
              '\u0129': 'i',  '\u012b': 'i', '\u012d': 'i', '\u012f': 'i', '\u0131': 'i',
              '\u0134': 'J',  '\u0135': 'j',
              '\u0136': 'K',  '\u0137': 'k', '\u0138': 'k',
              '\u0139': 'L',  '\u013b': 'L', '\u013d': 'L', '\u013f': 'L', '\u0141': 'L',
              '\u013a': 'l',  '\u013c': 'l', '\u013e': 'l', '\u0140': 'l', '\u0142': 'l',
              '\u0143': 'N',  '\u0145': 'N', '\u0147': 'N', '\u014a': 'N',
              '\u0144': 'n',  '\u0146': 'n', '\u0148': 'n', '\u014b': 'n',
              '\u014c': 'O',  '\u014e': 'O', '\u0150': 'O',
              '\u014d': 'o',  '\u014f': 'o', '\u0151': 'o',
              '\u0154': 'R',  '\u0156': 'R', '\u0158': 'R',
              '\u0155': 'r',  '\u0157': 'r', '\u0159': 'r',
              '\u015a': 'S',  '\u015c': 'S', '\u015e': 'S', '\u0160': 'S',
              '\u015b': 's',  '\u015d': 's', '\u015f': 's', '\u0161': 's',
              '\u0162': 'T',  '\u0164': 'T', '\u0166': 'T',
              '\u0163': 't',  '\u0165': 't', '\u0167': 't',
              '\u0168': 'U',  '\u016a': 'U', '\u016c': 'U', '\u016e': 'U', '\u0170': 'U', '\u0172': 'U',
              '\u0169': 'u',  '\u016b': 'u', '\u016d': 'u', '\u016f': 'u', '\u0171': 'u', '\u0173': 'u',
              '\u0174': 'W',  '\u0175': 'w',
              '\u0176': 'Y',  '\u0177': 'y', '\u0178': 'Y',
              '\u0179': 'Z',  '\u017b': 'Z', '\u017d': 'Z',
              '\u017a': 'z',  '\u017c': 'z', '\u017e': 'z',
              '\u0132': 'IJ', '\u0133': 'ij',
              '\u0152': 'Oe', '\u0153': 'oe',
              '\u0149': "'n", '\u017f': 'ss'
            };

            /** Detect free variable `global` from Node.js. */
            var freeGlobal = typeof commonjsGlobal == 'object' && commonjsGlobal && commonjsGlobal.Object === Object && commonjsGlobal;

            /** Detect free variable `self`. */
            var freeSelf = typeof self == 'object' && self && self.Object === Object && self;

            /** Used as a reference to the global object. */
            var root = freeGlobal || freeSelf || Function('return this')();

            /**
             * A specialized version of `_.reduce` for arrays without support for
             * iteratee shorthands.
             *
             * @private
             * @param {Array} [array] The array to iterate over.
             * @param {Function} iteratee The function invoked per iteration.
             * @param {*} [accumulator] The initial value.
             * @param {boolean} [initAccum] Specify using the first element of `array` as
             *  the initial value.
             * @returns {*} Returns the accumulated value.
             */
            function arrayReduce(array, iteratee, accumulator, initAccum) {
              var index = -1,
                  length = array ? array.length : 0;

              if (initAccum && length) {
                accumulator = array[++index];
              }
              while (++index < length) {
                accumulator = iteratee(accumulator, array[index], index, array);
              }
              return accumulator;
            }

            /**
             * Splits an ASCII `string` into an array of its words.
             *
             * @private
             * @param {string} The string to inspect.
             * @returns {Array} Returns the words of `string`.
             */
            function asciiWords(string) {
              return string.match(reAsciiWord) || [];
            }

            /**
             * The base implementation of `_.propertyOf` without support for deep paths.
             *
             * @private
             * @param {Object} object The object to query.
             * @returns {Function} Returns the new accessor function.
             */
            function basePropertyOf(object) {
              return function(key) {
                return object == null ? undefined : object[key];
              };
            }

            /**
             * Used by `_.deburr` to convert Latin-1 Supplement and Latin Extended-A
             * letters to basic Latin letters.
             *
             * @private
             * @param {string} letter The matched letter to deburr.
             * @returns {string} Returns the deburred letter.
             */
            var deburrLetter = basePropertyOf(deburredLetters);

            /**
             * Checks if `string` contains a word composed of Unicode symbols.
             *
             * @private
             * @param {string} string The string to inspect.
             * @returns {boolean} Returns `true` if a word is found, else `false`.
             */
            function hasUnicodeWord(string) {
              return reHasUnicodeWord.test(string);
            }

            /**
             * Splits a Unicode `string` into an array of its words.
             *
             * @private
             * @param {string} The string to inspect.
             * @returns {Array} Returns the words of `string`.
             */
            function unicodeWords(string) {
              return string.match(reUnicodeWord) || [];
            }

            /** Used for built-in method references. */
            var objectProto$1 = Object.prototype;

            /**
             * Used to resolve the
             * [`toStringTag`](http://ecma-international.org/ecma-262/7.0/#sec-object.prototype.tostring)
             * of values.
             */
            var objectToString$1 = objectProto$1.toString;

            /** Built-in value references. */
            var Symbol$1 = root.Symbol;

            /** Used to convert symbols to primitives and strings. */
            var symbolProto = Symbol$1 ? Symbol$1.prototype : undefined,
                symbolToString = symbolProto ? symbolProto.toString : undefined;

            /**
             * The base implementation of `_.toString` which doesn't convert nullish
             * values to empty strings.
             *
             * @private
             * @param {*} value The value to process.
             * @returns {string} Returns the string.
             */
            function baseToString(value) {
              // Exit early for strings to avoid a performance hit in some environments.
              if (typeof value == 'string') {
                return value;
              }
              if (isSymbol(value)) {
                return symbolToString ? symbolToString.call(value) : '';
              }
              var result = (value + '');
              return (result == '0' && (1 / value) == -INFINITY) ? '-0' : result;
            }

            /**
             * Creates a function like `_.camelCase`.
             *
             * @private
             * @param {Function} callback The function to combine each word.
             * @returns {Function} Returns the new compounder function.
             */
            function createCompounder(callback) {
              return function(string) {
                return arrayReduce(words(deburr(string).replace(reApos, '')), callback, '');
              };
            }

            /**
             * Checks if `value` is object-like. A value is object-like if it's not `null`
             * and has a `typeof` result of "object".
             *
             * @static
             * @memberOf _
             * @since 4.0.0
             * @category Lang
             * @param {*} value The value to check.
             * @returns {boolean} Returns `true` if `value` is object-like, else `false`.
             * @example
             *
             * _.isObjectLike({});
             * // => true
             *
             * _.isObjectLike([1, 2, 3]);
             * // => true
             *
             * _.isObjectLike(_.noop);
             * // => false
             *
             * _.isObjectLike(null);
             * // => false
             */
            function isObjectLike(value) {
              return !!value && typeof value == 'object';
            }

            /**
             * Checks if `value` is classified as a `Symbol` primitive or object.
             *
             * @static
             * @memberOf _
             * @since 4.0.0
             * @category Lang
             * @param {*} value The value to check.
             * @returns {boolean} Returns `true` if `value` is a symbol, else `false`.
             * @example
             *
             * _.isSymbol(Symbol.iterator);
             * // => true
             *
             * _.isSymbol('abc');
             * // => false
             */
            function isSymbol(value) {
              return typeof value == 'symbol' ||
                (isObjectLike(value) && objectToString$1.call(value) == symbolTag);
            }

            /**
             * Converts `value` to a string. An empty string is returned for `null`
             * and `undefined` values. The sign of `-0` is preserved.
             *
             * @static
             * @memberOf _
             * @since 4.0.0
             * @category Lang
             * @param {*} value The value to process.
             * @returns {string} Returns the string.
             * @example
             *
             * _.toString(null);
             * // => ''
             *
             * _.toString(-0);
             * // => '-0'
             *
             * _.toString([1, 2, 3]);
             * // => '1,2,3'
             */
            function toString(value) {
              return value == null ? '' : baseToString(value);
            }

            /**
             * Deburrs `string` by converting
             * [Latin-1 Supplement](https://en.wikipedia.org/wiki/Latin-1_Supplement_(Unicode_block)#Character_table)
             * and [Latin Extended-A](https://en.wikipedia.org/wiki/Latin_Extended-A)
             * letters to basic Latin letters and removing
             * [combining diacritical marks](https://en.wikipedia.org/wiki/Combining_Diacritical_Marks).
             *
             * @static
             * @memberOf _
             * @since 3.0.0
             * @category String
             * @param {string} [string=''] The string to deburr.
             * @returns {string} Returns the deburred string.
             * @example
             *
             * _.deburr('déjà vu');
             * // => 'deja vu'
             */
            function deburr(string) {
              string = toString(string);
              return string && string.replace(reLatin, deburrLetter).replace(reComboMark, '');
            }

            /**
             * Converts `string` to
             * [snake case](https://en.wikipedia.org/wiki/Snake_case).
             *
             * @static
             * @memberOf _
             * @since 3.0.0
             * @category String
             * @param {string} [string=''] The string to convert.
             * @returns {string} Returns the snake cased string.
             * @example
             *
             * _.snakeCase('Foo Bar');
             * // => 'foo_bar'
             *
             * _.snakeCase('fooBar');
             * // => 'foo_bar'
             *
             * _.snakeCase('--FOO-BAR--');
             * // => 'foo_bar'
             */
            var snakeCase = createCompounder(function(result, word, index) {
              return result + (index ? '_' : '') + word.toLowerCase();
            });

            /**
             * Splits `string` into an array of its words.
             *
             * @static
             * @memberOf _
             * @since 3.0.0
             * @category String
             * @param {string} [string=''] The string to inspect.
             * @param {RegExp|string} [pattern] The pattern to match words.
             * @param- {Object} [guard] Enables use as an iteratee for methods like `_.map`.
             * @returns {Array} Returns the words of `string`.
             * @example
             *
             * _.words('fred, barney, & pebbles');
             * // => ['fred', 'barney', 'pebbles']
             *
             * _.words('fred, barney, & pebbles', /[^, ]+/g);
             * // => ['fred', 'barney', '&', 'pebbles']
             */
            function words(string, pattern, guard) {
              string = toString(string);
              pattern = guard ? undefined : pattern;

              if (pattern === undefined) {
                return hasUnicodeWord(string) ? unicodeWords(string) : asciiWords(string);
              }
              return string.match(pattern) || [];
            }

            var lodash_snakecase = snakeCase;

            var src = createCommonjsModule(function (module, exports) {
            exports.__esModule = true;


            function normalizeKeys(obj, kind) {
                if (obj && obj.constructor === Object) {
                    Object.keys(obj).forEach(function (key) {
                        var value = obj[key];
                        delete obj[key];
                        if (kind === "camel") {
                            key = lodash_camelcase(key);
                        }
                        else if (kind === "snake") {
                            key = lodash_snakecase(key);
                        }
                        else if (kind === "upper") {
                            key = key.toUpperCase();
                        }
                        else if (kind === "lower") {
                            key = key.toLowerCase();
                        }
                        else if (typeof kind === "function") {
                            key = kind(key);
                        }
                        obj[key] = normalizeKeys(value, kind);
                    });
                }
                else if (obj && obj.constructor === Array) {
                    obj = obj.map(function (o) { return normalizeKeys(o, kind); });
                }
                return obj;
            }
            exports.normalizeKeys = normalizeKeys;

            });

            unwrapExports(src);
            src.normalizeKeys;

            var _regenerator$a = interopRequireDefault(regenerator);

            var _asyncToGenerator2$a = interopRequireDefault(asyncToGenerator);

            var _typeof2$4 = interopRequireDefault(_typeof_1);





















            var normalizeKeys = src.normalizeKeys;

            var options$1 = {};

            function merge$2(x, y) {

              if (!y || (0, _typeof2$4["default"])(y) !== 'object') {
                return x;
              }

              if (!x || (0, _typeof2$4["default"])(x) !== 'object') {
                return x;
              }

              function arrayMerge(target, source, options) {
                var destination = target.slice();
                source.forEach(function (item, index) {
                  if (typeof destination[index] === 'undefined') {
                    destination[index] = options.cloneUnlessOtherwiseSpecified(item, options);
                  } else if (options.isMergeableObject(item)) {
                    destination[index] = merge$2(target[index], item);
                  } else if (target.indexOf(item) === -1) {
                    destination.push(item);
                  }
                });
                return destination;
              }

              return cjs(x, y, {
                arrayMerge: arrayMerge
              });
            }

            function setOptions$1(optns) {
              options$1 = optns;
            }

            function getOptions$1() {
              return options$1;
            }

            function isObject$2(val) {
              return val && (0, _typeof2$4["default"])(val) === 'object' && !(val instanceof Array);
            }

            function toCamel$4(obj) {
              if (!obj) return;
              var objCopy = JSON.parse(JSON.stringify(obj));
              return normalizeKeys(objCopy, keyToCamel);
            }

            function toCamelPath$1(str) {
              if (typeof str === 'string') {
                return str.split('.').map(camelCase_1).join('.');
              }

              return str;
            }

            function toSnake$4(obj) {
              if (!obj) return;
              var objCopy = JSON.parse(JSON.stringify(obj));
              return normalizeKeys(objCopy, keyToSnake);
            }

            function keyToSnake(key) {
              // Handle keys prefixed with $ or _
              return (key[0] === '$' ? '$' : '') + snakeCase_1(key).replace(/\_([0-9])/g, '$1');
            }

            function keyToCamel(key) {
              // Handle keys prefixed with $ or _
              return (key[0] === '$' ? '$' : '') + camelCase_1(key).replace(/\_([0-9])/g, '$1');
            }

            function trimBoth$1(str) {
              return trimStart$1(trimEnd$1(str));
            }

            function trimStart$1(str) {
              return typeof str === 'string' ? str.replace(/^[/]+/, '') : '';
            }

            function trimEnd$1(str) {
              return typeof str === 'string' ? str.replace(/[/]+$/, '') : '';
            }

            function stringifyQuery$1(str) {
              return lib$1.stringify(str, {
                depth: 10,
                encode: false
              });
            }

            function map$3(arr, cb) {
              return arr instanceof Array ? arr.map(cb) : [];
            }

            function reduce$2(arr, cb, init) {
              return arr instanceof Array ? arr.reduce(cb, init) : init;
            }

            function isServer$1() {
              return !(typeof window !== 'undefined' && window && window.document);
            }

            function isFunction$3(func) {
              return typeof func === 'function';
            }

            function defaultMethods$3(request, uri, methods) {
              return {
                list: methods.indexOf('list') >= 0 ? function (query) {
                  return request('get', uri, undefined, query);
                } : undefined,
                get: methods.indexOf('get') >= 0 ? function (id, query) {
                  return request('get', uri, id, query);
                } : undefined
              };
            }

            function vaultRequest$2(_x, _x2, _x3) {
              return _vaultRequest.apply(this, arguments);
            }

            function _vaultRequest() {
              _vaultRequest = (0, _asyncToGenerator2$a["default"])( /*#__PURE__*/_regenerator$a["default"].mark(function _callee(method, url, data) {
                var vaultUrl,
                    timeout,
                    requestId,
                    callback;
                return _regenerator$a["default"].wrap(function _callee$(_context) {
                  while (1) {
                    switch (_context.prev = _context.next) {
                      case 0:
                        vaultUrl = options$1.vaultUrl;
                        timeout = options$1.timeout;
                        requestId = vaultRequestId();
                        callback = "swell_vault_response_".concat(requestId);
                        data = {
                          $jsonp: {
                            method: method,
                            callback: callback
                          },
                          $data: data,
                          $key: options$1.key
                        };
                        return _context.abrupt("return", new Promise(function (resolve, reject) {
                          var script = document.createElement('script');
                          script.type = 'text/javascript';
                          script.src = "".concat(trimEnd$1(vaultUrl), "/").concat(trimStart$1(url), "?").concat(serializeData(data));
                          var errorTimeout = setTimeout(function () {
                            window[callback]({
                              $error: "Request timed out after ".concat(timeout / 1000, " seconds"),
                              $status: 500
                            });
                          }, timeout);

                          window[callback] = function (result) {
                            clearTimeout(errorTimeout);

                            if (result && result.$error) {
                              var err = new Error(result.$error);
                              err.code = 'request_error';
                              err.status = result.$status;
                              reject(err);
                            } else if (!result || result.$status >= 300) {
                              var _err = new Error('A connection error occurred while making the request');

                              _err.code = 'connection_error';
                              _err.status = result.$status;
                              reject(_err);
                            } else {
                              resolve(options$1.useCamelCase ? toCamel$4(result.$data) : result.$data);
                            }

                            delete window[callback];
                            script.parentNode.removeChild(script);
                          };

                          document.getElementsByTagName('head')[0].appendChild(script);
                        }));

                      case 7:
                      case "end":
                        return _context.stop();
                    }
                  }
                }, _callee);
              }));
              return _vaultRequest.apply(this, arguments);
            }

            function vaultRequestId() {
              window.__swell_vault_request_id = window.__swell_vault_request_id || 0;
              window.__swell_vault_request_id++;
              return window.__swell_vault_request_id;
            }

            function serializeData(data) {
              var s = [];

              var add = function add(key, value) {
                // If value is a function, invoke it and return its value
                if (typeof value === 'function') {
                  value = value();
                } else if (value == null) {
                  value = '';
                }

                s[s.length] = encodeURIComponent(key) + '=' + encodeURIComponent(value);
              };

              for (var _key in data) {
                buildParams(_key, data[_key], add);
              }

              return s.join('&').replace(' ', '+');
            }

            var rbracket = /\[\]$/;

            function buildParams(key, obj, add) {
              var name;

              if (obj instanceof Array) {
                for (var i = 0; i < obj.length; i++) {
                  if (rbracket.test(key)) {
                    // Treat each array item as a scalar.
                    add(key, v);
                  } else {
                    // Item is non-scalar (array or object), encode its numeric index.
                    buildParams(key + '[' + ((typeof v === "undefined" ? "undefined" : (0, _typeof2$4["default"])(v)) === 'object' && v != null ? i : '') + ']', v, add);
                  }
                }
              } else if (obj && (0, _typeof2$4["default"])(obj) === 'object') {
                // Serialize object item.
                for (name in obj) {
                  buildParams(key + '[' + name + ']', obj[name], add);
                }
              } else {
                // Serialize scalar item.
                add(key, obj);
              }
            }

            function base64Encode$1(string) {
              if (typeof btoa !== 'undefined') {
                return btoa(string);
              }

              return Buffer$1.from(string).toString('base64');
            }

            var utils = {
              set: set_1,
              get: get_1,
              uniq: uniq_1,
              find: find_1,
              findIndex: findIndex_1,
              camelCase: camelCase_1,
              cloneDeep: cloneDeep_1,
              merge: merge$2,
              setOptions: setOptions$1,
              getOptions: getOptions$1,
              toCamel: toCamel$4,
              toCamelPath: toCamelPath$1,
              toSnake: toSnake$4,
              trimBoth: trimBoth$1,
              trimStart: trimStart$1,
              trimEnd: trimEnd$1,
              stringifyQuery: stringifyQuery$1,
              isServer: isServer$1,
              isFunction: isFunction$3,
              isObject: isObject$2,
              map: map$3,
              reduce: reduce$2,
              base64Encode: base64Encode$1,
              defaultMethods: defaultMethods$3,
              vaultRequest: vaultRequest$2
            };

            var _regenerator$9 = interopRequireDefault(regenerator);

            var _asyncToGenerator2$9 = interopRequireDefault(asyncToGenerator);

            var vaultRequest$1 = utils.vaultRequest,
                toSnake$3 = utils.toSnake;

            var cardApi = {
              createToken: function () {
                var _createToken = (0, _asyncToGenerator2$9["default"])( /*#__PURE__*/_regenerator$9["default"].mark(function _callee(data) {
                  var error, code, param, card, exp, err, result, _param, _err;

                  return _regenerator$9["default"].wrap(function _callee$(_context) {
                    while (1) {
                      switch (_context.prev = _context.next) {
                        case 0:
                          error = null;
                          code = null;
                          param = null;

                          if (!data) {
                            error = 'Card details are missing in `swell.card.createToken(card)`';
                            param = '';
                          }

                          card = toSnake$3(data);

                          if (!card.nonce) {
                            if (!this.validateNumber(card.number)) {
                              error = 'Card number appears to be invalid';
                              code = 'invalid_card_number';
                              param = 'number';
                            }

                            if (card.exp) {
                              exp = this.expiry(card.exp);
                              card.exp_month = exp.month;
                              card.exp_year = exp.year;
                            }

                            if (!this.validateExpiry(card.exp_month, card.exp_year)) {
                              error = 'Card expiry appears to be invalid';
                              code = 'invalid_card_expiry';
                              param = 'exp_month';
                            }

                            if (!this.validateCVC(card.cvc)) {
                              error = 'Card CVC code appears to be invalid';
                              code = 'invalid_card_cvc';
                              param = 'exp_cvc';
                            }
                          }

                          if (!error) {
                            _context.next = 12;
                            break;
                          }

                          err = new Error(error);
                          err.code = code || 'invalid_card';
                          err.status = 402;
                          err.param = param;
                          throw err;

                        case 12:
                          _context.next = 14;
                          return vaultRequest$1('post', '/tokens', card);

                        case 14:
                          result = _context.sent;

                          if (!result.errors) {
                            _context.next = 22;
                            break;
                          }

                          _param = Object.keys(result.errors)[0];
                          _err = new Error(result.errors[_param].message || 'Unknown error');
                          _err.code = 'vault_error';
                          _err.status = 402;
                          _err.param = _param;
                          throw _err;

                        case 22:
                          return _context.abrupt("return", result);

                        case 23:
                        case "end":
                          return _context.stop();
                      }
                    }
                  }, _callee, this);
                }));

                function createToken(_x) {
                  return _createToken.apply(this, arguments);
                }

                return createToken;
              }(),
              expiry: function expiry(value) {
                if (value && value.month && value.year) {
                  return value;
                }

                var parts = new String(value).split(/[\s\/\-]+/, 2);
                var month = parts[0];
                var year = parts[1]; // Convert 2 digit year

                if (year && year.length === 2 && /^\d+$/.test(year)) {
                  var prefix = new Date().getFullYear().toString().substring(0, 2);
                  year = prefix + year;
                }

                return {
                  month: ~~month,
                  year: ~~year
                };
              },
              types: function types() {
                var e, t, n, r;
                t = {};

                for (e = n = 40; n <= 49; e = ++n) {
                  t[e] = 'Visa';
                }

                for (e = r = 50; r <= 59; e = ++r) {
                  t[e] = 'MasterCard';
                }

                return t[34] = t[37] = 'American Express', t[60] = t[62] = t[64] = t[65] = 'Discover', t[35] = 'JCB', t[30] = t[36] = t[38] = t[39] = 'Diners Club', t;
              },
              type: function type(num) {
                return this.types()[num.slice(0, 2)] || 'Unknown';
              },
              luhnCheck: function luhnCheck(num) {
                var t, n, r, i, s, o;
                r = !0, i = 0, n = (num + '').split('').reverse();

                for (s = 0, o = n.length; s < o; s++) {
                  t = n[s], t = parseInt(t, 10);
                  if (r = !r) t *= 2;
                  t > 9 && (t -= 9), i += t;
                }

                return i % 10 === 0;
              },
              validateNumber: function validateNumber(num) {
                return num = (num + '').replace(/\s+|-/g, ''), num.length >= 10 && num.length <= 16 && this.luhnCheck(num);
              },
              validateExpiry: function validateExpiry(month, year) {
                var r, i;
                return month = String(month).trim(), year = String(year).trim(), /^\d+$/.test(month) ? /^\d+$/.test(year) ? parseInt(month, 10) <= 12 ? (i = new Date(year, month), r = new Date(), i.setMonth(i.getMonth() - 1), i.setMonth(i.getMonth() + 1, 1), i > r) : !1 : !1 : !1;
              },
              validateCVC: function validateCVC(val) {
                return val = String(val).trim(), /^\d+$/.test(val) && val.length >= 3 && val.length <= 4;
              }
            };
            var card = cardApi;

            var _defineProperty2$8 = interopRequireDefault(defineProperty$1);

            function ownKeys$8(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

            function _objectSpread$8(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys$8(Object(source), true).forEach(function (key) { (0, _defineProperty2$8["default"])(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys$8(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

            var isServer = utils.isServer;

            function getCookie$3(name) {
              if (isServer()) {
                return undefined;
              }

              var matches = document.cookie.match(new RegExp('(?:^|; )' + name.replace(/([.$?*|{}()[]\\\/\+^])/g, '\\$1') + '=([^;]*)'));
              return matches ? decodeURIComponent(matches[1]) : undefined;
            }

            function setCookie$3(name, value) {
              var options = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : {};

              if (isServer()) {
                return;
              }

              var date = new Date();
              date.setDate(date.getDate() + 7); // 1 week

              options = _objectSpread$8({
                path: '/',
                expires: date.toUTCString()
              }, options);

              if (options.expires && options.expires.toUTCString) {
                options.expires = options.expires.toUTCString();
              }

              var updatedCookie = encodeURIComponent(name) + '=' + encodeURIComponent(value);

              for (var optionKey in options) {
                updatedCookie += '; ' + optionKey;
                var optionValue = options[optionKey];

                if (optionValue !== true) {
                  updatedCookie += '=' + optionValue;
                }
              }

              document.cookie = updatedCookie;
            }

            var cookie = {
              getCookie: getCookie$3,
              setCookie: setCookie$3
            };

            var _regenerator$8 = interopRequireDefault(regenerator);

            var _asyncToGenerator2$8 = interopRequireDefault(asyncToGenerator);

            var _defineProperty2$7 = interopRequireDefault(defineProperty$1);

            var _typeof2$3 = interopRequireDefault(_typeof_1);

            function _createForOfIteratorHelper$2(o, allowArrayLike) { var it; if (typeof Symbol === "undefined" || o[Symbol.iterator] == null) { if (Array.isArray(o) || (it = _unsupportedIterableToArray$2(o)) || allowArrayLike && o && typeof o.length === "number") { if (it) o = it; var i = 0; var F = function F() {}; return { s: F, n: function n() { if (i >= o.length) return { done: true }; return { done: false, value: o[i++] }; }, e: function e(_e) { throw _e; }, f: F }; } throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); } var normalCompletion = true, didErr = false, err; return { s: function s() { it = o[Symbol.iterator](); }, n: function n() { var step = it.next(); normalCompletion = step.done; return step; }, e: function e(_e2) { didErr = true; err = _e2; }, f: function f() { try { if (!normalCompletion && it["return"] != null) it["return"](); } finally { if (didErr) throw err; } } }; }

            function _unsupportedIterableToArray$2(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray$2(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray$2(o, minLen); }

            function _arrayLikeToArray$2(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

            function ownKeys$7(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

            function _objectSpread$7(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys$7(Object(source), true).forEach(function (key) { (0, _defineProperty2$7["default"])(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys$7(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

            var get$3 = utils.get,
                _set$1 = utils.set,
                merge$1 = utils.merge,
                toCamel$3 = utils.toCamel,
                toCamelPath = utils.toCamelPath,
                getOptions = utils.getOptions;

            var RECORD_TIMEOUT = 5000;
            var VALUES = {
              /*
              [model]: {
                [id]: {
                  data,
                  record,
                  recordTimer,
                  presets,
                }
              }
              */
            };

            function debug$1() {
            }

            var cacheApi = {
              values: function values(_ref) {
                var model = _ref.model,
                    id = _ref.id;
                var setValues = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : undefined;
                debug$1.apply(void 0, ['cache.values'].concat(Array.prototype.slice.call(arguments)));

                if (setValues !== undefined) {
                  for (var key in setValues) {
                    _set$1(VALUES, "".concat(model, ".").concat(id, ".").concat(key), setValues[key]);
                  }

                  return;
                }

                return get$3(VALUES, "".concat(model, ".").concat(id), {});
              },
              preset: function preset(details) {
                debug$1.apply(void 0, ['cache.preset'].concat(Array.prototype.slice.call(arguments)));

                var _this$values = this.values(details),
                    _this$values$presets = _this$values.presets,
                    presets = _this$values$presets === void 0 ? [] : _this$values$presets;

                presets.push(details);
                this.values(details, {
                  presets: presets
                });
              },
              set: function set(details) {
                debug$1.apply(void 0, ['cache.set'].concat(Array.prototype.slice.call(arguments)));
                var model = details.model,
                    id = details.id,
                    path = details.path,
                    value = details.value;

                var _this$values2 = this.values(details),
                    _this$values2$data = _this$values2.data,
                    data = _this$values2$data === void 0 ? {} : _this$values2$data,
                    record = _this$values2.record;
                    _this$values2.presets;

                if (id === null) {
                  return;
                }

                if (record === undefined) {
                  return this.preset(details);
                }

                data = merge$1(record || {}, data);

                var _getOptions = getOptions(),
                    useCamelCase = _getOptions.useCamelCase;

                if (useCamelCase && value && (0, _typeof2$3["default"])(value) === 'object') {
                  value = toCamel$3(value);
                }

                if (path || value instanceof Array) {
                  var upData = _objectSpread$7({}, data || {});

                  var upPath = useCamelCase ? toCamelPath(path) : path;

                  _set$1(upData, upPath || '', value);

                  data = upData;
                } else if (value && (0, _typeof2$3["default"])(value) === 'object') {
                  data = data || {};
                  data = merge$1(data, value);
                } else {
                  data = value;
                }

                this.values(details, {
                  data: data
                }); // Make sure values have clean refs

                if (VALUES[model][id] !== undefined) {
                  VALUES[model][id] = JSON.parse(JSON.stringify(VALUES[model][id]));
                }
              },
              get: function get(model, id) {
                debug$1.apply(void 0, ['cache.get'].concat(Array.prototype.slice.call(arguments)));

                var _this$values3 = this.values({
                  model: model,
                  id: id
                }),
                    data = _this$values3.data,
                    recordTimer = _this$values3.recordTimer;

                debug$1.apply(void 0, ['cache.get:data+recordTimer'].concat(Array.prototype.slice.call(arguments)));

                if (recordTimer) {
                  return data;
                }
              },
              setRecord: function setRecord(record, details) {
                var _this = this;

                debug$1.apply(void 0, ['cache.setRecord'].concat(Array.prototype.slice.call(arguments)));

                var _this$values4 = this.values(details),
                    recordTimer = _this$values4.recordTimer,
                    presets = _this$values4.presets;

                if (recordTimer) {
                  clearTimeout(recordTimer);
                }

                recordTimer = setTimeout(function () {
                  _this.values(details, {
                    record: undefined,
                    recordTimer: undefined
                  });
                }, RECORD_TIMEOUT); // Record has to be an empty object at minimum

                this.values(details, {
                  record: record,
                  recordTimer: recordTimer
                });

                if (presets) {
                  var _iterator = _createForOfIteratorHelper$2(presets),
                      _step;

                  try {
                    for (_iterator.s(); !(_step = _iterator.n()).done;) {
                      var preset = _step.value;
                      this.set(preset);
                    }
                  } catch (err) {
                    _iterator.e(err);
                  } finally {
                    _iterator.f();
                  }

                  this.values(details, {
                    presets: undefined
                  });
                }

                var result = this.get(details.model, details.id);
                return result !== undefined ? result : record;
              },
              getFetch: function () {
                var _getFetch = (0, _asyncToGenerator2$8["default"])( /*#__PURE__*/_regenerator$8["default"].mark(function _callee(model, id, fetch) {
                  var value,
                      record,
                      _args = arguments;
                  return _regenerator$8["default"].wrap(function _callee$(_context) {
                    while (1) {
                      switch (_context.prev = _context.next) {
                        case 0:
                          debug$1.apply(void 0, ['cache.getFetch'].concat(Array.prototype.slice.call(_args)));
                          value = this.get(model, id);

                          if (!(value !== undefined)) {
                            _context.next = 4;
                            break;
                          }

                          return _context.abrupt("return", value);

                        case 4:
                          _context.next = 6;
                          return fetch();

                        case 6:
                          record = _context.sent;
                          return _context.abrupt("return", this.setRecord(record, {
                            model: model,
                            id: id
                          }));

                        case 8:
                        case "end":
                          return _context.stop();
                      }
                    }
                  }, _callee, this);
                }));

                function getFetch(_x, _x2, _x3) {
                  return _getFetch.apply(this, arguments);
                }

                return getFetch;
              }(),
              clear: function clear() {
                var model = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : undefined;
                var id = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : undefined;
                debug$1.apply(void 0, ['cache.clear'].concat(Array.prototype.slice.call(arguments)));

                if (model) {
                  if (id) {
                    _set$1(VALUES, "".concat(model, ".").concat(id), undefined);
                  } else {
                    _set$1(VALUES, model, undefined);
                  }
                } else {
                  VALUES = {};
                }
              }
            };
            var cache = cacheApi;

            function _arrayWithoutHoles(arr) {
              if (Array.isArray(arr)) {
                for (var i = 0, arr2 = new Array(arr.length); i < arr.length; i++) {
                  arr2[i] = arr[i];
                }

                return arr2;
              }
            }

            var arrayWithoutHoles = _arrayWithoutHoles;

            function _iterableToArray(iter) {
              if (Symbol.iterator in Object(iter) || Object.prototype.toString.call(iter) === "[object Arguments]") return Array.from(iter);
            }

            var iterableToArray = _iterableToArray;

            function _nonIterableSpread() {
              throw new TypeError("Invalid attempt to spread non-iterable instance");
            }

            var nonIterableSpread = _nonIterableSpread;

            function _toConsumableArray(arr) {
              return arrayWithoutHoles(arr) || iterableToArray(arr) || nonIterableSpread();
            }

            var toConsumableArray = _toConsumableArray;

            var _toConsumableArray2 = interopRequireDefault(toConsumableArray);

            var _typeof2$2 = interopRequireDefault(_typeof_1);

            var _defineProperty2$6 = interopRequireDefault(defineProperty$1);

            function _createForOfIteratorHelper$1(o, allowArrayLike) { var it; if (typeof Symbol === "undefined" || o[Symbol.iterator] == null) { if (Array.isArray(o) || (it = _unsupportedIterableToArray$1(o)) || allowArrayLike && o && typeof o.length === "number") { if (it) o = it; var i = 0; var F = function F() {}; return { s: F, n: function n() { if (i >= o.length) return { done: true }; return { done: false, value: o[i++] }; }, e: function e(_e) { throw _e; }, f: F }; } throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); } var normalCompletion = true, didErr = false, err; return { s: function s() { it = o[Symbol.iterator](); }, n: function n() { var step = it.next(); normalCompletion = step.done; return step; }, e: function e(_e2) { didErr = true; err = _e2; }, f: function f() { try { if (!normalCompletion && it["return"] != null) it["return"](); } finally { if (didErr) throw err; } } }; }

            function _unsupportedIterableToArray$1(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray$1(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray$1(o, minLen); }

            function _arrayLikeToArray$1(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

            function ownKeys$6(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

            function _objectSpread$6(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys$6(Object(source), true).forEach(function (key) { (0, _defineProperty2$6["default"])(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys$6(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

            var reduce$1 = utils.reduce,
                find$4 = utils.find,
                uniq = utils.uniq,
                defaultMethods$2 = utils.defaultMethods,
                toSnake$2 = utils.toSnake,
                toCamel$2 = utils.toCamel;



            var OPTIONS;

            function methods$a(request, opt) {
              OPTIONS = opt;

              var _defaultMethods = defaultMethods$2(request, '/products', ['list', 'get']),
                  _get = _defaultMethods.get,
                  list = _defaultMethods.list;

              return {
                get: function get(id) {
                  for (var _len = arguments.length, args = new Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
                    args[_key - 1] = arguments[_key];
                  }

                  return cache.getFetch('products', id, function () {
                    return _get.apply(void 0, [id].concat(args));
                  });
                },
                list: list,
                variation: calculateVariation,
                categories: getCategories,
                attributes: getAttributes,
                priceRange: getPriceRange,
                filters: getFilters
              };
            }

            function getProductOptionIndex(product) {
              var filter = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : undefined;

              if (!product.options) {
                return {};
              }

              var productOptions = filter ? product.options.filter(filter) : product.options;
              return reduce$1(productOptions, function (acc, op) {
                var _objectSpread3;

                var values = reduce$1(op.values, function (acc, val) {
                  var _objectSpread2;

                  return _objectSpread$6(_objectSpread$6({}, acc), {}, (_objectSpread2 = {}, (0, _defineProperty2$6["default"])(_objectSpread2, val.id, _objectSpread$6(_objectSpread$6({}, val), {}, {
                    id: val.id
                  })), (0, _defineProperty2$6["default"])(_objectSpread2, val.name, _objectSpread$6(_objectSpread$6({}, val), {}, {
                    id: val.id
                  })), _objectSpread2));
                }, {});
                return _objectSpread$6(_objectSpread$6({}, acc), {}, (_objectSpread3 = {}, (0, _defineProperty2$6["default"])(_objectSpread3, op.id, _objectSpread$6(_objectSpread$6({}, op), {}, {
                  values: values
                })), (0, _defineProperty2$6["default"])(_objectSpread3, op.name, _objectSpread$6(_objectSpread$6({}, op), {}, {
                  values: values
                })), _objectSpread3));
              }, {});
            }

            function cleanProductOptions$2(options) {
              var result = options || [];

              if (options && (0, _typeof2$2["default"])(options) === 'object' && !(options instanceof Array)) {
                result = [];

                for (var key in options) {
                  result.push({
                    id: key,
                    value: options[key]
                  });
                }
              }

              if (result instanceof Array) {
                return result.map(function (op) {
                  return {
                    id: op.id || op.name,
                    value: op.value
                  };
                });
              }

              return result;
            }

            function getVariantOptionValueIds(product, options) {
              var cleanOptions = cleanProductOptions$2(options);
              var index = getProductOptionIndex(product, function (op) {
                return op.variant;
              });
              var optionValueIds = [];

              var _iterator = _createForOfIteratorHelper$1(cleanOptions),
                  _step;

              try {
                for (_iterator.s(); !(_step = _iterator.n()).done;) {
                  var option = _step.value;

                  if (index[option.id] && index[option.id].values[option.value]) {
                    optionValueIds.push(index[option.id].values[option.value].id);
                  }
                }
              } catch (err) {
                _iterator.e(err);
              } finally {
                _iterator.f();
              }

              return optionValueIds;
            }

            function findVariantWithOptionValueIds(product, ids) {
              if (ids.length > 0) {
                var variants = product.variants && product.variants.results;

                if (variants.length > 0) {
                  var _iterator2 = _createForOfIteratorHelper$1(variants),
                      _step2;

                  try {
                    for (_iterator2.s(); !(_step2 = _iterator2.n()).done;) {
                      var variant = _step2.value;
                      var matched = true;

                      var _iterator3 = _createForOfIteratorHelper$1(ids),
                          _step3;

                      try {
                        for (_iterator3.s(); !(_step3 = _iterator3.n()).done;) {
                          var valueId = _step3.value;
                          var variantObj = toSnake$2(variant);

                          if (variantObj.option_value_ids && variantObj.option_value_ids.indexOf(valueId) === -1) {
                            matched = false;
                            break;
                          }
                        }
                      } catch (err) {
                        _iterator3.e(err);
                      } finally {
                        _iterator3.f();
                      }

                      if (matched) {
                        return variant;
                      }
                    }
                  } catch (err) {
                    _iterator2.e(err);
                  } finally {
                    _iterator2.f();
                  }
                }
              }

              return null;
            }

            function findVariantWithOptions(product, options) {
              var optionValueIds = getVariantOptionValueIds(product, options);
              return findVariantWithOptionValueIds(product, optionValueIds);
            }

            function calculateVariation(input, options) {
              var product = OPTIONS.useCamelCase ? toSnake$2(input) : input;

              var variation = _objectSpread$6(_objectSpread$6({}, product), {}, {
                price: product.price || 0,
                sale_price: product.sale_price,
                orig_price: product.orig_price,
                stock_status: product.stock_status
              });

              var optionPrice = 0;
              var variantOptionValueIds = [];
              var cleanOptions = cleanProductOptions$2(options);
              var index = getProductOptionIndex(product);

              var _iterator4 = _createForOfIteratorHelper$1(cleanOptions),
                  _step4;

              try {
                for (_iterator4.s(); !(_step4 = _iterator4.n()).done;) {
                  var option = _step4.value;

                  if (index[option.id] && index[option.id].values[option.value]) {
                    if (index[option.id].variant) {
                      variantOptionValueIds.push(index[option.id].values[option.value].id);
                    } else {
                      optionPrice += index[option.id].values[option.value].price || 0;
                    }
                  }
                }
              } catch (err) {
                _iterator4.e(err);
              } finally {
                _iterator4.f();
              }

              if (variantOptionValueIds.length > 0) {
                var variant = findVariantWithOptionValueIds(product, variantOptionValueIds);

                if (variant) {
                  variation.price = variant.price || 0;
                  variation.sale_price = variant.sale_price || product.sale_price;
                  variation.orig_price = variant.orig_price || product.orig_price;
                  variation.stock_status = variant.stock_status || product.stock_status;
                  variation.images = variant.images && variant.images.length ? variant.images : product.images;
                }
              }

              if (optionPrice > 0) {
                variation.price += optionPrice;

                if (variation.sale_price) {
                  variation.sale_price += optionPrice;
                }

                if (variation.orig_price) {
                  variation.orig_price += optionPrice;
                }
              }

              if (variation.sale_price === undefined) {
                delete variation.sale_price;
              }

              if (variation.orig_price === undefined) {
                delete variation.orig_price;
              }

              return OPTIONS.useCamelCase ? toCamel$2(variation) : variation;
            }

            function getFilters(products) {
              var options = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
              var attributes = (options.attributes || options.attributes === undefined) && getAttributes(products);
              var categories = (options.categories || options.categories === undefined) && getCategories(products);
              var priceRange = (options.price || options.price === undefined) && getPriceRange(products);
              var filters = [];

              if (priceRange) {
                filters.push({
                  id: 'price',
                  label: 'Price',
                  type: 'range',
                  options: [{
                    value: priceRange.min,
                    label: priceRange.min // TODO: formatting

                  }, {
                    value: priceRange.max,
                    label: priceRange.max // TODO: formatting

                  }],
                  interval: priceRange.interval
                });
              }

              if (categories && categories.length > 0) {
                filters.push({
                  id: 'category',
                  label: 'Category',
                  type: 'select',
                  options: categories.map(function (category) {
                    return {
                      value: category.slug,
                      label: category.name
                    };
                  })
                });
              }

              if (attributes && attributes.length > 0) {
                filters = [].concat((0, _toConsumableArray2["default"])(filters), (0, _toConsumableArray2["default"])(reduce$1(attributes, function (acc, attr) {
                  return [].concat((0, _toConsumableArray2["default"])(acc), (0, _toConsumableArray2["default"])(attr.id !== 'category' && attr.id !== 'price' && attr.values instanceof Array && attr.values.length > 0 ? [{
                    id: attr.id,
                    label: attr.name,
                    type: 'select',
                    options: attr.values.map(function (value) {
                      return {
                        value: value,
                        label: value
                      };
                    })
                  }] : []));
                }, [])));
              }

              return filters;
            }

            function getCategories(products) {
              var categories = [];
              var collection = products && products.results || (products.id ? [products] : products);

              if (collection instanceof Array) {
                var _iterator5 = _createForOfIteratorHelper$1(collection),
                    _step5;

                try {
                  for (_iterator5.s(); !(_step5 = _iterator5.n()).done;) {
                    var product = _step5.value;

                    if (product.categories) {
                      var _iterator6 = _createForOfIteratorHelper$1(product.categories),
                          _step6;

                      try {
                        for (_iterator6.s(); !(_step6 = _iterator6.n()).done;) {
                          var category = _step6.value;
                          if (!category) continue;
                          var ex = find$4(categories, {
                            id: category.id
                          });

                          if (!ex) {
                            categories.push(category);
                          }
                        }
                      } catch (err) {
                        _iterator6.e(err);
                      } finally {
                        _iterator6.f();
                      }
                    }
                  }
                } catch (err) {
                  _iterator5.e(err);
                } finally {
                  _iterator5.f();
                }
              }

              return categories;
            }

            function getAttributes(products) {
              var attributes = [];
              var collection = products && products.results || (products.id ? [products] : products);

              if (collection instanceof Array) {
                var _iterator7 = _createForOfIteratorHelper$1(collection),
                    _step7;

                try {
                  for (_iterator7.s(); !(_step7 = _iterator7.n()).done;) {
                    var product = _step7.value;

                    if (product.attributes) {
                      for (var id in product.attributes) {
                        if (!product.attributes[id]) continue;
                        var value = product.attributes[id].value;
                        var attr = find$4(attributes, {
                          id: id
                        });

                        if (attr) {
                          attr.values = uniq([].concat((0, _toConsumableArray2["default"])(attr.values), (0, _toConsumableArray2["default"])(value instanceof Array ? value : [value])));
                        } else {
                          attributes.push(_objectSpread$6(_objectSpread$6({}, product.attributes[id]), {}, {
                            value: undefined,
                            values: (0, _toConsumableArray2["default"])(value instanceof Array ? value : [value])
                          }));
                        }
                      }
                    }
                  }
                } catch (err) {
                  _iterator7.e(err);
                } finally {
                  _iterator7.f();
                }
              }

              return attributes;
            }

            function getPriceRange(products) {
              var min;
              var max;
              var interval;
              var collection = products && products.results || (products.id ? [products] : products);

              if (collection instanceof Array) {
                var _iterator8 = _createForOfIteratorHelper$1(collection),
                    _step8;

                try {
                  for (_iterator8.s(); !(_step8 = _iterator8.n()).done;) {
                    var product = _step8.value;

                    if (max === undefined || product.price > max) {
                      max = Math.ceil(product.price);
                    }

                    if (min === undefined || product.price < min) {
                      min = Math.floor(product.price);
                    }
                  }
                } catch (err) {
                  _iterator8.e(err);
                } finally {
                  _iterator8.f();
                }
              }

              if (min === max) {
                return null;
              }

              interval = Math.ceil((max - min) / 10) || 1;

              if (interval > 1000) {
                interval = 1000;
              } else if (interval > 100) {
                interval = 100;
              } else if (interval > 10) {
                interval = 10;
              }

              if (max % interval > 0) {
                max = interval + max - max % interval;
              }

              if (min % interval > 0) {
                min = min - min % interval;
              }

              while ((max - min) / interval % 1 > 0) {
                max++;
              }

              return {
                min: min,
                max: max,
                interval: interval
              };
            }

            var products = {
              methods: methods$a,
              cleanProductOptions: cleanProductOptions$2,
              getProductOptionIndex: getProductOptionIndex,
              getVariantOptionValueIds: getVariantOptionValueIds,
              findVariantWithOptions: findVariantWithOptions,
              calculateVariation: calculateVariation
            };

            var _defineProperty2$5 = interopRequireDefault(defineProperty$1);

            var _regenerator$7 = interopRequireDefault(regenerator);

            var _asyncToGenerator2$7 = interopRequireDefault(asyncToGenerator);

            function ownKeys$5(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

            function _objectSpread$5(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys$5(Object(source), true).forEach(function (key) { (0, _defineProperty2$5["default"])(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys$5(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

            var cloneDeep$1 = utils.cloneDeep;

            var cleanProductOptions$1 = products.cleanProductOptions;

            function methods$9(request, options) {
              return {
                state: null,
                order: null,
                settings: null,
                requested: false,
                pendingRequests: [],
                cacheClear: null,
                requestStateChange: function () {
                  var _requestStateChange = (0, _asyncToGenerator2$7["default"])( /*#__PURE__*/_regenerator$7["default"].mark(function _callee2(method, url, id, data) {
                    var _this = this;

                    return _regenerator$7["default"].wrap(function _callee2$(_context2) {
                      while (1) {
                        switch (_context2.prev = _context2.next) {
                          case 0:
                            return _context2.abrupt("return", this.requestStateSync( /*#__PURE__*/(0, _asyncToGenerator2$7["default"])( /*#__PURE__*/_regenerator$7["default"].mark(function _callee() {
                              var result;
                              return _regenerator$7["default"].wrap(function _callee$(_context) {
                                while (1) {
                                  switch (_context.prev = _context.next) {
                                    case 0:
                                      _context.next = 2;
                                      return request(method, url, id, data);

                                    case 2:
                                      result = _context.sent;

                                      if (!(result && result.errors)) {
                                        _context.next = 5;
                                        break;
                                      }

                                      return _context.abrupt("return", result);

                                    case 5:
                                      _this.state = result;
                                      return _context.abrupt("return", result);

                                    case 7:
                                    case "end":
                                      return _context.stop();
                                  }
                                }
                              }, _callee);
                            }))));

                          case 1:
                          case "end":
                            return _context2.stop();
                        }
                      }
                    }, _callee2, this);
                  }));

                  function requestStateChange(_x, _x2, _x3, _x4) {
                    return _requestStateChange.apply(this, arguments);
                  }

                  return requestStateChange;
                }(),
                requestStateSync: function () {
                  var _requestStateSync = (0, _asyncToGenerator2$7["default"])( /*#__PURE__*/_regenerator$7["default"].mark(function _callee3(handler) {
                    var _this2 = this;

                    var result, _this$pendingRequests, _handler, resolve;

                    return _regenerator$7["default"].wrap(function _callee3$(_context3) {
                      while (1) {
                        switch (_context3.prev = _context3.next) {
                          case 0:
                            if (!this.state) {
                              _context3.next = 6;
                              break;
                            }

                            _context3.next = 3;
                            return handler();

                          case 3:
                            return _context3.abrupt("return", _context3.sent);

                          case 6:
                            if (!this.requested) {
                              _context3.next = 8;
                              break;
                            }

                            return _context3.abrupt("return", new Promise(function (resolve) {
                              _this2.pendingRequests.push({
                                handler: handler,
                                resolve: resolve
                              });
                            }));

                          case 8:
                            this.requested = true;
                            _context3.next = 11;
                            return handler();

                          case 11:
                            result = _context3.sent;
                            this.requested = false;

                            while (this.pendingRequests.length > 0) {
                              _this$pendingRequests = this.pendingRequests.shift(), _handler = _this$pendingRequests.handler, resolve = _this$pendingRequests.resolve;
                              resolve(_handler());
                            }

                            return _context3.abrupt("return", result);

                          case 15:
                          case "end":
                            return _context3.stop();
                        }
                      }
                    }, _callee3, this);
                  }));

                  function requestStateSync(_x5) {
                    return _requestStateSync.apply(this, arguments);
                  }

                  return requestStateSync;
                }(),
                get: function get() {
                  var data;

                  if (this.cacheClear) {
                    this.cacheClear = null;
                    data = {
                      $cache: false
                    };
                  }

                  return this.requestStateChange('get', '/cart', undefined, data);
                },
                clearCache: function clearCache() {
                  this.cacheClear = true;
                },
                getItemData: function getItemData(item) {
                  var data = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
                  var result = cloneDeep$1(item);

                  if (typeof item === 'string') {
                    result = _objectSpread$5(_objectSpread$5({}, data || {}), {}, {
                      product_id: item
                    });
                  }

                  if (result && result.options) {
                    result.options = cleanProductOptions$1(result.options);
                  }

                  return result;
                },
                addItem: function addItem(item, data) {
                  return this.requestStateChange('post', '/cart/items', this.getItemData(item, data));
                },
                updateItem: function updateItem(id, item) {
                  return this.requestStateChange('put', "/cart/items/".concat(id), this.getItemData(item));
                },
                setItems: function setItems(input) {
                  var items = input;

                  if (items && items.map) {
                    items = items.map(this.getItemData);
                  }

                  return this.requestStateChange('put', '/cart/items', items);
                },
                removeItem: function removeItem(id) {
                  return this.requestStateChange('delete', "/cart/items/".concat(id));
                },
                recover: function recover(checkoutId) {
                  return this.requestStateChange('put', "/cart/recover/".concat(checkoutId));
                },
                update: function update(input) {
                  var data = input;

                  if (data.items && data.items.map) {
                    data = _objectSpread$5(_objectSpread$5({}, data), {}, {
                      items: data.items.map(this.getItemData)
                    });
                  }

                  return this.requestStateChange('put', "/cart", data);
                },
                applyCoupon: function applyCoupon(code) {
                  return this.requestStateChange('put', '/cart/coupon', {
                    code: code
                  });
                },
                removeCoupon: function removeCoupon() {
                  return this.requestStateChange('delete', '/cart/coupon');
                },
                applyGiftcard: function applyGiftcard(code) {
                  return this.requestStateChange('post', '/cart/giftcards', {
                    code: code
                  });
                },
                removeGiftcard: function removeGiftcard(id) {
                  return this.requestStateChange('delete', "/cart/giftcards/".concat(id));
                },
                getShippingRates: function () {
                  var _getShippingRates = (0, _asyncToGenerator2$7["default"])( /*#__PURE__*/_regenerator$7["default"].mark(function _callee4() {
                    return _regenerator$7["default"].wrap(function _callee4$(_context4) {
                      while (1) {
                        switch (_context4.prev = _context4.next) {
                          case 0:
                            _context4.next = 2;
                            return this.requestStateChange('get', '/cart/shipment-rating');

                          case 2:
                            return _context4.abrupt("return", this.state[options.useCamelCase ? 'shipmentRating' : 'shipment_rating']);

                          case 3:
                          case "end":
                            return _context4.stop();
                        }
                      }
                    }, _callee4, this);
                  }));

                  function getShippingRates() {
                    return _getShippingRates.apply(this, arguments);
                  }

                  return getShippingRates;
                }(),
                submitOrder: function () {
                  var _submitOrder = (0, _asyncToGenerator2$7["default"])( /*#__PURE__*/_regenerator$7["default"].mark(function _callee5() {
                    var result;
                    return _regenerator$7["default"].wrap(function _callee5$(_context5) {
                      while (1) {
                        switch (_context5.prev = _context5.next) {
                          case 0:
                            _context5.next = 2;
                            return request('post', '/cart/order');

                          case 2:
                            result = _context5.sent;

                            if (!result.errors) {
                              _context5.next = 5;
                              break;
                            }

                            return _context5.abrupt("return", result);

                          case 5:
                            this.state = null;
                            this.order = result;
                            return _context5.abrupt("return", result);

                          case 8:
                          case "end":
                            return _context5.stop();
                        }
                      }
                    }, _callee5, this);
                  }));

                  function submitOrder() {
                    return _submitOrder.apply(this, arguments);
                  }

                  return submitOrder;
                }(),
                getOrder: function () {
                  var _getOrder = (0, _asyncToGenerator2$7["default"])( /*#__PURE__*/_regenerator$7["default"].mark(function _callee6() {
                    var checkoutId,
                        result,
                        _args6 = arguments;
                    return _regenerator$7["default"].wrap(function _callee6$(_context6) {
                      while (1) {
                        switch (_context6.prev = _context6.next) {
                          case 0:
                            checkoutId = _args6.length > 0 && _args6[0] !== undefined ? _args6[0] : undefined;

                            if (!checkoutId) {
                              _context6.next = 7;
                              break;
                            }

                            _context6.next = 4;
                            return request('get', "/cart/order", {
                              checkout_id: checkoutId
                            });

                          case 4:
                            result = _context6.sent;
                            _context6.next = 10;
                            break;

                          case 7:
                            _context6.next = 9;
                            return request('get', "/cart/order");

                          case 9:
                            result = _context6.sent;

                          case 10:
                            this.order = result;
                            return _context6.abrupt("return", result);

                          case 12:
                          case "end":
                            return _context6.stop();
                        }
                      }
                    }, _callee6, this);
                  }));

                  function getOrder() {
                    return _getOrder.apply(this, arguments);
                  }

                  return getOrder;
                }(),
                getSettings: function () {
                  var _getSettings = (0, _asyncToGenerator2$7["default"])( /*#__PURE__*/_regenerator$7["default"].mark(function _callee7() {
                    return _regenerator$7["default"].wrap(function _callee7$(_context7) {
                      while (1) {
                        switch (_context7.prev = _context7.next) {
                          case 0:
                            _context7.next = 2;
                            return request('get', '/cart/settings');

                          case 2:
                            this.settings = _context7.sent;
                            return _context7.abrupt("return", this.settings);

                          case 4:
                          case "end":
                            return _context7.stop();
                        }
                      }
                    }, _callee7, this);
                  }));

                  function getSettings() {
                    return _getSettings.apply(this, arguments);
                  }

                  return getSettings;
                }()
              };
            }

            var cart = {
              methods: methods$9
            };

            var _regenerator$6 = interopRequireDefault(regenerator);

            var _asyncToGenerator2$6 = interopRequireDefault(asyncToGenerator);

            function methods$8(request) {
              return {
                state: null,
                requestStateChange: function () {
                  var _requestStateChange = (0, _asyncToGenerator2$6["default"])( /*#__PURE__*/_regenerator$6["default"].mark(function _callee(method, url, id, data) {
                    var result;
                    return _regenerator$6["default"].wrap(function _callee$(_context) {
                      while (1) {
                        switch (_context.prev = _context.next) {
                          case 0:
                            _context.next = 2;
                            return request(method, url, id, data);

                          case 2:
                            result = _context.sent;

                            if (!(result && result.errors)) {
                              _context.next = 5;
                              break;
                            }

                            return _context.abrupt("return", result);

                          case 5:
                            return _context.abrupt("return", this.state = result);

                          case 6:
                          case "end":
                            return _context.stop();
                        }
                      }
                    }, _callee, this);
                  }));

                  function requestStateChange(_x, _x2, _x3, _x4) {
                    return _requestStateChange.apply(this, arguments);
                  }

                  return requestStateChange;
                }(),
                get: function get(query) {
                  return this.requestStateChange('get', '/account', query);
                },
                create: function create(data) {
                  return this.requestStateChange('post', '/account', data);
                },
                update: function update(data) {
                  return this.requestStateChange('put', '/account', data);
                },
                login: function login(email, password) {
                  return this.requestStateChange('post', '/account/login', {
                    email: email,
                    password: password
                  });
                },
                logout: function logout() {
                  this.state = null;
                  return request('post', '/account/logout');
                },
                recover: function recover(data) {
                  return request('post', '/account/recover', data);
                },
                listAddresses: function listAddresses(query) {
                  return request('get', '/account/addresses', query);
                },
                createAddress: function createAddress(data) {
                  return request('post', '/account/addresses', data);
                },
                updateAddress: function updateAddress(id, data) {
                  return request('put', "/account/addresses/".concat(id), data);
                },
                deleteAddress: function deleteAddress(id) {
                  return request('delete', "/account/addresses/".concat(id));
                },
                listCards: function listCards(query) {
                  return request('get', '/account/cards', query);
                },
                createCard: function createCard(data) {
                  return request('post', '/account/cards', data);
                },
                updateCard: function updateCard(id, data) {
                  return request('put', "/account/cards/".concat(id), data);
                },
                deleteCard: function deleteCard(id) {
                  return request('delete', "/account/cards/".concat(id));
                },
                listOrders: function listOrders(query) {
                  return request('get', "/account/orders", query);
                },
                getOrder: function getOrder(id) {
                  return request('get', "/account/orders/".concat(id));
                },
                // Deprecated methods
                getAddresses: function getAddresses(query) {
                  return request('get', '/account/addresses', query);
                },
                getCards: function getCards(query) {
                  return request('get', '/account/cards', query);
                },
                getOrders: function getOrders(query) {
                  return request('get', "/account/orders", query);
                }
              };
            }

            var account = {
              methods: methods$8
            };

            var defaultMethods$1 = utils.defaultMethods;



            function methods$7(request) {
              var _defaultMethods = defaultMethods$1(request, '/categories', ['list', 'get']),
                  _get = _defaultMethods.get,
                  list = _defaultMethods.list;

              return {
                get: function get(id) {
                  for (var _len = arguments.length, args = new Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
                    args[_key - 1] = arguments[_key];
                  }

                  return cache.getFetch('categories', id, function () {
                    return _get.apply(void 0, [id].concat(args));
                  });
                },
                list: list
              };
            }

            var categories = {
              methods: methods$7
            };

            var defaultMethods = utils.defaultMethods;



            function methods$6(request) {
              var _defaultMethods = defaultMethods(request, '/attributes', ['list', 'get']),
                  _get = _defaultMethods.get,
                  list = _defaultMethods.list;

              return {
                get: function get(id) {
                  for (var _len = arguments.length, args = new Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
                    args[_key - 1] = arguments[_key];
                  }

                  return cache.getFetch('attributes', id, function () {
                    return _get.apply(void 0, [id].concat(args));
                  });
                },
                list: list
              };
            }

            var attributes = {
              methods: methods$6
            };

            var cleanProductOptions = products.cleanProductOptions;

            function methods$5(request) {
              return {
                get: function get(id, query) {
                  return request('get', '/subscriptions', id, query);
                },
                getCleanData: function getCleanData(data) {
                  if (data && data.options) {
                    data.options = cleanProductOptions(data.options);
                  }

                  if (data.items && data.items.map) {
                    data.items = data.items.map(function (item) {
                      if (item.options) {
                        item.options = cleanProductOptions(item.options);
                      }

                      return item;
                    });
                  }

                  return data;
                },
                create: function create(data) {
                  return request('post', '/subscriptions', this.getCleanData(data));
                },
                update: function update(id, data) {
                  return request('put', "/subscriptions/".concat(id), this.getCleanData(data));
                },
                addItem: function addItem(id, item) {
                  return request('post', "/subscriptions/".concat(id, "/items"), this.getCleanData(item));
                },
                setItems: function setItems(id, items) {
                  if (items && items.map) {
                    items = items.map(this.getCleanData);
                  }

                  return request('put', "/subscriptions/".concat(id, "/items"), items);
                },
                updateItem: function updateItem(id, itemId, item) {
                  return request('put', "/subscriptions/".concat(id, "/items/").concat(itemId), this.getCleanData(item));
                },
                removeItem: function removeItem(id, itemId) {
                  return request('delete', "/subscriptions/".concat(id, "/items/").concat(itemId));
                }
              };
            }

            var subscriptions = {
              methods: methods$5
            };

            var _defineProperty2$4 = interopRequireDefault(defineProperty$1);

            function ownKeys$4(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

            function _objectSpread$4(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys$4(Object(source), true).forEach(function (key) { (0, _defineProperty2$4["default"])(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys$4(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }



            function methods$4(request, opt) {
              return {
                get: function get(type, id, query) {
                  return cache.getFetch("content_".concat(type), id, function () {
                    return request('get', "/content/".concat(type), id, _objectSpread$4({
                      $preview: opt.previewContent
                    }, query || {}));
                  });
                },
                list: function list(type, query) {
                  return request('get', "/content/".concat(type), undefined, query);
                }
              };
            }

            var content = {
              methods: methods$4
            };

            var _regenerator$5 = interopRequireDefault(regenerator);

            var _asyncToGenerator2$5 = interopRequireDefault(asyncToGenerator);

            var _defineProperty2$3 = interopRequireDefault(defineProperty$1);

            var _typeof2$1 = interopRequireDefault(_typeof_1);

            function _createForOfIteratorHelper(o, allowArrayLike) { var it; if (typeof Symbol === "undefined" || o[Symbol.iterator] == null) { if (Array.isArray(o) || (it = _unsupportedIterableToArray(o)) || allowArrayLike && o && typeof o.length === "number") { if (it) o = it; var i = 0; var F = function F() {}; return { s: F, n: function n() { if (i >= o.length) return { done: true }; return { done: false, value: o[i++] }; }, e: function e(_e) { throw _e; }, f: F }; } throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); } var normalCompletion = true, didErr = false, err; return { s: function s() { it = o[Symbol.iterator](); }, n: function n() { var step = it.next(); normalCompletion = step.done; return step; }, e: function e(_e2) { didErr = true; err = _e2; }, f: function f() { try { if (!normalCompletion && it["return"] != null) it["return"](); } finally { if (didErr) throw err; } } }; }

            function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

            function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

            function ownKeys$3(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

            function _objectSpread$3(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys$3(Object(source), true).forEach(function (key) { (0, _defineProperty2$3["default"])(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys$3(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

            var get$2 = utils.get,
                find$3 = utils.find,
                _set = utils.set,
                merge = utils.merge,
                toCamel$1 = utils.toCamel,
                isObject$1 = utils.isObject,
                cloneDeep = utils.cloneDeep;

            function methods$3(request, opt) {
              return {
                state: null,
                menuState: null,
                paymentState: null,
                sessionState: null,
                locale: null,
                localizedState: {},
                refresh: function refresh() {
                  this.state = null;
                  this.menuState = null;
                  this.paymentState = null;
                  this.sessionState = null;
                  this.localizedState = {};
                  return this.get();
                },
                getState: function getState(uri, stateName) {
                  var _this = this;

                  var _ref = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : {},
                      _ref$id = _ref.id,
                      id = _ref$id === void 0 ? undefined : _ref$id,
                      _ref$def = _ref.def,
                      def = _ref$def === void 0 ? undefined : _ref$def,
                      _ref$refresh = _ref.refresh,
                      refresh = _ref$refresh === void 0 ? false : _ref$refresh;

                  if (!this[stateName] || refresh) {
                    this[stateName] = request('get', uri);
                  }

                  if (this[stateName] && typeof this[stateName].then === 'function') {
                    return this[stateName].then(function (state) {
                      _this[stateName] = state;
                      return _this.getLocalizedState(stateName, id, def);
                    });
                  }

                  return this.getLocalizedState(stateName, id, def);
                },
                getLocalizedState: function getLocalizedState(stateName, id, def) {
                  if (!this.locale) {
                    this.locale = opt.api.locale.selected();
                  }

                  var ls = this.localizedState;

                  if (ls.code !== this.locale) {
                    ls.code = this.locale;
                    delete ls[this.locale];
                  }

                  if (!ls[this.locale]) {
                    ls[this.locale] = {};
                  }

                  if (!ls[this.locale][stateName]) {
                    ls[this.locale][stateName] = this.decodeLocale(this[stateName]);
                  }

                  return id ? get$2(ls[this.locale][stateName], id, def) : ls[this.locale][stateName];
                },
                findState: function findState(uri, stateName) {
                  var _ref2 = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : {},
                      _ref2$where = _ref2.where,
                      where = _ref2$where === void 0 ? undefined : _ref2$where,
                      _ref2$def = _ref2.def,
                      def = _ref2$def === void 0 ? undefined : _ref2$def;

                  var state = this.getState(uri, stateName);

                  if (state && typeof state.then === 'function') {
                    return state.then(function (state) {
                      return find$3(state, where) || def;
                    });
                  }

                  return find$3(state, where) || def;
                },
                get: function get() {
                  var id = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : undefined;
                  var def = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : undefined;
                  return this.getState('/settings', 'state', {
                    id: id,
                    def: def
                  });
                },
                getStoreLocale: function getStoreLocale() {
                  return get$2(this.state, 'store.locale');
                },
                getStoreLocales: function getStoreLocales() {
                  return get$2(this.state, 'store.locales');
                },
                set: function set(_ref3) {
                  var model = _ref3.model,
                      path = _ref3.path,
                      value = _ref3.value;
                  var stateName = model ? "".concat(model.replace(/s$/, ''), "State") : 'state';
                  var useCamelCase = opt.useCamelCase;
                  var mergeData = {};

                  if (model === 'menus') {
                    if (path !== undefined) {
                      _set(mergeData, path || '', value);
                    } else {
                      mergeData = value;
                    }
                  } else {
                    _set(mergeData, path || '', value);
                  }

                  if (useCamelCase) {
                    mergeData = toCamel$1(mergeData);
                  }

                  this[stateName] = merge(this[stateName], mergeData);

                  if (this.localizedState[this.locale]) {
                    this.localizedState[this.locale][stateName] = this.decodeLocale(this[stateName]);
                  }
                },
                menus: function menus() {
                  var id = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : undefined;
                  var def = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : undefined;
                  return this.findState('/settings/menus', 'menuState', {
                    where: {
                      id: id
                    },
                    def: def
                  });
                },
                payments: function payments() {
                  var id = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : undefined;
                  var def = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : undefined;
                  return this.getState('/settings/payments', 'paymentState', {
                    id: id,
                    def: def
                  });
                },
                session: function session() {
                  var id = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : undefined;
                  var def = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : undefined;
                  return this.getState('/session', 'sessionState', {
                    id: id,
                    def: def
                  });
                },
                decodeLocale: function decodeLocale(values) {
                  if (!values || (0, _typeof2$1["default"])(values) !== 'object') {
                    return values;
                  }

                  var configs = this.getStoreLocales();

                  if (configs) {
                    configs = configs.reduce(function (acc, config) {
                      return _objectSpread$3(_objectSpread$3({}, acc), {}, (0, _defineProperty2$3["default"])({}, config.code, config));
                    }, {});
                  } else {
                    configs = {};
                  }

                  return decodeLocaleObjects(cloneDeep(values), this.locale, configs);
                },
                load: function () {
                  var _load = (0, _asyncToGenerator2$5["default"])( /*#__PURE__*/_regenerator$5["default"].mark(function _callee() {
                    var _yield$request, settings, menus, payments, session;

                    return _regenerator$5["default"].wrap(function _callee$(_context) {
                      while (1) {
                        switch (_context.prev = _context.next) {
                          case 0:
                            _context.prev = 0;
                            _context.next = 3;
                            return request('get', '/settings/all');

                          case 3:
                            _yield$request = _context.sent;
                            settings = _yield$request.settings;
                            menus = _yield$request.menus;
                            payments = _yield$request.payments;
                            session = _yield$request.session;
                            this.state = settings;
                            this.menuState = menus;
                            this.paymentState = payments;
                            this.sessionState = session;
                            this.localizedState = {};
                            _context.next = 18;
                            break;

                          case 15:
                            _context.prev = 15;
                            _context.t0 = _context["catch"](0);
                            console.error("Swell: unable to loading settings (".concat(_context.t0, ")"));

                          case 18:
                          case "end":
                            return _context.stop();
                        }
                      }
                    }, _callee, this, [[0, 15]]);
                  }));

                  function load() {
                    return _load.apply(this, arguments);
                  }

                  return load;
                }()
              };
            }

            function decodeLocaleObjects(values, locale, configs) {
              if (isObject$1(values)) {
                var keys = Object.keys(values);

                for (var _i = 0, _keys = keys; _i < _keys.length; _i++) {
                  var key = _keys[_i];

                  if (key == '$locale') {
                    decodeLocaleValue(locale, values, key, configs);
                    delete values.$locale;
                  }

                  if (values[key] !== undefined) {
                    values[key] = decodeLocaleObjects(values[key], locale, configs);
                  }
                }
              } else if (values instanceof Array) {
                for (var i = 0; i < values.length; i++) {
                  values[i] = decodeLocaleObjects(values[i], locale, configs);
                }
              }

              return values;
            }

            function decodeLocaleValue(locale, values, key, configs) {
              if (!locale || !isObject$1(values[key])) {
                return;
              }

              var returnLocaleKey;
              var returnLocaleConfig;
              var localeKeys = Object.keys(values[key]);

              for (var _i2 = 0, _localeKeys = localeKeys; _i2 < _localeKeys.length; _i2++) {
                var localeKey = _localeKeys[_i2];
                var shortKey = localeKey.replace(/\-.+$/, '');

                if (localeKey === locale || shortKey === locale) {
                  returnLocaleKey = localeKey;
                  returnLocaleConfig = configs[localeKey];
                }
              } // Find configured locale for fallback


              if (!returnLocaleKey && isObject$1(configs)) {
                var _localeKeys2 = Object.keys(configs);

                for (var _i3 = 0, _localeKeys3 = _localeKeys2; _i3 < _localeKeys3.length; _i3++) {
                  var _localeKey = _localeKeys3[_i3];

                  var _shortKey = _localeKey.replace(/\-.+$/, '');

                  if (_localeKey === locale || _shortKey === locale) {
                    returnLocaleKey = _localeKey;
                    returnLocaleConfig = configs[_localeKey];
                  }
                }
              } // Find fallback key and values if applicable


              var fallbackKeys;
              var fallbackValues = {};

              if (returnLocaleConfig) {
                var fallbackKey = returnLocaleConfig.fallback;
                var origFallbackKey = fallbackKey;

                while (fallbackKey) {
                  fallbackKeys = fallbackKeys || [];
                  fallbackKeys.push(fallbackKey);
                  fallbackValues = _objectSpread$3(_objectSpread$3({}, values[key][fallbackKey] || {}), fallbackValues);
                  fallbackKey = configs[fallbackKey] && configs[fallbackKey].fallback;

                  if (origFallbackKey === fallbackKey) {
                    break;
                  }
                }
              } // Merge locale value with fallbacks


              var localeValues = _objectSpread$3(_objectSpread$3({}, fallbackValues), values[key][returnLocaleKey] || {});

              var valueKeys = Object.keys(localeValues);

              for (var _i4 = 0, _valueKeys = valueKeys; _i4 < _valueKeys.length; _i4++) {
                var valueKey = _valueKeys[_i4];
                var hasValue = localeValues[valueKey] !== null && localeValues[valueKey] !== '';
                var shouldFallback = fallbackKeys && !hasValue;

                if (shouldFallback) {
                  var _iterator = _createForOfIteratorHelper(fallbackKeys),
                      _step;

                  try {
                    for (_iterator.s(); !(_step = _iterator.n()).done;) {
                      var _fallbackKey = _step.value;
                      shouldFallback = !values[key][_fallbackKey] || values[key][_fallbackKey][valueKey] === null || values[key][_fallbackKey][valueKey] === '';

                      if (shouldFallback) {
                        if (_fallbackKey === 'none') {
                          values[valueKey] = null;
                          break;
                        }

                        continue;
                      } else {
                        values[valueKey] = values[key][_fallbackKey][valueKey];
                        break;
                      }
                    }
                  } catch (err) {
                    _iterator.e(err);
                  } finally {
                    _iterator.f();
                  }
                } else {
                  if (hasValue) {
                    values[valueKey] = localeValues[valueKey];
                  }
                }
              }
            }

            var settings = {
              methods: methods$3
            };

            /**
             * Converts `string`, as a whole, to lower case just like
             * [String#toLowerCase](https://mdn.io/toLowerCase).
             *
             * @static
             * @memberOf _
             * @since 4.0.0
             * @category String
             * @param {string} [string=''] The string to convert.
             * @returns {string} Returns the lower cased string.
             * @example
             *
             * _.toLower('--Foo-Bar--');
             * // => '--foo-bar--'
             *
             * _.toLower('fooBar');
             * // => 'foobar'
             *
             * _.toLower('__FOO_BAR__');
             * // => '__foo_bar__'
             */
            function toLower(value) {
              return toString_1(value).toLowerCase();
            }

            var toLower_1 = toLower;

            /**
             * Creates a base function for methods like `_.forIn` and `_.forOwn`.
             *
             * @private
             * @param {boolean} [fromRight] Specify iterating from right to left.
             * @returns {Function} Returns the new base function.
             */
            function createBaseFor(fromRight) {
              return function(object, iteratee, keysFunc) {
                var index = -1,
                    iterable = Object(object),
                    props = keysFunc(object),
                    length = props.length;

                while (length--) {
                  var key = props[fromRight ? length : ++index];
                  if (iteratee(iterable[key], key, iterable) === false) {
                    break;
                  }
                }
                return object;
              };
            }

            var _createBaseFor = createBaseFor;

            /**
             * The base implementation of `baseForOwn` which iterates over `object`
             * properties returned by `keysFunc` and invokes `iteratee` for each property.
             * Iteratee functions may exit iteration early by explicitly returning `false`.
             *
             * @private
             * @param {Object} object The object to iterate over.
             * @param {Function} iteratee The function invoked per iteration.
             * @param {Function} keysFunc The function to get the keys of `object`.
             * @returns {Object} Returns `object`.
             */
            var baseFor = _createBaseFor();

            var _baseFor = baseFor;

            /**
             * The base implementation of `_.forOwn` without support for iteratee shorthands.
             *
             * @private
             * @param {Object} object The object to iterate over.
             * @param {Function} iteratee The function invoked per iteration.
             * @returns {Object} Returns `object`.
             */
            function baseForOwn(object, iteratee) {
              return object && _baseFor(object, iteratee, keys_1);
            }

            var _baseForOwn = baseForOwn;

            /**
             * Creates a `baseEach` or `baseEachRight` function.
             *
             * @private
             * @param {Function} eachFunc The function to iterate over a collection.
             * @param {boolean} [fromRight] Specify iterating from right to left.
             * @returns {Function} Returns the new base function.
             */
            function createBaseEach(eachFunc, fromRight) {
              return function(collection, iteratee) {
                if (collection == null) {
                  return collection;
                }
                if (!isArrayLike_1(collection)) {
                  return eachFunc(collection, iteratee);
                }
                var length = collection.length,
                    index = fromRight ? length : -1,
                    iterable = Object(collection);

                while ((fromRight ? index-- : ++index < length)) {
                  if (iteratee(iterable[index], index, iterable) === false) {
                    break;
                  }
                }
                return collection;
              };
            }

            var _createBaseEach = createBaseEach;

            /**
             * The base implementation of `_.forEach` without support for iteratee shorthands.
             *
             * @private
             * @param {Array|Object} collection The collection to iterate over.
             * @param {Function} iteratee The function invoked per iteration.
             * @returns {Array|Object} Returns `collection`.
             */
            var baseEach = _createBaseEach(_baseForOwn);

            var _baseEach = baseEach;

            /**
             * The base implementation of `_.reduce` and `_.reduceRight`, without support
             * for iteratee shorthands, which iterates over `collection` using `eachFunc`.
             *
             * @private
             * @param {Array|Object} collection The collection to iterate over.
             * @param {Function} iteratee The function invoked per iteration.
             * @param {*} accumulator The initial value.
             * @param {boolean} initAccum Specify using the first or last element of
             *  `collection` as the initial value.
             * @param {Function} eachFunc The function to iterate over `collection`.
             * @returns {*} Returns the accumulated value.
             */
            function baseReduce(collection, iteratee, accumulator, initAccum, eachFunc) {
              eachFunc(collection, function(value, index, collection) {
                accumulator = initAccum
                  ? (initAccum = false, value)
                  : iteratee(accumulator, value, index, collection);
              });
              return accumulator;
            }

            var _baseReduce = baseReduce;

            /**
             * Reduces `collection` to a value which is the accumulated result of running
             * each element in `collection` thru `iteratee`, where each successive
             * invocation is supplied the return value of the previous. If `accumulator`
             * is not given, the first element of `collection` is used as the initial
             * value. The iteratee is invoked with four arguments:
             * (accumulator, value, index|key, collection).
             *
             * Many lodash methods are guarded to work as iteratees for methods like
             * `_.reduce`, `_.reduceRight`, and `_.transform`.
             *
             * The guarded methods are:
             * `assign`, `defaults`, `defaultsDeep`, `includes`, `merge`, `orderBy`,
             * and `sortBy`
             *
             * @static
             * @memberOf _
             * @since 0.1.0
             * @category Collection
             * @param {Array|Object} collection The collection to iterate over.
             * @param {Function} [iteratee=_.identity] The function invoked per iteration.
             * @param {*} [accumulator] The initial value.
             * @returns {*} Returns the accumulated value.
             * @see _.reduceRight
             * @example
             *
             * _.reduce([1, 2], function(sum, n) {
             *   return sum + n;
             * }, 0);
             * // => 3
             *
             * _.reduce({ 'a': 1, 'b': 2, 'c': 1 }, function(result, value, key) {
             *   (result[value] || (result[value] = [])).push(key);
             *   return result;
             * }, {});
             * // => { '1': ['a', 'c'], '2': ['b'] } (iteration order is not guaranteed)
             */
            function reduce(collection, iteratee, accumulator) {
              var func = isArray_1(collection) ? _arrayReduce : _baseReduce,
                  initAccum = arguments.length < 3;

              return func(collection, _baseIteratee(iteratee), accumulator, initAccum, _baseEach);
            }

            var reduce_1 = reduce;

            /** `Object#toString` result references. */
            var mapTag = '[object Map]',
                setTag = '[object Set]';

            /** Used for built-in method references. */
            var objectProto = Object.prototype;

            /** Used to check objects for own properties. */
            var hasOwnProperty$2 = objectProto.hasOwnProperty;

            /**
             * Checks if `value` is an empty object, collection, map, or set.
             *
             * Objects are considered empty if they have no own enumerable string keyed
             * properties.
             *
             * Array-like values such as `arguments` objects, arrays, buffers, strings, or
             * jQuery-like collections are considered empty if they have a `length` of `0`.
             * Similarly, maps and sets are considered empty if they have a `size` of `0`.
             *
             * @static
             * @memberOf _
             * @since 0.1.0
             * @category Lang
             * @param {*} value The value to check.
             * @returns {boolean} Returns `true` if `value` is empty, else `false`.
             * @example
             *
             * _.isEmpty(null);
             * // => true
             *
             * _.isEmpty(true);
             * // => true
             *
             * _.isEmpty(1);
             * // => true
             *
             * _.isEmpty([1, 2, 3]);
             * // => false
             *
             * _.isEmpty({ 'a': 1 });
             * // => false
             */
            function isEmpty(value) {
              if (value == null) {
                return true;
              }
              if (isArrayLike_1(value) &&
                  (isArray_1(value) || typeof value == 'string' || typeof value.splice == 'function' ||
                    isBuffer_1(value) || isTypedArray_1(value) || isArguments_1(value))) {
                return !value.length;
              }
              var tag = _getTag(value);
              if (tag == mapTag || tag == setTag) {
                return !value.size;
              }
              if (_isPrototype(value)) {
                return !_baseKeys(value).length;
              }
              for (var key in value) {
                if (hasOwnProperty$2.call(value, key)) {
                  return false;
                }
              }
              return true;
            }

            var isEmpty_1 = isEmpty;

            /**
             * The base implementation of `_.map` without support for iteratee shorthands.
             *
             * @private
             * @param {Array|Object} collection The collection to iterate over.
             * @param {Function} iteratee The function invoked per iteration.
             * @returns {Array} Returns the new mapped array.
             */
            function baseMap(collection, iteratee) {
              var index = -1,
                  result = isArrayLike_1(collection) ? Array(collection.length) : [];

              _baseEach(collection, function(value, key, collection) {
                result[++index] = iteratee(value, key, collection);
              });
              return result;
            }

            var _baseMap = baseMap;

            /**
             * Creates an array of values by running each element in `collection` thru
             * `iteratee`. The iteratee is invoked with three arguments:
             * (value, index|key, collection).
             *
             * Many lodash methods are guarded to work as iteratees for methods like
             * `_.every`, `_.filter`, `_.map`, `_.mapValues`, `_.reject`, and `_.some`.
             *
             * The guarded methods are:
             * `ary`, `chunk`, `curry`, `curryRight`, `drop`, `dropRight`, `every`,
             * `fill`, `invert`, `parseInt`, `random`, `range`, `rangeRight`, `repeat`,
             * `sampleSize`, `slice`, `some`, `sortBy`, `split`, `take`, `takeRight`,
             * `template`, `trim`, `trimEnd`, `trimStart`, and `words`
             *
             * @static
             * @memberOf _
             * @since 0.1.0
             * @category Collection
             * @param {Array|Object} collection The collection to iterate over.
             * @param {Function} [iteratee=_.identity] The function invoked per iteration.
             * @returns {Array} Returns the new mapped array.
             * @example
             *
             * function square(n) {
             *   return n * n;
             * }
             *
             * _.map([4, 8], square);
             * // => [16, 64]
             *
             * _.map({ 'a': 4, 'b': 8 }, square);
             * // => [16, 64] (iteration order is not guaranteed)
             *
             * var users = [
             *   { 'user': 'barney' },
             *   { 'user': 'fred' }
             * ];
             *
             * // The `_.property` iteratee shorthand.
             * _.map(users, 'user');
             * // => ['barney', 'fred']
             */
            function map$2(collection, iteratee) {
              var func = isArray_1(collection) ? _arrayMap : _baseMap;
              return func(collection, _baseIteratee(iteratee));
            }

            var map_1 = map$2;

            var _regenerator$4 = interopRequireDefault(regenerator);

            var _asyncToGenerator2$4 = interopRequireDefault(asyncToGenerator);

            var _defineProperty2$2 = interopRequireDefault(defineProperty$1);

            function ownKeys$2(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

            function _objectSpread$2(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys$2(Object(source), true).forEach(function (key) { (0, _defineProperty2$2["default"])(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys$2(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }













            var addressFieldsMap = {
              city: 'city',
              country: 'country',
              line1: 'address1',
              line2: 'address2',
              postal_code: 'zip',
              state: 'state'
            };
            var billingFieldsMap = {
              name: 'name',
              phone: 'phone'
            };

            function getBillingDetails(data) {
              var _data$account = data.account,
                  account = _data$account === void 0 ? {} : _data$account,
                  billing = data.billing,
                  shipping = data.shipping;

              var billingData = _objectSpread$2(_objectSpread$2(_objectSpread$2(_objectSpread$2({}, account.shipping), account.billing), shipping), billing);

              var fillValues = function fillValues(fieldsMap) {
                return reduce_1(fieldsMap, function (acc, value, key) {
                  var billingValue = billingData[value];

                  if (billingValue) {
                    acc[key] = billingValue;
                  }

                  return acc;
                }, {});
              };

              var billingDetails = fillValues(billingFieldsMap);

              if (!isEmpty_1(billingDetails)) {
                var address = fillValues(addressFieldsMap);
                return _objectSpread$2(_objectSpread$2({}, billingDetails), !isEmpty_1(address) ? {
                  address: address
                } : {});
              }
            }

            function getKlarnaItems(cart) {
              var currency = toLower_1(get_1(cart, 'currency', 'eur'));
              var items = map_1(cart.items, function (item) {
                return {
                  type: 'sku',
                  description: item.product.name,
                  quantity: item.quantity,
                  currency: currency,
                  amount: Math.round(toNumber_1(item.price_total - item.discount_total) * 100)
                };
              });
              var tax = get_1(cart, 'tax_included_total');

              if (tax) {
                items.push({
                  type: 'tax',
                  description: 'Taxes',
                  currency: currency,
                  amount: Math.round(toNumber_1(tax) * 100)
                });
              }

              var shipping = get_1(cart, 'shipping', {});
              var shippingTotal = get_1(cart, 'shipment_total', {});

              if (shipping.price) {
                items.push({
                  type: 'shipping',
                  description: shipping.service_name,
                  currency: currency,
                  amount: Math.round(toNumber_1(shippingTotal) * 100)
                });
              }

              return items;
            }

            function setKlarnaBillingShipping(source, data) {
              var shippingNameFieldsMap = {
                shipping_first_name: 'first_name',
                shipping_last_name: 'last_name'
              };
              var shippingFieldsMap = {
                phone: 'phone'
              };
              var billingNameFieldsMap = {
                first_name: 'first_name',
                last_name: 'last_name'
              };
              var billingFieldsMap = {
                email: 'email'
              };

              var fillValues = function fillValues(fieldsMap, data) {
                return reduce_1(fieldsMap, function (acc, srcKey, destKey) {
                  var value = data[srcKey];

                  if (value) {
                    acc[destKey] = value;
                  }

                  return acc;
                }, {});
              };

              source.klarna = _objectSpread$2(_objectSpread$2({}, source.klarna), fillValues(shippingNameFieldsMap, data.shipping));
              var shipping = fillValues(shippingFieldsMap, data.shipping);
              var shippingAddress = fillValues(addressFieldsMap, data.shipping);

              if (shipping || shippingAddress) {
                source.source_order.shipping = _objectSpread$2(_objectSpread$2({}, shipping ? shipping : {}), shippingAddress ? {
                  address: shippingAddress
                } : {});
              }

              source.klarna = _objectSpread$2(_objectSpread$2({}, source.klarna), fillValues(billingNameFieldsMap, data.billing || get_1(data, 'account.billing') || data.shipping));
              var billing = fillValues(billingFieldsMap, data.account);
              var billingAddress = fillValues(addressFieldsMap, data.billing || get_1(data, 'account.billing') || data.shipping);

              if (billing || billingAddress) {
                source.owner = _objectSpread$2(_objectSpread$2({}, billing ? billing : {}), billingAddress ? {
                  address: billingAddress
                } : {});
              }
            }

            function setBancontactOwner(source, data) {
              var fillValues = function fillValues(fieldsMap, data) {
                return reduce_1(fieldsMap, function (acc, srcKey, destKey) {
                  var value = data[srcKey];

                  if (value) {
                    acc[destKey] = value;
                  }

                  return acc;
                }, {});
              };

              var _data$account2 = data.account,
                  account = _data$account2 === void 0 ? {} : _data$account2,
                  billing = data.billing,
                  shipping = data.shipping;

              var billingData = _objectSpread$2(_objectSpread$2(_objectSpread$2(_objectSpread$2({}, account.shipping), account.billing), shipping), billing);

              var billingAddress = fillValues(addressFieldsMap, billingData);
              source.owner = _objectSpread$2(_objectSpread$2({
                email: account.email,
                name: billingData.name || account.name
              }, billingData.phone ? {
                phone: billingData.phone
              } : account.phone ? {
                phone: account.phone
              } : {}), !isEmpty_1(billingAddress) ? {
                address: billingAddress
              } : {});
            }

            function createPaymentMethod$1(_x, _x2, _x3) {
              return _createPaymentMethod.apply(this, arguments);
            }

            function _createPaymentMethod() {
              _createPaymentMethod = (0, _asyncToGenerator2$4["default"])( /*#__PURE__*/_regenerator$4["default"].mark(function _callee(stripe, cardElement, cart) {
                var billingDetails, _yield$stripe$createP, error, paymentMethod;

                return _regenerator$4["default"].wrap(function _callee$(_context) {
                  while (1) {
                    switch (_context.prev = _context.next) {
                      case 0:
                        billingDetails = getBillingDetails(cart);
                        _context.next = 3;
                        return stripe.createPaymentMethod(_objectSpread$2({
                          type: 'card',
                          card: cardElement
                        }, billingDetails ? {
                          billing_details: billingDetails
                        } : {}));

                      case 3:
                        _yield$stripe$createP = _context.sent;
                        error = _yield$stripe$createP.error;
                        paymentMethod = _yield$stripe$createP.paymentMethod;
                        return _context.abrupt("return", error ? {
                          error: error
                        } : {
                          token: paymentMethod.id,
                          last4: paymentMethod.card.last4,
                          exp_month: paymentMethod.card.exp_month,
                          exp_year: paymentMethod.card.exp_year,
                          brand: paymentMethod.card.brand,
                          address_check: paymentMethod.card.checks.address_line1_check,
                          cvc_check: paymentMethod.card.checks.cvc_check,
                          zip_check: paymentMethod.card.checks.address_zip_check
                        });

                      case 7:
                      case "end":
                        return _context.stop();
                    }
                  }
                }, _callee);
              }));
              return _createPaymentMethod.apply(this, arguments);
            }

            function createIDealPaymentMethod$1(_x4, _x5) {
              return _createIDealPaymentMethod.apply(this, arguments);
            }

            function _createIDealPaymentMethod() {
              _createIDealPaymentMethod = (0, _asyncToGenerator2$4["default"])( /*#__PURE__*/_regenerator$4["default"].mark(function _callee2(stripe, element) {
                var billing,
                    billingDetails,
                    _args2 = arguments;
                return _regenerator$4["default"].wrap(function _callee2$(_context2) {
                  while (1) {
                    switch (_context2.prev = _context2.next) {
                      case 0:
                        billing = _args2.length > 2 && _args2[2] !== undefined ? _args2[2] : {};
                        billingDetails = getBillingDetails(billing);
                        _context2.next = 4;
                        return stripe.createPaymentMethod(_objectSpread$2({
                          type: 'ideal',
                          ideal: element
                        }, billingDetails ? {
                          billing_details: billingDetails
                        } : {}));

                      case 4:
                        return _context2.abrupt("return", _context2.sent);

                      case 5:
                      case "end":
                        return _context2.stop();
                    }
                  }
                }, _callee2);
              }));
              return _createIDealPaymentMethod.apply(this, arguments);
            }

            function createKlarnaSource$1(_x6, _x7) {
              return _createKlarnaSource.apply(this, arguments);
            }

            function _createKlarnaSource() {
              _createKlarnaSource = (0, _asyncToGenerator2$4["default"])( /*#__PURE__*/_regenerator$4["default"].mark(function _callee3(stripe, cart) {
                var sourceObject;
                return _regenerator$4["default"].wrap(function _callee3$(_context3) {
                  while (1) {
                    switch (_context3.prev = _context3.next) {
                      case 0:
                        sourceObject = {
                          type: 'klarna',
                          flow: 'redirect',
                          amount: Math.round(get_1(cart, 'grand_total', 0) * 100),
                          currency: toLower_1(get_1(cart, 'currency', 'eur')),
                          klarna: {
                            product: 'payment',
                            purchase_country: get_1(cart, 'settings.country', 'DE')
                          },
                          source_order: {
                            items: getKlarnaItems(cart)
                          },
                          redirect: {
                            return_url: window.location.href
                          }
                        };
                        setKlarnaBillingShipping(sourceObject, cart);
                        _context3.next = 4;
                        return stripe.createSource(sourceObject);

                      case 4:
                        return _context3.abrupt("return", _context3.sent);

                      case 5:
                      case "end":
                        return _context3.stop();
                    }
                  }
                }, _callee3);
              }));
              return _createKlarnaSource.apply(this, arguments);
            }

            function createBancontactSource$1(_x8, _x9) {
              return _createBancontactSource.apply(this, arguments);
            }

            function _createBancontactSource() {
              _createBancontactSource = (0, _asyncToGenerator2$4["default"])( /*#__PURE__*/_regenerator$4["default"].mark(function _callee4(stripe, cart) {
                var sourceObject;
                return _regenerator$4["default"].wrap(function _callee4$(_context4) {
                  while (1) {
                    switch (_context4.prev = _context4.next) {
                      case 0:
                        sourceObject = {
                          type: 'bancontact',
                          amount: Math.round(get_1(cart, 'grand_total', 0) * 100),
                          currency: toLower_1(get_1(cart, 'currency', 'eur')),
                          redirect: {
                            return_url: window.location.href
                          }
                        };
                        setBancontactOwner(sourceObject, cart);
                        _context4.next = 4;
                        return stripe.createSource(sourceObject);

                      case 4:
                        return _context4.abrupt("return", _context4.sent);

                      case 5:
                      case "end":
                        return _context4.stop();
                    }
                  }
                }, _callee4);
              }));
              return _createBancontactSource.apply(this, arguments);
            }

            function stripeAmountByCurrency$1(currency, amount) {
              var zeroDecimalCurrencies = ['BIF', // Burundian Franc
              'DJF', // Djiboutian Franc,
              'JPY', // Japanese Yen
              'KRW', // South Korean Won
              'PYG', // Paraguayan Guaraní
              'VND', // Vietnamese Đồng
              'XAF', // Central African Cfa Franc
              'XPF', // Cfp Franc
              'CLP', // Chilean Peso
              'GNF', // Guinean Franc
              'KMF', // Comorian Franc
              'MGA', // Malagasy Ariary
              'RWF', // Rwandan Franc
              'VUV', // Vanuatu Vatu
              'XOF' // West African Cfa Franc
              ];

              if (zeroDecimalCurrencies.includes(currency.toUpperCase())) {
                return amount;
              } else {
                return Math.round(amount * 100);
              }
            }

            var stripe = {
              createPaymentMethod: createPaymentMethod$1,
              createIDealPaymentMethod: createIDealPaymentMethod$1,
              createKlarnaSource: createKlarnaSource$1,
              createBancontactSource: createBancontactSource$1,
              stripeAmountByCurrency: stripeAmountByCurrency$1
            };

            var _defineProperty2$1 = interopRequireDefault(defineProperty$1);

            var _regenerator$3 = interopRequireDefault(regenerator);

            var _asyncToGenerator2$3 = interopRequireDefault(asyncToGenerator);

            function ownKeys$1(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

            function _objectSpread$1(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys$1(Object(source), true).forEach(function (key) { (0, _defineProperty2$1["default"])(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys$1(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }









            var isFunction$2 = utils.isFunction,
                vaultRequest = utils.vaultRequest,
                toSnake$1 = utils.toSnake;

            var createPaymentMethod = stripe.createPaymentMethod,
                createIDealPaymentMethod = stripe.createIDealPaymentMethod,
                createKlarnaSource = stripe.createKlarnaSource,
                createBancontactSource = stripe.createBancontactSource,
                stripeAmountByCurrency = stripe.stripeAmountByCurrency;

            var LOADING_SCRIPTS = {};
            var CARD_ELEMENTS = {};
            var API = {};

            function methods$2(request) {
              return {
                params: null,
                methodSettings: null,
                methods: function () {
                  var _methods = (0, _asyncToGenerator2$3["default"])( /*#__PURE__*/_regenerator$3["default"].mark(function _callee() {
                    var result;
                    return _regenerator$3["default"].wrap(function _callee$(_context) {
                      while (1) {
                        switch (_context.prev = _context.next) {
                          case 0:
                            if (!this.methodSettings) {
                              _context.next = 2;
                              break;
                            }

                            return _context.abrupt("return", this.methodSettings);

                          case 2:
                            _context.next = 4;
                            return request('get', '/payment/methods');

                          case 4:
                            result = _context.sent;
                            return _context.abrupt("return", this.methodSettings = result);

                          case 6:
                          case "end":
                            return _context.stop();
                        }
                      }
                    }, _callee, this);
                  }));

                  function methods() {
                    return _methods.apply(this, arguments);
                  }

                  return methods;
                }(),
                createElements: function () {
                  var _createElements = (0, _asyncToGenerator2$3["default"])( /*#__PURE__*/_regenerator$3["default"].mark(function _callee2(elementParams) {
                    var cart$1, payMethods;
                    return _regenerator$3["default"].wrap(function _callee2$(_context2) {
                      while (1) {
                        switch (_context2.prev = _context2.next) {
                          case 0:
                            this.params = elementParams || {};
                            _context2.t0 = toSnake$1;
                            _context2.next = 4;
                            return cart.methods(request).get();

                          case 4:
                            _context2.t1 = _context2.sent;
                            cart$1 = (0, _context2.t0)(_context2.t1);

                            if (cart$1) {
                              _context2.next = 8;
                              break;
                            }

                            throw new Error('Cart not found');

                          case 8:
                            _context2.t2 = toSnake$1;
                            _context2.next = 11;
                            return settings.methods(request).payments();

                          case 11:
                            _context2.t3 = _context2.sent;
                            payMethods = (0, _context2.t2)(_context2.t3);

                            if (!payMethods.error) {
                              _context2.next = 15;
                              break;
                            }

                            throw new Error(payMethods.error);

                          case 15:
                            _context2.next = 17;
                            return render(request, cart$1, payMethods, this.params);

                          case 17:
                          case "end":
                            return _context2.stop();
                        }
                      }
                    }, _callee2, this);
                  }));

                  function createElements(_x) {
                    return _createElements.apply(this, arguments);
                  }

                  return createElements;
                }(),
                tokenize: function () {
                  var _tokenize = (0, _asyncToGenerator2$3["default"])( /*#__PURE__*/_regenerator$3["default"].mark(function _callee3(params) {
                    var cart$1, payMethods;
                    return _regenerator$3["default"].wrap(function _callee3$(_context3) {
                      while (1) {
                        switch (_context3.prev = _context3.next) {
                          case 0:
                            _context3.t0 = toSnake$1;
                            _context3.next = 3;
                            return cart.methods(request).get();

                          case 3:
                            _context3.t1 = _context3.sent;
                            cart$1 = (0, _context3.t0)(_context3.t1);

                            if (cart$1) {
                              _context3.next = 7;
                              break;
                            }

                            throw new Error('Cart not found');

                          case 7:
                            _context3.t2 = toSnake$1;
                            _context3.next = 10;
                            return settings.methods(request).payments();

                          case 10:
                            _context3.t3 = _context3.sent;
                            payMethods = (0, _context3.t2)(_context3.t3);

                            if (!payMethods.error) {
                              _context3.next = 14;
                              break;
                            }

                            throw new Error(payMethods.error);

                          case 14:
                            _context3.next = 16;
                            return paymentTokenize(request, params || this.params, payMethods, cart$1);

                          case 16:
                            return _context3.abrupt("return", _context3.sent);

                          case 17:
                          case "end":
                            return _context3.stop();
                        }
                      }
                    }, _callee3, this);
                  }));

                  function tokenize(_x2) {
                    return _tokenize.apply(this, arguments);
                  }

                  return tokenize;
                }(),
                createIntent: function () {
                  var _createIntent = (0, _asyncToGenerator2$3["default"])( /*#__PURE__*/_regenerator$3["default"].mark(function _callee4(data) {
                    var intent, param, err;
                    return _regenerator$3["default"].wrap(function _callee4$(_context4) {
                      while (1) {
                        switch (_context4.prev = _context4.next) {
                          case 0:
                            _context4.next = 2;
                            return vaultRequest('post', '/intent', data);

                          case 2:
                            intent = _context4.sent;

                            if (!intent.errors) {
                              _context4.next = 10;
                              break;
                            }

                            param = Object.keys(intent.errors)[0];
                            err = new Error(intent.errors[param].message || 'Unknown error');
                            err.code = 'vault_error';
                            err.status = 402;
                            err.param = param;
                            throw err;

                          case 10:
                            return _context4.abrupt("return", intent);

                          case 11:
                          case "end":
                            return _context4.stop();
                        }
                      }
                    }, _callee4);
                  }));

                  function createIntent(_x3) {
                    return _createIntent.apply(this, arguments);
                  }

                  return createIntent;
                }(),
                updateIntent: function () {
                  var _updateIntent = (0, _asyncToGenerator2$3["default"])( /*#__PURE__*/_regenerator$3["default"].mark(function _callee5(data) {
                    var intent, param, err;
                    return _regenerator$3["default"].wrap(function _callee5$(_context5) {
                      while (1) {
                        switch (_context5.prev = _context5.next) {
                          case 0:
                            _context5.next = 2;
                            return vaultRequest('put', '/intent', data);

                          case 2:
                            intent = _context5.sent;

                            if (!intent.errors) {
                              _context5.next = 10;
                              break;
                            }

                            param = Object.keys(intent.errors)[0];
                            err = new Error(intent.errors[param].message || 'Unknown error');
                            err.code = 'vault_error';
                            err.status = 402;
                            err.param = param;
                            throw err;

                          case 10:
                            return _context5.abrupt("return", intent);

                          case 11:
                          case "end":
                            return _context5.stop();
                        }
                      }
                    }, _callee5);
                  }));

                  function updateIntent(_x4) {
                    return _updateIntent.apply(this, arguments);
                  }

                  return updateIntent;
                }()
              };
            }

            function render(_x5, _x6, _x7, _x8) {
              return _render.apply(this, arguments);
            }

            function _render() {
              _render = (0, _asyncToGenerator2$3["default"])( /*#__PURE__*/_regenerator$3["default"].mark(function _callee7(request, cart, payMethods, params) {
                return _regenerator$3["default"].wrap(function _callee7$(_context7) {
                  while (1) {
                    switch (_context7.prev = _context7.next) {
                      case 0:
                        if (!params.card) {
                          _context7.next = 17;
                          break;
                        }

                        if (payMethods.card) {
                          _context7.next = 5;
                          break;
                        }

                        console.error("Payment element error: credit card payments are disabled. See Payment settings in the Swell dashboard for details.");
                        _context7.next = 17;
                        break;

                      case 5:
                        if (!(payMethods.card.gateway === 'braintree')) {
                          _context7.next = 11;
                          break;
                        }

                        if (window.braintree) {
                          _context7.next = 9;
                          break;
                        }

                        _context7.next = 9;
                        return loadScript('braintree-web', 'https://js.braintreegateway.com/web/3.57.0/js/client.min.js');

                      case 9:
                        _context7.next = 17;
                        break;

                      case 11:
                        if (!(payMethods.card.gateway === 'stripe')) {
                          _context7.next = 17;
                          break;
                        }

                        if (window.Stripe) {
                          _context7.next = 15;
                          break;
                        }

                        _context7.next = 15;
                        return loadScript('stripe-js', 'https://js.stripe.com/v3/');

                      case 15:
                        _context7.next = 17;
                        return stripeElements(request, payMethods, params);

                      case 17:
                        if (!params.ideal) {
                          _context7.next = 32;
                          break;
                        }

                        if (payMethods.card) {
                          _context7.next = 22;
                          break;
                        }

                        console.error("Payment element error: credit card payments are disabled. See Payment settings in the Swell dashboard for details.");
                        _context7.next = 32;
                        break;

                      case 22:
                        if (payMethods.ideal) {
                          _context7.next = 26;
                          break;
                        }

                        console.error("Payment element error: iDEAL payments are disabled. See Payment settings in the Swell dashboard for details.");
                        _context7.next = 32;
                        break;

                      case 26:
                        if (!(payMethods.card.gateway === 'stripe')) {
                          _context7.next = 32;
                          break;
                        }

                        if (window.Stripe) {
                          _context7.next = 30;
                          break;
                        }

                        _context7.next = 30;
                        return loadScript('stripe-js', 'https://js.stripe.com/v3/');

                      case 30:
                        _context7.next = 32;
                        return stripeElements(request, payMethods, params);

                      case 32:
                        if (!params.paypal) {
                          _context7.next = 49;
                          break;
                        }

                        if (payMethods.paypal) {
                          _context7.next = 37;
                          break;
                        }

                        console.error("Payment element error: PayPal payments are disabled. See Payment settings in the Swell dashboard for details.");
                        _context7.next = 49;
                        break;

                      case 37:
                        if (window.paypal) {
                          _context7.next = 40;
                          break;
                        }

                        _context7.next = 40;
                        return loadScript('paypal-sdk', "https://www.paypal.com/sdk/js?client-id=".concat(payMethods.paypal.client_id, "&merchant-id=").concat(payMethods.paypal.merchant_id, "&vault=true"));

                      case 40:
                        if (!(payMethods.card && payMethods.card.gateway === 'braintree' && payMethods.paypal.gateway === 'braintree')) {
                          _context7.next = 49;
                          break;
                        }

                        if (window.braintree) {
                          _context7.next = 44;
                          break;
                        }

                        _context7.next = 44;
                        return loadScript('braintree-web', 'https://js.braintreegateway.com/web/3.57.0/js/client.min.js');

                      case 44:
                        if (!(window.braintree && !window.braintree.paypalCheckout)) {
                          _context7.next = 47;
                          break;
                        }

                        _context7.next = 47;
                        return loadScript('braintree-web-paypal-checkout', 'https://js.braintreegateway.com/web/3.57.0/js/paypal-checkout.min.js');

                      case 47:
                        _context7.next = 49;
                        return braintreePayPalButton(request, cart, payMethods, params);

                      case 49:
                      case "end":
                        return _context7.stop();
                    }
                  }
                }, _callee7);
              }));
              return _render.apply(this, arguments);
            }

            var loadScript = /*#__PURE__*/function () {
              var _ref = (0, _asyncToGenerator2$3["default"])( /*#__PURE__*/_regenerator$3["default"].mark(function _callee6(id, src) {
                return _regenerator$3["default"].wrap(function _callee6$(_context6) {
                  while (1) {
                    switch (_context6.prev = _context6.next) {
                      case 0:
                        LOADING_SCRIPTS[id] = LOADING_SCRIPTS[id] || new Promise(function (resolve) {
                          var script = document.createElement('script');
                          script.id = id;
                          script.src = src;
                          script.async = true;
                          script.type = 'text/javascript';
                          script.addEventListener('load', function () {
                            resolve();
                            LOADING_SCRIPTS[id] = null;
                          }, {
                            once: true
                          });
                          document.head.appendChild(script);
                        });
                        return _context6.abrupt("return", LOADING_SCRIPTS[id]);

                      case 2:
                      case "end":
                        return _context6.stop();
                    }
                  }
                }, _callee6);
              }));

              return function loadScript(_x9, _x10) {
                return _ref.apply(this, arguments);
              };
            }();

            function stripeElements(_x11, _x12, _x13) {
              return _stripeElements.apply(this, arguments);
            }

            function _stripeElements() {
              _stripeElements = (0, _asyncToGenerator2$3["default"])( /*#__PURE__*/_regenerator$3["default"].mark(function _callee8(request, payMethods, params) {
                var publishable_key, stripe, elements, createElement;
                return _regenerator$3["default"].wrap(function _callee8$(_context8) {
                  while (1) {
                    switch (_context8.prev = _context8.next) {
                      case 0:
                        publishable_key = payMethods.card.publishable_key;
                        stripe = window.Stripe(publishable_key);
                        elements = stripe.elements();

                        createElement = function createElement(type) {
                          var elementParams = get_1(params, "card[".concat(type, "]")) || params.card || params.ideal;
                          var elementOptions = elementParams.options || {};
                          var element = elements.create(type, elementOptions);
                          element.mount(elementParams.elementId || "#".concat(type, "-element"));
                          elementParams.onChange && element.on('change', elementParams.onChange);
                          elementParams.onReady && element.on('ready', elementParams.onReady);
                          elementParams.onFocus && element.on('focus', elementParams.onFocus);
                          elementParams.onBlur && element.on('blur', elementParams.onBlur);
                          elementParams.onEscape && element.on('escape', elementParams.onEscape);
                          elementParams.onClick && element.on('click', elementParams.onClick);

                          if (type === 'card' || type === 'cardNumber' || type === 'idealBank') {
                            CARD_ELEMENTS.stripe = element;
                          }
                        };

                        API.stripe = stripe;

                        if (params.ideal) {
                          createElement('idealBank');
                        } else if (params.card.separateElements) {
                          createElement('cardNumber');
                          createElement('cardExpiry');
                          createElement('cardCvc');
                        } else {
                          createElement('card');
                        }

                      case 6:
                      case "end":
                        return _context8.stop();
                    }
                  }
                }, _callee8);
              }));
              return _stripeElements.apply(this, arguments);
            }

            function braintreePayPalButton(_x14, _x15, _x16, _x17) {
              return _braintreePayPalButton.apply(this, arguments);
            }

            function _braintreePayPalButton() {
              _braintreePayPalButton = (0, _asyncToGenerator2$3["default"])( /*#__PURE__*/_regenerator$3["default"].mark(function _callee9(request, cart$1, payMethods, params) {
                var authorization, braintree, paypal;
                return _regenerator$3["default"].wrap(function _callee9$(_context9) {
                  while (1) {
                    switch (_context9.prev = _context9.next) {
                      case 0:
                        _context9.next = 2;
                        return vaultRequest('post', '/authorization', {
                          gateway: 'braintree'
                        });

                      case 2:
                        authorization = _context9.sent;

                        if (!authorization.error) {
                          _context9.next = 5;
                          break;
                        }

                        throw new Error(authorization.error);

                      case 5:
                        braintree = window.braintree;
                        paypal = window.paypal;
                        braintree.client.create({
                          authorization: authorization
                        }).then(function (client) {
                          return braintree.paypalCheckout.create({
                            client: client
                          });
                        }).then(function (paypalCheckoutInstance) {
                          return paypal.Buttons({
                            style: params.paypal.style || {},
                            createBillingAgreement: function createBillingAgreement() {
                              return paypalCheckoutInstance.createPayment({
                                flow: 'vault',
                                currency: cart$1.currency,
                                amount: cart$1.grand_total
                              });
                            },
                            onApprove: function onApprove(data, actions) {
                              return paypalCheckoutInstance.tokenizePayment(data).then(function (_ref2) {
                                var nonce = _ref2.nonce;
                                return cart.methods(request).update({
                                  billing: {
                                    paypal: {
                                      nonce: nonce
                                    }
                                  }
                                });
                              }).then(function () {
                                return isFunction$2(params.paypal.onSuccess) && params.paypal.onSuccess(data, actions);
                              })["catch"](isFunction$2(params.paypal.onError) ? params.paypal.onError : function (err) {
                                return console.error('PayPal error', err);
                              });
                            },
                            onCancel: isFunction$2(params.paypal.onCancel) ? function () {
                              return params.paypal.onCancel();
                            } : function () {
                              return console.log('PayPal payment cancelled');
                            },
                            onError: isFunction$2(params.paypal.onError) ? function (err) {
                              return params.paypal.onError(err);
                            } : function (err) {
                              return console.error('PayPal error', err);
                            }
                          }).render(params.paypal.elementId || '#paypal-button');
                        })["catch"](isFunction$2(params.paypal.onError) ? params.paypal.onError : function (err) {
                          return console.error('PayPal error', err);
                        });

                      case 8:
                      case "end":
                        return _context9.stop();
                    }
                  }
                }, _callee9);
              }));
              return _braintreePayPalButton.apply(this, arguments);
            }

            function paymentTokenize(_x18, _x19, _x20, _x21) {
              return _paymentTokenize.apply(this, arguments);
            }

            function _paymentTokenize() {
              _paymentTokenize = (0, _asyncToGenerator2$3["default"])( /*#__PURE__*/_regenerator$3["default"].mark(function _callee10(request, params, payMethods, cart$1) {
                var onError, stripe, paymentMethod, currency, amount, stripeCustomer, intent, _yield$stripe$confirm, paymentIntent, error, _yield$createIDealPay, _error, _paymentMethod, _currency, _amount, _intent, publishable_key, _stripe, settings$1, _yield$createKlarnaSo, _error2, source, _publishable_key, _stripe2, _yield$createBanconta, _error3, _source;

                return _regenerator$3["default"].wrap(function _callee10$(_context10) {
                  while (1) {
                    switch (_context10.prev = _context10.next) {
                      case 0:
                        onError = function onError(error) {
                          var errorHandler = get_1(params, 'card.onError') || get_1(params, 'ideal.onError') || get_1(params, 'klarna.onError') || get_1(params, 'bancontact.onError');

                          if (isFunction$2(errorHandler)) {
                            return errorHandler(error);
                          }

                          throw new Error(error.message);
                        };

                        if (params) {
                          _context10.next = 3;
                          break;
                        }

                        return _context10.abrupt("return", onError({
                          message: 'Tokenization parameters not passed'
                        }));

                      case 3:
                        if (!(params.card && payMethods.card)) {
                          _context10.next = 35;
                          break;
                        }

                        if (!(payMethods.card.gateway === 'stripe' && CARD_ELEMENTS.stripe && API.stripe)) {
                          _context10.next = 33;
                          break;
                        }

                        stripe = API.stripe;
                        _context10.next = 8;
                        return createPaymentMethod(stripe, CARD_ELEMENTS.stripe, cart$1);

                      case 8:
                        paymentMethod = _context10.sent;

                        if (!paymentMethod.error) {
                          _context10.next = 11;
                          break;
                        }

                        return _context10.abrupt("return", onError(paymentMethod.error));

                      case 11:
                        currency = toLower_1(get_1(cart$1, 'currency', 'usd'));
                        amount = stripeAmountByCurrency(currency, get_1(cart$1, 'grand_total', 0));
                        stripeCustomer = get_1(cart$1, 'account.stripe_customer');
                        _context10.t0 = toSnake$1;
                        _context10.next = 17;
                        return methods$2(request).createIntent({
                          gateway: 'stripe',
                          intent: _objectSpread$1({
                            payment_method: paymentMethod.token,
                            amount: amount,
                            currency: currency,
                            capture_method: 'manual',
                            setup_future_usage: 'off_session'
                          }, stripeCustomer ? {
                            customer: stripeCustomer
                          } : {})
                        })["catch"](function (err) {
                          return onError(err);
                        });

                      case 17:
                        _context10.t1 = _context10.sent;
                        intent = (0, _context10.t0)(_context10.t1);

                        if (!(intent && intent.status === 'requires_confirmation')) {
                          _context10.next = 33;
                          break;
                        }

                        _context10.next = 22;
                        return stripe.confirmCardPayment(intent.client_secret);

                      case 22:
                        _yield$stripe$confirm = _context10.sent;
                        paymentIntent = _yield$stripe$confirm.paymentIntent;
                        error = _yield$stripe$confirm.error;

                        if (!error) {
                          _context10.next = 29;
                          break;
                        }

                        _context10.t2 = onError(error);
                        _context10.next = 32;
                        break;

                      case 29:
                        _context10.next = 31;
                        return cart.methods(request).update({
                          billing: {
                            method: 'card',
                            card: paymentMethod,
                            intent: {
                              stripe: {
                                id: paymentIntent.id
                              }
                            }
                          }
                        }).then(function () {
                          return isFunction$2(params.card.onSuccess) && params.card.onSuccess();
                        })["catch"](function (err) {
                          return onError(err);
                        });

                      case 31:
                        _context10.t2 = _context10.sent;

                      case 32:
                        return _context10.abrupt("return", _context10.t2);

                      case 33:
                        _context10.next = 95;
                        break;

                      case 35:
                        if (!(params.ideal && payMethods.ideal)) {
                          _context10.next = 62;
                          break;
                        }

                        if (!(payMethods.card && payMethods.card.gateway === 'stripe' && CARD_ELEMENTS.stripe && API.stripe)) {
                          _context10.next = 60;
                          break;
                        }

                        _context10.next = 39;
                        return createIDealPaymentMethod(API.stripe, CARD_ELEMENTS.stripe, cart$1.billing);

                      case 39:
                        _yield$createIDealPay = _context10.sent;
                        _error = _yield$createIDealPay.error;
                        _paymentMethod = _yield$createIDealPay.paymentMethod;

                        if (!_error) {
                          _context10.next = 44;
                          break;
                        }

                        return _context10.abrupt("return", onError(_error));

                      case 44:
                        _currency = toLower_1(get_1(cart$1, 'currency', 'eur'));
                        _amount = stripeAmountByCurrency(_currency, get_1(cart$1, 'grand_total', 0));
                        _context10.t3 = toSnake$1;
                        _context10.next = 49;
                        return methods$2(request).createIntent({
                          gateway: 'stripe',
                          intent: {
                            payment_method: _paymentMethod.id,
                            amount: _amount,
                            currency: _currency,
                            payment_method_types: 'ideal',
                            confirmation_method: 'manual',
                            confirm: true,
                            return_url: window.location.href
                          }
                        })["catch"](function (err) {
                          return onError(err);
                        });

                      case 49:
                        _context10.t4 = _context10.sent;
                        _intent = (0, _context10.t3)(_context10.t4);

                        if (!_intent) {
                          _context10.next = 60;
                          break;
                        }

                        _context10.next = 54;
                        return cart.methods(request).update({
                          billing: {
                            method: 'ideal',
                            ideal: {
                              token: _paymentMethod.id
                            },
                            intent: {
                              stripe: {
                                id: _intent.id
                              }
                            }
                          }
                        })["catch"](function (err) {
                          return onError(err);
                        });

                      case 54:
                        _context10.t5 = _intent.status === 'requires_action' || _intent.status === 'requires_source_action';

                        if (!_context10.t5) {
                          _context10.next = 59;
                          break;
                        }

                        _context10.next = 58;
                        return API.stripe.handleCardAction(_intent.client_secret);

                      case 58:
                        _context10.t5 = _context10.sent;

                      case 59:
                        return _context10.abrupt("return", _context10.t5);

                      case 60:
                        _context10.next = 95;
                        break;

                      case 62:
                        if (!(params.klarna && payMethods.klarna)) {
                          _context10.next = 82;
                          break;
                        }

                        if (!(payMethods.card && payMethods.card.gateway === 'stripe')) {
                          _context10.next = 80;
                          break;
                        }

                        if (window.Stripe) {
                          _context10.next = 67;
                          break;
                        }

                        _context10.next = 67;
                        return loadScript('stripe-js', 'https://js.stripe.com/v3/');

                      case 67:
                        publishable_key = payMethods.card.publishable_key;
                        _stripe = window.Stripe(publishable_key);
                        _context10.t6 = toSnake$1;
                        _context10.next = 72;
                        return settings.methods(request).get();

                      case 72:
                        _context10.t7 = _context10.sent;
                        settings$1 = (0, _context10.t6)(_context10.t7);
                        _context10.next = 76;
                        return createKlarnaSource(_stripe, _objectSpread$1(_objectSpread$1({}, cart$1), {}, {
                          settings: settings$1.store
                        }));

                      case 76:
                        _yield$createKlarnaSo = _context10.sent;
                        _error2 = _yield$createKlarnaSo.error;
                        source = _yield$createKlarnaSo.source;
                        return _context10.abrupt("return", _error2 ? onError(_error2) : cart.methods(request).update({
                          billing: {
                            method: 'klarna'
                          }
                        }).then(function () {
                          return window.location.replace(source.redirect.url);
                        })["catch"](function (err) {
                          return onError(err);
                        }));

                      case 80:
                        _context10.next = 95;
                        break;

                      case 82:
                        if (!(params.bancontact && payMethods.bancontact)) {
                          _context10.next = 95;
                          break;
                        }

                        if (!(payMethods.card && payMethods.card.gateway === 'stripe')) {
                          _context10.next = 95;
                          break;
                        }

                        if (window.Stripe) {
                          _context10.next = 87;
                          break;
                        }

                        _context10.next = 87;
                        return loadScript('stripe-js', 'https://js.stripe.com/v3/');

                      case 87:
                        _publishable_key = payMethods.card.publishable_key;
                        _stripe2 = window.Stripe(_publishable_key);
                        _context10.next = 91;
                        return createBancontactSource(_stripe2, cart$1);

                      case 91:
                        _yield$createBanconta = _context10.sent;
                        _error3 = _yield$createBanconta.error;
                        _source = _yield$createBanconta.source;
                        return _context10.abrupt("return", _error3 ? onError(_error3) : cart.methods(request).update({
                          billing: {
                            method: 'bancontact'
                          }
                        }).then(function () {
                          return window.location.replace(_source.redirect.url);
                        })["catch"](function (err) {
                          return onError(err);
                        }));

                      case 95:
                      case "end":
                        return _context10.stop();
                    }
                  }
                }, _callee10);
              }));
              return _paymentTokenize.apply(this, arguments);
            }

            var payment = {
              methods: methods$2
            };

            var _regenerator$2 = interopRequireDefault(regenerator);

            var _asyncToGenerator2$2 = interopRequireDefault(asyncToGenerator);

            var find$2 = utils.find;

            var getCookie$2 = cookie.getCookie,
                setCookie$2 = cookie.setCookie;

            function methods$1(request, opt) {
              return {
                code: null,
                state: null,
                list: function list() {
                  return opt.api.settings.get('store.locales', []);
                },
                select: function () {
                  var _select = (0, _asyncToGenerator2$2["default"])( /*#__PURE__*/_regenerator$2["default"].mark(function _callee(locale) {
                    return _regenerator$2["default"].wrap(function _callee$(_context) {
                      while (1) {
                        switch (_context.prev = _context.next) {
                          case 0:
                            this.set(locale);
                            setCookie$2('swell-locale', locale);
                            opt.api.settings.locale = locale;
                            _context.next = 5;
                            return request('put', '/session', {
                              locale: locale
                            });

                          case 5:
                            return _context.abrupt("return", _context.sent);

                          case 6:
                          case "end":
                            return _context.stop();
                        }
                      }
                    }, _callee, this);
                  }));

                  function select(_x) {
                    return _select.apply(this, arguments);
                  }

                  return select;
                }(),
                selected: function selected() {
                  if (this.code) {
                    return this.code;
                  }

                  var storeLocale = opt.api.settings.getStoreLocale();
                  var cookieLocale = getCookie$2('swell-locale');
                  opt.api.settings.locale = cookieLocale || storeLocale;
                  return cookieLocale || storeLocale;
                },
                get: function get() {
                  if (!this.code) {
                    this.code = this.selected();
                  }

                  if (!this.state) {
                    this.state = this.set(this.code);
                  }

                  return this.state;
                },
                set: function set(code) {
                  this.code = code;
                  this.state = find$2(this.list(), {
                    code: code
                  }) || {};
                  return this.state;
                }
              };
            }

            var locale$1 = {
              methods: methods$1
            };

            var _typeof2 = interopRequireDefault(_typeof_1);

            var _regenerator$1 = interopRequireDefault(regenerator);

            var _asyncToGenerator2$1 = interopRequireDefault(asyncToGenerator);

            var get$1 = utils.get,
                find$1 = utils.find;

            var getCookie$1 = cookie.getCookie,
                setCookie$1 = cookie.setCookie;

            function methods(request, opt) {
              return {
                code: null,
                state: null,
                locale: null,
                formatter: null,
                list: function list() {
                  return opt.api.settings.get('store.currencies', []);
                },
                select: function () {
                  var _select = (0, _asyncToGenerator2$1["default"])( /*#__PURE__*/_regenerator$1["default"].mark(function _callee(currency) {
                    return _regenerator$1["default"].wrap(function _callee$(_context) {
                      while (1) {
                        switch (_context.prev = _context.next) {
                          case 0:
                            this.set(currency);
                            setCookie$1('swell-currency', currency);
                            _context.next = 4;
                            return request('put', '/session', {
                              currency: currency
                            });

                          case 4:
                            return _context.abrupt("return", _context.sent);

                          case 5:
                          case "end":
                            return _context.stop();
                        }
                      }
                    }, _callee, this);
                  }));

                  function select(_x) {
                    return _select.apply(this, arguments);
                  }

                  return select;
                }(),
                selected: function selected() {
                  if (this.code) {
                    return this.code;
                  }

                  var storeCurrency = opt.api.settings.get('store.currency');
                  var cookieCurrency = getCookie$1('swell-currency');
                  return cookieCurrency || storeCurrency;
                },
                get: function get() {
                  if (!this.code) {
                    this.code = this.selected();
                  }

                  if (!this.state) {
                    this.state = this.set(this.code);
                  }

                  return this.state;
                },
                set: function set(code) {
                  this.code = code;
                  this.locale = opt.api.settings.get('store.locale', (typeof navigator === "undefined" ? "undefined" : (0, _typeof2["default"])(navigator)) === 'object' ? navigator.language : 'en-US');
                  this.state = find$1(this.list(), {
                    code: code
                  }) || {};

                  try {
                    this.formatter = new Intl.NumberFormat(this.locale, {
                      style: 'currency',
                      currency: code,
                      currencyDisplay: 'symbol',
                      minimumFractionDigits: this.state.decimals,
                      maximumFractionDigits: this.state.decimals
                    });
                  } catch (err) {
                    console.error(err);
                  }

                  return this.state;
                },
                format: function format(amount) {
                  var params = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
                  var state = this.get();

                  if (params.code && params.code !== state.code) {
                    var list = this.list();
                    state = find$1(list, {
                      code: params.code
                    }) || {};
                  }

                  var _state = state,
                      code = _state.code,
                      rate = _state.rate,
                      decimals = _state.decimals,
                      type = _state.type;
                  var formatCode = params.code || code;
                  var formatRate = params.rate || rate;
                  var formatLocale = params.locale || this.locale;
                  var formatDecimals = typeof params.decimals === 'number' ? params.decimals : decimals;
                  var formatAmount = amount;

                  if ((type === 'display' || params.rate) && typeof formatRate === 'number') {
                    // Convert the price currency into the display currency
                    formatAmount = amount * formatRate;
                  }

                  var formatter;

                  try {
                    formatter = formatCode === this.state.code && formatLocale === this.locale && formatDecimals === this.state.decimals ? this.formatter : new Intl.NumberFormat(formatLocale, {
                      style: 'currency',
                      currency: formatCode,
                      currencyDisplay: 'symbol',
                      minimumFractionDigits: formatDecimals,
                      maximumFractionDigits: formatDecimals
                    });

                    if (typeof formatAmount === 'number') {
                      return formatter.format(formatAmount);
                    } else {
                      // Otherwise return the currency symbol only, falling back to '$'
                      return get$1(formatter.formatToParts(0), '0.value', '$');
                    }
                  } catch (err) {
                    console.error(err);
                  }

                  return String(amount);
                }
              };
            }

            var currency$1 = {
              methods: methods
            };

            var domain;

            // This constructor is used to store event handlers. Instantiating this is
            // faster than explicitly calling `Object.create(null)` to get a "clean" empty
            // object (tested with v8 v4.9).
            function EventHandlers() {}
            EventHandlers.prototype = Object.create(null);

            function EventEmitter() {
              EventEmitter.init.call(this);
            }

            // nodejs oddity
            // require('events') === require('events').EventEmitter
            EventEmitter.EventEmitter = EventEmitter;

            EventEmitter.usingDomains = false;

            EventEmitter.prototype.domain = undefined;
            EventEmitter.prototype._events = undefined;
            EventEmitter.prototype._maxListeners = undefined;

            // By default EventEmitters will print a warning if more than 10 listeners are
            // added to it. This is a useful default which helps finding memory leaks.
            EventEmitter.defaultMaxListeners = 10;

            EventEmitter.init = function() {
              this.domain = null;
              if (EventEmitter.usingDomains) {
                // if there is an active domain, then attach to it.
                if (domain.active ) ;
              }

              if (!this._events || this._events === Object.getPrototypeOf(this)._events) {
                this._events = new EventHandlers();
                this._eventsCount = 0;
              }

              this._maxListeners = this._maxListeners || undefined;
            };

            // Obviously not all Emitters should be limited to 10. This function allows
            // that to be increased. Set to zero for unlimited.
            EventEmitter.prototype.setMaxListeners = function setMaxListeners(n) {
              if (typeof n !== 'number' || n < 0 || isNaN(n))
                throw new TypeError('"n" argument must be a positive number');
              this._maxListeners = n;
              return this;
            };

            function $getMaxListeners(that) {
              if (that._maxListeners === undefined)
                return EventEmitter.defaultMaxListeners;
              return that._maxListeners;
            }

            EventEmitter.prototype.getMaxListeners = function getMaxListeners() {
              return $getMaxListeners(this);
            };

            // These standalone emit* functions are used to optimize calling of event
            // handlers for fast cases because emit() itself often has a variable number of
            // arguments and can be deoptimized because of that. These functions always have
            // the same number of arguments and thus do not get deoptimized, so the code
            // inside them can execute faster.
            function emitNone(handler, isFn, self) {
              if (isFn)
                handler.call(self);
              else {
                var len = handler.length;
                var listeners = arrayClone(handler, len);
                for (var i = 0; i < len; ++i)
                  listeners[i].call(self);
              }
            }
            function emitOne(handler, isFn, self, arg1) {
              if (isFn)
                handler.call(self, arg1);
              else {
                var len = handler.length;
                var listeners = arrayClone(handler, len);
                for (var i = 0; i < len; ++i)
                  listeners[i].call(self, arg1);
              }
            }
            function emitTwo(handler, isFn, self, arg1, arg2) {
              if (isFn)
                handler.call(self, arg1, arg2);
              else {
                var len = handler.length;
                var listeners = arrayClone(handler, len);
                for (var i = 0; i < len; ++i)
                  listeners[i].call(self, arg1, arg2);
              }
            }
            function emitThree(handler, isFn, self, arg1, arg2, arg3) {
              if (isFn)
                handler.call(self, arg1, arg2, arg3);
              else {
                var len = handler.length;
                var listeners = arrayClone(handler, len);
                for (var i = 0; i < len; ++i)
                  listeners[i].call(self, arg1, arg2, arg3);
              }
            }

            function emitMany(handler, isFn, self, args) {
              if (isFn)
                handler.apply(self, args);
              else {
                var len = handler.length;
                var listeners = arrayClone(handler, len);
                for (var i = 0; i < len; ++i)
                  listeners[i].apply(self, args);
              }
            }

            EventEmitter.prototype.emit = function emit(type) {
              var er, handler, len, args, i, events, domain;
              var doError = (type === 'error');

              events = this._events;
              if (events)
                doError = (doError && events.error == null);
              else if (!doError)
                return false;

              domain = this.domain;

              // If there is no 'error' event listener then throw.
              if (doError) {
                er = arguments[1];
                if (domain) {
                  if (!er)
                    er = new Error('Uncaught, unspecified "error" event');
                  er.domainEmitter = this;
                  er.domain = domain;
                  er.domainThrown = false;
                  domain.emit('error', er);
                } else if (er instanceof Error) {
                  throw er; // Unhandled 'error' event
                } else {
                  // At least give some kind of context to the user
                  var err = new Error('Uncaught, unspecified "error" event. (' + er + ')');
                  err.context = er;
                  throw err;
                }
                return false;
              }

              handler = events[type];

              if (!handler)
                return false;

              var isFn = typeof handler === 'function';
              len = arguments.length;
              switch (len) {
                // fast cases
                case 1:
                  emitNone(handler, isFn, this);
                  break;
                case 2:
                  emitOne(handler, isFn, this, arguments[1]);
                  break;
                case 3:
                  emitTwo(handler, isFn, this, arguments[1], arguments[2]);
                  break;
                case 4:
                  emitThree(handler, isFn, this, arguments[1], arguments[2], arguments[3]);
                  break;
                // slower
                default:
                  args = new Array(len - 1);
                  for (i = 1; i < len; i++)
                    args[i - 1] = arguments[i];
                  emitMany(handler, isFn, this, args);
              }

              return true;
            };

            function _addListener(target, type, listener, prepend) {
              var m;
              var events;
              var existing;

              if (typeof listener !== 'function')
                throw new TypeError('"listener" argument must be a function');

              events = target._events;
              if (!events) {
                events = target._events = new EventHandlers();
                target._eventsCount = 0;
              } else {
                // To avoid recursion in the case that type === "newListener"! Before
                // adding it to the listeners, first emit "newListener".
                if (events.newListener) {
                  target.emit('newListener', type,
                              listener.listener ? listener.listener : listener);

                  // Re-assign `events` because a newListener handler could have caused the
                  // this._events to be assigned to a new object
                  events = target._events;
                }
                existing = events[type];
              }

              if (!existing) {
                // Optimize the case of one listener. Don't need the extra array object.
                existing = events[type] = listener;
                ++target._eventsCount;
              } else {
                if (typeof existing === 'function') {
                  // Adding the second element, need to change to array.
                  existing = events[type] = prepend ? [listener, existing] :
                                                      [existing, listener];
                } else {
                  // If we've already got an array, just append.
                  if (prepend) {
                    existing.unshift(listener);
                  } else {
                    existing.push(listener);
                  }
                }

                // Check for listener leak
                if (!existing.warned) {
                  m = $getMaxListeners(target);
                  if (m && m > 0 && existing.length > m) {
                    existing.warned = true;
                    var w = new Error('Possible EventEmitter memory leak detected. ' +
                                        existing.length + ' ' + type + ' listeners added. ' +
                                        'Use emitter.setMaxListeners() to increase limit');
                    w.name = 'MaxListenersExceededWarning';
                    w.emitter = target;
                    w.type = type;
                    w.count = existing.length;
                    emitWarning(w);
                  }
                }
              }

              return target;
            }
            function emitWarning(e) {
              typeof console.warn === 'function' ? console.warn(e) : console.log(e);
            }
            EventEmitter.prototype.addListener = function addListener(type, listener) {
              return _addListener(this, type, listener, false);
            };

            EventEmitter.prototype.on = EventEmitter.prototype.addListener;

            EventEmitter.prototype.prependListener =
                function prependListener(type, listener) {
                  return _addListener(this, type, listener, true);
                };

            function _onceWrap(target, type, listener) {
              var fired = false;
              function g() {
                target.removeListener(type, g);
                if (!fired) {
                  fired = true;
                  listener.apply(target, arguments);
                }
              }
              g.listener = listener;
              return g;
            }

            EventEmitter.prototype.once = function once(type, listener) {
              if (typeof listener !== 'function')
                throw new TypeError('"listener" argument must be a function');
              this.on(type, _onceWrap(this, type, listener));
              return this;
            };

            EventEmitter.prototype.prependOnceListener =
                function prependOnceListener(type, listener) {
                  if (typeof listener !== 'function')
                    throw new TypeError('"listener" argument must be a function');
                  this.prependListener(type, _onceWrap(this, type, listener));
                  return this;
                };

            // emits a 'removeListener' event iff the listener was removed
            EventEmitter.prototype.removeListener =
                function removeListener(type, listener) {
                  var list, events, position, i, originalListener;

                  if (typeof listener !== 'function')
                    throw new TypeError('"listener" argument must be a function');

                  events = this._events;
                  if (!events)
                    return this;

                  list = events[type];
                  if (!list)
                    return this;

                  if (list === listener || (list.listener && list.listener === listener)) {
                    if (--this._eventsCount === 0)
                      this._events = new EventHandlers();
                    else {
                      delete events[type];
                      if (events.removeListener)
                        this.emit('removeListener', type, list.listener || listener);
                    }
                  } else if (typeof list !== 'function') {
                    position = -1;

                    for (i = list.length; i-- > 0;) {
                      if (list[i] === listener ||
                          (list[i].listener && list[i].listener === listener)) {
                        originalListener = list[i].listener;
                        position = i;
                        break;
                      }
                    }

                    if (position < 0)
                      return this;

                    if (list.length === 1) {
                      list[0] = undefined;
                      if (--this._eventsCount === 0) {
                        this._events = new EventHandlers();
                        return this;
                      } else {
                        delete events[type];
                      }
                    } else {
                      spliceOne(list, position);
                    }

                    if (events.removeListener)
                      this.emit('removeListener', type, originalListener || listener);
                  }

                  return this;
                };

            EventEmitter.prototype.removeAllListeners =
                function removeAllListeners(type) {
                  var listeners, events;

                  events = this._events;
                  if (!events)
                    return this;

                  // not listening for removeListener, no need to emit
                  if (!events.removeListener) {
                    if (arguments.length === 0) {
                      this._events = new EventHandlers();
                      this._eventsCount = 0;
                    } else if (events[type]) {
                      if (--this._eventsCount === 0)
                        this._events = new EventHandlers();
                      else
                        delete events[type];
                    }
                    return this;
                  }

                  // emit removeListener for all listeners on all events
                  if (arguments.length === 0) {
                    var keys = Object.keys(events);
                    for (var i = 0, key; i < keys.length; ++i) {
                      key = keys[i];
                      if (key === 'removeListener') continue;
                      this.removeAllListeners(key);
                    }
                    this.removeAllListeners('removeListener');
                    this._events = new EventHandlers();
                    this._eventsCount = 0;
                    return this;
                  }

                  listeners = events[type];

                  if (typeof listeners === 'function') {
                    this.removeListener(type, listeners);
                  } else if (listeners) {
                    // LIFO order
                    do {
                      this.removeListener(type, listeners[listeners.length - 1]);
                    } while (listeners[0]);
                  }

                  return this;
                };

            EventEmitter.prototype.listeners = function listeners(type) {
              var evlistener;
              var ret;
              var events = this._events;

              if (!events)
                ret = [];
              else {
                evlistener = events[type];
                if (!evlistener)
                  ret = [];
                else if (typeof evlistener === 'function')
                  ret = [evlistener.listener || evlistener];
                else
                  ret = unwrapListeners(evlistener);
              }

              return ret;
            };

            EventEmitter.listenerCount = function(emitter, type) {
              if (typeof emitter.listenerCount === 'function') {
                return emitter.listenerCount(type);
              } else {
                return listenerCount$1.call(emitter, type);
              }
            };

            EventEmitter.prototype.listenerCount = listenerCount$1;
            function listenerCount$1(type) {
              var events = this._events;

              if (events) {
                var evlistener = events[type];

                if (typeof evlistener === 'function') {
                  return 1;
                } else if (evlistener) {
                  return evlistener.length;
                }
              }

              return 0;
            }

            EventEmitter.prototype.eventNames = function eventNames() {
              return this._eventsCount > 0 ? Reflect.ownKeys(this._events) : [];
            };

            // About 1.5x faster than the two-arg version of Array#splice().
            function spliceOne(list, index) {
              for (var i = index, k = i + 1, n = list.length; k < n; i += 1, k += 1)
                list[i] = list[k];
              list.pop();
            }

            function arrayClone(arr, i) {
              var copy = new Array(i);
              while (i--)
                copy[i] = arr[i];
              return copy;
            }

            function unwrapListeners(arr) {
              var ret = new Array(arr.length);
              for (var i = 0; i < ret.length; ++i) {
                ret[i] = arr[i].listener || arr[i];
              }
              return ret;
            }

            // shim for using process in browser
            // based off https://github.com/defunctzombie/node-process/blob/master/browser.js

            function defaultSetTimout() {
                throw new Error('setTimeout has not been defined');
            }
            function defaultClearTimeout () {
                throw new Error('clearTimeout has not been defined');
            }
            var cachedSetTimeout = defaultSetTimout;
            var cachedClearTimeout = defaultClearTimeout;
            if (typeof global$1.setTimeout === 'function') {
                cachedSetTimeout = setTimeout;
            }
            if (typeof global$1.clearTimeout === 'function') {
                cachedClearTimeout = clearTimeout;
            }

            function runTimeout(fun) {
                if (cachedSetTimeout === setTimeout) {
                    //normal enviroments in sane situations
                    return setTimeout(fun, 0);
                }
                // if setTimeout wasn't available but was latter defined
                if ((cachedSetTimeout === defaultSetTimout || !cachedSetTimeout) && setTimeout) {
                    cachedSetTimeout = setTimeout;
                    return setTimeout(fun, 0);
                }
                try {
                    // when when somebody has screwed with setTimeout but no I.E. maddness
                    return cachedSetTimeout(fun, 0);
                } catch(e){
                    try {
                        // When we are in I.E. but the script has been evaled so I.E. doesn't trust the global object when called normally
                        return cachedSetTimeout.call(null, fun, 0);
                    } catch(e){
                        // same as above but when it's a version of I.E. that must have the global object for 'this', hopfully our context correct otherwise it will throw a global error
                        return cachedSetTimeout.call(this, fun, 0);
                    }
                }


            }
            function runClearTimeout(marker) {
                if (cachedClearTimeout === clearTimeout) {
                    //normal enviroments in sane situations
                    return clearTimeout(marker);
                }
                // if clearTimeout wasn't available but was latter defined
                if ((cachedClearTimeout === defaultClearTimeout || !cachedClearTimeout) && clearTimeout) {
                    cachedClearTimeout = clearTimeout;
                    return clearTimeout(marker);
                }
                try {
                    // when when somebody has screwed with setTimeout but no I.E. maddness
                    return cachedClearTimeout(marker);
                } catch (e){
                    try {
                        // When we are in I.E. but the script has been evaled so I.E. doesn't  trust the global object when called normally
                        return cachedClearTimeout.call(null, marker);
                    } catch (e){
                        // same as above but when it's a version of I.E. that must have the global object for 'this', hopfully our context correct otherwise it will throw a global error.
                        // Some versions of I.E. have different rules for clearTimeout vs setTimeout
                        return cachedClearTimeout.call(this, marker);
                    }
                }



            }
            var queue = [];
            var draining = false;
            var currentQueue;
            var queueIndex = -1;

            function cleanUpNextTick() {
                if (!draining || !currentQueue) {
                    return;
                }
                draining = false;
                if (currentQueue.length) {
                    queue = currentQueue.concat(queue);
                } else {
                    queueIndex = -1;
                }
                if (queue.length) {
                    drainQueue();
                }
            }

            function drainQueue() {
                if (draining) {
                    return;
                }
                var timeout = runTimeout(cleanUpNextTick);
                draining = true;

                var len = queue.length;
                while(len) {
                    currentQueue = queue;
                    queue = [];
                    while (++queueIndex < len) {
                        if (currentQueue) {
                            currentQueue[queueIndex].run();
                        }
                    }
                    queueIndex = -1;
                    len = queue.length;
                }
                currentQueue = null;
                draining = false;
                runClearTimeout(timeout);
            }
            function nextTick(fun) {
                var args = new Array(arguments.length - 1);
                if (arguments.length > 1) {
                    for (var i = 1; i < arguments.length; i++) {
                        args[i - 1] = arguments[i];
                    }
                }
                queue.push(new Item(fun, args));
                if (queue.length === 1 && !draining) {
                    runTimeout(drainQueue);
                }
            }
            // v8 likes predictible objects
            function Item(fun, array) {
                this.fun = fun;
                this.array = array;
            }
            Item.prototype.run = function () {
                this.fun.apply(null, this.array);
            };
            var title = 'browser';
            var platform = 'browser';
            var browser = true;
            var env = {};
            var argv = [];
            var version = ''; // empty string to avoid regexp issues
            var versions = {};
            var release = {};
            var config = {};

            function noop() {}

            var on = noop;
            var addListener = noop;
            var once = noop;
            var off = noop;
            var removeListener = noop;
            var removeAllListeners = noop;
            var emit = noop;

            function binding$1(name) {
                throw new Error('process.binding is not supported');
            }

            function cwd () { return '/' }
            function chdir (dir) {
                throw new Error('process.chdir is not supported');
            }function umask() { return 0; }

            // from https://github.com/kumavis/browser-process-hrtime/blob/master/index.js
            var performance = global$1.performance || {};
            var performanceNow =
              performance.now        ||
              performance.mozNow     ||
              performance.msNow      ||
              performance.oNow       ||
              performance.webkitNow  ||
              function(){ return (new Date()).getTime() };

            // generate timestamp or delta
            // see http://nodejs.org/api/process.html#process_process_hrtime
            function hrtime(previousTimestamp){
              var clocktime = performanceNow.call(performance)*1e-3;
              var seconds = Math.floor(clocktime);
              var nanoseconds = Math.floor((clocktime%1)*1e9);
              if (previousTimestamp) {
                seconds = seconds - previousTimestamp[0];
                nanoseconds = nanoseconds - previousTimestamp[1];
                if (nanoseconds<0) {
                  seconds--;
                  nanoseconds += 1e9;
                }
              }
              return [seconds,nanoseconds]
            }

            var startTime = new Date();
            function uptime() {
              var currentTime = new Date();
              var dif = currentTime - startTime;
              return dif / 1000;
            }

            var browser$1 = {
              nextTick: nextTick,
              title: title,
              browser: browser,
              env: env,
              argv: argv,
              version: version,
              versions: versions,
              on: on,
              addListener: addListener,
              once: once,
              off: off,
              removeListener: removeListener,
              removeAllListeners: removeAllListeners,
              emit: emit,
              binding: binding$1,
              cwd: cwd,
              chdir: chdir,
              umask: umask,
              hrtime: hrtime,
              platform: platform,
              release: release,
              config: config,
              uptime: uptime
            };

            var inherits;
            if (typeof Object.create === 'function'){
              inherits = function inherits(ctor, superCtor) {
                // implementation from standard node.js 'util' module
                ctor.super_ = superCtor;
                ctor.prototype = Object.create(superCtor.prototype, {
                  constructor: {
                    value: ctor,
                    enumerable: false,
                    writable: true,
                    configurable: true
                  }
                });
              };
            } else {
              inherits = function inherits(ctor, superCtor) {
                ctor.super_ = superCtor;
                var TempCtor = function () {};
                TempCtor.prototype = superCtor.prototype;
                ctor.prototype = new TempCtor();
                ctor.prototype.constructor = ctor;
              };
            }
            var inherits$1 = inherits;

            var formatRegExp = /%[sdj%]/g;
            function format$1(f) {
              if (!isString(f)) {
                var objects = [];
                for (var i = 0; i < arguments.length; i++) {
                  objects.push(inspect(arguments[i]));
                }
                return objects.join(' ');
              }

              var i = 1;
              var args = arguments;
              var len = args.length;
              var str = String(f).replace(formatRegExp, function(x) {
                if (x === '%%') return '%';
                if (i >= len) return x;
                switch (x) {
                  case '%s': return String(args[i++]);
                  case '%d': return Number(args[i++]);
                  case '%j':
                    try {
                      return JSON.stringify(args[i++]);
                    } catch (_) {
                      return '[Circular]';
                    }
                  default:
                    return x;
                }
              });
              for (var x = args[i]; i < len; x = args[++i]) {
                if (isNull(x) || !isObject(x)) {
                  str += ' ' + x;
                } else {
                  str += ' ' + inspect(x);
                }
              }
              return str;
            }

            // Mark that a method should not be used.
            // Returns a modified function which warns once by default.
            // If --no-deprecation is set, then it is a no-op.
            function deprecate(fn, msg) {
              // Allow for deprecating things in the process of starting up.
              if (isUndefined(global$1.process)) {
                return function() {
                  return deprecate(fn, msg).apply(this, arguments);
                };
              }

              if (browser$1.noDeprecation === true) {
                return fn;
              }

              var warned = false;
              function deprecated() {
                if (!warned) {
                  if (browser$1.throwDeprecation) {
                    throw new Error(msg);
                  } else if (browser$1.traceDeprecation) {
                    console.trace(msg);
                  } else {
                    console.error(msg);
                  }
                  warned = true;
                }
                return fn.apply(this, arguments);
              }

              return deprecated;
            }

            var debugs = {};
            var debugEnviron;
            function debuglog(set) {
              if (isUndefined(debugEnviron))
                debugEnviron = browser$1.env.NODE_DEBUG || '';
              set = set.toUpperCase();
              if (!debugs[set]) {
                if (new RegExp('\\b' + set + '\\b', 'i').test(debugEnviron)) {
                  var pid = 0;
                  debugs[set] = function() {
                    var msg = format$1.apply(null, arguments);
                    console.error('%s %d: %s', set, pid, msg);
                  };
                } else {
                  debugs[set] = function() {};
                }
              }
              return debugs[set];
            }

            /**
             * Echos the value of a value. Trys to print the value out
             * in the best way possible given the different types.
             *
             * @param {Object} obj The object to print out.
             * @param {Object} opts Optional options object that alters the output.
             */
            /* legacy: obj, showHidden, depth, colors*/
            function inspect(obj, opts) {
              // default options
              var ctx = {
                seen: [],
                stylize: stylizeNoColor
              };
              // legacy...
              if (arguments.length >= 3) ctx.depth = arguments[2];
              if (arguments.length >= 4) ctx.colors = arguments[3];
              if (isBoolean(opts)) {
                // legacy...
                ctx.showHidden = opts;
              } else if (opts) {
                // got an "options" object
                _extend(ctx, opts);
              }
              // set default options
              if (isUndefined(ctx.showHidden)) ctx.showHidden = false;
              if (isUndefined(ctx.depth)) ctx.depth = 2;
              if (isUndefined(ctx.colors)) ctx.colors = false;
              if (isUndefined(ctx.customInspect)) ctx.customInspect = true;
              if (ctx.colors) ctx.stylize = stylizeWithColor;
              return formatValue(ctx, obj, ctx.depth);
            }

            // http://en.wikipedia.org/wiki/ANSI_escape_code#graphics
            inspect.colors = {
              'bold' : [1, 22],
              'italic' : [3, 23],
              'underline' : [4, 24],
              'inverse' : [7, 27],
              'white' : [37, 39],
              'grey' : [90, 39],
              'black' : [30, 39],
              'blue' : [34, 39],
              'cyan' : [36, 39],
              'green' : [32, 39],
              'magenta' : [35, 39],
              'red' : [31, 39],
              'yellow' : [33, 39]
            };

            // Don't use 'blue' not visible on cmd.exe
            inspect.styles = {
              'special': 'cyan',
              'number': 'yellow',
              'boolean': 'yellow',
              'undefined': 'grey',
              'null': 'bold',
              'string': 'green',
              'date': 'magenta',
              // "name": intentionally not styling
              'regexp': 'red'
            };


            function stylizeWithColor(str, styleType) {
              var style = inspect.styles[styleType];

              if (style) {
                return '\u001b[' + inspect.colors[style][0] + 'm' + str +
                       '\u001b[' + inspect.colors[style][1] + 'm';
              } else {
                return str;
              }
            }


            function stylizeNoColor(str, styleType) {
              return str;
            }


            function arrayToHash(array) {
              var hash = {};

              array.forEach(function(val, idx) {
                hash[val] = true;
              });

              return hash;
            }


            function formatValue(ctx, value, recurseTimes) {
              // Provide a hook for user-specified inspect functions.
              // Check that value is an object with an inspect function on it
              if (ctx.customInspect &&
                  value &&
                  isFunction$1(value.inspect) &&
                  // Filter out the util module, it's inspect function is special
                  value.inspect !== inspect &&
                  // Also filter out any prototype objects using the circular check.
                  !(value.constructor && value.constructor.prototype === value)) {
                var ret = value.inspect(recurseTimes, ctx);
                if (!isString(ret)) {
                  ret = formatValue(ctx, ret, recurseTimes);
                }
                return ret;
              }

              // Primitive types cannot have properties
              var primitive = formatPrimitive(ctx, value);
              if (primitive) {
                return primitive;
              }

              // Look up the keys of the object.
              var keys = Object.keys(value);
              var visibleKeys = arrayToHash(keys);

              if (ctx.showHidden) {
                keys = Object.getOwnPropertyNames(value);
              }

              // IE doesn't make error fields non-enumerable
              // http://msdn.microsoft.com/en-us/library/ie/dww52sbt(v=vs.94).aspx
              if (isError(value)
                  && (keys.indexOf('message') >= 0 || keys.indexOf('description') >= 0)) {
                return formatError(value);
              }

              // Some type of object without properties can be shortcutted.
              if (keys.length === 0) {
                if (isFunction$1(value)) {
                  var name = value.name ? ': ' + value.name : '';
                  return ctx.stylize('[Function' + name + ']', 'special');
                }
                if (isRegExp(value)) {
                  return ctx.stylize(RegExp.prototype.toString.call(value), 'regexp');
                }
                if (isDate(value)) {
                  return ctx.stylize(Date.prototype.toString.call(value), 'date');
                }
                if (isError(value)) {
                  return formatError(value);
                }
              }

              var base = '', array = false, braces = ['{', '}'];

              // Make Array say that they are Array
              if (isArray$1(value)) {
                array = true;
                braces = ['[', ']'];
              }

              // Make functions say that they are functions
              if (isFunction$1(value)) {
                var n = value.name ? ': ' + value.name : '';
                base = ' [Function' + n + ']';
              }

              // Make RegExps say that they are RegExps
              if (isRegExp(value)) {
                base = ' ' + RegExp.prototype.toString.call(value);
              }

              // Make dates with properties first say the date
              if (isDate(value)) {
                base = ' ' + Date.prototype.toUTCString.call(value);
              }

              // Make error with message first say the error
              if (isError(value)) {
                base = ' ' + formatError(value);
              }

              if (keys.length === 0 && (!array || value.length == 0)) {
                return braces[0] + base + braces[1];
              }

              if (recurseTimes < 0) {
                if (isRegExp(value)) {
                  return ctx.stylize(RegExp.prototype.toString.call(value), 'regexp');
                } else {
                  return ctx.stylize('[Object]', 'special');
                }
              }

              ctx.seen.push(value);

              var output;
              if (array) {
                output = formatArray(ctx, value, recurseTimes, visibleKeys, keys);
              } else {
                output = keys.map(function(key) {
                  return formatProperty(ctx, value, recurseTimes, visibleKeys, key, array);
                });
              }

              ctx.seen.pop();

              return reduceToSingleString(output, base, braces);
            }


            function formatPrimitive(ctx, value) {
              if (isUndefined(value))
                return ctx.stylize('undefined', 'undefined');
              if (isString(value)) {
                var simple = '\'' + JSON.stringify(value).replace(/^"|"$/g, '')
                                                         .replace(/'/g, "\\'")
                                                         .replace(/\\"/g, '"') + '\'';
                return ctx.stylize(simple, 'string');
              }
              if (isNumber(value))
                return ctx.stylize('' + value, 'number');
              if (isBoolean(value))
                return ctx.stylize('' + value, 'boolean');
              // For some reason typeof null is "object", so special case here.
              if (isNull(value))
                return ctx.stylize('null', 'null');
            }


            function formatError(value) {
              return '[' + Error.prototype.toString.call(value) + ']';
            }


            function formatArray(ctx, value, recurseTimes, visibleKeys, keys) {
              var output = [];
              for (var i = 0, l = value.length; i < l; ++i) {
                if (hasOwnProperty$1(value, String(i))) {
                  output.push(formatProperty(ctx, value, recurseTimes, visibleKeys,
                      String(i), true));
                } else {
                  output.push('');
                }
              }
              keys.forEach(function(key) {
                if (!key.match(/^\d+$/)) {
                  output.push(formatProperty(ctx, value, recurseTimes, visibleKeys,
                      key, true));
                }
              });
              return output;
            }


            function formatProperty(ctx, value, recurseTimes, visibleKeys, key, array) {
              var name, str, desc;
              desc = Object.getOwnPropertyDescriptor(value, key) || { value: value[key] };
              if (desc.get) {
                if (desc.set) {
                  str = ctx.stylize('[Getter/Setter]', 'special');
                } else {
                  str = ctx.stylize('[Getter]', 'special');
                }
              } else {
                if (desc.set) {
                  str = ctx.stylize('[Setter]', 'special');
                }
              }
              if (!hasOwnProperty$1(visibleKeys, key)) {
                name = '[' + key + ']';
              }
              if (!str) {
                if (ctx.seen.indexOf(desc.value) < 0) {
                  if (isNull(recurseTimes)) {
                    str = formatValue(ctx, desc.value, null);
                  } else {
                    str = formatValue(ctx, desc.value, recurseTimes - 1);
                  }
                  if (str.indexOf('\n') > -1) {
                    if (array) {
                      str = str.split('\n').map(function(line) {
                        return '  ' + line;
                      }).join('\n').substr(2);
                    } else {
                      str = '\n' + str.split('\n').map(function(line) {
                        return '   ' + line;
                      }).join('\n');
                    }
                  }
                } else {
                  str = ctx.stylize('[Circular]', 'special');
                }
              }
              if (isUndefined(name)) {
                if (array && key.match(/^\d+$/)) {
                  return str;
                }
                name = JSON.stringify('' + key);
                if (name.match(/^"([a-zA-Z_][a-zA-Z_0-9]*)"$/)) {
                  name = name.substr(1, name.length - 2);
                  name = ctx.stylize(name, 'name');
                } else {
                  name = name.replace(/'/g, "\\'")
                             .replace(/\\"/g, '"')
                             .replace(/(^"|"$)/g, "'");
                  name = ctx.stylize(name, 'string');
                }
              }

              return name + ': ' + str;
            }


            function reduceToSingleString(output, base, braces) {
              var length = output.reduce(function(prev, cur) {
                if (cur.indexOf('\n') >= 0) ;
                return prev + cur.replace(/\u001b\[\d\d?m/g, '').length + 1;
              }, 0);

              if (length > 60) {
                return braces[0] +
                       (base === '' ? '' : base + '\n ') +
                       ' ' +
                       output.join(',\n  ') +
                       ' ' +
                       braces[1];
              }

              return braces[0] + base + ' ' + output.join(', ') + ' ' + braces[1];
            }


            // NOTE: These type checking functions intentionally don't use `instanceof`
            // because it is fragile and can be easily faked with `Object.create()`.
            function isArray$1(ar) {
              return Array.isArray(ar);
            }

            function isBoolean(arg) {
              return typeof arg === 'boolean';
            }

            function isNull(arg) {
              return arg === null;
            }

            function isNullOrUndefined(arg) {
              return arg == null;
            }

            function isNumber(arg) {
              return typeof arg === 'number';
            }

            function isString(arg) {
              return typeof arg === 'string';
            }

            function isUndefined(arg) {
              return arg === void 0;
            }

            function isRegExp(re) {
              return isObject(re) && objectToString(re) === '[object RegExp]';
            }

            function isObject(arg) {
              return typeof arg === 'object' && arg !== null;
            }

            function isDate(d) {
              return isObject(d) && objectToString(d) === '[object Date]';
            }

            function isError(e) {
              return isObject(e) &&
                  (objectToString(e) === '[object Error]' || e instanceof Error);
            }

            function isFunction$1(arg) {
              return typeof arg === 'function';
            }

            function objectToString(o) {
              return Object.prototype.toString.call(o);
            }

            function _extend(origin, add) {
              // Don't do anything if add isn't an object
              if (!add || !isObject(add)) return origin;

              var keys = Object.keys(add);
              var i = keys.length;
              while (i--) {
                origin[keys[i]] = add[keys[i]];
              }
              return origin;
            }
            function hasOwnProperty$1(obj, prop) {
              return Object.prototype.hasOwnProperty.call(obj, prop);
            }

            function BufferList() {
              this.head = null;
              this.tail = null;
              this.length = 0;
            }

            BufferList.prototype.push = function (v) {
              var entry = { data: v, next: null };
              if (this.length > 0) this.tail.next = entry;else this.head = entry;
              this.tail = entry;
              ++this.length;
            };

            BufferList.prototype.unshift = function (v) {
              var entry = { data: v, next: this.head };
              if (this.length === 0) this.tail = entry;
              this.head = entry;
              ++this.length;
            };

            BufferList.prototype.shift = function () {
              if (this.length === 0) return;
              var ret = this.head.data;
              if (this.length === 1) this.head = this.tail = null;else this.head = this.head.next;
              --this.length;
              return ret;
            };

            BufferList.prototype.clear = function () {
              this.head = this.tail = null;
              this.length = 0;
            };

            BufferList.prototype.join = function (s) {
              if (this.length === 0) return '';
              var p = this.head;
              var ret = '' + p.data;
              while (p = p.next) {
                ret += s + p.data;
              }return ret;
            };

            BufferList.prototype.concat = function (n) {
              if (this.length === 0) return Buffer$1.alloc(0);
              if (this.length === 1) return this.head.data;
              var ret = Buffer$1.allocUnsafe(n >>> 0);
              var p = this.head;
              var i = 0;
              while (p) {
                p.data.copy(ret, i);
                i += p.data.length;
                p = p.next;
              }
              return ret;
            };

            // Copyright Joyent, Inc. and other Node contributors.
            var isBufferEncoding = Buffer$1.isEncoding
              || function(encoding) {
                   switch (encoding && encoding.toLowerCase()) {
                     case 'hex': case 'utf8': case 'utf-8': case 'ascii': case 'binary': case 'base64': case 'ucs2': case 'ucs-2': case 'utf16le': case 'utf-16le': case 'raw': return true;
                     default: return false;
                   }
                 };


            function assertEncoding(encoding) {
              if (encoding && !isBufferEncoding(encoding)) {
                throw new Error('Unknown encoding: ' + encoding);
              }
            }

            // StringDecoder provides an interface for efficiently splitting a series of
            // buffers into a series of JS strings without breaking apart multi-byte
            // characters. CESU-8 is handled as part of the UTF-8 encoding.
            //
            // @TODO Handling all encodings inside a single object makes it very difficult
            // to reason about this code, so it should be split up in the future.
            // @TODO There should be a utf8-strict encoding that rejects invalid UTF-8 code
            // points as used by CESU-8.
            function StringDecoder(encoding) {
              this.encoding = (encoding || 'utf8').toLowerCase().replace(/[-_]/, '');
              assertEncoding(encoding);
              switch (this.encoding) {
                case 'utf8':
                  // CESU-8 represents each of Surrogate Pair by 3-bytes
                  this.surrogateSize = 3;
                  break;
                case 'ucs2':
                case 'utf16le':
                  // UTF-16 represents each of Surrogate Pair by 2-bytes
                  this.surrogateSize = 2;
                  this.detectIncompleteChar = utf16DetectIncompleteChar;
                  break;
                case 'base64':
                  // Base-64 stores 3 bytes in 4 chars, and pads the remainder.
                  this.surrogateSize = 3;
                  this.detectIncompleteChar = base64DetectIncompleteChar;
                  break;
                default:
                  this.write = passThroughWrite;
                  return;
              }

              // Enough space to store all bytes of a single character. UTF-8 needs 4
              // bytes, but CESU-8 may require up to 6 (3 bytes per surrogate).
              this.charBuffer = new Buffer$1(6);
              // Number of bytes received for the current incomplete multi-byte character.
              this.charReceived = 0;
              // Number of bytes expected for the current incomplete multi-byte character.
              this.charLength = 0;
            }

            // write decodes the given buffer and returns it as JS string that is
            // guaranteed to not contain any partial multi-byte characters. Any partial
            // character found at the end of the buffer is buffered up, and will be
            // returned when calling write again with the remaining bytes.
            //
            // Note: Converting a Buffer containing an orphan surrogate to a String
            // currently works, but converting a String to a Buffer (via `new Buffer`, or
            // Buffer#write) will replace incomplete surrogates with the unicode
            // replacement character. See https://codereview.chromium.org/121173009/ .
            StringDecoder.prototype.write = function(buffer) {
              var charStr = '';
              // if our last write ended with an incomplete multibyte character
              while (this.charLength) {
                // determine how many remaining bytes this buffer has to offer for this char
                var available = (buffer.length >= this.charLength - this.charReceived) ?
                    this.charLength - this.charReceived :
                    buffer.length;

                // add the new bytes to the char buffer
                buffer.copy(this.charBuffer, this.charReceived, 0, available);
                this.charReceived += available;

                if (this.charReceived < this.charLength) {
                  // still not enough chars in this buffer? wait for more ...
                  return '';
                }

                // remove bytes belonging to the current character from the buffer
                buffer = buffer.slice(available, buffer.length);

                // get the character that was split
                charStr = this.charBuffer.slice(0, this.charLength).toString(this.encoding);

                // CESU-8: lead surrogate (D800-DBFF) is also the incomplete character
                var charCode = charStr.charCodeAt(charStr.length - 1);
                if (charCode >= 0xD800 && charCode <= 0xDBFF) {
                  this.charLength += this.surrogateSize;
                  charStr = '';
                  continue;
                }
                this.charReceived = this.charLength = 0;

                // if there are no more bytes in this buffer, just emit our char
                if (buffer.length === 0) {
                  return charStr;
                }
                break;
              }

              // determine and set charLength / charReceived
              this.detectIncompleteChar(buffer);

              var end = buffer.length;
              if (this.charLength) {
                // buffer the incomplete character bytes we got
                buffer.copy(this.charBuffer, 0, buffer.length - this.charReceived, end);
                end -= this.charReceived;
              }

              charStr += buffer.toString(this.encoding, 0, end);

              var end = charStr.length - 1;
              var charCode = charStr.charCodeAt(end);
              // CESU-8: lead surrogate (D800-DBFF) is also the incomplete character
              if (charCode >= 0xD800 && charCode <= 0xDBFF) {
                var size = this.surrogateSize;
                this.charLength += size;
                this.charReceived += size;
                this.charBuffer.copy(this.charBuffer, size, 0, size);
                buffer.copy(this.charBuffer, 0, 0, size);
                return charStr.substring(0, end);
              }

              // or just emit the charStr
              return charStr;
            };

            // detectIncompleteChar determines if there is an incomplete UTF-8 character at
            // the end of the given buffer. If so, it sets this.charLength to the byte
            // length that character, and sets this.charReceived to the number of bytes
            // that are available for this character.
            StringDecoder.prototype.detectIncompleteChar = function(buffer) {
              // determine how many bytes we have to check at the end of this buffer
              var i = (buffer.length >= 3) ? 3 : buffer.length;

              // Figure out if one of the last i bytes of our buffer announces an
              // incomplete char.
              for (; i > 0; i--) {
                var c = buffer[buffer.length - i];

                // See http://en.wikipedia.org/wiki/UTF-8#Description

                // 110XXXXX
                if (i == 1 && c >> 5 == 0x06) {
                  this.charLength = 2;
                  break;
                }

                // 1110XXXX
                if (i <= 2 && c >> 4 == 0x0E) {
                  this.charLength = 3;
                  break;
                }

                // 11110XXX
                if (i <= 3 && c >> 3 == 0x1E) {
                  this.charLength = 4;
                  break;
                }
              }
              this.charReceived = i;
            };

            StringDecoder.prototype.end = function(buffer) {
              var res = '';
              if (buffer && buffer.length)
                res = this.write(buffer);

              if (this.charReceived) {
                var cr = this.charReceived;
                var buf = this.charBuffer;
                var enc = this.encoding;
                res += buf.slice(0, cr).toString(enc);
              }

              return res;
            };

            function passThroughWrite(buffer) {
              return buffer.toString(this.encoding);
            }

            function utf16DetectIncompleteChar(buffer) {
              this.charReceived = buffer.length % 2;
              this.charLength = this.charReceived ? 2 : 0;
            }

            function base64DetectIncompleteChar(buffer) {
              this.charReceived = buffer.length % 3;
              this.charLength = this.charReceived ? 3 : 0;
            }

            Readable$1.ReadableState = ReadableState;

            var debug = debuglog('stream');
            inherits$1(Readable$1, EventEmitter);

            function prependListener(emitter, event, fn) {
              // Sadly this is not cacheable as some libraries bundle their own
              // event emitter implementation with them.
              if (typeof emitter.prependListener === 'function') {
                return emitter.prependListener(event, fn);
              } else {
                // This is a hack to make sure that our error handler is attached before any
                // userland ones.  NEVER DO THIS. This is here only because this code needs
                // to continue to work with older versions of Node.js that do not include
                // the prependListener() method. The goal is to eventually remove this hack.
                if (!emitter._events || !emitter._events[event])
                  emitter.on(event, fn);
                else if (Array.isArray(emitter._events[event]))
                  emitter._events[event].unshift(fn);
                else
                  emitter._events[event] = [fn, emitter._events[event]];
              }
            }
            function listenerCount (emitter, type) {
              return emitter.listeners(type).length;
            }
            function ReadableState(options, stream) {

              options = options || {};

              // object stream flag. Used to make read(n) ignore n and to
              // make all the buffer merging and length checks go away
              this.objectMode = !!options.objectMode;

              if (stream instanceof Duplex) this.objectMode = this.objectMode || !!options.readableObjectMode;

              // the point at which it stops calling _read() to fill the buffer
              // Note: 0 is a valid value, means "don't call _read preemptively ever"
              var hwm = options.highWaterMark;
              var defaultHwm = this.objectMode ? 16 : 16 * 1024;
              this.highWaterMark = hwm || hwm === 0 ? hwm : defaultHwm;

              // cast to ints.
              this.highWaterMark = ~ ~this.highWaterMark;

              // A linked list is used to store data chunks instead of an array because the
              // linked list can remove elements from the beginning faster than
              // array.shift()
              this.buffer = new BufferList();
              this.length = 0;
              this.pipes = null;
              this.pipesCount = 0;
              this.flowing = null;
              this.ended = false;
              this.endEmitted = false;
              this.reading = false;

              // a flag to be able to tell if the onwrite cb is called immediately,
              // or on a later tick.  We set this to true at first, because any
              // actions that shouldn't happen until "later" should generally also
              // not happen before the first write call.
              this.sync = true;

              // whenever we return null, then we set a flag to say
              // that we're awaiting a 'readable' event emission.
              this.needReadable = false;
              this.emittedReadable = false;
              this.readableListening = false;
              this.resumeScheduled = false;

              // Crypto is kind of old and crusty.  Historically, its default string
              // encoding is 'binary' so we have to make this configurable.
              // Everything else in the universe uses 'utf8', though.
              this.defaultEncoding = options.defaultEncoding || 'utf8';

              // when piping, we only care about 'readable' events that happen
              // after read()ing all the bytes and not getting any pushback.
              this.ranOut = false;

              // the number of writers that are awaiting a drain event in .pipe()s
              this.awaitDrain = 0;

              // if true, a maybeReadMore has been scheduled
              this.readingMore = false;

              this.decoder = null;
              this.encoding = null;
              if (options.encoding) {
                this.decoder = new StringDecoder(options.encoding);
                this.encoding = options.encoding;
              }
            }
            function Readable$1(options) {

              if (!(this instanceof Readable$1)) return new Readable$1(options);

              this._readableState = new ReadableState(options, this);

              // legacy
              this.readable = true;

              if (options && typeof options.read === 'function') this._read = options.read;

              EventEmitter.call(this);
            }

            // Manually shove something into the read() buffer.
            // This returns true if the highWaterMark has not been hit yet,
            // similar to how Writable.write() returns true if you should
            // write() some more.
            Readable$1.prototype.push = function (chunk, encoding) {
              var state = this._readableState;

              if (!state.objectMode && typeof chunk === 'string') {
                encoding = encoding || state.defaultEncoding;
                if (encoding !== state.encoding) {
                  chunk = Buffer$1.from(chunk, encoding);
                  encoding = '';
                }
              }

              return readableAddChunk(this, state, chunk, encoding, false);
            };

            // Unshift should *always* be something directly out of read()
            Readable$1.prototype.unshift = function (chunk) {
              var state = this._readableState;
              return readableAddChunk(this, state, chunk, '', true);
            };

            Readable$1.prototype.isPaused = function () {
              return this._readableState.flowing === false;
            };

            function readableAddChunk(stream, state, chunk, encoding, addToFront) {
              var er = chunkInvalid(state, chunk);
              if (er) {
                stream.emit('error', er);
              } else if (chunk === null) {
                state.reading = false;
                onEofChunk(stream, state);
              } else if (state.objectMode || chunk && chunk.length > 0) {
                if (state.ended && !addToFront) {
                  var e = new Error('stream.push() after EOF');
                  stream.emit('error', e);
                } else if (state.endEmitted && addToFront) {
                  var _e = new Error('stream.unshift() after end event');
                  stream.emit('error', _e);
                } else {
                  var skipAdd;
                  if (state.decoder && !addToFront && !encoding) {
                    chunk = state.decoder.write(chunk);
                    skipAdd = !state.objectMode && chunk.length === 0;
                  }

                  if (!addToFront) state.reading = false;

                  // Don't add to the buffer if we've decoded to an empty string chunk and
                  // we're not in object mode
                  if (!skipAdd) {
                    // if we want the data now, just emit it.
                    if (state.flowing && state.length === 0 && !state.sync) {
                      stream.emit('data', chunk);
                      stream.read(0);
                    } else {
                      // update the buffer info.
                      state.length += state.objectMode ? 1 : chunk.length;
                      if (addToFront) state.buffer.unshift(chunk);else state.buffer.push(chunk);

                      if (state.needReadable) emitReadable(stream);
                    }
                  }

                  maybeReadMore(stream, state);
                }
              } else if (!addToFront) {
                state.reading = false;
              }

              return needMoreData(state);
            }

            // if it's past the high water mark, we can push in some more.
            // Also, if we have no data yet, we can stand some
            // more bytes.  This is to work around cases where hwm=0,
            // such as the repl.  Also, if the push() triggered a
            // readable event, and the user called read(largeNumber) such that
            // needReadable was set, then we ought to push more, so that another
            // 'readable' event will be triggered.
            function needMoreData(state) {
              return !state.ended && (state.needReadable || state.length < state.highWaterMark || state.length === 0);
            }

            // backwards compatibility.
            Readable$1.prototype.setEncoding = function (enc) {
              this._readableState.decoder = new StringDecoder(enc);
              this._readableState.encoding = enc;
              return this;
            };

            // Don't raise the hwm > 8MB
            var MAX_HWM = 0x800000;
            function computeNewHighWaterMark(n) {
              if (n >= MAX_HWM) {
                n = MAX_HWM;
              } else {
                // Get the next highest power of 2 to prevent increasing hwm excessively in
                // tiny amounts
                n--;
                n |= n >>> 1;
                n |= n >>> 2;
                n |= n >>> 4;
                n |= n >>> 8;
                n |= n >>> 16;
                n++;
              }
              return n;
            }

            // This function is designed to be inlinable, so please take care when making
            // changes to the function body.
            function howMuchToRead(n, state) {
              if (n <= 0 || state.length === 0 && state.ended) return 0;
              if (state.objectMode) return 1;
              if (n !== n) {
                // Only flow one buffer at a time
                if (state.flowing && state.length) return state.buffer.head.data.length;else return state.length;
              }
              // If we're asking for more than the current hwm, then raise the hwm.
              if (n > state.highWaterMark) state.highWaterMark = computeNewHighWaterMark(n);
              if (n <= state.length) return n;
              // Don't have enough
              if (!state.ended) {
                state.needReadable = true;
                return 0;
              }
              return state.length;
            }

            // you can override either this method, or the async _read(n) below.
            Readable$1.prototype.read = function (n) {
              debug('read', n);
              n = parseInt(n, 10);
              var state = this._readableState;
              var nOrig = n;

              if (n !== 0) state.emittedReadable = false;

              // if we're doing read(0) to trigger a readable event, but we
              // already have a bunch of data in the buffer, then just trigger
              // the 'readable' event and move on.
              if (n === 0 && state.needReadable && (state.length >= state.highWaterMark || state.ended)) {
                debug('read: emitReadable', state.length, state.ended);
                if (state.length === 0 && state.ended) endReadable(this);else emitReadable(this);
                return null;
              }

              n = howMuchToRead(n, state);

              // if we've ended, and we're now clear, then finish it up.
              if (n === 0 && state.ended) {
                if (state.length === 0) endReadable(this);
                return null;
              }

              // All the actual chunk generation logic needs to be
              // *below* the call to _read.  The reason is that in certain
              // synthetic stream cases, such as passthrough streams, _read
              // may be a completely synchronous operation which may change
              // the state of the read buffer, providing enough data when
              // before there was *not* enough.
              //
              // So, the steps are:
              // 1. Figure out what the state of things will be after we do
              // a read from the buffer.
              //
              // 2. If that resulting state will trigger a _read, then call _read.
              // Note that this may be asynchronous, or synchronous.  Yes, it is
              // deeply ugly to write APIs this way, but that still doesn't mean
              // that the Readable class should behave improperly, as streams are
              // designed to be sync/async agnostic.
              // Take note if the _read call is sync or async (ie, if the read call
              // has returned yet), so that we know whether or not it's safe to emit
              // 'readable' etc.
              //
              // 3. Actually pull the requested chunks out of the buffer and return.

              // if we need a readable event, then we need to do some reading.
              var doRead = state.needReadable;
              debug('need readable', doRead);

              // if we currently have less than the highWaterMark, then also read some
              if (state.length === 0 || state.length - n < state.highWaterMark) {
                doRead = true;
                debug('length less than watermark', doRead);
              }

              // however, if we've ended, then there's no point, and if we're already
              // reading, then it's unnecessary.
              if (state.ended || state.reading) {
                doRead = false;
                debug('reading or ended', doRead);
              } else if (doRead) {
                debug('do read');
                state.reading = true;
                state.sync = true;
                // if the length is currently zero, then we *need* a readable event.
                if (state.length === 0) state.needReadable = true;
                // call internal read method
                this._read(state.highWaterMark);
                state.sync = false;
                // If _read pushed data synchronously, then `reading` will be false,
                // and we need to re-evaluate how much data we can return to the user.
                if (!state.reading) n = howMuchToRead(nOrig, state);
              }

              var ret;
              if (n > 0) ret = fromList(n, state);else ret = null;

              if (ret === null) {
                state.needReadable = true;
                n = 0;
              } else {
                state.length -= n;
              }

              if (state.length === 0) {
                // If we have nothing in the buffer, then we want to know
                // as soon as we *do* get something into the buffer.
                if (!state.ended) state.needReadable = true;

                // If we tried to read() past the EOF, then emit end on the next tick.
                if (nOrig !== n && state.ended) endReadable(this);
              }

              if (ret !== null) this.emit('data', ret);

              return ret;
            };

            function chunkInvalid(state, chunk) {
              var er = null;
              if (!Buffer$1.isBuffer(chunk) && typeof chunk !== 'string' && chunk !== null && chunk !== undefined && !state.objectMode) {
                er = new TypeError('Invalid non-string/buffer chunk');
              }
              return er;
            }

            function onEofChunk(stream, state) {
              if (state.ended) return;
              if (state.decoder) {
                var chunk = state.decoder.end();
                if (chunk && chunk.length) {
                  state.buffer.push(chunk);
                  state.length += state.objectMode ? 1 : chunk.length;
                }
              }
              state.ended = true;

              // emit 'readable' now to make sure it gets picked up.
              emitReadable(stream);
            }

            // Don't emit readable right away in sync mode, because this can trigger
            // another read() call => stack overflow.  This way, it might trigger
            // a nextTick recursion warning, but that's not so bad.
            function emitReadable(stream) {
              var state = stream._readableState;
              state.needReadable = false;
              if (!state.emittedReadable) {
                debug('emitReadable', state.flowing);
                state.emittedReadable = true;
                if (state.sync) nextTick(emitReadable_, stream);else emitReadable_(stream);
              }
            }

            function emitReadable_(stream) {
              debug('emit readable');
              stream.emit('readable');
              flow(stream);
            }

            // at this point, the user has presumably seen the 'readable' event,
            // and called read() to consume some data.  that may have triggered
            // in turn another _read(n) call, in which case reading = true if
            // it's in progress.
            // However, if we're not ended, or reading, and the length < hwm,
            // then go ahead and try to read some more preemptively.
            function maybeReadMore(stream, state) {
              if (!state.readingMore) {
                state.readingMore = true;
                nextTick(maybeReadMore_, stream, state);
              }
            }

            function maybeReadMore_(stream, state) {
              var len = state.length;
              while (!state.reading && !state.flowing && !state.ended && state.length < state.highWaterMark) {
                debug('maybeReadMore read 0');
                stream.read(0);
                if (len === state.length)
                  // didn't get any data, stop spinning.
                  break;else len = state.length;
              }
              state.readingMore = false;
            }

            // abstract method.  to be overridden in specific implementation classes.
            // call cb(er, data) where data is <= n in length.
            // for virtual (non-string, non-buffer) streams, "length" is somewhat
            // arbitrary, and perhaps not very meaningful.
            Readable$1.prototype._read = function (n) {
              this.emit('error', new Error('not implemented'));
            };

            Readable$1.prototype.pipe = function (dest, pipeOpts) {
              var src = this;
              var state = this._readableState;

              switch (state.pipesCount) {
                case 0:
                  state.pipes = dest;
                  break;
                case 1:
                  state.pipes = [state.pipes, dest];
                  break;
                default:
                  state.pipes.push(dest);
                  break;
              }
              state.pipesCount += 1;
              debug('pipe count=%d opts=%j', state.pipesCount, pipeOpts);

              var doEnd = (!pipeOpts || pipeOpts.end !== false);

              var endFn = doEnd ? onend : cleanup;
              if (state.endEmitted) nextTick(endFn);else src.once('end', endFn);

              dest.on('unpipe', onunpipe);
              function onunpipe(readable) {
                debug('onunpipe');
                if (readable === src) {
                  cleanup();
                }
              }

              function onend() {
                debug('onend');
                dest.end();
              }

              // when the dest drains, it reduces the awaitDrain counter
              // on the source.  This would be more elegant with a .once()
              // handler in flow(), but adding and removing repeatedly is
              // too slow.
              var ondrain = pipeOnDrain(src);
              dest.on('drain', ondrain);

              var cleanedUp = false;
              function cleanup() {
                debug('cleanup');
                // cleanup event handlers once the pipe is broken
                dest.removeListener('close', onclose);
                dest.removeListener('finish', onfinish);
                dest.removeListener('drain', ondrain);
                dest.removeListener('error', onerror);
                dest.removeListener('unpipe', onunpipe);
                src.removeListener('end', onend);
                src.removeListener('end', cleanup);
                src.removeListener('data', ondata);

                cleanedUp = true;

                // if the reader is waiting for a drain event from this
                // specific writer, then it would cause it to never start
                // flowing again.
                // So, if this is awaiting a drain, then we just call it now.
                // If we don't know, then assume that we are waiting for one.
                if (state.awaitDrain && (!dest._writableState || dest._writableState.needDrain)) ondrain();
              }

              // If the user pushes more data while we're writing to dest then we'll end up
              // in ondata again. However, we only want to increase awaitDrain once because
              // dest will only emit one 'drain' event for the multiple writes.
              // => Introduce a guard on increasing awaitDrain.
              var increasedAwaitDrain = false;
              src.on('data', ondata);
              function ondata(chunk) {
                debug('ondata');
                increasedAwaitDrain = false;
                var ret = dest.write(chunk);
                if (false === ret && !increasedAwaitDrain) {
                  // If the user unpiped during `dest.write()`, it is possible
                  // to get stuck in a permanently paused state if that write
                  // also returned false.
                  // => Check whether `dest` is still a piping destination.
                  if ((state.pipesCount === 1 && state.pipes === dest || state.pipesCount > 1 && indexOf(state.pipes, dest) !== -1) && !cleanedUp) {
                    debug('false write response, pause', src._readableState.awaitDrain);
                    src._readableState.awaitDrain++;
                    increasedAwaitDrain = true;
                  }
                  src.pause();
                }
              }

              // if the dest has an error, then stop piping into it.
              // however, don't suppress the throwing behavior for this.
              function onerror(er) {
                debug('onerror', er);
                unpipe();
                dest.removeListener('error', onerror);
                if (listenerCount(dest, 'error') === 0) dest.emit('error', er);
              }

              // Make sure our error handler is attached before userland ones.
              prependListener(dest, 'error', onerror);

              // Both close and finish should trigger unpipe, but only once.
              function onclose() {
                dest.removeListener('finish', onfinish);
                unpipe();
              }
              dest.once('close', onclose);
              function onfinish() {
                debug('onfinish');
                dest.removeListener('close', onclose);
                unpipe();
              }
              dest.once('finish', onfinish);

              function unpipe() {
                debug('unpipe');
                src.unpipe(dest);
              }

              // tell the dest that it's being piped to
              dest.emit('pipe', src);

              // start the flow if it hasn't been started already.
              if (!state.flowing) {
                debug('pipe resume');
                src.resume();
              }

              return dest;
            };

            function pipeOnDrain(src) {
              return function () {
                var state = src._readableState;
                debug('pipeOnDrain', state.awaitDrain);
                if (state.awaitDrain) state.awaitDrain--;
                if (state.awaitDrain === 0 && src.listeners('data').length) {
                  state.flowing = true;
                  flow(src);
                }
              };
            }

            Readable$1.prototype.unpipe = function (dest) {
              var state = this._readableState;

              // if we're not piping anywhere, then do nothing.
              if (state.pipesCount === 0) return this;

              // just one destination.  most common case.
              if (state.pipesCount === 1) {
                // passed in one, but it's not the right one.
                if (dest && dest !== state.pipes) return this;

                if (!dest) dest = state.pipes;

                // got a match.
                state.pipes = null;
                state.pipesCount = 0;
                state.flowing = false;
                if (dest) dest.emit('unpipe', this);
                return this;
              }

              // slow case. multiple pipe destinations.

              if (!dest) {
                // remove all.
                var dests = state.pipes;
                var len = state.pipesCount;
                state.pipes = null;
                state.pipesCount = 0;
                state.flowing = false;

                for (var _i = 0; _i < len; _i++) {
                  dests[_i].emit('unpipe', this);
                }return this;
              }

              // try to find the right one.
              var i = indexOf(state.pipes, dest);
              if (i === -1) return this;

              state.pipes.splice(i, 1);
              state.pipesCount -= 1;
              if (state.pipesCount === 1) state.pipes = state.pipes[0];

              dest.emit('unpipe', this);

              return this;
            };

            // set up data events if they are asked for
            // Ensure readable listeners eventually get something
            Readable$1.prototype.on = function (ev, fn) {
              var res = EventEmitter.prototype.on.call(this, ev, fn);

              if (ev === 'data') {
                // Start flowing on next tick if stream isn't explicitly paused
                if (this._readableState.flowing !== false) this.resume();
              } else if (ev === 'readable') {
                var state = this._readableState;
                if (!state.endEmitted && !state.readableListening) {
                  state.readableListening = state.needReadable = true;
                  state.emittedReadable = false;
                  if (!state.reading) {
                    nextTick(nReadingNextTick, this);
                  } else if (state.length) {
                    emitReadable(this);
                  }
                }
              }

              return res;
            };
            Readable$1.prototype.addListener = Readable$1.prototype.on;

            function nReadingNextTick(self) {
              debug('readable nexttick read 0');
              self.read(0);
            }

            // pause() and resume() are remnants of the legacy readable stream API
            // If the user uses them, then switch into old mode.
            Readable$1.prototype.resume = function () {
              var state = this._readableState;
              if (!state.flowing) {
                debug('resume');
                state.flowing = true;
                resume(this, state);
              }
              return this;
            };

            function resume(stream, state) {
              if (!state.resumeScheduled) {
                state.resumeScheduled = true;
                nextTick(resume_, stream, state);
              }
            }

            function resume_(stream, state) {
              if (!state.reading) {
                debug('resume read 0');
                stream.read(0);
              }

              state.resumeScheduled = false;
              state.awaitDrain = 0;
              stream.emit('resume');
              flow(stream);
              if (state.flowing && !state.reading) stream.read(0);
            }

            Readable$1.prototype.pause = function () {
              debug('call pause flowing=%j', this._readableState.flowing);
              if (false !== this._readableState.flowing) {
                debug('pause');
                this._readableState.flowing = false;
                this.emit('pause');
              }
              return this;
            };

            function flow(stream) {
              var state = stream._readableState;
              debug('flow', state.flowing);
              while (state.flowing && stream.read() !== null) {}
            }

            // wrap an old-style stream as the async data source.
            // This is *not* part of the readable stream interface.
            // It is an ugly unfortunate mess of history.
            Readable$1.prototype.wrap = function (stream) {
              var state = this._readableState;
              var paused = false;

              var self = this;
              stream.on('end', function () {
                debug('wrapped end');
                if (state.decoder && !state.ended) {
                  var chunk = state.decoder.end();
                  if (chunk && chunk.length) self.push(chunk);
                }

                self.push(null);
              });

              stream.on('data', function (chunk) {
                debug('wrapped data');
                if (state.decoder) chunk = state.decoder.write(chunk);

                // don't skip over falsy values in objectMode
                if (state.objectMode && (chunk === null || chunk === undefined)) return;else if (!state.objectMode && (!chunk || !chunk.length)) return;

                var ret = self.push(chunk);
                if (!ret) {
                  paused = true;
                  stream.pause();
                }
              });

              // proxy all the other methods.
              // important when wrapping filters and duplexes.
              for (var i in stream) {
                if (this[i] === undefined && typeof stream[i] === 'function') {
                  this[i] = function (method) {
                    return function () {
                      return stream[method].apply(stream, arguments);
                    };
                  }(i);
                }
              }

              // proxy certain important events.
              var events = ['error', 'close', 'destroy', 'pause', 'resume'];
              forEach(events, function (ev) {
                stream.on(ev, self.emit.bind(self, ev));
              });

              // when we try to consume some more bytes, simply unpause the
              // underlying stream.
              self._read = function (n) {
                debug('wrapped _read', n);
                if (paused) {
                  paused = false;
                  stream.resume();
                }
              };

              return self;
            };

            // exposed for testing purposes only.
            Readable$1._fromList = fromList;

            // Pluck off n bytes from an array of buffers.
            // Length is the combined lengths of all the buffers in the list.
            // This function is designed to be inlinable, so please take care when making
            // changes to the function body.
            function fromList(n, state) {
              // nothing buffered
              if (state.length === 0) return null;

              var ret;
              if (state.objectMode) ret = state.buffer.shift();else if (!n || n >= state.length) {
                // read it all, truncate the list
                if (state.decoder) ret = state.buffer.join('');else if (state.buffer.length === 1) ret = state.buffer.head.data;else ret = state.buffer.concat(state.length);
                state.buffer.clear();
              } else {
                // read part of list
                ret = fromListPartial(n, state.buffer, state.decoder);
              }

              return ret;
            }

            // Extracts only enough buffered data to satisfy the amount requested.
            // This function is designed to be inlinable, so please take care when making
            // changes to the function body.
            function fromListPartial(n, list, hasStrings) {
              var ret;
              if (n < list.head.data.length) {
                // slice is the same for buffers and strings
                ret = list.head.data.slice(0, n);
                list.head.data = list.head.data.slice(n);
              } else if (n === list.head.data.length) {
                // first chunk is a perfect match
                ret = list.shift();
              } else {
                // result spans more than one buffer
                ret = hasStrings ? copyFromBufferString(n, list) : copyFromBuffer(n, list);
              }
              return ret;
            }

            // Copies a specified amount of characters from the list of buffered data
            // chunks.
            // This function is designed to be inlinable, so please take care when making
            // changes to the function body.
            function copyFromBufferString(n, list) {
              var p = list.head;
              var c = 1;
              var ret = p.data;
              n -= ret.length;
              while (p = p.next) {
                var str = p.data;
                var nb = n > str.length ? str.length : n;
                if (nb === str.length) ret += str;else ret += str.slice(0, n);
                n -= nb;
                if (n === 0) {
                  if (nb === str.length) {
                    ++c;
                    if (p.next) list.head = p.next;else list.head = list.tail = null;
                  } else {
                    list.head = p;
                    p.data = str.slice(nb);
                  }
                  break;
                }
                ++c;
              }
              list.length -= c;
              return ret;
            }

            // Copies a specified amount of bytes from the list of buffered data chunks.
            // This function is designed to be inlinable, so please take care when making
            // changes to the function body.
            function copyFromBuffer(n, list) {
              var ret = Buffer$1.allocUnsafe(n);
              var p = list.head;
              var c = 1;
              p.data.copy(ret);
              n -= p.data.length;
              while (p = p.next) {
                var buf = p.data;
                var nb = n > buf.length ? buf.length : n;
                buf.copy(ret, ret.length - n, 0, nb);
                n -= nb;
                if (n === 0) {
                  if (nb === buf.length) {
                    ++c;
                    if (p.next) list.head = p.next;else list.head = list.tail = null;
                  } else {
                    list.head = p;
                    p.data = buf.slice(nb);
                  }
                  break;
                }
                ++c;
              }
              list.length -= c;
              return ret;
            }

            function endReadable(stream) {
              var state = stream._readableState;

              // If we get here before consuming all the bytes, then that is a
              // bug in node.  Should never happen.
              if (state.length > 0) throw new Error('"endReadable()" called on non-empty stream');

              if (!state.endEmitted) {
                state.ended = true;
                nextTick(endReadableNT, state, stream);
              }
            }

            function endReadableNT(state, stream) {
              // Check that we didn't get one last unshift.
              if (!state.endEmitted && state.length === 0) {
                state.endEmitted = true;
                stream.readable = false;
                stream.emit('end');
              }
            }

            function forEach(xs, f) {
              for (var i = 0, l = xs.length; i < l; i++) {
                f(xs[i], i);
              }
            }

            function indexOf(xs, x) {
              for (var i = 0, l = xs.length; i < l; i++) {
                if (xs[i] === x) return i;
              }
              return -1;
            }

            // A bit simpler than readable streams.
            Writable.WritableState = WritableState;
            inherits$1(Writable, EventEmitter);

            function nop() {}

            function WriteReq(chunk, encoding, cb) {
              this.chunk = chunk;
              this.encoding = encoding;
              this.callback = cb;
              this.next = null;
            }

            function WritableState(options, stream) {
              Object.defineProperty(this, 'buffer', {
                get: deprecate(function () {
                  return this.getBuffer();
                }, '_writableState.buffer is deprecated. Use _writableState.getBuffer ' + 'instead.')
              });
              options = options || {};

              // object stream flag to indicate whether or not this stream
              // contains buffers or objects.
              this.objectMode = !!options.objectMode;

              if (stream instanceof Duplex) this.objectMode = this.objectMode || !!options.writableObjectMode;

              // the point at which write() starts returning false
              // Note: 0 is a valid value, means that we always return false if
              // the entire buffer is not flushed immediately on write()
              var hwm = options.highWaterMark;
              var defaultHwm = this.objectMode ? 16 : 16 * 1024;
              this.highWaterMark = hwm || hwm === 0 ? hwm : defaultHwm;

              // cast to ints.
              this.highWaterMark = ~ ~this.highWaterMark;

              this.needDrain = false;
              // at the start of calling end()
              this.ending = false;
              // when end() has been called, and returned
              this.ended = false;
              // when 'finish' is emitted
              this.finished = false;

              // should we decode strings into buffers before passing to _write?
              // this is here so that some node-core streams can optimize string
              // handling at a lower level.
              var noDecode = options.decodeStrings === false;
              this.decodeStrings = !noDecode;

              // Crypto is kind of old and crusty.  Historically, its default string
              // encoding is 'binary' so we have to make this configurable.
              // Everything else in the universe uses 'utf8', though.
              this.defaultEncoding = options.defaultEncoding || 'utf8';

              // not an actual buffer we keep track of, but a measurement
              // of how much we're waiting to get pushed to some underlying
              // socket or file.
              this.length = 0;

              // a flag to see when we're in the middle of a write.
              this.writing = false;

              // when true all writes will be buffered until .uncork() call
              this.corked = 0;

              // a flag to be able to tell if the onwrite cb is called immediately,
              // or on a later tick.  We set this to true at first, because any
              // actions that shouldn't happen until "later" should generally also
              // not happen before the first write call.
              this.sync = true;

              // a flag to know if we're processing previously buffered items, which
              // may call the _write() callback in the same tick, so that we don't
              // end up in an overlapped onwrite situation.
              this.bufferProcessing = false;

              // the callback that's passed to _write(chunk,cb)
              this.onwrite = function (er) {
                onwrite(stream, er);
              };

              // the callback that the user supplies to write(chunk,encoding,cb)
              this.writecb = null;

              // the amount that is being written when _write is called.
              this.writelen = 0;

              this.bufferedRequest = null;
              this.lastBufferedRequest = null;

              // number of pending user-supplied write callbacks
              // this must be 0 before 'finish' can be emitted
              this.pendingcb = 0;

              // emit prefinish if the only thing we're waiting for is _write cbs
              // This is relevant for synchronous Transform streams
              this.prefinished = false;

              // True if the error was already emitted and should not be thrown again
              this.errorEmitted = false;

              // count buffered requests
              this.bufferedRequestCount = 0;

              // allocate the first CorkedRequest, there is always
              // one allocated and free to use, and we maintain at most two
              this.corkedRequestsFree = new CorkedRequest(this);
            }

            WritableState.prototype.getBuffer = function writableStateGetBuffer() {
              var current = this.bufferedRequest;
              var out = [];
              while (current) {
                out.push(current);
                current = current.next;
              }
              return out;
            };
            function Writable(options) {

              // Writable ctor is applied to Duplexes, though they're not
              // instanceof Writable, they're instanceof Readable.
              if (!(this instanceof Writable) && !(this instanceof Duplex)) return new Writable(options);

              this._writableState = new WritableState(options, this);

              // legacy.
              this.writable = true;

              if (options) {
                if (typeof options.write === 'function') this._write = options.write;

                if (typeof options.writev === 'function') this._writev = options.writev;
              }

              EventEmitter.call(this);
            }

            // Otherwise people can pipe Writable streams, which is just wrong.
            Writable.prototype.pipe = function () {
              this.emit('error', new Error('Cannot pipe, not readable'));
            };

            function writeAfterEnd(stream, cb) {
              var er = new Error('write after end');
              // TODO: defer error events consistently everywhere, not just the cb
              stream.emit('error', er);
              nextTick(cb, er);
            }

            // If we get something that is not a buffer, string, null, or undefined,
            // and we're not in objectMode, then that's an error.
            // Otherwise stream chunks are all considered to be of length=1, and the
            // watermarks determine how many objects to keep in the buffer, rather than
            // how many bytes or characters.
            function validChunk(stream, state, chunk, cb) {
              var valid = true;
              var er = false;
              // Always throw error if a null is written
              // if we are not in object mode then throw
              // if it is not a buffer, string, or undefined.
              if (chunk === null) {
                er = new TypeError('May not write null values to stream');
              } else if (!Buffer$1.isBuffer(chunk) && typeof chunk !== 'string' && chunk !== undefined && !state.objectMode) {
                er = new TypeError('Invalid non-string/buffer chunk');
              }
              if (er) {
                stream.emit('error', er);
                nextTick(cb, er);
                valid = false;
              }
              return valid;
            }

            Writable.prototype.write = function (chunk, encoding, cb) {
              var state = this._writableState;
              var ret = false;

              if (typeof encoding === 'function') {
                cb = encoding;
                encoding = null;
              }

              if (Buffer$1.isBuffer(chunk)) encoding = 'buffer';else if (!encoding) encoding = state.defaultEncoding;

              if (typeof cb !== 'function') cb = nop;

              if (state.ended) writeAfterEnd(this, cb);else if (validChunk(this, state, chunk, cb)) {
                state.pendingcb++;
                ret = writeOrBuffer(this, state, chunk, encoding, cb);
              }

              return ret;
            };

            Writable.prototype.cork = function () {
              var state = this._writableState;

              state.corked++;
            };

            Writable.prototype.uncork = function () {
              var state = this._writableState;

              if (state.corked) {
                state.corked--;

                if (!state.writing && !state.corked && !state.finished && !state.bufferProcessing && state.bufferedRequest) clearBuffer(this, state);
              }
            };

            Writable.prototype.setDefaultEncoding = function setDefaultEncoding(encoding) {
              // node::ParseEncoding() requires lower case.
              if (typeof encoding === 'string') encoding = encoding.toLowerCase();
              if (!(['hex', 'utf8', 'utf-8', 'ascii', 'binary', 'base64', 'ucs2', 'ucs-2', 'utf16le', 'utf-16le', 'raw'].indexOf((encoding + '').toLowerCase()) > -1)) throw new TypeError('Unknown encoding: ' + encoding);
              this._writableState.defaultEncoding = encoding;
              return this;
            };

            function decodeChunk(state, chunk, encoding) {
              if (!state.objectMode && state.decodeStrings !== false && typeof chunk === 'string') {
                chunk = Buffer$1.from(chunk, encoding);
              }
              return chunk;
            }

            // if we're already writing something, then just put this
            // in the queue, and wait our turn.  Otherwise, call _write
            // If we return false, then we need a drain event, so set that flag.
            function writeOrBuffer(stream, state, chunk, encoding, cb) {
              chunk = decodeChunk(state, chunk, encoding);

              if (Buffer$1.isBuffer(chunk)) encoding = 'buffer';
              var len = state.objectMode ? 1 : chunk.length;

              state.length += len;

              var ret = state.length < state.highWaterMark;
              // we must ensure that previous needDrain will not be reset to false.
              if (!ret) state.needDrain = true;

              if (state.writing || state.corked) {
                var last = state.lastBufferedRequest;
                state.lastBufferedRequest = new WriteReq(chunk, encoding, cb);
                if (last) {
                  last.next = state.lastBufferedRequest;
                } else {
                  state.bufferedRequest = state.lastBufferedRequest;
                }
                state.bufferedRequestCount += 1;
              } else {
                doWrite(stream, state, false, len, chunk, encoding, cb);
              }

              return ret;
            }

            function doWrite(stream, state, writev, len, chunk, encoding, cb) {
              state.writelen = len;
              state.writecb = cb;
              state.writing = true;
              state.sync = true;
              if (writev) stream._writev(chunk, state.onwrite);else stream._write(chunk, encoding, state.onwrite);
              state.sync = false;
            }

            function onwriteError(stream, state, sync, er, cb) {
              --state.pendingcb;
              if (sync) nextTick(cb, er);else cb(er);

              stream._writableState.errorEmitted = true;
              stream.emit('error', er);
            }

            function onwriteStateUpdate(state) {
              state.writing = false;
              state.writecb = null;
              state.length -= state.writelen;
              state.writelen = 0;
            }

            function onwrite(stream, er) {
              var state = stream._writableState;
              var sync = state.sync;
              var cb = state.writecb;

              onwriteStateUpdate(state);

              if (er) onwriteError(stream, state, sync, er, cb);else {
                // Check if we're actually ready to finish, but don't emit yet
                var finished = needFinish(state);

                if (!finished && !state.corked && !state.bufferProcessing && state.bufferedRequest) {
                  clearBuffer(stream, state);
                }

                if (sync) {
                  /*<replacement>*/
                    nextTick(afterWrite, stream, state, finished, cb);
                  /*</replacement>*/
                } else {
                    afterWrite(stream, state, finished, cb);
                  }
              }
            }

            function afterWrite(stream, state, finished, cb) {
              if (!finished) onwriteDrain(stream, state);
              state.pendingcb--;
              cb();
              finishMaybe(stream, state);
            }

            // Must force callback to be called on nextTick, so that we don't
            // emit 'drain' before the write() consumer gets the 'false' return
            // value, and has a chance to attach a 'drain' listener.
            function onwriteDrain(stream, state) {
              if (state.length === 0 && state.needDrain) {
                state.needDrain = false;
                stream.emit('drain');
              }
            }

            // if there's something in the buffer waiting, then process it
            function clearBuffer(stream, state) {
              state.bufferProcessing = true;
              var entry = state.bufferedRequest;

              if (stream._writev && entry && entry.next) {
                // Fast case, write everything using _writev()
                var l = state.bufferedRequestCount;
                var buffer = new Array(l);
                var holder = state.corkedRequestsFree;
                holder.entry = entry;

                var count = 0;
                while (entry) {
                  buffer[count] = entry;
                  entry = entry.next;
                  count += 1;
                }

                doWrite(stream, state, true, state.length, buffer, '', holder.finish);

                // doWrite is almost always async, defer these to save a bit of time
                // as the hot path ends with doWrite
                state.pendingcb++;
                state.lastBufferedRequest = null;
                if (holder.next) {
                  state.corkedRequestsFree = holder.next;
                  holder.next = null;
                } else {
                  state.corkedRequestsFree = new CorkedRequest(state);
                }
              } else {
                // Slow case, write chunks one-by-one
                while (entry) {
                  var chunk = entry.chunk;
                  var encoding = entry.encoding;
                  var cb = entry.callback;
                  var len = state.objectMode ? 1 : chunk.length;

                  doWrite(stream, state, false, len, chunk, encoding, cb);
                  entry = entry.next;
                  // if we didn't call the onwrite immediately, then
                  // it means that we need to wait until it does.
                  // also, that means that the chunk and cb are currently
                  // being processed, so move the buffer counter past them.
                  if (state.writing) {
                    break;
                  }
                }

                if (entry === null) state.lastBufferedRequest = null;
              }

              state.bufferedRequestCount = 0;
              state.bufferedRequest = entry;
              state.bufferProcessing = false;
            }

            Writable.prototype._write = function (chunk, encoding, cb) {
              cb(new Error('not implemented'));
            };

            Writable.prototype._writev = null;

            Writable.prototype.end = function (chunk, encoding, cb) {
              var state = this._writableState;

              if (typeof chunk === 'function') {
                cb = chunk;
                chunk = null;
                encoding = null;
              } else if (typeof encoding === 'function') {
                cb = encoding;
                encoding = null;
              }

              if (chunk !== null && chunk !== undefined) this.write(chunk, encoding);

              // .end() fully uncorks
              if (state.corked) {
                state.corked = 1;
                this.uncork();
              }

              // ignore unnecessary end() calls.
              if (!state.ending && !state.finished) endWritable(this, state, cb);
            };

            function needFinish(state) {
              return state.ending && state.length === 0 && state.bufferedRequest === null && !state.finished && !state.writing;
            }

            function prefinish(stream, state) {
              if (!state.prefinished) {
                state.prefinished = true;
                stream.emit('prefinish');
              }
            }

            function finishMaybe(stream, state) {
              var need = needFinish(state);
              if (need) {
                if (state.pendingcb === 0) {
                  prefinish(stream, state);
                  state.finished = true;
                  stream.emit('finish');
                } else {
                  prefinish(stream, state);
                }
              }
              return need;
            }

            function endWritable(stream, state, cb) {
              state.ending = true;
              finishMaybe(stream, state);
              if (cb) {
                if (state.finished) nextTick(cb);else stream.once('finish', cb);
              }
              state.ended = true;
              stream.writable = false;
            }

            // It seems a linked list but it is not
            // there will be only 2 of these for each stream
            function CorkedRequest(state) {
              var _this = this;

              this.next = null;
              this.entry = null;

              this.finish = function (err) {
                var entry = _this.entry;
                _this.entry = null;
                while (entry) {
                  var cb = entry.callback;
                  state.pendingcb--;
                  cb(err);
                  entry = entry.next;
                }
                if (state.corkedRequestsFree) {
                  state.corkedRequestsFree.next = _this;
                } else {
                  state.corkedRequestsFree = _this;
                }
              };
            }

            inherits$1(Duplex, Readable$1);

            var keys = Object.keys(Writable.prototype);
            for (var v$1 = 0; v$1 < keys.length; v$1++) {
              var method = keys[v$1];
              if (!Duplex.prototype[method]) Duplex.prototype[method] = Writable.prototype[method];
            }
            function Duplex(options) {
              if (!(this instanceof Duplex)) return new Duplex(options);

              Readable$1.call(this, options);
              Writable.call(this, options);

              if (options && options.readable === false) this.readable = false;

              if (options && options.writable === false) this.writable = false;

              this.allowHalfOpen = true;
              if (options && options.allowHalfOpen === false) this.allowHalfOpen = false;

              this.once('end', onend);
            }

            // the no-half-open enforcer
            function onend() {
              // if we allow half-open state, or if the writable side ended,
              // then we're ok.
              if (this.allowHalfOpen || this._writableState.ended) return;

              // no more data can be written.
              // But allow more writes to happen in this tick.
              nextTick(onEndNT, this);
            }

            function onEndNT(self) {
              self.end();
            }

            // a transform stream is a readable/writable stream where you do
            inherits$1(Transform, Duplex);

            function TransformState(stream) {
              this.afterTransform = function (er, data) {
                return afterTransform(stream, er, data);
              };

              this.needTransform = false;
              this.transforming = false;
              this.writecb = null;
              this.writechunk = null;
              this.writeencoding = null;
            }

            function afterTransform(stream, er, data) {
              var ts = stream._transformState;
              ts.transforming = false;

              var cb = ts.writecb;

              if (!cb) return stream.emit('error', new Error('no writecb in Transform class'));

              ts.writechunk = null;
              ts.writecb = null;

              if (data !== null && data !== undefined) stream.push(data);

              cb(er);

              var rs = stream._readableState;
              rs.reading = false;
              if (rs.needReadable || rs.length < rs.highWaterMark) {
                stream._read(rs.highWaterMark);
              }
            }
            function Transform(options) {
              if (!(this instanceof Transform)) return new Transform(options);

              Duplex.call(this, options);

              this._transformState = new TransformState(this);

              // when the writable side finishes, then flush out anything remaining.
              var stream = this;

              // start out asking for a readable event once data is transformed.
              this._readableState.needReadable = true;

              // we have implemented the _read method, and done the other things
              // that Readable wants before the first _read call, so unset the
              // sync guard flag.
              this._readableState.sync = false;

              if (options) {
                if (typeof options.transform === 'function') this._transform = options.transform;

                if (typeof options.flush === 'function') this._flush = options.flush;
              }

              this.once('prefinish', function () {
                if (typeof this._flush === 'function') this._flush(function (er) {
                  done(stream, er);
                });else done(stream);
              });
            }

            Transform.prototype.push = function (chunk, encoding) {
              this._transformState.needTransform = false;
              return Duplex.prototype.push.call(this, chunk, encoding);
            };

            // This is the part where you do stuff!
            // override this function in implementation classes.
            // 'chunk' is an input chunk.
            //
            // Call `push(newChunk)` to pass along transformed output
            // to the readable side.  You may call 'push' zero or more times.
            //
            // Call `cb(err)` when you are done with this chunk.  If you pass
            // an error, then that'll put the hurt on the whole operation.  If you
            // never call cb(), then you'll never get another chunk.
            Transform.prototype._transform = function (chunk, encoding, cb) {
              throw new Error('Not implemented');
            };

            Transform.prototype._write = function (chunk, encoding, cb) {
              var ts = this._transformState;
              ts.writecb = cb;
              ts.writechunk = chunk;
              ts.writeencoding = encoding;
              if (!ts.transforming) {
                var rs = this._readableState;
                if (ts.needTransform || rs.needReadable || rs.length < rs.highWaterMark) this._read(rs.highWaterMark);
              }
            };

            // Doesn't matter what the args are here.
            // _transform does all the work.
            // That we got here means that the readable side wants more data.
            Transform.prototype._read = function (n) {
              var ts = this._transformState;

              if (ts.writechunk !== null && ts.writecb && !ts.transforming) {
                ts.transforming = true;
                this._transform(ts.writechunk, ts.writeencoding, ts.afterTransform);
              } else {
                // mark that we need a transform, so that any data that comes in
                // will get processed, now that we've asked for it.
                ts.needTransform = true;
              }
            };

            function done(stream, er) {
              if (er) return stream.emit('error', er);

              // if there's nothing in the write buffer, then that means
              // that nothing more will ever be provided
              var ws = stream._writableState;
              var ts = stream._transformState;

              if (ws.length) throw new Error('Calling transform done when ws.length != 0');

              if (ts.transforming) throw new Error('Calling transform done when still transforming');

              return stream.push(null);
            }

            inherits$1(PassThrough$2, Transform);
            function PassThrough$2(options) {
              if (!(this instanceof PassThrough$2)) return new PassThrough$2(options);

              Transform.call(this, options);
            }

            PassThrough$2.prototype._transform = function (chunk, encoding, cb) {
              cb(null, chunk);
            };

            inherits$1(Stream, EventEmitter);
            Stream.Readable = Readable$1;
            Stream.Writable = Writable;
            Stream.Duplex = Duplex;
            Stream.Transform = Transform;
            Stream.PassThrough = PassThrough$2;

            // Backwards-compat with node 0.4.x
            Stream.Stream = Stream;

            // old-style streams.  Note that the pipe method (the only relevant
            // part of this class) is overridden in the Readable class.

            function Stream() {
              EventEmitter.call(this);
            }

            Stream.prototype.pipe = function(dest, options) {
              var source = this;

              function ondata(chunk) {
                if (dest.writable) {
                  if (false === dest.write(chunk) && source.pause) {
                    source.pause();
                  }
                }
              }

              source.on('data', ondata);

              function ondrain() {
                if (source.readable && source.resume) {
                  source.resume();
                }
              }

              dest.on('drain', ondrain);

              // If the 'end' option is not supplied, dest.end() will be called when
              // source gets the 'end' or 'close' events.  Only dest.end() once.
              if (!dest._isStdio && (!options || options.end !== false)) {
                source.on('end', onend);
                source.on('close', onclose);
              }

              var didOnEnd = false;
              function onend() {
                if (didOnEnd) return;
                didOnEnd = true;

                dest.end();
              }


              function onclose() {
                if (didOnEnd) return;
                didOnEnd = true;

                if (typeof dest.destroy === 'function') dest.destroy();
              }

              // don't leave dangling pipes when there are errors.
              function onerror(er) {
                cleanup();
                if (EventEmitter.listenerCount(this, 'error') === 0) {
                  throw er; // Unhandled stream error in pipe.
                }
              }

              source.on('error', onerror);
              dest.on('error', onerror);

              // remove all the event listeners that were added.
              function cleanup() {
                source.removeListener('data', ondata);
                dest.removeListener('drain', ondrain);

                source.removeListener('end', onend);
                source.removeListener('close', onclose);

                source.removeListener('error', onerror);
                dest.removeListener('error', onerror);

                source.removeListener('end', cleanup);
                source.removeListener('close', cleanup);

                dest.removeListener('close', cleanup);
              }

              source.on('end', cleanup);
              source.on('close', cleanup);

              dest.on('close', cleanup);

              dest.emit('pipe', source);

              // Allow for unix-like usage: A.pipe(B).pipe(C)
              return dest;
            };

            var hasFetch = isFunction(global$1.fetch) && isFunction(global$1.ReadableStream);

            var _blobConstructor;
            function blobConstructor() {
              if (typeof _blobConstructor !== 'undefined') {
                return _blobConstructor;
              }
              try {
                new global$1.Blob([new ArrayBuffer(1)]);
                _blobConstructor = true;
              } catch (e) {
                _blobConstructor = false;
              }
              return _blobConstructor
            }
            var xhr;

            function checkTypeSupport(type) {
              if (!xhr) {
                xhr = new global$1.XMLHttpRequest();
                // If location.host is empty, e.g. if this page/worker was loaded
                // from a Blob, then use example.com to avoid an error
                xhr.open('GET', global$1.location.host ? '/' : 'https://example.com');
              }
              try {
                xhr.responseType = type;
                return xhr.responseType === type
              } catch (e) {
                return false
              }

            }

            // For some strange reason, Safari 7.0 reports typeof global.ArrayBuffer === 'object'.
            // Safari 7.1 appears to have fixed this bug.
            var haveArrayBuffer = typeof global$1.ArrayBuffer !== 'undefined';
            var haveSlice = haveArrayBuffer && isFunction(global$1.ArrayBuffer.prototype.slice);

            var arraybuffer = haveArrayBuffer && checkTypeSupport('arraybuffer');
              // These next two tests unavoidably show warnings in Chrome. Since fetch will always
              // be used if it's available, just return false for these to avoid the warnings.
            var msstream = !hasFetch && haveSlice && checkTypeSupport('ms-stream');
            var mozchunkedarraybuffer = !hasFetch && haveArrayBuffer &&
              checkTypeSupport('moz-chunked-arraybuffer');
            var overrideMimeType = isFunction(xhr.overrideMimeType);
            var vbArray = isFunction(global$1.VBArray);

            function isFunction(value) {
              return typeof value === 'function'
            }

            xhr = null; // Help gc

            var rStates = {
              UNSENT: 0,
              OPENED: 1,
              HEADERS_RECEIVED: 2,
              LOADING: 3,
              DONE: 4
            };
            function IncomingMessage(xhr, response, mode) {
              var self = this;
              Readable$1.call(self);

              self._mode = mode;
              self.headers = {};
              self.rawHeaders = [];
              self.trailers = {};
              self.rawTrailers = [];

              // Fake the 'close' event, but only once 'end' fires
              self.on('end', function() {
                // The nextTick is necessary to prevent the 'request' module from causing an infinite loop
                browser$1.nextTick(function() {
                  self.emit('close');
                });
              });
              var read;
              if (mode === 'fetch') {
                self._fetchResponse = response;

                self.url = response.url;
                self.statusCode = response.status;
                self.statusMessage = response.statusText;
                  // backwards compatible version of for (<item> of <iterable>):
                  // for (var <item>,_i,_it = <iterable>[Symbol.iterator](); <item> = (_i = _it.next()).value,!_i.done;)
                for (var header, _i, _it = response.headers[Symbol.iterator](); header = (_i = _it.next()).value, !_i.done;) {
                  self.headers[header[0].toLowerCase()] = header[1];
                  self.rawHeaders.push(header[0], header[1]);
                }

                // TODO: this doesn't respect backpressure. Once WritableStream is available, this can be fixed
                var reader = response.body.getReader();

                read = function () {
                  reader.read().then(function(result) {
                    if (self._destroyed)
                      return
                    if (result.done) {
                      self.push(null);
                      return
                    }
                    self.push(new Buffer$1(result.value));
                    read();
                  });
                };
                read();

              } else {
                self._xhr = xhr;
                self._pos = 0;

                self.url = xhr.responseURL;
                self.statusCode = xhr.status;
                self.statusMessage = xhr.statusText;
                var headers = xhr.getAllResponseHeaders().split(/\r?\n/);
                headers.forEach(function(header) {
                  var matches = header.match(/^([^:]+):\s*(.*)/);
                  if (matches) {
                    var key = matches[1].toLowerCase();
                    if (key === 'set-cookie') {
                      if (self.headers[key] === undefined) {
                        self.headers[key] = [];
                      }
                      self.headers[key].push(matches[2]);
                    } else if (self.headers[key] !== undefined) {
                      self.headers[key] += ', ' + matches[2];
                    } else {
                      self.headers[key] = matches[2];
                    }
                    self.rawHeaders.push(matches[1], matches[2]);
                  }
                });

                self._charset = 'x-user-defined';
                if (!overrideMimeType) {
                  var mimeType = self.rawHeaders['mime-type'];
                  if (mimeType) {
                    var charsetMatch = mimeType.match(/;\s*charset=([^;])(;|$)/);
                    if (charsetMatch) {
                      self._charset = charsetMatch[1].toLowerCase();
                    }
                  }
                  if (!self._charset)
                    self._charset = 'utf-8'; // best guess
                }
              }
            }

            inherits$1(IncomingMessage, Readable$1);

            IncomingMessage.prototype._read = function() {};

            IncomingMessage.prototype._onXHRProgress = function() {
              var self = this;

              var xhr = self._xhr;

              var response = null;
              switch (self._mode) {
              case 'text:vbarray': // For IE9
                if (xhr.readyState !== rStates.DONE)
                  break
                try {
                  // This fails in IE8
                  response = new global$1.VBArray(xhr.responseBody).toArray();
                } catch (e) {
                  // pass
                }
                if (response !== null) {
                  self.push(new Buffer$1(response));
                  break
                }
                // Falls through in IE8
              case 'text':
                try { // This will fail when readyState = 3 in IE9. Switch mode and wait for readyState = 4
                  response = xhr.responseText;
                } catch (e) {
                  self._mode = 'text:vbarray';
                  break
                }
                if (response.length > self._pos) {
                  var newData = response.substr(self._pos);
                  if (self._charset === 'x-user-defined') {
                    var buffer = new Buffer$1(newData.length);
                    for (var i = 0; i < newData.length; i++)
                      buffer[i] = newData.charCodeAt(i) & 0xff;

                    self.push(buffer);
                  } else {
                    self.push(newData, self._charset);
                  }
                  self._pos = response.length;
                }
                break
              case 'arraybuffer':
                if (xhr.readyState !== rStates.DONE || !xhr.response)
                  break
                response = xhr.response;
                self.push(new Buffer$1(new Uint8Array(response)));
                break
              case 'moz-chunked-arraybuffer': // take whole
                response = xhr.response;
                if (xhr.readyState !== rStates.LOADING || !response)
                  break
                self.push(new Buffer$1(new Uint8Array(response)));
                break
              case 'ms-stream':
                response = xhr.response;
                if (xhr.readyState !== rStates.LOADING)
                  break
                var reader = new global$1.MSStreamReader();
                reader.onprogress = function() {
                  if (reader.result.byteLength > self._pos) {
                    self.push(new Buffer$1(new Uint8Array(reader.result.slice(self._pos))));
                    self._pos = reader.result.byteLength;
                  }
                };
                reader.onload = function() {
                  self.push(null);
                };
                  // reader.onerror = ??? // TODO: this
                reader.readAsArrayBuffer(response);
                break
              }

              // The ms-stream case handles end separately in reader.onload()
              if (self._xhr.readyState === rStates.DONE && self._mode !== 'ms-stream') {
                self.push(null);
              }
            };

            // from https://github.com/jhiesey/to-arraybuffer/blob/6502d9850e70ba7935a7df4ad86b358fc216f9f0/index.js
            function toArrayBuffer (buf) {
              // If the buffer is backed by a Uint8Array, a faster version will work
              if (buf instanceof Uint8Array) {
                // If the buffer isn't a subarray, return the underlying ArrayBuffer
                if (buf.byteOffset === 0 && buf.byteLength === buf.buffer.byteLength) {
                  return buf.buffer
                } else if (typeof buf.buffer.slice === 'function') {
                  // Otherwise we need to get a proper copy
                  return buf.buffer.slice(buf.byteOffset, buf.byteOffset + buf.byteLength)
                }
              }

              if (isBuffer$1(buf)) {
                // This is the slow version that will work with any Buffer
                // implementation (even in old browsers)
                var arrayCopy = new Uint8Array(buf.length);
                var len = buf.length;
                for (var i = 0; i < len; i++) {
                  arrayCopy[i] = buf[i];
                }
                return arrayCopy.buffer
              } else {
                throw new Error('Argument must be a Buffer')
              }
            }

            function decideMode(preferBinary, useFetch) {
              if (hasFetch && useFetch) {
                return 'fetch'
              } else if (mozchunkedarraybuffer) {
                return 'moz-chunked-arraybuffer'
              } else if (msstream) {
                return 'ms-stream'
              } else if (arraybuffer && preferBinary) {
                return 'arraybuffer'
              } else if (vbArray && preferBinary) {
                return 'text:vbarray'
              } else {
                return 'text'
              }
            }

            function ClientRequest(opts) {
              var self = this;
              Writable.call(self);

              self._opts = opts;
              self._body = [];
              self._headers = {};
              if (opts.auth)
                self.setHeader('Authorization', 'Basic ' + new Buffer$1(opts.auth).toString('base64'));
              Object.keys(opts.headers).forEach(function(name) {
                self.setHeader(name, opts.headers[name]);
              });

              var preferBinary;
              var useFetch = true;
              if (opts.mode === 'disable-fetch') {
                // If the use of XHR should be preferred and includes preserving the 'content-type' header
                useFetch = false;
                preferBinary = true;
              } else if (opts.mode === 'prefer-streaming') {
                // If streaming is a high priority but binary compatibility and
                // the accuracy of the 'content-type' header aren't
                preferBinary = false;
              } else if (opts.mode === 'allow-wrong-content-type') {
                // If streaming is more important than preserving the 'content-type' header
                preferBinary = !overrideMimeType;
              } else if (!opts.mode || opts.mode === 'default' || opts.mode === 'prefer-fast') {
                // Use binary if text streaming may corrupt data or the content-type header, or for speed
                preferBinary = true;
              } else {
                throw new Error('Invalid value for opts.mode')
              }
              self._mode = decideMode(preferBinary, useFetch);

              self.on('finish', function() {
                self._onFinish();
              });
            }

            inherits$1(ClientRequest, Writable);
            // Taken from http://www.w3.org/TR/XMLHttpRequest/#the-setrequestheader%28%29-method
            var unsafeHeaders = [
              'accept-charset',
              'accept-encoding',
              'access-control-request-headers',
              'access-control-request-method',
              'connection',
              'content-length',
              'cookie',
              'cookie2',
              'date',
              'dnt',
              'expect',
              'host',
              'keep-alive',
              'origin',
              'referer',
              'te',
              'trailer',
              'transfer-encoding',
              'upgrade',
              'user-agent',
              'via'
            ];
            ClientRequest.prototype.setHeader = function(name, value) {
              var self = this;
              var lowerName = name.toLowerCase();
                // This check is not necessary, but it prevents warnings from browsers about setting unsafe
                // headers. To be honest I'm not entirely sure hiding these warnings is a good thing, but
                // http-browserify did it, so I will too.
              if (unsafeHeaders.indexOf(lowerName) !== -1)
                return

              self._headers[lowerName] = {
                name: name,
                value: value
              };
            };

            ClientRequest.prototype.getHeader = function(name) {
              var self = this;
              return self._headers[name.toLowerCase()].value
            };

            ClientRequest.prototype.removeHeader = function(name) {
              var self = this;
              delete self._headers[name.toLowerCase()];
            };

            ClientRequest.prototype._onFinish = function() {
              var self = this;

              if (self._destroyed)
                return
              var opts = self._opts;

              var headersObj = self._headers;
              var body;
              if (opts.method === 'POST' || opts.method === 'PUT' || opts.method === 'PATCH') {
                if (blobConstructor()) {
                  body = new global$1.Blob(self._body.map(function(buffer) {
                    return toArrayBuffer(buffer)
                  }), {
                    type: (headersObj['content-type'] || {}).value || ''
                  });
                } else {
                  // get utf8 string
                  body = Buffer$1.concat(self._body).toString();
                }
              }

              if (self._mode === 'fetch') {
                var headers = Object.keys(headersObj).map(function(name) {
                  return [headersObj[name].name, headersObj[name].value]
                });

                global$1.fetch(self._opts.url, {
                  method: self._opts.method,
                  headers: headers,
                  body: body,
                  mode: 'cors',
                  credentials: opts.withCredentials ? 'include' : 'same-origin'
                }).then(function(response) {
                  self._fetchResponse = response;
                  self._connect();
                }, function(reason) {
                  self.emit('error', reason);
                });
              } else {
                var xhr = self._xhr = new global$1.XMLHttpRequest();
                try {
                  xhr.open(self._opts.method, self._opts.url, true);
                } catch (err) {
                  browser$1.nextTick(function() {
                    self.emit('error', err);
                  });
                  return
                }

                // Can't set responseType on really old browsers
                if ('responseType' in xhr)
                  xhr.responseType = self._mode.split(':')[0];

                if ('withCredentials' in xhr)
                  xhr.withCredentials = !!opts.withCredentials;

                if (self._mode === 'text' && 'overrideMimeType' in xhr)
                  xhr.overrideMimeType('text/plain; charset=x-user-defined');

                Object.keys(headersObj).forEach(function(name) {
                  xhr.setRequestHeader(headersObj[name].name, headersObj[name].value);
                });

                self._response = null;
                xhr.onreadystatechange = function() {
                  switch (xhr.readyState) {
                  case rStates.LOADING:
                  case rStates.DONE:
                    self._onXHRProgress();
                    break
                  }
                };
                  // Necessary for streaming in Firefox, since xhr.response is ONLY defined
                  // in onprogress, not in onreadystatechange with xhr.readyState = 3
                if (self._mode === 'moz-chunked-arraybuffer') {
                  xhr.onprogress = function() {
                    self._onXHRProgress();
                  };
                }

                xhr.onerror = function() {
                  if (self._destroyed)
                    return
                  self.emit('error', new Error('XHR error'));
                };

                try {
                  xhr.send(body);
                } catch (err) {
                  browser$1.nextTick(function() {
                    self.emit('error', err);
                  });
                  return
                }
              }
            };

            /**
             * Checks if xhr.status is readable and non-zero, indicating no error.
             * Even though the spec says it should be available in readyState 3,
             * accessing it throws an exception in IE8
             */
            function statusValid(xhr) {
              try {
                var status = xhr.status;
                return (status !== null && status !== 0)
              } catch (e) {
                return false
              }
            }

            ClientRequest.prototype._onXHRProgress = function() {
              var self = this;

              if (!statusValid(self._xhr) || self._destroyed)
                return

              if (!self._response)
                self._connect();

              self._response._onXHRProgress();
            };

            ClientRequest.prototype._connect = function() {
              var self = this;

              if (self._destroyed)
                return

              self._response = new IncomingMessage(self._xhr, self._fetchResponse, self._mode);
              self.emit('response', self._response);
            };

            ClientRequest.prototype._write = function(chunk, encoding, cb) {
              var self = this;

              self._body.push(chunk);
              cb();
            };

            ClientRequest.prototype.abort = ClientRequest.prototype.destroy = function() {
              var self = this;
              self._destroyed = true;
              if (self._response)
                self._response._destroyed = true;
              if (self._xhr)
                self._xhr.abort();
                // Currently, there isn't a way to truly abort a fetch.
                // If you like bikeshedding, see https://github.com/whatwg/fetch/issues/27
            };

            ClientRequest.prototype.end = function(data, encoding, cb) {
              var self = this;
              if (typeof data === 'function') {
                cb = data;
                data = undefined;
              }

              Writable.prototype.end.call(self, data, encoding, cb);
            };

            ClientRequest.prototype.flushHeaders = function() {};
            ClientRequest.prototype.setTimeout = function() {};
            ClientRequest.prototype.setNoDelay = function() {};
            ClientRequest.prototype.setSocketKeepAlive = function() {};

            /*! https://mths.be/punycode v1.4.1 by @mathias */


            /** Highest positive signed 32-bit float value */
            var maxInt = 2147483647; // aka. 0x7FFFFFFF or 2^31-1

            /** Bootstring parameters */
            var base = 36;
            var tMin = 1;
            var tMax = 26;
            var skew = 38;
            var damp = 700;
            var initialBias = 72;
            var initialN = 128; // 0x80
            var delimiter = '-'; // '\x2D'
            var regexNonASCII = /[^\x20-\x7E]/; // unprintable ASCII chars + non-ASCII chars
            var regexSeparators = /[\x2E\u3002\uFF0E\uFF61]/g; // RFC 3490 separators

            /** Error messages */
            var errors = {
              'overflow': 'Overflow: input needs wider integers to process',
              'not-basic': 'Illegal input >= 0x80 (not a basic code point)',
              'invalid-input': 'Invalid input'
            };

            /** Convenience shortcuts */
            var baseMinusTMin = base - tMin;
            var floor = Math.floor;
            var stringFromCharCode = String.fromCharCode;

            /*--------------------------------------------------------------------------*/

            /**
             * A generic error utility function.
             * @private
             * @param {String} type The error type.
             * @returns {Error} Throws a `RangeError` with the applicable error message.
             */
            function error(type) {
              throw new RangeError(errors[type]);
            }

            /**
             * A generic `Array#map` utility function.
             * @private
             * @param {Array} array The array to iterate over.
             * @param {Function} callback The function that gets called for every array
             * item.
             * @returns {Array} A new array of values returned by the callback function.
             */
            function map$1(array, fn) {
              var length = array.length;
              var result = [];
              while (length--) {
                result[length] = fn(array[length]);
              }
              return result;
            }

            /**
             * A simple `Array#map`-like wrapper to work with domain name strings or email
             * addresses.
             * @private
             * @param {String} domain The domain name or email address.
             * @param {Function} callback The function that gets called for every
             * character.
             * @returns {Array} A new string of characters returned by the callback
             * function.
             */
            function mapDomain(string, fn) {
              var parts = string.split('@');
              var result = '';
              if (parts.length > 1) {
                // In email addresses, only the domain name should be punycoded. Leave
                // the local part (i.e. everything up to `@`) intact.
                result = parts[0] + '@';
                string = parts[1];
              }
              // Avoid `split(regex)` for IE8 compatibility. See #17.
              string = string.replace(regexSeparators, '\x2E');
              var labels = string.split('.');
              var encoded = map$1(labels, fn).join('.');
              return result + encoded;
            }

            /**
             * Creates an array containing the numeric code points of each Unicode
             * character in the string. While JavaScript uses UCS-2 internally,
             * this function will convert a pair of surrogate halves (each of which
             * UCS-2 exposes as separate characters) into a single code point,
             * matching UTF-16.
             * @see `punycode.ucs2.encode`
             * @see <https://mathiasbynens.be/notes/javascript-encoding>
             * @memberOf punycode.ucs2
             * @name decode
             * @param {String} string The Unicode input string (UCS-2).
             * @returns {Array} The new array of code points.
             */
            function ucs2decode(string) {
              var output = [],
                counter = 0,
                length = string.length,
                value,
                extra;
              while (counter < length) {
                value = string.charCodeAt(counter++);
                if (value >= 0xD800 && value <= 0xDBFF && counter < length) {
                  // high surrogate, and there is a next character
                  extra = string.charCodeAt(counter++);
                  if ((extra & 0xFC00) == 0xDC00) { // low surrogate
                    output.push(((value & 0x3FF) << 10) + (extra & 0x3FF) + 0x10000);
                  } else {
                    // unmatched surrogate; only append this code unit, in case the next
                    // code unit is the high surrogate of a surrogate pair
                    output.push(value);
                    counter--;
                  }
                } else {
                  output.push(value);
                }
              }
              return output;
            }

            /**
             * Converts a digit/integer into a basic code point.
             * @see `basicToDigit()`
             * @private
             * @param {Number} digit The numeric value of a basic code point.
             * @returns {Number} The basic code point whose value (when used for
             * representing integers) is `digit`, which needs to be in the range
             * `0` to `base - 1`. If `flag` is non-zero, the uppercase form is
             * used; else, the lowercase form is used. The behavior is undefined
             * if `flag` is non-zero and `digit` has no uppercase form.
             */
            function digitToBasic(digit, flag) {
              //  0..25 map to ASCII a..z or A..Z
              // 26..35 map to ASCII 0..9
              return digit + 22 + 75 * (digit < 26) - ((flag != 0) << 5);
            }

            /**
             * Bias adaptation function as per section 3.4 of RFC 3492.
             * https://tools.ietf.org/html/rfc3492#section-3.4
             * @private
             */
            function adapt(delta, numPoints, firstTime) {
              var k = 0;
              delta = firstTime ? floor(delta / damp) : delta >> 1;
              delta += floor(delta / numPoints);
              for ( /* no initialization */ ; delta > baseMinusTMin * tMax >> 1; k += base) {
                delta = floor(delta / baseMinusTMin);
              }
              return floor(k + (baseMinusTMin + 1) * delta / (delta + skew));
            }

            /**
             * Converts a string of Unicode symbols (e.g. a domain name label) to a
             * Punycode string of ASCII-only symbols.
             * @memberOf punycode
             * @param {String} input The string of Unicode symbols.
             * @returns {String} The resulting Punycode string of ASCII-only symbols.
             */
            function encode(input) {
              var n,
                delta,
                handledCPCount,
                basicLength,
                bias,
                j,
                m,
                q,
                k,
                t,
                currentValue,
                output = [],
                /** `inputLength` will hold the number of code points in `input`. */
                inputLength,
                /** Cached calculation results */
                handledCPCountPlusOne,
                baseMinusT,
                qMinusT;

              // Convert the input in UCS-2 to Unicode
              input = ucs2decode(input);

              // Cache the length
              inputLength = input.length;

              // Initialize the state
              n = initialN;
              delta = 0;
              bias = initialBias;

              // Handle the basic code points
              for (j = 0; j < inputLength; ++j) {
                currentValue = input[j];
                if (currentValue < 0x80) {
                  output.push(stringFromCharCode(currentValue));
                }
              }

              handledCPCount = basicLength = output.length;

              // `handledCPCount` is the number of code points that have been handled;
              // `basicLength` is the number of basic code points.

              // Finish the basic string - if it is not empty - with a delimiter
              if (basicLength) {
                output.push(delimiter);
              }

              // Main encoding loop:
              while (handledCPCount < inputLength) {

                // All non-basic code points < n have been handled already. Find the next
                // larger one:
                for (m = maxInt, j = 0; j < inputLength; ++j) {
                  currentValue = input[j];
                  if (currentValue >= n && currentValue < m) {
                    m = currentValue;
                  }
                }

                // Increase `delta` enough to advance the decoder's <n,i> state to <m,0>,
                // but guard against overflow
                handledCPCountPlusOne = handledCPCount + 1;
                if (m - n > floor((maxInt - delta) / handledCPCountPlusOne)) {
                  error('overflow');
                }

                delta += (m - n) * handledCPCountPlusOne;
                n = m;

                for (j = 0; j < inputLength; ++j) {
                  currentValue = input[j];

                  if (currentValue < n && ++delta > maxInt) {
                    error('overflow');
                  }

                  if (currentValue == n) {
                    // Represent delta as a generalized variable-length integer
                    for (q = delta, k = base; /* no condition */ ; k += base) {
                      t = k <= bias ? tMin : (k >= bias + tMax ? tMax : k - bias);
                      if (q < t) {
                        break;
                      }
                      qMinusT = q - t;
                      baseMinusT = base - t;
                      output.push(
                        stringFromCharCode(digitToBasic(t + qMinusT % baseMinusT, 0))
                      );
                      q = floor(qMinusT / baseMinusT);
                    }

                    output.push(stringFromCharCode(digitToBasic(q, 0)));
                    bias = adapt(delta, handledCPCountPlusOne, handledCPCount == basicLength);
                    delta = 0;
                    ++handledCPCount;
                  }
                }

                ++delta;
                ++n;

              }
              return output.join('');
            }

            /**
             * Converts a Unicode string representing a domain name or an email address to
             * Punycode. Only the non-ASCII parts of the domain name will be converted,
             * i.e. it doesn't matter if you call it with a domain that's already in
             * ASCII.
             * @memberOf punycode
             * @param {String} input The domain name or email address to convert, as a
             * Unicode string.
             * @returns {String} The Punycode representation of the given domain name or
             * email address.
             */
            function toASCII(input) {
              return mapDomain(input, function(string) {
                return regexNonASCII.test(string) ?
                  'xn--' + encode(string) :
                  string;
              });
            }

            // Copyright Joyent, Inc. and other Node contributors.
            //
            // Permission is hereby granted, free of charge, to any person obtaining a
            // copy of this software and associated documentation files (the
            // "Software"), to deal in the Software without restriction, including
            // without limitation the rights to use, copy, modify, merge, publish,
            // distribute, sublicense, and/or sell copies of the Software, and to permit
            // persons to whom the Software is furnished to do so, subject to the
            // following conditions:
            //
            // The above copyright notice and this permission notice shall be included
            // in all copies or substantial portions of the Software.
            //
            // THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
            // OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
            // MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN
            // NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM,
            // DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR
            // OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE
            // USE OR OTHER DEALINGS IN THE SOFTWARE.


            // If obj.hasOwnProperty has been overridden, then calling
            // obj.hasOwnProperty(prop) will break.
            // See: https://github.com/joyent/node/issues/1707
            function hasOwnProperty(obj, prop) {
              return Object.prototype.hasOwnProperty.call(obj, prop);
            }
            var isArray = Array.isArray || function (xs) {
              return Object.prototype.toString.call(xs) === '[object Array]';
            };
            function stringifyPrimitive(v) {
              switch (typeof v) {
                case 'string':
                  return v;

                case 'boolean':
                  return v ? 'true' : 'false';

                case 'number':
                  return isFinite(v) ? v : '';

                default:
                  return '';
              }
            }

            function stringify (obj, sep, eq, name) {
              sep = sep || '&';
              eq = eq || '=';
              if (obj === null) {
                obj = undefined;
              }

              if (typeof obj === 'object') {
                return map(objectKeys(obj), function(k) {
                  var ks = encodeURIComponent(stringifyPrimitive(k)) + eq;
                  if (isArray(obj[k])) {
                    return map(obj[k], function(v) {
                      return ks + encodeURIComponent(stringifyPrimitive(v));
                    }).join(sep);
                  } else {
                    return ks + encodeURIComponent(stringifyPrimitive(obj[k]));
                  }
                }).join(sep);

              }

              if (!name) return '';
              return encodeURIComponent(stringifyPrimitive(name)) + eq +
                     encodeURIComponent(stringifyPrimitive(obj));
            }
            function map (xs, f) {
              if (xs.map) return xs.map(f);
              var res = [];
              for (var i = 0; i < xs.length; i++) {
                res.push(f(xs[i], i));
              }
              return res;
            }

            var objectKeys = Object.keys || function (obj) {
              var res = [];
              for (var key in obj) {
                if (Object.prototype.hasOwnProperty.call(obj, key)) res.push(key);
              }
              return res;
            };

            function parse$1(qs, sep, eq, options) {
              sep = sep || '&';
              eq = eq || '=';
              var obj = {};

              if (typeof qs !== 'string' || qs.length === 0) {
                return obj;
              }

              var regexp = /\+/g;
              qs = qs.split(sep);

              var maxKeys = 1000;
              if (options && typeof options.maxKeys === 'number') {
                maxKeys = options.maxKeys;
              }

              var len = qs.length;
              // maxKeys <= 0 means that we should not limit keys count
              if (maxKeys > 0 && len > maxKeys) {
                len = maxKeys;
              }

              for (var i = 0; i < len; ++i) {
                var x = qs[i].replace(regexp, '%20'),
                    idx = x.indexOf(eq),
                    kstr, vstr, k, v;

                if (idx >= 0) {
                  kstr = x.substr(0, idx);
                  vstr = x.substr(idx + 1);
                } else {
                  kstr = x;
                  vstr = '';
                }

                k = decodeURIComponent(kstr);
                v = decodeURIComponent(vstr);

                if (!hasOwnProperty(obj, k)) {
                  obj[k] = v;
                } else if (isArray(obj[k])) {
                  obj[k].push(v);
                } else {
                  obj[k] = [obj[k], v];
                }
              }

              return obj;
            }

            // Copyright Joyent, Inc. and other Node contributors.
            var Url = {
              parse: urlParse,
              resolve: urlResolve,
              resolveObject: urlResolveObject,
              format: urlFormat,
              Url: Url$1
            };
            function Url$1() {
              this.protocol = null;
              this.slashes = null;
              this.auth = null;
              this.host = null;
              this.port = null;
              this.hostname = null;
              this.hash = null;
              this.search = null;
              this.query = null;
              this.pathname = null;
              this.path = null;
              this.href = null;
            }

            // Reference: RFC 3986, RFC 1808, RFC 2396

            // define these here so at least they only have to be
            // compiled once on the first module load.
            var protocolPattern = /^([a-z0-9.+-]+:)/i,
              portPattern = /:[0-9]*$/,

              // Special case for a simple path URL
              simplePathPattern = /^(\/\/?(?!\/)[^\?\s]*)(\?[^\s]*)?$/,

              // RFC 2396: characters reserved for delimiting URLs.
              // We actually just auto-escape these.
              delims = ['<', '>', '"', '`', ' ', '\r', '\n', '\t'],

              // RFC 2396: characters not allowed for various reasons.
              unwise = ['{', '}', '|', '\\', '^', '`'].concat(delims),

              // Allowed by RFCs, but cause of XSS attacks.  Always escape these.
              autoEscape = ['\''].concat(unwise),
              // Characters that are never ever allowed in a hostname.
              // Note that any invalid chars are also handled, but these
              // are the ones that are *expected* to be seen, so we fast-path
              // them.
              nonHostChars = ['%', '/', '?', ';', '#'].concat(autoEscape),
              hostEndingChars = ['/', '?', '#'],
              hostnameMaxLen = 255,
              hostnamePartPattern = /^[+a-z0-9A-Z_-]{0,63}$/,
              hostnamePartStart = /^([+a-z0-9A-Z_-]{0,63})(.*)$/,
              // protocols that can allow "unsafe" and "unwise" chars.
              unsafeProtocol = {
                'javascript': true,
                'javascript:': true
              },
              // protocols that never have a hostname.
              hostlessProtocol = {
                'javascript': true,
                'javascript:': true
              },
              // protocols that always contain a // bit.
              slashedProtocol = {
                'http': true,
                'https': true,
                'ftp': true,
                'gopher': true,
                'file': true,
                'http:': true,
                'https:': true,
                'ftp:': true,
                'gopher:': true,
                'file:': true
              };

            function urlParse(url, parseQueryString, slashesDenoteHost) {
              if (url && isObject(url) && url instanceof Url$1) return url;

              var u = new Url$1;
              u.parse(url, parseQueryString, slashesDenoteHost);
              return u;
            }
            Url$1.prototype.parse = function(url, parseQueryString, slashesDenoteHost) {
              return parse(this, url, parseQueryString, slashesDenoteHost);
            };

            function parse(self, url, parseQueryString, slashesDenoteHost) {
              if (!isString(url)) {
                throw new TypeError('Parameter \'url\' must be a string, not ' + typeof url);
              }

              // Copy chrome, IE, opera backslash-handling behavior.
              // Back slashes before the query string get converted to forward slashes
              // See: https://code.google.com/p/chromium/issues/detail?id=25916
              var queryIndex = url.indexOf('?'),
                splitter =
                (queryIndex !== -1 && queryIndex < url.indexOf('#')) ? '?' : '#',
                uSplit = url.split(splitter),
                slashRegex = /\\/g;
              uSplit[0] = uSplit[0].replace(slashRegex, '/');
              url = uSplit.join(splitter);

              var rest = url;

              // trim before proceeding.
              // This is to support parse stuff like "  http://foo.com  \n"
              rest = rest.trim();

              if (!slashesDenoteHost && url.split('#').length === 1) {
                // Try fast path regexp
                var simplePath = simplePathPattern.exec(rest);
                if (simplePath) {
                  self.path = rest;
                  self.href = rest;
                  self.pathname = simplePath[1];
                  if (simplePath[2]) {
                    self.search = simplePath[2];
                    if (parseQueryString) {
                      self.query = parse$1(self.search.substr(1));
                    } else {
                      self.query = self.search.substr(1);
                    }
                  } else if (parseQueryString) {
                    self.search = '';
                    self.query = {};
                  }
                  return self;
                }
              }

              var proto = protocolPattern.exec(rest);
              if (proto) {
                proto = proto[0];
                var lowerProto = proto.toLowerCase();
                self.protocol = lowerProto;
                rest = rest.substr(proto.length);
              }

              // figure out if it's got a host
              // user@server is *always* interpreted as a hostname, and url
              // resolution will treat //foo/bar as host=foo,path=bar because that's
              // how the browser resolves relative URLs.
              if (slashesDenoteHost || proto || rest.match(/^\/\/[^@\/]+@[^@\/]+/)) {
                var slashes = rest.substr(0, 2) === '//';
                if (slashes && !(proto && hostlessProtocol[proto])) {
                  rest = rest.substr(2);
                  self.slashes = true;
                }
              }
              var i, hec, l, p;
              if (!hostlessProtocol[proto] &&
                (slashes || (proto && !slashedProtocol[proto]))) {

                // there's a hostname.
                // the first instance of /, ?, ;, or # ends the host.
                //
                // If there is an @ in the hostname, then non-host chars *are* allowed
                // to the left of the last @ sign, unless some host-ending character
                // comes *before* the @-sign.
                // URLs are obnoxious.
                //
                // ex:
                // http://a@b@c/ => user:a@b host:c
                // http://a@b?@c => user:a host:c path:/?@c

                // v0.12 TODO(isaacs): This is not quite how Chrome does things.
                // Review our test case against browsers more comprehensively.

                // find the first instance of any hostEndingChars
                var hostEnd = -1;
                for (i = 0; i < hostEndingChars.length; i++) {
                  hec = rest.indexOf(hostEndingChars[i]);
                  if (hec !== -1 && (hostEnd === -1 || hec < hostEnd))
                    hostEnd = hec;
                }

                // at this point, either we have an explicit point where the
                // auth portion cannot go past, or the last @ char is the decider.
                var auth, atSign;
                if (hostEnd === -1) {
                  // atSign can be anywhere.
                  atSign = rest.lastIndexOf('@');
                } else {
                  // atSign must be in auth portion.
                  // http://a@b/c@d => host:b auth:a path:/c@d
                  atSign = rest.lastIndexOf('@', hostEnd);
                }

                // Now we have a portion which is definitely the auth.
                // Pull that off.
                if (atSign !== -1) {
                  auth = rest.slice(0, atSign);
                  rest = rest.slice(atSign + 1);
                  self.auth = decodeURIComponent(auth);
                }

                // the host is the remaining to the left of the first non-host char
                hostEnd = -1;
                for (i = 0; i < nonHostChars.length; i++) {
                  hec = rest.indexOf(nonHostChars[i]);
                  if (hec !== -1 && (hostEnd === -1 || hec < hostEnd))
                    hostEnd = hec;
                }
                // if we still have not hit it, then the entire thing is a host.
                if (hostEnd === -1)
                  hostEnd = rest.length;

                self.host = rest.slice(0, hostEnd);
                rest = rest.slice(hostEnd);

                // pull out port.
                parseHost(self);

                // we've indicated that there is a hostname,
                // so even if it's empty, it has to be present.
                self.hostname = self.hostname || '';

                // if hostname begins with [ and ends with ]
                // assume that it's an IPv6 address.
                var ipv6Hostname = self.hostname[0] === '[' &&
                  self.hostname[self.hostname.length - 1] === ']';

                // validate a little.
                if (!ipv6Hostname) {
                  var hostparts = self.hostname.split(/\./);
                  for (i = 0, l = hostparts.length; i < l; i++) {
                    var part = hostparts[i];
                    if (!part) continue;
                    if (!part.match(hostnamePartPattern)) {
                      var newpart = '';
                      for (var j = 0, k = part.length; j < k; j++) {
                        if (part.charCodeAt(j) > 127) {
                          // we replace non-ASCII char with a temporary placeholder
                          // we need this to make sure size of hostname is not
                          // broken by replacing non-ASCII by nothing
                          newpart += 'x';
                        } else {
                          newpart += part[j];
                        }
                      }
                      // we test again with ASCII char only
                      if (!newpart.match(hostnamePartPattern)) {
                        var validParts = hostparts.slice(0, i);
                        var notHost = hostparts.slice(i + 1);
                        var bit = part.match(hostnamePartStart);
                        if (bit) {
                          validParts.push(bit[1]);
                          notHost.unshift(bit[2]);
                        }
                        if (notHost.length) {
                          rest = '/' + notHost.join('.') + rest;
                        }
                        self.hostname = validParts.join('.');
                        break;
                      }
                    }
                  }
                }

                if (self.hostname.length > hostnameMaxLen) {
                  self.hostname = '';
                } else {
                  // hostnames are always lower case.
                  self.hostname = self.hostname.toLowerCase();
                }

                if (!ipv6Hostname) {
                  // IDNA Support: Returns a punycoded representation of "domain".
                  // It only converts parts of the domain name that
                  // have non-ASCII characters, i.e. it doesn't matter if
                  // you call it with a domain that already is ASCII-only.
                  self.hostname = toASCII(self.hostname);
                }

                p = self.port ? ':' + self.port : '';
                var h = self.hostname || '';
                self.host = h + p;
                self.href += self.host;

                // strip [ and ] from the hostname
                // the host field still retains them, though
                if (ipv6Hostname) {
                  self.hostname = self.hostname.substr(1, self.hostname.length - 2);
                  if (rest[0] !== '/') {
                    rest = '/' + rest;
                  }
                }
              }

              // now rest is set to the post-host stuff.
              // chop off any delim chars.
              if (!unsafeProtocol[lowerProto]) {

                // First, make 100% sure that any "autoEscape" chars get
                // escaped, even if encodeURIComponent doesn't think they
                // need to be.
                for (i = 0, l = autoEscape.length; i < l; i++) {
                  var ae = autoEscape[i];
                  if (rest.indexOf(ae) === -1)
                    continue;
                  var esc = encodeURIComponent(ae);
                  if (esc === ae) {
                    esc = escape(ae);
                  }
                  rest = rest.split(ae).join(esc);
                }
              }


              // chop off from the tail first.
              var hash = rest.indexOf('#');
              if (hash !== -1) {
                // got a fragment string.
                self.hash = rest.substr(hash);
                rest = rest.slice(0, hash);
              }
              var qm = rest.indexOf('?');
              if (qm !== -1) {
                self.search = rest.substr(qm);
                self.query = rest.substr(qm + 1);
                if (parseQueryString) {
                  self.query = parse$1(self.query);
                }
                rest = rest.slice(0, qm);
              } else if (parseQueryString) {
                // no query string, but parseQueryString still requested
                self.search = '';
                self.query = {};
              }
              if (rest) self.pathname = rest;
              if (slashedProtocol[lowerProto] &&
                self.hostname && !self.pathname) {
                self.pathname = '/';
              }

              //to support http.request
              if (self.pathname || self.search) {
                p = self.pathname || '';
                var s = self.search || '';
                self.path = p + s;
              }

              // finally, reconstruct the href based on what has been validated.
              self.href = format(self);
              return self;
            }

            // format a parsed object into a url string
            function urlFormat(obj) {
              // ensure it's an object, and not a string url.
              // If it's an obj, this is a no-op.
              // this way, you can call url_format() on strings
              // to clean up potentially wonky urls.
              if (isString(obj)) obj = parse({}, obj);
              return format(obj);
            }

            function format(self) {
              var auth = self.auth || '';
              if (auth) {
                auth = encodeURIComponent(auth);
                auth = auth.replace(/%3A/i, ':');
                auth += '@';
              }

              var protocol = self.protocol || '',
                pathname = self.pathname || '',
                hash = self.hash || '',
                host = false,
                query = '';

              if (self.host) {
                host = auth + self.host;
              } else if (self.hostname) {
                host = auth + (self.hostname.indexOf(':') === -1 ?
                  self.hostname :
                  '[' + this.hostname + ']');
                if (self.port) {
                  host += ':' + self.port;
                }
              }

              if (self.query &&
                isObject(self.query) &&
                Object.keys(self.query).length) {
                query = stringify(self.query);
              }

              var search = self.search || (query && ('?' + query)) || '';

              if (protocol && protocol.substr(-1) !== ':') protocol += ':';

              // only the slashedProtocols get the //.  Not mailto:, xmpp:, etc.
              // unless they had them to begin with.
              if (self.slashes ||
                (!protocol || slashedProtocol[protocol]) && host !== false) {
                host = '//' + (host || '');
                if (pathname && pathname.charAt(0) !== '/') pathname = '/' + pathname;
              } else if (!host) {
                host = '';
              }

              if (hash && hash.charAt(0) !== '#') hash = '#' + hash;
              if (search && search.charAt(0) !== '?') search = '?' + search;

              pathname = pathname.replace(/[?#]/g, function(match) {
                return encodeURIComponent(match);
              });
              search = search.replace('#', '%23');

              return protocol + host + pathname + search + hash;
            }

            Url$1.prototype.format = function() {
              return format(this);
            };

            function urlResolve(source, relative) {
              return urlParse(source, false, true).resolve(relative);
            }

            Url$1.prototype.resolve = function(relative) {
              return this.resolveObject(urlParse(relative, false, true)).format();
            };

            function urlResolveObject(source, relative) {
              if (!source) return relative;
              return urlParse(source, false, true).resolveObject(relative);
            }

            Url$1.prototype.resolveObject = function(relative) {
              if (isString(relative)) {
                var rel = new Url$1();
                rel.parse(relative, false, true);
                relative = rel;
              }

              var result = new Url$1();
              var tkeys = Object.keys(this);
              for (var tk = 0; tk < tkeys.length; tk++) {
                var tkey = tkeys[tk];
                result[tkey] = this[tkey];
              }

              // hash is always overridden, no matter what.
              // even href="" will remove it.
              result.hash = relative.hash;

              // if the relative url is empty, then there's nothing left to do here.
              if (relative.href === '') {
                result.href = result.format();
                return result;
              }

              // hrefs like //foo/bar always cut to the protocol.
              if (relative.slashes && !relative.protocol) {
                // take everything except the protocol from relative
                var rkeys = Object.keys(relative);
                for (var rk = 0; rk < rkeys.length; rk++) {
                  var rkey = rkeys[rk];
                  if (rkey !== 'protocol')
                    result[rkey] = relative[rkey];
                }

                //urlParse appends trailing / to urls like http://www.example.com
                if (slashedProtocol[result.protocol] &&
                  result.hostname && !result.pathname) {
                  result.path = result.pathname = '/';
                }

                result.href = result.format();
                return result;
              }
              var relPath;
              if (relative.protocol && relative.protocol !== result.protocol) {
                // if it's a known url protocol, then changing
                // the protocol does weird things
                // first, if it's not file:, then we MUST have a host,
                // and if there was a path
                // to begin with, then we MUST have a path.
                // if it is file:, then the host is dropped,
                // because that's known to be hostless.
                // anything else is assumed to be absolute.
                if (!slashedProtocol[relative.protocol]) {
                  var keys = Object.keys(relative);
                  for (var v = 0; v < keys.length; v++) {
                    var k = keys[v];
                    result[k] = relative[k];
                  }
                  result.href = result.format();
                  return result;
                }

                result.protocol = relative.protocol;
                if (!relative.host && !hostlessProtocol[relative.protocol]) {
                  relPath = (relative.pathname || '').split('/');
                  while (relPath.length && !(relative.host = relPath.shift()));
                  if (!relative.host) relative.host = '';
                  if (!relative.hostname) relative.hostname = '';
                  if (relPath[0] !== '') relPath.unshift('');
                  if (relPath.length < 2) relPath.unshift('');
                  result.pathname = relPath.join('/');
                } else {
                  result.pathname = relative.pathname;
                }
                result.search = relative.search;
                result.query = relative.query;
                result.host = relative.host || '';
                result.auth = relative.auth;
                result.hostname = relative.hostname || relative.host;
                result.port = relative.port;
                // to support http.request
                if (result.pathname || result.search) {
                  var p = result.pathname || '';
                  var s = result.search || '';
                  result.path = p + s;
                }
                result.slashes = result.slashes || relative.slashes;
                result.href = result.format();
                return result;
              }

              var isSourceAbs = (result.pathname && result.pathname.charAt(0) === '/'),
                isRelAbs = (
                  relative.host ||
                  relative.pathname && relative.pathname.charAt(0) === '/'
                ),
                mustEndAbs = (isRelAbs || isSourceAbs ||
                  (result.host && relative.pathname)),
                removeAllDots = mustEndAbs,
                srcPath = result.pathname && result.pathname.split('/') || [],
                psychotic = result.protocol && !slashedProtocol[result.protocol];
              relPath = relative.pathname && relative.pathname.split('/') || [];
              // if the url is a non-slashed url, then relative
              // links like ../.. should be able
              // to crawl up to the hostname, as well.  This is strange.
              // result.protocol has already been set by now.
              // Later on, put the first path part into the host field.
              if (psychotic) {
                result.hostname = '';
                result.port = null;
                if (result.host) {
                  if (srcPath[0] === '') srcPath[0] = result.host;
                  else srcPath.unshift(result.host);
                }
                result.host = '';
                if (relative.protocol) {
                  relative.hostname = null;
                  relative.port = null;
                  if (relative.host) {
                    if (relPath[0] === '') relPath[0] = relative.host;
                    else relPath.unshift(relative.host);
                  }
                  relative.host = null;
                }
                mustEndAbs = mustEndAbs && (relPath[0] === '' || srcPath[0] === '');
              }
              var authInHost;
              if (isRelAbs) {
                // it's absolute.
                result.host = (relative.host || relative.host === '') ?
                  relative.host : result.host;
                result.hostname = (relative.hostname || relative.hostname === '') ?
                  relative.hostname : result.hostname;
                result.search = relative.search;
                result.query = relative.query;
                srcPath = relPath;
                // fall through to the dot-handling below.
              } else if (relPath.length) {
                // it's relative
                // throw away the existing file, and take the new path instead.
                if (!srcPath) srcPath = [];
                srcPath.pop();
                srcPath = srcPath.concat(relPath);
                result.search = relative.search;
                result.query = relative.query;
              } else if (!isNullOrUndefined(relative.search)) {
                // just pull out the search.
                // like href='?foo'.
                // Put this after the other two cases because it simplifies the booleans
                if (psychotic) {
                  result.hostname = result.host = srcPath.shift();
                  //occationaly the auth can get stuck only in host
                  //this especially happens in cases like
                  //url.resolveObject('mailto:local1@domain1', 'local2@domain2')
                  authInHost = result.host && result.host.indexOf('@') > 0 ?
                    result.host.split('@') : false;
                  if (authInHost) {
                    result.auth = authInHost.shift();
                    result.host = result.hostname = authInHost.shift();
                  }
                }
                result.search = relative.search;
                result.query = relative.query;
                //to support http.request
                if (!isNull(result.pathname) || !isNull(result.search)) {
                  result.path = (result.pathname ? result.pathname : '') +
                    (result.search ? result.search : '');
                }
                result.href = result.format();
                return result;
              }

              if (!srcPath.length) {
                // no path at all.  easy.
                // we've already handled the other stuff above.
                result.pathname = null;
                //to support http.request
                if (result.search) {
                  result.path = '/' + result.search;
                } else {
                  result.path = null;
                }
                result.href = result.format();
                return result;
              }

              // if a url ENDs in . or .., then it must get a trailing slash.
              // however, if it ends in anything else non-slashy,
              // then it must NOT get a trailing slash.
              var last = srcPath.slice(-1)[0];
              var hasTrailingSlash = (
                (result.host || relative.host || srcPath.length > 1) &&
                (last === '.' || last === '..') || last === '');

              // strip single dots, resolve double dots to parent dir
              // if the path tries to go above the root, `up` ends up > 0
              var up = 0;
              for (var i = srcPath.length; i >= 0; i--) {
                last = srcPath[i];
                if (last === '.') {
                  srcPath.splice(i, 1);
                } else if (last === '..') {
                  srcPath.splice(i, 1);
                  up++;
                } else if (up) {
                  srcPath.splice(i, 1);
                  up--;
                }
              }

              // if the path is allowed to go above the root, restore leading ..s
              if (!mustEndAbs && !removeAllDots) {
                for (; up--; up) {
                  srcPath.unshift('..');
                }
              }

              if (mustEndAbs && srcPath[0] !== '' &&
                (!srcPath[0] || srcPath[0].charAt(0) !== '/')) {
                srcPath.unshift('');
              }

              if (hasTrailingSlash && (srcPath.join('/').substr(-1) !== '/')) {
                srcPath.push('');
              }

              var isAbsolute = srcPath[0] === '' ||
                (srcPath[0] && srcPath[0].charAt(0) === '/');

              // put the host back
              if (psychotic) {
                result.hostname = result.host = isAbsolute ? '' :
                  srcPath.length ? srcPath.shift() : '';
                //occationaly the auth can get stuck only in host
                //this especially happens in cases like
                //url.resolveObject('mailto:local1@domain1', 'local2@domain2')
                authInHost = result.host && result.host.indexOf('@') > 0 ?
                  result.host.split('@') : false;
                if (authInHost) {
                  result.auth = authInHost.shift();
                  result.host = result.hostname = authInHost.shift();
                }
              }

              mustEndAbs = mustEndAbs || (result.host && srcPath.length);

              if (mustEndAbs && !isAbsolute) {
                srcPath.unshift('');
              }

              if (!srcPath.length) {
                result.pathname = null;
                result.path = null;
              } else {
                result.pathname = srcPath.join('/');
              }

              //to support request.http
              if (!isNull(result.pathname) || !isNull(result.search)) {
                result.path = (result.pathname ? result.pathname : '') +
                  (result.search ? result.search : '');
              }
              result.auth = relative.auth || result.auth;
              result.slashes = result.slashes || relative.slashes;
              result.href = result.format();
              return result;
            };

            Url$1.prototype.parseHost = function() {
              return parseHost(this);
            };

            function parseHost(self) {
              var host = self.host;
              var port = portPattern.exec(host);
              if (port) {
                port = port[0];
                if (port !== ':') {
                  self.port = port.substr(1);
                }
                host = host.substr(0, host.length - port.length);
              }
              if (host) self.hostname = host;
            }

            function request$1(opts, cb) {
              if (typeof opts === 'string')
                opts = urlParse(opts);


              // Normally, the page is loaded from http or https, so not specifying a protocol
              // will result in a (valid) protocol-relative url. However, this won't work if
              // the protocol is something else, like 'file:'
              var defaultProtocol = global$1.location.protocol.search(/^https?:$/) === -1 ? 'http:' : '';

              var protocol = opts.protocol || defaultProtocol;
              var host = opts.hostname || opts.host;
              var port = opts.port;
              var path = opts.path || '/';

              // Necessary for IPv6 addresses
              if (host && host.indexOf(':') !== -1)
                host = '[' + host + ']';

              // This may be a relative url. The browser should always be able to interpret it correctly.
              opts.url = (host ? (protocol + '//' + host) : '') + (port ? ':' + port : '') + path;
              opts.method = (opts.method || 'GET').toUpperCase();
              opts.headers = opts.headers || {};

              // Also valid opts.auth, opts.mode

              var req = new ClientRequest(opts);
              if (cb)
                req.on('response', cb);
              return req
            }

            function get(opts, cb) {
              var req = request$1(opts, cb);
              req.end();
              return req
            }

            function Agent() {}
            Agent.defaultMaxSockets = 4;

            var METHODS = [
              'CHECKOUT',
              'CONNECT',
              'COPY',
              'DELETE',
              'GET',
              'HEAD',
              'LOCK',
              'M-SEARCH',
              'MERGE',
              'MKACTIVITY',
              'MKCOL',
              'MOVE',
              'NOTIFY',
              'OPTIONS',
              'PATCH',
              'POST',
              'PROPFIND',
              'PROPPATCH',
              'PURGE',
              'PUT',
              'REPORT',
              'SEARCH',
              'SUBSCRIBE',
              'TRACE',
              'UNLOCK',
              'UNSUBSCRIBE'
            ];
            var STATUS_CODES$1 = {
              100: 'Continue',
              101: 'Switching Protocols',
              102: 'Processing', // RFC 2518, obsoleted by RFC 4918
              200: 'OK',
              201: 'Created',
              202: 'Accepted',
              203: 'Non-Authoritative Information',
              204: 'No Content',
              205: 'Reset Content',
              206: 'Partial Content',
              207: 'Multi-Status', // RFC 4918
              300: 'Multiple Choices',
              301: 'Moved Permanently',
              302: 'Moved Temporarily',
              303: 'See Other',
              304: 'Not Modified',
              305: 'Use Proxy',
              307: 'Temporary Redirect',
              400: 'Bad Request',
              401: 'Unauthorized',
              402: 'Payment Required',
              403: 'Forbidden',
              404: 'Not Found',
              405: 'Method Not Allowed',
              406: 'Not Acceptable',
              407: 'Proxy Authentication Required',
              408: 'Request Time-out',
              409: 'Conflict',
              410: 'Gone',
              411: 'Length Required',
              412: 'Precondition Failed',
              413: 'Request Entity Too Large',
              414: 'Request-URI Too Large',
              415: 'Unsupported Media Type',
              416: 'Requested Range Not Satisfiable',
              417: 'Expectation Failed',
              418: 'I\'m a teapot', // RFC 2324
              422: 'Unprocessable Entity', // RFC 4918
              423: 'Locked', // RFC 4918
              424: 'Failed Dependency', // RFC 4918
              425: 'Unordered Collection', // RFC 4918
              426: 'Upgrade Required', // RFC 2817
              428: 'Precondition Required', // RFC 6585
              429: 'Too Many Requests', // RFC 6585
              431: 'Request Header Fields Too Large', // RFC 6585
              500: 'Internal Server Error',
              501: 'Not Implemented',
              502: 'Bad Gateway',
              503: 'Service Unavailable',
              504: 'Gateway Time-out',
              505: 'HTTP Version Not Supported',
              506: 'Variant Also Negotiates', // RFC 2295
              507: 'Insufficient Storage', // RFC 4918
              509: 'Bandwidth Limit Exceeded',
              510: 'Not Extended', // RFC 2774
              511: 'Network Authentication Required' // RFC 6585
            };

            var http = {
              request: request$1,
              get,
              Agent,
              METHODS,
              STATUS_CODES: STATUS_CODES$1
            };

            var msg = {
              2:      'need dictionary',     /* Z_NEED_DICT       2  */
              1:      'stream end',          /* Z_STREAM_END      1  */
              0:      '',                    /* Z_OK              0  */
              '-1':   'file error',          /* Z_ERRNO         (-1) */
              '-2':   'stream error',        /* Z_STREAM_ERROR  (-2) */
              '-3':   'data error',          /* Z_DATA_ERROR    (-3) */
              '-4':   'insufficient memory', /* Z_MEM_ERROR     (-4) */
              '-5':   'buffer error',        /* Z_BUF_ERROR     (-5) */
              '-6':   'incompatible version' /* Z_VERSION_ERROR (-6) */
            };

            function ZStream() {
              /* next input byte */
              this.input = null; // JS specific, because we have no pointers
              this.next_in = 0;
              /* number of bytes available at input */
              this.avail_in = 0;
              /* total number of input bytes read so far */
              this.total_in = 0;
              /* next output byte should be put there */
              this.output = null; // JS specific, because we have no pointers
              this.next_out = 0;
              /* remaining free space at output */
              this.avail_out = 0;
              /* total number of bytes output so far */
              this.total_out = 0;
              /* last error message, NULL if no error */
              this.msg = ''/*Z_NULL*/;
              /* not visible by applications */
              this.state = null;
              /* best guess about the data type: binary or text */
              this.data_type = 2/*Z_UNKNOWN*/;
              /* adler32 value of the uncompressed data */
              this.adler = 0;
            }

            function arraySet(dest, src, src_offs, len, dest_offs) {
              if (src.subarray && dest.subarray) {
                dest.set(src.subarray(src_offs, src_offs + len), dest_offs);
                return;
              }
              // Fallback to ordinary array
              for (var i = 0; i < len; i++) {
                dest[dest_offs + i] = src[src_offs + i];
              }
            }


            var Buf8 = Uint8Array;
            var Buf16 = Uint16Array;
            var Buf32 = Int32Array;
            // Enable/Disable typed arrays use, for testing
            //

            /* Public constants ==========================================================*/
            /* ===========================================================================*/


            //var Z_FILTERED          = 1;
            //var Z_HUFFMAN_ONLY      = 2;
            //var Z_RLE               = 3;
            var Z_FIXED$2 = 4;
            //var Z_DEFAULT_STRATEGY  = 0;

            /* Possible values of the data_type field (though see inflate()) */
            var Z_BINARY$1 = 0;
            var Z_TEXT$1 = 1;
            //var Z_ASCII             = 1; // = Z_TEXT
            var Z_UNKNOWN$2 = 2;

            /*============================================================================*/


            function zero$1(buf) {
              var len = buf.length;
              while (--len >= 0) {
                buf[len] = 0;
              }
            }

            // From zutil.h

            var STORED_BLOCK = 0;
            var STATIC_TREES = 1;
            var DYN_TREES = 2;
            /* The three kinds of block type */

            var MIN_MATCH$1 = 3;
            var MAX_MATCH$1 = 258;
            /* The minimum and maximum match lengths */

            // From deflate.h
            /* ===========================================================================
             * Internal compression state.
             */

            var LENGTH_CODES$1 = 29;
            /* number of length codes, not counting the special END_BLOCK code */

            var LITERALS$1 = 256;
            /* number of literal bytes 0..255 */

            var L_CODES$1 = LITERALS$1 + 1 + LENGTH_CODES$1;
            /* number of Literal or Length codes, including the END_BLOCK code */

            var D_CODES$1 = 30;
            /* number of distance codes */

            var BL_CODES$1 = 19;
            /* number of codes used to transfer the bit lengths */

            var HEAP_SIZE$1 = 2 * L_CODES$1 + 1;
            /* maximum heap size */

            var MAX_BITS$1 = 15;
            /* All codes must not exceed MAX_BITS bits */

            var Buf_size = 16;
            /* size of bit buffer in bi_buf */


            /* ===========================================================================
             * Constants
             */

            var MAX_BL_BITS = 7;
            /* Bit length codes must not exceed MAX_BL_BITS bits */

            var END_BLOCK = 256;
            /* end of block literal code */

            var REP_3_6 = 16;
            /* repeat previous bit length 3-6 times (2 bits of repeat count) */

            var REPZ_3_10 = 17;
            /* repeat a zero length 3-10 times  (3 bits of repeat count) */

            var REPZ_11_138 = 18;
            /* repeat a zero length 11-138 times  (7 bits of repeat count) */

            /* eslint-disable comma-spacing,array-bracket-spacing */
            var extra_lbits = /* extra bits for each length code */ [0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 1, 1, 2, 2, 2, 2, 3, 3, 3, 3, 4, 4, 4, 4, 5, 5, 5, 5, 0];

            var extra_dbits = /* extra bits for each distance code */ [0, 0, 0, 0, 1, 1, 2, 2, 3, 3, 4, 4, 5, 5, 6, 6, 7, 7, 8, 8, 9, 9, 10, 10, 11, 11, 12, 12, 13, 13];

            var extra_blbits = /* extra bits for each bit length code */ [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 3, 7];

            var bl_order = [16, 17, 18, 0, 8, 7, 9, 6, 10, 5, 11, 4, 12, 3, 13, 2, 14, 1, 15];
            /* eslint-enable comma-spacing,array-bracket-spacing */

            /* The lengths of the bit length codes are sent in order of decreasing
             * probability, to avoid transmitting the lengths for unused bit length codes.
             */

            /* ===========================================================================
             * Local data. These are initialized only once.
             */

            // We pre-fill arrays with 0 to avoid uninitialized gaps

            var DIST_CODE_LEN = 512; /* see definition of array dist_code below */

            // !!!! Use flat array insdead of structure, Freq = i*2, Len = i*2+1
            var static_ltree = new Array((L_CODES$1 + 2) * 2);
            zero$1(static_ltree);
            /* The static literal tree. Since the bit lengths are imposed, there is no
             * need for the L_CODES extra codes used during heap construction. However
             * The codes 286 and 287 are needed to build a canonical tree (see _tr_init
             * below).
             */

            var static_dtree = new Array(D_CODES$1 * 2);
            zero$1(static_dtree);
            /* The static distance tree. (Actually a trivial tree since all codes use
             * 5 bits.)
             */

            var _dist_code = new Array(DIST_CODE_LEN);
            zero$1(_dist_code);
            /* Distance codes. The first 256 values correspond to the distances
             * 3 .. 258, the last 256 values correspond to the top 8 bits of
             * the 15 bit distances.
             */

            var _length_code = new Array(MAX_MATCH$1 - MIN_MATCH$1 + 1);
            zero$1(_length_code);
            /* length code for each normalized match length (0 == MIN_MATCH) */

            var base_length = new Array(LENGTH_CODES$1);
            zero$1(base_length);
            /* First normalized length for each code (0 = MIN_MATCH) */

            var base_dist = new Array(D_CODES$1);
            zero$1(base_dist);
            /* First normalized distance for each code (0 = distance of 1) */


            function StaticTreeDesc(static_tree, extra_bits, extra_base, elems, max_length) {

              this.static_tree = static_tree; /* static tree or NULL */
              this.extra_bits = extra_bits; /* extra bits for each code or NULL */
              this.extra_base = extra_base; /* base index for extra_bits */
              this.elems = elems; /* max number of elements in the tree */
              this.max_length = max_length; /* max bit length for the codes */

              // show if `static_tree` has data or dummy - needed for monomorphic objects
              this.has_stree = static_tree && static_tree.length;
            }


            var static_l_desc;
            var static_d_desc;
            var static_bl_desc;


            function TreeDesc(dyn_tree, stat_desc) {
              this.dyn_tree = dyn_tree; /* the dynamic tree */
              this.max_code = 0; /* largest code with non zero frequency */
              this.stat_desc = stat_desc; /* the corresponding static tree */
            }



            function d_code(dist) {
              return dist < 256 ? _dist_code[dist] : _dist_code[256 + (dist >>> 7)];
            }


            /* ===========================================================================
             * Output a short LSB first on the stream.
             * IN assertion: there is enough room in pendingBuf.
             */
            function put_short(s, w) {
              //    put_byte(s, (uch)((w) & 0xff));
              //    put_byte(s, (uch)((ush)(w) >> 8));
              s.pending_buf[s.pending++] = (w) & 0xff;
              s.pending_buf[s.pending++] = (w >>> 8) & 0xff;
            }


            /* ===========================================================================
             * Send a value on a given number of bits.
             * IN assertion: length <= 16 and value fits in length bits.
             */
            function send_bits(s, value, length) {
              if (s.bi_valid > (Buf_size - length)) {
                s.bi_buf |= (value << s.bi_valid) & 0xffff;
                put_short(s, s.bi_buf);
                s.bi_buf = value >> (Buf_size - s.bi_valid);
                s.bi_valid += length - Buf_size;
              } else {
                s.bi_buf |= (value << s.bi_valid) & 0xffff;
                s.bi_valid += length;
              }
            }


            function send_code(s, c, tree) {
              send_bits(s, tree[c * 2] /*.Code*/ , tree[c * 2 + 1] /*.Len*/ );
            }


            /* ===========================================================================
             * Reverse the first len bits of a code, using straightforward code (a faster
             * method would use a table)
             * IN assertion: 1 <= len <= 15
             */
            function bi_reverse(code, len) {
              var res = 0;
              do {
                res |= code & 1;
                code >>>= 1;
                res <<= 1;
              } while (--len > 0);
              return res >>> 1;
            }


            /* ===========================================================================
             * Flush the bit buffer, keeping at most 7 bits in it.
             */
            function bi_flush(s) {
              if (s.bi_valid === 16) {
                put_short(s, s.bi_buf);
                s.bi_buf = 0;
                s.bi_valid = 0;

              } else if (s.bi_valid >= 8) {
                s.pending_buf[s.pending++] = s.bi_buf & 0xff;
                s.bi_buf >>= 8;
                s.bi_valid -= 8;
              }
            }


            /* ===========================================================================
             * Compute the optimal bit lengths for a tree and update the total bit length
             * for the current block.
             * IN assertion: the fields freq and dad are set, heap[heap_max] and
             *    above are the tree nodes sorted by increasing frequency.
             * OUT assertions: the field len is set to the optimal bit length, the
             *     array bl_count contains the frequencies for each bit length.
             *     The length opt_len is updated; static_len is also updated if stree is
             *     not null.
             */
            function gen_bitlen(s, desc) {
            //    deflate_state *s;
            //    tree_desc *desc;    /* the tree descriptor */
              var tree = desc.dyn_tree;
              var max_code = desc.max_code;
              var stree = desc.stat_desc.static_tree;
              var has_stree = desc.stat_desc.has_stree;
              var extra = desc.stat_desc.extra_bits;
              var base = desc.stat_desc.extra_base;
              var max_length = desc.stat_desc.max_length;
              var h; /* heap index */
              var n, m; /* iterate over the tree elements */
              var bits; /* bit length */
              var xbits; /* extra bits */
              var f; /* frequency */
              var overflow = 0; /* number of elements with bit length too large */

              for (bits = 0; bits <= MAX_BITS$1; bits++) {
                s.bl_count[bits] = 0;
              }

              /* In a first pass, compute the optimal bit lengths (which may
               * overflow in the case of the bit length tree).
               */
              tree[s.heap[s.heap_max] * 2 + 1] /*.Len*/ = 0; /* root of the heap */

              for (h = s.heap_max + 1; h < HEAP_SIZE$1; h++) {
                n = s.heap[h];
                bits = tree[tree[n * 2 + 1] /*.Dad*/ * 2 + 1] /*.Len*/ + 1;
                if (bits > max_length) {
                  bits = max_length;
                  overflow++;
                }
                tree[n * 2 + 1] /*.Len*/ = bits;
                /* We overwrite tree[n].Dad which is no longer needed */

                if (n > max_code) {
                  continue;
                } /* not a leaf node */

                s.bl_count[bits]++;
                xbits = 0;
                if (n >= base) {
                  xbits = extra[n - base];
                }
                f = tree[n * 2] /*.Freq*/ ;
                s.opt_len += f * (bits + xbits);
                if (has_stree) {
                  s.static_len += f * (stree[n * 2 + 1] /*.Len*/ + xbits);
                }
              }
              if (overflow === 0) {
                return;
              }

              // Trace((stderr,"\nbit length overflow\n"));
              /* This happens for example on obj2 and pic of the Calgary corpus */

              /* Find the first bit length which could increase: */
              do {
                bits = max_length - 1;
                while (s.bl_count[bits] === 0) {
                  bits--;
                }
                s.bl_count[bits]--; /* move one leaf down the tree */
                s.bl_count[bits + 1] += 2; /* move one overflow item as its brother */
                s.bl_count[max_length]--;
                /* The brother of the overflow item also moves one step up,
                 * but this does not affect bl_count[max_length]
                 */
                overflow -= 2;
              } while (overflow > 0);

              /* Now recompute all bit lengths, scanning in increasing frequency.
               * h is still equal to HEAP_SIZE. (It is simpler to reconstruct all
               * lengths instead of fixing only the wrong ones. This idea is taken
               * from 'ar' written by Haruhiko Okumura.)
               */
              for (bits = max_length; bits !== 0; bits--) {
                n = s.bl_count[bits];
                while (n !== 0) {
                  m = s.heap[--h];
                  if (m > max_code) {
                    continue;
                  }
                  if (tree[m * 2 + 1] /*.Len*/ !== bits) {
                    // Trace((stderr,"code %d bits %d->%d\n", m, tree[m].Len, bits));
                    s.opt_len += (bits - tree[m * 2 + 1] /*.Len*/ ) * tree[m * 2] /*.Freq*/ ;
                    tree[m * 2 + 1] /*.Len*/ = bits;
                  }
                  n--;
                }
              }
            }


            /* ===========================================================================
             * Generate the codes for a given tree and bit counts (which need not be
             * optimal).
             * IN assertion: the array bl_count contains the bit length statistics for
             * the given tree and the field len is set for all tree elements.
             * OUT assertion: the field code is set for all tree elements of non
             *     zero code length.
             */
            function gen_codes(tree, max_code, bl_count) {
            //    ct_data *tree;             /* the tree to decorate */
            //    int max_code;              /* largest code with non zero frequency */
            //    ushf *bl_count;            /* number of codes at each bit length */

              var next_code = new Array(MAX_BITS$1 + 1); /* next code value for each bit length */
              var code = 0; /* running code value */
              var bits; /* bit index */
              var n; /* code index */

              /* The distribution counts are first used to generate the code values
               * without bit reversal.
               */
              for (bits = 1; bits <= MAX_BITS$1; bits++) {
                next_code[bits] = code = (code + bl_count[bits - 1]) << 1;
              }
              /* Check that the bit counts in bl_count are consistent. The last code
               * must be all ones.
               */
              //Assert (code + bl_count[MAX_BITS]-1 == (1<<MAX_BITS)-1,
              //        "inconsistent bit counts");
              //Tracev((stderr,"\ngen_codes: max_code %d ", max_code));

              for (n = 0; n <= max_code; n++) {
                var len = tree[n * 2 + 1] /*.Len*/ ;
                if (len === 0) {
                  continue;
                }
                /* Now reverse the bits */
                tree[n * 2] /*.Code*/ = bi_reverse(next_code[len]++, len);

                //Tracecv(tree != static_ltree, (stderr,"\nn %3d %c l %2d c %4x (%x) ",
                //     n, (isgraph(n) ? n : ' '), len, tree[n].Code, next_code[len]-1));
              }
            }


            /* ===========================================================================
             * Initialize the various 'constant' tables.
             */
            function tr_static_init() {
              var n; /* iterates over tree elements */
              var bits; /* bit counter */
              var length; /* length value */
              var code; /* code value */
              var dist; /* distance index */
              var bl_count = new Array(MAX_BITS$1 + 1);
              /* number of codes at each bit length for an optimal tree */

              // do check in _tr_init()
              //if (static_init_done) return;

              /* For some embedded targets, global variables are not initialized: */
              /*#ifdef NO_INIT_GLOBAL_POINTERS
                static_l_desc.static_tree = static_ltree;
                static_l_desc.extra_bits = extra_lbits;
                static_d_desc.static_tree = static_dtree;
                static_d_desc.extra_bits = extra_dbits;
                static_bl_desc.extra_bits = extra_blbits;
              #endif*/

              /* Initialize the mapping length (0..255) -> length code (0..28) */
              length = 0;
              for (code = 0; code < LENGTH_CODES$1 - 1; code++) {
                base_length[code] = length;
                for (n = 0; n < (1 << extra_lbits[code]); n++) {
                  _length_code[length++] = code;
                }
              }
              //Assert (length == 256, "tr_static_init: length != 256");
              /* Note that the length 255 (match length 258) can be represented
               * in two different ways: code 284 + 5 bits or code 285, so we
               * overwrite length_code[255] to use the best encoding:
               */
              _length_code[length - 1] = code;

              /* Initialize the mapping dist (0..32K) -> dist code (0..29) */
              dist = 0;
              for (code = 0; code < 16; code++) {
                base_dist[code] = dist;
                for (n = 0; n < (1 << extra_dbits[code]); n++) {
                  _dist_code[dist++] = code;
                }
              }
              //Assert (dist == 256, "tr_static_init: dist != 256");
              dist >>= 7; /* from now on, all distances are divided by 128 */
              for (; code < D_CODES$1; code++) {
                base_dist[code] = dist << 7;
                for (n = 0; n < (1 << (extra_dbits[code] - 7)); n++) {
                  _dist_code[256 + dist++] = code;
                }
              }
              //Assert (dist == 256, "tr_static_init: 256+dist != 512");

              /* Construct the codes of the static literal tree */
              for (bits = 0; bits <= MAX_BITS$1; bits++) {
                bl_count[bits] = 0;
              }

              n = 0;
              while (n <= 143) {
                static_ltree[n * 2 + 1] /*.Len*/ = 8;
                n++;
                bl_count[8]++;
              }
              while (n <= 255) {
                static_ltree[n * 2 + 1] /*.Len*/ = 9;
                n++;
                bl_count[9]++;
              }
              while (n <= 279) {
                static_ltree[n * 2 + 1] /*.Len*/ = 7;
                n++;
                bl_count[7]++;
              }
              while (n <= 287) {
                static_ltree[n * 2 + 1] /*.Len*/ = 8;
                n++;
                bl_count[8]++;
              }
              /* Codes 286 and 287 do not exist, but we must include them in the
               * tree construction to get a canonical Huffman tree (longest code
               * all ones)
               */
              gen_codes(static_ltree, L_CODES$1 + 1, bl_count);

              /* The static distance tree is trivial: */
              for (n = 0; n < D_CODES$1; n++) {
                static_dtree[n * 2 + 1] /*.Len*/ = 5;
                static_dtree[n * 2] /*.Code*/ = bi_reverse(n, 5);
              }

              // Now data ready and we can init static trees
              static_l_desc = new StaticTreeDesc(static_ltree, extra_lbits, LITERALS$1 + 1, L_CODES$1, MAX_BITS$1);
              static_d_desc = new StaticTreeDesc(static_dtree, extra_dbits, 0, D_CODES$1, MAX_BITS$1);
              static_bl_desc = new StaticTreeDesc(new Array(0), extra_blbits, 0, BL_CODES$1, MAX_BL_BITS);

              //static_init_done = true;
            }


            /* ===========================================================================
             * Initialize a new block.
             */
            function init_block(s) {
              var n; /* iterates over tree elements */

              /* Initialize the trees. */
              for (n = 0; n < L_CODES$1; n++) {
                s.dyn_ltree[n * 2] /*.Freq*/ = 0;
              }
              for (n = 0; n < D_CODES$1; n++) {
                s.dyn_dtree[n * 2] /*.Freq*/ = 0;
              }
              for (n = 0; n < BL_CODES$1; n++) {
                s.bl_tree[n * 2] /*.Freq*/ = 0;
              }

              s.dyn_ltree[END_BLOCK * 2] /*.Freq*/ = 1;
              s.opt_len = s.static_len = 0;
              s.last_lit = s.matches = 0;
            }


            /* ===========================================================================
             * Flush the bit buffer and align the output on a byte boundary
             */
            function bi_windup(s) {
              if (s.bi_valid > 8) {
                put_short(s, s.bi_buf);
              } else if (s.bi_valid > 0) {
                //put_byte(s, (Byte)s->bi_buf);
                s.pending_buf[s.pending++] = s.bi_buf;
              }
              s.bi_buf = 0;
              s.bi_valid = 0;
            }

            /* ===========================================================================
             * Copy a stored block, storing first the length and its
             * one's complement if requested.
             */
            function copy_block(s, buf, len, header) {
            //DeflateState *s;
            //charf    *buf;    /* the input data */
            //unsigned len;     /* its length */
            //int      header;  /* true if block header must be written */

              bi_windup(s); /* align on byte boundary */

              if (header) {
                put_short(s, len);
                put_short(s, ~len);
              }
              //  while (len--) {
              //    put_byte(s, *buf++);
              //  }
              arraySet(s.pending_buf, s.window, buf, len, s.pending);
              s.pending += len;
            }

            /* ===========================================================================
             * Compares to subtrees, using the tree depth as tie breaker when
             * the subtrees have equal frequency. This minimizes the worst case length.
             */
            function smaller(tree, n, m, depth) {
              var _n2 = n * 2;
              var _m2 = m * 2;
              return (tree[_n2] /*.Freq*/ < tree[_m2] /*.Freq*/ ||
                (tree[_n2] /*.Freq*/ === tree[_m2] /*.Freq*/ && depth[n] <= depth[m]));
            }

            /* ===========================================================================
             * Restore the heap property by moving down the tree starting at node k,
             * exchanging a node with the smallest of its two sons if necessary, stopping
             * when the heap property is re-established (each father smaller than its
             * two sons).
             */
            function pqdownheap(s, tree, k)
            //    deflate_state *s;
            //    ct_data *tree;  /* the tree to restore */
            //    int k;               /* node to move down */
            {
              var v = s.heap[k];
              var j = k << 1; /* left son of k */
              while (j <= s.heap_len) {
                /* Set j to the smallest of the two sons: */
                if (j < s.heap_len &&
                  smaller(tree, s.heap[j + 1], s.heap[j], s.depth)) {
                  j++;
                }
                /* Exit if v is smaller than both sons */
                if (smaller(tree, v, s.heap[j], s.depth)) {
                  break;
                }

                /* Exchange v with the smallest son */
                s.heap[k] = s.heap[j];
                k = j;

                /* And continue down the tree, setting j to the left son of k */
                j <<= 1;
              }
              s.heap[k] = v;
            }


            // inlined manually
            // var SMALLEST = 1;

            /* ===========================================================================
             * Send the block data compressed using the given Huffman trees
             */
            function compress_block(s, ltree, dtree)
            //    deflate_state *s;
            //    const ct_data *ltree; /* literal tree */
            //    const ct_data *dtree; /* distance tree */
            {
              var dist; /* distance of matched string */
              var lc; /* match length or unmatched char (if dist == 0) */
              var lx = 0; /* running index in l_buf */
              var code; /* the code to send */
              var extra; /* number of extra bits to send */

              if (s.last_lit !== 0) {
                do {
                  dist = (s.pending_buf[s.d_buf + lx * 2] << 8) | (s.pending_buf[s.d_buf + lx * 2 + 1]);
                  lc = s.pending_buf[s.l_buf + lx];
                  lx++;

                  if (dist === 0) {
                    send_code(s, lc, ltree); /* send a literal byte */
                    //Tracecv(isgraph(lc), (stderr," '%c' ", lc));
                  } else {
                    /* Here, lc is the match length - MIN_MATCH */
                    code = _length_code[lc];
                    send_code(s, code + LITERALS$1 + 1, ltree); /* send the length code */
                    extra = extra_lbits[code];
                    if (extra !== 0) {
                      lc -= base_length[code];
                      send_bits(s, lc, extra); /* send the extra length bits */
                    }
                    dist--; /* dist is now the match distance - 1 */
                    code = d_code(dist);
                    //Assert (code < D_CODES, "bad d_code");

                    send_code(s, code, dtree); /* send the distance code */
                    extra = extra_dbits[code];
                    if (extra !== 0) {
                      dist -= base_dist[code];
                      send_bits(s, dist, extra); /* send the extra distance bits */
                    }
                  } /* literal or match pair ? */

                  /* Check that the overlay between pending_buf and d_buf+l_buf is ok: */
                  //Assert((uInt)(s->pending) < s->lit_bufsize + 2*lx,
                  //       "pendingBuf overflow");

                } while (lx < s.last_lit);
              }

              send_code(s, END_BLOCK, ltree);
            }


            /* ===========================================================================
             * Construct one Huffman tree and assigns the code bit strings and lengths.
             * Update the total bit length for the current block.
             * IN assertion: the field freq is set for all tree elements.
             * OUT assertions: the fields len and code are set to the optimal bit length
             *     and corresponding code. The length opt_len is updated; static_len is
             *     also updated if stree is not null. The field max_code is set.
             */
            function build_tree(s, desc)
            //    deflate_state *s;
            //    tree_desc *desc; /* the tree descriptor */
            {
              var tree = desc.dyn_tree;
              var stree = desc.stat_desc.static_tree;
              var has_stree = desc.stat_desc.has_stree;
              var elems = desc.stat_desc.elems;
              var n, m; /* iterate over heap elements */
              var max_code = -1; /* largest code with non zero frequency */
              var node; /* new node being created */

              /* Construct the initial heap, with least frequent element in
               * heap[SMALLEST]. The sons of heap[n] are heap[2*n] and heap[2*n+1].
               * heap[0] is not used.
               */
              s.heap_len = 0;
              s.heap_max = HEAP_SIZE$1;

              for (n = 0; n < elems; n++) {
                if (tree[n * 2] /*.Freq*/ !== 0) {
                  s.heap[++s.heap_len] = max_code = n;
                  s.depth[n] = 0;

                } else {
                  tree[n * 2 + 1] /*.Len*/ = 0;
                }
              }

              /* The pkzip format requires that at least one distance code exists,
               * and that at least one bit should be sent even if there is only one
               * possible code. So to avoid special checks later on we force at least
               * two codes of non zero frequency.
               */
              while (s.heap_len < 2) {
                node = s.heap[++s.heap_len] = (max_code < 2 ? ++max_code : 0);
                tree[node * 2] /*.Freq*/ = 1;
                s.depth[node] = 0;
                s.opt_len--;

                if (has_stree) {
                  s.static_len -= stree[node * 2 + 1] /*.Len*/ ;
                }
                /* node is 0 or 1 so it does not have extra bits */
              }
              desc.max_code = max_code;

              /* The elements heap[heap_len/2+1 .. heap_len] are leaves of the tree,
               * establish sub-heaps of increasing lengths:
               */
              for (n = (s.heap_len >> 1 /*int /2*/ ); n >= 1; n--) {
                pqdownheap(s, tree, n);
              }

              /* Construct the Huffman tree by repeatedly combining the least two
               * frequent nodes.
               */
              node = elems; /* next internal node of the tree */
              do {
                //pqremove(s, tree, n);  /* n = node of least frequency */
                /*** pqremove ***/
                n = s.heap[1 /*SMALLEST*/ ];
                s.heap[1 /*SMALLEST*/ ] = s.heap[s.heap_len--];
                pqdownheap(s, tree, 1 /*SMALLEST*/ );
                /***/

                m = s.heap[1 /*SMALLEST*/ ]; /* m = node of next least frequency */

                s.heap[--s.heap_max] = n; /* keep the nodes sorted by frequency */
                s.heap[--s.heap_max] = m;

                /* Create a new node father of n and m */
                tree[node * 2] /*.Freq*/ = tree[n * 2] /*.Freq*/ + tree[m * 2] /*.Freq*/ ;
                s.depth[node] = (s.depth[n] >= s.depth[m] ? s.depth[n] : s.depth[m]) + 1;
                tree[n * 2 + 1] /*.Dad*/ = tree[m * 2 + 1] /*.Dad*/ = node;

                /* and insert the new node in the heap */
                s.heap[1 /*SMALLEST*/ ] = node++;
                pqdownheap(s, tree, 1 /*SMALLEST*/ );

              } while (s.heap_len >= 2);

              s.heap[--s.heap_max] = s.heap[1 /*SMALLEST*/ ];

              /* At this point, the fields freq and dad are set. We can now
               * generate the bit lengths.
               */
              gen_bitlen(s, desc);

              /* The field len is now set, we can generate the bit codes */
              gen_codes(tree, max_code, s.bl_count);
            }


            /* ===========================================================================
             * Scan a literal or distance tree to determine the frequencies of the codes
             * in the bit length tree.
             */
            function scan_tree(s, tree, max_code)
            //    deflate_state *s;
            //    ct_data *tree;   /* the tree to be scanned */
            //    int max_code;    /* and its largest code of non zero frequency */
            {
              var n; /* iterates over all tree elements */
              var prevlen = -1; /* last emitted length */
              var curlen; /* length of current code */

              var nextlen = tree[0 * 2 + 1] /*.Len*/ ; /* length of next code */

              var count = 0; /* repeat count of the current code */
              var max_count = 7; /* max repeat count */
              var min_count = 4; /* min repeat count */

              if (nextlen === 0) {
                max_count = 138;
                min_count = 3;
              }
              tree[(max_code + 1) * 2 + 1] /*.Len*/ = 0xffff; /* guard */

              for (n = 0; n <= max_code; n++) {
                curlen = nextlen;
                nextlen = tree[(n + 1) * 2 + 1] /*.Len*/ ;

                if (++count < max_count && curlen === nextlen) {
                  continue;

                } else if (count < min_count) {
                  s.bl_tree[curlen * 2] /*.Freq*/ += count;

                } else if (curlen !== 0) {

                  if (curlen !== prevlen) {
                    s.bl_tree[curlen * 2] /*.Freq*/ ++;
                  }
                  s.bl_tree[REP_3_6 * 2] /*.Freq*/ ++;

                } else if (count <= 10) {
                  s.bl_tree[REPZ_3_10 * 2] /*.Freq*/ ++;

                } else {
                  s.bl_tree[REPZ_11_138 * 2] /*.Freq*/ ++;
                }

                count = 0;
                prevlen = curlen;

                if (nextlen === 0) {
                  max_count = 138;
                  min_count = 3;

                } else if (curlen === nextlen) {
                  max_count = 6;
                  min_count = 3;

                } else {
                  max_count = 7;
                  min_count = 4;
                }
              }
            }


            /* ===========================================================================
             * Send a literal or distance tree in compressed form, using the codes in
             * bl_tree.
             */
            function send_tree(s, tree, max_code)
            //    deflate_state *s;
            //    ct_data *tree; /* the tree to be scanned */
            //    int max_code;       /* and its largest code of non zero frequency */
            {
              var n; /* iterates over all tree elements */
              var prevlen = -1; /* last emitted length */
              var curlen; /* length of current code */

              var nextlen = tree[0 * 2 + 1] /*.Len*/ ; /* length of next code */

              var count = 0; /* repeat count of the current code */
              var max_count = 7; /* max repeat count */
              var min_count = 4; /* min repeat count */

              /* tree[max_code+1].Len = -1; */
              /* guard already set */
              if (nextlen === 0) {
                max_count = 138;
                min_count = 3;
              }

              for (n = 0; n <= max_code; n++) {
                curlen = nextlen;
                nextlen = tree[(n + 1) * 2 + 1] /*.Len*/ ;

                if (++count < max_count && curlen === nextlen) {
                  continue;

                } else if (count < min_count) {
                  do {
                    send_code(s, curlen, s.bl_tree);
                  } while (--count !== 0);

                } else if (curlen !== 0) {
                  if (curlen !== prevlen) {
                    send_code(s, curlen, s.bl_tree);
                    count--;
                  }
                  //Assert(count >= 3 && count <= 6, " 3_6?");
                  send_code(s, REP_3_6, s.bl_tree);
                  send_bits(s, count - 3, 2);

                } else if (count <= 10) {
                  send_code(s, REPZ_3_10, s.bl_tree);
                  send_bits(s, count - 3, 3);

                } else {
                  send_code(s, REPZ_11_138, s.bl_tree);
                  send_bits(s, count - 11, 7);
                }

                count = 0;
                prevlen = curlen;
                if (nextlen === 0) {
                  max_count = 138;
                  min_count = 3;

                } else if (curlen === nextlen) {
                  max_count = 6;
                  min_count = 3;

                } else {
                  max_count = 7;
                  min_count = 4;
                }
              }
            }


            /* ===========================================================================
             * Construct the Huffman tree for the bit lengths and return the index in
             * bl_order of the last bit length code to send.
             */
            function build_bl_tree(s) {
              var max_blindex; /* index of last bit length code of non zero freq */

              /* Determine the bit length frequencies for literal and distance trees */
              scan_tree(s, s.dyn_ltree, s.l_desc.max_code);
              scan_tree(s, s.dyn_dtree, s.d_desc.max_code);

              /* Build the bit length tree: */
              build_tree(s, s.bl_desc);
              /* opt_len now includes the length of the tree representations, except
               * the lengths of the bit lengths codes and the 5+5+4 bits for the counts.
               */

              /* Determine the number of bit length codes to send. The pkzip format
               * requires that at least 4 bit length codes be sent. (appnote.txt says
               * 3 but the actual value used is 4.)
               */
              for (max_blindex = BL_CODES$1 - 1; max_blindex >= 3; max_blindex--) {
                if (s.bl_tree[bl_order[max_blindex] * 2 + 1] /*.Len*/ !== 0) {
                  break;
                }
              }
              /* Update opt_len to include the bit length tree and counts */
              s.opt_len += 3 * (max_blindex + 1) + 5 + 5 + 4;
              //Tracev((stderr, "\ndyn trees: dyn %ld, stat %ld",
              //        s->opt_len, s->static_len));

              return max_blindex;
            }


            /* ===========================================================================
             * Send the header for a block using dynamic Huffman trees: the counts, the
             * lengths of the bit length codes, the literal tree and the distance tree.
             * IN assertion: lcodes >= 257, dcodes >= 1, blcodes >= 4.
             */
            function send_all_trees(s, lcodes, dcodes, blcodes)
            //    deflate_state *s;
            //    int lcodes, dcodes, blcodes; /* number of codes for each tree */
            {
              var rank; /* index in bl_order */

              //Assert (lcodes >= 257 && dcodes >= 1 && blcodes >= 4, "not enough codes");
              //Assert (lcodes <= L_CODES && dcodes <= D_CODES && blcodes <= BL_CODES,
              //        "too many codes");
              //Tracev((stderr, "\nbl counts: "));
              send_bits(s, lcodes - 257, 5); /* not +255 as stated in appnote.txt */
              send_bits(s, dcodes - 1, 5);
              send_bits(s, blcodes - 4, 4); /* not -3 as stated in appnote.txt */
              for (rank = 0; rank < blcodes; rank++) {
                //Tracev((stderr, "\nbl code %2d ", bl_order[rank]));
                send_bits(s, s.bl_tree[bl_order[rank] * 2 + 1] /*.Len*/ , 3);
              }
              //Tracev((stderr, "\nbl tree: sent %ld", s->bits_sent));

              send_tree(s, s.dyn_ltree, lcodes - 1); /* literal tree */
              //Tracev((stderr, "\nlit tree: sent %ld", s->bits_sent));

              send_tree(s, s.dyn_dtree, dcodes - 1); /* distance tree */
              //Tracev((stderr, "\ndist tree: sent %ld", s->bits_sent));
            }


            /* ===========================================================================
             * Check if the data type is TEXT or BINARY, using the following algorithm:
             * - TEXT if the two conditions below are satisfied:
             *    a) There are no non-portable control characters belonging to the
             *       "black list" (0..6, 14..25, 28..31).
             *    b) There is at least one printable character belonging to the
             *       "white list" (9 {TAB}, 10 {LF}, 13 {CR}, 32..255).
             * - BINARY otherwise.
             * - The following partially-portable control characters form a
             *   "gray list" that is ignored in this detection algorithm:
             *   (7 {BEL}, 8 {BS}, 11 {VT}, 12 {FF}, 26 {SUB}, 27 {ESC}).
             * IN assertion: the fields Freq of dyn_ltree are set.
             */
            function detect_data_type(s) {
              /* black_mask is the bit mask of black-listed bytes
               * set bits 0..6, 14..25, and 28..31
               * 0xf3ffc07f = binary 11110011111111111100000001111111
               */
              var black_mask = 0xf3ffc07f;
              var n;

              /* Check for non-textual ("black-listed") bytes. */
              for (n = 0; n <= 31; n++, black_mask >>>= 1) {
                if ((black_mask & 1) && (s.dyn_ltree[n * 2] /*.Freq*/ !== 0)) {
                  return Z_BINARY$1;
                }
              }

              /* Check for textual ("white-listed") bytes. */
              if (s.dyn_ltree[9 * 2] /*.Freq*/ !== 0 || s.dyn_ltree[10 * 2] /*.Freq*/ !== 0 ||
                s.dyn_ltree[13 * 2] /*.Freq*/ !== 0) {
                return Z_TEXT$1;
              }
              for (n = 32; n < LITERALS$1; n++) {
                if (s.dyn_ltree[n * 2] /*.Freq*/ !== 0) {
                  return Z_TEXT$1;
                }
              }

              /* There are no "black-listed" or "white-listed" bytes:
               * this stream either is empty or has tolerated ("gray-listed") bytes only.
               */
              return Z_BINARY$1;
            }


            var static_init_done = false;

            /* ===========================================================================
             * Initialize the tree data structures for a new zlib stream.
             */
            function _tr_init(s) {

              if (!static_init_done) {
                tr_static_init();
                static_init_done = true;
              }

              s.l_desc = new TreeDesc(s.dyn_ltree, static_l_desc);
              s.d_desc = new TreeDesc(s.dyn_dtree, static_d_desc);
              s.bl_desc = new TreeDesc(s.bl_tree, static_bl_desc);

              s.bi_buf = 0;
              s.bi_valid = 0;

              /* Initialize the first block of the first file: */
              init_block(s);
            }


            /* ===========================================================================
             * Send a stored block
             */
            function _tr_stored_block(s, buf, stored_len, last)
            //DeflateState *s;
            //charf *buf;       /* input block */
            //ulg stored_len;   /* length of input block */
            //int last;         /* one if this is the last block for a file */
            {
              send_bits(s, (STORED_BLOCK << 1) + (last ? 1 : 0), 3); /* send block type */
              copy_block(s, buf, stored_len, true); /* with header */
            }


            /* ===========================================================================
             * Send one empty static block to give enough lookahead for inflate.
             * This takes 10 bits, of which 7 may remain in the bit buffer.
             */
            function _tr_align(s) {
              send_bits(s, STATIC_TREES << 1, 3);
              send_code(s, END_BLOCK, static_ltree);
              bi_flush(s);
            }


            /* ===========================================================================
             * Determine the best encoding for the current block: dynamic trees, static
             * trees or store, and output the encoded block to the zip file.
             */
            function _tr_flush_block(s, buf, stored_len, last)
            //DeflateState *s;
            //charf *buf;       /* input block, or NULL if too old */
            //ulg stored_len;   /* length of input block */
            //int last;         /* one if this is the last block for a file */
            {
              var opt_lenb, static_lenb; /* opt_len and static_len in bytes */
              var max_blindex = 0; /* index of last bit length code of non zero freq */

              /* Build the Huffman trees unless a stored block is forced */
              if (s.level > 0) {

                /* Check if the file is binary or text */
                if (s.strm.data_type === Z_UNKNOWN$2) {
                  s.strm.data_type = detect_data_type(s);
                }

                /* Construct the literal and distance trees */
                build_tree(s, s.l_desc);
                // Tracev((stderr, "\nlit data: dyn %ld, stat %ld", s->opt_len,
                //        s->static_len));

                build_tree(s, s.d_desc);
                // Tracev((stderr, "\ndist data: dyn %ld, stat %ld", s->opt_len,
                //        s->static_len));
                /* At this point, opt_len and static_len are the total bit lengths of
                 * the compressed block data, excluding the tree representations.
                 */

                /* Build the bit length tree for the above two trees, and get the index
                 * in bl_order of the last bit length code to send.
                 */
                max_blindex = build_bl_tree(s);

                /* Determine the best encoding. Compute the block lengths in bytes. */
                opt_lenb = (s.opt_len + 3 + 7) >>> 3;
                static_lenb = (s.static_len + 3 + 7) >>> 3;

                // Tracev((stderr, "\nopt %lu(%lu) stat %lu(%lu) stored %lu lit %u ",
                //        opt_lenb, s->opt_len, static_lenb, s->static_len, stored_len,
                //        s->last_lit));

                if (static_lenb <= opt_lenb) {
                  opt_lenb = static_lenb;
                }

              } else {
                // Assert(buf != (char*)0, "lost buf");
                opt_lenb = static_lenb = stored_len + 5; /* force a stored block */
              }

              if ((stored_len + 4 <= opt_lenb) && (buf !== -1)) {
                /* 4: two words for the lengths */

                /* The test buf != NULL is only necessary if LIT_BUFSIZE > WSIZE.
                 * Otherwise we can't have processed more than WSIZE input bytes since
                 * the last block flush, because compression would have been
                 * successful. If LIT_BUFSIZE <= WSIZE, it is never too late to
                 * transform a block into a stored block.
                 */
                _tr_stored_block(s, buf, stored_len, last);

              } else if (s.strategy === Z_FIXED$2 || static_lenb === opt_lenb) {

                send_bits(s, (STATIC_TREES << 1) + (last ? 1 : 0), 3);
                compress_block(s, static_ltree, static_dtree);

              } else {
                send_bits(s, (DYN_TREES << 1) + (last ? 1 : 0), 3);
                send_all_trees(s, s.l_desc.max_code + 1, s.d_desc.max_code + 1, max_blindex + 1);
                compress_block(s, s.dyn_ltree, s.dyn_dtree);
              }
              // Assert (s->compressed_len == s->bits_sent, "bad compressed size");
              /* The above check is made mod 2^32, for files larger than 512 MB
               * and uLong implemented on 32 bits.
               */
              init_block(s);

              if (last) {
                bi_windup(s);
              }
              // Tracev((stderr,"\ncomprlen %lu(%lu) ", s->compressed_len>>3,
              //       s->compressed_len-7*last));
            }

            /* ===========================================================================
             * Save the match info and tally the frequency counts. Return true if
             * the current block must be flushed.
             */
            function _tr_tally(s, dist, lc)
            //    deflate_state *s;
            //    unsigned dist;  /* distance of matched string */
            //    unsigned lc;    /* match length-MIN_MATCH or unmatched char (if dist==0) */
            {
              //var out_length, in_length, dcode;

              s.pending_buf[s.d_buf + s.last_lit * 2] = (dist >>> 8) & 0xff;
              s.pending_buf[s.d_buf + s.last_lit * 2 + 1] = dist & 0xff;

              s.pending_buf[s.l_buf + s.last_lit] = lc & 0xff;
              s.last_lit++;

              if (dist === 0) {
                /* lc is the unmatched char */
                s.dyn_ltree[lc * 2] /*.Freq*/ ++;
              } else {
                s.matches++;
                /* Here, lc is the match length - MIN_MATCH */
                dist--; /* dist = match distance - 1 */
                //Assert((ush)dist < (ush)MAX_DIST(s) &&
                //       (ush)lc <= (ush)(MAX_MATCH-MIN_MATCH) &&
                //       (ush)d_code(dist) < (ush)D_CODES,  "_tr_tally: bad match");

                s.dyn_ltree[(_length_code[lc] + LITERALS$1 + 1) * 2] /*.Freq*/ ++;
                s.dyn_dtree[d_code(dist) * 2] /*.Freq*/ ++;
              }

              // (!) This block is disabled in zlib defailts,
              // don't enable it for binary compatibility

              //#ifdef TRUNCATE_BLOCK
              //  /* Try to guess if it is profitable to stop the current block here */
              //  if ((s.last_lit & 0x1fff) === 0 && s.level > 2) {
              //    /* Compute an upper bound for the compressed length */
              //    out_length = s.last_lit*8;
              //    in_length = s.strstart - s.block_start;
              //
              //    for (dcode = 0; dcode < D_CODES; dcode++) {
              //      out_length += s.dyn_dtree[dcode*2]/*.Freq*/ * (5 + extra_dbits[dcode]);
              //    }
              //    out_length >>>= 3;
              //    //Tracev((stderr,"\nlast_lit %u, in %ld, out ~%ld(%ld%%) ",
              //    //       s->last_lit, in_length, out_length,
              //    //       100L - out_length*100L/in_length));
              //    if (s.matches < (s.last_lit>>1)/*int /2*/ && out_length < (in_length>>1)/*int /2*/) {
              //      return true;
              //    }
              //  }
              //#endif

              return (s.last_lit === s.lit_bufsize - 1);
              /* We avoid equality with lit_bufsize because of wraparound at 64K
               * on 16 bit machines and because stored blocks are restricted to
               * 64K-1 bytes.
               */
            }

            // Note: adler32 takes 12% for level 0 and 2% for level 6.
            // It doesn't worth to make additional optimizationa as in original.
            // Small size is preferable.

            function adler32(adler, buf, len, pos) {
              var s1 = (adler & 0xffff) |0,
                  s2 = ((adler >>> 16) & 0xffff) |0,
                  n = 0;

              while (len !== 0) {
                // Set limit ~ twice less than 5552, to keep
                // s2 in 31-bits, because we force signed ints.
                // in other case %= will fail.
                n = len > 2000 ? 2000 : len;
                len -= n;

                do {
                  s1 = (s1 + buf[pos++]) |0;
                  s2 = (s2 + s1) |0;
                } while (--n);

                s1 %= 65521;
                s2 %= 65521;
              }

              return (s1 | (s2 << 16)) |0;
            }

            // Note: we can't get significant speed boost here.
            // So write code to minimize size - no pregenerated tables
            // and array tools dependencies.


            // Use ordinary array, since untyped makes no boost here
            function makeTable() {
              var c, table = [];

              for (var n = 0; n < 256; n++) {
                c = n;
                for (var k = 0; k < 8; k++) {
                  c = ((c & 1) ? (0xEDB88320 ^ (c >>> 1)) : (c >>> 1));
                }
                table[n] = c;
              }

              return table;
            }

            // Create table on load. Just 255 signed longs. Not a problem.
            var crcTable = makeTable();


            function crc32(crc, buf, len, pos) {
              var t = crcTable,
                  end = pos + len;

              crc ^= -1;

              for (var i = pos; i < end; i++) {
                crc = (crc >>> 8) ^ t[(crc ^ buf[i]) & 0xFF];
              }

              return (crc ^ (-1)); // >>> 0;
            }

            /* Public constants ==========================================================*/
            /* ===========================================================================*/


            /* Allowed flush values; see deflate() and inflate() below for details */
            var Z_NO_FLUSH$1 = 0;
            var Z_PARTIAL_FLUSH$1 = 1;
            //var Z_SYNC_FLUSH    = 2;
            var Z_FULL_FLUSH$1 = 3;
            var Z_FINISH$2 = 4;
            var Z_BLOCK$2 = 5;
            //var Z_TREES         = 6;


            /* Return codes for the compression/decompression functions. Negative values
             * are errors, positive values are used for special but normal events.
             */
            var Z_OK$2 = 0;
            var Z_STREAM_END$2 = 1;
            //var Z_NEED_DICT     = 2;
            //var Z_ERRNO         = -1;
            var Z_STREAM_ERROR$2 = -2;
            var Z_DATA_ERROR$2 = -3;
            //var Z_MEM_ERROR     = -4;
            var Z_BUF_ERROR$2 = -5;
            //var Z_VERSION_ERROR = -6;


            /* compression levels */
            //var Z_NO_COMPRESSION      = 0;
            //var Z_BEST_SPEED          = 1;
            //var Z_BEST_COMPRESSION    = 9;
            var Z_DEFAULT_COMPRESSION$1 = -1;


            var Z_FILTERED$1 = 1;
            var Z_HUFFMAN_ONLY$1 = 2;
            var Z_RLE$1 = 3;
            var Z_FIXED$1 = 4;

            /* Possible values of the data_type field (though see inflate()) */
            //var Z_BINARY              = 0;
            //var Z_TEXT                = 1;
            //var Z_ASCII               = 1; // = Z_TEXT
            var Z_UNKNOWN$1 = 2;


            /* The deflate compression method */
            var Z_DEFLATED$2 = 8;

            /*============================================================================*/


            var MAX_MEM_LEVEL = 9;


            var LENGTH_CODES = 29;
            /* number of length codes, not counting the special END_BLOCK code */
            var LITERALS = 256;
            /* number of literal bytes 0..255 */
            var L_CODES = LITERALS + 1 + LENGTH_CODES;
            /* number of Literal or Length codes, including the END_BLOCK code */
            var D_CODES = 30;
            /* number of distance codes */
            var BL_CODES = 19;
            /* number of codes used to transfer the bit lengths */
            var HEAP_SIZE = 2 * L_CODES + 1;
            /* maximum heap size */
            var MAX_BITS = 15;
            /* All codes must not exceed MAX_BITS bits */

            var MIN_MATCH = 3;
            var MAX_MATCH = 258;
            var MIN_LOOKAHEAD = (MAX_MATCH + MIN_MATCH + 1);

            var PRESET_DICT = 0x20;

            var INIT_STATE = 42;
            var EXTRA_STATE = 69;
            var NAME_STATE = 73;
            var COMMENT_STATE = 91;
            var HCRC_STATE = 103;
            var BUSY_STATE = 113;
            var FINISH_STATE = 666;

            var BS_NEED_MORE = 1; /* block not completed, need more input or more output */
            var BS_BLOCK_DONE = 2; /* block flush performed */
            var BS_FINISH_STARTED = 3; /* finish started, need only more output at next deflate */
            var BS_FINISH_DONE = 4; /* finish done, accept no more input or output */

            var OS_CODE = 0x03; // Unix :) . Don't detect, use this default.

            function err(strm, errorCode) {
              strm.msg = msg[errorCode];
              return errorCode;
            }

            function rank(f) {
              return ((f) << 1) - ((f) > 4 ? 9 : 0);
            }

            function zero(buf) {
              var len = buf.length;
              while (--len >= 0) {
                buf[len] = 0;
              }
            }


            /* =========================================================================
             * Flush as much pending output as possible. All deflate() output goes
             * through this function so some applications may wish to modify it
             * to avoid allocating a large strm->output buffer and copying into it.
             * (See also read_buf()).
             */
            function flush_pending(strm) {
              var s = strm.state;

              //_tr_flush_bits(s);
              var len = s.pending;
              if (len > strm.avail_out) {
                len = strm.avail_out;
              }
              if (len === 0) {
                return;
              }

              arraySet(strm.output, s.pending_buf, s.pending_out, len, strm.next_out);
              strm.next_out += len;
              s.pending_out += len;
              strm.total_out += len;
              strm.avail_out -= len;
              s.pending -= len;
              if (s.pending === 0) {
                s.pending_out = 0;
              }
            }


            function flush_block_only(s, last) {
              _tr_flush_block(s, (s.block_start >= 0 ? s.block_start : -1), s.strstart - s.block_start, last);
              s.block_start = s.strstart;
              flush_pending(s.strm);
            }


            function put_byte(s, b) {
              s.pending_buf[s.pending++] = b;
            }


            /* =========================================================================
             * Put a short in the pending buffer. The 16-bit value is put in MSB order.
             * IN assertion: the stream state is correct and there is enough room in
             * pending_buf.
             */
            function putShortMSB(s, b) {
              //  put_byte(s, (Byte)(b >> 8));
              //  put_byte(s, (Byte)(b & 0xff));
              s.pending_buf[s.pending++] = (b >>> 8) & 0xff;
              s.pending_buf[s.pending++] = b & 0xff;
            }


            /* ===========================================================================
             * Read a new buffer from the current input stream, update the adler32
             * and total number of bytes read.  All deflate() input goes through
             * this function so some applications may wish to modify it to avoid
             * allocating a large strm->input buffer and copying from it.
             * (See also flush_pending()).
             */
            function read_buf(strm, buf, start, size) {
              var len = strm.avail_in;

              if (len > size) {
                len = size;
              }
              if (len === 0) {
                return 0;
              }

              strm.avail_in -= len;

              // zmemcpy(buf, strm->next_in, len);
              arraySet(buf, strm.input, strm.next_in, len, start);
              if (strm.state.wrap === 1) {
                strm.adler = adler32(strm.adler, buf, len, start);
              } else if (strm.state.wrap === 2) {
                strm.adler = crc32(strm.adler, buf, len, start);
              }

              strm.next_in += len;
              strm.total_in += len;

              return len;
            }


            /* ===========================================================================
             * Set match_start to the longest match starting at the given string and
             * return its length. Matches shorter or equal to prev_length are discarded,
             * in which case the result is equal to prev_length and match_start is
             * garbage.
             * IN assertions: cur_match is the head of the hash chain for the current
             *   string (strstart) and its distance is <= MAX_DIST, and prev_length >= 1
             * OUT assertion: the match length is not greater than s->lookahead.
             */
            function longest_match(s, cur_match) {
              var chain_length = s.max_chain_length; /* max hash chain length */
              var scan = s.strstart; /* current string */
              var match; /* matched string */
              var len; /* length of current match */
              var best_len = s.prev_length; /* best match length so far */
              var nice_match = s.nice_match; /* stop if match long enough */
              var limit = (s.strstart > (s.w_size - MIN_LOOKAHEAD)) ?
                s.strstart - (s.w_size - MIN_LOOKAHEAD) : 0 /*NIL*/ ;

              var _win = s.window; // shortcut

              var wmask = s.w_mask;
              var prev = s.prev;

              /* Stop when cur_match becomes <= limit. To simplify the code,
               * we prevent matches with the string of window index 0.
               */

              var strend = s.strstart + MAX_MATCH;
              var scan_end1 = _win[scan + best_len - 1];
              var scan_end = _win[scan + best_len];

              /* The code is optimized for HASH_BITS >= 8 and MAX_MATCH-2 multiple of 16.
               * It is easy to get rid of this optimization if necessary.
               */
              // Assert(s->hash_bits >= 8 && MAX_MATCH == 258, "Code too clever");

              /* Do not waste too much time if we already have a good match: */
              if (s.prev_length >= s.good_match) {
                chain_length >>= 2;
              }
              /* Do not look for matches beyond the end of the input. This is necessary
               * to make deflate deterministic.
               */
              if (nice_match > s.lookahead) {
                nice_match = s.lookahead;
              }

              // Assert((ulg)s->strstart <= s->window_size-MIN_LOOKAHEAD, "need lookahead");

              do {
                // Assert(cur_match < s->strstart, "no future");
                match = cur_match;

                /* Skip to next match if the match length cannot increase
                 * or if the match length is less than 2.  Note that the checks below
                 * for insufficient lookahead only occur occasionally for performance
                 * reasons.  Therefore uninitialized memory will be accessed, and
                 * conditional jumps will be made that depend on those values.
                 * However the length of the match is limited to the lookahead, so
                 * the output of deflate is not affected by the uninitialized values.
                 */

                if (_win[match + best_len] !== scan_end ||
                  _win[match + best_len - 1] !== scan_end1 ||
                  _win[match] !== _win[scan] ||
                  _win[++match] !== _win[scan + 1]) {
                  continue;
                }

                /* The check at best_len-1 can be removed because it will be made
                 * again later. (This heuristic is not always a win.)
                 * It is not necessary to compare scan[2] and match[2] since they
                 * are always equal when the other bytes match, given that
                 * the hash keys are equal and that HASH_BITS >= 8.
                 */
                scan += 2;
                match++;
                // Assert(*scan == *match, "match[2]?");

                /* We check for insufficient lookahead only every 8th comparison;
                 * the 256th check will be made at strstart+258.
                 */
                do {
                  /*jshint noempty:false*/
                } while (_win[++scan] === _win[++match] && _win[++scan] === _win[++match] &&
                  _win[++scan] === _win[++match] && _win[++scan] === _win[++match] &&
                  _win[++scan] === _win[++match] && _win[++scan] === _win[++match] &&
                  _win[++scan] === _win[++match] && _win[++scan] === _win[++match] &&
                  scan < strend);

                // Assert(scan <= s->window+(unsigned)(s->window_size-1), "wild scan");

                len = MAX_MATCH - (strend - scan);
                scan = strend - MAX_MATCH;

                if (len > best_len) {
                  s.match_start = cur_match;
                  best_len = len;
                  if (len >= nice_match) {
                    break;
                  }
                  scan_end1 = _win[scan + best_len - 1];
                  scan_end = _win[scan + best_len];
                }
              } while ((cur_match = prev[cur_match & wmask]) > limit && --chain_length !== 0);

              if (best_len <= s.lookahead) {
                return best_len;
              }
              return s.lookahead;
            }


            /* ===========================================================================
             * Fill the window when the lookahead becomes insufficient.
             * Updates strstart and lookahead.
             *
             * IN assertion: lookahead < MIN_LOOKAHEAD
             * OUT assertions: strstart <= window_size-MIN_LOOKAHEAD
             *    At least one byte has been read, or avail_in == 0; reads are
             *    performed for at least two bytes (required for the zip translate_eol
             *    option -- not supported here).
             */
            function fill_window(s) {
              var _w_size = s.w_size;
              var p, n, m, more, str;

              //Assert(s->lookahead < MIN_LOOKAHEAD, "already enough lookahead");

              do {
                more = s.window_size - s.lookahead - s.strstart;

                // JS ints have 32 bit, block below not needed
                /* Deal with !@#$% 64K limit: */
                //if (sizeof(int) <= 2) {
                //    if (more == 0 && s->strstart == 0 && s->lookahead == 0) {
                //        more = wsize;
                //
                //  } else if (more == (unsigned)(-1)) {
                //        /* Very unlikely, but possible on 16 bit machine if
                //         * strstart == 0 && lookahead == 1 (input done a byte at time)
                //         */
                //        more--;
                //    }
                //}


                /* If the window is almost full and there is insufficient lookahead,
                 * move the upper half to the lower one to make room in the upper half.
                 */
                if (s.strstart >= _w_size + (_w_size - MIN_LOOKAHEAD)) {

                  arraySet(s.window, s.window, _w_size, _w_size, 0);
                  s.match_start -= _w_size;
                  s.strstart -= _w_size;
                  /* we now have strstart >= MAX_DIST */
                  s.block_start -= _w_size;

                  /* Slide the hash table (could be avoided with 32 bit values
                   at the expense of memory usage). We slide even when level == 0
                   to keep the hash table consistent if we switch back to level > 0
                   later. (Using level 0 permanently is not an optimal usage of
                   zlib, so we don't care about this pathological case.)
                   */

                  n = s.hash_size;
                  p = n;
                  do {
                    m = s.head[--p];
                    s.head[p] = (m >= _w_size ? m - _w_size : 0);
                  } while (--n);

                  n = _w_size;
                  p = n;
                  do {
                    m = s.prev[--p];
                    s.prev[p] = (m >= _w_size ? m - _w_size : 0);
                    /* If n is not on any hash chain, prev[n] is garbage but
                     * its value will never be used.
                     */
                  } while (--n);

                  more += _w_size;
                }
                if (s.strm.avail_in === 0) {
                  break;
                }

                /* If there was no sliding:
                 *    strstart <= WSIZE+MAX_DIST-1 && lookahead <= MIN_LOOKAHEAD - 1 &&
                 *    more == window_size - lookahead - strstart
                 * => more >= window_size - (MIN_LOOKAHEAD-1 + WSIZE + MAX_DIST-1)
                 * => more >= window_size - 2*WSIZE + 2
                 * In the BIG_MEM or MMAP case (not yet supported),
                 *   window_size == input_size + MIN_LOOKAHEAD  &&
                 *   strstart + s->lookahead <= input_size => more >= MIN_LOOKAHEAD.
                 * Otherwise, window_size == 2*WSIZE so more >= 2.
                 * If there was sliding, more >= WSIZE. So in all cases, more >= 2.
                 */
                //Assert(more >= 2, "more < 2");
                n = read_buf(s.strm, s.window, s.strstart + s.lookahead, more);
                s.lookahead += n;

                /* Initialize the hash value now that we have some input: */
                if (s.lookahead + s.insert >= MIN_MATCH) {
                  str = s.strstart - s.insert;
                  s.ins_h = s.window[str];

                  /* UPDATE_HASH(s, s->ins_h, s->window[str + 1]); */
                  s.ins_h = ((s.ins_h << s.hash_shift) ^ s.window[str + 1]) & s.hash_mask;
                  //#if MIN_MATCH != 3
                  //        Call update_hash() MIN_MATCH-3 more times
                  //#endif
                  while (s.insert) {
                    /* UPDATE_HASH(s, s->ins_h, s->window[str + MIN_MATCH-1]); */
                    s.ins_h = ((s.ins_h << s.hash_shift) ^ s.window[str + MIN_MATCH - 1]) & s.hash_mask;

                    s.prev[str & s.w_mask] = s.head[s.ins_h];
                    s.head[s.ins_h] = str;
                    str++;
                    s.insert--;
                    if (s.lookahead + s.insert < MIN_MATCH) {
                      break;
                    }
                  }
                }
                /* If the whole input has less than MIN_MATCH bytes, ins_h is garbage,
                 * but this is not important since only literal bytes will be emitted.
                 */

              } while (s.lookahead < MIN_LOOKAHEAD && s.strm.avail_in !== 0);

              /* If the WIN_INIT bytes after the end of the current data have never been
               * written, then zero those bytes in order to avoid memory check reports of
               * the use of uninitialized (or uninitialised as Julian writes) bytes by
               * the longest match routines.  Update the high water mark for the next
               * time through here.  WIN_INIT is set to MAX_MATCH since the longest match
               * routines allow scanning to strstart + MAX_MATCH, ignoring lookahead.
               */
              //  if (s.high_water < s.window_size) {
              //    var curr = s.strstart + s.lookahead;
              //    var init = 0;
              //
              //    if (s.high_water < curr) {
              //      /* Previous high water mark below current data -- zero WIN_INIT
              //       * bytes or up to end of window, whichever is less.
              //       */
              //      init = s.window_size - curr;
              //      if (init > WIN_INIT)
              //        init = WIN_INIT;
              //      zmemzero(s->window + curr, (unsigned)init);
              //      s->high_water = curr + init;
              //    }
              //    else if (s->high_water < (ulg)curr + WIN_INIT) {
              //      /* High water mark at or above current data, but below current data
              //       * plus WIN_INIT -- zero out to current data plus WIN_INIT, or up
              //       * to end of window, whichever is less.
              //       */
              //      init = (ulg)curr + WIN_INIT - s->high_water;
              //      if (init > s->window_size - s->high_water)
              //        init = s->window_size - s->high_water;
              //      zmemzero(s->window + s->high_water, (unsigned)init);
              //      s->high_water += init;
              //    }
              //  }
              //
              //  Assert((ulg)s->strstart <= s->window_size - MIN_LOOKAHEAD,
              //    "not enough room for search");
            }

            /* ===========================================================================
             * Copy without compression as much as possible from the input stream, return
             * the current block state.
             * This function does not insert new strings in the dictionary since
             * uncompressible data is probably not useful. This function is used
             * only for the level=0 compression option.
             * NOTE: this function should be optimized to avoid extra copying from
             * window to pending_buf.
             */
            function deflate_stored(s, flush) {
              /* Stored blocks are limited to 0xffff bytes, pending_buf is limited
               * to pending_buf_size, and each stored block has a 5 byte header:
               */
              var max_block_size = 0xffff;

              if (max_block_size > s.pending_buf_size - 5) {
                max_block_size = s.pending_buf_size - 5;
              }

              /* Copy as much as possible from input to output: */
              for (;;) {
                /* Fill the window as much as possible: */
                if (s.lookahead <= 1) {

                  //Assert(s->strstart < s->w_size+MAX_DIST(s) ||
                  //  s->block_start >= (long)s->w_size, "slide too late");
                  //      if (!(s.strstart < s.w_size + (s.w_size - MIN_LOOKAHEAD) ||
                  //        s.block_start >= s.w_size)) {
                  //        throw  new Error("slide too late");
                  //      }

                  fill_window(s);
                  if (s.lookahead === 0 && flush === Z_NO_FLUSH$1) {
                    return BS_NEED_MORE;
                  }

                  if (s.lookahead === 0) {
                    break;
                  }
                  /* flush the current block */
                }
                //Assert(s->block_start >= 0L, "block gone");
                //    if (s.block_start < 0) throw new Error("block gone");

                s.strstart += s.lookahead;
                s.lookahead = 0;

                /* Emit a stored block if pending_buf will be full: */
                var max_start = s.block_start + max_block_size;

                if (s.strstart === 0 || s.strstart >= max_start) {
                  /* strstart == 0 is possible when wraparound on 16-bit machine */
                  s.lookahead = s.strstart - max_start;
                  s.strstart = max_start;
                  /*** FLUSH_BLOCK(s, 0); ***/
                  flush_block_only(s, false);
                  if (s.strm.avail_out === 0) {
                    return BS_NEED_MORE;
                  }
                  /***/


                }
                /* Flush if we may have to slide, otherwise block_start may become
                 * negative and the data will be gone:
                 */
                if (s.strstart - s.block_start >= (s.w_size - MIN_LOOKAHEAD)) {
                  /*** FLUSH_BLOCK(s, 0); ***/
                  flush_block_only(s, false);
                  if (s.strm.avail_out === 0) {
                    return BS_NEED_MORE;
                  }
                  /***/
                }
              }

              s.insert = 0;

              if (flush === Z_FINISH$2) {
                /*** FLUSH_BLOCK(s, 1); ***/
                flush_block_only(s, true);
                if (s.strm.avail_out === 0) {
                  return BS_FINISH_STARTED;
                }
                /***/
                return BS_FINISH_DONE;
              }

              if (s.strstart > s.block_start) {
                /*** FLUSH_BLOCK(s, 0); ***/
                flush_block_only(s, false);
                if (s.strm.avail_out === 0) {
                  return BS_NEED_MORE;
                }
                /***/
              }

              return BS_NEED_MORE;
            }

            /* ===========================================================================
             * Compress as much as possible from the input stream, return the current
             * block state.
             * This function does not perform lazy evaluation of matches and inserts
             * new strings in the dictionary only for unmatched strings or for short
             * matches. It is used only for the fast compression options.
             */
            function deflate_fast(s, flush) {
              var hash_head; /* head of the hash chain */
              var bflush; /* set if current block must be flushed */

              for (;;) {
                /* Make sure that we always have enough lookahead, except
                 * at the end of the input file. We need MAX_MATCH bytes
                 * for the next match, plus MIN_MATCH bytes to insert the
                 * string following the next match.
                 */
                if (s.lookahead < MIN_LOOKAHEAD) {
                  fill_window(s);
                  if (s.lookahead < MIN_LOOKAHEAD && flush === Z_NO_FLUSH$1) {
                    return BS_NEED_MORE;
                  }
                  if (s.lookahead === 0) {
                    break; /* flush the current block */
                  }
                }

                /* Insert the string window[strstart .. strstart+2] in the
                 * dictionary, and set hash_head to the head of the hash chain:
                 */
                hash_head = 0 /*NIL*/ ;
                if (s.lookahead >= MIN_MATCH) {
                  /*** INSERT_STRING(s, s.strstart, hash_head); ***/
                  s.ins_h = ((s.ins_h << s.hash_shift) ^ s.window[s.strstart + MIN_MATCH - 1]) & s.hash_mask;
                  hash_head = s.prev[s.strstart & s.w_mask] = s.head[s.ins_h];
                  s.head[s.ins_h] = s.strstart;
                  /***/
                }

                /* Find the longest match, discarding those <= prev_length.
                 * At this point we have always match_length < MIN_MATCH
                 */
                if (hash_head !== 0 /*NIL*/ && ((s.strstart - hash_head) <= (s.w_size - MIN_LOOKAHEAD))) {
                  /* To simplify the code, we prevent matches with the string
                   * of window index 0 (in particular we have to avoid a match
                   * of the string with itself at the start of the input file).
                   */
                  s.match_length = longest_match(s, hash_head);
                  /* longest_match() sets match_start */
                }
                if (s.match_length >= MIN_MATCH) {
                  // check_match(s, s.strstart, s.match_start, s.match_length); // for debug only

                  /*** _tr_tally_dist(s, s.strstart - s.match_start,
                                 s.match_length - MIN_MATCH, bflush); ***/
                  bflush = _tr_tally(s, s.strstart - s.match_start, s.match_length - MIN_MATCH);

                  s.lookahead -= s.match_length;

                  /* Insert new strings in the hash table only if the match length
                   * is not too large. This saves time but degrades compression.
                   */
                  if (s.match_length <= s.max_lazy_match /*max_insert_length*/ && s.lookahead >= MIN_MATCH) {
                    s.match_length--; /* string at strstart already in table */
                    do {
                      s.strstart++;
                      /*** INSERT_STRING(s, s.strstart, hash_head); ***/
                      s.ins_h = ((s.ins_h << s.hash_shift) ^ s.window[s.strstart + MIN_MATCH - 1]) & s.hash_mask;
                      hash_head = s.prev[s.strstart & s.w_mask] = s.head[s.ins_h];
                      s.head[s.ins_h] = s.strstart;
                      /***/
                      /* strstart never exceeds WSIZE-MAX_MATCH, so there are
                       * always MIN_MATCH bytes ahead.
                       */
                    } while (--s.match_length !== 0);
                    s.strstart++;
                  } else {
                    s.strstart += s.match_length;
                    s.match_length = 0;
                    s.ins_h = s.window[s.strstart];
                    /* UPDATE_HASH(s, s.ins_h, s.window[s.strstart+1]); */
                    s.ins_h = ((s.ins_h << s.hash_shift) ^ s.window[s.strstart + 1]) & s.hash_mask;

                    //#if MIN_MATCH != 3
                    //                Call UPDATE_HASH() MIN_MATCH-3 more times
                    //#endif
                    /* If lookahead < MIN_MATCH, ins_h is garbage, but it does not
                     * matter since it will be recomputed at next deflate call.
                     */
                  }
                } else {
                  /* No match, output a literal byte */
                  //Tracevv((stderr,"%c", s.window[s.strstart]));
                  /*** _tr_tally_lit(s, s.window[s.strstart], bflush); ***/
                  bflush = _tr_tally(s, 0, s.window[s.strstart]);

                  s.lookahead--;
                  s.strstart++;
                }
                if (bflush) {
                  /*** FLUSH_BLOCK(s, 0); ***/
                  flush_block_only(s, false);
                  if (s.strm.avail_out === 0) {
                    return BS_NEED_MORE;
                  }
                  /***/
                }
              }
              s.insert = ((s.strstart < (MIN_MATCH - 1)) ? s.strstart : MIN_MATCH - 1);
              if (flush === Z_FINISH$2) {
                /*** FLUSH_BLOCK(s, 1); ***/
                flush_block_only(s, true);
                if (s.strm.avail_out === 0) {
                  return BS_FINISH_STARTED;
                }
                /***/
                return BS_FINISH_DONE;
              }
              if (s.last_lit) {
                /*** FLUSH_BLOCK(s, 0); ***/
                flush_block_only(s, false);
                if (s.strm.avail_out === 0) {
                  return BS_NEED_MORE;
                }
                /***/
              }
              return BS_BLOCK_DONE;
            }

            /* ===========================================================================
             * Same as above, but achieves better compression. We use a lazy
             * evaluation for matches: a match is finally adopted only if there is
             * no better match at the next window position.
             */
            function deflate_slow(s, flush) {
              var hash_head; /* head of hash chain */
              var bflush; /* set if current block must be flushed */

              var max_insert;

              /* Process the input block. */
              for (;;) {
                /* Make sure that we always have enough lookahead, except
                 * at the end of the input file. We need MAX_MATCH bytes
                 * for the next match, plus MIN_MATCH bytes to insert the
                 * string following the next match.
                 */
                if (s.lookahead < MIN_LOOKAHEAD) {
                  fill_window(s);
                  if (s.lookahead < MIN_LOOKAHEAD && flush === Z_NO_FLUSH$1) {
                    return BS_NEED_MORE;
                  }
                  if (s.lookahead === 0) {
                    break;
                  } /* flush the current block */
                }

                /* Insert the string window[strstart .. strstart+2] in the
                 * dictionary, and set hash_head to the head of the hash chain:
                 */
                hash_head = 0 /*NIL*/ ;
                if (s.lookahead >= MIN_MATCH) {
                  /*** INSERT_STRING(s, s.strstart, hash_head); ***/
                  s.ins_h = ((s.ins_h << s.hash_shift) ^ s.window[s.strstart + MIN_MATCH - 1]) & s.hash_mask;
                  hash_head = s.prev[s.strstart & s.w_mask] = s.head[s.ins_h];
                  s.head[s.ins_h] = s.strstart;
                  /***/
                }

                /* Find the longest match, discarding those <= prev_length.
                 */
                s.prev_length = s.match_length;
                s.prev_match = s.match_start;
                s.match_length = MIN_MATCH - 1;

                if (hash_head !== 0 /*NIL*/ && s.prev_length < s.max_lazy_match &&
                  s.strstart - hash_head <= (s.w_size - MIN_LOOKAHEAD) /*MAX_DIST(s)*/ ) {
                  /* To simplify the code, we prevent matches with the string
                   * of window index 0 (in particular we have to avoid a match
                   * of the string with itself at the start of the input file).
                   */
                  s.match_length = longest_match(s, hash_head);
                  /* longest_match() sets match_start */

                  if (s.match_length <= 5 &&
                    (s.strategy === Z_FILTERED$1 || (s.match_length === MIN_MATCH && s.strstart - s.match_start > 4096 /*TOO_FAR*/ ))) {

                    /* If prev_match is also MIN_MATCH, match_start is garbage
                     * but we will ignore the current match anyway.
                     */
                    s.match_length = MIN_MATCH - 1;
                  }
                }
                /* If there was a match at the previous step and the current
                 * match is not better, output the previous match:
                 */
                if (s.prev_length >= MIN_MATCH && s.match_length <= s.prev_length) {
                  max_insert = s.strstart + s.lookahead - MIN_MATCH;
                  /* Do not insert strings in hash table beyond this. */

                  //check_match(s, s.strstart-1, s.prev_match, s.prev_length);

                  /***_tr_tally_dist(s, s.strstart - 1 - s.prev_match,
                                 s.prev_length - MIN_MATCH, bflush);***/
                  bflush = _tr_tally(s, s.strstart - 1 - s.prev_match, s.prev_length - MIN_MATCH);
                  /* Insert in hash table all strings up to the end of the match.
                   * strstart-1 and strstart are already inserted. If there is not
                   * enough lookahead, the last two strings are not inserted in
                   * the hash table.
                   */
                  s.lookahead -= s.prev_length - 1;
                  s.prev_length -= 2;
                  do {
                    if (++s.strstart <= max_insert) {
                      /*** INSERT_STRING(s, s.strstart, hash_head); ***/
                      s.ins_h = ((s.ins_h << s.hash_shift) ^ s.window[s.strstart + MIN_MATCH - 1]) & s.hash_mask;
                      hash_head = s.prev[s.strstart & s.w_mask] = s.head[s.ins_h];
                      s.head[s.ins_h] = s.strstart;
                      /***/
                    }
                  } while (--s.prev_length !== 0);
                  s.match_available = 0;
                  s.match_length = MIN_MATCH - 1;
                  s.strstart++;

                  if (bflush) {
                    /*** FLUSH_BLOCK(s, 0); ***/
                    flush_block_only(s, false);
                    if (s.strm.avail_out === 0) {
                      return BS_NEED_MORE;
                    }
                    /***/
                  }

                } else if (s.match_available) {
                  /* If there was no match at the previous position, output a
                   * single literal. If there was a match but the current match
                   * is longer, truncate the previous match to a single literal.
                   */
                  //Tracevv((stderr,"%c", s->window[s->strstart-1]));
                  /*** _tr_tally_lit(s, s.window[s.strstart-1], bflush); ***/
                  bflush = _tr_tally(s, 0, s.window[s.strstart - 1]);

                  if (bflush) {
                    /*** FLUSH_BLOCK_ONLY(s, 0) ***/
                    flush_block_only(s, false);
                    /***/
                  }
                  s.strstart++;
                  s.lookahead--;
                  if (s.strm.avail_out === 0) {
                    return BS_NEED_MORE;
                  }
                } else {
                  /* There is no previous match to compare with, wait for
                   * the next step to decide.
                   */
                  s.match_available = 1;
                  s.strstart++;
                  s.lookahead--;
                }
              }
              //Assert (flush != Z_NO_FLUSH, "no flush?");
              if (s.match_available) {
                //Tracevv((stderr,"%c", s->window[s->strstart-1]));
                /*** _tr_tally_lit(s, s.window[s.strstart-1], bflush); ***/
                bflush = _tr_tally(s, 0, s.window[s.strstart - 1]);

                s.match_available = 0;
              }
              s.insert = s.strstart < MIN_MATCH - 1 ? s.strstart : MIN_MATCH - 1;
              if (flush === Z_FINISH$2) {
                /*** FLUSH_BLOCK(s, 1); ***/
                flush_block_only(s, true);
                if (s.strm.avail_out === 0) {
                  return BS_FINISH_STARTED;
                }
                /***/
                return BS_FINISH_DONE;
              }
              if (s.last_lit) {
                /*** FLUSH_BLOCK(s, 0); ***/
                flush_block_only(s, false);
                if (s.strm.avail_out === 0) {
                  return BS_NEED_MORE;
                }
                /***/
              }

              return BS_BLOCK_DONE;
            }


            /* ===========================================================================
             * For Z_RLE, simply look for runs of bytes, generate matches only of distance
             * one.  Do not maintain a hash table.  (It will be regenerated if this run of
             * deflate switches away from Z_RLE.)
             */
            function deflate_rle(s, flush) {
              var bflush; /* set if current block must be flushed */
              var prev; /* byte at distance one to match */
              var scan, strend; /* scan goes up to strend for length of run */

              var _win = s.window;

              for (;;) {
                /* Make sure that we always have enough lookahead, except
                 * at the end of the input file. We need MAX_MATCH bytes
                 * for the longest run, plus one for the unrolled loop.
                 */
                if (s.lookahead <= MAX_MATCH) {
                  fill_window(s);
                  if (s.lookahead <= MAX_MATCH && flush === Z_NO_FLUSH$1) {
                    return BS_NEED_MORE;
                  }
                  if (s.lookahead === 0) {
                    break;
                  } /* flush the current block */
                }

                /* See how many times the previous byte repeats */
                s.match_length = 0;
                if (s.lookahead >= MIN_MATCH && s.strstart > 0) {
                  scan = s.strstart - 1;
                  prev = _win[scan];
                  if (prev === _win[++scan] && prev === _win[++scan] && prev === _win[++scan]) {
                    strend = s.strstart + MAX_MATCH;
                    do {
                      /*jshint noempty:false*/
                    } while (prev === _win[++scan] && prev === _win[++scan] &&
                      prev === _win[++scan] && prev === _win[++scan] &&
                      prev === _win[++scan] && prev === _win[++scan] &&
                      prev === _win[++scan] && prev === _win[++scan] &&
                      scan < strend);
                    s.match_length = MAX_MATCH - (strend - scan);
                    if (s.match_length > s.lookahead) {
                      s.match_length = s.lookahead;
                    }
                  }
                  //Assert(scan <= s->window+(uInt)(s->window_size-1), "wild scan");
                }

                /* Emit match if have run of MIN_MATCH or longer, else emit literal */
                if (s.match_length >= MIN_MATCH) {
                  //check_match(s, s.strstart, s.strstart - 1, s.match_length);

                  /*** _tr_tally_dist(s, 1, s.match_length - MIN_MATCH, bflush); ***/
                  bflush = _tr_tally(s, 1, s.match_length - MIN_MATCH);

                  s.lookahead -= s.match_length;
                  s.strstart += s.match_length;
                  s.match_length = 0;
                } else {
                  /* No match, output a literal byte */
                  //Tracevv((stderr,"%c", s->window[s->strstart]));
                  /*** _tr_tally_lit(s, s.window[s.strstart], bflush); ***/
                  bflush = _tr_tally(s, 0, s.window[s.strstart]);

                  s.lookahead--;
                  s.strstart++;
                }
                if (bflush) {
                  /*** FLUSH_BLOCK(s, 0); ***/
                  flush_block_only(s, false);
                  if (s.strm.avail_out === 0) {
                    return BS_NEED_MORE;
                  }
                  /***/
                }
              }
              s.insert = 0;
              if (flush === Z_FINISH$2) {
                /*** FLUSH_BLOCK(s, 1); ***/
                flush_block_only(s, true);
                if (s.strm.avail_out === 0) {
                  return BS_FINISH_STARTED;
                }
                /***/
                return BS_FINISH_DONE;
              }
              if (s.last_lit) {
                /*** FLUSH_BLOCK(s, 0); ***/
                flush_block_only(s, false);
                if (s.strm.avail_out === 0) {
                  return BS_NEED_MORE;
                }
                /***/
              }
              return BS_BLOCK_DONE;
            }

            /* ===========================================================================
             * For Z_HUFFMAN_ONLY, do not look for matches.  Do not maintain a hash table.
             * (It will be regenerated if this run of deflate switches away from Huffman.)
             */
            function deflate_huff(s, flush) {
              var bflush; /* set if current block must be flushed */

              for (;;) {
                /* Make sure that we have a literal to write. */
                if (s.lookahead === 0) {
                  fill_window(s);
                  if (s.lookahead === 0) {
                    if (flush === Z_NO_FLUSH$1) {
                      return BS_NEED_MORE;
                    }
                    break; /* flush the current block */
                  }
                }

                /* Output a literal byte */
                s.match_length = 0;
                //Tracevv((stderr,"%c", s->window[s->strstart]));
                /*** _tr_tally_lit(s, s.window[s.strstart], bflush); ***/
                bflush = _tr_tally(s, 0, s.window[s.strstart]);
                s.lookahead--;
                s.strstart++;
                if (bflush) {
                  /*** FLUSH_BLOCK(s, 0); ***/
                  flush_block_only(s, false);
                  if (s.strm.avail_out === 0) {
                    return BS_NEED_MORE;
                  }
                  /***/
                }
              }
              s.insert = 0;
              if (flush === Z_FINISH$2) {
                /*** FLUSH_BLOCK(s, 1); ***/
                flush_block_only(s, true);
                if (s.strm.avail_out === 0) {
                  return BS_FINISH_STARTED;
                }
                /***/
                return BS_FINISH_DONE;
              }
              if (s.last_lit) {
                /*** FLUSH_BLOCK(s, 0); ***/
                flush_block_only(s, false);
                if (s.strm.avail_out === 0) {
                  return BS_NEED_MORE;
                }
                /***/
              }
              return BS_BLOCK_DONE;
            }

            /* Values for max_lazy_match, good_match and max_chain_length, depending on
             * the desired pack level (0..9). The values given below have been tuned to
             * exclude worst case performance for pathological files. Better values may be
             * found for specific files.
             */
            function Config(good_length, max_lazy, nice_length, max_chain, func) {
              this.good_length = good_length;
              this.max_lazy = max_lazy;
              this.nice_length = nice_length;
              this.max_chain = max_chain;
              this.func = func;
            }

            var configuration_table;

            configuration_table = [
              /*      good lazy nice chain */
              new Config(0, 0, 0, 0, deflate_stored), /* 0 store only */
              new Config(4, 4, 8, 4, deflate_fast), /* 1 max speed, no lazy matches */
              new Config(4, 5, 16, 8, deflate_fast), /* 2 */
              new Config(4, 6, 32, 32, deflate_fast), /* 3 */

              new Config(4, 4, 16, 16, deflate_slow), /* 4 lazy matches */
              new Config(8, 16, 32, 32, deflate_slow), /* 5 */
              new Config(8, 16, 128, 128, deflate_slow), /* 6 */
              new Config(8, 32, 128, 256, deflate_slow), /* 7 */
              new Config(32, 128, 258, 1024, deflate_slow), /* 8 */
              new Config(32, 258, 258, 4096, deflate_slow) /* 9 max compression */
            ];


            /* ===========================================================================
             * Initialize the "longest match" routines for a new zlib stream
             */
            function lm_init(s) {
              s.window_size = 2 * s.w_size;

              /*** CLEAR_HASH(s); ***/
              zero(s.head); // Fill with NIL (= 0);

              /* Set the default configuration parameters:
               */
              s.max_lazy_match = configuration_table[s.level].max_lazy;
              s.good_match = configuration_table[s.level].good_length;
              s.nice_match = configuration_table[s.level].nice_length;
              s.max_chain_length = configuration_table[s.level].max_chain;

              s.strstart = 0;
              s.block_start = 0;
              s.lookahead = 0;
              s.insert = 0;
              s.match_length = s.prev_length = MIN_MATCH - 1;
              s.match_available = 0;
              s.ins_h = 0;
            }


            function DeflateState() {
              this.strm = null; /* pointer back to this zlib stream */
              this.status = 0; /* as the name implies */
              this.pending_buf = null; /* output still pending */
              this.pending_buf_size = 0; /* size of pending_buf */
              this.pending_out = 0; /* next pending byte to output to the stream */
              this.pending = 0; /* nb of bytes in the pending buffer */
              this.wrap = 0; /* bit 0 true for zlib, bit 1 true for gzip */
              this.gzhead = null; /* gzip header information to write */
              this.gzindex = 0; /* where in extra, name, or comment */
              this.method = Z_DEFLATED$2; /* can only be DEFLATED */
              this.last_flush = -1; /* value of flush param for previous deflate call */

              this.w_size = 0; /* LZ77 window size (32K by default) */
              this.w_bits = 0; /* log2(w_size)  (8..16) */
              this.w_mask = 0; /* w_size - 1 */

              this.window = null;
              /* Sliding window. Input bytes are read into the second half of the window,
               * and move to the first half later to keep a dictionary of at least wSize
               * bytes. With this organization, matches are limited to a distance of
               * wSize-MAX_MATCH bytes, but this ensures that IO is always
               * performed with a length multiple of the block size.
               */

              this.window_size = 0;
              /* Actual size of window: 2*wSize, except when the user input buffer
               * is directly used as sliding window.
               */

              this.prev = null;
              /* Link to older string with same hash index. To limit the size of this
               * array to 64K, this link is maintained only for the last 32K strings.
               * An index in this array is thus a window index modulo 32K.
               */

              this.head = null; /* Heads of the hash chains or NIL. */

              this.ins_h = 0; /* hash index of string to be inserted */
              this.hash_size = 0; /* number of elements in hash table */
              this.hash_bits = 0; /* log2(hash_size) */
              this.hash_mask = 0; /* hash_size-1 */

              this.hash_shift = 0;
              /* Number of bits by which ins_h must be shifted at each input
               * step. It must be such that after MIN_MATCH steps, the oldest
               * byte no longer takes part in the hash key, that is:
               *   hash_shift * MIN_MATCH >= hash_bits
               */

              this.block_start = 0;
              /* Window position at the beginning of the current output block. Gets
               * negative when the window is moved backwards.
               */

              this.match_length = 0; /* length of best match */
              this.prev_match = 0; /* previous match */
              this.match_available = 0; /* set if previous match exists */
              this.strstart = 0; /* start of string to insert */
              this.match_start = 0; /* start of matching string */
              this.lookahead = 0; /* number of valid bytes ahead in window */

              this.prev_length = 0;
              /* Length of the best match at previous step. Matches not greater than this
               * are discarded. This is used in the lazy match evaluation.
               */

              this.max_chain_length = 0;
              /* To speed up deflation, hash chains are never searched beyond this
               * length.  A higher limit improves compression ratio but degrades the
               * speed.
               */

              this.max_lazy_match = 0;
              /* Attempt to find a better match only when the current match is strictly
               * smaller than this value. This mechanism is used only for compression
               * levels >= 4.
               */
              // That's alias to max_lazy_match, don't use directly
              //this.max_insert_length = 0;
              /* Insert new strings in the hash table only if the match length is not
               * greater than this length. This saves time but degrades compression.
               * max_insert_length is used only for compression levels <= 3.
               */

              this.level = 0; /* compression level (1..9) */
              this.strategy = 0; /* favor or force Huffman coding*/

              this.good_match = 0;
              /* Use a faster search when the previous match is longer than this */

              this.nice_match = 0; /* Stop searching when current match exceeds this */

              /* used by c: */

              /* Didn't use ct_data typedef below to suppress compiler warning */

              // struct ct_data_s dyn_ltree[HEAP_SIZE];   /* literal and length tree */
              // struct ct_data_s dyn_dtree[2*D_CODES+1]; /* distance tree */
              // struct ct_data_s bl_tree[2*BL_CODES+1];  /* Huffman tree for bit lengths */

              // Use flat array of DOUBLE size, with interleaved fata,
              // because JS does not support effective
              this.dyn_ltree = new Buf16(HEAP_SIZE * 2);
              this.dyn_dtree = new Buf16((2 * D_CODES + 1) * 2);
              this.bl_tree = new Buf16((2 * BL_CODES + 1) * 2);
              zero(this.dyn_ltree);
              zero(this.dyn_dtree);
              zero(this.bl_tree);

              this.l_desc = null; /* desc. for literal tree */
              this.d_desc = null; /* desc. for distance tree */
              this.bl_desc = null; /* desc. for bit length tree */

              //ush bl_count[MAX_BITS+1];
              this.bl_count = new Buf16(MAX_BITS + 1);
              /* number of codes at each bit length for an optimal tree */

              //int heap[2*L_CODES+1];      /* heap used to build the Huffman trees */
              this.heap = new Buf16(2 * L_CODES + 1); /* heap used to build the Huffman trees */
              zero(this.heap);

              this.heap_len = 0; /* number of elements in the heap */
              this.heap_max = 0; /* element of largest frequency */
              /* The sons of heap[n] are heap[2*n] and heap[2*n+1]. heap[0] is not used.
               * The same heap array is used to build all
               */

              this.depth = new Buf16(2 * L_CODES + 1); //uch depth[2*L_CODES+1];
              zero(this.depth);
              /* Depth of each subtree used as tie breaker for trees of equal frequency
               */

              this.l_buf = 0; /* buffer index for literals or lengths */

              this.lit_bufsize = 0;
              /* Size of match buffer for literals/lengths.  There are 4 reasons for
               * limiting lit_bufsize to 64K:
               *   - frequencies can be kept in 16 bit counters
               *   - if compression is not successful for the first block, all input
               *     data is still in the window so we can still emit a stored block even
               *     when input comes from standard input.  (This can also be done for
               *     all blocks if lit_bufsize is not greater than 32K.)
               *   - if compression is not successful for a file smaller than 64K, we can
               *     even emit a stored file instead of a stored block (saving 5 bytes).
               *     This is applicable only for zip (not gzip or zlib).
               *   - creating new Huffman trees less frequently may not provide fast
               *     adaptation to changes in the input data statistics. (Take for
               *     example a binary file with poorly compressible code followed by
               *     a highly compressible string table.) Smaller buffer sizes give
               *     fast adaptation but have of course the overhead of transmitting
               *     trees more frequently.
               *   - I can't count above 4
               */

              this.last_lit = 0; /* running index in l_buf */

              this.d_buf = 0;
              /* Buffer index for distances. To simplify the code, d_buf and l_buf have
               * the same number of elements. To use different lengths, an extra flag
               * array would be necessary.
               */

              this.opt_len = 0; /* bit length of current block with optimal trees */
              this.static_len = 0; /* bit length of current block with static trees */
              this.matches = 0; /* number of string matches in current block */
              this.insert = 0; /* bytes at end of window left to insert */


              this.bi_buf = 0;
              /* Output buffer. bits are inserted starting at the bottom (least
               * significant bits).
               */
              this.bi_valid = 0;
              /* Number of valid bits in bi_buf.  All bits above the last valid bit
               * are always zero.
               */

              // Used for window memory init. We safely ignore it for JS. That makes
              // sense only for pointers and memory check tools.
              //this.high_water = 0;
              /* High water mark offset in window for initialized bytes -- bytes above
               * this are set to zero in order to avoid memory check warnings when
               * longest match routines access bytes past the input.  This is then
               * updated to the new high water mark.
               */
            }


            function deflateResetKeep(strm) {
              var s;

              if (!strm || !strm.state) {
                return err(strm, Z_STREAM_ERROR$2);
              }

              strm.total_in = strm.total_out = 0;
              strm.data_type = Z_UNKNOWN$1;

              s = strm.state;
              s.pending = 0;
              s.pending_out = 0;

              if (s.wrap < 0) {
                s.wrap = -s.wrap;
                /* was made negative by deflate(..., Z_FINISH); */
              }
              s.status = (s.wrap ? INIT_STATE : BUSY_STATE);
              strm.adler = (s.wrap === 2) ?
                0 // crc32(0, Z_NULL, 0)
                :
                1; // adler32(0, Z_NULL, 0)
              s.last_flush = Z_NO_FLUSH$1;
              _tr_init(s);
              return Z_OK$2;
            }


            function deflateReset(strm) {
              var ret = deflateResetKeep(strm);
              if (ret === Z_OK$2) {
                lm_init(strm.state);
              }
              return ret;
            }


            function deflateInit2(strm, level, method, windowBits, memLevel, strategy) {
              if (!strm) { // === Z_NULL
                return Z_STREAM_ERROR$2;
              }
              var wrap = 1;

              if (level === Z_DEFAULT_COMPRESSION$1) {
                level = 6;
              }

              if (windowBits < 0) { /* suppress zlib wrapper */
                wrap = 0;
                windowBits = -windowBits;
              } else if (windowBits > 15) {
                wrap = 2; /* write gzip wrapper instead */
                windowBits -= 16;
              }


              if (memLevel < 1 || memLevel > MAX_MEM_LEVEL || method !== Z_DEFLATED$2 ||
                windowBits < 8 || windowBits > 15 || level < 0 || level > 9 ||
                strategy < 0 || strategy > Z_FIXED$1) {
                return err(strm, Z_STREAM_ERROR$2);
              }


              if (windowBits === 8) {
                windowBits = 9;
              }
              /* until 256-byte window bug fixed */

              var s = new DeflateState();

              strm.state = s;
              s.strm = strm;

              s.wrap = wrap;
              s.gzhead = null;
              s.w_bits = windowBits;
              s.w_size = 1 << s.w_bits;
              s.w_mask = s.w_size - 1;

              s.hash_bits = memLevel + 7;
              s.hash_size = 1 << s.hash_bits;
              s.hash_mask = s.hash_size - 1;
              s.hash_shift = ~~((s.hash_bits + MIN_MATCH - 1) / MIN_MATCH);

              s.window = new Buf8(s.w_size * 2);
              s.head = new Buf16(s.hash_size);
              s.prev = new Buf16(s.w_size);

              // Don't need mem init magic for JS.
              //s.high_water = 0;  /* nothing written to s->window yet */

              s.lit_bufsize = 1 << (memLevel + 6); /* 16K elements by default */

              s.pending_buf_size = s.lit_bufsize * 4;

              //overlay = (ushf *) ZALLOC(strm, s->lit_bufsize, sizeof(ush)+2);
              //s->pending_buf = (uchf *) overlay;
              s.pending_buf = new Buf8(s.pending_buf_size);

              // It is offset from `s.pending_buf` (size is `s.lit_bufsize * 2`)
              //s->d_buf = overlay + s->lit_bufsize/sizeof(ush);
              s.d_buf = 1 * s.lit_bufsize;

              //s->l_buf = s->pending_buf + (1+sizeof(ush))*s->lit_bufsize;
              s.l_buf = (1 + 2) * s.lit_bufsize;

              s.level = level;
              s.strategy = strategy;
              s.method = method;

              return deflateReset(strm);
            }


            function deflate$1(strm, flush) {
              var old_flush, s;
              var beg, val; // for gzip header write only

              if (!strm || !strm.state ||
                flush > Z_BLOCK$2 || flush < 0) {
                return strm ? err(strm, Z_STREAM_ERROR$2) : Z_STREAM_ERROR$2;
              }

              s = strm.state;

              if (!strm.output ||
                (!strm.input && strm.avail_in !== 0) ||
                (s.status === FINISH_STATE && flush !== Z_FINISH$2)) {
                return err(strm, (strm.avail_out === 0) ? Z_BUF_ERROR$2 : Z_STREAM_ERROR$2);
              }

              s.strm = strm; /* just in case */
              old_flush = s.last_flush;
              s.last_flush = flush;

              /* Write the header */
              if (s.status === INIT_STATE) {
                if (s.wrap === 2) {
                  // GZIP header
                  strm.adler = 0; //crc32(0L, Z_NULL, 0);
                  put_byte(s, 31);
                  put_byte(s, 139);
                  put_byte(s, 8);
                  if (!s.gzhead) { // s->gzhead == Z_NULL
                    put_byte(s, 0);
                    put_byte(s, 0);
                    put_byte(s, 0);
                    put_byte(s, 0);
                    put_byte(s, 0);
                    put_byte(s, s.level === 9 ? 2 :
                      (s.strategy >= Z_HUFFMAN_ONLY$1 || s.level < 2 ?
                        4 : 0));
                    put_byte(s, OS_CODE);
                    s.status = BUSY_STATE;
                  } else {
                    put_byte(s, (s.gzhead.text ? 1 : 0) +
                      (s.gzhead.hcrc ? 2 : 0) +
                      (!s.gzhead.extra ? 0 : 4) +
                      (!s.gzhead.name ? 0 : 8) +
                      (!s.gzhead.comment ? 0 : 16)
                    );
                    put_byte(s, s.gzhead.time & 0xff);
                    put_byte(s, (s.gzhead.time >> 8) & 0xff);
                    put_byte(s, (s.gzhead.time >> 16) & 0xff);
                    put_byte(s, (s.gzhead.time >> 24) & 0xff);
                    put_byte(s, s.level === 9 ? 2 :
                      (s.strategy >= Z_HUFFMAN_ONLY$1 || s.level < 2 ?
                        4 : 0));
                    put_byte(s, s.gzhead.os & 0xff);
                    if (s.gzhead.extra && s.gzhead.extra.length) {
                      put_byte(s, s.gzhead.extra.length & 0xff);
                      put_byte(s, (s.gzhead.extra.length >> 8) & 0xff);
                    }
                    if (s.gzhead.hcrc) {
                      strm.adler = crc32(strm.adler, s.pending_buf, s.pending, 0);
                    }
                    s.gzindex = 0;
                    s.status = EXTRA_STATE;
                  }
                } else // DEFLATE header
                {
                  var header = (Z_DEFLATED$2 + ((s.w_bits - 8) << 4)) << 8;
                  var level_flags = -1;

                  if (s.strategy >= Z_HUFFMAN_ONLY$1 || s.level < 2) {
                    level_flags = 0;
                  } else if (s.level < 6) {
                    level_flags = 1;
                  } else if (s.level === 6) {
                    level_flags = 2;
                  } else {
                    level_flags = 3;
                  }
                  header |= (level_flags << 6);
                  if (s.strstart !== 0) {
                    header |= PRESET_DICT;
                  }
                  header += 31 - (header % 31);

                  s.status = BUSY_STATE;
                  putShortMSB(s, header);

                  /* Save the adler32 of the preset dictionary: */
                  if (s.strstart !== 0) {
                    putShortMSB(s, strm.adler >>> 16);
                    putShortMSB(s, strm.adler & 0xffff);
                  }
                  strm.adler = 1; // adler32(0L, Z_NULL, 0);
                }
              }

              //#ifdef GZIP
              if (s.status === EXTRA_STATE) {
                if (s.gzhead.extra /* != Z_NULL*/ ) {
                  beg = s.pending; /* start of bytes to update crc */

                  while (s.gzindex < (s.gzhead.extra.length & 0xffff)) {
                    if (s.pending === s.pending_buf_size) {
                      if (s.gzhead.hcrc && s.pending > beg) {
                        strm.adler = crc32(strm.adler, s.pending_buf, s.pending - beg, beg);
                      }
                      flush_pending(strm);
                      beg = s.pending;
                      if (s.pending === s.pending_buf_size) {
                        break;
                      }
                    }
                    put_byte(s, s.gzhead.extra[s.gzindex] & 0xff);
                    s.gzindex++;
                  }
                  if (s.gzhead.hcrc && s.pending > beg) {
                    strm.adler = crc32(strm.adler, s.pending_buf, s.pending - beg, beg);
                  }
                  if (s.gzindex === s.gzhead.extra.length) {
                    s.gzindex = 0;
                    s.status = NAME_STATE;
                  }
                } else {
                  s.status = NAME_STATE;
                }
              }
              if (s.status === NAME_STATE) {
                if (s.gzhead.name /* != Z_NULL*/ ) {
                  beg = s.pending; /* start of bytes to update crc */
                  //int val;

                  do {
                    if (s.pending === s.pending_buf_size) {
                      if (s.gzhead.hcrc && s.pending > beg) {
                        strm.adler = crc32(strm.adler, s.pending_buf, s.pending - beg, beg);
                      }
                      flush_pending(strm);
                      beg = s.pending;
                      if (s.pending === s.pending_buf_size) {
                        val = 1;
                        break;
                      }
                    }
                    // JS specific: little magic to add zero terminator to end of string
                    if (s.gzindex < s.gzhead.name.length) {
                      val = s.gzhead.name.charCodeAt(s.gzindex++) & 0xff;
                    } else {
                      val = 0;
                    }
                    put_byte(s, val);
                  } while (val !== 0);

                  if (s.gzhead.hcrc && s.pending > beg) {
                    strm.adler = crc32(strm.adler, s.pending_buf, s.pending - beg, beg);
                  }
                  if (val === 0) {
                    s.gzindex = 0;
                    s.status = COMMENT_STATE;
                  }
                } else {
                  s.status = COMMENT_STATE;
                }
              }
              if (s.status === COMMENT_STATE) {
                if (s.gzhead.comment /* != Z_NULL*/ ) {
                  beg = s.pending; /* start of bytes to update crc */
                  //int val;

                  do {
                    if (s.pending === s.pending_buf_size) {
                      if (s.gzhead.hcrc && s.pending > beg) {
                        strm.adler = crc32(strm.adler, s.pending_buf, s.pending - beg, beg);
                      }
                      flush_pending(strm);
                      beg = s.pending;
                      if (s.pending === s.pending_buf_size) {
                        val = 1;
                        break;
                      }
                    }
                    // JS specific: little magic to add zero terminator to end of string
                    if (s.gzindex < s.gzhead.comment.length) {
                      val = s.gzhead.comment.charCodeAt(s.gzindex++) & 0xff;
                    } else {
                      val = 0;
                    }
                    put_byte(s, val);
                  } while (val !== 0);

                  if (s.gzhead.hcrc && s.pending > beg) {
                    strm.adler = crc32(strm.adler, s.pending_buf, s.pending - beg, beg);
                  }
                  if (val === 0) {
                    s.status = HCRC_STATE;
                  }
                } else {
                  s.status = HCRC_STATE;
                }
              }
              if (s.status === HCRC_STATE) {
                if (s.gzhead.hcrc) {
                  if (s.pending + 2 > s.pending_buf_size) {
                    flush_pending(strm);
                  }
                  if (s.pending + 2 <= s.pending_buf_size) {
                    put_byte(s, strm.adler & 0xff);
                    put_byte(s, (strm.adler >> 8) & 0xff);
                    strm.adler = 0; //crc32(0L, Z_NULL, 0);
                    s.status = BUSY_STATE;
                  }
                } else {
                  s.status = BUSY_STATE;
                }
              }
              //#endif

              /* Flush as much pending output as possible */
              if (s.pending !== 0) {
                flush_pending(strm);
                if (strm.avail_out === 0) {
                  /* Since avail_out is 0, deflate will be called again with
                   * more output space, but possibly with both pending and
                   * avail_in equal to zero. There won't be anything to do,
                   * but this is not an error situation so make sure we
                   * return OK instead of BUF_ERROR at next call of deflate:
                   */
                  s.last_flush = -1;
                  return Z_OK$2;
                }

                /* Make sure there is something to do and avoid duplicate consecutive
                 * flushes. For repeated and useless calls with Z_FINISH, we keep
                 * returning Z_STREAM_END instead of Z_BUF_ERROR.
                 */
              } else if (strm.avail_in === 0 && rank(flush) <= rank(old_flush) &&
                flush !== Z_FINISH$2) {
                return err(strm, Z_BUF_ERROR$2);
              }

              /* User must not provide more input after the first FINISH: */
              if (s.status === FINISH_STATE && strm.avail_in !== 0) {
                return err(strm, Z_BUF_ERROR$2);
              }

              /* Start a new block or continue the current one.
               */
              if (strm.avail_in !== 0 || s.lookahead !== 0 ||
                (flush !== Z_NO_FLUSH$1 && s.status !== FINISH_STATE)) {
                var bstate = (s.strategy === Z_HUFFMAN_ONLY$1) ? deflate_huff(s, flush) :
                  (s.strategy === Z_RLE$1 ? deflate_rle(s, flush) :
                    configuration_table[s.level].func(s, flush));

                if (bstate === BS_FINISH_STARTED || bstate === BS_FINISH_DONE) {
                  s.status = FINISH_STATE;
                }
                if (bstate === BS_NEED_MORE || bstate === BS_FINISH_STARTED) {
                  if (strm.avail_out === 0) {
                    s.last_flush = -1;
                    /* avoid BUF_ERROR next call, see above */
                  }
                  return Z_OK$2;
                  /* If flush != Z_NO_FLUSH && avail_out == 0, the next call
                   * of deflate should use the same flush parameter to make sure
                   * that the flush is complete. So we don't have to output an
                   * empty block here, this will be done at next call. This also
                   * ensures that for a very small output buffer, we emit at most
                   * one empty block.
                   */
                }
                if (bstate === BS_BLOCK_DONE) {
                  if (flush === Z_PARTIAL_FLUSH$1) {
                    _tr_align(s);
                  } else if (flush !== Z_BLOCK$2) { /* FULL_FLUSH or SYNC_FLUSH */

                    _tr_stored_block(s, 0, 0, false);
                    /* For a full flush, this empty block will be recognized
                     * as a special marker by inflate_sync().
                     */
                    if (flush === Z_FULL_FLUSH$1) {
                      /*** CLEAR_HASH(s); ***/
                      /* forget history */
                      zero(s.head); // Fill with NIL (= 0);

                      if (s.lookahead === 0) {
                        s.strstart = 0;
                        s.block_start = 0;
                        s.insert = 0;
                      }
                    }
                  }
                  flush_pending(strm);
                  if (strm.avail_out === 0) {
                    s.last_flush = -1; /* avoid BUF_ERROR at next call, see above */
                    return Z_OK$2;
                  }
                }
              }
              //Assert(strm->avail_out > 0, "bug2");
              //if (strm.avail_out <= 0) { throw new Error("bug2");}

              if (flush !== Z_FINISH$2) {
                return Z_OK$2;
              }
              if (s.wrap <= 0) {
                return Z_STREAM_END$2;
              }

              /* Write the trailer */
              if (s.wrap === 2) {
                put_byte(s, strm.adler & 0xff);
                put_byte(s, (strm.adler >> 8) & 0xff);
                put_byte(s, (strm.adler >> 16) & 0xff);
                put_byte(s, (strm.adler >> 24) & 0xff);
                put_byte(s, strm.total_in & 0xff);
                put_byte(s, (strm.total_in >> 8) & 0xff);
                put_byte(s, (strm.total_in >> 16) & 0xff);
                put_byte(s, (strm.total_in >> 24) & 0xff);
              } else {
                putShortMSB(s, strm.adler >>> 16);
                putShortMSB(s, strm.adler & 0xffff);
              }

              flush_pending(strm);
              /* If avail_out is zero, the application will call deflate again
               * to flush the rest.
               */
              if (s.wrap > 0) {
                s.wrap = -s.wrap;
              }
              /* write the trailer only once! */
              return s.pending !== 0 ? Z_OK$2 : Z_STREAM_END$2;
            }

            function deflateEnd(strm) {
              var status;

              if (!strm /*== Z_NULL*/ || !strm.state /*== Z_NULL*/ ) {
                return Z_STREAM_ERROR$2;
              }

              status = strm.state.status;
              if (status !== INIT_STATE &&
                status !== EXTRA_STATE &&
                status !== NAME_STATE &&
                status !== COMMENT_STATE &&
                status !== HCRC_STATE &&
                status !== BUSY_STATE &&
                status !== FINISH_STATE
              ) {
                return err(strm, Z_STREAM_ERROR$2);
              }

              strm.state = null;

              return status === BUSY_STATE ? err(strm, Z_DATA_ERROR$2) : Z_OK$2;
            }

            /* Not implemented
            exports.deflateBound = deflateBound;
            exports.deflateCopy = deflateCopy;
            exports.deflateParams = deflateParams;
            exports.deflatePending = deflatePending;
            exports.deflatePrime = deflatePrime;
            exports.deflateTune = deflateTune;
            */

            // See state defs from inflate.js
            var BAD$1 = 30;       /* got a data error -- remain here until reset */
            var TYPE$2 = 12;      /* i: waiting for type bits, including last-flag bit */

            /*
               Decode literal, length, and distance codes and write out the resulting
               literal and match bytes until either not enough input or output is
               available, an end-of-block is encountered, or a data error is encountered.
               When large enough input and output buffers are supplied to inflate(), for
               example, a 16K input buffer and a 64K output buffer, more than 95% of the
               inflate execution time is spent in this routine.

               Entry assumptions:

                    state.mode === LEN
                    strm.avail_in >= 6
                    strm.avail_out >= 258
                    start >= strm.avail_out
                    state.bits < 8

               On return, state.mode is one of:

                    LEN -- ran out of enough output space or enough available input
                    TYPE -- reached end of block code, inflate() to interpret next block
                    BAD -- error in block data

               Notes:

                - The maximum input bits used by a length/distance pair is 15 bits for the
                  length code, 5 bits for the length extra, 15 bits for the distance code,
                  and 13 bits for the distance extra.  This totals 48 bits, or six bytes.
                  Therefore if strm.avail_in >= 6, then there is enough input to avoid
                  checking for available input while decoding.

                - The maximum bytes that a single length/distance pair can output is 258
                  bytes, which is the maximum length that can be coded.  inflate_fast()
                  requires strm.avail_out >= 258 for each loop to avoid checking for
                  output space.
             */
            function inflate_fast(strm, start) {
              var state;
              var _in;                    /* local strm.input */
              var last;                   /* have enough input while in < last */
              var _out;                   /* local strm.output */
              var beg;                    /* inflate()'s initial strm.output */
              var end;                    /* while out < end, enough space available */
            //#ifdef INFLATE_STRICT
              var dmax;                   /* maximum distance from zlib header */
            //#endif
              var wsize;                  /* window size or zero if not using window */
              var whave;                  /* valid bytes in the window */
              var wnext;                  /* window write index */
              // Use `s_window` instead `window`, avoid conflict with instrumentation tools
              var s_window;               /* allocated sliding window, if wsize != 0 */
              var hold;                   /* local strm.hold */
              var bits;                   /* local strm.bits */
              var lcode;                  /* local strm.lencode */
              var dcode;                  /* local strm.distcode */
              var lmask;                  /* mask for first level of length codes */
              var dmask;                  /* mask for first level of distance codes */
              var here;                   /* retrieved table entry */
              var op;                     /* code bits, operation, extra bits, or */
                                          /*  window position, window bytes to copy */
              var len;                    /* match length, unused bytes */
              var dist;                   /* match distance */
              var from;                   /* where to copy match from */
              var from_source;


              var input, output; // JS specific, because we have no pointers

              /* copy state to local variables */
              state = strm.state;
              //here = state.here;
              _in = strm.next_in;
              input = strm.input;
              last = _in + (strm.avail_in - 5);
              _out = strm.next_out;
              output = strm.output;
              beg = _out - (start - strm.avail_out);
              end = _out + (strm.avail_out - 257);
            //#ifdef INFLATE_STRICT
              dmax = state.dmax;
            //#endif
              wsize = state.wsize;
              whave = state.whave;
              wnext = state.wnext;
              s_window = state.window;
              hold = state.hold;
              bits = state.bits;
              lcode = state.lencode;
              dcode = state.distcode;
              lmask = (1 << state.lenbits) - 1;
              dmask = (1 << state.distbits) - 1;


              /* decode literals and length/distances until end-of-block or not enough
                 input data or output space */

              top:
              do {
                if (bits < 15) {
                  hold += input[_in++] << bits;
                  bits += 8;
                  hold += input[_in++] << bits;
                  bits += 8;
                }

                here = lcode[hold & lmask];

                dolen:
                for (;;) { // Goto emulation
                  op = here >>> 24/*here.bits*/;
                  hold >>>= op;
                  bits -= op;
                  op = (here >>> 16) & 0xff/*here.op*/;
                  if (op === 0) {                          /* literal */
                    //Tracevv((stderr, here.val >= 0x20 && here.val < 0x7f ?
                    //        "inflate:         literal '%c'\n" :
                    //        "inflate:         literal 0x%02x\n", here.val));
                    output[_out++] = here & 0xffff/*here.val*/;
                  }
                  else if (op & 16) {                     /* length base */
                    len = here & 0xffff/*here.val*/;
                    op &= 15;                           /* number of extra bits */
                    if (op) {
                      if (bits < op) {
                        hold += input[_in++] << bits;
                        bits += 8;
                      }
                      len += hold & ((1 << op) - 1);
                      hold >>>= op;
                      bits -= op;
                    }
                    //Tracevv((stderr, "inflate:         length %u\n", len));
                    if (bits < 15) {
                      hold += input[_in++] << bits;
                      bits += 8;
                      hold += input[_in++] << bits;
                      bits += 8;
                    }
                    here = dcode[hold & dmask];

                    dodist:
                    for (;;) { // goto emulation
                      op = here >>> 24/*here.bits*/;
                      hold >>>= op;
                      bits -= op;
                      op = (here >>> 16) & 0xff/*here.op*/;

                      if (op & 16) {                      /* distance base */
                        dist = here & 0xffff/*here.val*/;
                        op &= 15;                       /* number of extra bits */
                        if (bits < op) {
                          hold += input[_in++] << bits;
                          bits += 8;
                          if (bits < op) {
                            hold += input[_in++] << bits;
                            bits += 8;
                          }
                        }
                        dist += hold & ((1 << op) - 1);
            //#ifdef INFLATE_STRICT
                        if (dist > dmax) {
                          strm.msg = 'invalid distance too far back';
                          state.mode = BAD$1;
                          break top;
                        }
            //#endif
                        hold >>>= op;
                        bits -= op;
                        //Tracevv((stderr, "inflate:         distance %u\n", dist));
                        op = _out - beg;                /* max distance in output */
                        if (dist > op) {                /* see if copy from window */
                          op = dist - op;               /* distance back in window */
                          if (op > whave) {
                            if (state.sane) {
                              strm.msg = 'invalid distance too far back';
                              state.mode = BAD$1;
                              break top;
                            }

            // (!) This block is disabled in zlib defailts,
            // don't enable it for binary compatibility
            //#ifdef INFLATE_ALLOW_INVALID_DISTANCE_TOOFAR_ARRR
            //                if (len <= op - whave) {
            //                  do {
            //                    output[_out++] = 0;
            //                  } while (--len);
            //                  continue top;
            //                }
            //                len -= op - whave;
            //                do {
            //                  output[_out++] = 0;
            //                } while (--op > whave);
            //                if (op === 0) {
            //                  from = _out - dist;
            //                  do {
            //                    output[_out++] = output[from++];
            //                  } while (--len);
            //                  continue top;
            //                }
            //#endif
                          }
                          from = 0; // window index
                          from_source = s_window;
                          if (wnext === 0) {           /* very common case */
                            from += wsize - op;
                            if (op < len) {         /* some from window */
                              len -= op;
                              do {
                                output[_out++] = s_window[from++];
                              } while (--op);
                              from = _out - dist;  /* rest from output */
                              from_source = output;
                            }
                          }
                          else if (wnext < op) {      /* wrap around window */
                            from += wsize + wnext - op;
                            op -= wnext;
                            if (op < len) {         /* some from end of window */
                              len -= op;
                              do {
                                output[_out++] = s_window[from++];
                              } while (--op);
                              from = 0;
                              if (wnext < len) {  /* some from start of window */
                                op = wnext;
                                len -= op;
                                do {
                                  output[_out++] = s_window[from++];
                                } while (--op);
                                from = _out - dist;      /* rest from output */
                                from_source = output;
                              }
                            }
                          }
                          else {                      /* contiguous in window */
                            from += wnext - op;
                            if (op < len) {         /* some from window */
                              len -= op;
                              do {
                                output[_out++] = s_window[from++];
                              } while (--op);
                              from = _out - dist;  /* rest from output */
                              from_source = output;
                            }
                          }
                          while (len > 2) {
                            output[_out++] = from_source[from++];
                            output[_out++] = from_source[from++];
                            output[_out++] = from_source[from++];
                            len -= 3;
                          }
                          if (len) {
                            output[_out++] = from_source[from++];
                            if (len > 1) {
                              output[_out++] = from_source[from++];
                            }
                          }
                        }
                        else {
                          from = _out - dist;          /* copy direct from output */
                          do {                        /* minimum length is three */
                            output[_out++] = output[from++];
                            output[_out++] = output[from++];
                            output[_out++] = output[from++];
                            len -= 3;
                          } while (len > 2);
                          if (len) {
                            output[_out++] = output[from++];
                            if (len > 1) {
                              output[_out++] = output[from++];
                            }
                          }
                        }
                      }
                      else if ((op & 64) === 0) {          /* 2nd level distance code */
                        here = dcode[(here & 0xffff)/*here.val*/ + (hold & ((1 << op) - 1))];
                        continue dodist;
                      }
                      else {
                        strm.msg = 'invalid distance code';
                        state.mode = BAD$1;
                        break top;
                      }

                      break; // need to emulate goto via "continue"
                    }
                  }
                  else if ((op & 64) === 0) {              /* 2nd level length code */
                    here = lcode[(here & 0xffff)/*here.val*/ + (hold & ((1 << op) - 1))];
                    continue dolen;
                  }
                  else if (op & 32) {                     /* end-of-block */
                    //Tracevv((stderr, "inflate:         end of block\n"));
                    state.mode = TYPE$2;
                    break top;
                  }
                  else {
                    strm.msg = 'invalid literal/length code';
                    state.mode = BAD$1;
                    break top;
                  }

                  break; // need to emulate goto via "continue"
                }
              } while (_in < last && _out < end);

              /* return unused bytes (on entry, bits < 8, so in won't go too far back) */
              len = bits >> 3;
              _in -= len;
              bits -= len << 3;
              hold &= (1 << bits) - 1;

              /* update state and return */
              strm.next_in = _in;
              strm.next_out = _out;
              strm.avail_in = (_in < last ? 5 + (last - _in) : 5 - (_in - last));
              strm.avail_out = (_out < end ? 257 + (end - _out) : 257 - (_out - end));
              state.hold = hold;
              state.bits = bits;
              return;
            }

            var MAXBITS = 15;
            var ENOUGH_LENS$1 = 852;
            var ENOUGH_DISTS$1 = 592;
            //var ENOUGH = (ENOUGH_LENS+ENOUGH_DISTS);

            var CODES$1 = 0;
            var LENS$1 = 1;
            var DISTS$1 = 2;

            var lbase = [ /* Length codes 257..285 base */
              3, 4, 5, 6, 7, 8, 9, 10, 11, 13, 15, 17, 19, 23, 27, 31,
              35, 43, 51, 59, 67, 83, 99, 115, 131, 163, 195, 227, 258, 0, 0
            ];

            var lext = [ /* Length codes 257..285 extra */
              16, 16, 16, 16, 16, 16, 16, 16, 17, 17, 17, 17, 18, 18, 18, 18,
              19, 19, 19, 19, 20, 20, 20, 20, 21, 21, 21, 21, 16, 72, 78
            ];

            var dbase = [ /* Distance codes 0..29 base */
              1, 2, 3, 4, 5, 7, 9, 13, 17, 25, 33, 49, 65, 97, 129, 193,
              257, 385, 513, 769, 1025, 1537, 2049, 3073, 4097, 6145,
              8193, 12289, 16385, 24577, 0, 0
            ];

            var dext = [ /* Distance codes 0..29 extra */
              16, 16, 16, 16, 17, 17, 18, 18, 19, 19, 20, 20, 21, 21, 22, 22,
              23, 23, 24, 24, 25, 25, 26, 26, 27, 27,
              28, 28, 29, 29, 64, 64
            ];

            function inflate_table(type, lens, lens_index, codes, table, table_index, work, opts) {
              var bits = opts.bits;
              //here = opts.here; /* table entry for duplication */

              var len = 0; /* a code's length in bits */
              var sym = 0; /* index of code symbols */
              var min = 0,
                max = 0; /* minimum and maximum code lengths */
              var root = 0; /* number of index bits for root table */
              var curr = 0; /* number of index bits for current table */
              var drop = 0; /* code bits to drop for sub-table */
              var left = 0; /* number of prefix codes available */
              var used = 0; /* code entries in table used */
              var huff = 0; /* Huffman code */
              var incr; /* for incrementing code, index */
              var fill; /* index for replicating entries */
              var low; /* low bits for current root entry */
              var mask; /* mask for low root bits */
              var next; /* next available space in table */
              var base = null; /* base value table to use */
              var base_index = 0;
              //  var shoextra;    /* extra bits table to use */
              var end; /* use base and extra for symbol > end */
              var count = new Buf16(MAXBITS + 1); //[MAXBITS+1];    /* number of codes of each length */
              var offs = new Buf16(MAXBITS + 1); //[MAXBITS+1];     /* offsets in table for each length */
              var extra = null;
              var extra_index = 0;

              var here_bits, here_op, here_val;

              /*
               Process a set of code lengths to create a canonical Huffman code.  The
               code lengths are lens[0..codes-1].  Each length corresponds to the
               symbols 0..codes-1.  The Huffman code is generated by first sorting the
               symbols by length from short to long, and retaining the symbol order
               for codes with equal lengths.  Then the code starts with all zero bits
               for the first code of the shortest length, and the codes are integer
               increments for the same length, and zeros are appended as the length
               increases.  For the deflate format, these bits are stored backwards
               from their more natural integer increment ordering, and so when the
               decoding tables are built in the large loop below, the integer codes
               are incremented backwards.

               This routine assumes, but does not check, that all of the entries in
               lens[] are in the range 0..MAXBITS.  The caller must assure this.
               1..MAXBITS is interpreted as that code length.  zero means that that
               symbol does not occur in this code.

               The codes are sorted by computing a count of codes for each length,
               creating from that a table of starting indices for each length in the
               sorted table, and then entering the symbols in order in the sorted
               table.  The sorted table is work[], with that space being provided by
               the caller.

               The length counts are used for other purposes as well, i.e. finding
               the minimum and maximum length codes, determining if there are any
               codes at all, checking for a valid set of lengths, and looking ahead
               at length counts to determine sub-table sizes when building the
               decoding tables.
               */

              /* accumulate lengths for codes (assumes lens[] all in 0..MAXBITS) */
              for (len = 0; len <= MAXBITS; len++) {
                count[len] = 0;
              }
              for (sym = 0; sym < codes; sym++) {
                count[lens[lens_index + sym]]++;
              }

              /* bound code lengths, force root to be within code lengths */
              root = bits;
              for (max = MAXBITS; max >= 1; max--) {
                if (count[max] !== 0) {
                  break;
                }
              }
              if (root > max) {
                root = max;
              }
              if (max === 0) { /* no symbols to code at all */
                //table.op[opts.table_index] = 64;  //here.op = (var char)64;    /* invalid code marker */
                //table.bits[opts.table_index] = 1;   //here.bits = (var char)1;
                //table.val[opts.table_index++] = 0;   //here.val = (var short)0;
                table[table_index++] = (1 << 24) | (64 << 16) | 0;


                //table.op[opts.table_index] = 64;
                //table.bits[opts.table_index] = 1;
                //table.val[opts.table_index++] = 0;
                table[table_index++] = (1 << 24) | (64 << 16) | 0;

                opts.bits = 1;
                return 0; /* no symbols, but wait for decoding to report error */
              }
              for (min = 1; min < max; min++) {
                if (count[min] !== 0) {
                  break;
                }
              }
              if (root < min) {
                root = min;
              }

              /* check for an over-subscribed or incomplete set of lengths */
              left = 1;
              for (len = 1; len <= MAXBITS; len++) {
                left <<= 1;
                left -= count[len];
                if (left < 0) {
                  return -1;
                } /* over-subscribed */
              }
              if (left > 0 && (type === CODES$1 || max !== 1)) {
                return -1; /* incomplete set */
              }

              /* generate offsets into symbol table for each length for sorting */
              offs[1] = 0;
              for (len = 1; len < MAXBITS; len++) {
                offs[len + 1] = offs[len] + count[len];
              }

              /* sort symbols by length, by symbol order within each length */
              for (sym = 0; sym < codes; sym++) {
                if (lens[lens_index + sym] !== 0) {
                  work[offs[lens[lens_index + sym]]++] = sym;
                }
              }

              /*
               Create and fill in decoding tables.  In this loop, the table being
               filled is at next and has curr index bits.  The code being used is huff
               with length len.  That code is converted to an index by dropping drop
               bits off of the bottom.  For codes where len is less than drop + curr,
               those top drop + curr - len bits are incremented through all values to
               fill the table with replicated entries.

               root is the number of index bits for the root table.  When len exceeds
               root, sub-tables are created pointed to by the root entry with an index
               of the low root bits of huff.  This is saved in low to check for when a
               new sub-table should be started.  drop is zero when the root table is
               being filled, and drop is root when sub-tables are being filled.

               When a new sub-table is needed, it is necessary to look ahead in the
               code lengths to determine what size sub-table is needed.  The length
               counts are used for this, and so count[] is decremented as codes are
               entered in the tables.

               used keeps track of how many table entries have been allocated from the
               provided *table space.  It is checked for LENS and DIST tables against
               the constants ENOUGH_LENS and ENOUGH_DISTS to guard against changes in
               the initial root table size constants.  See the comments in inftrees.h
               for more information.

               sym increments through all symbols, and the loop terminates when
               all codes of length max, i.e. all codes, have been processed.  This
               routine permits incomplete codes, so another loop after this one fills
               in the rest of the decoding tables with invalid code markers.
               */

              /* set up for code type */
              // poor man optimization - use if-else instead of switch,
              // to avoid deopts in old v8
              if (type === CODES$1) {
                base = extra = work; /* dummy value--not used */
                end = 19;

              } else if (type === LENS$1) {
                base = lbase;
                base_index -= 257;
                extra = lext;
                extra_index -= 257;
                end = 256;

              } else { /* DISTS */
                base = dbase;
                extra = dext;
                end = -1;
              }

              /* initialize opts for loop */
              huff = 0; /* starting code */
              sym = 0; /* starting code symbol */
              len = min; /* starting code length */
              next = table_index; /* current table to fill in */
              curr = root; /* current table index bits */
              drop = 0; /* current bits to drop from code for index */
              low = -1; /* trigger new sub-table when len > root */
              used = 1 << root; /* use root table entries */
              mask = used - 1; /* mask for comparing low */

              /* check available table space */
              if ((type === LENS$1 && used > ENOUGH_LENS$1) ||
                (type === DISTS$1 && used > ENOUGH_DISTS$1)) {
                return 1;
              }
              /* process all codes and make table entries */
              for (;;) {
                /* create table entry */
                here_bits = len - drop;
                if (work[sym] < end) {
                  here_op = 0;
                  here_val = work[sym];
                } else if (work[sym] > end) {
                  here_op = extra[extra_index + work[sym]];
                  here_val = base[base_index + work[sym]];
                } else {
                  here_op = 32 + 64; /* end of block */
                  here_val = 0;
                }

                /* replicate for those indices with low len bits equal to huff */
                incr = 1 << (len - drop);
                fill = 1 << curr;
                min = fill; /* save offset to next table */
                do {
                  fill -= incr;
                  table[next + (huff >> drop) + fill] = (here_bits << 24) | (here_op << 16) | here_val | 0;
                } while (fill !== 0);

                /* backwards increment the len-bit code huff */
                incr = 1 << (len - 1);
                while (huff & incr) {
                  incr >>= 1;
                }
                if (incr !== 0) {
                  huff &= incr - 1;
                  huff += incr;
                } else {
                  huff = 0;
                }

                /* go to next symbol, update count, len */
                sym++;
                if (--count[len] === 0) {
                  if (len === max) {
                    break;
                  }
                  len = lens[lens_index + work[sym]];
                }

                /* create new sub-table if needed */
                if (len > root && (huff & mask) !== low) {
                  /* if first time, transition to sub-tables */
                  if (drop === 0) {
                    drop = root;
                  }

                  /* increment past last table */
                  next += min; /* here min is 1 << curr */

                  /* determine length of next table */
                  curr = len - drop;
                  left = 1 << curr;
                  while (curr + drop < max) {
                    left -= count[curr + drop];
                    if (left <= 0) {
                      break;
                    }
                    curr++;
                    left <<= 1;
                  }

                  /* check for enough space */
                  used += 1 << curr;
                  if ((type === LENS$1 && used > ENOUGH_LENS$1) ||
                    (type === DISTS$1 && used > ENOUGH_DISTS$1)) {
                    return 1;
                  }

                  /* point entry in root table to sub-table */
                  low = huff & mask;
                  /*table.op[low] = curr;
                  table.bits[low] = root;
                  table.val[low] = next - opts.table_index;*/
                  table[low] = (root << 24) | (curr << 16) | (next - table_index) | 0;
                }
              }

              /* fill in remaining table entry if code is incomplete (guaranteed to have
               at most one remaining entry, since if the code is incomplete, the
               maximum code length that was allowed to get this far is one bit) */
              if (huff !== 0) {
                //table.op[next + huff] = 64;            /* invalid code marker */
                //table.bits[next + huff] = len - drop;
                //table.val[next + huff] = 0;
                table[next + huff] = ((len - drop) << 24) | (64 << 16) | 0;
              }

              /* set return parameters */
              //opts.table_index += used;
              opts.bits = root;
              return 0;
            }

            var CODES = 0;
            var LENS = 1;
            var DISTS = 2;

            /* Public constants ==========================================================*/
            /* ===========================================================================*/


            /* Allowed flush values; see deflate() and inflate() below for details */
            //var Z_NO_FLUSH      = 0;
            //var Z_PARTIAL_FLUSH = 1;
            //var Z_SYNC_FLUSH    = 2;
            //var Z_FULL_FLUSH    = 3;
            var Z_FINISH$1 = 4;
            var Z_BLOCK$1 = 5;
            var Z_TREES$1 = 6;


            /* Return codes for the compression/decompression functions. Negative values
             * are errors, positive values are used for special but normal events.
             */
            var Z_OK$1 = 0;
            var Z_STREAM_END$1 = 1;
            var Z_NEED_DICT$1 = 2;
            //var Z_ERRNO         = -1;
            var Z_STREAM_ERROR$1 = -2;
            var Z_DATA_ERROR$1 = -3;
            var Z_MEM_ERROR = -4;
            var Z_BUF_ERROR$1 = -5;
            //var Z_VERSION_ERROR = -6;

            /* The deflate compression method */
            var Z_DEFLATED$1 = 8;


            /* STATES ====================================================================*/
            /* ===========================================================================*/


            var HEAD = 1; /* i: waiting for magic header */
            var FLAGS = 2; /* i: waiting for method and flags (gzip) */
            var TIME = 3; /* i: waiting for modification time (gzip) */
            var OS = 4; /* i: waiting for extra flags and operating system (gzip) */
            var EXLEN = 5; /* i: waiting for extra length (gzip) */
            var EXTRA = 6; /* i: waiting for extra bytes (gzip) */
            var NAME = 7; /* i: waiting for end of file name (gzip) */
            var COMMENT = 8; /* i: waiting for end of comment (gzip) */
            var HCRC = 9; /* i: waiting for header crc (gzip) */
            var DICTID = 10; /* i: waiting for dictionary check value */
            var DICT = 11; /* waiting for inflateSetDictionary() call */
            var TYPE$1 = 12; /* i: waiting for type bits, including last-flag bit */
            var TYPEDO = 13; /* i: same, but skip check to exit inflate on new block */
            var STORED = 14; /* i: waiting for stored size (length and complement) */
            var COPY_ = 15; /* i/o: same as COPY below, but only first time in */
            var COPY = 16; /* i/o: waiting for input or output to copy stored block */
            var TABLE = 17; /* i: waiting for dynamic block table lengths */
            var LENLENS = 18; /* i: waiting for code length code lengths */
            var CODELENS = 19; /* i: waiting for length/lit and distance code lengths */
            var LEN_ = 20; /* i: same as LEN below, but only first time in */
            var LEN = 21; /* i: waiting for length/lit/eob code */
            var LENEXT = 22; /* i: waiting for length extra bits */
            var DIST = 23; /* i: waiting for distance code */
            var DISTEXT = 24; /* i: waiting for distance extra bits */
            var MATCH = 25; /* o: waiting for output space to copy string */
            var LIT = 26; /* o: waiting for output space to write literal */
            var CHECK = 27; /* i: waiting for 32-bit check value */
            var LENGTH = 28; /* i: waiting for 32-bit length (gzip) */
            var DONE = 29; /* finished check, done -- remain here until reset */
            var BAD = 30; /* got a data error -- remain here until reset */
            var MEM = 31; /* got an inflate() memory error -- remain here until reset */
            var SYNC = 32; /* looking for synchronization bytes to restart inflate() */

            /* ===========================================================================*/



            var ENOUGH_LENS = 852;
            var ENOUGH_DISTS = 592;


            function zswap32(q) {
              return (((q >>> 24) & 0xff) +
                ((q >>> 8) & 0xff00) +
                ((q & 0xff00) << 8) +
                ((q & 0xff) << 24));
            }


            function InflateState() {
              this.mode = 0; /* current inflate mode */
              this.last = false; /* true if processing last block */
              this.wrap = 0; /* bit 0 true for zlib, bit 1 true for gzip */
              this.havedict = false; /* true if dictionary provided */
              this.flags = 0; /* gzip header method and flags (0 if zlib) */
              this.dmax = 0; /* zlib header max distance (INFLATE_STRICT) */
              this.check = 0; /* protected copy of check value */
              this.total = 0; /* protected copy of output count */
              // TODO: may be {}
              this.head = null; /* where to save gzip header information */

              /* sliding window */
              this.wbits = 0; /* log base 2 of requested window size */
              this.wsize = 0; /* window size or zero if not using window */
              this.whave = 0; /* valid bytes in the window */
              this.wnext = 0; /* window write index */
              this.window = null; /* allocated sliding window, if needed */

              /* bit accumulator */
              this.hold = 0; /* input bit accumulator */
              this.bits = 0; /* number of bits in "in" */

              /* for string and stored block copying */
              this.length = 0; /* literal or length of data to copy */
              this.offset = 0; /* distance back to copy string from */

              /* for table and code decoding */
              this.extra = 0; /* extra bits needed */

              /* fixed and dynamic code tables */
              this.lencode = null; /* starting table for length/literal codes */
              this.distcode = null; /* starting table for distance codes */
              this.lenbits = 0; /* index bits for lencode */
              this.distbits = 0; /* index bits for distcode */

              /* dynamic table building */
              this.ncode = 0; /* number of code length code lengths */
              this.nlen = 0; /* number of length code lengths */
              this.ndist = 0; /* number of distance code lengths */
              this.have = 0; /* number of code lengths in lens[] */
              this.next = null; /* next available space in codes[] */

              this.lens = new Buf16(320); /* temporary storage for code lengths */
              this.work = new Buf16(288); /* work area for code table building */

              /*
               because we don't have pointers in js, we use lencode and distcode directly
               as buffers so we don't need codes
              */
              //this.codes = new Buf32(ENOUGH);       /* space for code tables */
              this.lendyn = null; /* dynamic table for length/literal codes (JS specific) */
              this.distdyn = null; /* dynamic table for distance codes (JS specific) */
              this.sane = 0; /* if false, allow invalid distance too far */
              this.back = 0; /* bits back of last unprocessed length/lit */
              this.was = 0; /* initial length of match */
            }

            function inflateResetKeep(strm) {
              var state;

              if (!strm || !strm.state) {
                return Z_STREAM_ERROR$1;
              }
              state = strm.state;
              strm.total_in = strm.total_out = state.total = 0;
              strm.msg = ''; /*Z_NULL*/
              if (state.wrap) { /* to support ill-conceived Java test suite */
                strm.adler = state.wrap & 1;
              }
              state.mode = HEAD;
              state.last = 0;
              state.havedict = 0;
              state.dmax = 32768;
              state.head = null /*Z_NULL*/ ;
              state.hold = 0;
              state.bits = 0;
              //state.lencode = state.distcode = state.next = state.codes;
              state.lencode = state.lendyn = new Buf32(ENOUGH_LENS);
              state.distcode = state.distdyn = new Buf32(ENOUGH_DISTS);

              state.sane = 1;
              state.back = -1;
              //Tracev((stderr, "inflate: reset\n"));
              return Z_OK$1;
            }

            function inflateReset(strm) {
              var state;

              if (!strm || !strm.state) {
                return Z_STREAM_ERROR$1;
              }
              state = strm.state;
              state.wsize = 0;
              state.whave = 0;
              state.wnext = 0;
              return inflateResetKeep(strm);

            }

            function inflateReset2(strm, windowBits) {
              var wrap;
              var state;

              /* get the state */
              if (!strm || !strm.state) {
                return Z_STREAM_ERROR$1;
              }
              state = strm.state;

              /* extract wrap request from windowBits parameter */
              if (windowBits < 0) {
                wrap = 0;
                windowBits = -windowBits;
              } else {
                wrap = (windowBits >> 4) + 1;
                if (windowBits < 48) {
                  windowBits &= 15;
                }
              }

              /* set number of window bits, free window if different */
              if (windowBits && (windowBits < 8 || windowBits > 15)) {
                return Z_STREAM_ERROR$1;
              }
              if (state.window !== null && state.wbits !== windowBits) {
                state.window = null;
              }

              /* update state and reset the rest of it */
              state.wrap = wrap;
              state.wbits = windowBits;
              return inflateReset(strm);
            }

            function inflateInit2(strm, windowBits) {
              var ret;
              var state;

              if (!strm) {
                return Z_STREAM_ERROR$1;
              }
              //strm.msg = Z_NULL;                 /* in case we return an error */

              state = new InflateState();

              //if (state === Z_NULL) return Z_MEM_ERROR;
              //Tracev((stderr, "inflate: allocated\n"));
              strm.state = state;
              state.window = null /*Z_NULL*/ ;
              ret = inflateReset2(strm, windowBits);
              if (ret !== Z_OK$1) {
                strm.state = null /*Z_NULL*/ ;
              }
              return ret;
            }


            /*
             Return state with length and distance decoding tables and index sizes set to
             fixed code decoding.  Normally this returns fixed tables from inffixed.h.
             If BUILDFIXED is defined, then instead this routine builds the tables the
             first time it's called, and returns those tables the first time and
             thereafter.  This reduces the size of the code by about 2K bytes, in
             exchange for a little execution time.  However, BUILDFIXED should not be
             used for threaded applications, since the rewriting of the tables and virgin
             may not be thread-safe.
             */
            var virgin = true;

            var lenfix, distfix; // We have no pointers in JS, so keep tables separate

            function fixedtables(state) {
              /* build fixed huffman tables if first call (may not be thread safe) */
              if (virgin) {
                var sym;

                lenfix = new Buf32(512);
                distfix = new Buf32(32);

                /* literal/length table */
                sym = 0;
                while (sym < 144) {
                  state.lens[sym++] = 8;
                }
                while (sym < 256) {
                  state.lens[sym++] = 9;
                }
                while (sym < 280) {
                  state.lens[sym++] = 7;
                }
                while (sym < 288) {
                  state.lens[sym++] = 8;
                }

                inflate_table(LENS, state.lens, 0, 288, lenfix, 0, state.work, {
                  bits: 9
                });

                /* distance table */
                sym = 0;
                while (sym < 32) {
                  state.lens[sym++] = 5;
                }

                inflate_table(DISTS, state.lens, 0, 32, distfix, 0, state.work, {
                  bits: 5
                });

                /* do this just once */
                virgin = false;
              }

              state.lencode = lenfix;
              state.lenbits = 9;
              state.distcode = distfix;
              state.distbits = 5;
            }


            /*
             Update the window with the last wsize (normally 32K) bytes written before
             returning.  If window does not exist yet, create it.  This is only called
             when a window is already in use, or when output has been written during this
             inflate call, but the end of the deflate stream has not been reached yet.
             It is also called to create a window for dictionary data when a dictionary
             is loaded.

             Providing output buffers larger than 32K to inflate() should provide a speed
             advantage, since only the last 32K of output is copied to the sliding window
             upon return from inflate(), and since all distances after the first 32K of
             output will fall in the output data, making match copies simpler and faster.
             The advantage may be dependent on the size of the processor's data caches.
             */
            function updatewindow(strm, src, end, copy) {
              var dist;
              var state = strm.state;

              /* if it hasn't been done already, allocate space for the window */
              if (state.window === null) {
                state.wsize = 1 << state.wbits;
                state.wnext = 0;
                state.whave = 0;

                state.window = new Buf8(state.wsize);
              }

              /* copy state->wsize or less output bytes into the circular window */
              if (copy >= state.wsize) {
                arraySet(state.window, src, end - state.wsize, state.wsize, 0);
                state.wnext = 0;
                state.whave = state.wsize;
              } else {
                dist = state.wsize - state.wnext;
                if (dist > copy) {
                  dist = copy;
                }
                //zmemcpy(state->window + state->wnext, end - copy, dist);
                arraySet(state.window, src, end - copy, dist, state.wnext);
                copy -= dist;
                if (copy) {
                  //zmemcpy(state->window, end - copy, copy);
                  arraySet(state.window, src, end - copy, copy, 0);
                  state.wnext = copy;
                  state.whave = state.wsize;
                } else {
                  state.wnext += dist;
                  if (state.wnext === state.wsize) {
                    state.wnext = 0;
                  }
                  if (state.whave < state.wsize) {
                    state.whave += dist;
                  }
                }
              }
              return 0;
            }

            function inflate$1(strm, flush) {
              var state;
              var input, output; // input/output buffers
              var next; /* next input INDEX */
              var put; /* next output INDEX */
              var have, left; /* available input and output */
              var hold; /* bit buffer */
              var bits; /* bits in bit buffer */
              var _in, _out; /* save starting available input and output */
              var copy; /* number of stored or match bytes to copy */
              var from; /* where to copy match bytes from */
              var from_source;
              var here = 0; /* current decoding table entry */
              var here_bits, here_op, here_val; // paked "here" denormalized (JS specific)
              //var last;                   /* parent table entry */
              var last_bits, last_op, last_val; // paked "last" denormalized (JS specific)
              var len; /* length to copy for repeats, bits to drop */
              var ret; /* return code */
              var hbuf = new Buf8(4); /* buffer for gzip header crc calculation */
              var opts;

              var n; // temporary var for NEED_BITS

              var order = /* permutation of code lengths */ [16, 17, 18, 0, 8, 7, 9, 6, 10, 5, 11, 4, 12, 3, 13, 2, 14, 1, 15];


              if (!strm || !strm.state || !strm.output ||
                (!strm.input && strm.avail_in !== 0)) {
                return Z_STREAM_ERROR$1;
              }

              state = strm.state;
              if (state.mode === TYPE$1) {
                state.mode = TYPEDO;
              } /* skip check */


              //--- LOAD() ---
              put = strm.next_out;
              output = strm.output;
              left = strm.avail_out;
              next = strm.next_in;
              input = strm.input;
              have = strm.avail_in;
              hold = state.hold;
              bits = state.bits;
              //---

              _in = have;
              _out = left;
              ret = Z_OK$1;

              inf_leave: // goto emulation
                for (;;) {
                  switch (state.mode) {
                  case HEAD:
                    if (state.wrap === 0) {
                      state.mode = TYPEDO;
                      break;
                    }
                    //=== NEEDBITS(16);
                    while (bits < 16) {
                      if (have === 0) {
                        break inf_leave;
                      }
                      have--;
                      hold += input[next++] << bits;
                      bits += 8;
                    }
                    //===//
                    if ((state.wrap & 2) && hold === 0x8b1f) { /* gzip header */
                      state.check = 0 /*crc32(0L, Z_NULL, 0)*/ ;
                      //=== CRC2(state.check, hold);
                      hbuf[0] = hold & 0xff;
                      hbuf[1] = (hold >>> 8) & 0xff;
                      state.check = crc32(state.check, hbuf, 2, 0);
                      //===//

                      //=== INITBITS();
                      hold = 0;
                      bits = 0;
                      //===//
                      state.mode = FLAGS;
                      break;
                    }
                    state.flags = 0; /* expect zlib header */
                    if (state.head) {
                      state.head.done = false;
                    }
                    if (!(state.wrap & 1) || /* check if zlib header allowed */
                      (((hold & 0xff) /*BITS(8)*/ << 8) + (hold >> 8)) % 31) {
                      strm.msg = 'incorrect header check';
                      state.mode = BAD;
                      break;
                    }
                    if ((hold & 0x0f) /*BITS(4)*/ !== Z_DEFLATED$1) {
                      strm.msg = 'unknown compression method';
                      state.mode = BAD;
                      break;
                    }
                    //--- DROPBITS(4) ---//
                    hold >>>= 4;
                    bits -= 4;
                    //---//
                    len = (hold & 0x0f) /*BITS(4)*/ + 8;
                    if (state.wbits === 0) {
                      state.wbits = len;
                    } else if (len > state.wbits) {
                      strm.msg = 'invalid window size';
                      state.mode = BAD;
                      break;
                    }
                    state.dmax = 1 << len;
                    //Tracev((stderr, "inflate:   zlib header ok\n"));
                    strm.adler = state.check = 1 /*adler32(0L, Z_NULL, 0)*/ ;
                    state.mode = hold & 0x200 ? DICTID : TYPE$1;
                    //=== INITBITS();
                    hold = 0;
                    bits = 0;
                    //===//
                    break;
                  case FLAGS:
                    //=== NEEDBITS(16); */
                    while (bits < 16) {
                      if (have === 0) {
                        break inf_leave;
                      }
                      have--;
                      hold += input[next++] << bits;
                      bits += 8;
                    }
                    //===//
                    state.flags = hold;
                    if ((state.flags & 0xff) !== Z_DEFLATED$1) {
                      strm.msg = 'unknown compression method';
                      state.mode = BAD;
                      break;
                    }
                    if (state.flags & 0xe000) {
                      strm.msg = 'unknown header flags set';
                      state.mode = BAD;
                      break;
                    }
                    if (state.head) {
                      state.head.text = ((hold >> 8) & 1);
                    }
                    if (state.flags & 0x0200) {
                      //=== CRC2(state.check, hold);
                      hbuf[0] = hold & 0xff;
                      hbuf[1] = (hold >>> 8) & 0xff;
                      state.check = crc32(state.check, hbuf, 2, 0);
                      //===//
                    }
                    //=== INITBITS();
                    hold = 0;
                    bits = 0;
                    //===//
                    state.mode = TIME;
                    /* falls through */
                  case TIME:
                    //=== NEEDBITS(32); */
                    while (bits < 32) {
                      if (have === 0) {
                        break inf_leave;
                      }
                      have--;
                      hold += input[next++] << bits;
                      bits += 8;
                    }
                    //===//
                    if (state.head) {
                      state.head.time = hold;
                    }
                    if (state.flags & 0x0200) {
                      //=== CRC4(state.check, hold)
                      hbuf[0] = hold & 0xff;
                      hbuf[1] = (hold >>> 8) & 0xff;
                      hbuf[2] = (hold >>> 16) & 0xff;
                      hbuf[3] = (hold >>> 24) & 0xff;
                      state.check = crc32(state.check, hbuf, 4, 0);
                      //===
                    }
                    //=== INITBITS();
                    hold = 0;
                    bits = 0;
                    //===//
                    state.mode = OS;
                    /* falls through */
                  case OS:
                    //=== NEEDBITS(16); */
                    while (bits < 16) {
                      if (have === 0) {
                        break inf_leave;
                      }
                      have--;
                      hold += input[next++] << bits;
                      bits += 8;
                    }
                    //===//
                    if (state.head) {
                      state.head.xflags = (hold & 0xff);
                      state.head.os = (hold >> 8);
                    }
                    if (state.flags & 0x0200) {
                      //=== CRC2(state.check, hold);
                      hbuf[0] = hold & 0xff;
                      hbuf[1] = (hold >>> 8) & 0xff;
                      state.check = crc32(state.check, hbuf, 2, 0);
                      //===//
                    }
                    //=== INITBITS();
                    hold = 0;
                    bits = 0;
                    //===//
                    state.mode = EXLEN;
                    /* falls through */
                  case EXLEN:
                    if (state.flags & 0x0400) {
                      //=== NEEDBITS(16); */
                      while (bits < 16) {
                        if (have === 0) {
                          break inf_leave;
                        }
                        have--;
                        hold += input[next++] << bits;
                        bits += 8;
                      }
                      //===//
                      state.length = hold;
                      if (state.head) {
                        state.head.extra_len = hold;
                      }
                      if (state.flags & 0x0200) {
                        //=== CRC2(state.check, hold);
                        hbuf[0] = hold & 0xff;
                        hbuf[1] = (hold >>> 8) & 0xff;
                        state.check = crc32(state.check, hbuf, 2, 0);
                        //===//
                      }
                      //=== INITBITS();
                      hold = 0;
                      bits = 0;
                      //===//
                    } else if (state.head) {
                      state.head.extra = null /*Z_NULL*/ ;
                    }
                    state.mode = EXTRA;
                    /* falls through */
                  case EXTRA:
                    if (state.flags & 0x0400) {
                      copy = state.length;
                      if (copy > have) {
                        copy = have;
                      }
                      if (copy) {
                        if (state.head) {
                          len = state.head.extra_len - state.length;
                          if (!state.head.extra) {
                            // Use untyped array for more conveniend processing later
                            state.head.extra = new Array(state.head.extra_len);
                          }
                          arraySet(
                            state.head.extra,
                            input,
                            next,
                            // extra field is limited to 65536 bytes
                            // - no need for additional size check
                            copy,
                            /*len + copy > state.head.extra_max - len ? state.head.extra_max : copy,*/
                            len
                          );
                          //zmemcpy(state.head.extra + len, next,
                          //        len + copy > state.head.extra_max ?
                          //        state.head.extra_max - len : copy);
                        }
                        if (state.flags & 0x0200) {
                          state.check = crc32(state.check, input, copy, next);
                        }
                        have -= copy;
                        next += copy;
                        state.length -= copy;
                      }
                      if (state.length) {
                        break inf_leave;
                      }
                    }
                    state.length = 0;
                    state.mode = NAME;
                    /* falls through */
                  case NAME:
                    if (state.flags & 0x0800) {
                      if (have === 0) {
                        break inf_leave;
                      }
                      copy = 0;
                      do {
                        // TODO: 2 or 1 bytes?
                        len = input[next + copy++];
                        /* use constant limit because in js we should not preallocate memory */
                        if (state.head && len &&
                          (state.length < 65536 /*state.head.name_max*/ )) {
                          state.head.name += String.fromCharCode(len);
                        }
                      } while (len && copy < have);

                      if (state.flags & 0x0200) {
                        state.check = crc32(state.check, input, copy, next);
                      }
                      have -= copy;
                      next += copy;
                      if (len) {
                        break inf_leave;
                      }
                    } else if (state.head) {
                      state.head.name = null;
                    }
                    state.length = 0;
                    state.mode = COMMENT;
                    /* falls through */
                  case COMMENT:
                    if (state.flags & 0x1000) {
                      if (have === 0) {
                        break inf_leave;
                      }
                      copy = 0;
                      do {
                        len = input[next + copy++];
                        /* use constant limit because in js we should not preallocate memory */
                        if (state.head && len &&
                          (state.length < 65536 /*state.head.comm_max*/ )) {
                          state.head.comment += String.fromCharCode(len);
                        }
                      } while (len && copy < have);
                      if (state.flags & 0x0200) {
                        state.check = crc32(state.check, input, copy, next);
                      }
                      have -= copy;
                      next += copy;
                      if (len) {
                        break inf_leave;
                      }
                    } else if (state.head) {
                      state.head.comment = null;
                    }
                    state.mode = HCRC;
                    /* falls through */
                  case HCRC:
                    if (state.flags & 0x0200) {
                      //=== NEEDBITS(16); */
                      while (bits < 16) {
                        if (have === 0) {
                          break inf_leave;
                        }
                        have--;
                        hold += input[next++] << bits;
                        bits += 8;
                      }
                      //===//
                      if (hold !== (state.check & 0xffff)) {
                        strm.msg = 'header crc mismatch';
                        state.mode = BAD;
                        break;
                      }
                      //=== INITBITS();
                      hold = 0;
                      bits = 0;
                      //===//
                    }
                    if (state.head) {
                      state.head.hcrc = ((state.flags >> 9) & 1);
                      state.head.done = true;
                    }
                    strm.adler = state.check = 0;
                    state.mode = TYPE$1;
                    break;
                  case DICTID:
                    //=== NEEDBITS(32); */
                    while (bits < 32) {
                      if (have === 0) {
                        break inf_leave;
                      }
                      have--;
                      hold += input[next++] << bits;
                      bits += 8;
                    }
                    //===//
                    strm.adler = state.check = zswap32(hold);
                    //=== INITBITS();
                    hold = 0;
                    bits = 0;
                    //===//
                    state.mode = DICT;
                    /* falls through */
                  case DICT:
                    if (state.havedict === 0) {
                      //--- RESTORE() ---
                      strm.next_out = put;
                      strm.avail_out = left;
                      strm.next_in = next;
                      strm.avail_in = have;
                      state.hold = hold;
                      state.bits = bits;
                      //---
                      return Z_NEED_DICT$1;
                    }
                    strm.adler = state.check = 1 /*adler32(0L, Z_NULL, 0)*/ ;
                    state.mode = TYPE$1;
                    /* falls through */
                  case TYPE$1:
                    if (flush === Z_BLOCK$1 || flush === Z_TREES$1) {
                      break inf_leave;
                    }
                    /* falls through */
                  case TYPEDO:
                    if (state.last) {
                      //--- BYTEBITS() ---//
                      hold >>>= bits & 7;
                      bits -= bits & 7;
                      //---//
                      state.mode = CHECK;
                      break;
                    }
                    //=== NEEDBITS(3); */
                    while (bits < 3) {
                      if (have === 0) {
                        break inf_leave;
                      }
                      have--;
                      hold += input[next++] << bits;
                      bits += 8;
                    }
                    //===//
                    state.last = (hold & 0x01) /*BITS(1)*/ ;
                    //--- DROPBITS(1) ---//
                    hold >>>= 1;
                    bits -= 1;
                    //---//

                    switch ((hold & 0x03) /*BITS(2)*/ ) {
                    case 0:
                      /* stored block */
                      //Tracev((stderr, "inflate:     stored block%s\n",
                      //        state.last ? " (last)" : ""));
                      state.mode = STORED;
                      break;
                    case 1:
                      /* fixed block */
                      fixedtables(state);
                      //Tracev((stderr, "inflate:     fixed codes block%s\n",
                      //        state.last ? " (last)" : ""));
                      state.mode = LEN_; /* decode codes */
                      if (flush === Z_TREES$1) {
                        //--- DROPBITS(2) ---//
                        hold >>>= 2;
                        bits -= 2;
                        //---//
                        break inf_leave;
                      }
                      break;
                    case 2:
                      /* dynamic block */
                      //Tracev((stderr, "inflate:     dynamic codes block%s\n",
                      //        state.last ? " (last)" : ""));
                      state.mode = TABLE;
                      break;
                    case 3:
                      strm.msg = 'invalid block type';
                      state.mode = BAD;
                    }
                    //--- DROPBITS(2) ---//
                    hold >>>= 2;
                    bits -= 2;
                    //---//
                    break;
                  case STORED:
                    //--- BYTEBITS() ---// /* go to byte boundary */
                    hold >>>= bits & 7;
                    bits -= bits & 7;
                    //---//
                    //=== NEEDBITS(32); */
                    while (bits < 32) {
                      if (have === 0) {
                        break inf_leave;
                      }
                      have--;
                      hold += input[next++] << bits;
                      bits += 8;
                    }
                    //===//
                    if ((hold & 0xffff) !== ((hold >>> 16) ^ 0xffff)) {
                      strm.msg = 'invalid stored block lengths';
                      state.mode = BAD;
                      break;
                    }
                    state.length = hold & 0xffff;
                    //Tracev((stderr, "inflate:       stored length %u\n",
                    //        state.length));
                    //=== INITBITS();
                    hold = 0;
                    bits = 0;
                    //===//
                    state.mode = COPY_;
                    if (flush === Z_TREES$1) {
                      break inf_leave;
                    }
                    /* falls through */
                  case COPY_:
                    state.mode = COPY;
                    /* falls through */
                  case COPY:
                    copy = state.length;
                    if (copy) {
                      if (copy > have) {
                        copy = have;
                      }
                      if (copy > left) {
                        copy = left;
                      }
                      if (copy === 0) {
                        break inf_leave;
                      }
                      //--- zmemcpy(put, next, copy); ---
                      arraySet(output, input, next, copy, put);
                      //---//
                      have -= copy;
                      next += copy;
                      left -= copy;
                      put += copy;
                      state.length -= copy;
                      break;
                    }
                    //Tracev((stderr, "inflate:       stored end\n"));
                    state.mode = TYPE$1;
                    break;
                  case TABLE:
                    //=== NEEDBITS(14); */
                    while (bits < 14) {
                      if (have === 0) {
                        break inf_leave;
                      }
                      have--;
                      hold += input[next++] << bits;
                      bits += 8;
                    }
                    //===//
                    state.nlen = (hold & 0x1f) /*BITS(5)*/ + 257;
                    //--- DROPBITS(5) ---//
                    hold >>>= 5;
                    bits -= 5;
                    //---//
                    state.ndist = (hold & 0x1f) /*BITS(5)*/ + 1;
                    //--- DROPBITS(5) ---//
                    hold >>>= 5;
                    bits -= 5;
                    //---//
                    state.ncode = (hold & 0x0f) /*BITS(4)*/ + 4;
                    //--- DROPBITS(4) ---//
                    hold >>>= 4;
                    bits -= 4;
                    //---//
                    //#ifndef PKZIP_BUG_WORKAROUND
                    if (state.nlen > 286 || state.ndist > 30) {
                      strm.msg = 'too many length or distance symbols';
                      state.mode = BAD;
                      break;
                    }
                    //#endif
                    //Tracev((stderr, "inflate:       table sizes ok\n"));
                    state.have = 0;
                    state.mode = LENLENS;
                    /* falls through */
                  case LENLENS:
                    while (state.have < state.ncode) {
                      //=== NEEDBITS(3);
                      while (bits < 3) {
                        if (have === 0) {
                          break inf_leave;
                        }
                        have--;
                        hold += input[next++] << bits;
                        bits += 8;
                      }
                      //===//
                      state.lens[order[state.have++]] = (hold & 0x07); //BITS(3);
                      //--- DROPBITS(3) ---//
                      hold >>>= 3;
                      bits -= 3;
                      //---//
                    }
                    while (state.have < 19) {
                      state.lens[order[state.have++]] = 0;
                    }
                    // We have separate tables & no pointers. 2 commented lines below not needed.
                    //state.next = state.codes;
                    //state.lencode = state.next;
                    // Switch to use dynamic table
                    state.lencode = state.lendyn;
                    state.lenbits = 7;

                    opts = {
                      bits: state.lenbits
                    };
                    ret = inflate_table(CODES, state.lens, 0, 19, state.lencode, 0, state.work, opts);
                    state.lenbits = opts.bits;

                    if (ret) {
                      strm.msg = 'invalid code lengths set';
                      state.mode = BAD;
                      break;
                    }
                    //Tracev((stderr, "inflate:       code lengths ok\n"));
                    state.have = 0;
                    state.mode = CODELENS;
                    /* falls through */
                  case CODELENS:
                    while (state.have < state.nlen + state.ndist) {
                      for (;;) {
                        here = state.lencode[hold & ((1 << state.lenbits) - 1)]; /*BITS(state.lenbits)*/
                        here_bits = here >>> 24;
                        here_op = (here >>> 16) & 0xff;
                        here_val = here & 0xffff;

                        if ((here_bits) <= bits) {
                          break;
                        }
                        //--- PULLBYTE() ---//
                        if (have === 0) {
                          break inf_leave;
                        }
                        have--;
                        hold += input[next++] << bits;
                        bits += 8;
                        //---//
                      }
                      if (here_val < 16) {
                        //--- DROPBITS(here.bits) ---//
                        hold >>>= here_bits;
                        bits -= here_bits;
                        //---//
                        state.lens[state.have++] = here_val;
                      } else {
                        if (here_val === 16) {
                          //=== NEEDBITS(here.bits + 2);
                          n = here_bits + 2;
                          while (bits < n) {
                            if (have === 0) {
                              break inf_leave;
                            }
                            have--;
                            hold += input[next++] << bits;
                            bits += 8;
                          }
                          //===//
                          //--- DROPBITS(here.bits) ---//
                          hold >>>= here_bits;
                          bits -= here_bits;
                          //---//
                          if (state.have === 0) {
                            strm.msg = 'invalid bit length repeat';
                            state.mode = BAD;
                            break;
                          }
                          len = state.lens[state.have - 1];
                          copy = 3 + (hold & 0x03); //BITS(2);
                          //--- DROPBITS(2) ---//
                          hold >>>= 2;
                          bits -= 2;
                          //---//
                        } else if (here_val === 17) {
                          //=== NEEDBITS(here.bits + 3);
                          n = here_bits + 3;
                          while (bits < n) {
                            if (have === 0) {
                              break inf_leave;
                            }
                            have--;
                            hold += input[next++] << bits;
                            bits += 8;
                          }
                          //===//
                          //--- DROPBITS(here.bits) ---//
                          hold >>>= here_bits;
                          bits -= here_bits;
                          //---//
                          len = 0;
                          copy = 3 + (hold & 0x07); //BITS(3);
                          //--- DROPBITS(3) ---//
                          hold >>>= 3;
                          bits -= 3;
                          //---//
                        } else {
                          //=== NEEDBITS(here.bits + 7);
                          n = here_bits + 7;
                          while (bits < n) {
                            if (have === 0) {
                              break inf_leave;
                            }
                            have--;
                            hold += input[next++] << bits;
                            bits += 8;
                          }
                          //===//
                          //--- DROPBITS(here.bits) ---//
                          hold >>>= here_bits;
                          bits -= here_bits;
                          //---//
                          len = 0;
                          copy = 11 + (hold & 0x7f); //BITS(7);
                          //--- DROPBITS(7) ---//
                          hold >>>= 7;
                          bits -= 7;
                          //---//
                        }
                        if (state.have + copy > state.nlen + state.ndist) {
                          strm.msg = 'invalid bit length repeat';
                          state.mode = BAD;
                          break;
                        }
                        while (copy--) {
                          state.lens[state.have++] = len;
                        }
                      }
                    }

                    /* handle error breaks in while */
                    if (state.mode === BAD) {
                      break;
                    }

                    /* check for end-of-block code (better have one) */
                    if (state.lens[256] === 0) {
                      strm.msg = 'invalid code -- missing end-of-block';
                      state.mode = BAD;
                      break;
                    }

                    /* build code tables -- note: do not change the lenbits or distbits
                       values here (9 and 6) without reading the comments in inftrees.h
                       concerning the ENOUGH constants, which depend on those values */
                    state.lenbits = 9;

                    opts = {
                      bits: state.lenbits
                    };
                    ret = inflate_table(LENS, state.lens, 0, state.nlen, state.lencode, 0, state.work, opts);
                    // We have separate tables & no pointers. 2 commented lines below not needed.
                    // state.next_index = opts.table_index;
                    state.lenbits = opts.bits;
                    // state.lencode = state.next;

                    if (ret) {
                      strm.msg = 'invalid literal/lengths set';
                      state.mode = BAD;
                      break;
                    }

                    state.distbits = 6;
                    //state.distcode.copy(state.codes);
                    // Switch to use dynamic table
                    state.distcode = state.distdyn;
                    opts = {
                      bits: state.distbits
                    };
                    ret = inflate_table(DISTS, state.lens, state.nlen, state.ndist, state.distcode, 0, state.work, opts);
                    // We have separate tables & no pointers. 2 commented lines below not needed.
                    // state.next_index = opts.table_index;
                    state.distbits = opts.bits;
                    // state.distcode = state.next;

                    if (ret) {
                      strm.msg = 'invalid distances set';
                      state.mode = BAD;
                      break;
                    }
                    //Tracev((stderr, 'inflate:       codes ok\n'));
                    state.mode = LEN_;
                    if (flush === Z_TREES$1) {
                      break inf_leave;
                    }
                    /* falls through */
                  case LEN_:
                    state.mode = LEN;
                    /* falls through */
                  case LEN:
                    if (have >= 6 && left >= 258) {
                      //--- RESTORE() ---
                      strm.next_out = put;
                      strm.avail_out = left;
                      strm.next_in = next;
                      strm.avail_in = have;
                      state.hold = hold;
                      state.bits = bits;
                      //---
                      inflate_fast(strm, _out);
                      //--- LOAD() ---
                      put = strm.next_out;
                      output = strm.output;
                      left = strm.avail_out;
                      next = strm.next_in;
                      input = strm.input;
                      have = strm.avail_in;
                      hold = state.hold;
                      bits = state.bits;
                      //---

                      if (state.mode === TYPE$1) {
                        state.back = -1;
                      }
                      break;
                    }
                    state.back = 0;
                    for (;;) {
                      here = state.lencode[hold & ((1 << state.lenbits) - 1)]; /*BITS(state.lenbits)*/
                      here_bits = here >>> 24;
                      here_op = (here >>> 16) & 0xff;
                      here_val = here & 0xffff;

                      if (here_bits <= bits) {
                        break;
                      }
                      //--- PULLBYTE() ---//
                      if (have === 0) {
                        break inf_leave;
                      }
                      have--;
                      hold += input[next++] << bits;
                      bits += 8;
                      //---//
                    }
                    if (here_op && (here_op & 0xf0) === 0) {
                      last_bits = here_bits;
                      last_op = here_op;
                      last_val = here_val;
                      for (;;) {
                        here = state.lencode[last_val +
                          ((hold & ((1 << (last_bits + last_op)) - 1)) /*BITS(last.bits + last.op)*/ >> last_bits)];
                        here_bits = here >>> 24;
                        here_op = (here >>> 16) & 0xff;
                        here_val = here & 0xffff;

                        if ((last_bits + here_bits) <= bits) {
                          break;
                        }
                        //--- PULLBYTE() ---//
                        if (have === 0) {
                          break inf_leave;
                        }
                        have--;
                        hold += input[next++] << bits;
                        bits += 8;
                        //---//
                      }
                      //--- DROPBITS(last.bits) ---//
                      hold >>>= last_bits;
                      bits -= last_bits;
                      //---//
                      state.back += last_bits;
                    }
                    //--- DROPBITS(here.bits) ---//
                    hold >>>= here_bits;
                    bits -= here_bits;
                    //---//
                    state.back += here_bits;
                    state.length = here_val;
                    if (here_op === 0) {
                      //Tracevv((stderr, here.val >= 0x20 && here.val < 0x7f ?
                      //        "inflate:         literal '%c'\n" :
                      //        "inflate:         literal 0x%02x\n", here.val));
                      state.mode = LIT;
                      break;
                    }
                    if (here_op & 32) {
                      //Tracevv((stderr, "inflate:         end of block\n"));
                      state.back = -1;
                      state.mode = TYPE$1;
                      break;
                    }
                    if (here_op & 64) {
                      strm.msg = 'invalid literal/length code';
                      state.mode = BAD;
                      break;
                    }
                    state.extra = here_op & 15;
                    state.mode = LENEXT;
                    /* falls through */
                  case LENEXT:
                    if (state.extra) {
                      //=== NEEDBITS(state.extra);
                      n = state.extra;
                      while (bits < n) {
                        if (have === 0) {
                          break inf_leave;
                        }
                        have--;
                        hold += input[next++] << bits;
                        bits += 8;
                      }
                      //===//
                      state.length += hold & ((1 << state.extra) - 1) /*BITS(state.extra)*/ ;
                      //--- DROPBITS(state.extra) ---//
                      hold >>>= state.extra;
                      bits -= state.extra;
                      //---//
                      state.back += state.extra;
                    }
                    //Tracevv((stderr, "inflate:         length %u\n", state.length));
                    state.was = state.length;
                    state.mode = DIST;
                    /* falls through */
                  case DIST:
                    for (;;) {
                      here = state.distcode[hold & ((1 << state.distbits) - 1)]; /*BITS(state.distbits)*/
                      here_bits = here >>> 24;
                      here_op = (here >>> 16) & 0xff;
                      here_val = here & 0xffff;

                      if ((here_bits) <= bits) {
                        break;
                      }
                      //--- PULLBYTE() ---//
                      if (have === 0) {
                        break inf_leave;
                      }
                      have--;
                      hold += input[next++] << bits;
                      bits += 8;
                      //---//
                    }
                    if ((here_op & 0xf0) === 0) {
                      last_bits = here_bits;
                      last_op = here_op;
                      last_val = here_val;
                      for (;;) {
                        here = state.distcode[last_val +
                          ((hold & ((1 << (last_bits + last_op)) - 1)) /*BITS(last.bits + last.op)*/ >> last_bits)];
                        here_bits = here >>> 24;
                        here_op = (here >>> 16) & 0xff;
                        here_val = here & 0xffff;

                        if ((last_bits + here_bits) <= bits) {
                          break;
                        }
                        //--- PULLBYTE() ---//
                        if (have === 0) {
                          break inf_leave;
                        }
                        have--;
                        hold += input[next++] << bits;
                        bits += 8;
                        //---//
                      }
                      //--- DROPBITS(last.bits) ---//
                      hold >>>= last_bits;
                      bits -= last_bits;
                      //---//
                      state.back += last_bits;
                    }
                    //--- DROPBITS(here.bits) ---//
                    hold >>>= here_bits;
                    bits -= here_bits;
                    //---//
                    state.back += here_bits;
                    if (here_op & 64) {
                      strm.msg = 'invalid distance code';
                      state.mode = BAD;
                      break;
                    }
                    state.offset = here_val;
                    state.extra = (here_op) & 15;
                    state.mode = DISTEXT;
                    /* falls through */
                  case DISTEXT:
                    if (state.extra) {
                      //=== NEEDBITS(state.extra);
                      n = state.extra;
                      while (bits < n) {
                        if (have === 0) {
                          break inf_leave;
                        }
                        have--;
                        hold += input[next++] << bits;
                        bits += 8;
                      }
                      //===//
                      state.offset += hold & ((1 << state.extra) - 1) /*BITS(state.extra)*/ ;
                      //--- DROPBITS(state.extra) ---//
                      hold >>>= state.extra;
                      bits -= state.extra;
                      //---//
                      state.back += state.extra;
                    }
                    //#ifdef INFLATE_STRICT
                    if (state.offset > state.dmax) {
                      strm.msg = 'invalid distance too far back';
                      state.mode = BAD;
                      break;
                    }
                    //#endif
                    //Tracevv((stderr, "inflate:         distance %u\n", state.offset));
                    state.mode = MATCH;
                    /* falls through */
                  case MATCH:
                    if (left === 0) {
                      break inf_leave;
                    }
                    copy = _out - left;
                    if (state.offset > copy) { /* copy from window */
                      copy = state.offset - copy;
                      if (copy > state.whave) {
                        if (state.sane) {
                          strm.msg = 'invalid distance too far back';
                          state.mode = BAD;
                          break;
                        }
                        // (!) This block is disabled in zlib defailts,
                        // don't enable it for binary compatibility
                        //#ifdef INFLATE_ALLOW_INVALID_DISTANCE_TOOFAR_ARRR
                        //          Trace((stderr, "inflate.c too far\n"));
                        //          copy -= state.whave;
                        //          if (copy > state.length) { copy = state.length; }
                        //          if (copy > left) { copy = left; }
                        //          left -= copy;
                        //          state.length -= copy;
                        //          do {
                        //            output[put++] = 0;
                        //          } while (--copy);
                        //          if (state.length === 0) { state.mode = LEN; }
                        //          break;
                        //#endif
                      }
                      if (copy > state.wnext) {
                        copy -= state.wnext;
                        from = state.wsize - copy;
                      } else {
                        from = state.wnext - copy;
                      }
                      if (copy > state.length) {
                        copy = state.length;
                      }
                      from_source = state.window;
                    } else { /* copy from output */
                      from_source = output;
                      from = put - state.offset;
                      copy = state.length;
                    }
                    if (copy > left) {
                      copy = left;
                    }
                    left -= copy;
                    state.length -= copy;
                    do {
                      output[put++] = from_source[from++];
                    } while (--copy);
                    if (state.length === 0) {
                      state.mode = LEN;
                    }
                    break;
                  case LIT:
                    if (left === 0) {
                      break inf_leave;
                    }
                    output[put++] = state.length;
                    left--;
                    state.mode = LEN;
                    break;
                  case CHECK:
                    if (state.wrap) {
                      //=== NEEDBITS(32);
                      while (bits < 32) {
                        if (have === 0) {
                          break inf_leave;
                        }
                        have--;
                        // Use '|' insdead of '+' to make sure that result is signed
                        hold |= input[next++] << bits;
                        bits += 8;
                      }
                      //===//
                      _out -= left;
                      strm.total_out += _out;
                      state.total += _out;
                      if (_out) {
                        strm.adler = state.check =
                          /*UPDATE(state.check, put - _out, _out);*/
                          (state.flags ? crc32(state.check, output, _out, put - _out) : adler32(state.check, output, _out, put - _out));

                      }
                      _out = left;
                      // NB: crc32 stored as signed 32-bit int, zswap32 returns signed too
                      if ((state.flags ? hold : zswap32(hold)) !== state.check) {
                        strm.msg = 'incorrect data check';
                        state.mode = BAD;
                        break;
                      }
                      //=== INITBITS();
                      hold = 0;
                      bits = 0;
                      //===//
                      //Tracev((stderr, "inflate:   check matches trailer\n"));
                    }
                    state.mode = LENGTH;
                    /* falls through */
                  case LENGTH:
                    if (state.wrap && state.flags) {
                      //=== NEEDBITS(32);
                      while (bits < 32) {
                        if (have === 0) {
                          break inf_leave;
                        }
                        have--;
                        hold += input[next++] << bits;
                        bits += 8;
                      }
                      //===//
                      if (hold !== (state.total & 0xffffffff)) {
                        strm.msg = 'incorrect length check';
                        state.mode = BAD;
                        break;
                      }
                      //=== INITBITS();
                      hold = 0;
                      bits = 0;
                      //===//
                      //Tracev((stderr, "inflate:   length matches trailer\n"));
                    }
                    state.mode = DONE;
                    /* falls through */
                  case DONE:
                    ret = Z_STREAM_END$1;
                    break inf_leave;
                  case BAD:
                    ret = Z_DATA_ERROR$1;
                    break inf_leave;
                  case MEM:
                    return Z_MEM_ERROR;
                  case SYNC:
                    /* falls through */
                  default:
                    return Z_STREAM_ERROR$1;
                  }
                }

              // inf_leave <- here is real place for "goto inf_leave", emulated via "break inf_leave"

              /*
                 Return from inflate(), updating the total counts and the check value.
                 If there was no progress during the inflate() call, return a buffer
                 error.  Call updatewindow() to create and/or update the window state.
                 Note: a memory error from inflate() is non-recoverable.
               */

              //--- RESTORE() ---
              strm.next_out = put;
              strm.avail_out = left;
              strm.next_in = next;
              strm.avail_in = have;
              state.hold = hold;
              state.bits = bits;
              //---

              if (state.wsize || (_out !== strm.avail_out && state.mode < BAD &&
                  (state.mode < CHECK || flush !== Z_FINISH$1))) {
                if (updatewindow(strm, strm.output, strm.next_out, _out - strm.avail_out)) ;
              }
              _in -= strm.avail_in;
              _out -= strm.avail_out;
              strm.total_in += _in;
              strm.total_out += _out;
              state.total += _out;
              if (state.wrap && _out) {
                strm.adler = state.check = /*UPDATE(state.check, strm.next_out - _out, _out);*/
                  (state.flags ? crc32(state.check, output, _out, strm.next_out - _out) : adler32(state.check, output, _out, strm.next_out - _out));
              }
              strm.data_type = state.bits + (state.last ? 64 : 0) +
                (state.mode === TYPE$1 ? 128 : 0) +
                (state.mode === LEN_ || state.mode === COPY_ ? 256 : 0);
              if (((_in === 0 && _out === 0) || flush === Z_FINISH$1) && ret === Z_OK$1) {
                ret = Z_BUF_ERROR$1;
              }
              return ret;
            }

            function inflateEnd(strm) {

              if (!strm || !strm.state /*|| strm->zfree == (free_func)0*/ ) {
                return Z_STREAM_ERROR$1;
              }

              var state = strm.state;
              if (state.window) {
                state.window = null;
              }
              strm.state = null;
              return Z_OK$1;
            }

            /* Not implemented
            exports.inflateCopy = inflateCopy;
            exports.inflateGetDictionary = inflateGetDictionary;
            exports.inflateMark = inflateMark;
            exports.inflatePrime = inflatePrime;
            exports.inflateSync = inflateSync;
            exports.inflateSyncPoint = inflateSyncPoint;
            exports.inflateUndermine = inflateUndermine;
            */

            // import constants from './constants';


            // zlib modes
            var NONE = 0;
            var DEFLATE = 1;
            var INFLATE = 2;
            var GZIP = 3;
            var GUNZIP = 4;
            var DEFLATERAW = 5;
            var INFLATERAW = 6;
            var UNZIP = 7;
            var Z_NO_FLUSH=         0,
              Z_PARTIAL_FLUSH=    1,
              Z_SYNC_FLUSH=    2,
              Z_FULL_FLUSH=       3,
              Z_FINISH=       4,
              Z_BLOCK=           5,
              Z_TREES=            6,

              /* Return codes for the compression/decompression functions. Negative values
              * are errors, positive values are used for special but normal events.
              */
              Z_OK=               0,
              Z_STREAM_END=       1,
              Z_NEED_DICT=      2,
              Z_ERRNO=       -1,
              Z_STREAM_ERROR=   -2,
              Z_DATA_ERROR=    -3,
              //Z_MEM_ERROR:     -4,
              Z_BUF_ERROR=    -5,
              //Z_VERSION_ERROR: -6,

              /* compression levels */
              Z_NO_COMPRESSION=         0,
              Z_BEST_SPEED=             1,
              Z_BEST_COMPRESSION=       9,
              Z_DEFAULT_COMPRESSION=   -1,


              Z_FILTERED=               1,
              Z_HUFFMAN_ONLY=           2,
              Z_RLE=                    3,
              Z_FIXED=                  4,
              Z_DEFAULT_STRATEGY=       0,

              /* Possible values of the data_type field (though see inflate()) */
              Z_BINARY=                 0,
              Z_TEXT=                   1,
              //Z_ASCII:                1, // = Z_TEXT (deprecated)
              Z_UNKNOWN=                2,

              /* The deflate compression method */
              Z_DEFLATED=               8;
            function Zlib$1(mode) {
              if (mode < DEFLATE || mode > UNZIP)
                throw new TypeError('Bad argument');

              this.mode = mode;
              this.init_done = false;
              this.write_in_progress = false;
              this.pending_close = false;
              this.windowBits = 0;
              this.level = 0;
              this.memLevel = 0;
              this.strategy = 0;
              this.dictionary = null;
            }

            Zlib$1.prototype.init = function(windowBits, level, memLevel, strategy, dictionary) {
              this.windowBits = windowBits;
              this.level = level;
              this.memLevel = memLevel;
              this.strategy = strategy;
              // dictionary not supported.

              if (this.mode === GZIP || this.mode === GUNZIP)
                this.windowBits += 16;

              if (this.mode === UNZIP)
                this.windowBits += 32;

              if (this.mode === DEFLATERAW || this.mode === INFLATERAW)
                this.windowBits = -this.windowBits;

              this.strm = new ZStream();
              var status;
              switch (this.mode) {
              case DEFLATE:
              case GZIP:
              case DEFLATERAW:
                status = deflateInit2(
                  this.strm,
                  this.level,
                  Z_DEFLATED,
                  this.windowBits,
                  this.memLevel,
                  this.strategy
                );
                break;
              case INFLATE:
              case GUNZIP:
              case INFLATERAW:
              case UNZIP:
                status  = inflateInit2(
                  this.strm,
                  this.windowBits
                );
                break;
              default:
                throw new Error('Unknown mode ' + this.mode);
              }

              if (status !== Z_OK) {
                this._error(status);
                return;
              }

              this.write_in_progress = false;
              this.init_done = true;
            };

            Zlib$1.prototype.params = function() {
              throw new Error('deflateParams Not supported');
            };

            Zlib$1.prototype._writeCheck = function() {
              if (!this.init_done)
                throw new Error('write before init');

              if (this.mode === NONE)
                throw new Error('already finalized');

              if (this.write_in_progress)
                throw new Error('write already in progress');

              if (this.pending_close)
                throw new Error('close is pending');
            };

            Zlib$1.prototype.write = function(flush, input, in_off, in_len, out, out_off, out_len) {
              this._writeCheck();
              this.write_in_progress = true;

              var self = this;
              browser$1.nextTick(function() {
                self.write_in_progress = false;
                var res = self._write(flush, input, in_off, in_len, out, out_off, out_len);
                self.callback(res[0], res[1]);

                if (self.pending_close)
                  self.close();
              });

              return this;
            };

            // set method for Node buffers, used by pako
            function bufferSet(data, offset) {
              for (var i = 0; i < data.length; i++) {
                this[offset + i] = data[i];
              }
            }

            Zlib$1.prototype.writeSync = function(flush, input, in_off, in_len, out, out_off, out_len) {
              this._writeCheck();
              return this._write(flush, input, in_off, in_len, out, out_off, out_len);
            };

            Zlib$1.prototype._write = function(flush, input, in_off, in_len, out, out_off, out_len) {
              this.write_in_progress = true;

              if (flush !== Z_NO_FLUSH &&
                  flush !== Z_PARTIAL_FLUSH &&
                  flush !== Z_SYNC_FLUSH &&
                  flush !== Z_FULL_FLUSH &&
                  flush !== Z_FINISH &&
                  flush !== Z_BLOCK) {
                throw new Error('Invalid flush value');
              }

              if (input == null) {
                input = new Buffer$1(0);
                in_len = 0;
                in_off = 0;
              }

              if (out._set)
                out.set = out._set;
              else
                out.set = bufferSet;

              var strm = this.strm;
              strm.avail_in = in_len;
              strm.input = input;
              strm.next_in = in_off;
              strm.avail_out = out_len;
              strm.output = out;
              strm.next_out = out_off;
              var status;
              switch (this.mode) {
              case DEFLATE:
              case GZIP:
              case DEFLATERAW:
                status = deflate$1(strm, flush);
                break;
              case UNZIP:
              case INFLATE:
              case GUNZIP:
              case INFLATERAW:
                status = inflate$1(strm, flush);
                break;
              default:
                throw new Error('Unknown mode ' + this.mode);
              }

              if (status !== Z_STREAM_END && status !== Z_OK) {
                this._error(status);
              }

              this.write_in_progress = false;
              return [strm.avail_in, strm.avail_out];
            };

            Zlib$1.prototype.close = function() {
              if (this.write_in_progress) {
                this.pending_close = true;
                return;
              }

              this.pending_close = false;

              if (this.mode === DEFLATE || this.mode === GZIP || this.mode === DEFLATERAW) {
                deflateEnd(this.strm);
              } else {
                inflateEnd(this.strm);
              }

              this.mode = NONE;
            };
            var status;
            Zlib$1.prototype.reset = function() {
              switch (this.mode) {
              case DEFLATE:
              case DEFLATERAW:
                status = deflateReset(this.strm);
                break;
              case INFLATE:
              case INFLATERAW:
                status = inflateReset(this.strm);
                break;
              }

              if (status !== Z_OK) {
                this._error(status);
              }
            };

            Zlib$1.prototype._error = function(status) {
              this.onerror(msg[status] + ': ' + this.strm.msg, status);

              this.write_in_progress = false;
              if (this.pending_close)
                this.close();
            };

            var _binding = /*#__PURE__*/Object.freeze({
                __proto__: null,
                NONE: NONE,
                DEFLATE: DEFLATE,
                INFLATE: INFLATE,
                GZIP: GZIP,
                GUNZIP: GUNZIP,
                DEFLATERAW: DEFLATERAW,
                INFLATERAW: INFLATERAW,
                UNZIP: UNZIP,
                Z_NO_FLUSH: Z_NO_FLUSH,
                Z_PARTIAL_FLUSH: Z_PARTIAL_FLUSH,
                Z_SYNC_FLUSH: Z_SYNC_FLUSH,
                Z_FULL_FLUSH: Z_FULL_FLUSH,
                Z_FINISH: Z_FINISH,
                Z_BLOCK: Z_BLOCK,
                Z_TREES: Z_TREES,
                Z_OK: Z_OK,
                Z_STREAM_END: Z_STREAM_END,
                Z_NEED_DICT: Z_NEED_DICT,
                Z_ERRNO: Z_ERRNO,
                Z_STREAM_ERROR: Z_STREAM_ERROR,
                Z_DATA_ERROR: Z_DATA_ERROR,
                Z_BUF_ERROR: Z_BUF_ERROR,
                Z_NO_COMPRESSION: Z_NO_COMPRESSION,
                Z_BEST_SPEED: Z_BEST_SPEED,
                Z_BEST_COMPRESSION: Z_BEST_COMPRESSION,
                Z_DEFAULT_COMPRESSION: Z_DEFAULT_COMPRESSION,
                Z_FILTERED: Z_FILTERED,
                Z_HUFFMAN_ONLY: Z_HUFFMAN_ONLY,
                Z_RLE: Z_RLE,
                Z_FIXED: Z_FIXED,
                Z_DEFAULT_STRATEGY: Z_DEFAULT_STRATEGY,
                Z_BINARY: Z_BINARY,
                Z_TEXT: Z_TEXT,
                Z_UNKNOWN: Z_UNKNOWN,
                Z_DEFLATED: Z_DEFLATED,
                Zlib: Zlib$1
            });

            function assert (a, msg) {
              if (!a) {
                throw new Error(msg);
              }
            }
            var binding = {};
            Object.keys(_binding).forEach(function (key) {
              binding[key] = _binding[key];
            });
            // zlib doesn't provide these, so kludge them in following the same
            // const naming scheme zlib uses.
            binding.Z_MIN_WINDOWBITS = 8;
            binding.Z_MAX_WINDOWBITS = 15;
            binding.Z_DEFAULT_WINDOWBITS = 15;

            // fewer than 64 bytes per chunk is stupid.
            // technically it could work with as few as 8, but even 64 bytes
            // is absurdly low.  Usually a MB or more is best.
            binding.Z_MIN_CHUNK = 64;
            binding.Z_MAX_CHUNK = Infinity;
            binding.Z_DEFAULT_CHUNK = (16 * 1024);

            binding.Z_MIN_MEMLEVEL = 1;
            binding.Z_MAX_MEMLEVEL = 9;
            binding.Z_DEFAULT_MEMLEVEL = 8;

            binding.Z_MIN_LEVEL = -1;
            binding.Z_MAX_LEVEL = 9;
            binding.Z_DEFAULT_LEVEL = binding.Z_DEFAULT_COMPRESSION;


            // translation table for return codes.
            var codes = {
              Z_OK: binding.Z_OK,
              Z_STREAM_END: binding.Z_STREAM_END,
              Z_NEED_DICT: binding.Z_NEED_DICT,
              Z_ERRNO: binding.Z_ERRNO,
              Z_STREAM_ERROR: binding.Z_STREAM_ERROR,
              Z_DATA_ERROR: binding.Z_DATA_ERROR,
              Z_MEM_ERROR: binding.Z_MEM_ERROR,
              Z_BUF_ERROR: binding.Z_BUF_ERROR,
              Z_VERSION_ERROR: binding.Z_VERSION_ERROR
            };

            Object.keys(codes).forEach(function(k) {
              codes[codes[k]] = k;
            });

            function createDeflate(o) {
              return new Deflate(o);
            }

            function createInflate(o) {
              return new Inflate(o);
            }

            function createDeflateRaw(o) {
              return new DeflateRaw(o);
            }

            function createInflateRaw(o) {
              return new InflateRaw(o);
            }

            function createGzip(o) {
              return new Gzip(o);
            }

            function createGunzip(o) {
              return new Gunzip(o);
            }

            function createUnzip(o) {
              return new Unzip(o);
            }


            // Convenience methods.
            // compress/decompress a string or buffer in one step.
            function deflate(buffer, opts, callback) {
              if (typeof opts === 'function') {
                callback = opts;
                opts = {};
              }
              return zlibBuffer(new Deflate(opts), buffer, callback);
            }

            function deflateSync(buffer, opts) {
              return zlibBufferSync(new Deflate(opts), buffer);
            }

            function gzip(buffer, opts, callback) {
              if (typeof opts === 'function') {
                callback = opts;
                opts = {};
              }
              return zlibBuffer(new Gzip(opts), buffer, callback);
            }

            function gzipSync(buffer, opts) {
              return zlibBufferSync(new Gzip(opts), buffer);
            }

            function deflateRaw(buffer, opts, callback) {
              if (typeof opts === 'function') {
                callback = opts;
                opts = {};
              }
              return zlibBuffer(new DeflateRaw(opts), buffer, callback);
            }

            function deflateRawSync(buffer, opts) {
              return zlibBufferSync(new DeflateRaw(opts), buffer);
            }

            function unzip(buffer, opts, callback) {
              if (typeof opts === 'function') {
                callback = opts;
                opts = {};
              }
              return zlibBuffer(new Unzip(opts), buffer, callback);
            }

            function unzipSync(buffer, opts) {
              return zlibBufferSync(new Unzip(opts), buffer);
            }

            function inflate(buffer, opts, callback) {
              if (typeof opts === 'function') {
                callback = opts;
                opts = {};
              }
              return zlibBuffer(new Inflate(opts), buffer, callback);
            }

            function inflateSync(buffer, opts) {
              return zlibBufferSync(new Inflate(opts), buffer);
            }

            function gunzip(buffer, opts, callback) {
              if (typeof opts === 'function') {
                callback = opts;
                opts = {};
              }
              return zlibBuffer(new Gunzip(opts), buffer, callback);
            }

            function gunzipSync(buffer, opts) {
              return zlibBufferSync(new Gunzip(opts), buffer);
            }

            function inflateRaw(buffer, opts, callback) {
              if (typeof opts === 'function') {
                callback = opts;
                opts = {};
              }
              return zlibBuffer(new InflateRaw(opts), buffer, callback);
            }

            function inflateRawSync(buffer, opts) {
              return zlibBufferSync(new InflateRaw(opts), buffer);
            }

            function zlibBuffer(engine, buffer, callback) {
              var buffers = [];
              var nread = 0;

              engine.on('error', onError);
              engine.on('end', onEnd);

              engine.end(buffer);
              flow();

              function flow() {
                var chunk;
                while (null !== (chunk = engine.read())) {
                  buffers.push(chunk);
                  nread += chunk.length;
                }
                engine.once('readable', flow);
              }

              function onError(err) {
                engine.removeListener('end', onEnd);
                engine.removeListener('readable', flow);
                callback(err);
              }

              function onEnd() {
                var buf = Buffer$1.concat(buffers, nread);
                buffers = [];
                callback(null, buf);
                engine.close();
              }
            }

            function zlibBufferSync(engine, buffer) {
              if (typeof buffer === 'string')
                buffer = new Buffer$1(buffer);
              if (!Buffer$1.isBuffer(buffer))
                throw new TypeError('Not a string or buffer');

              var flushFlag = binding.Z_FINISH;

              return engine._processChunk(buffer, flushFlag);
            }

            // generic zlib
            // minimal 2-byte header
            function Deflate(opts) {
              if (!(this instanceof Deflate)) return new Deflate(opts);
              Zlib.call(this, opts, binding.DEFLATE);
            }

            function Inflate(opts) {
              if (!(this instanceof Inflate)) return new Inflate(opts);
              Zlib.call(this, opts, binding.INFLATE);
            }



            // gzip - bigger header, same deflate compression
            function Gzip(opts) {
              if (!(this instanceof Gzip)) return new Gzip(opts);
              Zlib.call(this, opts, binding.GZIP);
            }

            function Gunzip(opts) {
              if (!(this instanceof Gunzip)) return new Gunzip(opts);
              Zlib.call(this, opts, binding.GUNZIP);
            }



            // raw - no header
            function DeflateRaw(opts) {
              if (!(this instanceof DeflateRaw)) return new DeflateRaw(opts);
              Zlib.call(this, opts, binding.DEFLATERAW);
            }

            function InflateRaw(opts) {
              if (!(this instanceof InflateRaw)) return new InflateRaw(opts);
              Zlib.call(this, opts, binding.INFLATERAW);
            }


            // auto-detect header.
            function Unzip(opts) {
              if (!(this instanceof Unzip)) return new Unzip(opts);
              Zlib.call(this, opts, binding.UNZIP);
            }


            // the Zlib class they all inherit from
            // This thing manages the queue of requests, and returns
            // true or false if there is anything in the queue when
            // you call the .write() method.

            function Zlib(opts, mode) {
              this._opts = opts = opts || {};
              this._chunkSize = opts.chunkSize || binding.Z_DEFAULT_CHUNK;

              Transform.call(this, opts);

              if (opts.flush) {
                if (opts.flush !== binding.Z_NO_FLUSH &&
                    opts.flush !== binding.Z_PARTIAL_FLUSH &&
                    opts.flush !== binding.Z_SYNC_FLUSH &&
                    opts.flush !== binding.Z_FULL_FLUSH &&
                    opts.flush !== binding.Z_FINISH &&
                    opts.flush !== binding.Z_BLOCK) {
                  throw new Error('Invalid flush flag: ' + opts.flush);
                }
              }
              this._flushFlag = opts.flush || binding.Z_NO_FLUSH;

              if (opts.chunkSize) {
                if (opts.chunkSize < binding.Z_MIN_CHUNK ||
                    opts.chunkSize > binding.Z_MAX_CHUNK) {
                  throw new Error('Invalid chunk size: ' + opts.chunkSize);
                }
              }

              if (opts.windowBits) {
                if (opts.windowBits < binding.Z_MIN_WINDOWBITS ||
                    opts.windowBits > binding.Z_MAX_WINDOWBITS) {
                  throw new Error('Invalid windowBits: ' + opts.windowBits);
                }
              }

              if (opts.level) {
                if (opts.level < binding.Z_MIN_LEVEL ||
                    opts.level > binding.Z_MAX_LEVEL) {
                  throw new Error('Invalid compression level: ' + opts.level);
                }
              }

              if (opts.memLevel) {
                if (opts.memLevel < binding.Z_MIN_MEMLEVEL ||
                    opts.memLevel > binding.Z_MAX_MEMLEVEL) {
                  throw new Error('Invalid memLevel: ' + opts.memLevel);
                }
              }

              if (opts.strategy) {
                if (opts.strategy != binding.Z_FILTERED &&
                    opts.strategy != binding.Z_HUFFMAN_ONLY &&
                    opts.strategy != binding.Z_RLE &&
                    opts.strategy != binding.Z_FIXED &&
                    opts.strategy != binding.Z_DEFAULT_STRATEGY) {
                  throw new Error('Invalid strategy: ' + opts.strategy);
                }
              }

              if (opts.dictionary) {
                if (!Buffer$1.isBuffer(opts.dictionary)) {
                  throw new Error('Invalid dictionary: it should be a Buffer instance');
                }
              }

              this._binding = new binding.Zlib(mode);

              var self = this;
              this._hadError = false;
              this._binding.onerror = function(message, errno) {
                // there is no way to cleanly recover.
                // continuing only obscures problems.
                self._binding = null;
                self._hadError = true;

                var error = new Error(message);
                error.errno = errno;
                error.code = binding.codes[errno];
                self.emit('error', error);
              };

              var level = binding.Z_DEFAULT_COMPRESSION;
              if (typeof opts.level === 'number') level = opts.level;

              var strategy = binding.Z_DEFAULT_STRATEGY;
              if (typeof opts.strategy === 'number') strategy = opts.strategy;

              this._binding.init(opts.windowBits || binding.Z_DEFAULT_WINDOWBITS,
                                 level,
                                 opts.memLevel || binding.Z_DEFAULT_MEMLEVEL,
                                 strategy,
                                 opts.dictionary);

              this._buffer = new Buffer$1(this._chunkSize);
              this._offset = 0;
              this._closed = false;
              this._level = level;
              this._strategy = strategy;

              this.once('end', this.close);
            }

            inherits$1(Zlib, Transform);

            Zlib.prototype.params = function(level, strategy, callback) {
              if (level < binding.Z_MIN_LEVEL ||
                  level > binding.Z_MAX_LEVEL) {
                throw new RangeError('Invalid compression level: ' + level);
              }
              if (strategy != binding.Z_FILTERED &&
                  strategy != binding.Z_HUFFMAN_ONLY &&
                  strategy != binding.Z_RLE &&
                  strategy != binding.Z_FIXED &&
                  strategy != binding.Z_DEFAULT_STRATEGY) {
                throw new TypeError('Invalid strategy: ' + strategy);
              }

              if (this._level !== level || this._strategy !== strategy) {
                var self = this;
                this.flush(binding.Z_SYNC_FLUSH, function() {
                  self._binding.params(level, strategy);
                  if (!self._hadError) {
                    self._level = level;
                    self._strategy = strategy;
                    if (callback) callback();
                  }
                });
              } else {
                browser$1.nextTick(callback);
              }
            };

            Zlib.prototype.reset = function() {
              return this._binding.reset();
            };

            // This is the _flush function called by the transform class,
            // internally, when the last chunk has been written.
            Zlib.prototype._flush = function(callback) {
              this._transform(new Buffer$1(0), '', callback);
            };

            Zlib.prototype.flush = function(kind, callback) {
              var ws = this._writableState;

              if (typeof kind === 'function' || (kind === void 0 && !callback)) {
                callback = kind;
                kind = binding.Z_FULL_FLUSH;
              }

              if (ws.ended) {
                if (callback)
                  browser$1.nextTick(callback);
              } else if (ws.ending) {
                if (callback)
                  this.once('end', callback);
              } else if (ws.needDrain) {
                var self = this;
                this.once('drain', function() {
                  self.flush(callback);
                });
              } else {
                this._flushFlag = kind;
                this.write(new Buffer$1(0), '', callback);
              }
            };

            Zlib.prototype.close = function(callback) {
              if (callback)
                browser$1.nextTick(callback);

              if (this._closed)
                return;

              this._closed = true;

              this._binding.close();

              var self = this;
              browser$1.nextTick(function() {
                self.emit('close');
              });
            };

            Zlib.prototype._transform = function(chunk, encoding, cb) {
              var flushFlag;
              var ws = this._writableState;
              var ending = ws.ending || ws.ended;
              var last = ending && (!chunk || ws.length === chunk.length);

              if (!chunk === null && !Buffer$1.isBuffer(chunk))
                return cb(new Error('invalid input'));

              // If it's the last chunk, or a final flush, we use the Z_FINISH flush flag.
              // If it's explicitly flushing at some other time, then we use
              // Z_FULL_FLUSH. Otherwise, use Z_NO_FLUSH for maximum compression
              // goodness.
              if (last)
                flushFlag = binding.Z_FINISH;
              else {
                flushFlag = this._flushFlag;
                // once we've flushed the last of the queue, stop flushing and
                // go back to the normal behavior.
                if (chunk.length >= ws.length) {
                  this._flushFlag = this._opts.flush || binding.Z_NO_FLUSH;
                }
              }

              this._processChunk(chunk, flushFlag, cb);
            };

            Zlib.prototype._processChunk = function(chunk, flushFlag, cb) {
              var availInBefore = chunk && chunk.length;
              var availOutBefore = this._chunkSize - this._offset;
              var inOff = 0;

              var self = this;

              var async = typeof cb === 'function';

              if (!async) {
                var buffers = [];
                var nread = 0;

                var error;
                this.on('error', function(er) {
                  error = er;
                });

                do {
                  var res = this._binding.writeSync(flushFlag,
                                                    chunk, // in
                                                    inOff, // in_off
                                                    availInBefore, // in_len
                                                    this._buffer, // out
                                                    this._offset, //out_off
                                                    availOutBefore); // out_len
                } while (!this._hadError && callback(res[0], res[1]));

                if (this._hadError) {
                  throw error;
                }

                var buf = Buffer$1.concat(buffers, nread);
                this.close();

                return buf;
              }

              var req = this._binding.write(flushFlag,
                                            chunk, // in
                                            inOff, // in_off
                                            availInBefore, // in_len
                                            this._buffer, // out
                                            this._offset, //out_off
                                            availOutBefore); // out_len

              req.buffer = chunk;
              req.callback = callback;

              function callback(availInAfter, availOutAfter) {
                if (self._hadError)
                  return;

                var have = availOutBefore - availOutAfter;
                assert(have >= 0, 'have should not go down');

                if (have > 0) {
                  var out = self._buffer.slice(self._offset, self._offset + have);
                  self._offset += have;
                  // serve some output to the consumer.
                  if (async) {
                    self.push(out);
                  } else {
                    buffers.push(out);
                    nread += out.length;
                  }
                }

                // exhausted the output buffer, or used all the input create a new one.
                if (availOutAfter === 0 || self._offset >= self._chunkSize) {
                  availOutBefore = self._chunkSize;
                  self._offset = 0;
                  self._buffer = new Buffer$1(self._chunkSize);
                }

                if (availOutAfter === 0) {
                  // Not actually done.  Need to reprocess.
                  // Also, update the availInBefore to the availInAfter value,
                  // so that if we have to hit it a third (fourth, etc.) time,
                  // it'll have the correct byte counts.
                  inOff += (availInBefore - availInAfter);
                  availInBefore = availInAfter;

                  if (!async)
                    return true;

                  var newReq = self._binding.write(flushFlag,
                                                   chunk,
                                                   inOff,
                                                   availInBefore,
                                                   self._buffer,
                                                   self._offset,
                                                   self._chunkSize);
                  newReq.callback = callback; // this same function
                  newReq.buffer = chunk;
                  return;
                }

                if (!async)
                  return false;

                // finished with the chunk.
                cb();
              }
            };

            inherits$1(Deflate, Zlib);
            inherits$1(Inflate, Zlib);
            inherits$1(Gzip, Zlib);
            inherits$1(Gunzip, Zlib);
            inherits$1(DeflateRaw, Zlib);
            inherits$1(InflateRaw, Zlib);
            inherits$1(Unzip, Zlib);
            var zlib = {
              codes: codes,
              createDeflate: createDeflate,
              createInflate: createInflate,
              createDeflateRaw: createDeflateRaw,
              createInflateRaw: createInflateRaw,
              createGzip: createGzip,
              createGunzip: createGunzip,
              createUnzip: createUnzip,
              deflate: deflate,
              deflateSync: deflateSync,
              gzip: gzip,
              gzipSync: gzipSync,
              deflateRaw: deflateRaw,
              deflateRawSync: deflateRawSync,
              unzip: unzip,
              unzipSync: unzipSync,
              inflate: inflate,
              inflateSync: inflateSync,
              gunzip: gunzip,
              gunzipSync: gunzipSync,
              inflateRaw: inflateRaw,
              inflateRawSync: inflateRawSync,
              Deflate: Deflate,
              Inflate: Inflate,
              Gzip: Gzip,
              Gunzip: Gunzip,
              DeflateRaw: DeflateRaw,
              InflateRaw: InflateRaw,
              Unzip: Unzip,
              Zlib: Zlib
            };

            // Based on https://github.com/tmpvar/jsdom/blob/aa85b2abf07766ff7bf5c1f6daafb3726f2f2db5/lib/jsdom/living/blob.js

            // fix for "Readable" isn't a named export issue
            const Readable = Stream.Readable;

            const BUFFER = Symbol('buffer');
            const TYPE = Symbol('type');

            class Blob {
            	constructor() {
            		this[TYPE] = '';

            		const blobParts = arguments[0];
            		const options = arguments[1];

            		const buffers = [];
            		let size = 0;

            		if (blobParts) {
            			const a = blobParts;
            			const length = Number(a.length);
            			for (let i = 0; i < length; i++) {
            				const element = a[i];
            				let buffer;
            				if (element instanceof Buffer) {
            					buffer = element;
            				} else if (ArrayBuffer.isView(element)) {
            					buffer = Buffer.from(element.buffer, element.byteOffset, element.byteLength);
            				} else if (element instanceof ArrayBuffer) {
            					buffer = Buffer.from(element);
            				} else if (element instanceof Blob) {
            					buffer = element[BUFFER];
            				} else {
            					buffer = Buffer.from(typeof element === 'string' ? element : String(element));
            				}
            				size += buffer.length;
            				buffers.push(buffer);
            			}
            		}

            		this[BUFFER] = Buffer.concat(buffers);

            		let type = options && options.type !== undefined && String(options.type).toLowerCase();
            		if (type && !/[^\u0020-\u007E]/.test(type)) {
            			this[TYPE] = type;
            		}
            	}
            	get size() {
            		return this[BUFFER].length;
            	}
            	get type() {
            		return this[TYPE];
            	}
            	text() {
            		return Promise.resolve(this[BUFFER].toString());
            	}
            	arrayBuffer() {
            		const buf = this[BUFFER];
            		const ab = buf.buffer.slice(buf.byteOffset, buf.byteOffset + buf.byteLength);
            		return Promise.resolve(ab);
            	}
            	stream() {
            		const readable = new Readable();
            		readable._read = function () {};
            		readable.push(this[BUFFER]);
            		readable.push(null);
            		return readable;
            	}
            	toString() {
            		return '[object Blob]';
            	}
            	slice() {
            		const size = this.size;

            		const start = arguments[0];
            		const end = arguments[1];
            		let relativeStart, relativeEnd;
            		if (start === undefined) {
            			relativeStart = 0;
            		} else if (start < 0) {
            			relativeStart = Math.max(size + start, 0);
            		} else {
            			relativeStart = Math.min(start, size);
            		}
            		if (end === undefined) {
            			relativeEnd = size;
            		} else if (end < 0) {
            			relativeEnd = Math.max(size + end, 0);
            		} else {
            			relativeEnd = Math.min(end, size);
            		}
            		const span = Math.max(relativeEnd - relativeStart, 0);

            		const buffer = this[BUFFER];
            		const slicedBuffer = buffer.slice(relativeStart, relativeStart + span);
            		const blob = new Blob([], { type: arguments[2] });
            		blob[BUFFER] = slicedBuffer;
            		return blob;
            	}
            }

            Object.defineProperties(Blob.prototype, {
            	size: { enumerable: true },
            	type: { enumerable: true },
            	slice: { enumerable: true }
            });

            Object.defineProperty(Blob.prototype, Symbol.toStringTag, {
            	value: 'Blob',
            	writable: false,
            	enumerable: false,
            	configurable: true
            });

            /**
             * fetch-error.js
             *
             * FetchError interface for operational errors
             */

            /**
             * Create FetchError instance
             *
             * @param   String      message      Error message for human
             * @param   String      type         Error type for machine
             * @param   String      systemError  For Node.js system error
             * @return  FetchError
             */
            function FetchError(message, type, systemError) {
              Error.call(this, message);

              this.message = message;
              this.type = type;

              // when err.type is `system`, err.code contains system error code
              if (systemError) {
                this.code = this.errno = systemError.code;
              }

              // hide custom error implementation details from end-users
              Error.captureStackTrace(this, this.constructor);
            }

            FetchError.prototype = Object.create(Error.prototype);
            FetchError.prototype.constructor = FetchError;
            FetchError.prototype.name = 'FetchError';

            let convert;
            try {
            	convert = require('encoding').convert;
            } catch (e) {}

            const INTERNALS = Symbol('Body internals');

            // fix an issue where "PassThrough" isn't a named export for node <10
            const PassThrough = Stream.PassThrough;

            /**
             * Body mixin
             *
             * Ref: https://fetch.spec.whatwg.org/#body
             *
             * @param   Stream  body  Readable stream
             * @param   Object  opts  Response options
             * @return  Void
             */
            function Body(body) {
            	var _this = this;

            	var _ref = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {},
            	    _ref$size = _ref.size;

            	let size = _ref$size === undefined ? 0 : _ref$size;
            	var _ref$timeout = _ref.timeout;
            	let timeout = _ref$timeout === undefined ? 0 : _ref$timeout;

            	if (body == null) {
            		// body is undefined or null
            		body = null;
            	} else if (isURLSearchParams(body)) {
            		// body is a URLSearchParams
            		body = Buffer.from(body.toString());
            	} else if (isBlob(body)) ; else if (Buffer.isBuffer(body)) ; else if (Object.prototype.toString.call(body) === '[object ArrayBuffer]') {
            		// body is ArrayBuffer
            		body = Buffer.from(body);
            	} else if (ArrayBuffer.isView(body)) {
            		// body is ArrayBufferView
            		body = Buffer.from(body.buffer, body.byteOffset, body.byteLength);
            	} else if (body instanceof Stream) ; else {
            		// none of the above
            		// coerce to string then buffer
            		body = Buffer.from(String(body));
            	}
            	this[INTERNALS] = {
            		body,
            		disturbed: false,
            		error: null
            	};
            	this.size = size;
            	this.timeout = timeout;

            	if (body instanceof Stream) {
            		body.on('error', function (err) {
            			const error = err.name === 'AbortError' ? err : new FetchError(`Invalid response body while trying to fetch ${_this.url}: ${err.message}`, 'system', err);
            			_this[INTERNALS].error = error;
            		});
            	}
            }

            Body.prototype = {
            	get body() {
            		return this[INTERNALS].body;
            	},

            	get bodyUsed() {
            		return this[INTERNALS].disturbed;
            	},

            	/**
              * Decode response as ArrayBuffer
              *
              * @return  Promise
              */
            	arrayBuffer() {
            		return consumeBody.call(this).then(function (buf) {
            			return buf.buffer.slice(buf.byteOffset, buf.byteOffset + buf.byteLength);
            		});
            	},

            	/**
              * Return raw response as Blob
              *
              * @return Promise
              */
            	blob() {
            		let ct = this.headers && this.headers.get('content-type') || '';
            		return consumeBody.call(this).then(function (buf) {
            			return Object.assign(
            			// Prevent copying
            			new Blob([], {
            				type: ct.toLowerCase()
            			}), {
            				[BUFFER]: buf
            			});
            		});
            	},

            	/**
              * Decode response as json
              *
              * @return  Promise
              */
            	json() {
            		var _this2 = this;

            		return consumeBody.call(this).then(function (buffer) {
            			try {
            				return JSON.parse(buffer.toString());
            			} catch (err) {
            				return Body.Promise.reject(new FetchError(`invalid json response body at ${_this2.url} reason: ${err.message}`, 'invalid-json'));
            			}
            		});
            	},

            	/**
              * Decode response as text
              *
              * @return  Promise
              */
            	text() {
            		return consumeBody.call(this).then(function (buffer) {
            			return buffer.toString();
            		});
            	},

            	/**
              * Decode response as buffer (non-spec api)
              *
              * @return  Promise
              */
            	buffer() {
            		return consumeBody.call(this);
            	},

            	/**
              * Decode response as text, while automatically detecting the encoding and
              * trying to decode to UTF-8 (non-spec api)
              *
              * @return  Promise
              */
            	textConverted() {
            		var _this3 = this;

            		return consumeBody.call(this).then(function (buffer) {
            			return convertBody(buffer, _this3.headers);
            		});
            	}
            };

            // In browsers, all properties are enumerable.
            Object.defineProperties(Body.prototype, {
            	body: { enumerable: true },
            	bodyUsed: { enumerable: true },
            	arrayBuffer: { enumerable: true },
            	blob: { enumerable: true },
            	json: { enumerable: true },
            	text: { enumerable: true }
            });

            Body.mixIn = function (proto) {
            	for (const name of Object.getOwnPropertyNames(Body.prototype)) {
            		// istanbul ignore else: future proof
            		if (!(name in proto)) {
            			const desc = Object.getOwnPropertyDescriptor(Body.prototype, name);
            			Object.defineProperty(proto, name, desc);
            		}
            	}
            };

            /**
             * Consume and convert an entire Body to a Buffer.
             *
             * Ref: https://fetch.spec.whatwg.org/#concept-body-consume-body
             *
             * @return  Promise
             */
            function consumeBody() {
            	var _this4 = this;

            	if (this[INTERNALS].disturbed) {
            		return Body.Promise.reject(new TypeError(`body used already for: ${this.url}`));
            	}

            	this[INTERNALS].disturbed = true;

            	if (this[INTERNALS].error) {
            		return Body.Promise.reject(this[INTERNALS].error);
            	}

            	let body = this.body;

            	// body is null
            	if (body === null) {
            		return Body.Promise.resolve(Buffer.alloc(0));
            	}

            	// body is blob
            	if (isBlob(body)) {
            		body = body.stream();
            	}

            	// body is buffer
            	if (Buffer.isBuffer(body)) {
            		return Body.Promise.resolve(body);
            	}

            	// istanbul ignore if: should never happen
            	if (!(body instanceof Stream)) {
            		return Body.Promise.resolve(Buffer.alloc(0));
            	}

            	// body is stream
            	// get ready to actually consume the body
            	let accum = [];
            	let accumBytes = 0;
            	let abort = false;

            	return new Body.Promise(function (resolve, reject) {
            		let resTimeout;

            		// allow timeout on slow response body
            		if (_this4.timeout) {
            			resTimeout = setTimeout(function () {
            				abort = true;
            				reject(new FetchError(`Response timeout while trying to fetch ${_this4.url} (over ${_this4.timeout}ms)`, 'body-timeout'));
            			}, _this4.timeout);
            		}

            		// handle stream errors
            		body.on('error', function (err) {
            			if (err.name === 'AbortError') {
            				// if the request was aborted, reject with this Error
            				abort = true;
            				reject(err);
            			} else {
            				// other errors, such as incorrect content-encoding
            				reject(new FetchError(`Invalid response body while trying to fetch ${_this4.url}: ${err.message}`, 'system', err));
            			}
            		});

            		body.on('data', function (chunk) {
            			if (abort || chunk === null) {
            				return;
            			}

            			if (_this4.size && accumBytes + chunk.length > _this4.size) {
            				abort = true;
            				reject(new FetchError(`content size at ${_this4.url} over limit: ${_this4.size}`, 'max-size'));
            				return;
            			}

            			accumBytes += chunk.length;
            			accum.push(chunk);
            		});

            		body.on('end', function () {
            			if (abort) {
            				return;
            			}

            			clearTimeout(resTimeout);

            			try {
            				resolve(Buffer.concat(accum, accumBytes));
            			} catch (err) {
            				// handle streams that have accumulated too much data (issue #414)
            				reject(new FetchError(`Could not create Buffer from response body for ${_this4.url}: ${err.message}`, 'system', err));
            			}
            		});
            	});
            }

            /**
             * Detect buffer encoding and convert to target encoding
             * ref: http://www.w3.org/TR/2011/WD-html5-20110113/parsing.html#determining-the-character-encoding
             *
             * @param   Buffer  buffer    Incoming buffer
             * @param   String  encoding  Target encoding
             * @return  String
             */
            function convertBody(buffer, headers) {
            	if (typeof convert !== 'function') {
            		throw new Error('The package `encoding` must be installed to use the textConverted() function');
            	}

            	const ct = headers.get('content-type');
            	let charset = 'utf-8';
            	let res, str;

            	// header
            	if (ct) {
            		res = /charset=([^;]*)/i.exec(ct);
            	}

            	// no charset in content type, peek at response body for at most 1024 bytes
            	str = buffer.slice(0, 1024).toString();

            	// html5
            	if (!res && str) {
            		res = /<meta.+?charset=(['"])(.+?)\1/i.exec(str);
            	}

            	// html4
            	if (!res && str) {
            		res = /<meta[\s]+?http-equiv=(['"])content-type\1[\s]+?content=(['"])(.+?)\2/i.exec(str);
            		if (!res) {
            			res = /<meta[\s]+?content=(['"])(.+?)\1[\s]+?http-equiv=(['"])content-type\3/i.exec(str);
            			if (res) {
            				res.pop(); // drop last quote
            			}
            		}

            		if (res) {
            			res = /charset=(.*)/i.exec(res.pop());
            		}
            	}

            	// xml
            	if (!res && str) {
            		res = /<\?xml.+?encoding=(['"])(.+?)\1/i.exec(str);
            	}

            	// found charset
            	if (res) {
            		charset = res.pop();

            		// prevent decode issues when sites use incorrect encoding
            		// ref: https://hsivonen.fi/encoding-menu/
            		if (charset === 'gb2312' || charset === 'gbk') {
            			charset = 'gb18030';
            		}
            	}

            	// turn raw buffers into a single utf-8 buffer
            	return convert(buffer, 'UTF-8', charset).toString();
            }

            /**
             * Detect a URLSearchParams object
             * ref: https://github.com/bitinn/node-fetch/issues/296#issuecomment-307598143
             *
             * @param   Object  obj     Object to detect by type or brand
             * @return  String
             */
            function isURLSearchParams(obj) {
            	// Duck-typing as a necessary condition.
            	if (typeof obj !== 'object' || typeof obj.append !== 'function' || typeof obj.delete !== 'function' || typeof obj.get !== 'function' || typeof obj.getAll !== 'function' || typeof obj.has !== 'function' || typeof obj.set !== 'function') {
            		return false;
            	}

            	// Brand-checking and more duck-typing as optional condition.
            	return obj.constructor.name === 'URLSearchParams' || Object.prototype.toString.call(obj) === '[object URLSearchParams]' || typeof obj.sort === 'function';
            }

            /**
             * Check if `obj` is a W3C `Blob` object (which `File` inherits from)
             * @param  {*} obj
             * @return {boolean}
             */
            function isBlob(obj) {
            	return typeof obj === 'object' && typeof obj.arrayBuffer === 'function' && typeof obj.type === 'string' && typeof obj.stream === 'function' && typeof obj.constructor === 'function' && typeof obj.constructor.name === 'string' && /^(Blob|File)$/.test(obj.constructor.name) && /^(Blob|File)$/.test(obj[Symbol.toStringTag]);
            }

            /**
             * Clone body given Res/Req instance
             *
             * @param   Mixed  instance  Response or Request instance
             * @return  Mixed
             */
            function clone(instance) {
            	let p1, p2;
            	let body = instance.body;

            	// don't allow cloning a used body
            	if (instance.bodyUsed) {
            		throw new Error('cannot clone body after it is used');
            	}

            	// check that body is a stream and not form-data object
            	// note: we can't clone the form-data object without having it as a dependency
            	if (body instanceof Stream && typeof body.getBoundary !== 'function') {
            		// tee instance body
            		p1 = new PassThrough();
            		p2 = new PassThrough();
            		body.pipe(p1);
            		body.pipe(p2);
            		// set instance body to teed body and return the other teed body
            		instance[INTERNALS].body = p1;
            		body = p2;
            	}

            	return body;
            }

            /**
             * Performs the operation "extract a `Content-Type` value from |object|" as
             * specified in the specification:
             * https://fetch.spec.whatwg.org/#concept-bodyinit-extract
             *
             * This function assumes that instance.body is present.
             *
             * @param   Mixed  instance  Any options.body input
             */
            function extractContentType(body) {
            	if (body === null) {
            		// body is null
            		return null;
            	} else if (typeof body === 'string') {
            		// body is string
            		return 'text/plain;charset=UTF-8';
            	} else if (isURLSearchParams(body)) {
            		// body is a URLSearchParams
            		return 'application/x-www-form-urlencoded;charset=UTF-8';
            	} else if (isBlob(body)) {
            		// body is blob
            		return body.type || null;
            	} else if (Buffer.isBuffer(body)) {
            		// body is buffer
            		return null;
            	} else if (Object.prototype.toString.call(body) === '[object ArrayBuffer]') {
            		// body is ArrayBuffer
            		return null;
            	} else if (ArrayBuffer.isView(body)) {
            		// body is ArrayBufferView
            		return null;
            	} else if (typeof body.getBoundary === 'function') {
            		// detect form data input from form-data module
            		return `multipart/form-data;boundary=${body.getBoundary()}`;
            	} else if (body instanceof Stream) {
            		// body is stream
            		// can't really do much about this
            		return null;
            	} else {
            		// Body constructor defaults other things to string
            		return 'text/plain;charset=UTF-8';
            	}
            }

            /**
             * The Fetch Standard treats this as if "total bytes" is a property on the body.
             * For us, we have to explicitly get it with a function.
             *
             * ref: https://fetch.spec.whatwg.org/#concept-body-total-bytes
             *
             * @param   Body    instance   Instance of Body
             * @return  Number?            Number of bytes, or null if not possible
             */
            function getTotalBytes(instance) {
            	const body = instance.body;


            	if (body === null) {
            		// body is null
            		return 0;
            	} else if (isBlob(body)) {
            		return body.size;
            	} else if (Buffer.isBuffer(body)) {
            		// body is buffer
            		return body.length;
            	} else if (body && typeof body.getLengthSync === 'function') {
            		// detect form data input from form-data module
            		if (body._lengthRetrievers && body._lengthRetrievers.length == 0 || // 1.x
            		body.hasKnownLength && body.hasKnownLength()) {
            			// 2.x
            			return body.getLengthSync();
            		}
            		return null;
            	} else {
            		// body is stream
            		return null;
            	}
            }

            /**
             * Write a Body to a Node.js WritableStream (e.g. http.Request) object.
             *
             * @param   Body    instance   Instance of Body
             * @return  Void
             */
            function writeToStream(dest, instance) {
            	const body = instance.body;


            	if (body === null) {
            		// body is null
            		dest.end();
            	} else if (isBlob(body)) {
            		body.stream().pipe(dest);
            	} else if (Buffer.isBuffer(body)) {
            		// body is buffer
            		dest.write(body);
            		dest.end();
            	} else {
            		// body is stream
            		body.pipe(dest);
            	}
            }

            // expose Promise
            Body.Promise = global.Promise;

            /**
             * headers.js
             *
             * Headers class offers convenient helpers
             */

            const invalidTokenRegex = /[^\^_`a-zA-Z\-0-9!#$%&'*+.|~]/;
            const invalidHeaderCharRegex = /[^\t\x20-\x7e\x80-\xff]/;

            function validateName(name) {
            	name = `${name}`;
            	if (invalidTokenRegex.test(name) || name === '') {
            		throw new TypeError(`${name} is not a legal HTTP header name`);
            	}
            }

            function validateValue(value) {
            	value = `${value}`;
            	if (invalidHeaderCharRegex.test(value)) {
            		throw new TypeError(`${value} is not a legal HTTP header value`);
            	}
            }

            /**
             * Find the key in the map object given a header name.
             *
             * Returns undefined if not found.
             *
             * @param   String  name  Header name
             * @return  String|Undefined
             */
            function find(map, name) {
            	name = name.toLowerCase();
            	for (const key in map) {
            		if (key.toLowerCase() === name) {
            			return key;
            		}
            	}
            	return undefined;
            }

            const MAP = Symbol('map');
            class Headers {
            	/**
              * Headers class
              *
              * @param   Object  headers  Response headers
              * @return  Void
              */
            	constructor() {
            		let init = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : undefined;

            		this[MAP] = Object.create(null);

            		if (init instanceof Headers) {
            			const rawHeaders = init.raw();
            			const headerNames = Object.keys(rawHeaders);

            			for (const headerName of headerNames) {
            				for (const value of rawHeaders[headerName]) {
            					this.append(headerName, value);
            				}
            			}

            			return;
            		}

            		// We don't worry about converting prop to ByteString here as append()
            		// will handle it.
            		if (init == null) ; else if (typeof init === 'object') {
            			const method = init[Symbol.iterator];
            			if (method != null) {
            				if (typeof method !== 'function') {
            					throw new TypeError('Header pairs must be iterable');
            				}

            				// sequence<sequence<ByteString>>
            				// Note: per spec we have to first exhaust the lists then process them
            				const pairs = [];
            				for (const pair of init) {
            					if (typeof pair !== 'object' || typeof pair[Symbol.iterator] !== 'function') {
            						throw new TypeError('Each header pair must be iterable');
            					}
            					pairs.push(Array.from(pair));
            				}

            				for (const pair of pairs) {
            					if (pair.length !== 2) {
            						throw new TypeError('Each header pair must be a name/value tuple');
            					}
            					this.append(pair[0], pair[1]);
            				}
            			} else {
            				// record<ByteString, ByteString>
            				for (const key of Object.keys(init)) {
            					const value = init[key];
            					this.append(key, value);
            				}
            			}
            		} else {
            			throw new TypeError('Provided initializer must be an object');
            		}
            	}

            	/**
              * Return combined header value given name
              *
              * @param   String  name  Header name
              * @return  Mixed
              */
            	get(name) {
            		name = `${name}`;
            		validateName(name);
            		const key = find(this[MAP], name);
            		if (key === undefined) {
            			return null;
            		}

            		return this[MAP][key].join(', ');
            	}

            	/**
              * Iterate over all headers
              *
              * @param   Function  callback  Executed for each item with parameters (value, name, thisArg)
              * @param   Boolean   thisArg   `this` context for callback function
              * @return  Void
              */
            	forEach(callback) {
            		let thisArg = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : undefined;

            		let pairs = getHeaders(this);
            		let i = 0;
            		while (i < pairs.length) {
            			var _pairs$i = pairs[i];
            			const name = _pairs$i[0],
            			      value = _pairs$i[1];

            			callback.call(thisArg, value, name, this);
            			pairs = getHeaders(this);
            			i++;
            		}
            	}

            	/**
              * Overwrite header values given name
              *
              * @param   String  name   Header name
              * @param   String  value  Header value
              * @return  Void
              */
            	set(name, value) {
            		name = `${name}`;
            		value = `${value}`;
            		validateName(name);
            		validateValue(value);
            		const key = find(this[MAP], name);
            		this[MAP][key !== undefined ? key : name] = [value];
            	}

            	/**
              * Append a value onto existing header
              *
              * @param   String  name   Header name
              * @param   String  value  Header value
              * @return  Void
              */
            	append(name, value) {
            		name = `${name}`;
            		value = `${value}`;
            		validateName(name);
            		validateValue(value);
            		const key = find(this[MAP], name);
            		if (key !== undefined) {
            			this[MAP][key].push(value);
            		} else {
            			this[MAP][name] = [value];
            		}
            	}

            	/**
              * Check for header name existence
              *
              * @param   String   name  Header name
              * @return  Boolean
              */
            	has(name) {
            		name = `${name}`;
            		validateName(name);
            		return find(this[MAP], name) !== undefined;
            	}

            	/**
              * Delete all header values given name
              *
              * @param   String  name  Header name
              * @return  Void
              */
            	delete(name) {
            		name = `${name}`;
            		validateName(name);
            		const key = find(this[MAP], name);
            		if (key !== undefined) {
            			delete this[MAP][key];
            		}
            	}

            	/**
              * Return raw headers (non-spec api)
              *
              * @return  Object
              */
            	raw() {
            		return this[MAP];
            	}

            	/**
              * Get an iterator on keys.
              *
              * @return  Iterator
              */
            	keys() {
            		return createHeadersIterator(this, 'key');
            	}

            	/**
              * Get an iterator on values.
              *
              * @return  Iterator
              */
            	values() {
            		return createHeadersIterator(this, 'value');
            	}

            	/**
              * Get an iterator on entries.
              *
              * This is the default iterator of the Headers object.
              *
              * @return  Iterator
              */
            	[Symbol.iterator]() {
            		return createHeadersIterator(this, 'key+value');
            	}
            }
            Headers.prototype.entries = Headers.prototype[Symbol.iterator];

            Object.defineProperty(Headers.prototype, Symbol.toStringTag, {
            	value: 'Headers',
            	writable: false,
            	enumerable: false,
            	configurable: true
            });

            Object.defineProperties(Headers.prototype, {
            	get: { enumerable: true },
            	forEach: { enumerable: true },
            	set: { enumerable: true },
            	append: { enumerable: true },
            	has: { enumerable: true },
            	delete: { enumerable: true },
            	keys: { enumerable: true },
            	values: { enumerable: true },
            	entries: { enumerable: true }
            });

            function getHeaders(headers) {
            	let kind = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 'key+value';

            	const keys = Object.keys(headers[MAP]).sort();
            	return keys.map(kind === 'key' ? function (k) {
            		return k.toLowerCase();
            	} : kind === 'value' ? function (k) {
            		return headers[MAP][k].join(', ');
            	} : function (k) {
            		return [k.toLowerCase(), headers[MAP][k].join(', ')];
            	});
            }

            const INTERNAL = Symbol('internal');

            function createHeadersIterator(target, kind) {
            	const iterator = Object.create(HeadersIteratorPrototype);
            	iterator[INTERNAL] = {
            		target,
            		kind,
            		index: 0
            	};
            	return iterator;
            }

            const HeadersIteratorPrototype = Object.setPrototypeOf({
            	next() {
            		// istanbul ignore if
            		if (!this || Object.getPrototypeOf(this) !== HeadersIteratorPrototype) {
            			throw new TypeError('Value of `this` is not a HeadersIterator');
            		}

            		var _INTERNAL = this[INTERNAL];
            		const target = _INTERNAL.target,
            		      kind = _INTERNAL.kind,
            		      index = _INTERNAL.index;

            		const values = getHeaders(target, kind);
            		const len = values.length;
            		if (index >= len) {
            			return {
            				value: undefined,
            				done: true
            			};
            		}

            		this[INTERNAL].index = index + 1;

            		return {
            			value: values[index],
            			done: false
            		};
            	}
            }, Object.getPrototypeOf(Object.getPrototypeOf([][Symbol.iterator]())));

            Object.defineProperty(HeadersIteratorPrototype, Symbol.toStringTag, {
            	value: 'HeadersIterator',
            	writable: false,
            	enumerable: false,
            	configurable: true
            });

            /**
             * Export the Headers object in a form that Node.js can consume.
             *
             * @param   Headers  headers
             * @return  Object
             */
            function exportNodeCompatibleHeaders(headers) {
            	const obj = Object.assign({ __proto__: null }, headers[MAP]);

            	// http.request() only supports string as Host header. This hack makes
            	// specifying custom Host header possible.
            	const hostHeaderKey = find(headers[MAP], 'Host');
            	if (hostHeaderKey !== undefined) {
            		obj[hostHeaderKey] = obj[hostHeaderKey][0];
            	}

            	return obj;
            }

            /**
             * Create a Headers object from an object of headers, ignoring those that do
             * not conform to HTTP grammar productions.
             *
             * @param   Object  obj  Object of headers
             * @return  Headers
             */
            function createHeadersLenient(obj) {
            	const headers = new Headers();
            	for (const name of Object.keys(obj)) {
            		if (invalidTokenRegex.test(name)) {
            			continue;
            		}
            		if (Array.isArray(obj[name])) {
            			for (const val of obj[name]) {
            				if (invalidHeaderCharRegex.test(val)) {
            					continue;
            				}
            				if (headers[MAP][name] === undefined) {
            					headers[MAP][name] = [val];
            				} else {
            					headers[MAP][name].push(val);
            				}
            			}
            		} else if (!invalidHeaderCharRegex.test(obj[name])) {
            			headers[MAP][name] = [obj[name]];
            		}
            	}
            	return headers;
            }

            const INTERNALS$1 = Symbol('Response internals');

            // fix an issue where "STATUS_CODES" aren't a named export for node <10
            const STATUS_CODES = http.STATUS_CODES;

            /**
             * Response class
             *
             * @param   Stream  body  Readable stream
             * @param   Object  opts  Response options
             * @return  Void
             */
            class Response {
            	constructor() {
            		let body = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : null;
            		let opts = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};

            		Body.call(this, body, opts);

            		const status = opts.status || 200;
            		const headers = new Headers(opts.headers);

            		if (body != null && !headers.has('Content-Type')) {
            			const contentType = extractContentType(body);
            			if (contentType) {
            				headers.append('Content-Type', contentType);
            			}
            		}

            		this[INTERNALS$1] = {
            			url: opts.url,
            			status,
            			statusText: opts.statusText || STATUS_CODES[status],
            			headers,
            			counter: opts.counter
            		};
            	}

            	get url() {
            		return this[INTERNALS$1].url || '';
            	}

            	get status() {
            		return this[INTERNALS$1].status;
            	}

            	/**
              * Convenience property representing if the request ended normally
              */
            	get ok() {
            		return this[INTERNALS$1].status >= 200 && this[INTERNALS$1].status < 300;
            	}

            	get redirected() {
            		return this[INTERNALS$1].counter > 0;
            	}

            	get statusText() {
            		return this[INTERNALS$1].statusText;
            	}

            	get headers() {
            		return this[INTERNALS$1].headers;
            	}

            	/**
              * Clone this response
              *
              * @return  Response
              */
            	clone() {
            		return new Response(clone(this), {
            			url: this.url,
            			status: this.status,
            			statusText: this.statusText,
            			headers: this.headers,
            			ok: this.ok,
            			redirected: this.redirected
            		});
            	}
            }

            Body.mixIn(Response.prototype);

            Object.defineProperties(Response.prototype, {
            	url: { enumerable: true },
            	status: { enumerable: true },
            	ok: { enumerable: true },
            	redirected: { enumerable: true },
            	statusText: { enumerable: true },
            	headers: { enumerable: true },
            	clone: { enumerable: true }
            });

            Object.defineProperty(Response.prototype, Symbol.toStringTag, {
            	value: 'Response',
            	writable: false,
            	enumerable: false,
            	configurable: true
            });

            const INTERNALS$2 = Symbol('Request internals');

            // fix an issue where "format", "parse" aren't a named export for node <10
            const parse_url = Url.parse;
            const format_url = Url.format;

            const streamDestructionSupported = 'destroy' in Stream.Readable.prototype;

            /**
             * Check if a value is an instance of Request.
             *
             * @param   Mixed   input
             * @return  Boolean
             */
            function isRequest(input) {
            	return typeof input === 'object' && typeof input[INTERNALS$2] === 'object';
            }

            function isAbortSignal(signal) {
            	const proto = signal && typeof signal === 'object' && Object.getPrototypeOf(signal);
            	return !!(proto && proto.constructor.name === 'AbortSignal');
            }

            /**
             * Request class
             *
             * @param   Mixed   input  Url or Request instance
             * @param   Object  init   Custom options
             * @return  Void
             */
            class Request {
            	constructor(input) {
            		let init = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};

            		let parsedURL;

            		// normalize input
            		if (!isRequest(input)) {
            			if (input && input.href) {
            				// in order to support Node.js' Url objects; though WHATWG's URL objects
            				// will fall into this branch also (since their `toString()` will return
            				// `href` property anyway)
            				parsedURL = parse_url(input.href);
            			} else {
            				// coerce input to a string before attempting to parse
            				parsedURL = parse_url(`${input}`);
            			}
            			input = {};
            		} else {
            			parsedURL = parse_url(input.url);
            		}

            		let method = init.method || input.method || 'GET';
            		method = method.toUpperCase();

            		if ((init.body != null || isRequest(input) && input.body !== null) && (method === 'GET' || method === 'HEAD')) {
            			throw new TypeError('Request with GET/HEAD method cannot have body');
            		}

            		let inputBody = init.body != null ? init.body : isRequest(input) && input.body !== null ? clone(input) : null;

            		Body.call(this, inputBody, {
            			timeout: init.timeout || input.timeout || 0,
            			size: init.size || input.size || 0
            		});

            		const headers = new Headers(init.headers || input.headers || {});

            		if (inputBody != null && !headers.has('Content-Type')) {
            			const contentType = extractContentType(inputBody);
            			if (contentType) {
            				headers.append('Content-Type', contentType);
            			}
            		}

            		let signal = isRequest(input) ? input.signal : null;
            		if ('signal' in init) signal = init.signal;

            		if (signal != null && !isAbortSignal(signal)) {
            			throw new TypeError('Expected signal to be an instanceof AbortSignal');
            		}

            		this[INTERNALS$2] = {
            			method,
            			redirect: init.redirect || input.redirect || 'follow',
            			headers,
            			parsedURL,
            			signal
            		};

            		// node-fetch-only options
            		this.follow = init.follow !== undefined ? init.follow : input.follow !== undefined ? input.follow : 20;
            		this.compress = init.compress !== undefined ? init.compress : input.compress !== undefined ? input.compress : true;
            		this.counter = init.counter || input.counter || 0;
            		this.agent = init.agent || input.agent;
            	}

            	get method() {
            		return this[INTERNALS$2].method;
            	}

            	get url() {
            		return format_url(this[INTERNALS$2].parsedURL);
            	}

            	get headers() {
            		return this[INTERNALS$2].headers;
            	}

            	get redirect() {
            		return this[INTERNALS$2].redirect;
            	}

            	get signal() {
            		return this[INTERNALS$2].signal;
            	}

            	/**
              * Clone this request
              *
              * @return  Request
              */
            	clone() {
            		return new Request(this);
            	}
            }

            Body.mixIn(Request.prototype);

            Object.defineProperty(Request.prototype, Symbol.toStringTag, {
            	value: 'Request',
            	writable: false,
            	enumerable: false,
            	configurable: true
            });

            Object.defineProperties(Request.prototype, {
            	method: { enumerable: true },
            	url: { enumerable: true },
            	headers: { enumerable: true },
            	redirect: { enumerable: true },
            	clone: { enumerable: true },
            	signal: { enumerable: true }
            });

            /**
             * Convert a Request to Node.js http request options.
             *
             * @param   Request  A Request instance
             * @return  Object   The options object to be passed to http.request
             */
            function getNodeRequestOptions(request) {
            	const parsedURL = request[INTERNALS$2].parsedURL;
            	const headers = new Headers(request[INTERNALS$2].headers);

            	// fetch step 1.3
            	if (!headers.has('Accept')) {
            		headers.set('Accept', '*/*');
            	}

            	// Basic fetch
            	if (!parsedURL.protocol || !parsedURL.hostname) {
            		throw new TypeError('Only absolute URLs are supported');
            	}

            	if (!/^https?:$/.test(parsedURL.protocol)) {
            		throw new TypeError('Only HTTP(S) protocols are supported');
            	}

            	if (request.signal && request.body instanceof Stream.Readable && !streamDestructionSupported) {
            		throw new Error('Cancellation of streamed requests with AbortSignal is not supported in node < 8');
            	}

            	// HTTP-network-or-cache fetch steps 2.4-2.7
            	let contentLengthValue = null;
            	if (request.body == null && /^(POST|PUT)$/i.test(request.method)) {
            		contentLengthValue = '0';
            	}
            	if (request.body != null) {
            		const totalBytes = getTotalBytes(request);
            		if (typeof totalBytes === 'number') {
            			contentLengthValue = String(totalBytes);
            		}
            	}
            	if (contentLengthValue) {
            		headers.set('Content-Length', contentLengthValue);
            	}

            	// HTTP-network-or-cache fetch step 2.11
            	if (!headers.has('User-Agent')) {
            		headers.set('User-Agent', 'node-fetch/1.0 (+https://github.com/bitinn/node-fetch)');
            	}

            	// HTTP-network-or-cache fetch step 2.15
            	if (request.compress && !headers.has('Accept-Encoding')) {
            		headers.set('Accept-Encoding', 'gzip,deflate');
            	}

            	let agent = request.agent;
            	if (typeof agent === 'function') {
            		agent = agent(parsedURL);
            	}

            	if (!headers.has('Connection') && !agent) {
            		headers.set('Connection', 'close');
            	}

            	// HTTP-network fetch step 4.2
            	// chunked encoding is handled by Node.js

            	return Object.assign({}, parsedURL, {
            		method: request.method,
            		headers: exportNodeCompatibleHeaders(headers),
            		agent
            	});
            }

            /**
             * abort-error.js
             *
             * AbortError interface for cancelled requests
             */

            /**
             * Create AbortError instance
             *
             * @param   String      message      Error message for human
             * @return  AbortError
             */
            function AbortError(message) {
              Error.call(this, message);

              this.type = 'aborted';
              this.message = message;

              // hide custom error implementation details from end-users
              Error.captureStackTrace(this, this.constructor);
            }

            AbortError.prototype = Object.create(Error.prototype);
            AbortError.prototype.constructor = AbortError;
            AbortError.prototype.name = 'AbortError';

            // fix an issue where "PassThrough", "resolve" aren't a named export for node <10
            const PassThrough$1 = Stream.PassThrough;
            const resolve_url = Url.resolve;

            /**
             * Fetch function
             *
             * @param   Mixed    url   Absolute url or Request instance
             * @param   Object   opts  Fetch options
             * @return  Promise
             */
            function fetch$1(url, opts) {

            	// allow custom promise
            	if (!fetch$1.Promise) {
            		throw new Error('native promise missing, set fetch.Promise to your favorite alternative');
            	}

            	Body.Promise = fetch$1.Promise;

            	// wrap http.request into fetch
            	return new fetch$1.Promise(function (resolve, reject) {
            		// build request object
            		const request = new Request(url, opts);
            		const options = getNodeRequestOptions(request);

            		const send = (options.protocol === 'https:' ? http : http).request;
            		const signal = request.signal;

            		let response = null;

            		const abort = function abort() {
            			let error = new AbortError('The user aborted a request.');
            			reject(error);
            			if (request.body && request.body instanceof Stream.Readable) {
            				request.body.destroy(error);
            			}
            			if (!response || !response.body) return;
            			response.body.emit('error', error);
            		};

            		if (signal && signal.aborted) {
            			abort();
            			return;
            		}

            		const abortAndFinalize = function abortAndFinalize() {
            			abort();
            			finalize();
            		};

            		// send request
            		const req = send(options);
            		let reqTimeout;

            		if (signal) {
            			signal.addEventListener('abort', abortAndFinalize);
            		}

            		function finalize() {
            			req.abort();
            			if (signal) signal.removeEventListener('abort', abortAndFinalize);
            			clearTimeout(reqTimeout);
            		}

            		if (request.timeout) {
            			req.once('socket', function (socket) {
            				reqTimeout = setTimeout(function () {
            					reject(new FetchError(`network timeout at: ${request.url}`, 'request-timeout'));
            					finalize();
            				}, request.timeout);
            			});
            		}

            		req.on('error', function (err) {
            			reject(new FetchError(`request to ${request.url} failed, reason: ${err.message}`, 'system', err));
            			finalize();
            		});

            		req.on('response', function (res) {
            			clearTimeout(reqTimeout);

            			const headers = createHeadersLenient(res.headers);

            			// HTTP fetch step 5
            			if (fetch$1.isRedirect(res.statusCode)) {
            				// HTTP fetch step 5.2
            				const location = headers.get('Location');

            				// HTTP fetch step 5.3
            				const locationURL = location === null ? null : resolve_url(request.url, location);

            				// HTTP fetch step 5.5
            				switch (request.redirect) {
            					case 'error':
            						reject(new FetchError(`uri requested responds with a redirect, redirect mode is set to error: ${request.url}`, 'no-redirect'));
            						finalize();
            						return;
            					case 'manual':
            						// node-fetch-specific step: make manual redirect a bit easier to use by setting the Location header value to the resolved URL.
            						if (locationURL !== null) {
            							// handle corrupted header
            							try {
            								headers.set('Location', locationURL);
            							} catch (err) {
            								// istanbul ignore next: nodejs server prevent invalid response headers, we can't test this through normal request
            								reject(err);
            							}
            						}
            						break;
            					case 'follow':
            						// HTTP-redirect fetch step 2
            						if (locationURL === null) {
            							break;
            						}

            						// HTTP-redirect fetch step 5
            						if (request.counter >= request.follow) {
            							reject(new FetchError(`maximum redirect reached at: ${request.url}`, 'max-redirect'));
            							finalize();
            							return;
            						}

            						// HTTP-redirect fetch step 6 (counter increment)
            						// Create a new Request object.
            						const requestOpts = {
            							headers: new Headers(request.headers),
            							follow: request.follow,
            							counter: request.counter + 1,
            							agent: request.agent,
            							compress: request.compress,
            							method: request.method,
            							body: request.body,
            							signal: request.signal,
            							timeout: request.timeout,
            							size: request.size
            						};

            						// HTTP-redirect fetch step 9
            						if (res.statusCode !== 303 && request.body && getTotalBytes(request) === null) {
            							reject(new FetchError('Cannot follow redirect with body being a readable stream', 'unsupported-redirect'));
            							finalize();
            							return;
            						}

            						// HTTP-redirect fetch step 11
            						if (res.statusCode === 303 || (res.statusCode === 301 || res.statusCode === 302) && request.method === 'POST') {
            							requestOpts.method = 'GET';
            							requestOpts.body = undefined;
            							requestOpts.headers.delete('content-length');
            						}

            						// HTTP-redirect fetch step 15
            						resolve(fetch$1(new Request(locationURL, requestOpts)));
            						finalize();
            						return;
            				}
            			}

            			// prepare response
            			res.once('end', function () {
            				if (signal) signal.removeEventListener('abort', abortAndFinalize);
            			});
            			let body = res.pipe(new PassThrough$1());

            			const response_options = {
            				url: request.url,
            				status: res.statusCode,
            				statusText: res.statusMessage,
            				headers: headers,
            				size: request.size,
            				timeout: request.timeout,
            				counter: request.counter
            			};

            			// HTTP-network fetch step 12.1.1.3
            			const codings = headers.get('Content-Encoding');

            			// HTTP-network fetch step 12.1.1.4: handle content codings

            			// in following scenarios we ignore compression support
            			// 1. compression support is disabled
            			// 2. HEAD request
            			// 3. no Content-Encoding header
            			// 4. no content response (204)
            			// 5. content not modified response (304)
            			if (!request.compress || request.method === 'HEAD' || codings === null || res.statusCode === 204 || res.statusCode === 304) {
            				response = new Response(body, response_options);
            				resolve(response);
            				return;
            			}

            			// For Node v6+
            			// Be less strict when decoding compressed responses, since sometimes
            			// servers send slightly invalid responses that are still accepted
            			// by common browsers.
            			// Always using Z_SYNC_FLUSH is what cURL does.
            			const zlibOptions = {
            				flush: zlib.Z_SYNC_FLUSH,
            				finishFlush: zlib.Z_SYNC_FLUSH
            			};

            			// for gzip
            			if (codings == 'gzip' || codings == 'x-gzip') {
            				body = body.pipe(zlib.createGunzip(zlibOptions));
            				response = new Response(body, response_options);
            				resolve(response);
            				return;
            			}

            			// for deflate
            			if (codings == 'deflate' || codings == 'x-deflate') {
            				// handle the infamous raw deflate response from old servers
            				// a hack for old IIS and Apache servers
            				const raw = res.pipe(new PassThrough$1());
            				raw.once('data', function (chunk) {
            					// see http://stackoverflow.com/questions/37519828
            					if ((chunk[0] & 0x0F) === 0x08) {
            						body = body.pipe(zlib.createInflate());
            					} else {
            						body = body.pipe(zlib.createInflateRaw());
            					}
            					response = new Response(body, response_options);
            					resolve(response);
            				});
            				return;
            			}

            			// for br
            			if (codings == 'br' && typeof zlib.createBrotliDecompress === 'function') {
            				body = body.pipe(zlib.createBrotliDecompress());
            				response = new Response(body, response_options);
            				resolve(response);
            				return;
            			}

            			// otherwise, use response as-is
            			response = new Response(body, response_options);
            			resolve(response);
            		});

            		writeToStream(req, request);
            	});
            }
            /**
             * Redirect code matching
             *
             * @param   Number   code  Status code
             * @return  Boolean
             */
            fetch$1.isRedirect = function (code) {
            	return code === 301 || code === 302 || code === 303 || code === 307 || code === 308;
            };

            // expose Promise
            fetch$1.Promise = global.Promise;

            var lib = /*#__PURE__*/Object.freeze({
                __proto__: null,
                'default': fetch$1,
                Headers: Headers,
                Request: Request,
                Response: Response,
                FetchError: FetchError
            });

            var realFetch = getCjsExportFromNamespace(lib);

            createCommonjsModule(function (module) {


            module.exports = function(url, options) {
            	if (/^\/\//.test(url)) {
            		url = 'https:' + url;
            	}
            	return realFetch.call(this, url, options);
            };

            if (!commonjsGlobal.fetch) {
            	commonjsGlobal.fetch = module.exports;
            	commonjsGlobal.Response = realFetch.Response;
            	commonjsGlobal.Headers = realFetch.Headers;
            	commonjsGlobal.Request = realFetch.Request;
            }
            });

            var _regenerator = interopRequireDefault(regenerator);

            var _slicedToArray2 = interopRequireDefault(slicedToArray);

            var _defineProperty2 = interopRequireDefault(defineProperty$1);

            var _asyncToGenerator2 = interopRequireDefault(asyncToGenerator);

            function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

            function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { (0, _defineProperty2["default"])(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }



            var getCookie = cookie.getCookie,
                setCookie = cookie.setCookie;

            var setOptions = utils.setOptions,
                toCamel = utils.toCamel,
                toSnake = utils.toSnake,
                trimBoth = utils.trimBoth,
                trimStart = utils.trimStart,
                trimEnd = utils.trimEnd,
                stringifyQuery = utils.stringifyQuery,
                base64Encode = utils.base64Encode;





















            var locale = locale$1;

            var currency = currency$1;



            var options = {
              store: null,
              key: null,
              url: null,
              useCamelCase: null,
              previewContent: null
            };
            var api = {
              options: options,
              request: request,
              init: function init(store, key) {
                var opt = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : {};
                options.key = key;
                options.store = store;
                options.url = opt.url ? trimEnd(opt.url) : "https://".concat(store, ".swell.store");
                options.vaultUrl = opt.vaultUrl ? trimEnd(opt.vaultUrl) : "https://vault.schema.io";
                options.timeout = opt.timeout && parseInt(opt.timeout, 10) || 20000;
                options.useCamelCase = opt.useCamelCase || false;
                options.previewContent = opt.previewContent || false;
                options.session = opt.session;
                options.locale = opt.locale;
                options.currency = opt.currency;
                options.api = api;
                setOptions(options);
              },
              // Backward compatibility
              auth: function auth() {
                return this.init.apply(this, arguments);
              },
              get: function get(url, query) {
                return request('get', url, query);
              },
              put: function put(url, data) {
                return request('put', url, data);
              },
              post: function post(url, data) {
                return request('post', url, data);
              },
              "delete": function _delete(url, data) {
                return request('delete', url, data);
              },
              cache: cache,
              card: card,
              cart: cart.methods(request, options),
              account: account.methods(request, options),
              products: products.methods(request, options),
              categories: categories.methods(request, options),
              attributes: attributes.methods(request, options),
              subscriptions: subscriptions.methods(request, options),
              content: content.methods(request, options),
              settings: settings.methods(request, options),
              payment: payment.methods(request, options),
              locale: locale.methods(request, options),
              currency: currency.methods(request, options)
            };

            function request(_x, _x2) {
              return _request.apply(this, arguments);
            }

            function _request() {
              _request = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee(method, url) {
                var id,
                    data,
                    opt,
                    reqMethod,
                    reqUrl,
                    reqData,
                    allOptions,
                    baseUrl,
                    reqBody,
                    exQuery,
                    _reqUrl$split,
                    _reqUrl$split2,
                    fullQuery,
                    session,
                    locale,
                    currency,
                    reqHeaders,
                    response,
                    responseSession,
                    result,
                    err,
                    _err,
                    _args = arguments;

                return _regenerator["default"].wrap(function _callee$(_context) {
                  while (1) {
                    switch (_context.prev = _context.next) {
                      case 0:
                        id = _args.length > 2 && _args[2] !== undefined ? _args[2] : undefined;
                        data = _args.length > 3 && _args[3] !== undefined ? _args[3] : undefined;
                        opt = _args.length > 4 && _args[4] !== undefined ? _args[4] : undefined;
                        reqMethod = String(method).toLowerCase();
                        reqUrl = url;
                        reqData = id;

                        if (data !== undefined || typeof id === 'string') {
                          reqUrl = [trimEnd(url), trimStart(id)].join('/');
                          reqData = data;
                        }

                        allOptions = _objectSpread(_objectSpread({}, options), opt);
                        baseUrl = "".concat(allOptions.url).concat(allOptions.base || '', "/api");
                        reqUrl = allOptions.fullUrl || "".concat(baseUrl, "/").concat(trimBoth(reqUrl));
                        reqData = allOptions.useCamelCase ? toSnake(reqData) : reqData;

                        if (reqMethod === 'get') {
                          _reqUrl$split = reqUrl.split('?');
                          _reqUrl$split2 = (0, _slicedToArray2["default"])(_reqUrl$split, 2);
                          reqUrl = _reqUrl$split2[0];
                          exQuery = _reqUrl$split2[1];
                          fullQuery = [exQuery, stringifyQuery(reqData)].join('&').replace(/^&/, '');
                          reqUrl = "".concat(reqUrl).concat(fullQuery ? "?".concat(fullQuery) : '');
                        } else {
                          reqBody = JSON.stringify(reqData);
                        }

                        session = allOptions.session || getCookie('swell-session');
                        locale = allOptions.locale || getCookie('swell-locale');
                        currency = allOptions.currency || getCookie('swell-currency');
                        reqHeaders = _objectSpread(_objectSpread(_objectSpread({
                          'Content-Type': 'application/json',
                          Authorization: "Basic ".concat(base64Encode(String(allOptions.key)))
                        }, session ? {
                          'X-Session': session
                        } : {}), locale ? {
                          'X-Locale': locale
                        } : {}), currency ? {
                          'X-Currency': currency
                        } : {});
                        _context.next = 18;
                        return fetch(reqUrl, {
                          method: reqMethod,
                          headers: reqHeaders,
                          body: reqBody,
                          credentials: 'include',
                          mode: 'cors'
                        });

                      case 18:
                        response = _context.sent;
                        responseSession = response.headers.get('X-Session');

                        if (typeof responseSession === 'string' && session !== responseSession) {
                          setCookie('swell-session', responseSession);
                        }

                        _context.next = 23;
                        return response.json();

                      case 23:
                        result = _context.sent;

                        if (!(result && result.error)) {
                          _context.next = 32;
                          break;
                        }

                        err = new Error(result.error.message);
                        err.status = response.status;
                        err.code = result.error.code;
                        err.param = result.error.param;
                        throw err;

                      case 32:
                        if (response.ok) {
                          _context.next = 36;
                          break;
                        }

                        _err = new Error('A connection error occurred while making the request');
                        _err.code = 'connection_error';
                        throw _err;

                      case 36:
                        return _context.abrupt("return", options.useCamelCase ? toCamel(result) : result);

                      case 37:
                      case "end":
                        return _context.stop();
                    }
                  }
                }, _callee);
              }));
              return _request.apply(this, arguments);
            }

            if (typeof window !== 'undefined') {
              window.swell = {
                version: '@VERSION@'
              };
            }

            var api_1 = api;

            registerCommercePlugin({
                name: 'Swell',
                // should always match package.json package name
                id: '@builder.io/plugin-swell',
                settings: [
                    {
                        name: 'storeId',
                        type: 'string',
                        required: true,
                        helperText: 'Get your Store ID from swell store settings https://swell.store/docs/api/?javascript#authentication',
                    },
                    {
                        name: 'publicKey',
                        type: 'string',
                        required: true,
                        helperText: 'Get your Public key from swell store settings > API keys > Public api key https://swell.store/docs/api/?javascript#authentication',
                    },
                ],
                ctaText: "Connect your swell.is store",
            }, function (settings) { return __awaiter$1(void 0, void 0, void 0, function () {
                var storeId, publicKey, transformResource;
                var _a, _b;
                return __generator$1(this, function (_c) {
                    switch (_c.label) {
                        case 0:
                            storeId = (_a = settings.get('storeId')) === null || _a === void 0 ? void 0 : _a.trim();
                            publicKey = (_b = settings.get('publicKey')) === null || _b === void 0 ? void 0 : _b.trim();
                            return [4 /*yield*/, api_1.init(storeId, publicKey)];
                        case 1:
                            _c.sent();
                            transformResource = function (resource) {
                                var _a;
                                return (__assign$1({ id: resource.id, title: resource.name, handle: resource.slug }, (resource.images && {
                                    image: {
                                        src: (_a = resource.images[0]) === null || _a === void 0 ? void 0 : _a.file.url,
                                    },
                                })));
                            };
                            return [2 /*return*/, {
                                    product: {
                                        findById: function (id) {
                                            return __awaiter$1(this, void 0, void 0, function () {
                                                var product;
                                                return __generator$1(this, function (_a) {
                                                    switch (_a.label) {
                                                        case 0: return [4 /*yield*/, api_1.products.get(id)];
                                                        case 1:
                                                            product = _a.sent();
                                                            return [2 /*return*/, transformResource(product)];
                                                    }
                                                });
                                            });
                                        },
                                        findByHandle: function (handle) {
                                            return __awaiter$1(this, void 0, void 0, function () {
                                                var product;
                                                return __generator$1(this, function (_a) {
                                                    switch (_a.label) {
                                                        case 0: return [4 /*yield*/, api_1.products.get(handle)];
                                                        case 1:
                                                            product = _a.sent();
                                                            return [2 /*return*/, transformResource(product)];
                                                    }
                                                });
                                            });
                                        },
                                        search: function (search) {
                                            return __awaiter$1(this, void 0, void 0, function () {
                                                var response;
                                                return __generator$1(this, function (_a) {
                                                    switch (_a.label) {
                                                        case 0: return [4 /*yield*/, api_1.products.list({
                                                                search: search,
                                                                // TODO: pagination if needed
                                                                limit: 100,
                                                                page: 1,
                                                            })];
                                                        case 1:
                                                            response = _a.sent();
                                                            return [2 /*return*/, response.results.map(transformResource)];
                                                    }
                                                });
                                            });
                                        },
                                        getRequestObject: function (id) {
                                            return {
                                                '@type': '@builder.io/core:Request',
                                                request: {
                                                    // https://{public_key}@{client_id}.swell.store/api/products/5e31e67be53f9a59d89600f1.
                                                    url: "https://" + publicKey + "@" + storeId + ".swell.store/api/products/" + id,
                                                },
                                                options: {
                                                    product: id,
                                                },
                                            };
                                        },
                                    },
                                    category: {
                                        findById: function (id) {
                                            return __awaiter$1(this, void 0, void 0, function () {
                                                var category;
                                                return __generator$1(this, function (_a) {
                                                    switch (_a.label) {
                                                        case 0: return [4 /*yield*/, api_1.categories.get(id)];
                                                        case 1:
                                                            category = _a.sent();
                                                            return [2 /*return*/, transformResource(category)];
                                                    }
                                                });
                                            });
                                        },
                                        findByHandle: function (handle) {
                                            return __awaiter$1(this, void 0, void 0, function () {
                                                var category;
                                                return __generator$1(this, function (_a) {
                                                    switch (_a.label) {
                                                        case 0: return [4 /*yield*/, api_1.categories.get(handle)];
                                                        case 1:
                                                            category = _a.sent();
                                                            return [2 /*return*/, transformResource(category)];
                                                    }
                                                });
                                            });
                                        },
                                        search: function (search) {
                                            return __awaiter$1(this, void 0, void 0, function () {
                                                var response;
                                                return __generator$1(this, function (_a) {
                                                    switch (_a.label) {
                                                        case 0: return [4 /*yield*/, api_1.categories.list({
                                                                search: search,
                                                                // TODO: pagination if needed
                                                                limit: 100,
                                                                page: 1,
                                                            })];
                                                        case 1:
                                                            response = _a.sent();
                                                            return [2 /*return*/, response.results.map(transformResource)];
                                                    }
                                                });
                                            });
                                        },
                                        getRequestObject: function (id) {
                                            return {
                                                '@type': '@builder.io/core:Request',
                                                request: {
                                                    // https://{public_key}@{client_id}.swell.store/api/categories/5e31e67be53f9a59d89600f1.
                                                    url: "https://" + publicKey + "@" + storeId + ".swell.store/api/categories/" + id,
                                                },
                                                options: {
                                                    category: id,
                                                },
                                            };
                                        },
                                    },
                                }];
                    }
                });
            }); });

        }
    };
});
//# sourceMappingURL=plugin.system.js.map
